/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/base/common/types","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/errors","electron","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","os","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/uuid","vs/base/common/extpath","vs/platform/environment/common/environment","vs/platform/state/electron-main/state","vs/base/common/map","vs/base/common/process","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/json","vs/base/common/errorMessage","vs/base/common/labels","child_process","vs/base/parts/ipc/common/ipc","vs/platform/dialogs/common/dialogs","vs/platform/update/common/update","vs/base/common/functional","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/remote/common/remoteHosts","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/processes","vs/base/common/severity","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensions/common/extensions","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/update/electron-main/abstractUpdateService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/shell/node/shellEnv","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/codicons","vs/base/common/themables","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetryUtils","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","vs/platform/utilityProcess/electron-main/utilityProcess","string_decoder","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","https","vscode-policy-watcher","zlib","vs/code/electron-main/main"],te=function(G){for(var e=[],E=0,M=G.length;E<M;E++)e[E]=ee[G[E]];return e};define(ee[122],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function E(P,f){const d=Math.pow(10,f);return Math.round(P*d)/d}class M{constructor(f,d,b,v=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,d))|0,this.b=Math.min(255,Math.max(0,b))|0,this.a=E(Math.max(Math.min(1,v),0),3)}static equals(f,d){return f.r===d.r&&f.g===d.g&&f.b===d.b&&f.a===d.a}}e.RGBA=M;class n{constructor(f,d,b,v){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=E(Math.max(Math.min(1,d),0),3),this.l=E(Math.max(Math.min(1,b),0),3),this.a=E(Math.max(Math.min(1,v),0),3)}static equals(f,d){return f.h===d.h&&f.s===d.s&&f.l===d.l&&f.a===d.a}static fromRGBA(f){const d=f.r/255,b=f.g/255,v=f.b/255,y=f.a,g=Math.max(d,b,v),m=Math.min(d,b,v);let w=0,o=0;const h=(m+g)/2,p=g-m;if(p>0){switch(o=Math.min(h<=.5?p/(2*h):p/(2-2*h),1),g){case d:w=(b-v)/p+(b<v?6:0);break;case b:w=(v-d)/p+2;break;case v:w=(d-b)/p+4;break}w*=60,w=Math.round(w)}return new n(w,o,h,y)}static i(f,d,b){return b<0&&(b+=1),b>1&&(b-=1),b<1/6?f+(d-f)*6*b:b<1/2?d:b<2/3?f+(d-f)*(2/3-b)*6:f}static toRGBA(f){const d=f.h/360,{s:b,l:v,a:y}=f;let g,m,w;if(b===0)g=m=w=v;else{const o=v<.5?v*(1+b):v+b-v*b,h=2*v-o;g=n.i(h,o,d+1/3),m=n.i(h,o,d),w=n.i(h,o,d-1/3)}return new M(Math.round(g*255),Math.round(m*255),Math.round(w*255),y)}}e.HSLA=n;class C{constructor(f,d,b,v){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=E(Math.max(Math.min(1,d),0),3),this.v=E(Math.max(Math.min(1,b),0),3),this.a=E(Math.max(Math.min(1,v),0),3)}static equals(f,d){return f.h===d.h&&f.s===d.s&&f.v===d.v&&f.a===d.a}static fromRGBA(f){const d=f.r/255,b=f.g/255,v=f.b/255,y=Math.max(d,b,v),g=Math.min(d,b,v),m=y-g,w=y===0?0:m/y;let o;return m===0?o=0:y===d?o=((b-v)/m%6+6)%6:y===b?o=(v-d)/m+2:o=(d-b)/m+4,new C(Math.round(o*60),w,y,f.a)}static toRGBA(f){const{h:d,s:b,v,a:y}=f,g=v*b,m=g*(1-Math.abs(d/60%2-1)),w=v-g;let[o,h,p]=[0,0,0];return d<60?(o=g,h=m):d<120?(o=m,h=g):d<180?(h=g,p=m):d<240?(h=m,p=g):d<300?(o=m,p=g):d<=360&&(o=g,p=m),o=Math.round((o+w)*255),h=Math.round((h+w)*255),p=Math.round((p+w)*255),new M(o,h,p,y)}}e.HSVA=C;class D{static fromHex(f){return D.Format.CSS.parseHex(f)||D.red}static equals(f,d){return!f&&!d?!0:!f||!d?!1:f.equals(d)}get hsla(){return this.i?this.i:n.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:C.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof M)this.rgba=f;else if(f instanceof n)this.i=f,this.rgba=n.toRGBA(f);else if(f instanceof C)this.j=f,this.rgba=C.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&M.equals(this.rgba,f.rgba)&&n.equals(this.hsla,f.hsla)&&C.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=D.k(this.rgba.r),d=D.k(this.rgba.g),b=D.k(this.rgba.b),v=.2126*f+.7152*d+.0722*b;return E(v,4)}static k(f){const d=f/255;return d<=.03928?d/12.92:Math.pow((d+.055)/1.055,2.4)}getContrastRatio(f){const d=this.getRelativeLuminance(),b=f.getRelativeLuminance();return d>b?(d+.05)/(b+.05):(b+.05)/(d+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const d=this.getRelativeLuminance(),b=f.getRelativeLuminance();return d>b}isDarkerThan(f){const d=this.getRelativeLuminance(),b=f.getRelativeLuminance();return d<b}lighten(f){return new D(new n(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new D(new n(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:d,g:b,b:v,a:y}=this.rgba;return new D(new M(d,b,v,y*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new M(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const d=f.rgba,b=this.rgba.a,v=d.a,y=b+v*(1-b);if(y<1e-6)return D.transparent;const g=this.rgba.r*b/y+d.r*v*(1-b)/y,m=this.rgba.g*b/y+d.g*v*(1-b)/y,w=this.rgba.b*b/y+d.b*v*(1-b)/y;return new D(new M(g,m,w,y))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:d,g:b,b:v,a:y}=this.rgba;return new D(new M(f.rgba.r-y*(f.rgba.r-d),f.rgba.g-y*(f.rgba.g-b),f.rgba.b-y*(f.rgba.b-v),1))}flatten(...f){const d=f.reduceRight((b,v)=>D.o(v,b));return D.o(this,d)}static o(f,d){const b=1-f.rgba.a;return new D(new M(b*d.rgba.r+f.rgba.a*f.rgba.r,b*d.rgba.g+f.rgba.a*f.rgba.g,b*d.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(f,d,b){if(f.isLighterThan(d))return f;b=b||.5;const v=f.getRelativeLuminance(),y=d.getRelativeLuminance();return b=b*(y-v)/y,f.lighten(b)}static getDarkerColor(f,d,b){if(f.isDarkerThan(d))return f;b=b||.5;const v=f.getRelativeLuminance(),y=d.getRelativeLuminance();return b=b*(v-y)/v,f.darken(b)}}D.white=new D(new M(255,255,255,1)),D.black=new D(new M(0,0,0,1)),D.red=new D(new M(255,0,0,1)),D.blue=new D(new M(0,0,255,1)),D.green=new D(new M(0,255,0,1)),D.cyan=new D(new M(0,255,255,1)),D.lightgrey=new D(new M(211,211,211,1)),D.transparent=new D(new M(0,0,0,0)),e.Color=D,function(P){let f;(function(d){let b;(function(v){function y(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:P.Format.CSS.formatRGBA(t)}v.formatRGB=y;function g(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}v.formatRGBA=g;function m(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(t)}v.formatHSL=m;function w(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}v.formatHSLA=w;function o(t){const a=t.toString(16);return a.length!==2?"0"+a:a}function h(t){return`#${o(t.rgba.r)}${o(t.rgba.g)}${o(t.rgba.b)}`}v.formatHex=h;function p(t,a=!1){return a&&t.rgba.a===1?P.Format.CSS.formatHex(t):`#${o(t.rgba.r)}${o(t.rgba.g)}${o(t.rgba.b)}${o(Math.round(t.rgba.a*255))}`}v.formatHexA=p;function k(t){return t.isOpaque()?P.Format.CSS.formatHex(t):P.Format.CSS.formatRGBA(t)}v.format=k;function S(t){const a=t.length;if(a===0||t.charCodeAt(0)!==35)return null;if(a===7){const i=16*R(t.charCodeAt(1))+R(t.charCodeAt(2)),s=16*R(t.charCodeAt(3))+R(t.charCodeAt(4)),c=16*R(t.charCodeAt(5))+R(t.charCodeAt(6));return new P(new M(i,s,c,1))}if(a===9){const i=16*R(t.charCodeAt(1))+R(t.charCodeAt(2)),s=16*R(t.charCodeAt(3))+R(t.charCodeAt(4)),c=16*R(t.charCodeAt(5))+R(t.charCodeAt(6)),u=16*R(t.charCodeAt(7))+R(t.charCodeAt(8));return new P(new M(i,s,c,u/255))}if(a===4){const i=R(t.charCodeAt(1)),s=R(t.charCodeAt(2)),c=R(t.charCodeAt(3));return new P(new M(16*i+i,16*s+s,16*c+c))}if(a===5){const i=R(t.charCodeAt(1)),s=R(t.charCodeAt(2)),c=R(t.charCodeAt(3)),u=R(t.charCodeAt(4));return new P(new M(16*i+i,16*s+s,16*c+c,(16*u+u)/255))}return null}v.parseHex=S;function R(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(b=d.CSS||(d.CSS={}))})(f=P.Format||(P.Format={}))}(D=e.Color||(e.Color={})),e.Color=D}),define(ee[55],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function E(D){return(P,f,d)=>{let b=null,v=null;if(typeof d.value=="function"?(b="value",v=d.value):typeof d.get=="function"&&(b="get",v=d.get),!v)throw new Error("not supported");d[b]=D(v,f)}}function M(D,P,f){let d=null,b=null;if(typeof f.value=="function"?(d="value",b=f.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(d="get",b=f.get),!b)throw new Error("not supported");const v=`$memoize$${P}`;f[d]=function(...y){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,y)}),this[v]}}e.memoize=M;function n(D,P,f){return E((d,b)=>{const v=`$debounce$${b}`,y=`$debounce$result$${b}`;return function(...g){this[y]||(this[y]=f?f():void 0),clearTimeout(this[v]),P&&(this[y]=P(this[y],...g),g=[this[y]]),this[v]=setTimeout(()=>{d.apply(this,g),this[y]=f?f():void 0},D)}})}e.debounce=n;function C(D,P,f){return E((d,b)=>{const v=`$throttle$timer$${b}`,y=`$throttle$result$${b}`,g=`$throttle$lastRun$${b}`,m=`$throttle$pending$${b}`;return function(...w){if(this[y]||(this[y]=f?f():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),P&&(this[y]=P(this[y],...w)),this[m])return;const o=this[g]+D;o<=Date.now()?(this[g]=Date.now(),d.apply(this,[this[y]]),this[y]=f?f():void 0):(this[m]=!0,this[v]=setTimeout(()=>{this[m]=!1,this[g]=Date.now(),d.apply(this,[this[y]]),this[y]=f?f():void 0},o-Date.now()))}})}e.throttle=C}),define(ee[13],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.b=[],this.a=function(a){setTimeout(()=>{throw a.stack?S.isErrorNoTelemetry(a)?new S(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.b.push(a),()=>{this.d(a)}}c(a){this.b.forEach(i=>{i(a)})}d(a){this.b.splice(this.b.indexOf(a),1)}setUnexpectedErrorHandler(a){this.a=a}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(a){this.a(a),this.c(a)}onUnexpectedExternalError(a){this.a(a)}}e.ErrorHandler=E,e.errorHandler=new E;function M(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=M;function n(t){if(!t||typeof t!="object")return!1;const a=t;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=n;function C(t){d(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=C;function D(t){d(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=D;function P(t){if(t instanceof Error){const{name:a,message:i}=t,s=t.stacktrace||t.stack;return{$isError:!0,name:a,message:i,stack:s,noTelemetry:S.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=P;const f="Canceled";function d(t){return t instanceof b?!0:t instanceof Error&&t.name===f&&t.message===f}e.isCancellationError=d;class b extends Error{constructor(){super(f),this.name=this.message}}e.CancellationError=b;function v(){const t=new Error(f);return t.name=t.message,t}e.canceled=v;function y(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=y;function g(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=g;function m(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function w(t){const a=new Error(`${t} has been disposed`);return a.name="DISPOSED",a}e.disposed=w;function o(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=o;class h extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}e.NotImplementedError=h;class p extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}e.NotSupportedError=p;class k extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=k;class S extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof S)return a;const i=new S;return i.message=a.message,i.stack=a.stack,i}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}e.ErrorNoTelemetry=S;class R extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,R.prototype);debugger}}e.BugIndicatingError=R}),define(ee[25],te([0,1,13]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function M(j,$=0){return j[j.length-(1+$)]}e.tail=M;function n(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=n;function C(j,$,q=(oe,de)=>oe===de){if(j===$)return!0;if(!j||!$||j.length!==$.length)return!1;for(let oe=0,de=j.length;oe<de;oe++)if(!q(j[oe],$[oe]))return!1;return!0}e.equals=C;function D(j,$){const q=j.length-1;$<q&&(j[$]=j[q]),j.pop()}e.removeFastWithoutKeepingOrder=D;function P(j,$,q){return f(j.length,oe=>q(j[oe],$))}e.binarySearch=P;function f(j,$){let q=0,oe=j-1;for(;q<=oe;){const de=(q+oe)/2|0,pe=$(de);if(pe<0)q=de+1;else if(pe>0)oe=de-1;else return de}return-(q+1)}e.binarySearch2=f;function d(j,$){let q=0,oe=j.length;if(oe===0)return 0;for(;q<oe;){const de=Math.floor((q+oe)/2);$(j[de])?oe=de:q=de+1}return q}e.findFirstInSorted=d;function b(j,$,q){if(j=j|0,j>=$.length)throw new TypeError("invalid index");const oe=$[Math.floor($.length*Math.random())],de=[],pe=[],ye=[];for(const Le of $){const Fe=q(Le,oe);Fe<0?de.push(Le):Fe>0?pe.push(Le):ye.push(Le)}return j<de.length?b(j,de,q):j<de.length+ye.length?ye[0]:b(j-(de.length+ye.length),pe,q)}e.quickSelect=b;function v(j,$){const q=[];let oe;for(const de of j.slice(0).sort($))!oe||$(oe[0],de)!==0?(oe=[de],q.push(oe)):oe.push(de);return q}e.groupBy=v;function y(j,$,q){const oe=[];function de(Le,Fe,Te){if(Fe===0&&Te.length===0)return;const we=oe[oe.length-1];we&&we.start+we.deleteCount===Le?(we.deleteCount+=Fe,we.toInsert.push(...Te)):oe.push({start:Le,deleteCount:Fe,toInsert:Te})}let pe=0,ye=0;for(;;){if(pe===j.length){de(pe,0,$.slice(ye));break}if(ye===$.length){de(pe,j.length-pe,[]);break}const Le=j[pe],Fe=$[ye],Te=q(Le,Fe);Te===0?(pe+=1,ye+=1):Te<0?(de(pe,1,[]),pe+=1):Te>0&&(de(pe,0,[Fe]),ye+=1)}return oe}e.sortedDiff=y;function g(j,$,q){const oe=y(j,$,q),de=[],pe=[];for(const ye of oe)de.push(...j.slice(ye.start,ye.start+ye.deleteCount)),pe.push(...ye.toInsert);return{removed:de,added:pe}}e.delta=g;function m(j,$,q){if(q===0)return[];const oe=j.slice(0,q).sort($);return o(j,$,oe,q,j.length),oe}e.top=m;function w(j,$,q,oe,de){return q===0?Promise.resolve([]):new Promise((pe,ye)=>{(async()=>{const Le=j.length,Fe=j.slice(0,q).sort($);for(let Te=q,we=Math.min(q+oe,Le);Te<Le;Te=we,we=Math.min(we+oe,Le)){if(Te>q&&await new Promise(Ce=>setTimeout(Ce)),de&&de.isCancellationRequested)throw new E.CancellationError;o(j,$,Fe,Te,we)}return Fe})().then(pe,ye)})}e.topAsync=w;function o(j,$,q,oe,de){for(const pe=q.length;oe<de;oe++){const ye=j[oe];if($(ye,q[pe-1])<0){q.pop();const Le=d(q,Fe=>$(ye,Fe)<0);q.splice(Le,0,ye)}}}function h(j){return j.filter($=>!!$)}e.coalesce=h;function p(j){let $=0;for(let q=0;q<j.length;q++)j[q]&&(j[$]=j[q],$+=1);j.length=$}e.coalesceInPlace=p;function k(j,$,q){j.splice(q,0,j.splice($,1)[0])}e.move=k;function S(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=S;function R(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=R;function t(j,$=q=>q){const q=new Set;return j.filter(oe=>{const de=$(oe);return q.has(de)?!1:(q.add(de),!0)})}e.distinct=t;function a(j){const $=new Set;return q=>{const oe=j(q);return $.has(oe)?!1:($.add(oe),!0)}}e.uniqueFilter=a;function i(j,$){const q=s(j,$);if(q!==-1)return j[q]}e.findLast=i;function s(j,$){for(let q=j.length-1;q>=0;q--){const oe=j[q];if($(oe))return q}return-1}e.lastIndex=s;function c(j,$){return j.length>0?j[0]:$}e.firstOrDefault=c;function u(j,$){return j.length>0?j[j.length-1]:$}e.lastOrDefault=u;function r(j,$,q=(oe,de)=>oe===de){let oe=0;for(let de=0,pe=Math.min(j.length,$.length);de<pe&&q(j[de],$[de]);de++)oe++;return oe}e.commonPrefixLength=r;function l(j){return[].concat(...j)}e.flatten=l;function I(j,$){let q=typeof $=="number"?j:0;typeof $=="number"?q=j:(q=0,$=j);const oe=[];if(q<=$)for(let de=q;de<$;de++)oe.push(de);else for(let de=q;de>$;de--)oe.push(de);return oe}e.range=I;function A(j,$,q){return j.reduce((oe,de)=>(oe[$(de)]=q?q(de):de,oe),Object.create(null))}e.index=A;function O(j,$){return j.push($),()=>N(j,$)}e.insert=O;function N(j,$){const q=j.indexOf($);if(q>-1)return j.splice(q,1),$}e.remove=N;function X(j,$,q){const oe=j.slice(0,$),de=j.slice($);return oe.concat(q,de)}e.arrayInsert=X;function V(j,$){let q;if(typeof $=="number"){let oe=$;q=()=>{const de=Math.sin(oe++)*179426549;return de-Math.floor(de)}}else q=Math.random;for(let oe=j.length-1;oe>0;oe-=1){const de=Math.floor(q()*(oe+1)),pe=j[oe];j[oe]=j[de],j[de]=pe}}e.shuffle=V;function K(j,$){const q=j.indexOf($);q>-1&&(j.splice(q,1),j.unshift($))}e.pushToStart=K;function ie(j,$){const q=j.indexOf($);q>-1&&(j.splice(q,1),j.push($))}e.pushToEnd=ie;function re(j,$){for(const q of $)j.push(q)}e.pushMany=re;function ce(j,$){return Array.isArray(j)?j.map($):$(j)}e.mapArrayOrNot=ce;function fe(j){return Array.isArray(j)?j:[j]}e.asArray=fe;function ge(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=ge;function x(j,$){for(const q of j){const oe=$(q);if(oe!==void 0)return oe}}e.mapFind=x;function F(j,$,q){const oe=z(j,$),de=j.length,pe=q.length;j.length=de+pe;for(let ye=de-1;ye>=oe;ye--)j[ye+pe]=j[ye];for(let ye=0;ye<pe;ye++)j[ye+oe]=q[ye]}e.insertInto=F;function W(j,$,q,oe){const de=z(j,$),pe=j.splice(de,q);return F(j,de,oe),pe}e.splice=W;function z(j,$){return $<0?Math.max($+j.length,0):Math.min($,j.length)}var J;(function(j){function $(de){return de<0}j.isLessThan=$;function q(de){return de>0}j.isGreaterThan=q;function oe(de){return de===0}j.isNeitherLessOrGreaterThan=oe,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(J=e.CompareResult||(e.CompareResult={}));function ne(j,$){return(q,oe)=>$(j(q),j(oe))}e.compareBy=ne;function se(...j){return($,q)=>{for(const oe of j){const de=oe($,q);if(!J.isNeitherLessOrGreaterThan(de))return de}return J.neitherLessOrGreaterThan}}e.tieBreakComparators=se;const Z=(j,$)=>j-$;e.numberComparator=Z;function U(j,$){if(j.length===0)return;let q=j[0];for(let oe=1;oe<j.length;oe++){const de=j[oe];$(de,q)>0&&(q=de)}return q}e.findMaxBy=U;function L(j,$){if(j.length===0)return;let q=j[0];for(let oe=1;oe<j.length;oe++){const de=j[oe];$(de,q)>=0&&(q=de)}return q}e.findLastMaxBy=L;function T(j,$){return U(j,(q,oe)=>-$(q,oe))}e.findMinBy=T;class B{constructor($){this.f=$,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile($){let q=this.c;for(;q<this.f.length&&$(this.f[q]);)q++;const oe=q===this.c?null:this.f.slice(this.c,q);return this.c=q,oe}takeFromEndWhile($){let q=this.d;for(;q>=0&&$(this.f[q]);)q--;const oe=q===this.d?null:this.f.slice(q+1,this.d+1);return this.d=q,oe}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const $=this.f[this.c];return this.c++,$}removeLast(){const $=this.f[this.d];return this.d--,$}takeCount($){const q=this.f.slice(this.c,this.c+$);return this.c+=$,q}}e.ArrayQueue=B;class H{constructor($){this.iterate=$}forEach($){this.iterate(q=>($(q),!0))}toArray(){const $=[];return this.iterate(q=>($.push(q),!0)),$}filter($){return new H(q=>this.iterate(oe=>$(oe)?q(oe):!0))}map($){return new H(q=>this.iterate(oe=>q($(oe))))}some($){let q=!1;return this.iterate(oe=>(q=$(oe),!q)),q}findFirst($){let q;return this.iterate(oe=>$(oe)?(q=oe,!1):!0),q}findLast($){let q;return this.iterate(oe=>($(oe)&&(q=oe),!0)),q}findLastMaxBy($){let q,oe=!0;return this.iterate(de=>((oe||J.isGreaterThan($(de,q)))&&(oe=!1,q=de),!0)),q}}H.empty=new H(j=>{}),e.CallbackIterable=H}),define(ee[123],te([0,1,13]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function M(f,d){if(!f)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}e.ok=M;function n(f,d="Unreachable"){throw new Error(d)}e.assertNever=n;function C(f){if(!f)throw new E.BugIndicatingError("Assertion Failed")}e.assert=C;function D(f){if(!f()){debugger;f(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function P(f,d){let b=0;for(;b<f.length-1;){const v=f[b],y=f[b+1];if(!d(v,y))return!1;b++}return!0}e.checkAdjacentItems=P}),define(ee[50],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(M){const n=this;let C=!1,D;return function(){return C||(C=!0,D=M.apply(n,arguments)),D}}e.once=E}),define(ee[70],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(M){function n(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}M.is=n;const C=Object.freeze([]);function D(){return C}M.empty=D;function*P(S){yield S}M.single=P;function f(S){return n(S)?S:P(S)}M.wrap=f;function d(S){return S||C}M.from=d;function b(S){return!S||S[Symbol.iterator]().next().done===!0}M.isEmpty=b;function v(S){return S[Symbol.iterator]().next().value}M.first=v;function y(S,R){for(const t of S)if(R(t))return!0;return!1}M.some=y;function g(S,R){for(const t of S)if(R(t))return t}M.find=g;function*m(S,R){for(const t of S)R(t)&&(yield t)}M.filter=m;function*w(S,R){let t=0;for(const a of S)yield R(a,t++)}M.map=w;function*o(...S){for(const R of S)for(const t of R)yield t}M.concat=o;function h(S,R,t){let a=t;for(const i of S)a=R(a,i);return a}M.reduce=h;function*p(S,R,t=S.length){for(R<0&&(R+=S.length),t<0?t+=S.length:t>S.length&&(t=S.length);R<t;R++)yield S[R]}M.slice=p;function k(S,R=Number.POSITIVE_INFINITY){const t=[];if(R===0)return[t,S];const a=S[Symbol.iterator]();for(let i=0;i<R;i++){const s=a.next();if(s.done)return[t,M.empty()];t.push(s.value)}return[t,{[Symbol.iterator](){return a}}]}M.consume=k})(E=e.Iterable||(e.Iterable={}))}),define(ee[43],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var M;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var n;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(n=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(t){t.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function D(t,a=!1){let i=0;const s=t.length;let c="",u=0,r=16,l=0;function I(ie){let re=0,ce=0;for(;re<ie;){const fe=t.charCodeAt(i);if(fe>=48&&fe<=57)ce=ce*16+fe-48;else if(fe>=65&&fe<=70)ce=ce*16+fe-65+10;else if(fe>=97&&fe<=102)ce=ce*16+fe-97+10;else break;i++,re++}return re<ie&&(ce=-1),ce}function A(ie){i=ie,c="",u=0,r=16,l=0}function O(){const ie=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&d(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&d(t.charCodeAt(i)))for(i++;i<t.length&&d(t.charCodeAt(i));)i++;else return l=3,t.substring(ie,i);let re=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&d(t.charCodeAt(i))){for(i++;i<t.length&&d(t.charCodeAt(i));)i++;re=i}else l=3;return t.substring(ie,re)}function N(){let ie="",re=i;for(;;){if(i>=s){ie+=t.substring(re,i),l=2;break}const ce=t.charCodeAt(i);if(ce===34){ie+=t.substring(re,i),i++;break}if(ce===92){if(ie+=t.substring(re,i),i++,i>=s){l=2;break}switch(t.charCodeAt(i++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const ge=I(4);ge>=0?ie+=String.fromCharCode(ge):l=4;break}default:l=5}re=i;continue}if(ce>=0&&ce<=31)if(f(ce)){ie+=t.substring(re,i),l=2;break}else l=6;i++}return ie}function X(){if(c="",l=0,u=i,i>=s)return u=s,r=17;let ie=t.charCodeAt(i);if(P(ie)){do i++,c+=String.fromCharCode(ie),ie=t.charCodeAt(i);while(P(ie));return r=15}if(f(ie))return i++,c+=String.fromCharCode(ie),ie===13&&t.charCodeAt(i)===10&&(i++,c+=`
`),r=14;switch(ie){case 123:return i++,r=1;case 125:return i++,r=2;case 91:return i++,r=3;case 93:return i++,r=4;case 58:return i++,r=6;case 44:return i++,r=5;case 34:return i++,c=N(),r=10;case 47:{const re=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<s&&!f(t.charCodeAt(i));)i++;return c=t.substring(re,i),r=12}if(t.charCodeAt(i+1)===42){i+=2;const ce=s-1;let fe=!1;for(;i<ce;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,fe=!0;break}i++}return fe||(i++,l=1),c=t.substring(re,i),r=13}return c+=String.fromCharCode(ie),i++,r=16}case 45:if(c+=String.fromCharCode(ie),i++,i===s||!d(t.charCodeAt(i)))return r=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=O(),r=11;default:for(;i<s&&V(ie);)i++,ie=t.charCodeAt(i);if(u!==i){switch(c=t.substring(u,i),c){case"true":return r=8;case"false":return r=9;case"null":return r=7}return r=16}return c+=String.fromCharCode(ie),i++,r=16}}function V(ie){if(P(ie)||f(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function K(){let ie;do ie=X();while(ie>=12&&ie<=15);return ie}return{setPosition:A,getPosition:()=>i,scan:a?K:X,getToken:()=>r,getTokenValue:()=>c,getTokenOffset:()=>u,getTokenLength:()=>i-u,getTokenError:()=>l}}e.createScanner=D;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function d(t){return t>=48&&t<=57}var b;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(b||(b={}));function v(t,a){const i=[],s=new Object;let c;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function l(I,A,O,N){u.value=I,u.offset=A,u.length=O,u.type=N,u.colonOffset=void 0,c=u}try{k(t,{onObjectBegin:(I,A)=>{if(a<=I)throw s;c=void 0,r=a>I,i.push("")},onObjectProperty:(I,A,O)=>{if(a<A||(l(I,A,O,"property"),i[i.length-1]=I,a<=A+O))throw s},onObjectEnd:(I,A)=>{if(a<=I)throw s;c=void 0,i.pop()},onArrayBegin:(I,A)=>{if(a<=I)throw s;c=void 0,i.push(0)},onArrayEnd:(I,A)=>{if(a<=I)throw s;c=void 0,i.pop()},onLiteralValue:(I,A,O)=>{if(a<A||(l(I,A,O,R(I)),a<=A+O))throw s},onSeparator:(I,A,O)=>{if(a<=A)throw s;if(I===":"&&c&&c.type==="property")c.colonOffset=A,r=!1,c=void 0;else if(I===","){const N=i[i.length-1];typeof N=="number"?i[i.length-1]=N+1:(r=!0,i[i.length-1]=""),c=void 0}}})}catch(I){if(I!==s)throw I}return{path:i,previousNode:c,isAtPropertyKey:r,matches:I=>{let A=0;for(let O=0;A<I.length&&O<i.length;O++)if(I[A]===i[O]||I[A]==="*")A++;else if(I[A]!=="**")return!1;return A===I.length}}}e.getLocation=v;function y(t,a=[],i=C.DEFAULT){let s=null,c=[];const u=[];function r(I){Array.isArray(c)?c.push(I):s!==null&&(c[s]=I)}return k(t,{onObjectBegin:()=>{const I={};r(I),u.push(c),c=I,s=null},onObjectProperty:I=>{s=I},onObjectEnd:()=>{c=u.pop()},onArrayBegin:()=>{const I=[];r(I),u.push(c),c=I,s=null},onArrayEnd:()=>{c=u.pop()},onLiteralValue:r,onError:(I,A,O)=>{a.push({error:I,offset:A,length:O})}},i),c[0]}e.parse=y;function g(t,a=[],i=C.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(I){s.type==="property"&&(s.length=I-s.offset,s=s.parent)}function u(I){return s.children.push(I),I}k(t,{onObjectBegin:I=>{s=u({type:"object",offset:I,length:-1,parent:s,children:[]})},onObjectProperty:(I,A,O)=>{s=u({type:"property",offset:A,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:I,offset:A,length:O,parent:s})},onObjectEnd:(I,A)=>{s.length=I+A-s.offset,s=s.parent,c(I+A)},onArrayBegin:(I,A)=>{s=u({type:"array",offset:I,length:-1,parent:s,children:[]})},onArrayEnd:(I,A)=>{s.length=I+A-s.offset,s=s.parent,c(I+A)},onLiteralValue:(I,A,O)=>{u({type:R(I),offset:A,length:O,parent:s,value:I}),c(A+O)},onSeparator:(I,A,O)=>{s.type==="property"&&(I===":"?s.colonOffset=A:I===","&&c(A))},onError:(I,A,O)=>{a.push({error:I,offset:A,length:O})}},i);const l=s.children[0];return l&&delete l.parent,l}e.parseTree=g;function m(t,a){if(!t)return;let i=t;for(const s of a)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let c=!1;for(const u of i.children)if(Array.isArray(u.children)&&u.children[0].value===s){i=u.children[1],c=!0;break}if(!c)return}else{const c=s;if(i.type!=="array"||c<0||!Array.isArray(i.children)||c>=i.children.length)return;i=i.children[c]}return i}e.findNodeAtLocation=m;function w(t){if(!t.parent||!t.parent.children)return[];const a=w(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;a.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&a.push(i)}return a}e.getNodePath=w;function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const a=Object.create(null);for(const i of t.children){const s=i.children[1];s&&(a[i.children[0].value]=o(s))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=o;function h(t,a,i=!1){return a>=t.offset&&a<t.offset+t.length||i&&a===t.offset+t.length}e.contains=h;function p(t,a,i=!1){if(h(t,a,i)){const s=t.children;if(Array.isArray(s))for(let c=0;c<s.length&&s[c].offset<=a;c++){const u=p(s[c],a,i);if(u)return u}return t}}e.findNodeAtOffset=p;function k(t,a,i=C.DEFAULT){const s=D(t,!1);function c(ne){return ne?()=>ne(s.getTokenOffset(),s.getTokenLength()):()=>!0}function u(ne){return ne?se=>ne(se,s.getTokenOffset(),s.getTokenLength()):()=>!0}const r=c(a.onObjectBegin),l=u(a.onObjectProperty),I=c(a.onObjectEnd),A=c(a.onArrayBegin),O=c(a.onArrayEnd),N=u(a.onLiteralValue),X=u(a.onSeparator),V=c(a.onComment),K=u(a.onError),ie=i&&i.disallowComments,re=i&&i.allowTrailingComma;function ce(){for(;;){const ne=s.scan();switch(s.getTokenError()){case 4:fe(14);break;case 5:fe(15);break;case 3:fe(13);break;case 1:ie||fe(11);break;case 2:fe(12);break;case 6:fe(16);break}switch(ne){case 12:case 13:ie?fe(10):V();break;case 16:fe(1);break;case 15:case 14:break;default:return ne}}}function fe(ne,se=[],Z=[]){if(K(ne),se.length+Z.length>0){let U=s.getToken();for(;U!==17;){if(se.indexOf(U)!==-1){ce();break}else if(Z.indexOf(U)!==-1)break;U=ce()}}}function ge(ne){const se=s.getTokenValue();return ne?N(se):l(se),ce(),!0}function x(){switch(s.getToken()){case 11:{let ne=0;try{ne=JSON.parse(s.getTokenValue()),typeof ne!="number"&&(fe(2),ne=0)}catch{fe(2)}N(ne);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return ce(),!0}function F(){return s.getToken()!==10?(fe(3,[],[2,5]),!1):(ge(!1),s.getToken()===6?(X(":"),ce(),J()||fe(4,[],[2,5])):fe(5,[],[2,5]),!0)}function W(){r(),ce();let ne=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ne||fe(4,[],[]),X(","),ce(),s.getToken()===2&&re)break}else ne&&fe(6,[],[]);F()||fe(4,[],[2,5]),ne=!0}return I(),s.getToken()!==2?fe(7,[2],[]):ce(),!0}function z(){A(),ce();let ne=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ne||fe(4,[],[]),X(","),ce(),s.getToken()===4&&re)break}else ne&&fe(6,[],[]);J()||fe(4,[],[4,5]),ne=!0}return O(),s.getToken()!==4?fe(8,[4],[]):ce(),!0}function J(){switch(s.getToken()){case 3:return z();case 1:return W();case 10:return ge(!0);default:return x()}}return ce(),s.getToken()===17?i.allowEmptyContent?!0:(fe(4,[],[]),!1):J()?(s.getToken()!==17&&fe(9,[],[]),!0):(fe(4,[],[]),!1)}e.visit=k;function S(t,a){const i=D(t),s=[];let c,u=0,r;do switch(r=i.getPosition(),c=i.scan(),c){case 12:case 13:case 17:u!==r&&s.push(t.substring(u,r)),a!==void 0&&s.push(i.getTokenValue().replace(/[^\r\n]/g,a)),u=i.getPosition();break}while(c!==17);return s.join("")}e.stripComments=S;function R(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=R}),define(ee[124],te([0,1,43]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function M(d,b,v){let y,g,m,w,o;if(b){for(w=b.offset,o=w+b.length,m=w;m>0&&!f(d,m-1);)m--;let r=o;for(;r<d.length&&!f(d,r);)r++;g=d.substring(m,r),y=D(g,v)}else g=d,y=0,m=0,w=0,o=d.length;const h=P(v,d);let p=!1,k=0,S;v.insertSpaces?S=C(" ",v.tabSize||4):S="	";const R=(0,E.createScanner)(g,!1);let t=!1;function a(){return h+C(S,y+k)}function i(){let r=R.scan();for(p=!1;r===15||r===14;)p=p||r===14,r=R.scan();return t=r===16||R.getTokenError()!==0,r}const s=[];function c(r,l,I){!t&&l<o&&I>w&&d.substring(l,I)!==r&&s.push({offset:l,length:I-l,content:r})}let u=i();if(u!==17){const r=R.getTokenOffset()+m,l=C(S,y);c(l,m,r)}for(;u!==17;){let r=R.getTokenOffset()+R.getTokenLength()+m,l=i(),I="";for(;!p&&(l===12||l===13);){const O=R.getTokenOffset()+m;c(" ",r,O),r=R.getTokenOffset()+R.getTokenLength()+m,I=l===12?a():"",l=i()}if(l===2)u!==1&&(k--,I=a());else if(l===4)u!==3&&(k--,I=a());else{switch(u){case 3:case 1:k++,I=a();break;case 5:case 12:I=a();break;case 13:p?I=a():I=" ";break;case 6:I=" ";break;case 10:if(l===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?I=" ":l!==5&&l!==17&&(t=!0);break;case 16:t=!0;break}p&&(l===12||l===13)&&(I=a())}const A=R.getTokenOffset()+m;c(I,r,A),u=l}return s}e.format=M;function n(d,b){const v=JSON.stringify(d,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?v.replace(/\r\n|\r|\n/g,b.eol):v}e.toFormattedString=n;function C(d,b){let v="";for(let y=0;y<b;y++)v+=d;return v}function D(d,b){let v=0,y=0;const g=b.tabSize||4;for(;v<d.length;){const m=d.charAt(v);if(m===" ")y++;else if(m==="	")y+=g;else break;v++}return Math.floor(y/g)}function P(d,b){for(let v=0;v<b.length;v++){const y=b.charAt(v);if(y==="\r")return v+1<b.length&&b.charAt(v+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return d&&d.eol||`
`}e.getEOL=P;function f(d,b){return`\r
`.indexOf(d.charAt(b))!==-1}e.isEOL=f}),define(ee[125],te([0,1,43,124]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function n(d,b,v){return C(d,b,void 0,v)}e.removeProperty=n;function C(d,b,v,y,g){const m=b.slice(),w=[],o=(0,E.parseTree)(d,w);let h,p;for(;m.length>0&&(p=m.pop(),h=(0,E.findNodeAtLocation)(o,m),h===void 0&&v!==void 0);)typeof p=="string"?v={[p]:v}:v=[v];if(h)if(h.type==="object"&&typeof p=="string"&&Array.isArray(h.children)){const k=(0,E.findNodeAtLocation)(h,[p]);if(k!==void 0)if(v===void 0){if(!k.parent)throw new Error("Malformed AST");const S=h.children.indexOf(k.parent);let R,t=k.parent.offset+k.parent.length;if(S>0){const a=h.children[S-1];R=a.offset+a.length}else R=h.offset+1,h.children.length>1&&(t=h.children[1].offset);return D(d,{offset:R,length:t-R,content:""},y)}else return D(d,{offset:k.offset,length:k.length,content:JSON.stringify(v)},y);else{if(v===void 0)return[];const S=`${JSON.stringify(p)}: ${JSON.stringify(v)}`,R=g?g(h.children.map(a=>a.children[0].value)):h.children.length;let t;if(R>0){const a=h.children[R-1];t={offset:a.offset+a.length,length:0,content:","+S}}else h.children.length===0?t={offset:h.offset+1,length:0,content:S}:t={offset:h.offset+1,length:0,content:S+","};return D(d,t,y)}}else if(h.type==="array"&&typeof p=="number"&&Array.isArray(h.children))if(v!==void 0){const k=`${JSON.stringify(v)}`;let S;if(h.children.length===0||p===0)S={offset:h.offset+1,length:0,content:h.children.length===0?k:k+","};else{const R=p===-1||p>h.children.length?h.children.length:p,t=h.children[R-1];S={offset:t.offset+t.length,length:0,content:","+k}}return D(d,S,y)}else{const k=p,S=h.children[k];let R;if(h.children.length===1)R={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===k){const t=h.children[k-1],a=t.offset+t.length,i=h.offset+h.length;R={offset:a,length:i-2-a,content:""}}else R={offset:S.offset,length:h.children[k+1].offset-S.offset,content:""};return D(d,R,y)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${h.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return D(d,{offset:o?o.offset:0,length:o?o.length:0,content:JSON.stringify(v)},y)}}e.setProperty=C;function D(d,b,v){let y=P(d,b),g=b.offset,m=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;g>0&&!(0,M.isEOL)(y,g-1);)g--;for(;m<y.length&&!(0,M.isEOL)(y,m);)m++}const w=(0,M.format)(y,{offset:g,length:m-g},v);for(let h=w.length-1;h>=0;h--){const p=w[h];y=P(y,p),g=Math.min(g,p.offset),m=Math.max(m,p.offset+p.length),m+=p.content.length-p.length}const o=d.length-(y.length-m)-g;return[{offset:g,length:o,content:y.substring(g,m)}]}e.withFormatting=D;function P(d,b){return d.substring(0,b.offset)+b.content+d.substring(b.offset+b.length)}e.applyEdit=P;function f(d,b){const v=b.slice(0).sort((g,m)=>{const w=g.offset-m.offset;return w===0?g.length-m.length:w});let y=d.length;for(let g=v.length-1;g>=0;g--){const m=v[g];if(m.offset+m.length<=y)d=P(d,m);else throw new Error("Overlapping edit");y=m.offset}return d}e.applyEdits=f}),define(ee[126],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(n){this.d=n,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(n){this.c=n}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=E}),define(ee[2],te([0,1,50,70]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const n=!1;let C=null;function D(u){C=u}if(e.setDisposableTracker=D,n){const u="__is_disposable_tracked__";D(new class{trackDisposable(r){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[u]||console.log(l)},3e3)}setParent(r,l){if(r&&r!==p.None)try{r[u]=!0}catch{}}markAsDisposed(r){if(r&&r!==p.None)try{r[u]=!0}catch{}}markAsSingleton(r){}})}function P(u){return C?.trackDisposable(u),u}function f(u){C?.markAsDisposed(u)}function d(u,r){C?.setParent(u,r)}function b(u,r){if(!!C)for(const l of u)C.setParent(l,r)}function v(u){return C?.markAsSingleton(u),u}e.markAsSingleton=v;function y(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=y;function g(u){if(M.Iterable.is(u)){const r=[];for(const l of u)if(l)try{l.dispose()}catch(I){r.push(I)}if(r.length===1)throw r[0];if(r.length>1)throw new AggregateError(r,"Encountered errors while disposing of store");return Array.isArray(u)?[]:u}else if(u)return u.dispose(),u}e.dispose=g;function m(u){for(const r of u)y(r)&&r.dispose();return[]}e.disposeIfDisposable=m;function w(...u){const r=o(()=>g(u));return b(u,r),r}e.combinedDisposable=w;function o(u){const r=P({dispose:(0,E.once)(()=>{f(r),u()})});return r}e.toDisposable=o;class h{constructor(){this.c=new Set,this.f=!1,P(this)}dispose(){this.f||(f(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{g(this.c)}finally{this.c.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return d(r,this),this.f?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(r),r}}h.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=h;class p{constructor(){this.q=new h,P(this),d(this.q,this)}dispose(){f(this),this.q.dispose()}B(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(r)}}p.None=Object.freeze({dispose(){}}),e.Disposable=p;class k{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(r){this.b||r===this.a||(this.a?.dispose(),r&&d(r,this),this.a=r)}clear(){this.value=void 0}dispose(){this.b=!0,f(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const r=this.a;return this.a=void 0,r&&d(r,null),r}}e.MutableDisposable=k;class S{constructor(r){this.b=r,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=S;class R{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(r){let l=r;return this.unset=()=>l=void 0,this.isset=()=>l!==void 0,this.dispose=()=>{l&&(l(),l=void 0,f(this))},this}}e.SafeDisposable=R;class t{constructor(){this.a=new Map}acquire(r,...l){let I=this.a.get(r);I||(I={counter:0,object:this.b(r,...l)},this.a.set(r,I));const{object:A}=I,O=(0,E.once)(()=>{--I.counter===0&&(this.c(r,I.object),this.a.delete(r))});return I.counter++,{object:A,dispose:O}}}e.ReferenceCollection=t;class a{constructor(r){this.a=r}async acquire(r,...l){const I=this.a.acquire(r,...l);try{return{object:await I.object,dispose:()=>I.dispose()}}catch(A){throw I.dispose(),A}}}e.AsyncReferenceCollection=a;class i{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=i;function s(u){const r=new h;try{u(r)}finally{r.dispose()}}e.disposeOnReturn=s;class c{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){f(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(r){return this.a.has(r)}get(r){return this.a.get(r)}set(r,l,I=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),I||this.a.get(r)?.dispose(),this.a.set(r,l)}deleteAndDispose(r){this.a.get(r)?.dispose(),this.a.delete(r)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=c}),define(ee[99],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(C){this.element=C,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class M{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let C=this.a;for(;C!==E.Undefined;){const D=C.next;C.prev=E.Undefined,C.next=E.Undefined,C=D}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(C){return this.d(C,!1)}push(C){return this.d(C,!0)}d(C,D){const P=new E(C);if(this.a===E.Undefined)this.a=P,this.b=P;else if(D){const d=this.b;this.b=P,P.prev=d,d.next=P}else{const d=this.a;this.a=P,P.next=d,d.prev=P}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(P))}}shift(){if(this.a!==E.Undefined){const C=this.a.element;return this.e(this.a),C}}pop(){if(this.b!==E.Undefined){const C=this.b.element;return this.e(this.b),C}}e(C){if(C.prev!==E.Undefined&&C.next!==E.Undefined){const D=C.prev;D.next=C.next,C.next.prev=D}else C.prev===E.Undefined&&C.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):C.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):C.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let C=this.a;for(;C!==E.Undefined;)yield C.element,C=C.next}}e.LinkedList=M}),define(ee[35],te([0,1]),function(G,e){"use strict";var E,M,n;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function C(m,w,o){let h=m.get(w);return h===void 0&&(h=o,m.set(w,h)),h}e.getOrSet=C;function D(m){const w=[];return m.forEach((o,h)=>{w.push(`${h} => ${o}`)}),`Map(${m.size}) {${w.join(", ")}}`}e.mapToString=D;function P(m){const w=[];return m.forEach(o=>{w.push(o)}),`Set(${m.size}) {${w.join(", ")}}`}e.setToString=P;class f{constructor(w,o){this.uri=w,this.value=o}}class d{constructor(w,o){this[E]="ResourceMap",w instanceof d?(this.b=new Map(w.b),this.c=o??d.a):(this.b=new Map,this.c=w??d.a)}set(w,o){return this.b.set(this.c(w),new f(w,o)),this}get(w){return this.b.get(this.c(w))?.value}has(w){return this.b.has(this.c(w))}get size(){return this.b.size}clear(){this.b.clear()}delete(w){return this.b.delete(this.c(w))}forEach(w,o){typeof o<"u"&&(w=w.bind(o));for(const[h,p]of this.b)w(p.value,p.uri,this)}*values(){for(const w of this.b.values())yield w.value}*keys(){for(const w of this.b.values())yield w.uri}*entries(){for(const w of this.b.values())yield[w.uri,w.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,w]of this.b)yield[w.uri,w.value]}}d.a=m=>m.toString(),e.ResourceMap=d;class b{constructor(w,o){this[M]="ResourceSet",!w||typeof w=="function"?this.a=new d(w):(this.a=new d(o),w.forEach(this.add,this))}get size(){return this.a.size}add(w){return this.a.set(w,w),this}clear(){this.a.clear()}delete(w){return this.a.delete(w)}forEach(w,o){this.a.forEach((h,p)=>w.call(o,p,p,this))}has(w){return this.a.has(w)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=b;var v;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(v=e.Touch||(e.Touch={}));class y{constructor(){this[n]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(w){return this.a.has(w)}get(w,o=0){const h=this.a.get(w);if(!!h)return o!==0&&this.j(h,o),h.value}set(w,o,h=0){let p=this.a.get(w);if(p)p.value=o,h!==0&&this.j(p,h);else{switch(p={key:w,value:o,next:void 0,previous:void 0},h){case 0:this.h(p);break;case 1:this.g(p);break;case 2:this.h(p);break;default:this.h(p);break}this.a.set(w,p),this.d++}return this}delete(w){return!!this.remove(w)}remove(w){const o=this.a.get(w);if(!!o)return this.a.delete(w),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const w=this.b;return this.a.delete(w.key),this.i(w),this.d--,w.value}forEach(w,o){const h=this.e;let p=this.b;for(;p;){if(o?w.bind(o)(p.value,p.key,this):w(p.value,p.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const w=this,o=this.e;let h=this.b;const p={[Symbol.iterator](){return p},next(){if(w.e!==o)throw new Error("LinkedMap got modified during iteration.");if(h){const k={value:h.key,done:!1};return h=h.next,k}else return{value:void 0,done:!0}}};return p}values(){const w=this,o=this.e;let h=this.b;const p={[Symbol.iterator](){return p},next(){if(w.e!==o)throw new Error("LinkedMap got modified during iteration.");if(h){const k={value:h.value,done:!1};return h=h.next,k}else return{value:void 0,done:!0}}};return p}entries(){const w=this,o=this.e;let h=this.b;const p={[Symbol.iterator](){return p},next(){if(w.e!==o)throw new Error("LinkedMap got modified during iteration.");if(h){const k={value:[h.key,h.value],done:!1};return h=h.next,k}else return{value:void 0,done:!0}}};return p}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(w){if(w>=this.size)return;if(w===0){this.clear();return}let o=this.b,h=this.size;for(;o&&h>w;)this.a.delete(o.key),o=o.next,h--;this.b=o,this.d=h,o&&(o.previous=void 0),this.e++}g(w){if(!this.b&&!this.c)this.c=w;else if(this.b)w.next=this.b,this.b.previous=w;else throw new Error("Invalid list");this.b=w,this.e++}h(w){if(!this.b&&!this.c)this.b=w;else if(this.c)w.previous=this.c,this.c.next=w;else throw new Error("Invalid list");this.c=w,this.e++}i(w){if(w===this.b&&w===this.c)this.b=void 0,this.c=void 0;else if(w===this.b){if(!w.next)throw new Error("Invalid list");w.next.previous=void 0,this.b=w.next}else if(w===this.c){if(!w.previous)throw new Error("Invalid list");w.previous.next=void 0,this.c=w.previous}else{const o=w.next,h=w.previous;if(!o||!h)throw new Error("Invalid list");o.previous=h,h.next=o}w.next=void 0,w.previous=void 0,this.e++}j(w,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(w===this.b)return;const h=w.next,p=w.previous;w===this.c?(p.next=void 0,this.c=p):(h.previous=p,p.next=h),w.previous=void 0,w.next=this.b,this.b.previous=w,this.b=w,this.e++}else if(o===2){if(w===this.c)return;const h=w.next,p=w.previous;w===this.b?(h.previous=void 0,this.b=h):(h.previous=p,p.next=h),w.next=void 0,w.previous=this.c,this.c.next=w,this.c=w,this.e++}}}toJSON(){const w=[];return this.forEach((o,h)=>{w.push([h,o])}),w}fromJSON(w){this.clear();for(const[o,h]of w)this.set(o,h)}}e.LinkedMap=y;class g extends y{constructor(w,o=1){super(),this.k=w,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(w){this.k=w,this.m()}get ratio(){return this.l}set ratio(w){this.l=Math.min(Math.max(0,w),1),this.m()}get(w,o=2){return super.get(w,o)}peek(w){return super.get(w,0)}set(w,o){return super.set(w,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=g}),define(ee[80],te([0,1,35]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const M=new E.LRUCache(1e4);function n(d){return f(d,"NFC",M)}e.normalizeNFC=n;const C=new E.LRUCache(1e4);function D(d){return f(d,"NFD",C)}e.normalizeNFD=D;const P=/[^\u0000-\u0080]/;function f(d,b,v){if(!d)return d;const y=v.get(d);if(y)return y;let g;return P.test(d)?g=d.normalize(b):g=d,v.set(d,g),g}e.removeAccents=function(){const d=/[\u0300-\u036f]/g;return function(b){return D(b).replace(d,"")}}()}),define(ee[127],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(P,f,d){return Math.min(Math.max(P,f),d)}e.clamp=E;function M(P,f){return(f+P%f)%f}e.rot=M;class n{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=n;class C{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=C;class D{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const d=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=d,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=D}),function(){function G(n){const C=[];typeof n=="number"&&C.push("code/timeOrigin",n);function D(f){C.push(f,Date.now())}function P(){const f=[];for(let d=0;d<C.length;d+=2)f.push({name:C[d],startTime:C[d+1]});return f}return{mark:D,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(n){performance.mark(n)},getMarks(){let n=performance.timeOrigin;typeof n!="number"&&(n=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(n)}];for(const D of performance.getEntriesByType("mark"))C.push({name:D.name,startTime:Math.round(n+D.startTime)});return C}};if(typeof process=="object"){const n=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(n)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function E(n){return n.MonacoPerformanceMarks||(n.MonacoPerformanceMarks=e()),n.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=E(M))}(),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var M in E)(typeof exports=="object"?exports:G)[M]=E[M]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function E(M){if(e[M])return e[M].exports;var n=e[M]={i:M,l:!1,exports:{}};return G[M].call(n.exports,n,n.exports,E),n.l=!0,n.exports}return E.m=G,E.c=e,E.d=function(M,n,C){E.o(M,n)||Object.defineProperty(M,n,{enumerable:!0,get:C})},E.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},E.t=function(M,n){if(1&n&&(M=E(M)),8&n||4&n&&typeof M=="object"&&M&&M.__esModule)return M;var C=Object.create(null);if(E.r(C),Object.defineProperty(C,"default",{enumerable:!0,value:M}),2&n&&typeof M!="string")for(var D in M)E.d(C,D,function(P){return M[P]}.bind(null,D));return C},E.n=function(M){var n=M&&M.__esModule?function(){return M.default}:function(){return M};return E.d(n,"a",n),n},E.o=function(M,n){return Object.prototype.hasOwnProperty.call(M,n)},E.p="",E(E.s=0)}([function(G,e,E){(function(M){var n;e=G.exports=Z,n=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var Q=Array.prototype.slice.call(arguments,0);Q.unshift("SEMVER"),console.log.apply(console,Q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var C=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],f=e.src=[],d=0,b=d++;f[b]="0|[1-9]\\d*";var v=d++;f[v]="[0-9]+";var y=d++;f[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=d++;f[g]="("+f[b]+")\\.("+f[b]+")\\.("+f[b]+")";var m=d++;f[m]="("+f[v]+")\\.("+f[v]+")\\.("+f[v]+")";var w=d++;f[w]="(?:"+f[b]+"|"+f[y]+")";var o=d++;f[o]="(?:"+f[v]+"|"+f[y]+")";var h=d++;f[h]="(?:-("+f[w]+"(?:\\."+f[w]+")*))";var p=d++;f[p]="(?:-?("+f[o]+"(?:\\."+f[o]+")*))";var k=d++;f[k]="[0-9A-Za-z-]+";var S=d++;f[S]="(?:\\+("+f[k]+"(?:\\."+f[k]+")*))";var R=d++,t="v?"+f[g]+f[h]+"?"+f[S]+"?";f[R]="^"+t+"$";var a="[v=\\s]*"+f[m]+f[p]+"?"+f[S]+"?",i=d++;f[i]="^"+a+"$";var s=d++;f[s]="((?:<|>)?=?)";var c=d++;f[c]=f[v]+"|x|X|\\*";var u=d++;f[u]=f[b]+"|x|X|\\*";var r=d++;f[r]="[v=\\s]*("+f[u]+")(?:\\.("+f[u]+")(?:\\.("+f[u]+")(?:"+f[h]+")?"+f[S]+"?)?)?";var l=d++;f[l]="[v=\\s]*("+f[c]+")(?:\\.("+f[c]+")(?:\\.("+f[c]+")(?:"+f[p]+")?"+f[S]+"?)?)?";var I=d++;f[I]="^"+f[s]+"\\s*"+f[r]+"$";var A=d++;f[A]="^"+f[s]+"\\s*"+f[l]+"$";var O=d++;f[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=d++;f[N]="(?:~>?)";var X=d++;f[X]="(\\s*)"+f[N]+"\\s+",P[X]=new RegExp(f[X],"g");var V=d++;f[V]="^"+f[N]+f[r]+"$";var K=d++;f[K]="^"+f[N]+f[l]+"$";var ie=d++;f[ie]="(?:\\^)";var re=d++;f[re]="(\\s*)"+f[ie]+"\\s+",P[re]=new RegExp(f[re],"g");var ce=d++;f[ce]="^"+f[ie]+f[r]+"$";var fe=d++;f[fe]="^"+f[ie]+f[l]+"$";var ge=d++;f[ge]="^"+f[s]+"\\s*("+a+")$|^$";var x=d++;f[x]="^"+f[s]+"\\s*("+t+")$|^$";var F=d++;f[F]="(\\s*)"+f[s]+"\\s*("+a+"|"+f[r]+")",P[F]=new RegExp(f[F],"g");var W=d++;f[W]="^\\s*("+f[r]+")\\s+-\\s+("+f[r]+")\\s*$";var z=d++;f[z]="^\\s*("+f[l]+")\\s+-\\s+("+f[l]+")\\s*$";var J=d++;f[J]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)n(ne,f[ne]),P[ne]||(P[ne]=new RegExp(f[ne]));function se(Q,ae){if(Q instanceof Z)return Q;if(typeof Q!="string"||Q.length>C||!(ae?P[i]:P[R]).test(Q))return null;try{return new Z(Q,ae)}catch{return null}}function Z(Q,ae){if(Q instanceof Z){if(Q.loose===ae)return Q;Q=Q.version}else if(typeof Q!="string")throw new TypeError("Invalid Version: "+Q);if(Q.length>C)throw new TypeError("version is longer than "+C+" characters");if(!(this instanceof Z))return new Z(Q,ae);n("SemVer",Q,ae),this.loose=ae;var he=Q.trim().match(ae?P[i]:P[R]);if(!he)throw new TypeError("Invalid Version: "+Q);if(this.raw=Q,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Me=+Pe;if(Me>=0&&Me<D)return Me}return Pe}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=se,e.valid=function(Q,ae){var he=se(Q,ae);return he?he.version:null},e.clean=function(Q,ae){var he=se(Q.trim().replace(/^[=v]+/,""),ae);return he?he.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(Q){return n("SemVer.compare",this.version,this.loose,Q),Q instanceof Z||(Q=new Z(Q,this.loose)),this.compareMain(Q)||this.comparePre(Q)},Z.prototype.compareMain=function(Q){return Q instanceof Z||(Q=new Z(Q,this.loose)),L(this.major,Q.major)||L(this.minor,Q.minor)||L(this.patch,Q.patch)},Z.prototype.comparePre=function(Q){if(Q instanceof Z||(Q=new Z(Q,this.loose)),this.prerelease.length&&!Q.prerelease.length)return-1;if(!this.prerelease.length&&Q.prerelease.length)return 1;if(!this.prerelease.length&&!Q.prerelease.length)return 0;var ae=0;do{var he=this.prerelease[ae],Pe=Q.prerelease[ae];if(n("prerelease compare",ae,he,Pe),he===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(he===void 0)return-1;if(he!==Pe)return L(he,Pe)}while(++ae)},Z.prototype.inc=function(Q,ae){switch(Q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+Q)}return this.format(),this.raw=this.version,this},e.inc=function(Q,ae,he,Pe){typeof he=="string"&&(Pe=he,he=void 0);try{return new Z(Q,he).inc(ae,Pe).version}catch{return null}},e.diff=function(Q,ae){if(j(Q,ae))return null;var he=se(Q),Pe=se(ae);if(he.prerelease.length||Pe.prerelease.length){for(var Me in he)if((Me==="major"||Me==="minor"||Me==="patch")&&he[Me]!==Pe[Me])return"pre"+Me;return"prerelease"}for(var Me in he)if((Me==="major"||Me==="minor"||Me==="patch")&&he[Me]!==Pe[Me])return Me},e.compareIdentifiers=L;var U=/^[0-9]+$/;function L(Q,ae){var he=U.test(Q),Pe=U.test(ae);return he&&Pe&&(Q=+Q,ae=+ae),he&&!Pe?-1:Pe&&!he?1:Q<ae?-1:Q>ae?1:0}function T(Q,ae,he){return new Z(Q,he).compare(new Z(ae,he))}function B(Q,ae,he){return T(Q,ae,he)>0}function H(Q,ae,he){return T(Q,ae,he)<0}function j(Q,ae,he){return T(Q,ae,he)===0}function $(Q,ae,he){return T(Q,ae,he)!==0}function q(Q,ae,he){return T(Q,ae,he)>=0}function oe(Q,ae,he){return T(Q,ae,he)<=0}function de(Q,ae,he,Pe){var Me;switch(ae){case"===":typeof Q=="object"&&(Q=Q.version),typeof he=="object"&&(he=he.version),Me=Q===he;break;case"!==":typeof Q=="object"&&(Q=Q.version),typeof he=="object"&&(he=he.version),Me=Q!==he;break;case"":case"=":case"==":Me=j(Q,he,Pe);break;case"!=":Me=$(Q,he,Pe);break;case">":Me=B(Q,he,Pe);break;case">=":Me=q(Q,he,Pe);break;case"<":Me=H(Q,he,Pe);break;case"<=":Me=oe(Q,he,Pe);break;default:throw new TypeError("Invalid operator: "+ae)}return Me}function pe(Q,ae){if(Q instanceof pe){if(Q.loose===ae)return Q;Q=Q.value}if(!(this instanceof pe))return new pe(Q,ae);n("comparator",Q,ae),this.loose=ae,this.parse(Q),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,n("comp",this)}e.rcompareIdentifiers=function(Q,ae){return L(ae,Q)},e.major=function(Q,ae){return new Z(Q,ae).major},e.minor=function(Q,ae){return new Z(Q,ae).minor},e.patch=function(Q,ae){return new Z(Q,ae).patch},e.compare=T,e.compareLoose=function(Q,ae){return T(Q,ae,!0)},e.rcompare=function(Q,ae,he){return T(ae,Q,he)},e.sort=function(Q,ae){return Q.sort(function(he,Pe){return e.compare(he,Pe,ae)})},e.rsort=function(Q,ae){return Q.sort(function(he,Pe){return e.rcompare(he,Pe,ae)})},e.gt=B,e.lt=H,e.eq=j,e.neq=$,e.gte=q,e.lte=oe,e.cmp=de,e.Comparator=pe;var ye={};function Le(Q,ae){if(Q instanceof Le)return Q.loose===ae?Q:new Le(Q.raw,ae);if(Q instanceof pe)return new Le(Q.value,ae);if(!(this instanceof Le))return new Le(Q,ae);if(this.loose=ae,this.raw=Q,this.set=Q.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Q);this.format()}function Fe(Q){return!Q||Q.toLowerCase()==="x"||Q==="*"}function Te(Q,ae,he,Pe,Me,Ae,Ue,He,Ne,$e,Ge,We,Ve){return((ae=Fe(he)?"":Fe(Pe)?">="+he+".0.0":Fe(Me)?">="+he+"."+Pe+".0":">="+ae)+" "+(He=Fe(Ne)?"":Fe($e)?"<"+(+Ne+1)+".0.0":Fe(Ge)?"<"+Ne+"."+(+$e+1)+".0":We?"<="+Ne+"."+$e+"."+Ge+"-"+We:"<="+He)).trim()}function we(Q,ae){for(var he=0;he<Q.length;he++)if(!Q[he].test(ae))return!1;if(ae.prerelease.length){for(he=0;he<Q.length;he++)if(n(Q[he].semver),Q[he].semver!==ye&&Q[he].semver.prerelease.length>0){var Pe=Q[he].semver;if(Pe.major===ae.major&&Pe.minor===ae.minor&&Pe.patch===ae.patch)return!0}return!1}return!0}function Ce(Q,ae,he){try{ae=new Le(ae,he)}catch{return!1}return ae.test(Q)}function Re(Q,ae,he,Pe){var Me,Ae,Ue,He,Ne;switch(Q=new Z(Q,Pe),ae=new Le(ae,Pe),he){case">":Me=B,Ae=oe,Ue=H,He=">",Ne=">=";break;case"<":Me=H,Ae=q,Ue=B,He="<",Ne="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ce(Q,ae,Pe))return!1;for(var $e=0;$e<ae.set.length;++$e){var Ge=ae.set[$e],We=null,Ve=null;if(Ge.forEach(function(Y){Y.semver===ye&&(Y=new pe(">=0.0.0")),We=We||Y,Ve=Ve||Y,Me(Y.semver,We.semver,Pe)?We=Y:Ue(Y.semver,Ve.semver,Pe)&&(Ve=Y)}),We.operator===He||We.operator===Ne||(!Ve.operator||Ve.operator===He)&&Ae(Q,Ve.semver)||Ve.operator===Ne&&Ue(Q,Ve.semver))return!1}return!0}pe.prototype.parse=function(Q){var ae=this.loose?P[ge]:P[x],he=Q.match(ae);if(!he)throw new TypeError("Invalid comparator: "+Q);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new Z(he[2],this.loose):this.semver=ye},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(Q){return n("Comparator.test",Q,this.loose),this.semver===ye||(typeof Q=="string"&&(Q=new Z(Q,this.loose)),de(Q,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(Q,ae){if(!(Q instanceof pe))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new Le(Q.value,ae),Ce(this.value,he,ae);if(Q.operator==="")return he=new Le(this.value,ae),Ce(Q.semver,he,ae);var Pe=!(this.operator!==">="&&this.operator!==">"||Q.operator!==">="&&Q.operator!==">"),Me=!(this.operator!=="<="&&this.operator!=="<"||Q.operator!=="<="&&Q.operator!=="<"),Ae=this.semver.version===Q.semver.version,Ue=!(this.operator!==">="&&this.operator!=="<="||Q.operator!==">="&&Q.operator!=="<="),He=de(this.semver,"<",Q.semver,ae)&&(this.operator===">="||this.operator===">")&&(Q.operator==="<="||Q.operator==="<"),Ne=de(this.semver,">",Q.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(Q.operator===">="||Q.operator===">");return Pe||Me||Ae&&Ue||He||Ne},e.Range=Le,Le.prototype.format=function(){return this.range=this.set.map(function(Q){return Q.join(" ").trim()}).join("||").trim(),this.range},Le.prototype.toString=function(){return this.range},Le.prototype.parseRange=function(Q){var ae=this.loose;Q=Q.trim(),n("range",Q,ae);var he=ae?P[z]:P[W];Q=Q.replace(he,Te),n("hyphen replace",Q),Q=Q.replace(P[F],"$1$2$3"),n("comparator trim",Q,P[F]),Q=(Q=(Q=Q.replace(P[X],"$1~")).replace(P[re],"$1^")).split(/\s+/).join(" ");var Pe=ae?P[ge]:P[x],Me=Q.split(" ").map(function(Ae){return function(Ue,He){return n("comp",Ue),Ue=function(Ne,$e){return Ne.trim().split(/\s+/).map(function(Ge){return function(We,Ve){n("caret",We,Ve);var Y=Ve?P[fe]:P[ce];return We.replace(Y,function(le,ue,me,Se,Oe){var ze;return n("caret",We,le,ue,me,Se,Oe),Fe(ue)?ze="":Fe(me)?ze=">="+ue+".0.0 <"+(+ue+1)+".0.0":Fe(Se)?ze=ue==="0"?">="+ue+"."+me+".0 <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+".0 <"+(+ue+1)+".0.0":Oe?(n("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),ze=ue==="0"?me==="0"?">="+ue+"."+me+"."+Se+Oe+" <"+ue+"."+me+"."+(+Se+1):">="+ue+"."+me+"."+Se+Oe+" <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+"."+Se+Oe+" <"+(+ue+1)+".0.0"):(n("no pr"),ze=ue==="0"?me==="0"?">="+ue+"."+me+"."+Se+" <"+ue+"."+me+"."+(+Se+1):">="+ue+"."+me+"."+Se+" <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+"."+Se+" <"+(+ue+1)+".0.0"),n("caret return",ze),ze})}(Ge,$e)}).join(" ")}(Ue,He),n("caret",Ue),Ue=function(Ne,$e){return Ne.trim().split(/\s+/).map(function(Ge){return function(We,Ve){var Y=Ve?P[K]:P[V];return We.replace(Y,function(le,ue,me,Se,Oe){var ze;return n("tilde",We,le,ue,me,Se,Oe),Fe(ue)?ze="":Fe(me)?ze=">="+ue+".0.0 <"+(+ue+1)+".0.0":Fe(Se)?ze=">="+ue+"."+me+".0 <"+ue+"."+(+me+1)+".0":Oe?(n("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),ze=">="+ue+"."+me+"."+Se+Oe+" <"+ue+"."+(+me+1)+".0"):ze=">="+ue+"."+me+"."+Se+" <"+ue+"."+(+me+1)+".0",n("tilde return",ze),ze})}(Ge,$e)}).join(" ")}(Ue,He),n("tildes",Ue),Ue=function(Ne,$e){return n("replaceXRanges",Ne,$e),Ne.split(/\s+/).map(function(Ge){return function(We,Ve){We=We.trim();var Y=Ve?P[A]:P[I];return We.replace(Y,function(le,ue,me,Se,Oe,ze){n("xRange",We,le,ue,me,Se,Oe,ze);var tt=Fe(me),Qe=tt||Fe(Se),Ke=Qe||Fe(Oe);return ue==="="&&Ke&&(ue=""),tt?le=ue===">"||ue==="<"?"<0.0.0":"*":ue&&Ke?(Qe&&(Se=0),Ke&&(Oe=0),ue===">"?(ue=">=",Qe?(me=+me+1,Se=0,Oe=0):Ke&&(Se=+Se+1,Oe=0)):ue==="<="&&(ue="<",Qe?me=+me+1:Se=+Se+1),le=ue+me+"."+Se+"."+Oe):Qe?le=">="+me+".0.0 <"+(+me+1)+".0.0":Ke&&(le=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0"),n("xRange return",le),le})}(Ge,$e)}).join(" ")}(Ue,He),n("xrange",Ue),Ue=function(Ne,$e){return n("replaceStars",Ne,$e),Ne.trim().replace(P[J],"")}(Ue,He),n("stars",Ue),Ue}(Ae,ae)}).join(" ").split(/\s+/);return this.loose&&(Me=Me.filter(function(Ae){return!!Ae.match(Pe)})),Me=Me.map(function(Ae){return new pe(Ae,ae)})},Le.prototype.intersects=function(Q,ae){if(!(Q instanceof Le))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(Pe){return Q.set.some(function(Me){return Me.every(function(Ae){return Pe.intersects(Ae,ae)})})})})},e.toComparators=function(Q,ae){return new Le(Q,ae).set.map(function(he){return he.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},Le.prototype.test=function(Q){if(!Q)return!1;typeof Q=="string"&&(Q=new Z(Q,this.loose));for(var ae=0;ae<this.set.length;ae++)if(we(this.set[ae],Q))return!0;return!1},e.satisfies=Ce,e.maxSatisfying=function(Q,ae,he){var Pe=null,Me=null;try{var Ae=new Le(ae,he)}catch{return null}return Q.forEach(function(Ue){Ae.test(Ue)&&(Pe&&Me.compare(Ue)!==-1||(Me=new Z(Pe=Ue,he)))}),Pe},e.minSatisfying=function(Q,ae,he){var Pe=null,Me=null;try{var Ae=new Le(ae,he)}catch{return null}return Q.forEach(function(Ue){Ae.test(Ue)&&(Pe&&Me.compare(Ue)!==1||(Me=new Z(Pe=Ue,he)))}),Pe},e.validRange=function(Q,ae){try{return new Le(Q,ae).range||"*"}catch{return null}},e.ltr=function(Q,ae,he){return Re(Q,ae,"<",he)},e.gtr=function(Q,ae,he){return Re(Q,ae,">",he)},e.outside=Re,e.prerelease=function(Q,ae){var he=se(Q,ae);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(Q,ae,he){return Q=new Le(Q,he),ae=new Le(ae,he),Q.intersects(ae)},e.coerce=function(Q){if(Q instanceof Z)return Q;if(typeof Q!="string")return null;var ae=Q.match(P[O]);return ae==null?null:se((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,E(1))},function(G,e){var E,M,n=G.exports={};function C(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function P(o){if(E===setTimeout)return setTimeout(o,0);if((E===C||!E)&&setTimeout)return E=setTimeout,setTimeout(o,0);try{return E(o,0)}catch{try{return E.call(null,o,0)}catch{return E.call(this,o,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:C}catch{E=C}try{M=typeof clearTimeout=="function"?clearTimeout:D}catch{M=D}})();var f,d=[],b=!1,v=-1;function y(){b&&f&&(b=!1,f.length?d=f.concat(d):v=-1,d.length&&g())}function g(){if(!b){var o=P(y);b=!0;for(var h=d.length;h;){for(f=d,d=[];++v<h;)f&&f[v].run();v=-1,h=d.length}f=null,b=!1,function(p){if(M===clearTimeout)return clearTimeout(p);if((M===D||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(p);try{M(p)}catch{try{return M.call(null,p)}catch{return M.call(this,p)}}}(o)}}function m(o,h){this.fun=o,this.array=h}function w(){}n.nextTick=function(o){var h=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)h[p-1]=arguments[p];d.push(new m(o,h)),d.length!==1||b||P(g)},m.prototype.run=function(){this.fun.apply(null,this.array)},n.title="browser",n.browser=!0,n.env={},n.argv=[],n.version="",n.versions={},n.on=w,n.addListener=w,n.once=w,n.off=w,n.removeListener=w,n.removeAllListeners=w,n.emit=w,n.prependListener=w,n.prependOnceListener=w,n.listeners=function(o){return[]},n.binding=function(o){throw new Error("process.binding is not supported")},n.cwd=function(){return"/"},n.chdir=function(o){throw new Error("process.chdir is not supported")},n.umask=function(){return 0}}])}),define(ee[128],te([0,1]),function(G,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class M{constructor(P,f,d){this.level=P,this.key=f,this.value=d,this.forward=[]}}const n=void 0;class C{constructor(P,f=2**16){this.comparator=P,this[E]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(f)|0),this.e=new M(this.c,n,n)}get size(){return this.f}clear(){this.e=new M(this.c,n,n)}has(P){return Boolean(C.g(this,P,this.comparator))}get(P){return C.g(this,P,this.comparator)?.value}set(P,f){return C.h(this,P,f,this.comparator)&&(this.f+=1),this}delete(P){const f=C.k(this,P,this.comparator);return f&&(this.f-=1),f}forEach(P,f){let d=this.e.forward[0];for(;d;)P.call(f,d.value,d.key,this),d=d.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",f=this.e.forward[0];for(;f;)P+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return P}static g(P,f,d){let b=P.e;for(let v=P.d-1;v>=0;v--)for(;b.forward[v]&&d(b.forward[v].key,f)<0;)b=b.forward[v];if(b=b.forward[0],b&&d(b.key,f)===0)return b}static h(P,f,d,b){const v=[];let y=P.e;for(let g=P.d-1;g>=0;g--){for(;y.forward[g]&&b(y.forward[g].key,f)<0;)y=y.forward[g];v[g]=y}if(y=y.forward[0],y&&b(y.key,f)===0)return y.value=d,!1;{const g=C.j(P);if(g>P.d){for(let m=P.d;m<g;m++)v[m]=P.e;P.d=g}y=new M(g,f,d);for(let m=0;m<g;m++)y.forward[m]=v[m].forward[m],v[m].forward[m]=y;return!0}}static j(P,f=.5){let d=1;for(;Math.random()<f&&d<P.c;)d+=1;return d}static k(P,f,d){const b=[];let v=P.e;for(let y=P.d-1;y>=0;y--){for(;v.forward[y]&&d(v.forward[y].key,f)<0;)v=v.forward[y];b[y]=v}if(v=v.forward[0],!v||d(v.key,f)!==0)return!1;for(let y=0;y<P.d&&b[y].forward[y]===v;y++)b[y].forward[y]=v.forward[y];for(;P.d>0&&P.e.forward[P.d-1]===n;)P.d-=1;return!0}}e.SkipList=C}),define(ee[60],te([0,1,13,2]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function n(S){const R=S;return R?typeof R.read=="function":!1}e.isReadable=n;function C(S){const R=S;return R?[R.on,R.pause,R.resume,R.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=C;function D(S){const R=S;return R?C(R.stream)&&Array.isArray(R.buffer)&&typeof R.ended=="boolean":!1}e.isReadableBufferedStream=D;function P(S,R){return new f(S,R)}e.newWriteableStream=P;class f{constructor(R,t){this.e=R,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(R){if(!this.a.destroyed){if(this.a.flowing)this.g(R);else if(this.b.data.push(R),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(R){this.a.destroyed||(this.a.flowing?this.h(R):this.b.error.push(R))}end(R){this.a.destroyed||(typeof R<"u"&&this.write(R),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(R){this.c.data.slice(0).forEach(t=>t(R))}h(R){this.c.error.length===0?(0,E.onUnexpectedError)(R):this.c.error.slice(0).forEach(t=>t(R))}i(){this.c.end.slice(0).forEach(R=>R())}on(R,t){if(!this.a.destroyed)switch(R){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(R,t){if(this.a.destroyed)return;let a;switch(R){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const i=a.indexOf(t);i>=0&&a.splice(i,1)}}j(){if(this.b.data.length>0){const R=this.e(this.b.data);this.g(R),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const R of this.b.error)this.h(R);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(S,R){const t=[];let a;for(;(a=S.read())!==null;)t.push(a);return R(t)}e.consumeReadable=d;function b(S,R,t){const a=[];let i;for(;(i=S.read())!==null&&a.length<t;)a.push(i);return i===null&&a.length>0?R(a):{read:()=>{if(a.length>0)return a.shift();if(typeof i<"u"){const s=i;return i=void 0,s}return S.read()}}}e.peekReadable=b;function v(S,R){return new Promise((t,a)=>{const i=[];y(S,{onData:s=>{R&&i.push(s)},onError:s=>{R?a(s):t(void 0)},onEnd:()=>{t(R?R(i):void 0)}})})}e.consumeStream=v;function y(S,R){let t=!1;return S.on("error",a=>{t||R.onError(a)}),S.on("end",()=>{t||R.onEnd()}),S.on("data",a=>{t||R.onData(a)}),(0,M.toDisposable)(()=>t=!0)}e.listenStream=y;function g(S,R){return new Promise((t,a)=>{const i=new M.DisposableStore,s=[],c=l=>{if(s.push(l),s.length>R)return i.dispose(),S.pause(),t({stream:S,buffer:s,ended:!1})},u=l=>a(l),r=()=>t({stream:S,buffer:s,ended:!0});i.add((0,M.toDisposable)(()=>S.removeListener("error",u))),S.on("error",u),i.add((0,M.toDisposable)(()=>S.removeListener("end",r))),S.on("end",r),i.add((0,M.toDisposable)(()=>S.removeListener("data",c))),S.on("data",c)})}e.peekStream=g;function m(S,R){const t=P(R);return t.end(S),t}e.toStream=m;function w(){const S=P(()=>{throw new Error("not supported")});return S.end(),S}e.emptyStream=w;function o(S){let R=!1;return{read:()=>R?null:(R=!0,S)}}e.toReadable=o;function h(S,R,t){const a=P(t);return y(S,{onData:i=>a.write(R.data(i)),onError:i=>a.error(R.error?R.error(i):i),onEnd:()=>a.end()}),a}e.transform=h;function p(S,R,t){let a=!1;return{read:()=>{const i=R.read();return a?i:(a=!0,i!==null?t([S,i]):S)}}}e.prefixedReadable=p;function k(S,R,t){let a=!1;const i=P(t);return y(R,{onData:s=>a?i.write(s):(a=!0,i.write(t([S,s]))),onError:s=>i.error(s),onEnd:()=>{a||(a=!0,i.write(S)),i.end()}}),i}e.prefixedStream=k}),define(ee[17],te([0,1,60]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer<"u";let n,C;class D{static alloc(l){return M?new D(Buffer.allocUnsafe(l)):new D(new Uint8Array(l))}static wrap(l){return M&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new D(l)}static fromString(l,I){return!(I?.dontUseNodeBuffer||!1)&&M?new D(Buffer.from(l)):(n||(n=new TextEncoder),new D(n.encode(l)))}static fromByteArray(l){const I=D.alloc(l.length);for(let A=0,O=l.length;A<O;A++)I.buffer[A]=l[A];return I}static concat(l,I){if(typeof I>"u"){I=0;for(let N=0,X=l.length;N<X;N++)I+=l[N].byteLength}const A=D.alloc(I);let O=0;for(let N=0,X=l.length;N<X;N++){const V=l[N];A.set(V,O),O+=V.byteLength}return A}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=D.alloc(this.byteLength);return l.set(this),l}toString(){return M?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(l,I){return new D(this.buffer.subarray(l,I))}set(l,I){if(l instanceof D)this.buffer.set(l.buffer,I);else if(l instanceof Uint8Array)this.buffer.set(l,I);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),I);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return d(this.buffer,l)}writeUInt32BE(l,I){b(this.buffer,l,I)}readUInt32LE(l){return v(this.buffer,l)}writeUInt32LE(l,I){y(this.buffer,l,I)}readUInt8(l){return g(this.buffer,l)}writeUInt8(l,I){m(this.buffer,l,I)}}e.VSBuffer=D;function P(r,l){return r[l+0]<<0>>>0|r[l+1]<<8>>>0}e.readUInt16LE=P;function f(r,l,I){r[I+0]=l&255,l=l>>>8,r[I+1]=l&255}e.writeUInt16LE=f;function d(r,l){return r[l]*2**24+r[l+1]*2**16+r[l+2]*2**8+r[l+3]}e.readUInt32BE=d;function b(r,l,I){r[I+3]=l,l=l>>>8,r[I+2]=l,l=l>>>8,r[I+1]=l,l=l>>>8,r[I]=l}e.writeUInt32BE=b;function v(r,l){return r[l+0]<<0>>>0|r[l+1]<<8>>>0|r[l+2]<<16>>>0|r[l+3]<<24>>>0}e.readUInt32LE=v;function y(r,l,I){r[I+0]=l&255,l=l>>>8,r[I+1]=l&255,l=l>>>8,r[I+2]=l&255,l=l>>>8,r[I+3]=l&255}e.writeUInt32LE=y;function g(r,l){return r[l]}e.readUInt8=g;function m(r,l,I){r[I]=l}e.writeUInt8=m;function w(r){return E.consumeReadable(r,l=>D.concat(l))}e.readableToBuffer=w;function o(r){return E.toReadable(r)}e.bufferToReadable=o;function h(r){return E.consumeStream(r,l=>D.concat(l))}e.streamToBuffer=h;async function p(r){return r.ended?D.concat(r.buffer):D.concat([...r.buffer,await h(r.stream)])}e.bufferedStreamToBuffer=p;function k(r){return E.toStream(r,l=>D.concat(l))}e.bufferToStream=k;function S(r){return E.transform(r,{data:l=>typeof l=="string"?D.fromString(l):D.wrap(l)},l=>D.concat(l))}e.streamToBufferReadableStream=S;function R(r){return E.newWriteableStream(l=>D.concat(l),r)}e.newWriteableBufferStream=R;function t(r,l){return E.prefixedReadable(r,l,I=>D.concat(I))}e.prefixedBufferReadable=t;function a(r,l){return E.prefixedStream(r,l,I=>D.concat(I))}e.prefixedBufferStream=a;function i(r){let l=0,I=0,A=0;const O=new Uint8Array(Math.floor(r.length/4*3)),N=V=>{switch(I){case 3:O[A++]=l|V,I=0;break;case 2:O[A++]=l|V>>>2,l=V<<6,I=3;break;case 1:O[A++]=l|V>>>4,l=V<<4,I=2;break;default:l=V<<2,I=1}};for(let V=0;V<r.length;V++){const K=r.charCodeAt(V);if(K>=65&&K<=90)N(K-65);else if(K>=97&&K<=122)N(K-97+26);else if(K>=48&&K<=57)N(K-48+52);else if(K===43||K===45)N(62);else if(K===47||K===95)N(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${r[V]}`)}}const X=A;for(;I>0;)N(0);return D.wrap(O).slice(0,X)}e.decodeBase64=i;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:r},l=!0,I=!1){const A=I?c:s;let O="";const N=r.byteLength%3;let X=0;for(;X<r.byteLength-N;X+=3){const V=r[X+0],K=r[X+1],ie=r[X+2];O+=A[V>>>2],O+=A[(V<<4|K>>>4)&63],O+=A[(K<<2|ie>>>6)&63],O+=A[ie&63]}if(N===1){const V=r[X+0];O+=A[V>>>2],O+=A[V<<4&63],l&&(O+="==")}else if(N===2){const V=r[X+0],K=r[X+1];O+=A[V>>>2],O+=A[(V<<4|K>>>4)&63],O+=A[K<<2&63],l&&(O+="=")}return O}e.encodeBase64=u}),define(ee[129],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ee[10],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function E(a){return typeof a=="string"}e.isString=E;function M(a){return Array.isArray(a)&&a.every(i=>E(i))}e.isStringArray=M;function n(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=n;function C(a){const i=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof i}e.isTypedArray=C;function D(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=D;function P(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=P;function f(a){return a===!0||a===!1}e.isBoolean=f;function d(a){return typeof a>"u"}e.isUndefined=d;function b(a){return!v(a)}e.isDefined=b;function v(a){return d(a)||a===null}e.isUndefinedOrNull=v;function y(a,i){if(!a)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=y;function g(a){if(v(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=g;function m(...a){const i=[];for(let s=0;s<a.length;s++){const c=a[s];if(v(c))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);i.push(c)}return i}e.assertAllDefined=m;const w=Object.prototype.hasOwnProperty;function o(a){if(!n(a))return!1;for(const i in a)if(w.call(a,i))return!1;return!0}e.isEmptyObject=o;function h(a){return typeof a=="function"}e.isFunction=h;function p(...a){return a.length>0&&a.every(h)}e.areFunctions=p;function k(a,i){const s=Math.min(a.length,i.length);for(let c=0;c<s;c++)S(a[c],i[c])}e.validateConstraints=k;function S(a,i){if(E(i)){if(typeof a!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(h(i)){try{if(a instanceof i)return}catch{}if(!v(a)&&a.constructor===i||i.length===1&&i.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=S;function R(a){return a===null?void 0:a}e.withNullAsUndefined=R;function t(a){return typeof a>"u"?null:a}e.withUndefinedAsNull=t}),define(ee[130],te([0,1,10]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const M=Object.create(null);function n(P,f){if((0,E.isString)(f)){const d=M[f];if(d===void 0)throw new Error(`${P} references an unknown codicon: ${f}`);f=d}return M[P]=f,{id:P}}function C(){return M}e.getCodiconFontCharacters=C;function D(){return Object.values(e.Codicon)}e.getAllCodicons=D,e.Codicon={add:n("add",6e4),plus:n("plus",6e4),gistNew:n("gist-new",6e4),repoCreate:n("repo-create",6e4),lightbulb:n("lightbulb",60001),lightBulb:n("light-bulb",60001),repo:n("repo",60002),repoDelete:n("repo-delete",60002),gistFork:n("gist-fork",60003),repoForked:n("repo-forked",60003),gitPullRequest:n("git-pull-request",60004),gitPullRequestAbandoned:n("git-pull-request-abandoned",60004),recordKeys:n("record-keys",60005),keyboard:n("keyboard",60005),tag:n("tag",60006),tagAdd:n("tag-add",60006),tagRemove:n("tag-remove",60006),person:n("person",60007),personFollow:n("person-follow",60007),personOutline:n("person-outline",60007),personFilled:n("person-filled",60007),gitBranch:n("git-branch",60008),gitBranchCreate:n("git-branch-create",60008),gitBranchDelete:n("git-branch-delete",60008),sourceControl:n("source-control",60008),mirror:n("mirror",60009),mirrorPublic:n("mirror-public",60009),star:n("star",60010),starAdd:n("star-add",60010),starDelete:n("star-delete",60010),starEmpty:n("star-empty",60010),comment:n("comment",60011),commentAdd:n("comment-add",60011),alert:n("alert",60012),warning:n("warning",60012),search:n("search",60013),searchSave:n("search-save",60013),logOut:n("log-out",60014),signOut:n("sign-out",60014),logIn:n("log-in",60015),signIn:n("sign-in",60015),eye:n("eye",60016),eyeUnwatch:n("eye-unwatch",60016),eyeWatch:n("eye-watch",60016),circleFilled:n("circle-filled",60017),primitiveDot:n("primitive-dot",60017),closeDirty:n("close-dirty",60017),debugBreakpoint:n("debug-breakpoint",60017),debugBreakpointDisabled:n("debug-breakpoint-disabled",60017),debugHint:n("debug-hint",60017),primitiveSquare:n("primitive-square",60018),edit:n("edit",60019),pencil:n("pencil",60019),info:n("info",60020),issueOpened:n("issue-opened",60020),gistPrivate:n("gist-private",60021),gitForkPrivate:n("git-fork-private",60021),lock:n("lock",60021),mirrorPrivate:n("mirror-private",60021),close:n("close",60022),removeClose:n("remove-close",60022),x:n("x",60022),repoSync:n("repo-sync",60023),sync:n("sync",60023),clone:n("clone",60024),desktopDownload:n("desktop-download",60024),beaker:n("beaker",60025),microscope:n("microscope",60025),vm:n("vm",60026),deviceDesktop:n("device-desktop",60026),file:n("file",60027),fileText:n("file-text",60027),more:n("more",60028),ellipsis:n("ellipsis",60028),kebabHorizontal:n("kebab-horizontal",60028),mailReply:n("mail-reply",60029),reply:n("reply",60029),organization:n("organization",60030),organizationFilled:n("organization-filled",60030),organizationOutline:n("organization-outline",60030),newFile:n("new-file",60031),fileAdd:n("file-add",60031),newFolder:n("new-folder",60032),fileDirectoryCreate:n("file-directory-create",60032),trash:n("trash",60033),trashcan:n("trashcan",60033),history:n("history",60034),clock:n("clock",60034),folder:n("folder",60035),fileDirectory:n("file-directory",60035),symbolFolder:n("symbol-folder",60035),logoGithub:n("logo-github",60036),markGithub:n("mark-github",60036),github:n("github",60036),terminal:n("terminal",60037),console:n("console",60037),repl:n("repl",60037),zap:n("zap",60038),symbolEvent:n("symbol-event",60038),error:n("error",60039),stop:n("stop",60039),variable:n("variable",60040),symbolVariable:n("symbol-variable",60040),array:n("array",60042),symbolArray:n("symbol-array",60042),symbolModule:n("symbol-module",60043),symbolPackage:n("symbol-package",60043),symbolNamespace:n("symbol-namespace",60043),symbolObject:n("symbol-object",60043),symbolMethod:n("symbol-method",60044),symbolFunction:n("symbol-function",60044),symbolConstructor:n("symbol-constructor",60044),symbolBoolean:n("symbol-boolean",60047),symbolNull:n("symbol-null",60047),symbolNumeric:n("symbol-numeric",60048),symbolNumber:n("symbol-number",60048),symbolStructure:n("symbol-structure",60049),symbolStruct:n("symbol-struct",60049),symbolParameter:n("symbol-parameter",60050),symbolTypeParameter:n("symbol-type-parameter",60050),symbolKey:n("symbol-key",60051),symbolText:n("symbol-text",60051),symbolReference:n("symbol-reference",60052),goToFile:n("go-to-file",60052),symbolEnum:n("symbol-enum",60053),symbolValue:n("symbol-value",60053),symbolRuler:n("symbol-ruler",60054),symbolUnit:n("symbol-unit",60054),activateBreakpoints:n("activate-breakpoints",60055),archive:n("archive",60056),arrowBoth:n("arrow-both",60057),arrowDown:n("arrow-down",60058),arrowLeft:n("arrow-left",60059),arrowRight:n("arrow-right",60060),arrowSmallDown:n("arrow-small-down",60061),arrowSmallLeft:n("arrow-small-left",60062),arrowSmallRight:n("arrow-small-right",60063),arrowSmallUp:n("arrow-small-up",60064),arrowUp:n("arrow-up",60065),bell:n("bell",60066),bold:n("bold",60067),book:n("book",60068),bookmark:n("bookmark",60069),debugBreakpointConditionalUnverified:n("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:n("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:n("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:n("debug-breakpoint-data-unverified",60072),debugBreakpointData:n("debug-breakpoint-data",60073),debugBreakpointDataDisabled:n("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:n("debug-breakpoint-log-unverified",60074),debugBreakpointLog:n("debug-breakpoint-log",60075),debugBreakpointLogDisabled:n("debug-breakpoint-log-disabled",60075),briefcase:n("briefcase",60076),broadcast:n("broadcast",60077),browser:n("browser",60078),bug:n("bug",60079),calendar:n("calendar",60080),caseSensitive:n("case-sensitive",60081),check:n("check",60082),checklist:n("checklist",60083),chevronDown:n("chevron-down",60084),dropDownButton:n("drop-down-button",60084),chevronLeft:n("chevron-left",60085),chevronRight:n("chevron-right",60086),chevronUp:n("chevron-up",60087),chromeClose:n("chrome-close",60088),chromeMaximize:n("chrome-maximize",60089),chromeMinimize:n("chrome-minimize",60090),chromeRestore:n("chrome-restore",60091),circle:n("circle",60092),circleOutline:n("circle-outline",60092),debugBreakpointUnverified:n("debug-breakpoint-unverified",60092),circleSlash:n("circle-slash",60093),circuitBoard:n("circuit-board",60094),clearAll:n("clear-all",60095),clippy:n("clippy",60096),closeAll:n("close-all",60097),cloudDownload:n("cloud-download",60098),cloudUpload:n("cloud-upload",60099),code:n("code",60100),collapseAll:n("collapse-all",60101),colorMode:n("color-mode",60102),commentDiscussion:n("comment-discussion",60103),compareChanges:n("compare-changes",60157),creditCard:n("credit-card",60105),dash:n("dash",60108),dashboard:n("dashboard",60109),database:n("database",60110),debugContinue:n("debug-continue",60111),debugDisconnect:n("debug-disconnect",60112),debugPause:n("debug-pause",60113),debugRestart:n("debug-restart",60114),debugStart:n("debug-start",60115),debugStepInto:n("debug-step-into",60116),debugStepOut:n("debug-step-out",60117),debugStepOver:n("debug-step-over",60118),debugStop:n("debug-stop",60119),debug:n("debug",60120),deviceCameraVideo:n("device-camera-video",60121),deviceCamera:n("device-camera",60122),deviceMobile:n("device-mobile",60123),diffAdded:n("diff-added",60124),diffIgnored:n("diff-ignored",60125),diffModified:n("diff-modified",60126),diffRemoved:n("diff-removed",60127),diffRenamed:n("diff-renamed",60128),diff:n("diff",60129),discard:n("discard",60130),editorLayout:n("editor-layout",60131),emptyWindow:n("empty-window",60132),exclude:n("exclude",60133),extensions:n("extensions",60134),eyeClosed:n("eye-closed",60135),fileBinary:n("file-binary",60136),fileCode:n("file-code",60137),fileMedia:n("file-media",60138),filePdf:n("file-pdf",60139),fileSubmodule:n("file-submodule",60140),fileSymlinkDirectory:n("file-symlink-directory",60141),fileSymlinkFile:n("file-symlink-file",60142),fileZip:n("file-zip",60143),files:n("files",60144),filter:n("filter",60145),flame:n("flame",60146),foldDown:n("fold-down",60147),foldUp:n("fold-up",60148),fold:n("fold",60149),folderActive:n("folder-active",60150),folderOpened:n("folder-opened",60151),gear:n("gear",60152),gift:n("gift",60153),gistSecret:n("gist-secret",60154),gist:n("gist",60155),gitCommit:n("git-commit",60156),gitCompare:n("git-compare",60157),gitMerge:n("git-merge",60158),githubAction:n("github-action",60159),githubAlt:n("github-alt",60160),globe:n("globe",60161),grabber:n("grabber",60162),graph:n("graph",60163),gripper:n("gripper",60164),heart:n("heart",60165),home:n("home",60166),horizontalRule:n("horizontal-rule",60167),hubot:n("hubot",60168),inbox:n("inbox",60169),issueClosed:n("issue-closed",60324),issueReopened:n("issue-reopened",60171),issues:n("issues",60172),italic:n("italic",60173),jersey:n("jersey",60174),json:n("json",60175),bracket:n("bracket",60175),kebabVertical:n("kebab-vertical",60176),key:n("key",60177),law:n("law",60178),lightbulbAutofix:n("lightbulb-autofix",60179),linkExternal:n("link-external",60180),link:n("link",60181),listOrdered:n("list-ordered",60182),listUnordered:n("list-unordered",60183),liveShare:n("live-share",60184),loading:n("loading",60185),location:n("location",60186),mailRead:n("mail-read",60187),mail:n("mail",60188),markdown:n("markdown",60189),megaphone:n("megaphone",60190),mention:n("mention",60191),milestone:n("milestone",60192),mortarBoard:n("mortar-board",60193),move:n("move",60194),multipleWindows:n("multiple-windows",60195),mute:n("mute",60196),noNewline:n("no-newline",60197),note:n("note",60198),octoface:n("octoface",60199),openPreview:n("open-preview",60200),package_:n("package",60201),paintcan:n("paintcan",60202),pin:n("pin",60203),play:n("play",60204),run:n("run",60204),plug:n("plug",60205),preserveCase:n("preserve-case",60206),preview:n("preview",60207),project:n("project",60208),pulse:n("pulse",60209),question:n("question",60210),quote:n("quote",60211),radioTower:n("radio-tower",60212),reactions:n("reactions",60213),references:n("references",60214),refresh:n("refresh",60215),regex:n("regex",60216),remoteExplorer:n("remote-explorer",60217),remote:n("remote",60218),remove:n("remove",60219),replaceAll:n("replace-all",60220),replace:n("replace",60221),repoClone:n("repo-clone",60222),repoForcePush:n("repo-force-push",60223),repoPull:n("repo-pull",60224),repoPush:n("repo-push",60225),report:n("report",60226),requestChanges:n("request-changes",60227),rocket:n("rocket",60228),rootFolderOpened:n("root-folder-opened",60229),rootFolder:n("root-folder",60230),rss:n("rss",60231),ruby:n("ruby",60232),saveAll:n("save-all",60233),saveAs:n("save-as",60234),save:n("save",60235),screenFull:n("screen-full",60236),screenNormal:n("screen-normal",60237),searchStop:n("search-stop",60238),server:n("server",60240),settingsGear:n("settings-gear",60241),settings:n("settings",60242),shield:n("shield",60243),smiley:n("smiley",60244),sortPrecedence:n("sort-precedence",60245),splitHorizontal:n("split-horizontal",60246),splitVertical:n("split-vertical",60247),squirrel:n("squirrel",60248),starFull:n("star-full",60249),starHalf:n("star-half",60250),symbolClass:n("symbol-class",60251),symbolColor:n("symbol-color",60252),symbolCustomColor:n("symbol-customcolor",60252),symbolConstant:n("symbol-constant",60253),symbolEnumMember:n("symbol-enum-member",60254),symbolField:n("symbol-field",60255),symbolFile:n("symbol-file",60256),symbolInterface:n("symbol-interface",60257),symbolKeyword:n("symbol-keyword",60258),symbolMisc:n("symbol-misc",60259),symbolOperator:n("symbol-operator",60260),symbolProperty:n("symbol-property",60261),wrench:n("wrench",60261),wrenchSubaction:n("wrench-subaction",60261),symbolSnippet:n("symbol-snippet",60262),tasklist:n("tasklist",60263),telescope:n("telescope",60264),textSize:n("text-size",60265),threeBars:n("three-bars",60266),thumbsdown:n("thumbsdown",60267),thumbsup:n("thumbsup",60268),tools:n("tools",60269),triangleDown:n("triangle-down",60270),triangleLeft:n("triangle-left",60271),triangleRight:n("triangle-right",60272),triangleUp:n("triangle-up",60273),twitter:n("twitter",60274),unfold:n("unfold",60275),unlock:n("unlock",60276),unmute:n("unmute",60277),unverified:n("unverified",60278),verified:n("verified",60279),versions:n("versions",60280),vmActive:n("vm-active",60281),vmOutline:n("vm-outline",60282),vmRunning:n("vm-running",60283),watch:n("watch",60284),whitespace:n("whitespace",60285),wholeWord:n("whole-word",60286),window:n("window",60287),wordWrap:n("word-wrap",60288),zoomIn:n("zoom-in",60289),zoomOut:n("zoom-out",60290),listFilter:n("list-filter",60291),listFlat:n("list-flat",60292),listSelection:n("list-selection",60293),selection:n("selection",60293),listTree:n("list-tree",60294),debugBreakpointFunctionUnverified:n("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:n("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:n("debug-breakpoint-function-disabled",60296),debugStackframeActive:n("debug-stackframe-active",60297),circleSmallFilled:n("circle-small-filled",60298),debugStackframeDot:n("debug-stackframe-dot",60298),debugStackframe:n("debug-stackframe",60299),debugStackframeFocused:n("debug-stackframe-focused",60299),debugBreakpointUnsupported:n("debug-breakpoint-unsupported",60300),symbolString:n("symbol-string",60301),debugReverseContinue:n("debug-reverse-continue",60302),debugStepBack:n("debug-step-back",60303),debugRestartFrame:n("debug-restart-frame",60304),callIncoming:n("call-incoming",60306),callOutgoing:n("call-outgoing",60307),menu:n("menu",60308),expandAll:n("expand-all",60309),feedback:n("feedback",60310),groupByRefType:n("group-by-ref-type",60311),ungroupByRefType:n("ungroup-by-ref-type",60312),account:n("account",60313),bellDot:n("bell-dot",60314),debugConsole:n("debug-console",60315),library:n("library",60316),output:n("output",60317),runAll:n("run-all",60318),syncIgnored:n("sync-ignored",60319),pinned:n("pinned",60320),githubInverted:n("github-inverted",60321),debugAlt:n("debug-alt",60305),serverProcess:n("server-process",60322),serverEnvironment:n("server-environment",60323),pass:n("pass",60324),stopCircle:n("stop-circle",60325),playCircle:n("play-circle",60326),record:n("record",60327),debugAltSmall:n("debug-alt-small",60328),vmConnect:n("vm-connect",60329),cloud:n("cloud",60330),merge:n("merge",60331),exportIcon:n("export",60332),graphLeft:n("graph-left",60333),magnet:n("magnet",60334),notebook:n("notebook",60335),redo:n("redo",60336),checkAll:n("check-all",60337),pinnedDirty:n("pinned-dirty",60338),passFilled:n("pass-filled",60339),circleLargeFilled:n("circle-large-filled",60340),circleLarge:n("circle-large",60341),circleLargeOutline:n("circle-large-outline",60341),combine:n("combine",60342),gather:n("gather",60342),table:n("table",60343),variableGroup:n("variable-group",60344),typeHierarchy:n("type-hierarchy",60345),typeHierarchySub:n("type-hierarchy-sub",60346),typeHierarchySuper:n("type-hierarchy-super",60347),gitPullRequestCreate:n("git-pull-request-create",60348),runAbove:n("run-above",60349),runBelow:n("run-below",60350),notebookTemplate:n("notebook-template",60351),debugRerun:n("debug-rerun",60352),workspaceTrusted:n("workspace-trusted",60353),workspaceUntrusted:n("workspace-untrusted",60354),workspaceUnspecified:n("workspace-unspecified",60355),terminalCmd:n("terminal-cmd",60356),terminalDebian:n("terminal-debian",60357),terminalLinux:n("terminal-linux",60358),terminalPowershell:n("terminal-powershell",60359),terminalTmux:n("terminal-tmux",60360),terminalUbuntu:n("terminal-ubuntu",60361),terminalBash:n("terminal-bash",60362),arrowSwap:n("arrow-swap",60363),copy:n("copy",60364),personAdd:n("person-add",60365),filterFilled:n("filter-filled",60366),wand:n("wand",60367),debugLineByLine:n("debug-line-by-line",60368),inspect:n("inspect",60369),layers:n("layers",60370),layersDot:n("layers-dot",60371),layersActive:n("layers-active",60372),compass:n("compass",60373),compassDot:n("compass-dot",60374),compassActive:n("compass-active",60375),azure:n("azure",60376),issueDraft:n("issue-draft",60377),gitPullRequestClosed:n("git-pull-request-closed",60378),gitPullRequestDraft:n("git-pull-request-draft",60379),debugAll:n("debug-all",60380),debugCoverage:n("debug-coverage",60381),runErrors:n("run-errors",60382),folderLibrary:n("folder-library",60383),debugContinueSmall:n("debug-continue-small",60384),beakerStop:n("beaker-stop",60385),graphLine:n("graph-line",60386),graphScatter:n("graph-scatter",60387),pieChart:n("pie-chart",60388),bracketDot:n("bracket-dot",60389),bracketError:n("bracket-error",60390),lockSmall:n("lock-small",60391),azureDevops:n("azure-devops",60392),verifiedFilled:n("verified-filled",60393),newLine:n("newline",60394),layout:n("layout",60395),layoutActivitybarLeft:n("layout-activitybar-left",60396),layoutActivitybarRight:n("layout-activitybar-right",60397),layoutPanelLeft:n("layout-panel-left",60398),layoutPanelCenter:n("layout-panel-center",60399),layoutPanelJustify:n("layout-panel-justify",60400),layoutPanelRight:n("layout-panel-right",60401),layoutPanel:n("layout-panel",60402),layoutSidebarLeft:n("layout-sidebar-left",60403),layoutSidebarRight:n("layout-sidebar-right",60404),layoutStatusbar:n("layout-statusbar",60405),layoutMenubar:n("layout-menubar",60406),layoutCentered:n("layout-centered",60407),layoutSidebarRightOff:n("layout-sidebar-right-off",60416),layoutPanelOff:n("layout-panel-off",60417),layoutSidebarLeftOff:n("layout-sidebar-left-off",60418),target:n("target",60408),indent:n("indent",60409),recordSmall:n("record-small",60410),errorSmall:n("error-small",60411),arrowCircleDown:n("arrow-circle-down",60412),arrowCircleLeft:n("arrow-circle-left",60413),arrowCircleRight:n("arrow-circle-right",60414),arrowCircleUp:n("arrow-circle-up",60415),heartFilled:n("heart-filled",60420),map:n("map",60421),mapFilled:n("map-filled",60422),circleSmall:n("circle-small",60423),bellSlash:n("bell-slash",60424),bellSlashDot:n("bell-slash-dot",60425),commentUnresolved:n("comment-unresolved",60426),gitPullRequestGoToChanges:n("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:n("git-pull-request-new-changes",60428),searchFuzzy:n("search-fuzzy",60429),commentDraft:n("comment-draft",60430),dialogError:n("dialog-error","error"),dialogWarning:n("dialog-warning","warning"),dialogInfo:n("dialog-info","info"),dialogClose:n("dialog-close","close"),treeItemExpanded:n("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:n("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:n("tree-filter-on-type-off","list-selection"),treeFilterClear:n("tree-filter-clear","close"),treeItemLoading:n("tree-item-loading","loading"),menuSelection:n("menu-selection","check"),menuSubmenu:n("menu-submenu","chevron-right"),menuBarMore:n("menubar-more","more"),scrollbarButtonLeft:n("scrollbar-button-left","triangle-left"),scrollbarButtonRight:n("scrollbar-button-right","triangle-right"),scrollbarButtonUp:n("scrollbar-button-up","triangle-up"),scrollbarButtonDown:n("scrollbar-button-down","triangle-down"),toolBarMore:n("toolbar-more","more"),quickInputBack:n("quick-input-back","arrow-left")}}),define(ee[40],te([0,1,10]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const p=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([k,S])=>{p[k]=S&&typeof S=="object"?M(S):S}),p}e.deepClone=M;function n(h){if(!h||typeof h!="object")return h;const p=[h];for(;p.length>0;){const k=p.shift();Object.freeze(k);for(const S in k)if(C.call(k,S)){const R=k[S];typeof R=="object"&&!Object.isFrozen(R)&&!(0,E.isTypedArray)(R)&&p.push(R)}}return h}e.deepFreeze=n;const C=Object.prototype.hasOwnProperty;function D(h,p){return P(h,p,new Set)}e.cloneAndChange=D;function P(h,p,k){if((0,E.isUndefinedOrNull)(h))return h;const S=p(h);if(typeof S<"u")return S;if(Array.isArray(h)){const R=[];for(const t of h)R.push(P(t,p,k));return R}if((0,E.isObject)(h)){if(k.has(h))throw new Error("Cannot clone recursive data-structure");k.add(h);const R={};for(const t in h)C.call(h,t)&&(R[t]=P(h[t],p,k));return k.delete(h),R}return h}function f(h,p,k=!0){return(0,E.isObject)(h)?((0,E.isObject)(p)&&Object.keys(p).forEach(S=>{S in h?k&&((0,E.isObject)(h[S])&&(0,E.isObject)(p[S])?f(h[S],p[S],k):h[S]=p[S]):h[S]=p[S]}),h):p}e.mixin=f;function d(h,p){if(h===p)return!0;if(h==null||p===null||p===void 0||typeof h!=typeof p||typeof h!="object"||Array.isArray(h)!==Array.isArray(p))return!1;let k,S;if(Array.isArray(h)){if(h.length!==p.length)return!1;for(k=0;k<h.length;k++)if(!d(h[k],p[k]))return!1}else{const R=[];for(S in h)R.push(S);R.sort();const t=[];for(S in p)t.push(S);if(t.sort(),!d(R,t))return!1;for(k=0;k<R.length;k++)if(!d(h[R[k]],p[R[k]]))return!1}return!0}e.equals=d;function b(h){const p=new Set;return JSON.stringify(h,(k,S)=>{if((0,E.isObject)(S)||Array.isArray(S)){if(p.has(S))return"[Circular]";p.add(S)}return S})}e.safeStringify=b;function v(h,p){const k=Object.create(null);return!h||!p||Object.keys(p).forEach(R=>{const t=h[R],a=p[R];d(t,a)||(k[R]=a)}),k}e.distinct=v;function y(h,p){const k=p.toLowerCase(),S=Object.keys(h).find(R=>R.toLowerCase()===k);return S?h[S]:h[p]}e.getCaseInsensitive=y;function g(h,p){const k=Object.create(null);for(const[S,R]of Object.entries(h))p(S,R)&&(k[S]=R);return k}e.filter=g;function m(h){let p=[],k=Object.getPrototypeOf(h);for(;Object.prototype!==k;)p=p.concat(Object.getOwnPropertyNames(k)),k=Object.getPrototypeOf(k);return p}e.getAllPropertyNames=m;function w(h){const p=[];for(const k of m(h))typeof h[k]=="function"&&p.push(k);return p}e.getAllMethodNames=w;function o(h,p){const k=R=>function(){const t=Array.prototype.slice.call(arguments,0);return p(R,t)},S={};for(const R of h)S[R]=k(R);return S}e.createProxyObject=o}),define(ee[131],te([0,1,130]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var M;(function(D){function P(f){return f&&typeof f=="object"&&typeof f.id=="string"}D.isThemeColor=P})(M=e.ThemeColor||(e.ThemeColor={}));function n(D){return{id:D}}e.themeColorFromId=n;var C;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function f(p){const k=P.exec(p.id);if(!k)return f(E.Codicon.error);const[,S,R]=k,t=["codicon","codicon-"+S];return R&&t.push("codicon-modifier-"+R.substring(1)),t}D.asClassNameArray=f;function d(p){return f(p).join(" ")}D.asClassName=d;function b(p){return"."+f(p).join(".")}D.asCSSSelector=b;function v(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(typeof p.color>"u"||M.isThemeColor(p.color))}D.isThemeIcon=v;const y=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function g(p){const k=y.exec(p);if(!k)return;const[,S]=k;return{id:S}}D.fromString=g;function m(p){return{id:p}}D.fromId=m;function w(p,k){let S=p.id;const R=S.lastIndexOf("~");return R!==-1&&(S=S.substring(0,R)),k&&(S=`${S}~${k}`),{id:S}}D.modify=w;function o(p){const k=p.id.lastIndexOf("~");if(k!==-1)return p.id.substring(k+1)}D.getModifier=o;function h(p,k){return p.id===k.id&&p.color?.id===k.color?.id}D.isEqual=h})(C=e.ThemeIcon||(e.ThemeIcon={}))}),define(ee[31],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(n){return E.test(n)}e.isUUID=M,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let n;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?n=crypto.getRandomValues.bind(crypto):n=function(P){for(let f=0;f<P.length;f++)P[f]=Math.floor(Math.random()*256);return P};const C=new Uint8Array(16),D=[];for(let P=0;P<256;P++)D.push(P.toString(16).padStart(2,"0"));return function(){n(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let f=0,d="";return d+=D[C[f++]],d+=D[C[f++]],d+=D[C[f++]],d+=D[C[f++]],d+="-",d+=D[C[f++]],d+=D[C[f++]],d+="-",d+=D[C[f++]],d+=D[C[f++]],d+="-",d+=D[C[f++]],d+=D[C[f++]],d+="-",d+=D[C[f++]],d+=D[C[f++]],d+=D[C[f++]],d+=D[C[f++]],d+=D[C[f++]],d+=D[C[f++]],d}}()}),define(ee[132],te([0,1,81,41,50]),function(G,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function C(D,P){if(await new Promise((b,v)=>{const y=M.createReadStream(D),g=E.createHash("sha1");y.pipe(g);const m=(0,n.once)((w,o)=>{y.removeAllListeners(),g.removeAllListeners(),w?v(w):b(o)});y.once("error",m),y.once("end",m),g.once("error",m),g.once("data",w=>m(void 0,w.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.checksum=C}),define(ee[133],te([0,1,26]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const M=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function n(D){const P=D.replace(/\-/g,":").toLowerCase();return!M.has(P)}function C(){const D=(0,E.networkInterfaces)();for(const P in D){const f=D[P];if(f){for(const{mac:d}of f)if(n(d))return d}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=C}),define(ee[100],te([0,1,82]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function M(P,f,d,b=1){let v=!1;return new Promise(y=>{const g=setTimeout(()=>{if(!v)return v=!0,y(0)},d);n(P,f,b,m=>{if(!v)return v=!0,clearTimeout(g),y(m)})})}e.findFreePort=M;function n(P,f,d,b){if(f===0)return b(0);const v=new E.Socket;v.once("connect",()=>(D(v),n(P+d,f-1,d,b))),v.once("data",()=>{}),v.once("error",y=>(D(v),y.code!=="ECONNREFUSED"?n(P+d,f-1,d,b):b(P))),v.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function C(P,f,d,b="127.0.0.1"){let v=!1,y,g=1;const m=E.createServer({pauseOnConnect:!0});function w(o,h){v||(v=!0,m.removeAllListeners(),m.close(),y&&clearTimeout(y),h(o))}return new Promise(o=>{y=setTimeout(()=>{w(0,o)},d),m.on("listening",()=>{w(P,o)}),m.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&g<f?(P++,g++,m.listen(P,b)):w(0,o)}),m.on("close",()=>{w(0,o)}),m.listen(P,b)})}e.findFreePortFaster=C;function D(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(f){console.error(f)}}}),define(ee[134],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ee[135],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class E{constructor(n,C){this.a=n,this.onMessage=C}send(n){try{this.a.send("vscode:message",n.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.Protocol=E}),define(ee[42],te([0,1,14,13]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class n{constructor(){this.a=new WeakMap}on(D,P){const f=(d,...b)=>{this.b(D,d)&&P(d,...b)};return this.a.set(P,f),E.ipcMain.on(D,f),this}once(D,P){return E.ipcMain.once(D,(f,...d)=>{this.b(D,f)&&P(f,...d)}),this}handle(D,P){return E.ipcMain.handle(D,(f,...d)=>this.b(D,f)?P(f,...d):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return E.ipcMain.removeHandler(D),this}removeListener(D,P){const f=this.a.get(P);return f&&(E.ipcMain.removeListener(D,f),this.a.delete(P)),this}b(D,P){if(!D||!D.startsWith("vscode:"))return(0,M.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const f=P.senderFrame,d=f.url;if(!d)return!0;let b="unknown";try{b=new URL(d).host}catch{return(0,M.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${d}'.`),!1}return b!=="vscode-app"?((0,M.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${b}'.`),!1):f.parent!==null?((0,M.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${b}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new n}),define(ee[136],te([0,1,14,42,10,134]),function(G,e,E,M,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){M.validatedIpcMain.on(C.CONTEXT_MENU_CHANNEL,(f,d,b,v,y)=>{const g=P(f,v,b);g.popup({window:(0,n.withNullAsUndefined)(E.BrowserWindow.fromWebContents(f.sender)),x:y?y.x:void 0,y:y?y.y:void 0,positioningItem:y?y.positioningItem:void 0,callback:()=>{g&&f.sender.send(C.CONTEXT_MENU_CLOSE_CHANNEL,d)}})})}e.registerContextMenuListener=D;function P(f,d,b){const v=new E.Menu;return b.forEach(y=>{let g;y.type==="separator"?g=new E.MenuItem({type:y.type}):Array.isArray(y.submenu)?g=new E.MenuItem({submenu:P(f,d,y.submenu),label:y.label}):g=new E.MenuItem({label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:y.enabled,visible:y.visible,click:(m,w,o)=>f.sender.send(d,y.id,o)}),v.append(g)}),v}}),define(ee[137],te([12,11]),function(G,e){return G.create("vs/base/common/date",e)}),define(ee[138],te([0,1,137]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const M=60,n=M*60,C=n*24,D=C*7,P=C*30,f=C*365;function d(v,y,g,m){typeof v!="number"&&(v=v.getTime());const w=Math.round((new Date().getTime()-v)/1e3);if(w<-30)return(0,E.localize)(0,null,d(new Date().getTime()+w*1e3,!1));if(!m&&w<30)return(0,E.localize)(1,null);let o;return w<M?(o=w,y?o===1?g?(0,E.localize)(2,null,o):(0,E.localize)(3,null,o):g?(0,E.localize)(4,null,o):(0,E.localize)(5,null,o):o===1?g?(0,E.localize)(6,null,o):(0,E.localize)(7,null,o):g?(0,E.localize)(8,null,o):(0,E.localize)(9,null,o)):w<n?(o=Math.floor(w/M),y?o===1?g?(0,E.localize)(10,null,o):(0,E.localize)(11,null,o):g?(0,E.localize)(12,null,o):(0,E.localize)(13,null,o):o===1?g?(0,E.localize)(14,null,o):(0,E.localize)(15,null,o):g?(0,E.localize)(16,null,o):(0,E.localize)(17,null,o)):w<C?(o=Math.floor(w/n),y?o===1?g?(0,E.localize)(18,null,o):(0,E.localize)(19,null,o):g?(0,E.localize)(20,null,o):(0,E.localize)(21,null,o):o===1?g?(0,E.localize)(22,null,o):(0,E.localize)(23,null,o):g?(0,E.localize)(24,null,o):(0,E.localize)(25,null,o)):w<D?(o=Math.floor(w/C),y?o===1?(0,E.localize)(26,null,o):(0,E.localize)(27,null,o):o===1?(0,E.localize)(28,null,o):(0,E.localize)(29,null,o)):w<P?(o=Math.floor(w/D),y?o===1?g?(0,E.localize)(30,null,o):(0,E.localize)(31,null,o):g?(0,E.localize)(32,null,o):(0,E.localize)(33,null,o):o===1?g?(0,E.localize)(34,null,o):(0,E.localize)(35,null,o):g?(0,E.localize)(36,null,o):(0,E.localize)(37,null,o)):w<f?(o=Math.floor(w/P),y?o===1?g?(0,E.localize)(38,null,o):(0,E.localize)(39,null,o):g?(0,E.localize)(40,null,o):(0,E.localize)(41,null,o):o===1?g?(0,E.localize)(42,null,o):(0,E.localize)(43,null,o):g?(0,E.localize)(44,null,o):(0,E.localize)(45,null,o)):(o=Math.floor(w/f),y?o===1?g?(0,E.localize)(46,null,o):(0,E.localize)(47,null,o):g?(0,E.localize)(48,null,o):(0,E.localize)(49,null,o):o===1?g?(0,E.localize)(50,null,o):(0,E.localize)(51,null,o):g?(0,E.localize)(52,null,o):(0,E.localize)(53,null,o))}e.fromNow=d;function b(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(ee[139],te([12,11]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(ee[44],te([0,1,25,10,139]),function(G,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function C(v,y){return y&&(v.stack||v.stacktrace)?n.localize(0,null,P(v),D(v.stack)||D(v.stacktrace)):P(v)}function D(v){return Array.isArray(v)?v.join(`
`):v}function P(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?n.localize(1,null,v.message):v.message||n.localize(2,null)}function f(v=null,y=!1){if(!v)return n.localize(3,null);if(Array.isArray(v)){const g=E.coalesce(v),m=f(g[0],y);return g.length>1?n.localize(4,null,m,g.length):m}if(M.isString(v))return v;if(v.detail){const g=v.detail;if(g.error)return C(g.error,y);if(g.exception)return C(g.exception,y)}return v.stack?C(v,y):v.message?v.message:n.localize(5,null)}e.toErrorMessage=f;function d(v){const y=v;return y instanceof Error&&Array.isArray(y.actions)}e.isErrorWithActions=d;function b(v,y){let g;return typeof v=="string"?g=new Error(v):g=v,g.actions=y,g}e.createErrorWithActions=b}),define(ee[140],te([12,11]),function(G,e){return G.create("vs/base/common/jsonErrorMessages",e)}),define(ee[141],te([0,1,140]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function M(n){switch(n){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.getParseErrorMessage=M}),define(ee[142],te([12,11]),function(G,e){return G.create("vs/base/common/platform",e)}),define(ee[4],te([0,1,142]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let M=!1,n=!1,C=!1,D=!1,P=!1,f=!1,d=!1,b=!1,v=!1,y=!1,g,m=e.LANGUAGE_DEFAULT,w,o;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const p=typeof h?.versions?.electron=="string",k=p&&h?.type==="renderer";if(typeof navigator=="object"&&!k)o=navigator.userAgent,M=o.indexOf("Windows")>=0,n=o.indexOf("Macintosh")>=0,b=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=o.indexOf("Linux")>=0,y=o?.indexOf("Mobi")>=0,f=!0,g=E.getConfiguredDefaultLocale(E.localize(0,null))||e.LANGUAGE_DEFAULT,m=g;else if(typeof h=="object"){M=h.platform==="win32",n=h.platform==="darwin",C=h.platform==="linux",D=C&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,d=p,v=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=e.LANGUAGE_DEFAULT,m=e.LANGUAGE_DEFAULT;const r=h.env.VSCODE_NLS_CONFIG;if(r)try{const l=JSON.parse(r),I=l.availableLanguages["*"];g=l.locale,m=I||e.LANGUAGE_DEFAULT,w=l._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var S;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function R(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=R;let t=0;n?t=1:M?t=3:C&&(t=2),e.isWindows=M,e.isMacintosh=n,e.isLinux=C,e.isLinuxSnap=D,e.isNative=P,e.isElectron=d,e.isWeb=f,e.isWebWorker=f&&typeof e.globals.importScripts=="function",e.isIOS=b,e.isMobile=y,e.isCI=v,e.platform=t,e.userAgent=o,e.language=m;var a;(function(r){function l(){return e.language}r.value=l;function I(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=I;function A(){return e.language==="en"}r.isDefault=A})(a=e.Language||(e.Language={})),e.locale=g,e.translationsConfigFile=w,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const r=[];e.globals.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let A=0,O=r.length;A<O;A++){const N=r[A];if(N.id===I.data.vscodeScheduleAsyncWork){r.splice(A,1),N.callback();return}}});let l=0;return I=>{const A=++l;r.push({id:A,callback:I}),e.globals.postMessage({vscodeScheduleAsyncWork:A},"*")}}return r=>setTimeout(r)})();var i;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=n||b?2:M?1:3;let s=!0,c=!1;function u(){if(!c){c=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,s=new Uint16Array(r.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=u,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ee[36],te([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let M;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const n=E.globals.vscode.process;M={get platform(){return n.platform},get arch(){return n.arch},get env(){return n.env},cwd(){return n.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=M.cwd,e.env=M.env,e.platform=M.platform,e.arch=M.arch}),define(ee[9],te([0,1,36]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const M=65,n=97,C=90,D=122,P=46,f=47,d=92,b=58,v=63;class y extends Error{constructor(a,i,s){let c;typeof i=="string"&&i.indexOf("not ")===0?(c="must not be",i=i.replace(/^not /,"")):c="must be";const u=a.indexOf(".")!==-1?"property":"argument";let r=`The "${a}" ${u} ${c} of type ${i}`;r+=`. Received type ${typeof s}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function g(t,a){if(t===null||typeof t!="object")throw new y(a,"Object",t)}function m(t,a){if(typeof t!="string")throw new y(a,"string",t)}const w=E.platform==="win32";function o(t){return t===f||t===d}function h(t){return t===f}function p(t){return t>=M&&t<=C||t>=n&&t<=D}function k(t,a,i,s){let c="",u=0,r=-1,l=0,I=0;for(let A=0;A<=t.length;++A){if(A<t.length)I=t.charCodeAt(A);else{if(s(I))break;I=f}if(s(I)){if(!(r===A-1||l===1))if(l===2){if(c.length<2||u!==2||c.charCodeAt(c.length-1)!==P||c.charCodeAt(c.length-2)!==P){if(c.length>2){const O=c.lastIndexOf(i);O===-1?(c="",u=0):(c=c.slice(0,O),u=c.length-1-c.lastIndexOf(i)),r=A,l=0;continue}else if(c.length!==0){c="",u=0,r=A,l=0;continue}}a&&(c+=c.length>0?`${i}..`:"..",u=2)}else c.length>0?c+=`${i}${t.slice(r+1,A)}`:c=t.slice(r+1,A),u=A-r-1;r=A,l=0}else I===P&&l!==-1?++l:l=-1}return c}function S(t,a){g(a,"pathObject");const i=a.dir||a.root,s=a.base||`${a.name||""}${a.ext||""}`;return i?i===a.root?`${i}${s}`:`${i}${t}${s}`:s}e.win32={resolve(...t){let a="",i="",s=!1;for(let c=t.length-1;c>=-1;c--){let u;if(c>=0){if(u=t[c],m(u,"path"),u.length===0)continue}else a.length===0?u=E.cwd():(u=E.env[`=${a}`]||E.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==a.toLowerCase()&&u.charCodeAt(2)===d)&&(u=`${a}\\`));const r=u.length;let l=0,I="",A=!1;const O=u.charCodeAt(0);if(r===1)o(O)&&(l=1,A=!0);else if(o(O))if(A=!0,o(u.charCodeAt(1))){let N=2,X=N;for(;N<r&&!o(u.charCodeAt(N));)N++;if(N<r&&N!==X){const V=u.slice(X,N);for(X=N;N<r&&o(u.charCodeAt(N));)N++;if(N<r&&N!==X){for(X=N;N<r&&!o(u.charCodeAt(N));)N++;(N===r||N!==X)&&(I=`\\\\${V}\\${u.slice(X,N)}`,l=N)}}}else l=1;else p(O)&&u.charCodeAt(1)===b&&(I=u.slice(0,2),l=2,r>2&&o(u.charCodeAt(2))&&(A=!0,l=3));if(I.length>0)if(a.length>0){if(I.toLowerCase()!==a.toLowerCase())continue}else a=I;if(s){if(a.length>0)break}else if(i=`${u.slice(l)}\\${i}`,s=A,A&&a.length>0)break}return i=k(i,!s,"\\",o),s?`${a}\\${i}`:`${a}${i}`||"."},normalize(t){m(t,"path");const a=t.length;if(a===0)return".";let i=0,s,c=!1;const u=t.charCodeAt(0);if(a===1)return h(u)?"\\":t;if(o(u))if(c=!0,o(t.charCodeAt(1))){let l=2,I=l;for(;l<a&&!o(t.charCodeAt(l));)l++;if(l<a&&l!==I){const A=t.slice(I,l);for(I=l;l<a&&o(t.charCodeAt(l));)l++;if(l<a&&l!==I){for(I=l;l<a&&!o(t.charCodeAt(l));)l++;if(l===a)return`\\\\${A}\\${t.slice(I)}\\`;l!==I&&(s=`\\\\${A}\\${t.slice(I,l)}`,i=l)}}}else i=1;else p(u)&&t.charCodeAt(1)===b&&(s=t.slice(0,2),i=2,a>2&&o(t.charCodeAt(2))&&(c=!0,i=3));let r=i<a?k(t.slice(i),!c,"\\",o):"";return r.length===0&&!c&&(r="."),r.length>0&&o(t.charCodeAt(a-1))&&(r+="\\"),s===void 0?c?`\\${r}`:r:c?`${s}\\${r}`:`${s}${r}`},isAbsolute(t){m(t,"path");const a=t.length;if(a===0)return!1;const i=t.charCodeAt(0);return o(i)||a>2&&p(i)&&t.charCodeAt(1)===b&&o(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let a,i;for(let u=0;u<t.length;++u){const r=t[u];m(r,"path"),r.length>0&&(a===void 0?a=i=r:a+=`\\${r}`)}if(a===void 0)return".";let s=!0,c=0;if(typeof i=="string"&&o(i.charCodeAt(0))){++c;const u=i.length;u>1&&o(i.charCodeAt(1))&&(++c,u>2&&(o(i.charCodeAt(2))?++c:s=!1))}if(s){for(;c<a.length&&o(a.charCodeAt(c));)c++;c>=2&&(a=`\\${a.slice(c)}`)}return e.win32.normalize(a)},relative(t,a){if(m(t,"from"),m(a,"to"),t===a)return"";const i=e.win32.resolve(t),s=e.win32.resolve(a);if(i===s||(t=i.toLowerCase(),a=s.toLowerCase(),t===a))return"";let c=0;for(;c<t.length&&t.charCodeAt(c)===d;)c++;let u=t.length;for(;u-1>c&&t.charCodeAt(u-1)===d;)u--;const r=u-c;let l=0;for(;l<a.length&&a.charCodeAt(l)===d;)l++;let I=a.length;for(;I-1>l&&a.charCodeAt(I-1)===d;)I--;const A=I-l,O=r<A?r:A;let N=-1,X=0;for(;X<O;X++){const K=t.charCodeAt(c+X);if(K!==a.charCodeAt(l+X))break;K===d&&(N=X)}if(X!==O){if(N===-1)return s}else{if(A>O){if(a.charCodeAt(l+X)===d)return s.slice(l+X+1);if(X===2)return s.slice(l+X)}r>O&&(t.charCodeAt(c+X)===d?N=X:X===2&&(N=3)),N===-1&&(N=0)}let V="";for(X=c+N+1;X<=u;++X)(X===u||t.charCodeAt(X)===d)&&(V+=V.length===0?"..":"\\..");return l+=N,V.length>0?`${V}${s.slice(l,I)}`:(s.charCodeAt(l)===d&&++l,s.slice(l,I))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const a=e.win32.resolve(t);if(a.length<=2)return t;if(a.charCodeAt(0)===d){if(a.charCodeAt(1)===d){const i=a.charCodeAt(2);if(i!==v&&i!==P)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(p(a.charCodeAt(0))&&a.charCodeAt(1)===b&&a.charCodeAt(2)===d)return`\\\\?\\${a}`;return t},dirname(t){m(t,"path");const a=t.length;if(a===0)return".";let i=-1,s=0;const c=t.charCodeAt(0);if(a===1)return o(c)?t:".";if(o(c)){if(i=s=1,o(t.charCodeAt(1))){let l=2,I=l;for(;l<a&&!o(t.charCodeAt(l));)l++;if(l<a&&l!==I){for(I=l;l<a&&o(t.charCodeAt(l));)l++;if(l<a&&l!==I){for(I=l;l<a&&!o(t.charCodeAt(l));)l++;if(l===a)return t;l!==I&&(i=s=l+1)}}}}else p(c)&&t.charCodeAt(1)===b&&(i=a>2&&o(t.charCodeAt(2))?3:2,s=i);let u=-1,r=!0;for(let l=a-1;l>=s;--l)if(o(t.charCodeAt(l))){if(!r){u=l;break}}else r=!1;if(u===-1){if(i===-1)return".";u=i}return t.slice(0,u)},basename(t,a){a!==void 0&&m(a,"ext"),m(t,"path");let i=0,s=-1,c=!0,u;if(t.length>=2&&p(t.charCodeAt(0))&&t.charCodeAt(1)===b&&(i=2),a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let r=a.length-1,l=-1;for(u=t.length-1;u>=i;--u){const I=t.charCodeAt(u);if(o(I)){if(!c){i=u+1;break}}else l===-1&&(c=!1,l=u+1),r>=0&&(I===a.charCodeAt(r)?--r===-1&&(s=u):(r=-1,s=l))}return i===s?s=l:s===-1&&(s=t.length),t.slice(i,s)}for(u=t.length-1;u>=i;--u)if(o(t.charCodeAt(u))){if(!c){i=u+1;break}}else s===-1&&(c=!1,s=u+1);return s===-1?"":t.slice(i,s)},extname(t){m(t,"path");let a=0,i=-1,s=0,c=-1,u=!0,r=0;t.length>=2&&t.charCodeAt(1)===b&&p(t.charCodeAt(0))&&(a=s=2);for(let l=t.length-1;l>=a;--l){const I=t.charCodeAt(l);if(o(I)){if(!u){s=l+1;break}continue}c===-1&&(u=!1,c=l+1),I===P?i===-1?i=l:r!==1&&(r=1):i!==-1&&(r=-1)}return i===-1||c===-1||r===0||r===1&&i===c-1&&i===s+1?"":t.slice(i,c)},format:S.bind(null,"\\"),parse(t){m(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const i=t.length;let s=0,c=t.charCodeAt(0);if(i===1)return o(c)?(a.root=a.dir=t,a):(a.base=a.name=t,a);if(o(c)){if(s=1,o(t.charCodeAt(1))){let N=2,X=N;for(;N<i&&!o(t.charCodeAt(N));)N++;if(N<i&&N!==X){for(X=N;N<i&&o(t.charCodeAt(N));)N++;if(N<i&&N!==X){for(X=N;N<i&&!o(t.charCodeAt(N));)N++;N===i?s=N:N!==X&&(s=N+1)}}}}else if(p(c)&&t.charCodeAt(1)===b){if(i<=2)return a.root=a.dir=t,a;if(s=2,o(t.charCodeAt(2))){if(i===3)return a.root=a.dir=t,a;s=3}}s>0&&(a.root=t.slice(0,s));let u=-1,r=s,l=-1,I=!0,A=t.length-1,O=0;for(;A>=s;--A){if(c=t.charCodeAt(A),o(c)){if(!I){r=A+1;break}continue}l===-1&&(I=!1,l=A+1),c===P?u===-1?u=A:O!==1&&(O=1):u!==-1&&(O=-1)}return l!==-1&&(u===-1||O===0||O===1&&u===l-1&&u===r+1?a.base=a.name=t.slice(r,l):(a.name=t.slice(r,u),a.base=t.slice(r,l),a.ext=t.slice(u,l))),r>0&&r!==s?a.dir=t.slice(0,r-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const R=(()=>{if(w){const t=/\\/g;return()=>{const a=E.cwd().replace(t,"/");return a.slice(a.indexOf("/"))}}return()=>E.cwd()})();e.posix={resolve(...t){let a="",i=!1;for(let s=t.length-1;s>=-1&&!i;s--){const c=s>=0?t[s]:R();m(c,"path"),c.length!==0&&(a=`${c}/${a}`,i=c.charCodeAt(0)===f)}return a=k(a,!i,"/",h),i?`/${a}`:a.length>0?a:"."},normalize(t){if(m(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===f,i=t.charCodeAt(t.length-1)===f;return t=k(t,!a,"/",h),t.length===0?a?"/":i?"./":".":(i&&(t+="/"),a?`/${t}`:t)},isAbsolute(t){return m(t,"path"),t.length>0&&t.charCodeAt(0)===f},join(...t){if(t.length===0)return".";let a;for(let i=0;i<t.length;++i){const s=t[i];m(s,"path"),s.length>0&&(a===void 0?a=s:a+=`/${s}`)}return a===void 0?".":e.posix.normalize(a)},relative(t,a){if(m(t,"from"),m(a,"to"),t===a||(t=e.posix.resolve(t),a=e.posix.resolve(a),t===a))return"";const i=1,s=t.length,c=s-i,u=1,r=a.length-u,l=c<r?c:r;let I=-1,A=0;for(;A<l;A++){const N=t.charCodeAt(i+A);if(N!==a.charCodeAt(u+A))break;N===f&&(I=A)}if(A===l)if(r>l){if(a.charCodeAt(u+A)===f)return a.slice(u+A+1);if(A===0)return a.slice(u+A)}else c>l&&(t.charCodeAt(i+A)===f?I=A:A===0&&(I=0));let O="";for(A=i+I+1;A<=s;++A)(A===s||t.charCodeAt(A)===f)&&(O+=O.length===0?"..":"/..");return`${O}${a.slice(u+I)}`},toNamespacedPath(t){return t},dirname(t){if(m(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===f;let i=-1,s=!0;for(let c=t.length-1;c>=1;--c)if(t.charCodeAt(c)===f){if(!s){i=c;break}}else s=!1;return i===-1?a?"/":".":a&&i===1?"//":t.slice(0,i)},basename(t,a){a!==void 0&&m(a,"ext"),m(t,"path");let i=0,s=-1,c=!0,u;if(a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let r=a.length-1,l=-1;for(u=t.length-1;u>=0;--u){const I=t.charCodeAt(u);if(I===f){if(!c){i=u+1;break}}else l===-1&&(c=!1,l=u+1),r>=0&&(I===a.charCodeAt(r)?--r===-1&&(s=u):(r=-1,s=l))}return i===s?s=l:s===-1&&(s=t.length),t.slice(i,s)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===f){if(!c){i=u+1;break}}else s===-1&&(c=!1,s=u+1);return s===-1?"":t.slice(i,s)},extname(t){m(t,"path");let a=-1,i=0,s=-1,c=!0,u=0;for(let r=t.length-1;r>=0;--r){const l=t.charCodeAt(r);if(l===f){if(!c){i=r+1;break}continue}s===-1&&(c=!1,s=r+1),l===P?a===-1?a=r:u!==1&&(u=1):a!==-1&&(u=-1)}return a===-1||s===-1||u===0||u===1&&a===s-1&&a===i+1?"":t.slice(a,s)},format:S.bind(null,"/"),parse(t){m(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const i=t.charCodeAt(0)===f;let s;i?(a.root="/",s=1):s=0;let c=-1,u=0,r=-1,l=!0,I=t.length-1,A=0;for(;I>=s;--I){const O=t.charCodeAt(I);if(O===f){if(!l){u=I+1;break}continue}r===-1&&(l=!1,r=I+1),O===P?c===-1?c=I:A!==1&&(A=1):c!==-1&&(A=-1)}if(r!==-1){const O=u===0&&i?1:u;c===-1||A===0||A===1&&c===r-1&&c===u+1?a.base=a.name=t.slice(O,r):(a.name=t.slice(O,c),a.base=t.slice(O,r),a.ext=t.slice(c,r))}return u>0?a.dir=t.slice(0,u-1):i&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w?e.win32.normalize:e.posix.normalize,e.isAbsolute=w?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w?e.win32.join:e.posix.join,e.resolve=w?e.win32.resolve:e.posix.resolve,e.relative=w?e.win32.relative:e.posix.relative,e.dirname=w?e.win32.dirname:e.posix.dirname,e.basename=w?e.win32.basename:e.posix.basename,e.extname=w?e.win32.extname:e.posix.extname,e.format=w?e.win32.format:e.posix.format,e.parse=w?e.win32.parse:e.posix.parse,e.toNamespacedPath=w?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w?e.win32.sep:e.posix.sep,e.delimiter=w?e.win32.delimiter:e.posix.delimiter}),define(ee[83],te([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var M;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(M=e.Source||(e.Source={}));var n;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(P,...f){const d=f.reduce((y,g)=>(y[g]=!0,y),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(y=>!d[y]).forEach(y=>{for(let g=0;g<b.length;g++)if(y.search(b[g])!==-1){delete P[y];break}})}e.sanitizeProcessEnvironment=C;function D(P){!P||(delete P.DEBUG,E.isMacintosh&&delete P.DYLD_LIBRARY_PATH,E.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(ee[71],te([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const M=E.globals.performance&&typeof E.globals.performance.now=="function";class n{static create(D=!0){return new n(D)}constructor(D){this.a=M&&D,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?E.globals.performance.now():Date.now()}}e.StopWatch=n}),define(ee[3],te([0,1,13,50,2,99,71]),function(G,e,E,M,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,f=!1;var d;(function(u){u.None=()=>n.Disposable.None;function r(T){if(f){const{onDidAddListener:B}=T,H=m.create();let j=0;T.onDidAddListener=()=>{++j===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),H.print()),B?.()}}}function l(T,B){return re(T,()=>{},0,void 0,void 0,B)}u.defer=l;function I(T){return(B,H=null,j)=>{let $=!1,q;return q=T(oe=>{if(!$)return q?q.dispose():$=!0,B.call(H,oe)},null,j),$&&q.dispose(),q}}u.once=I;function A(T,B,H){return ie((j,$=null,q)=>T(oe=>j.call($,B(oe)),null,q),H)}u.map=A;function O(T,B,H){return ie((j,$=null,q)=>T(oe=>{B(oe),j.call($,oe)},null,q),H)}u.forEach=O;function N(T,B,H){return ie((j,$=null,q)=>T(oe=>B(oe)&&j.call($,oe),null,q),H)}u.filter=N;function X(T){return T}u.signal=X;function V(...T){return(B,H=null,j)=>(0,n.combinedDisposable)(...T.map($=>$(q=>B.call(H,q),null,j)))}u.any=V;function K(T,B,H,j){let $=H;return A(T,q=>($=B($,q),$),j)}u.reduce=K;function ie(T,B){let H;const j={onWillAddFirstListener(){H=T($.fire,$)},onDidRemoveLastListener(){H?.dispose()}};B||r(j);const $=new o(j);return B?.add($),$.event}function re(T,B,H=100,j=!1,$,q){let oe,de,pe,ye=0;const Le={leakWarningThreshold:$,onWillAddFirstListener(){oe=T(Te=>{ye++,de=B(de,Te),j&&!pe&&(Fe.fire(de),de=void 0);const we=()=>{const Ce=de;de=void 0,pe=void 0,(!j||ye>1)&&Fe.fire(Ce),ye=0};typeof H=="number"?(clearTimeout(pe),pe=setTimeout(we,H)):pe===void 0&&(pe=0,queueMicrotask(we))})},onDidRemoveLastListener(){oe.dispose()}};q||r(Le);const Fe=new o(Le);return q?.add(Fe),Fe.event}u.debounce=re;function ce(T,B=0,H){return u.debounce(T,(j,$)=>j?(j.push($),j):[$],B,void 0,void 0,H)}u.accumulate=ce;function fe(T,B=(j,$)=>j===$,H){let j=!0,$;return N(T,q=>{const oe=j||!B(q,$);return j=!1,$=q,oe},H)}u.latch=fe;function ge(T,B,H){return[u.filter(T,B,H),u.filter(T,j=>!B(j),H)]}u.split=ge;function x(T,B=!1,H=[]){let j=H.slice(),$=T(de=>{j?j.push(de):oe.fire(de)});const q=()=>{j?.forEach(de=>oe.fire(de)),j=null},oe=new o({onWillAddFirstListener(){$||($=T(de=>oe.fire(de)))},onDidAddFirstListener(){j&&(B?setTimeout(q):q())},onDidRemoveLastListener(){$&&$.dispose(),$=null}});return oe.event}u.buffer=x;class F{constructor(B){this.event=B,this.c=new n.DisposableStore}map(B){return new F(A(this.event,B,this.c))}forEach(B){return new F(O(this.event,B,this.c))}filter(B){return new F(N(this.event,B,this.c))}reduce(B,H){return new F(K(this.event,B,H,this.c))}latch(){return new F(fe(this.event,void 0,this.c))}debounce(B,H=100,j=!1,$){return new F(re(this.event,B,H,j,$,this.c))}on(B,H,j){return this.event(B,H,j)}once(B,H,j){return I(this.event)(B,H,j)}dispose(){this.c.dispose()}}function W(T){return new F(T)}u.chain=W;function z(T,B,H=j=>j){const j=(...de)=>oe.fire(H(...de)),$=()=>T.on(B,j),q=()=>T.removeListener(B,j),oe=new o({onWillAddFirstListener:$,onDidRemoveLastListener:q});return oe.event}u.fromNodeEventEmitter=z;function J(T,B,H=j=>j){const j=(...de)=>oe.fire(H(...de)),$=()=>T.addEventListener(B,j),q=()=>T.removeEventListener(B,j),oe=new o({onWillAddFirstListener:$,onDidRemoveLastListener:q});return oe.event}u.fromDOMEventEmitter=J;function ne(T){return new Promise(B=>I(T)(B))}u.toPromise=ne;function se(T,B){return B(void 0),T(H=>B(H))}u.runAndSubscribe=se;function Z(T,B){let H=null;function j(q){H?.dispose(),H=new n.DisposableStore,B(q,H)}j(void 0);const $=T(q=>j(q));return(0,n.toDisposable)(()=>{$.dispose(),H?.dispose()})}u.runAndSubscribeWithStore=Z;class U{constructor(B,H){this.obs=B,this.c=0,this.d=!1;const j={onWillAddFirstListener:()=>{B.addObserver(this)},onDidRemoveLastListener:()=>{B.removeObserver(this)}};H||r(j),this.emitter=new o(j),H&&H.add(this.emitter)}beginUpdate(B){this.c++}handleChange(B,H){this.d=!0}endUpdate(B){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function L(T,B){return new U(T,B).emitter.event}u.fromObservable=L})(d=e.Event||(e.Event={}));class b{constructor(r){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${r}_${b.c++}`,b.all.add(this)}start(r){this.d=new D.StopWatch(!0),this.listenerCount=r}stop(){if(this.d){const r=this.d.elapsed();this.durations.push(r),this.elapsedOverall+=r,this.invocationCount+=1,this.d=void 0}}}b.all=new Set,b.c=0,e.EventProfiling=b;let v=-1;function y(u){const r=v;return v=u,{dispose(){v=r}}}e.setGlobalLeakWarningThreshold=y;class g{constructor(r,l=Math.random().toString(18).slice(2,5)){this.threshold=r,this.name=l,this.d=0}dispose(){this.c?.clear()}check(r,l){const I=this.threshold;if(I<=0||l<I)return;this.c||(this.c=new Map);const A=this.c.get(r.value)||0;if(this.c.set(r.value,A+1),this.d-=1,this.d<=0){this.d=I*.5;let O,N=0;for(const[X,V]of this.c)(!O||N<V)&&(O=X,N=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${N}):`),console.warn(O)}return()=>{const O=this.c.get(r.value)||0;this.c.set(r.value,O-1)}}}class m{static create(){return new m(new Error().stack??"")}constructor(r){this.value=r}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class w{constructor(r,l,I){this.callback=r,this.callbackThis=l,this.stack=I,this.subscription=new n.SafeDisposable}invoke(r){this.callback.call(this.callbackThis,r)}}class o{constructor(r){this.j=!1,this.d=r,this.f=v>0||this.d?.leakWarningThreshold?new g(this.d?.leakWarningThreshold??v):void 0,this.g=this.d?._profName?new b(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const r=Array.from(this.q);queueMicrotask(()=>{for(const l of r)l.subscription.isset()&&(l.subscription.unset(),l.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(r,l,I)=>{if(this.q||(this.q=new C.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),n.Disposable.None;const A=this.q.isEmpty();A&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let O,N;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(N=m.create(),O=this.f.check(N,this.q.size+1)),P&&(N=N??m.create());const X=new w(r,l,N),V=this.q.push(X);A&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,r,l);const K=X.subscription.set(()=>{O?.(),this.j||(V(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return I instanceof n.DisposableStore?I.add(K):Array.isArray(I)&&I.push(K),K}),this.l}fire(r){if(this.q){this.m||(this.m=new p);for(const l of this.q)this.m.push(this,l,r);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=o;class h{constructor(){this.c=new C.LinkedList}get size(){return this.c.size}push(r,l,I){this.c.push(new k(r,l,I))}clear(r){const l=new C.LinkedList;for(const I of this.c)I.emitter!==r&&l.push(I);this.c=l}deliver(){for(;this.c.size>0;){const r=this.c.shift();try{r.listener.invoke(r.event)}catch(l){(0,E.onUnexpectedError)(l)}}}}e.EventDeliveryQueue=h;class p extends h{clear(r){this.c.clear()}}class k{constructor(r,l,I){this.emitter=r,this.listener=l,this.event=I}}class S extends o{async fireAsync(r,l,I){if(!!this.q){this.c||(this.c=new C.LinkedList);for(const A of this.q)this.c.push([A,r]);for(;this.c.size>0&&!l.isCancellationRequested;){const[A,O]=this.c.shift(),N=[],X={...O,token:l,waitUntil:V=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");I&&(V=I(V,A.callback)),N.push(V)}};try{A.invoke(X)}catch(V){(0,E.onUnexpectedError)(V);continue}Object.freeze(N),await Promise.allSettled(N).then(V=>{for(const K of V)K.status==="rejected"&&(0,E.onUnexpectedError)(K.reason)})}}}}e.AsyncEmitter=S;class R extends o{constructor(r){super(r),this.h=0,this.s=new C.LinkedList,this.t=r?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const r=Array.from(this.s);this.s.clear(),super.fire(this.t(r))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(r){this.q&&(this.h!==0?this.s.push(r):super.fire(r))}}e.PauseableEmitter=R;class t extends R{constructor(r){super(r),this.c=r.delay??100}fire(r){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(r)}}e.DebounceEmitter=t;class a extends o{constructor(r){super(r),this.c=[],this.h=r?.merge}fire(r){!this.hasListeners()||(this.c.push(r),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(l=>super.fire(l)),this.c=[]}))}}e.MicrotaskEmitter=a;class i{constructor(){this.d=!1,this.f=[],this.c=new o({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(r){const l={event:r,listener:null};this.f.push(l),this.d&&this.j(l);const I=()=>{this.d&&this.k(l);const A=this.f.indexOf(l);this.f.splice(A,1)};return(0,n.toDisposable)((0,M.once)(I))}g(){this.d=!0,this.f.forEach(r=>this.j(r))}h(){this.d=!1,this.f.forEach(r=>this.k(r))}j(r){r.listener=r.event(l=>this.c.fire(l))}k(r){r.listener&&r.listener.dispose(),r.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=i;class s{constructor(){this.c=[]}wrapEvent(r){return(l,I,A)=>r(O=>{const N=this.c[this.c.length-1];N?N.push(()=>l.call(I,O)):l.call(I,O)},void 0,A)}bufferEvents(r){const l=[];this.c.push(l);const I=r();return this.c.pop(),l.forEach(A=>A()),I}}e.EventBufferer=s;class c{constructor(){this.c=!1,this.d=d.None,this.f=n.Disposable.None,this.g=new o({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(r){this.d=r,this.c&&(this.f.dispose(),this.f=r(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=c}),define(ee[22],te([0,1,3]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const M=Object.freeze(function(P,f){const d=setTimeout(P.bind(f),0);return{dispose(){clearTimeout(d)}}});var n;(function(P){function f(d){return d===P.None||d===P.Cancelled||d instanceof C?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}P.isCancellationToken=f,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(n=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?M:(this.b||(this.b=new E.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(f){this.a=void 0,this.b=void 0,this.b=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new C),this.a}cancel(){this.a?this.a instanceof C&&this.a.cancel():this.a=n.Cancelled}dispose(f=!1){f&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof C&&this.a.dispose():this.a=n.None}}e.CancellationTokenSource=D}),define(ee[143],te([0,1,22]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class M{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new E.CancellationTokenSource,f=this.b(P.token);return this.a={promise:f,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=M;class n{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const f=JSON.stringify(P);return this.b!==f&&(this.b=f,this.a=this.c(P)),this.a}}e.LRUCachedFunction=n;class C{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const f=this.b(P);return this.a.set(P,f),f}}e.CachedFunction=C}),define(ee[27],te([0,1,143,126]),function(G,e,E,M){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function C(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=C;const D=/{(\d+)}/g;function P(Y,...le){return le.length===0?Y:Y.replace(D,function(ue,me){const Se=parseInt(me,10);return isNaN(Se)||Se<0||Se>=le.length?ue:le[Se]})}e.format=P;const f=/{([^}]+)}/g;function d(Y,le){return Y.replace(f,(ue,me)=>le[me]??ue)}e.format2=d;function b(Y){return Y.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=b;function v(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=v;function y(Y,le){let ue=0;const me=le.charCodeAt(0);for(let Se=Y.length-1;Se>=0;Se--)Y.charCodeAt(Se)===me&&ue++;return ue}e.count=y;function g(Y,le,ue="\u2026"){return Y.length<=le?Y:`${Y.substr(0,le)}${ue}`}e.truncate=g;function m(Y,le=" "){const ue=w(Y,le);return o(ue,le)}e.trim=m;function w(Y,le){if(!Y||!le)return Y;const ue=le.length;if(ue===0||Y.length===0)return Y;let me=0;for(;Y.indexOf(le,me)===me;)me=me+ue;return Y.substring(me)}e.ltrim=w;function o(Y,le){if(!Y||!le)return Y;const ue=le.length,me=Y.length;if(ue===0||me===0)return Y;let Se=me,Oe=-1;for(;Oe=Y.lastIndexOf(le,Se-1),!(Oe===-1||Oe+ue!==Se);){if(Oe===0)return"";Se=Oe}return Y.substring(0,Se)}e.rtrim=o;function h(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function p(Y){return Y.replace(/\*/g,"")}e.stripWildcards=p;function k(Y,le,ue={}){if(!Y)throw new Error("Cannot create regex from empty string");le||(Y=v(Y)),ue.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let me="";return ue.global&&(me+="g"),ue.matchCase||(me+="i"),ue.multiline&&(me+="m"),ue.unicode&&(me+="u"),new RegExp(Y,me)}e.createRegExp=k;function S(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function R(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=R;function t(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=t;function a(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=a;function i(Y){for(let le=0,ue=Y.length;le<ue;le++){const me=Y.charCodeAt(le);if(me!==32&&me!==9)return le}return-1}e.firstNonWhitespaceIndex=i;function s(Y,le=0,ue=Y.length){for(let me=le;me<ue;me++){const Se=Y.charCodeAt(me);if(Se!==32&&Se!==9)return Y.substring(le,me)}return Y.substring(le,ue)}e.getLeadingWhitespace=s;function c(Y,le=Y.length-1){for(let ue=le;ue>=0;ue--){const me=Y.charCodeAt(ue);if(me!==32&&me!==9)return ue}return-1}e.lastNonWhitespaceIndex=c;function u(Y,le,ue){const me=[];let Se=0;for(const Oe of Y.matchAll(le)){if(me.push(Y.slice(Se,Oe.index)),Oe.index===void 0)throw new Error("match.index should be defined");Se=Oe.index+Oe[0].length,me.push(ue(Oe[0],...Oe.slice(1),Oe.index,Y,Oe.groups))}return me.push(Y.slice(Se)),Promise.all(me).then(Oe=>Oe.join(""))}e.replaceAsync=u;function r(Y,le){return Y<le?-1:Y>le?1:0}e.compare=r;function l(Y,le,ue=0,me=Y.length,Se=0,Oe=le.length){for(;ue<me&&Se<Oe;ue++,Se++){const Qe=Y.charCodeAt(ue),Ke=le.charCodeAt(Se);if(Qe<Ke)return-1;if(Qe>Ke)return 1}const ze=me-ue,tt=Oe-Se;return ze<tt?-1:ze>tt?1:0}e.compareSubstring=l;function I(Y,le){return A(Y,le,0,Y.length,0,le.length)}e.compareIgnoreCase=I;function A(Y,le,ue=0,me=Y.length,Se=0,Oe=le.length){for(;ue<me&&Se<Oe;ue++,Se++){let Qe=Y.charCodeAt(ue),Ke=le.charCodeAt(Se);if(Qe===Ke)continue;if(Qe>=128||Ke>=128)return l(Y.toLowerCase(),le.toLowerCase(),ue,me,Se,Oe);N(Qe)&&(Qe-=32),N(Ke)&&(Ke-=32);const et=Qe-Ke;if(et!==0)return et}const ze=me-ue,tt=Oe-Se;return ze<tt?-1:ze>tt?1:0}e.compareSubstringIgnoreCase=A;function O(Y){return Y>=48&&Y<=57}e.isAsciiDigit=O;function N(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=N;function X(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=X;function V(Y,le){return Y.length===le.length&&A(Y,le)===0}e.equalsIgnoreCase=V;function K(Y,le){const ue=le.length;return le.length>Y.length?!1:A(Y,le,0,ue)===0}e.startsWithIgnoreCase=K;function ie(Y,le){const ue=Math.min(Y.length,le.length);let me;for(me=0;me<ue;me++)if(Y.charCodeAt(me)!==le.charCodeAt(me))return me;return ue}e.commonPrefixLength=ie;function re(Y,le){const ue=Math.min(Y.length,le.length);let me;const Se=Y.length-1,Oe=le.length-1;for(me=0;me<ue;me++)if(Y.charCodeAt(Se-me)!==le.charCodeAt(Oe-me))return me;return ue}e.commonSuffixLength=re;function ce(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=ce;function fe(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=fe;function ge(Y,le){return(Y-55296<<10)+(le-56320)+65536}e.computeCodePoint=ge;function x(Y,le,ue){const me=Y.charCodeAt(ue);if(ce(me)&&ue+1<le){const Se=Y.charCodeAt(ue+1);if(fe(Se))return ge(me,Se)}return me}e.getNextCodePoint=x;function F(Y,le){const ue=Y.charCodeAt(le-1);if(fe(ue)&&le>1){const me=Y.charCodeAt(le-2);if(ce(me))return ge(me,ue)}return ue}class W{get offset(){return this.e}constructor(le,ue=0){this.c=le,this.d=le.length,this.e=ue}setOffset(le){this.e=le}prevCodePoint(){const le=F(this.c,this.e);return this.e-=le>=65536?2:1,le}nextCodePoint(){const le=x(this.c,this.d,this.e);return this.e+=le>=65536?2:1,le}eol(){return this.e>=this.d}}e.CodePointIterator=W;class z{get offset(){return this.c.offset}constructor(le,ue=0){this.c=new W(le,ue)}nextGraphemeLength(){const le=Ae.getInstance(),ue=this.c,me=ue.offset;let Se=le.getGraphemeBreakType(ue.nextCodePoint());for(;!ue.eol();){const Oe=ue.offset,ze=le.getGraphemeBreakType(ue.nextCodePoint());if(Pe(Se,ze)){ue.setOffset(Oe);break}Se=ze}return ue.offset-me}prevGraphemeLength(){const le=Ae.getInstance(),ue=this.c,me=ue.offset;let Se=le.getGraphemeBreakType(ue.prevCodePoint());for(;ue.offset>0;){const Oe=ue.offset,ze=le.getGraphemeBreakType(ue.prevCodePoint());if(Pe(ze,Se)){ue.setOffset(Oe);break}Se=ze}return me-ue.offset}eol(){return this.c.eol()}}e.GraphemeIterator=z;function J(Y,le){return new z(Y,le).nextGraphemeLength()}e.nextCharLength=J;function ne(Y,le){return new z(Y,le).prevGraphemeLength()}e.prevCharLength=ne;function se(Y,le){le>0&&fe(Y.charCodeAt(le))&&le--;const ue=le+J(Y,le);return[ue-ne(Y,ue),ue]}e.getCharContainingOffset=se;function Z(Y){const le=new z(Y);let ue=0;for(;!le.eol();)ue++,le.nextGraphemeLength();return ue}e.charCount=Z;let U;function L(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function T(Y){return U||(U=L()),U.test(Y)}e.containsRTL=T;const B=/^[\t\n\r\x20-\x7E]*$/;function H(Y){return B.test(Y)}e.isBasicASCII=H,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function j(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=j;function $(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=$;function q(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129008||Y>=129280&&Y<=129535||Y>=129648&&Y<=129782}e.isEmojiImprecise=q;function oe(Y,le){if(Y.length<le)return Y;const ue=/\b/g;let me=0;for(;ue.test(Y)&&!(Y.length-ue.lastIndex<le);)me=ue.lastIndex,ue.lastIndex+=1;return Y.substring(me).replace(/^\s/,"")}e.lcut=oe;const de=/\x1B\x5B[12]?K/g,pe=/\x1b\[\d+m/g,ye=/\x1b\[0?m/g;function Le(Y){return Y&&(Y=Y.replace(de,""),Y=Y.replace(pe,""),Y=Y.replace(ye,"")),Y}e.removeAnsiEscapeCodes=Le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Fe(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Fe;function Te(Y){return Fe(Y)?Y.substr(1):Y}e.stripUTF8BOM=Te;function we(Y,le){if(!Y||!le||Y.length<le.length)return!1;const ue=le.length,me=Y.toLowerCase();let Se=0,Oe=-1;for(;Se<ue;){const ze=me.indexOf(le[Se],Oe+1);if(ze<0)return!1;Oe=ze,Se++}return!0}e.fuzzyContains=we;function Ce(Y,le=!1){return Y?(le&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=Ce;function Re(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=Re;function Q(Y,le=1){if(le===0)return"";let ue=-1;do ue=Y.indexOf(`
`,ue+1),le--;while(le>0&&ue>=0);return ue===-1?Y:(Y[ue-1]==="\r"&&ue--,Y.substr(0,ue))}e.getNLines=Q;function ae(Y){return Y=Y%(2*26),Y<26?String.fromCharCode(97+Y):String.fromCharCode(65+Y-26)}e.singleLetterHash=ae;function he(Y){return Ae.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=he;function Pe(Y,le){return Y===0?le!==5&&le!==7:Y===2&&le===3?!1:Y===4||Y===2||Y===3||le===4||le===2||le===3?!0:!(Y===8&&(le===8||le===9||le===11||le===12)||(Y===11||Y===9)&&(le===9||le===10)||(Y===12||Y===10)&&le===10||le===5||le===13||le===7||Y===1||Y===13&&le===14||Y===6&&le===6)}var Me;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(Me=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ae{static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=Ue()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const ue=this.d,me=ue.length/3;let Se=1;for(;Se<=me;)if(le<ue[3*Se])Se=2*Se;else if(le>ue[3*Se+1])Se=2*Se+1;else return ue[3*Se+2];return 0}}Ae.c=null;function Ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(Y,le){if(Y===0)return 0;const ue=Ne(Y,le);if(ue!==void 0)return ue;const me=new W(le,Y);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=He;function Ne(Y,le){const ue=new W(le,Y);let me=ue.prevCodePoint();for(;$e(me)||me===65039||me===8419;){if(ue.offset===0)return;me=ue.prevCodePoint()}if(!q(me))return;let Se=ue.offset;return Se>0&&ue.prevCodePoint()===8205&&(Se=ue.offset),Se}function $e(Y){return 127995<=Y&&Y<=127999}var Ge;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(Ge||(Ge={})),e.noBreakWhitespace="\xA0";class We{static getInstance(le){return We.d.get(Array.from(le))}static getLocales(){return We.e.value}constructor(le){this.f=le}isAmbiguous(le){return this.f.has(le)}getPrimaryConfusable(le){return this.f.get(le)}getConfusableCodePoints(){return new Set(this.f.keys())}}n=We,We.c=new M.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),We.d=new E.LRUCachedFunction(Y=>{function le(Ke){const et=new Map;for(let it=0;it<Ke.length;it+=2)et.set(Ke[it],Ke[it+1]);return et}function ue(Ke,et){const it=new Map(Ke);for(const[ot,ut]of et)it.set(ot,ut);return it}function me(Ke,et){if(!Ke)return et;const it=new Map;for(const[ot,ut]of Ke)et.has(ot)&&it.set(ot,ut);return it}const Se=n.c.value;let Oe=Y.filter(Ke=>!Ke.startsWith("_")&&Ke in Se);Oe.length===0&&(Oe=["_default"]);let ze;for(const Ke of Oe){const et=le(Se[Ke]);ze=me(ze,et)}const tt=le(Se._common),Qe=ue(tt,ze);return new We(Qe)}),We.e=new M.Lazy(()=>Object.keys(We.c.value).filter(Y=>!Y.startsWith("_"))),e.AmbiguousCharacters=We;class Ve{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ve.c())),this.d}static isInvisibleCharacter(le){return Ve.e().has(le)}static get codePoints(){return Ve.e()}}Ve.d=void 0,e.InvisibleCharacters=Ve}),define(ee[32],te([0,1,9,4,27,10]),function(G,e,E,M,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(c){return c===47||c===92}e.isPathSeparator=D;function P(c){return c.replace(/[\\/]/g,E.posix.sep)}e.toSlashes=P;function f(c){return c.indexOf("/")===-1&&(c=P(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=f;function d(c,u=E.posix.sep){if(!c)return"";const r=c.length,l=c.charCodeAt(0);if(D(l)){if(D(c.charCodeAt(1))&&!D(c.charCodeAt(2))){let A=3;const O=A;for(;A<r&&!D(c.charCodeAt(A));A++);if(O!==A&&!D(c.charCodeAt(A+1))){for(A+=1;A<r;A++)if(D(c.charCodeAt(A)))return c.slice(0,A+1).replace(/[\\/]/g,u)}}return u}else if(h(l)&&c.charCodeAt(1)===58)return D(c.charCodeAt(2))?c.slice(0,2)+u:c.slice(0,2);let I=c.indexOf("://");if(I!==-1){for(I+=3;I<r;I++)if(D(c.charCodeAt(I)))return c.slice(0,I+1)}return""}e.getRoot=d;function b(c){if(!M.isWindows||!c||c.length<5)return!1;let u=c.charCodeAt(0);if(u!==92||(u=c.charCodeAt(1),u!==92))return!1;let r=2;const l=r;for(;r<c.length&&(u=c.charCodeAt(r),u!==92);r++);return!(l===r||(u=c.charCodeAt(r+1),isNaN(u)||u===92))}e.isUNC=b;const v=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(c,u=M.isWindows){const r=u?v:y;return!(!c||c.length===0||/^\s+$/.test(c)||(r.lastIndex=0,r.test(c))||u&&g.test(c)||c==="."||c===".."||u&&c[c.length-1]==="."||u&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=m;function w(c,u,r){const l=c===u;return!r||l?l:!c||!u?!1:(0,n.equalsIgnoreCase)(c,u)}e.isEqual=w;function o(c,u,r,l=E.sep){if(c===u)return!0;if(!c||!u||u.length>c.length)return!1;if(r){if(!(0,n.startsWithIgnoreCase)(c,u))return!1;if(u.length===c.length)return!0;let A=u.length;return u.charAt(u.length-1)===l&&A--,c.charAt(A)===l}return u.charAt(u.length-1)!==l&&(u+=l),c.indexOf(u)===0}e.isEqualOrParent=o;function h(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=h;function p(c,u){return M.isWindows&&c.endsWith(":")&&(c+=E.sep),(0,E.isAbsolute)(c)||(c=(0,E.join)(u,c)),c=(0,E.normalize)(c),M.isWindows?(c=(0,n.rtrim)(c,E.sep),c.endsWith(":")&&(c+=E.sep)):(c=(0,n.rtrim)(c,E.sep),c||(c=E.sep)),c}e.sanitizeFilePath=p;function k(c){const u=(0,E.normalize)(c);return M.isWindows?c.length>3?!1:S(u)&&(c.length===2||u.charCodeAt(2)===92):u===E.posix.sep}e.isRootOrDriveLetter=k;function S(c,u=M.isWindows){return u?h(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=S;function R(c){return S(c)?c[0]:void 0}e.getDriveLetter=R;function t(c,u,r){return u.length>c.length?-1:c===u?0:(r&&(c=c.toLowerCase(),u=u.toLowerCase()),c.indexOf(u))}e.indexOfPath=t;function a(c){const u=c.split(":");let r,l,I;for(const A of u){const O=Number(A);(0,C.isNumber)(O)?l===void 0?l=O:I===void 0&&(I=O):r=r?[r,A].join(":"):A}if(!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:l!==void 0?l:void 0,column:I!==void 0?I:l!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(c,u,r=8){let l="";for(let A=0;A<r;A++)l+=i.charAt(Math.floor(Math.random()*i.length));let I;return u?I=`${u}-${l}`:I=l,c?(0,E.join)(c,I):I}e.randomPath=s}),define(ee[72],te([0,1,27]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function M(h){return n(h,0)}e.hash=M;function n(h,p){switch(typeof h){case"object":return h===null?C(349,p):Array.isArray(h)?f(h,p):d(h,p);case"string":return P(h,p);case"boolean":return D(h,p);case"number":return C(h,p);case"undefined":return C(937,p);default:return C(617,p)}}e.doHash=n;function C(h,p){return(p<<5)-p+h|0}e.numberHash=C;function D(h,p){return C(h?433:863,p)}function P(h,p){p=C(149417,p);for(let k=0,S=h.length;k<S;k++)p=C(h.charCodeAt(k),p);return p}e.stringHash=P;function f(h,p){return p=C(104579,p),h.reduce((k,S)=>n(S,k),p)}function d(h,p){return p=C(181387,p),Object.keys(h).sort().reduce((k,S)=>(k=P(S,k),n(h[S],k)),p)}class b{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=n(p,this.g),this.g}}e.Hasher=b;var v;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function y(h,p,k=32){const S=k-p,R=~((1<<S)-1);return(h<<p|(R&h)>>>S)>>>0}function g(h,p=0,k=h.byteLength,S=0){for(let R=0;R<k;R++)h[p+R]=S}function m(h,p,k="0"){for(;h.length<p;)h=k+h;return h}function w(h,p=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(k=>k.toString(16).padStart(2,"0")).join(""):m((h>>>0).toString(16),p/4)}e.toHexString=w;class o{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const k=p.length;if(k===0)return;const S=this.p;let R=this.r,t=this.u,a,i;for(t!==0?(a=t,i=-1,t=0):(a=p.charCodeAt(0),i=0);;){let s=a;if(E.isHighSurrogate(a))if(i+1<k){const c=p.charCodeAt(i+1);E.isLowSurrogate(c)?(i++,s=E.computeCodePoint(a,c)):s=65533}else{t=a;break}else E.isLowSurrogate(a)&&(s=65533);if(R=this.w(S,R,s),i++,i<k)a=p.charCodeAt(i);else break}this.r=R,this.u=t}w(p,k,S){return S<128?p[k++]=S:S<2048?(p[k++]=192|(S&1984)>>>6,p[k++]=128|(S&63)>>>0):S<65536?(p[k++]=224|(S&61440)>>>12,p[k++]=128|(S&4032)>>>6,p[k++]=128|(S&63)>>>0):(p[k++]=240|(S&1835008)>>>18,p[k++]=128|(S&258048)>>>12,p[k++]=128|(S&4032)>>>6,p[k++]=128|(S&63)>>>0),k>=64&&(this.y(),k-=64,this.t+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),k}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,g(this.p,this.r),this.r>56&&(this.y(),g(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=o.g,k=this.q;for(let r=0;r<64;r+=4)p.setUint32(r,k.getUint32(r,!1),!1);for(let r=64;r<320;r+=4)p.setUint32(r,y(p.getUint32(r-12,!1)^p.getUint32(r-32,!1)^p.getUint32(r-56,!1)^p.getUint32(r-64,!1),1),!1);let S=this.h,R=this.l,t=this.m,a=this.n,i=this.o,s,c,u;for(let r=0;r<80;r++)r<20?(s=R&t|~R&a,c=1518500249):r<40?(s=R^t^a,c=1859775393):r<60?(s=R&t|R&a|t&a,c=2400959708):(s=R^t^a,c=3395469782),u=y(S,5)+s+i+c+p.getUint32(r*4,!1)&4294967295,i=a,a=t,t=y(R,30),R=S,S=u;this.h=this.h+S&4294967295,this.l=this.l+R&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+i&4294967295}}o.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=o}),define(ee[84],te([0,1,27]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(n){n[n.Ignore=0]="Ignore",n[n.Info=1]="Info",n[n.Warning=2]="Warning",n[n.Error=3]="Error"})(M||(M={})),function(n){const C="error",D="warning",P="warn",f="info",d="ignore";function b(y){return y?E.equalsIgnoreCase(C,y)?n.Error:E.equalsIgnoreCase(D,y)||E.equalsIgnoreCase(P,y)?n.Warning:E.equalsIgnoreCase(f,y)?n.Info:n.Ignore:n.Ignore}n.fromValue=b;function v(y){switch(y){case n.Error:return C;case n.Warning:return D;case n.Info:return f;default:return d}}n.toString=v}(M||(M={})),e.default=M}),define(ee[61],te([0,1,25,27]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class n{constructor(){this.b="",this.c=0}reset(g){return this.b=g,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(g){const m=g.charCodeAt(0),w=this.b.charCodeAt(this.c);return m-w}value(){return this.b[this.c]}}e.StringIterator=n;class C{constructor(g=!0){this.e=g}reset(g){return this.b=g,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let g=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(g)this.c++;else break;else g=!1;return this}cmp(g){return this.e?(0,M.compareSubstring)(g,this.b,0,g.length,this.c,this.d):(0,M.compareSubstringIgnoreCase)(g,this.b,0,g.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=C;class D{constructor(g=!0,m=!0){this.f=g,this.g=m}reset(g){this.d=0,this.e=0,this.b=g,this.c=g.length;for(let m=g.length-1;m>=0;m--,this.c--){const w=this.b.charCodeAt(m);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let g=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(g)this.d++;else break;else g=!1}return this}cmp(g){return this.g?(0,M.compareSubstring)(g,this.b,0,g.length,this.d,this.e):(0,M.compareSubstringIgnoreCase)(g,this.b,0,g.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=D;var P;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(P||(P={}));class f{constructor(g,m){this.f=g,this.g=m,this.d=[],this.e=0}reset(g){return this.c=g,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(g)),this.b.reset(g.path),this.b.value()&&this.d.push(3)),this.g(g)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(g){if(this.d[this.e]===1)return(0,M.compareIgnoreCase)(g,this.c.scheme);if(this.d[this.e]===2)return(0,M.compareIgnoreCase)(g,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(g);if(this.d[this.e]===4)return(0,M.compare)(g,this.c.query);if(this.d[this.e]===5)return(0,M.compare)(g,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=f;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const g=this.right;return this.right=g.left,g.left=this,this.updateHeight(),g.updateHeight(),g}rotateRight(){const g=this.left;return this.left=g.right,g.right=this,this.updateHeight(),g.updateHeight(),g}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(b||(b={}));class v{static forUris(g=()=>!1,m=()=>!1){return new v(new f(g,m))}static forPaths(g=!1){return new v(new D(void 0,!g))}static forStrings(){return new v(new n)}static forConfigKeys(){return new v(new C)}constructor(g){this.b=g}clear(){this.c=void 0}fill(g,m){if(m){const w=m.slice(0);(0,E.shuffle)(w);for(const o of w)this.set(o,g)}else{const w=g.slice(0);(0,E.shuffle)(w);for(const o of w)this.set(o[0],o[1])}}set(g,m){const w=this.b.reset(g);let o;this.c||(this.c=new d,this.c.segment=w.value());const h=[];for(o=this.c;;){const k=w.cmp(o.segment);if(k>0)o.left||(o.left=new d,o.left.segment=w.value()),h.push([-1,o]),o=o.left;else if(k<0)o.right||(o.right=new d,o.right.segment=w.value()),h.push([1,o]),o=o.right;else if(w.hasNext())w.next(),o.mid||(o.mid=new d,o.mid.segment=w.value()),h.push([0,o]),o=o.mid;else break}const p=o.value;o.value=m,o.key=g;for(let k=h.length-1;k>=0;k--){const S=h[k][1];S.updateHeight();const R=S.balanceFactor();if(R<-1||R>1){const t=h[k][0],a=h[k+1][0];if(t===1&&a===1)h[k][1]=S.rotateLeft();else if(t===-1&&a===-1)h[k][1]=S.rotateRight();else if(t===1&&a===-1)S.right=h[k+1][1]=h[k+1][1].rotateRight(),h[k][1]=S.rotateLeft();else if(t===-1&&a===1)S.left=h[k+1][1]=h[k+1][1].rotateLeft(),h[k][1]=S.rotateRight();else throw new Error;if(k>0)switch(h[k-1][0]){case-1:h[k-1][1].left=h[k][1];break;case 1:h[k-1][1].right=h[k][1];break;case 0:h[k-1][1].mid=h[k][1];break}else this.c=h[0][1]}}return p}get(g){return this.d(g)?.value}d(g){const m=this.b.reset(g);let w=this.c;for(;w;){const o=m.cmp(w.segment);if(o>0)w=w.left;else if(o<0)w=w.right;else if(m.hasNext())m.next(),w=w.mid;else break}return w}has(g){const m=this.d(g);return!(m?.value===void 0&&m?.mid===void 0)}delete(g){return this.e(g,!1)}deleteSuperstr(g){return this.e(g,!0)}e(g,m){const w=this.b.reset(g),o=[];let h=this.c;for(;h;){const p=w.cmp(h.segment);if(p>0)o.push([-1,h]),h=h.left;else if(p<0)o.push([1,h]),h=h.right;else if(w.hasNext())w.next(),o.push([0,h]),h=h.mid;else break}if(!!h){if(m?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const p=this.f(h.right);if(p.key){const{key:k,value:S,segment:R}=p;this.e(p.key,!1),h.key=k,h.value=S,h.segment=R}}else{const p=h.left??h.right;if(o.length>0){const[k,S]=o[o.length-1];switch(k){case-1:S.left=p;break;case 0:S.mid=p;break;case 1:S.right=p;break}}else this.c=p}for(let p=o.length-1;p>=0;p--){const k=o[p][1];k.updateHeight();const S=k.balanceFactor();if(S>1?(k.right.balanceFactor()>=0||(k.right=k.right.rotateRight()),o[p][1]=k.rotateLeft()):S<-1&&(k.left.balanceFactor()<=0||(k.left=k.left.rotateLeft()),o[p][1]=k.rotateRight()),p>0)switch(o[p-1][0]){case-1:o[p-1][1].left=o[p][1];break;case 1:o[p-1][1].right=o[p][1];break;case 0:o[p-1][1].mid=o[p][1];break}else this.c=o[0][1]}}}f(g){for(;g.left;)g=g.left;return g}findSubstr(g){const m=this.b.reset(g);let w=this.c,o;for(;w;){const h=m.cmp(w.segment);if(h>0)w=w.left;else if(h<0)w=w.right;else if(m.hasNext())m.next(),o=w.value||o,w=w.mid;else break}return w&&w.value||o}findSuperstr(g){return this.g(g,!1)}g(g,m){const w=this.b.reset(g);let o=this.c;for(;o;){const h=w.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(w.hasNext())w.next(),o=o.mid;else return o.mid?this.h(o.mid):m?o.value:void 0}}hasElementOrSubtree(g){return this.g(g,!0)!==void 0}forEach(g){for(const[m,w]of this)g(w,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(g){const m=[];return this.j(g,m),m[Symbol.iterator]()}j(g,m){!g||(g.left&&this.j(g.left,m),g.value&&m.push([g.key,g.value]),g.mid&&this.j(g.mid,m),g.right&&this.j(g.right,m))}_isBalanced(){const g=m=>{if(!m)return!0;const w=m.balanceFactor();return w<-1||w>1?!1:g(m.left)&&g(m.right)};return g(this.c)}}e.TernarySearchTree=v}),define(ee[7],te([0,1,9,4]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const n=/^\w[\w\d+.-]*$/,C=/^\//,D=/^\/\//;function P(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!n.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!C.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(i,s){return!i&&!s?"file":i}function d(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==v&&(s=v+s):s=v;break}return s}const b="",v="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(s){return s instanceof g?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,c,u,r,l,I=!1){typeof s=="object"?(this.scheme=s.scheme||b,this.authority=s.authority||b,this.path=s.path||b,this.query=s.query||b,this.fragment=s.fragment||b):(this.scheme=f(s,I),this.authority=c||b,this.path=d(this.scheme,u||b),this.query=r||b,this.fragment=l||b,P(this,I))}get fsPath(){return k(this,!1)}with(s){if(!s)return this;let{scheme:c,authority:u,path:r,query:l,fragment:I}=s;return c===void 0?c=this.scheme:c===null&&(c=b),u===void 0?u=this.authority:u===null&&(u=b),r===void 0?r=this.path:r===null&&(r=b),l===void 0?l=this.query:l===null&&(l=b),I===void 0?I=this.fragment:I===null&&(I=b),c===this.scheme&&u===this.authority&&r===this.path&&l===this.query&&I===this.fragment?this:new w(c,u,r,l,I)}static parse(s,c=!1){const u=y.exec(s);return u?new w(u[2]||b,a(u[4]||b),a(u[5]||b),a(u[7]||b),a(u[9]||b),c):new w(b,b,b,b,b)}static file(s){let c=b;if(M.isWindows&&(s=s.replace(/\\/g,v)),s[0]===v&&s[1]===v){const u=s.indexOf(v,2);u===-1?(c=s.substring(2),s=v):(c=s.substring(2,u),s=s.substring(u)||v)}return new w("file",c,s,b,b)}static from(s){const c=new w(s.scheme,s.authority,s.path,s.query,s.fragment);return P(c,!0),c}static joinPath(s,...c){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return M.isWindows&&s.scheme==="file"?u=g.file(E.win32.join(k(s,!0),...c)).path:u=E.posix.join(s.path,...c),s.with({path:u})}toString(s=!1){return S(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof g)return s;{const c=new w(s);return c._formatted=s.external,c._fsPath=s._sep===m?s.fsPath:null,c}}else return s}}e.URI=g;const m=M.isWindows?1:void 0;class w extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=k(this,!1)),this._fsPath}toString(s=!1){return s?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=m),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(i,s,c){let u,r=-1;for(let l=0;l<i.length;l++){const I=i.charCodeAt(l);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||s&&I===47||c&&I===91||c&&I===93||c&&I===58)r!==-1&&(u+=encodeURIComponent(i.substring(r,l)),r=-1),u!==void 0&&(u+=i.charAt(l));else{u===void 0&&(u=i.substr(0,l));const A=o[I];A!==void 0?(r!==-1&&(u+=encodeURIComponent(i.substring(r,l)),r=-1),u+=A):r===-1&&(r=l)}}return r!==-1&&(u+=encodeURIComponent(i.substring(r))),u!==void 0?u:i}function p(i){let s;for(let c=0;c<i.length;c++){const u=i.charCodeAt(c);u===35||u===63?(s===void 0&&(s=i.substr(0,c)),s+=o[u]):s!==void 0&&(s+=i[c])}return s!==void 0?s:i}function k(i,s){let c;return i.authority&&i.path.length>1&&i.scheme==="file"?c=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?c=i.path.substr(1):c=i.path[1].toLowerCase()+i.path.substr(2):c=i.path,M.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=k;function S(i,s){const c=s?p:h;let u="",{scheme:r,authority:l,path:I,query:A,fragment:O}=i;if(r&&(u+=r,u+=":"),(l||r==="file")&&(u+=v,u+=v),l){let N=l.indexOf("@");if(N!==-1){const X=l.substr(0,N);l=l.substr(N+1),N=X.lastIndexOf(":"),N===-1?u+=c(X,!1,!1):(u+=c(X.substr(0,N),!1,!1),u+=":",u+=c(X.substr(N+1),!1,!0)),u+="@"}l=l.toLowerCase(),N=l.lastIndexOf(":"),N===-1?u+=c(l,!1,!0):(u+=c(l.substr(0,N),!1,!0),u+=l.substr(N))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const N=I.charCodeAt(1);N>=65&&N<=90&&(I=`/${String.fromCharCode(N+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const N=I.charCodeAt(0);N>=65&&N<=90&&(I=`${String.fromCharCode(N+32)}:${I.substr(2)}`)}u+=c(I,!0,!1)}return A&&(u+="?",u+=c(A,!1,!1)),O&&(u+="#",u+=s?O:h(O,!1,!1)),u}function R(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+R(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(i){return i.match(t)?i.replace(t,s=>R(s)):i}}),define(ee[144],te([0,1,7]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function M(d){const b=d;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=M;function n(d){const b=[];let v;try{const y=JSON.parse(d.arguments),g=y[y.length-1];g&&g.__$stack&&(y.pop(),v=g.__$stack),b.push(...y)}catch{b.push("Unable to log remote console arguments",d.arguments)}return{args:b,stack:v}}e.parse=n;function C(d){if(typeof d!="string")return C(n(d).stack);const b=d;if(b){const v=D(b),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(y&&y.length===4)return{uri:E.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=C;function D(d){if(!d)return d;const b=d.indexOf(`
`);return b===-1?d:d.substring(0,b)}function P(d,b){const{args:v,stack:y}=n(d),g=typeof v[0]=="string"&&v.length===1;let m=D(y);m&&(m=`(${m.trim()})`);let w=[];if(typeof v[0]=="string"?m&&g?w=[`%c[${b}] %c${v[0]} %c${m}`,f("blue"),f(""),f("grey")]:w=[`%c[${b}] %c${v[0]}`,f("blue"),f(""),...v.slice(1)]:w=[`%c[${b}]%`,f("blue"),...v],m&&!g&&w.push(m),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,w)}e.log=P;function f(d){return`color: ${d}`}}),define(ee[73],te([0,1,17,27,7]),function(G,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function C(d){return JSON.stringify(d,P)}e.stringify=C;function D(d){let b=JSON.parse(d);return b=f(b),b}e.parse=D;function P(d,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,M.regExpFlags)(b)}:b}function f(d,b=0){if(!d||b>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return n.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 16:return new Date(d.source)}if(d instanceof E.VSBuffer||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let v=0;v<d.length;++v)d[v]=f(d[v],b+1);else for(const v in d)Object.hasOwnProperty.call(d,v)&&(d[v]=f(d[v],b+1))}return d}e.revive=f}),define(ee[15],te([0,1,13,4,7]),function(G,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var C;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractive="vscode-interactive",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm"})(C=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${C.vscodeRemoteResource}`}setPreferredWebSchema(b){this.d=b}setDelegate(b){this.e=b}setServerRootPath(b){this.f=`${b}/${C.vscodeRemoteResource}`}set(b,v,y){this.a[b]=v,this.b[b]=y}setConnectionToken(b,v){this.c[b]=v}getPreferredWebSchema(){return this.d}rewrite(b){if(this.e)try{return this.e(b)}catch(o){return E.onUnexpectedError(o),b}const v=b.authority;let y=this.a[v];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const g=this.b[v],m=this.c[v];let w=`path=${encodeURIComponent(b.path)}`;return typeof m=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),n.URI.from({scheme:M.isWeb?this.d:C.vscodeRemoteResource,authority:`${y}:${g}`,path:this.f,query:w})}}e.RemoteAuthorities=new D,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(b){const v=this.b(b,G);return this.uriToBrowserUri(v)}uriToBrowserUri(b){return b.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(b):b.scheme===C.file&&(M.isNative||M.isWebWorker&&M.globals.origin===`${C.vscodeFileResource}://${P.a}`)?b.with({scheme:C.vscodeFileResource,authority:b.authority||P.a,query:null,fragment:null}):b}asFileUri(b){const v=this.b(b,G);return this.uriToFileUri(v)}uriToFileUri(b){return b.scheme===C.vscodeFileResource?b.with({scheme:C.file,authority:b.authority!==P.a?b.authority:null,query:null,fragment:null}):b}b(b,v){return n.URI.isUri(b)?b:n.URI.parse(v.toUrl(b))}}P.a="vscode-app",e.FileAccess=new P;var f;(function(d){const b=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(b.get("3"));const v="vscode-coi";function y(m){let w;typeof m=="string"?w=new URL(m).searchParams:m instanceof URL?w=m.searchParams:n.URI.isUri(m)&&(w=new URL(m.toString(!0)).searchParams);const o=w?.get(v);if(!!o)return b.get(o)}d.getHeadersFromQuery=y;function g(m,w,o){if(!globalThis.crossOriginIsolated)return;const h=w&&o?"3":o?"2":"1";m instanceof URLSearchParams?m.set(v,h):m[v]=h}d.addSearchParam=g})(f=e.COI||(e.COI={}))}),define(ee[18],te([0,1,32,15,9,4,27,7]),function(G,e,E,M,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(g){return(0,P.uriToFsPath)(g,!0)}e.originalFSPath=f;class d{constructor(m){this.a=m}compare(m,w,o=!1){return m===w?0:(0,D.compare)(this.getComparisonKey(m,o),this.getComparisonKey(w,o))}isEqual(m,w,o=!1){return m===w?!0:!m||!w?!1:this.getComparisonKey(m,o)===this.getComparisonKey(w,o)}getComparisonKey(m,w=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,w,o=!1){if(m.scheme===w.scheme){if(m.scheme===M.Schemas.file)return E.isEqualOrParent(f(m),f(w),this.a(m))&&m.query===w.query&&(o||m.fragment===w.fragment);if((0,e.isEqualAuthority)(m.authority,w.authority))return E.isEqualOrParent(m.path,w.path,this.a(m),"/")&&m.query===w.query&&(o||m.fragment===w.fragment)}return!1}joinPath(m,...w){return P.URI.joinPath(m,...w)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return n.posix.basename(m.path)}extname(m){return n.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let w;return m.scheme===M.Schemas.file?w=P.URI.file(n.dirname(f(m))).path:(w=n.posix.dirname(m.path),m.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),w="/")),m.with({path:w})}normalizePath(m){if(!m.path.length)return m;let w;return m.scheme===M.Schemas.file?w=P.URI.file(n.normalize(f(m))).path:w=n.posix.normalize(m.path),m.with({path:w})}relativePath(m,w){if(m.scheme!==w.scheme||!(0,e.isEqualAuthority)(m.authority,w.authority))return;if(m.scheme===M.Schemas.file){const p=n.relative(f(m),f(w));return C.isWindows?E.toSlashes(p):p}let o=m.path||"/";const h=w.path||"/";if(this.a(m)){let p=0;for(const k=Math.min(o.length,h.length);p<k&&!(o.charCodeAt(p)!==h.charCodeAt(p)&&o.charAt(p).toLowerCase()!==h.charAt(p).toLowerCase());p++);o=h.substr(0,p)+o.substr(p)}return n.posix.relative(o,h)}resolvePath(m,w){if(m.scheme===M.Schemas.file){const o=P.URI.file(n.resolve(f(m),w));return m.with({authority:o.authority,path:o.path})}return w=E.toPosixPath(w),m.with({path:n.posix.resolve(m.path,w)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,w){return m===w||m!==void 0&&w!==void 0&&(0,D.equalsIgnoreCase)(m,w)}hasTrailingPathSeparator(m,w=n.sep){if(m.scheme===M.Schemas.file){const o=f(m);return o.length>E.getRoot(o).length&&o[o.length-1]===w}else{const o=m.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,w=n.sep){return(0,e.hasTrailingPathSeparator)(m,w)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,w=n.sep){let o=!1;if(m.scheme===M.Schemas.file){const h=f(m);o=h!==void 0&&h.length===E.getRoot(h).length&&h[h.length-1]===w}else{w="/";const h=m.path;o=h.length===1&&h.charCodeAt(h.length-1)===47}return!o&&!(0,e.hasTrailingPathSeparator)(m,w)?m.with({path:m.path+"/"}):m}}e.ExtUri=d,e.extUri=new d(()=>!1),e.extUriBiasedIgnorePathCase=new d(g=>g.scheme===M.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new d(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function b(g,m){const w=[];for(let o=0;o<g.length;o++){const h=m(g[o]);g.some((p,k)=>k===o?!1:(0,e.isEqualOrParent)(h,m(p)))||w.push(g[o])}return w}e.distinctParents=b;var v;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function m(w){const o=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(k=>{const[S,R]=k.split(":");S&&R&&o.set(S,R)});const p=w.path.substring(0,w.path.indexOf(";"));return p&&o.set(g.META_DATA_MIME,p),o}g.parseMetaData=m})(v=e.DataUri||(e.DataUri={}));function y(g,m,w){if(m){let o=g.path;return o&&o[0]!==n.posix.sep&&(o=n.posix.sep+o),g.with({scheme:w,authority:m,path:o})}return g.with({scheme:w})}e.toLocalResource=y}),define(ee[8],te([0,1,22,13,3,2,18,4,129]),function(G,e,E,M,n,C,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function d(Z){return!!Z&&typeof Z.then=="function"}e.isThenable=d;function b(Z){const U=new E.CancellationTokenSource,L=Z(U.token),T=new Promise((B,H)=>{const j=U.token.onCancellationRequested(()=>{j.dispose(),U.dispose(),H(new M.CancellationError)});Promise.resolve(L).then($=>{j.dispose(),U.dispose(),B($)},$=>{j.dispose(),U.dispose(),H($)})});return new class{cancel(){U.cancel()}then(B,H){return T.then(B,H)}catch(B){return this.then(void 0,B)}finally(B){return T.finally(B)}}}e.createCancelablePromise=b;function v(Z,U,L){return new Promise((T,B)=>{const H=U.onCancellationRequested(()=>{H.dispose(),T(L)});Z.then(T,B).finally(()=>H.dispose())})}e.raceCancellation=v;function y(Z,U){return new Promise((L,T)=>{const B=U.onCancellationRequested(()=>{B.dispose(),T(new M.CancellationError)});Z.then(L,T).finally(()=>B.dispose())})}e.raceCancellationError=y;async function g(Z){let U=-1;const L=Z.map((B,H)=>B.then(j=>(U=H,j))),T=await Promise.race(L);return Z.forEach((B,H)=>{H!==U&&B.cancel()}),T}e.raceCancellablePromises=g;function m(Z,U,L){let T;const B=setTimeout(()=>{T?.(void 0),L?.()},U);return Promise.race([Z.finally(()=>clearTimeout(B)),new Promise(H=>T=H)])}e.raceTimeout=m;function w(Z){return new Promise((U,L)=>{const T=Z();d(T)?T.then(U,L):U(T)})}e.asPromise=w;class o{constructor(){this.a=null,this.b=null,this.d=null}queue(U){if(this.a){if(this.d=U,!this.b){const L=()=>{this.b=null;const T=this.queue(this.d);return this.d=null,T};this.b=new Promise(T=>{this.a.then(L,L).then(T)})}return new Promise((L,T)=>{this.b.then(L,T)})}return this.a=U(),new Promise((L,T)=>{this.a.then(B=>{this.a=null,L(B)},B=>{this.a=null,T(B)})})}}e.Throttler=o;class h{constructor(){this.a=Promise.resolve(null)}queue(U){return this.a=this.a.then(()=>U(),()=>U())}}e.Sequencer=h;class p{constructor(){this.a=new Map}queue(U,L){const B=(this.a.get(U)??Promise.resolve()).catch(()=>{}).then(L).finally(()=>{this.a.get(U)===B&&this.a.delete(U)});return this.a.set(U,B),B}}e.SequencerByKey=p;const k=(Z,U)=>{let L=!0;const T=setTimeout(()=>{L=!1,U()},Z);return{isTriggered:()=>L,dispose:()=>{clearTimeout(T),L=!1}}},S=Z=>{let U=!0;return queueMicrotask(()=>{U&&(U=!1,Z())}),{isTriggered:()=>U,dispose:()=>{U=!1}}};class R{constructor(U){this.defaultDelay=U,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(U,L=this.defaultDelay){this.g=U,this.h(),this.b||(this.b=new Promise((B,H)=>{this.d=B,this.f=H}).then(()=>{if(this.b=null,this.d=null,this.g){const B=this.g;return this.g=null,B()}}));const T=()=>{this.a=null,this.d?.(null)};return this.a=L===f.MicrotaskDelay?S(T):k(L,T),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=R;class t{constructor(U){this.a=new R(U),this.b=new o}trigger(U,L){return this.a.trigger(()=>this.b.queue(U),L)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class a{constructor(){this.a=!1,this.b=new Promise((U,L)=>{this.d=U})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=a;class i extends a{constructor(U){super(),this.f=setTimeout(()=>this.open(),U)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=i;function s(Z,U){return U?new Promise((L,T)=>{const B=setTimeout(()=>{H.dispose(),L()},Z),H=U.onCancellationRequested(()=>{clearTimeout(B),H.dispose(),T(new M.CancellationError)})}):b(L=>s(Z,L))}e.timeout=s;function c(Z,U=0){const L=setTimeout(Z,U);return(0,C.toDisposable)(()=>clearTimeout(L))}e.disposableTimeout=c;function u(Z){const U=[];let L=0;const T=Z.length;function B(){return L<T?Z[L++]():null}function H(j){j!=null&&U.push(j);const $=B();return $?$.then(H):Promise.resolve(U)}return Promise.resolve(null).then(H)}e.sequence=u;function r(Z,U=T=>!!T,L=null){let T=0;const B=Z.length,H=()=>{if(T>=B)return Promise.resolve(L);const j=Z[T++];return Promise.resolve(j()).then(q=>U(q)?Promise.resolve(q):H())};return H()}e.first=r;function l(Z,U=T=>!!T,L=null){if(Z.length===0)return Promise.resolve(L);let T=Z.length;const B=()=>{T=-1;for(const H of Z)H.cancel?.()};return new Promise((H,j)=>{for(const $ of Z)$.then(q=>{--T>=0&&U(q)?(B(),H(q)):T===0&&H(L)}).catch(q=>{--T>=0&&(B(),j(q))})})}e.firstParallel=l;class I{constructor(U){this.a=0,this.d=U,this.f=[],this.b=0,this.g=new n.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(U){return this.a++,new Promise((L,T)=>{this.f.push({factory:U,c:L,e:T}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const U=this.f.shift();this.b++;const L=U.factory();L.then(U.c,U.e),L.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=I;class A extends I{constructor(){super(1)}}e.Queue=A;class O{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const U=new F;return this.b.add(U),U.p}d(){for(const[,U]of this.a)if(U.size>0)return!1;return!0}queueFor(U,L=D.extUri){const T=L.getComparisonKey(U);let B=this.a.get(T);return B||(B=new A,n.Event.once(B.onDrained)(()=>{B?.dispose(),this.a.delete(T),this.f()}),this.a.set(T,B)),B}f(){!this.d()||this.g()}g(){for(const U of this.b)U.complete();this.b.clear()}dispose(){for(const[,U]of this.a)U.dispose();this.a.clear(),this.g()}}e.ResourceQueue=O;class N{constructor(U,L){this.a=-1,typeof U=="function"&&typeof L=="number"&&this.setIfNotSet(U,L)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(U,L){this.cancel(),this.a=setTimeout(()=>{this.a=-1,U()},L)}setIfNotSet(U,L){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,U()},L))}}e.TimeoutTimer=N;class X{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(U,L){this.cancel(),this.a=setInterval(()=>{U()},L)}}e.IntervalTimer=X;class V{constructor(U,L){this.b=-1,this.a=U,this.d=L,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(U=this.d){this.cancel(),this.b=setTimeout(this.f,U)}get delay(){return this.d}set delay(U){this.d=U}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=V;class K{constructor(U,L){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.a=U,this.b=L,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(U=this.b){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(U/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=K;class ie extends V{constructor(U,L){super(U,L),this.j=[]}work(U){this.j.push(U),this.isScheduled()||this.schedule()}h(){const U=this.j;this.j=[],this.a?.(U)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=ie;class re extends C.Disposable{constructor(U,L){super(),this.g=U,this.h=L,this.a=[],this.b=this.B(new C.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(U){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+U.length>this.g.maxBufferedWork)return!1}else if(this.pending+U.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const L of U)this.a.push(L);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new V(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=re,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Z=>{(0,P.setTimeout0)(()=>{if(U)return;const L=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,L-Date.now())}}))});let U=!1;return{dispose(){U||(U=!0)}}}:e.runWhenIdle=(Z,U)=>{const L=requestIdleCallback(Z,typeof U=="number"?{timeout:U}:void 0);let T=!1;return{dispose(){T||(T=!0,cancelIdleCallback(L))}}}}();class ce{constructor(U){this.d=!1,this.a=()=>{try{this.f=U()}catch(L){this.g=L}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=ce;async function fe(Z,U,L){let T;for(let B=0;B<L;B++)try{return await Z()}catch(H){T=H,await s(U)}throw T}e.retry=fe;class ge{hasPending(U){return this.a?typeof U=="number"?this.a.taskId===U:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(U,L,T){return this.a={taskId:U,cancel:()=>T?.(),promise:L},L.then(()=>this.d(U),()=>this.d(U)),L}d(U){this.a&&U===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const U=this.b;this.b=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this.b)this.b.run=U;else{let L,T;const B=new Promise((H,j)=>{L=H,T=j});this.b={run:U,promise:B,promiseResolve:L,promiseReject:T}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=ge;class x{constructor(U,L=()=>Date.now()){this.d=U,this.f=L,this.a=0,this.b=0}increment(){const U=this.f();return U-this.a>this.d&&(this.a=U,this.b=0),this.b++,this.b}}e.IntervalCounter=x;class F{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((U,L)=>{this.a=U,this.b=L})}complete(U){return new Promise(L=>{this.a(U),this.f=!0,L()})}error(U){return new Promise(L=>{this.b(U),this.d=!0,L()})}cancel(){new Promise(U=>{this.b(new M.CancellationError),this.d=!0,U()})}}e.DeferredPromise=F;var W;(function(Z){async function U(T){let B;const H=await Promise.all(T.map(j=>j.then($=>$,$=>{B||(B=$)})));if(typeof B<"u")throw B;return H}Z.settled=U;function L(T){return new Promise(async(B,H)=>{try{await T(B,H)}catch(j){H(j)}})}Z.withAsyncBody=L})(W=e.Promises||(e.Promises={}));var z;(function(Z){Z[Z.Initial=0]="Initial",Z[Z.DoneOK=1]="DoneOK",Z[Z.DoneError=2]="DoneError"})(z||(z={}));class J{static fromArray(U){return new J(L=>{L.emitMany(U)})}static fromPromise(U){return new J(async L=>{L.emitMany(await U)})}static fromPromises(U){return new J(async L=>{await Promise.all(U.map(async T=>L.emitOne(await T)))})}static merge(U){return new J(async L=>{await Promise.all(U.map(async T=>{for await(const B of T)L.emitOne(B)}))})}constructor(U){this.a=0,this.b=[],this.d=null,this.f=new n.Emitter,queueMicrotask(async()=>{const L={emitOne:T=>this.g(T),emitMany:T=>this.h(T),reject:T=>this.k(T)};try{await Promise.resolve(U(L)),this.j()}catch(T){this.k(T)}finally{L.emitOne=void 0,L.emitMany=void 0,L.reject=void 0}})}[Symbol.asyncIterator](){let U=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(U<this.b.length)return{done:!1,value:this.b[U++]};if(this.a===1)return{done:!0,value:void 0};await n.Event.toPromise(this.f.event)}while(!0)}}}static map(U,L){return new J(async T=>{for await(const B of U)T.emitOne(L(B))})}map(U){return J.map(this,U)}static filter(U,L){return new J(async T=>{for await(const B of U)L(B)&&T.emitOne(B)})}filter(U){return J.filter(this,U)}static coalesce(U){return J.filter(U,L=>!!L)}coalesce(){return J.coalesce(this)}static async toPromise(U){const L=[];for await(const T of U)L.push(T);return L}toPromise(){return J.toPromise(this)}g(U){this.a===0&&(this.b.push(U),this.f.fire())}h(U){this.a===0&&(this.b=this.b.concat(U),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(U){this.a===0&&(this.a=2,this.d=U,this.f.fire())}}J.EMPTY=J.fromArray([]),e.AsyncIterableObject=J;class ne extends J{constructor(U,L){super(L),this.l=U}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ne;function se(Z){const U=new E.CancellationTokenSource,L=Z(U.token);return new ne(U,async T=>{const B=U.token.onCancellationRequested(()=>{B.dispose(),U.dispose(),T.reject(new M.CancellationError)});try{for await(const H of L){if(U.token.isCancellationRequested)return;T.emitOne(H)}B.dispose(),U.dispose()}catch(H){B.dispose(),U.dispose(),T.reject(H)}})}e.createCancelableAsyncIterable=se}),define(ee[101],te([0,1,25,8,32,35,9,4,27]),function(G,e,E,M,n,C,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function d(){return Object.create(null)}e.getEmptyExpression=d,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const b="[/\\\\]",v="[^/\\\\]",y=/\//g;function g(x,F){switch(x){case 0:return"";case 1:return`${v}*?`;default:return`(?:${b}|${v}+${b}${F?`|${b}${v}+`:""})*?`}}function m(x,F){if(!x)return[];const W=[];let z=!1,J=!1,ne="";for(const se of x){switch(se){case F:if(!z&&!J){W.push(ne),ne="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":J=!0;break;case"]":J=!1;break}ne+=se}return ne&&W.push(ne),W}e.splitGlobAware=m;function w(x){if(!x)return"";let F="";const W=m(x,e.GLOB_SPLIT);if(W.every(z=>z===e.GLOBSTAR))F=".*";else{let z=!1;W.forEach((J,ne)=>{if(J===e.GLOBSTAR){if(z)return;F+=g(2,ne===W.length-1)}else{let se=!1,Z="",U=!1,L="";for(const T of J){if(T!=="}"&&se){Z+=T;continue}if(U&&(T!=="]"||!L)){let B;T==="-"?B=T:(T==="^"||T==="!")&&!L?B="^":T===e.GLOB_SPLIT?B="":B=(0,f.escapeRegExpCharacters)(T),L+=B;continue}switch(T){case"{":se=!0;continue;case"[":U=!0;continue;case"}":{F+=`(?:${m(Z,",").map(j=>w(j)).join("|")})`,se=!1,Z="";break}case"]":{F+="["+L+"]",U=!1,L="";break}case"?":F+=v;continue;case"*":F+=g(1);continue;default:F+=(0,f.escapeRegExpCharacters)(T)}}ne<W.length-1&&(W[ne+1]!==e.GLOBSTAR||ne+2<W.length)&&(F+=b)}z=J===e.GLOBSTAR})}return F}const o=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,k=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,R=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new C.LRUCache(1e4),a=function(){return!1},i=function(){return null};function s(x,F){if(!x)return i;let W;typeof x!="string"?W=x.pattern:W=x,W=W.trim();const z=`${W}_${!!F.trimForExclusions}`;let J=t.get(z);if(J)return c(J,x);let ne;return o.test(W)?J=r(W.substr(4),W):(ne=h.exec(u(W,F)))?J=l(ne[1],W):(F.trimForExclusions?k:p).test(W)?J=I(W,F):(ne=S.exec(u(W,F)))?J=A(ne[1].substr(1),W,!0):(ne=R.exec(u(W,F)))?J=A(ne[1],W,!1):J=O(W),t.set(z,J),c(J,x)}function c(x,F){if(typeof F=="string")return x;const W=function(z,J){return(0,n.isEqualOrParent)(z,F.base,!P.isLinux)?x((0,f.ltrim)(z.substr(F.base.length),D.sep),J):null};return W.allBasenames=x.allBasenames,W.allPaths=x.allPaths,W.basenames=x.basenames,W.patterns=x.patterns,W}function u(x,F){return F.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function r(x,F){return function(W,z){return typeof W=="string"&&W.endsWith(x)?F:null}}function l(x,F){const W=`/${x}`,z=`\\${x}`,J=function(se,Z){return typeof se!="string"?null:Z?Z===x?F:null:se===x||se.endsWith(W)||se.endsWith(z)?F:null},ne=[x];return J.basenames=ne,J.patterns=[F],J.allBasenames=ne,J}function I(x,F){const W=fe(x.slice(1,-1).split(",").map(Z=>s(Z,F)).filter(Z=>Z!==i),x),z=W.length;if(!z)return i;if(z===1)return W[0];const J=function(Z,U){for(let L=0,T=W.length;L<T;L++)if(W[L](Z,U))return x;return null},ne=W.find(Z=>!!Z.allBasenames);ne&&(J.allBasenames=ne.allBasenames);const se=W.reduce((Z,U)=>U.allPaths?Z.concat(U.allPaths):Z,[]);return se.length&&(J.allPaths=se),J}function A(x,F,W){const z=D.sep===D.posix.sep,J=z?x:x.replace(y,D.sep),ne=D.sep+J,se=D.posix.sep+x;let Z;return W?Z=function(U,L){return typeof U=="string"&&(U===J||U.endsWith(ne)||!z&&(U===x||U.endsWith(se)))?F:null}:Z=function(U,L){return typeof U=="string"&&(U===J||!z&&U===x)?F:null},Z.allPaths=[(W?"*/":"./")+x],Z}function O(x){try{const F=new RegExp(`^${w(x)}$`);return function(W){return F.lastIndex=0,typeof W=="string"&&F.test(W)?x:null}}catch{return i}}function N(x,F,W){return!x||typeof F!="string"?!1:X(x)(F,void 0,W)}e.match=N;function X(x,F={}){if(!x)return a;if(typeof x=="string"||V(x)){const W=s(x,F);if(W===i)return a;const z=function(J,ne){return!!W(J,ne)};return W.allBasenames&&(z.allBasenames=W.allBasenames),W.allPaths&&(z.allPaths=W.allPaths),z}return re(x,F)}e.parse=X;function V(x){const F=x;return F?typeof F.base=="string"&&typeof F.pattern=="string":!1}e.isRelativePattern=V;function K(x){return x.allBasenames||[]}e.getBasenameTerms=K;function ie(x){return x.allPaths||[]}e.getPathTerms=ie;function re(x,F){const W=fe(Object.getOwnPropertyNames(x).map(Z=>ce(Z,x[Z],F)).filter(Z=>Z!==i)),z=W.length;if(!z)return i;if(!W.some(Z=>!!Z.requiresSiblings)){if(z===1)return W[0];const Z=function(T,B){let H;for(let j=0,$=W.length;j<$;j++){const q=W[j](T,B);if(typeof q=="string")return q;(0,M.isThenable)(q)&&(H||(H=[]),H.push(q))}return H?(async()=>{for(const j of H){const $=await j;if(typeof $=="string")return $}return null})():null},U=W.find(T=>!!T.allBasenames);U&&(Z.allBasenames=U.allBasenames);const L=W.reduce((T,B)=>B.allPaths?T.concat(B.allPaths):T,[]);return L.length&&(Z.allPaths=L),Z}const J=function(Z,U,L){let T,B;for(let H=0,j=W.length;H<j;H++){const $=W[H];$.requiresSiblings&&L&&(U||(U=(0,D.basename)(Z)),T||(T=U.substr(0,U.length-(0,D.extname)(Z).length)));const q=$(Z,U,T,L);if(typeof q=="string")return q;(0,M.isThenable)(q)&&(B||(B=[]),B.push(q))}return B?(async()=>{for(const H of B){const j=await H;if(typeof j=="string")return j}return null})():null},ne=W.find(Z=>!!Z.allBasenames);ne&&(J.allBasenames=ne.allBasenames);const se=W.reduce((Z,U)=>U.allPaths?Z.concat(U.allPaths):Z,[]);return se.length&&(J.allPaths=se),J}function ce(x,F,W){if(F===!1)return i;const z=s(x,W);if(z===i)return i;if(typeof F=="boolean")return z;if(F){const J=F.when;if(typeof J=="string"){const ne=(se,Z,U,L)=>{if(!L||!z(se,Z))return null;const T=J.replace("$(basename)",()=>U),B=L(T);return(0,M.isThenable)(B)?B.then(H=>H?x:null):B?x:null};return ne.requiresSiblings=!0,ne}}return z}function fe(x,F){const W=x.filter(Z=>!!Z.basenames);if(W.length<2)return x;const z=W.reduce((Z,U)=>{const L=U.basenames;return L?Z.concat(L):Z},[]);let J;if(F){J=[];for(let Z=0,U=z.length;Z<U;Z++)J.push(F)}else J=W.reduce((Z,U)=>{const L=U.patterns;return L?Z.concat(L):Z},[]);const ne=function(Z,U){if(typeof Z!="string")return null;if(!U){let T;for(T=Z.length;T>0;T--){const B=Z.charCodeAt(T-1);if(B===47||B===92)break}U=Z.substr(T)}const L=z.indexOf(U);return L!==-1?J[L]:null};ne.basenames=z,ne.patterns=J,ne.allBasenames=z;const se=x.filter(Z=>!Z.basenames);return se.push(ne),se}function ge(x,F){return(0,E.equals)(x,F,(W,z)=>typeof W=="string"&&typeof z=="string"?W===z:typeof W!="string"&&typeof z!="string"?W.base===z.base&&W.pattern===z.pattern:!1)}e.patternsEquals=ge}),define(ee[45],te([0,1,25,32,9,4,18,27]),function(G,e,E,M,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function f(i,s){const{os:c,tildify:u,relative:r}=s;if(r){const A=d(i,r,c);if(typeof A=="string")return A}let l=i.fsPath;if(c===1&&!C.isWindows?l=l.replace(/\//g,"\\"):c!==1&&C.isWindows&&(l=l.replace(/\\/g,"/")),c!==1&&u?.userHome){const A=u.userHome.fsPath;let O;i.scheme!==u.userHome.scheme&&i.path.startsWith(n.posix.sep)?O=u.userHome.with({path:i.path}).fsPath:O=i.fsPath,l=y(O,A,c)}return(c===1?n.win32:n.posix).normalize(b(l,c===1))}e.getPathLabel=f;function d(i,s,c){const u=c===1?n.win32:n.posix,r=c===3?D.extUri:D.extUriIgnorePathCase,l=s.getWorkspace(),I=(0,E.firstOrDefault)(l.folders);if(!I)return;i.scheme!==I.uri.scheme&&i.path.startsWith(n.posix.sep)&&(i=I.uri.with({path:i.path}));const A=s.getWorkspaceFolder(i);if(!A)return;let O;if(r.isEqual(A.uri,i)?O="":O=r.relativePath(A.uri,i)??"",O&&(O=u.normalize(O)),l.folders.length>1&&!s.noPrefix){const N=A.name?A.name:r.basenameOrAuthority(A.uri);O=O?`${N} \u2022 ${O}`:N}return O}function b(i,s=C.isWindows){return(0,M.hasDriveLetter)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=b;let v=Object.create(null);function y(i,s,c=C.OS){if(c===1||!i||!s)return i;let u=v.original===s?v.normalized:void 0;u||(u=s,C.isWindows&&(u=(0,M.toSlashes)(u)),u=`${(0,P.rtrim)(u,n.posix.sep)}${n.posix.sep}`,v={original:s,normalized:u});let r=i;return C.isWindows&&(r=(0,M.toSlashes)(r)),(c===3?r.startsWith(u):(0,P.startsWithIgnoreCase)(r,u))?`~/${r.substr(u.length)}`:i}e.tildify=y;function g(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=g;const m="\u2026",w="\\\\",o="~";function h(i,s=n.sep){const c=new Array(i.length);let u=!1;for(let r=0;r<i.length;r++){const l=i[r];if(l===""){c[r]=`.${s}`;continue}if(!l){c[r]=l;continue}u=!0;let I="",A=l;A.indexOf(w)===0?(I=A.substr(0,A.indexOf(w)+w.length),A=A.substr(A.indexOf(w)+w.length)):A.indexOf(s)===0?(I=A.substr(0,A.indexOf(s)+s.length),A=A.substr(A.indexOf(s)+s.length)):A.indexOf(o)===0&&(I=A.substr(0,A.indexOf(o)+o.length),A=A.substr(A.indexOf(o)+o.length));const O=A.split(s);for(let N=1;u&&N<=O.length;N++)for(let X=O.length-N;u&&X>=0;X--){u=!1;let V=O.slice(X,X+N).join(s);for(let K=0;!u&&K<i.length;K++)if(K!==r&&i[K]&&i[K].indexOf(V)>-1){const ie=X+N===O.length,re=X>0&&i[K].indexOf(s)>-1?s+V:V,ce=i[K].endsWith(re);u=!ie||ce}if(!u){let K="";(O[0].endsWith(":")||I!=="")&&(X===1&&(X=0,N++,V=O[0]+s+V),X>0&&(K=O[0]+s),K=I+K),X>0&&(K=K+m+s),K=K+V,X+N<O.length&&(K=K+s+m),c[r]=K}}u&&(c[r]=l)}return c}e.shorten=h;var p;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function k(i,s=Object.create(null)){const c=[];let u=!1,r="";for(const l of i)if(l==="$"||u&&l==="{")r&&c.push({value:r,type:p.TEXT}),r="",u=!0;else if(l==="}"&&u){const I=s[r];if(typeof I=="string")I.length&&c.push({value:I,type:p.VARIABLE});else if(I){const A=c[c.length-1];(!A||A.type!==p.SEPARATOR)&&c.push({value:I.label,type:p.SEPARATOR})}r="",u=!1}else r+=l;return r&&!u&&c.push({value:r,type:p.TEXT}),c.filter((l,I)=>{if(l.type===p.SEPARATOR){const A=c[I-1],O=c[I+1];return[A,O].every(N=>N&&(N.type===p.VARIABLE||N.type===p.TEXT)&&N.value.length>0)}return!0}).map(l=>l.value).join("")}e.template=k;function S(i,s){return C.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):i.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=S;function R(i,s){return C.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,""):C.isWindows?i.replace(/&&|&/g,c=>c==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=R;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function a(i){const s=i.indexOf("/")!==-1?n.posix:n.win32,c=s.basename(i),u=s.dirname(i);return c.length?{name:c,parentPath:u}:{name:u,parentPath:""}}e.splitName=a}),define(ee[145],te([0,1,17,7]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(v){return v.toJSON()}class C{constructor(y){this.a=y}transformIncoming(y){const g=this.a.transformIncoming(y);return g===y?y:n(M.URI.from(g))}transformOutgoing(y){const g=this.a.transformOutgoing(y);return g===y?y:n(M.URI.from(g))}transformOutgoingURI(y){const g=this.a.transformOutgoing(y);return g===y?y:M.URI.from(g)}transformOutgoingScheme(y){return this.a.transformOutgoingScheme(y)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function D(v,y,g){if(!v||g>200)return null;if(typeof v=="object"){if(v instanceof M.URI)return y.transformOutgoing(v);for(const m in v)if(Object.hasOwnProperty.call(v,m)){const w=D(v[m],y,g+1);w!==null&&(v[m]=w)}}return null}function P(v,y){const g=D(v,y,0);return g===null?v:g}e.transformOutgoingURIs=P;function f(v,y,g,m){if(!v||m>200)return null;if(typeof v=="object"){if(v.$mid===1)return g?M.URI.revive(y.transformIncoming(v)):y.transformIncoming(v);if(v instanceof E.VSBuffer)return null;for(const w in v)if(Object.hasOwnProperty.call(v,w)){const o=f(v[w],y,g,m+1);o!==null&&(v[w]=o)}}return null}function d(v,y){const g=f(v,y,!1,0);return g===null?v:g}e.transformIncomingURIs=d;function b(v,y){const g=f(v,y,!0,0);return g===null?v:g}e.transformAndReviveIncomingURIs=b}),define(ee[85],te([0,1,26,13,61,31,133]),function(G,e,E,M,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(b){return this.a||(this.a=n.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,v=0;const y=(0,E.networkInterfaces)();for(const g in y){const m=y[g];if(m)for(const{mac:w,internal:o}of m)o||(v+=1,this.c(w.toUpperCase())&&(b+=1))}this.b=v>0?b/v:0}return this.b}};let P;async function f(){return P||(P=(async()=>await d()||C.generateUuid())()),P}e.getMachineId=f;async function d(){try{const b=await new Promise((y,g)=>{G(["crypto"],y,g)}),v=(0,D.getMac)();return b.createHash("sha256").update(v,"utf8").digest("hex")}catch(b){M.onUnexpectedError(b);return}}}),define(ee[23],te([0,1,41,26,146,8,32,80,9,4,18,7]),function(G,e,E,M,n,C,D,P,f,d,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(re){re[re.UNLINK=0]="UNLINK",re[re.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function g(re,ce=y.UNLINK){if((0,D.isRootOrDriveLetter)(re))throw new Error("rimraf - will refuse to recursively delete root");return ce===y.UNLINK?w(re):m(re)}async function m(re){try{const ce=(0,D.randomPath)((0,M.tmpdir)());try{await E.promises.rename(re,ce)}catch(fe){return fe.code==="ENOENT"?void 0:w(re)}w(ce).catch(fe=>{})}catch(ce){if(ce.code!=="ENOENT")throw ce}}async function w(re){return(0,n.promisify)(E.rm)(re,{recursive:!0,force:!0,maxRetries:3})}function o(re){if((0,D.isRootOrDriveLetter)(re))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(re,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=o;async function h(re,ce){return S(await(ce?p(re):(0,n.promisify)(E.readdir)(re)))}async function p(re){try{return await(0,n.promisify)(E.readdir)(re,{withFileTypes:!0})}catch(ge){console.warn("[node.js fs] readdir with filetypes failed with error: ",ge)}const ce=[],fe=await h(re);for(const ge of fe){let x=!1,F=!1,W=!1;try{const z=await e.Promises.lstat((0,f.join)(re,ge));x=z.isFile(),F=z.isDirectory(),W=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}ce.push({name:ge,isFile:()=>x,isDirectory:()=>F,isSymbolicLink:()=>W})}return ce}function k(re){return S(E.readdirSync(re))}e.readdirSync=k;function S(re){return re.map(ce=>typeof ce=="string"?d.isMacintosh?(0,P.normalizeNFC)(ce):ce:(ce.name=d.isMacintosh?(0,P.normalizeNFC)(ce.name):ce.name,ce))}async function R(re){const ce=await h(re),fe=[];for(const ge of ce)await a.existsDirectory((0,f.join)(re,ge))&&fe.push(ge);return fe}function t(re,ce=1e3){return new Promise(fe=>{let ge=!1;const x=setInterval(()=>{ge||(ge=!0,E.access(re,F=>{ge=!1,F&&(clearInterval(x),fe(void 0))}))},ce)})}e.whenDeleted=t;var a;(function(re){async function ce(x){let F;try{if(F=await e.Promises.lstat(x),!F.isSymbolicLink())return{stat:F}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(d.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw z}throw W}}re.stat=ce;async function fe(x){try{const{stat:F,symbolicLink:W}=await re.stat(x);return F.isFile()&&W?.dangling!==!0}catch{}return!1}re.existsFile=fe;async function ge(x){try{const{stat:F,symbolicLink:W}=await re.stat(x);return F.isDirectory()&&W?.dangling!==!0}catch{}return!1}re.existsDirectory=ge})(a=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new C.ResourceQueue;function s(re,ce,fe){return i.queueFor(v.URI.file(re),b.extUriBiasedIgnorePathCase).queue(()=>{const ge=I(fe);return new Promise((x,F)=>r(re,ce,ge,W=>W?F(W):x()))})}let c=!0;function u(re){c=re}e.configureFlushOnWrite=u;function r(re,ce,fe,ge){if(!c)return E.writeFile(re,ce,{mode:fe.mode,flag:fe.flag},ge);E.open(re,fe.flag,fe.mode,(x,F)=>{if(x)return ge(x);E.writeFile(F,ce,W=>{if(W)return E.close(F,()=>ge(W));E.fdatasync(F,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),u(!1)),E.close(F,J=>ge(J))))})})}function l(re,ce,fe){const ge=I(fe);if(!c)return E.writeFileSync(re,ce,{mode:ge.mode,flag:ge.flag});const x=E.openSync(re,ge.flag,ge.mode);try{E.writeFileSync(x,ce);try{E.fdatasyncSync(x)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),u(!1)}}finally{E.closeSync(x)}}e.writeFileSync=l;function I(re){return re?{mode:typeof re.mode=="number"?re.mode:438,flag:typeof re.flag=="string"?re.flag:"w"}:{mode:438,flag:"w"}}async function A(re,ce){if(re!==ce)try{await e.Promises.rename(re,ce)}catch(fe){if(re.toLowerCase()!==ce.toLowerCase()&&fe.code==="EXDEV"||re.endsWith("."))await O(re,ce,{preserveSymlinks:!1}),await g(re,y.MOVE);else throw fe}}async function O(re,ce,fe){return X(re,ce,{root:{source:re,target:ce},options:fe,handledSourcePaths:new Set})}const N=511;async function X(re,ce,fe){if(fe.handledSourcePaths.has(re))return;fe.handledSourcePaths.add(re);const{stat:ge,symbolicLink:x}=await a.stat(re);if(x){if(fe.options.preserveSymlinks)try{return await ie(re,ce,fe)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(x.dangling)return}return ge.isDirectory()?V(re,ce,ge.mode&N,fe):K(re,ce,ge.mode&N)}async function V(re,ce,fe,ge){await e.Promises.mkdir(ce,{recursive:!0,mode:fe});const x=await h(re);for(const F of x)await X((0,f.join)(re,F),(0,f.join)(ce,F),ge)}async function K(re,ce,fe){await e.Promises.copyFile(re,ce),await e.Promises.chmod(ce,fe)}async function ie(re,ce,fe){let ge=await e.Promises.readlink(re);(0,D.isEqualOrParent)(ge,fe.root.source,!d.isLinux)&&(ge=(0,f.join)(fe.root.target,ge.substr(fe.root.source.length+1))),await e.Promises.symlink(ge,ce)}e.Promises=new class{get access(){return(0,n.promisify)(E.access)}get stat(){return(0,n.promisify)(E.stat)}get lstat(){return(0,n.promisify)(E.lstat)}get utimes(){return(0,n.promisify)(E.utimes)}get read(){return(re,ce,fe,ge,x)=>new Promise((F,W)=>{E.read(re,ce,fe,ge,x,(z,J,ne)=>z?W(z):F({bytesRead:J,buffer:ne}))})}get readFile(){return(0,n.promisify)(E.readFile)}get write(){return(re,ce,fe,ge,x)=>new Promise((F,W)=>{E.write(re,ce,fe,ge,x,(z,J,ne)=>z?W(z):F({bytesWritten:J,buffer:ne}))})}get appendFile(){return(0,n.promisify)(E.appendFile)}get fdatasync(){return(0,n.promisify)(E.fdatasync)}get truncate(){return(0,n.promisify)(E.truncate)}get rename(){return(0,n.promisify)(E.rename)}get copyFile(){return(0,n.promisify)(E.copyFile)}get open(){return(0,n.promisify)(E.open)}get close(){return(0,n.promisify)(E.close)}get symlink(){return(0,n.promisify)(E.symlink)}get readlink(){return(0,n.promisify)(E.readlink)}get chmod(){return(0,n.promisify)(E.chmod)}get mkdir(){return(0,n.promisify)(E.mkdir)}get unlink(){return(0,n.promisify)(E.unlink)}get rmdir(){return(0,n.promisify)(E.rmdir)}get realpath(){return(0,n.promisify)(E.realpath)}async exists(re){try{return await e.Promises.access(re),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return R}get writeFile(){return s}get rm(){return g}get move(){return A}get copy(){return O}}}),define(ee[102],te([0,1,41,9,4,27,23]),function(G,e,E,M,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(y){if(n.isLinux)return y;const g=(0,M.dirname)(y);if(y===g)return y;const m=((0,M.basename)(y)||y).toLowerCase();try{const o=(0,D.readdirSync)(g).filter(h=>h.toLowerCase()===m);if(o.length===1){const h=P(g);if(h)return(0,M.join)(h,o[0])}else if(o.length>1){const h=o.indexOf(m);if(h>=0){const p=P(g);if(p)return(0,M.join)(p,o[h])}}}catch{}return null}e.realcaseSync=P;async function f(y){if(n.isLinux)return y;const g=(0,M.dirname)(y);if(y===g)return y;const m=((0,M.basename)(y)||y).toLowerCase();try{const o=(await D.Promises.readdir(g)).filter(h=>h.toLowerCase()===m);if(o.length===1){const h=await f(g);if(h)return(0,M.join)(h,o[0])}else if(o.length>1){const h=o.indexOf(m);if(h>=0){const p=await f(g);if(p)return(0,M.join)(p,o[h])}}}catch{}return null}e.realcase=f;async function d(y){try{return await D.Promises.realpath(y)}catch{const m=v(y);return await D.Promises.access(m,E.constants.R_OK),m}}e.realpath=d;function b(y){try{return E.realpathSync(y)}catch{const m=v(y);return E.accessSync(m,E.constants.R_OK),m}}e.realpathSync=b;function v(y){return(0,C.rtrim)((0,M.normalize)(y),M.sep)}}),define(ee[147],te([0,1,26,9,23]),function(G,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,D=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var f;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(f||(f={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class v{constructor(R,t,a){this.exePath=R,this.displayName=t,this.a=a}async exists(){return this.a===void 0&&(this.a=await n.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:S=!1}={}){return S?d===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:S=!1,findPreview:R=!1}={}){const t=y({useAlternateBitness:S});if(!t)return null;const a=M.join(t,"PowerShell");if(!await n.SymlinkSupport.existsDirectory(a))return null;let i=-1,s=null;for(const r of await n.Promises.readdir(a)){let l=-1;if(R){const A=r.indexOf("-");if(A<0)continue;const O=r.substring(0,A);if(!C.test(O)||r.substring(A+1)!=="preview")continue;l=parseInt(O,10)}else{if(!C.test(r))continue;l=parseInt(r,10)}if(l<=i)continue;const I=M.join(a,r,"pwsh.exe");!await n.SymlinkSupport.existsFile(I)||(s=I,i=l)}if(!s)return null;const c=t.includes("x86")?" (x86)":"",u=R?" Preview":"";return new v(s,`PowerShell${u}${c}`,!0)}async function m({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const R=M.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await n.SymlinkSupport.existsDirectory(R))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=S?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const i of await n.Promises.readdir(R))if(t.test(i)){const s=M.join(R,i,"pwsh.exe");return new v(s,a)}return null}function w(){const S=M.join(E.homedir(),".dotnet","tools","pwsh.exe");return new v(S,".NET Core PowerShell Global Tool")}function o(){const S=M.join(process.env.windir,d===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(S,"Windows PowerShell",!0)}async function*h(){let S=await g();S&&(yield S),S=await g({useAlternateBitness:!0}),S&&(yield S),S=await m(),S&&(yield S),S=w(),S&&(yield S),S=await g({findPreview:!0}),S&&(yield S),S=await m({findPreview:!0}),S&&(yield S),S=await g({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=o(),S&&(yield S)}async function*p(){for await(const S of h())await S.exists()&&(yield S)}e.enumeratePowerShellInstallations=p;async function k(){for await(const S of p())return S;return null}e.getFirstAvailablePowerShellInstallation=k}),define(ee[86],te([0,1,9,4,36,83,10,23]),function(G,e,E,M,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function f(v=n.env){return v.comspec||"cmd.exe"}e.getWindowsShell=f;function d(v){let y=[],g=!1;const m=function(w){if(g){y.push(w);return}(!v.send(w,h=>{if(h&&console.error(h),g=!1,y.length>0){const p=y.slice(0);y=[],p.forEach(k=>m(k))}})||M.isWindows)&&(g=!0)};return{send:m}}e.createQueuedSender=d;var b;(function(v){async function y(g,m,w){if(E.isAbsolute(g))return g;if(m===void 0&&(m=n.cwd()),E.dirname(g)!=="."||(w===void 0&&D.isString(n.env.PATH)&&(w=n.env.PATH.split(E.delimiter)),w===void 0||w.length===0))return E.join(m,g);async function h(p){if(await P.Promises.exists(p)){let k;try{k=await P.Promises.stat(p)}catch(S){S.message.startsWith("EACCES")&&(k=await P.Promises.lstat(p))}return k?!k.isDirectory():!1}return!1}for(const p of w){let k;if(E.isAbsolute(p)?k=E.join(p,g):k=E.join(m,p,g),await h(k))return k;let S=k+".com";if(await h(S)||(S=k+".exe",await h(S)))return S}return E.join(m,g)}v.findExecutable=y})(b=e.win32||(e.win32={}))}),define(ee[103],te([0,1,46,15]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function n(D){return new Promise((P,f)=>{let d;const b=new Map;function v(g,m,w,o,h){const p=b.get(m);if(g===D||p){const k={name:y(w),cmd:w,pid:g,ppid:m,load:o,mem:h};b.set(g,k),g===D&&(d=k),p&&(p.children||(p.children=[]),p.children.push(k),p.children.length>1&&(p.children=p.children.sort((S,R)=>S.pid-R.pid)))}}function y(g){const m=/--vscode-window-kind=shared-process/,w=/--vscode-window-kind=issue-reporter/,o=/--vscode-window-kind=process-explorer/,h=/--utility-sub-type=network/,p=/--utility-sub-type=node.mojom.NodeService/,k=/--crashes-directory/,S=/\\pipe\\winpty-control/,R=/conhost\.exe/,t=/--type=([a-zA-Z-]+)/;if(k.exec(g))return"electron-crash-reporter";if(S.exec(g))return"winpty-process";if(R.exec(g))return"console-window-host (Windows internal process)";let a=t.exec(g);if(a&&a.length===2){if(a[1]==="renderer")return m.exec(g)?"shared-process":w.exec(g)?"issue-reporter":o.exec(g)?"process-explorer":"window";if(a[1]==="utility"){if(h.exec(g))return"utility-network-service";if(p.exec(g))return"extension-host"}else if(a[1]==="extensionHost")return"extension-host";return a[1]}const i=/[a-zA-Z-]+\.js/g;let s="";do a=i.exec(g),a&&(s+=a+" ");while(a);return s&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron_node ${s}`:g}if(process.platform==="win32"){const g=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substr(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substr(5):m;new Promise((m,w)=>{G(["windows-process-tree"],m,w)}).then(m=>{m.getProcessList(D,w=>{if(!w){f(new Error(`Root process ${D} not found`));return}m.getProcessCpuUsage(w,o=>{const h=new Map;o.forEach(p=>{const k=g(p.commandLine||"");h.set(p.pid,{name:y(k),cmd:k,pid:p.pid,ppid:p.ppid,load:p.cpu||0,mem:p.memory||0})}),d=h.get(D),d?(h.forEach(p=>{const k=h.get(p.ppid);k&&(k.children||(k.children=[]),k.children.push(p))}),h.forEach(p=>{p.children&&(p.children=p.children.sort((k,S)=>k.pid-S.pid))}),P(d)):f(new Error(`Root process ${D} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let g=function(){let m=[d];const w=[];for(;m.length;){const h=m.shift();h&&(w.push(h.pid),h.children&&(m=m.concat(h.children)))}let o=JSON.stringify(M.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);o+=" "+w.join(" "),(0,E.exec)(o,{},(h,p,k)=>{if(h||k)f(h||new Error(k.toString()));else{const S=p.toString().split(`
`);for(let R=0;R<w.length;R++){const t=b.get(w[R]);t.load=parseFloat(S[R])}if(!d){f(new Error(`Root process ${D} not found`));return}P(d)}})};(0,E.exec)("which ps",{},(m,w,o)=>{if(m||o)if(process.platform!=="linux")f(m||new Error(o.toString()));else{const h=JSON.stringify(M.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,E.exec)(h,{},(p,k,S)=>{p||S?f(p||new Error(S.toString())):(C(k,v),g())})}else{const h=w.toString().trim(),p="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${h} ${p}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(k,S,R)=>{k||R&&!R.includes("screen size is bogus")?f(k||new Error(R.toString())):(C(S,v),process.platform==="linux"?g():d?P(d):f(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=n;function C(D,P){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,d=D.toString().split(`
`);for(const b of d){const v=f.exec(b.trim());v&&v.length===6&&P(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}}),define(ee[148],te([0,1,26,4,147,86]),function(G,e,E,M,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function D(v,y){return v===1?M.isWindows?b():C.getWindowsShell(y):f(v,y)}e.getSystemShell=D;let P=null;function f(v,y){if(M.isLinux&&v===2||M.isMacintosh&&v===3)return"/bin/bash";if(!P){let g;if(M.isWindows)g="/bin/bash";else{if(g=y.SHELL,!g)try{g=(0,E.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}P=g}return P}let d=null;async function b(){return d||(d=(await(0,n.getFirstAvailablePowerShellInstallation)()).exePath),d}});var ve=this&&this.__decorate||function(G,e,E,M){var n=arguments.length,C=n<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,E):M,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(G,e,E,M);else for(var P=G.length-1;P>=0;P--)(D=G[P])&&(C=(n<3?D(C):n>3?D(e,E,C):D(e,E))||C);return n>3&&C&&Object.defineProperty(e,E,C),C};define(ee[47],te([0,1,25,8,17,22,55,13,3,2,73,27,10]),function(G,e,E,M,n,C,D,P,f,d,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var g;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(g||(g={}));function m(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(w||(w={}));function o(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(h||(h={}));function p(F){let W=0;for(let z=0;;z+=7){const J=F.read(1);if(W|=(J.buffer[0]&127)<<z,!(J.buffer[0]&128))return W}}const k=i(0);function S(F,W){if(W===0){F.write(k);return}let z=0;for(let ne=W;ne!==0;ne=ne>>>7)z++;const J=n.VSBuffer.alloc(z);for(let ne=0;W!==0;ne++)J.buffer[ne]=W&127,W=W>>>7,W>0&&(J.buffer[ne]|=128);F.write(J)}class R{constructor(W){this.b=W,this.a=0}read(W){const z=this.b.slice(this.a,this.a+W);return this.a+=z.byteLength,z}}e.BufferReader=R;class t{constructor(){this.a=[]}get buffer(){return n.VSBuffer.concat(this.a)}write(W){this.a.push(W)}}e.BufferWriter=t;var a;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object",F[F.Int=6]="Int"})(a||(a={}));function i(F){const W=n.VSBuffer.alloc(1);return W.writeUInt8(F,0),W}const s={Undefined:i(a.Undefined),String:i(a.String),Buffer:i(a.Buffer),VSBuffer:i(a.VSBuffer),Array:i(a.Array),Object:i(a.Object),Uint:i(a.Int)},c=typeof Buffer<"u";function u(F,W){if(typeof W>"u")F.write(s.Undefined);else if(typeof W=="string"){const z=n.VSBuffer.fromString(W);F.write(s.String),S(F,z.byteLength),F.write(z)}else if(c&&Buffer.isBuffer(W)){const z=n.VSBuffer.wrap(W);F.write(s.Buffer),S(F,z.byteLength),F.write(z)}else if(W instanceof n.VSBuffer)F.write(s.VSBuffer),S(F,W.byteLength),F.write(W);else if(Array.isArray(W)){F.write(s.Array),S(F,W.length);for(const z of W)u(F,z)}else if(typeof W=="number"&&(W|0)===W)F.write(s.Uint),S(F,W);else{const z=n.VSBuffer.fromString(JSON.stringify(W));F.write(s.Object),S(F,z.byteLength),F.write(z)}}e.serialize=u;function r(F){switch(F.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return F.read(p(F)).toString();case a.Buffer:return F.read(p(F)).buffer;case a.VSBuffer:return F.read(p(F));case a.Array:{const z=p(F),J=[];for(let ne=0;ne<z;ne++)J.push(r(F));return J}case a.Object:return JSON.parse(F.read(p(F)).toString());case a.Int:return p(F)}}e.deserialize=r;class l{constructor(W,z,J=null,ne=1e3){this.h=W,this.j=z,this.k=J,this.l=ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(se=>this.q(se)),this.m({type:200})}registerChannel(W,z){this.b.set(W,z),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case 200:{const z=this.o([W.type]);this.k?.logOutgoing(z,0,1,o(W.type));return}case 201:case 202:case 204:case 203:{const z=this.o([W.type,W.id],W.data);this.k?.logOutgoing(z,W.id,1,o(W.type),W.data);return}}}o(W,z=void 0){const J=new t;return u(J,W),u(J,z),this.p(J.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const z=new R(W),J=r(z),ne=r(z),se=J[0];switch(se){case 100:return this.k?.logIncoming(W.byteLength,J[1],1,`${m(se)}: ${J[2]}.${J[3]}`,ne),this.s({type:se,id:J[1],channelName:J[2],name:J[3],arg:ne});case 102:return this.k?.logIncoming(W.byteLength,J[1],1,`${m(se)}: ${J[2]}.${J[3]}`,ne),this.t({type:se,id:J[1],channelName:J[2],name:J[3],arg:ne});case 101:return this.k?.logIncoming(W.byteLength,J[1],1,`${m(se)}`),this.u({type:se,id:J[1]});case 103:return this.k?.logIncoming(W.byteLength,J[1],1,`${m(se)}`),this.u({type:se,id:J[1]})}}s(W){const z=this.b.get(W.channelName);if(!z){this.v(W);return}const J=new C.CancellationTokenSource;let ne;try{ne=z.call(this.j,W.name,W.arg,J.token)}catch(U){ne=Promise.reject(U)}const se=W.id;ne.then(U=>{this.m({id:se,data:U,type:201}),this.d.delete(W.id)},U=>{U instanceof Error?this.m({id:se,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.m({id:se,data:U,type:203}),this.d.delete(W.id)});const Z=(0,d.toDisposable)(()=>J.cancel());this.d.set(W.id,Z)}t(W){const z=this.b.get(W.channelName);if(!z){this.v(W);return}const J=W.id,se=z.listen(this.j,W.name,W.arg)(Z=>this.m({id:J,data:Z,type:204}));this.d.set(W.id,se)}u(W){const z=this.d.get(W.id);z&&(z.dispose(),this.d.delete(W.id))}v(W){let z=this.g.get(W.channelName);z||(z=[],this.g.set(W.channelName,z));const J=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);z.push({request:W,timeoutTimer:J})}w(W){const z=this.g.get(W);if(z){for(const J of z)switch(clearTimeout(J.timeoutTimer),J.request.type){case 100:this.s(J.request);break;case 102:this.t(J.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,d.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=l;var I;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(I=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(W,z=null){this.l=W,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(J=>this.s(J)),this.j=z}getChannel(W){const z=this;return{call(J,ne,se){return z.a?Promise.reject(new P.CancellationError):z.m(W,J,ne,se)},listen(J,ne){return z.a?f.Event.None:z.o(W,J,ne)}}}m(W,z,J,ne=C.CancellationToken.None){const se=this.g++,U={id:se,type:100,channelName:W,name:z,arg:J};if(ne.isCancellationRequested)return Promise.reject(new P.CancellationError);let L;return new Promise((B,H)=>{if(ne.isCancellationRequested)return H(new P.CancellationError);const j=()=>{const de=pe=>{switch(pe.type){case 201:this.f.delete(se),B(pe.data);break;case 202:{this.f.delete(se);const ye=new Error(pe.data.message);ye.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,ye.name=pe.data.name,H(ye);break}case 203:this.f.delete(se),H(pe.data);break}};this.f.set(se,de),this.p(U)};let $=null;this.b===h.Idle?j():($=(0,M.createCancelablePromise)(de=>this.u()),$.then(()=>{$=null,j()}));const q=()=>{$?($.cancel(),$=null):this.p({id:se,type:101}),H(new P.CancellationError)},oe=ne.onCancellationRequested(q);L=(0,d.combinedDisposable)((0,d.toDisposable)(q),oe),this.d.add(L)}).finally(()=>{this.d.delete(L)})}o(W,z,J){const ne=this.g++,Z={id:ne,type:102,channelName:W,name:z,arg:J};let U=null;const L=new f.Emitter({onWillAddFirstListener:()=>{U=(0,M.createCancelablePromise)(B=>this.u()),U.then(()=>{U=null,this.d.add(L),this.p(Z)})},onDidRemoveLastListener:()=>{U?(U.cancel(),U=null):(this.d.delete(L),this.p({id:ne,type:103}))}}),T=B=>L.fire(B.data);return this.f.set(ne,T),L.event}p(W){switch(W.type){case 100:case 102:{const z=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(z,W.id,0,`${m(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const z=this.q([W.type,W.id]);this.j?.logOutgoing(z,W.id,0,m(W.type));return}}}q(W,z=void 0){const J=new t;return u(J,W),u(J,z),this.r(J.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const z=new R(W),J=r(z),ne=r(z),se=J[0];switch(se){case 200:return this.j?.logIncoming(W.byteLength,0,0,o(se)),this.t({type:J[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(W.byteLength,J[1],0,o(se),ne),this.t({type:J[0],id:J[1],data:ne})}}t(W){if(W.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,d.dispose)(this.d.values()),this.d.clear()}}ve([D.memoize],A.prototype,"onDidInitializePromise",null),e.ChannelClient=A;class O{get connections(){const W=[];return this.f.forEach(z=>W.push(z)),W}constructor(W){this.a=new Map,this.f=new Set,this.g=new f.Emitter,this.onDidAddConnection=this.g.event,this.h=new f.Emitter,this.onDidRemoveConnection=this.h.event,W(({protocol:z,onDidClientDisconnect:J})=>{f.Event.once(z.onMessage)(se=>{const Z=new R(se),U=r(Z),L=new l(z,U),T=new A(z);this.a.forEach((H,j)=>L.registerChannel(j,H));const B={channelServer:L,channelClient:T,ctx:U};this.f.add(B),this.g.fire(B),J(()=>{L.dispose(),T.dispose(),this.f.delete(B),this.h.fire(B)})})})}getChannel(W,z){const J=this;return{call(ne,se,Z){let U;if((0,y.isFunction)(z)){const T=(0,E.getRandomElement)(J.connections.filter(z));U=T?Promise.resolve(T):f.Event.toPromise(f.Event.filter(J.onDidAddConnection,z))}else U=z.routeCall(J,ne,se);const L=U.then(T=>T.channelClient.getChannel(W));return X(L).call(ne,se,Z)},listen(ne,se){if((0,y.isFunction)(z))return J.j(W,z,ne,se);const Z=z.routeEvent(J,ne,se).then(U=>U.channelClient.getChannel(W));return X(Z).listen(ne,se)}}}j(W,z,J,ne){const se=this;let Z=new d.DisposableStore;const U=new f.Emitter({onWillAddFirstListener:()=>{Z=new d.DisposableStore;const L=new f.EventMultiplexer,T=new Map,B=j=>{const q=j.channelClient.getChannel(W).listen(J,ne),oe=L.add(q);T.set(j,oe)},H=j=>{const $=T.get(j);!$||($.dispose(),T.delete(j))};se.connections.filter(z).forEach(B),f.Event.filter(se.onDidAddConnection,z)(B,void 0,Z),se.onDidRemoveConnection(H,void 0,Z),L.event(U.fire,U,Z),Z.add(L)},onDidRemoveLastListener:()=>{Z.dispose()}});return U.event}registerChannel(W,z){this.a.set(W,z),this.f.forEach(J=>{J.channelServer.registerChannel(W,z)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=O;class N{constructor(W,z,J=null){const ne=new t;u(ne,z),W.send(ne.buffer),this.a=new A(W,J),this.d=new l(W,z,J)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,z){this.d.registerChannel(W,z)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=N;function X(F){return{call(W,z,J){return F.then(ne=>ne.call(W,z,J))},listen(W,z){const J=new f.Relay;return F.then(ne=>J.input=ne.listen(W,z)),J.event}}}e.getDelayedChannel=X;function V(F){let W=!1;return{call(z,J,ne){return W?F.call(z,J,ne):(0,M.timeout)(0).then(()=>W=!0).then(()=>F.call(z,J,ne))},listen(z,J){if(W)return F.listen(z,J);const ne=new f.Relay;return(0,M.timeout)(0).then(()=>W=!0).then(()=>ne.input=F.listen(z,J)),ne.event}}}e.getNextTickChannel=V;class K{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const z of W.connections)if(await Promise.resolve(this.a(z.ctx)))return Promise.resolve(z);return await f.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.StaticRouter=K;var ie;(function(F){function W(se,Z){const U=se,L=Z&&Z.disableMarshalling,T=new Map;for(const B in U)J(B)&&T.set(B,f.Event.buffer(U[B],!0));return new class{listen(B,H,j){const $=T.get(H);if($)return $;if(ne(H)){const q=U[H];if(typeof q=="function")return q.call(U,j)}throw new Error(`Event not found: ${H}`)}call(B,H,j){const $=U[H];if(typeof $=="function"){if(!L&&Array.isArray(j))for(let q=0;q<j.length;q++)j[q]=(0,b.revive)(j[q]);return $.apply(U,j)}throw new Error(`Method not found: ${H}`)}}}F.fromService=W;function z(se,Z){const U=Z&&Z.disableMarshalling;return new Proxy({},{get(L,T){if(typeof T=="string")return Z?.properties?.has(T)?Z.properties.get(T):ne(T)?function(B){return se.listen(T,B)}:J(T)?se.listen(T):async function(...B){let H;Z&&!(0,y.isUndefinedOrNull)(Z.context)?H=[Z.context,...B]:H=B;const j=await se.call(T,H);return U?j:(0,b.revive)(j)};throw new Error(`Property not found: ${String(T)}`)}})}F.toService=z;function J(se){return se[0]==="o"&&se[1]==="n"&&v.isUpperAsciiLetter(se.charCodeAt(2))}function ne(se){return/^onDynamic/.test(se)&&v.isUpperAsciiLetter(se.charCodeAt(9))}})(ie=e.ProxyChannel||(e.ProxyChannel={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){const W=F.toString();if(W!=="[object Object]")return W}return F}function fe(F){return Array.isArray(F)?F.map(ce):ce(F)}function ge(F,W,z,J,ne,se,Z){Z=fe(Z);const U=re[ne],L=U[J%U.length];let T=[`%c[${F}]%c[${String(W).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${L}`];/\($/.test(se)?(T=T.concat(Z),T.push(")")):T.push(Z),console.log.apply(console,T)}class x{constructor(W,z){this.d=W,this.f=z,this.a=0,this.b=0}logOutgoing(W,z,J,ne,se){this.b+=W,ge(this.d,this.b,W,z,J,ne,se)}logIncoming(W,z,J,ne,se){this.a+=W,ge(this.f,this.a,W,z,J,ne,se)}}e.IPCLogger=x}),define(ee[149],te([0,1,17,3,47]),function(G,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class C{constructor(f){this.a=f,this.onMessage=M.Event.fromDOMEventEmitter(this.a,"message",d=>E.VSBuffer.wrap(d.data)),f.start()}send(f){this.a.postMessage(f.buffer)}disconnect(){this.a.close()}}e.Protocol=C;class D extends n.IPCClient{constructor(f,d){const b=new C(f);super(b,d),this.b=b}dispose(){this.b.disconnect()}}e.Client=D}),define(ee[104],te([0,1,8,17,3,2,47]),function(G,e,E,M,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(A){A.Created="created",A.Read="read",A.Write="write",A.Open="open",A.Error="error",A.Close="close",A.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",A.NodeEndReceived="nodeEndReceived",A.NodeEndSent="nodeEndSent",A.NodeDrainBegin="nodeDrainBegin",A.NodeDrainEnd="nodeDrainEnd",A.zlibInflateError="zlibInflateError",A.zlibInflateData="zlibInflateData",A.zlibInflateInitialWrite="zlibInflateInitialWrite",A.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",A.zlibInflateWrite="zlibInflateWrite",A.zlibInflateFlushFired="zlibInflateFlushFired",A.zlibDeflateError="zlibDeflateError",A.zlibDeflateData="zlibDeflateData",A.zlibDeflateWrite="zlibDeflateWrite",A.zlibDeflateFlushFired="zlibDeflateFlushFired",A.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",A.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",A.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",A.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",A.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",A.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",A.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",A.ProtocolHeaderRead="protocolHeaderRead",A.ProtocolMessageRead="protocolMessageRead",A.ProtocolHeaderWrite="protocolHeaderWrite",A.ProtocolMessageWrite="protocolMessageWrite",A.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var f;(function(A){A.enableDiagnostics=!1,A.records=[];const O=new WeakMap;let N=0;function X(K,ie){if(!O.has(K)){const re=String(++N);O.set(K,re)}return O.get(K)}function V(K,ie,re,ce){if(!A.enableDiagnostics)return;const fe=X(K,ie);if(ce instanceof M.VSBuffer||ce instanceof Uint8Array||ce instanceof ArrayBuffer||ArrayBuffer.isView(ce)){const ge=M.VSBuffer.alloc(ce.byteLength);ge.set(ce),A.records.push({timestamp:Date.now(),id:fe,label:ie,type:re,buff:ge})}else A.records.push({timestamp:Date.now(),id:fe,label:ie,type:re,data:ce})}A.traceSocketEvent=V})(f=e.SocketDiagnostics||(e.SocketDiagnostics={}));var d;(function(A){A[A.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",A[A.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(d=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function v(){return b||(b=M.VSBuffer.alloc(0)),b}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(O){this.a.push(O),this.b+=O.byteLength}read(O){return this.c(O,!0)}peek(O){return this.c(O,!1)}c(O,N){if(O===0)return v();if(O>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===O){const ie=this.a[0];return N&&(this.a.shift(),this.b-=O),ie}if(this.a[0].byteLength>O){const ie=this.a[0].slice(0,O);return N&&(this.a[0]=this.a[0].slice(O),this.b-=O),ie}const X=M.VSBuffer.alloc(O);let V=0,K=0;for(;O>0;){const ie=this.a[K];if(ie.byteLength>O){const re=ie.slice(0,O);X.set(re,V),V+=O,N&&(this.a[K]=ie.slice(O),this.b-=O),O-=O}else X.set(ie,V),V+=ie.byteLength,N?(this.a.shift(),this.b-=ie.byteLength):K++,O-=ie.byteLength}return X}}e.ChunkStream=y;var g;(function(A){A[A.None=0]="None",A[A.Regular=1]="Regular",A[A.Control=2]="Control",A[A.Ack=3]="Ack",A[A.Disconnect=5]="Disconnect",A[A.ReplayRequest=6]="ReplayRequest",A[A.Pause=7]="Pause",A[A.Resume=8]="Resume",A[A.KeepAlive=9]="KeepAlive",A[A.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",A[A.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(g||(g={}));function m(A){switch(A){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var w;(function(A){A[A.HeaderLength=13]="HeaderLength",A[A.AcknowledgeTime=2e3]="AcknowledgeTime",A[A.TimeoutTime=2e4]="TimeoutTime",A[A.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",A[A.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",A[A.KeepAliveSendTime=5e3]="KeepAliveSendTime",A[A.LatencySampleTime=6e4]="LatencySampleTime",A[A.LatencySampleCount=5]="LatencySampleCount",A[A.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",A[A.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(w=e.ProtocolConstants||(e.ProtocolConstants={}));class o{constructor(O,N,X,V){this.type=O,this.id=N,this.ack=X,this.data=V,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends C.Disposable{constructor(O){super(),this.f=this.B(new n.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=O,this.b=!1,this.c=new y,this.B(this.a.onData(N=>this.acceptChunk(N))),this.lastReadTime=Date.now()}acceptChunk(O){if(!(!O||O.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(O);this.c.byteLength>=this.g.readLen;){const N=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=N.readUInt32BE(9),this.g.messageType=N.readUInt8(0),this.g.id=N.readUInt32BE(1),this.g.ack=N.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:m(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const X=this.g.messageType,V=this.g.id,K=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",N),this.f.fire(new o(X,V,K,N)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class p{constructor(O){this.k=null,this.a=!1,this.b=!1,this.c=O,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(O){if(this.a)return;O.writtenTime=Date.now(),this.lastWriteTime=Date.now();const N=M.VSBuffer.alloc(13);N.writeUInt8(O.type,0),N.writeUInt32BE(O.id,1),N.writeUInt32BE(O.ack,5),N.writeUInt32BE(O.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:m(O.type),id:O.id,ack:O.ack,messageSize:O.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",O.data),this.j(N,O.data)}g(O,N){const X=this.f===0;return this.d.push(O,N),this.f+=O.byteLength+N.byteLength,X}h(){const O=M.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,O}j(O,N){this.g(O,N)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const O=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:O.byteLength}),this.c.write(O)}}class k extends C.Disposable{constructor(O){super(),this.f=new n.Emitter,this.onMessage=this.f.event,this.g=new n.Emitter,this.onDidDispose=this.g.event,this.a=O,this.b=this.B(new p(this.a)),this.c=this.B(new h(this.a)),this.B(this.c.onMessage(N=>{N.type===1&&this.f.fire(N.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(O){this.b.write(new o(1,0,0,O))}}e.Protocol=k;class S extends D.IPCClient{static fromSocket(O,N){return new S(new k(O),N)}get onDidDispose(){return this.b.onDidDispose}constructor(O,N,X=null){super(O,N,X),this.b=O}dispose(){super.dispose();const O=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),O.end()}}e.Client=S;class R{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new n.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(O){this.b?this.d.length>0?this.d.push(O):this.a.fire(O):this.d.push(O)}flushBuffer(){this.d=[]}}e.BufferedEmitter=R;class t{constructor(O){this.data=O,this.next=null}}class a{constructor(){this.a=null,this.b=null}length(){let O=0,N=this.a;for(;N;)N=N.next,O++;return O}peek(){return this.a?this.a.data:null}toArray(){const O=[];let N=0,X=this.a;for(;X;)O[N++]=X.data,X=X.next;return O}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(O){const N=new t(O);if(!this.a){this.a=N,this.b=N;return}this.b.next=N,this.b=N}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const O=Date.now();for(let N=0;N<i.a;N++)this.c[N]=O-1e3*N;setInterval(()=>{for(let N=i.a;N>=1;N--)this.c[N]=this.c[N-1];this.c[0]=Date.now()},1e3)}d(){const O=Date.now(),N=(1+i.a)*1e3;let X=0;for(let V=0;V<i.a;V++)O-this.c[V]<=N&&X++;return 1-X/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;var s;(function(A){A[A.Good=0]="Good",A[A.Poor=1]="Poor"})(s=e.ConnectionHealth||(e.ConnectionHealth={}));function c(A){switch(A){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=c;class u{constructor(O){this.connectionHealth=O}}e.ConnectionHealthChangedEvent=u;class r{constructor(O,N){this.roundTripTime=O,this.recentHighRoundTripCount=N}}e.HighRoundTripTimeEvent=r;class l{get unacknowledgedCount(){return this.c-this.d}constructor(O){this.x=new R,this.onControlMessage=this.x.event,this.y=new R,this.onMessage=this.y.event,this.z=new R,this.onDidDispose=this.z.event,this.A=new R,this.onSocketClose=this.A.event,this.B=new R,this.onSocketTimeout=this.B.event,this.C=new R,this.onHighRoundTripTime=this.C.event,this.D=new R,this.onDidChangeConnectionHealth=this.D.event,this.u=O.loadEstimator??i.getInstance(),this.v=O.measureRoundTripTime??!1,this.w=O.sendKeepAlive??!0,this.a=!1,this.b=new a,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new C.DisposableStore,this.o=O.socket,this.p=this.t.add(new p(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(N=>this.E(N))),this.t.add(this.o.onClose(N=>this.A.fire(N))),this.r=this.t.add(new I),this.t.add(this.r.onSendLatencyRequest(N=>this.J(N))),this.t.add(this.r.onHighRoundTripTime(N=>this.C.fire(N))),this.t.add(this.r.onDidChangeConnectionHealth(N=>this.D.fire(N))),this.v&&this.r.start(),O.initialChunk&&this.q.acceptChunk(O.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const O=new o(5,0,0,v());this.p.write(O),this.p.flush()}sendPause(){const O=new o(7,0,0,v());this.p.write(O)}sendResume(){const O=new o(8,0,0,v());this.p.write(O)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(O,N){this.a=!0,this.t.dispose(),this.t=new C.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=O,this.p=this.t.add(new p(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(X=>this.E(X))),this.t.add(this.o.onClose(X=>this.A.fire(X))),this.r=this.t.add(new I),this.t.add(this.r.onSendLatencyRequest(X=>this.J(X))),this.t.add(this.r.onHighRoundTripTime(X=>this.C.fire(X))),this.t.add(this.r.onDidChangeConnectionHealth(X=>this.D.fire(X))),this.q.acceptChunk(N)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const O=new o(3,0,this.h,v());this.p.write(O);const N=this.b.toArray();for(let X=0,V=N.length;X<V;X++)this.p.write(N[X]);this.G()}acceptDisconnect(){this.z.fire()}E(O){if(O.ack>this.d){this.d=O.ack;do{const N=this.b.peek();if(N&&N.id<=O.ack)this.b.pop();else break}while(!0)}switch(O.type){case 0:break;case 1:{if(O.id>this.g)if(O.id!==this.g+1){const N=Date.now();N-this.m>1e4&&(this.m=N,this.p.write(new o(6,0,0,v())))}else this.g=O.id,this.j=Date.now(),this.F(),this.y.fire(O.data);break}case 2:{this.x.fire(O.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const N=this.b.toArray();for(let X=0,V=N.length;X<V;X++)this.p.write(N[X]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(O.data);break}case 11:{this.r.handleResponse(O.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(O){const N=++this.c;this.h=this.g;const X=new o(1,N,this.h,O);this.b.push(X),this.a||(this.p.write(X),this.G())}sendControl(O){const N=new o(2,0,0,O);this.p.write(N)}F(){if(this.g<=this.h||this.k)return;const O=Date.now()-this.j;if(O>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-O+5)}G(){if(this.c<=this.d||this.f||this.a)return;const O=this.b.peek(),N=Date.now()-O.writtenTime,X=Date.now()-this.q.lastReadTime,V=Date.now()-this.n;if(N>=2e4&&X>=2e4&&V>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:N,timeSinceLastReceivedSomeData:X});return}const K=Math.max(2e4-N,2e4-X,2e4-V,500);this.f=setTimeout(()=>{this.f=null,this.G()},K)}H(){if(this.g<=this.h)return;this.h=this.g;const O=new o(3,0,this.h,v());this.p.write(O)}I(){this.h=this.g;const O=new o(9,0,this.h,v());this.p.write(O)}J(O){this.h=this.g;const N=new o(10,0,this.h,O);this.p.write(N)}K(O){this.h=this.g;const N=new o(11,0,this.h,O);this.p.write(N)}}e.PersistentProtocol=l;class I extends C.Disposable{constructor(){super(),this.a=this.B(new n.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new n.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new n.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new E.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},O=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const O=++this.h,N=M.VSBuffer.alloc(4);N.writeUInt32BE(O,0),this.a.fire(N)},6e4)}handleResponse(O){if(O.byteLength!==4)return;const N=O.readUInt32BE(0);if(this.g<=0||N!==this.h)return;const X=Date.now()-this.g,V=this.k++;this.j[V%this.j.length]=X;const K=this.l,ie=this.j.filter(re=>re>=1e3).length;this.l=ie>=3?1:0,X>1e3&&this.b.fire(new r(X,ie)),K!==this.l&&this.c.fire(this.l)}}}),define(ee[150],te([0,1,42,17,3,2,47,135]),function(G,e,E,M,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(b,v){const y=n.Event.fromNodeEventEmitter(E.validatedIpcMain,v,(m,w)=>({event:m,message:w})),g=n.Event.filter(y,({event:m})=>m.sender.id===b);return n.Event.map(g,({message:m})=>m&&M.VSBuffer.wrap(m))}class d extends D.IPCServer{static d(){const v=n.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:hello",({sender:y})=>y);return n.Event.map(v,y=>{const g=y.id;d.b.get(g)?.dispose();const w=new n.Emitter;d.b.set(g,(0,C.toDisposable)(()=>w.fire()));const o=f(g,"vscode:message"),h=n.Event.any(n.Event.signal(f(g,"vscode:disconnect")),w.event);return{protocol:new P.Protocol(y,o),onDidClientDisconnect:h}})}constructor(){super(d.d())}}d.b=new Map,e.Server=d}),define(ee[105],te([0,1,42,3,31,149]),function(G,e,E,M,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class D extends C.Client{constructor(d,b){super({addEventListener:(v,y)=>d.addListener(v,y),removeEventListener:(v,y)=>d.removeListener(v,y),postMessage:v=>d.postMessage(v),start:()=>d.start(),close:()=>d.close()},b)}}e.Client=D;async function P(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const d=(0,n.generateUuid)();f.webContents.send("vscode:createMessageChannel",d);const b=M.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:createMessageChannelResult",(y,g)=>({nonce:g,port:y.ports[0]})),{port:v}=await M.Event.toPromise(M.Event.once(M.Event.filter(b,y=>y.nonce===d)));return v}e.connect=P}),define(ee[151],te([0,1,46,8,17,22,144,13,3,2,40,86,83,47]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class m extends g.ChannelServer{constructor(h){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",p=>n.VSBuffer.wrap(Buffer.from(p,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.Server=m;class w{constructor(h,p){this.i=h,this.j=p,this.c=new Set,this.g=new Map,this.h=new f.Emitter,this.onDidProcessExit=this.h.event;const k=p&&p.timeout?p.timeout:6e4;this.b=new M.Delayer(k),this.d=null,this.f=null}getChannel(h){const p=this;return{call(k,S,R){return p.k(h,k,S,R)},listen(k,S){return p.l(h,k,S)}}}k(h,p,k,S=C.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(S.isCancellationRequested)return Promise.reject(P.canceled());this.b.cancel();const R=this.n(h),t=(0,M.createCancelablePromise)(s=>R.call(p,k,s)),a=S.onCancellationRequested(()=>t.cancel()),i=(0,d.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{a.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(h,p,k){if(!this.b)return f.Event.None;this.b.cancel();let S;const R=new f.Emitter({onWillAddFirstListener:()=>{S=this.n(h).listen(p,k)(R.fire,R),this.c.add(S)},onDidRemoveLastListener:()=>{this.c.delete(S),S.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return R.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c))),(0,y.removeDangerousEnvVariables)(p.env),this.d=(0,E.fork)(this.i,h,p);const k=new f.Emitter;f.Event.fromNodeEventEmitter(this.d,"message",c=>c)(c=>{if((0,D.isRemoteConsoleLog)(c)){(0,D.log)(c,`IPC Library: ${this.j.serverName}`);return}k.fire(n.VSBuffer.wrap(Buffer.from(c,"base64")))});const R=this.j.useQueue?(0,v.createQueuedSender)(this.d):this.d,t=c=>this.d&&this.d.connected&&R.send(c.buffer.toString("base64")),a=k.event,i={send:t,onMessage:a};this.f=new g.ChannelClient(i);const s=()=>this.o();process.once("exit",s),this.d.on("error",c=>console.warn('IPC "'+this.j.serverName+'" errored with '+c)),this.d.on("exit",(c,u)=>{process.removeListener("exit",s),this.c.forEach(r=>(0,d.dispose)(r)),this.c.clear(),c!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+c+" and signal "+u),this.b?.cancel(),this.o(),this.h.fire({code:c,signal:u})})}return this.f}n(h){let p=this.g.get(h);return p||(p=this.m.getChannel(h),this.g.set(h,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=w}),define(ee[87],te([0,1,17,13,3,2,9,4,31,47,104]),function(G,e,E,M,n,C,D,P,f,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function v(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class y{traceSocketEvent(r,l){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,r,l)}constructor(r,l=""){this.f=!0,this.debugLabel=l,this.socket=r,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=I=>{if(this.traceSocketEvent("error",{code:I?.code,message:I?.message}),I){if(I.code==="EPIPE")return;(0,M.onUnexpectedError)(I)}},this.socket.on("error",this.a),this.b=I=>{this.traceSocketEvent("close",{hadError:I}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(r){const l=I=>{this.traceSocketEvent("read",I),r(E.VSBuffer.wrap(I))};return this.socket.on("data",l),{dispose:()=>this.socket.off("data",l)}}onClose(r){const l=I=>{r({type:0,hadError:I,error:void 0})};return this.socket.on("close",l),{dispose:()=>this.socket.off("close",l)}}onEnd(r){const l=()=>{r()};return this.socket.on("end",l),{dispose:()=>this.socket.off("end",l)}}write(r){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",r),this.socket.write(r.buffer,l=>{if(l){if(l.code==="EPIPE")return;(0,M.onUnexpectedError)(l)}})}catch(l){if(l.code==="EPIPE")return;(0,M.onUnexpectedError)(l)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((r,l)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),r();return}const I=()=>{this.socket.off("close",I),this.socket.off("end",I),this.socket.off("error",I),this.socket.off("timeout",I),this.socket.off("drain",I),this.traceSocketEvent("nodeDrainEnd"),r()};this.socket.on("close",I),this.socket.on("end",I),this.socket.on("error",I),this.socket.on("timeout",I),this.socket.on("drain",I)})}}e.NodeSocket=y;var g;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize"})(g||(g={}));var m;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(m||(m={}));class w extends C.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(r,l){this.socket.traceSocketEvent(r,l)}constructor(r,l,I,A){super(),this.f=this.B(new n.Emitter),this.g=this.B(new n.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=r,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:l,inflateBytesLength:I?.byteLength||0,recordInflateBytes:A}),this.a=this.B(new o(this,l,I,A,this.f,(O,N)=>this.k(O,N))),this.B(this.a.onError(O=>{console.error(O),(0,M.onUnexpectedError)(O),this.g.fire({type:0,hadError:!0,error:O})})),this.b=new b.ChunkStream,this.B(this.socket.onData(O=>this.l(O))),this.B(this.socket.onClose(O=>this.g.fire(O)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(r){return this.f.event(r)}onClose(r){return this.g.event(r)}onEnd(r){return this.socket.onEnd(r)}write(r){this.a.writeMessage(r)}k(r,l){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",r);let I=2;r.byteLength<126?I+=0:r.byteLength<2**16?I+=2:I+=8;const A=E.VSBuffer.alloc(I);if(l?A.writeUInt8(194,0):A.writeUInt8(130,0),r.byteLength<126)A.writeUInt8(r.byteLength,1);else if(r.byteLength<2**16){A.writeUInt8(126,1);let O=1;A.writeUInt8(r.byteLength>>>8&255,++O),A.writeUInt8(r.byteLength>>>0&255,++O)}else{A.writeUInt8(127,1);let O=1;A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(r.byteLength>>>24&255,++O),A.writeUInt8(r.byteLength>>>16&255,++O),A.writeUInt8(r.byteLength>>>8&255,++O),A.writeUInt8(r.byteLength>>>0&255,++O)}this.socket.write(E.VSBuffer.concat([A,r]))}end(){this.h=!0,this.socket.end()}l(r){if(r.byteLength!==0){for(this.b.acceptChunk(r);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const l=this.b.peek(this.j.readLen),I=l.readUInt8(0),A=(I&128)>>>7,O=(I&64)>>>6,N=l.readUInt8(1),X=(N&128)>>>7,V=N&127;this.j.state=2,this.j.readLen=2+(X?4:0)+(V===126?2:0)+(V===127?8:0),this.j.fin=A,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(O)),this.j.firstFrameOfMessage=Boolean(A),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const l=this.b.read(this.j.readLen),I=l.readUInt8(1),A=(I&128)>>>7;let O=I&127,N=1;O===126?O=l.readUInt8(++N)*2**8+l.readUInt8(++N):O===127&&(O=l.readUInt8(++N)*0+l.readUInt8(++N)*0+l.readUInt8(++N)*0+l.readUInt8(++N)*0+l.readUInt8(++N)*2**24+l.readUInt8(++N)*2**16+l.readUInt8(++N)*2**8+l.readUInt8(++N));let X=0;A&&(X=l.readUInt8(++N)*2**24+l.readUInt8(++N)*2**16+l.readUInt8(++N)*2**8+l.readUInt8(++N)),this.j.state=3,this.j.readLen=O,this.j.mask=X,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const l=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",l),k(l,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",l),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(l,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await n.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class o extends C.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:E.VSBuffer.alloc(0)}constructor(r,l,I,A,O,N){super(),this.k=r,this.l=O,this.m=N,this.a=this.B(new n.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new n.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,l?(this.b=this.B(new h(this.k,A,I,{windowBits:15})),this.f=this.B(new p(this.k,{windowBits:15})),this.B(this.b.onError(X=>this.a.fire(X))),this.B(this.f.onError(X=>this.a.fire(X)))):(this.b=null,this.f=null)}writeMessage(r){this.g.push(r),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const r=this.g.shift();if(this.f){const l=await this.r(this.f,r);this.m(l,!0)}else this.m(r,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(r,l){return new Promise((I,A)=>{r.write(l),r.flush(O=>I(O))})}acceptFrame(r,l,I){this.h.push({data:r,isCompressed:l,isLastFrameOfMessage:I}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const r=this.h.shift();if(this.b&&r.isCompressed){const l=await this.u(this.b,r.data,r.isLastFrameOfMessage);this.l.fire(l)}else this.l.fire(r.data)}this.s=!1}}u(r,l,I){return new Promise((A,O)=>{r.write(l),I&&r.write(E.VSBuffer.fromByteArray([0,0,255,255])),r.flush(N=>A(N))})}}class h extends C.Disposable{get recordedInflateBytes(){return this.j?E.VSBuffer.concat(this.f):E.VSBuffer.alloc(0)}constructor(r,l,I,A){super(),this.h=r,this.j=l,this.a=this.B(new n.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=v().zlib.createInflateRaw(A),this.b.on("error",O=>{this.h.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent("zlibInflateData",O),this.g.push(E.VSBuffer.wrap(O))}),I&&(this.h.traceSocketEvent("zlibInflateInitialWrite",I.buffer),this.b.write(I.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(r){this.j&&this.f.push(r.clone()),this.h.traceSocketEvent("zlibInflateWrite",r),this.b.write(r.buffer)}flush(r){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const l=E.VSBuffer.concat(this.g);this.g.length=0,r(l)})}}class p extends C.Disposable{constructor(r,l){super(),this.g=r,this.a=this.B(new n.Emitter),this.onError=this.a.event,this.f=[],this.b=v().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",I=>{this.g.traceSocketEvent("zlibDeflateError",{message:I?.message,code:I?.code}),this.a.fire(I)}),this.b.on("data",I=>{this.g.traceSocketEvent("zlibDeflateData",I),this.f.push(E.VSBuffer.wrap(I))})}write(r){this.g.traceSocketEvent("zlibDeflateWrite",r.buffer),this.b.write(r.buffer)}flush(r){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let l=E.VSBuffer.concat(this.f);this.f.length=0,l=l.slice(0,l.byteLength-4),r(l)})}}function k(u,r){if(r===0)return;const l=u.byteLength>>>2;for(let V=0;V<l;V++){const K=u.readUInt32BE(V*4);u.writeUInt32BE(K^r,V*4)}const I=l*4,A=u.byteLength-I,O=r>>>24&255,N=r>>>16&255,X=r>>>8&255;A>=1&&u.writeUInt8(u.readUInt8(I)^O,I),A>=2&&u.writeUInt8(u.readUInt8(I+1)^N,I+1),A>=3&&u.writeUInt8(u.readUInt8(I+2)^X,I+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const S={[2]:107,[1]:103};function R(){const u=(0,f.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;let r;return e.XDG_RUNTIME_DIR?r=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${u}.sock`):r=(0,D.join)(v().os.tmpdir(),`vscode-ipc-${u}.sock`),a(r),r}e.createRandomIPCHandle=R;function t(u,r,l){const I=v().crypto.createHash("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${I}-${l}-${r}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${I.substr(0,8)}-${l}-${r}.sock`):A=(0,D.join)(u,`${l}-${r}.sock`),a(A),A}e.createStaticIPCHandle=t;function a(u){const r=S[P.platform];typeof r=="number"&&u.length>=r&&console.warn(`WARNING: IPC handle "${u}" is longer than ${r} chars, try a shorter --user-data-dir`)}class i extends d.IPCServer{static b(r){const l=n.Event.fromNodeEventEmitter(r,"connection");return n.Event.map(l,I=>({protocol:new b.Protocol(new y(I,"ipc-server-connection")),onDidClientDisconnect:n.Event.once(n.Event.fromNodeEventEmitter(I,"close"))}))}constructor(r){super(i.b(r)),this.d=r}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=i;function s(u){return new Promise((r,l)=>{const I=v().net.createServer();I.on("error",l),I.listen(u,()=>{I.removeListener("error",l),r(new i(I))})})}e.serve=s;function c(u,r){return new Promise((l,I)=>{const A=v().net.createConnection(u,()=>{A.removeListener("error",I),l(b.Client.fromSocket(new y(A,`ipc-client${r}`),r))});A.once("error",I)})}e.connect=c}),define(ee[106],te([0,1,8,3,2,10]),function(G,e,E,M,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(D=e.StorageHint||(e.StorageHint={}));function P(v){const y=v;return y?.changed instanceof Map||y?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var f;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(f=e.StorageState||(e.StorageState={}));class d extends n.Disposable{constructor(y,g=Object.create(null)){super(),this.m=y,this.n=g,this.b=this.B(new M.Emitter),this.onDidChangeStorage=this.b.event,this.c=f.None,this.f=new Map,this.g=new E.ThrottledDelayer(d.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(y=>this.r(y)))}r(y){y.changed?.forEach((g,m)=>this.s(m,g)),y.deleted?.forEach(g=>this.s(g,void 0))}s(y,g){if(this.c===f.Closed)return;let m=!1;(0,C.isUndefinedOrNull)(g)?m=this.f.delete(y):this.f.get(y)!==g&&(this.f.set(y,g),m=!0),m&&this.b.fire(y)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===f.None&&(this.c=f.Initialized,this.n.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(y,g){const m=this.f.get(y);return(0,C.isUndefinedOrNull)(m)?g:m}getBoolean(y,g){const m=this.get(y);return(0,C.isUndefinedOrNull)(m)?g:m==="true"}getNumber(y,g){const m=this.get(y);return(0,C.isUndefinedOrNull)(m)?g:parseInt(m,10)}async set(y,g){if(this.c===f.Closed)return;if((0,C.isUndefinedOrNull)(g))return this.delete(y);const m=String(g);if(this.f.get(y)!==m)return this.f.set(y,m),this.j.set(y,m),this.h.delete(y),this.b.fire(y),this.w()}async delete(y){if(!(this.c===f.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire(y),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=f.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(y).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(y){if(!!this.u)return this.w(y)}async w(y){return this.g.trigger(()=>this.v(),y)}async whenFlushed(){if(!!this.u)return new Promise(y=>this.l.push(y))}isInMemory(){return this.n.hint===D.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}d.a=100,e.Storage=d;class b{constructor(){this.onDidChangeItemsExternal=M.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((g,m)=>this.a.set(m,g)),y.delete?.forEach(g=>this.a.delete(g))}async close(){}}e.InMemoryStorageDatabase=b}),define(ee[152],te([0,1,8,3,35,9,23]),function(G,e,E,M,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class P{get onDidChangeItemsExternal(){return M.Event.None}constructor(b,v=Object.create(null)){this.g=b,this.h=v,this.c=(0,C.basename)(this.g),this.d=new f(this.h.logging),this.f=this.n(this.g)}async getItems(){const b=await this.f,v=new Map;return(await this.s(b,"SELECT * FROM ItemTable")).forEach(g=>v.set(g.key,g.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${v.size} rows`),v}async updateItems(b){const v=await this.f;return this.j(v,b)}j(b,v){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${v.insert?(0,n.mapToString)(v.insert):"0"}), delete(${v.delete?(0,n.setToString)(v.delete):"0"})`),this.t(b,()=>{const y=v.insert,g=v.delete;if(y&&y.size>0){const m=[];m.push([]);let w=0;y.forEach((o,h)=>{let p=m[w];p.length>P.b&&(w++,p=[],m.push(p)),p.push(h,o)}),m.forEach(o=>{this.u(b,`INSERT INTO ItemTable VALUES ${new Array(o.length/2).fill("(?,?)").join(",")}`,h=>h.run(o),()=>{const h=[];let p=0;return y.forEach((k,S)=>{h.push(S),p+=k.length}),`Keys: ${h.join(", ")} Length: ${p}`})})}if(g&&g.size){const m=[];m.push([]);let w=0;g.forEach(o=>{let h=m[w];h.length>P.b&&(w++,h=[],m.push(h)),h.push(o)}),m.forEach(o=>{this.u(b,`DELETE FROM ItemTable WHERE key IN (${new Array(o.length).fill("?").join(",")})`,h=>h.run(o),()=>{const h=[];return g.forEach(p=>{h.push(p)}),`Keys: ${h.join(", ")}`})})}})}async close(b){this.d.trace(`[storage ${this.c}] close()`);const v=await this.f;return this.k(v,b)}k(b,v){return new Promise((y,g)=>{b.db.close(m=>(m&&this.o(b,`[storage ${this.c}] close(): ${m}`),this.g===P.IN_MEMORY_PATH?y():!b.isErroneous&&!b.isInMemory?this.l().then(y,w=>(this.d.error(`[storage ${this.c}] backup(): ${w}`),y())):typeof v=="function"?D.Promises.unlink(this.g).then(()=>this.p(this.g).then(w=>{const o=()=>this.k(w,void 0);return this.j(w,{insert:v()}).then(()=>o(),h=>(o(),Promise.reject(h)))})).then(y,g):g(m||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const b=this.m(this.g);return D.Promises.copy(this.g,b,{preserveSymlinks:!1})}m(b){return`${b}.backup`}async checkIntegrity(b){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${b})`);const v=await this.f,y=await this.r(v,b?"PRAGMA integrity_check":"PRAGMA quick_check"),g=b?y.integrity_check:y.quick_check;return v.isErroneous?`${g} (last error: ${v.lastError})`:v.isInMemory?`${g} (in-memory!)`:g}async n(b,v=!0){this.d.trace(`[storage ${this.c}] open(${b}, retryOnBusy: ${v})`);try{return await this.p(b)}catch(y){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&v)return await(0,E.timeout)(P.a),this.n(b,!1);try{await D.Promises.unlink(b);try{await D.Promises.rename(this.m(b),b)}catch{}return await this.p(b)}catch(g){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${g}`),this.p(P.IN_MEMORY_PATH)}}}o(b,v){b.isErroneous=!0,b.lastError=v,this.d.error(v)}p(b){return new Promise((v,y)=>{new Promise((g,m)=>{G(["@vscode/sqlite3"],g,m)}).then(g=>{const m={db:new(this.d.isTracing?g.verbose().Database:g.Database)(b,w=>w?m.db&&w.code!=="SQLITE_CANTOPEN"?m.db.close(()=>y(w)):y(w):this.q(m,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>v(m),o=>m.db.close(()=>y(o)))),isInMemory:b===P.IN_MEMORY_PATH};m.db.on("error",w=>this.o(m,`[storage ${this.c}] Error (event): ${w}`)),this.d.isTracing&&m.db.on("trace",w=>this.d.trace(`[storage ${this.c}] Trace (event): ${w}`))},y)})}q(b,v){return new Promise((y,g)=>{b.db.exec(v,m=>m?(this.o(b,`[storage ${this.c}] exec(): ${m}`),g(m)):y())})}r(b,v){return new Promise((y,g)=>{b.db.get(v,(m,w)=>m?(this.o(b,`[storage ${this.c}] get(): ${m}`),g(m)):y(w))})}s(b,v){return new Promise((y,g)=>{b.db.all(v,(m,w)=>m?(this.o(b,`[storage ${this.c}] all(): ${m}`),g(m)):y(w))})}t(b,v){return new Promise((y,g)=>{b.db.serialize(()=>{b.db.run("BEGIN TRANSACTION"),v(),b.db.run("END TRANSACTION",m=>m?(this.o(b,`[storage ${this.c}] transaction(): ${m}`),g(m)):y())})})}u(b,v,y,g){const m=b.db.prepare(v),w=o=>{this.o(b,`[storage ${this.c}] prepare(): ${o} (${v}). Details: ${g()}`)};m.on("error",w),y(m),m.finalize(o=>{o&&w(o),m.removeListener("error",w)})}}P.IN_MEMORY_PATH=":memory:",P.a=2e3,P.b=256,e.SQLiteStorageDatabase=P;class f{constructor(b){b&&typeof b.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.a=b.logTrace),b&&typeof b.logError=="function"&&(this.b=b.logError)}get isTracing(){return!!this.a}trace(b){this.a?.(b)}error(b){this.b?.(b)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ee[153],te([12,11]),function(G,e){return G.create("vs/code/electron-main/app",e)}),define(ee[154],te([12,11]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[155],te([12,11]),function(G,e){return G.create("vs/platform/dialogs/common/dialogs",e)}),define(ee[156],te([12,11]),function(G,e){return G.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[157],te([12,11]),function(G,e){return G.create("vs/platform/environment/node/argv",e)}),define(ee[158],te([12,11]),function(G,e){return G.create("vs/platform/environment/node/argvHelper",e)}),define(ee[159],te([12,11]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[160],te([12,11]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ee[161],te([12,11]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ee[162],te([12,11]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[163],te([12,11]),function(G,e){return G.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[164],te([12,11]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(ee[165],te([12,11]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(ee[166],te([12,11]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(ee[167],te([12,11]),function(G,e){return G.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[168],te([12,11]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[169],te([12,11]),function(G,e){return G.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[170],te([12,11]),function(G,e){return G.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[171],te([12,11]),function(G,e){return G.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[172],te([12,11]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(ee[173],te([12,11]),function(G,e){return G.create("vs/platform/shell/node/shellEnv",e)}),define(ee[174],te([12,11]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[175],te([12,11]),function(G,e){return G.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[176],te([12,11]),function(G,e){return G.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ee[177],te([12,11]),function(G,e){return G.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ee[178],te([12,11]),function(G,e){return G.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[179],te([12,11]),function(G,e){return G.create("vs/platform/workspace/common/workspace",e)}),define(ee[180],te([12,11]),function(G,e){return G.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[181],te([12,11]),function(G,e){return G.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[182],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function E(n){return n&&n.hasOwnProperty("folderUri")}e.isFolderBackupInfo=E;function M(n){return n&&n.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=M}),define(ee[183],te([0,1,7]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function M(D){return typeof D?.backupFolder=="string"}e.isEmptyWindowBackupInfo=M;function n(D){let P=[];try{Array.isArray(D.workspaces)&&(P=D.workspaces.map(f=>({workspace:{id:f.id,configPath:E.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}return P}e.deserializeWorkspaceInfos=n;function C(D){let P=[];try{Array.isArray(D.folders)&&(P=D.folders.map(f=>({folderUri:E.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})))}catch{}return P}e.deserializeFolderInfos=C}),define(ee[184],te([0,1,3,2]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class n{constructor(){this.a=new E.Emitter,this.b=new E.Emitter,this.c=new E.Emitter,this.d=new E.Emitter}call(P,f,d){switch(f){case"close":return Promise.resolve(this.a.fire({sessionId:d[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:d[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:d[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:d[0],port:d[1],subId:d[2]}))}throw new Error("Method not implemented.")}listen(P,f,d){switch(f){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}n.ChannelName="extensionhostdebugservice",e.ExtensionHostDebugBroadcastChannel=n;class C extends M.Disposable{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,f,d){this.b.call("attach",[P,f,d])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,f){this.b.call("terminate",[P,f])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,f){return this.b.call("openExtensionDevelopmentHostWindow",[P,f])}}e.ExtensionHostDebugChannelClient=C}),define(ee[185],te([0,1,138,55,15,9,36,18,7]),function(G,e,E,M,n,C,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class d{get appRoot(){return(0,C.dirname)(n.FileAccess.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return f.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.b.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const m=(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",m)}return this.args.logsPath}get userDataSyncLogResource(){return f.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return f.URI.file((0,C.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(f.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=D.env.VSCODE_PORTABLE;return m?f.URI.file((0,C.join)(m,"argv.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,C.resolve)(m):(0,C.normalize)((0,C.join)(n.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const m=this.args["extensions-download-dir"];return m?f.URI.file((0,C.resolve)(m)):f.URI.file((0,C.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,C.resolve)(m);const w=D.env.VSCODE_EXTENSIONS;if(w)return w;const o=D.env.VSCODE_PORTABLE;return o?(0,C.join)(o,"extensions"):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(w=>/^[^:/?#]+?:\/\//.test(w)?f.URI.parse(w):f.URI.file((0,C.normalize)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?f.URI.parse(m):f.URI.file((0,C.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(m=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(m))}get extensionLogLevel(){const m=[];for(const w of this.args.log||[]){const o=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(w);o&&o[1]&&o[2]&&m.push([o[1],o[2]])}return m.length?m:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return f.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=D.env.VSCODE_PORTABLE;return m?f.URI.file((0,C.join)(m,"policy.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this.a}constructor(m,w,o){this.a=m,this.b=w,this.c=o,this.editSessionId=this.args.editSessionId}}ve([M.memoize],d.prototype,"appRoot",null),ve([M.memoize],d.prototype,"userHome",null),ve([M.memoize],d.prototype,"userDataPath",null),ve([M.memoize],d.prototype,"appSettingsHome",null),ve([M.memoize],d.prototype,"tmpDir",null),ve([M.memoize],d.prototype,"cacheHome",null),ve([M.memoize],d.prototype,"stateResource",null),ve([M.memoize],d.prototype,"userRoamingDataHome",null),ve([M.memoize],d.prototype,"userDataSyncHome",null),ve([M.memoize],d.prototype,"userDataSyncLogResource",null),ve([M.memoize],d.prototype,"editSessionsLogResource",null),ve([M.memoize],d.prototype,"sync",null),ve([M.memoize],d.prototype,"machineSettingsResource",null),ve([M.memoize],d.prototype,"workspaceStorageHome",null),ve([M.memoize],d.prototype,"localHistoryHome",null),ve([M.memoize],d.prototype,"keyboardLayoutResource",null),ve([M.memoize],d.prototype,"argvResource",null),ve([M.memoize],d.prototype,"isExtensionDevelopment",null),ve([M.memoize],d.prototype,"untitledWorkspacesHome",null),ve([M.memoize],d.prototype,"installSourcePath",null),ve([M.memoize],d.prototype,"builtinExtensionsPath",null),ve([M.memoize],d.prototype,"extensionsPath",null),ve([M.memoize],d.prototype,"extensionDevelopmentLocationURI",null),ve([M.memoize],d.prototype,"extensionDevelopmentKind",null),ve([M.memoize],d.prototype,"extensionTestsLocationURI",null),ve([M.memoize],d.prototype,"debugExtensionHost",null),ve([M.memoize],d.prototype,"logLevel",null),ve([M.memoize],d.prototype,"extensionLogLevel",null),ve([M.memoize],d.prototype,"serviceMachineIdResource",null),ve([M.memoize],d.prototype,"telemetryLogResource",null),ve([M.memoize],d.prototype,"disableWorkspaceTrust",null),ve([M.memoize],d.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=d;function b(g,m){return y(g["inspect-extensions"],g["inspect-brk-extensions"],5870,m,g.debugId,g.extensionEnvironment)}e.parseExtensionHostPort=b;function v(g,m){return y(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,m,g.extensionEnvironment)}e.parsePtyHostPort=v;function y(g,m,w,o,h,p){const S=Number(m||g)||(o?null:w),R=S?Boolean(!!m):!1;let t;if(p)try{t=JSON.parse(p)}catch{}return{port:S,break:R,debugId:h,env:t}}}),define(ee[107],te([0,1,287,4,157]),function(G,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const C={o:(0,n.localize)(0,null),e:(0,n.localize)(1,null),t:(0,n.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,n.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,n.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,n.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,n.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,n.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,n.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,n.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,n.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,n.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,n.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,n.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,n.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,n.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,n.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,n.localize)(17,null)},category:{type:"string",cat:"e",description:(0,n.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,n.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,n.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,n.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,n.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,n.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,n.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,n.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,n.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,n.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,n.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,n.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,n.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,n.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,n.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,n.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,n.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,n.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(w,o,h=D){const p=w.find(u=>u.length>0&&u[0]!=="-"),k={},S=["_"],R=[],t={};let a;for(const u in o){const r=o[u];r.type==="subcommand"?u===p&&(a=r):(r.alias&&(k[u]=r.alias),r.type==="string"||r.type==="string[]"?(S.push(u),r.deprecates&&S.push(...r.deprecates)):r.type==="boolean"&&(R.push(u),r.deprecates&&R.push(...r.deprecates)),r.global&&(t[u]=r))}if(a&&p){const u=t;for(const A in a.options)u[A]=a.options[A];const r=w.filter(A=>A!==p),l=h.getSubcommandReporter?h.getSubcommandReporter(p):void 0,I=P(r,u,l);return{[p]:I,_:[]}}const i=E(w,{string:S,boolean:R,alias:k}),s={},c=i;s._=i._.map(u=>String(u)).filter(u=>u.length>0),delete c._;for(const u in o){const r=o[u];if(r.type==="subcommand")continue;r.alias&&delete c[r.alias];let l=c[u];if(r.deprecates)for(const I of r.deprecates)c.hasOwnProperty(I)&&(l||(l=c[I],l&&h.onDeprecatedOption(I,r.deprecationMessage||(0,n.localize)(36,null,u))),delete c[I]);if(typeof l<"u"){if(r.type==="string[]"){if(Array.isArray(l)||(l=[l]),!r.allowEmptyValue){const I=l.filter(A=>A.length>0);I.length!==l.length&&(h.onEmptyValue(u),l=I.length>0?I:void 0)}}else r.type==="string"&&(Array.isArray(l)?(l=l.pop(),h.onMultipleValues(u,l)):!l&&!r.allowEmptyValue&&(h.onEmptyValue(u),l=void 0));s[u]=l,r.deprecationMessage&&h.onDeprecatedOption(u,r.deprecationMessage)}delete c[u]}for(const u in c)h.onUnknownOption(u);return s}e.parseArgs=P;function f(w,o){let h="";return o.args&&(Array.isArray(o.args)?h=` <${o.args.join("> <")}>`:h=` <${o.args}>`),o.alias?`-${o.alias} --${w}${h}`:`--${w}${h}`}function d(w,o){const h=[];for(const p in w){const k=w[p],S=f(p,k);h.push([S,k.description])}return b(h,o)}e.formatOptions=d;function b(w,o){const p=w.reduce((R,t)=>Math.max(R,t[0].length),12)+2+1;if(o-p<25)return w.reduce((R,t)=>R.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const k=o-p-1,S=[];for(const R of w){const t=R[0],a=y(R[1],k),i=v(p-t.length-2);S.push("  "+t+i+a[0]);for(let s=1;s<a.length;s++)S.push(v(p)+a[s])}return S}function v(w){return" ".repeat(w)}function y(w,o){const h=[];for(;w.length;){const p=w.length<o?w.length:w.lastIndexOf(" ",o),k=w.slice(0,p).trim();w=w.slice(p),h.push(k)}return h}function g(w,o,h,p,k){const S=process.stdout.isTTY&&process.stdout.columns||80,R=k?.noInputFiles!==!0?`[${(0,n.localize)(37,null)}...]`:"",t=[`${w} ${h}`];t.push(""),t.push(`${(0,n.localize)(38,null)}: ${o} [${(0,n.localize)(39,null)}]${R}`),t.push(""),k?.noPipe!==!0&&(M.isWindows?t.push((0,n.localize)(40,null,o)):t.push((0,n.localize)(41,null,o)),t.push(""));const a={},i=[];for(const s in p){const c=p[s];if(c.type==="subcommand")c.description&&i.push({command:s,description:c.description});else if(c.description&&c.cat){let u=a[c.cat];u||(a[c.cat]=u={}),u[s]=c}}for(const s in a){const c=s,u=a[c];u&&(t.push(C[c]),t.push(...d(u,S)),t.push(""))}return i.length&&(t.push((0,n.localize)(42,null)),t.push(...b(i.map(s=>[s.command,s.description]),S)),t.push("")),t.join(`
`)}e.buildHelpMessage=g;function m(w,o){return`${w||(0,n.localize)(43,null)}
${o||(0,n.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=m}),define(ee[186],te([0,1,82,184,107]),function(G,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class C extends M.ExtensionHostDebugBroadcastChannel{constructor(P){super(),this.f=P}call(P,f,d){return f==="openExtensionDevelopmentHostWindow"?this.g(d[0],d[1]):super.call(P,f,d)}async g(P,f){const d=(0,n.parseArgs)(P,n.OPTIONS);d.debugRenderer=f;const b=d.extensionDevelopmentPath;if(!b)return{success:!1};const[v]=await this.f.openExtensionDevelopmentHostWindow(b,{context:5,cli:d,forceProfile:d.profile,forceTempProfile:d["profile-temp"]});if(!f)return{success:!0};const y=v.win;if(!y)return{success:!0};const g=y.webContents.debugger;let m=g.isAttached()?1/0:0;const w=(0,E.createServer)(o=>{m++===0&&g.attach();let h=!1;const p=R=>{h||o.write(JSON.stringify(R)+"\0")},k=(R,t,a,i)=>p({method:t,params:a,sessionId:i});y.on("close",()=>{g.removeListener("message",k),o.end(),h=!0}),g.addListener("message",k);let S=Buffer.alloc(0);o.on("data",R=>{S=Buffer.concat([S,R]);for(let t=S.indexOf(0);t!==-1;t=S.indexOf(0)){let a;try{const i=S.slice(0,t).toString("utf8");S=S.slice(t+1),a=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}g.sendCommand(a.method,a.params,a.sessionId).then(i=>p({id:a.id,sessionId:a.sessionId,result:i})).catch(i=>p({id:a.id,sessionId:a.sessionId,error:{code:0,message:i.message}}))}}),o.on("error",R=>{console.error("error on cdp pipe:",R)}),o.on("close",()=>{h=!0,--m===0&&g.detach()})});return await new Promise(o=>w.listen(0,o)),y.on("close",()=>w.close()),{rendererDebugPort:w.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=C}),define(ee[62],te([0,1,288,158,107]),function(G,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const C=2048;function D(y,g){const m=(S,R)=>{console.warn((0,M.localize)(0,null,S,R))},w=S=>{console.warn((0,M.localize)(1,null,S))},o=(S,R)=>{console.warn((0,M.localize)(2,null,S,R))},h=S=>({onUnknownOption:R=>{S!=="tunnel"&&console.warn((0,M.localize)(3,null,R,S))},onMultipleValues:m,onEmptyValue:w,onDeprecatedOption:o,getSubcommandReporter:S!=="tunnel"?h:void 0}),p={onUnknownOption:S=>{console.warn((0,M.localize)(4,null,S))},onMultipleValues:m,onEmptyValue:w,onDeprecatedOption:o,getSubcommandReporter:h},k=(0,n.parseArgs)(y,n.OPTIONS,g?p:void 0);return k.goto&&k._.forEach(S=>E(/^(\w:)?[^:]+(:\d*){0,2}$/.test(S),(0,M.localize)(5,null))),k["max-memory"]&&E(parseInt(k["max-memory"])>=C,`The max-memory argument cannot be specified lower than ${C} MB.`),k}function P(y){const g=y.findIndex(m=>!/^-/.test(m));if(g>-1)return[...y.slice(0,g),...y.slice(g+1)]}function f(y){let[,...g]=y;process.env.VSCODE_DEV&&(g=P(g)||[]);const m=!v(process.env);return D(g,m)}e.parseMainProcessArgv=f;function d(y){let[,,...g]=y;return process.env.VSCODE_DEV&&(g=P(g)||[]),D(g,!0)}e.parseCLIProcessArgv=d;function b(y,...g){const m=y.indexOf("--");return m===-1?y.push(...g):y.splice(m,0,...g),y}e.addArg=b;function v(y){return y.VSCODE_CLI==="1"}e.isLaunchedFromCli=v}),function(){"use strict";function G(e,E,M){function n(D,P){const f=C(D,P),d=[f];return e.isAbsolute(f)||d.unshift(M),e.resolve(...d)}function C(D,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return e.join(d,P);const b=D["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=e.join(v,"AppData","Roaming")}break;case"darwin":d=e.join(E.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(d,P)}return{getUserDataPath:n}}if(typeof define=="function")define(ee[187],te([188,26,36]),function(e,E,M){return G(e,E,M.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=G(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[189],te([0,1,26,185,187]),function(G,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class C extends M.AbstractNativeEnvironmentService{constructor(P,f){super(P,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,n.getUserDataPath)(P,f.nameShort)},f)}}e.NativeEnvironmentService=C}),define(ee[190],te([0,1,41,26,32]),function(G,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function C(D){const P=(0,n.randomPath)((0,M.tmpdir)());try{return(0,E.writeFileSync)(P,""),D&&console.log(`Marker file for --wait created: ${P}`),P}catch(f){D&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFileSync=C}),define(ee[191],te([0,1,10,160]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function n(D,P,f){try{C(D,P,f)}catch(d){console.error(d?.message??d)}return D}e.localizeManifest=n;function C(D,P,f){const d=(b,v,y)=>{const g=b[v];if((0,E.isString)(g)){const m=g,w=m.length;if(w>1&&m[0]==="%"&&m[w-1]==="%"){const o=m.substr(1,w-2);let h=P[o];h===void 0&&f&&(h=f[o]);const p=typeof h=="string"?h:h?.message,k=f?.[o],S=typeof k=="string"?k:k?.message;if(!p){S||console.warn(`[${D.name}]: ${(0,M.localize)(0,null,o)}`);return}if(y&&(v==="title"||v==="category")&&S&&S!==p){const R={value:p,original:S};b[v]=R}else b[v]=p}}else if((0,E.isObject)(g))for(const m in g)g.hasOwnProperty(m)&&(m==="commands"?d(g,m,!0):d(g,m,y));else if(Array.isArray(g))for(let m=0;m<g.length;m++)d(g,m,y)};for(const b in D)D.hasOwnProperty(b)&&d(D,b)}}),define(ee[192],te([0,1,13]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class M{constructor(){this.a=new Map}register(C,D){this.a.set(C,D)}updateManifest(C){if(!(typeof C.main>"u"&&typeof C.browser>"u")&&(C.activationEvents===void 0&&Object.assign(C,{activationEvents:[]}),!(!Array.isArray(C.activationEvents)||!C.contributes)))for(const D in C.contributes){const P=this.a.get(D);if(!P)continue;const f=C.contributes[D],d=Array.isArray(f)?f:[f];try{P(d,C.activationEvents)}catch(b){(0,E.onUnexpectedError)(b)}}}}e.ImplicitActivationEventsImpl=M,e.ImplicitActivationEvents=new M}),define(ee[193],te([0,1,18,84,162,194]),function(G,e,E,M,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function f(h){return h=h.trim(),h==="*"||D.test(h)}e.isValidVersionStr=f;function d(h){if(!f(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=h.match(D);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=d;function b(h){if(!h)return null;const p=h.majorBase,k=h.majorMustEqual,S=h.minorBase;let R=h.minorMustEqual;const t=h.patchBase;let a=h.patchMustEqual;h.hasCaret&&(p===0||(R=!1),a=!1);let i=0;if(h.preRelease){const s=P.exec(h.preRelease);if(s){const[,c,u,r]=s;i=Date.UTC(Number(c),Number(u)-1,Number(r))}}return{majorBase:p,majorMustEqual:k,minorBase:S,minorMustEqual:R,patchBase:t,patchMustEqual:a,isMinimum:h.hasGreaterEquals,notBefore:i}}e.normalizeVersion=b;function v(h,p,k){let S;typeof h=="string"?S=b(d(h)):S=h;let R;p instanceof Date?R=p.getTime():typeof p=="string"&&(R=new Date(p).getTime());let t;if(typeof k=="string"?t=b(d(k)):t=k,!S||!t)return!1;const a=S.majorBase,i=S.minorBase,s=S.patchBase;let c=t.majorBase,u=t.minorBase,r=t.patchBase;const l=t.notBefore;let I=t.majorMustEqual,A=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?a>c?!0:a<c?!1:i>u?!0:i<u||R&&R<l?!1:s>=r:(a===1&&c===0&&(!I||!A||!O)&&(c=1,u=0,r=0,I=!0,A=!1,O=!1),a<c?!1:a>c?!I:i<u?!1:i>u?!A:s<r?!1:s>r?!O:!(R&&R<l))}e.isValidVersion=v;function y(h,p,k,S,R){const t=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return t.push([M.default.Error,n.localize(0,null)]),t;if(typeof S.name!="string")return t.push([M.default.Error,n.localize(1,null,"name")]),t;if(typeof S.version!="string")return t.push([M.default.Error,n.localize(2,null,"version")]),t;if(!S.engines)return t.push([M.default.Error,n.localize(3,null,"engines")]),t;if(typeof S.engines.vscode!="string")return t.push([M.default.Error,n.localize(4,null,"engines.vscode")]),t;if(typeof S.extensionDependencies<"u"&&!o(S.extensionDependencies))return t.push([M.default.Error,n.localize(5,null,"extensionDependencies")]),t;if(typeof S.activationEvents<"u"){if(!o(S.activationEvents))return t.push([M.default.Error,n.localize(6,null,"activationEvents")]),t;if(typeof S.main>"u"&&typeof S.browser>"u")return t.push([M.default.Error,n.localize(7,null,"activationEvents","main")]),t}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&t.push([M.default.Warning,n.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return t.push([M.default.Error,n.localize(9,null,"main")]),t;{const s=(0,E.joinPath)(k,S.main);(0,E.isEqualOrParent)(s,k)||t.push([M.default.Warning,n.localize(10,null,s.path,k.path)])}if(typeof S.activationEvents>"u")return t.push([M.default.Error,n.localize(11,null,"activationEvents","main")]),t}if(typeof S.browser<"u"){if(typeof S.browser!="string")return t.push([M.default.Error,n.localize(12,null,"browser")]),t;{const s=(0,E.joinPath)(k,S.browser);(0,E.isEqualOrParent)(s,k)||t.push([M.default.Warning,n.localize(13,null,s.path,k.path)])}if(typeof S.activationEvents>"u")return t.push([M.default.Error,n.localize(14,null,"activationEvents","browser")]),t}if(!C.valid(S.version))return t.push([M.default.Error,n.localize(15,null)]),t;const a=[];if(!g(h,p,S,R,a))for(const s of a)t.push([M.default.Error,s]);return t}e.validateExtensionManifest=y;function g(h,p,k,S,R){return S||typeof k.main>"u"&&typeof k.browser>"u"?!0:w(h,p,k.engines.vscode,R)}e.isValidExtensionVersion=g;function m(h,p,k){return h==="*"||w(p,k,h)}e.isEngineValid=m;function w(h,p,k,S=[]){const R=b(d(k));if(!R)return S.push(n.localize(16,null,k)),!1;if(R.majorBase===0){if(!R.majorMustEqual||!R.minorMustEqual)return S.push(n.localize(17,null,k)),!1}else if(!R.majorMustEqual)return S.push(n.localize(18,null,k)),!1;return v(h,p,R)?!0:(S.push(n.localize(19,null,h,k)),!1)}function o(h){if(!Array.isArray(h))return!1;for(let p=0,k=h.length;p<k;p++)if(typeof h[p]!="string")return!1;return!0}}),define(ee[195],te([0,1,17,31]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function n(C,D,P){let f=P&&P.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const b=(await D.readFile(C.serviceMachineIdResource)).value.toString();f=(0,M.isUUID)(b)?b:null}catch{f=null}if(!f){f=(0,M.generateUuid)();try{await D.writeFile(C.serviceMachineIdResource,E.VSBuffer.fromString(f))}catch{}}return P?.store("storage.serviceMachineId",f,-1,1),f}e.getServiceMachineId=n}),define(ee[74],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class E{constructor(n,C=[],D=!1){this.ctor=n,this.staticArguments=C,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=E}),define(ee[196],te([0,1,74]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const M=[];var n;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(n=e.InstantiationType||(e.InstantiationType={}));function C(P,f,d){f instanceof E.SyncDescriptor||(f=new E.SyncDescriptor(f,[],Boolean(d))),M.push([P,f])}e.registerSingleton=C;function D(){return M}e.getSingletonServiceDescriptors=D}),define(ee[197],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(C,D){this.key=C,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=E;class M{constructor(C){this.b=C,this.a=new Map}roots(){const C=[];for(const D of this.a.values())D.outgoing.size===0&&C.push(D);return C}insertEdge(C,D){const P=this.lookupOrInsertNode(C),f=this.lookupOrInsertNode(D);P.outgoing.set(f.key,f),f.incoming.set(P.key,P)}removeNode(C){const D=this.b(C);this.a.delete(D);for(const P of this.a.values())P.outgoing.delete(D),P.incoming.delete(D)}lookupOrInsertNode(C){const D=this.b(C);let P=this.a.get(D);return P||(P=new E(D,C),this.a.set(D,P)),P}lookup(C){return this.a.get(this.b(C))}isEmpty(){return this.a.size===0}toString(){const C=[];for(const[D,P]of this.a)C.push(`${D}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return C.join(`
`)}findCycleSlow(){for(const[C,D]of this.a){const P=new Set([C]),f=this.c(D,P);if(f)return f}}c(C,D){for(const[P,f]of C.outgoing){if(D.has(P))return[...D,P].join(" -> ");D.add(P);const d=this.c(f,D);if(d)return d;D.delete(P)}}}e.Graph=M}),define(ee[6],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function P(f){return f[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=P})(E=e._util||(e._util={})),e.IInstantiationService=n("instantiationService");function M(D,P,f){P[E.DI_TARGET]===P?P[E.DI_DEPENDENCIES].push({id:D,index:f}):(P[E.DI_DEPENDENCIES]=[{id:D,index:f}],P[E.DI_TARGET]=P)}function n(D){if(E.serviceIds.has(D))return E.serviceIds.get(D);const P=function(f,d,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(P,f,b)};return P.toString=()=>D,E.serviceIds.set(D,P),P}e.createDecorator=n;function C(D){return D}e.refineServiceDecorator=C}),define(ee[63],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,E.createDecorator)("backupMainService")}),define(ee[19],te([0,1,10,7,6]),function(G,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,n.createDecorator)("configurationService");function C(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof M.URI)}e.isConfigurationOverrides=C;function D(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof M.URI)}e.isConfigurationUpdateOverrides=D;var P;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function f(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=f;function d(o,h){const p=Object.create(null);for(const k in o)b(p,k,o[k],h);return p}e.toValuesTree=d;function b(o,h,p,k){const S=h.split("."),R=S.pop();let t=o;for(let a=0;a<S.length;a++){const i=S[a];let s=t[i];switch(typeof s){case"undefined":s=t[i]=Object.create(null);break;case"object":break;default:k(`Ignoring ${h} as ${S.slice(0,a+1).join(".")} is ${JSON.stringify(s)}`);return}t=s}if(typeof t=="object"&&t!==null)try{t[R]=p}catch{k(`Ignoring ${h} as ${S.join(".")} is ${JSON.stringify(t)}`)}else k(`Ignoring ${h} as ${S.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=b;function v(o,h){const p=h.split(".");y(o,p)}e.removeFromValueTree=v;function y(o,h){const p=h.shift();if(h.length===0){delete o[p];return}if(Object.keys(o).indexOf(p)!==-1){const k=o[p];typeof k=="object"&&!Array.isArray(k)&&(y(k,h),Object.keys(k).length===0&&delete o[p])}}function g(o,h,p){function k(t,a){let i=t;for(const s of a){if(typeof i!="object"||i===null)return;i=i[s]}return i}const S=h.split("."),R=k(o,S);return typeof R>"u"?p:R}e.getConfigurationValue=g;function m(o,h,p){Object.keys(h).forEach(k=>{k!=="__proto__"&&(k in o?E.isObject(o[k])&&E.isObject(h[k])?m(o[k],h[k],p):p&&(o[k]=h[k]):o[k]=h[k])})}e.merge=m;function w(o){return o.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=w}),define(ee[75],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,E.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,E.createDecorator)("credentialsMainService");class M{constructor(){this.a={}}async getPassword(C,D){return this.a[C]?.[D]??null}async setPassword(C,D,P){this.a[C]=this.a[C]??{},this.a[C][D]=P}async deletePassword(C,D){return this.a[C]?.[D]?(delete this.a[C][D],Object.keys(this.a[C]).length===0&&delete this.a[C],!0):!1}async findPassword(C){return JSON.stringify(this.a[C])??null}async findCredentials(C){const D=[];for(const P of Object.keys(this.a[C]||{}))D.push({account:P,password:this.a[C][P]});return D}async clear(){this.a={}}}e.InMemoryCredentialsProvider=M}),define(ee[88],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,E.createDecorator)(e.ID);function M(C){return!!C.hostName&&!!C.errorMessage}e.isRemoteDiagnosticError=M;class n{async getPerformanceInfo(D,P){return{}}async getSystemInfo(D,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,P){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=n}),define(ee[48],te([0,1,18,155,6,45,4,40]),function(G,e,E,M,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.IDialogService=void 0,e.IDialogService=(0,n.createDecorator)("dialogService"),e.IFileDialogService=(0,n.createDecorator)("fileDialogService");var f;(function(y){y[y.SAVE=0]="SAVE",y[y.DONT_SAVE=1]="DONT_SAVE",y[y.CANCEL=2]="CANCEL"})(f=e.ConfirmResult||(e.ConfirmResult={}));const d=10;function b(y){const g=[];return g.push(...y.slice(0,d).map(m=>typeof m=="string"?m:(0,E.basename)(m))),y.length>d&&(y.length-d===1?g.push((0,M.localize)(0,null)):g.push((0,M.localize)(1,null,y.length-d))),g.push(""),g.join(`
`)}e.getFileNamesMessage=b;function v(y,g){const m=(0,P.deepClone)(y);let w=(m.buttons??[]).map(k=>(0,C.mnemonicButtonLabel)(k)),o=(y.buttons||[]).map((k,S)=>S),h=0,p=m.cancelId??w.length-1;if(w.length>1)if(D.isLinux){const k=typeof p=="number"?w[p]:void 0;if(w=w.reverse(),o=o.reverse(),h=w.length-1,typeof k=="string"&&(p=w.indexOf(k),p!==w.length-2)){w.splice(p,1),w.splice(w.length-1,0,k);const S=o[p];o.splice(p,1),o.splice(o.length-1,0,S),p=w.length-2}}else if(D.isWindows){const k=typeof p=="number"?w[p]:void 0;if(typeof k=="string"&&(p=w.indexOf(k),p!==w.length-1)){w.splice(p,1),w.push(k);const S=o[p];o.splice(p,1),o.push(S),p=w.length-1}}else D.isMacintosh;return m.buttons=w,m.defaultId=h,m.cancelId=p,m.noLink=!0,m.title=m.title||g.nameLong,{options:m,buttonIndeces:o}}e.massageMessageBoxOptions=v}),define(ee[108],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,E.createDecorator)("encryptionMainService")}),define(ee[33],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[28],te([0,1,55,9,87,33,189,6]),function(G,e,E,M,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,P.refineServiceDecorator)(C.IEnvironmentService);class f extends D.NativeEnvironmentService{get cachedLanguagesPath(){return(0,M.join)(this.userDataPath,"clp")}get backupHome(){return(0,M.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,n.createStaticIPCHandle)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,M.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ve([E.memoize],f.prototype,"cachedLanguagesPath",null),ve([E.memoize],f.prototype,"backupHome",null),ve([E.memoize],f.prototype,"mainIPCHandle",null),ve([E.memoize],f.prototype,"mainLockfile",null),ve([E.memoize],f.prototype,"disableUpdates",null),ve([E.memoize],f.prototype,"disableKeytar",null),ve([E.memoize],f.prototype,"crossOriginIsolated",null),ve([E.memoize],f.prototype,"codeCachePath",null),ve([E.memoize],f.prototype,"useCodeCache",null),e.EnvironmentMainService=f}),define(ee[198],te([0,1,159,6]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough";function n(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=n;function C(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=C;function D(h,p){switch(h){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function P(h,p){return p==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function f(h,p,k){return P(p,k)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===k?!0:d(k).includes(h)}e.isTargetPlatformCompatible=f;function d(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=d;function b(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=b;var v;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(v=e.SortBy||(e.SortBy={}));var y;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var g;(function(h){h.Install="install",h.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var m;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,M.createDecorator)("extensionGalleryService");var w;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal",h.Signature="Signature"})(w=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class o extends Error{constructor(p,k){super(p),this.code=k,this.name=k}}e.ExtensionManagementError=o,e.IExtensionManagementService=(0,M.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,M.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,M.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,E.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ee[199],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,E.createDecorator)("extensionUrlTrustService")}),define(ee[200],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,E.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[109],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,E.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,E.createDecorator)("externalTerminal")}),define(ee[201],te([0,1,46,15,9,4,83,23,86,163,109]),function(G,e,E,M,n,C,D,P,f,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const v=d.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:g.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class g extends y{openTerminal(S,R){return this.spawnTerminal(E,S,f.getWindowsShell(),R)}spawnTerminal(S,R,t,a){const i=R.windowsExec||g.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const s=n.basename(i,".exe").toLowerCase();if(s==="cmder")return S.spawn(i,a?[a]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return i.indexOf(" ")>=0&&c.push('""'),c.push(i),s==="wt"&&c.push("-d ."),new Promise((u,r)=>{const l=o(process),I=S.spawn(t,c,{cwd:a,env:l});I.on("error",r),I.on("exit",()=>u())})}runInTerminal(S,R,t,a,i){const s="windowsExec"in i&&i.windowsExec?i.windowsExec:g.getDefaultTerminalWindows();return new Promise((c,u)=>{const r=`"${R} - ${v}"`,l=`""${t.join('" "')}" & pause"`,I=Object.assign({},o(process),a);Object.keys(I).filter(V=>I[V]===null).forEach(V=>delete I[V]);const A={cwd:R,env:I,windowsVerbatimArguments:!0};let O,N;n.basename(s,".exe")==="wt"?(O=s,N=["-d",".",g.b,"/c",l]):(O=g.b,N=["/c","start",r,"/wait",s,"/c",l]),E.spawn(O,N,A).on("error",V=>{u(h(V))}),c(void 0)})}static getDefaultTerminalWindows(){if(!g.d){const S=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");g.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${S?"Sysnative":"System32"}\\cmd.exe`}return g.d}}g.b="cmd.exe",e.WindowsExternalTerminalService=g;class m extends y{openTerminal(S,R){return this.spawnTerminal(E,S,R)}runInTerminal(S,R,t,a,i){const s=i.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((c,u)=>{if(s===b.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const r=s===b.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",I=[M.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${r}.scpt`).fsPath,"-t",S||v,"-w",R];for(const N of t)I.push("-a"),I.push(N);if(a){const N=Object.assign({},o(process),a);for(const X in N){const V=N[X];V===null?(I.push("-u"),I.push(X)):(I.push("-e"),I.push(`${X}=${V}`))}}let A="";const O=E.spawn(m.b,I);O.on("error",N=>{u(h(N))}),O.stderr.on("data",N=>{A+=N.toString()}),O.on("exit",N=>{if(N===0)c(void 0);else if(A){const X=A.split(`
`,1);u(new Error(X[0]))}else u(new Error(d.localize(1,null,r,N)))})}else u(new Error(d.localize(2,null,s)))})}spawnTerminal(S,R,t){const a=R.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((i,s)=>{const c=["-a",a];t&&c.push(t);const u=o(process),r=S.spawn("/usr/bin/open",c,{cwd:t,env:u});r.on("error",s),r.on("exit",()=>i())})}}m.b="/usr/bin/osascript",e.MacExternalTerminalService=m;class w extends y{openTerminal(S,R){return this.spawnTerminal(E,S,R)}runInTerminal(S,R,t,a,i){const s=i.linuxExec?Promise.resolve(i.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((c,u)=>{const r=[];s.then(l=>{l.indexOf("gnome-terminal")>=0?r.push("-x"):r.push("-e"),r.push("bash"),r.push("-c");const I=`${p(t)}; echo; read -p "${w.b}" -n1;`;r.push(`''${I}''`);const A=Object.assign({},o(process),a);Object.keys(A).filter(V=>A[V]===null).forEach(V=>delete A[V]);const O={cwd:R,env:A};let N="";const X=E.spawn(l,r,O);X.on("error",V=>{u(h(V))}),X.stderr.on("data",V=>{N+=V.toString()}),X.on("exit",V=>{if(V===0)c(void 0);else if(N){const K=N.split(`
`,1);u(new Error(K[0]))}else u(new Error(d.localize(4,null,l,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!C.isLinux)w.d=Promise.resolve("xterm");else{const S=await P.Promises.exists("/etc/debian_version");w.d=new Promise(R=>{S?R("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?R("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?R("konsole"):process.env.COLORTERM?R(process.env.COLORTERM):process.env.TERM?R(process.env.TERM):R("xterm")})}return w.d}spawnTerminal(S,R,t){const a=R.linuxExec?Promise.resolve(R.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((i,s)=>{a.then(c=>{const u=o(process),r=S.spawn(c,[],{cwd:t,env:u});r.on("error",s),r.on("exit",()=>i())})})}}w.b=d.localize(3,null),e.LinuxExternalTerminalService=w;function o(k){const S={...k.env};return(0,D.sanitizeProcessEnvironment)(S),S}function h(k){return"errno"in k&&k.errno==="ENOENT"&&"path"in k&&typeof k.path=="string"?new Error(d.localize(5,null,k.path)):k}function p(k){let S="";for(const R of k)R.indexOf(" ")>=0?S+='"'+R+'"':S+=R,S+=" ";return S}}),define(ee[16],te([0,1,61,9,27,10,7,165,6,4]),function(G,e,E,M,n,C,D,P,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function b(F){return F.create===!0}e.isFileOpenForWriteOptions=b;var v;(function(F){F[F.Unknown=0]="Unknown",F[F.File=1]="File",F[F.Directory=2]="Directory",F[F.SymbolicLink=64]="SymbolicLink"})(v=e.FileType||(e.FileType={}));var y;(function(F){F[F.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var g;(function(F){F[F.None=0]="None",F[F.FileReadWrite=2]="FileReadWrite",F[F.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",F[F.FileReadStream=16]="FileReadStream",F[F.FileFolderCopy=8]="FileFolderCopy",F[F.PathCaseSensitive=1024]="PathCaseSensitive",F[F.Readonly=2048]="Readonly",F[F.Trash=4096]="Trash",F[F.FileWriteUnlock=8192]="FileWriteUnlock",F[F.FileAtomicRead=16384]="FileAtomicRead",F[F.FileClone=32768]="FileClone"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(F){return!!(F.capabilities&2)}e.hasReadWriteCapability=m;function w(F){return!!(F.capabilities&8)}e.hasFileFolderCopyCapability=w;function o(F){return!!(F.capabilities&32768)}e.hasFileCloneCapability=o;function h(F){return!!(F.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function p(F){return!!(F.capabilities&16)}e.hasFileReadStreamCapability=p;function k(F){return m(F)?!!(F.capabilities&16384):!1}e.hasFileAtomicReadCapability=k;var S;(function(F){F.FileExists="EntryExists",F.FileNotFound="EntryNotFound",F.FileNotADirectory="EntryNotADirectory",F.FileIsADirectory="EntryIsADirectory",F.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",F.FileTooLarge="EntryTooLarge",F.FileWriteLocked="EntryWriteLocked",F.NoPermissions="NoPermissions",F.Unavailable="Unavailable",F.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class R extends Error{constructor(W,z){super(W),this.code=z}}e.FileSystemProviderError=R;function t(F,W){const z=new R(F.toString(),W);return i(z,W),z}e.createFileSystemProviderError=t;function a(F){return F||t((0,P.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=a;function i(F,W){return F.name=W?`${W} (FileSystemError)`:"FileSystemError",F}e.markAsFileSystemProviderError=i;function s(F){if(!F)return S.Unknown;if(F instanceof R)return F.code;const W=/^(.+) \(FileSystemError\)$/.exec(F.name);if(!W)return S.Unknown;switch(W[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=s;function c(F){if(F instanceof O)return F.fileOperationResult;switch(s(F)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=c;var u;(function(F){F[F.CREATE=0]="CREATE",F[F.DELETE=1]="DELETE",F[F.MOVE=2]="MOVE",F[F.COPY=3]="COPY",F[F.WRITE=4]="WRITE"})(u=e.FileOperation||(e.FileOperation={}));class r{constructor(W,z,J){this.resource=W,this.operation=z,this.target=J}isOperation(W){return this.operation===W}}e.FileOperationEvent=r;var l;(function(F){F[F.UPDATED=0]="UPDATED",F[F.ADDED=1]="ADDED",F[F.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class I{constructor(W,z){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const J=new Map;for(const ne of W){const se=J.get(ne.type);switch(se?se.push([ne.resource,ne]):J.set(ne.type,[[ne.resource,ne]]),ne.type){case 1:this.rawAdded.push(ne.resource);break;case 0:this.rawUpdated.push(ne.resource);break;case 2:this.rawDeleted.push(ne.resource);break}}for(const[ne,se]of J)switch(ne){case 1:this.a=E.TernarySearchTree.forUris(()=>z),this.a.fill(se);break;case 0:this.b=E.TernarySearchTree.forUris(()=>z),this.b.fill(se);break;case 2:this.c=E.TernarySearchTree.forUris(()=>z),this.c.fill(se);break}}contains(W,...z){return this.d(W,{includeChildren:!1},...z)}affects(W,...z){return this.d(W,{includeChildren:!0},...z)}d(W,z,...J){if(!W)return!1;const ne=J.length>0;return!!((!ne||J.includes(1))&&(this.a?.get(W)||z.includeChildren&&this.a?.findSuperstr(W))||(!ne||J.includes(0))&&(this.b?.get(W)||z.includeChildren&&this.b?.findSuperstr(W))||(!ne||J.includes(2))&&(this.c?.findSubstr(W)||z.includeChildren&&this.c?.findSuperstr(W)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=I;function A(F,W,z){return!F||!W||F===W||W.length>F.length?!1:(W.charAt(W.length-1)!==M.sep&&(W+=M.sep),z?(0,n.startsWithIgnoreCase)(F,W):F.indexOf(W)===0)}e.isParent=A;class O extends Error{constructor(W,z,J){super(W),this.fileOperationResult=z,this.options=J}}e.FileOperationError=O;class N extends O{constructor(W,z,J,ne){super(W,z,ne),this.fileOperationResult=z,this.size=J}}e.TooLargeFileOperationError=N;class X extends O{constructor(W,z,J){super(W,2,J),this.stat=z}}e.NotModifiedSinceFileOperationError=X;var V;(function(F){F[F.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",F[F.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",F[F.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",F[F.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",F[F.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",F[F.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",F[F.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",F[F.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",F[F.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",F[F.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",F[F.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",F[F.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(V=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var K;(function(F){F[F.FILE=0]="FILE",F[F.FOLDER=1]="FOLDER",F[F.ROOT_FOLDER=2]="ROOT_FOLDER"})(K=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function ie(F){if(!(typeof F.size!="number"||typeof F.mtime!="number"))return F.mtime.toString(29)+F.size.toString(31)}e.etag=ie;async function re(F,W){if(!W.hasProvider(D.URI.from({scheme:F.scheme})))return new Promise(z=>{const J=W.onDidChangeFileSystemProviderRegistrations(ne=>{ne.scheme===F.scheme&&ne.added&&(J.dispose(),z())})})}e.whenProviderRegistered=re,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ce{static formatSize(W){return(0,C.isNumber)(W)||(W=0),W<ce.KB?(0,P.localize)(1,null,W.toFixed(0)):W<ce.MB?(0,P.localize)(2,null,(W/ce.KB).toFixed(2)):W<ce.GB?(0,P.localize)(3,null,(W/ce.MB).toFixed(2)):W<ce.TB?(0,P.localize)(4,null,(W/ce.GB).toFixed(2)):(0,P.localize)(5,null,(W/ce.TB).toFixed(2))}}ce.KB=1024,ce.MB=ce.KB*ce.KB,ce.GB=ce.MB*ce.KB,ce.TB=ce.GB*ce.KB,e.ByteSize=ce;var fe;(function(F){F[F.IA32=0]="IA32",F[F.OTHER=1]="OTHER"})(fe=e.Arch||(e.Arch={}));function ge(F){return{maxFileSize:F===0?300*ce.MB:16*ce.GB,maxHeapSize:F===0?700*ce.MB:2*700*ce.MB}}e.getPlatformFileLimits=ge;function x(F){return d.isWeb?F?10*ce.MB:50*ce.MB:F?100*ce.MB:1024*ce.MB}e.getLargeFileConfirmationLimit=x}),define(ee[202],te([0,1,17,44,13,3,2,60,7,31,16]),function(G,e,E,M,n,C,D,P,f,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class v extends D.Disposable{constructor(g,m){super(),this.a=g,this.b=m,this.onDidChangeCapabilities=C.Event.None,this.f=this.B(new C.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new C.Emitter),this.onDidWatchError=this.g.event,this.h=(0,d.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(g){return this.a.call("stat",[g])}readdir(g){return this.a.call("readdir",[g])}async readFile(g,m){const{buffer:w}=await this.a.call("readFile",[g,m]);return w}readFileStream(g,m,w){const o=(0,P.newWriteableStream)(p=>E.VSBuffer.concat(p.map(k=>E.VSBuffer.wrap(k))).buffer),h=this.a.listen("readFileStream",[g,m])(p=>{if(p instanceof E.VSBuffer)o.write(p.buffer);else{if(p==="end")o.end();else{let k;if(p instanceof Error)k=p;else{const S=p;k=(0,b.createFileSystemProviderError)(S.message??(0,M.toErrorMessage)(S),S.code??b.FileSystemProviderErrorCode.Unknown)}o.error(k),o.end()}h.dispose()}});return w.onCancellationRequested(()=>{o.error((0,n.canceled)()),o.end(),h.dispose()}),o}writeFile(g,m,w){return this.a.call("writeFile",[g,E.VSBuffer.wrap(m),w])}open(g,m){return this.a.call("open",[g,m])}close(g){return this.a.call("close",[g])}async read(g,m,w,o,h){const[p,k]=await this.a.call("read",[g,m,h]);return w.set(p.buffer.slice(0,k),o),k}write(g,m,w,o,h){return this.a.call("write",[g,m,E.VSBuffer.wrap(w),o,h])}mkdir(g){return this.a.call("mkdir",[g])}delete(g,m){return this.a.call("delete",[g,m])}rename(g,m,w){return this.a.call("rename",[g,m,w])}copy(g,m,w){return this.a.call("copy",[g,m,w])}cloneFile(g,m){return this.a.call("cloneFile",[g,m])}i(){this.B(this.a.listen("fileChange",[this.h])(g=>{if(Array.isArray(g)){const m=g;this.f.fire(m.map(w=>({resource:f.URI.revive(w.resource),type:w.type})))}else{const m=g;this.g.fire(m)}}))}watch(g,m){const w=(0,d.generateUuid)();return this.a.call("watch",[this.h,w,g,m]),(0,D.toDisposable)(()=>this.a.call("unwatch",[this.h,w]))}}e.DiskFileSystemProviderClient=v}),define(ee[110],te([0,1,17,13,166,16]),function(G,e,E,M,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(b,v,y,g,m,w){let o;try{await P(b,v,y,g,m,w)}catch(h){o=h}finally{o&&m.errorTransformer&&(o=m.errorTransformer(o)),typeof o<"u"&&y.error(o),y.end()}}e.readFileIntoStream=D;async function P(b,v,y,g,m,w){f(w);const o=await b.open(v,{create:!1});try{f(w);let h=0,p=0,k=m&&typeof m.length=="number"?m.length:void 0,S=E.VSBuffer.alloc(Math.min(m.bufferSize,typeof k=="number"?k:m.bufferSize)),R=m&&typeof m.position=="number"?m.position:0,t=0;do p=await b.read(o,R,S.buffer,t,S.byteLength-t),R+=p,t+=p,h+=p,typeof k=="number"&&(k-=p),t===S.byteLength&&(await y.write(g(S)),S=E.VSBuffer.alloc(Math.min(m.bufferSize,typeof k=="number"?k:m.bufferSize)),t=0);while(p>0&&(typeof k!="number"||k>0)&&f(w)&&d(h,m));if(t>0){let a=t;typeof k=="number"&&(a=Math.min(t,k)),y.write(g(S.slice(0,a)))}}catch(h){throw(0,C.ensureFileSystemProviderError)(h)}finally{await b.close(o)}}function f(b){if(b.isCancellationRequested)throw(0,M.canceled)();return!0}function d(b,v){if(v?.limits){if(typeof v.limits.memory=="number"&&b>v.limits.memory)throw(0,C.createFileSystemProviderError)((0,n.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof v.limits.size=="number"&&b>v.limits.size)throw(0,C.createFileSystemProviderError)((0,n.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[76],te([0,1,101,2,9,4,7,16]),function(G,e,E,M,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function f(h){return h.recursive===!0}e.isRecursiveWatchRequest=f;class d extends M.Disposable{constructor(p,k,S,R){super(),this.h=p,this.i=k,this.j=S,this.k=R,this.c=this.B(new M.MutableDisposable),this.f=void 0,this.g=0}m(){const p=new M.DisposableStore;this.c.value=p,this.b=this.l(p),this.b.setVerboseLogging(this.j),p.add(this.b.onDidChangeFile(k=>this.h(k))),p.add(this.b.onDidLogMessage(k=>this.i(k))),p.add(this.b.onDidError(k=>this.n(k)))}n(p){this.k.restartOnError?this.g<d.a&&this.f?(this.r(`restarting watcher after error: ${p}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${p}`):this.r(p)}p(p){this.g++,this.m(),this.watch(p)}async watch(p){this.f=p,await this.b?.watch(p)}async setVerboseLogging(p){this.j=p,await this.b?.setVerboseLogging(p)}r(p){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${p}`})}dispose(){return this.b=void 0,super.dispose()}}d.a=5,e.AbstractWatcherClient=d;class b extends d{constructor(p,k,S){super(p,k,S,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=b;class v extends d{constructor(p,k,S){super(p,k,S,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=v;function y(h){return h.map(p=>({type:p.type,resource:D.URI.file(p.path)}))}e.toFileChanges=y;function g(h){const p=new o;for(const k of h)p.processEvent(k);return p.coalesce()}e.coalesceEvents=g;function m(h,p){return typeof p=="string"&&!p.startsWith(E.GLOBSTAR)&&!(0,n.isAbsolute)(p)?{base:h,pattern:p}:p}e.normalizeWatcherPattern=m;function w(h,p){const k=[];for(const S of p)k.push((0,E.parse)(m(h,S)));return k}e.parseWatcherPatterns=w;class o{constructor(){this.a=new Set,this.b=new Map}c(p){return C.isLinux?p.path:p.path.toLowerCase()}processEvent(p){const k=this.b.get(this.c(p));let S=!1;if(k){const R=k.type,t=p.type;k.path!==p.path&&(p.type===2||p.type===1)?S=!0:R===1&&t===2?(this.b.delete(this.c(p)),this.a.delete(k)):R===2&&t===1?k.type=0:R===1&&t===0||(k.type=t)}else S=!0;S&&(this.a.add(p),this.b.set(this.c(p),p))}coalesce(){const p=[],k=[];return Array.from(this.a).filter(S=>S.type!==2?(p.push(S),!1):!0).sort((S,R)=>S.path.length-R.path.length).filter(S=>k.some(R=>(0,P.isParent)(S.path,R,!C.isLinux))?!1:(k.push(S.path),!0)).concat(p)}}}),define(ee[203],te([0,1,41,8,22,32,2,80,9,4,102,23,76]),function(G,e,E,M,n,C,D,P,f,d,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class g extends D.Disposable{constructor(o,h,p,k){super(),this.j=o,this.k=h,this.l=p,this.m=k,this.c=this.B(new M.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},S=>this.k(S))),this.f=this.B(new M.RunOnceWorker(S=>this.u(S),g.b)),this.g=(0,y.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,y.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new n.CancellationTokenSource,this.ready=this.n()}async n(){try{const o=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const h=await v.Promises.stat(o);this.B(await this.s(o,h.isDirectory()))}catch(o){o.code!=="ENOENT"?this.w(o):this.z(o)}}async r(o){let h=o.path;try{h=await v.Promises.realpath(o.path),o.path===h&&(h=await(0,b.realcase)(o.path)??o.path),o.path!==h&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${o.path}, real: ${h})`)}catch{}return h}async s(o,h){if(d.isMacintosh&&(0,C.isEqualOrParent)(o,"/Volumes/",!0))return this.w(`Refusing to watch ${o} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const p=new n.CancellationTokenSource(this.i.token),k=new D.DisposableStore;try{const S=(0,f.basename)(o),R=(0,E.watch)(o);k.add((0,D.toDisposable)(()=>{R.removeAllListeners(),R.close()})),this.z(`Started watching: '${o}'`);const t=new Set;if(h)try{for(const i of await v.Promises.readdir(o))t.add(i)}catch(i){this.w(i)}const a=new Map;k.add((0,D.toDisposable)(()=>{for(const[,i]of a)i.dispose();a.clear()})),R.on("error",(i,s)=>{this.w(`Failed to watch ${o} for changes using fs.watch() (${i}, ${s})`),this.dispose()}),R.on("change",(i,s)=>{if(p.token.isCancellationRequested)return;this.z(`[raw] ["${i}"] ${s}`);let c="";if(s&&(c=s.toString(),d.isMacintosh&&(c=(0,P.normalizeNFC)(c))),!(!c||i!=="change"&&i!=="rename"))if(h)if(i==="rename"){a.get(c)?.dispose();const u=setTimeout(async()=>{if(a.delete(c),c===S&&!await v.Promises.exists(o)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const r=await this.v((0,f.join)(o,c));if(p.token.isCancellationRequested)return;let l;r?t.has(c)?l=0:(l=1,t.add(c)):(t.delete(c),l=2),this.t({path:(0,f.join)(this.j.path,c),type:l})},g.a);a.set(c,(0,D.toDisposable)(()=>clearTimeout(u)))}else{let u;t.has(c)?u=0:(u=1,t.add(c)),this.t({path:(0,f.join)(this.j.path,c),type:u})}else if(i==="rename"||c!==S){const u=setTimeout(async()=>{const r=await v.Promises.exists(o);p.token.isCancellationRequested||(r?(this.t({path:this.j.path,type:0},!0),k.add(await this.s(o,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},g.a);k.clear(),k.add((0,D.toDisposable)(()=>clearTimeout(u)))}else this.t({path:this.j.path,type:0},!0)})}catch(S){await v.Promises.exists(o)&&!p.token.isCancellationRequested&&this.w(`Failed to watch ${o} for changes using fs.watch() (${S.toString()})`)}return(0,D.toDisposable)(()=>{p.dispose(!0),k.dispose()})}t(o,h=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`),!h&&this.g.some(p=>p(o.path))?this.m&&this.z(` >> ignored (excluded) ${o.path}`):!h&&this.h&&this.h.length>0&&!this.h.some(p=>p(o.path))?this.m&&this.z(` >> ignored (not included) ${o.path}`):this.f.work(o))}u(o){const h=(0,y.coalesceEvents)(o);if(h.length>0){if(this.m)for(const k of h)this.z(`>> normalized ${k.type===1?"[ADDED]":k.type===2?"[DELETED]":"[CHANGED]"} ${k.path}`);this.c.work(h)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(o){if(d.isLinux)return v.Promises.exists(o);try{const h=(0,f.basename)(o);return(await v.Promises.readdir((0,f.dirname)(o))).some(k=>k===h)}catch(h){return this.z(h),!1}}setVerboseLogging(o){this.m=o}w(o){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${o}`})}y(o){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${o}`})}z(o){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${o}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}g.a=100,g.b=75,e.NodeJSFileWatcherLibrary=g;async function m(w,o,h,p,k=512){const S=await v.Promises.open(w,"r"),R=Buffer.allocUnsafe(k),t=new n.CancellationTokenSource(p);let a,i=!1;const s={path:w,excludes:[],recursive:!1},c=new g(s,u=>{(async()=>{for(const{type:r}of u)if(r===0){if(i)return;i=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:l}=await v.Promises.read(S,R,0,k,null);if(!l||t.token.isCancellationRequested)break;o(R.slice(0,l))}}catch(l){a=new Error(l),t.dispose(!0)}finally{i=!1}}})()});return await c.ready,h(),new Promise((u,r)=>{t.token.onCancellationRequested(async()=>{c.dispose();try{await v.Promises.close(S)}catch(l){a=new Error(l)}a?r(a):u()})})}e.watchFileContents=m}),define(ee[204],te([0,1,3,101,2,4,203]),function(G,e,E,M,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends n.Disposable{constructor(){super(...arguments),this.a=this.B(new E.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new E.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=E.Event.None,this.c=new Map,this.f=!1}async watch(d){const b=this.i(d),v=b.filter(g=>{const m=this.c.get(g.path);return m?!(0,M.patternsEquals)(m.request.excludes,g.excludes)||!(0,M.patternsEquals)(m.request.includes,g.includes):!0}),y=Array.from(this.c.values()).filter(({request:g})=>!b.find(m=>m.path===g.path&&(0,M.patternsEquals)(m.excludes,g.excludes)&&(0,M.patternsEquals)(m.includes,g.includes))).map(({request:g})=>g.path);v.length&&this.j(`Request to start watching: ${v.map(g=>`${g.path} (excludes: ${g.excludes.length>0?g.excludes:"<none>"}, includes: ${g.includes&&g.includes.length>0?JSON.stringify(g.includes):"<all>"})`).join(",")}`),y.length&&this.j(`Request to stop watching: ${y.join(",")}`);for(const g of y)this.h(g);for(const g of v)this.g(g)}g(d){const b=new D.NodeJSFileWatcherLibrary(d,y=>this.a.fire(y),y=>this.b.fire(y),this.f),v={request:d,instance:b};this.c.set(d.path,v)}async stop(){for(const[d]of this.c)this.h(d);this.c.clear()}h(d){const b=this.c.get(d);b&&(this.c.delete(d),b.instance.dispose())}i(d){const b=new Map;for(const v of d){const y=C.isLinux?v.path:v.path.toLowerCase();b.set(y,v)}return Array.from(b.values())}async setVerboseLogging(d){this.f=d;for(const[,b]of this.c)b.instance.setVerboseLogging(d)}j(d){this.f&&this.b.fire({type:"trace",message:this.k(d)})}k(d,b){return b?`[File Watcher (node.js)] ${d} (path: ${b.request.path})`:`[File Watcher (node.js)] ${d}`}}e.NodeJSWatcher=P}),define(ee[205],te([0,1,76,204]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class n extends E.AbstractNonRecursiveWatcherClient{constructor(D,P,f){super(D,P,f),this.m()}l(){return new M.NodeJSWatcher}}e.NodeJSWatcherClient=n}),define(ee[206],te([0,1,15,47,151,76]),function(G,e,E,M,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends C.AbstractUniversalWatcherClient{constructor(f,d,b){super(f,d,b),this.m()}l(f){const d=f.add(new n.Client(E.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(d.onDidProcessExit(({code:b,signal:v})=>this.n(`terminated by itself with code ${b}, signal: ${v}`))),M.ProxyChannel.toService((0,M.getNextTickChannel)(d.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(ee[89],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...n){this.a=new Map;for(const[C,D]of n)this.set(C,D)}set(n,C){const D=this.a.get(n);return this.a.set(n,C),D}has(n){return this.a.has(n)}get(n){return this.a.get(n)}}e.ServiceCollection=E}),define(ee[207],te([0,1,8,13,2,74,197,6,89,99]),function(G,e,E,M,n,C,D,P,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class v extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class y{constructor(o=new f.ServiceCollection,h=!1,p,k=b){this.f=o,this.g=h,this.h=p,this.i=k,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=k?p?._globalGraph??new D.Graph(S=>S):void 0}createChild(o){return new y(o,this.g,this,this.i)}invokeFunction(o,...h){const p=m.traceInvocation(this.i,o);let k=!1;try{return o({get:R=>{if(k)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(R,p);if(!t)throw new Error(`[invokeFunction] unknown service '${R}'`);return t}},...h)}finally{k=!0,p.stop()}}createInstance(o,...h){let p,k;return o instanceof C.SyncDescriptor?(p=m.traceCreation(this.i,o.ctor),k=this.j(o.ctor,o.staticArguments.concat(h),p)):(p=m.traceCreation(this.i,o),k=this.j(o,h,p)),p.stop(),k}j(o,h=[],p){const k=P._util.getServiceDependencies(o).sort((t,a)=>t.index-a.index),S=[];for(const t of k){const a=this.m(t.id,p);a||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),S.push(a)}const R=k.length>0?k[0].index:h.length;if(h.length!==R){console.trace(`[createInstance] First service dependency of ${o.name} at position ${R+1} conflicts with ${h.length} static arguments`);const t=R-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,R)}return Reflect.construct(o,h.concat(S))}k(o,h){if(this.f.get(o)instanceof C.SyncDescriptor)this.f.set(o,h);else if(this.h)this.h.k(o,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const h=this.f.get(o);return!h&&this.h?this.h.l(o):h}m(o,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const p=this.l(o);return p instanceof C.SyncDescriptor?this.q(o,p,h.branch(o,!0)):(h.branch(o,!1),p)}q(o,h,p){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,h,p)}finally{this.o.delete(o)}}r(o,h,p){const k=new D.Graph(t=>t.id.toString());let S=0;const R=[{id:o,desc:h,_trace:p}];for(;R.length;){const t=R.pop();if(k.lookupOrInsertNode(t),S++>1e3)throw new v(k);for(const a of P._util.getServiceDependencies(t.desc.ctor)){const i=this.l(a.id);if(i||this.u(`[createInstance] ${o} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),i instanceof C.SyncDescriptor){const s={id:a.id,desc:i,_trace:t._trace.branch(a.id,!0)};k.insertEdge(t,s),R.push(s)}}}for(;;){const t=k.roots();if(t.length===0){if(!k.isEmpty())throw new v(k);break}for(const{data:a}of t){if(this.l(a.id)instanceof C.SyncDescriptor){const s=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,s)}k.removeNode(a)}}return this.l(o)}s(o,h,p=[],k,S){if(this.f.get(o)instanceof C.SyncDescriptor)return this.t(o,h,p,k,S);if(this.h)return this.h.s(o,h,p,k,S);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(o,h,p=[],k,S){if(k){const R=new y(void 0,this.g,this,this.i);R.c=String(o);const t=new Map,a=new E.IdleValue(()=>{const i=R.j(h,p,S);for(const[s,c]of t){const u=i[s];if(typeof u=="function")for(const r of c)u.apply(i,r)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,s){if(!a.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let r=t.get(s);return r||(r=new d.LinkedList,t.set(s,r)),(I,A,O)=>{const N=r.push([I,A,O]);return(0,n.toDisposable)(N)}}if(s in i)return i[s];const c=a.value;let u=c[s];return typeof u!="function"||(u=u.bind(c),i[s]=u),u},set(i,s,c){return a.value[s]=c,!0},getPrototypeOf(i){return h.prototype}})}else return this.j(h,p,S)}u(o,h){if(h&&console.warn(o),this.g)throw new Error(o)}}e.InstantiationService=y;var g;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(g||(g={}));class m{static traceInvocation(o,h){return o?new m(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(o,h){return o?new m(1,h.name):m.c}constructor(o,h){this.type=o,this.name=h,this.g=Date.now(),this.h=[]}branch(o,h){const p=new m(3,o.toString());return this.h.push([o,h,p]),p}stop(){const o=Date.now()-this.g;m.f+=o;let h=!1;function p(S,R){const t=[],a=new Array(S+1).join("	");for(const[i,s,c]of R.h)if(s&&c){h=!0,t.push(`${a}CREATES -> ${i}`);const u=p(S+1,c);u&&t.push(u)}else t.push(`${a}uses -> ${i}`);return t.join(`
`)}const k=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(o>2||h)&&m.all.add(k.join(`
`))}}m.all=new Set,m.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}},m.f=0,e.Trace=m}),define(ee[5],te([0,1,44,3,2,35,4,10,7,6]),function(G,e,E,M,n,C,D,P,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,d.createDecorator)("logService"),e.ILoggerService=(0,d.createDecorator)("loggerService");function b(){return new Date().toISOString()}function v(r){return(0,P.isNumber)(r)}e.isLogLevel=v;var y;(function(r){r[r.Off=0]="Off",r[r.Trace=1]="Trace",r[r.Debug=2]="Debug",r[r.Info=3]="Info",r[r.Warning=4]="Warning",r[r.Error=5]="Error"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;function g(r,l,I){switch(l){case y.Trace:r.trace(I);break;case y.Debug:r.debug(I);break;case y.Info:r.info(I);break;case y.Warning:r.warn(I);break;case y.Error:r.error(I);break;case y.Off:break;default:throw new Error(`Invalid log level ${l}`)}}e.log=g;function m(r){let l="";for(let I=0;I<r.length;I++){let A=r[I];if(typeof A=="object")try{A=JSON.stringify(A)}catch{}l+=(I>0?" ":"")+A}return l}e.format=m;class w extends n.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new M.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(l){this.b!==l&&(this.b=l,this.c.fire(this.b))}getLevel(){return this.b}f(l){return this.b!==y.Off&&this.b<=l}}e.AbstractLogger=w;class o extends w{constructor(l){super(),this.h=l}f(l){return this.h||super.f(l)}trace(l,...I){this.f(y.Trace)&&this.g(y.Trace,m([l,...I]))}debug(l,...I){this.f(y.Debug)&&this.g(y.Debug,m([l,...I]))}info(l,...I){this.f(y.Info)&&this.g(y.Info,m([l,...I]))}warn(l,...I){this.f(y.Warning)&&this.g(y.Warning,m([l,...I]))}error(l,...I){if(this.f(y.Error))if(l instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=l.stack,this.g(y.Error,m(A))}else this.g(y.Error,m([l,...I]))}flush(){}}e.AbstractMessageLogger=o;class h extends w{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l),this.g=!D.isWindows}trace(l,...I){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,l,...I):console.log(`[main ${b()}]`,l,...I))}debug(l,...I){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,l,...I):console.log(`[main ${b()}]`,l,...I))}info(l,...I){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,l,...I):console.log(`[main ${b()}]`,l,...I))}warn(l,...I){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,l,...I):console.warn(`[main ${b()}]`,l,...I))}error(l,...I){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,l,...I):console.error(`[main ${b()}]`,l,...I))}dispose(){}flush(){}}e.ConsoleMainLogger=h;class p extends w{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l)}trace(l,...I){this.f(y.Trace)&&console.log("%cTRACE","color: #888",l,...I)}debug(l,...I){this.f(y.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",l,...I)}info(l,...I){this.f(y.Info)&&console.log("%c INFO","color: #33f",l,...I)}warn(l,...I){this.f(y.Warning)&&console.log("%c WARN","color: #993",l,...I)}error(l,...I){this.f(y.Error)&&console.log("%c  ERR","color: #f33",l,...I)}dispose(){}flush(){}}e.ConsoleLogger=p;class k extends w{constructor(l,I=e.DEFAULT_LOG_LEVEL){super(),this.g=l,this.setLevel(I)}trace(l,...I){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(l),...I])}debug(l,...I){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(l),...I])}info(l,...I){this.f(y.Info)&&this.g.log(y.Info,[this.h(l),...I])}warn(l,...I){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(l),...I])}error(l,...I){this.f(y.Error)&&this.g.log(y.Error,[this.h(l),...I])}h(l){return typeof l=="string"?l:(0,E.toErrorMessage)(l,this.f(y.Trace))}dispose(){}flush(){}}e.AdapterLogger=k;class S extends w{constructor(l){super(),this.g=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const I of this.g)I.setLevel(l);super.setLevel(l)}trace(l,...I){for(const A of this.g)A.trace(l,...I)}debug(l,...I){for(const A of this.g)A.debug(l,...I)}info(l,...I){for(const A of this.g)A.info(l,...I)}warn(l,...I){for(const A of this.g)A.warn(l,...I)}error(l,...I){for(const A of this.g)A.error(l,...I)}flush(){for(const l of this.g)l.flush()}dispose(){for(const l of this.g)l.dispose()}}e.MultiplexLogger=S;class R extends n.Disposable{constructor(l,I){if(super(),this.j=l,this.b=new C.ResourceMap,this.c=new C.ResourceMap,this.f=this.B(new M.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new M.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new M.Emitter),this.onDidChangeVisibility=this.h.event,I)for(const A of I)this.c.set(A.resource,A)}getLogger(l){return this.b.get(l)}createLogger(l,I){let A=this.b.get(l);const O=I?.logLevel==="always"?y.Trace:I?.logLevel;return A||(A=this.k(l,O??this.getLogLevel(l)??this.j,I),this.b.set(l,A)),this.registerLogger({resource:l,id:I?.id??l.toString(),logLevel:O,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId}),A}setLogLevel(l,I){if(f.URI.isUri(l)){const A=l,O=I,N=this.c.get(A);N&&O!==N.logLevel&&(N.logLevel=O===this.j?void 0:O,this.b.get(A)?.setLevel(O),this.c.set(N.resource,N),this.g.fire([A,O]))}else{this.j=l;for(const[A,O]of this.b.entries())this.c.get(A)?.logLevel===void 0&&O.setLevel(this.j);this.g.fire(this.j)}}setVisibility(l,I){const A=this.c.get(l);A&&I!==!A.hidden&&(A.hidden=!I,this.c.set(A.resource,A),this.h.fire([l,I]))}getLogLevel(l){let I;return l&&(I=this.c.get(l)?.logLevel),I??this.j}registerLogger(l){const I=this.c.get(l.resource);I?I.hidden!==l.hidden&&this.setVisibility(l.resource,!l.hidden):(this.c.set(l.resource,l),this.f.fire({added:[l],removed:[]}))}deregisterLogger(l){const I=this.c.get(l);if(I){this.c.delete(l);const A=this.b.get(l);A&&(this.b.delete(l),A.dispose()),this.f.fire({added:[],removed:[I]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(l){return this.c.get(l)}dispose(){this.b.forEach(l=>l.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=R;class t{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(l){}getLevel(){return y.Info}trace(l,...I){}debug(l,...I){}info(l,...I){}warn(l,...I){}error(l,...I){}critical(l,...I){}dispose(){}flush(){}}e.NullLogger=t;class a extends t{}e.NullLogService=a;class i extends R{constructor(){super(y.Info)}k(l,I,A){return new t}}e.NullLoggerService=i;function s(r){if(r.verbose)return y.Trace;if(typeof r.logLevel=="string"){const l=u(r.logLevel.toLowerCase());if(l!==void 0)return l}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=s;function c(r){switch(r){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.LogLevelToString=c;function u(r){switch(r){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.parseLogLevel=u});var _=this&&this.__param||function(G,e){return function(E,M){e(E,M,G)}};define(ee[208],te([0,1,75,3,2,5,4,8]),function(G,e,E,M,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let f=class dt extends n.Disposable{constructor(b){super(),this.g=b,this.c=this.B(new M.Emitter),this.onDidChangePassword=this.c.event}async getPassword(b,v){this.g.trace("Getting password from keytar:",b,v);let y;try{y=await this.h()}catch{return null}const g=await(0,P.retry)(()=>y.getPassword(b,v),50,3);if(!g)return this.g.trace("Did not get a password from keytar for account:",v),g;let m,w;try{const o=JSON.parse(g);m=o.content,w=o.hasNextChunk}catch{}if(!m||!w)return this.g.trace("Got password from keytar for account:",v),g;try{let o=1;for(;w;){const h=await(0,P.retry)(()=>y.getPassword(b,`${v}-${o}`),50,3),p=JSON.parse(h);m+=p.content,w=p.hasNextChunk,o++}return this.g.trace(`Got ${o}-chunked password from keytar for account:`,v),m}catch(o){return this.g.error(o),g}}async setPassword(b,v,y){this.g.trace("Setting password using keytar:",b,v);let g;try{g=await this.h()}catch(m){throw this.i?.(m),m}if(D.isWindows&&y.length>dt.a){let m=0,w=0,o=!0;for(;o;){const h=y.substring(m,m+dt.b);m+=dt.b,o=y.length-m>0;const p={content:h,hasNextChunk:o};await(0,P.retry)(()=>g.setPassword(b,w?`${v}-${w}`:v,JSON.stringify(p)),50,3),w++}this.g.trace(`Got${w?` ${w}-chunked`:""} password from keytar for account:`,v)}else await(0,P.retry)(()=>g.setPassword(b,v,y),50,3),this.g.trace("Got password from keytar for account:",v);this.c.fire({service:b,account:v})}async deletePassword(b,v){this.g.trace("Deleting password using keytar:",b,v);let y;try{y=await this.h()}catch(h){throw this.i?.(h),h}const g=await y.getPassword(b,v);if(!g)return this.g.trace("Did not get a password to delete from keytar for account:",v),!1;let m,w;try{const h=JSON.parse(g);m=h.content,w=h.hasNextChunk}catch{}let o=0;if(m&&w)try{for(o++;w;){const h=`${v}-${o}`,p=await y.getPassword(b,h);await y.deletePassword(b,h),w=JSON.parse(p).hasNextChunk,o++}}catch(h){this.g.error(h)}return await y.deletePassword(b,v)?(this.c.fire({service:b,account:v}),this.g.trace(`Deleted${o?` ${o}-chunked`:""} password from keytar for account:`,v),!0):(this.g.trace(`Keytar failed to delete${o?` ${o}-chunked`:""} password for account:`,v),!1)}async findPassword(b){let v;try{v=await this.h()}catch{return null}return await v.findPassword(b)}async findCredentials(b){let v;try{v=await this.h()}catch{return[]}return await v.findCredentials(b)}clear(){return this.f instanceof E.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};f.a=2500,f.b=f.a-100,f=ve([_(0,C.ILogService)],f),e.BaseCredentialsMainService=f}),define(ee[209],te([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let M=class{constructor(C,D){this.a=C,this.b=D}c(){return new Promise((C,D)=>G(["vscode-encrypt"],C,D))}async encrypt(C){let D;try{D=await this.c()}catch{return C}try{return D.encrypt(this.a,C)}catch(P){return this.b.error(P),C}}async decrypt(C){let D;try{D=await this.c()}catch{return C}try{return D.decrypt(this.a,C)}catch(P){return this.b.error(P),C}}};M=ve([_(1,E.ILogService)],M),e.EncryptionMainService=M}),define(ee[210],te([0,1,25,8,13,3,2,9,76,5]),function(G,e,E,M,n,C,D,P,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends D.Disposable{constructor(y,g){super(),this.a=y,this.b=g,this.c=this.B(new C.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new C.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new M.ThrottledDelayer(0)),this.s=[],this.t=this.B(new M.ThrottledDelayer(0))}watch(y,g){return g.recursive||this.b?.watcher?.forceUniversal?this.l(y,g):this.u(y,g)}l(y,g){const m={path:this.C(y),excludes:g.excludes,includes:g.includes,recursive:g.recursive},w=(0,E.insert)(this.j,m);return this.m(),(0,D.toDisposable)(()=>{w(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(y=>(0,n.onUnexpectedError)(y))}n(){this.h||(this.h=this.B(this.p(g=>this.c.fire((0,f.toFileChanges)(g)),g=>this.z(g),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const g of this.j)(0,f.isRecursiveWatchRequest)(g)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const g of this.j)(0,f.isRecursiveWatchRequest)(g)&&y.includes(g.path)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(y,g){const m={path:this.C(y),excludes:g.excludes,includes:g.includes,recursive:!1},w=(0,E.insert)(this.s,m);return this.v(),(0,D.toDisposable)(()=>{w(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(y=>(0,n.onUnexpectedError)(y))}w(){return this.r||(this.r=this.B(this.y(y=>this.c.fire((0,f.toFileChanges)(y)),y=>this.z(y),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)}))),this.r.watch(this.s)}z(y){y.type==="error"&&this.g.fire(y.message),this.a[y.type](y.message)}C(y){return(0,P.normalize)(y.fsPath)}}e.AbstractDiskFileSystemProvider=b}),define(ee[211],te([0,1,25,8,17,22,3,72,70,2,61,15,64,18,60,164,16,110,5,13]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g,m,w,o,h,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let S=class extends d.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new D.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new D.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new D.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new M.ResourceQueue)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${t}`);const i=new d.DisposableStore;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),i.add(a.onDidChangeFile(s=>this.R.fire(new o.FileChangesEvent(s,!this.O(a))))),typeof a.onDidWatchError=="function"&&i.add(a.onDidWatchError(s=>this.S.fire(new Error(s)))),i.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,d.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,d.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(i){a.push(i)}}),!this.h.has(t)&&await M.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&a)}listCapabilities(){return f.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,g.isAbsolutePath)(t))throw new o.FileOperationError((0,w.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const i=new k.ErrorNoTelemetry;throw i.message=(0,w.localize)(1,null,t.toString()),i}return a}async k(t){const a=await this.j(t);if((0,o.hasOpenReadWriteCloseCapability)(a)||(0,o.hasReadWriteCapability)(a)||(0,o.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const a=await this.j(t);if((0,o.hasOpenReadWriteCloseCapability)(a)||(0,o.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.n(t,a)}catch(i){throw(0,o.toFileSystemProviderErrorCode)(i)===o.FileSystemProviderErrorCode.FileNotFound?new o.FileOperationError((0,w.localize)(2,null,this.nb(t)),1):(0,o.ensureFileSystemProviderError)(i)}}async n(t,a){const i=await this.j(t),s=this.O(i),c=a?.resolveTo,u=a?.resolveSingleChildDescendants,r=a?.resolveMetadata,l=await i.stat(t);let I;return this.p(i,t,l,void 0,!!r,(A,O)=>(I||(I=b.TernarySearchTree.forUris(()=>!s),I.set(t,!0),c&&I.fill(!0,c)),I.get(A.resource)||I.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&u?O===1:!1))}async p(t,a,i,s,c,u){const{providerExtUri:r}=this.N(t),l={resource:a,name:r.basename(a),isFile:(i.type&o.FileType.File)!==0,isDirectory:(i.type&o.FileType.Directory)!==0,isSymbolicLink:(i.type&o.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&o.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,o.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(l.isDirectory&&u(l,s)){try{const I=await t.readdir(a),A=await M.Promises.settled(I.map(async([O,N])=>{try{const X=r.joinPath(a,O),V=c?await t.stat(X):{type:N};return await this.p(t,X,V,I.length,c,u)}catch(X){return this.b.trace(X),null}}));l.children=(0,E.coalesce)(A)}catch(I){this.b.trace(I),l.children=[]}return l}return l}async resolveAll(t){return M.Promises.settled(t.map(async a=>{try{return{stat:await this.n(a.resource,a.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),i=await a.stat(t);return this.p(a,t,i,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.r(t,a)}catch(i){return i}return!0}async r(t,a){if(!a?.overwrite&&await this.exists(t))throw new o.FileOperationError((0,w.localize)(3,null,this.nb(t)),3,a)}async createFile(t,a=n.VSBuffer.fromString(""),i){await this.r(t,i);const s=await this.writeFile(t,a);return this.m.fire(new o.FileOperationEvent(t,0,s)),s}async writeFile(t,a,i){const s=this.lb(await this.l(t),t),{providerExtUri:c}=this.N(s);try{await this.s(s,t,i)||await this.P(s,c.dirname(t));let r;if((0,o.hasReadWriteCapability)(s)&&!(a instanceof n.VSBuffer))if((0,m.isReadableStream)(a)){const l=await(0,m.peekStream)(a,3);l.ended?r=n.VSBuffer.concat(l.buffer):r=l}else r=(0,m.peekReadable)(a,l=>n.VSBuffer.concat(l),3);else r=a;!(0,o.hasOpenReadWriteCloseCapability)(s)||(0,o.hasReadWriteCapability)(s)&&r instanceof n.VSBuffer?await this.cb(s,t,i,r):await this.Y(s,t,i,r instanceof n.VSBuffer?(0,n.bufferToReadable)(r):r),this.m.fire(new o.FileOperationEvent(t,4))}catch(u){throw new o.FileOperationError((0,w.localize)(4,null,this.nb(t),(0,o.ensureFileSystemProviderError)(u).toString()),(0,o.toFileOperationResult)(u),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,a,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,w.localize)(5,null,this.nb(a)));let c;try{c=await t.stat(a)}catch{return}if((c.type&o.FileType.Directory)!==0)throw new o.FileOperationError((0,w.localize)(6,null,this.nb(a)),0,i);if(this.mb(a,c),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==o.ETAG_DISABLED&&typeof c.mtime=="number"&&typeof c.size=="number"&&i.mtime<c.mtime&&i.etag!==(0,o.etag)({mtime:i.mtime,size:c.size}))throw new o.FileOperationError((0,w.localize)(7,null),3,i);return c}async readFile(t,a,i){const s=await this.k(t);return a?.atomic?this.t(s,t,a,i):this.u(s,t,a,i)}async t(t,a,i,s){return new Promise((c,u)=>{this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{try{const r=await this.u(t,a,i,s);c(r)}catch(r){u(r)}})})}async u(t,a,i,s){const c=await this.v(t,a,{...i,preferUnbuffered:!0},s);return{...c,value:await(0,n.streamToBuffer)(c.value)}}async readFileStream(t,a,i){const s=await this.k(t);return this.v(s,t,a,i)}async v(t,a,i,s){const c=new C.CancellationTokenSource(s),u=this.F(a,i).then(l=>l,l=>{throw c.cancel(),l});let r;try{return typeof i?.etag=="string"&&i.etag!==o.ETAG_DISABLED&&await u,i?.atomic&&(0,o.hasFileAtomicReadCapability)(t)||!((0,o.hasOpenReadWriteCloseCapability)(t)||(0,o.hasFileReadStreamCapability)(t))||(0,o.hasReadWriteCapability)(t)&&i?.preferUnbuffered?r=this.D(t,a,i):(0,o.hasFileReadStreamCapability)(t)?r=this.z(t,a,c.token,i):r=this.C(t,a,c.token,i),{...await u,value:r}}catch(l){throw r&&await(0,m.consumeStream)(r),this.w(l,a,i)}}w(t,a,i){const s=(0,w.localize)(8,null,this.nb(a),(0,o.ensureFileSystemProviderError)(t).toString());return t instanceof o.NotModifiedSinceFileOperationError?new o.NotModifiedSinceFileOperationError(s,t.stat,i):t instanceof o.TooLargeFileOperationError?new o.TooLargeFileOperationError(s,t.fileOperationResult,t.size,t.options):new o.FileOperationError(s,(0,o.toFileOperationResult)(t),i)}z(t,a,i,s=Object.create(null)){const c=t.readFileStream(a,s,i);return(0,m.transform)(c,{data:u=>u instanceof n.VSBuffer?u:n.VSBuffer.wrap(u),error:u=>this.w(u,a,s)},u=>n.VSBuffer.concat(u))}C(t,a,i,s=Object.create(null)){const c=(0,n.newWriteableBufferStream)();return(0,h.readFileIntoStream)(t,a,c,u=>u,{...s,bufferSize:this.a,errorTransformer:u=>this.w(u,a,s)},i),c}D(t,a,i){const s=(0,m.newWriteableStream)(c=>n.VSBuffer.concat(c));return(async()=>{try{let c;i?.atomic&&(0,o.hasFileAtomicReadCapability)(t)?c=await t.readFile(a,{atomic:!0}):c=await t.readFile(a),typeof i?.position=="number"&&(c=c.slice(i.position)),typeof i?.length=="number"&&(c=c.slice(0,i.length)),this.G(a,c.byteLength,i),s.end(n.VSBuffer.wrap(c))}catch(c){s.error(c),s.end()}})(),s}async F(t,a){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new o.FileOperationError((0,w.localize)(9,null,this.nb(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==o.ETAG_DISABLED&&a.etag===i.etag)throw new o.NotModifiedSinceFileOperationError((0,w.localize)(10,null),i,a);return this.G(t,i.size,a),i}G(t,a,i){if(i?.limits){let s;if(typeof i.limits.memory=="number"&&a>i.limits.memory&&(s=9),typeof i.limits.size=="number"&&a>i.limits.size&&(s=7),typeof s=="number")throw new o.TooLargeFileOperationError((0,w.localize)(11,null,this.nb(t)),s,a,i)}}async canMove(t,a,i){return this.H(t,a,"move",i)}async canCopy(t,a,i){return this.H(t,a,"copy",i)}async H(t,a,i,s){if(t.toString()!==a.toString())try{const c=i==="move"?this.lb(await this.l(t),t):await this.k(t),u=this.lb(await this.l(a),a);await this.M(c,t,u,a,i,s)}catch(c){return c}return!0}async move(t,a,i){const s=this.lb(await this.l(t),t),c=this.lb(await this.l(a),a),u=await this.I(s,t,c,a,"move",!!i),r=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new o.FileOperationEvent(t,u==="move"?2:3,r)),r}async copy(t,a,i){const s=await this.k(t),c=this.lb(await this.l(a),a),u=await this.I(s,t,c,a,"copy",!!i),r=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new o.FileOperationEvent(t,u==="copy"?3:2,r)),r}async I(t,a,i,s,c,u){if(a.toString()===s.toString())return c;const{exists:r,isSameResourceWithDifferentPathCase:l}=await this.M(t,a,i,s,c,u);if(r&&!l&&u&&await this.del(s,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(s)),c==="copy"){if(t===i&&(0,o.hasFileFolderCopyCapability)(t))await t.copy(a,s,{overwrite:u});else{const I=await this.resolve(a);I.isDirectory?await this.L(t,I,i,s):await this.J(t,a,i,s)}return c}else return t===i?(await t.rename(a,s,{overwrite:u}),c):(await this.I(t,a,i,s,"copy",u),await this.del(a,{recursive:!0}),"copy")}async J(t,a,i,s){if((0,o.hasOpenReadWriteCloseCapability)(t)&&(0,o.hasOpenReadWriteCloseCapability)(i))return this.eb(t,a,i,s);if((0,o.hasOpenReadWriteCloseCapability)(t)&&(0,o.hasReadWriteCapability)(i))return this.kb(t,a,i,s);if((0,o.hasReadWriteCapability)(t)&&(0,o.hasOpenReadWriteCloseCapability)(i))return this.ib(t,a,i,s);if((0,o.hasReadWriteCapability)(t)&&(0,o.hasReadWriteCapability)(i))return this.gb(t,a,i,s)}async L(t,a,i,s){await i.mkdir(s),Array.isArray(a.children)&&await M.Promises.settled(a.children.map(async c=>{const u=this.N(i).providerExtUri.joinPath(s,c.name);return c.isDirectory?this.L(t,await this.resolve(c.resource),i,u):this.J(t,c.resource,i,u)}))}async M(t,a,i,s,c,u){let r=!1;if(t===i){const{providerExtUri:I,isPathCaseSensitive:A}=this.N(t);if(A||(r=I.isEqual(a,s)),r&&c==="copy")throw new Error((0,w.localize)(12,null,this.nb(a),this.nb(s)));if(!r&&I.isEqualOrParent(s,a))throw new Error((0,w.localize)(13,null,this.nb(a),this.nb(s)))}const l=await this.exists(s);if(l&&!r){if(!u)throw new o.FileOperationError((0,w.localize)(14,null,this.nb(a),this.nb(s)),4);if(t===i){const{providerExtUri:I}=this.N(t);if(I.isEqualOrParent(a,s))throw new Error((0,w.localize)(15,null,this.nb(a),this.nb(s)))}}return{exists:l,isSameResourceWithDifferentPathCase:r}}N(t){const a=this.O(t);return{providerExtUri:a?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:a}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.lb(await this.j(t),t);await this.P(a,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new o.FileOperationEvent(t,0,i)),i}async P(t,a){const i=[],{providerExtUri:s}=this.N(t);for(;!s.isEqual(a,s.dirname(a));)try{if(((await t.stat(a)).type&o.FileType.Directory)===0)throw new Error((0,w.localize)(16,null,this.nb(a)));break}catch(c){if((0,o.toFileSystemProviderErrorCode)(c)!==o.FileSystemProviderErrorCode.FileNotFound)throw c;i.push(s.basename(a)),a=s.dirname(a)}for(let c=i.length-1;c>=0;c--){a=s.joinPath(a,i[c]);try{await t.mkdir(a)}catch(u){if((0,o.toFileSystemProviderErrorCode)(u)!==o.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(t,a){try{await this.Q(t,a)}catch(i){return i}return!0}async Q(t,a){const i=this.lb(await this.j(t),t);if(!!a?.useTrash&&!(i.capabilities&4096))throw new Error((0,w.localize)(17,null,this.nb(t)));let c;try{c=await i.stat(t)}catch{}if(c)this.mb(t,c);else throw new o.FileOperationError((0,w.localize)(18,null,this.nb(t)),1);if(!!!a?.recursive){const r=await this.resolve(t);if(r.isDirectory&&Array.isArray(r.children)&&r.children.length>0)throw new Error((0,w.localize)(19,null,this.nb(t)))}return i}async del(t,a){const i=await this.Q(t,a),s=!!a?.useTrash,c=!!a?.recursive;await i.delete(t,{recursive:c,useTrash:s}),this.m.fire(new o.FileOperationEvent(t,1))}async cloneFile(t,a){const i=await this.j(t),s=this.lb(await this.l(a),a);if(i===s&&this.N(i).providerExtUri.isEqual(t,a))return;if(i===s&&(0,o.hasFileCloneCapability)(i))return i.cloneFile(t,a);await this.P(s,this.N(s).providerExtUri.dirname(a));const c=this.X.queueFor(t,this.N(i).providerExtUri);return i===s&&(0,o.hasFileFolderCopyCapability)(i)?c.queue(()=>i.copy(t,a,{overwrite:!0})):c.queue(()=>this.J(i,t,s,a))}watch(t,a={recursive:!1,excludes:[]}){const i=new d.DisposableStore;let s=!1,c=()=>{s=!0};return i.add((0,d.toDisposable)(()=>c())),(async()=>{try{const u=await this.W(t,a);s?(0,d.dispose)(u):c=()=>(0,d.dispose)(u)}catch(u){this.b.error(u)}})(),i}async W(t,a){const i=await this.j(t),s=(0,P.hash)([this.N(i).providerExtUri.getComparisonKey(t),a]);let c=this.U.get(s);return c||(c={count:0,disposable:i.watch(t,a)},this.U.set(s,c)),c.count+=1,(0,d.toDisposable)(()=>{c&&(c.count--,c.count===0&&((0,d.dispose)(c.disposable),this.U.delete(s)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,d.dispose)(t.disposable);this.U.clear()}async Y(t,a,i,s){return this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{const c=await t.open(a,{create:!0,unlock:i?.unlock??!1});try{(0,m.isReadableStream)(s)||(0,m.isReadableBufferedStream)(s)?await this.Z(t,c,s):await this.ab(t,c,s)}catch(u){throw(0,o.ensureFileSystemProviderError)(u)}finally{await t.close(c)}})}async Z(t,a,i){let s=0,c;if((0,m.isReadableBufferedStream)(i)){if(i.buffer.length>0){const u=n.VSBuffer.concat(i.buffer);await this.bb(t,a,u,u.byteLength,s,0),s+=u.byteLength}if(i.ended)return;c=i.stream}else c=i;return new Promise((u,r)=>{(0,m.listenStream)(c,{onData:async l=>{c.pause();try{await this.bb(t,a,l,l.byteLength,s,0)}catch(I){return r(I)}s+=l.byteLength,setTimeout(()=>c.resume())},onError:l=>r(l),onEnd:()=>u()})})}async ab(t,a,i){let s=0,c;for(;(c=i.read())!==null;)await this.bb(t,a,c,c.byteLength,s,0),s+=c.byteLength}async bb(t,a,i,s,c,u){let r=0;for(;r<s;)r+=await t.write(a,c+r,i.buffer,u+r,s-r)}async cb(t,a,i,s){return this.X.queueFor(a,this.N(t).providerExtUri).queue(()=>this.db(t,a,i,s))}async db(t,a,i,s){let c;s instanceof n.VSBuffer?c=s:(0,m.isReadableStream)(s)?c=await(0,n.streamToBuffer)(s):(0,m.isReadableBufferedStream)(s)?c=await(0,n.bufferedStreamToBuffer)(s):c=(0,n.readableToBuffer)(s),await t.writeFile(a,c.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,a,i,s){return this.X.queueFor(s,this.N(i).providerExtUri).queue(()=>this.fb(t,a,i,s))}async fb(t,a,i,s){let c,u;try{c=await t.open(a,{create:!1}),u=await i.open(s,{create:!0,unlock:!1});const r=n.VSBuffer.alloc(this.a);let l=0,I=0,A=0;do A=await t.read(c,l,r.buffer,I,r.byteLength-I),await this.bb(i,u,r,A,l,I),l+=A,I+=A,I===r.byteLength&&(I=0);while(A>0)}catch(r){throw(0,o.ensureFileSystemProviderError)(r)}finally{await M.Promises.settled([typeof c=="number"?t.close(c):Promise.resolve(),typeof u=="number"?i.close(u):Promise.resolve()])}}async gb(t,a,i,s){return this.X.queueFor(s,this.N(i).providerExtUri).queue(()=>this.hb(t,a,i,s))}async hb(t,a,i,s){return i.writeFile(s,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async ib(t,a,i,s){return this.X.queueFor(s,this.N(i).providerExtUri).queue(()=>this.jb(t,a,i,s))}async jb(t,a,i,s){const c=await i.open(s,{create:!0,unlock:!1});try{const u=await t.readFile(a);await this.bb(i,c,n.VSBuffer.wrap(u),u.byteLength,0,0)}catch(u){throw(0,o.ensureFileSystemProviderError)(u)}finally{await i.close(c)}}async kb(t,a,i,s){const c=await(0,n.streamToBuffer)(this.C(t,a,C.CancellationToken.None));await this.cb(i,s,void 0,c)}lb(t,a){if(t.capabilities&2048)throw new o.FileOperationError((0,w.localize)(20,null,this.nb(a)),6);return t}mb(t,a){if((a.permissions??0)&o.FilePermission.Readonly)throw new o.FileOperationError((0,w.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===v.Schemas.file?t.fsPath:t.toString(!0)}};S=ve([_(0,p.ILogService)],S),e.FileService=S}),define(ee[90],te([0,1,41,289,8,35,17,3,32,2,9,4,18,60,23,168,16,110,210,44,206,205]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g,m,w,o,h,p,k,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,M.gracefulify)(E)}catch(a){console.error(`Error enabling graceful-fs: ${(0,k.toErrorMessage)(a)}`)}})();class t extends p.AbstractDiskFileSystemProvider{constructor(i,s){super(i,s),this.onDidChangeCapabilities=P.Event.None,this.H=new C.ResourceMap(c=>y.extUriBiasedIgnorePathCase.getComparisonKey(c)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,v.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:s,symbolicLink:c}=await m.SymlinkSupport.stat(this.C(i));return{type:this.G(s,c),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.Y(s)}}async readdir(i){try{const s=await m.Promises.readdir(this.C(i),{withFileTypes:!0}),c=[];return await Promise.all(s.map(async u=>{try{let r;u.isSymbolicLink()?r=(await this.stat((0,y.joinPath)(i,u.name))).type:r=this.G(u),c.push([u.name,r])}catch(r){this.a.trace(r)}})),c}catch(s){throw this.Y(s)}}G(i,s){let c;return s?.dangling?c=o.FileType.Unknown:i.isFile()?c=o.FileType.File:i.isDirectory()?c=o.FileType.Directory:c=o.FileType.Unknown,s&&(c|=o.FileType.SymbolicLink),c}async I(i){const s=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let c;for(;c=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await c.wait();const u=new n.Barrier;return this.H.set(i,u),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,d.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.H.get(i)===u&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),u.open()})}async readFile(i,s){let c;try{s?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),c=await this.I(i));const u=this.C(i);return await m.Promises.readFile(u)}catch(u){throw this.Y(u)}finally{c?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,s,c){const u=(0,g.newWriteableStream)(r=>D.VSBuffer.concat(r.map(l=>D.VSBuffer.wrap(l))).buffer);return(0,h.readFileIntoStream)(this,i,u,r=>r.buffer,{...s,bufferSize:256*1024},c),u}async writeFile(i,s,c){let u;try{const r=this.C(i);if(!c.create||!c.overwrite){if(await m.Promises.exists(r)){if(!c.overwrite)throw(0,o.createFileSystemProviderError)((0,w.localize)(0,null),o.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,o.createFileSystemProviderError)((0,w.localize)(1,null),o.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(i,{create:!0,unlock:c.unlock}),await this.write(u,0,s,0,s.byteLength)}catch(r){throw await this.Z(i,r)}finally{typeof u=="number"&&await this.close(u)}}static configureFlushOnWrite(i){t.O=i}async open(i,s){const c=this.C(i);let u;(0,o.isFileOpenForWriteOptions)(s)&&(u=await this.I(i));let r;try{if((0,o.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:I}=await m.SymlinkSupport.stat(c);I.mode&128||await m.Promises.chmod(c,I.mode|128)}catch(I){this.a.trace(I)}let l;if((0,o.isFileOpenForWriteOptions)(s)){if(v.isWindows)try{await m.Promises.truncate(c,0),l="r+"}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}l||(l="w")}else l="r";r=await m.Promises.open(c,l)}catch(l){throw u?.dispose(),(0,o.isFileOpenForWriteOptions)(s)?await this.Z(i,l):this.Y(l)}if(this.L.set(r,0),(0,o.isFileOpenForWriteOptions)(s)&&this.N.set(r,i),u){const l=this.M.get(r);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${r} (${c})`),this.M.set(r,u),l&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${r} (${c})`),l.dispose())}return r}async close(i){const s=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await m.Promises.fdatasync(i)}catch(c){t.configureFlushOnWrite(!1),this.a.error(c)}return await m.Promises.close(i)}catch(c){throw this.Y(c)}finally{s&&(this.M.get(i)===s&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),s.dispose())}}async read(i,s,c,u,r){const l=this.P(i,s);let I=null;try{I=(await m.Promises.read(i,c,u,r,l)).bytesRead}catch(A){throw this.Y(A)}finally{this.Q(i,l,I)}return I}P(i,s){return s===this.L.get(i)?null:s}Q(i,s,c){const u=this.L.get(i);typeof u=="number"&&(typeof s=="number"||(typeof c=="number"?this.L.set(i,u+c):this.L.delete(i)))}async write(i,s,c,u,r){return(0,n.retry)(()=>this.R(i,s,c,u,r),100,3)}async R(i,s,c,u,r){const l=this.P(i,s);let I=null;try{I=(await m.Promises.write(i,c,u,r,l)).bytesWritten}catch(A){throw await this.Z(this.N.get(i),A)}finally{this.Q(i,l,I)}return I}async mkdir(i){try{await m.Promises.mkdir(this.C(i))}catch(s){throw this.Y(s)}}async delete(i,s){try{const c=this.C(i);s.recursive?await m.Promises.rm(c,m.RimRafMode.MOVE):await m.Promises.unlink(c)}catch(c){throw this.Y(c)}}async rename(i,s,c){const u=this.C(i),r=this.C(s);if(u!==r)try{await this.S(i,s,"move",c.overwrite),await m.Promises.move(u,r)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,w.localize)(2,null,(0,b.basename)(u),(0,b.basename)((0,b.dirname)(r)),l.toString()))),this.Y(l)}}async copy(i,s,c){const u=this.C(i),r=this.C(s);if(u!==r)try{await this.S(i,s,"copy",c.overwrite),await m.Promises.copy(u,r,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,w.localize)(3,null,(0,b.basename)(u),(0,b.basename)((0,b.dirname)(r)),l.toString()))),this.Y(l)}}async S(i,s,c,u){const r=this.C(i),l=this.C(s);let I=!1;if(!!(this.capabilities&1024)||(I=(0,f.isEqual)(r,l,!0)),I&&c==="copy")throw(0,o.createFileSystemProviderError)((0,w.localize)(4,null),o.FileSystemProviderErrorCode.FileExists);if(!I&&await m.Promises.exists(l)){if(!u)throw(0,o.createFileSystemProviderError)((0,w.localize)(5,null),o.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}async cloneFile(i,s){return this.U(i,s,!1)}async U(i,s,c){const u=this.C(i),r=this.C(s),l=!!(this.capabilities&1024);if((0,f.isEqual)(u,r,!l))return;const I=new d.DisposableStore;try{const[A,O]=await Promise.all([this.I(i),this.I(s)]);I.add(A),I.add(O),c&&await m.Promises.mkdir((0,b.dirname)(r),{recursive:!0}),await m.Promises.copyFile(u,r)}catch(A){if(A.code==="ENOENT"&&!c)return this.U(i,s,!0);throw this.Y(A)}finally{I.dispose()}}p(i,s,c){return new S.UniversalWatcherClient(u=>i(u),u=>s(u),c)}y(i,s,c){return new R.NodeJSWatcherClient(u=>i(u),u=>s(u),c)}Y(i){if(i instanceof o.FileSystemProviderError)return i;let s;switch(i.code){case"ENOENT":s=o.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=o.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=o.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=o.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=o.FileSystemProviderErrorCode.NoPermissions;break;default:s=o.FileSystemProviderErrorCode.Unknown}return(0,o.createFileSystemProviderError)(i,s)}async Z(i,s){let c=this.Y(s);if(i&&c.code===o.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await m.SymlinkSupport.stat(this.C(i));u.mode&128||(c=(0,o.createFileSystemProviderError)(s,o.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.a.trace(u)}return c}}t.D=!1,t.O=!0,e.DiskFileSystemProvider=t}),define(ee[212],te([0,1,3,90,2,17,60,22]),function(G,e,E,M,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class f extends n.Disposable{constructor(v,y){super(),this.a=v,this.b=y,this.w=new Map,this.y=new Map}call(v,y,g){const m=this.c(v);switch(y){case"stat":return this.g(m,g[0]);case"readdir":return this.h(m,g[0]);case"open":return this.l(m,g[0],g[1]);case"close":return this.m(g[0]);case"read":return this.n(g[0],g[1],g[2]);case"readFile":return this.i(m,g[0],g[1]);case"write":return this.p(g[0],g[1],g[2],g[3],g[4]);case"writeFile":return this.k(m,g[0],g[1],g[2]);case"rename":return this.t(m,g[0],g[1],g[2]);case"copy":return this.u(m,g[0],g[1],g[2]);case"cloneFile":return this.v(m,g[0],g[1]);case"mkdir":return this.r(m,g[0]);case"delete":return this.s(m,g[0],g[1]);case"watch":return this.C(m,g[0],g[1],g[2],g[3]);case"unwatch":return this.D(g[0],g[1])}throw new Error(`IPC Command ${y} not found`)}listen(v,y,g){const m=this.c(v);switch(y){case"fileChange":return this.z(m,g[0]);case"readFileStream":return this.j(m,g[0],g[1])}throw new Error(`Unknown event ${y}`)}g(v,y){const g=this.f(v,y,!0);return this.a.stat(g)}h(v,y){const g=this.f(v,y);return this.a.readdir(g)}async i(v,y,g){const m=this.f(v,y,!0),w=await this.a.readFile(m,g);return C.VSBuffer.wrap(w)}j(v,y,g){const m=this.f(v,y,!0),w=new P.CancellationTokenSource,o=new E.Emitter({onDidRemoveLastListener:()=>{w.cancel()}}),h=this.a.readFileStream(m,g,w.token);return(0,D.listenStream)(h,{onData:p=>o.fire(C.VSBuffer.wrap(p)),onError:p=>o.fire(p),onEnd:()=>{o.fire("end"),o.dispose(),w.dispose()}}),o.event}k(v,y,g,m){const w=this.f(v,y);return this.a.writeFile(w,g.buffer,m)}l(v,y,g){const m=this.f(v,y,!0);return this.a.open(m,g)}m(v){return this.a.close(v)}async n(v,y,g){const m=C.VSBuffer.alloc(g),w=0,o=await this.a.read(v,y,m.buffer,w,g);return[m,o]}p(v,y,g,m,w){return this.a.write(v,y,g.buffer,m,w)}r(v,y){const g=this.f(v,y);return this.a.mkdir(g)}s(v,y,g){const m=this.f(v,y);return this.a.delete(m,g)}t(v,y,g,m){const w=this.f(v,y),o=this.f(v,g);return this.a.rename(w,o,m)}u(v,y,g,m){const w=this.f(v,y),o=this.f(v,g);return this.a.copy(w,o,m)}v(v,y,g){const m=this.f(v,y),w=this.f(v,g);return this.a.cloneFile(m,w)}z(v,y){const g=new E.Emitter({onWillAddFirstListener:()=>{this.w.set(y,this.F(v,g))},onDidRemoveLastListener:()=>{(0,n.dispose)(this.w.get(y)),this.w.delete(y)}});return g.event}async C(v,y,g,m,w){const o=this.w.get(y);if(o){const h=this.f(v,m),p=o.watch(g,h,w);this.y.set(y+g,p)}}async D(v,y){const g=v+y,m=this.y.get(g);m&&((0,n.dispose)(m),this.y.delete(g))}dispose(){super.dispose();for(const[,v]of this.y)v.dispose();this.y.clear();for(const[,v]of this.w)v.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=f;class d extends n.Disposable{constructor(v,y,g,m){super(),this.c=v,this.f=g,this.g=m,this.a=new Map,this.b=this.B(new M.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(y)}h(v){const y=this.B(new E.Emitter);this.B(y.event(g=>{v.fire(g.map(m=>({resource:this.c.transformOutgoingURI(m.resource),type:m.type})))})),this.B(this.b.onDidChangeFile(g=>y.fire(g))),this.B(this.b.onDidWatchError(g=>v.fire(g)))}i(v){}j(v){}watch(v,y,g){const m=this.j(this.g);return Array.isArray(m)&&(g.excludes=[...g.excludes,...m]),this.a.set(v,this.b.watch(y,g)),(0,n.toDisposable)(()=>{(0,n.dispose)(this.a.get(v)),this.a.delete(v)})}dispose(){super.dispose();for(const[,v]of this.a)v.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=d}),define(ee[213],te([0,1,14,167,4,7,16,9,212,145]),function(G,e,E,M,n,C,D,P,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class b extends f.AbstractDiskFileSystemProviderChannel{constructor(g,m,w){super(g,m),this.G=w}c(g){return d.DefaultURITransformer}f(g,m){return C.URI.revive(m)}async s(g,m,w){if(!w.useTrash)return super.s(g,m,w);const o=this.f(g,m),h=(0,P.normalize)(o.fsPath);try{await E.shell.trashItem(h)}catch{throw(0,D.createFileSystemProviderError)(n.isWindows?(0,M.localize)(0,null,(0,P.basename)(h)):(0,M.localize)(1,null,(0,P.basename)(h)),D.FileSystemProviderErrorCode.Unknown)}}F(g,m){return new v(g,m,this.b,this.G)}}e.DiskFileSystemProviderChannel=b;class v extends f.AbstractSessionFileWatcher{watch(g,m,w){if(w.recursive)throw(0,D.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(g,m,w)}}}),define(ee[214],te([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class M extends E.AbstractMessageLogger{constructor(C=E.DEFAULT_LOG_LEVEL){super(),this.k=[],this.l=void 0,this.setLevel(C),this.B(this.onDidChangeLogLevel(D=>{this.l?.setLevel(D)}))}set logger(C){this.l=C;for(const{level:D,message:P}of this.k)(0,E.log)(C,D,P);this.k=[]}g(C,D){this.l?(0,E.log)(this.l,C,D):this.getLevel()<=C&&this.k.push({level:C,message:D})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.BufferLogger=M}),define(ee[215],te([0,1,2,5]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class n extends E.Disposable{constructor(D,P=[]){super(),this.a=new M.MultiplexLogger([D,...P]),this.B(D.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...P){this.a.trace(D,...P)}debug(D,...P){this.a.debug(D,...P)}info(D,...P){this.a.info(D,...P)}warn(D,...P){this.a.warn(D,...P)}error(D,...P){this.a.error(D,...P)}flush(){this.a.flush()}}e.LogService=n}),define(ee[216],te([0,1,35,7,5]),function(G,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class C{constructor(P){this.b=P,this.a=new E.ResourceMap}listen(P,f,d){switch(f){case"onDidChangeLoggers":return d?this.b.getOnDidChangeLoggersEvent(d):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return d?this.b.getOnDidChangeLogLevelEvent(d):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return d?this.b.getOnDidChangeVisibilityEvent(d):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${f}`)}async call(P,f,d){switch(f){case"createLogger":this.c(M.URI.revive(d[0]),d[1],d[2]);return;case"log":return this.e(M.URI.revive(d[0]),d[1]);case"consoleLog":return this.d(d[0],d[1]);case"setLogLevel":return(0,n.isLogLevel)(d[0])?this.b.setLogLevel(d[0]):this.b.setLogLevel(M.URI.revive(d[0]),d[1]);case"setVisibility":return this.b.setVisibility(M.URI.revive(d[0]),d[1]);case"registerLogger":return this.b.registerLogger({...d[0],resource:M.URI.revive(d[0].resource)},d[1]);case"deregisterLogger":return this.b.deregisterLogger(M.URI.revive(d[0]))}throw new Error(`Call not found: ${f}`)}c(P,f,d){this.a.set(P,this.b.createLogger(P,f,d))}d(P,f){let d=console.log;switch(P){case n.LogLevel.Error:d=console.error;break;case n.LogLevel.Warning:d=console.warn;break;case n.LogLevel.Info:d=console.info;break}d.call(console,...f)}e(P,f){const d=this.a.get(P);if(!d)throw new Error("Create the logger before logging");for(const[b,v]of f)(0,n.log)(d,b,v)}}e.LoggerChannel=C}),define(ee[217],te([0,1,16,5]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var n;(function(d){d[d.Trace=0]="Trace",d[d.Debug=1]="Debug",d[d.Info=2]="Info",d[d.Warning=3]="Warning",d[d.Error=4]="Error",d[d.Critical=5]="Critical",d[d.Off=6]="Off"})(n||(n={}));async function C(d,b,v,y,g){try{const m=await new Promise((o,h)=>{G(["spdlog"],o,h)});m.setFlushOn(n.Trace);const w=await m.createAsyncRotatingLogger(d,b,v,y);return g?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(m){console.error(m)}return null}function D(d,b,v){switch(b){case M.LogLevel.Trace:d.trace(v);break;case M.LogLevel.Debug:d.debug(v);break;case M.LogLevel.Info:d.info(v);break;case M.LogLevel.Warning:d.warn(v);break;case M.LogLevel.Error:d.error(v);break;case M.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function P(d,b){switch(b){case M.LogLevel.Trace:d.setLevel(n.Trace);break;case M.LogLevel.Debug:d.setLevel(n.Debug);break;case M.LogLevel.Info:d.setLevel(n.Info);break;case M.LogLevel.Warning:d.setLevel(n.Warning);break;case M.LogLevel.Error:d.setLevel(n.Error);break;case M.LogLevel.Off:d.setLevel(n.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class f extends M.AbstractMessageLogger{constructor(b,v,y,g,m){super(),this.k=[],this.setLevel(m),this.l=this.n(b,v,y,g),this.B(this.onDidChangeLogLevel(w=>{this.m&&P(this.m,w)}))}async n(b,v,y,g){const m=y?6:1,w=30/m*E.ByteSize.MB,o=await C(b,v,w,m,g);if(o){this.m=o,P(this.m,this.getLevel());for(const{level:h,message:p}of this.k)D(this.m,h,p);this.k=[]}}g(b,v){this.m?D(this.m,b,v):this.getLevel()<=b&&this.k.push({level:b,message:v})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=f}),define(ee[218],te([0,1,31,5,217]),function(G,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class C extends M.AbstractLoggerService{k(P,f,d){return new n.SpdLogLogger((0,E.generateUuid)(),P.fsPath,!d?.donotRotate,!!d?.donotUseFormatters,f)}}e.LoggerService=C}),define(ee[65],te([0,1,35,3,6,5,218]),function(G,e,E,M,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,n.refineServiceDecorator)(C.ILoggerService);class P extends D.LoggerService{constructor(){super(...arguments),this.m=new E.ResourceMap}createLogger(d,b,v){v!==void 0&&this.m.set(d,v);try{return super.createLogger(d,b)}catch(y){throw this.m.delete(d),y}}registerLogger(d,b){b!==void 0&&this.m.set(d.resource,b),super.registerLogger(d)}deregisterLogger(d){this.m.delete(d),super.deregisterLogger(d)}getRegisteredLoggers(d){const b=[];for(const v of super.getRegisteredLoggers())d===this.m.get(v.resource)&&b.push(v);return b}getOnDidChangeLogLevelEvent(d){return M.Event.filter(this.onDidChangeLogLevel,b=>(0,C.isLogLevel)(b)||this.n(b[0],d))}getOnDidChangeVisibilityEvent(d){return M.Event.filter(this.onDidChangeVisibility,([b])=>this.n(b,d))}getOnDidChangeLoggersEvent(d){return M.Event.filter(M.Event.map(this.onDidChangeLoggers,b=>({added:[...b.added].filter(y=>this.n(y.resource,d)),removed:[...b.removed].filter(y=>this.n(y.resource,d))})),b=>b.added.length>0||b.removed.length>0)}deregisterLoggers(d){for(const[b,v]of this.m)v===d&&this.deregisterLogger(b)}n(d,b){const v=this.m.get(d);return v===void 0||v===b}dispose(){super.dispose(),this.m.clear()}}e.LoggerMainService=P}),define(ee[219],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function E(D){return D.submenu!==void 0}e.isMenubarMenuItemSubmenu=E;function M(D){return D.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=M;function n(D){return D.uri!==void 0}e.isMenubarMenuItemRecentAction=n;function C(D){return!E(D)&&!M(D)&&!n(D)}e.isMenubarMenuItemAction=C}),define(ee[37],te([0,1,3,70,2,6]),function(G,e,E,M,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,C.createDecorator)("policy");class D extends n.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new E.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(d){const b=Object.keys(this.f).length;return this.f={...d,...this.f},b!==Object.keys(this.f).length&&await this.i(d),M.Iterable.reduce(this.g.entries(),(v,[y,g])=>({...v,[y]:g}),{})}getPolicyValue(d){return this.g.get(d)}serialize(){return M.Iterable.reduce(Object.entries(this.f),(d,[b,v])=>({...d,[b]:{definition:v,value:this.g.get(b)}}),{})}}e.AbstractPolicyService=D;class P{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(ee[220],te([0,1,8,3,70,10,16,5,37]),function(G,e,E,M,n,C,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function d(v,y){const g=[];for(const m of new Set(n.Iterable.concat(v.keys(),y.keys())))v.get(m)!==y.get(m)&&g.push(m);return g}let b=class extends f.AbstractPolicyService{constructor(y,g,m){super(),this.j=y,this.k=g,this.l=m,this.c=this.B(new E.ThrottledDelayer(500));const w=M.Event.filter(g.onDidFilesChange,o=>o.affects(y));this.B(g.watch(y)),this.B(w(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const y=new Map;try{const g=await this.k.readFile(this.j),m=JSON.parse(g.value.toString());if(!(0,C.isObject)(m))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys(m))this.f[w]&&y.set(w,m[w])}catch(g){g.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",g)}return y}async p(){const y=await this.n(),g=d(this.g,y);this.g=y,g.length>0&&this.h.fire(g)}};b=ve([_(1,D.IFileService),_(2,P.ILogService)],b),e.FilePolicyService=b}),define(ee[221],te([0,1,3,2,37]),function(G,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class C{constructor(f){this.b=f,this.a=new M.DisposableStore}listen(f,d){switch(d){case"onDidChange":return E.Event.map(this.b.onDidChange,b=>b.reduce((v,y)=>({...v,[y]:this.b.getPolicyValue(y)??null}),{}),this.a)}throw new Error(`Event not found: ${d}`)}call(f,d,b){switch(d){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(b)}throw new Error(`Call not found: ${d}`)}dispose(){this.a.dispose()}}e.PolicyChannel=C;class D extends n.AbstractPolicyService{constructor(f,d){super(),this.a=d;for(const b in f){const{definition:v,value:y}=f[b];this.f[b]=v,y!==void 0&&this.g.set(b,y)}this.a.listen("onDidChange")(b=>{for(const v in b){const y=b[v];y===null?this.g.delete(v):this.g.set(v,y)}this.h.fire(Object.keys(b))})}async i(f){const d=await this.a.call("updatePolicyDefinitions",f);for(const b in d)this.g.set(b,d[b])}}e.PolicyChannelClient=D}),define(ee[66],te([0,1,4,36]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let n;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.context<"u"){const C=E.globals.vscode.context.configuration();if(C)n=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(n=globalThis._VSCODE_PRODUCT_JSON,M.env.VSCODE_DEV&&Object.assign(n,{nameShort:`${n.nameShort} Dev`,nameLong:`${n.nameLong} Dev`,dataFolderName:`${n.dataFolderName}-dev`,serverDataFolderName:n.serverDataFolderName?`${n.serverDataFolderName}-dev`:void 0}),!n.version){const C=globalThis._VSCODE_PACKAGE_JSON;Object.assign(n,{version:C.version})}}else n={},Object.keys(n).length===0&&Object.assign(n,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=n}),define(ee[20],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,E.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[222],te([0,1,81,5,20]),function(G,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let C=class{constructor(P,f){this.b=P,this.c=f,this.a=new Map}async isExtensionUrlTrusted(P,f){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const d=/^(.*)#([^#]+)$/.exec(f);if(!d)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,b,v]=d;let y=this.a.get(P);if(!y){if(y=this.b.trustedExtensionUrlPublicKeys[P],!y||y.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",P),!1;this.a.set(P,[...y])}const g=Buffer.from(decodeURIComponent(v),"base64");if(g.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const m=g.slice(0,6),w=g.readUIntBE(0,6),o=Date.now()-w;if(o<0||o>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const h=g.slice(6),p=E.createVerify("SHA256");p.write(m),p.write(Buffer.from(b)),p.end();for(let k=0;k<y.length;k++){let S=y[k];if(S!==null){if(typeof S=="string")try{S=E.createPublicKey({key:Buffer.from(S,"base64"),format:"der",type:"spki"}),y[k]=S}catch(R){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${k+1} for ${P}:`,R),y[k]=null;continue}if(p.verify(S,h))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};C=ve([_(0,n.IProductService),_(1,M.ILogService)],C),e.ExtensionUrlTrustService=C}),define(ee[223],te([0,1,8,5]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let n=class{constructor(D,P,f){this.a=D,this.b=P,this.c=f}async inspect(D){await this.d();const P=this.a.webContents.debugger;await P.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,E.timeout)(D);const f=await P.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),f.profile}async d(){const D=this.a.webContents.debugger;D.attach(),await D.sendCommand("Profiler.enable")}async e(){const D=this.a.webContents.debugger;await D.sendCommand("Profiler.disable"),D.detach()}};n=ve([_(2,M.ILogService)],n),e.WindowProfiler=n}),define(ee[67],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,E.createDecorator)("protocolMainService")}),define(ee[51],te([0,1,123,10]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class n{constructor(){this.a=new Map}add(D,P){E.ok(M.isString(D)),E.ok(M.isObject(P)),E.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,P)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.Registry=new n}),define(ee[224],te([0,1,3,51]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function n(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class C{constructor(){this.b=new E.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,d){this.a[n(f)]=d,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const D=new C;M.Registry.add(e.Extensions.JSONContribution,D)}),define(ee[68],te([0,1,25,3,10,154,19,224,51]),function(G,e,E,M,n,C,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var d;(function(R){R.Multiline="multilineText",R.Singleline="singlelineText"})(d=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(R){R[R.APPLICATION=1]="APPLICATION",R[R.MACHINE=2]="MACHINE",R[R.WINDOW=3]="WINDOW",R[R.RESOURCE=4]="RESOURCE",R[R.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",R[R.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const v=f.Registry.as(P.Extensions.JSONContribution);class y{constructor(){this.h=new Set,this.i=new M.Emitter,this.onDidSchemaChange=this.i.event,this.j=new M.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const i=new Set;this.n(t,a,i),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const a=new Set;this.o(t,a),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const i=new Set;this.o(a,i),this.n(t,!1,i),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const i=[];for(const{overrides:s,source:c}of t)for(const u in s)if(a.add(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const r=this.a.get(u),l=r?.valuesSources??new Map;if(c)for(const N of Object.keys(s[u]))l.set(N,c);const I={...r?.value||{},...s[u]};this.a.set(u,{source:c,value:I,valuesSources:l});const A=(0,D.getLanguageTagSettingPlainKey)(u),O={type:"object",default:I,description:C.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:I,source:n.isString(c)?void 0:c,defaultValueSource:c};i.push(...w(u)),this.d[u]=O,this.b.properties[u]=O}else{this.a.set(u,{value:s[u],source:c});const r=this.d[u];r&&(this.w(u,r),this.r(u,r))}this.m(i)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:i,source:s}of t)for(const c in i){const u=this.a.get(c),r=n.isString(s)?s:s?.id,l=n.isString(u?.source)?u?.source:u?.source?.id;if(r===l)if(a.add(c),this.a.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.d[c],delete this.b.properties[c];else{const I=this.d[c];I&&(this.w(c,I),this.r(c,I))}}this.u()}deltaConfiguration(t){let a=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,i){t.forEach(s=>{this.p(s,a,s.extensionInfo,s.restrictedProperties,void 0,i),this.c.push(s),this.q(s)})}o(t,a){const i=s=>{if(s.properties)for(const c in s.properties){a.add(c);const u=this.d[c];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[c],this.s(c,s.properties[c])}s.allOf?.forEach(c=>i(c))};for(const s of t){i(s);const c=this.c.indexOf(s);c!==-1&&this.c.splice(c,1)}}p(t,a=!0,i,s,c=3,u){c=n.isUndefinedOrNull(t.scope)?c:t.scope;const r=t.properties;if(r)for(const I in r){const A=r[I];if(a&&k(I,A)){delete r[I];continue}if(A.source=i,A.defaultDefaultValue=r[I].default,this.w(I,A),e.OVERRIDE_PROPERTY_REGEX.test(I)?A.scope=void 0:(A.scope=n.isUndefinedOrNull(A.scope)?c:A.scope,A.restricted=n.isUndefinedOrNull(A.restricted)?!!s?.includes(I):A.restricted),r[I].hasOwnProperty("included")&&!r[I].included){this.f[I]=r[I],delete r[I];continue}else this.d[I]=r[I],r[I].policy?.name&&this.e.set(r[I].policy.name,I);!r[I].deprecationMessage&&r[I].markdownDeprecationMessage&&(r[I].deprecationMessage=r[I].markdownDeprecationMessage),u.add(I)}const l=t.allOf;if(l)for(const I of l)this.p(I,a,i,s,c,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=i=>{const s=i.properties;if(s)for(const u in s)this.r(u,s[u]);i.allOf?.forEach(a)};a(t)}r(t,a){switch(e.allSettings.properties[t]=a,a.scope){case 1:e.applicationSettings.properties[t]=a;break;case 2:e.machineSettings.properties[t]=a;break;case 6:e.machineOverridableSettings.properties[t]=a;break;case 3:e.windowSettings.properties[t]=a;break;case 4:e.resourceSettings.properties[t]=a;break;case 5:e.resourceSettings.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.allSettings.properties[t],a.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,i={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(a,i),e.allSettings.properties[a]=i,e.applicationSettings.properties[a]=i,e.machineSettings.properties[a]=i,e.machineOverridableSettings.properties[a]=i,e.windowSettings.properties[a]=i,e.resourceSettings.properties[a]=i}}v(){const t={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,a){const i=this.a.get(t);let s=i?.value,c=i?.source;n.isUndefined(s)&&(s=a.defaultDefaultValue,c=void 0),n.isUndefined(s)&&(s=h(a.type)),a.default=s,a.defaultValueSource=c}}const g="\\[([^\\]]+)\\]",m=new RegExp(g,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function w(R){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(R)){let a=m.exec(R);for(;a?.length;){const i=a[1].trim();i&&t.push(i),a=m.exec(R)}}return(0,E.distinct)(t)}e.overrideIdentifiersFromKey=w;function o(R){return R.reduce((t,a)=>`${t}[${a}]`,"")}e.keyFromOverrideIdentifiers=o;function h(R){switch(Array.isArray(R)?R[0]:R){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const p=new y;f.Registry.add(e.Extensions.Configuration,p);function k(R,t){return R.trim()?e.OVERRIDE_PROPERTY_REGEX.test(R)?C.localize(7,null,R):p.getConfigurationProperties()[R]!==void 0?C.localize(8,null,R):t.policy?.name&&p.getPolicyConfigurations().get(t.policy?.name)!==void 0?C.localize(9,null,R,t.policy?.name,p.getPolicyConfigurations().get(t.policy?.name)):null:C.localize(6,null)}e.validateProperty=k;function S(){const R=[],t=p.getConfigurationProperties();for(const a of Object.keys(t))R.push([a,t[a].scope]);return R.push(["launch",4]),R.push(["task",4]),R}e.getScopes=S}),define(ee[111],te([0,1,25,3,43,2,35,40,10,7,19,68,51]),function(G,e,E,M,n,C,D,P,f,d,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function g(a){return Object.isFrozen(a)?a:P.deepFreeze(a)}class m{constructor(i={},s=[],c=[],u){this.b=i,this.c=s,this.d=c,this.raw=u,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(s=>{if(s instanceof m)return s;const c=new w("");return c.parseRaw(s),c.configurationModel});this.f=i.reduce((s,c)=>c===s?c:s.merge(c),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,b.getConfigurationValue)(this.contents,i):this.contents}inspect(i,s){const c=this.rawConfiguration.getValue(i),u=s?this.rawConfiguration.getOverrideValue(i,s):void 0,r=s?this.rawConfiguration.override(s).getValue(i):c;return{value:c,override:u,merged:r}}getOverrideValue(i,s){const c=this.i(s);return c?i?(0,b.getConfigurationValue)(c,i):c:void 0}getKeysForOverrideIdentifier(i){const s=[];for(const c of this.overrides)c.identifiers.includes(i)&&s.push(...c.keys);return E.distinct(s)}getAllOverrideIdentifiers(){const i=[];for(const s of this.overrides)i.push(...s.identifiers);return E.distinct(i)}override(i){let s=this.a.get(i);return s||(s=this.g(i),this.a.set(i,s)),s}merge(...i){const s=P.deepClone(this.contents),c=P.deepClone(this.overrides),u=[...this.keys],r=this.raw?.length?[...this.raw]:[this];for(const l of i)if(r.push(...l.raw?.length?l.raw:[l]),!l.isEmpty()){this.h(s,l.contents);for(const I of l.overrides){const[A]=c.filter(O=>E.equals(O.identifiers,I.identifiers));A?(this.h(A.contents,I.contents),A.keys.push(...I.keys),A.keys=E.distinct(A.keys)):c.push(P.deepClone(I))}for(const I of l.keys)u.indexOf(I)===-1&&u.push(I)}return new m(s,u,c,r.every(l=>l instanceof m)?void 0:r)}g(i){const s=this.i(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const c={};for(const u of E.distinct([...Object.keys(this.contents),...Object.keys(s)])){let r=this.contents[u];const l=s[u];l&&(typeof r=="object"&&typeof l=="object"?(r=P.deepClone(r),this.h(r,l)):r=l),c[u]=r}return new m(c,this.keys,this.overrides)}h(i,s){for(const c of Object.keys(s)){if(c in i&&f.isObject(i[c])&&f.isObject(s[c])){this.h(i[c],s[c]);continue}i[c]=P.deepClone(s[c])}}i(i){let s=null,c=null;const u=r=>{r&&(c?this.h(c,r):c=P.deepClone(r))};for(const r of this.overrides)E.equals(r.identifiers,[i])?s=r.contents:r.identifiers.includes(i)&&u(r.contents);return u(s),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,s){this.j(i,s,!0)}setValue(i,s){this.j(i,s,!1)}removeValue(i){const s=this.keys.indexOf(i);s!==-1&&(this.keys.splice(s,1),(0,b.removeFromValueTree)(this.contents,i),v.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(c=>E.equals(c.identifiers,(0,v.overrideIdentifiersFromKey)(i))),1))}j(i,s,c){(0,b.addToValueTree)(this.contents,i,s,u=>console.error(u)),c=c||this.keys.indexOf(i)===-1,c&&this.keys.push(i),v.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,v.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,b.toValuesTree)(this.contents[i],u=>console.error(u))})}}e.ConfigurationModel=m;class w{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,s){if(!f.isUndefinedOrNull(i)){const c=this.g(i);this.parseRaw(c,s)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,s){this.a=i;const{contents:c,keys:u,overrides:r,restricted:l,hasExcludedProperties:I}=this.h(i,s);this.b=new m(c,u,r,I?[i]:void 0),this.c=l||[]}g(i){let s={},c=null,u=[];const r=[],l=[];function I(O){Array.isArray(u)?u.push(O):c!==null&&(u[c]=O)}const A={onObjectBegin:()=>{const O={};I(O),r.push(u),u=O,c=null},onObjectProperty:O=>{c=O},onObjectEnd:()=>{u=r.pop()},onArrayBegin:()=>{const O=[];I(O),r.push(u),u=O,c=null},onArrayEnd:()=>{u=r.pop()},onLiteralValue:I,onError:(O,N,X)=>{l.push({error:O,offset:N,length:X})}};if(i)try{n.visit(i,A),s=u[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return s}h(i,s){const c=y.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),u=this.i(i,c,!0,s);i=u.raw;const r=(0,b.toValuesTree)(i,A=>console.error(`Conflict in settings file ${this.f}: ${A}`)),l=Object.keys(i),I=this.j(i,A=>console.error(`Conflict in settings file ${this.f}: ${A}`));return{contents:r,keys:l,overrides:I,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}i(i,s,c,u){let r=!1;if(!u?.scopes&&!u?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:r};const l={},I=[];for(const A in i)if(v.OVERRIDE_PROPERTY_REGEX.test(A)&&c){const O=this.i(i[A],s,!1,u);l[A]=O.raw,r=r||O.hasExcludedProperties,I.push(...O.restricted)}else{const O=s[A],N=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&I.push(A),(N===void 0||u.scopes===void 0||u.scopes.includes(N))&&!(u.skipRestricted&&O?.restricted)?l[A]=i[A]:r=!0}return{raw:l,restricted:I,hasExcludedProperties:r}}j(i,s){const c=[];for(const u of Object.keys(i))if(v.OVERRIDE_PROPERTY_REGEX.test(u)){const r={};for(const l in i[u])r[l]=i[u][l];c.push({identifiers:(0,v.overrideIdentifiersFromKey)(u),keys:Object.keys(r),contents:(0,b.toValuesTree)(r,s)})}return c}}e.ConfigurationModelParser=w;class o extends C.Disposable{constructor(i,s,c,u){super(),this.f=i,this.g=s,this.h=u,this.c=this.B(new M.Emitter),this.onDidChange=this.c.event,this.a=new w(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(c.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(M.Event.any(M.Event.filter(this.h.onDidFilesChange,r=>r.contains(this.f)),M.Event.filter(this.h.onDidRunOperation,r=>(r.isOperation(0)||r.isOperation(3)||r.isOperation(1)||r.isOperation(4))&&c.isEqual(r.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new m}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=o;class h{constructor(i,s,c,u,r,l,I,A,O,N,X,V,K){this.a=i,this.b=s,this.c=c,this.overrideIdentifiers=u,this.d=r,this.f=l,this.g=I,this.h=A,this.i=O,this.j=N,this.k=X,this.l=V,this.m=K}get value(){return g(this.c)}n(i,s,c){const u=i.inspect(s,c);return{get value(){return g(u.value)},get override(){return g(u.override)},get merged(){return g(u.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class p{constructor(i,s,c,u,r=new m,l=new m,I=new D.ResourceMap,A=new m,O=new D.ResourceMap){this.c=i,this.d=s,this.f=c,this.g=u,this.h=r,this.i=l,this.j=I,this.l=A,this.m=O,this.a=null,this.b=new D.ResourceMap,this.n=null}getValue(i,s,c){return this.q(i,s,c).getValue(i)}updateValue(i,s,c={}){let u;c.resource?(u=this.m.get(c.resource),u||(u=new m,this.m.set(c.resource,u))):u=this.l,s===void 0?u.removeValue(i):u.setValue(i,s),c.resource||(this.a=null)}inspect(i,s,c){const u=this.q(i,s,c),r=this.u(s.resource,c),l=s.resource?this.m.get(s.resource)||this.l:this.l,I=new Set;for(const A of u.overrides)for(const O of A.identifiers)u.getOverrideValue(i,O)!==void 0&&I.add(O);return new h(i,s,u.getValue(i),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this.i:void 0,r||void 0,l)}keys(i){const s=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,s){this.j.set(i,s),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const c=[];if(!s){const{added:u,updated:r,removed:l}=R(this.c,i);s=[...u,...r,...l]}for(const u of s)for(const r of(0,v.overrideIdentifiersFromKey)(u)){const l=this.c.getKeysForOverrideIdentifier(r),I=i.getKeysForOverrideIdentifier(r),A=[...I.filter(O=>l.indexOf(O)===-1),...l.filter(O=>I.indexOf(O)===-1),...l.filter(O=>!P.equals(this.c.override(r).getValue(O),i.override(r).getValue(O)))];c.push([r,A])}return this.updateDefaultConfiguration(i),{keys:s,overrides:c}}compareAndUpdatePolicyConfiguration(i){const{added:s,updated:c,removed:u}=R(this.d,i),r=[...s,...c,...u];return r.length&&this.updatePolicyConfiguration(i),{keys:r,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:s,updated:c,removed:u,overrides:r}=R(this.applicationConfiguration,i),l=[...s,...c,...u];return l.length&&this.updateApplicationConfiguration(i),{keys:l,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:c,removed:u,overrides:r}=R(this.localUserConfiguration,i),l=[...s,...c,...u];return l.length&&this.updateLocalUserConfiguration(i),{keys:l,overrides:r}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:c,removed:u,overrides:r}=R(this.remoteUserConfiguration,i),l=[...s,...c,...u];return l.length&&this.updateRemoteUserConfiguration(i),{keys:l,overrides:r}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:c,removed:u,overrides:r}=R(this.workspaceConfiguration,i),l=[...s,...c,...u];return l.length&&this.updateWorkspaceConfiguration(i),{keys:l,overrides:r}}compareAndUpdateFolderConfiguration(i,s){const c=this.p.get(i),{added:u,updated:r,removed:l,overrides:I}=R(c,s),A=[...u,...r,...l];return(A.length||!c)&&this.updateFolderConfiguration(i,s),{keys:A,overrides:I}}compareAndDeleteFolderConfiguration(i){const s=this.p.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:c,updated:u,removed:r,overrides:l}=R(s,void 0);return{keys:[...c,...u,...r],overrides:l}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,s,c){let u=this.r(s,c);return s.overrideIdentifier&&(u=u.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(u=u.merge(this.d)),u}r({resource:i},s){let c=this.s();if(s&&i){const u=s.getFolder(i);u&&(c=this.t(u.uri)||c);const r=this.m.get(i);r&&(c=c.merge(r))}return c}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let s=this.b.get(i);if(!s){const c=this.s(),u=this.j.get(i);u?(s=c.merge(u),this.b.set(i,s)):s=c}return s}u(i,s){if(s&&i){const c=s.getFolder(i);if(c)return this.j.get(c.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,s)=>{const{contents:c,overrides:u,keys:r}=this.j.get(s);return i.push([s,{contents:c,overrides:u,keys:r}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(s=>i.add(s)),this.userConfiguration.keys.forEach(s=>i.add(s)),this.i.keys.forEach(s=>i.add(s)),this.j.forEach(s=>s.keys.forEach(c=>i.add(c))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(c=>i.add(c))),[...i.values()]}w(i){const s=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(c=>s.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(c=>s.add(c)),this.i.getKeysForOverrideIdentifier(i).forEach(c=>s.add(c)),this.j.forEach(c=>c.getKeysForOverrideIdentifier(i).forEach(u=>s.add(u))),[...s.values()]}static parse(i){const s=this.x(i.defaults),c=this.x(i.policy),u=this.x(i.application),r=this.x(i.user),l=this.x(i.workspace),I=i.folders.reduce((A,O)=>(A.set(d.URI.revive(O[0]),this.x(O[1])),A),new D.ResourceMap);return new p(s,c,u,r,new m,l,I,new m,new D.ResourceMap)}static x(i){return new m(i.contents,i.keys,i.overrides)}}e.Configuration=p;function k(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,s=new Map;for(const u of a)u.keys.forEach(r=>i.add(r)),u.overrides.forEach(([r,l])=>{const I=(0,D.getOrSet)(s,r,new Set);l.forEach(A=>I.add(A))});const c=[];return s.forEach((u,r)=>c.push([r,[...u.values()]])),{keys:[...i.values()],overrides:c}}e.mergeChanges=k;class S{constructor(i,s,c,u){this.change=i,this.f=s,this.g=c,this.h=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const r of i.keys)this.affectedKeys.add(r);for(const[,r]of i.overrides)for(const l of r)this.affectedKeys.add(l);this.d=this.a;for(const r of this.affectedKeys)this.d+=r+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=p.parse(this.f.data)),this.i}affectsConfiguration(i,s){const c=this.a+i,u=this.d.indexOf(c);if(u<0)return!1;const r=u+c.length;if(r>=this.d.length)return!1;const l=this.d.charCodeAt(r);if(l!==this.b&&l!==this.c)return!1;if(s){const I=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.f?.workspace):void 0,A=this.g.getValue(i,s,this.h);return!P.equals(I,A)}return!0}}e.ConfigurationChangeEvent=S;function R(a,i){const{added:s,removed:c,updated:u}=t(i?.rawConfiguration,a?.rawConfiguration),r=[],l=a?.getAllOverrideIdentifiers()||[],I=i?.getAllOverrideIdentifiers()||[];if(i){const A=I.filter(O=>!l.includes(O));for(const O of A)r.push([O,i.getKeysForOverrideIdentifier(O)])}if(a){const A=l.filter(O=>!I.includes(O));for(const O of A)r.push([O,a.getKeysForOverrideIdentifier(O)])}if(i&&a){for(const A of l)if(I.includes(A)){const O=t({contents:a.getOverrideValue(void 0,A)||{},keys:a.getKeysForOverrideIdentifier(A)},{contents:i.getOverrideValue(void 0,A)||{},keys:i.getKeysForOverrideIdentifier(A)});r.push([A,[...O.added,...O.removed,...O.updated]])}}return{added:s,removed:c,updated:u,overrides:r}}function t(a,i){const s=a?i?a.keys.filter(r=>i.keys.indexOf(r)===-1):[...a.keys]:[],c=i?a?i.keys.filter(r=>a.keys.indexOf(r)===-1):[...i.keys]:[],u=[];if(a&&i){for(const r of i.keys)if(a.keys.indexOf(r)!==-1){const l=(0,b.getConfigurationValue)(i.contents,r),I=(0,b.getConfigurationValue)(a.contents,r);P.equals(l,I)||u.push(r)}}return{added:s,removed:c,updated:u}}}),define(ee[225],te([0,1,25,3,2,40,10,111,68,5,37,51]),function(G,e,E,M,n,C,D,P,f,d,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class y extends n.Disposable{constructor(){super(...arguments),this.a=this.B(new M.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(v.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(({properties:o,defaultsOverrides:h})=>this.c(Array.from(o),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(o,h){this.h(o,v.Registry.as(f.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:o})}f(){return{}}g(){this.b=new P.ConfigurationModel;const o=v.Registry.as(f.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(o),o)}h(o,h){const p=this.f();for(const k of o){const S=p[k],R=h[k];S!==void 0?this.b.addValue(k,S):R?this.b.addValue(k,R.default):this.b.removeValue(k)}}}e.DefaultConfiguration=y;class g{constructor(){this.onDidChangeConfiguration=M.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=g;let m=class extends n.Disposable{get configurationModel(){return this.b}constructor(o,h,p){super(),this.c=o,this.f=h,this.g=p,this.a=this.B(new M.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(o=>this.i(o))),this.B(this.c.onDidChangeConfiguration(async({properties:o})=>this.j(await this.h(o),!0))),this.b}async h(o){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",o);const h={},p=[],k=v.Registry.as(f.Extensions.Configuration).getConfigurationProperties();for(const S of o){const R=k[S];if(!R){p.push(S);continue}if(R.policy){if(R.type!=="string"&&R.type!=="number"){this.g.warn(`Policy ${R.policy.name} has unsupported type ${R.type}`);continue}p.push(S),h[R.policy.name]={type:R.type}}}return(0,D.isEmptyObject)(h)||await this.f.updatePolicyDefinitions(h),p}i(o){this.g.trace("PolicyConfiguration#onDidChangePolicies",o);const h=v.Registry.as(f.Extensions.Configuration).getPolicyConfigurations(),p=(0,E.coalesce)(o.map(k=>h.get(k)));this.j(p,!0)}j(o,h){this.g.trace("PolicyConfiguration#update",o);const p=v.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),k=[],S=this.b.isEmpty();for(const R of o){const t=p[R]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(S?a!==void 0:!(0,C.equals)(this.b.getValue(R),a))&&k.push([R,a])}else this.b.getValue(R)!==void 0&&k.push([R,void 0])}if(k.length){this.g.trace("PolicyConfiguration#changed",k);const R=this.b;this.b=new P.ConfigurationModel;for(const t of R.keys)this.b.setValue(t,R.getValue(t));for(const[t,a]of k)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);h&&this.a.fire(this.b)}}};m=ve([_(1,b.IPolicyService),_(2,d.ILogService)],m),e.PolicyConfiguration=m}),define(ee[226],te([0,1,8,3,2,18,19,111,225,37]),function(G,e,E,M,n,C,D,P,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends n.Disposable{constructor(y,g,m,w){super(),this.i=y,this.h=this.B(new M.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new f.DefaultConfiguration),this.c=m instanceof d.NullPolicyService?new f.NullPolicyConfiguration:this.B(new f.PolicyConfiguration(this.b,m,w)),this.f=this.B(new P.UserSettings(this.i,void 0,C.extUriBiasedIgnorePathCase,g)),this.a=new P.Configuration(this.b.configurationModel,this.c.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.g=this.B(new E.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:o,properties:h})=>this.k(o,h))),this.B(this.c.onDidChangeConfiguration(o=>this.l(o))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[y,g,m]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.Configuration(y,g,new P.ConfigurationModel,m)}getConfigurationData(){return this.a.toData()}getValue(y,g){const m=typeof y=="string"?y:void 0,w=(0,D.isConfigurationOverrides)(y)?y:(0,D.isConfigurationOverrides)(g)?g:{};return this.a.getValue(m,w,void 0)}updateValue(y,g,m,w){return Promise.reject(new Error("not supported"))}inspect(y){return this.a.inspect(y,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const y=await this.f.loadConfiguration();this.j(y)}j(y){const g=this.a.toData(),m=this.a.compareAndUpdateLocalUserConfiguration(y);this.m(m,g,2)}k(y,g){const m=this.a.toData(),w=this.a.compareAndUpdateDefaultConfiguration(y,g);this.m(w,m,7)}l(y){const g=this.a.toData(),m=this.a.compareAndUpdatePolicyConfiguration(y);this.m(m,g,7)}m(y,g,m){const w=new P.ConfigurationChangeEvent(y,{data:g},this.a);w.source=m,w.sourceConfig=this.n(m),this.h.fire(w)}n(y){switch(y){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(ee[227],te([0,1,13,6]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,M.createDecorator)("remoteAuthorityResolverService");var n;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class C extends E.ErrorNoTelemetry{static isNotAvailable(f){return f instanceof C&&f._code===n.NotAvailable}static isTemporarilyNotAvailable(f){return f instanceof C&&f._code===n.TemporarilyNotAvailable}static isNoResolverFound(f){return f instanceof C&&f._code===n.NoResolverFound}static isHandled(f){return f instanceof C&&f.isHandled}constructor(f,d=n.Unknown,b){super(f),this._message=f,this._code=d,this._detail=b,this.isHandled=d===n.NotAvailable&&b===!0,Object.setPrototypeOf(this,C.prototype)}}e.RemoteAuthorityResolverError=C;function D(P){const f=P.indexOf("+");return f===-1?P:P.substring(0,f)}e.getRemoteAuthorityPrefix=D}),define(ee[56],te([0,1,15]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function M(d){return d.scheme===E.Schemas.vscodeRemote?d.authority:void 0}e.getRemoteAuthority=M;function n(d){if(!d)return;const b=d.indexOf("+");return b<0?d:d.substr(0,b)}e.getRemoteName=n;function C(d){return`/${d.quality??"oss"}-${d.commit??"dev"}`}e.getRemoteServerRootPath=C;function D(d){const{host:b,port:v}=f(d);if(typeof v>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:v}}e.parseAuthorityWithPort=D;function P(d,b){let{host:v,port:y}=f(d);return typeof y>"u"&&(y=b),{host:v,port:y}}e.parseAuthorityWithOptionalPort=P;function f(d){const b=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const v=d.match(/^(\[[0-9a-z:]+\])$/);if(v)return{host:v[1],port:void 0};const y=d.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:d,port:void 0}}}),define(ee[91],te([0,1,27,6,56]),function(G,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=C;function D(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var f;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(f=e.TargetPlatform||(e.TargetPlatform={}));class d{constructor(w){this.value=w,this.c=w.toLowerCase()}static equals(w,o){if(typeof w>"u"||w===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof w=="string"||typeof o=="string"){const h=typeof w=="string"?w:w.value,p=typeof o=="string"?o:o.value;return E.equalsIgnoreCase(h,p)}return w.c===o.c}static toKey(w){return typeof w=="string"?w.toLowerCase():w.c}}e.ExtensionIdentifier=d;function b(m){return v(m)}e.isApplicationScopedExtension=b;function v(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=v;function y(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=y;function g(m,w){if(w){const o=`onResolveRemoteAuthority:${(0,n.getRemoteName)(w)}`;return m.activationEvents?.indexOf(o)!==-1}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[228],te([0,1,8,17,22,13,3,2,64,71,31,104,227,56]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const m=30*1e3;var w;(function(L){L[L.Management=1]="Management",L[L.ExtensionHost=2]="ExtensionHost",L[L.Tunnel=3]="Tunnel"})(w=e.ConnectionType||(e.ConnectionType={}));function o(L){switch(L){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(L){const T=new n.CancellationTokenSource;return setTimeout(()=>T.cancel(),L),T.token}function p(L,T){if(L.isCancellationRequested||T.isCancellationRequested)return n.CancellationToken.Cancelled;const B=new n.CancellationTokenSource;return L.onCancellationRequested(()=>B.cancel()),T.onCancellationRequested(()=>B.cancel()),B.token}class k{get didTimeout(){return this.c==="timedout"}constructor(T){this.c="pending",this.d=new P.DisposableStore,this.promise=new Promise((B,H)=>{this.f=B,this.g=H}),T.isCancellationRequested?this.h():this.d.add(T.onCancellationRequested(()=>this.h()))}registerDisposable(T){this.c==="pending"?this.d.add(T):T.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const T=new Error("Time limit reached");return T.code="ETIMEDOUT",T.syscall="connect",T}resolve(T){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(T))}reject(T){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(T))}}function S(L,T){const B=new k(T);return B.registerDisposable(L.onControlMessage(H=>{const j=JSON.parse(H.toString()),$=z(j);$?B.reject($):B.resolve(j)})),B.promise}function R(L,T,B,H,j,$,q,oe,de){const pe=new k(de),ye=d.StopWatch.create(!1);return L.info(`Creating a socket (${oe})...`),f.mark(`code/willCreateSocket/${q}`),T.connect(B,H,j,$,oe,(Le,Fe)=>{pe.didTimeout?(f.mark(`code/didCreateSocketError/${q}`),L.info(`Creating a socket (${oe}) finished after ${ye.elapsed()} ms, but this is too late and has timed out already.`),Le&&L.error(Le),Fe?.dispose()):Le||!Fe?(f.mark(`code/didCreateSocketError/${q}`),L.info(`Creating a socket (${oe}) returned an error after ${ye.elapsed()} ms.`),pe.reject(Le)):(f.mark(`code/didCreateSocketOK/${q}`),L.info(`Creating a socket (${oe}) was successful after ${ye.elapsed()} ms.`),pe.resolve(Fe))}),pe.promise}function t(L,T){const B=new k(T);return L.then(H=>{B.didTimeout||B.resolve(H)},H=>{B.didTimeout||B.reject(H)}),B.promise}async function a(L,T,B,H){const j=Z(L,T);L.logService.trace(`${j} 1/6. invoking socketFactory.connect().`);let $;try{$=await R(L.logService,L.socketFactory,L.host,L.port,(0,g.getRemoteServerRootPath)(L),`reconnectionToken=${L.reconnectionToken}&reconnection=${L.reconnectionProtocol?"true":"false"}`,o(T),`renderer-${o(T)}-${L.reconnectionToken}`,H)}catch(ye){throw L.logService.error(`${j} socketFactory.connect() failed or timed out. Error:`),L.logService.error(ye),ye}L.logService.trace(`${j} 2/6. socketFactory.connect() was successful.`);let q,oe;L.reconnectionProtocol?(L.reconnectionProtocol.beginAcceptReconnection($,null),q=L.reconnectionProtocol,oe=!1):(q=new v.PersistentProtocol({socket:$,measureRoundTripTime:!0}),oe=!0),L.logService.trace(`${j} 3/6. sending AuthRequest control message.`);const de=await t(L.signService.createNewMessage((0,b.generateUuid)()),H),pe={type:"auth",auth:L.connectionToken||"00000000000000000000",data:de.data};q.sendControl(M.VSBuffer.fromString(JSON.stringify(pe)));try{const ye=await S(q,p(H,h(1e4)));if(ye.type!=="sign"||typeof ye.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(L.logService.trace(`${j} 4/6. received SignRequest control message.`),!await t(L.signService.validate(de,ye.signedData),H)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const Fe=await t(L.signService.sign(ye.data),H),Te={type:"connectionType",commit:L.commit,signedData:Fe,desiredConnectionType:T};return B&&(Te.args=B),L.logService.trace(`${j} 5/6. sending ConnectionTypeRequest control message.`),q.sendControl(M.VSBuffer.fromString(JSON.stringify(Te))),{protocol:q,ownsProtocol:oe}}catch(ye){throw ye&&ye.code==="ETIMEDOUT"&&(L.logService.error(`${j} the handshake timed out. Error:`),L.logService.error(ye)),ye&&ye.code==="VSCODE_CONNECTION_ERROR"&&(L.logService.error(`${j} received error control message when negotiating connection. Error:`),L.logService.error(ye)),oe&&W(q),ye}}async function i(L,T,B,H){const j=Date.now(),$=Z(L,T),{protocol:q,ownsProtocol:oe}=await a(L,T,B,H),de=new k(H);return de.registerDisposable(q.onControlMessage(pe=>{const ye=JSON.parse(pe.toString()),Le=z(ye);Le?(L.logService.error(`${$} received error control message when negotiating connection. Error:`),L.logService.error(Le),oe&&W(q),de.reject(Le)):(L.reconnectionProtocol?.endAcceptReconnection(),L.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${U(j)}!`),de.resolve({protocol:q,firstMessage:ye}))})),de.promise}async function s(L,T){const{protocol:B}=await i(L,1,void 0,T);return{protocol:B}}async function c(L,T,B){const{protocol:H,firstMessage:j}=await i(L,2,T,B),$=j&&j.debugPort;return{protocol:H,debugPort:$}}async function u(L,T,B){const H=Date.now(),j=Z(L,3),{protocol:$}=await a(L,3,T,B);return L.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${U(H)}!`),$}async function r(L,T,B){const{host:H,port:j,connectionToken:$}=await L.addressProvider.getAddress();return{commit:L.commit,quality:L.quality,host:H,port:j,connectionToken:$,reconnectionToken:T,reconnectionProtocol:B,socketFactory:L.socketFactory,signService:L.signService,logService:L.logService}}async function l(L,T,B){return A(L,async H=>{const{protocol:j}=await s(H,n.CancellationToken.None);return new x(L,T,B,H.reconnectionToken,j)})}e.connectRemoteAgentManagement=l;async function I(L,T){return A(L,async B=>{const{protocol:H,debugPort:j}=await c(B,T,n.CancellationToken.None);return new F(L,T,B.reconnectionToken,H,j)})}e.connectRemoteAgentExtensionHost=I;async function A(L,T){for(let H=1;;H++)try{const j=(0,b.generateUuid)(),$=await r(L,j,null);return await T($)}catch(j){if(H<5)L.logService.error(`[remote-connection][attempt ${H}] An error occurred in initial connection! Will retry... Error:`),L.logService.error(j);else throw L.logService.error(`[remote-connection][attempt ${H}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),L.logService.error(j),ge.triggerPermanentFailure(0,0,y.RemoteAuthorityResolverError.isHandled(j)),j}}async function O(L,T,B){const H=await r(L,(0,b.generateUuid)(),null);return await u(H,{host:T,port:B},n.CancellationToken.None)}e.connectRemoteAgentTunnel=O;function N(L){return(0,E.createCancelablePromise)(T=>new Promise((B,H)=>{const j=setTimeout(B,L*1e3);T.onCancellationRequested(()=>{clearTimeout(j),B()})}))}var X;(function(L){L[L.ConnectionLost=0]="ConnectionLost",L[L.ReconnectionWait=1]="ReconnectionWait",L[L.ReconnectionRunning=2]="ReconnectionRunning",L[L.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",L[L.ConnectionGain=4]="ConnectionGain",L[L.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(X=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class V{constructor(T,B){this.reconnectionToken=T,this.millisSinceLastIncomingData=B,this.type=0}}e.ConnectionLostEvent=V;class K{constructor(T,B,H,j){this.reconnectionToken=T,this.millisSinceLastIncomingData=B,this.durationSeconds=H,this.c=j,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=K;class ie{constructor(T,B,H){this.reconnectionToken=T,this.millisSinceLastIncomingData=B,this.attempt=H,this.type=2}}e.ReconnectionRunningEvent=ie;class re{constructor(T,B,H){this.reconnectionToken=T,this.millisSinceLastIncomingData=B,this.attempt=H,this.type=4}}e.ConnectionGainEvent=re;class ce{constructor(T,B){this.reconnectionToken=T,this.connectionHealth=B,this.type=5}}e.ConnectionHealthChangedEvent=ce;class fe{constructor(T,B,H,j){this.reconnectionToken=T,this.millisSinceLastIncomingData=B,this.attempt=H,this.handled=j,this.type=3}}e.ReconnectionPermanentFailureEvent=fe;class ge extends P.Disposable{static triggerPermanentFailure(T,B,H){this._permanentFailure=!0,this.f=T,this.g=B,this.h=H,this.i.forEach(j=>j.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(T=>T.r())}static debugPauseSocketWriting(){this.i.forEach(T=>T.v())}get k(){return this.c||ge._permanentFailure}constructor(T,B,H,j,$){super(),this.m=T,this.n=B,this.reconnectionToken=H,this.protocol=j,this.p=$,this.j=this.B(new D.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new re(this.reconnectionToken,0,0)),this.B(j.onSocketClose(q=>{const oe=se(this.m,this.reconnectionToken,!0);q?q.type===0?(this.n.logService.info(`${oe} received socket close event (hadError: ${q.hadError}).`),q.error&&this.n.logService.error(q.error)):(this.n.logService.info(`${oe} received socket close event (wasClean: ${q.wasClean}, code: ${q.code}, reason: ${q.reason}).`),q.event&&this.n.logService.error(q.event)):this.n.logService.info(`${oe} received socket close event.`),this.r()})),this.B(j.onSocketTimeout(q=>{const oe=se(this.m,this.reconnectionToken,!0);this.n.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${q.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${q.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${q.timeSinceLastReceivedSomeData}).`),this.r()})),this.B(j.onHighRoundTripTime(q=>{const oe=ne(this.m,this.reconnectionToken);this.n.logService.info(`${oe} high roundtrip time: ${q.roundTripTime}ms (${q.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B(j.onDidChangeConnectionHealth(q=>{this.j.fire(new ce(this.reconnectionToken,q))})),ge.i.push(this),this.B((0,P.toDisposable)(()=>{const q=ge.i.indexOf(this);q>=0&&ge.i.splice(q,1)})),this.k&&this.u(ge.f,ge.g,ge.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const T=se(this.m,this.reconnectionToken,!0);this.n.logService.info(`${T} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const B=[0,5,5,10,10,10,10,10,30];let H=-1;do{H++;const j=H<B.length?B[H]:B[B.length-1];try{if(j>0){const q=N(j);this.j.fire(new K(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j,q)),this.n.logService.info(`${T} waiting for ${j} seconds before reconnecting...`);try{await q}catch{}}if(this.k){this.n.logService.error(`${T} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new ie(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H+1)),this.n.logService.info(`${T} resolving connection...`);const $=await r(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${T} connecting to ${$.host}:${$.port}...`),await this.w($,h(m)),this.n.logService.info(`${T} reconnected!`),this.j.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H+1));break}catch($){if($.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${T} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error($),this.t(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}if(H>360){this.n.logService.error(`${T} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error($),this.t(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}if(y.RemoteAuthorityResolverError.isTemporarilyNotAvailable($)){this.n.logService.info(`${T} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace($);continue}if(($.code==="ETIMEDOUT"||$.code==="ENETUNREACH"||$.code==="ECONNREFUSED"||$.code==="ECONNRESET")&&$.syscall==="connect"){this.n.logService.info(`${T} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace($);continue}if((0,C.isCancellationError)($)){this.n.logService.info(`${T} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace($);continue}if($ instanceof y.RemoteAuthorityResolverError){this.n.logService.error(`${T} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error($),this.t(this.protocol.getMillisSinceLastIncomingData(),H+1,y.RemoteAuthorityResolverError.isHandled($));break}this.n.logService.error(`${T} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error($),this.t(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}}while(!this.k)}t(T,B,H){this.p?ge.triggerPermanentFailure(T,B,H):this.u(T,B,H)}u(T,B,H){this.j.fire(new fe(this.reconnectionToken,T,B,H)),W(this.protocol)}v(){this.protocol.pauseSocketWriting()}}ge._permanentFailure=!1,ge.f=0,ge.g=0,ge.h=!1,ge.i=[],e.PersistentConnection=ge;class x extends ge{constructor(T,B,H,j,$){super(1,T,j,$,!0),this.client=this.B(new v.Client($,{remoteAuthority:B,clientId:H},T.ipcLogger))}async w(T,B){await s(T,B)}}e.ManagementPersistentConnection=x;class F extends ge{constructor(T,B,H,j,$){super(2,T,H,j,!1),this.y=B,this.debugPort=$}async w(T,B){await c(T,this.y,B)}}e.ExtensionHostPersistentConnection=F;function W(L){try{L.acceptDisconnect();const T=L.getSocket();L.dispose(),T.dispose()}catch(T){(0,C.onUnexpectedError)(T)}}function z(L){if(L&&L.type==="error"){const T=new Error(`Connection error: ${L.reason}`);return T.code="VSCODE_CONNECTION_ERROR",T}return null}function J(L,T){for(;L.length<T;)L+=" ";return L}function ne(L,T){return`[remote-connection][${J(o(L),13)}][${T.substr(0,5)}\u2026]`}function se(L,T,B){return`${ne(L,T)}[${B?"reconnect":"initial"}]`}function Z(L,T){return`${se(T,L.reconnectionToken,!!L.reconnectionProtocol)}[${L.host}:${L.port}]`}function U(L){return`${Date.now()-L} ms`}}),define(ee[229],te([0,1,82,87]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(n,C,D,P,f,d){const b=y=>d(y,void 0),v=E.createConnection({host:n,port:C},()=>{v.removeListener("error",b);const y=Buffer.alloc(16);for(let o=0;o<16;o++)y[o]=Math.round(Math.random()*256);const g=y.toString("base64"),m=[`GET ws://${/:/.test(n)?`[${n}]`:n}:${C}${D}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`];v.write(m.join(`\r
`)+`\r
\r
`);const w=o=>{o.toString().indexOf(`\r
\r
`)>=0&&(v.off("data",w),d(void 0,new M.NodeSocket(v,f)))};v.on("data",w)});v.setNoDelay(!0),v.once("error",b)}}}),define(ee[230],te([0,1,26,46,41,188]),function(G,e,E,M,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let D;async function P(g=!1){return(D===void 0||g)&&(D=f()),D}e.hasWSLFeatureInstalled=P;async function f(){const g=d();if(g===void 0)return!1;if(g>=22e3){const m=v();if(m)return new Promise(w=>{M.execFile(m,["--status"],o=>w(!o))})}else{const m=y();if(m)try{if((await n.promises.stat(m)).isFile())return!0}catch{}}return!1}function d(){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());if(g)return parseInt(g[3])}function b(g){const m=process.env.SystemRoot;if(m){const w=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return C.join(m,w?"Sysnative":"System32",g)}}function v(){return b("wsl.exe")}function y(){return b("lxss\\LxssManager.dll")}}),define(ee[57],te([0,1,17,172,68,6,51]),function(G,e,E,M,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,C.createDecorator)("requestService");function P(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}e.isSuccess=P;function f(w){return w.res.statusCode===204}async function d(w){return f(w)?null:(await(0,E.streamToBuffer)(w.stream)).toString()}e.asText=d;async function b(w){if(!P(w))throw new Error("Server returned "+w.res.statusCode);return d(w)}e.asTextOrError=b;async function v(w){if(!P(w))throw new Error("Server returned "+w.res.statusCode);if(f(w))return null;const h=(await(0,E.streamToBuffer)(w.stream)).toString();try{return JSON.parse(h)}catch(p){throw p.message+=`:
`+h,p}}e.asJson=v;function y(w){m(w)}e.updateProxyConfigurationsScope=y;let g;function m(w){const o=D.Registry.as(n.Extensions.Configuration),h=g;g={id:"http",order:15,title:(0,M.localize)(0,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(4,null),(0,M.localize)(5,null),(0,M.localize)(6,null),(0,M.localize)(7,null)],default:"override",description:(0,M.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(9,null),restricted:!0}}},o.updateConfigurations({add:[g],remove:h?[h]:[]})}m(2)}),define(ee[231],te([0,1,17,22]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class n{constructor(P){this.a=P}listen(P,f){throw new Error("Invalid listen")}call(P,f,d,b=M.CancellationToken.None){switch(f){case"request":return this.a.request(d[0],b).then(async({res:v,stream:y})=>{const g=await(0,E.streamToBuffer)(y);return[{statusCode:v.statusCode,headers:v.headers},g]});case"resolveProxy":return this.a.resolveProxy(d[0])}throw new Error("Invalid call")}}e.RequestChannel=n;class C{constructor(P){this.a=P}async request(P,f){const[d,b]=await this.a.call("request",[P],f);return{res:d,stream:(0,E.bufferToStream)(b)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.RequestChannelClient=C}),define(ee[232],te([0,1,233,10]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function n(D,P){return D.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:D.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function C(D,P,f={}){const d=(0,E.parse)(D),b=f.proxyUrl||n(d,P);if(!b)return null;const v=(0,E.parse)(b);if(!/^https?:$/.test(v.protocol||""))return null;const y={host:v.hostname||"",port:v.port||(v.protocol==="https"?"443":"80"),auth:v.auth,rejectUnauthorized:(0,M.isBoolean)(f.strictSSL)?f.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((g,m)=>{G(["http-proxy-agent"],g,m)}))(y):new(await new Promise((g,m)=>{G(["https-proxy-agent"],g,m)}))(y)}e.getProxyAgent=C}),define(ee[112],te([0,1,46,9,173,22,44,13,4,31,148,62,8,127]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let m;async function w(h,p,k,S){return k["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.isLaunchedFromCli)(S)&&!k["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.isLaunchedFromCli)(S)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=y.Promises.withAsyncBody(async(R,t)=>{const a=new C.CancellationTokenSource;let i=1e4;const s=h.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(i=(0,g.clamp)(s,1,120)*1e3);const c=setTimeout(()=>{a.dispose(!0),t(new Error((0,n.localize)(0,null)))},i);try{R(await o(p,a.token))}catch(u){!(0,P.isCancellationError)(u)&&!a.token.isCancellationRequested?t(new Error((0,n.localize)(1,null,(0,D.toErrorMessage)(u)))):R({})}finally{clearTimeout(c),a.dispose()}})),m)}e.getResolvedShellEnv=w;async function o(h,p){const k=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",k);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",S);const R=(0,d.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(R+"({.*})"+R),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",a);const i=await(0,b.getSystemShell)(f.OS,a);return h.trace("getUnixShellEnvironment#shell",i),new Promise((s,c)=>{if(p.isCancellationRequested)return c(new P.CancellationError);const u=(0,M.basename)(i);let r,l;const I=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(u)?(r=`& '${process.execPath}' ${I} -p '''${R}'' + JSON.stringify(process.env) + ''${R}'''`,l=["-Login","-Command"]):(r=`'${process.execPath}' ${I} -p '"${R}" + JSON.stringify(process.env) + "${R}"'`,u==="tcsh"||u==="csh"?l=["-ic"]:l=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),r);const A=(0,E.spawn)(i,[...l,r],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});p.onCancellationRequested(()=>(A.kill(),c(new P.CancellationError))),A.on("error",X=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(X)),c(X)});const O=[];A.stdout.on("data",X=>O.push(X));const N=[];A.stderr.on("data",X=>N.push(X)),A.on("close",(X,V)=>{const K=Buffer.concat(O).toString("utf8");h.trace("getUnixShellEnvironment#raw",K);const ie=Buffer.concat(N).toString("utf8");if(ie.trim()&&h.trace("getUnixShellEnvironment#stderr",ie),X||V)return c(new Error((0,n.localize)(2,null,X,V)));const re=t.exec(K),ce=re?re[1]:"{}";try{const fe=JSON.parse(ce);k?fe.ELECTRON_RUN_AS_NODE=k:delete fe.ELECTRON_RUN_AS_NODE,S?fe.ELECTRON_NO_ATTACH_CONSOLE=S:delete fe.ELECTRON_NO_ATTACH_CONSOLE,delete fe.VSCODE_RESOLVING_ENVIRONMENT,delete fe.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",fe),s(fe)}catch(fe){h.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(fe)),c(fe)}})})}}),define(ee[92],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,E.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[234],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class E{constructor(){this.b=new Map}c(){return new Promise((n,C)=>G(["vsda"],n,C))}async createNewMessage(n){try{const C=await this.c(),D=new C.validator;if(D){const P=String(E.a++);return this.b.set(P,D),{id:P,data:D.createNewMessage(n)}}}catch{}return{id:"",data:n}}async validate(n,C){if(!n.id)return!0;const D=this.b.get(n.id);if(!D)return!1;this.b.delete(n.id);try{return D.validate(C)==="ok"}catch{return!1}}async sign(n){try{const C=await this.c(),D=new C.signer;if(D)return D.sign(n)}catch{}return n}}E.a=1,e.SignService=E}),define(ee[34],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,E.createDecorator)("stateMainService")}),define(ee[21],te([0,1,14,42,8,3,2,4,36,10,6,5,34,28]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,b.createDecorator)("lifecycleMainService");var m;(function(h){h[h.QUIT=1]="QUIT",h[h.KILL=2]="KILL"})(m=e.ShutdownReason||(e.ShutdownReason={}));var w;(function(h){h[h.Starting=1]="Starting",h[h.Ready=2]="Ready",h[h.AfterWindowOpen=3]="AfterWindowOpen",h[h.Eventually=4]="Eventually"})(w=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let o=class ft extends D.Disposable{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(p,k,S){super(),this.v=p,this.w=k,this.y=S,this.c=this.B(new C.Emitter),this.onBeforeShutdown=this.c.event,this.f=this.B(new C.Emitter),this.onWillShutdown=this.f.event,this.g=this.B(new C.Emitter),this.onWillLoadWindow=this.g.event,this.h=this.B(new C.Emitter),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.z(),this.when(2).then(()=>this.C())}z(){this.j=!!this.w.getItem(ft.b),this.j&&this.w.removeItem(ft.b)}C(){const p=()=>{this.i||(this.L("Lifecycle#app.on(before-quit)"),this.i=!0,this.L("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),P.isMacintosh&&this.n===0&&this.D(1))};E.app.addListener("before-quit",p);const k=()=>{this.L("Lifecycle#app.on(window-all-closed)"),(this.i||!P.isMacintosh)&&E.app.quit()};E.app.addListener("window-all-closed",k),E.app.once("will-quit",S=>{this.L("Lifecycle#app.on(will-quit)"),S.preventDefault(),this.D(1).finally(()=>{this.H(!1),E.app.removeListener("before-quit",p),E.app.removeListener("window-all-closed",k),E.app.quit()})})}D(p){if(this.s)return this.s;this.L("Lifecycle#onWillShutdown.fire()");const k=[];return this.f.fire({reason:p,join(S){k.push(S)}}),this.s=(async()=>{try{await n.Promises.settled(k)}catch(S){this.v.error(S)}try{await this.w.close()}catch(S){this.v.error(S)}})(),this.s}set phase(p){if(p<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===p)return;this.L(`lifecycle (main): phase changed (value: ${p})`),this.k=p;const k=this.u.get(this.k);k&&(k.open(),this.u.delete(this.k))}async when(p){if(p<=this.k)return;let k=this.u.get(p);k||(k=new n.Barrier,this.u.set(p,k)),await k.wait()}registerWindow(p){const k=new D.DisposableStore;this.n++,k.add(p.onWillLoad(R=>this.g.fire({window:p,workspace:R.workspace,reason:R.reason})));const S=(0,d.assertIsDefined)(p.win);S.on("close",R=>{const t=p.id;if(this.l.has(t)){this.l.delete(t);return}this.L(`Lifecycle#window.on('close') - window ID ${p.id}`),R.preventDefault(),this.unload(p,1).then(a=>{if(a){this.l.delete(t);return}this.l.add(t),this.L(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${t}`),this.h.fire(p),p.close()})}),S.on("closed",()=>{this.L(`Lifecycle#window.on('closed') - window ID ${p.id}`),this.n--,k.dispose(),this.n===0&&(!P.isMacintosh||this.i)&&this.D(1)})}async reload(p,k){await this.unload(p,3)||p.reload(k)}unload(p,k){const S=this.t.get(p.id);if(S)return S;const R=this.F(p,k).finally(()=>{this.t.delete(p.id)});return this.t.set(p.id,R),R}async F(p,k){if(!p.isReady)return!1;this.L(`Lifecycle#unload() - window ID ${p.id}`);const S=this.i?2:k,R=await this.I(p,S);return R?(this.L(`Lifecycle#unload() - veto in renderer (window ID ${p.id})`),this.G(R)):(await this.J(p,S),!1)}G(p){return p?(this.H(!0),this.i=!1,!0):!1}H(p){this.r&&(this.r(p),this.r=void 0,this.p=void 0)}I(p,k){return new Promise(S=>{const R=this.m++,t=`vscode:ok${R}`,a=`vscode:cancel${R}`;M.validatedIpcMain.once(t,()=>{S(!1)}),M.validatedIpcMain.once(a,()=>{S(!0)}),p.send("vscode:onBeforeUnload",{okChannel:t,cancelChannel:a,reason:k})})}J(p,k){return new Promise(S=>{const t=`vscode:reply${this.m++}`;M.validatedIpcMain.once(t,()=>S()),p.send("vscode:onWillUnload",{replyChannel:t,reason:k})})}quit(p){return this.L(`Lifecycle#quit() - begin (willRestart: ${p})`),this.p?(this.L("Lifecycle#quit() - returning pending quit promise"),this.p):(p&&this.w.setItem(ft.b,!0),this.p=new Promise(k=>{this.r=k,this.L("Lifecycle#quit() - calling app.quit()"),E.app.quit()}),this.p)}L(p){this.y.args["enable-smoke-test-driver"]?this.v.info(p):this.v.trace(p)}async relaunch(p){this.L("Lifecycle#relaunch()");const k=process.argv.slice(1);if(p?.addArgs&&k.push(...p.addArgs),p?.removeArgs)for(const t of p.removeArgs){const a=k.indexOf(t);a>=0&&k.splice(a,1)}const S=()=>{try{if(P.isWindows){const t=(0,f.cwd)();t!==process.cwd()&&process.chdir(t)}}catch(t){this.v.error(t)}this.L("Lifecycle#relaunch() - calling app.relaunch()"),E.app.relaunch({args:k})};E.app.once("quit",S),await this.quit(!0)&&E.app.removeListener("quit",S)}async kill(p){this.L("Lifecycle#kill()"),await this.D(2),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const k of E.BrowserWindow.getAllWindows())if(k&&!k.isDestroyed()){let S;k.webContents&&!k.webContents.isDestroyed()?S=new Promise(R=>k.once("closed",R)):S=Promise.resolve(),k.destroy(),await S}})()]),E.app.exit(p)}};o.b="lifecycle.quitAndRestart",o=ve([_(0,v.ILogService),_(1,y.IStateMainService),_(2,g.IEnvironmentMainService)],o),e.LifecycleMainService=o}),define(ee[235],te([0,1,4,3,2,6,21]),function(G,e,E,M,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,C.createDecorator)("keyboardLayoutMainService");let P=class extends n.Disposable{constructor(b){super(),this.a=this.B(new M.Emitter),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,b.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const b=await new Promise((v,y)=>{G(["native-keymap"],v,y)});this.c=f(b),E.isCI||b.onDidChangeKeyboardLayout(()=>{this.c=f(b),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};P=ve([_(0,D.ILifecycleMainService)],P),e.KeyboardLayoutMainService=P;function f(d){const b=d.getKeyMap(),v=d.getCurrentKeyboardLayout();return{keyboardMapping:b,keyboardLayoutInfo:v}}}),define(ee[236],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,E.createDecorator)("stateService")}),define(ee[237],te([0,1,8,17,10,33,16,5]),function(G,e,E,M,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class f{constructor(v,y,g){this.f=v,this.g=y,this.h=g,this.a=Object.create(null),this.b="",this.c=new E.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(v){v.fileOperationResult!==1&&this.g.error(v)}}getItem(v,y){const g=this.a[v];return(0,n.isUndefinedOrNull)(g)?y:g}setItem(v,y){this.setItems([{key:v,data:y}])}setItems(v){let y=!1;for(const{key:g,data:m}of v)this.a[g]!==m&&((0,n.isUndefinedOrNull)(m)?(0,n.isUndefined)(this.a[g])||(this.a[g]=void 0,y=!0):(this.a[g]=m,y=!0));y&&this.j()}removeItem(v){(0,n.isUndefined)(this.a[v])||(this.a[v]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const v=JSON.stringify(this.a,null,4);if(v!==this.b)try{await this.h.writeFile(this.f,M.VSBuffer.fromString(v)),this.b=v}catch(y){this.g.error(y)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=f;let d=class{constructor(v,y,g){this.a=new f(v.stateResource,y,g)}async init(){await this.a.init()}getItem(v,y){return this.a.getItem(v,y)}};d=ve([_(0,C.IEnvironmentService),_(1,P.ILogService),_(2,D.IFileService)],d),e.StateService=d}),define(ee[238],te([0,1,237]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class M extends E.StateService{setItem(C,D){this.a.setItem(C,D)}setItems(C){this.a.setItems(C)}removeItem(C){this.a.removeItem(C)}close(){return this.a.close()}}e.StateMainService=M}),define(ee[93],te([0,1,4,36,7,31]),function(G,e,E,M,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(d){if(E.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function P(d,b,v,y,g,m,w,o,h,p){const k=Object.create(null);k["common.machineId"]=w,k.sessionID=(0,C.generateUuid)()+Date.now(),k.commitHash=g,k.version=m,k["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),k["common.platform"]=(0,E.PlatformToString)(E.platform),k["common.nodePlatform"]=M.platform,k["common.nodeArch"]=y,k["common.product"]=p||"desktop",o&&(k["common.msftInternal"]=o);let S=0;const R=Date.now();Object.defineProperties(k,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-R,enumerable:!0},"common.sequence":{get:()=>S++,enumerable:!0}}),E.isLinuxSnap&&(k["common.snap"]="true");const t=D(v);t&&(k["common.platformDetail"]=t);try{const a=await d.readFile(n.URI.file(h));k["common.source"]=a.value.toString().slice(0,30)}catch{}return k}e.resolveCommonProperties=P;function f(d){const b=M.env.USERDNSDOMAIN;if(!b)return!1;const v=b.toLowerCase();return d.some(y=>v===y)}e.verifyMicrosoftInternalDomain=f}),define(ee[24],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,E.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,E.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var M;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(M=e.TelemetryLevel||(e.TelemetryLevel={}));var n;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(n=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ee[239],te([0,1,26,8,43,15,9,4,7,85,23,103,88,16,20,24]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const o=new Map;async function h(t,a){const i=`${t}::${a.join(":")}`,s=o.get(i);if(s)return s;const c=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,r=new Map,l=2e4;function I(O,N,X,V){const K=N.substring(O.length+1);return M.Promises.withAsyncBody(async ie=>{let re;try{re=await b.Promises.readdir(N,{withFileTypes:!0})}catch{ie();return}if(V.count>=l){V.count+=re.length,V.maxReached=!0,ie();return}let ce=re.length;if(ce===0){ie();return}let fe=re;V.count+re.length>l&&(V.maxReached=!0,ce=l-V.count,fe=re.slice(0,ce)),V.count+=re.length;for(const ge of fe)if(ge.isDirectory()){if(X.includes(ge.name)||await I(O,(0,D.join)(N,ge.name),X,V),--ce===0){ie();return}}else{const x=ge.name.lastIndexOf(".");if(x>=0){const F=ge.name.substring(x+1);F&&u.set(F,(u.get(F)??0)+1)}for(const F of c)F.relativePathPattern?.test(K)!==!1&&F.filePattern.test(ge.name)&&r.set(F.tag,(r.get(F.tag)??0)+1);if(--ce===0){ie();return}}})}const A=M.Promises.withAsyncBody(async O=>{const N={count:0,maxReached:!1};await I(t,t,a,N);const X=await S(t);O({configFiles:p(r),fileTypes:p(u),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:X})});return o.set(i,A),A}e.collectWorkspaceStats=h;function p(t){return Array.from(t.entries(),([a,i])=>({name:a,count:i})).sort((a,i)=>i.count-a.count)}function k(){const t={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(d.virtualMachineHint.value()*100)}%`},a=E.cpus();return a&&a.length>0&&(t.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),t}e.getMachineInfo=k;async function S(t){try{const a=new Map,i=(0,D.join)(t,".vscode","launch.json"),s=await b.Promises.readFile(i),c=[],u=(0,n.parse)(s.toString(),c);if(c.length)return console.log(`Unable to parse ${i}`),[];if((0,n.getNodeType)(u)==="object"&&u.configurations)for(const r of u.configurations){const l=r.type;l&&(a.has(l)?a.set(l,a.get(l)+1):a.set(l,1))}return p(a)}catch{return[]}}e.collectLaunchConfigs=S;let R=class{constructor(a,i){this.c=a,this.d=i}f(a){const i=[];return i.push(`OS Version:       ${a.os}`),i.push(`CPUs:             ${a.cpus}`),i.push(`Memory (System):  ${a.memory}`),i.push(`VM:               ${a.vmHint}`),i.join(`
`)}g(a){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const s=E.cpus();return s&&s.length>0&&i.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),i.push(`Memory (System):  ${(E.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||i.push(`Load (avg):       ${E.loadavg().map(c=>Math.round(c)).join(", ")}`),i.push(`VM:               ${Math.round(d.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${a.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(a,i){return Promise.all([(0,v.listProcesses)(a.mainPID),this.k(a)]).then(async s=>{let[c,u]=s,r=this.m(a,c);return i.forEach(l=>{if((0,y.isRemoteDiagnosticError)(l))r+=`
${l.errorMessage}`,u+=`
${l.errorMessage}`;else if(r+=`

Remote: ${l.hostName}`,l.processes&&(r+=`
${this.m(a,l.processes)}`),l.workspaceMetadata){u+=`
|  Remote: ${l.hostName}`;for(const I of Object.keys(l.workspaceMetadata)){const A=l.workspaceMetadata[I];let O=`${A.fileCount} files`;A.maxFilesReached&&(O=`more than ${O}`),u+=`|    Folder (${I}): ${O}`,u+=this.h(A)}}}),{processInfo:r,workspaceInfo:u}})}async getSystemInfo(a,i){const{memory:s,vmHint:c,os:u,cpus:r}=k(),l={os:u,memory:s,cpus:r,vmHint:c,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:i};return P.isWindows||(l.load=`${E.loadavg().map(I=>Math.round(I)).join(", ")}`),P.isLinux&&(l.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(l)}async getDiagnostics(a,i){const s=[];return(0,v.listProcesses)(a.mainPID).then(async c=>(s.push(""),s.push(this.g(a)),s.push(""),s.push(this.m(a,c)),a.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(a))),i.forEach(u=>{if((0,y.isRemoteDiagnosticError)(u))s.push(`
${u.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${u.hostName}`),s.push(this.f(u.machineInfo)),u.processes&&s.push(this.m(a,u.processes)),u.workspaceMetadata)for(const r of Object.keys(u.workspaceMetadata)){const l=u.workspaceMetadata[r];let I=`${l.fileCount} files`;l.maxFilesReached&&(I=`more than ${I}`),s.push(`Folder (${r}): ${I}`),s.push(this.h(l))}}),s.push(""),s.push(""),s.join(`
`)))}h(a){const i=[];let c=0;const u=(A,O)=>{const N=` ${A}(${O})`;c+N.length>60?(i.push(r),r="|                 ",c=r.length):c+=N.length,r+=N};let r="|      File types:";const l=10,I=a.fileTypes.length>l?l:a.fileTypes.length;for(let A=0;A<I;A++){const O=a.fileTypes[A];u(O.name,O.count)}if(i.push(r),a.configFiles.length>=0&&(r="|      Conf files:",c=0,a.configFiles.forEach(A=>{u(A.name,A.count)}),i.push(r)),a.launchConfigFiles.length>0){let A="|      Launch Configs:";a.launchConfigFiles.forEach(O=>{A+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),i.push(A)}return i.join(`
`)}j(a){const i=Math.max(...Object.keys(a).map(s=>s.length));return Object.keys(a).map(s=>`${s}:  ${" ".repeat(i-s.length)}  ${a[s]}`).join(`
                  `)}k(a){const i=[],s=[];return a.windows.forEach(c=>{c.folderURIs.length===0||!!c.remoteAuthority||(i.push(`|  Window (${c.title})`),c.folderURIs.forEach(u=>{const r=f.URI.revive(u);if(r.scheme===C.Schemas.file){const l=r.fsPath;s.push(h(l,["node_modules",".git"]).then(I=>{let A=`${I.fileCount} files`;I.maxFilesReached&&(A=`more than ${A}`),i.push(`|    Folder (${(0,D.basename)(l)}): ${A}`),i.push(this.h(I))}).catch(I=>{i.push(`|      Error: Unable to collect workspace stats for folder ${l} (${I.toString()})`)}))}else i.push(`|    Folder (${r.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(c=>i.join(`
`)).catch(c=>`Unable to collect workspace stats: ${c}`)}m(a,i){const s=new Map;a.windows.forEach(u=>s.set(u.pid,u.title));const c=[];return c.push("CPU %	Mem MB	   PID	Process"),i&&this.n(a.mainPID,s,c,i,0),c.join(`
`)}n(a,i,s,c,u){const r=u===0;let l;r?l=c.pid===a?`${this.d.applicationName} main`:"remote agent":(l=`${"  ".repeat(u)} ${c.name}`,c.name==="window"&&(l=`${l} (${i.get(c.pid)})`));const I=process.platform==="win32"?c.mem:E.totalmem()*(c.mem/100);s.push(`${c.load.toFixed(0).padStart(5," ")}	${(I/g.ByteSize.MB).toFixed(0).padStart(6," ")}	${c.pid.toFixed(0).padStart(6," ")}	${l}`),Array.isArray(c.children)&&c.children.forEach(A=>this.n(a,i,s,A,u+1))}async getWorkspaceFileExtensions(a){const i=new Set;for(const{uri:s}of a.folders){const c=f.URI.revive(s);if(c.scheme!==C.Schemas.file)continue;const u=c.fsPath;try{(await h(u,["node_modules",".git"])).fileTypes.forEach(l=>i.add(l.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(a){for(const{uri:i}of a.folders){const s=f.URI.revive(i);if(s.scheme!==C.Schemas.file)continue;const c=s.fsPath;try{const u=await h(c,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),u.fileTypes.forEach(r=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:r.name,count:r.count})}),u.launchConfigFiles.forEach(r=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:r.name,count:r.count})}),u.configFiles.forEach(r=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:r.name,count:r.count})})}catch{}}}};R=ve([_(0,w.ITelemetryService),_(1,m.IProductService)],R),e.DiagnosticsService=R}),define(ee[240],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class E{constructor(C){this.b=C}listen(C,D){throw new Error(`Event not found: ${D}`)}call(C,D,{eventName:P,data:f}){return this.b.forEach(d=>d.log(P,f)),Promise.resolve(null)}}e.TelemetryAppenderChannel=E;class M{constructor(C){this.b=C}log(C,D){return this.b.call("log",{eventName:C,data:D}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=M}),define(ee[52],te([0,1,40,10,3,19,56,93,24]),function(G,e,E,M,n,C,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class d{constructor(r){this.value=r}}e.TelemetryTrustedValue=d;class b{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(r,l){return Promise.resolve(void 0)}publicLog2(r,l){return this.publicLog(r,l)}publicLogError(r,l){return Promise.resolve(void 0)}publicLogError2(r,l){return this.publicLogError(r,l)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=b,e.NullTelemetryService=new b;class v{async publicLog(r,l,I){}async publicLogError(r,l,I){}}e.NullEndpointTelemetryService=v,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function y(u,r){return n.Event.debounce(r.onDidChangeConfiguration,(I,A)=>{const O=I?new Set([...I.affectedKeys,...A.affectedKeys]):A.affectedKeys;return{...A,affectedKeys:O}},1e3,!0)(I=>{I.source!==7&&u.publicLog2("updateConfiguration",{configurationSource:(0,C.ConfigurationTargetToString)(I.source),configurationKeys:S(I.affectedKeys)})})}e.configurationTelemetry=y;function g(u,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!u.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=g;function m(u,r){return!(r.isBuilt||r.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}e.isLoggingOnly=m;function w(u){const r=u.getValue(f.TELEMETRY_SETTING_ID),l=u.getValue(f.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(u.getValue(f.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=w;function o(u){const r={},l={},I={};k(u,I);for(let A in I){A=A.length>150?A.substr(A.length-149):A;const O=I[A];typeof O=="number"?l[A]=O:typeof O=="boolean"?l[A]=O?1:0:typeof O=="string"?(O.length>8192&&console.warn(`Telemetry property: ${A} has been trimmed to 8192, the original length is ${O.length}`),r[A]=O.substring(0,8191)):typeof O<"u"&&O!==null&&(r[A]=O)}return{properties:r,measurements:l}}e.validateTelemetryData=o;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function p(u){if(!u)return"none";const r=(0,D.getRemoteName)(u);return h.has(r)?r:"other"}e.cleanRemoteAuthority=p;function k(u,r,l=0,I){if(!!u)for(const A of Object.getOwnPropertyNames(u)){const O=u[A],N=I?I+A:A;Array.isArray(O)?r[N]=(0,E.safeStringify)(O):O instanceof Date?r[N]=O.toISOString():(0,M.isObject)(O)?l<2?k(O,r,l+1,N+"."):r[N]=(0,E.safeStringify)(O):r[N]=O}}function S(u){if(!u)return[];const r=[];return R(r,"",u),r}function R(u,r,l){l&&typeof l=="object"&&!Array.isArray(l)?Object.keys(l).forEach(I=>R(u,r?`${r}.${I}`:I,l[I])):u.push(r)}function t(u,r){const l=u.msftInternalDomains||[],I=r.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(l)||I}e.isInternalTelemetry=t;function a(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}e.getPiiPathsFromEnvironment=a;function i(u,r){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let l=u;const I=[];for(const X of r)for(;;){const V=X.exec(u);if(!V)break;I.push([V.index,X.lastIndex])}const A=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,O=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let N=0;for(l="";;){const X=O.exec(u);if(!X)break;const V=I.some(([K,ie])=>X.index<ie&&K<O.lastIndex);!A.test(X[0])&&!V&&(l+=u.substring(N,X.index)+"<REDACTED: user-file-path>",N=O.lastIndex)}return N<u.length&&(l+=u.substr(N)),l}function s(u){if(!u)return u;const r=u.toLowerCase(),l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const I of l)if(I.regex.test(r))return`<REDACTED: ${I.label}>`;return u}function c(u,r){return(0,E.cloneAndChange)(u,l=>{if(l instanceof d)return l.value;if(typeof l=="string"){let I=l.replaceAll("%20"," ");I=i(I,r);for(const A of r)I=I.replace(A,"");return I=s(I),I}})}e.cleanData=c}),define(ee[113],te([0,1,27,198,91,4,7,13,36,52]),function(G,e,E,M,n,C,D,P,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function b(i,s){return i.uuid&&s.uuid?i.uuid===s.uuid:i.id===s.id?!0:(0,E.compareIgnoreCase)(i.id,s.id)===0}e.areSameExtensions=b;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(s){const c=s.manifest?s.manifest.version:s.version,u=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new y(s.identifier,c,u)}static parse(s){const c=v.exec(s);return c&&c[1]&&c[2]?new y({id:c[1]},c[2],c[4]||void 0):null}constructor(s,c,u="undefined"){this.version=c,this.targetPlatform=u,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof y?b(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=y;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(i){const s=g.exec(i);return s&&s[1]?[o(s[1]),s[2]]:[o(i),void 0]}e.getIdAndVersion=m;function w(i,s){return`${i}.${s}`}e.getExtensionId=w;function o(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=o;function h(i,s){return o(w(i,s))}e.getGalleryExtensionId=h;function p(i,s){const c=[],u=r=>{for(const l of c)if(l.some(I=>b(s(I),s(r))))return l;return null};for(const r of i){const l=u(r);l?l.push(r):c.push([r])}return c}e.groupByExtension=p;function k(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=k;function S(i){return{id:new d.TelemetryTrustedValue(i.identifier.id),name:new d.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function R(i,s){const c=[],u=s.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const r=u.shift();if(r&&c.every(l=>!b(l.identifier,{id:r}))){const l=i.filter(I=>b(I.identifier,{id:r}));l.length===1&&(c.push(l[0]),u.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.getExtensionDependencies=R;async function t(i,s){if(!C.isLinux)return!1;let c;try{c=(await i.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await i.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(r){s.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(r))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=t;async function a(i,s){const c=await t(i,s),u=(0,M.getTargetPlatform)(c?"alpine":C.platform,f.arch);return s.debug("ComputeTargetPlatform:",u),u}e.computeTargetPlatform=a}),define(ee[241],te([0,1,195,52]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function n(C,D,P,f,d,b,v){const y={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C} (${D.nameShort})`};if((0,M.supportsTelemetry)(D,P)&&(0,M.getTelemetryLevel)(f)===3){const g=await(0,E.getServiceMachineId)(P,d,b),{machineId:m}=await v.getTelemetryInfo();y["X-Market-User-Id"]=g,y["VSCode-SessionId"]=m||g}return y}e.resolveMarketplaceHeaders=n}),define(ee[242],te([0,1,13,40,52]),function(G,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const C="https://mobile.events.data.microsoft.com/OneCollector/1.0",D="https://mobile.events.data.microsoft.com/ping";async function P(d,b,v){const y=await new Promise((h,p)=>{G(["@microsoft/1ds-core-js"],h,p)}),g=await new Promise((h,p)=>{G(["@microsoft/1ds-post-js"],h,p)}),m=new y.AppInsightsCore,w=new g.PostChannel,o={instrumentationKey:d,endpointUrl:C,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if(v){o.extensionConfig={};const h={alwaysUseXhrOverride:!0,httpXHROverride:v};o.extensionConfig[w.identifier]=h}return m.initialize(o,[]),m.addTelemetryInitializer(h=>{b&&(h.ext=h.ext??{},h.ext.utc=h.ext.utc??{},h.ext.utc.flags=8462029)}),m}class f{constructor(b,v,y,g,m){this.e=b,this.f=v,this.g=y,this.h=m,this.c=C,this.d=D,this.g||(this.g={}),typeof g=="function"?this.a=g():this.a=g,this.b=null}i(b){if(!!this.a){if(typeof this.a!="string"){b(this.a);return}this.b||(this.b=P(this.a,this.e,this.h)),this.b.then(v=>{b(v)},v=>{(0,E.onUnexpectedError)(v),console.error(v)})}}log(b,v){if(!this.a)return;v=(0,M.mixin)(v,this.g),v=(0,n.validateTelemetryData)(v);const y=this.f+"/"+b;try{this.i(g=>{g.pluginVersionString=v?.properties.version??"Unknown",g.track({name:y,baseData:{name:y,properties:v?.properties,measurements:v?.measurements}})})}catch{}}flush(){return this.a?new Promise(b=>{this.i(v=>{v.unload(!0,()=>{this.a=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=f}),define(ee[114],te([0,1,2,40,4,27,174,19,68,66,20,51,24,52]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let m=class{constructor(h,p,k){this.k=p,this.l=k,this.d={},this.i=new E.DisposableStore,this.j=[],this.b=h.appenders,this.c=h.commonProperties||Promise.resolve({}),this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const S of this.f)this.j.push(new RegExp((0,C.escapeRegExpCharacters)(S),"gi")),S.indexOf("\\")>=0&&this.j.push(new RegExp((0,C.escapeRegExpCharacters)(S.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(S=>{(S.affectsConfiguration(y.TELEMETRY_SETTING_ID)||S.affectsConfiguration(y.TELEMETRY_OLD_SETTING_ID)||S.affectsConfiguration(y.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(h,p){this.d[h]=p}m(){let h=(0,g.getTelemetryLevel)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const k=p.usage?3:p.error?2:0;h=Math.min(h,k)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const h=await this.c,p=h.sessionID,k=h["common.machineId"],S=h["common.firstSessionDate"],R=h["common.msftInternal"];return{sessionId:p,machineId:k,firstSessionDate:S,msftInternal:R}}dispose(){this.i.dispose()}n(h,p,k){return this.g<p?Promise.resolve(void 0):this.c.then(S=>{k=(0,M.mixin)(k,this.d),k=(0,g.cleanData)(k,this.j),k=(0,M.mixin)(k,S),this.b.forEach(R=>R.log(h,k))},S=>{console.error(S)})}publicLog(h,p){return this.n(h,3,p)}publicLog2(h,p){return this.publicLog(h,p)}publicLogError(h,p){return this.h?this.n(h,2,p):Promise.resolve(void 0)}publicLogError2(h,p){return this.publicLogError(h,p)}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=ve([_(1,P.IConfigurationService),_(2,b.IProductService)],m),e.TelemetryService=m;function w(){const o=(0,D.localize)(0,null,d.default.nameLong),h=d.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=n.isWeb?"":(0,D.localize)(3,null),k=(0,D.localize)(4,null),S=(0,D.localize)(5,null),R=(0,D.localize)(6,null),t=(0,D.localize)(7,null),a=`
|       | ${k} | ${S} | ${R} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,D.localize)(8,null);return`
${o} ${h} ${p}

&nbsp;

${t}
${a}

&nbsp;

${i}
`}v.Registry.as(f.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.Registry.as(f.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,D.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,D.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[243],te([0,1,290,242]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class n extends M.AbstractOneDataSystemAppender{constructor(D,P,f,d){const b={sendPOST:(v,y)=>{const g={method:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data)}};try{const m=E.request(v.urlString,g,w=>{w.on("data",function(o){y(w.statusCode??200,w.headers,o.toString())}),w.on("error",function(o){y(0,{})})});m.write(v.data),m.end()}catch{y(0,{})}}};super(D,P,f,d,b)}}e.OneDataSystemAppender=n}),define(ee[244],te([0,1,4,85,24]),function(G,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function C(D){let P=D.getItem(n.machineIdKey);return(typeof P!="string"||E.isMacintosh&&P==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(P=await(0,M.getMachineId)()),P}e.resolveMachineId=C}),define(ee[115],te([0,1,24,244]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function n(C){const D=await(0,M.resolveMachineId)(C);return C.setItem(E.machineIdKey,D),D}e.resolveMachineId=n}),define(ee[69],te([0,1,14,3,2,4,19,6,34]),function(G,e,E,M,n,C,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const d="#FFFFFF",b="#1E1E1E",v="#000000",y="#FFFFFF",g="theme",m="themeBackground",w="windowSplash";e.IThemeMainService=(0,P.createDecorator)("themeMainService");let o=class extends n.Disposable{constructor(p,k){super(),this.b=p,this.c=k,this.a=this.B(new M.Emitter),this.onDidChangeColorScheme=this.a.event,E.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(C.isWindows){if(E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(C.isMacintosh){if(E.nativeTheme.shouldUseInvertedColorScheme||E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(C.isLinux&&E.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const p=this.getColorScheme();if(p.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return p.dark?v:y;let k=this.b.getItem(m,null);if(!k)switch(this.b.getItem(g,"vs-dark").split(" ")[0]){case"vs":k=d;break;case"hc-black":k=v;break;case"hc-light":k=y;break;default:k=b}return C.isMacintosh&&k.toUpperCase()===b&&(k="#171717"),k}saveWindowSplash(p,k){this.b.setItems([{key:g,data:k.baseTheme},{key:m,data:k.colorInfo.background},{key:w,data:k}]),typeof p=="number"&&this.f(p,k)}f(p,k){for(const S of E.BrowserWindow.getAllWindows())if(S.id===p){S.setBackgroundColor(k.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(w)}};o=ve([_(0,f.IStateMainService),_(1,D.IConfigurationService)],o),e.ThemeMainService=o}),define(ee[116],te([0,1,3,19,6,5]),function(G,e,E,M,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,n.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,n.createDecorator)("sharedTunnelsService");var D;(function(w){w.Http="http",w.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var f;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(f=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function d(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if(!!o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=d,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(w){return e.LOCALHOST_ADDRESSES.indexOf(w)>=0}e.isLocalhost=b,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(w){return e.ALL_INTERFACES_ADDRESSES.indexOf(w)>=0}e.isAllInterfaces=v;function y(w,o,h,p){if(h===1)return!1;if(h===2&&v(o)){const k=/(\d+)\.(\d+)\.(\d+)/g.exec(p);if(k?.length===4&&parseInt(k[1])>=18)return!1}return w<1024}e.isPortPrivileged=y;class g{constructor(o,h,p){this.remoteAddress=o,this.localAddress=h,this.b=p,this.a=new E.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=g;let m=class{constructor(o,h){this.i=o,this.j=h,this.a=new E.Emitter,this.onTunnelOpened=this.a.event,this.b=new E.Emitter,this.onTunnelClosed=this.b.event,this.c=new E.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const o=this.j.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.e=o,o?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.f=o.elevation,this.g=o.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const o=[],h=Array.from(this.d.values());for(const p of h){const k=Array.from(p.values());for(const S of k){const R=await S.value;R&&o.push(R)}}return o}async dispose(){for(const o of this.d.values()){for(const{value:h}of o.values())await h.then(p=>p?.dispose());o.clear()}this.d.clear()}setEnvironmentTunnel(o,h,p,k,S){this.o(o,h,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:h,localAddress:p,privacy:k,protocol:S,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,h){(v(o)||b(o))&&(o=e.LOCALHOST_ADDRESSES[0]);const p=this.q(o,h);if(p)return++p.refcount,p.value}openTunnel(o,h,p,k,S,R=!1,t,a){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${p} on local port ${S}.`),!o)return;if(h||(h="localhost"),k||(k=this.k),this.e&&this.h.has(p)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(o,h,p,k,S,R,t,a);return i?i.then(s=>{if(!s){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(h,p);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const c=this.m(s);return(s.tunnelRemoteHost!==h||s.tunnelRemotePort!==p)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(c),c}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const h=this.d.get(o.tunnelRemoteHost);if(h){const p=h.get(o.tunnelRemotePort);p&&(p.refcount--,await this.n(o.tunnelRemoteHost,o.tunnelRemotePort,p))}}}}async n(o,h,p){if(p.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${h}.`);const k=p.value.then(async S=>{S&&(await S.dispose(!0),this.b.fire({host:S.tunnelRemoteHost,port:S.tunnelRemotePort}))});return this.d.has(o)&&this.d.get(o).delete(h),k}}async closeTunnel(o,h){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${h} `);const p=this.d.get(o);if(p&&p.has(h)){const k=p.get(h);k.refcount=0,await this.n(o,h,k)}}o(o,h,p){this.d.has(o)||this.d.set(o,new Map),this.d.get(o).set(h,{refcount:1,value:p})}async p(o,h){const p=this.d.get(o);p&&(await p.get(h)||p.delete(h),p.size===0&&this.d.delete(o))}q(o,h){const p=[o];b(o)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):v(o)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const k=p.map(S=>this.d.get(S));for(const S of k){const R=S?.get(h);if(R)return R}}canTunnel(o){return!!d(o)}s(o,h,p,k,S,R,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${p} on local port ${k}.`);const a=p;this.h.add(a);const i=k===void 0?p:k,s={elevationRequired:S?this.isPortPrivileged(i):!1},c={remoteAddress:{host:h,port:p},localAddressPort:k,privacy:R,public:R?R!==P.Private:void 0,protocol:t},u=o.forwardPort(c,s);return u?(this.o(h,p,u),u.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(a)})):this.h.delete(a),u}};m=ve([_(0,C.ILogService),_(1,M.IConfigurationService)],m),e.AbstractTunnelService=m}),define(ee[245],te([0,1,82,26,100,229,8,2,19,5,20,228,116,92,4]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function w(S,R,t,a,i){let s;for(let c=3;c&&(s?.dispose(),s=await new o(S,R,t,a,i).waitForReady(),!(i&&n.BROWSER_RESTRICTED_PORTS[i]||!n.BROWSER_RESTRICTED_PORTS[s.tunnelLocalPort]));c--);return s}class o extends P.Disposable{constructor(R,t,a,i,s){super(),this.j=t,this.k=s,this.privacy=y.TunnelPrivacyId.Private,this.i=new Map,this.a=R,this.b=E.createServer(),this.c=new D.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=c=>this.l(c),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(t=>{t()})}async waitForReady(){const R=this.k??this.tunnelRemotePort,t=(0,y.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let a=await(0,n.findFreePortFaster)(R,2,1e3,t),i=null;return this.b.listen(a,this.j),await this.c.wait(),i=this.b.address(),i||(a=0,this.b.listen(a,this.j),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async l(R){R.pause();const t=(0,y.isLocalhost)(this.tunnelRemoteHost)||(0,y.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,a=await(0,v.connectRemoteAgentTunnel)(this.a,t,this.tunnelRemotePort),i=a.getSocket().socket,s=a.readEntireBuffer();a.dispose(),s.byteLength>0&&R.write(s.buffer),R.on("end",()=>{R.localAddress&&this.i.delete(R.localAddress),i.end()}),R.on("close",()=>i.end()),R.on("error",()=>{R.localAddress&&this.i.delete(R.localAddress),i.destroy()}),i.on("end",()=>R.end()),i.on("close",()=>R.end()),i.on("error",()=>{R.destroy()}),R.pipe(i),i.pipe(R),R.localAddress&&this.i.set(R.localAddress,()=>{R.end(),i.end()})}}let h=class extends y.AbstractTunnelService{constructor(R,t,a,i,s){super(t,s),this.t=R,this.u=a,this.v=i}isPortPrivileged(R){return(0,y.isPortPrivileged)(R,this.k,m.OS,M.release())}r(R,t,a,i,s,c,u,r){const l=this.q(t,a);if(l)return++l.refcount,l.value;if(this.e)return this.s(this.e,t,a,s,c,u,r);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${a} on local port ${s}.`);const I={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:R,signService:this.u,logService:this.i,ipcLogger:null},A=w(I,i,t,a,s);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(t,a,A),A}}};h=ve([_(1,d.ILogService),_(2,g.ISignService),_(3,b.IProductService),_(4,f.IConfigurationService)],h),e.BaseTunnelService=h;let p=class extends h{constructor(R,t,a,i){super(C.nodeSocketFactory,R,t,a,i)}};p=ve([_(0,d.ILogService),_(1,g.ISignService),_(2,b.IProductService),_(3,f.IConfigurationService)],p),e.TunnelService=p;let k=class extends P.Disposable{constructor(R,t,a,i){super(),this.b=R,this.c=t,this.f=a,this.g=i,this.a=new Map}async openTunnel(R,t,a,i,s,c,u,r,l){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${a}:${i} on local port ${c}.`),!this.a.has(R)){const I=new p(this.b,this.f,this.c,this.g);this.B(I),this.a.set(R,I),I.onTunnelClosed(async()=>{(await I.tunnels).length===0&&(I.dispose(),this.a.delete(R))})}return this.a.get(R).openTunnel(t,a,i,s,c,u,r,l)}};k=ve([_(0,d.ILogService),_(1,b.IProductService),_(2,g.ISignService),_(3,f.IConfigurationService)],k),e.SharedTunnelsService=k}),define(ee[49],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var M;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(M=e.StateType||(e.StateType={}));var n;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(n=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(C,D)=>({type:"idle",updateType:C,error:D}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:C=>({type:"downloading",update:C}),Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.IUpdateService=(0,E.createDecorator)("updateService")}),define(ee[246],te([0,1,4,175,68,51]),function(G,e,E,M,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),C.Registry.as(n.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,M.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,M.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,M.localize)(2,null),(0,M.localize)(3,null),(0,M.localize)(4,null),(0,M.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,M.localize)(6,null),deprecationMessage:(0,M.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,M.localize)(8,null),description:(0,M.localize)(9,null),included:E.isWindows&&!E.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,M.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[247],te([0,1,3,49]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class n{constructor(P){this.a=P}listen(P,f){switch(f){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${f}`)}call(P,f,d){switch(f){case"checkForUpdates":return this.a.checkForUpdates(d);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(d)}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=n;class C{get state(){return this.b}set state(P){this.b=P,this.a.fire(P)}constructor(P){this.c=P,this.a=new E.Emitter,this.onStateChange=this.a.event,this.b=M.State.Uninitialized,this.c.listen("onStateChange")(f=>this.state=f),this.c.call("_getInitialState").then(f=>this.state=f)}checkForUpdates(P){return this.c.call("checkForUpdates",P)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(P){return this.c.call("_applySpecificUpdate",P)}}e.UpdateChannelClient=C}),define(ee[94],te([0,1,8,22,3,19,28,21,5,20,57,49]),function(G,e,E,M,n,C,D,P,f,d,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function y(m,w,o){return`${o.updateUrl}/api/update/${m}/${w}/${o.commit}`}e.createUpdateURL=y;let g=class{get state(){return this.b}d(w){this.j.info("update#setState",w.type),this.b=w,this.c.fire(w)}constructor(w,o,h,p,k,S){this.f=w,this.g=o,this.h=h,this.i=p,this.j=k,this.k=S,this.b=v.State.Uninitialized,this.c=new n.Emitter,this.onStateChange=this.c.event}async initialize(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const w=this.g.getValue("update.mode"),o=this.l(w);if(!o){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.r(o),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(v.State.Idle(this.p())),w==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.m(30*1e3).then(void 0,h=>this.j.error(h))}l(w){return w==="none"?void 0:this.k.quality}m(w=60*60*1e3){return(0,E.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.m(60*60*1e3))}async checkForUpdates(w){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.s(w)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.n(this.state)}async n(w){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.o()}async o(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.q())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},M.CancellationToken.None)).res.statusCode===204}catch(o){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(o);return}}async _applySpecificUpdate(w){}p(){return 1}q(){}};g=ve([_(0,P.ILifecycleMainService),_(1,C.IConfigurationService),_(2,D.IEnvironmentMainService),_(3,b.IRequestService),_(4,f.ILogService),_(5,d.IProductService)],g),e.AbstractUpdateService=g}),define(ee[248],te([0,1,14,55,3,2,19,28,21,5,20,57,24,49,94]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let w=class extends m.AbstractUpdateService{get u(){return n.Event.fromNodeEventEmitter(E.autoUpdater,"error",(h,p)=>p)}get v(){return n.Event.fromNodeEventEmitter(E.autoUpdater,"update-not-available")}get w(){return n.Event.fromNodeEventEmitter(E.autoUpdater,"update-available",(h,p,k)=>({url:p,version:k,productVersion:k}))}get x(){return n.Event.fromNodeEventEmitter(E.autoUpdater,"update-downloaded",(h,p,k,S)=>({releaseNotes:p,version:k,productVersion:k,date:S}))}constructor(h,p,k,S,R,t,a){super(h,p,S,R,t,a),this.y=k,this.t=new C.DisposableStore}async initialize(){await super.initialize(),this.u(this.z,this,this.t),this.w(this.C,this,this.t),this.x(this.D,this,this.t),this.v(this.E,this,this.t)}z(h){this.j.error("UpdateService error:",h);const k=(this.state.type==="checking for updates"?this.state.explicit:!0)?h:void 0;this.d(g.State.Idle(1,k))}r(h){let p;this.k.darwinUniversalAssetId?p=this.k.darwinUniversalAssetId:p=process.arch==="x64"?"darwin":"darwin-arm64";const k=(0,m.createUpdateURL)(p,h,this.k);try{E.autoUpdater.setFeedURL({url:k})}catch(S){this.j.error("Failed to set update feed URL",S);return}return k}s(h){this.d(g.State.CheckingForUpdates(h)),E.autoUpdater.checkForUpdates()}C(h){this.state.type==="checking for updates"&&this.d(g.State.Downloading(h))}D(h){this.state.type==="downloading"&&(this.y.publicLog2("update:downloaded",{version:h.version}),this.d(g.State.Ready(h)))}E(){this.state.type==="checking for updates"&&(this.y.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(g.State.Idle(1)))}q(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),E.autoUpdater.quitAndInstall()}dispose(){this.t.dispose()}};ve([M.memoize],w.prototype,"u",null),ve([M.memoize],w.prototype,"v",null),ve([M.memoize],w.prototype,"w",null),ve([M.memoize],w.prototype,"x",null),w=ve([_(0,f.ILifecycleMainService),_(1,D.IConfigurationService),_(2,y.ITelemetryService),_(3,P.IEnvironmentMainService),_(4,v.IRequestService),_(5,d.ILogService),_(6,b.IProductService)],w),e.DarwinUpdateService=w}),define(ee[249],te([0,1,46,41,8,3,9,28,21,5,24,49]),function(G,e,E,M,n,C,D,P,f,d,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let y=class{get state(){return this.a}d(w){this.g.info("update#setState",w.type),this.a=w,this.b.fire(w)}constructor(w,o,h){if(this.f=w,this.g=h,this.a=v.State.Uninitialized,this.b=new C.Emitter,this.onStateChange=this.b.event,o.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(v.State.Idle(this.k())),this.h(30*1e3).then(void 0,p=>this.g.error(p))}h(w=60*60*1e3){return(0,n.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(w){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(w)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(w){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(w){}};y=ve([_(0,f.ILifecycleMainService),_(1,P.IEnvironmentMainService),_(2,d.ILogService)],y);let g=class extends y{constructor(w,o,h,p,k,S){super(h,p,k),this.o=w,this.p=o,this.q=S;const R=(0,M.watch)(D.dirname(this.o)),t=C.Event.fromNodeEventEmitter(R,"change",(c,u)=>u),a=C.Event.filter(t,c=>c==="current"),s=C.Event.debounce(a,(c,u)=>u,2e3)(()=>this.checkForUpdates(!1));h.onWillShutdown(()=>{s.dispose(),R.close()})}m(){this.d(v.State.CheckingForUpdates(!1)),this.u().then(w=>{w?this.d(v.State.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.State.Idle(2)))},w=>{this.g.error(w),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.State.Idle(2,w.message||w))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,E.spawn)("sleep 3 && "+D.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const w=await new Promise((h,p)=>(0,M.realpath)(`${D.dirname(this.o)}/current`,(k,S)=>k?p(k):h(S))),o=D.basename(w);return this.p!==o}isLatestVersion(){return this.u().then(void 0,w=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};g=ve([_(2,f.ILifecycleMainService),_(3,P.IEnvironmentMainService),_(4,d.ILogService),_(5,b.ITelemetryService)],g),e.SnapUpdateService=g}),define(ee[38],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,E.createDecorator)("IUriIdentityService")}),define(ee[250],te([0,1,38,196,16,18,128,3,2]),function(G,e,E,M,n,C,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class d{constructor(y){this.uri=y,this.time=d._clock++}touch(){return this.time=d._clock++,this}}d._clock=0;let b=class{constructor(y){this.g=y,this.c=new f.DisposableStore,this.f=2**16;const g=new Map,m=w=>{let o=g.get(w.scheme);return o===void 0&&(o=y.hasProvider(w)&&!this.g.hasCapability(w,1024),g.set(w.scheme,o)),o};this.c.add(P.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(w=>{g.delete(w.scheme)})),this.extUri=new C.ExtUri(m),this.d=new D.SkipList((w,o)=>this.extUri.compare(w,o,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,C.normalizePath)(y));const g=this.d.get(y);return g?g.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new d(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((m,w)=>m[1].touch<w[1].touch?1:m[1].touch>w[1].touch?-1:0);d._clock=0,this.d.clear();const g=this.f*.5;for(let m=0;m<g;m++)this.d.set(y[m][0],y[m][1].touch())}};b=ve([_(0,n.IFileService)],b),e.UriIdentityService=b,(0,M.registerSingleton)(E.IUriIdentityService,b,1)}),define(ee[117],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,E.createDecorator)("urlService")}),define(ee[251],te([0,1,7]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class M{constructor(P){this.a=P}listen(P,f){throw new Error(`Event not found: ${f}`)}call(P,f,d){switch(f){case"handleURL":return this.a.handleURL(E.URI.revive(d[0]),d[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=M;class n{constructor(P){this.a=P}handleURL(P,f){return this.a.call("handleURL",[P.toJSON(),f])}}e.URLHandlerChannelClient=n;class C{constructor(P,f){this.a=P,this.b=f}async routeCall(P,f,d,b){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(Array.isArray(d)&&d.length>0){const v=E.URI.revive(d[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",v.toString(!0)),v.query){const y=/\bwindowId=(\d+)/.exec(v.query);if(y){const g=y[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${g}"`,v.toString(!0));const m=new RegExp(`window:${g}`),w=P.connections.find(o=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",o.ctx),m.test(o.ctx)));if(w)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",v.toString(!0)),w;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",v.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",v.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(P,f,d,b)}routeEvent(P,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=C}),define(ee[252],te([0,1,8,2,7,20]),function(G,e,E,M,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class D extends M.Disposable{constructor(){super(...arguments),this.a=new Set}open(d,b){const v=[...this.a.values()];return(0,E.first)(v.map(y=>()=>y.handleURL(d,b)),void 0,!1).then(y=>y||!1)}registerHandler(d){return this.a.add(d),(0,M.toDisposable)(()=>this.a.delete(d))}}e.AbstractURLService=D;let P=class extends D{constructor(d){super(),this.b=d}create(d){let{authority:b,path:v,query:y,fragment:g}=d||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return b&&v&&v.indexOf("/")!==0&&(v=`/${v}`),n.URI.from({scheme:this.b.urlProtocol,authority:b,path:v,query:y,fragment:g})}};P=ve([_(0,C.IProductService)],P),e.NativeURLService=P}),define(ee[253],te([0,1,14,8,3,2,4,7]),function(G,e,E,M,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class f{constructor(b,v,y,g,m,w){if(this.f=v,this.g=w,this.a=[],this.b=0,this.c=C.Disposable.None,this.d=new C.DisposableStore,b&&(w.trace("ElectronURLListener initialUrisToHandle:",b.map(p=>p.originalUrl)),this.a=b),D.isWindows){const p=g.isBuilt?[]:[`"${g.appRoot}"`];p.push("--open-url","--"),E.app.setAsDefaultProtocolClient(m.urlProtocol,process.execPath,p)}const o=n.Event.map(n.Event.fromNodeEventEmitter(E.app,"open-url",(p,k)=>({event:p,url:k})),({event:p,url:k})=>(p.preventDefault(),k));this.d.add(o(p=>{const k=this.h(p);!k||this.f.open(k,{originalUrl:p})})),y.getWindows().filter(p=>p.isReady).length>0?(w.trace("ElectronURLListener: window is ready to handle URLs"),this.i()):(w.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),n.Event.once(y.onDidSignalReadyWindow)(this.i,this,this.d))}h(b){try{return P.URI.parse(b)}catch{return}}async i(){if(this.b++>10){this.g.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.g.trace("ElectronURLListener#flush(): flushing URLs");const b=[];for(const v of this.a)await this.f.open(v.uri,{originalUrl:v.originalUrl})?this.g.trace("ElectronURLListener#flush(): URL was handled",v.originalUrl):(this.g.trace("ElectronURLListener#flush(): URL was not yet handled",v.originalUrl),b.push(v));b.length!==0&&(this.a=b,this.c=(0,M.disposableTimeout)(()=>this.i(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.ElectronURLListener=f}),define(ee[254],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,E.createDecorator)("webviewManagerService")}),define(ee[255],te([0,1,14,2,15,7]),function(G,e,E,M,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class D extends M.Disposable{constructor(){super();const f=this.b.bind(this);E.protocol.registerFileProtocol(n.Schemas.vscodeWebview,f)}b(f,d){try{const b=C.URI.parse(f.url),v=D.a.get(b.path);if(typeof v=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${v}`,g=n.FileAccess.asFileUri(y);return d({path:decodeURIComponent(g.fsPath),headers:{...n.COI.getHeadersFromQuery(f.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return d({error:-10})}catch{}return d({error:-2})}}D.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]]),e.WebviewProtocolProvider=D}),define(ee[77],te([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function M(b){return!!b.workspaceUri}e.isWorkspaceToOpen=M;function n(b){return!!b.folderUri}e.isFolderToOpen=n;function C(b){return!!b.fileUri}e.isFileToOpen=C;function D(b){const v=P(b),y=b.getValue("window.menuBarVisibility");return y==="default"||v==="native"&&y==="compact"||E.isMacintosh&&E.isNative?"classic":y}e.getMenuBarVisibility=D;function P(b){if(E.isWeb)return"custom";const v=b.getValue("window");if(v){if(E.isMacintosh&&v.nativeTabs===!0||E.isMacintosh&&v.nativeFullScreen===!1)return"native";const m=v.titleBarStyle;if(m==="native"||m==="custom")return m}return E.isLinux?"native":"custom"}e.getTitleBarStyle=P;function f(b){if(!E.isWindows||E.isWeb||P(b)==="native")return!1;const v=b.getValue("window.experimental.windowControlsOverlay.enabled");return typeof v=="boolean"?v:!0}e.useWindowControlsOverlay=f;function d(b=0){return Math.pow(1.2,b)}e.zoomLevelToZoomFactor=d}),define(ee[118],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var E;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(E=e.LoadReason||(e.LoadReason={}));var M;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(M=e.UnloadReason||(e.UnloadReason={}));const n=function(P=1){return{width:1024,height:768,mode:P}};e.defaultWindowState=n;var C;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(C=e.WindowMode||(e.WindowMode={}));var D;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(D=e.WindowError||(e.WindowError={}))}),define(ee[30],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,E.createDecorator)("windowsMainService");var M;(function(n){n[n.CLI=0]="CLI",n[n.DOCK=1]="DOCK",n[n.MENU=2]="MENU",n[n.DIALOG=3]="DIALOG",n[n.DESKTOP=4]="DESKTOP",n[n.API=5]="API"})(M=e.OpenContext||(e.OpenContext={}))}),define(ee[256],te([0,1,14,22,3,72,2,31,75,108,5,20,30]),function(G,e,E,M,n,C,D,P,f,d,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var g;(function(w){w[w.Initial=1]="Initial",w[w.StoredCredentialsUsed=2]="StoredCredentialsUsed",w[w.LoginDialogShown=3]="LoginDialogShown"})(g||(g={}));let m=class extends D.Disposable{constructor(o,h,p,k,S){super(),this.g=o,this.h=h,this.i=p,this.j=k,this.k=S,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=g.Initial,this.f=void 0,this.l()}l(){const o=n.Event.fromNodeEventEmitter(E.app,"login",(h,p,k,S,R)=>({event:h,webContents:p,req:k,authInfo:S,callback:R}));this.B(o(this.m,this))}async m({event:o,authInfo:h,req:p,callback:k}){if(!h.isProxy)return;if(!this.b&&this.c===g.LoginDialogShown&&p.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}o.preventDefault();let S;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),S=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(h);try{S=await this.b}finally{this.b=void 0}}k(S?.username,S?.password)}async n(o){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const h=await this.p(o);if(h)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),h;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(o){this.g.trace("auth#doResolveProxyCredentials - enter",o);const h=String((0,C.hash)({scheme:o.scheme,host:o.host,port:o.port}));let p,k;try{const a=await this.i.getPassword(this.a,h);if(a){const i=JSON.parse(await this.j.decrypt(a));p=i.username,k=i.password}}catch(a){this.g.error(a)}if(this.c!==g.StoredCredentialsUsed&&typeof p=="string"&&typeof k=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=g.StoredCredentialsUsed,{username:p,password:k};const S=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!S){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${S.id} to handle proxy login`);const R={authInfo:o,username:this.f?.username??p,password:this.f?.password??k,replyChannel:`vscode:proxyAuthResponse:${(0,P.generateUuid)()}`};S.sendWhenReady("vscode:openProxyAuthenticationDialog",M.CancellationToken.None,R),this.c=g.LoginDialogShown;const t=await new Promise(a=>{const i=async(s,c,u)=>{if(c===R.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${S.id}`),S.win?.webContents.off("ipc-message",i),u){const r={username:u.username,password:u.password};try{if(u.remember){const l=await this.j.encrypt(JSON.stringify(r));await this.i.setPassword(this.a,h,l)}else await this.i.deletePassword(this.a,h)}catch(l){this.g.error(l)}a({username:r.username,password:r.password})}else a(void 0)};S.win?.webContents.on("ipc-message",i)});return this.f=t,t}};m=ve([_(0,b.ILogService),_(1,y.IWindowsMainService),_(2,f.ICredentialsMainService),_(3,d.IEncryptionMainService),_(4,v.IProductService)],m),e.ProxyAuthHandler=m}),define(ee[257],te([0,1,75,5,33,20,30,208]),function(G,e,E,M,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let f=class extends P.BaseCredentialsMainService{constructor(b,v,y,g){super(b),this.j=v,this.k=y,this.l=g,this.i=m=>{this.l.sendToFocused("vscode:showCredentialsError",m.message??m)}}async getSecretStoragePrefix(){return Promise.resolve(this.k.urlProtocol)}async h(){if(this.f)return this.f;if(this.j.disableKeytar)return this.g.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new E.InMemoryCredentialsProvider,this.f;const b=await new Promise((v,y)=>{G(["keytar"],v,y)});return await b.findCredentials("test-keytar-loads"),this.f=b,this.f}};f=ve([_(0,M.ILogService),_(1,n.INativeEnvironmentService),_(2,C.IProductService),_(3,D.IWindowsMainService)],f),e.CredentialsNativeMainService=f}),define(ee[258],te([0,1,14,25,4,7,23,19,62,6,5,117,30]),function(G,e,E,M,n,C,D,P,f,d,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,d.createDecorator)(e.ID);let g=class{constructor(w,o,h,p){this.a=w,this.b=o,this.c=h,this.d=p}async start(w,o){this.a.trace("Received data from other instance: ",w,o),n.isMacintosh&&E.app.focus({steal:!0});const h=this.e(w);if(h.length){let p=Promise.resolve();if(this.b.getWindowCount()===0){const k=(0,M.firstOrDefault)(await this.b.openEmptyWindow({context:4}));k&&(p=k.ready())}p.then(()=>{for(const{uri:k,originalUrl:S}of h)this.c.open(k,{originalUrl:S})})}else return this.f(w,o)}e(w){return w["open-url"]&&w._urls&&w._urls.length>0?(0,M.coalesce)(w._urls.map(o=>{try{return{uri:C.URI.parse(o),originalUrl:o}}catch{return null}})):[]}async f(w,o){const h=(0,f.isLaunchedFromCli)(o)?0:4;let p=[];const k=w.wait&&w.waitMarkerFilePath?C.URI.file(w.waitMarkerFilePath):void 0,S=w.remote||void 0,R={context:h,cli:w,userEnv:o,waitMarkerFileURI:k,remoteAuthority:S,forceProfile:w.profile,forceTempProfile:w["profile-temp"]};if(w.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(w.extensionDevelopmentPath,R);else if(!w._.length&&!w["folder-uri"]&&!w["file-uri"]){let t=!1;if(w["new-window"]||w["unity-launch"]||R.forceProfile||R.forceTempProfile)t=!0;else if(w["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!n.isMacintosh}if(t)p=await this.b.open({...R,forceNewWindow:!0,forceEmpty:!0});else{const a=this.b.getLastActiveWindow();a?(this.b.openExistingWindow(a,R),p=[a]):p=await this.b.open({...R,forceEmpty:!0})}}else p=await this.b.open({...R,forceNewWindow:w["new-window"],preferNewWindow:!w["reuse-window"]&&!w.wait,forceReuseWindow:w["reuse-window"],diffMode:w.diff,mergeMode:w.merge,addMode:w.add,noRecentEntry:!!w["skip-add-to-recently-opened"],gotoLineMode:w.goto});if(k&&p.length===1&&p[0])return Promise.race([p[0].whenClosedOrLoaded,(0,D.whenDeleted)(k.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};g=ve([_(0,b.ILogService),_(1,y.IWindowsMainService),_(2,v.IURLService),_(3,P.IConfigurationService)],g),e.LaunchMainService=g}),define(ee[259],te([0,1,14,2,3,5,260,8,15,30,84,24]),function(G,e,E,M,n,C,D,P,f,d,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcess=void 0;let y=class It extends M.Disposable{constructor(m,w,o){super(),this.n=m,this.p=w,this.r=o,this.b=String(++It.a),this.c=this.B(new n.Emitter),this.onStdout=this.c.event,this.f=this.B(new n.Emitter),this.onStderr=this.f.event,this.g=this.B(new n.Emitter),this.onMessage=this.g.event,this.h=this.B(new n.Emitter),this.onExit=this.h.event,this.i=this.B(new n.Emitter),this.onCrash=this.i.event,this.j=void 0,this.k=void 0,this.l=void 0,this.m=!1}s(m,w){let o;switch(this.l?.correlationId?o=`[UtilityProcess id: ${this.l?.correlationId}, type: ${this.l?.type}, pid: ${this.k??"<none>"}]: ${m}`:o=`[UtilityProcess type: ${this.l?.type}, pid: ${this.k??"<none>"}]: ${m}`,w){case b.default.Error:this.n.error(o);break;case b.default.Warning:this.n.warn(o);break;case b.default.Info:this.n.info(o);break}}t(m){if(this.j){this.s("Cannot start utility process because it is already running...",b.default.Error);return}const w=this.p.getWindowById(m.responseWindowId)?.win;if(!w||w.isDestroyed()||w.webContents.isDestroyed()){this.s("Refusing to start utility process because requesting window cannot be found or is destroyed...",b.default.Error);return}return w}start(m){const w=this.t(m);if(!w)return;this.l=m;const o=`${this.l.type}-${this.b}`,h=f.FileAccess.asFileUri("bootstrap-fork.js").fsPath,p=[...this.l.args??[],`--type=${this.l.type}`],k=this.l.execArgv,S=this.l.allowLoadingUnsignedLibraries,R="pipe";let t=this.l.env;if(t){t={...t};for(const a of Object.keys(t))t[a]=String(t[a])}this.s("creating new...",b.default.Info),this.j=E.utilityProcess.fork(h,p,{serviceName:o,env:t,execArgv:k,allowLoadingUnsignedLibraries:S,stdio:R}),this.u(this.j,this.l,o),this.v(this.j,this.l,w)}u(m,w,o){if(m.stdout){const h=new D.StringDecoder("utf-8");this.B(n.Event.fromNodeEventEmitter(m.stdout,"data")(p=>this.c.fire(typeof p=="string"?p:h.write(p))))}if(m.stderr){const h=new D.StringDecoder("utf-8");this.B(n.Event.fromNodeEventEmitter(m.stderr,"data")(p=>this.f.fire(typeof p=="string"?p:h.write(p))))}this.B(n.Event.fromNodeEventEmitter(m,"message")(h=>this.g.fire(h))),this.B(n.Event.fromNodeEventEmitter(m,"spawn")(()=>{this.k=m.pid,this.s("successfully created",b.default.Info)})),this.B(n.Event.fromNodeEventEmitter(m,"exit")(h=>{this.s(`received exit event with code ${h}`,b.default.Info),this.m=!0,this.h.fire({pid:this.k,code:h,signal:"unknown"})})),this.B(n.Event.fromNodeEventEmitter(E.app,"child-process-gone",(h,p)=>({event:h,details:p}))(({details:h})=>{h.type==="Utility"&&h.name===o&&(this.s(`crashed with code ${h.exitCode} and reason '${h.reason}'`,b.default.Error),this.r.publicLog2("utilityprocesscrash",{type:w.type,reason:h.reason,code:h.exitCode}),this.i.fire({pid:this.k,code:h.exitCode,reason:h.reason}))}))}v(m,w,o){const{port1:h,port2:p}=new E.MessageChannelMain;m.postMessage("null",[p]),o.webContents.postMessage(w.responseChannel,w.responseNonce,[h])}enableInspectPort(){if(typeof this.k!="number")return!1;this.s("enabling inspect port",b.default.Info);const m=process;return typeof m._debugProcess=="function"?(m._debugProcess(this.k),!0):!1}kill(){if(!this.j){this.s("no running process to kill",b.default.Warning);return}this.s("attempting to kill the process...",b.default.Info),this.j.kill()?this.s("successfully killed the process",b.default.Info):this.s("unable to kill the process",b.default.Warning)}async waitForExit(m){if(!this.j){this.s("no running process to wait for exit",b.default.Warning);return}this.m||(this.s("waiting to exit...",b.default.Info),await Promise.race([n.Event.toPromise(this.onExit),(0,P.timeout)(m)]),this.m||(this.s("did not exit within ${maxWaitTimeMs}ms, will kill it now...",b.default.Info),this.kill()))}};y.a=0,y=ve([_(0,C.ILogService),_(1,d.IWindowsMainService),_(2,v.ITelemetryService)],y),e.UtilityProcess=y}),define(ee[261],te([0,1,13,2,3,5,21,71,46,260,8,15,40,4,36,259,30,24]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g,m,w,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let p=class Pt{constructor(R,t,a,i){this.d=R,this.f=a,this.g=i,this.c=!1,this.b=new Map,t.onWillShutdown(s=>{this.c=!0,s.join(this._waitForAllExit(6e3))})}dispose(){}h(R){const t=this.b.get(R);if(!t)throw new Error("Unknown extension host!");return t}onDynamicStdout(R){return this.h(R).onStdout}onDynamicStderr(R){return this.h(R).onStderr}onDynamicMessage(R){return this.h(R).onMessage}onDynamicError(R){const t=this.h(R);return t instanceof w.UtilityProcess?n.Event.None:t.onError}onDynamicExit(R){return this.h(R).onExit}async createExtensionHost(R){if(this.c)throw(0,E.canceled)();const t=String(++Pt.a);let a;return R?a=new w.UtilityProcess(this.d,this.f,this.g):a=new k(t,this.d),this.b.set(t,a),a.onExit(({pid:i,code:s,signal:c})=>{this.d.info(`Extension host with pid ${i} exited with code: ${s}, signal: ${c}.`),setTimeout(()=>{a.dispose(),this.b.delete(t)})}),{id:t}}async start(R,t){if(this.c)throw(0,E.canceled)();return this.h(R).start({...t,type:"extensionHost",args:["--skipWorkspaceStorageLock"],execArgv:t.execArgv??[],allowLoadingUnsignedLibraries:!0,correlationId:R})}async enableInspectPort(R){if(this.c)throw(0,E.canceled)();const t=this.b.get(R);return t?t.enableInspectPort():!1}async kill(R){if(this.c)throw(0,E.canceled)();const t=this.b.get(R);!t||t.kill()}async _killAllNow(){for(const[,R]of this.b)R.kill()}async _waitForAllExit(R){const t=[];for(const[,a]of this.b)t.push(a.waitForExit(R));return b.Promises.settled(t).then(()=>{})}};p.a=0,p=ve([_(0,C.ILogService),_(1,D.ILifecycleMainService),_(2,o.IWindowsMainService),_(3,h.ITelemetryService)],p),e.ExtensionHostStarter=p;let k=class extends M.Disposable{constructor(R,t){super(),this.id=R,this.c=t,this._onStdout=this.B(new n.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new n.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new n.Emitter),this.onMessage=this._onMessage.event,this._onError=this.B(new n.Emitter),this.onError=this._onError.event,this._onExit=this.B(new n.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(R){g.isCI&&this.c.info("Calling fork to start extension host...");const t=P.StopWatch.create(!1);this.a=(0,f.fork)(v.FileAccess.asFileUri("bootstrap-fork").fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,y.mixin)({cwd:(0,m.cwd)()},R));const a=t.elapsed(),i=this.a.pid;this.c.info(`Starting extension host with pid ${i} (fork() took ${a} ms).`);const s=new d.StringDecoder("utf-8");this.a.stdout?.on("data",u=>{const r=typeof u=="string"?u:s.write(u);this._onStdout.fire(r)});const c=new d.StringDecoder("utf-8");this.a.stderr?.on("data",u=>{const r=typeof u=="string"?u:c.write(u);this._onStderr.fire(r)}),this.a.on("message",u=>{this._onMessage.fire(u)}),this.a.on("error",u=>{this._onError.fire({error:(0,E.transformErrorForSerialization)(u)})}),this.a.on("exit",(u,r)=>{this.b=!0,this._onExit.fire({pid:i,code:u,signal:r})})}enableInspectPort(){return this.a?(this.c.info(`Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):g.isWindows?!1:(this.a.kill("SIGUSR1"),!0)):!1}kill(){!this.a||(this.c.info(`Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(R){if(!this.a)return;const t=this.a.pid;this.c.info(`Waiting for extension host with pid ${t} to exit.`),await Promise.race([n.Event.toPromise(this.onExit),(0,b.timeout)(R)]),this.b||(this.c.info(`Extension host with pid ${t} did not exit within ${R}ms.`),this.a.kill())}};k=ve([_(1,C.ILogService)],k)}),define(ee[262],te([0,1,14,3,2,255,30]),function(G,e,E,M,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let P=class extends n.Disposable{constructor(d){super(),this.b=d,this.a=this.B(new M.Emitter),this.onFoundInFrame=this.a.event,this.B(new C.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(d,b){let v;if(typeof d.windowId=="number"){const{windowId:y}=d,g=this.b.getWindowById(y);if(!g?.win)throw new Error(`Invalid windowId: ${y}`);v=g.win.webContents}else{const{webContentsId:y}=d;if(v=E.webContents.fromId(y),!v)throw new Error(`Invalid webContentsId: ${y}`)}v.isDestroyed()||v.setIgnoreMenuShortcuts(b)}async findInFrame(d,b,v,y){const m=this.c(d,b);if(typeof m.findInFrame=="function"){m.findInFrame(v,{findNext:y.findNext,forward:y.forward});const w=(o,h)=>{h.finalUpdate&&(this.a.fire(h),m.removeListener("found-in-frame",w))};m.on("found-in-frame",w)}}async stopFindInFrame(d,b,v){const g=this.c(d,b);typeof g.stopFindInFrame=="function"&&g.stopFindInFrame(v.keepSelection?"keepSelection":"clearSelection")}c(d,b){const v=this.b.getWindowById(d.windowId);if(!v?.win)throw new Error(`Invalid windowId: ${d}`);const y=v.win.webContents.mainFrame.framesInSubtree.find(g=>g.name===b);if(!y)throw new Error(`Unknown frame: ${b}`);return y}};P=ve([_(0,D.IWindowsMainService)],P),e.WebviewMainService=P}),define(ee[263],te([0,1,8,3,2]),function(G,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class C extends n.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:f,getActiveWindowId:d}){super(),this.a=this.B(new n.DisposableStore),M.Event.latch(M.Event.any(P,f))(this.f,this,this.a),this.b=(0,E.createCancelablePromise)(()=>d()),(async()=>{try{const v=await this.b;this.c=typeof this.c=="number"?this.c:v}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=C}),define(ee[29],te([0,1,179,9,61,18,7,6,15]),function(G,e,E,M,n,C,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function d(i){const s=i;return typeof s?.id=="string"&&D.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=d;function b(i){return typeof i?.id=="string"&&!d(i)&&!y(i)}e.isEmptyWorkspaceIdentifier=b,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function v(i,s){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,M.basename)(i)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const c=i;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.toWorkspaceIdentifier=v;function y(i){const s=i;return typeof s?.id=="string"&&D.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=y;function g(i){const s=i;if(s?.uri)return{id:s.id,uri:D.URI.revive(s.uri)};const c=i;if(c?.configPath)return{id:c.id,configPath:D.URI.revive(c.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=g;var m;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(m=e.WorkbenchState||(e.WorkbenchState={}));function w(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=w;function o(i){const s=i;return!!(s&&typeof s=="object"&&D.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=o;class h{constructor(s,c,u,r,l){this.h=s,this.j=u,this.k=r,this.l=l,this.c=n.TernarySearchTree.forUris(this.l,()=>!0),this.folders=c}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=n.TernarySearchTree.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class p{constructor(s,c){this.raw=c,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,C.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function k(i){return new p({uri:i,index:0,name:(0,C.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=k,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(i,s){return C.extUriBiasedIgnorePathCase.isEqualOrParent(i,s.untitledWorkspacesHome)}e.isUntitledWorkspace=S;function R(i){let s;return D.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===f.Schemas.tmp}e.isTemporaryWorkspace=R;function t(i,s){return!S(i,s)&&!R(i)}e.isSavedWorkspace=t;function a(i){return(typeof i=="string"?(0,M.extname)(i):(0,C.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=a}),define(ee[58],te([0,1,14,8,72,45,2,80,4,10,23,156,6,5,29]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,y.createDecorator)("dialogMainService");let w=class{constructor(h){this.d=h,this.a=new Map,this.b=new Map,this.c=new M.Queue}pickFileFolder(h,p){return this.e({...h,pickFolders:!0,pickFiles:!0,title:(0,v.localize)(0,null)},p)}pickFolder(h,p){return this.e({...h,pickFolders:!0,title:(0,v.localize)(1,null)},p)}pickFile(h,p){return this.e({...h,pickFiles:!0,title:(0,v.localize)(2,null)},p)}pickWorkspace(h,p){const k=(0,v.localize)(3,null),S=(0,C.mnemonicButtonLabel)((0,v.localize)(4,null)),R=m.WORKSPACE_FILTER;return this.e({...h,pickFiles:!0,title:k,filters:R,buttonLabel:S},p)}async e(h,p){const k={title:h.title,buttonLabel:h.buttonLabel,filters:h.filters,defaultPath:h.defaultPath};(typeof h.pickFiles=="boolean"||typeof h.pickFolders=="boolean")&&(k.properties=void 0,h.pickFiles&&h.pickFolders&&(k.properties=["multiSelections","openDirectory","openFile","createDirectory"])),k.properties||(k.properties=["multiSelections",h.pickFolders?"openDirectory":"openFile","createDirectory"]),f.isMacintosh&&k.properties.push("treatPackageAsDirectory");const S=await this.showOpenDialog(k,(0,d.withNullAsUndefined)(p||E.BrowserWindow.getFocusedWindow()));if(S&&S.filePaths&&S.filePaths.length>0)return S.filePaths}f(h){if(h){let p=this.b.get(h.id);return p||(p=new M.Queue,this.b.set(h.id,p)),p}else return this.c}showMessageBox(h,p){return this.f(p).queue(async()=>p?E.dialog.showMessageBox(p,h):E.dialog.showMessageBox(h))}async showSaveDialog(h,p){const k=this.i(h,p);if(!k)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.f(p).queue(async()=>{let S;return p?S=await E.dialog.showSaveDialog(p,h):S=await E.dialog.showSaveDialog(h),S.filePath=this.g(S.filePath),S})}finally{(0,D.dispose)(k)}}g(h){return h&&f.isMacintosh&&(h=(0,P.normalizeNFC)(h)),h}h(h){return h.map(p=>this.g(p))}async showOpenDialog(h,p){h.defaultPath&&(await b.Promises.exists(h.defaultPath)||(h.defaultPath=void 0));const k=this.i(h,p);if(!k)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.f(p).queue(async()=>{let S;return p?S=await E.dialog.showOpenDialog(p,h):S=await E.dialog.showOpenDialog(h),S.filePaths=this.h(S.filePaths),S})}finally{(0,D.dispose)(k)}}i(h,p){if(!p)return D.Disposable.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",h);let k=this.a.get(p.id);k||(k=new Set,this.a.set(p.id,k));const S=(0,n.hash)(h);if(!k.has(S))return this.d.trace("[DialogMainService]: new file dialog lock created",h),k.add(S),(0,D.toDisposable)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",h),k?.delete(S),k?.size===0&&this.a.delete(p.id)})}};w=ve([_(0,g.ILogService)],w),e.DialogMainService=w}),define(ee[264],te([0,1,3,2,73,29]),function(G,e,E,M,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends M.Disposable{constructor(f,d){super(),this.f=f,this.g=d,this.b=this.B(new E.Emitter),this.c=new Map,this.h(d.applicationStorage,this.b)}h(f,d){this.B(E.Event.debounce(f.onDidChangeStorage,(b,v)=>(b?b.push(v):b=[v],b),D.a)(b=>{b.length&&d.fire(this.i(b,f))}))}i(f,d){const b=new Map,v=new Set;return f.forEach(y=>{const g=d.get(y.key);typeof g=="string"?b.set(y.key,g):v.add(y.key)}),{changed:Array.from(b.entries()),deleted:Array.from(v.values())}}listen(f,d,b){switch(d){case"onDidChangeStorage":{const v=b.profile?(0,n.revive)(b.profile):void 0;if(!v)return this.b.event;let y=this.c.get(v.id);return y||(y=this.B(new E.Emitter),this.h(this.g.profileStorage(v),y),this.c.set(v.id,y)),y.event}}throw new Error(`Event not found: ${d}`)}async call(f,d,b){const v=b.profile?(0,n.revive)(b.profile):void 0,y=(0,C.reviveIdentifier)(b.workspace),g=await this.j(v,y);switch(d){case"getItems":return Array.from(g.items.entries());case"updateItems":{const m=b;if(m.insert)for(const[w,o]of m.insert)g.set(w,o);m.delete?.forEach(w=>g.delete(w));break}case"isUsed":{const m=b.payload;if(typeof m=="string")return this.g.isUsed(m)}default:throw new Error(`Call not found: ${d}`)}}async j(f,d){let b;d?b=this.g.workspaceStorage(d):f?b=this.g.profileStorage(f):b=this.g.applicationStorage;try{await b.init()}catch(v){this.f.error(`StorageIPC#init: Unable to init ${d?"workspace":f?"profile":"application"} storage due to ${v}`)}return b}}D.a=100,e.StorageDatabaseChannel=D}),define(ee[39],te([0,1,72,3,2,18,7,176,33,16,6,5,29,35,38,8,31,27,10]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g,m,w,o,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function k(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&D.URI.isUri(s.location)&&D.URI.isUri(s.globalStorageHome)&&D.URI.isUri(s.settingsResource)&&D.URI.isUri(s.keybindingsResource)&&D.URI.isUri(s.tasksResource)&&D.URI.isUri(s.snippetsHome)&&D.URI.isUri(s.extensionsResource))}e.isUserDataProfile=k,e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function S(i,s){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:D.URI.revive(i.location).with({scheme:s}),globalStorageHome:D.URI.revive(i.globalStorageHome).with({scheme:s}),settingsResource:D.URI.revive(i.settingsResource).with({scheme:s}),keybindingsResource:D.URI.revive(i.keybindingsResource).with({scheme:s}),tasksResource:D.URI.revive(i.tasksResource).with({scheme:s}),snippetsHome:D.URI.revive(i.snippetsHome).with({scheme:s}),extensionsResource:D.URI.revive(i.extensionsResource)?.with({scheme:s}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=S;function R(i,s,c,u){return{id:i,name:s,location:c,isDefault:!1,shortName:u?.shortName,globalStorageHome:(0,C.joinPath)(c,"globalStorage"),settingsResource:(0,C.joinPath)(c,"settings.json"),keybindingsResource:(0,C.joinPath)(c,"keybindings.json"),tasksResource:(0,C.joinPath)(c,"tasks.json"),snippetsHome:(0,C.joinPath)(c,"snippets"),extensionsResource:(0,C.joinPath)(c,"extensions.json"),useDefaultFlags:u?.useDefaultFlags,isTransient:u?.transient}}e.toUserDataProfile=R;let t=class extends n.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(s,c,u,r){super(),this.m=s,this.n=c,this.r=u,this.s=r,this.f=!0,this.g=this.B(new M.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new M.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new M.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new M.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new g.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,C.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.t=void 0}setEnablement(s){this.f!==s&&(this.t=void 0,this.f=s)}isEnabled(){return this.f}get u(){if(!this.t){const s=[];if(this.f)for(const l of this.G()){if(!l.name||!(0,p.isString)(l.name)||!l.location){this.s.warn("Skipping the invalid stored profile",l.location||l.name);continue}s.push(R((0,C.basename)(l.location),l.name,l.location,{shortName:l.shortName,useDefaultFlags:l.useDefaultFlags}))}const c=new g.ResourceMap,u=new Map,r=R((0,E.hash)(this.m.userRoamingDataHome.path).toString(16),(0,P.localize)(0,null),this.m.userRoamingDataHome);if(s.unshift({...r,extensionsResource:this.L()??r.extensionsResource,isDefault:!0}),s.length){const l=this.I();if(l.workspaces)for(const[I,A]of Object.entries(l.workspaces)){const O=D.URI.parse(I),N=D.URI.parse(A),X=s.find(V=>this.r.extUri.isEqual(V.location,N));X&&c.set(O,X)}if(l.emptyWindows)for(const[I,A]of Object.entries(l.emptyWindows)){const O=D.URI.parse(A),N=s.find(X=>this.r.extUri.isEqual(X.location,O));N&&u.set(I,N)}}this.t={profiles:s,workspaces:c,emptyWindows:u}}return this.t}async createTransientProfile(s){const c="Temp",u=new RegExp(`${(0,h.escapeRegExpCharacters)(c)}\\s(\\d+)`);let r=0;for(const I of this.profiles){const A=u.exec(I.name),O=A?parseInt(A[1]):0;r=O>r?O:r}const l=`${c} ${r+1}`;return this.createProfile((0,E.hash)((0,o.generateUuid)()).toString(16),l,{transient:!0},s)}async createNamedProfile(s,c,u){return this.createProfile((0,E.hash)((0,o.generateUuid)()).toString(16),s,c,u)}async createProfile(s,c,u,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=await this.v(s,c,u);return r&&await this.setProfileForWorkspace(r,l),l}async v(s,c,u){if(!(0,p.isString)(c)||!c)throw new Error("Name of the profile is mandatory and must be of type `string`");let r=this.k.get(c);return r||(r=(async()=>{try{const l=this.profiles.find(O=>O.name===c||O.id===s);if(l)return l;const I=R(s,c,(0,C.joinPath)(this.profilesHome,s),u);await this.n.createFolder(I.location);const A=[];return this.h.fire({profile:I,join(O){A.push(O)}}),await w.Promises.settled(A),this.z([I],[],[]),I}finally{this.k.delete(c)}})(),this.k.set(c,r)),r}async updateProfile(s,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let u=this.profiles.find(r=>r.id===s.id);if(!u)throw new Error(`Profile '${s.name}' does not exist`);return u=R(u.id,c.name??u.name,u.location,{shortName:c.shortName??u.shortName,transient:c.transient??u.isTransient,useDefaultFlags:c.useDefaultFlags??u.useDefaultFlags}),this.z([],[],[u]),u}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const c=this.profiles.find(r=>r.id===s.id);if(!c)throw new Error(`Profile '${s.name}' does not exist`);const u=[];this.i.fire({profile:c,join(r){u.push(r)}});try{await Promise.allSettled(u)}catch(r){this.s.error(r)}for(const r of[...this.u.emptyWindows.keys()])c.id===this.u.emptyWindows.get(r)?.id&&this.u.emptyWindows.delete(r);for(const r of[...this.u.workspaces.keys()])c.id===this.u.workspaces.get(r)?.id&&this.u.workspaces.delete(r);this.F(),this.z([],[c],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(c.location,{recursive:!0})}catch(r){this.s.error(r)}}async setProfileForWorkspace(s,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const u=this.profiles.find(r=>r.id===c.id);if(!u)throw new Error(`Profile '${c.name}' does not exist`);this.D(s,u)}unsetWorkspace(s,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.D(s,void 0,c)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.F(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const s=await this.n.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(c=>c.isDirectory&&this.profiles.every(u=>!this.r.extUri.isEqual(u.location,c.resource))).map(c=>this.n.del(c.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.l.profiles.filter(c=>!this.y(c));await Promise.allSettled(s.map(c=>this.removeProfile(c)))}getProfileForWorkspace(s){const c=this.w(s);return D.URI.isUri(c)?this.l.workspaces.get(c)??this.u.workspaces.get(c):this.l.emptyWindows.get(c)??this.u.emptyWindows.get(c)}w(s){return(0,y.isSingleFolderWorkspaceIdentifier)(s)?s.uri:(0,y.isWorkspaceIdentifier)(s)?s.configPath:s.id}y(s){return!!([...this.l.emptyWindows.values()].some(c=>this.r.extUri.isEqual(c.location,s.location))||[...this.l.workspaces.values()].some(c=>this.r.extUri.isEqual(c.location,s.location))||[...this.u.emptyWindows.values()].some(c=>this.r.extUri.isEqual(c.location,s.location))||[...this.u.workspaces.values()].some(c=>this.r.extUri.isEqual(c.location,s.location)))}z(s,c,u){const r=[...this.profiles,...s],l=[];this.l.profiles=[];for(let I of r)I.isDefault||c.some(A=>I.id===A.id)||(I=u.find(A=>I.id===A.id)??I,I.isTransient?this.l.profiles.push(I):l.push({location:I.location,name:I.name,shortName:I.shortName,useDefaultFlags:I.useDefaultFlags}));this.H(l),this.t=void 0,this.C(s,c,u)}C(s,c,u){this.g.fire({added:s,removed:c,updated:u,all:this.profiles})}D(s,c,u){u=c?.isTransient?!0:u,u||this.D(s,void 0,!0);const r=this.w(s),l=u?this.l:this.u;D.URI.isUri(r)?(l.workspaces.delete(r),c&&l.workspaces.set(r,c)):(l.emptyWindows.delete(r),c&&l.emptyWindows.set(r,c)),u||this.F()}F(){const s={};for(const[u,r]of this.u.workspaces.entries())s[u.toString()]=r.location.toString();const c={};for(const[u,r]of this.u.emptyWindows.entries())c[u.toString()]=r.location.toString();this.J({workspaces:s,emptyWindows:c}),this.t=void 0}G(){return[]}H(s){throw new Error("not implemented")}I(){return{}}J(s){throw new Error("not implemented")}L(){}};t.b="userDataProfiles",t.c="profileAssociations",t=ve([_(0,f.IEnvironmentService),_(1,d.IFileService),_(2,m.IUriIdentityService),_(3,v.ILogService)],t),e.UserDataProfilesService=t;class a extends t{constructor(){super(...arguments),this.a=[],this.O={}}G(){return this.a}H(s){this.a=s}I(){return this.O}J(s){this.O=s}}e.InMemoryUserDataProfilesService=a}),define(ee[78],te([0,1,8,17,2,3,35,7,113,91,16,6,5,39,38,10,13,24]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g,m,w,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class k extends Error{constructor(i,s){super(i),this.code=s}}e.ExtensionsProfileScanningError=k,e.IExtensionsProfileScannerService=(0,v.createDecorator)("IExtensionsProfileScannerService");let S=class extends n.Disposable{constructor(i,s,c,u,r,l){super(),this.h=i,this.i=s,this.j=c,this.k=u,this.l=r,this.m=l,this.a=this.B(new C.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new C.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new C.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new C.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new D.ResourceMap}scanProfileExtensions(i,s){return this.n(i,void 0,s)}async addExtensionsToProfile(i,s){const c=[],u=[];try{return await this.n(s,r=>{const l=[];for(const I of r)i.some(([A])=>(0,f.areSameExtensions)(A.identifier,I.identifier)&&A.manifest.version!==I.version)?c.push(I):l.push(I);for(const[I,A]of i)if(!l.some(O=>(0,f.areSameExtensions)(O.identifier,I.identifier)&&O.version===I.manifest.version)){const O={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:A};u.push(O),l.push(O)}return u.length&&this.a.fire({extensions:u,profileLocation:s}),c.length&&this.c.fire({extensions:c,profileLocation:s}),l}),u.length&&this.b.fire({extensions:u,profileLocation:s}),c.length&&this.f.fire({extensions:c,profileLocation:s}),u}catch(r){throw u.length&&this.b.fire({extensions:u,error:r,profileLocation:s}),c.length&&this.f.fire({extensions:c,error:r,profileLocation:s}),r}}async updateMetadata(i,s){const c=[];return await this.n(s,u=>{const r=[];for(const l of u){const I=i.find(([A])=>(0,f.areSameExtensions)(A.identifier,l.identifier)&&A.manifest.version===l.version);I&&(l.metadata={...l.metadata,...I[1]},c.push(l)),r.push(l)}return r}),c}async removeExtensionFromProfile(i,s){const c=[];this.c.fire({extensions:c,profileLocation:s});try{await this.n(s,u=>{const r=[];for(const l of u)(0,f.areSameExtensions)(l.identifier,i.identifier)?c.push(l):r.push(l);return c.length&&this.c.fire({extensions:c,profileLocation:s}),r}),c.length&&this.f.fire({extensions:c,profileLocation:s})}catch(u){throw c.length&&this.f.fire({extensions:c,error:u,profileLocation:s}),u}}async n(i,s,c){return this.v(i).queue(async()=>{let u=[],r;try{const l=await this.i.readFile(i);r=JSON.parse(l.value.toString())}catch(l){if((0,b.toFileOperationResult)(l)!==1)throw l;if(this.k.extUri.isEqual(i,this.j.defaultProfile.extensionsResource)&&(r=await this.u()),!r&&c?.bailOutWhenFileNotFound)throw new k((0,o.getErrorMessage)(l),"ERROR_PROFILE_NOT_FOUND")}if(r){Array.isArray(r)||this.p(i);let l=!1;for(const I of r){R(I)||this.p(i);let A;if((0,w.isString)(I.location))A=this.s(I.location);else{A=P.URI.revive(I.location);const O=this.r(A);O&&(l=!0,I.location=O)}u.push({identifier:I.identifier,location:A,version:I.version,metadata:I.metadata})}l&&await this.i.writeFile(i,M.VSBuffer.fromString(JSON.stringify(r)))}if(s){u=s(u);const l=u.map(I=>({identifier:I.identifier,version:I.version,location:this.r(I.location)??I.location.toJSON(),metadata:I.metadata}));await this.i.writeFile(i,M.VSBuffer.fromString(JSON.stringify(l)))}return u})}p(i){const s=new k(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.l.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}r(i){return this.k.extUri.isEqualOrParent(i,this.h)?this.k.extUri.relativePath(this.h,i):void 0}s(i){return this.k.extUri.joinPath(this.h,i)}async u(){return this.t||(this.t=(async()=>{const i=this.k.extUri.joinPath(this.j.defaultProfile.location,"extensions.json");let s;try{s=(await this.i.readFile(i)).value.toString()}catch(u){if((0,b.toFileOperationResult)(u)===1)return;throw u}this.m.info("Migrating extensions from old default profile location",i.toString());let c;try{const u=JSON.parse(s);Array.isArray(u)&&u.every(r=>R(r))?c=u:this.m.warn("Skipping migrating from old default profile locaiton: Found invalid data",u)}catch(u){this.m.error(u)}if(c)try{await this.i.createFile(this.j.defaultProfile.extensionsResource,M.VSBuffer.fromString(JSON.stringify(c)),{overwrite:!1}),this.m.info("Migrated extensions from old default profile location to new location",i.toString(),this.j.defaultProfile.extensionsResource.toString())}catch(u){if((0,b.toFileOperationResult)(u)===3)this.m.info("Migration from old default profile location to new location is done by another window",i.toString(),this.j.defaultProfile.extensionsResource.toString());else throw u}try{await this.i.del(i)}catch(u){(0,b.toFileOperationResult)(u)!==1&&this.m.error(u)}return c})()),this.t}v(i){let s=this.g.get(i);return s||(s=new E.Queue,this.g.set(i,s)),s}};S=ve([_(1,b.IFileService),_(2,g.IUserDataProfilesService),_(3,m.IUriIdentityService),_(4,h.ITelemetryService),_(5,y.ILogService)],S),e.AbstractExtensionsProfileScannerService=S;function R(a){return(0,w.isObject)(a)&&(0,d.isIExtensionIdentifier)(a.identifier)&&(t(a.location)||(0,w.isString)(a.location))&&a.version&&(0,w.isString)(a.version)}function t(a){return a?(0,w.isString)(a.path)&&(0,w.isString)(a.scheme):!1}}),define(ee[119],te([0,1,25,8,40,17,13,43,141,2,15,9,4,18,194,84,10,7,161,33,113,91,193,16,6,5,20,3,73,78,39,38,191,192]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g,m,w,o,h,p,k,S,R,t,a,i,s,c,u,r,l,I,A,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var X;(function(ge){function x(F,W){if(F===W)return!0;const z=Object.keys(F),J=new Set;for(const ne of Object.keys(W))J.add(ne);if(z.length!==J.size)return!1;for(const ne of z){if(F[ne]!==W[ne])return!1;J.delete(ne)}return J.size===0}ge.equals=x})(X=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let V=class extends d.Disposable{constructor(x,F,W,z,J,ne,se,Z,U,L,T,B){super(),this.systemExtensionsLocation=x,this.userExtensionsLocation=F,this.l=W,this.m=z,this.n=J,this.p=ne,this.r=se,this.s=Z,this.t=U,this.u=L,this.v=T,this.w=B,this.g=this.B(new u.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,g.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(re,(0,g.joinPath)(this.m,R.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(re,(0,g.joinPath)(this.m,R.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(ie,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,S.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(x,F,W){const[z,J]=await Promise.all([this.scanSystemExtensions(x),this.scanUserExtensions(F)]),ne=W?await this.scanExtensionsUnderDevelopment(x,[...z,...J]):[];return this.F(z,J,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(x){const F=[];F.push(this.G(!!x.useCache,x.language)),F.push(this.H(x.language,!!x.checkControlFile));const[W,z]=await Promise.all(F);return this.D([...W,...z],0,x,!1)}async scanUserExtensions(x){const F=x.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",F);const W=this.v.extUri.isEqual(x.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.J(F,!!x.profileLocation,1,!x.includeUninstalled,x.language,!0,W),J=x.useCache&&!z.devMode&&z.excludeObsolete?this.j:this.k;let ne;try{ne=await J.scanExtensions(z)}catch(se){if(se instanceof l.ExtensionsProfileScanningError&&se.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),ne=await J.scanExtensions(z);else throw se}return ne=await this.D(ne,1,x,!0),this.s.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(x,F){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const W=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(z=>z.scheme===b.Schemas.file).map(async z=>{const J=await this.J(z,!1,1,!0,x.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(J)).map(se=>(se.type=F.find(Z=>(0,S.areSameExtensions)(Z.identifier,se.identifier))?.type??se.type,this.k.validate(se,J)))}))).flat();return this.D(W,"development",x,!0)}return[]}async scanExistingExtension(x,F,W){const z=await this.J(x,!1,F,!0,W.language,!0,void 0),J=await this.k.scanExtension(z);return!J||!W.includeInvalid&&!J.isValid?null:J}async scanOneOrMultipleExtensions(x,F,W){const z=await this.J(x,!1,F,!0,W.language,!0,void 0),J=await this.k.scanOneOrMultipleExtensions(z);return this.D(J,F,W,!0)}async scanMetadata(x){const F=(0,g.joinPath)(x,"package.json"),W=(await this.r.readFile(F)).value.toString();return JSON.parse(W).__metadata}async updateMetadata(x,F){const W=(0,g.joinPath)(x,"package.json"),z=(await this.r.readFile(W)).value.toString(),J=JSON.parse(z);F.isMachineScoped=F.isMachineScoped||void 0,F.isBuiltin=F.isBuiltin||void 0,F.installedTimestamp=F.installedTimestamp||void 0,J.__metadata={...J.__metadata,...F},await this.r.writeFile((0,g.joinPath)(x,"package.json"),C.VSBuffer.fromString(JSON.stringify(J,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(x){if(x instanceof l.ExtensionsProfileScanningError&&x.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw x}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const x=await this.scanUserExtensions({includeInvalid:!0});if(x.length)await this.p.addExtensionsToProfile(x.map(F=>[F,F.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,C.VSBuffer.fromString(JSON.stringify([])))}catch(F){(0,a.toFileOperationResult)(F)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.getErrorMessage)(F))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(x){this.s.error(x)}finally{this.z=void 0}})()),this.z}async D(x,F,W,z){return W.includeAllVersions||(x=this.F(F===0?x:void 0,F===1?x:void 0,F==="development"?x:void 0,await this.getTargetPlatform(),z)),W.includeInvalid||(x=x.filter(J=>J.isValid)),x.sort((J,ne)=>{const se=v.basename(J.location.fsPath),Z=v.basename(ne.location.fsPath);return se<Z?-1:se>Z?1:0})}F(x,F,W,z,J){const ne=(Z,U,L)=>{if(Z.isValid&&!U.isValid)return!1;if(Z.isValid===U.isValid){if(J&&m.gt(Z.manifest.version,U.manifest.version))return this.s.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${Z.location.path} with version ${Z.manifest.version}`),!1;if(m.eq(Z.manifest.version,U.manifest.version)){if(Z.type===0)return this.s.debug(`Skipping extension ${U.location.path} in favour of system extension ${Z.location.path} with same version`),!1;if(Z.targetPlatform===z)return this.s.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return L?this.s.warn(`Overwriting user extension ${Z.location.path} with ${U.location.path}.`):this.s.debug(`Overwriting user extension ${Z.location.path} with ${U.location.path}.`),!0},se=new Map;return x?.forEach(Z=>{const U=R.ExtensionIdentifier.toKey(Z.identifier.id),L=se.get(U);(!L||ne(L,Z,!1))&&se.set(U,Z)}),F?.forEach(Z=>{const U=R.ExtensionIdentifier.toKey(Z.identifier.id),L=se.get(U);if(!L&&x&&Z.type===0){this.s.debug(`Skipping obsolete system extension ${Z.location.path}.`);return}(!L||ne(L,Z,!1))&&se.set(U,Z)}),W?.forEach(Z=>{const U=R.ExtensionIdentifier.toKey(Z.identifier.id),L=se.get(U);(!L||ne(L,Z,!0))&&se.set(U,Z),se.set(U,Z)}),[...se.values()]}async G(x,F){this.s.trace("Started scanning system extensions");const W=await this.J(this.systemExtensionsLocation,!1,0,!0,F,!0,void 0),J=await(x&&!W.devMode?this.i:this.k).scanExtensions(W);return this.s.trace("Scanned system extensions:",J.length),J}async H(x,F){const W=this.t.isBuilt?[]:this.u.builtInExtensions;if(!W?.length)return[];this.s.trace("Started scanning dev system extensions");const z=F?await this.I():{},J=[],ne=h.URI.file(v.normalize(v.join(b.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Z of W){const U=z[Z.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":J.push((0,g.joinPath)(ne,Z.name));break;default:J.push(h.URI.file(U));break}}const se=await Promise.all(J.map(async Z=>this.k.scanExtension(await this.J(Z,!1,0,!0,x,!0,void 0))));return this.s.trace("Scanned dev system extensions:",se.length),(0,E.coalesce)(se)}async I(){try{const x=await this.r.readFile(this.l);return JSON.parse(x.value.toString())}catch{return{}}}async J(x,F,W,z,J,ne,se){const Z=await this.f(J??y.language),U=await this.L(x),L=F&&!this.v.extUri.isEqual(x,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,T=L?await this.L(L):void 0;return new K(x,U,L,T,F,se,W,z,ne,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,J,Z)}async L(x){try{const F=await this.r.stat(x);if(typeof F.mtime=="number")return F.mtime}catch{}}};V=ve([_(4,I.IUserDataProfilesService),_(5,l.IExtensionsProfileScannerService),_(6,a.IFileService),_(7,s.ILogService),_(8,k.IEnvironmentService),_(9,c.IProductService),_(10,A.IUriIdentityService),_(11,i.IInstantiationService)],V),e.AbstractExtensionsScannerService=V;class K{constructor(x,F,W,z,J,ne,se,Z,U,L,T,B,H,j,$){this.location=x,this.mtime=F,this.applicationExtensionslocation=W,this.applicationExtensionslocationMtime=z,this.profile=J,this.profileScanOptions=ne,this.type=se,this.excludeObsolete=Z,this.validate=U,this.productVersion=L,this.productDate=T,this.productCommit=B,this.devMode=H,this.language=j,this.translations=$}static createNlsConfiguration(x){return{language:x.language,pseudo:x.language==="pseudo",devMode:x.devMode,translations:x.translations}}static equals(x,F){return(0,g.isEqual)(x.location,F.location)&&x.mtime===F.mtime&&(0,g.isEqual)(x.applicationExtensionslocation,F.applicationExtensionslocation)&&x.applicationExtensionslocationMtime===F.applicationExtensionslocationMtime&&x.profile===F.profile&&n.equals(x.profileScanOptions,F.profileScanOptions)&&x.type===F.type&&x.excludeObsolete===F.excludeObsolete&&x.validate===F.validate&&x.productVersion===F.productVersion&&x.productDate===F.productDate&&x.productCommit===F.productCommit&&x.devMode===F.devMode&&x.language===F.language&&X.equals(x.translations,F.translations)}}e.ExtensionScannerInput=K;let ie=class extends d.Disposable{constructor(x,F,W,z,J){super(),this.f=x,this.g=F,this.h=W,this.i=z,this.j=J}async scanExtensions(x){const F=x.profile?await this.l(x):await this.k(x);let W={};if(x.excludeObsolete&&x.type===1)try{const z=(await this.i.readFile(this.f)).value.toString();W=JSON.parse(z)}catch{}return(0,o.isEmptyObject)(W)?F:F.filter(z=>!W[S.ExtensionKey.create(z).toString()])}async k(x){const F=await this.i.resolve(x.location);if(!F.children?.length)return[];const W=await Promise.all(F.children.map(async z=>{if(!z.isDirectory||x.type===1&&(0,g.basename)(z.resource).indexOf(".")===0)return null;const J=new K(z.resource,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(J)}));return(0,E.coalesce)(W).sort((z,J)=>z.location.path<J.location.path?-1:1)}async l(x){let F=await this.m(x.location,()=>!0,x);if(x.applicationExtensionslocation&&!this.h.extUri.isEqual(x.location,x.applicationExtensionslocation)){F=F.filter(z=>!z.metadata?.isApplicationScoped);const W=await this.m(x.applicationExtensionslocation,z=>!!z.metadata?.isApplicationScoped,x);F.push(...W)}return F}async m(x,F,W){const z=await this.g.scanProfileExtensions(x,W.profileScanOptions);if(!z.length)return[];const J=await Promise.all(z.map(async ne=>{if(F(ne)){const se=new K(ne.location,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(se,ne.metadata)}return null}));return(0,E.coalesce)(J)}async scanOneOrMultipleExtensions(x){try{if(await this.i.exists((0,g.joinPath)(x.location,"package.json"))){const F=await this.scanExtension(x);return F?[F]:[]}else return await this.scanExtensions(x)}catch(F){return this.j.error(`Error scanning extensions at ${x.location.path}:`,(0,D.getErrorMessage)(F)),[]}}async scanExtension(x,F){try{let W=await this.scanExtensionManifest(x.location);if(W){W.publisher||(W.publisher=R.UNDEFINED_PUBLISHER),F=F??W.__metadata,delete W.__metadata;const z=(0,S.getGalleryExtensionId)(W.publisher,W.name),J=F?.id?{id:z,uuid:F.id}:{id:z},ne=F?.isSystem?0:x.type,se=ne===0||!!F?.isBuiltin;N.ImplicitActivationEvents.updateManifest(W),W=await this.n(x.location,W,K.createNlsConfiguration(x));const Z={type:ne,identifier:J,manifest:W,location:x.location,isBuiltin:se,targetPlatform:F?.targetPlatform??"undefined",metadata:F,isValid:!0,validations:[]};return x.validate?this.validate(Z,x):Z}}catch(W){x.type!==0&&this.j.error(W)}return null}validate(x,F){let W=!0;const z=(0,t.validateExtensionManifest)(F.productVersion,F.productDate,F.location,x.manifest,x.isBuiltin);for(const[J,ne]of z)J===w.default.Error&&(W=!1,this.j.error(this.t(F.location,ne)));return x.isValid=W,x.validations=z,x}async scanExtensionManifest(x){const F=(0,g.joinPath)(x,"package.json");let W;try{W=(await this.i.readFile(F)).value.toString()}catch(J){return(0,a.toFileOperationResult)(J)!==1&&this.j.error(this.t(x,(0,p.localize)(0,null,F.path,J.message))),null}let z;try{z=JSON.parse(W)}catch{const ne=[];(0,P.parse)(W,ne);for(const se of ne)this.j.error(this.t(x,(0,p.localize)(1,null,F.path,se.offset,se.length,(0,f.getParseErrorMessage)(se.error))));return null}return(0,P.getNodeType)(z)!=="object"?(this.j.error(this.t(x,(0,p.localize)(2,null,F.path))),null):z}async n(x,F,W){const z=await this.p(x,F,W);if(z)try{const J=[],ne=await this.r(z.default,J);if(J.length>0)return J.forEach(Z=>{this.j.error(this.t(x,(0,p.localize)(3,null,z.default?.path,(0,f.getParseErrorMessage)(Z.error))))}),F;if((0,P.getNodeType)(z)!=="object")return this.j.error(this.t(x,(0,p.localize)(4,null,z.default?.path))),F;const se=z.values||Object.create(null);return(0,O.localizeManifest)(F,se,ne)}catch{}return F}async p(x,F,W){const z=(0,g.joinPath)(x,"package.nls.json"),J=(U,L)=>{L.forEach(T=>{this.j.error(this.t(x,(0,p.localize)(5,null,U?.path,(0,f.getParseErrorMessage)(T.error))))})},ne=U=>{this.j.error(this.t(x,(0,p.localize)(6,null,U?.path)))},se=`${F.publisher}.${F.name}`,Z=W.translations[se];if(Z)try{const U=h.URI.file(Z),L=(await this.i.readFile(U)).value.toString(),T=[],B=(0,P.parse)(L,T);return T.length>0?(J(U,T),{values:void 0,default:z}):(0,P.getNodeType)(B)!=="object"?(ne(U),{values:void 0,default:z}):{values:B.contents?B.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.i.exists(z))return;let L;try{L=await this.s(x,W)}catch{return}if(!L.localized)return{values:void 0,default:L.original};try{const T=(await this.i.readFile(L.localized)).value.toString(),B=[],H=(0,P.parse)(T,B);return B.length>0?(J(L.localized,B),{values:void 0,default:L.original}):(0,P.getNodeType)(H)!=="object"?(ne(L.localized),{values:void 0,default:L.original}):{values:H,default:L.original}}catch{return{values:void 0,default:L.original}}}}async r(x,F){if(x)try{const W=(await this.i.readFile(x)).value.toString();return(0,P.parse)(W,F)}catch{}}s(x,F){return new Promise((W,z)=>{const J=ne=>{const se=(0,g.joinPath)(x,`package.nls.${ne}.json`);this.i.exists(se).then(Z=>{Z&&W({localized:se,original:(0,g.joinPath)(x,"package.nls.json")});const U=ne.lastIndexOf("-");U===-1?W({localized:(0,g.joinPath)(x,"package.nls.json"),original:null}):(ne=ne.substring(0,U),J(ne))})};if(F.devMode||F.pseudo||!F.language)return W({localized:(0,g.joinPath)(x,"package.nls.json"),original:null});J(F.language)})}t(x,F){return`[${x.path}]: ${F}`}};ie=ve([_(1,l.IExtensionsProfileScannerService),_(2,A.IUriIdentityService),_(3,a.IFileService),_(4,s.ILogService)],ie);let re=class extends ie{constructor(x,F,W,z,J,ne){super(F,W,z,J,ne),this.y=x,this.v=this.B(new M.ThrottledDelayer(3e3)),this.w=this.B(new u.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(x){const F=await this.z();if(this.u=x,F&&F.input&&K.equals(F.input,this.u))return this.j.debug("Using cached extensions scan result",x.location.toString()),this.v.trigger(()=>this.D()),F.result.map(z=>(z.location=h.URI.revive(z.location),z));const W=await super.scanExtensions(x);return await this.C({input:x,result:W}),W}async z(){try{const x=await this.i.readFile(this.y),F=JSON.parse(x.value.toString());return{result:F.result,input:(0,r.revive)(F.input)}}catch(x){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,D.getErrorMessage)(x))}return null}async C(x){try{await this.i.writeFile(this.y,C.VSBuffer.fromString(JSON.stringify(x)))}catch(F){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,D.getErrorMessage)(F))}}async D(){if(!this.u)return;const x=await this.z();if(!x)return;const F=x.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!n.equals(W,F))try{await this.i.del(this.y),this.w.fire()}catch(z){this.j.error(z)}}};re=ve([_(2,l.IExtensionsProfileScannerService),_(3,A.IUriIdentityService),_(4,a.IFileService),_(5,s.ILogService)],re);function ce(ge,x){const F=(0,S.getExtensionId)(ge.manifest.publisher,ge.manifest.name);return{id:F,identifier:new R.ExtensionIdentifier(F),isBuiltin:ge.type===0,isUserBuiltin:ge.type===1&&ge.isBuiltin,isUnderDevelopment:x,extensionLocation:ge.location,uuid:ge.identifier.uuid,targetPlatform:ge.targetPlatform,...ge.manifest}}e.toExtensionDescription=ce;class fe extends V{constructor(x,F,W,z,J,ne,se,Z,U,L,T,B){super(x,F,(0,g.joinPath)(W,".vscode-oss-dev","extensions","control.json"),(0,g.joinPath)(z,R.MANIFEST_CACHE_FOLDER),J,ne,se,Z,U,L,T,B),this.M=(async()=>{if(y.translationsConfigFile)try{const H=await this.r.readFile(h.URI.file(y.translationsConfigFile));return JSON.parse(H.value.toString())}catch{}return Object.create(null)})()}f(x){return this.M}}e.NativeExtensionsScannerService=fe}),define(ee[265],te([0,1,5,39,38,24,78,16,33,7]),function(G,e,E,M,n,C,D,P,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let b=class extends D.AbstractExtensionsProfileScannerService{constructor(y,g,m,w,o,h){super(d.URI.file(y.extensionsPath),g,m,w,o,h)}};b=ve([_(0,f.INativeEnvironmentService),_(1,P.IFileService),_(2,M.IUserDataProfilesService),_(3,n.IUriIdentityService),_(4,C.ITelemetryService),_(5,E.ILogService)],b),e.ExtensionsProfileScannerService=b}),define(ee[266],te([0,1,7,33,78,119,16,6,5,20,38,39]),function(G,e,E,M,n,C,D,P,f,d,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let y=class extends C.NativeExtensionsScannerService{constructor(m,w,o,h,p,k,S,R){super(E.URI.file(p.builtinExtensionsPath),E.URI.file(p.extensionsPath),p.userHome,E.URI.file(p.userDataPath),m,w,o,h,p,k,S,R)}};y=ve([_(0,v.IUserDataProfilesService),_(1,n.IExtensionsProfileScannerService),_(2,D.IFileService),_(3,f.ILogService),_(4,M.INativeEnvironmentService),_(5,d.IProductService),_(6,b.IUriIdentityService),_(7,P.IInstantiationService)],y),e.ExtensionsScannerService=y}),define(ee[267],te([0,1,14,2,15,9,4,61,7,31,42,33,5,39]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let m=class extends M.Disposable{constructor(o,h,p){super(),this.c=o,this.f=p,this.a=P.TernarySearchTree.forPaths(!D.isLinux),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(o.appRoot),this.addValidFileRoot(o.extensionsPath),this.addValidFileRoot(h.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(o.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:o}=E.session;o.protocol.registerFileProtocol(n.Schemas.vscodeFileResource,(h,p)=>this.i(h,p)),o.protocol.interceptFileProtocol(n.Schemas.file,(h,p)=>this.h(h,p)),this.B((0,M.toDisposable)(()=>{o.protocol.unregisterProtocol(n.Schemas.vscodeFileResource),o.protocol.uninterceptProtocol(n.Schemas.file)}))}addValidFileRoot(o){const h=(0,C.normalize)(o);return this.a.get(h)?M.Disposable.None:(this.a.set(h,!0),(0,M.toDisposable)(()=>this.a.delete(h)))}h(o,h){const p=f.URI.parse(o.url);return this.f.error(`Refused to load resource ${p.fsPath} from ${n.Schemas.file}: protocol (original URL: ${o.url})`),h({error:-3})}i(o,h){const p=this.j(o);let k;return this.c.crossOriginIsolated&&((0,C.basename)(p)==="workbench.html"||(0,C.basename)(p)==="workbench-dev.html"?k=n.COI.CoopAndCoep:k=n.COI.getHeadersFromQuery(o.url)),this.a.findSubstr(p)?h({path:p,headers:k}):this.b.has((0,C.extname)(p).toLowerCase())?h({path:p}):(this.f.error(`${n.Schemas.vscodeFileResource}: Refused to load resource ${p} from ${n.Schemas.vscodeFileResource}: protocol (original URL: ${o.url})`),h({error:-3}))}j(o){const h=f.URI.parse(o.url),p=n.FileAccess.uriToFileUri(h);return(0,C.normalize)(p.fsPath)}createIPCObjectUrl(){let o;const h=f.URI.from({scheme:"vscode",path:(0,d.generateUuid)()}),p=h.toString(),k=async()=>o;return b.validatedIpcMain.handle(p,k),this.f.trace(`IPC Object URL: Registered new channel ${p}.`),{resource:h,update:S=>o=S,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${p}.`),b.validatedIpcMain.removeHandler(p)}}}};m=ve([_(0,v.INativeEnvironmentService),_(1,g.IUserDataProfilesService),_(2,y.ILogService)],m),e.ProtocolMainService=m}),define(ee[268],te([0,1,14,42,8,3,2,15,10,105,28,21,5,66,67,69,44,39,37,65]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g,m,w,o,h,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let S=class extends D.Disposable{constructor(t,a,i,s,c,u,r,l,I,A){super(),this.g=t,this.h=a,this.i=i,this.j=s,this.k=c,this.l=u,this.m=r,this.n=l,this.p=I,this.r=A,this.a=new n.Barrier,this.b=void 0,this.c=void 0,this.f=this.B(new C.Emitter),this.onDidError=C.Event.buffer(this.f.event),this.y=void 0,this.z=void 0,this.s()}s(){M.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(t,a)=>this.t(t,a)),M.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(t,a)=>this.u(t,a)),this.B(this.k.onWillShutdown(()=>this.v()))}async t(t,a){this.l.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.a.isOpen()||this.a.open(),await this.whenReady();const i=await this.connect();if(t.sender.isDestroyed())return i.close();t.sender.postMessage("vscode:createSharedProcessMessageChannelResult",a,[i])}u(t,a){this.l.trace("SharedProcess: onWorkerConnection",a);const i=new D.DisposableStore,s=u=>{!this.G()||(this.l.trace(`SharedProcess: disposing worker (reason: '${u}')`,a),i.dispose(),this.w("vscode:electron-main->shared-process=disposeWorker",a))},c=E.BrowserWindow.fromId(a.reply.windowId);if(!c||c.isDestroyed()||c.webContents.isDestroyed()||!a.reply.channel){s("unavailable");return}i.add(C.Event.filter(this.k.onWillLoadWindow,u=>u.window.win===c)(()=>s("load"))),i.add(C.Event.fromNodeEventEmitter(c,"closed")(()=>s("closed"))),c.webContents.postMessage(a.reply.channel,a.reply.nonce,t.ports)}v(){const t=this.b;!t||(this.w("vscode:electron-main->shared-process=exit"),this.c&&(t.removeListener("close",this.c),this.c=void 0),setTimeout(()=>{try{t.close()}catch{}this.b=void 0},0))}w(t,...a){if(!this.G()){this.l.warn(`Sending IPC message to channel '${t}' for shared process window that is destroyed`);return}try{this.b?.webContents.send(t,...a)}catch(i){this.l.warn(`Error sending IPC message to channel '${t}' of shared process: ${(0,o.toErrorMessage)(i)}`)}}whenReady(){return this.y||(this.y=new Promise(t=>M.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.l.trace("SharedProcess: Overall ready"),t()}))),this.y}get C(){return this.z||(this.z=(async()=>{await this.a.wait(),this.D(),this.F(),await new Promise(t=>M.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.l.trace("SharedProcess: IPC ready"),t()}))})()),this.z}D(){const t=this.B(this.r.createIPCObjectUrl());this.b=new E.BrowserWindow({show:!1,backgroundColor:this.p.getBackgroundColor(),webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${t.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.i.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),t.update({machineId:this.g,windowId:this.b.id,appRoot:this.i.appRoot,codeCachePath:this.i.codeCachePath,profiles:this.j.profiles,userEnv:this.h,args:this.i.args,logLevel:this.m.getLogLevel(),loggers:this.m.getRegisteredLoggers(),product:g.default,policiesData:this.n.serialize()}),this.b.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.i.isBuilt?"":"-dev"}.html`).toString(!0))}F(){!this.b||(this.c=t=>{this.l.trace("SharedProcess#close prevented"),t.preventDefault(),this.b?.isVisible()&&this.b.hide()},this.b.on("close",this.c),this.b.webContents.on("render-process-gone",(t,a)=>this.f.fire({type:2,details:a})),this.b.on("unresponsive",()=>this.f.fire({type:1})),this.b.webContents.on("did-fail-load",(t,a,i)=>this.f.fire({type:3,details:{reason:i,exitCode:a}})))}async connect(){await this.C;const t=(0,f.assertIsDefined)(this.b);return(0,d.connect)(t)}async toggle(){await this.C,this.b&&(this.b.isVisible()?(this.b.webContents.closeDevTools(),this.b.hide()):(this.b.show(),this.b.webContents.openDevTools()))}isVisible(){return this.b?.isVisible()??!1}G(){const t=this.b;return t?!t.isDestroyed()&&!t.webContents.isDestroyed():!1}};S=ve([_(2,b.IEnvironmentMainService),_(3,h.IUserDataProfilesService),_(4,v.ILifecycleMainService),_(5,y.ILogService),_(6,k.ILoggerMainService),_(7,p.IPolicyService),_(8,w.IThemeMainService),_(9,m.IProtocolMainService)],S),e.SharedProcess=S}),define(ee[95],te([0,1,8,3,2,64,10,106,6,39]),function(G,e,E,M,n,C,D,P,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,f.createDecorator)("storageService");var b;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var v;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(v=e.StorageScope||(e.StorageScope={}));var y;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));function g(p){const k=p.get(e.TARGET_KEY);if(k)try{return JSON.parse(k)}catch{}return Object.create(null)}e.loadKeyTargets=g;class m extends n.Disposable{constructor(k={flushInterval:m.a}){super(),this.j=k,this.b=this.B(new M.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new M.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new M.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new E.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new n.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,E.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,n.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.J()}finally{(0,C.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(k,S){if(S===e.TARGET_KEY){switch(k){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:k})}else this.b.fire({scope:k,key:S,target:this.F(k)[S]})}r(k){this.f.fire({reason:k})}get(k,S,R){return this.L(S)?.get(k,R)}getBoolean(k,S,R){return this.L(S)?.getBoolean(k,R)}getNumber(k,S,R){return this.L(S)?.getNumber(k,R)}store(k,S,R,t){if((0,D.isUndefinedOrNull)(S)){this.remove(k,R);return}this.t(()=>{this.u(k,R,t),this.L(R)?.set(k,S)})}remove(k,S){this.t(()=>{this.u(k,S,void 0),this.L(S)?.delete(k)})}t(k){this.b.pause(),this.c.pause();try{k()}finally{this.b.resume(),this.c.resume()}}keys(k,S){const R=[],t=this.F(k);for(const a of Object.keys(t))t[a]===S&&R.push(a);return R}u(k,S,R){const t=this.F(S);typeof R=="number"?t[k]!==R&&(t[k]=R,this.L(S)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[k]=="number"&&(delete t[k],this.L(S)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(k){switch(k){case-1:return this.D;case 0:return this.z;default:return this.w}}G(k){const S=this.L(k);return S?g(S):Object.create(null)}isNew(k){return this.getBoolean(e.IS_NEW_KEY,k)===!0}async flush(k=b.NONE){this.f.fire({reason:k});const S=this.L(-1),R=this.L(0),t=this.L(1);switch(k){case b.NONE:await E.Promises.settled([S?.whenFlushed()??Promise.resolve(),R?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await E.Promises.settled([S?.flush(0)??Promise.resolve(),R?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const k=this.L(-1)?.items??new Map,S=this.L(0)?.items??new Map,R=this.L(1)?.items??new Map;return h(k,S,R,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(k,S){return this.r(b.NONE),(0,d.isUserDataProfile)(k)?this.N(k,S):this.O(k,S)}H(k,S){return!(k.id===S.id||w(S)&&w(k))}I(k,S,R,t){this.t(()=>{if(t)for(const[a,i]of k)S.set(a,i);else{const a=new Set;for(const[i,s]of k)a.add(i),S.get(i)!==s&&this.n(R,i);for(const[i]of S.items)a.has(i)||this.n(R,i)}})}}m.a=60*1e3,e.AbstractStorageService=m;function w(p){return p.isDefault||!!p.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=w;class o extends m{constructor(){super(),this.p=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(k=>this.n(1,k))),this.B(this.P.onDidChangeStorage(k=>this.n(0,k))),this.B(this.p.onDidChangeStorage(k=>this.n(-1,k)))}L(k){switch(k){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(k){switch(k){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(k){return!1}}e.InMemoryStorageService=o;async function h(p,k,S,R,t,a){const i=N=>{try{return JSON.parse(N)}catch{return N}},s=new Map,c=new Map;p.forEach((N,X)=>{s.set(X,N),c.set(X,i(N))});const u=new Map,r=new Map;k.forEach((N,X)=>{u.set(X,N),r.set(X,i(N))});const l=new Map,I=new Map;S.forEach((N,X)=>{l.set(X,N),I.set(X,i(N))}),console.group(R!==t?`Storage: Application (path: ${R})`:`Storage: Application & Profile (path: ${R}, default profile)`);const A=[];if(s.forEach((N,X)=>{A.push({key:X,value:N})}),console.table(A),console.groupEnd(),console.log(c),R!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const N=[];u.forEach((X,V)=>{N.push({key:V,value:X})}),console.table(N),console.groupEnd(),console.log(r)}console.group(`Storage: Workspace (path: ${a})`);const O=[];l.forEach((N,X)=>{O.push({key:X,value:N})}),console.table(O),console.groupEnd(),console.log(I)}e.logStorage=h}),define(ee[269],te([0,1,25,8,3,2,9,71,7,23,106,152,5,95,24,29]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class o extends C.Disposable{get storage(){return this.f}constructor(a,i){super(),this.j=a,this.k=i,this.b=this.B(new n.Emitter),this.onDidChangeStorage=this.b.event,this.c=this.B(new n.Emitter),this.onDidCloseStorage=this.c.event,this.f=new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new M.DeferredPromise,this.whenInit=this.h.p,this.i=b.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===b.StorageState.None)try{const a=await this.n();this.f.dispose(),this.f=a,this.B(a.onDidChangeStorage(s=>this.b.fire({key:s}))),await this.m(a);const i=a.getBoolean(g.IS_NEW_KEY);i===void 0?a.set(g.IS_NEW_KEY,!0):i&&a.set(g.IS_NEW_KEY,!1)}catch(a){this.j.error(`[storage main] initialize(): Unable to init storage due to ${a}`)}finally{this.i=b.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===y.LogLevel.Trace?a=>this.j.trace(a):void 0,logError:a=>this.j.error(a)}}m(a){return a.init()}get items(){return this.f.items}get(a,i){return this.f.get(a,i)}set(a,i){return this.f.set(a,i)}delete(a){return this.f.delete(a)}async close(){const a=new P.StopWatch(!1);await this.s(),a.stop(),a.elapsed()>o.a&&await this.r(a),this.c.fire()}async r(a){if(!!this.path)try{const i=(0,E.top)(Array.from(this.f.items.entries()).map(([c,u])=>({key:c,length:u.length})),(c,u)=>u.length-c.length,5).map(c=>`${c.key}:${c.length}`).join(", "),s=(await this.k.stat(f.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${a.elapsed()}ms, DB size: ${s}b, Large Keys: ${i}`)}catch(i){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async s(){this.g&&await this.g,this.i=b.StorageState.Closed,await this.f.close()}}o.a=2e3;class h extends o{get path(){if(!this.v.useInMemoryStorage)return(0,D.join)(this.u.globalStorageHome.fsPath,h.t)}constructor(a,i,s,c){super(s,c),this.u=a,this.v=i}async n(){return new b.Storage(new v.SQLiteStorageDatabase(this.path??v.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:b.StorageHint.STORAGE_IN_MEMORY})}}h.t="state.vscdb";class p extends h{constructor(a,i,s,c){super(a,i,s,c)}}e.ProfileStorageMain=p;class k extends h{constructor(a,i,s,c){super(i.defaultProfile,a,s,c)}async m(a){await super.m(a),this.z(a)}z(a){a.get(m.firstSessionDateStorageKey,void 0)===void 0&&a.set(m.firstSessionDateStorageKey,new Date().toUTCString());const s=a.get(m.currentSessionDateStorageKey,void 0),c=new Date().toUTCString();a.set(m.lastSessionDateStorageKey,typeof s>"u"?null:s),a.set(m.currentSessionDateStorageKey,c)}}e.ApplicationStorageMain=k;class S extends o{get path(){if(!this.w.useInMemoryStorage)return(0,D.join)(this.y.workspaceStorageHome.fsPath,this.v.id,S.t)}constructor(a,i,s,c,u){super(s,u),this.v=a,this.w=i,this.y=c}async n(){const{storageFilePath:a,wasCreated:i}=await this.C();return new b.Storage(new v.SQLiteStorageDatabase(a,{logging:this.l()}),{hint:this.w.useInMemoryStorage?b.StorageHint.STORAGE_IN_MEMORY:i?b.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:v.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const a=(0,D.join)(this.y.workspaceStorageHome.fsPath,this.v.id),i=(0,D.join)(a,S.t);return await d.Promises.exists(a)?{storageFilePath:i,wasCreated:!1}:(await d.Promises.mkdir(a,{recursive:!0}),this.D(a),{storageFilePath:i,wasCreated:!0})}async D(a){let i;if((0,w.isSingleFolderWorkspaceIdentifier)(this.v)?i={folder:this.v.uri.toString()}:(0,w.isWorkspaceIdentifier)(this.v)&&(i={workspace:this.v.configPath.toString()}),i)try{const s=(0,D.join)(a,S.u);await d.Promises.exists(s)||await d.Promises.writeFile(s,JSON.stringify(i,void 0,2))}catch(s){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${s}`)}}}S.t="state.vscdb",S.u="workspace.json",e.WorkspaceStorageMain=S;class R extends o{get path(){}async n(){return new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=R}),define(ee[270],te([0,1,3,2,95]),function(G,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class C extends M.Disposable{constructor(P,f,d){super(),this.b=P,this.c=f,this.f=d;const b=this.B(new M.MutableDisposable);this.a=this.B(new E.Emitter({onWillAddFirstListener:()=>b.value=this.g(),onDidRemoveLastListener:()=>b.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new M.DisposableStore;return P.add(E.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(f,d)=>(f?f.push(d.key):f=[d.key],f),100)(f=>this.h(f))),P.add(E.Event.debounce(this.b.onDidChangeProfileStorage,(f,d)=>{f||(f=new Map);let b=f.get(d.profile.id);return b||f.set(d.profile.id,b={profile:d.profile,keys:[],storage:d.storage}),b.keys.push(d.key),f},100)(f=>this.i(f))),P}h(P){const f=P.includes(n.TARGET_KEY)?[this.c.defaultProfile]:[],d=[];if(P=P.filter(b=>b!==n.TARGET_KEY),P.length){const b=(0,n.loadKeyTargets)(this.b.applicationStorage.storage);d.push({profile:this.c.defaultProfile,changes:P.map(v=>({key:v,scope:0,target:b[v]}))})}this.j(f,d)}i(P){const f=[],d=new Map;for(const[b,v]of P.entries()){v.keys.includes(n.TARGET_KEY)&&f.push(v.profile);const y=v.keys.filter(g=>g!==n.TARGET_KEY);if(y.length){const g=(0,n.loadKeyTargets)(v.storage.storage);d.set(b,{profile:v.profile,changes:y.map(m=>({key:m,scope:0,target:g[m]}))})}}this.j(f,[...d.values()])}j(P,f){(P.length||f.length)&&this.a.fire({valueChanges:f,targetChanges:P})}listen(P,f,d){switch(f){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${f}`)}async call(P,f){throw new Error(`Call not found: ${f}`)}}e.ProfileStorageChangesListenerChannel=C}),define(ee[271],te([0,1,73,7,33,16,5,236,38,39]),function(G,e,E,M,n,C,D,P,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.ServerUserDataProfilesService=void 0;let b=class extends d.UserDataProfilesService{constructor(g,m,w,o){super(m,w,g,o),this.a=m}L(){return this.r.extUri.joinPath(M.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};b=ve([_(0,f.IUriIdentityService),_(1,n.INativeEnvironmentService),_(2,C.IFileService),_(3,D.ILogService)],b),e.ServerUserDataProfilesService=b;let v=class pt extends b{constructor(g,m,w,o,h){super(m,w,o,h),this.N=g}G(){return(0,E.revive)(this.N.getItem(pt.b,[]))}I(){return(0,E.revive)(this.N.getItem(pt.c,{}))}L(){return this.r.extUri.joinPath(M.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};v=ve([_(0,P.IStateService),_(1,f.IUriIdentityService),_(2,n.INativeEnvironmentService),_(3,C.IFileService),_(4,D.ILogService)],v),e.UserDataProfilesService=v}),define(ee[53],te([0,1,7,33,16,6,5,34,38,39,271]),function(G,e,E,M,n,C,D,P,f,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,C.refineServiceDecorator)(d.IUserDataProfilesService);let v=class at extends b.UserDataProfilesService{constructor(g,m,w,o,h){super(g,m,w,o,h),this.R=g}getAssociatedEmptyWindows(){const g=[];for(const m of this.u.emptyWindows.keys())g.push({id:m});return g}H(g){g.length?this.R.setItem(at.b,g):this.R.removeItem(at.b)}J(g){g.emptyWindows||g.workspaces?this.R.setItem(at.c,g):this.R.removeItem(at.c)}I(){const g="workspaceAndProfileInfo",m=this.R.getItem(g,void 0);if(m){this.R.removeItem(g);const w=m.reduce((o,{workspace:h,profile:p})=>(o[E.URI.revive(h).toString()]=E.URI.revive(p).toString(),o),{});this.R.setItem(at.c,{workspaces:w})}return super.I()}};v=ve([_(0,P.IStateMainService),_(1,f.IUriIdentityService),_(2,M.INativeEnvironmentService),_(3,n.IFileService),_(4,D.ILogService)],v),e.UserDataProfilesMainService=v}),define(ee[96],te([0,1,7,50,3,2,33,16,6,21,5,95,269,39,53,38]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,f.createDecorator)("storageMainService");let o=class extends C.Disposable{constructor(k,S,R,t,a,i){super(),this.c=k,this.f=S,this.g=R,this.h=t,this.i=a,this.j=i,this.a=void 0,this.b=this.B(new n.Emitter),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(k=>{k.window.profile&&this.profileStorage(k.window.profile).init(),k.workspace&&this.workspaceStorage(k.workspace).init()})),this.B(this.h.onWillShutdown(k=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=k.reason,k.join(this.applicationStorage.close());for(const[,S]of this.n)k.join(S.close());for(const[,S]of this.r)k.join(S.close())})),this.B(this.g.onWillCreateProfile(k=>{k.join((async()=>{await this.i.exists(k.profile.globalStorageHome)||await this.i.createFolder(k.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(k=>{const S=this.n.get(k.profile.id);S&&k.join(S.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const k=new y.ApplicationStorageMain(this.k(),this.g,this.c,this.i);return(0,M.once)(k.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),k}profileStorage(k){if((0,v.isProfileUsingDefaultStorage)(k))return this.applicationStorage;let S=this.n.get(k.id);if(!S){this.c.trace(`StorageMainService: creating profile storage (${k.name})`),S=this.p(k),this.n.set(k.id,S);const R=this.B(S.onDidChangeStorage(t=>this.b.fire({...t,storage:S,profile:k})));(0,M.once)(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${k.name})`),this.n.delete(k.id),R.dispose()})}return S}p(k){return this.a===2?new y.InMemoryStorageMain(this.c,this.i):new y.ProfileStorageMain(k,this.k(),this.c,this.i)}workspaceStorage(k){let S=this.r.get(k.id);return S||(this.c.trace(`StorageMainService: creating workspace storage (${k.id})`),S=this.s(k),this.r.set(k.id,S),(0,M.once)(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${k.id})`),this.r.delete(k.id)})),S}s(k){return this.a===2?new y.InMemoryStorageMain(this.c,this.i):new y.WorkspaceStorageMain(k,this.k(),this.c,this.f,this.i)}isUsed(k){const S=E.URI.file(k);for(const R of[this.applicationStorage,...this.n.values(),...this.r.values()])if(!!R.path&&this.j.extUri.isEqualOrParent(E.URI.file(R.path),S))return!0;return!1}};o=ve([_(0,b.ILogService),_(1,D.IEnvironmentService),_(2,m.IUserDataProfilesMainService),_(3,d.ILifecycleMainService),_(4,P.IFileService),_(5,w.IUriIdentityService)],o),e.StorageMainService=o,e.IApplicationStorageMainService=(0,f.createDecorator)("applicationStorageMainService");let h=class extends v.AbstractStorageService{constructor(k,S){super(),this.p=k,this.s=S,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(k){if(k===-1)return this.s.applicationStorage.storage}M(k){if(k===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};h=ve([_(0,g.IUserDataProfilesService),_(1,e.IStorageMainService)],h),e.ApplicationStorageMainService=h}),define(ee[272],te([0,1,2,21,53,29,8,30]),function(G,e,E,M,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let f=class extends E.Disposable{constructor(b,v,y){super(),this.a=v,this.b=y,this.B(b.onWillLoadWindow(g=>{g.reason===2&&this.c(g.window)})),this.B(b.onBeforeCloseWindow(g=>this.c(g))),this.B(new D.RunOnceScheduler(()=>this.g(),30*1e3)).schedule()}async c(b){const v=this.f(b),y=this.a.getProfileForWorkspace(v);y&&((0,C.isEmptyWorkspaceIdentifier)(v)||y.isTransient)&&(this.a.unsetWorkspace(v,y.isTransient),y.isTransient&&await this.a.cleanUpTransientProfiles())}f(b){return b.openedWorkspace??(0,C.toWorkspaceIdentifier)(b.backupPath,b.isExtensionDevelopmentHost)}g(){const b=this.a.getAssociatedEmptyWindows();if(b.length===0)return;const v=this.b.getWindows().map(y=>this.f(y));for(const y of b)v.some(g=>g.id===y.id)||this.a.unsetWorkspace(y,!1)}};f=ve([_(0,M.ILifecycleMainService),_(1,n.IUserDataProfilesMainService),_(2,P.IWindowsMainService)],f),e.UserDataProfilesHandler=f}),define(ee[120],te([0,1,18,7,29]),function(G,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function C(f,d,b){for(const y of f){const g=y.openedWorkspace;if((0,n.isWorkspaceIdentifier)(g)){const m=await b(g);if(m){if(m.folders.some(w=>E.extUriBiasedIgnorePathCase.isEqualOrParent(d,w.uri)))return y}else if(E.extUriBiasedIgnorePathCase.isEqualOrParent(d,g.configPath))return y}}const v=f.filter(y=>(0,n.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqualOrParent(d,y.openedWorkspace.uri));if(v.length)return v.sort((y,g)=>-(y.openedWorkspace.uri.path.length-g.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=C;function D(f,d){for(const b of f)if((0,n.isWorkspaceIdentifier)(b.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.configPath,d)||(0,n.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.uri,d))return b}e.findWindowOnWorkspaceOrFolder=D;function P(f,d){const b=v=>d.some(y=>E.extUriBiasedIgnorePathCase.isEqual(M.URI.file(y),M.URI.file(v)));for(const v of f)if(v.config?.extensionDevelopmentPath?.some(y=>b(y)))return v}e.findWindowOnExtensionDevelopmentPath=P}),define(ee[273],te([0,1,14,2,4,18,7,19,21,5,34,30,118,29]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let m=class wt extends M.Disposable{get state(){return this.b}constructor(S,R,t,a,i){super(),this.g=S,this.h=R,this.i=t,this.j=a,this.k=i,this.b=w(this.h.getItem(wt.a)),this.c=void 0,this.f=!1,this.l()}l(){E.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(S=>this.p(S)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(S=>{S.newCount-S.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(S=>this.p(S))}m(){this.f=!0,this.n()}n(){const S=new Set,R={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!R.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(s=>!s.isExtensionDevelopmentHost)),i&&(R.lastActiveWindow=this.r(i),R.lastActiveWindow.uiState.mode===3&&S.add(R.lastActiveWindow.uiState.display))}const t=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);t&&(R.lastPluginDevelopmentHostWindow=this.r(t),R.lastPluginDevelopmentHostWindow.uiState.mode===3&&(S.has(R.lastPluginDevelopmentHostWindow.uiState.display)?n.isMacintosh&&!t.win?.isSimpleFullScreen()&&(R.lastPluginDevelopmentHostWindow.uiState.mode=1):S.add(R.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(R.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const s=this.r(i);return s.uiState.mode===3&&(S.has(s.uiState.display)?n.isMacintosh&&s.windowId!==R.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(s.uiState.mode=1):S.add(s.uiState.display)),s}));const a=h(R);this.h.setItem(wt.a,a),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",a)}p(S){if(this.i.quitRequested)return;const R=this.r(S);S.isExtensionDevelopmentHost&&!S.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=R:!S.isExtensionDevelopmentHost&&S.openedWorkspace&&this.b.openedWindows.forEach(t=>{const a=(0,g.isWorkspaceIdentifier)(S.openedWorkspace)&&t.workspace?.id===S.openedWorkspace.id,i=(0,g.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&t.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(t.folderUri,S.openedWorkspace.uri);(a||i)&&(t.uiState=R.uiState)}),this.g.getWindowCount()===1&&(this.c=R)}r(S){return{windowId:S.id,workspace:(0,g.isWorkspaceIdentifier)(S.openedWorkspace)?S.openedWorkspace:void 0,folderUri:(0,g.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)?S.openedWorkspace.uri:void 0,backupPath:S.backupPath,remoteAuthority:S.remoteAuthority,uiState:S.serializeWindowState()}}getNewWindowState(S){const R=this.s(S),t=this.k.getValue("window");if(R.mode===3){let a;R.hasDefaultState?a=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):a=!!(this.i.wasRestarted||t?.restoreFullscreen),a||(R.mode=1)}return R}s(S){const R=this.g.getLastActiveWindow();if(!S.extensionTestsPath){if(!!S.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const u=S.workspace;if((0,g.isWorkspaceIdentifier)(u)){const l=this.state.openedWindows.filter(I=>I.workspace&&I.workspace.id===u.id).map(I=>I.uiState);if(l.length)return l[0]}if((0,g.isSingleFolderWorkspaceIdentifier)(u)){const l=this.state.openedWindows.filter(I=>I.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(I.folderUri,u.uri)).map(I=>I.uiState);if(l.length)return l[0]}else if(S.backupPath){const l=this.state.openedWindows.filter(I=>I.backupPath===S.backupPath).map(I=>I.uiState);if(l.length)return l[0]}const r=this.c||this.state.lastActiveWindow;if(!R&&r)return r.uiState}let t;const a=E.screen.getAllDisplays();if(a.length===1)t=a[0];else{if(n.isMacintosh){const u=E.screen.getCursorScreenPoint();t=E.screen.getDisplayNearestPoint(u)}!t&&R&&(t=E.screen.getDisplayMatching(R.getBounds())),t||(t=E.screen.getPrimaryDisplay()||a[0])}let i=(0,y.defaultWindowState)();i.x=Math.round(t.bounds.x+t.bounds.width/2-i.width/2),i.y=Math.round(t.bounds.y+t.bounds.height/2-i.height/2);const s=this.k.getValue("window");let c=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")i.mode=0,c=!1;else if(s.newWindowDimensions==="fullscreen")i.mode=3,c=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&R){const u=R.serializeWindowState();u.mode===3?i.mode=3:i=u,c=i.mode!==3&&s.newWindowDimensions==="offset"}}return c&&(i=this.t(i)),i.hasDefaultState=!0,i}t(S){if(this.g.getWindows().length===0)return S;S.x=typeof S.x=="number"?S.x:0,S.y=typeof S.y=="number"?S.y:0;const R=this.g.getWindows().map(t=>t.getBounds());for(;R.some(t=>t.x===S.x||t.y===S.y);)S.x+=30,S.y+=30;return S}};m.a="windowsState",m=ve([_(0,v.IWindowsMainService),_(1,b.IStateMainService),_(2,f.ILifecycleMainService),_(3,d.ILogService),_(4,P.IConfigurationService)],m),e.WindowsStateHandler=m;function w(k){const S={openedWindows:[]},R=k||{openedWindows:[]};return R.lastActiveWindow&&(S.lastActiveWindow=o(R.lastActiveWindow)),R.lastPluginDevelopmentHostWindow&&(S.lastPluginDevelopmentHostWindow=o(R.lastPluginDevelopmentHostWindow)),Array.isArray(R.openedWindows)&&(S.openedWindows=R.openedWindows.map(t=>o(t))),S}e.restoreWindowsState=w;function o(k){const S={uiState:k.uiState};return k.backupPath&&(S.backupPath=k.backupPath),k.remoteAuthority&&(S.remoteAuthority=k.remoteAuthority),k.folder&&(S.folderUri=D.URI.parse(k.folder)),k.workspaceIdentifier&&(S.workspace={id:k.workspaceIdentifier.id,configPath:D.URI.parse(k.workspaceIdentifier.configURIPath)}),S}function h(k){return{lastActiveWindow:k.lastActiveWindow&&p(k.lastActiveWindow),lastPluginDevelopmentHostWindow:k.lastPluginDevelopmentHostWindow&&p(k.lastPluginDevelopmentHostWindow),openedWindows:k.openedWindows.map(S=>p(S))}}e.getWindowsStateStoreData=h;function p(k){return{workspaceIdentifier:k.workspace&&{id:k.workspace.id,configURIPath:k.workspace.configPath.toString()},folder:k.folderUri&&k.folderUri.toString(),backupPath:k.backupPath,remoteAuthority:k.remoteAuthority,uiState:k.uiState}}}),define(ee[97],te([0,1,32,43,125,45,15,9,4,18,7,6,56,29]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,v.createDecorator)("workspacesService");function m(I){return I.hasOwnProperty("workspace")}e.isRecentWorkspace=m;function w(I){return I.hasOwnProperty("folderUri")}e.isRecentFolder=w;function o(I){return I.hasOwnProperty("fileUri")}e.isRecentFile=o;function h(I){return p(I)||k(I)}e.isStoredWorkspaceFolder=h;function p(I){const A=I;return typeof A?.path=="string"&&(!A.name||typeof A.name=="string")}function k(I){const A=I;return typeof A?.uri=="string"&&(!A.name||typeof A.name=="string")}function S(I,A,O,N,X){if(I.scheme!==N.scheme)return{name:O,uri:I.toString(!0)};let V=A?void 0:X.relativePath(N,I);if(V!==void 0)V.length===0?V=".":f.isWindows&&(V=R(V));else if(I.scheme===D.Schemas.file)V=I.fsPath,f.isWindows&&(V=R(V));else if(X.isEqualAuthority(I.authority,N.authority))V=I.path;else return{name:O,uri:I.toString(!0)};return{name:O,path:V}}e.getStoredWorkspaceFolder=S;function R(I){return I=(0,C.normalizeDriveLetter)(I),(0,E.isUNC)(I)||(I=(0,E.toSlashes)(I)),I}function t(I,A,O){const N=[],X=new Set,V=O.dirname(A);for(const K of I){let ie;if(p(K))K.path&&(ie=O.resolvePath(V,K.path));else if(k(K))try{ie=b.URI.parse(K.uri),ie.path[0]!==P.posix.sep&&(ie=ie.with({path:P.posix.sep+ie.path}))}catch(re){console.warn(re)}if(ie){const re=O.getComparisonKey(ie);if(!X.has(re)){X.add(re);const ce=K.name||O.basenameOrAuthority(ie);N.push(new g.WorkspaceFolder({uri:ie,name:ce,index:N.length},K))}}}return N}e.toWorkspaceFolders=t;function a(I,A,O,N,X){const V=i(A,I),K=X.dirname(A),ie=X.dirname(N),re=[];for(const x of V.folders){const F=p(x)?X.resolvePath(K,x.path):b.URI.parse(x.uri);let W;O?W=!1:W=!p(x)||(0,P.isAbsolute)(x.path),re.push(S(F,W,x.name,ie,X))}const ce={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},fe=n.setProperty(I,["folders"],re,ce);let ge=n.applyEdits(I,fe);return(0,d.isEqualAuthority)(V.remoteAuthority,(0,y.getRemoteAuthority)(N))&&(ge=n.applyEdits(ge,n.removeProperty(ge,["remoteAuthority"],ce))),ge}e.rewriteWorkspaceFileForNewLocation=a;function i(I,A){const O=M.parse(A);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter(N=>h(N));else throw new Error(`${I} looks like an invalid workspace file.`);return O}function s(I){return I.workspace&&typeof I.workspace=="object"&&typeof I.workspace.id=="string"&&typeof I.workspace.configPath=="string"}function c(I){return typeof I.folderUri=="string"}function u(I){return typeof I.fileUri=="string"}function r(I,A){const O={workspaces:[],files:[]};if(I){const N=function(V,K){for(let ie=0;ie<V.length;ie++)try{K(V[ie],ie)}catch(re){A.warn(`Error restoring recent entry ${JSON.stringify(V[ie])}: ${re.toString()}. Skip entry.`)}},X=I;Array.isArray(X.entries)&&N(X.entries,V=>{const K=V.label,ie=V.remoteAuthority;s(V)?O.workspaces.push({label:K,remoteAuthority:ie,workspace:{id:V.workspace.id,configPath:b.URI.parse(V.workspace.configPath)}}):c(V)?O.workspaces.push({label:K,remoteAuthority:ie,folderUri:b.URI.parse(V.folderUri)}):u(V)&&O.files.push({label:K,remoteAuthority:ie,fileUri:b.URI.parse(V.fileUri)})})}return O}e.restoreRecentlyOpened=r;function l(I){const A={entries:[]};for(const O of I.workspaces)w(O)?A.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):A.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of I.files)A.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return A}e.toStoreData=l}),define(ee[98],te([0,1,81,15,4,18]),function(G,e,E,M,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function D(d){function b(){let v=d.scheme===M.Schemas.file?(0,C.originalFSPath)(d):d.toString();return n.isLinux||(v=v.toLowerCase()),(0,E.createHash)("md5").update(v).digest("hex")}return{id:b(),configPath:d}}e.getWorkspaceIdentifier=D;function P(d,b){function v(){if(d.scheme!==M.Schemas.file)return(0,E.createHash)("md5").update(d.toString()).digest("hex");if(!b)return;let g;return n.isLinux?g=b.ino:n.isMacintosh?g=b.birthtime.getTime():n.isWindows&&(typeof b.birthtimeMs=="number"?g=Math.floor(b.birthtimeMs):g=b.birthtime.getTime()),(0,E.createHash)("md5").update(d.fsPath).update(g?String(g):"").digest("hex")}const y=v();if(typeof y=="string")return{id:y,uri:d}}e.getSingleFolderWorkspaceIdentifier=P;function f(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=f}),define(ee[274],te([0,1,81,32,15,9,4,18,23,183,19,28,34,16,5,182,29,98]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g,m,w,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let p=class vt{constructor(S,R,t,a){this.j=S,this.k=R,this.l=t,this.m=a,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=P.extUriBiasedIgnorePathCase,this.i={isEqual:(i,s)=>(0,M.isEqual)(i,s,!D.isLinux)}}async initialize(){const S=this.m.getItem(vt.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(S.emptyWindows),this.d=await this.u((0,d.deserializeWorkspaceInfos)(S)),this.e=await this.v((0,d.deserializeFolderInfos)(S)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==g.HotExitConfiguration.OFF}q(){return this.s()===g.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||g.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(S,R){this.d.some(a=>S.workspace.id===a.workspace.id)||(this.d.push(S),this.C());const t=(0,C.join)(this.c,S.workspace.id);return R?this.t(t,R).then(()=>t):t}async t(S,R){if(await f.Promises.exists(S)&&await this.z(S),await f.Promises.exists(R))try{await f.Promises.rename(R,S)}catch(t){this.l.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(S){return this.e.some(R=>this.h.isEqual(S.folderUri,R.folderUri))||(this.e.push(S),this.C()),(0,C.join)(this.c,this.D(S))}registerEmptyWindowBackup(S){return this.g.some(R=>!!R.backupFolder&&this.i.isEqual(R.backupFolder,S.backupFolder))||(this.g.push(S),this.C()),(0,C.join)(this.c,S.backupFolder)}async u(S){if(!Array.isArray(S))return[];const R=new Set,t=[];for(const a of S){const i=a.workspace;if(!(0,o.isWorkspaceIdentifier)(i))return[];if(!R.has(i.id)){R.add(i.id);const s=(0,C.join)(this.c,i.id);await this.B(s)?i.configPath.scheme!==n.Schemas.file||await f.Promises.exists(i.configPath.fsPath)?t.push(a):await this.z(s):await this.x(s)}}return t}async v(S){if(!Array.isArray(S))return[];const R=[],t=new Set;for(const a of S){const i=a.folderUri,s=this.h.getComparisonKey(i);if(!t.has(s)){t.add(s);const c=(0,C.join)(this.c,this.D(a));await this.B(c)?i.scheme!==n.Schemas.file||await f.Promises.exists(i.fsPath)?R.push(a):await this.z(c):await this.x(c)}}return R}async w(S){if(!Array.isArray(S))return[];const R=[],t=new Set;for(const a of S){const i=a.backupFolder;if(typeof i!="string")return[];if(!t.has(i)){t.add(i);const s=(0,C.join)(this.c,i);await this.B(s)?R.push(a):await this.x(s)}}return R}async x(S){try{await f.Promises.rm(S,f.RimRafMode.MOVE)}catch(R){this.l.error(`Backup: Could not delete stale backup: ${R.toString()}`)}}y(){let S=(0,h.createEmptyWorkspaceIdentifier)();for(;this.g.some(R=>!!R.backupFolder&&this.i.isEqual(R.backupFolder,S.id));)S=(0,h.createEmptyWorkspaceIdentifier)();return{backupFolder:S.id}}async z(S){const R=this.y(),t=(0,C.join)(this.c,R.backupFolder);try{await f.Promises.rename(S,t)}catch(a){return this.l.error(`Backup: Could not rename backup folder: ${a.toString()}`),!1}return this.g.push(R),!0}async getDirtyWorkspaces(){const S=[];for(const R of this.d)await this.A(R)&&S.push(R);for(const R of this.e)await this.A(R)&&S.push(R);return S}A(S){let R;return(0,d.isEmptyWindowBackupInfo)(S)?R=(0,C.join)(this.c,S.backupFolder):(0,w.isFolderBackupInfo)(S)?R=(0,C.join)(this.c,this.D(S)):R=(0,C.join)(this.c,S.workspace.id),this.B(R)}async B(S){try{const R=await f.Promises.readdir(S);for(const t of R)try{if((await f.Promises.readdir((0,C.join)(S,t))).length>0)return!0}catch{}}catch{}return!1}C(){const S={workspaces:this.d.map(({workspace:R,remoteAuthority:t})=>{const a={id:R.id,configURIPath:R.configPath.toString()};return t&&(a.remoteAuthority=t),a}),folders:this.e.map(({folderUri:R,remoteAuthority:t})=>{const a={folderUri:R.toString()};return t&&(a.remoteAuthority=t),a}),emptyWindows:this.g.map(({backupFolder:R,remoteAuthority:t})=>{const a={backupFolder:R};return t&&(a.remoteAuthority=t),a})};this.m.setItem(vt.a,S)}D(S){const R=S.folderUri;let t;return R.scheme===n.Schemas.file?t=D.isLinux?R.fsPath:R.fsPath.toLowerCase():t=R.toString().toLowerCase(),(0,E.createHash)("md5").update(t).digest("hex")}};p.a="backupWorkspaces",p=ve([_(0,v.IEnvironmentMainService),_(1,b.IConfigurationService),_(2,m.ILogService),_(3,y.IStateMainService)],p),e.BackupMainService=p}),define(ee[54],te([0,1,14,3,43,2,15,9,18,10,23,181,63,48,58,28,6,5,20,53,120,29,97,98]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g,m,w,o,h,p,k,S,R,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,o.createDecorator)("workspacesManagementMainService");let i=class extends C.Disposable{constructor(c,u,r,l,I,A){super(),this.g=c,this.h=u,this.i=r,this.j=l,this.k=I,this.l=A,this.a=this.B(new M.Emitter),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new M.Emitter),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const c=(await b.Promises.readdir(this.c.fsPath)).map(u=>(0,f.joinPath)(this.c,u,R.UNTITLED_WORKSPACE_NAME));for(const u of c){const r=(0,a.getWorkspaceIdentifier)(u),l=await this.resolveLocalWorkspace(u);l?this.f.push({workspace:r,remoteAuthority:l.remoteAuthority}):await this.deleteUntitledWorkspace(r)}}catch(c){c.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${c}).`)}}resolveLocalWorkspace(c){return this.m(c,u=>b.Promises.readFile(u,"utf8"))}m(c,u){if(!!this.n(c)&&c.scheme===D.Schemas.file)try{const r=u(c.fsPath);return r instanceof Promise?r.then(l=>this.p(c,l),l=>{}):this.p(c,r)}catch{return}}n(c){return(0,R.isUntitledWorkspace)(c,this.g)||(0,R.hasWorkspaceFileExtension)(c)}p(c,u){try{const r=this.r(c,u),l=(0,a.getWorkspaceIdentifier)(c);return{id:l.id,configPath:l.configPath,folders:(0,t.toWorkspaceFolders)(r.folders,l.configPath,f.extUriBiasedIgnorePathCase),remoteAuthority:r.remoteAuthority,transient:r.transient}}catch(r){this.h.warn(r.toString())}}r(c,u){const r=(0,n.parse)(u);if(r&&Array.isArray(r.folders))r.folders=r.folders.filter(l=>(0,t.isStoredWorkspaceFolder)(l));else throw new Error(`${c.toString(!0)} looks like an invalid workspace file.`);return r}async createUntitledWorkspace(c,u){const{workspace:r,storedWorkspace:l}=this.s(c,u),I=r.configPath.fsPath;return await b.Promises.mkdir((0,P.dirname)(I),{recursive:!0}),await b.Promises.writeFile(I,JSON.stringify(l,null,"	")),this.f.push({workspace:r,remoteAuthority:u}),r}s(c=[],u){const r=(Date.now()+Math.round(Math.random()*1e3)).toString(),l=(0,f.joinPath)(this.c,r),I=(0,f.joinPath)(l,R.UNTITLED_WORKSPACE_NAME),A=[];for(const O of c)A.push((0,t.getStoredWorkspaceFolder)(O.uri,!0,O.name,l,f.extUriBiasedIgnorePathCase));return{workspace:(0,a.getWorkspaceIdentifier)(I),storedWorkspace:{folders:A,remoteAuthority:u}}}async getWorkspaceIdentifier(c){return(0,a.getWorkspaceIdentifier)(c)}isUntitledWorkspace(c){return(0,R.isUntitledWorkspace)(c.configPath,this.g)}async deleteUntitledWorkspace(c){!this.isUntitledWorkspace(c)||(await this.t(c),this.i.isEnabled()&&this.i.unsetWorkspace(c),this.a.fire(c))}async t(c){const u=(0,f.originalFSPath)(c.configPath);try{await b.Promises.rm((0,P.dirname)(u));const r=(0,P.join)(this.g.workspaceStorageHome.fsPath,c.id);await b.Promises.exists(r)&&await b.Promises.writeFile((0,P.join)(r,"obsolete"),""),this.f=this.f.filter(l=>l.workspace.id!==c.id)}catch(r){this.h.warn(`Unable to delete untitled workspace ${u} (${r}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(c,u,r){if(!c||!c.win||!c.isReady||!await this.u(c,u,r))return;const I=await this.v(c,(0,a.getWorkspaceIdentifier)(r));if(!!I)return this.b.fire({window:c,workspace:I.workspace}),I}async u(c,u,r){return r?(0,R.isWorkspaceIdentifier)(c.openedWorkspace)&&f.extUriBiasedIgnorePathCase.isEqual(c.openedWorkspace.configPath,r)?!1:(0,S.findWindowOnWorkspaceOrFolder)(u,r)?(await this.k.showMessageBox((0,g.massageMessageBoxOptions)({type:"info",buttons:[(0,v.localize)(0,null)],message:(0,v.localize)(1,null,(0,f.basename)(r)),detail:(0,v.localize)(2,null)},this.l).options,(0,d.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),!1):!0:!0}async v(c,u){if(!c.config)return;c.focus();let r;return c.config.extensionDevelopmentPath||(c.config.backupPath?r=await this.j.registerWorkspaceBackup({workspace:u,remoteAuthority:c.remoteAuthority},c.config.backupPath):r=this.j.registerWorkspaceBackup({workspace:u,remoteAuthority:c.remoteAuthority})),(0,R.isWorkspaceIdentifier)(c.openedWorkspace)&&this.isUntitledWorkspace(c.openedWorkspace)&&await this.deleteUntitledWorkspace(c.openedWorkspace),c.config.workspace=u,c.config.backupPath=r,{workspace:u,backupPath:r}}};i=ve([_(0,w.IEnvironmentMainService),_(1,h.ILogService),_(2,k.IUserDataProfilesMainService),_(3,y.IBackupMainService),_(4,m.IDialogMainService),_(5,p.IProductService)],i),e.WorkspacesManagementMainService=i}),define(ee[121],te([0,1,14,42,22,6,30,29,54,10,5]),function(G,e,E,M,n,C,D,P,f,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,C.createDecorator)(e.ID);let v=class{constructor(g,m,w){this.a=g,this.b=m,this.c=w}async getRemoteDiagnostics(g){const m=this.a.getWindows();return(await Promise.all(m.map(async o=>{const h=o.remoteAuthority;if(!h)return;const p=`vscode:getDiagnosticInfoResponse${o.id}`,k={includeProcesses:g.includeProcesses,folders:g.includeWorkspaceMetadata?await this.f(o):void 0};return new Promise(S=>{o.sendWhenReady("vscode:getDiagnosticInfo",n.CancellationToken.None,{replyChannel:p,args:k}),M.validatedIpcMain.once(p,(R,t)=>{t||S({hostName:h,errorMessage:`Unable to resolve connection to '${h}'.`}),S(t)}),setTimeout(()=>{S({hostName:h,errorMessage:`Connection to '${h}' could not be established`})},5e3)})}))).filter(o=>!!o)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const g=[];for(const m of E.BrowserWindow.getAllWindows()){const w=this.a.getWindowById(m.id);w?g.push(await this.d(w)):g.push(this.e(m))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:g,screenReader:!!E.app.accessibilitySupportEnabled,gpuFeatureStatus:E.app.getGPUFeatureStatus()}}async d(g){const m=await this.f(g),w=(0,d.assertIsDefined)(g.win);return this.e(w,m,g.remoteAuthority)}e(g,m=[],w){return{pid:g.webContents.getOSProcessId(),title:g.getTitle(),folderURIs:m,remoteAuthority:w}}async f(g){const m=[],w=g.openedWorkspace;if((0,P.isSingleFolderWorkspaceIdentifier)(w))m.push(w.uri);else if((0,P.isWorkspaceIdentifier)(w)){const o=await this.b.resolveLocalWorkspace(w.configPath);o&&o.folders.forEach(p=>{m.push(p.uri)})}return m}};v=ve([_(0,D.IWindowsMainService),_(1,f.IWorkspacesManagementMainService),_(2,b.ILogService)],v),e.DiagnosticsMainService=v}),define(ee[59],te([0,1,46,14,26,146,55,3,2,15,9,4,7,102,85,23,100,171,48,58,28,6,21,5,20,69,30,29,54,17,230,223,34]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g,m,w,o,h,p,k,S,R,t,a,i,s,c,u,r,l,I,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,R.createDecorator)("nativeHostMainService");let N=class extends f.Disposable{constructor(V,K,ie,re,ce,fe,ge,x,F,W){super(),this.a=V,this.b=K,this.c=ie,this.f=re,this.g=ce,this.h=fe,this.i=ge,this.j=x,this.k=F,this.l=W,this.onDidOpenWindow=P.Event.map(this.b.onDidOpenWindow,z=>z.id),this.onDidTriggerSystemContextMenu=P.Event.filter(P.Event.map(this.b.onDidTriggerSystemContextMenu,({window:z,x:J,y:ne})=>({windowId:z.id,x:J,y:ne})),({windowId:z})=>!!this.b.getWindowById(z)),this.onDidMaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(M.app,"browser-window-maximize",(z,J)=>J.id),z=>!!this.b.getWindowById(z)),this.onDidUnmaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(M.app,"browser-window-unmaximize",(z,J)=>J.id),z=>!!this.b.getWindowById(z)),this.onDidBlurWindow=P.Event.filter(P.Event.fromNodeEventEmitter(M.app,"browser-window-blur",(z,J)=>J.id),z=>!!this.b.getWindowById(z)),this.onDidFocusWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.b.onDidChangeWindowsCount,()=>this.b.getLastActiveWindow()),z=>!!z),z=>z.id),P.Event.filter(P.Event.fromNodeEventEmitter(M.app,"browser-window-focus",(z,J)=>J.id),z=>!!this.b.getWindowById(z))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(M.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.m=this.B(new P.Emitter),this.onDidChangePassword=this.m.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(M.screen,"display-metrics-changed",(z,J,ne)=>ne),z=>!(Array.isArray(z)&&z.length===1&&z[0]==="workArea")),P.Event.fromNodeEventEmitter(M.screen,"display-added"),P.Event.fromNodeEventEmitter(M.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.b.getWindows().map(K=>({id:K.id,workspace:K.openedWorkspace??(0,u.toWorkspaceIdentifier)(K.backupPath,K.isExtensionDevelopmentHost),title:K.win?.getTitle()??"",filename:K.getRepresentedFilename(),dirty:K.isDocumentEdited()}))}async getWindowCount(V){return this.b.getWindowCount()}async getActiveWindowId(V){const K=M.BrowserWindow.getFocusedWindow()||this.b.getLastActiveWindow();if(K)return K.id}openWindow(V,K,ie){return Array.isArray(K)?this.n(V,K,ie):this.p(V,K)}async n(V,K,ie=Object.create(null)){K.length>0&&await this.b.open({context:5,contextWindowId:V,urisToOpen:K,cli:this.g.args,forceNewWindow:ie.forceNewWindow,forceReuseWindow:ie.forceReuseWindow,preferNewWindow:ie.preferNewWindow,diffMode:ie.diffMode,mergeMode:ie.mergeMode,addMode:ie.addMode,gotoLineMode:ie.gotoLineMode,noRecentEntry:ie.noRecentEntry,waitMarkerFileURI:ie.waitMarkerFileURI,remoteAuthority:ie.remoteAuthority||void 0,forceProfile:ie.forceProfile,forceTempProfile:ie.forceTempProfile})}async p(V,K){await this.b.openEmptyWindow({context:5,contextWindowId:V},K)}async toggleFullScreen(V){this.w(V)?.toggleFullScreen()}async handleTitleDoubleClick(V){this.w(V)?.handleTitleDoubleClick()}async isMaximized(V){const K=this.w(V);return K?.win?K.win.isMaximized():!1}async maximizeWindow(V){const K=this.w(V);K?.win&&K.win.maximize()}async unmaximizeWindow(V){const K=this.w(V);K?.win&&K.win.unmaximize()}async minimizeWindow(V){const K=this.w(V);K?.win&&K.win.minimize()}async updateWindowControls(V,K){const ie=this.w(V);ie&&ie.updateWindowControls(K)}async focusWindow(V,K){K&&typeof K.windowId=="number"&&(V=K.windowId),this.w(V)?.focus({force:K?.force??!1})}async setMinimumSize(V,K,ie){const re=this.w(V);if(re?.win){const[ce,fe]=re.win.getSize(),[ge,x]=re.win.getMinimumSize(),[F,W]=[K??ge,ie??x],[z,J]=[Math.max(ce,F),Math.max(fe,W)];(ge!==F||x!==W)&&re.win.setMinimumSize(F,W),(ce!==z||fe!==J)&&re.win.setSize(z,J)}}async saveWindowSplash(V,K){this.j.saveWindowSplash(V,K)}async installShellCommand(V){const{source:K,target:ie}=await this.r();try{const{symbolicLink:re}=await w.SymlinkSupport.stat(K);if(re&&!re.dangling){const ce=await(0,g.realpath)(K);if(ie===ce)return}await w.Promises.unlink(K)}catch(re){if(re.code!=="ENOENT")throw re}try{await w.Promises.symlink(ie,K)}catch(re){if(re.code!=="EACCES"&&re.code!=="ENOENT")throw re;const{options:ce,buttonIndeces:fe}=(0,p.massageMessageBoxOptions)({type:"info",message:(0,h.localize)(0,null,this.i.nameShort),buttons:[(0,h.localize)(1,null),(0,h.localize)(2,null)]},this.i),{response:ge}=await this.showMessageBox(V,ce);if(fe[ge]===0)try{const x=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${ie}' '${K}'\\" with administrator privileges"`;await(0,C.promisify)(E.exec)(x)}catch{throw new Error((0,h.localize)(3,null,K))}}}async uninstallShellCommand(V){const{source:K}=await this.r();try{await w.Promises.unlink(K)}catch(ie){switch(ie.code){case"EACCES":{const{options:re,buttonIndeces:ce}=(0,p.massageMessageBoxOptions)({type:"info",message:(0,h.localize)(4,null,this.i.nameShort),buttons:[(0,h.localize)(5,null),(0,h.localize)(6,null)]},this.i),{response:fe}=await this.showMessageBox(V,re);if(ce[fe]===0)try{const ge=`osascript -e "do shell script \\"rm '${K}'\\" with administrator privileges"`;await(0,C.promisify)(E.exec)(ge)}catch{throw new Error((0,h.localize)(7,null,K))}break}case"ENOENT":break;default:throw ie}}}async r(){const V=(0,b.resolve)(this.g.appRoot,"bin","code"),K=`/usr/local/bin/${this.i.applicationName}`;if(!await w.Promises.exists(V))throw new Error((0,h.localize)(8,null,V));return{source:K,target:V}}async showMessageBox(V,K){return this.c.showMessageBox(K,this.s(V))}async showSaveDialog(V,K){return this.c.showSaveDialog(K,this.s(V))}async showOpenDialog(V,K){return this.c.showOpenDialog(K,this.s(V))}s(V){const K=this.w(V);if(K?.win)return K.win}async pickFileFolderAndOpen(V,K){const ie=await this.c.pickFileFolder(K);ie&&await this.t(await Promise.all(ie.map(async re=>await w.SymlinkSupport.existsDirectory(re)?{folderUri:y.URI.file(re)}:{fileUri:y.URI.file(re)})),K,V)}async pickFolderAndOpen(V,K){const ie=await this.c.pickFolder(K);ie&&await this.t(ie.map(re=>({folderUri:y.URI.file(re)})),K,V)}async pickFileAndOpen(V,K){const ie=await this.c.pickFile(K);ie&&await this.t(ie.map(re=>({fileUri:y.URI.file(re)})),K,V)}async pickWorkspaceAndOpen(V,K){const ie=await this.c.pickWorkspace(K);ie&&await this.t(ie.map(re=>({workspaceUri:y.URI.file(re)})),K,V)}async t(V,K,ie){await this.b.open({context:3,contextWindowId:ie,cli:this.g.args,urisToOpen:V,forceNewWindow:K.forceNewWindow})}async showItemInFolder(V,K){M.shell.showItemInFolder(K)}async setRepresentedFilename(V,K){this.w(V)?.setRepresentedFilename(K)}async setDocumentEdited(V,K){this.w(V)?.setDocumentEdited(K)}async openExternal(V,K){return v.isLinuxSnap?this.u(K):M.shell.openExternal(K),!0}u(V){const K=process.env.GDK_PIXBUF_MODULE_FILE,ie=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,M.shell.openExternal(V),process.env.GDK_PIXBUF_MODULE_FILE=K,process.env.GDK_PIXBUF_MODULEDIR=ie}moveItemToTrash(V,K){return M.shell.trashItem(K)}async isAdmin(){let V;return v.isWindows?V=(await new Promise((K,ie)=>{G(["native-is-elevated"],K,ie)}))():V=process.getuid()===0,V}async writeElevated(V,K,ie,re){const ce=await new Promise((fe,ge)=>{G(["@vscode/sudo-prompt"],fe,ge)});return new Promise((fe,ge)=>{const x=[`"${this.v}"`];re?.unlock&&x.push("--file-chmod"),x.push("--file-write",`"${K.fsPath}"`,`"${ie.fsPath}"`);const F={name:this.i.nameLong.replace("-",""),icns:v.isMacintosh&&this.g.isBuilt?(0,b.join)((0,b.dirname)(this.g.appRoot),`${this.i.nameShort}.icns`):void 0};ce.exec(x.join(" "),F,(W,z,J)=>{z&&this.h.trace(`[sudo-prompt] received stdout: ${z}`),J&&this.h.trace(`[sudo-prompt] received stderr: ${J}`),W?ge(W):fe(void 0)})})}get v(){return v.isWindows?this.g.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.i.applicationName}.cmd`):(0,b.join)(this.g.appRoot,"scripts","code-cli.bat"):v.isLinux?this.g.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.i.applicationName}`):(0,b.join)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,b.join)(this.g.appRoot,"bin","code"):(0,b.join)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,n.totalmem)(),freemem:(0,n.freemem)(),loadavg:(0,n.loadavg)()}}async getOSProperties(){return{arch:(0,n.arch)(),platform:(0,n.platform)(),release:(0,n.release)(),type:(0,n.type)(),cpus:(0,n.cpus)()}}async getOSVirtualMachineHint(){return m.virtualMachineHint.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return v.isWindows&&(0,I.hasWSLFeatureInstalled)()}async killProcess(V,K,ie){process.kill(K,ie)}async readClipboardText(V,K){return M.clipboard.readText(K)}async writeClipboardText(V,K,ie){return M.clipboard.writeText(K,ie)}async readClipboardFindText(V){return M.clipboard.readFindText()}async writeClipboardFindText(V,K){return M.clipboard.writeFindText(K)}async writeClipboardBuffer(V,K,ie,re){return M.clipboard.writeBuffer(K,Buffer.from(ie.buffer),re)}async readClipboardBuffer(V,K){return l.VSBuffer.wrap(M.clipboard.readBuffer(K))}async hasClipboard(V,K,ie){return M.clipboard.has(K,ie)}async newWindowTab(){await this.b.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){M.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){M.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){M.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){M.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){M.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(V,K){this.w(V)?.updateTouchBar(K)}async notifyReady(V){this.w(V)?.setReady()}async relaunch(V,K){return this.f.relaunch(K)}async reload(V,K){const ie=this.w(V);if(ie){if((0,u.isWorkspaceIdentifier)(ie.openedWorkspace)){const re=ie.openedWorkspace.configPath;if(re.scheme===d.Schemas.file&&(await this.l.resolveLocalWorkspace(re))?.transient)return this.openWindow(ie.id,{forceReuseWindow:!0})}return this.f.reload(ie,K?.disableExtensions!==void 0?{_:[],"disable-extensions":K.disableExtensions}:void 0)}}async closeWindow(V){this.closeWindowById(V,V)}async closeWindowById(V,K){const ie=this.w(K);if(ie?.win)return ie.win.close()}async quit(V){const K=this.b.getLastActiveWindow();K?.isExtensionDevelopmentHost&&this.b.getWindowCount()>1&&K.win?K.win.close():this.f.quit()}async exit(V,K){await this.f.kill(K)}async resolveProxy(V,K){const re=this.w(V)?.win?.webContents?.session;if(re)return re.resolveProxy(K)}findFreePort(V,K,ie,re,ce=1){return(0,o.findFreePort)(K,ie,re,ce)}async openDevTools(V,K){const ie=this.w(V);ie?.win&&ie.win.webContents.openDevTools(K)}async toggleDevTools(V){const K=this.w(V);K?.win&&K.win.webContents.toggleDevTools()}async sendInputEvent(V,K){const ie=this.w(V);ie?.win&&(K.type==="mouseDown"||K.type==="mouseUp")&&ie.win.webContents.sendInputEvent(K)}async enableSandbox(V,K){K?this.k.setItem("window.experimental.useSandbox",!0):this.k.removeItem("window.experimental.useSandbox")}async toggleSharedProcessWindow(){return this.a.toggle()}async profileRenderer(V,K,ie){const re=this.w(V);if(!re||!re.win)throw new Error;return await new A.WindowProfiler(re.win,K,this.h).inspect(ie)}async windowsGetStringRegKey(V,K,ie,re){if(!v.isWindows)return;const ce=await new Promise((fe,ge)=>{G(["@vscode/windows-registry"],fe,ge)});try{return ce.GetStringRegKey(K,ie,re)}catch{return}}w(V){if(typeof V=="number")return this.b.getWindowById(V)}};ve([D.memoize],N.prototype,"v",null),N=ve([_(1,c.IWindowsMainService),_(2,k.IDialogMainService),_(3,t.ILifecycleMainService),_(4,S.IEnvironmentMainService),_(5,a.ILogService),_(6,i.IProductService),_(7,s.IThemeMainService),_(8,O.IStateMainService),_(9,r.IWorkspacesManagementMainService)],N),e.NativeHostMainService=N}),define(ee[275],te([0,1,14,42,26,2,15,4,103,169,88,121,58,28,6,5,59,66,20,67,77,32,10,34,48]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g,m,w,o,h,p,k,S,R,t,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,m.createDecorator)("issueMainService");const s="issue.processExplorerWindowState";let c=class kt{constructor(l,I,A,O,N,X,V,K,ie,re){this.g=l,this.h=I,this.i=A,this.j=O,this.k=N,this.l=X,this.m=V,this.n=K,this.o=ie,this.p=re,this.b=null,this.c=null,this.d=null,this.f=null,this.q()}q(){M.validatedIpcMain.on("vscode:issueSystemInfoRequest",async l=>{const[I,A]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),O=await this.j.getSystemInfo(I,A);this.r(l,"vscode:issueSystemInfoResponse",O)}),M.validatedIpcMain.on("vscode:listProcesses",async l=>{const I=[];try{I.push({name:(0,d.localize)(0,null),rootProcess:await(0,f.listProcesses)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(O=>{(0,b.isRemoteDiagnosticError)(O)?I.push({name:O.hostName,rootProcess:O}):O.processes&&I.push({name:O.hostName,rootProcess:O.processes})})}catch(A){this.i.error(`Listing processes failed: ${A}`)}this.r(l,"vscode:listProcessesResponse",I)}),M.validatedIpcMain.on("vscode:issueReporterClipboard",async l=>{if(this.b){const{options:I,buttonIndeces:A}=(0,i.massageMessageBoxOptions)({message:(0,d.localize)(1,null),type:"warning",buttons:[(0,d.localize)(2,null),(0,d.localize)(3,null)]},this.o),O=await this.l.showMessageBox(I,this.b);this.r(l,"vscode:issueReporterClipboardResponse",A[O.response]===0)}}),M.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async l=>{const I=await this.v();this.r(l,"vscode:issuePerformanceInfoResponse",I)}),M.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{if(this.b){const{options:l,buttonIndeces:I}=(0,i.massageMessageBoxOptions)({message:(0,d.localize)(4,null),type:"warning",buttons:[(0,d.localize)(5,null),(0,d.localize)(6,null)]},this.o),A=await this.l.showMessageBox(l,this.b);I[A.response]===0&&this.b&&(this.b.destroy(),this.b=null)}}),M.validatedIpcMain.on("vscode:workbenchCommand",(l,I)=>{const{id:A,from:O,args:N}=I;let X;switch(O){case"issueReporter":X=this.c;break;case"processExplorer":X=this.f;break;default:throw new Error(`Unexpected command source: ${O}`)}X?.webContents.send("vscode:runAction",{id:A,from:O,args:N})}),M.validatedIpcMain.on("vscode:openExternal",(l,I)=>{this.m.openExternal(void 0,I)}),M.validatedIpcMain.on("vscode:closeIssueReporter",l=>{this.b?.close()}),M.validatedIpcMain.on("vscode:closeProcessExplorer",l=>{this.d?.close()}),M.validatedIpcMain.on("vscode:windowsInfoRequest",async l=>{const I=await this.k.getMainDiagnostics();this.r(l,"vscode:windowsInfoResponse",I.windows)})}r(l,I,...A){l.sender.isDestroyed()||l.sender.send(I,...A)}async openReporter(l){if(!this.b&&(this.c=E.BrowserWindow.getFocusedWindow(),this.c)){const I=new C.DisposableStore,A=I.add(this.n.createIPCObjectUrl()),O=this.u(this.c,700,800);this.b=this.t(O,A,{backgroundColor:l.styles.backgroundColor,title:(0,d.localize)(7,null),zoomLevel:l.zoomLevel,alwaysOnTop:!1},"issue-reporter"),A.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:l,disableExtensions:!!this.h.disableExtensions,os:{type:(0,n.type)(),arch:(0,n.arch)(),release:(0,n.release)()},product:h.default}),this.b.loadURL(D.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,I.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,I.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(l){if(!this.d&&(this.f=E.BrowserWindow.getFocusedWindow(),this.f)){const I=new C.DisposableStore,A=I.add(this.n.createIPCObjectUrl()),O=this.p.getItem(s,void 0),N=u(O)?O:this.u(this.f,800,500),X=E.screen.getDisplayNearestPoint({x:N.x,y:N.y});N.width/=X.scaleFactor,N.height/=X.scaleFactor,this.d=this.t(N,A,{backgroundColor:l.styles.backgroundColor,title:(0,d.localize)(8,null),zoomLevel:l.zoomLevel,alwaysOnTop:!0},"process-explorer"),A.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:l,product:h.default}),this.d.loadURL(D.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,I.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,I.dispose())});const V=()=>{if(!this.d)return;const K=this.d.getSize(),ie=this.d.getPosition();if(!K||!ie)return;const re={width:K[0],height:K[1],x:ie[0],y:ie[1]};this.p.setItem(s,re)};this.d.on("moved",V),this.d.on("resized",V)}this.d&&this.s(this.d)}s(l){l.isMinimized()&&l.restore(),l.focus()}t(l,I,A,O){const N=new E.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:l.width,height:l.height,minWidth:300,minHeight:200,x:l.x,y:l.y,title:A.title,backgroundColor:A.backgroundColor||kt.a,webPreferences:{preload:D.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${I.resource.toString()}`,`--vscode-window-kind=${O}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,S.zoomLevelToZoomFactor)(A.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:A.alwaysOnTop,experimentalDarkMode:!0});return N.setMenuBarVisibility(!1),N}async getSystemStatus(){const[l,I]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(l,I)}u(l,I,A){let O;const N=E.screen.getAllDisplays();if(N.length===1)O=N[0];else{if(P.isMacintosh){const K=E.screen.getCursorScreenPoint();O=E.screen.getDisplayNearestPoint(K)}!O&&l&&(O=E.screen.getDisplayMatching(l.getBounds())),O||(O=E.screen.getPrimaryDisplay()||N[0])}const X=O.bounds,V={width:I,height:A,x:X.x+X.width/2-I/2,y:X.y+X.height/2-A/2};return X.width>0&&X.height>0&&(V.x<X.x&&(V.x=X.x),V.y<X.y&&(V.y=X.y),V.x>X.x+X.width&&(V.x=X.x),V.y>X.y+X.height&&(V.y=X.y),V.width>X.width&&(V.width=X.width),V.height>X.height&&(V.height=X.height)),V}async v(){try{const[l,I]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(l,I)}catch(l){throw this.i.warn("issueService#getPerformanceInfo ",l.message),l}}async stopTracing(){if(!this.h.args.trace)return;const l=await E.contentTracing.stopRecording(`${(0,R.randomPath)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`),{options:I}=(0,i.massageMessageBoxOptions)({type:"info",message:(0,d.localize)(9,null),detail:(0,d.localize)(10,null,l),buttons:[(0,d.localize)(11,null)]},this.o);await this.l.showMessageBox(I,(0,t.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,l)}};c.a="#1E1E1E",c=ve([_(1,g.IEnvironmentMainService),_(2,w.ILogService),_(3,b.IDiagnosticsService),_(4,v.IDiagnosticsMainService),_(5,y.IDialogMainService),_(6,o.INativeHostMainService),_(7,k.IProtocolMainService),_(8,p.IProductService),_(9,a.IStateMainService)],c),e.IssueMainService=c;function u(r){return typeof r!="object"||r===null?!1:"x"in r&&"y"in r&&"width"in r&&"height"in r}}),define(ee[276],te([0,1,22,19,28,21,5,59,20,57,24,49,94]),function(G,e,E,M,n,C,D,P,f,d,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let g=class extends y.AbstractUpdateService{constructor(w,o,h,p,k,S,R,t){super(w,o,p,k,S,t),this.e=h,this.t=R}r(w){return(0,y.createUpdateURL)(`linux-${process.arch}`,w,this.k)}s(w){!this.a||(this.d(v.State.CheckingForUpdates(w)),this.i.request({url:this.a},E.CancellationToken.None).then(d.asJson).then(o=>{!o||!o.url||!o.version||!o.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!w}),this.d(v.State.Idle(1))):this.d(v.State.AvailableForDownload(o))}).then(void 0,o=>{this.j.error(o),this.e.publicLog2("update:notAvailable",{explicit:!!w});const h=w?o.message||o:void 0;this.d(v.State.Idle(1,h))}))}async n(w){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.t.openExternal(void 0,this.k.downloadUrl):w.update.url&&this.t.openExternal(void 0,w.update.url),this.d(v.State.Idle(1))}};g=ve([_(0,C.ILifecycleMainService),_(1,M.IConfigurationService),_(2,b.ITelemetryService),_(3,n.IEnvironmentMainService),_(4,d.IRequestService),_(5,D.ILogService),_(6,P.INativeHostMainService),_(7,f.IProductService)],g),e.LinuxUpdateService=g}),define(ee[277],te([0,1,46,41,26,8,22,55,9,7,132,23,19,28,16,21,5,59,20,57,24,49,94]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g,m,w,o,h,p,k,S,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function a(u,r=1e3){for(;!u();)await(0,C.timeout)(r)}let i;function s(){return typeof i>"u"&&(i=M.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?0:1),i}let c=class extends t.AbstractUpdateService{get cachePath(){const r=f.join((0,n.tmpdir)(),`vscode-update-${this.k.target}-${process.arch}`);return v.Promises.mkdir(r,{recursive:!0}).then(()=>r)}constructor(r,l,I,A,O,N,X,V,K){super(r,l,A,O,N,K),this.t=I,this.u=X,this.v=V}async initialize(){if(this.k.target==="user"&&await this.v.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}r(r){let l="win32";return process.arch!=="ia32"&&(l+=`-${process.arch}`),s()===1?l+="-archive":this.k.target==="user"&&(l+="-user"),(0,t.createUpdateURL)(l,r,this.k)}s(r){!this.a||(this.d(R.State.CheckingForUpdates(r)),this.i.request({url:this.a},D.CancellationToken.None).then(k.asJson).then(l=>{const I=s();return!l||!l.url||!l.version||!l.productVersion?(this.t.publicLog2("update:notAvailable",{explicit:!!r}),this.d(R.State.Idle(I)),Promise.resolve(null)):I===1?(this.d(R.State.AvailableForDownload(l)),Promise.resolve(null)):(this.d(R.State.Downloading(l)),this.A(l.version).then(()=>this.z(l.version).then(A=>v.Promises.exists(A).then(O=>{if(O)return Promise.resolve(A);const N=l.url,X=l.hash,V=`${A}.tmp`;return this.i.request({url:N},D.CancellationToken.None).then(K=>this.u.writeFile(d.URI.file(V),K.stream)).then(X?()=>(0,b.checksum)(V,l.hash):()=>{}).then(()=>v.Promises.rename(V,A)).then(()=>A)})).then(A=>{const O=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:A},O&&l.supportsFastUpdate?this.k.target==="user"?this.o():this.d(R.State.Downloaded(l)):this.d(R.State.Ready(l))})))}).then(void 0,l=>{this.j.error(l),this.t.publicLog2("update:notAvailable",{explicit:!!r});const I=r?l.message||l:void 0;this.d(R.State.Idle(s(),I))}))}async n(r){r.update.url&&this.v.openExternal(void 0,r.update.url),this.d(R.State.Idle(s()))}async z(r){const l=await this.cachePath;return f.join(l,`CodeSetup-${this.k.quality}-${r}.exe`)}async A(r=null){const l=r?N=>!new RegExp(`${this.k.quality}-${r}\\.exe$`).test(N):()=>!0,I=await this.cachePath,O=(await v.Promises.readdir(I)).filter(l).map(async N=>{try{await v.Promises.unlink(f.join(I,N))}catch{}});await Promise.all(O)}async o(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const r=this.state.update;this.d(R.State.Updating(r));const l=await this.cachePath;this.e.updateFilePath=f.join(l,`CodeSetup-${this.k.quality}-${r.version}.flag`),await v.Promises.writeFile(this.e.updateFilePath,"flag"),(0,E.spawn)(this.e.packagePath,["/verysilent",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(R.State.Idle(s()))});const A=`${this.k.win32MutexName}-ready`,O=await new Promise((N,X)=>{G(["windows-mutex"],N,X)});a(()=>O.isActive(A)).then(()=>this.d(R.State.Ready(r)))}q(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?M.unlinkSync(this.e.updateFilePath):(0,E.spawn)(this.e.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}p(){return s()}async _applySpecificUpdate(r){if(this.state.type!=="idle")return;const l=this.g.getValue("update.enableWindowsBackgroundUpdates"),I={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!l};this.d(R.State.Downloading(I)),this.e={packagePath:r},l?this.k.target==="user"?this.o():this.d(R.State.Downloaded(I)):this.d(R.State.Ready(I))}};ve([P.memoize],c.prototype,"cachePath",null),c=ve([_(0,w.ILifecycleMainService),_(1,y.IConfigurationService),_(2,S.ITelemetryService),_(3,g.IEnvironmentMainService),_(4,k.IRequestService),_(5,o.ILogService),_(6,m.IFileService),_(7,h.INativeHostMainService),_(8,p.IProductService)],c),e.Win32UpdateService=c}),define(ee[278],te([0,1,14,8,22,44,3,2,15,9,64,4,7,177,63,19,58,28,62,16,21,5,20,67,241,96,24,131,69,77,30,29,54,118,122,37,34,53,59,243,114,52,93,26,115,65,48]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g,m,w,o,h,p,k,S,R,t,a,i,s,c,u,r,l,I,A,O,N,X,V,K,ie,re,ce,fe,ge,x,F,W,z,J){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var ne;(function(Z){Z[Z.NONE=0]="NONE",Z[Z.NAVIGATING=1]="NAVIGATING",Z[Z.READY=2]="READY"})(ne||(ne={}));let se=class ct extends P.Disposable{get id(){return this.k}get win(){return this.l}get lastFocusTime(){return this.m}get backupPath(){return this.n?.backupPath}get openedWorkspace(){return this.n?.workspace}get profile(){if(!this.config)return;const U=this.P.profiles.find(L=>L.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&U?U:this.P.getProfileForWorkspace(this.config.workspace??(0,A.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.P.defaultProfile}get remoteAuthority(){return this.n?.remoteAuthority}get config(){return this.n}get isExtensionDevelopmentHost(){return!!this.n?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.n?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.n?.debugId}constructor(U,L,T,B,H,j,$,q,oe,de,pe,ye,Le,Fe,Te,we,Ce,Re,Q,ae,he){super(),this.L=L,this.M=T,this.N=B,this.O=H,this.P=j,this.Q=$,this.R=q,this.S=oe,this.U=de,this.W=pe,this.X=ye,this.Y=Le,this.Z=Fe,this.ab=Te,this.bb=we,this.db=Ce,this.eb=Re,this.fb=Q,this.gb=ae,this.hb=he,this.c=this.B(new D.Emitter),this.onWillLoad=this.c.event,this.f=this.B(new D.Emitter),this.onDidSignalReady=this.f.event,this.g=this.B(new D.Emitter),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.B(new D.Emitter),this.onDidClose=this.h.event,this.j=this.B(new D.Emitter),this.onDidDestroy=this.j.event,this.m=-1,this.t=void 0,this.u=void 0,this.z=!1,this.C=[],this.D=[],this.F=void 0,this.G=void 0,this.H=this.B(this.eb.createIPCObjectUrl()),this.J=!1,this.ib=0;{const[Pe,Me]=this.tb(U.state);this.r=Pe,this.L.trace("window#ctor: using window state",Pe);const Ae=this.r.mode===0||this.r.mode===3;typeof ct.b>"u"&&(ct.b=this.gb.getItem("window.experimental.useSandbox",!1));const Ue=this.U.getValue("window");let He=!1;typeof Ue?.experimental?.useSandbox=="boolean"?He=Ue.experimental.useSandbox:this.db.quality==="stable"&&ct.b?He=!0:He=typeof this.db.quality=="string"&&this.db.quality!=="stable";const Ne={width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y,backgroundColor:this.W.getBackgroundColor(),minWidth:l.WindowMinimumSize.WIDTH,minHeight:l.WindowMinimumSize.HEIGHT,show:!Ae,title:this.db.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.H.resource.toString()}`],v8CacheOptions:this.N.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,l.zoomLevelToZoomFactor)(Ue?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...He?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};v.isLinux?Ne.icon=(0,d.join)(this.N.appRoot,"resources/linux/code.png"):v.isWindows&&!this.N.isBuilt&&(Ne.icon=(0,d.join)(this.N.appRoot,"resources/win32/code_150x150.png")),v.isMacintosh&&!this.Ab()&&(Ne.fullscreenable=!1),v.isMacintosh&&(Ne.acceptFirstMouse=!0,Ue?.clickThroughInactive===!1&&(Ne.acceptFirstMouse=!1));const $e=v.isMacintosh&&Ue?.nativeTabs===!0;$e&&(Ne.tabbingIdentifier=this.db.nameShort);const Ge=(0,l.getTitleBarStyle)(this.U)==="custom";if(Ge&&(Ne.titleBarStyle="hidden",v.isMacintosh||(Ne.frame=!1),(0,l.useWindowControlsOverlay)(this.U))){const We=this.W.getWindowSplash()?.colorInfo.titleBarBackground??this.W.getBackgroundColor(),Ve=X.Color.fromHex(We).isDarker()?"#FFFFFF":"#000000";Ne.titleBarOverlay={height:29,color:We,symbolColor:Ve},this.z=!0}if((0,b.mark)("code/willCreateCodeBrowserWindow"),this.l=new E.BrowserWindow(Ne),(0,b.mark)("code/didCreateCodeBrowserWindow"),this.k=this.l.id,v.isMacintosh&&Ge&&this.l.setSheetOffset(22),Ge&&(v.isWindows&&(0,l.useWindowControlsOverlay)(this.U)||v.isMacintosh)){const We=this.gb.getItem(ct.a);We&&this.updateWindowControls({height:We})}v.isWindows&&Ge&&this.l.hookWindowMessage(278,()=>{const[Ve,Y]=this.l.getPosition(),le=E.screen.getCursorScreenPoint(),ue=le.x-Ve,me=le.y-Y;return(()=>!(ue>30&&me>=0&&me<=Math.max(this.l.getBounds().height*.15,35)))()||(this.l.setEnabled(!1),this.l.setEnabled(!0),this.g.fire({x:ue,y:me})),0}),(v.isMacintosh||v.isWindows)&&Me&&(!$e||E.BrowserWindow.getAllWindows().length===1)&&[this.r.width,this.r.height,this.r.x,this.r.y].every(We=>typeof We=="number")&&this.l.setBounds({width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y}),Ae&&((0,b.mark)("code/willMaximizeCodeWindow"),this.l.maximize(),this.r.mode===3&&this.wb(!0),this.l.show(),(0,b.mark)("code/didMaximizeCodeWindow")),this.m=Date.now()}this.N.args["open-devtools"]===!0&&this.l.webContents.openDevTools(),this.qb(),this.Eb(),this.jb()}setRepresentedFilename(U){v.isMacintosh?this.l.setRepresentedFilename(U):this.v=U}getRepresentedFilename(){return v.isMacintosh?this.l.getRepresentedFilename():this.v}setDocumentEdited(U){v.isMacintosh&&this.l.setDocumentEdited(U),this.w=U}isDocumentEdited(){return v.isMacintosh?this.l.isDocumentEdited():!!this.w}focus(U){v.isMacintosh&&U?.force&&E.app.focus({steal:!0}),this.l&&(this.l.isMinimized()&&this.l.restore(),this.l.focus())}setReady(){for(this.L.trace(`window#load: window reported ready (id: ${this.k})`),this.ib=2;this.C.length;)this.C.pop()(this);this.f.fire()}ready(){return new Promise(U=>{if(this.isReady)return U(this);this.C.push(U)})}get isReady(){return this.ib===2}get whenClosedOrLoaded(){return new Promise(U=>{function L(){T.dispose(),B.dispose(),U()}const T=this.onDidClose(()=>L()),B=this.onWillLoad(()=>L())})}jb(){this.l.on("unresponsive",()=>this.mb(1)),this.l.webContents.on("render-process-gone",(L,T)=>this.mb(2,T)),this.l.webContents.on("did-fail-load",(L,T,B)=>this.mb(3,{reason:B,exitCode:T})),this.l.webContents.on("will-prevent-unload",L=>{L.preventDefault()}),this.l.on("closed",()=>{this.h.fire(),this.dispose()}),this.l.webContents.on("did-finish-load",()=>{this.I&&(this.n=this.I,this.I=void 0)}),this.l.on("focus",()=>{this.m=Date.now()}),this.l.on("maximize",L=>{this.n&&(this.n.maximized=!0),E.app.emit("browser-window-maximize",L,this.l)}),this.l.on("unmaximize",L=>{this.n&&(this.n.maximized=!1),E.app.emit("browser-window-unmaximize",L,this.l)}),this.l.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",n.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.l.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",n.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.B(this.U.onDidChangeConfiguration(L=>this.qb(L))),this.B(this.X.onDidDeleteUntitledWorkspace(L=>this.pb(L)));const U=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.l.webContents.session.webRequest.onBeforeSendHeaders({urls:U},async(L,T)=>{const B=await this.lb();T({cancel:!1,requestHeaders:Object.assign(L.requestHeaders,B)})})}lb(){return this.kb||(this.kb=(0,i.resolveMarketplaceHeaders)(this.db.version,this.db,this.N,this.U,this.Q,this.R,this.Z)),this.kb}async mb(U,L){switch(U){case 2:this.L.error(`CodeWindow: renderer process gone (reason: ${L?.reason||"<unknown>"}, code: ${L?.exitCode||"<unknown>"})`);break;case 1:this.L.error("CodeWindow: detected unresponsive");break;case 3:this.L.error(`CodeWindow: failed to load (reason: ${L?.reason||"<unknown>"}, code: ${L?.exitCode||"<unknown>"})`);break}switch(this.Z.publicLog2("windowerror",{type:U,reason:L?.reason,code:L?.exitCode}),U){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.bb.kill(1);return}if(this.N.args["enable-smoke-test-driver"]){await this.ob(!1,!1),this.bb.quit();return}if(U===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.l&&this.l.webContents&&this.l.webContents.isDevToolsOpened())return;const{options:T,buttonIndeces:B}=(0,J.massageMessageBoxOptions)({type:"warning",buttons:[(0,g.localize)(0,null),(0,g.localize)(1,null),(0,g.localize)(2,null)],message:(0,g.localize)(3,null),detail:(0,g.localize)(4,null),checkboxLabel:this.n?.workspace?(0,g.localize)(5,null):void 0},this.db),H=await this.ab.showMessageBox(T,this.l),j=B[H.response];if(j!==1){const $=j===0;await this.ob($,H.checkboxChecked)}}else if(U===2)if(v.isWindows&&L?.reason==="launch-failed"&&L.exitCode===18&&await this.hb.isAdmin(void 0))await this.nb(L);else{let T;L?T=(0,g.localize)(7,null,L.reason,L.exitCode??"<unknown>"):T=(0,g.localize)(6,null);const{options:B,buttonIndeces:H}=(0,J.massageMessageBoxOptions)({type:"warning",buttons:[this.n?.workspace?(0,g.localize)(8,null):(0,g.localize)(9,null),(0,g.localize)(10,null)],message:T,detail:this.n?.workspace?(0,g.localize)(11,null):(0,g.localize)(12,null),checkboxLabel:this.n?.workspace?(0,g.localize)(13,null):void 0},this.db),j=await this.ab.showMessageBox(B,this.l),$=H[j.response]===0;await this.ob($,j.checkboxChecked)}break}}async nb(U){const L=[],T=(0,ge.isInternalTelemetry)(this.db,this.U);if((0,ge.supportsTelemetry)(this.db,this.N)){this.db.aiConfig&&this.db.aiConfig.ariaKey&&L.push(new ce.OneDataSystemAppender(T,"monacoworkbench",null,this.db.aiConfig.ariaKey));const{installSourcePath:$}=this.N,q=await(0,W.resolveMachineId)(this.gb),oe={appenders:L,sendErrorTelemetry:!1,commonProperties:(0,x.resolveCommonProperties)(this.Q,(0,F.release)(),(0,F.hostname)(),process.arch,this.db.commit,this.db.version,q,T,$),piiPaths:(0,ge.getPiiPathsFromEnvironment)(this.N)};await new fe.TelemetryService(oe,this.U,this.db).publicLog2("windowadminerror",{reason:U.reason,code:U.exitCode})}const{options:B,buttonIndeces:H}=(0,J.massageMessageBoxOptions)({type:"error",buttons:[(0,g.localize)(14,null),(0,g.localize)(15,null)],message:(0,g.localize)(16,null),detail:(0,g.localize)(17,null,this.db.nameLong)},this.db),j=await this.ab.showMessageBox(B,this.l);H[j.response]===0&&await this.hb.openExternal(void 0,"https://go.microsoft.com/fwlink/?linkid=2220179"),await Promise.all(L.map($=>$.flush())),await this.ob(!1,!1)}async ob(U,L){const T=this.n?.workspace;if(L&&T)try{const B=this.S.workspaceStorage(T);await B.init(),B.delete("memento/workbench.parts.editor"),await B.close()}catch(B){this.L.error(B)}if(this.j.fire(),this.l?.destroy(),U&&this.n){let B,H;(0,A.isSingleFolderWorkspaceIdentifier)(T)?B={folderUri:T.uri}:(0,A.isWorkspaceIdentifier)(T)?B={workspaceUri:T.configPath}:H=!0;const[j]=await this.fb.open({context:5,userEnv:this.n.userEnv,cli:{...this.N.args,_:[]},urisToOpen:B?[B]:void 0,forceEmpty:H,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});j.focus()}}pb(U){this.n?.workspace?.id===U.id&&(this.n.workspace=void 0)}qb(U){if(!U||U.affectsConfiguration("window.menuBarVisibility")){const L=this.Bb();L!==this.s&&(this.s=L,this.Cb(L))}if(!U||U.affectsConfiguration("http.proxy")){let L=(this.U.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;L?.endsWith("/")&&(L=L.substr(0,L.length-1));const T=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((L||"").indexOf("@")===-1&&(L!==this.F||T!==this.G)){this.F=L,this.G=T;const B=L||"",H=T?`${T},<local>`:"<local>";this.L.trace(`Setting proxy to '${B}', bypassing '${H}'`),this.l.webContents.session.setProxy({proxyRules:B,proxyBypassRules:H,pacScript:""})}}}addTabbedWindow(U){v.isMacintosh&&U.win&&this.l.addTabbedWindow(U.win)}load(U,L=Object.create(null)){this.L.trace(`window#load: attempt to load window (id: ${this.k})`),this.isDocumentEdited()&&(!L.isReload||!this.Y.isHotExitEnabled())&&this.setDocumentEdited(!1),L.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.l.setTitle(this.db.nameLong)),this.rb(U,L),this.ib===0?this.n=U:this.I=U,this.ib=1,this.l.loadURL(f.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.N.isBuilt?"":"-dev"}.html`).toString(!0));const T=this.J;this.J=!0,!this.N.isBuilt&&!this.N.extensionTestsLocationURI&&this.B(new M.RunOnceScheduler(()=>{this.l&&!this.l.isVisible()&&!this.l.isMinimized()&&(this.l.show(),this.focus({force:!0}),this.l.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:U.workspace,reason:L.isReload?3:T?2:1})}rb(U,L){const T=(this.n??this.I)?.userEnv;if(T){const B=(0,p.isLaunchedFromCli)(T)&&!(0,p.isLaunchedFromCli)(U.userEnv),H=this.isExtensionDevelopmentHost;(B||H)&&(U.userEnv={...T,...U.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(U.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),L.disableExtensions!==void 0&&(U["disable-extensions"]=L.disableExtensions),U.fullscreen=this.isFullScreen,U.maximized=this.l.isMaximized(),U.partsSplash=this.W.getWindowSplash(),(0,b.mark)("code/willOpenNewWindow"),U.perfMarks=(0,b.getMarks)(),this.H.update(U)}async reload(U){const L=Object.assign({},this.n);L.workspace=await this.sb(L),delete L.filesToOpenOrCreate,delete L.filesToDiff,delete L.filesToMerge,delete L.filesToWait,this.isExtensionDevelopmentHost&&U&&(L.verbose=U.verbose,L.debugId=U.debugId,L.extensionEnvironment=U.extensionEnvironment,L["inspect-extensions"]=U["inspect-extensions"],L["inspect-brk-extensions"]=U["inspect-brk-extensions"],L["extensions-dir"]=U["extensions-dir"]),L.accessibilitySupport=E.app.isAccessibilitySupportEnabled(),L.isInitialStartup=!1,L.policiesData=this.O.serialize(),L.continueOn=this.N.continueOn,L.profiles={all:this.P.profiles,profile:this.profile||this.P.defaultProfile},L.logLevel=this.M.getLogLevel(),L.loggers={window:this.M.getRegisteredLoggers(this.id),global:this.M.getRegisteredLoggers()},this.load(L,{isReload:!0,disableExtensions:U?.["disable-extensions"]})}async sb(U){if((0,A.isWorkspaceIdentifier)(U.workspace)){const L=U.workspace.configPath;if(L.scheme===f.Schemas.file&&!await this.Q.exists(L))return}else if((0,A.isSingleFolderWorkspaceIdentifier)(U.workspace)){const L=U.workspace.uri;if(L.scheme===f.Schemas.file&&!await this.Q.exists(L))return}return U.workspace}serializeWindowState(){if(!this.l)return(0,N.defaultWindowState)();if(this.isFullScreen){let T;try{T=E.screen.getDisplayMatching(this.getBounds())}catch{}const B=(0,N.defaultWindowState)();return{mode:3,display:T?T.id:void 0,width:this.r.width||B.width,height:this.r.height||B.height,x:this.r.x||0,y:this.r.y||0}}const U=Object.create(null);let L;if(!v.isMacintosh&&this.l.isMaximized()?L=0:L=1,L===0?U.mode=0:U.mode=1,L===1||L===0){let T;L===1?T=this.getBounds():T=this.l.getNormalBounds(),U.x=T.x,U.y=T.y,U.width=T.width,U.height=T.height}return U}updateWindowControls(U){if(U.height&&this.gb.setItem(ct.a,U.height),v.isWindows&&this.z)this.l.setTitleBarOverlay({color:U.backgroundColor?.trim()===""?void 0:U.backgroundColor,symbolColor:U.foregroundColor?.trim()===""?void 0:U.foregroundColor,height:U.height?U.height-1:void 0});else if(v.isMacintosh&&U.height!==void 0){const L=(U.height-15)/2;this.l.setTrafficLightPosition({x:L,y:L})}}tb(U){(0,b.mark)("code/willRestoreCodeWindowState");let L=!1;if(U)try{const T=E.screen.getAllDisplays();L=T.length>1,U=this.ub(U,T)}catch(T){this.L.warn(`Unexpected error validating window state: ${T}
${T.stack}`)}return(0,b.mark)("code/didRestoreCodeWindowState"),[U||(0,N.defaultWindowState)(),L]}ub(U,L){if(this.L.trace(`window#validateWindowState: validating window state on ${L.length} display(s)`,U),typeof U.x!="number"||typeof U.y!="number"||typeof U.width!="number"||typeof U.height!="number"){this.L.trace("window#validateWindowState: unexpected type of state values");return}if(U.width<=0||U.height<=0){this.L.trace("window#validateWindowState: unexpected negative values");return}if(L.length===1){const H=this.vb(L[0]);if(H){let j=function(){!U||typeof U.x!="number"||typeof U.y!="number"||!H||(U.x<H.x&&(U.x=H.x),U.y<H.y&&(U.y=H.y))};this.L.trace("window#validateWindowState: 1 monitor working area",H),j(),U.width>H.width&&(U.width=H.width),U.height>H.height&&(U.height=H.height),U.x>H.x+H.width-128&&(U.x=H.x+H.width-U.width),U.y>H.y+H.height-128&&(U.y=H.y+H.height-U.height),j()}return U}if(U.display&&U.mode===3){const H=L.find(j=>j.id===U.display);if(H&&typeof H.bounds?.x=="number"&&typeof H.bounds?.y=="number"){this.L.trace("window#validateWindowState: restoring fullscreen to previous display");const j=(0,N.defaultWindowState)(3);return j.x=H.bounds.x,j.y=H.bounds.y,j}}let T,B;try{T=E.screen.getDisplayMatching({x:U.x,y:U.y,width:U.width,height:U.height}),B=this.vb(T)}catch{}if(T&&B&&U.x+U.width>B.x&&U.y+U.height>B.y&&U.x<B.x+B.width&&U.y<B.y+B.height)return this.L.trace("window#validateWindowState: multi-monitor working area",B),U}vb(U){if(U.workArea.width>0&&U.workArea.height>0)return U.workArea;if(U.bounds.width>0&&U.bounds.height>0)return U.bounds}getBounds(){const[U,L]=this.l.getPosition(),[T,B]=this.l.getSize();return{x:U,y:L,width:T,height:B}}toggleFullScreen(){this.wb(!this.isFullScreen)}wb(U){this.Ab()?this.xb(U):this.zb(U),this.sendWhenReady(U?"vscode:enterFullScreen":"vscode:leaveFullScreen",n.CancellationToken.None),this.s&&this.Cb(this.s,!1)}get isFullScreen(){return v.isMacintosh&&typeof this.t=="boolean"?this.t:this.l.isFullScreen()||this.l.isSimpleFullScreen()}xb(U){this.l.isSimpleFullScreen()&&this.l.setSimpleFullScreen(!1),this.yb(U)}yb(U){v.isMacintosh&&(this.t=U,this.u=new M.DeferredPromise,Promise.race([this.u.p,(0,M.timeout)(1e3)]).finally(()=>this.t=void 0)),this.l.setFullScreen(U)}zb(U){this.l.isFullScreen()&&this.yb(!1),this.l.setSimpleFullScreen(U),this.l.webContents.focus()}Ab(){const U=this.U.getValue("window");return!U||typeof U.nativeFullScreen!="boolean"||U.nativeTabs?!0:U.nativeFullScreen!==!1}isMinimized(){return this.l.isMinimized()}Bb(){let U=(0,l.getMenuBarVisibility)(this.U);return["visible","toggle","hidden"].indexOf(U)<0&&(U="classic"),U}Cb(U,L=!0){v.isMacintosh||(U==="toggle"&&L&&this.send("vscode:showInfoMessage",(0,g.localize)(18,null)),U==="hidden"?setTimeout(()=>{this.Db(U)}):this.Db(U))}Db(U){const L=this.isFullScreen;switch(U){case"classic":this.l.setMenuBarVisibility(!L),this.l.autoHideMenuBar=L;break;case"visible":this.l.setMenuBarVisibility(!0),this.l.autoHideMenuBar=!1;break;case"toggle":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!0;break;case"hidden":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(v.isMacintosh)switch(E.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.l.minimize();break;case"None":break;case"Maximize":default:this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}else this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}close(){this.l?.close()}sendWhenReady(U,L,...T){this.isReady?this.send(U,...T):this.ready().then(()=>{L.isCancellationRequested||this.send(U,...T)})}send(U,...L){if(this.l){if(this.l.isDestroyed()||this.l.webContents.isDestroyed()){this.L.warn(`Sending IPC message to channel '${U}' for window that is destroyed`);return}try{this.l.webContents.send(U,...L)}catch(T){this.L.warn(`Error sending IPC message to channel '${U}' of window ${this.k}: ${(0,C.toErrorMessage)(T)}`)}}}updateTouchBar(U){!v.isMacintosh||this.D.forEach((L,T)=>{const B=U[T];L.segments=this.Gb(B)})}Eb(){if(!!v.isMacintosh){for(let U=0;U<10;U++){const L=this.Fb();this.D.push(L)}this.l.setTouchBar(new E.TouchBar({items:this.D}))}}Fb(U=[]){const L=this.Gb(U),T=new E.TouchBar.TouchBarSegmentedControl({segments:L,mode:"buttons",segmentStyle:"automatic",change:B=>{this.sendWhenReady("vscode:runAction",n.CancellationToken.None,{id:T.segments[B].id,from:"touchbar"})}});return T}Gb(U=[]){return U.map(T=>{let B;T.icon&&!u.ThemeIcon.isThemeIcon(T.icon)&&T.icon?.dark?.scheme===f.Schemas.file&&(B=E.nativeImage.createFromPath(y.URI.revive(T.icon.dark).fsPath),B.isEmpty()&&(B=void 0));let H;return typeof T.title=="string"?H=T.title:H=T.title.value,{id:T.id,label:B?void 0:H,icon:B}})}dispose(){super.dispose(),this.M.deregisterLoggers(this.id),this.l=null}};se.a="windowControlHeight",se.b=void 0,se=ve([_(1,R.ILogService),_(2,z.ILoggerMainService),_(3,h.IEnvironmentMainService),_(4,V.IPolicyService),_(5,ie.IUserDataProfilesMainService),_(6,k.IFileService),_(7,s.IApplicationStorageMainService),_(8,s.IStorageMainService),_(9,w.IConfigurationService),_(10,r.IThemeMainService),_(11,O.IWorkspacesManagementMainService),_(12,m.IBackupMainService),_(13,c.ITelemetryService),_(14,o.IDialogMainService),_(15,S.ILifecycleMainService),_(16,t.IProductService),_(17,a.IProtocolMainService),_(18,I.IWindowsMainService),_(19,K.IStateMainService),_(20,re.INativeHostMainService)],se),e.CodeWindow=se}),define(ee[79],te([0,1,14,25,8,3,45,2,15,4,18,7,23,180,6,21,5,96,97,29,54,35]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g,m,w,o,h,p,k,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,m.createDecorator)("workspacesHistoryMainService");let t=class nt extends P.Disposable{constructor(i,s,c,u){super(),this.f=i,this.g=s,this.h=c,this.j=u,this.c=this.B(new C.Emitter),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new n.ThrottledDelayer(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let s=[],c=[];for(const r of i)if((0,p.isRecentWorkspace)(r))!this.g.isUntitledWorkspace(r.workspace)&&!this.r(s,r.workspace)&&s.push(r);else if((0,p.isRecentFolder)(r))this.s(s,r.folderUri)||s.push(r);else{const l=this.t(c,r.fileUri),I=r.fileUri.scheme===f.Schemas.file&&nt.y.indexOf((0,b.basename)(r.fileUri))>=0;!l&&!I&&(c.push(r),d.isWindows&&r.fileUri.scheme===f.Schemas.file&&E.app.addRecentDocument(r.fileUri.fsPath))}const u=await this.l({workspaces:s,files:c});s=u.workspaces,c=u.files,s.length>nt.a&&(s.length=nt.a),c.length>nt.a&&(c.length=nt.a),await this.n({workspaces:s,files:c}),this.c.fire(),d.isMacintosh&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(i){const s=l=>{const I=this.p(l);for(const A of i)if(b.extUriBiasedIgnorePathCase.isEqual(A,I))return!1;return!0},c=await this.getRecentlyOpened(),u=c.workspaces.filter(s),r=c.files.filter(s);(u.length!==c.workspaces.length||r.length!==c.files.length)&&(await this.n({files:r,workspaces:u}),this.c.fire(),d.isMacintosh&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),E.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(i){const s=new R.ResourceMap(r=>b.extUriBiasedIgnorePathCase.getComparisonKey(r));if(i?.workspaces)for(const r of i.workspaces)s.set(this.p(r),r);const c=new R.ResourceMap(r=>b.extUriBiasedIgnorePathCase.getComparisonKey(r));if(i?.files)for(const r of i.files)c.set(this.p(r),r);const u=await this.m();for(const r of u.workspaces){const l=s.get(this.p(r));l?l.label=l.label??r.label:s.set(this.p(r),r)}for(const r of u.files){const l=c.get(this.p(r));l?l.label=l.label??r.label:c.set(this.p(r),r)}return{workspaces:[...s.values()],files:[...c.values()]}}async m(){await this.j.whenReady;let i;const s=this.j.get(nt.b,-1);if(typeof s=="string")try{i=JSON.parse(s)}catch(c){this.f.error("Unexpected error parsing opened paths list",c)}return(0,p.restoreRecentlyOpened)(i,this.f)}async n(i){await this.j.whenReady,this.j.store(nt.b,JSON.stringify((0,p.toStoreData)(i)),-1,1)}p(i){return(0,p.isRecentFolder)(i)?i.folderUri:(0,p.isRecentFile)(i)?i.fileUri:i.workspace.configPath}r(i,s){return!!i.find(c=>(0,p.isRecentWorkspace)(c)&&c.workspace.id===s.id)}s(i,s){return!!i.find(c=>(0,p.isRecentFolder)(c)&&b.extUriBiasedIgnorePathCase.isEqual(c.folderUri,s))}t(i,s){return!!i.find(c=>b.extUriBiasedIgnorePathCase.isEqual(c.fileUri,s))}async C(){!d.isWindows||(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!d.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,g.localize)(0,null),description:(0,g.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const s=[];for(const r of E.app.getJumpListSettings().removedItems){const l=r.args;if(l){const I=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(l);I&&s.push(v.URI.parse(I[2]))}}await this.removeRecentlyOpened(s);let c=!1;const u=(0,M.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,nt.w).map(r=>{const l=(0,p.isRecentWorkspace)(r)?r.workspace:r.folderUri,{title:I,description:A}=this.F(l,r.label);let O;return v.URI.isUri(l)?O=`--folder-uri "${l.toString()}"`:(c=!0,O=`--file-uri "${l.configPath.toString()}"`),{type:"task",title:I.substr(0,255),description:A.substr(0,255),program:process.execPath,args:O,iconPath:"explorer.exe",iconIndex:0}}));u.length>0&&i.push({type:"custom",name:c?(0,g.localize)(2,null):(0,g.localize)(3,null),items:u})}i.push({type:"recent"});try{const s=E.app.setJumpList(i);s&&s!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${s}`)}catch(s){this.f.warn("updateWindowsJumpList#setJumpList",s)}}F(i,s){if(s)return{title:(0,D.splitName)(s).name,description:s};if(v.URI.isUri(i))return{title:(0,b.basename)(i),description:this.G(i)};if(this.g.isUntitledWorkspace(i))return{title:(0,g.localize)(4,null),description:""};let c=(0,b.basename)(i.configPath);return c.endsWith(k.WORKSPACE_EXTENSION)&&(c=c.substr(0,c.length-k.WORKSPACE_EXTENSION.length-1)),{title:(0,g.localize)(5,null,c),description:this.G(i.configPath)}}G(i){return i.scheme==="file"?(0,D.normalizeDriveLetter)(i.fsPath):i.toString()}async H(){if(!d.isMacintosh)return;E.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),s=[];let c=0;for(let r=0;r<i.workspaces.length&&c<nt.u;r++){const l=this.p(i.workspaces[r]);if(l.scheme===f.Schemas.file){const I=(0,b.originalFSPath)(l);await y.Promises.exists(I)&&(s.push(I),c++)}}const u=[];for(let r=0;r<i.files.length&&c<nt.v;r++){const l=this.p(i.files[r]);if(l.scheme===f.Schemas.file){const I=(0,b.originalFSPath)(l);if(nt.y.includes((0,b.basename)(l))||s.includes(I))continue;await y.Promises.exists(I)&&(u.push(I),c++)}}u.reverse().forEach(r=>E.app.addRecentDocument(r)),s.reverse().forEach(r=>E.app.addRecentDocument(r))}};t.a=500,t.b="history.recentlyOpenedPathsList",t.u=7,t.v=10,t.w=7,t.y=["COMMIT_EDITMSG","MERGE_MSG"],t=ve([_(0,o.ILogService),_(1,S.IWorkspacesManagementMainService),_(2,w.ILifecycleMainService),_(3,h.IApplicationStorageMainService)],t),e.WorkspacesHistoryMainService=t}),define(ee[279],te([0,1,14,8,22,45,4,7,170,19,48,28,21,5,219,59,20,34,24,49,77,30,79]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g,m,w,o,h,p,k,S,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const a="menu";let i=class bt{constructor(u,r,l,I,A,O,N,X,V,K,ie){this.n=u,this.o=r,this.p=l,this.q=I,this.r=A,this.s=O,this.t=N,this.u=X,this.v=V,this.w=K,this.x=ie,this.m=Object.create(null),this.g=new M.RunOnceScheduler(()=>this.E(),0),this.h=new M.RunOnceScheduler(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(D.isMacintosh||(0,S.getTitleBarStyle)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const u=this.t.getItem(bt.a);u&&(u.menus&&(this.k=u.menus),u.keybindings&&(this.l=u.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(O,N,X)=>this.p.openEmptyWindow({context:2,contextWindowId:N?.id}),this.m["workbench.action.newWindow"]=(O,N,X)=>this.p.openEmptyWindow({context:2,contextWindowId:N?.id}),this.m["workbench.action.files.openFileFolder"]=(O,N,X)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(X),telemetryExtraData:{from:a}}),this.m["workbench.action.files.openFolder"]=(O,N,X)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(X),telemetryExtraData:{from:a}}),this.m["workbench.action.openWorkspace"]=(O,N,X)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(X),telemetryExtraData:{from:a}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const u=this.x.twitterUrl;u&&(this.m["workbench.action.openTwitterUrl"]=()=>this.Z(u,"openTwitterUrl"));const r=this.x.requestFeatureUrl;r&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(r,"openUserVoiceUrl"));const l=this.x.reportIssueUrl;l&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(l,"openReportIssues"));const I=this.x.licenseUrl;I&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(D.language){const O=I.indexOf("?")>0?"&":"?";this.Z(`${I}${O}lang=${D.language}`,"openLicenseUrl")}else this.Z(I,"openLicenseUrl")});const A=this.x.privacyStatementUrl;A&&I&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(A,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(u=>this.F(u)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const u=this.o.getValue("window.enableMenuBarMnemonics");return typeof u!="boolean"?!0:u}get C(){if(!D.isMacintosh)return!1;const u=this.o.getValue("window.nativeTabs");return typeof u!="boolean"?!1:u}updateMenu(u,r){this.k=u.menus,this.l=u.keybindings,this.t.setItem(bt.a,u),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(u){!D.isMacintosh||(u.oldCount===0&&u.newCount>0||u.oldCount>0&&u.newCount===0)&&(this.d=u.newCount===0,this.D())}G(){!D.isMacintosh||(this.f=!E.BrowserWindow.getFocusedWindow(),this.D())}H(){const u=E.Menu.getApplicationMenu();if(u&&this.j.push(u),Object.keys(this.k).length===0){E.Menu.setApplicationMenu(D.isMacintosh?new E.Menu:null);return}const r=new E.Menu;let l;if(D.isMacintosh){const A=new E.Menu;l=new E.MenuItem({label:this.x.nameShort,submenu:A}),this.I(A),r.append(l)}if(D.isMacintosh&&!this.c){this.c=!0;const A=new E.Menu;A.append(new E.MenuItem({label:this.bb(f.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),E.app.dock.setMenu(A)}if(this.K("File")){const A=new E.Menu,O=new E.MenuItem({label:this.bb(f.localize(1,null)),submenu:A});this.M(A,"File"),r.append(O)}if(this.K("Edit")){const A=new E.Menu,O=new E.MenuItem({label:this.bb(f.localize(2,null)),submenu:A});this.M(A,"Edit"),r.append(O)}if(this.K("Selection")){const A=new E.Menu,O=new E.MenuItem({label:this.bb(f.localize(3,null)),submenu:A});this.M(A,"Selection"),r.append(O)}if(this.K("View")){const A=new E.Menu,O=new E.MenuItem({label:this.bb(f.localize(4,null)),submenu:A});this.M(A,"View"),r.append(O)}if(this.K("Go")){const A=new E.Menu,O=new E.MenuItem({label:this.bb(f.localize(5,null)),submenu:A});this.M(A,"Go"),r.append(O)}if(this.K("Run")){const A=new E.Menu,O=new E.MenuItem({label:this.bb(f.localize(6,null)),submenu:A});this.M(A,"Run"),r.append(O)}if(this.K("Terminal")){const A=new E.Menu,O=new E.MenuItem({label:this.bb(f.localize(7,null)),submenu:A});this.M(A,"Terminal"),r.append(O)}let I;if(this.K("Window")){const A=new E.Menu;I=new E.MenuItem({label:this.bb(f.localize(8,null)),submenu:A,role:"window"}),this.S(A)}if(I&&r.append(I),this.K("Help")){const A=new E.Menu,O=new E.MenuItem({label:this.bb(f.localize(9,null)),submenu:A,role:"help"});this.M(A,"Help"),r.append(O)}r.items&&r.items.length>0?E.Menu.setApplicationMenu(r):E.Menu.setApplicationMenu(null),this.h.schedule()}I(u){const r=this.U(f.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),l=this.T();let I;if(this.K("Preferences")){const re=new E.Menu;this.M(re,"Preferences"),I=new E.MenuItem({label:this.bb(f.localize(11,null)),submenu:re})}const A=new E.Menu,O=new E.MenuItem({label:f.localize(12,null),role:"services",submenu:A}),N=new E.MenuItem({label:f.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),X=new E.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),V=new E.MenuItem({label:f.localize(15,null),role:"unhide"}),K=new E.MenuItem(this.Y("workbench.action.quit",{label:f.localize(16,null,this.x.nameLong),click:async(re,ce,fe)=>{const ge=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||!!E.BrowserWindow.getFocusedWindow()||ge?.isMinimized())&&await this.J(fe)&&this.w.quit(void 0)}})),ie=[r];ie.push(...l),I&&ie.push(s(),I),ie.push(s(),O,s(),N,X,V,s(),K),ie.forEach(re=>u.append(re))}async J(u){if(this.p.getWindowCount()===0)return!0;const r=this.o.getValue("window.confirmBeforeClose");if(r==="always"||r==="keyboardOnly"&&this.Q(u)){const{options:l,buttonIndeces:I}=(0,b.massageMessageBoxOptions)({type:"question",buttons:[f.localize(17,null),f.localize(18,null)],message:f.localize(19,null)},this.x),{response:A}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,l);return I[A]===0}return!0}K(u){if(!D.isMacintosh&&(0,S.getTitleBarStyle)(this.o)==="custom")return!1;switch(u){case"File":case"Help":if(D.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[u];case"Window":if(D.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[u]}}L(u,r){r.forEach(l=>{if((0,m.isMenubarMenuItemSeparator)(l))u.append(s());else if((0,m.isMenubarMenuItemSubmenu)(l)){const I=new E.Menu,A=new E.MenuItem({label:this.bb(l.label),submenu:I});this.L(I,l.submenu.items),u.append(A)}else(0,m.isMenubarMenuItemRecentAction)(l)?u.append(this.O(l)):(0,m.isMenubarMenuItemAction)(l)&&(l.id==="workbench.action.showAboutDialog"&&this.N(u),D.isMacintosh?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[l.id]?u.append(new E.MenuItem(this.Y(l.id,{label:this.bb(l.label),click:this.m[l.id]}))):u.append(this.U(l.label,l.id,!1,l.checked)):u.append(this.U(l.label,l.id,l.enabled!==!1,!!l.checked)):u.append(this.U(l.label,l.id,l.enabled!==!1,!!l.checked)))})}M(u,r){this.k&&this.k[r]&&this.L(u,this.k[r].items)}N(u){const r=this.T();r.length&&(r.forEach(l=>u.append(l)),u.append(s()))}O(u){const r=P.URI.revive(u.uri),l=u.id,I=l==="openRecentFile"?{fileUri:r}:l==="openRecentWorkspace"?{workspaceUri:r}:{folderUri:r};return new E.MenuItem(this.Y(l,{label:u.label,click:async(A,O,N)=>{const X=this.P(N);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[I],forceNewWindow:X,gotoLineMode:!1,remoteAuthority:u.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([r])}},!1))}P(u){return!!(u&&(!D.isMacintosh&&(u.ctrlKey||u.shiftKey)||D.isMacintosh&&(u.metaKey||u.altKey)))}Q(u){return!!(u.triggeredByAccelerator||u.altKey||u.ctrlKey||u.metaKey||u.shiftKey)}R(u,r,l){const I={label:this.bb(u),role:l,enabled:!0};return new E.MenuItem(this.X(r,I))}S(u){const r=new E.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),l=new E.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),I=new E.MenuItem({label:f.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),A=this.U(f.localize(23,null),"workbench.action.switchWindow"),O=[];this.C&&(O.push(s()),O.push(this.U(f.localize(24,null),"workbench.action.newWindowTab")),O.push(this.R(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),O.push(this.R(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),O.push(this.R(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),O.push(this.R(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[r,l,s(),A,...O,s(),I].forEach(N=>u.append(N))}T(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new E.MenuItem({label:this.bb(f.localize(29,null)),click:()=>setTimeout(()=>{this.ab("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new E.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new E.MenuItem({label:this.bb(f.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new E.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new E.MenuItem({label:this.bb(f.localize(33,null)),click:()=>{this.ab("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new E.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new E.MenuItem({label:this.bb(f.localize(35,null)),click:()=>{this.ab("RestartToUpdate"),this.n.quitAndInstall()}})]}}U(u,r,l,I){const A=this.bb(u),O=typeof r=="function"?r:(ie,re,ce)=>{const fe=ie?ie.userSettingsLabel:null;let ge=r;Array.isArray(r)&&(ge=this.P(ce)?r[1]:r[0]),fe&&ce.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:fe}):this.W({type:"commandId",commandId:ge})},N=typeof l=="boolean"?l:this.p.getWindowCount()>0,X=typeof I=="boolean"?I:!1,V={label:A,click:O,enabled:N};X&&(V.type="checkbox",V.checked=X);let K;return typeof r=="string"?K=r:Array.isArray(r)&&(K=r[0]),D.isMacintosh&&(K==="editor.action.clipboardCutAction"?V.role="cut":K==="editor.action.clipboardCopyAction"?V.role="copy":K==="editor.action.clipboardPasteAction"&&(V.role="paste"),K==="undo"?V.click=this.V(O,{inDevTools:ie=>ie.undo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("undo:")}):K==="redo"?V.click=this.V(O,{inDevTools:ie=>ie.redo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("redo:")}):K==="editor.action.selectAll"&&(V.click=this.V(O,{inDevTools:ie=>ie.selectAll(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("selectAll:")}))),new E.MenuItem(this.X(K,V))}V(u,r){return(l,I,A)=>{const O=E.BrowserWindow.getFocusedWindow();if(!O)return r.inNoWindow();if(O.webContents.isDevToolsFocused()&&O.webContents.devToolsWebContents)return r.inDevTools(O.webContents.devToolsWebContents);u(l,I||O,A)}}W(u){let r=E.BrowserWindow.getFocusedWindow();if(!r){const I=this.p.getLastActiveWindow();I?.isMinimized()&&(r=I.win)}const l=r?this.p.getWindowById(r.id):void 0;if(l){if(this.v.trace("menubar#runActionInRenderer",u),D.isMacintosh&&!this.q.isBuilt&&!l.isReady&&(u.type==="commandId"&&u.commandId==="workbench.action.toggleDevTools"||u.type!=="commandId"&&u.userSettingsLabel==="alt+cmd+i"))return;if(u.type==="commandId"){const I={id:u.commandId,from:"menu"};l.sendWhenReady("vscode:runAction",n.CancellationToken.None,I)}else{const I={userSettingsLabel:u.userSettingsLabel};l.sendWhenReady("vscode:runKeybinding",n.CancellationToken.None,I)}}else this.v.trace("menubar#runActionInRenderer: no active window found",u)}X(u,r){const l=typeof u=="string"?this.l[u]:void 0;if(l?.label){if(l.isNative!==!1)r.accelerator=l.label,r.userSettingsLabel=l.userSettingsLabel;else if(typeof r.label=="string"){const I=r.label.indexOf("[");I>=0?r.label=`${r.label.substr(0,I)} [${l.label}]`:r.label=`${r.label} [${l.label}]`}}else r.accelerator=void 0;return r}Y(u,r,l=!r.accelerator){l&&(r=this.X(u,r));const I=r.click;return r.click=(A,O,N)=>{this.ab(u),I?.(A,O,N)},r}Z(u,r){this.w.openExternal(void 0,u),this.ab(r)}ab(u){this.r.publicLog2("workbenchActionExecuted",{id:u,from:a})}bb(u){return(0,C.mnemonicMenuLabel)(u,!this.B)}};i.a="lastKnownMenubarData",i=ve([_(0,k.IUpdateService),_(1,d.IConfigurationService),_(2,R.IWindowsMainService),_(3,v.IEnvironmentMainService),_(4,p.ITelemetryService),_(5,t.IWorkspacesHistoryMainService),_(6,h.IStateMainService),_(7,y.ILifecycleMainService),_(8,g.ILogService),_(9,w.INativeHostMainService),_(10,o.IProductService)],i),e.Menubar=i;function s(){return new E.MenuItem({type:"separator"})}}),define(ee[280],te([0,1,6,21,5,279]),function(G,e,E,M,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,E.createDecorator)("menubarMainService");let D=class{constructor(f,d,b){this.b=f,this.c=d,this.d=b,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(C.Menubar)}async updateMenubar(f,d){this.d.trace("menubarService#updateMenubar",f),(await this.a).updateMenu(d,f)}};D=ve([_(0,E.IInstantiationService),_(1,M.ILifecycleMainService),_(2,n.ILogService)],D),e.MenubarMainService=D}),define(ee[281],te([0,1,14,23,26,25,22,3,32,50,45,2,15,9,64,4,36,18,10,7,178,63,19,58,28,16,6,21,5,66,20,67,56,34,77,278,120,273,29,98,79,54,69,37,53,65,48]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g,m,w,o,h,p,k,S,R,t,a,i,s,c,u,r,l,I,A,O,N,X,V,K,ie,re,ce,fe,ge,x,F,W,z,J){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function ne(U){return(0,re.isWorkspaceIdentifier)(U?.workspace)}function se(U){return(0,re.isSingleFolderWorkspaceIdentifier)(U?.workspace)}let Z=class lt extends v.Disposable{constructor(L,T,B,H,j,$,q,oe,de,pe,ye,Le,Fe,Te,we,Ce,Re,Q,ae){super(),this.k=L,this.l=T,this.m=B,this.n=H,this.r=j,this.s=$,this.t=q,this.u=oe,this.v=de,this.w=pe,this.z=ye,this.C=Le,this.D=Fe,this.F=Te,this.G=we,this.H=Ce,this.I=Re,this.J=Q,this.L=ae,this.b=this.B(new P.Emitter),this.onDidOpenWindow=this.b.event,this.c=this.B(new P.Emitter),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new P.Emitter),this.onDidDestroyWindow=this.f.event,this.g=this.B(new P.Emitter),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new P.Emitter),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new ie.WindowsStateHandler(this,this.r,this.v,this.m,this.z)),this.M()}M(){this.B(this.D.onDidEnterWorkspace(L=>this.c.fire(L.window))),this.B(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const T=new v.DisposableStore;if(T.add(P.Event.any(L.onDidClose,L.onDidDestroy)(()=>T.dispose())),L.config.extensionDevelopmentPath)for(const B of L.config.extensionDevelopmentPath)T.add(this.J.addValidFileRoot(B));L.config.extensionTestsPath&&T.add(this.J.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,T){const B=this.t.args,H=T?.remoteAuthority||void 0,j=!0,$=T?.forceReuseWindow,q=!$;return this.open({...L,cli:B,forceEmpty:j,forceNewWindow:q,forceReuseWindow:$,remoteAuthority:H})}openExistingWindow(L,T){L.focus(),this.N(T,[L])}async open(L){this.m.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const T=[],B=[],H=[],j=[],$=[];let q,oe=0;const de=await this.U(L);this.m.trace("windowsManager#open pathsToOpen",de);for(const Te of de)se(Te)?L.addMode?T.push(Te):B.push(Te):ne(Te)?H.push(Te):Te.fileUri?(q||(q={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Te.remoteAuthority}),q.filesToOpenOrCreate.push(Te)):Te.backupPath?$.push({backupFolder:(0,g.basename)(Te.backupPath),remoteAuthority:Te.remoteAuthority}):oe++;L.diffMode&&q&&q.filesToOpenOrCreate.length>=2&&(q.filesToDiff=q.filesToOpenOrCreate.slice(0,2),q.filesToOpenOrCreate=[]),L.mergeMode&&q&&q.filesToOpenOrCreate.length===4&&(q.filesToMerge=q.filesToOpenOrCreate.slice(0,4),q.filesToOpenOrCreate=[],q.filesToDiff=[]),q&&L.waitMarkerFileURI&&(q.filesToWait={paths:(0,C.coalesce)([...q.filesToDiff,q.filesToMerge[3],...q.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(j.push(...this.D.getUntitledWorkspaces()),H.push(...j),$.push(...this.w.getEmptyWindowBackups())):$.length=0;const{windows:pe,filesOpenedInWindow:ye}=await this.O(L,H,B,$,oe,q,T);if(this.m.trace(`windowsManager#open used window count ${pe.length} (workspacesToOpen: ${H.length}, foldersToOpen: ${B.length}, emptyToRestore: ${$.length}, emptyToOpen: ${oe})`),pe.length>1)if(ye)ye.focus();else{const Te=this.j.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let we=!0,Ce=!0;if(Te){const Re=pe.filter(Q=>this.j.state.lastActiveWindow&&Q.backupPath===this.j.state.lastActiveWindow.backupPath);Re.length&&(Re[0].focus(),we=!1,Ce=!1)}if(we)for(let Re=pe.length-1;Re>=0;Re--){const Q=pe[Re];if(!(Q.openedWorkspace&&j.some(ae=>Q.openedWorkspace&&ae.workspace.id===Q.openedWorkspace.id)||Q.backupPath&&$.some(ae=>Q.backupPath&&ae.backupFolder===(0,g.basename)(Q.backupPath)))){Q.focus(),Ce=!1;break}}Ce&&pe[pe.length-1].focus()}const Le=q&&q.filesToDiff.length>0,Fe=q&&q.filesToMerge.length>0;if(!pe.some(Te=>Te.isExtensionDevelopmentHost)&&!Le&&!Fe&&!L.noRecentEntry){const Te=[];for(const we of de)ne(we)&&!we.transient?Te.push({label:we.label,workspace:we.workspace,remoteAuthority:we.remoteAuthority}):se(we)?Te.push({label:we.label,folderUri:we.workspace.uri,remoteAuthority:we.remoteAuthority}):we.fileUri&&Te.push({label:we.label,fileUri:we.fileUri,remoteAuthority:we.remoteAuthority});this.C.addRecentlyOpened(Te)}return this.N(L,pe),pe}N(L,T){const B=L.waitMarkerFileURI;L.context===0&&B&&T.length===1&&T[0]&&(async()=>{await T[0].whenClosedOrLoaded;try{await this.H.del(B)}catch{}})()}async O(L,T,B,H,j,$,q){const oe=[];let de;function pe(Re,Q){oe.push(Re),Q&&(de=Re,$=void 0)}let{openFolderInNewWindow:ye,openFilesInNewWindow:Le}=this.gb(L);if(!L.initialStartup&&q.length>0){const Re=q[0].remoteAuthority,Q=this.lb(Re);Q&&pe(this.Q(Q,q.map(ae=>ae.workspace.uri)))}const Fe=B.length+T.length+H.length;if($&&Fe===0){const Re=$.filesToOpenOrCreate[0]||$.filesToDiff[0]||$.filesToMerge[3],Q=this.getWindows().filter(he=>$&&(0,h.isEqualAuthority)(he.remoteAuthority,$.remoteAuthority));let ae;Re?.fileUri&&!Le&&((L.context===4||L.context===0||L.context===1)&&(ae=await(0,K.findWindowOnFile)(Q,Re.fileUri,async he=>he.configPath.scheme===y.Schemas.file?this.D.resolveLocalWorkspace(he.configPath):void 0)),ae||(ae=this.mb(Q))),ae?(0,re.isWorkspaceIdentifier)(ae.openedWorkspace)?T.push({workspace:ae.openedWorkspace,remoteAuthority:ae.remoteAuthority}):(0,re.isSingleFolderWorkspaceIdentifier)(ae.openedWorkspace)?B.push({workspace:ae.openedWorkspace,remoteAuthority:ae.remoteAuthority}):pe(this.P(L,ae,$),!0):pe(await this.hb({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:$,forceNewWindow:!0,remoteAuthority:$.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile}),!0)}const Te=(0,C.distinct)(T,Re=>Re.workspace.id);if(Te.length>0){const Re=(0,C.coalesce)(Te.map(Q=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),Q.workspace.configPath)));if(Re.length>0){const Q=Re[0],ae=(0,h.isEqualAuthority)($?.remoteAuthority,Q.remoteAuthority)?$:void 0;pe(this.P(L,Q,ae),!!ae),ye=!0}for(const Q of Te){if(Re.some(Pe=>Pe.openedWorkspace&&Pe.openedWorkspace.id===Q.workspace.id))continue;const ae=Q.remoteAuthority,he=(0,h.isEqualAuthority)($?.remoteAuthority,ae)?$:void 0;pe(await this.S(L,Q,ye,he),!!he),ye=!0}}const we=(0,C.distinct)(B,Re=>h.extUriBiasedIgnorePathCase.getComparisonKey(Re.workspace.uri));if(we.length>0){const Re=(0,C.coalesce)(we.map(Q=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),Q.workspace.uri)));if(Re.length>0){const Q=Re[0],ae=(0,h.isEqualAuthority)($?.remoteAuthority,Q.remoteAuthority)?$:void 0;pe(this.P(L,Q,ae),!!ae),ye=!0}for(const Q of we){if(Re.some(Pe=>(0,re.isSingleFolderWorkspaceIdentifier)(Pe.openedWorkspace)&&h.extUriBiasedIgnorePathCase.isEqual(Pe.openedWorkspace.uri,Q.workspace.uri)))continue;const ae=Q.remoteAuthority,he=(0,h.isEqualAuthority)($?.remoteAuthority,ae)?$:void 0;pe(await this.S(L,Q,ye,he),!!he),ye=!0}}const Ce=(0,C.distinct)(H,Re=>Re.backupFolder);if(Ce.length>0)for(const Re of Ce){const Q=Re.remoteAuthority,ae=(0,h.isEqualAuthority)($?.remoteAuthority,Q)?$:void 0;pe(await this.R(L,!0,Q,ae,Re),!!ae),ye=!0}if(oe.length===0||$){$&&!j&&j++;const Re=$?$.remoteAuthority:L.remoteAuthority;for(let Q=0;Q<j;Q++)pe(await this.R(L,ye,Re,$),!!$),ye=!0}return{windows:(0,C.distinct)(oe),filesOpenedInWindow:de}}P(L,T,B){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:B}),T.focus();const H={filesToOpenOrCreate:B?.filesToOpenOrCreate,filesToDiff:B?.filesToDiff,filesToMerge:B?.filesToMerge,filesToWait:B?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return T.sendWhenReady("vscode:openFiles",D.CancellationToken.None,H),T}Q(L,T){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:T}),L.focus();const B={foldersToAdd:T};return L.sendWhenReady("vscode:addFolders",D.CancellationToken.None,B),L}R(L,T,B,H,j){this.m.trace("windowsManager#doOpenEmpty",{restore:!!j,remoteAuthority:B,filesToOpen:H,forceNewWindow:T});let $;return!T&&typeof L.contextWindowId=="number"&&($=this.getWindowById(L.contextWindowId)),this.hb({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:B,forceNewWindow:T,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:H,windowToUse:$,emptyWindowBackupInfo:j,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile})}S(L,T,B,H,j){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:T,filesToOpen:H}),!B&&!j&&typeof L.contextWindowId=="number"&&(j=this.getWindowById(L.contextWindowId)),this.hb({workspace:T.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:T.remoteAuthority,forceNewWindow:B,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:H,windowToUse:j,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile})}async U(L){let T,B=!1,H=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(T=await this.W(L),B=!0):L.forceEmpty?T=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(T=await this.X(L.cli),T.length===0&&T.push(Object.create(null)),B=!0):(T=await this.Z(),T.length===0&&T.push(Object.create(null)),H=!0),!L.addMode&&B){const j=T.filter($=>se($));if(j.length>1){const $=j[0].remoteAuthority;if(j.every(q=>(0,h.isEqualAuthority)(q.remoteAuthority,$))){const q=await this.D.createUntitledWorkspace(j.map(oe=>({uri:oe.workspace.uri})));T.push({workspace:q,remoteAuthority:$}),T=T.filter(oe=>!se(oe))}}}if(L.initialStartup&&!H&&this.z.getValue("window")?.restoreWindows==="preserve"){const j=await this.Z();T.unshift(...j.filter($=>ne($)||se($)||$.backupPath))}return T}async W(L){const T={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority},B=await Promise.all((0,C.coalesce)(L.urisToOpen||[]).map(async H=>{const j=await this.bb(H,T);if(j)return j.label=H.label,j;const $=this.db(H);this.G.showMessageBox((0,J.massageMessageBoxOptions)({type:"info",buttons:[(0,S.localize)(0,null)],message:$.scheme===y.Schemas.file?(0,S.localize)(1,null):(0,S.localize)(2,null),detail:$.scheme===y.Schemas.file?(0,S.localize)(3,null,(0,b.getPathLabel)($,{os:w.OS,tildify:this.t})):(0,S.localize)(4,null,$.toString(!0))},this.I).options,(0,p.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow()))}));return(0,C.coalesce)(B)}async X(L){const T=[],B={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},H=L["folder-uri"];if(H){const q=await Promise.all(H.map(oe=>{const de=this.Y(oe);if(!!de)return this.bb({folderUri:de},B)}));T.push(...(0,C.coalesce)(q))}const j=L["file-uri"];if(j){const q=await Promise.all(j.map(oe=>{const de=this.Y(oe);if(!!de)return this.bb((0,re.hasWorkspaceFileExtension)(oe)?{workspaceUri:de}:{fileUri:de},B)}));T.push(...(0,C.coalesce)(q))}const $=await Promise.all(L._.map(q=>B.remoteAuthority?this.fb(q,B):this.eb(q,B)));return T.push(...(0,C.coalesce)($)),T}Y(L){try{const T=k.URI.parse(L);if(!T.scheme){this.m.error(`Invalid URI input string, scheme missing: ${L}`);return}return T}catch(T){this.m.error(`Invalid URI input string: ${L}, ${T.message}`)}}async Z(){const L=this.ab();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const T=[];L!=="one"&&T.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&T.push(this.j.state.lastActiveWindow);const B=await Promise.all(T.map(async H=>{if(H.workspace){const j=await this.bb({workspaceUri:H.workspace.configPath},{remoteAuthority:H.remoteAuthority,rejectTransientWorkspaces:!0});if(ne(j))return j}else if(H.folderUri){const j=await this.bb({folderUri:H.folderUri},{remoteAuthority:H.remoteAuthority});if(se(j))return j}else if(L!=="folders"&&H.backupPath)return{backupPath:H.backupPath,remoteAuthority:H.remoteAuthority}}));return(0,C.coalesce)(B)}}}ab(){let L;return this.v.wasRestarted?L="all":(L=this.z.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}async bb(L,T=Object.create(null)){const B=this.db(L);return B.scheme===y.Schemas.file?((0,X.isFileToOpen)(L)&&(T={...T,forceOpenWorkspaceAsFile:!0}),this.eb(B.fsPath,T)):this.cb(L,T)}cb(L,T){let B=this.db(L);const H=(0,O.getRemoteAuthority)(B)||T.remoteAuthority;if(B=(0,h.removeTrailingPathSeparator)((0,h.normalizePath)(B)),(0,X.isFileToOpen)(L)){if(T.gotoLineMode){const{path:j,line:$,column:q}=(0,f.parseLineAndColumnAware)(B.path);return{fileUri:B.with({path:j}),options:{selection:$?{startLineNumber:$,startColumn:q||1}:void 0},remoteAuthority:H}}return{fileUri:B,remoteAuthority:H}}else if((0,X.isWorkspaceToOpen)(L))return{workspace:(0,ce.getWorkspaceIdentifier)(B),remoteAuthority:H};return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(B),remoteAuthority:H}}db(L){return(0,X.isWorkspaceToOpen)(L)?L.workspaceUri:(0,X.isFolderToOpen)(L)?L.folderUri:L.fileUri}async eb(L,T){let B,H;T.gotoLineMode&&({path:L,line:B,column:H}=(0,f.parseLineAndColumnAware)(L)),L=(0,f.sanitizeFilePath)((0,g.normalize)(L),(0,o.cwd)());try{const j=await M.Promises.stat(L);if(j.isFile()){if(!T.forceOpenWorkspaceAsFile){const $=await this.D.resolveLocalWorkspace(k.URI.file(L));if($)return $.transient&&T.rejectTransientWorkspaces?void 0:{workspace:{id:$.id,configPath:$.configPath},type:s.FileType.File,exists:!0,remoteAuthority:$.remoteAuthority,transient:$.transient}}return{fileUri:k.URI.file(L),type:s.FileType.File,exists:!0,options:{selection:B?{startLineNumber:B,startColumn:H||1}:void 0}}}else{if(j.isDirectory())return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(k.URI.file(L),j),type:s.FileType.Directory,exists:!0};if(!w.isWindows&&L==="/dev/null")return{fileUri:k.URI.file(L),type:s.FileType.File,exists:!0}}}catch{const $=k.URI.file(L);if(this.C.removeRecentlyOpened([$]),T.ignoreFileNotFound)return{fileUri:$,type:s.FileType.File,exists:!1}}}fb(L,T){const B=L.charCodeAt(0),H=T.remoteAuthority;let j,$;T.gotoLineMode&&({path:L,line:j,column:$}=(0,f.parseLineAndColumnAware)(L)),B!==47&&((0,f.isWindowsDriveLetter)(B)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,f.toSlashes)(L)),L=`/${L}`);const q=k.URI.from({scheme:y.Schemas.vscodeRemote,authority:H,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,re.hasWorkspaceFileExtension)(L))return T.forceOpenWorkspaceAsFile?{fileUri:q,options:{selection:j?{startLineNumber:j,startColumn:$||1}:void 0},remoteAuthority:T.remoteAuthority}:{workspace:(0,ce.getWorkspaceIdentifier)(q),remoteAuthority:H};if(T.gotoLineMode||g.posix.basename(L).indexOf(".")!==-1)return{fileUri:q,options:{selection:j?{startLineNumber:j,startColumn:$||1}:void 0},remoteAuthority:H}}return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(q),remoteAuthority:H}}gb(L){const T=this.z.getValue("window"),B=T?.openFoldersInNewWindow||"default",H=T?.openFilesInNewWindow||"off";let j=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(B==="on"||B==="off")&&(j=B==="on");let $=!1;return L.forceNewWindow||L.forceReuseWindow?$=!!L.forceNewWindow&&!L.forceReuseWindow:(w.isMacintosh?L.context===1&&($=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&($=!0),!L.cli.extensionDevelopmentPath&&(H==="on"||H==="off")&&($=H==="on")),{openFolderInNewWindow:!!j,openFilesInNewWindow:$}}async openExtensionDevelopmentHostWindow(L,T){const B=(0,K.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(B)return this.v.reload(B,T.cli),B.focus(),[B];let H=T.cli["folder-uri"]||[],j=T.cli["file-uri"]||[],$=T.cli._;if(!$.length&&!H.length&&!j.length&&!T.cli.extensionTestsPath){const de=this.j.state.lastPluginDevelopmentHostWindow,pe=de?.workspace??de?.folderUri;pe&&(k.URI.isUri(pe)?pe.scheme===y.Schemas.file?$=[pe.fsPath]:H=[pe.toString()]:pe.configPath.scheme===y.Schemas.file?$=[(0,h.originalFSPath)(pe.configPath)]:j=[pe.configPath.toString()])}let q=T.remoteAuthority;for(const de of L)if(de.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const pe=k.URI.parse(de),ye=(0,O.getRemoteAuthority)(pe);ye&&(q?(0,h.isEqualAuthority)(ye,q)||this.m.error("more than one extension development path authority"):q=ye)}$=$.filter(de=>{const pe=k.URI.file(de);return(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe)?!1:(0,h.isEqualAuthority)((0,O.getRemoteAuthority)(pe),q)}),H=H.filter(de=>{const pe=this.Y(de);return pe&&!!(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe)?!1:pe?(0,h.isEqualAuthority)((0,O.getRemoteAuthority)(pe),q):!1}),j=j.filter(de=>{const pe=this.Y(de);return pe&&!!(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe)?!1:pe?(0,h.isEqualAuthority)((0,O.getRemoteAuthority)(pe),q):!1}),T.cli._=$,T.cli["folder-uri"]=H,T.cli["file-uri"]=j;const oe={context:T.context,cli:T.cli,forceNewWindow:!0,forceEmpty:!$.length&&!H.length&&!j.length,userEnv:T.userEnv,noRecentEntry:!0,waitMarkerFileURI:T.waitMarkerFileURI,remoteAuthority:q,forceProfile:T.forceProfile,forceTempProfile:T.forceTempProfile};return this.open(oe)}async hb(L){const T=this.z.getValue("window"),B=this.getLastActiveWindow(),H=B?.profile??this.u.defaultProfile;let j;!L.forceNewWindow&&!L.forceNewTabbedWindow&&(j=L.windowToUse||B,j&&j.focus());const $={...this.t.args,...L.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.t.appRoot,execPath:process.execPath,codeCachePath:this.t.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,g.join)(this.t.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.u.profiles,profile:H},homeDir:this.t.userHome.fsPath,tmpDir:this.t.tmpDir.fsPath,userDataDir:this.t.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.l,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.n.getLogLevel(),loggers:{window:[],global:this.n.getRegisteredLoggers()},logsPath:this.t.logsPath,product:l.default,isInitialStartup:L.initialStartup,perfMarks:(0,m.getMarks)(),os:{release:(0,n.release)(),hostname:(0,n.hostname)()},zoomLevel:typeof T?.zoomLevel=="number"?T.zoomLevel:void 0,autoDetectHighContrast:T?.autoDetectHighContrast??!0,autoDetectColorScheme:T?.autoDetectColorScheme??!1,accessibilitySupport:E.app.accessibilitySupportEnabled,colorScheme:this.L.getColorScheme(),policiesData:this.s.serialize(),continueOn:this.t.continueOn};if(j){const q=j.config;!$.extensionDevelopmentPath&&q?.extensionDevelopmentPath&&($.extensionDevelopmentPath=q.extensionDevelopmentPath,$.extensionDevelopmentKind=q.extensionDevelopmentKind,$["enable-proposed-api"]=q["enable-proposed-api"],$.verbose=q.verbose,$["inspect-extensions"]=q["inspect-extensions"],$["inspect-brk-extensions"]=q["inspect-brk-extensions"],$.debugId=q.debugId,$.extensionEnvironment=q.extensionEnvironment,$["extensions-dir"]=q["extensions-dir"],$["disable-extensions"]=q["disable-extensions"]),$.loggers=q?.loggers??$.loggers}else{const q=this.j.getNewWindowState($);(0,m.mark)("code/willCreateCodeWindow");const oe=j=this.F.createInstance(V.CodeWindow,{state:q,extensionDevelopmentPath:$.extensionDevelopmentPath,isExtensionTestHost:!!$.extensionTestsPath});(0,m.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(oe),lt.a.push(oe),this.b.fire(oe),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,d.once)(oe.onDidSignalReady)(()=>this.c.fire(oe)),(0,d.once)(oe.onDidClose)(()=>this.kb(oe)),(0,d.once)(oe.onDidDestroy)(()=>this.f.fire(oe)),oe.onDidTriggerSystemContextMenu(({x:pe,y:ye})=>this.h.fire({window:oe,x:pe,y:ye}));const de=(0,p.assertIsDefined)(oe.win?.webContents);de.removeAllListeners("devtools-reload-page"),de.on("devtools-reload-page",()=>this.v.reload(oe)),this.v.registerWindow(oe)}return $.windowId=j.id,j.isReady?this.v.unload(j,4).then(async q=>{q||await this.ib(j,$,L,H)}):await this.ib(j,$,L,H),j}async ib(L,T,B,H){if(T.extensionDevelopmentPath||((0,re.isWorkspaceIdentifier)(T.workspace)?T.backupPath=this.w.registerWorkspaceBackup({workspace:T.workspace,remoteAuthority:T.remoteAuthority}):(0,re.isSingleFolderWorkspaceIdentifier)(T.workspace)?T.backupPath=this.w.registerFolderBackup({folderUri:T.workspace.uri,remoteAuthority:T.remoteAuthority}):T.backupPath=this.w.registerEmptyWindowBackup({backupFolder:B.emptyWindowBackupInfo?.backupFolder??(0,ce.createEmptyWorkspaceIdentifier)().id,remoteAuthority:T.remoteAuthority})),this.u.isEnabled()){const j=T.workspace??(0,re.toWorkspaceIdentifier)(T.backupPath,!1),$=this.jb(B,j,H),q=$ instanceof Promise?await $:$;T.profiles.profile=q,T.extensionDevelopmentPath||await this.u.setProfileForWorkspace(j,q)}L.load(T)}jb(L,T,B){return L.forceProfile?this.u.profiles.find(H=>H.name===L.forceProfile)??this.u.createNamedProfile(L.forceProfile):L.forceTempProfile?this.u.createTransientProfile():this.u.getProfileForWorkspace(T)??B}kb(L){const T=lt.a.indexOf(L);lt.a.splice(T,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=E.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.mb(this.getWindows())}lb(L){return this.mb(this.getWindows().filter(T=>(0,h.isEqualAuthority)(T.remoteAuthority,L)))}mb(L){const T=Math.max.apply(Math,L.map(B=>B.lastFocusTime));return L.find(B=>B.lastFocusTime===T)}sendToFocused(L,...T){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,D.CancellationToken.None,...T)}sendToAll(L,T,B){for(const H of this.getWindows())B&&B.indexOf(H.id)>=0||H.sendWhenReady(L,D.CancellationToken.None,T)}getWindows(){return lt.a}getWindowCount(){return lt.a.length}getWindowById(L){const T=this.getWindows().filter(B=>B.id===L);return(0,C.firstOrDefault)(T)}getWindowByWebContents(L){const T=E.BrowserWindow.fromWebContents(L);if(!!T)return this.getWindowById(T.id)}};Z.a=[],Z=ve([_(2,r.ILogService),_(3,z.ILoggerMainService),_(4,N.IStateMainService),_(5,F.IPolicyService),_(6,i.IEnvironmentMainService),_(7,W.IUserDataProfilesMainService),_(8,u.ILifecycleMainService),_(9,R.IBackupMainService),_(10,t.IConfigurationService),_(11,fe.IWorkspacesHistoryMainService),_(12,ge.IWorkspacesManagementMainService),_(13,c.IInstantiationService),_(14,a.IDialogMainService),_(15,s.IFileService),_(16,I.IProductService),_(17,A.IProtocolMainService),_(18,x.IThemeMainService)],Z),e.WindowsMainService=Z}),define(ee[282],te([0,1,63,30,79,54]),function(G,e,E,M,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let D=class{constructor(f,d,b,v){this.a=f,this.b=d,this.c=b,this.d=v,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(f,d){const b=this.b.getWindowById(f);if(b)return this.a.enterWorkspace(b,this.b.getWindows(),d)}createUntitledWorkspace(f,d,b){return this.a.createUntitledWorkspace(d,b)}deleteUntitledWorkspace(f,d){return this.a.deleteUntitledWorkspace(d)}getWorkspaceIdentifier(f,d){return this.a.getWorkspaceIdentifier(d)}getRecentlyOpened(f){return this.c.getRecentlyOpened()}addRecentlyOpened(f,d){return this.c.addRecentlyOpened(d)}removeRecentlyOpened(f,d){return this.c.removeRecentlyOpened(d)}clearRecentlyOpened(f){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};D=ve([_(0,C.IWorkspacesManagementMainService),_(1,M.IWindowsMainService),_(2,n.IWorkspacesHistoryMainService),_(3,E.IBackupMainService)],D),e.WorkspacesMainService=D}),define(ee[283],te([0,1,14,42,26,17,44,13,32,50,43,45,2,15,9,4,10,7,31,136,47,150,105,256,153,63,274,19,75,186,88,121,58,108,209,28,62,112,199,222,200,261,109,201,202,16,213,90,74,6,89,275,235,258,21,5,280,59,20,56,268,92,34,264,96,93,24,240,114,52,49,247,248,276,249,277,117,251,252,253,254,262,30,281,263,29,97,79,282,54,257,37,221,53,231,57,78,119,266,272,270,8,115,265,216,65,48]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g,m,w,o,h,p,k,S,R,t,a,i,s,c,u,r,l,I,A,O,N,X,V,K,ie,re,ce,fe,ge,x,F,W,z,J,ne,se,Z,U,L,T,B,H,j,$,q,oe,de,pe,ye,Le,Fe,Te,we,Ce,Re,Q,ae,he,Pe,Me,Ae,Ue,He,Ne,$e,Ge,We,Ve,Y,le,ue,me,Se,Oe,ze,tt,Qe,Ke,et,it,ot,ut,Dt,Ct,Rt,Mt,At,Lt,gt,Ot,Tt,Ft,Ut,Wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let mt=class extends y.Disposable{constructor(ke,Ie,be,Ee,De,je,Xe,Ye,qe,Be,xe){super(),this.c=ke,this.f=Ie,this.g=be,this.h=Ee,this.i=De,this.j=je,this.k=Xe,this.l=Ye,this.m=qe,this.n=Be,this.p=xe,this.r(),this.s()}r(){const ke=qe=>qe?.startsWith(`${g.Schemas.vscodeWebview}://`),Ie=new Set(["clipboard-read","clipboard-sanitized-write"]);E.session.defaultSession.setPermissionRequestHandler((qe,Be,xe,Je)=>ke(Je.requestingUrl)?xe(Ie.has(Be)):xe(!1)),E.session.defaultSession.setPermissionCheckHandler((qe,Be,xe,Je)=>ke(Je.requestingUrl)?Ie.has(Be):!1);const be=new Set([g.Schemas.file,g.Schemas.vscodeFileResource,g.Schemas.vscodeRemoteResource,"devtools"]),Ee=qe=>{for(let Be=qe;Be;Be=Be.parent)if(Be.url.startsWith(`${g.Schemas.vscodeWebview}://`))return!0;return!1},De=qe=>qe.resourceType==="xhr"||Ee(qe.frame),je=qe=>{const Be=qe.frame;if(!Be||!this.a)return!1;const xe=E.BrowserWindow.getAllWindows();for(const Je of xe)if(Be.processId===Je.webContents.mainFrame.processId)return!0;return!1},Xe=(qe,Be)=>{if(qe.path!=="/index.html")return!0;const xe=Be.frame;if(!xe||!this.a)return!1;for(const Je of this.a.getWindows())if(Je.win&&xe.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};E.session.defaultSession.webRequest.onBeforeRequest((qe,Be)=>{const xe=h.URI.parse(qe.url);return xe.scheme===g.Schemas.vscodeWebview&&!Xe(xe,qe)?(this.h.error("Blocked vscode-webview request",qe.url),Be({cancel:!0})):xe.scheme===g.Schemas.vscodeFileResource&&!je(qe)?(this.h.error("Blocked vscode-file request",qe.url),Be({cancel:!0})):xe.path.endsWith(".svg")&&!be.has(xe.scheme)?Be({cancel:!De(qe)}):Be({cancel:!1})}),E.session.defaultSession.webRequest.onHeadersReceived((qe,Be)=>{const xe=qe.responseHeaders,Je=xe["content-type"]||xe["Content-Type"];if(Je&&Array.isArray(Je)){const Ze=h.URI.parse(qe.url);if(Ze.path.endsWith(".svg")&&be.has(Ze.scheme))return xe["Content-Type"]=["image/svg+xml"],Be({cancel:!1,responseHeaders:xe});if(!Ze.path.endsWith(g.Schemas.vscodeRemoteResource)&&Je.some(st=>st.toLowerCase().includes("image/svg")))return Be({cancel:!De(qe)})}return Be({cancel:!1})});const Ye=E.session.defaultSession;typeof Ye.setCodeCachePath=="function"&&this.i.codeCachePath&&Ye.setCodeCachePath((0,m.join)(this.i.codeCachePath,"chrome"))}s(){(0,P.setUnexpectedErrorHandler)(be=>this.u(be)),process.on("uncaughtException",be=>(0,P.onUnexpectedError)(be)),process.on("unhandledRejection",be=>(0,P.onUnexpectedError)(be)),this.j.onWillShutdown(()=>this.dispose()),(0,k.registerContextMenuListener)(),E.app.on("accessibility-support-changed",(be,Ee)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Ee)}),E.app.on("activate",async(be,Ee)=>{this.h.trace("app#activate"),Ee||await this.a?.openEmptyWindow({context:1})}),E.app.on("web-contents-created",(be,Ee)=>{Ee.on("will-navigate",De=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),De.preventDefault()}),Ee.setWindowOpenHandler(({url:De})=>(this.b?.openExternal(void 0,De),{action:"deny"}))});let ke=[],Ie;E.app.on("open-file",(be,Ee)=>{this.h.trace("app#open-file: ",Ee),be.preventDefault(),ke.push((0,Se.hasWorkspaceFileExtension)(Ee)?{workspaceUri:h.URI.file(Ee)}:{fileUri:h.URI.file(Ee)}),Ie!==void 0&&(clearTimeout(Ie),Ie=void 0),Ie=setTimeout(async()=>{await this.a?.open({context:1,cli:this.i.args,urisToOpen:ke,gotoLineMode:!1,preferNewWindow:!0}),ke=[],Ie=void 0},100)}),E.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),M.validatedIpcMain.handle("vscode:fetchShellEnv",be=>{const Ee=this.a?.getWindowByWebContents(be.sender);let De,je;return Ee?.config?(De=Ee.config,je={...process.env,...Ee.config.userEnv}):(De=this.i.args,je=process.env),this.M(De,je,!1)}),M.validatedIpcMain.handle("vscode:writeNlsFile",(be,Ee,De)=>{const je=this.t([Ee]);if(!je||typeof De!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.m.writeFile(je,C.VSBuffer.fromString(De))}),M.validatedIpcMain.handle("vscode:readNlsFile",async(be,...Ee)=>{const De=this.t(Ee);if(!De)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.m.readFile(De)).value.toString()}),M.validatedIpcMain.on("vscode:toggleDevTools",be=>be.sender.toggleDevTools()),M.validatedIpcMain.on("vscode:openDevTools",be=>be.sender.openDevTools()),M.validatedIpcMain.on("vscode:reloadWindow",be=>be.sender.reload())}t(ke){let Ie;for(const be of ke)typeof be=="string"&&(typeof Ie!="string"?Ie=be:Ie=(0,m.join)(Ie,be));if(!(typeof Ie!="string"||!(0,m.isAbsolute)(Ie)||!(0,f.isEqualOrParent)(Ie,this.i.cachedLanguagesPath,!w.isLinux)))return h.URI.file(Ie)}u(ke){if(ke){const Ie={message:`[uncaught exception in main]: ${ke.message}`,stack:ke.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Ie))}this.h.error(`[uncaught exception in main]: ${ke}`),ke.stack&&this.h.error(ke.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.i.appRoot}`),this.h.debug("args:",this.i.args);const ke=this.n.win32AppUserModelId;w.isWindows&&ke&&E.app.setAppUserModelId(ke);try{w.isMacintosh&&this.k.getValue("window.nativeTabs")===!0&&!E.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&E.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Be){this.h.error(Be)}const Ie=new R.Server;this.j.onWillShutdown(Be=>{Be.reason===2&&Ie.dispose()}),this.h.trace("Resolving machine identifier...");const be=await(0,Ot.resolveMachineId)(this.l);this.h.trace(`Resolved machine identifier: ${be}`);const{sharedProcess:Ee,sharedProcessReady:De,sharedProcessClient:je}=this.D(be),Xe=await this.F(be,Ee,De);this.B(Xe.createInstance(a.ProxyAuthHandler)),this.B(Xe.createInstance(At.UserDataProfilesHandler)),Xe.invokeFunction(Be=>this.G(Be,Ie,je));const Ye=Xe.invokeFunction(Be=>this.v(Be,Ie));this.j.phase=2,await Xe.invokeFunction(Be=>this.H(Be,Ye)),this.j.phase=3,Xe.invokeFunction(Be=>this.I(Be,Ee)),this.B(new gt.RunOnceScheduler(()=>{this.B((0,gt.runWhenIdle)(()=>this.j.phase=4,2500))},2500)).schedule()}v(ke,Ie){const be=this.a=ke.get(le.IWindowsMainService),Ee=ke.get(Ne.IURLService),De=this.b=ke.get(q.INativeHostMainService),je=this;Ee.registerHandler({async handleURL(Je,Ze){return je.C(be,Ee,Je,Ze)}});const Xe=this.B(new me.ActiveWindowManager({onDidOpenWindow:De.onDidOpenWindow,onDidFocusWindow:De.onDidFocusWindow,getActiveWindowId:()=>De.getActiveWindowId(-1)})),Ye=new S.StaticRouter(Je=>Xe.getActiveClientId().then(Ze=>Je===Ze)),qe=new $e.URLHandlerRouter(Ye,this.h),Be=Ie.getChannel("urlHandler",qe);Ee.registerHandler(new $e.URLHandlerChannelClient(Be));const xe=this.w();return this.B(new We.ElectronURLListener(xe?.urls,Ee,be,this.i,this.n,this.h)),xe}w(){const ke=this.i.args["open-url"]?this.i.args._urls||[]:[];ke.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",ke);const Ie=global.getOpenUrls()||[];if(Ie.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Ie),ke.length+Ie.length===0)return;const be=[];return{urls:[...ke,...Ie].map(De=>{try{return{uri:h.URI.parse(De),originalUrl:De}}catch{this.h.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",De);return}}).filter(De=>{if(!De)return!1;if(this.y(De.uri))return this.h.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",De.uri.toString(!0)),!1;const je=this.z(De.uri);return je?(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",De.uri.toString(!0),je),be.push(je),!1):(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",De.uri.toString(!0)),!0)}),openables:be}}y(ke){if(ke.authority===g.Schemas.file&&w.isWindows){const{options:Ie,buttonIndeces:be}=(0,Wt.massageMessageBoxOptions)({type:"question",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,v.getPathLabel)(ke,{os:w.OS,tildify:this.i}),this.n.nameShort),detail:(0,i.localize)(3,null)},this.n);if(be[E.dialog.showMessageBoxSync(Ie)]===1)return!0}return!1}z(ke){if(!!ke.path){if(ke.authority===g.Schemas.file){const Ie=h.URI.file(ke.fsPath);return(0,Se.hasWorkspaceFileExtension)(Ie)?{workspaceUri:Ie}:{fileUri:Ie}}else if(ke.authority===g.Schemas.vscodeRemote){const Ie=ke.path.indexOf(m.posix.sep,1);if(Ie!==-1){const be=ke.path.substring(1,Ie),Ee=ke.path.substring(Ie),De=h.URI.from({scheme:g.Schemas.vscodeRemote,authority:be,path:Ee,query:ke.query,fragment:ke.fragment});return(0,Se.hasWorkspaceFileExtension)(Ee)?{workspaceUri:De}:/:[\d]+$/.test(Ee)?{fileUri:De}:{folderUri:De}}}}}async C(ke,Ie,be,Ee){if(this.h.trace("app#handleProtocolUrl():",be.toString(!0),Ee),be.scheme===this.n.urlProtocol&&be.path==="workspace"&&(be=be.with({authority:"file",path:h.URI.parse(be.query).path,query:""})),this.y(be))return this.h.trace("app#handleProtocolUrl() protocol url was blocked:",be.toString(!0)),!0;let De=!1;const je=new URLSearchParams(be.query);je.get("windowId")==="_blank"?(this.h.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",be.toString(!0)),je.delete("windowId"),be=be.with({query:je.toString()}),De=!0):w.isMacintosh&&ke.getWindowCount()===0&&(this.h.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",be.toString(!0)),De=!0);const Xe=je.get("continueOn");Xe!==null&&(this.h.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",be.toString(!0)),je.delete("continueOn"),be=be.with({query:je.toString()}),this.i.continueOn=Xe??void 0);const Ye=this.z(be);if(Ye){this.h.trace("app#handleProtocolUrl() opening protocol url as window:",Ye,be.toString(!0));const[qe]=await ke.open({context:5,cli:{...this.i.args},urisToOpen:[Ye],forceNewWindow:De,gotoLineMode:!0});return qe.focus(),!0}if(De){this.h.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",be.toString(!0));const[qe]=await ke.open({context:5,cli:{...this.i.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,de.getRemoteAuthority)(be)});return await qe.ready(),Ie.open(be,Ee)}return this.h.trace("app#handleProtocolUrl(): not handled",be.toString(!0),Ee),!1}D(ke){const Ie=this.B(this.g.createInstance(pe.SharedProcess,ke,this.f)),be=(async()=>{this.h.trace("Main->SharedProcess#connect");const De=await Ie.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new t.Client(De,"main")})(),Ee=(async()=>(await Ie.whenReady(),be))();return{sharedProcess:Ie,sharedProcessReady:Ee,sharedProcessClient:be}}async F(ke,Ie,be){const Ee=new U.ServiceCollection;switch(process.platform){case"win32":Ee.set(he.IUpdateService,new se.SyncDescriptor(He.Win32UpdateService));break;case"linux":w.isLinuxSnap?Ee.set(he.IUpdateService,new se.SyncDescriptor(Ue.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ee.set(he.IUpdateService,new se.SyncDescriptor(Ae.LinuxUpdateService));break;case"darwin":Ee.set(he.IUpdateService,new se.SyncDescriptor(Me.DarwinUpdateService));break}Ee.set(le.IWindowsMainService,new se.SyncDescriptor(ue.WindowsMainService,[ke,this.f],!1));const De=new O.DialogMainService(this.h);Ee.set(O.IDialogMainService,De),Ee.set(B.ILaunchMainService,new se.SyncDescriptor(B.LaunchMainService,void 0,!1)),Ee.set(A.IDiagnosticsMainService,new se.SyncDescriptor(A.DiagnosticsMainService,void 0,!1)),Ee.set(I.IDiagnosticsService,S.ProxyChannel.toService((0,S.getDelayedChannel)(be.then(Ye=>Ye.getChannel("diagnostics"))))),Ee.set(L.IIssueMainService,new se.SyncDescriptor(L.IssueMainService,[this.f])),Ee.set(N.IEncryptionMainService,new se.SyncDescriptor(X.EncryptionMainService,[ke])),Ee.set(T.IKeyboardLayoutMainService,new se.SyncDescriptor(T.KeyboardLayoutMainService)),Ee.set(q.INativeHostMainService,new se.SyncDescriptor(q.NativeHostMainService,[Ie],!1)),Ee.set(r.ICredentialsMainService,new se.SyncDescriptor(Ke.CredentialsNativeMainService)),Ee.set(Ve.IWebviewManagerService,new se.SyncDescriptor(Y.WebviewMainService)),Ee.set($.IMenubarMainService,new se.SyncDescriptor($.MenubarMainService)),Ee.set(re.IExtensionUrlTrustService,new se.SyncDescriptor(ce.ExtensionUrlTrustService)),Ee.set(fe.IExtensionHostStarter,new se.SyncDescriptor(ge.ExtensionHostStarter)),Ee.set(Te.IStorageMainService,new se.SyncDescriptor(Te.StorageMainService)),Ee.set(Te.IApplicationStorageMainService,new se.SyncDescriptor(Te.ApplicationStorageMainService)),w.isWindows?Ee.set(x.IExternalTerminalMainService,new se.SyncDescriptor(F.WindowsExternalTerminalService)):w.isMacintosh?Ee.set(x.IExternalTerminalMainService,new se.SyncDescriptor(F.MacExternalTerminalService)):w.isLinux&&Ee.set(x.IExternalTerminalMainService,new se.SyncDescriptor(F.LinuxExternalTerminalService));const je=new c.BackupMainService(this.i,this.k,this.h,this.l);Ee.set(s.IBackupMainService,je);const Xe=new Qe.WorkspacesManagementMainService(this.i,this.h,this.p,je,De,this.n);if(Ee.set(Qe.IWorkspacesManagementMainService,Xe),Ee.set(Oe.IWorkspacesService,new se.SyncDescriptor(tt.WorkspacesMainService,void 0,!1)),Ee.set(ze.IWorkspacesHistoryMainService,new se.SyncDescriptor(ze.WorkspacesHistoryMainService,void 0,!1)),Ee.set(Ne.IURLService,new se.SyncDescriptor(Ge.NativeURLService,void 0,!1)),(0,ae.supportsTelemetry)(this.n,this.i)){const Ye=(0,ae.isInternalTelemetry)(this.n,this.k),qe=(0,S.getDelayedChannel)(be.then(st=>st.getChannel("telemetryAppender"))),Be=new Re.TelemetryAppenderClient(qe),xe=(0,we.resolveCommonProperties)(this.m,(0,n.release)(),(0,n.hostname)(),process.arch,this.n.commit,this.n.version,ke,Ye,this.i.installSourcePath),Je=(0,ae.getPiiPathsFromEnvironment)(this.i),Ze={appenders:[Be],commonProperties:xe,piiPaths:Je,sendErrorTelemetry:!0};Ee.set(Ce.ITelemetryService,new se.SyncDescriptor(Q.TelemetryService,[Ze],!1))}else Ee.set(Ce.ITelemetryService,ae.NullTelemetryService);return Ee.set(Ct.IExtensionsProfileScannerService,new se.SyncDescriptor(Tt.ExtensionsProfileScannerService,void 0,!0)),Ee.set(Rt.IExtensionsScannerService,new se.SyncDescriptor(Mt.ExtensionsScannerService,void 0,!0)),await gt.Promises.settled([je.initialize(),Xe.initialize()]),this.g.createChild(Ee)}G(ke,Ie,be){const Ee=S.ProxyChannel.fromService(ke.get(B.ILaunchMainService),{disableMarshalling:!0});this.c.registerChannel("launch",Ee);const De=S.ProxyChannel.fromService(ke.get(A.IDiagnosticsMainService),{disableMarshalling:!0});this.c.registerChannel("diagnostics",De);const je=new it.PolicyChannel(ke.get(et.IPolicyService));Ie.registerChannel("policy",je),be.then(_e=>_e.registerChannel("policy",je));const Xe=this.m.getProvider(g.Schemas.file);(0,o.assertType)(Xe instanceof ne.DiskFileSystemProvider);const Ye=new J.DiskFileSystemProviderChannel(Xe,this.h,this.i);Ie.registerChannel(W.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Ye),be.then(_e=>_e.registerChannel(W.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Ye));const qe=S.ProxyChannel.fromService(ke.get(ot.IUserDataProfilesMainService));Ie.registerChannel("userDataProfiles",qe),be.then(_e=>_e.registerChannel("userDataProfiles",qe));const Be=new ut.RequestChannel(ke.get(Dt.IRequestService));be.then(_e=>_e.registerChannel("request",Be));const xe=new Pe.UpdateChannel(ke.get(he.IUpdateService));Ie.registerChannel("update",xe);const Je=S.ProxyChannel.fromService(ke.get(L.IIssueMainService));Ie.registerChannel("issue",Je);const Ze=S.ProxyChannel.fromService(ke.get(N.IEncryptionMainService));Ie.registerChannel("encryption",Ze);const st=S.ProxyChannel.fromService(ke.get(r.ICredentialsMainService));Ie.registerChannel("credentials",st);const rt=S.ProxyChannel.fromService(ke.get(ye.ISignService));Ie.registerChannel("sign",rt);const ht=S.ProxyChannel.fromService(ke.get(T.IKeyboardLayoutMainService));Ie.registerChannel("keyboardLayout",ht),this.b=ke.get(q.INativeHostMainService);const yt=S.ProxyChannel.fromService(this.b);Ie.registerChannel("nativeHost",yt),be.then(_e=>_e.registerChannel("nativeHost",yt));const Nt=S.ProxyChannel.fromService(ke.get(Oe.IWorkspacesService));Ie.registerChannel("workspaces",Nt);const jt=S.ProxyChannel.fromService(ke.get($.IMenubarMainService));Ie.registerChannel("menubar",jt);const Bt=S.ProxyChannel.fromService(ke.get(Ne.IURLService));Ie.registerChannel("url",Bt);const $t=S.ProxyChannel.fromService(ke.get(re.IExtensionUrlTrustService));Ie.registerChannel("extensionUrlTrust",$t);const zt=S.ProxyChannel.fromService(ke.get(Ve.IWebviewManagerService));Ie.registerChannel("webview",zt);const St=this.B(new Fe.StorageDatabaseChannel(this.h,ke.get(Te.IStorageMainService)));Ie.registerChannel("storage",St),be.then(_e=>_e.registerChannel("storage",St));const qt=this.B(new Lt.ProfileStorageChangesListenerChannel(ke.get(Te.IStorageMainService),ke.get(ot.IUserDataProfilesMainService),this.h));be.then(_e=>_e.registerChannel("profileStorageListener",qt));const Ht=S.ProxyChannel.fromService(ke.get(x.IExternalTerminalMainService));Ie.registerChannel("externalTerminal",Ht);const Et=new Ft.LoggerChannel(ke.get(Ut.ILoggerMainService));Ie.registerChannel("logger",Et),be.then(_e=>_e.registerChannel("logger",Et));const Vt=new l.ElectronExtensionHostDebugBroadcastChannel(ke.get(le.IWindowsMainService));Ie.registerChannel("extensionhostdebugservice",Vt);const xt=S.ProxyChannel.fromService(ke.get(fe.IExtensionHostStarter));Ie.registerChannel(fe.ipcExtensionHostStarterChannelName,xt)}async H(ke,Ie){const be=this.a=ke.get(le.IWindowsMainService),Ee=(0,K.isLaunchedFromCli)(process.env)?0:4,De=this.i.args;if(Ie){if(Ie.openables.length>0)return be.open({context:Ee,cli:De,urisToOpen:Ie.openables,gotoLineMode:!0,initialStartup:!0});if(Ie.urls.length>0)for(const rt of Ie.urls){const ht=new URLSearchParams(rt.uri.query);if(ht.get("windowId")==="_blank")return ht.delete("windowId"),rt.originalUrl=rt.uri.toString(!0),rt.uri=rt.uri.with({query:ht.toString()}),be.open({context:Ee,cli:De,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const je=global.macOpenFiles,Xe=De._.length,Ye=!!De["folder-uri"],qe=!!De["file-uri"],Be=De["skip-add-to-recently-opened"]===!0,xe=De.wait&&De.waitMarkerFilePath?h.URI.file(De.waitMarkerFilePath):void 0,Je=De.remote||void 0,Ze=De.profile,st=De["profile-temp"];if(!Xe&&!Ye&&!qe){if(De["new-window"]||Ze||st)return be.open({context:Ee,cli:De,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Be,waitMarkerFileURI:xe,initialStartup:!0,remoteAuthority:Je,forceProfile:Ze,forceTempProfile:st});if(je.length)return be.open({context:1,cli:De,urisToOpen:je.map(rt=>(0,Se.hasWorkspaceFileExtension)(rt)?{workspaceUri:h.URI.file(rt)}:{fileUri:h.URI.file(rt)}),noRecentEntry:Be,waitMarkerFileURI:xe,initialStartup:!0})}return be.open({context:Ee,cli:De,forceNewWindow:De["new-window"]||!Xe&&De["unity-launch"],diffMode:De.diff,mergeMode:De.merge,noRecentEntry:Be,waitMarkerFileURI:xe,gotoLineMode:De.goto,initialStartup:!0,remoteAuthority:Je,forceProfile:Ze,forceTempProfile:st})}I(ke,Ie){const be=ke.get(Ce.ITelemetryService),Ee=ke.get(he.IUpdateService);this.L(be,Ie),this.J(),E.protocol.registerHttpProtocol(g.Schemas.vscodeRemoteResource,(De,je)=>{je({url:De.url.replace(/^vscode-remote-resource:/,"http:"),method:De.method})}),(Ee instanceof He.Win32UpdateService||Ee instanceof Ae.LinuxUpdateService||Ee instanceof Me.DarwinUpdateService)&&Ee.initialize(),this.M(this.i.args,process.env,!0),this.N()}async J(){const ke=this.n.win32MutexName;if(w.isWindows&&ke)try{const Ie=await new Promise((Ee,De)=>{G(["windows-mutex"],Ee,De)}),be=new Ie.Mutex(ke);(0,d.once)(this.j.onWillShutdown)(()=>be.release())}catch(Ie){this.h.error(Ie)}}L(ke,Ie){let be=!1;(0,d.once)(this.j.onWillShutdown)(()=>be=!0),this.B(Ie.onDidError(({type:Ee,details:De})=>{let je;switch(Ee){case 1:je="SharedProcess: detected unresponsive window";break;case 2:je=`SharedProcess: renderer process gone (detail: ${De?.reason??"<unknown>"}, code: ${De?.exitCode??"<unknown>"})`;break;case 3:je=`SharedProcess: failed to load (detail: ${De?.reason??"<unknown>"}, code: ${De?.exitCode??"<unknown>"})`;break}(0,P.onUnexpectedError)(new Error(je)),ke.publicLog2("sharedprocesserror",{type:Ee,reason:De?.reason,code:De?.exitCode,visible:Ie.isVisible(),shuttingdown:be})}))}async M(ke,Ie,be){try{return await(0,ie.getResolvedShellEnv)(this.k,this.h,ke,Ie)}catch(Ee){const De=(0,D.toErrorMessage)(Ee);be?this.a?.sendToFocused("vscode:showResolveShellEnvError",De):this.h.error(De)}return{}}async N(){try{const Ie=(await this.m.readFile(this.i.argvResource)).value.toString(),be=JSON.parse((0,b.stripComments)(Ie)),De=(0,ae.getTelemetryLevel)(this.k)>=1;if(be["enable-crash-reporter"]===void 0){const je=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${De},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,p.generateUuid)()}"`,"}"],Xe=Ie.substring(0,Ie.length-2).concat(`,
`,je.join(`
`));await this.m.writeFile(this.i.argvResource,C.VSBuffer.fromString(Xe))}else{const je=Ie.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${De},`);je!==Ie&&await this.m.writeFile(this.i.argvResource,C.VSBuffer.fromString(je))}}catch(ke){this.h.error(ke)}}};mt=ve([_(2,Z.IInstantiationService),_(3,j.ILogService),_(4,V.IEnvironmentMainService),_(5,H.ILifecycleMainService),_(6,u.IConfigurationService),_(7,Le.IStateMainService),_(8,z.IFileService),_(9,oe.IProductService),_(10,ot.IUserDataProfilesMainService)],mt),e.CodeApplication=mt}),define(ee[284],te([0,1,37,8,291,2,5]),function(G,e,E,M,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let P=class extends E.AbstractPolicyService{constructor(d,b){super(),this.j=d,this.k=b,this.a=new M.Throttler,this.b=this.B(new C.MutableDisposable)}async i(d){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(d).length} policy definitions`),await this.a.queue(()=>new Promise((b,v)=>{try{this.b.value=(0,n.createWatcher)(this.k,d,y=>{this.m(y),b()})}catch(y){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),v(y)}}))}m(d){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(d)}`);for(const b in d){const v=d[b];v===void 0?this.g.delete(b):this.g.set(b,v)}this.h.fire(Object.keys(d))}};P=ve([_(0,D.ILogService)],P),e.NativePolicyService=P}),define(ee[285],te([0,1,233,8,17,13,2,10,19,33,112,5,232,292]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let m=class extends D.Disposable{constructor(o,h,p){super(),this.h=o,this.i=h,this.j=p,this.k(),this.B(o.onDidChangeConfiguration(k=>{k.affectsConfiguration("http")&&this.k()}))}k(){const o=this.h.getValue("http");this.a=o?.proxy,this.b=!!o?.proxyStrictSSL,this.f=o?.proxyAuthorization}async request(o,h){this.j.trace("RequestService#request (node) - begin",o.url);const{a:p,b:k}=this;let S;try{S=await(0,b.getResolvedShellEnv)(this.h,this.j,this.i.args,process.env)}catch(a){this.g||(this.g=!0,this.j.error("RequestService#request (node) resolving shell environment failed",a))}const R={...process.env,...S},t=o.agent?o.agent:await(0,y.getProxyAgent)(o.url||"",R,{proxyUrl:p,strictSSL:k});o.agent=t,o.strictSSL=k,this.f&&(o.headers={...o.headers||{},"Proxy-Authorization":this.f});try{const a=await this.m(o,h);return this.j.trace("RequestService#request (node) - success",o.url),a}catch(a){throw this.j.trace("RequestService#request (node) - error",o.url,a),a}}async l(o){return((0,E.parse)(o.url).protocol==="https:"?await new Promise((k,S)=>{G(["https"],k,S)}):await new Promise((k,S)=>{G(["http"],k,S)})).request}m(o,h){return M.Promises.withAsyncBody(async(p,k)=>{const S=(0,E.parse)(o.url),R=o.getRawRequest?o.getRawRequest(o):await this.l(o),t={hostname:S.hostname,port:S.port?parseInt(S.port):S.protocol==="https:"?443:80,protocol:S.protocol,path:S.path,method:o.type||"GET",headers:o.headers,agent:o.agent,rejectUnauthorized:(0,P.isBoolean)(o.strictSSL)?o.strictSSL:!0};o.user&&o.password&&(t.auth=o.user+":"+o.password);const a=R(t,i=>{const s=(0,P.isNumber)(o.followRedirects)?o.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)this.m({...o,url:i.headers.location,followRedirects:s-1},h).then(p,k);else{let c=i;!o.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(c=i.pipe((0,g.createGunzip)())),p({res:i,stream:(0,n.streamToBufferReadableStream)(c)})}});a.on("error",k),o.timeout&&a.setTimeout(o.timeout),o.isChromiumNetwork&&a.removeHeader("Content-Length"),o.data&&typeof o.data=="string"&&a.write(o.data),a.end(),h.onCancellationRequested(()=>{a.abort(),k(new C.CancellationError)})})}async resolveProxy(o){}};m=ve([_(0,f.IConfigurationService),_(1,d.INativeEnvironmentService),_(2,v.ILogService)],m),e.RequestService=m}),define(ee[286],te([0,1,14,285]),function(G,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function n(D){return E.net.request}class C extends M.RequestService{request(P,f){return super.request({...P||{},getRawRequest:n,isChromiumNetwork:!0},f)}}e.RequestMainService=C}),define(ee[293],te([0,1,14,41,7,25,8,44,13,32,50,45,15,9,64,4,36,27,23,47,87,283,11,19,226,239,28,62,190,16,211,90,74,207,89,21,214,5,66,20,67,267,116,245,57,286,92,234,34,238,52,69,53,37,284,220,2,38,250,65,215,48,246]),function(G,e,E,M,n,C,D,P,f,d,b,v,y,g,m,w,o,h,p,k,S,R,t,a,i,s,c,u,r,l,I,A,O,N,X,V,K,ie,re,ce,fe,ge,x,F,W,z,J,ne,se,Z,U,L,T,B,H,j,$,q,oe,de,pe,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Le{main(){try{this.a()}catch(we){console.error(we.message),E.app.exit(1)}}async a(){(0,f.setUnexpectedErrorHandler)(Ae=>console.error(Ae));const[we,Ce,Re,Q,ae,he,Pe,Me]=this.b();try{try{await this.d(Re,Me,Q,ae,Pe)}catch(Ae){throw this.f(Re,Pe,Ae),Ae}await we.invokeFunction(async Ae=>{const Ue=Ae.get(ie.ILogService),He=Ae.get(V.ILifecycleMainService),Ne=Ae.get(l.IFileService),$e=Ae.get(ie.ILoggerService),Ge=await this.e(Ue,Re,He,we,Pe,!0);return p.Promises.writeFile(Re.mainLockfile,String(process.pid)).catch(We=>{Ue.warn(`Error writing main lockfile: ${We.stack}`)}),he.logger=$e.createLogger(n.URI.file((0,g.join)(Re.logsPath,"main.log")),{id:"mainLog",name:(0,t.localize)(0,null)}),(0,b.once)(He.onWillShutdown)(We=>{Ne.dispose(),Q.dispose(),We.join(p.Promises.unlink(Re.mainLockfile).catch(()=>{}))}),we.createInstance(R.CodeApplication,Ge,Ce).startup()})}catch(Ae){we.invokeFunction(this.i,Ae)}}b(){const we=new X.ServiceCollection,Ce=new $.DisposableStore;process.once("exit",()=>Ce.dispose());const Re={_serviceBrand:void 0,...re.default};we.set(ce.IProductService,Re);const Q=new c.EnvironmentMainService(this.j(),Re),ae=this.c(Q);we.set(c.IEnvironmentMainService,Q);const he=new de.LoggerMainService((0,ie.getLogLevel)(Q));we.set(de.ILoggerMainService,he);const Pe=new K.BufferLogger(he.getLogLevel()),Me=Ce.add(new pe.LogService(Pe,[new ie.ConsoleMainLogger(he.getLogLevel())]));we.set(ie.ILogService,Me);const Ae=new I.FileService(Me);we.set(l.IFileService,Ae);const Ue=new A.DiskFileSystemProvider(Me);Ae.registerProvider(y.Schemas.file,Ue);const He=new oe.UriIdentityService(Ae);we.set(q.IUriIdentityService,He);const Ne=new Z.StateMainService(Q,Me,Ae);we.set(se.IStateMainService,Ne);const $e=new T.UserDataProfilesMainService(Ne,He,Q,Ae,Me);we.set(T.IUserDataProfilesMainService,$e);const Ge=w.isWindows&&Re.win32RegValueName?Ce.add(new H.NativePolicyService(Me,Re.win32RegValueName)):Q.policyFile?Ce.add(new j.FilePolicyService(Q.policyFile,Ae,Me)):new B.NullPolicyService;we.set(B.IPolicyService,Ge);const We=new i.ConfigurationService($e.defaultProfile.settingsResource,Ae,Ge,Me);return we.set(a.IConfigurationService,We),we.set(V.ILifecycleMainService,new O.SyncDescriptor(V.LifecycleMainService,void 0,!1)),we.set(W.IRequestService,new O.SyncDescriptor(z.RequestMainService,void 0,!0)),we.set(L.IThemeMainService,new O.SyncDescriptor(L.ThemeMainService)),we.set(J.ISignService,new O.SyncDescriptor(ne.SignService,void 0,!1)),we.set(x.ITunnelService,new O.SyncDescriptor(F.TunnelService)),we.set(fe.IProtocolMainService,new ge.ProtocolMainService(Q,$e,Me)),[new N.InstantiationService(we,!0),ae,Q,We,Ne,Pe,Re,$e]}c(we){const Ce={VSCODE_IPC_HOOK:we.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Re=>{const Q=process.env[Re];typeof Q=="string"&&(Ce[Re]=Q)}),Object.assign(process.env,Ce),Ce}async d(we,Ce,Re,Q,ae){await D.Promises.settled([Promise.all([we.extensionsPath,we.codeCachePath,we.logsPath,Ce.defaultProfile.globalStorageHome.fsPath,we.workspaceStorageHome.fsPath,we.localHistoryHome.fsPath,we.backupHome].map(he=>he?p.Promises.mkdir(he,{recursive:!0}):void 0)),Q.init(),Re.initialize()]),Ce.init()}async e(we,Ce,Re,Q,ae,he){let Pe;try{(0,m.mark)("code/willStartMainServer"),Pe=await(0,S.serve)(Ce.mainIPCHandle),(0,m.mark)("code/didStartMainServer"),(0,b.once)(Re.onWillShutdown)(()=>Pe.dispose())}catch(Me){if(Me.code!=="EADDRINUSE")throw this.f(Ce,ae,Me),Me;let Ae;try{Ae=await(0,S.connect)(Ce.mainIPCHandle,"main")}catch($e){if(!he||w.isWindows||$e.code!=="ECONNREFUSED")throw $e.code==="EPERM"&&this.g((0,t.localize)(1,null,ae.nameShort),(0,t.localize)(2,null),ae),$e;try{(0,M.unlinkSync)(Ce.mainIPCHandle)}catch(Ge){throw we.warn("Could not delete obsolete instance handle",Ge),Ge}return this.e(we,Ce,Re,Q,ae,!1)}if(Ce.extensionTestsLocationURI&&!Ce.debugExtensionHost.break){const $e=`Running extension tests from the command line is currently only supported if no other instance of ${ae.nameShort} is running.`;throw we.error($e),Ae.dispose(),new Error($e)}let Ue;!Ce.args.wait&&!Ce.args.status&&(Ue=setTimeout(()=>{this.g((0,t.localize)(3,null,ae.nameShort),(0,t.localize)(4,null),ae)},1e4));const He=k.ProxyChannel.toService(Ae.getChannel("launch"),{disableMarshalling:!0}),Ne=k.ProxyChannel.toService(Ae.getChannel("diagnostics"),{disableMarshalling:!0});if(Ce.args.status)return Q.invokeFunction(async()=>{const $e=new s.DiagnosticsService(U.NullTelemetryService,ae),Ge=await Ne.getMainDiagnostics(),We=await Ne.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ve=await $e.getDiagnostics(Ge,We);throw console.log(Ve),new f.ExpectedError});throw w.isWindows&&await this.h(He,we),we.trace("Sending env to running instance..."),await He.start(Ce.args,process.env),Ae.dispose(),Ue&&clearTimeout(Ue),new f.ExpectedError("Sent env to running instance. Terminating...")}if(Ce.args.status)throw we.warn(`Warning: The --status argument can only be used if ${ae.nameShort} is already running. Please run it again after {0} has started.`),new f.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Pe}f(we,Ce,Re){if(Re.code==="EACCES"||Re.code==="EPERM"){const Q=(0,C.coalesce)([we.userDataPath,we.extensionsPath,S.XDG_RUNTIME_DIR]).map(ae=>(0,v.getPathLabel)(n.URI.file(ae),{os:w.OS,tildify:we}));this.g((0,t.localize)(5,null),(0,t.localize)(6,null,(0,P.toErrorMessage)(Re),Q.join(`
`)),Ce)}}g(we,Ce,Re){E.dialog.showMessageBoxSync((0,ye.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(7,null)],message:we,detail:Ce},Re).options)}async h(we,Ce){if(w.isWindows){const Re=await we.getMainProcessId();Ce.trace("Sending some foreground love to the running instance:",Re);try{(await new Promise((Q,ae)=>{G(["windows-foreground-love"],Q,ae)})).allowSetForegroundWindow(Re)}catch(Q){Ce.error(Q)}}}i(we,Ce){const Re=we.get(ie.ILogService),Q=we.get(V.ILifecycleMainService);let ae=0;Ce&&(Ce.isExpected?Ce.message&&Re.trace(Ce.message):(ae=1,Ce.stack?Re.error(Ce.stack):Re.error(`Startup error: ${Ce.toString()}`))),Q.kill(ae)}j(){const we=this.k((0,u.parseMainProcessArgv)(process.argv));if(we.wait&&!we.waitMarkerFilePath){const Ce=(0,r.createWaitMarkerFileSync)(we.verbose);Ce&&((0,u.addArg)(process.argv,"--waitMarkerFilePath",Ce),we.waitMarkerFilePath=Ce)}return we}k(we){if(we["open-url"]&&(we._urls=we._,we._=[]),!we.remote){const Ce=this.l(we._,we.goto);we._=Ce}return we}l(we,Ce){const Re=(0,o.cwd)(),Q=we.map(Pe=>{let Me=String(Pe),Ae;Ce&&(Ae=(0,d.parseLineAndColumnAware)(Me),Me=Ae.path),Me&&(Me=this.m(Re,Me));const Ue=(0,d.sanitizeFilePath)(Me,Re),He=(0,g.basename)(Ue);return He&&!(0,d.isValidBasename)(He)?null:Ce&&Ae?(Ae.path=Ue,this.n(Ae)):Ue}),ae=w.isWindows||w.isMacintosh,he=(0,C.distinct)(Q,Pe=>Pe&&ae?Pe.toLowerCase():Pe||"");return(0,C.coalesce)(he)}m(we,Ce){return w.isWindows&&(Ce=(0,h.rtrim)(Ce,'"')),Ce=(0,h.trim)((0,h.trim)(Ce," "),"	"),w.isWindows&&(Ce=(0,g.resolve)(we,Ce),Ce=(0,h.rtrim)(Ce,".")),Ce}n(we){const Ce=[we.path];return typeof we.line=="number"&&Ce.push(String(we.line)),typeof we.column=="number"&&Ce.push(String(we.column)),Ce.join(":")}}new Le().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ac229ad6e485f87b5c172a909c5aafe333cad9ce/core/vs/code/electron-main/main.js.map
