/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/types","vs/base/common/path","vs/base/common/errors","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/editor/common/core/range","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","vs/base/common/severity","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/stopwatch","vs/platform/files/common/files","vs/base/common/errorMessage","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/themables","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/codicons","vs/base/common/ternarySearchTree","vs/base/common/marshalling","fs","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/normalization","vs/base/common/mime","vs/base/common/hash","os","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/processes","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/actions","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(ne){for(var e=[],c=0,A=ne.length;c<A;c++)e[c]=ye[ne[c]];return e};define(ye[61],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function c(C,P){const S=Object.create(null);for(const I of C){const L=P(I);let k=S[L];k||(k=S[L]=[]),k.push(I)}return S}e.groupBy=c;function A(C,P){const S=[],I=[];for(const L of C)P.has(L)||S.push(L);for(const L of P)C.has(L)||I.push(L);return{removed:S,added:I}}e.diffSets=A;function u(C,P){const S=[],I=[];for(const[L,k]of C)P.has(L)||S.push(k);for(const[L,k]of P)C.has(L)||I.push(k);return{removed:S,added:I}}e.diffMaps=u;class R{constructor(){this.a=new Map}add(P,S){let I=this.a.get(P);I||(I=new Set,this.a.set(P,I)),I.add(S)}delete(P,S){const I=this.a.get(P);!I||(I.delete(S),I.size===0&&this.a.delete(P))}forEach(P,S){const I=this.a.get(P);!I||I.forEach(S)}}e.SetMap=R}),define(ye[62],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function c(C){return(P,S,I)=>{let L=null,k=null;if(typeof I.value=="function"?(L="value",k=I.value):typeof I.get=="function"&&(L="get",k=I.get),!k)throw new Error("not supported");I[L]=C(k,S)}}function A(C,P,S){let I=null,L=null;if(typeof S.value=="function"?(I="value",L=S.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(I="get",L=S.get),!L)throw new Error("not supported");const k=`$memoize$${P}`;S[I]=function(...v){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,v)}),this[k]}}e.memoize=A;function u(C,P,S){return c((I,L)=>{const k=`$debounce$${L}`,v=`$debounce$result$${L}`;return function(...T){this[v]||(this[v]=S?S():void 0),clearTimeout(this[k]),P&&(this[v]=P(this[v],...T),T=[this[v]]),this[k]=setTimeout(()=>{I.apply(this,T),this[v]=S?S():void 0},C)}})}e.debounce=u;function R(C,P,S){return c((I,L)=>{const k=`$throttle$timer$${L}`,v=`$throttle$result$${L}`,T=`$throttle$lastRun$${L}`,E=`$throttle$pending$${L}`;return function(...f){if(this[v]||(this[v]=S?S():void 0),(this[T]===null||this[T]===void 0)&&(this[T]=-Number.MAX_VALUE),P&&(this[v]=P(this[v],...f)),this[E])return;const d=this[T]+C;d<=Date.now()?(this[T]=Date.now(),I.apply(this,[this[v]]),this[v]=S?S():void 0):(this[E]=!0,this[k]=setTimeout(()=>{this[E]=!1,this[T]=Date.now(),I.apply(this,[this[v]]),this[v]=S?S():void 0},d-Date.now()))}})}e.throttle=R}),define(ye[11],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class c{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?y.isErrorNoTelemetry(o)?new y(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(s=>{s(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}e.ErrorHandler=c,e.errorHandler=new c;function A(i){e.errorHandler.setUnexpectedErrorHandler(i)}e.setUnexpectedErrorHandler=A;function u(i){if(!i||typeof i!="object")return!1;const o=i;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=u;function R(i){I(i)||e.errorHandler.onUnexpectedError(i)}e.onUnexpectedError=R;function C(i){I(i)||e.errorHandler.onUnexpectedExternalError(i)}e.onUnexpectedExternalError=C;function P(i){if(i instanceof Error){const{name:o,message:s}=i,l=i.stacktrace||i.stack;return{$isError:!0,name:o,message:s,stack:l,noTelemetry:y.isErrorNoTelemetry(i)}}return i}e.transformErrorForSerialization=P;const S="Canceled";function I(i){return i instanceof L?!0:i instanceof Error&&i.name===S&&i.message===S}e.isCancellationError=I;class L extends Error{constructor(){super(S),this.name=this.message}}e.CancellationError=L;function k(){const i=new Error(S);return i.name=i.message,i}e.canceled=k;function v(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}e.illegalArgument=v;function T(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}e.illegalState=T;function E(i){return i?new Error(`readonly property '${i} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=E;function f(i){const o=new Error(`${i} has been disposed`);return o.name="DISPOSED",o}e.disposed=f;function d(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}e.getErrorMessage=d;class h extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.NotImplementedError=h;class g extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.NotSupportedError=g;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=p;class y extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof y)return o;const s=new y;return s.message=o.message,s.stack=o.stack,s}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.ErrorNoTelemetry=y;class b extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,b.prototype);debugger}}e.BugIndicatingError=b}),define(ye[15],De([1,0,11]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function A(oe,ae=0){return oe[oe.length-(1+ae)]}e.tail=A;function u(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}e.tail2=u;function R(oe,ae,fe=(Z,le)=>Z===le){if(oe===ae)return!0;if(!oe||!ae||oe.length!==ae.length)return!1;for(let Z=0,le=oe.length;Z<le;Z++)if(!fe(oe[Z],ae[Z]))return!1;return!0}e.equals=R;function C(oe,ae){const fe=oe.length-1;ae<fe&&(oe[ae]=oe[fe]),oe.pop()}e.removeFastWithoutKeepingOrder=C;function P(oe,ae,fe){return S(oe.length,Z=>fe(oe[Z],ae))}e.binarySearch=P;function S(oe,ae){let fe=0,Z=oe-1;for(;fe<=Z;){const le=(fe+Z)/2|0,re=ae(le);if(re<0)fe=le+1;else if(re>0)Z=le-1;else return le}return-(fe+1)}e.binarySearch2=S;function I(oe,ae){let fe=0,Z=oe.length;if(Z===0)return 0;for(;fe<Z;){const le=Math.floor((fe+Z)/2);ae(oe[le])?Z=le:fe=le+1}return fe}e.findFirstInSorted=I;function L(oe,ae,fe){if(oe=oe|0,oe>=ae.length)throw new TypeError("invalid index");const Z=ae[Math.floor(ae.length*Math.random())],le=[],re=[],N=[];for(const H of ae){const K=fe(H,Z);K<0?le.push(H):K>0?re.push(H):N.push(H)}return oe<le.length?L(oe,le,fe):oe<le.length+N.length?N[0]:L(oe-(le.length+N.length),re,fe)}e.quickSelect=L;function k(oe,ae){const fe=[];let Z;for(const le of oe.slice(0).sort(ae))!Z||ae(Z[0],le)!==0?(Z=[le],fe.push(Z)):Z.push(le);return fe}e.groupBy=k;function v(oe,ae,fe){const Z=[];function le(H,K,_){if(K===0&&_.length===0)return;const he=Z[Z.length-1];he&&he.start+he.deleteCount===H?(he.deleteCount+=K,he.toInsert.push(..._)):Z.push({start:H,deleteCount:K,toInsert:_})}let re=0,N=0;for(;;){if(re===oe.length){le(re,0,ae.slice(N));break}if(N===ae.length){le(re,oe.length-re,[]);break}const H=oe[re],K=ae[N],_=fe(H,K);_===0?(re+=1,N+=1):_<0?(le(re,1,[]),re+=1):_>0&&(le(re,0,[K]),N+=1)}return Z}e.sortedDiff=v;function T(oe,ae,fe){const Z=v(oe,ae,fe),le=[],re=[];for(const N of Z)le.push(...oe.slice(N.start,N.start+N.deleteCount)),re.push(...N.toInsert);return{removed:le,added:re}}e.delta=T;function E(oe,ae,fe){if(fe===0)return[];const Z=oe.slice(0,fe).sort(ae);return d(oe,ae,Z,fe,oe.length),Z}e.top=E;function f(oe,ae,fe,Z,le){return fe===0?Promise.resolve([]):new Promise((re,N)=>{(async()=>{const H=oe.length,K=oe.slice(0,fe).sort(ae);for(let _=fe,he=Math.min(fe+Z,H);_<H;_=he,he=Math.min(he+Z,H)){if(_>fe&&await new Promise(we=>setTimeout(we)),le&&le.isCancellationRequested)throw new c.CancellationError;d(oe,ae,K,_,he)}return K})().then(re,N)})}e.topAsync=f;function d(oe,ae,fe,Z,le){for(const re=fe.length;Z<le;Z++){const N=oe[Z];if(ae(N,fe[re-1])<0){fe.pop();const H=I(fe,K=>ae(N,K)<0);fe.splice(H,0,N)}}}function h(oe){return oe.filter(ae=>!!ae)}e.coalesce=h;function g(oe){let ae=0;for(let fe=0;fe<oe.length;fe++)oe[fe]&&(oe[ae]=oe[fe],ae+=1);oe.length=ae}e.coalesceInPlace=g;function p(oe,ae,fe){oe.splice(fe,0,oe.splice(ae,1)[0])}e.move=p;function y(oe){return!Array.isArray(oe)||oe.length===0}e.isFalsyOrEmpty=y;function b(oe){return Array.isArray(oe)&&oe.length>0}e.isNonEmptyArray=b;function i(oe,ae=fe=>fe){const fe=new Set;return oe.filter(Z=>{const le=ae(Z);return fe.has(le)?!1:(fe.add(le),!0)})}e.distinct=i;function o(oe){const ae=new Set;return fe=>{const Z=oe(fe);return ae.has(Z)?!1:(ae.add(Z),!0)}}e.uniqueFilter=o;function s(oe,ae){const fe=l(oe,ae);if(fe!==-1)return oe[fe]}e.findLast=s;function l(oe,ae){for(let fe=oe.length-1;fe>=0;fe--){const Z=oe[fe];if(ae(Z))return fe}return-1}e.lastIndex=l;function r(oe,ae){return oe.length>0?oe[0]:ae}e.firstOrDefault=r;function m(oe,ae){return oe.length>0?oe[oe.length-1]:ae}e.lastOrDefault=m;function n(oe,ae,fe=(Z,le)=>Z===le){let Z=0;for(let le=0,re=Math.min(oe.length,ae.length);le<re&&fe(oe[le],ae[le]);le++)Z++;return Z}e.commonPrefixLength=n;function t(oe){return[].concat(...oe)}e.flatten=t;function a(oe,ae){let fe=typeof ae=="number"?oe:0;typeof ae=="number"?fe=oe:(fe=0,ae=oe);const Z=[];if(fe<=ae)for(let le=fe;le<ae;le++)Z.push(le);else for(let le=fe;le>ae;le--)Z.push(le);return Z}e.range=a;function w(oe,ae,fe){return oe.reduce((Z,le)=>(Z[ae(le)]=fe?fe(le):le,Z),Object.create(null))}e.index=w;function D(oe,ae){return oe.push(ae),()=>F(oe,ae)}e.insert=D;function F(oe,ae){const fe=oe.indexOf(ae);if(fe>-1)return oe.splice(fe,1),ae}e.remove=F;function x(oe,ae,fe){const Z=oe.slice(0,ae),le=oe.slice(ae);return Z.concat(fe,le)}e.arrayInsert=x;function q(oe,ae){let fe;if(typeof ae=="number"){let Z=ae;fe=()=>{const le=Math.sin(Z++)*179426549;return le-Math.floor(le)}}else fe=Math.random;for(let Z=oe.length-1;Z>0;Z-=1){const le=Math.floor(fe()*(Z+1)),re=oe[Z];oe[Z]=oe[le],oe[le]=re}}e.shuffle=q;function M(oe,ae){const fe=oe.indexOf(ae);fe>-1&&(oe.splice(fe,1),oe.unshift(ae))}e.pushToStart=M;function B(oe,ae){const fe=oe.indexOf(ae);fe>-1&&(oe.splice(fe,1),oe.push(ae))}e.pushToEnd=B;function O(oe,ae){for(const fe of ae)oe.push(fe)}e.pushMany=O;function U(oe,ae){return Array.isArray(oe)?oe.map(ae):ae(oe)}e.mapArrayOrNot=U;function z(oe){return Array.isArray(oe)?oe:[oe]}e.asArray=z;function j(oe){return oe[Math.floor(Math.random()*oe.length)]}e.getRandomElement=j;function de(oe,ae){for(const fe of oe){const Z=ae(fe);if(Z!==void 0)return Z}}e.mapFind=de;function V(oe,ae,fe){const Z=J(oe,ae),le=oe.length,re=fe.length;oe.length=le+re;for(let N=le-1;N>=Z;N--)oe[N+re]=oe[N];for(let N=0;N<re;N++)oe[N+Z]=fe[N]}e.insertInto=V;function X(oe,ae,fe,Z){const le=J(oe,ae),re=oe.splice(le,fe);return V(oe,le,Z),re}e.splice=X;function J(oe,ae){return ae<0?Math.max(ae+oe.length,0):Math.min(ae,oe.length)}var te;(function(oe){function ae(le){return le<0}oe.isLessThan=ae;function fe(le){return le>0}oe.isGreaterThan=fe;function Z(le){return le===0}oe.isNeitherLessOrGreaterThan=Z,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(te=e.CompareResult||(e.CompareResult={}));function ee(oe,ae){return(fe,Z)=>ae(oe(fe),oe(Z))}e.compareBy=ee;function Q(...oe){return(ae,fe)=>{for(const Z of oe){const le=Z(ae,fe);if(!te.isNeitherLessOrGreaterThan(le))return le}return te.neitherLessOrGreaterThan}}e.tieBreakComparators=Q;const Y=(oe,ae)=>oe-ae;e.numberComparator=Y;function ie(oe,ae){if(oe.length===0)return;let fe=oe[0];for(let Z=1;Z<oe.length;Z++){const le=oe[Z];ae(le,fe)>0&&(fe=le)}return fe}e.findMaxBy=ie;function pe(oe,ae){if(oe.length===0)return;let fe=oe[0];for(let Z=1;Z<oe.length;Z++){const le=oe[Z];ae(le,fe)>=0&&(fe=le)}return fe}e.findLastMaxBy=pe;function ve(oe,ae){return ie(oe,(fe,Z)=>-ae(fe,Z))}e.findMinBy=ve;class ke{constructor(ae){this.f=ae,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(ae){let fe=this.c;for(;fe<this.f.length&&ae(this.f[fe]);)fe++;const Z=fe===this.c?null:this.f.slice(this.c,fe);return this.c=fe,Z}takeFromEndWhile(ae){let fe=this.d;for(;fe>=0&&ae(this.f[fe]);)fe--;const Z=fe===this.d?null:this.f.slice(fe+1,this.d+1);return this.d=fe,Z}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const ae=this.f[this.c];return this.c++,ae}removeLast(){const ae=this.f[this.d];return this.d--,ae}takeCount(ae){const fe=this.f.slice(this.c,this.c+ae);return this.c+=ae,fe}}e.ArrayQueue=ke;class Oe{constructor(ae){this.iterate=ae}forEach(ae){this.iterate(fe=>(ae(fe),!0))}toArray(){const ae=[];return this.iterate(fe=>(ae.push(fe),!0)),ae}filter(ae){return new Oe(fe=>this.iterate(Z=>ae(Z)?fe(Z):!0))}map(ae){return new Oe(fe=>this.iterate(Z=>fe(ae(Z))))}some(ae){let fe=!1;return this.iterate(Z=>(fe=ae(Z),!fe)),fe}findFirst(ae){let fe;return this.iterate(Z=>ae(Z)?(fe=Z,!1):!0),fe}findLast(ae){let fe;return this.iterate(Z=>(ae(Z)&&(fe=Z),!0)),fe}findLastMaxBy(ae){let fe,Z=!0;return this.iterate(le=>((Z||te.isGreaterThan(ae(le,fe)))&&(Z=!1,fe=le),!0)),fe}}Oe.empty=new Oe(oe=>{}),e.CallbackIterable=Oe}),define(ye[50],De([1,0,11]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function A(S,I){if(!S)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=A;function u(S,I="Unreachable"){throw new Error(I)}e.assertNever=u;function R(S){if(!S)throw new c.BugIndicatingError("Assertion Failed")}e.assert=R;function C(S){if(!S()){debugger;S(),(0,c.onUnexpectedError)(new c.BugIndicatingError("Assertion Failed"))}}e.assertFn=C;function P(S,I){let L=0;for(;L<S.length-1;){const k=S[L],v=S[L+1];if(!I(k,v))return!1;L++}return!0}e.checkAdjacentItems=P}),define(ye[63],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function c(A){const u=this;let R=!1,C;return function(){return R||(R=!0,C=A.apply(u,arguments)),C}}e.once=c}),define(ye[101],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(u){this.a=u,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(ye[64],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var c;(function(A){function u(y){return y&&typeof y=="object"&&typeof y[Symbol.iterator]=="function"}A.is=u;const R=Object.freeze([]);function C(){return R}A.empty=C;function*P(y){yield y}A.single=P;function S(y){return u(y)?y:P(y)}A.wrap=S;function I(y){return y||R}A.from=I;function L(y){return!y||y[Symbol.iterator]().next().done===!0}A.isEmpty=L;function k(y){return y[Symbol.iterator]().next().value}A.first=k;function v(y,b){for(const i of y)if(b(i))return!0;return!1}A.some=v;function T(y,b){for(const i of y)if(b(i))return i}A.find=T;function*E(y,b){for(const i of y)b(i)&&(yield i)}A.filter=E;function*f(y,b){let i=0;for(const o of y)yield b(o,i++)}A.map=f;function*d(...y){for(const b of y)for(const i of b)yield i}A.concat=d;function h(y,b,i){let o=i;for(const s of y)o=b(o,s);return o}A.reduce=h;function*g(y,b,i=y.length){for(b<0&&(b+=y.length),i<0?i+=y.length:i>y.length&&(i=y.length);b<i;b++)yield y[b]}A.slice=g;function p(y,b=Number.POSITIVE_INFINITY){const i=[];if(b===0)return[i,y];const o=y[Symbol.iterator]();for(let s=0;s<b;s++){const l=o.next();if(l.done)return[i,A.empty()];i.push(l.value)}return[i,{[Symbol.iterator](){return o}}]}A.consume=p})(c=e.Iterable||(e.Iterable={}))}),define(ye[146],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var c;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(c=e.ScanError||(e.ScanError={}));var A;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var u;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(u=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function C(i,o=!1){let s=0;const l=i.length;let r="",m=0,n=16,t=0;function a(B){let O=0,U=0;for(;O<B;){const z=i.charCodeAt(s);if(z>=48&&z<=57)U=U*16+z-48;else if(z>=65&&z<=70)U=U*16+z-65+10;else if(z>=97&&z<=102)U=U*16+z-97+10;else break;s++,O++}return O<B&&(U=-1),U}function w(B){s=B,r="",m=0,n=16,t=0}function D(){const B=s;if(i.charCodeAt(s)===48)s++;else for(s++;s<i.length&&I(i.charCodeAt(s));)s++;if(s<i.length&&i.charCodeAt(s)===46)if(s++,s<i.length&&I(i.charCodeAt(s)))for(s++;s<i.length&&I(i.charCodeAt(s));)s++;else return t=3,i.substring(B,s);let O=s;if(s<i.length&&(i.charCodeAt(s)===69||i.charCodeAt(s)===101))if(s++,(s<i.length&&i.charCodeAt(s)===43||i.charCodeAt(s)===45)&&s++,s<i.length&&I(i.charCodeAt(s))){for(s++;s<i.length&&I(i.charCodeAt(s));)s++;O=s}else t=3;return i.substring(B,O)}function F(){let B="",O=s;for(;;){if(s>=l){B+=i.substring(O,s),t=2;break}const U=i.charCodeAt(s);if(U===34){B+=i.substring(O,s),s++;break}if(U===92){if(B+=i.substring(O,s),s++,s>=l){t=2;break}switch(i.charCodeAt(s++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const j=a(4);j>=0?B+=String.fromCharCode(j):t=4;break}default:t=5}O=s;continue}if(U>=0&&U<=31)if(S(U)){B+=i.substring(O,s),t=2;break}else t=6;s++}return B}function x(){if(r="",t=0,m=s,s>=l)return m=l,n=17;let B=i.charCodeAt(s);if(P(B)){do s++,r+=String.fromCharCode(B),B=i.charCodeAt(s);while(P(B));return n=15}if(S(B))return s++,r+=String.fromCharCode(B),B===13&&i.charCodeAt(s)===10&&(s++,r+=`
`),n=14;switch(B){case 123:return s++,n=1;case 125:return s++,n=2;case 91:return s++,n=3;case 93:return s++,n=4;case 58:return s++,n=6;case 44:return s++,n=5;case 34:return s++,r=F(),n=10;case 47:{const O=s-1;if(i.charCodeAt(s+1)===47){for(s+=2;s<l&&!S(i.charCodeAt(s));)s++;return r=i.substring(O,s),n=12}if(i.charCodeAt(s+1)===42){s+=2;const U=l-1;let z=!1;for(;s<U;){if(i.charCodeAt(s)===42&&i.charCodeAt(s+1)===47){s+=2,z=!0;break}s++}return z||(s++,t=1),r=i.substring(O,s),n=13}return r+=String.fromCharCode(B),s++,n=16}case 45:if(r+=String.fromCharCode(B),s++,s===l||!I(i.charCodeAt(s)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=D(),n=11;default:for(;s<l&&q(B);)s++,B=i.charCodeAt(s);if(m!==s){switch(r=i.substring(m,s),r){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return r+=String.fromCharCode(B),s++,n=16}}function q(B){if(P(B)||S(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let B;do B=x();while(B>=12&&B<=15);return B}return{setPosition:w,getPosition:()=>s,scan:o?M:x,getToken:()=>n,getTokenValue:()=>r,getTokenOffset:()=>m,getTokenLength:()=>s-m,getTokenError:()=>t}}e.createScanner=C;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function S(i){return i===10||i===13||i===8232||i===8233}function I(i){return i>=48&&i<=57}var L;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(L||(L={}));function k(i,o){const s=[],l=new Object;let r;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function t(a,w,D,F){m.value=a,m.offset=w,m.length=D,m.type=F,m.colonOffset=void 0,r=m}try{p(i,{onObjectBegin:(a,w)=>{if(o<=a)throw l;r=void 0,n=o>a,s.push("")},onObjectProperty:(a,w,D)=>{if(o<w||(t(a,w,D,"property"),s[s.length-1]=a,o<=w+D))throw l},onObjectEnd:(a,w)=>{if(o<=a)throw l;r=void 0,s.pop()},onArrayBegin:(a,w)=>{if(o<=a)throw l;r=void 0,s.push(0)},onArrayEnd:(a,w)=>{if(o<=a)throw l;r=void 0,s.pop()},onLiteralValue:(a,w,D)=>{if(o<w||(t(a,w,D,b(a)),o<=w+D))throw l},onSeparator:(a,w,D)=>{if(o<=w)throw l;if(a===":"&&r&&r.type==="property")r.colonOffset=w,n=!1,r=void 0;else if(a===","){const F=s[s.length-1];typeof F=="number"?s[s.length-1]=F+1:(n=!0,s[s.length-1]=""),r=void 0}}})}catch(a){if(a!==l)throw a}return{path:s,previousNode:r,isAtPropertyKey:n,matches:a=>{let w=0;for(let D=0;w<a.length&&D<s.length;D++)if(a[w]===s[D]||a[w]==="*")w++;else if(a[w]!=="**")return!1;return w===a.length}}}e.getLocation=k;function v(i,o=[],s=R.DEFAULT){let l=null,r=[];const m=[];function n(a){Array.isArray(r)?r.push(a):l!==null&&(r[l]=a)}return p(i,{onObjectBegin:()=>{const a={};n(a),m.push(r),r=a,l=null},onObjectProperty:a=>{l=a},onObjectEnd:()=>{r=m.pop()},onArrayBegin:()=>{const a=[];n(a),m.push(r),r=a,l=null},onArrayEnd:()=>{r=m.pop()},onLiteralValue:n,onError:(a,w,D)=>{o.push({error:a,offset:w,length:D})}},s),r[0]}e.parse=v;function T(i,o=[],s=R.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(a){l.type==="property"&&(l.length=a-l.offset,l=l.parent)}function m(a){return l.children.push(a),a}p(i,{onObjectBegin:a=>{l=m({type:"object",offset:a,length:-1,parent:l,children:[]})},onObjectProperty:(a,w,D)=>{l=m({type:"property",offset:w,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:a,offset:w,length:D,parent:l})},onObjectEnd:(a,w)=>{l.length=a+w-l.offset,l=l.parent,r(a+w)},onArrayBegin:(a,w)=>{l=m({type:"array",offset:a,length:-1,parent:l,children:[]})},onArrayEnd:(a,w)=>{l.length=a+w-l.offset,l=l.parent,r(a+w)},onLiteralValue:(a,w,D)=>{m({type:b(a),offset:w,length:D,parent:l,value:a}),r(w+D)},onSeparator:(a,w,D)=>{l.type==="property"&&(a===":"?l.colonOffset=w:a===","&&r(w))},onError:(a,w,D)=>{o.push({error:a,offset:w,length:D})}},s);const t=l.children[0];return t&&delete t.parent,t}e.parseTree=T;function E(i,o){if(!i)return;let s=i;for(const l of o)if(typeof l=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const m of s.children)if(Array.isArray(m.children)&&m.children[0].value===l){s=m.children[1],r=!0;break}if(!r)return}else{const r=l;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}e.findNodeAtLocation=E;function f(i){if(!i.parent||!i.parent.children)return[];const o=f(i.parent);if(i.parent.type==="property"){const s=i.parent.children[0].value;o.push(s)}else if(i.parent.type==="array"){const s=i.parent.children.indexOf(i);s!==-1&&o.push(s)}return o}e.getNodePath=f;function d(i){switch(i.type){case"array":return i.children.map(d);case"object":{const o=Object.create(null);for(const s of i.children){const l=s.children[1];l&&(o[s.children[0].value]=d(l))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=d;function h(i,o,s=!1){return o>=i.offset&&o<i.offset+i.length||s&&o===i.offset+i.length}e.contains=h;function g(i,o,s=!1){if(h(i,o,s)){const l=i.children;if(Array.isArray(l))for(let r=0;r<l.length&&l[r].offset<=o;r++){const m=g(l[r],o,s);if(m)return m}return i}}e.findNodeAtOffset=g;function p(i,o,s=R.DEFAULT){const l=C(i,!1);function r(ee){return ee?()=>ee(l.getTokenOffset(),l.getTokenLength()):()=>!0}function m(ee){return ee?Q=>ee(Q,l.getTokenOffset(),l.getTokenLength()):()=>!0}const n=r(o.onObjectBegin),t=m(o.onObjectProperty),a=r(o.onObjectEnd),w=r(o.onArrayBegin),D=r(o.onArrayEnd),F=m(o.onLiteralValue),x=m(o.onSeparator),q=r(o.onComment),M=m(o.onError),B=s&&s.disallowComments,O=s&&s.allowTrailingComma;function U(){for(;;){const ee=l.scan();switch(l.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:B||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(ee){case 12:case 13:B?z(10):q();break;case 16:z(1);break;case 15:case 14:break;default:return ee}}}function z(ee,Q=[],Y=[]){if(M(ee),Q.length+Y.length>0){let ie=l.getToken();for(;ie!==17;){if(Q.indexOf(ie)!==-1){U();break}else if(Y.indexOf(ie)!==-1)break;ie=U()}}}function j(ee){const Q=l.getTokenValue();return ee?F(Q):t(Q),U(),!0}function de(){switch(l.getToken()){case 11:{let ee=0;try{ee=JSON.parse(l.getTokenValue()),typeof ee!="number"&&(z(2),ee=0)}catch{z(2)}F(ee);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return U(),!0}function V(){return l.getToken()!==10?(z(3,[],[2,5]),!1):(j(!1),l.getToken()===6?(x(":"),U(),te()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function X(){n(),U();let ee=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(ee||z(4,[],[]),x(","),U(),l.getToken()===2&&O)break}else ee&&z(6,[],[]);V()||z(4,[],[2,5]),ee=!0}return a(),l.getToken()!==2?z(7,[2],[]):U(),!0}function J(){w(),U();let ee=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(ee||z(4,[],[]),x(","),U(),l.getToken()===4&&O)break}else ee&&z(6,[],[]);te()||z(4,[],[4,5]),ee=!0}return D(),l.getToken()!==4?z(8,[4],[]):U(),!0}function te(){switch(l.getToken()){case 3:return J();case 1:return X();case 10:return j(!0);default:return de()}}return U(),l.getToken()===17?s.allowEmptyContent?!0:(z(4,[],[]),!1):te()?(l.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=p;function y(i,o){const s=C(i),l=[];let r,m=0,n;do switch(n=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:m!==n&&l.push(i.substring(m,n)),o!==void 0&&l.push(s.getTokenValue().replace(/[^\r\n]/g,o)),m=s.getPosition();break}while(r!==17);return l.join("")}e.stripComments=y;function b(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=b}),define(ye[65],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(u){this.d=u,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(u){this.c=u}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=c}),define(ye[6],De([1,0,63,64]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const u=!1;let R=null;function C(m){R=m}if(e.setDisposableTracker=C,u){const m="__is_disposable_tracked__";C(new class{trackDisposable(n){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[m]||console.log(t)},3e3)}setParent(n,t){if(n&&n!==g.None)try{n[m]=!0}catch{}}markAsDisposed(n){if(n&&n!==g.None)try{n[m]=!0}catch{}}markAsSingleton(n){}})}function P(m){return R?.trackDisposable(m),m}function S(m){R?.markAsDisposed(m)}function I(m,n){R?.setParent(m,n)}function L(m,n){if(!!R)for(const t of m)R.setParent(t,n)}function k(m){return R?.markAsSingleton(m),m}e.markAsSingleton=k;function v(m){return typeof m.dispose=="function"&&m.dispose.length===0}e.isDisposable=v;function T(m){if(A.Iterable.is(m)){const n=[];for(const t of m)if(t)try{t.dispose()}catch(a){n.push(a)}if(n.length===1)throw n[0];if(n.length>1)throw new AggregateError(n,"Encountered errors while disposing of store");return Array.isArray(m)?[]:m}else if(m)return m.dispose(),m}e.dispose=T;function E(m){for(const n of m)v(n)&&n.dispose();return[]}e.disposeIfDisposable=E;function f(...m){const n=d(()=>T(m));return L(m,n),n}e.combinedDisposable=f;function d(m){const n=P({dispose:(0,c.once)(()=>{S(n),m()})});return n}e.toDisposable=d;class h{constructor(){this.c=new Set,this.f=!1,P(this)}dispose(){this.f||(S(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{T(this.c)}finally{this.c.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return I(n,this),this.f?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(n),n}}h.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=h;class g{constructor(){this.q=new h,P(this),I(this.q,this)}dispose(){S(this),this.q.dispose()}B(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(n)}}g.None=Object.freeze({dispose(){}}),e.Disposable=g;class p{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(n){this.b||n===this.a||(this.a?.dispose(),n&&I(n,this),this.a=n)}clear(){this.value=void 0}dispose(){this.b=!0,S(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const n=this.a;return this.a=void 0,n&&I(n,null),n}}e.MutableDisposable=p;class y{constructor(n){this.b=n,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=y;class b{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(n){let t=n;return this.unset=()=>t=void 0,this.isset=()=>t!==void 0,this.dispose=()=>{t&&(t(),t=void 0,S(this))},this}}e.SafeDisposable=b;class i{constructor(){this.a=new Map}acquire(n,...t){let a=this.a.get(n);a||(a={counter:0,object:this.b(n,...t)},this.a.set(n,a));const{object:w}=a,D=(0,c.once)(()=>{--a.counter===0&&(this.c(n,a.object),this.a.delete(n))});return a.counter++,{object:w,dispose:D}}}e.ReferenceCollection=i;class o{constructor(n){this.a=n}async acquire(n,...t){const a=this.a.acquire(n,...t);try{return{object:await a.object,dispose:()=>a.dispose()}}catch(w){throw a.dispose(),w}}}e.AsyncReferenceCollection=o;class s{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=s;function l(m){const n=new h;try{m(n)}finally{n.dispose()}}e.disposeOnReturn=l;class r{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){S(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{T(this.a.values())}finally{this.a.clear()}}has(n){return this.a.has(n)}get(n){return this.a.get(n)}set(n,t,a=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),a||this.a.get(n)?.dispose(),this.a.set(n,t)}deleteAndDispose(n){this.a.get(n)?.dispose(),this.a.delete(n)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=r}),define(ye[66],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class c{constructor(R){this.element=R,this.next=c.Undefined,this.prev=c.Undefined}}c.Undefined=new c(void 0);class A{constructor(){this.a=c.Undefined,this.b=c.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===c.Undefined}clear(){let R=this.a;for(;R!==c.Undefined;){const C=R.next;R.prev=c.Undefined,R.next=c.Undefined,R=C}this.a=c.Undefined,this.b=c.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,C){const P=new c(R);if(this.a===c.Undefined)this.a=P,this.b=P;else if(C){const I=this.b;this.b=P,P.prev=I,I.next=P}else{const I=this.a;this.a=P,P.next=I,I.prev=P}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(P))}}shift(){if(this.a!==c.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==c.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==c.Undefined&&R.next!==c.Undefined){const C=R.prev;C.next=R.next,R.next.prev=C}else R.prev===c.Undefined&&R.next===c.Undefined?(this.a=c.Undefined,this.b=c.Undefined):R.next===c.Undefined?(this.b=this.b.prev,this.b.next=c.Undefined):R.prev===c.Undefined&&(this.a=this.a.next,this.a.prev=c.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==c.Undefined;)yield R.element,R=R.next}}e.LinkedList=A}),define(ye[28],De([1,0]),function(ne,e){"use strict";var c,A,u;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(E,f,d){let h=E.get(f);return h===void 0&&(h=d,E.set(f,h)),h}e.getOrSet=R;function C(E){const f=[];return E.forEach((d,h)=>{f.push(`${h} => ${d}`)}),`Map(${E.size}) {${f.join(", ")}}`}e.mapToString=C;function P(E){const f=[];return E.forEach(d=>{f.push(d)}),`Set(${E.size}) {${f.join(", ")}}`}e.setToString=P;class S{constructor(f,d){this.uri=f,this.value=d}}class I{constructor(f,d){this[c]="ResourceMap",f instanceof I?(this.b=new Map(f.b),this.c=d??I.a):(this.b=new Map,this.c=f??I.a)}set(f,d){return this.b.set(this.c(f),new S(f,d)),this}get(f){return this.b.get(this.c(f))?.value}has(f){return this.b.has(this.c(f))}get size(){return this.b.size}clear(){this.b.clear()}delete(f){return this.b.delete(this.c(f))}forEach(f,d){typeof d<"u"&&(f=f.bind(d));for(const[h,g]of this.b)f(g.value,g.uri,this)}*values(){for(const f of this.b.values())yield f.value}*keys(){for(const f of this.b.values())yield f.uri}*entries(){for(const f of this.b.values())yield[f.uri,f.value]}*[(c=Symbol.toStringTag,Symbol.iterator)](){for(const[,f]of this.b)yield[f.uri,f.value]}}I.a=E=>E.toString(),e.ResourceMap=I;class L{constructor(f,d){this[A]="ResourceSet",!f||typeof f=="function"?this.a=new I(f):(this.a=new I(d),f.forEach(this.add,this))}get size(){return this.a.size}add(f){return this.a.set(f,f),this}clear(){this.a.clear()}delete(f){return this.a.delete(f)}forEach(f,d){this.a.forEach((h,g)=>f.call(d,g,g,this))}has(f){return this.a.has(f)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=L;var k;(function(E){E[E.None=0]="None",E[E.AsOld=1]="AsOld",E[E.AsNew=2]="AsNew"})(k=e.Touch||(e.Touch={}));class v{constructor(){this[u]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(f){return this.a.has(f)}get(f,d=0){const h=this.a.get(f);if(!!h)return d!==0&&this.j(h,d),h.value}set(f,d,h=0){let g=this.a.get(f);if(g)g.value=d,h!==0&&this.j(g,h);else{switch(g={key:f,value:d,next:void 0,previous:void 0},h){case 0:this.h(g);break;case 1:this.g(g);break;case 2:this.h(g);break;default:this.h(g);break}this.a.set(f,g),this.d++}return this}delete(f){return!!this.remove(f)}remove(f){const d=this.a.get(f);if(!!d)return this.a.delete(f),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const f=this.b;return this.a.delete(f.key),this.i(f),this.d--,f.value}forEach(f,d){const h=this.e;let g=this.b;for(;g;){if(d?f.bind(d)(g.value,g.key,this):f(g.value,g.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const f=this,d=this.e;let h=this.b;const g={[Symbol.iterator](){return g},next(){if(f.e!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const p={value:h.key,done:!1};return h=h.next,p}else return{value:void 0,done:!0}}};return g}values(){const f=this,d=this.e;let h=this.b;const g={[Symbol.iterator](){return g},next(){if(f.e!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const p={value:h.value,done:!1};return h=h.next,p}else return{value:void 0,done:!0}}};return g}entries(){const f=this,d=this.e;let h=this.b;const g={[Symbol.iterator](){return g},next(){if(f.e!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const p={value:[h.key,h.value],done:!1};return h=h.next,p}else return{value:void 0,done:!0}}};return g}[(u=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(f){if(f>=this.size)return;if(f===0){this.clear();return}let d=this.b,h=this.size;for(;d&&h>f;)this.a.delete(d.key),d=d.next,h--;this.b=d,this.d=h,d&&(d.previous=void 0),this.e++}g(f){if(!this.b&&!this.c)this.c=f;else if(this.b)f.next=this.b,this.b.previous=f;else throw new Error("Invalid list");this.b=f,this.e++}h(f){if(!this.b&&!this.c)this.b=f;else if(this.c)f.previous=this.c,this.c.next=f;else throw new Error("Invalid list");this.c=f,this.e++}i(f){if(f===this.b&&f===this.c)this.b=void 0,this.c=void 0;else if(f===this.b){if(!f.next)throw new Error("Invalid list");f.next.previous=void 0,this.b=f.next}else if(f===this.c){if(!f.previous)throw new Error("Invalid list");f.previous.next=void 0,this.c=f.previous}else{const d=f.next,h=f.previous;if(!d||!h)throw new Error("Invalid list");d.previous=h,h.next=d}f.next=void 0,f.previous=void 0,this.e++}j(f,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(f===this.b)return;const h=f.next,g=f.previous;f===this.c?(g.next=void 0,this.c=g):(h.previous=g,g.next=h),f.previous=void 0,f.next=this.b,this.b.previous=f,this.b=f,this.e++}else if(d===2){if(f===this.c)return;const h=f.next,g=f.previous;f===this.b?(h.previous=void 0,this.b=h):(h.previous=g,g.next=h),f.next=void 0,f.previous=this.c,this.c.next=f,this.c=f,this.e++}}}toJSON(){const f=[];return this.forEach((d,h)=>{f.push([h,d])}),f}fromJSON(f){this.clear();for(const[d,h]of f)this.set(d,h)}}e.LinkedMap=v;class T extends v{constructor(f,d=1){super(),this.k=f,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(f){this.k=f,this.m()}get ratio(){return this.l}set ratio(f){this.l=Math.min(Math.max(0,f),1),this.m()}get(f,d=2){return super.get(f,d)}peek(f){return super.get(f,0)}set(f,d){return super.set(f,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=T}),function(ne,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(ye[147],De([0]),e):(ne=typeof globalThis<"u"?globalThis:ne||self,e(ne.marked={}))}(this,function(ne){"use strict";function e(oe,ae){for(var fe=0;fe<ae.length;fe++){var Z=ae[fe];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(oe,Z.key,Z)}}function c(oe,ae,fe){return ae&&e(oe.prototype,ae),fe&&e(oe,fe),Object.defineProperty(oe,"prototype",{writable:!1}),oe}function A(oe,ae){if(!!oe){if(typeof oe=="string")return u(oe,ae);var fe=Object.prototype.toString.call(oe).slice(8,-1);if(fe==="Object"&&oe.constructor&&(fe=oe.constructor.name),fe==="Map"||fe==="Set")return Array.from(oe);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return u(oe,ae)}}function u(oe,ae){(ae==null||ae>oe.length)&&(ae=oe.length);for(var fe=0,Z=new Array(ae);fe<ae;fe++)Z[fe]=oe[fe];return Z}function R(oe,ae){var fe=typeof Symbol<"u"&&oe[Symbol.iterator]||oe["@@iterator"];if(fe)return(fe=fe.call(oe)).next.bind(fe);if(Array.isArray(oe)||(fe=A(oe))||ae&&oe&&typeof oe.length=="number"){fe&&(oe=fe);var Z=0;return function(){return Z>=oe.length?{done:!0}:{done:!1,value:oe[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=C();function P(oe){ne.defaults=oe}var S=/[&<>"']/,I=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},T=function(ae){return v[ae]};function E(oe,ae){if(ae){if(S.test(oe))return oe.replace(I,T)}else if(L.test(oe))return oe.replace(k,T);return oe}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(oe){return oe.replace(f,function(ae,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var h=/(^|[^\[])\^/g;function g(oe,ae){oe=typeof oe=="string"?oe:oe.source,ae=ae||"";var fe={replace:function(le,re){return re=re.source||re,re=re.replace(h,"$1"),oe=oe.replace(le,re),fe},getRegex:function(){return new RegExp(oe,ae)}};return fe}var p=/[^\w:]/g,y=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(oe,ae,fe){if(oe){var Z;try{Z=decodeURIComponent(d(fe)).replace(p,"").toLowerCase()}catch{return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}ae&&!y.test(fe)&&(fe=r(ae,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch{return null}return fe}var i={},o=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(oe,ae){i[" "+oe]||(o.test(oe)?i[" "+oe]=oe+"/":i[" "+oe]=a(oe,"/",!0)),oe=i[" "+oe];var fe=oe.indexOf(":")===-1;return ae.substring(0,2)==="//"?fe?ae:oe.replace(s,"$1")+ae:ae.charAt(0)==="/"?fe?ae:oe.replace(l,"$1")+ae:oe+ae}var m={exec:function(){}};function n(oe){for(var ae=1,fe,Z;ae<arguments.length;ae++){fe=arguments[ae];for(Z in fe)Object.prototype.hasOwnProperty.call(fe,Z)&&(oe[Z]=fe[Z])}return oe}function t(oe,ae){var fe=oe.replace(/\|/g,function(re,N,H){for(var K=!1,_=N;--_>=0&&H[_]==="\\";)K=!K;return K?"|":" |"}),Z=fe.split(/ \|/),le=0;if(Z[0].trim()||Z.shift(),Z.length>0&&!Z[Z.length-1].trim()&&Z.pop(),Z.length>ae)Z.splice(ae);else for(;Z.length<ae;)Z.push("");for(;le<Z.length;le++)Z[le]=Z[le].trim().replace(/\\\|/g,"|");return Z}function a(oe,ae,fe){var Z=oe.length;if(Z===0)return"";for(var le=0;le<Z;){var re=oe.charAt(Z-le-1);if(re===ae&&!fe)le++;else if(re!==ae&&fe)le++;else break}return oe.slice(0,Z-le)}function w(oe,ae){if(oe.indexOf(ae[1])===-1)return-1;for(var fe=oe.length,Z=0,le=0;le<fe;le++)if(oe[le]==="\\")le++;else if(oe[le]===ae[0])Z++;else if(oe[le]===ae[1]&&(Z--,Z<0))return le;return-1}function D(oe){oe&&oe.sanitize&&!oe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(oe,ae){if(ae<1)return"";for(var fe="";ae>1;)ae&1&&(fe+=oe),ae>>=1,oe+=oe;return fe+oe}function x(oe,ae,fe,Z){var le=ae.href,re=ae.title?E(ae.title):null,N=oe[1].replace(/\\([\[\]])/g,"$1");if(oe[0].charAt(0)!=="!"){Z.state.inLink=!0;var H={type:"link",raw:fe,href:le,title:re,text:N,tokens:Z.inlineTokens(N)};return Z.state.inLink=!1,H}return{type:"image",raw:fe,href:le,title:re,text:E(N)}}function q(oe,ae){var fe=oe.match(/^(\s+)(?:```)/);if(fe===null)return ae;var Z=fe[1];return ae.split(`
`).map(function(le){var re=le.match(/^\s+/);if(re===null)return le;var N=re[0];return N.length>=Z.length?le.slice(Z.length):le}).join(`
`)}var M=function(){function oe(fe){this.options=fe||ne.defaults}var ae=oe.prototype;return ae.space=function(Z){var le=this.rules.block.newline.exec(Z);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},ae.code=function(Z){var le=this.rules.block.code.exec(Z);if(le){var re=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?re:a(re,`
`)}}},ae.fences=function(Z){var le=this.rules.block.fences.exec(Z);if(le){var re=le[0],N=q(re,le[3]||"");return{type:"code",raw:re,lang:le[2]?le[2].trim():le[2],text:N}}},ae.heading=function(Z){var le=this.rules.block.heading.exec(Z);if(le){var re=le[2].trim();if(/#$/.test(re)){var N=a(re,"#");(this.options.pedantic||!N||/ $/.test(N))&&(re=N.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:re,tokens:this.lexer.inline(re)}}},ae.hr=function(Z){var le=this.rules.block.hr.exec(Z);if(le)return{type:"hr",raw:le[0]}},ae.blockquote=function(Z){var le=this.rules.block.blockquote.exec(Z);if(le){var re=le[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(re,[]),text:re}}},ae.list=function(Z){var le=this.rules.block.list.exec(Z);if(le){var re,N,H,K,_,he,we,Ae,be,Ce,Te,Ve,xe=le[1].trim(),et=xe.length>1,Qe={type:"list",raw:"",ordered:et,start:et?+xe.slice(0,-1):"",loose:!1,items:[]};xe=et?"\\d{1,9}\\"+xe.slice(-1):"\\"+xe,this.options.pedantic&&(xe=et?xe:"[*+-]");for(var nt=new RegExp("^( {0,3}"+xe+")((?:[	 ][^\\n]*)?(?:\\n|$))");Z&&(Ve=!1,!(!(le=nt.exec(Z))||this.rules.block.hr.test(Z)));){if(re=le[0],Z=Z.substring(re.length),Ae=le[2].split(`
`,1)[0],be=Z.split(`
`,1)[0],this.options.pedantic?(K=2,Te=Ae.trimLeft()):(K=le[2].search(/[^ ]/),K=K>4?1:K,Te=Ae.slice(K),K+=le[1].length),he=!1,!Ae&&/^ *$/.test(be)&&(re+=be+`
`,Z=Z.substring(be.length+1),Ve=!0),!Ve)for(var st=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ht=new RegExp("^ {0,"+Math.min(3,K-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ue=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,K-1)+"}#");Z&&(Ce=Z.split(`
`,1)[0],Ae=Ce,this.options.pedantic&&(Ae=Ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ue.test(Ae)||rt.test(Ae)||st.test(Ae)||ht.test(Z)));){if(Ae.search(/[^ ]/)>=K||!Ae.trim())Te+=`
`+Ae.slice(K);else if(!he)Te+=`
`+Ae;else break;!he&&!Ae.trim()&&(he=!0),re+=Ce+`
`,Z=Z.substring(Ce.length+1)}Qe.loose||(we?Qe.loose=!0:/\n *\n *$/.test(re)&&(we=!0)),this.options.gfm&&(N=/^\[[ xX]\] /.exec(Te),N&&(H=N[0]!=="[ ] ",Te=Te.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:re,task:!!N,checked:H,loose:!1,text:Te}),Qe.raw+=re}Qe.items[Qe.items.length-1].raw=re.trimRight(),Qe.items[Qe.items.length-1].text=Te.trimRight(),Qe.raw=Qe.raw.trimRight();var ce=Qe.items.length;for(_=0;_<ce;_++){this.lexer.state.top=!1,Qe.items[_].tokens=this.lexer.blockTokens(Qe.items[_].text,[]);var $=Qe.items[_].tokens.filter(function(Ie){return Ie.type==="space"}),ue=$.every(function(Ie){for(var Le=Ie.raw.split(""),$e=0,Ke=R(Le),Ze;!(Ze=Ke()).done;){var pt=Ze.value;if(pt===`
`&&($e+=1),$e>1)return!0}return!1});!Qe.loose&&$.length&&ue&&(Qe.loose=!0,Qe.items[_].loose=!0)}return Qe}},ae.html=function(Z){var le=this.rules.block.html.exec(Z);if(le){var re={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};if(this.options.sanitize){var N=this.options.sanitizer?this.options.sanitizer(le[0]):E(le[0]);re.type="paragraph",re.text=N,re.tokens=this.lexer.inline(N)}return re}},ae.def=function(Z){var le=this.rules.block.def.exec(Z);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var re=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:re,raw:le[0],href:le[2],title:le[3]}}},ae.table=function(Z){var le=this.rules.block.table.exec(Z);if(le){var re={type:"table",header:t(le[1]).map(function(we){return{text:we}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]&&le[3].trim()?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(re.header.length===re.align.length){re.raw=le[0];var N=re.align.length,H,K,_,he;for(H=0;H<N;H++)/^ *-+: *$/.test(re.align[H])?re.align[H]="right":/^ *:-+: *$/.test(re.align[H])?re.align[H]="center":/^ *:-+ *$/.test(re.align[H])?re.align[H]="left":re.align[H]=null;for(N=re.rows.length,H=0;H<N;H++)re.rows[H]=t(re.rows[H],re.header.length).map(function(we){return{text:we}});for(N=re.header.length,K=0;K<N;K++)re.header[K].tokens=this.lexer.inline(re.header[K].text);for(N=re.rows.length,K=0;K<N;K++)for(he=re.rows[K],_=0;_<he.length;_++)he[_].tokens=this.lexer.inline(he[_].text);return re}}},ae.lheading=function(Z){var le=this.rules.block.lheading.exec(Z);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:this.lexer.inline(le[1])}},ae.paragraph=function(Z){var le=this.rules.block.paragraph.exec(Z);if(le){var re=le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1];return{type:"paragraph",raw:le[0],text:re,tokens:this.lexer.inline(re)}}},ae.text=function(Z){var le=this.rules.block.text.exec(Z);if(le)return{type:"text",raw:le[0],text:le[0],tokens:this.lexer.inline(le[0])}},ae.escape=function(Z){var le=this.rules.inline.escape.exec(Z);if(le)return{type:"escape",raw:le[0],text:E(le[1])}},ae.tag=function(Z){var le=this.rules.inline.tag.exec(Z);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):E(le[0]):le[0]}},ae.link=function(Z){var le=this.rules.inline.link.exec(Z);if(le){var re=le[2].trim();if(!this.options.pedantic&&/^</.test(re)){if(!/>$/.test(re))return;var N=a(re.slice(0,-1),"\\");if((re.length-N.length)%2===0)return}else{var H=w(le[2],"()");if(H>-1){var K=le[0].indexOf("!")===0?5:4,_=K+le[1].length+H;le[2]=le[2].substring(0,H),le[0]=le[0].substring(0,_).trim(),le[3]=""}}var he=le[2],we="";if(this.options.pedantic){var Ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(he);Ae&&(he=Ae[1],we=Ae[3])}else we=le[3]?le[3].slice(1,-1):"";return he=he.trim(),/^</.test(he)&&(this.options.pedantic&&!/>$/.test(re)?he=he.slice(1):he=he.slice(1,-1)),x(le,{href:he&&he.replace(this.rules.inline._escapes,"$1"),title:we&&we.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},ae.reflink=function(Z,le){var re;if((re=this.rules.inline.reflink.exec(Z))||(re=this.rules.inline.nolink.exec(Z))){var N=(re[2]||re[1]).replace(/\s+/g," ");if(N=le[N.toLowerCase()],!N||!N.href){var H=re[0].charAt(0);return{type:"text",raw:H,text:H}}return x(re,N,re[0],this.lexer)}},ae.emStrong=function(Z,le,re){re===void 0&&(re="");var N=this.rules.inline.emStrong.lDelim.exec(Z);if(!!N&&!(N[3]&&re.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var H=N[1]||N[2]||"";if(!H||H&&(re===""||this.rules.inline.punctuation.exec(re))){var K=N[0].length-1,_,he,we=K,Ae=0,be=N[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(be.lastIndex=0,le=le.slice(-1*Z.length+K);(N=be.exec(le))!=null;)if(_=N[1]||N[2]||N[3]||N[4]||N[5]||N[6],!!_){if(he=_.length,N[3]||N[4]){we+=he;continue}else if((N[5]||N[6])&&K%3&&!((K+he)%3)){Ae+=he;continue}if(we-=he,!(we>0)){if(he=Math.min(he,he+we+Ae),Math.min(K,he)%2){var Ce=Z.slice(1,K+N.index+he);return{type:"em",raw:Z.slice(0,K+N.index+he+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var Te=Z.slice(2,K+N.index+he-1);return{type:"strong",raw:Z.slice(0,K+N.index+he+1),text:Te,tokens:this.lexer.inlineTokens(Te)}}}}}},ae.codespan=function(Z){var le=this.rules.inline.code.exec(Z);if(le){var re=le[2].replace(/\n/g," "),N=/[^ ]/.test(re),H=/^ /.test(re)&&/ $/.test(re);return N&&H&&(re=re.substring(1,re.length-1)),re=E(re,!0),{type:"codespan",raw:le[0],text:re}}},ae.br=function(Z){var le=this.rules.inline.br.exec(Z);if(le)return{type:"br",raw:le[0]}},ae.del=function(Z){var le=this.rules.inline.del.exec(Z);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2])}},ae.autolink=function(Z,le){var re=this.rules.inline.autolink.exec(Z);if(re){var N,H;return re[2]==="@"?(N=E(this.options.mangle?le(re[1]):re[1]),H="mailto:"+N):(N=E(re[1]),H=N),{type:"link",raw:re[0],text:N,href:H,tokens:[{type:"text",raw:N,text:N}]}}},ae.url=function(Z,le){var re;if(re=this.rules.inline.url.exec(Z)){var N,H;if(re[2]==="@")N=E(this.options.mangle?le(re[0]):re[0]),H="mailto:"+N;else{var K;do K=re[0],re[0]=this.rules.inline._backpedal.exec(re[0])[0];while(K!==re[0]);N=E(re[0]),re[1]==="www."?H="http://"+N:H=N}return{type:"link",raw:re[0],text:N,href:H,tokens:[{type:"text",raw:N,text:N}]}}},ae.inlineText=function(Z,le){var re=this.rules.inline.text.exec(Z);if(re){var N;return this.lexer.state.inRawBlock?N=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(re[0]):E(re[0]):re[0]:N=E(this.options.smartypants?le(re[0]):re[0]),{type:"text",raw:re[0],text:N}}},oe}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:m,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=g(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=g(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=g(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=g(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=g(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=g(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=n({},B),B.gfm=n({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=g(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=g(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=n({},B.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:m,paragraph:g(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:m,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:m,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=g(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=g(B._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=g(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=g(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=g(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=g(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=g(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=g(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=g(O.reflink).replace("label",O._label).replace("ref",B._label).getRegex(),O.nolink=g(O.nolink).replace("ref",B._label).getRegex(),O.reflinkSearch=g(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=n({},O),O.pedantic=n({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=n({},O.normal,{escape:g(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=g(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=n({},O.gfm,{br:g(O.br).replace("{2,}","*").getRegex(),text:g(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function U(oe){return oe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(oe){var ae="",fe,Z,le=oe.length;for(fe=0;fe<le;fe++)Z=oe.charCodeAt(fe),Math.random()>.5&&(Z="x"+Z.toString(16)),ae+="&#"+Z+";";return ae}var j=function(){function oe(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||ne.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:B.normal,inline:O.normal};this.options.pedantic?(Z.block=B.pedantic,Z.inline=O.pedantic):this.options.gfm&&(Z.block=B.gfm,this.options.breaks?Z.inline=O.breaks:Z.inline=O.gfm),this.tokenizer.rules=Z}oe.lex=function(Z,le){var re=new oe(le);return re.lex(Z)},oe.lexInline=function(Z,le){var re=new oe(le);return re.inlineTokens(Z)};var ae=oe.prototype;return ae.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`),this.blockTokens(Z,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},ae.blockTokens=function(Z,le){var re=this;le===void 0&&(le=[]),this.options.pedantic?Z=Z.replace(/\t/g,"    ").replace(/^ +$/gm,""):Z=Z.replace(/^( *)(\t+)/gm,function(we,Ae,be){return Ae+"    ".repeat(be.length)});for(var N,H,K,_;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(we){return(N=we.call({lexer:re},Z,le))?(Z=Z.substring(N.raw.length),le.push(N),!0):!1}))){if(N=this.tokenizer.space(Z)){Z=Z.substring(N.raw.length),N.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(N);continue}if(N=this.tokenizer.code(Z)){Z=Z.substring(N.raw.length),H=le[le.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+N.raw,H.text+=`
`+N.text,this.inlineQueue[this.inlineQueue.length-1].src=H.text):le.push(N);continue}if(N=this.tokenizer.fences(Z)){Z=Z.substring(N.raw.length),le.push(N);continue}if(N=this.tokenizer.heading(Z)){Z=Z.substring(N.raw.length),le.push(N);continue}if(N=this.tokenizer.hr(Z)){Z=Z.substring(N.raw.length),le.push(N);continue}if(N=this.tokenizer.blockquote(Z)){Z=Z.substring(N.raw.length),le.push(N);continue}if(N=this.tokenizer.list(Z)){Z=Z.substring(N.raw.length),le.push(N);continue}if(N=this.tokenizer.html(Z)){Z=Z.substring(N.raw.length),le.push(N);continue}if(N=this.tokenizer.def(Z)){Z=Z.substring(N.raw.length),H=le[le.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+N.raw,H.text+=`
`+N.raw,this.inlineQueue[this.inlineQueue.length-1].src=H.text):this.tokens.links[N.tag]||(this.tokens.links[N.tag]={href:N.href,title:N.title});continue}if(N=this.tokenizer.table(Z)){Z=Z.substring(N.raw.length),le.push(N);continue}if(N=this.tokenizer.lheading(Z)){Z=Z.substring(N.raw.length),le.push(N);continue}if(K=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var we=1/0,Ae=Z.slice(1),be=void 0;re.options.extensions.startBlock.forEach(function(Ce){be=Ce.call({lexer:this},Ae),typeof be=="number"&&be>=0&&(we=Math.min(we,be))}),we<1/0&&we>=0&&(K=Z.substring(0,we+1))}(),this.state.top&&(N=this.tokenizer.paragraph(K))){H=le[le.length-1],_&&H.type==="paragraph"?(H.raw+=`
`+N.raw,H.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):le.push(N),_=K.length!==Z.length,Z=Z.substring(N.raw.length);continue}if(N=this.tokenizer.text(Z)){Z=Z.substring(N.raw.length),H=le[le.length-1],H&&H.type==="text"?(H.raw+=`
`+N.raw,H.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):le.push(N);continue}if(Z){var he="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(he);break}else throw new Error(he)}}return this.state.top=!0,le},ae.inline=function(Z,le){return le===void 0&&(le=[]),this.inlineQueue.push({src:Z,tokens:le}),le},ae.inlineTokens=function(Z,le){var re=this;le===void 0&&(le=[]);var N,H,K,_=Z,he,we,Ae;if(this.tokens.links){var be=Object.keys(this.tokens.links);if(be.length>0)for(;(he=this.tokenizer.rules.inline.reflinkSearch.exec(_))!=null;)be.includes(he[0].slice(he[0].lastIndexOf("[")+1,-1))&&(_=_.slice(0,he.index)+"["+F("a",he[0].length-2)+"]"+_.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(he=this.tokenizer.rules.inline.blockSkip.exec(_))!=null;)_=_.slice(0,he.index)+"["+F("a",he[0].length-2)+"]"+_.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(he=this.tokenizer.rules.inline.escapedEmSt.exec(_))!=null;)_=_.slice(0,he.index)+"++"+_.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(we||(Ae=""),we=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Te){return(N=Te.call({lexer:re},Z,le))?(Z=Z.substring(N.raw.length),le.push(N),!0):!1}))){if(N=this.tokenizer.escape(Z)){Z=Z.substring(N.raw.length),le.push(N);continue}if(N=this.tokenizer.tag(Z)){Z=Z.substring(N.raw.length),H=le[le.length-1],H&&N.type==="text"&&H.type==="text"?(H.raw+=N.raw,H.text+=N.text):le.push(N);continue}if(N=this.tokenizer.link(Z)){Z=Z.substring(N.raw.length),le.push(N);continue}if(N=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(N.raw.length),H=le[le.length-1],H&&N.type==="text"&&H.type==="text"?(H.raw+=N.raw,H.text+=N.text):le.push(N);continue}if(N=this.tokenizer.emStrong(Z,_,Ae)){Z=Z.substring(N.raw.length),le.push(N);continue}if(N=this.tokenizer.codespan(Z)){Z=Z.substring(N.raw.length),le.push(N);continue}if(N=this.tokenizer.br(Z)){Z=Z.substring(N.raw.length),le.push(N);continue}if(N=this.tokenizer.del(Z)){Z=Z.substring(N.raw.length),le.push(N);continue}if(N=this.tokenizer.autolink(Z,z)){Z=Z.substring(N.raw.length),le.push(N);continue}if(!this.state.inLink&&(N=this.tokenizer.url(Z,z))){Z=Z.substring(N.raw.length),le.push(N);continue}if(K=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var Te=1/0,Ve=Z.slice(1),xe=void 0;re.options.extensions.startInline.forEach(function(et){xe=et.call({lexer:this},Ve),typeof xe=="number"&&xe>=0&&(Te=Math.min(Te,xe))}),Te<1/0&&Te>=0&&(K=Z.substring(0,Te+1))}(),N=this.tokenizer.inlineText(K,U)){Z=Z.substring(N.raw.length),N.raw.slice(-1)!=="_"&&(Ae=N.raw.slice(-1)),we=!0,H=le[le.length-1],H&&H.type==="text"?(H.raw+=N.raw,H.text+=N.text):le.push(N);continue}if(Z){var Ce="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return le},c(oe,null,[{key:"rules",get:function(){return{block:B,inline:O}}}]),oe}(),de=function(){function oe(fe){this.options=fe||ne.defaults}var ae=oe.prototype;return ae.code=function(Z,le,re){var N=(le||"").match(/\S*/)[0];if(this.options.highlight){var H=this.options.highlight(Z,N);H!=null&&H!==Z&&(re=!0,Z=H)}return Z=Z.replace(/\n$/,"")+`
`,N?'<pre><code class="'+this.options.langPrefix+E(N,!0)+'">'+(re?Z:E(Z,!0))+`</code></pre>
`:"<pre><code>"+(re?Z:E(Z,!0))+`</code></pre>
`},ae.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},ae.html=function(Z){return Z},ae.heading=function(Z,le,re,N){if(this.options.headerIds){var H=this.options.headerPrefix+N.slug(re);return"<h"+le+' id="'+H+'">'+Z+"</h"+le+`>
`}return"<h"+le+">"+Z+"</h"+le+`>
`},ae.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ae.list=function(Z,le,re){var N=le?"ol":"ul",H=le&&re!==1?' start="'+re+'"':"";return"<"+N+H+`>
`+Z+"</"+N+`>
`},ae.listitem=function(Z){return"<li>"+Z+`</li>
`},ae.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ae.paragraph=function(Z){return"<p>"+Z+`</p>
`},ae.table=function(Z,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+le+`</table>
`},ae.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},ae.tablecell=function(Z,le){var re=le.header?"th":"td",N=le.align?"<"+re+' align="'+le.align+'">':"<"+re+">";return N+Z+("</"+re+`>
`)},ae.strong=function(Z){return"<strong>"+Z+"</strong>"},ae.em=function(Z){return"<em>"+Z+"</em>"},ae.codespan=function(Z){return"<code>"+Z+"</code>"},ae.br=function(){return this.options.xhtml?"<br/>":"<br>"},ae.del=function(Z){return"<del>"+Z+"</del>"},ae.link=function(Z,le,re){if(Z=b(this.options.sanitize,this.options.baseUrl,Z),Z===null)return re;var N='<a href="'+E(Z)+'"';return le&&(N+=' title="'+le+'"'),N+=">"+re+"</a>",N},ae.image=function(Z,le,re){if(Z=b(this.options.sanitize,this.options.baseUrl,Z),Z===null)return re;var N='<img src="'+Z+'" alt="'+re+'"';return le&&(N+=' title="'+le+'"'),N+=this.options.xhtml?"/>":">",N},ae.text=function(Z){return Z},oe}(),V=function(){function oe(){}var ae=oe.prototype;return ae.strong=function(Z){return Z},ae.em=function(Z){return Z},ae.codespan=function(Z){return Z},ae.del=function(Z){return Z},ae.html=function(Z){return Z},ae.text=function(Z){return Z},ae.link=function(Z,le,re){return""+re},ae.image=function(Z,le,re){return""+re},ae.br=function(){return""},oe}(),X=function(){function oe(){this.seen={}}var ae=oe.prototype;return ae.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ae.getNextSafeSlug=function(Z,le){var re=Z,N=0;if(this.seen.hasOwnProperty(re)){N=this.seen[Z];do N++,re=Z+"-"+N;while(this.seen.hasOwnProperty(re))}return le||(this.seen[Z]=N,this.seen[re]=0),re},ae.slug=function(Z,le){le===void 0&&(le={});var re=this.serialize(Z);return this.getNextSafeSlug(re,le.dryrun)},oe}(),J=function(){function oe(fe){this.options=fe||ne.defaults,this.options.renderer=this.options.renderer||new de,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new V,this.slugger=new X}oe.parse=function(Z,le){var re=new oe(le);return re.parse(Z)},oe.parseInline=function(Z,le){var re=new oe(le);return re.parseInline(Z)};var ae=oe.prototype;return ae.parse=function(Z,le){le===void 0&&(le=!0);var re="",N,H,K,_,he,we,Ae,be,Ce,Te,Ve,xe,et,Qe,nt,st,ht,Ue,rt,ce=Z.length;for(N=0;N<ce;N++){if(Te=Z[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(rt=this.options.extensions.renderers[Te.type].call({parser:this},Te),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Te.type))){re+=rt||"";continue}switch(Te.type){case"space":continue;case"hr":{re+=this.renderer.hr();continue}case"heading":{re+=this.renderer.heading(this.parseInline(Te.tokens),Te.depth,d(this.parseInline(Te.tokens,this.textRenderer)),this.slugger);continue}case"code":{re+=this.renderer.code(Te.text,Te.lang,Te.escaped);continue}case"table":{for(be="",Ae="",_=Te.header.length,H=0;H<_;H++)Ae+=this.renderer.tablecell(this.parseInline(Te.header[H].tokens),{header:!0,align:Te.align[H]});for(be+=this.renderer.tablerow(Ae),Ce="",_=Te.rows.length,H=0;H<_;H++){for(we=Te.rows[H],Ae="",he=we.length,K=0;K<he;K++)Ae+=this.renderer.tablecell(this.parseInline(we[K].tokens),{header:!1,align:Te.align[K]});Ce+=this.renderer.tablerow(Ae)}re+=this.renderer.table(be,Ce);continue}case"blockquote":{Ce=this.parse(Te.tokens),re+=this.renderer.blockquote(Ce);continue}case"list":{for(Ve=Te.ordered,xe=Te.start,et=Te.loose,_=Te.items.length,Ce="",H=0;H<_;H++)nt=Te.items[H],st=nt.checked,ht=nt.task,Qe="",nt.task&&(Ue=this.renderer.checkbox(st),et?nt.tokens.length>0&&nt.tokens[0].type==="paragraph"?(nt.tokens[0].text=Ue+" "+nt.tokens[0].text,nt.tokens[0].tokens&&nt.tokens[0].tokens.length>0&&nt.tokens[0].tokens[0].type==="text"&&(nt.tokens[0].tokens[0].text=Ue+" "+nt.tokens[0].tokens[0].text)):nt.tokens.unshift({type:"text",text:Ue}):Qe+=Ue),Qe+=this.parse(nt.tokens,et),Ce+=this.renderer.listitem(Qe,ht,st);re+=this.renderer.list(Ce,Ve,xe);continue}case"html":{re+=this.renderer.html(Te.text);continue}case"paragraph":{re+=this.renderer.paragraph(this.parseInline(Te.tokens));continue}case"text":{for(Ce=Te.tokens?this.parseInline(Te.tokens):Te.text;N+1<ce&&Z[N+1].type==="text";)Te=Z[++N],Ce+=`
`+(Te.tokens?this.parseInline(Te.tokens):Te.text);re+=le?this.renderer.paragraph(Ce):Ce;continue}default:{var $='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error($);return}else throw new Error($)}}}return re},ae.parseInline=function(Z,le){le=le||this.renderer;var re="",N,H,K,_=Z.length;for(N=0;N<_;N++){if(H=Z[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(K=this.options.extensions.renderers[H.type].call({parser:this},H),K!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(H.type))){re+=K||"";continue}switch(H.type){case"escape":{re+=le.text(H.text);break}case"html":{re+=le.html(H.text);break}case"link":{re+=le.link(H.href,H.title,this.parseInline(H.tokens,le));break}case"image":{re+=le.image(H.href,H.title,H.text);break}case"strong":{re+=le.strong(this.parseInline(H.tokens,le));break}case"em":{re+=le.em(this.parseInline(H.tokens,le));break}case"codespan":{re+=le.codespan(H.text);break}case"br":{re+=le.br();break}case"del":{re+=le.del(this.parseInline(H.tokens,le));break}case"text":{re+=le.text(H.text);break}default:{var he='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(he);return}else throw new Error(he)}}}return re},oe}();function te(oe,ae,fe){if(typeof oe>"u"||oe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");if(typeof ae=="function"&&(fe=ae,ae=null),ae=n({},te.defaults,ae||{}),D(ae),fe){var Z=ae.highlight,le;try{le=j.lex(oe,ae)}catch(_){return fe(_)}var re=function(he){var we;if(!he)try{ae.walkTokens&&te.walkTokens(le,ae.walkTokens),we=J.parse(le,ae)}catch(Ae){he=Ae}return ae.highlight=Z,he?fe(he):fe(null,we)};if(!Z||Z.length<3||(delete ae.highlight,!le.length))return re();var N=0;te.walkTokens(le,function(_){_.type==="code"&&(N++,setTimeout(function(){Z(_.text,_.lang,function(he,we){if(he)return re(he);we!=null&&we!==_.text&&(_.text=we,_.escaped=!0),N--,N===0&&re()})},0))}),N===0&&re();return}function H(_){if(_.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+E(_.message+"",!0)+"</pre>";throw _}try{var K=j.lex(oe,ae);if(ae.walkTokens){if(ae.async)return Promise.all(te.walkTokens(K,ae.walkTokens)).then(function(){return J.parse(K,ae)}).catch(H);te.walkTokens(K,ae.walkTokens)}return J.parse(K,ae)}catch(_){H(_)}}te.options=te.setOptions=function(oe){return n(te.defaults,oe),P(te.defaults),te},te.getDefaults=C,te.defaults=ne.defaults,te.use=function(){for(var oe=arguments.length,ae=new Array(oe),fe=0;fe<oe;fe++)ae[fe]=arguments[fe];var Z=n.apply(void 0,[{}].concat(ae)),le=te.defaults.extensions||{renderers:{},childTokens:{}},re;ae.forEach(function(N){if(N.extensions&&(re=!0,N.extensions.forEach(function(K){if(!K.name)throw new Error("extension name required");if(K.renderer){var _=le.renderers?le.renderers[K.name]:null;_?le.renderers[K.name]=function(){for(var he=arguments.length,we=new Array(he),Ae=0;Ae<he;Ae++)we[Ae]=arguments[Ae];var be=K.renderer.apply(this,we);return be===!1&&(be=_.apply(this,we)),be}:le.renderers[K.name]=K.renderer}if(K.tokenizer){if(!K.level||K.level!=="block"&&K.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[K.level]?le[K.level].unshift(K.tokenizer):le[K.level]=[K.tokenizer],K.start&&(K.level==="block"?le.startBlock?le.startBlock.push(K.start):le.startBlock=[K.start]:K.level==="inline"&&(le.startInline?le.startInline.push(K.start):le.startInline=[K.start]))}K.childTokens&&(le.childTokens[K.name]=K.childTokens)})),N.renderer&&function(){var K=te.defaults.renderer||new de,_=function(Ae){var be=K[Ae];K[Ae]=function(){for(var Ce=arguments.length,Te=new Array(Ce),Ve=0;Ve<Ce;Ve++)Te[Ve]=arguments[Ve];var xe=N.renderer[Ae].apply(K,Te);return xe===!1&&(xe=be.apply(K,Te)),xe}};for(var he in N.renderer)_(he);Z.renderer=K}(),N.tokenizer&&function(){var K=te.defaults.tokenizer||new M,_=function(Ae){var be=K[Ae];K[Ae]=function(){for(var Ce=arguments.length,Te=new Array(Ce),Ve=0;Ve<Ce;Ve++)Te[Ve]=arguments[Ve];var xe=N.tokenizer[Ae].apply(K,Te);return xe===!1&&(xe=be.apply(K,Te)),xe}};for(var he in N.tokenizer)_(he);Z.tokenizer=K}(),N.walkTokens){var H=te.defaults.walkTokens;Z.walkTokens=function(K){var _=[];return _.push(N.walkTokens.call(this,K)),H&&(_=_.concat(H.call(this,K))),_}}re&&(Z.extensions=le),te.setOptions(Z)})},te.walkTokens=function(oe,ae){for(var fe=[],Z=function(){var H=re.value;switch(fe=fe.concat(ae.call(te,H)),H.type){case"table":{for(var K=R(H.header),_;!(_=K()).done;){var he=_.value;fe=fe.concat(te.walkTokens(he.tokens,ae))}for(var we=R(H.rows),Ae;!(Ae=we()).done;)for(var be=Ae.value,Ce=R(be),Te;!(Te=Ce()).done;){var Ve=Te.value;fe=fe.concat(te.walkTokens(Ve.tokens,ae))}break}case"list":{fe=fe.concat(te.walkTokens(H.items,ae));break}default:te.defaults.extensions&&te.defaults.extensions.childTokens&&te.defaults.extensions.childTokens[H.type]?te.defaults.extensions.childTokens[H.type].forEach(function(xe){fe=fe.concat(te.walkTokens(H[xe],ae))}):H.tokens&&(fe=fe.concat(te.walkTokens(H.tokens,ae)))}},le=R(oe),re;!(re=le()).done;)Z();return fe},te.parseInline=function(oe,ae){if(typeof oe>"u"||oe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");ae=n({},te.defaults,ae||{}),D(ae);try{var fe=j.lexInline(oe,ae);return ae.walkTokens&&te.walkTokens(fe,ae.walkTokens),J.parseInline(fe,ae)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+E(Z.message+"",!0)+"</pre>";throw Z}},te.Parser=J,te.parser=J.parse,te.Renderer=de,te.TextRenderer=V,te.Lexer=j,te.lexer=j.lex,te.Tokenizer=M,te.Slugger=X,te.parse=te;var ee=te.options,Q=te.setOptions,Y=te.use,ie=te.walkTokens,pe=te.parseInline,ve=te,ke=J.parse,Oe=j.lex;ne.Lexer=j,ne.Parser=J,ne.Renderer=de,ne.Slugger=X,ne.TextRenderer=V,ne.Tokenizer=M,ne.getDefaults=C,ne.lexer=Oe,ne.marked=te,ne.options=ee,ne.parse=ve,ne.parseInline=pe,ne.parser=ke,ne.setOptions=Q,ne.use=Y,ne.walkTokens=ie,Object.defineProperty(ne,"__esModule",{value:!0})}),define(ye[85],De([1,0,28]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const A=new c.LRUCache(1e4);function u(I){return S(I,"NFC",A)}e.normalizeNFC=u;const R=new c.LRUCache(1e4);function C(I){return S(I,"NFD",R)}e.normalizeNFD=C;const P=/[^\u0000-\u0080]/;function S(I,L,k){if(!I)return I;const v=k.get(I);if(v)return v;let T;return P.test(I)?T=I.normalize(L):T=I,k.set(I,T),T}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(L){return C(L).replace(I,"")}}()}),define(ye[102],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function c(P,S,I){return Math.min(Math.max(P,S),I)}e.clamp=c;function A(P,S){return(S+P%S)%S}e.rot=A;class u{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=u;class R{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=R;class C{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const I=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=C}),function(){function ne(u){const R=[];typeof u=="number"&&R.push("code/timeOrigin",u);function C(S){R.push(S,Date.now())}function P(){const S=[];for(let I=0;I<R.length;I+=2)S.push({name:R[I],startTime:R[I+1]});return S}return{mark:C,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(u){performance.mark(u)},getMarks(){let u=performance.timeOrigin;typeof u!="number"&&(u=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(u)}];for(const C of performance.getEntriesByType("mark"))R.push({name:C.name,startTime:Math.round(u+C.startTime)});return R}};if(typeof process=="object"){const u=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(u)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function c(u){return u.MonacoPerformanceMarks||(u.MonacoPerformanceMarks=e()),u.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=c(A))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var c=e();for(var A in c)(typeof exports=="object"?exports:ne)[A]=c[A]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function c(A){if(e[A])return e[A].exports;var u=e[A]={i:A,l:!1,exports:{}};return ne[A].call(u.exports,u,u.exports,c),u.l=!0,u.exports}return c.m=ne,c.c=e,c.d=function(A,u,R){c.o(A,u)||Object.defineProperty(A,u,{enumerable:!0,get:R})},c.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},c.t=function(A,u){if(1&u&&(A=c(A)),8&u||4&u&&typeof A=="object"&&A&&A.__esModule)return A;var R=Object.create(null);if(c.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:A}),2&u&&typeof A!="string")for(var C in A)c.d(R,C,function(P){return A[P]}.bind(null,C));return R},c.n=function(A){var u=A&&A.__esModule?function(){return A.default}:function(){return A};return c.d(u,"a",u),u},c.o=function(A,u){return Object.prototype.hasOwnProperty.call(A,u)},c.p="",c(c.s=0)}([function(ne,e,c){(function(A){var u;e=ne.exports=Y,u=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var be=Array.prototype.slice.call(arguments,0);be.unshift("SEMVER"),console.log.apply(console,be)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],S=e.src=[],I=0,L=I++;S[L]="0|[1-9]\\d*";var k=I++;S[k]="[0-9]+";var v=I++;S[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var T=I++;S[T]="("+S[L]+")\\.("+S[L]+")\\.("+S[L]+")";var E=I++;S[E]="("+S[k]+")\\.("+S[k]+")\\.("+S[k]+")";var f=I++;S[f]="(?:"+S[L]+"|"+S[v]+")";var d=I++;S[d]="(?:"+S[k]+"|"+S[v]+")";var h=I++;S[h]="(?:-("+S[f]+"(?:\\."+S[f]+")*))";var g=I++;S[g]="(?:-?("+S[d]+"(?:\\."+S[d]+")*))";var p=I++;S[p]="[0-9A-Za-z-]+";var y=I++;S[y]="(?:\\+("+S[p]+"(?:\\."+S[p]+")*))";var b=I++,i="v?"+S[T]+S[h]+"?"+S[y]+"?";S[b]="^"+i+"$";var o="[v=\\s]*"+S[E]+S[g]+"?"+S[y]+"?",s=I++;S[s]="^"+o+"$";var l=I++;S[l]="((?:<|>)?=?)";var r=I++;S[r]=S[k]+"|x|X|\\*";var m=I++;S[m]=S[L]+"|x|X|\\*";var n=I++;S[n]="[v=\\s]*("+S[m]+")(?:\\.("+S[m]+")(?:\\.("+S[m]+")(?:"+S[h]+")?"+S[y]+"?)?)?";var t=I++;S[t]="[v=\\s]*("+S[r]+")(?:\\.("+S[r]+")(?:\\.("+S[r]+")(?:"+S[g]+")?"+S[y]+"?)?)?";var a=I++;S[a]="^"+S[l]+"\\s*"+S[n]+"$";var w=I++;S[w]="^"+S[l]+"\\s*"+S[t]+"$";var D=I++;S[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=I++;S[F]="(?:~>?)";var x=I++;S[x]="(\\s*)"+S[F]+"\\s+",P[x]=new RegExp(S[x],"g");var q=I++;S[q]="^"+S[F]+S[n]+"$";var M=I++;S[M]="^"+S[F]+S[t]+"$";var B=I++;S[B]="(?:\\^)";var O=I++;S[O]="(\\s*)"+S[B]+"\\s+",P[O]=new RegExp(S[O],"g");var U=I++;S[U]="^"+S[B]+S[n]+"$";var z=I++;S[z]="^"+S[B]+S[t]+"$";var j=I++;S[j]="^"+S[l]+"\\s*("+o+")$|^$";var de=I++;S[de]="^"+S[l]+"\\s*("+i+")$|^$";var V=I++;S[V]="(\\s*)"+S[l]+"\\s*("+o+"|"+S[n]+")",P[V]=new RegExp(S[V],"g");var X=I++;S[X]="^\\s*("+S[n]+")\\s+-\\s+("+S[n]+")\\s*$";var J=I++;S[J]="^\\s*("+S[t]+")\\s+-\\s+("+S[t]+")\\s*$";var te=I++;S[te]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)u(ee,S[ee]),P[ee]||(P[ee]=new RegExp(S[ee]));function Q(be,Ce){if(be instanceof Y)return be;if(typeof be!="string"||be.length>R||!(Ce?P[s]:P[b]).test(be))return null;try{return new Y(be,Ce)}catch{return null}}function Y(be,Ce){if(be instanceof Y){if(be.loose===Ce)return be;be=be.version}else if(typeof be!="string")throw new TypeError("Invalid Version: "+be);if(be.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof Y))return new Y(be,Ce);u("SemVer",be,Ce),this.loose=Ce;var Te=be.trim().match(Ce?P[s]:P[b]);if(!Te)throw new TypeError("Invalid Version: "+be);if(this.raw=be,this.major=+Te[1],this.minor=+Te[2],this.patch=+Te[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");Te[4]?this.prerelease=Te[4].split(".").map(function(Ve){if(/^[0-9]+$/.test(Ve)){var xe=+Ve;if(xe>=0&&xe<C)return xe}return Ve}):this.prerelease=[],this.build=Te[5]?Te[5].split("."):[],this.format()}e.parse=Q,e.valid=function(be,Ce){var Te=Q(be,Ce);return Te?Te.version:null},e.clean=function(be,Ce){var Te=Q(be.trim().replace(/^[=v]+/,""),Ce);return Te?Te.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(be){return u("SemVer.compare",this.version,this.loose,be),be instanceof Y||(be=new Y(be,this.loose)),this.compareMain(be)||this.comparePre(be)},Y.prototype.compareMain=function(be){return be instanceof Y||(be=new Y(be,this.loose)),pe(this.major,be.major)||pe(this.minor,be.minor)||pe(this.patch,be.patch)},Y.prototype.comparePre=function(be){if(be instanceof Y||(be=new Y(be,this.loose)),this.prerelease.length&&!be.prerelease.length)return-1;if(!this.prerelease.length&&be.prerelease.length)return 1;if(!this.prerelease.length&&!be.prerelease.length)return 0;var Ce=0;do{var Te=this.prerelease[Ce],Ve=be.prerelease[Ce];if(u("prerelease compare",Ce,Te,Ve),Te===void 0&&Ve===void 0)return 0;if(Ve===void 0)return 1;if(Te===void 0)return-1;if(Te!==Ve)return pe(Te,Ve)}while(++Ce)},Y.prototype.inc=function(be,Ce){switch(be){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ce),this.inc("pre",Ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ce),this.inc("pre",Ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Te=this.prerelease.length;--Te>=0;)typeof this.prerelease[Te]=="number"&&(this.prerelease[Te]++,Te=-2);Te===-1&&this.prerelease.push(0)}Ce&&(this.prerelease[0]===Ce?isNaN(this.prerelease[1])&&(this.prerelease=[Ce,0]):this.prerelease=[Ce,0]);break;default:throw new Error("invalid increment argument: "+be)}return this.format(),this.raw=this.version,this},e.inc=function(be,Ce,Te,Ve){typeof Te=="string"&&(Ve=Te,Te=void 0);try{return new Y(be,Te).inc(Ce,Ve).version}catch{return null}},e.diff=function(be,Ce){if(oe(be,Ce))return null;var Te=Q(be),Ve=Q(Ce);if(Te.prerelease.length||Ve.prerelease.length){for(var xe in Te)if((xe==="major"||xe==="minor"||xe==="patch")&&Te[xe]!==Ve[xe])return"pre"+xe;return"prerelease"}for(var xe in Te)if((xe==="major"||xe==="minor"||xe==="patch")&&Te[xe]!==Ve[xe])return xe},e.compareIdentifiers=pe;var ie=/^[0-9]+$/;function pe(be,Ce){var Te=ie.test(be),Ve=ie.test(Ce);return Te&&Ve&&(be=+be,Ce=+Ce),Te&&!Ve?-1:Ve&&!Te?1:be<Ce?-1:be>Ce?1:0}function ve(be,Ce,Te){return new Y(be,Te).compare(new Y(Ce,Te))}function ke(be,Ce,Te){return ve(be,Ce,Te)>0}function Oe(be,Ce,Te){return ve(be,Ce,Te)<0}function oe(be,Ce,Te){return ve(be,Ce,Te)===0}function ae(be,Ce,Te){return ve(be,Ce,Te)!==0}function fe(be,Ce,Te){return ve(be,Ce,Te)>=0}function Z(be,Ce,Te){return ve(be,Ce,Te)<=0}function le(be,Ce,Te,Ve){var xe;switch(Ce){case"===":typeof be=="object"&&(be=be.version),typeof Te=="object"&&(Te=Te.version),xe=be===Te;break;case"!==":typeof be=="object"&&(be=be.version),typeof Te=="object"&&(Te=Te.version),xe=be!==Te;break;case"":case"=":case"==":xe=oe(be,Te,Ve);break;case"!=":xe=ae(be,Te,Ve);break;case">":xe=ke(be,Te,Ve);break;case">=":xe=fe(be,Te,Ve);break;case"<":xe=Oe(be,Te,Ve);break;case"<=":xe=Z(be,Te,Ve);break;default:throw new TypeError("Invalid operator: "+Ce)}return xe}function re(be,Ce){if(be instanceof re){if(be.loose===Ce)return be;be=be.value}if(!(this instanceof re))return new re(be,Ce);u("comparator",be,Ce),this.loose=Ce,this.parse(be),this.semver===N?this.value="":this.value=this.operator+this.semver.version,u("comp",this)}e.rcompareIdentifiers=function(be,Ce){return pe(Ce,be)},e.major=function(be,Ce){return new Y(be,Ce).major},e.minor=function(be,Ce){return new Y(be,Ce).minor},e.patch=function(be,Ce){return new Y(be,Ce).patch},e.compare=ve,e.compareLoose=function(be,Ce){return ve(be,Ce,!0)},e.rcompare=function(be,Ce,Te){return ve(Ce,be,Te)},e.sort=function(be,Ce){return be.sort(function(Te,Ve){return e.compare(Te,Ve,Ce)})},e.rsort=function(be,Ce){return be.sort(function(Te,Ve){return e.rcompare(Te,Ve,Ce)})},e.gt=ke,e.lt=Oe,e.eq=oe,e.neq=ae,e.gte=fe,e.lte=Z,e.cmp=le,e.Comparator=re;var N={};function H(be,Ce){if(be instanceof H)return be.loose===Ce?be:new H(be.raw,Ce);if(be instanceof re)return new H(be.value,Ce);if(!(this instanceof H))return new H(be,Ce);if(this.loose=Ce,this.raw=be,this.set=be.split(/\s*\|\|\s*/).map(function(Te){return this.parseRange(Te.trim())},this).filter(function(Te){return Te.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+be);this.format()}function K(be){return!be||be.toLowerCase()==="x"||be==="*"}function _(be,Ce,Te,Ve,xe,et,Qe,nt,st,ht,Ue,rt,ce){return((Ce=K(Te)?"":K(Ve)?">="+Te+".0.0":K(xe)?">="+Te+"."+Ve+".0":">="+Ce)+" "+(nt=K(st)?"":K(ht)?"<"+(+st+1)+".0.0":K(Ue)?"<"+st+"."+(+ht+1)+".0":rt?"<="+st+"."+ht+"."+Ue+"-"+rt:"<="+nt)).trim()}function he(be,Ce){for(var Te=0;Te<be.length;Te++)if(!be[Te].test(Ce))return!1;if(Ce.prerelease.length){for(Te=0;Te<be.length;Te++)if(u(be[Te].semver),be[Te].semver!==N&&be[Te].semver.prerelease.length>0){var Ve=be[Te].semver;if(Ve.major===Ce.major&&Ve.minor===Ce.minor&&Ve.patch===Ce.patch)return!0}return!1}return!0}function we(be,Ce,Te){try{Ce=new H(Ce,Te)}catch{return!1}return Ce.test(be)}function Ae(be,Ce,Te,Ve){var xe,et,Qe,nt,st;switch(be=new Y(be,Ve),Ce=new H(Ce,Ve),Te){case">":xe=ke,et=Z,Qe=Oe,nt=">",st=">=";break;case"<":xe=Oe,et=fe,Qe=ke,nt="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(be,Ce,Ve))return!1;for(var ht=0;ht<Ce.set.length;++ht){var Ue=Ce.set[ht],rt=null,ce=null;if(Ue.forEach(function($){$.semver===N&&($=new re(">=0.0.0")),rt=rt||$,ce=ce||$,xe($.semver,rt.semver,Ve)?rt=$:Qe($.semver,ce.semver,Ve)&&(ce=$)}),rt.operator===nt||rt.operator===st||(!ce.operator||ce.operator===nt)&&et(be,ce.semver)||ce.operator===st&&Qe(be,ce.semver))return!1}return!0}re.prototype.parse=function(be){var Ce=this.loose?P[j]:P[de],Te=be.match(Ce);if(!Te)throw new TypeError("Invalid comparator: "+be);this.operator=Te[1],this.operator==="="&&(this.operator=""),Te[2]?this.semver=new Y(Te[2],this.loose):this.semver=N},re.prototype.toString=function(){return this.value},re.prototype.test=function(be){return u("Comparator.test",be,this.loose),this.semver===N||(typeof be=="string"&&(be=new Y(be,this.loose)),le(be,this.operator,this.semver,this.loose))},re.prototype.intersects=function(be,Ce){if(!(be instanceof re))throw new TypeError("a Comparator is required");var Te;if(this.operator==="")return Te=new H(be.value,Ce),we(this.value,Te,Ce);if(be.operator==="")return Te=new H(this.value,Ce),we(be.semver,Te,Ce);var Ve=!(this.operator!==">="&&this.operator!==">"||be.operator!==">="&&be.operator!==">"),xe=!(this.operator!=="<="&&this.operator!=="<"||be.operator!=="<="&&be.operator!=="<"),et=this.semver.version===be.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||be.operator!==">="&&be.operator!=="<="),nt=le(this.semver,"<",be.semver,Ce)&&(this.operator===">="||this.operator===">")&&(be.operator==="<="||be.operator==="<"),st=le(this.semver,">",be.semver,Ce)&&(this.operator==="<="||this.operator==="<")&&(be.operator===">="||be.operator===">");return Ve||xe||et&&Qe||nt||st},e.Range=H,H.prototype.format=function(){return this.range=this.set.map(function(be){return be.join(" ").trim()}).join("||").trim(),this.range},H.prototype.toString=function(){return this.range},H.prototype.parseRange=function(be){var Ce=this.loose;be=be.trim(),u("range",be,Ce);var Te=Ce?P[J]:P[X];be=be.replace(Te,_),u("hyphen replace",be),be=be.replace(P[V],"$1$2$3"),u("comparator trim",be,P[V]),be=(be=(be=be.replace(P[x],"$1~")).replace(P[O],"$1^")).split(/\s+/).join(" ");var Ve=Ce?P[j]:P[de],xe=be.split(" ").map(function(et){return function(Qe,nt){return u("comp",Qe),Qe=function(st,ht){return st.trim().split(/\s+/).map(function(Ue){return function(rt,ce){u("caret",rt,ce);var $=ce?P[z]:P[U];return rt.replace($,function(ue,Ie,Le,$e,Ke){var Ze;return u("caret",rt,ue,Ie,Le,$e,Ke),K(Ie)?Ze="":K(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":K($e)?Ze=Ie==="0"?">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+".0 <"+(+Ie+1)+".0.0":Ke?(u("replaceCaret pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+$e+Ke+" <"+Ie+"."+Le+"."+(+$e+1):">="+Ie+"."+Le+"."+$e+Ke+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+$e+Ke+" <"+(+Ie+1)+".0.0"):(u("no pr"),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+$e+" <"+Ie+"."+Le+"."+(+$e+1):">="+Ie+"."+Le+"."+$e+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+$e+" <"+(+Ie+1)+".0.0"),u("caret return",Ze),Ze})}(Ue,ht)}).join(" ")}(Qe,nt),u("caret",Qe),Qe=function(st,ht){return st.trim().split(/\s+/).map(function(Ue){return function(rt,ce){var $=ce?P[M]:P[q];return rt.replace($,function(ue,Ie,Le,$e,Ke){var Ze;return u("tilde",rt,ue,Ie,Le,$e,Ke),K(Ie)?Ze="":K(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":K($e)?Ze=">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":Ke?(u("replaceTilde pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),Ze=">="+Ie+"."+Le+"."+$e+Ke+" <"+Ie+"."+(+Le+1)+".0"):Ze=">="+Ie+"."+Le+"."+$e+" <"+Ie+"."+(+Le+1)+".0",u("tilde return",Ze),Ze})}(Ue,ht)}).join(" ")}(Qe,nt),u("tildes",Qe),Qe=function(st,ht){return u("replaceXRanges",st,ht),st.split(/\s+/).map(function(Ue){return function(rt,ce){rt=rt.trim();var $=ce?P[w]:P[a];return rt.replace($,function(ue,Ie,Le,$e,Ke,Ze){u("xRange",rt,ue,Ie,Le,$e,Ke,Ze);var pt=K(Le),gt=pt||K($e),ct=gt||K(Ke);return Ie==="="&&ct&&(Ie=""),pt?ue=Ie===">"||Ie==="<"?"<0.0.0":"*":Ie&&ct?(gt&&($e=0),ct&&(Ke=0),Ie===">"?(Ie=">=",gt?(Le=+Le+1,$e=0,Ke=0):ct&&($e=+$e+1,Ke=0)):Ie==="<="&&(Ie="<",gt?Le=+Le+1:$e=+$e+1),ue=Ie+Le+"."+$e+"."+Ke):gt?ue=">="+Le+".0.0 <"+(+Le+1)+".0.0":ct&&(ue=">="+Le+"."+$e+".0 <"+Le+"."+(+$e+1)+".0"),u("xRange return",ue),ue})}(Ue,ht)}).join(" ")}(Qe,nt),u("xrange",Qe),Qe=function(st,ht){return u("replaceStars",st,ht),st.trim().replace(P[te],"")}(Qe,nt),u("stars",Qe),Qe}(et,Ce)}).join(" ").split(/\s+/);return this.loose&&(xe=xe.filter(function(et){return!!et.match(Ve)})),xe=xe.map(function(et){return new re(et,Ce)})},H.prototype.intersects=function(be,Ce){if(!(be instanceof H))throw new TypeError("a Range is required");return this.set.some(function(Te){return Te.every(function(Ve){return be.set.some(function(xe){return xe.every(function(et){return Ve.intersects(et,Ce)})})})})},e.toComparators=function(be,Ce){return new H(be,Ce).set.map(function(Te){return Te.map(function(Ve){return Ve.value}).join(" ").trim().split(" ")})},H.prototype.test=function(be){if(!be)return!1;typeof be=="string"&&(be=new Y(be,this.loose));for(var Ce=0;Ce<this.set.length;Ce++)if(he(this.set[Ce],be))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(be,Ce,Te){var Ve=null,xe=null;try{var et=new H(Ce,Te)}catch{return null}return be.forEach(function(Qe){et.test(Qe)&&(Ve&&xe.compare(Qe)!==-1||(xe=new Y(Ve=Qe,Te)))}),Ve},e.minSatisfying=function(be,Ce,Te){var Ve=null,xe=null;try{var et=new H(Ce,Te)}catch{return null}return be.forEach(function(Qe){et.test(Qe)&&(Ve&&xe.compare(Qe)!==1||(xe=new Y(Ve=Qe,Te)))}),Ve},e.validRange=function(be,Ce){try{return new H(be,Ce).range||"*"}catch{return null}},e.ltr=function(be,Ce,Te){return Ae(be,Ce,"<",Te)},e.gtr=function(be,Ce,Te){return Ae(be,Ce,">",Te)},e.outside=Ae,e.prerelease=function(be,Ce){var Te=Q(be,Ce);return Te&&Te.prerelease.length?Te.prerelease:null},e.intersects=function(be,Ce,Te){return be=new H(be,Te),Ce=new H(Ce,Te),be.intersects(Ce)},e.coerce=function(be){if(be instanceof Y)return be;if(typeof be!="string")return null;var Ce=be.match(P[D]);return Ce==null?null:Q((Ce[1]||"0")+"."+(Ce[2]||"0")+"."+(Ce[3]||"0"))}}).call(this,c(1))},function(ne,e){var c,A,u=ne.exports={};function R(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function P(d){if(c===setTimeout)return setTimeout(d,0);if((c===R||!c)&&setTimeout)return c=setTimeout,setTimeout(d,0);try{return c(d,0)}catch{try{return c.call(null,d,0)}catch{return c.call(this,d,0)}}}(function(){try{c=typeof setTimeout=="function"?setTimeout:R}catch{c=R}try{A=typeof clearTimeout=="function"?clearTimeout:C}catch{A=C}})();var S,I=[],L=!1,k=-1;function v(){L&&S&&(L=!1,S.length?I=S.concat(I):k=-1,I.length&&T())}function T(){if(!L){var d=P(v);L=!0;for(var h=I.length;h;){for(S=I,I=[];++k<h;)S&&S[k].run();k=-1,h=I.length}S=null,L=!1,function(g){if(A===clearTimeout)return clearTimeout(g);if((A===C||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(g);try{A(g)}catch{try{return A.call(null,g)}catch{return A.call(this,g)}}}(d)}}function E(d,h){this.fun=d,this.array=h}function f(){}u.nextTick=function(d){var h=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)h[g-1]=arguments[g];I.push(new E(d,h)),I.length!==1||L||P(T)},E.prototype.run=function(){this.fun.apply(null,this.array)},u.title="browser",u.browser=!0,u.env={},u.argv=[],u.version="",u.versions={},u.on=f,u.addListener=f,u.once=f,u.off=f,u.removeListener=f,u.removeAllListeners=f,u.emit=f,u.prependListener=f,u.prependOnceListener=f,u.listeners=function(d){return[]},u.binding=function(d){throw new Error("process.binding is not supported")},u.cwd=function(){return"/"},u.chdir=function(d){throw new Error("process.chdir is not supported")},u.umask=function(){return 0}}])}),define(ye[103],De([1,0,11,6]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function u(y){const b=y;return b?typeof b.read=="function":!1}e.isReadable=u;function R(y){const b=y;return b?[b.on,b.pause,b.resume,b.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=R;function C(y){const b=y;return b?R(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}e.isReadableBufferedStream=C;function P(y,b){return new S(y,b)}e.newWriteableStream=P;class S{constructor(b,i){this.e=b,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(i=>i(b))}h(b){this.c.error.length===0?(0,c.onUnexpectedError)(b):this.c.error.slice(0).forEach(i=>i(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,i){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(b,i){if(this.a.destroyed)return;let o;switch(b){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const s=o.indexOf(i);s>=0&&o.splice(s,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function I(y,b){const i=[];let o;for(;(o=y.read())!==null;)i.push(o);return b(i)}e.consumeReadable=I;function L(y,b,i){const o=[];let s;for(;(s=y.read())!==null&&o.length<i;)o.push(s);return s===null&&o.length>0?b(o):{read:()=>{if(o.length>0)return o.shift();if(typeof s<"u"){const l=s;return s=void 0,l}return y.read()}}}e.peekReadable=L;function k(y,b){return new Promise((i,o)=>{const s=[];v(y,{onData:l=>{b&&s.push(l)},onError:l=>{b?o(l):i(void 0)},onEnd:()=>{i(b?b(s):void 0)}})})}e.consumeStream=k;function v(y,b){let i=!1;return y.on("error",o=>{i||b.onError(o)}),y.on("end",()=>{i||b.onEnd()}),y.on("data",o=>{i||b.onData(o)}),(0,A.toDisposable)(()=>i=!0)}e.listenStream=v;function T(y,b){return new Promise((i,o)=>{const s=new A.DisposableStore,l=[],r=t=>{if(l.push(t),l.length>b)return s.dispose(),y.pause(),i({stream:y,buffer:l,ended:!1})},m=t=>o(t),n=()=>i({stream:y,buffer:l,ended:!0});s.add((0,A.toDisposable)(()=>y.removeListener("error",m))),y.on("error",m),s.add((0,A.toDisposable)(()=>y.removeListener("end",n))),y.on("end",n),s.add((0,A.toDisposable)(()=>y.removeListener("data",r))),y.on("data",r)})}e.peekStream=T;function E(y,b){const i=P(b);return i.end(y),i}e.toStream=E;function f(){const y=P(()=>{throw new Error("not supported")});return y.end(),y}e.emptyStream=f;function d(y){let b=!1;return{read:()=>b?null:(b=!0,y)}}e.toReadable=d;function h(y,b,i){const o=P(i);return v(y,{onData:s=>o.write(b.data(s)),onError:s=>o.error(b.error?b.error(s):s),onEnd:()=>o.end()}),o}e.transform=h;function g(y,b,i){let o=!1;return{read:()=>{const s=b.read();return o?s:(o=!0,s!==null?i([y,s]):y)}}}e.prefixedReadable=g;function p(y,b,i){let o=!1;const s=P(i);return v(b,{onData:l=>o?s.write(l):(o=!0,s.write(i([y,l]))),onError:l=>s.error(l),onEnd:()=>{o||(o=!0,s.write(y)),s.end()}}),s}e.prefixedStream=p}),define(ye[22],De([1,0,103]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer<"u";let u,R;class C{static alloc(t){return A?new C(Buffer.allocUnsafe(t)):new C(new Uint8Array(t))}static wrap(t){return A&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new C(t)}static fromString(t,a){return!(a?.dontUseNodeBuffer||!1)&&A?new C(Buffer.from(t)):(u||(u=new TextEncoder),new C(u.encode(t)))}static fromByteArray(t){const a=C.alloc(t.length);for(let w=0,D=t.length;w<D;w++)a.buffer[w]=t[w];return a}static concat(t,a){if(typeof a>"u"){a=0;for(let F=0,x=t.length;F<x;F++)a+=t[F].byteLength}const w=C.alloc(a);let D=0;for(let F=0,x=t.length;F<x;F++){const q=t[F];w.set(q,D),D+=q.byteLength}return w}constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}clone(){const t=C.alloc(this.byteLength);return t.set(this),t}toString(){return A?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(t,a){return new C(this.buffer.subarray(t,a))}set(t,a){if(t instanceof C)this.buffer.set(t.buffer,a);else if(t instanceof Uint8Array)this.buffer.set(t,a);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),a);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),a);else throw new Error("Unknown argument 'array'")}readUInt32BE(t){return I(this.buffer,t)}writeUInt32BE(t,a){L(this.buffer,t,a)}readUInt32LE(t){return k(this.buffer,t)}writeUInt32LE(t,a){v(this.buffer,t,a)}readUInt8(t){return T(this.buffer,t)}writeUInt8(t,a){E(this.buffer,t,a)}}e.VSBuffer=C;function P(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0}e.readUInt16LE=P;function S(n,t,a){n[a+0]=t&255,t=t>>>8,n[a+1]=t&255}e.writeUInt16LE=S;function I(n,t){return n[t]*2**24+n[t+1]*2**16+n[t+2]*2**8+n[t+3]}e.readUInt32BE=I;function L(n,t,a){n[a+3]=t,t=t>>>8,n[a+2]=t,t=t>>>8,n[a+1]=t,t=t>>>8,n[a]=t}e.writeUInt32BE=L;function k(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0|n[t+2]<<16>>>0|n[t+3]<<24>>>0}e.readUInt32LE=k;function v(n,t,a){n[a+0]=t&255,t=t>>>8,n[a+1]=t&255,t=t>>>8,n[a+2]=t&255,t=t>>>8,n[a+3]=t&255}e.writeUInt32LE=v;function T(n,t){return n[t]}e.readUInt8=T;function E(n,t,a){n[a]=t}e.writeUInt8=E;function f(n){return c.consumeReadable(n,t=>C.concat(t))}e.readableToBuffer=f;function d(n){return c.toReadable(n)}e.bufferToReadable=d;function h(n){return c.consumeStream(n,t=>C.concat(t))}e.streamToBuffer=h;async function g(n){return n.ended?C.concat(n.buffer):C.concat([...n.buffer,await h(n.stream)])}e.bufferedStreamToBuffer=g;function p(n){return c.toStream(n,t=>C.concat(t))}e.bufferToStream=p;function y(n){return c.transform(n,{data:t=>typeof t=="string"?C.fromString(t):C.wrap(t)},t=>C.concat(t))}e.streamToBufferReadableStream=y;function b(n){return c.newWriteableStream(t=>C.concat(t),n)}e.newWriteableBufferStream=b;function i(n,t){return c.prefixedReadable(n,t,a=>C.concat(a))}e.prefixedBufferReadable=i;function o(n,t){return c.prefixedStream(n,t,a=>C.concat(a))}e.prefixedBufferStream=o;function s(n){let t=0,a=0,w=0;const D=new Uint8Array(Math.floor(n.length/4*3)),F=q=>{switch(a){case 3:D[w++]=t|q,a=0;break;case 2:D[w++]=t|q>>>2,t=q<<6,a=3;break;case 1:D[w++]=t|q>>>4,t=q<<4,a=2;break;default:t=q<<2,a=1}};for(let q=0;q<n.length;q++){const M=n.charCodeAt(q);if(M>=65&&M<=90)F(M-65);else if(M>=97&&M<=122)F(M-97+26);else if(M>=48&&M<=57)F(M-48+52);else if(M===43||M===45)F(62);else if(M===47||M===95)F(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${n[q]}`)}}const x=w;for(;a>0;)F(0);return C.wrap(D).slice(0,x)}e.decodeBase64=s;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function m({buffer:n},t=!0,a=!1){const w=a?r:l;let D="";const F=n.byteLength%3;let x=0;for(;x<n.byteLength-F;x+=3){const q=n[x+0],M=n[x+1],B=n[x+2];D+=w[q>>>2],D+=w[(q<<4|M>>>4)&63],D+=w[(M<<2|B>>>6)&63],D+=w[B&63]}if(F===1){const q=n[x+0];D+=w[q>>>2],D+=w[q<<4&63],t&&(D+="==")}else if(F===2){const q=n[x+0],M=n[x+1];D+=w[q>>>2],D+=w[(q<<4|M>>>4)&63],D+=w[M<<2&63],t&&(D+="=")}return D}e.encodeBase64=m}),define(ye[148],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ye[9],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function c(o){return typeof o=="string"}e.isString=c;function A(o){return Array.isArray(o)&&o.every(s=>c(s))}e.isStringArray=A;function u(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=u;function R(o){const s=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof s}e.isTypedArray=R;function C(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=C;function P(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=P;function S(o){return o===!0||o===!1}e.isBoolean=S;function I(o){return typeof o>"u"}e.isUndefined=I;function L(o){return!k(o)}e.isDefined=L;function k(o){return I(o)||o===null}e.isUndefinedOrNull=k;function v(o,s){if(!o)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.assertType=v;function T(o){if(k(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=T;function E(...o){const s=[];for(let l=0;l<o.length;l++){const r=o[l];if(k(r))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);s.push(r)}return s}e.assertAllDefined=E;const f=Object.prototype.hasOwnProperty;function d(o){if(!u(o))return!1;for(const s in o)if(f.call(o,s))return!1;return!0}e.isEmptyObject=d;function h(o){return typeof o=="function"}e.isFunction=h;function g(...o){return o.length>0&&o.every(h)}e.areFunctions=g;function p(o,s){const l=Math.min(o.length,s.length);for(let r=0;r<l;r++)y(o[r],s[r])}e.validateConstraints=p;function y(o,s){if(c(s)){if(typeof o!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(h(s)){try{if(o instanceof s)return}catch{}if(!k(o)&&o.constructor===s||s.length===1&&s.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=y;function b(o){return o===null?void 0:o}e.withNullAsUndefined=b;function i(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=i}),define(ye[67],De([1,0,9]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const A=Object.create(null);function u(P,S){if((0,c.isString)(S)){const I=A[S];if(I===void 0)throw new Error(`${P} references an unknown codicon: ${S}`);S=I}return A[P]=S,{id:P}}function R(){return A}e.getCodiconFontCharacters=R;function C(){return Object.values(e.Codicon)}e.getAllCodicons=C,e.Codicon={add:u("add",6e4),plus:u("plus",6e4),gistNew:u("gist-new",6e4),repoCreate:u("repo-create",6e4),lightbulb:u("lightbulb",60001),lightBulb:u("light-bulb",60001),repo:u("repo",60002),repoDelete:u("repo-delete",60002),gistFork:u("gist-fork",60003),repoForked:u("repo-forked",60003),gitPullRequest:u("git-pull-request",60004),gitPullRequestAbandoned:u("git-pull-request-abandoned",60004),recordKeys:u("record-keys",60005),keyboard:u("keyboard",60005),tag:u("tag",60006),tagAdd:u("tag-add",60006),tagRemove:u("tag-remove",60006),person:u("person",60007),personFollow:u("person-follow",60007),personOutline:u("person-outline",60007),personFilled:u("person-filled",60007),gitBranch:u("git-branch",60008),gitBranchCreate:u("git-branch-create",60008),gitBranchDelete:u("git-branch-delete",60008),sourceControl:u("source-control",60008),mirror:u("mirror",60009),mirrorPublic:u("mirror-public",60009),star:u("star",60010),starAdd:u("star-add",60010),starDelete:u("star-delete",60010),starEmpty:u("star-empty",60010),comment:u("comment",60011),commentAdd:u("comment-add",60011),alert:u("alert",60012),warning:u("warning",60012),search:u("search",60013),searchSave:u("search-save",60013),logOut:u("log-out",60014),signOut:u("sign-out",60014),logIn:u("log-in",60015),signIn:u("sign-in",60015),eye:u("eye",60016),eyeUnwatch:u("eye-unwatch",60016),eyeWatch:u("eye-watch",60016),circleFilled:u("circle-filled",60017),primitiveDot:u("primitive-dot",60017),closeDirty:u("close-dirty",60017),debugBreakpoint:u("debug-breakpoint",60017),debugBreakpointDisabled:u("debug-breakpoint-disabled",60017),debugHint:u("debug-hint",60017),primitiveSquare:u("primitive-square",60018),edit:u("edit",60019),pencil:u("pencil",60019),info:u("info",60020),issueOpened:u("issue-opened",60020),gistPrivate:u("gist-private",60021),gitForkPrivate:u("git-fork-private",60021),lock:u("lock",60021),mirrorPrivate:u("mirror-private",60021),close:u("close",60022),removeClose:u("remove-close",60022),x:u("x",60022),repoSync:u("repo-sync",60023),sync:u("sync",60023),clone:u("clone",60024),desktopDownload:u("desktop-download",60024),beaker:u("beaker",60025),microscope:u("microscope",60025),vm:u("vm",60026),deviceDesktop:u("device-desktop",60026),file:u("file",60027),fileText:u("file-text",60027),more:u("more",60028),ellipsis:u("ellipsis",60028),kebabHorizontal:u("kebab-horizontal",60028),mailReply:u("mail-reply",60029),reply:u("reply",60029),organization:u("organization",60030),organizationFilled:u("organization-filled",60030),organizationOutline:u("organization-outline",60030),newFile:u("new-file",60031),fileAdd:u("file-add",60031),newFolder:u("new-folder",60032),fileDirectoryCreate:u("file-directory-create",60032),trash:u("trash",60033),trashcan:u("trashcan",60033),history:u("history",60034),clock:u("clock",60034),folder:u("folder",60035),fileDirectory:u("file-directory",60035),symbolFolder:u("symbol-folder",60035),logoGithub:u("logo-github",60036),markGithub:u("mark-github",60036),github:u("github",60036),terminal:u("terminal",60037),console:u("console",60037),repl:u("repl",60037),zap:u("zap",60038),symbolEvent:u("symbol-event",60038),error:u("error",60039),stop:u("stop",60039),variable:u("variable",60040),symbolVariable:u("symbol-variable",60040),array:u("array",60042),symbolArray:u("symbol-array",60042),symbolModule:u("symbol-module",60043),symbolPackage:u("symbol-package",60043),symbolNamespace:u("symbol-namespace",60043),symbolObject:u("symbol-object",60043),symbolMethod:u("symbol-method",60044),symbolFunction:u("symbol-function",60044),symbolConstructor:u("symbol-constructor",60044),symbolBoolean:u("symbol-boolean",60047),symbolNull:u("symbol-null",60047),symbolNumeric:u("symbol-numeric",60048),symbolNumber:u("symbol-number",60048),symbolStructure:u("symbol-structure",60049),symbolStruct:u("symbol-struct",60049),symbolParameter:u("symbol-parameter",60050),symbolTypeParameter:u("symbol-type-parameter",60050),symbolKey:u("symbol-key",60051),symbolText:u("symbol-text",60051),symbolReference:u("symbol-reference",60052),goToFile:u("go-to-file",60052),symbolEnum:u("symbol-enum",60053),symbolValue:u("symbol-value",60053),symbolRuler:u("symbol-ruler",60054),symbolUnit:u("symbol-unit",60054),activateBreakpoints:u("activate-breakpoints",60055),archive:u("archive",60056),arrowBoth:u("arrow-both",60057),arrowDown:u("arrow-down",60058),arrowLeft:u("arrow-left",60059),arrowRight:u("arrow-right",60060),arrowSmallDown:u("arrow-small-down",60061),arrowSmallLeft:u("arrow-small-left",60062),arrowSmallRight:u("arrow-small-right",60063),arrowSmallUp:u("arrow-small-up",60064),arrowUp:u("arrow-up",60065),bell:u("bell",60066),bold:u("bold",60067),book:u("book",60068),bookmark:u("bookmark",60069),debugBreakpointConditionalUnverified:u("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:u("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:u("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:u("debug-breakpoint-data-unverified",60072),debugBreakpointData:u("debug-breakpoint-data",60073),debugBreakpointDataDisabled:u("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:u("debug-breakpoint-log-unverified",60074),debugBreakpointLog:u("debug-breakpoint-log",60075),debugBreakpointLogDisabled:u("debug-breakpoint-log-disabled",60075),briefcase:u("briefcase",60076),broadcast:u("broadcast",60077),browser:u("browser",60078),bug:u("bug",60079),calendar:u("calendar",60080),caseSensitive:u("case-sensitive",60081),check:u("check",60082),checklist:u("checklist",60083),chevronDown:u("chevron-down",60084),dropDownButton:u("drop-down-button",60084),chevronLeft:u("chevron-left",60085),chevronRight:u("chevron-right",60086),chevronUp:u("chevron-up",60087),chromeClose:u("chrome-close",60088),chromeMaximize:u("chrome-maximize",60089),chromeMinimize:u("chrome-minimize",60090),chromeRestore:u("chrome-restore",60091),circle:u("circle",60092),circleOutline:u("circle-outline",60092),debugBreakpointUnverified:u("debug-breakpoint-unverified",60092),circleSlash:u("circle-slash",60093),circuitBoard:u("circuit-board",60094),clearAll:u("clear-all",60095),clippy:u("clippy",60096),closeAll:u("close-all",60097),cloudDownload:u("cloud-download",60098),cloudUpload:u("cloud-upload",60099),code:u("code",60100),collapseAll:u("collapse-all",60101),colorMode:u("color-mode",60102),commentDiscussion:u("comment-discussion",60103),compareChanges:u("compare-changes",60157),creditCard:u("credit-card",60105),dash:u("dash",60108),dashboard:u("dashboard",60109),database:u("database",60110),debugContinue:u("debug-continue",60111),debugDisconnect:u("debug-disconnect",60112),debugPause:u("debug-pause",60113),debugRestart:u("debug-restart",60114),debugStart:u("debug-start",60115),debugStepInto:u("debug-step-into",60116),debugStepOut:u("debug-step-out",60117),debugStepOver:u("debug-step-over",60118),debugStop:u("debug-stop",60119),debug:u("debug",60120),deviceCameraVideo:u("device-camera-video",60121),deviceCamera:u("device-camera",60122),deviceMobile:u("device-mobile",60123),diffAdded:u("diff-added",60124),diffIgnored:u("diff-ignored",60125),diffModified:u("diff-modified",60126),diffRemoved:u("diff-removed",60127),diffRenamed:u("diff-renamed",60128),diff:u("diff",60129),discard:u("discard",60130),editorLayout:u("editor-layout",60131),emptyWindow:u("empty-window",60132),exclude:u("exclude",60133),extensions:u("extensions",60134),eyeClosed:u("eye-closed",60135),fileBinary:u("file-binary",60136),fileCode:u("file-code",60137),fileMedia:u("file-media",60138),filePdf:u("file-pdf",60139),fileSubmodule:u("file-submodule",60140),fileSymlinkDirectory:u("file-symlink-directory",60141),fileSymlinkFile:u("file-symlink-file",60142),fileZip:u("file-zip",60143),files:u("files",60144),filter:u("filter",60145),flame:u("flame",60146),foldDown:u("fold-down",60147),foldUp:u("fold-up",60148),fold:u("fold",60149),folderActive:u("folder-active",60150),folderOpened:u("folder-opened",60151),gear:u("gear",60152),gift:u("gift",60153),gistSecret:u("gist-secret",60154),gist:u("gist",60155),gitCommit:u("git-commit",60156),gitCompare:u("git-compare",60157),gitMerge:u("git-merge",60158),githubAction:u("github-action",60159),githubAlt:u("github-alt",60160),globe:u("globe",60161),grabber:u("grabber",60162),graph:u("graph",60163),gripper:u("gripper",60164),heart:u("heart",60165),home:u("home",60166),horizontalRule:u("horizontal-rule",60167),hubot:u("hubot",60168),inbox:u("inbox",60169),issueClosed:u("issue-closed",60324),issueReopened:u("issue-reopened",60171),issues:u("issues",60172),italic:u("italic",60173),jersey:u("jersey",60174),json:u("json",60175),bracket:u("bracket",60175),kebabVertical:u("kebab-vertical",60176),key:u("key",60177),law:u("law",60178),lightbulbAutofix:u("lightbulb-autofix",60179),linkExternal:u("link-external",60180),link:u("link",60181),listOrdered:u("list-ordered",60182),listUnordered:u("list-unordered",60183),liveShare:u("live-share",60184),loading:u("loading",60185),location:u("location",60186),mailRead:u("mail-read",60187),mail:u("mail",60188),markdown:u("markdown",60189),megaphone:u("megaphone",60190),mention:u("mention",60191),milestone:u("milestone",60192),mortarBoard:u("mortar-board",60193),move:u("move",60194),multipleWindows:u("multiple-windows",60195),mute:u("mute",60196),noNewline:u("no-newline",60197),note:u("note",60198),octoface:u("octoface",60199),openPreview:u("open-preview",60200),package_:u("package",60201),paintcan:u("paintcan",60202),pin:u("pin",60203),play:u("play",60204),run:u("run",60204),plug:u("plug",60205),preserveCase:u("preserve-case",60206),preview:u("preview",60207),project:u("project",60208),pulse:u("pulse",60209),question:u("question",60210),quote:u("quote",60211),radioTower:u("radio-tower",60212),reactions:u("reactions",60213),references:u("references",60214),refresh:u("refresh",60215),regex:u("regex",60216),remoteExplorer:u("remote-explorer",60217),remote:u("remote",60218),remove:u("remove",60219),replaceAll:u("replace-all",60220),replace:u("replace",60221),repoClone:u("repo-clone",60222),repoForcePush:u("repo-force-push",60223),repoPull:u("repo-pull",60224),repoPush:u("repo-push",60225),report:u("report",60226),requestChanges:u("request-changes",60227),rocket:u("rocket",60228),rootFolderOpened:u("root-folder-opened",60229),rootFolder:u("root-folder",60230),rss:u("rss",60231),ruby:u("ruby",60232),saveAll:u("save-all",60233),saveAs:u("save-as",60234),save:u("save",60235),screenFull:u("screen-full",60236),screenNormal:u("screen-normal",60237),searchStop:u("search-stop",60238),server:u("server",60240),settingsGear:u("settings-gear",60241),settings:u("settings",60242),shield:u("shield",60243),smiley:u("smiley",60244),sortPrecedence:u("sort-precedence",60245),splitHorizontal:u("split-horizontal",60246),splitVertical:u("split-vertical",60247),squirrel:u("squirrel",60248),starFull:u("star-full",60249),starHalf:u("star-half",60250),symbolClass:u("symbol-class",60251),symbolColor:u("symbol-color",60252),symbolCustomColor:u("symbol-customcolor",60252),symbolConstant:u("symbol-constant",60253),symbolEnumMember:u("symbol-enum-member",60254),symbolField:u("symbol-field",60255),symbolFile:u("symbol-file",60256),symbolInterface:u("symbol-interface",60257),symbolKeyword:u("symbol-keyword",60258),symbolMisc:u("symbol-misc",60259),symbolOperator:u("symbol-operator",60260),symbolProperty:u("symbol-property",60261),wrench:u("wrench",60261),wrenchSubaction:u("wrench-subaction",60261),symbolSnippet:u("symbol-snippet",60262),tasklist:u("tasklist",60263),telescope:u("telescope",60264),textSize:u("text-size",60265),threeBars:u("three-bars",60266),thumbsdown:u("thumbsdown",60267),thumbsup:u("thumbsup",60268),tools:u("tools",60269),triangleDown:u("triangle-down",60270),triangleLeft:u("triangle-left",60271),triangleRight:u("triangle-right",60272),triangleUp:u("triangle-up",60273),twitter:u("twitter",60274),unfold:u("unfold",60275),unlock:u("unlock",60276),unmute:u("unmute",60277),unverified:u("unverified",60278),verified:u("verified",60279),versions:u("versions",60280),vmActive:u("vm-active",60281),vmOutline:u("vm-outline",60282),vmRunning:u("vm-running",60283),watch:u("watch",60284),whitespace:u("whitespace",60285),wholeWord:u("whole-word",60286),window:u("window",60287),wordWrap:u("word-wrap",60288),zoomIn:u("zoom-in",60289),zoomOut:u("zoom-out",60290),listFilter:u("list-filter",60291),listFlat:u("list-flat",60292),listSelection:u("list-selection",60293),selection:u("selection",60293),listTree:u("list-tree",60294),debugBreakpointFunctionUnverified:u("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:u("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:u("debug-breakpoint-function-disabled",60296),debugStackframeActive:u("debug-stackframe-active",60297),circleSmallFilled:u("circle-small-filled",60298),debugStackframeDot:u("debug-stackframe-dot",60298),debugStackframe:u("debug-stackframe",60299),debugStackframeFocused:u("debug-stackframe-focused",60299),debugBreakpointUnsupported:u("debug-breakpoint-unsupported",60300),symbolString:u("symbol-string",60301),debugReverseContinue:u("debug-reverse-continue",60302),debugStepBack:u("debug-step-back",60303),debugRestartFrame:u("debug-restart-frame",60304),callIncoming:u("call-incoming",60306),callOutgoing:u("call-outgoing",60307),menu:u("menu",60308),expandAll:u("expand-all",60309),feedback:u("feedback",60310),groupByRefType:u("group-by-ref-type",60311),ungroupByRefType:u("ungroup-by-ref-type",60312),account:u("account",60313),bellDot:u("bell-dot",60314),debugConsole:u("debug-console",60315),library:u("library",60316),output:u("output",60317),runAll:u("run-all",60318),syncIgnored:u("sync-ignored",60319),pinned:u("pinned",60320),githubInverted:u("github-inverted",60321),debugAlt:u("debug-alt",60305),serverProcess:u("server-process",60322),serverEnvironment:u("server-environment",60323),pass:u("pass",60324),stopCircle:u("stop-circle",60325),playCircle:u("play-circle",60326),record:u("record",60327),debugAltSmall:u("debug-alt-small",60328),vmConnect:u("vm-connect",60329),cloud:u("cloud",60330),merge:u("merge",60331),exportIcon:u("export",60332),graphLeft:u("graph-left",60333),magnet:u("magnet",60334),notebook:u("notebook",60335),redo:u("redo",60336),checkAll:u("check-all",60337),pinnedDirty:u("pinned-dirty",60338),passFilled:u("pass-filled",60339),circleLargeFilled:u("circle-large-filled",60340),circleLarge:u("circle-large",60341),circleLargeOutline:u("circle-large-outline",60341),combine:u("combine",60342),gather:u("gather",60342),table:u("table",60343),variableGroup:u("variable-group",60344),typeHierarchy:u("type-hierarchy",60345),typeHierarchySub:u("type-hierarchy-sub",60346),typeHierarchySuper:u("type-hierarchy-super",60347),gitPullRequestCreate:u("git-pull-request-create",60348),runAbove:u("run-above",60349),runBelow:u("run-below",60350),notebookTemplate:u("notebook-template",60351),debugRerun:u("debug-rerun",60352),workspaceTrusted:u("workspace-trusted",60353),workspaceUntrusted:u("workspace-untrusted",60354),workspaceUnspecified:u("workspace-unspecified",60355),terminalCmd:u("terminal-cmd",60356),terminalDebian:u("terminal-debian",60357),terminalLinux:u("terminal-linux",60358),terminalPowershell:u("terminal-powershell",60359),terminalTmux:u("terminal-tmux",60360),terminalUbuntu:u("terminal-ubuntu",60361),terminalBash:u("terminal-bash",60362),arrowSwap:u("arrow-swap",60363),copy:u("copy",60364),personAdd:u("person-add",60365),filterFilled:u("filter-filled",60366),wand:u("wand",60367),debugLineByLine:u("debug-line-by-line",60368),inspect:u("inspect",60369),layers:u("layers",60370),layersDot:u("layers-dot",60371),layersActive:u("layers-active",60372),compass:u("compass",60373),compassDot:u("compass-dot",60374),compassActive:u("compass-active",60375),azure:u("azure",60376),issueDraft:u("issue-draft",60377),gitPullRequestClosed:u("git-pull-request-closed",60378),gitPullRequestDraft:u("git-pull-request-draft",60379),debugAll:u("debug-all",60380),debugCoverage:u("debug-coverage",60381),runErrors:u("run-errors",60382),folderLibrary:u("folder-library",60383),debugContinueSmall:u("debug-continue-small",60384),beakerStop:u("beaker-stop",60385),graphLine:u("graph-line",60386),graphScatter:u("graph-scatter",60387),pieChart:u("pie-chart",60388),bracketDot:u("bracket-dot",60389),bracketError:u("bracket-error",60390),lockSmall:u("lock-small",60391),azureDevops:u("azure-devops",60392),verifiedFilled:u("verified-filled",60393),newLine:u("newline",60394),layout:u("layout",60395),layoutActivitybarLeft:u("layout-activitybar-left",60396),layoutActivitybarRight:u("layout-activitybar-right",60397),layoutPanelLeft:u("layout-panel-left",60398),layoutPanelCenter:u("layout-panel-center",60399),layoutPanelJustify:u("layout-panel-justify",60400),layoutPanelRight:u("layout-panel-right",60401),layoutPanel:u("layout-panel",60402),layoutSidebarLeft:u("layout-sidebar-left",60403),layoutSidebarRight:u("layout-sidebar-right",60404),layoutStatusbar:u("layout-statusbar",60405),layoutMenubar:u("layout-menubar",60406),layoutCentered:u("layout-centered",60407),layoutSidebarRightOff:u("layout-sidebar-right-off",60416),layoutPanelOff:u("layout-panel-off",60417),layoutSidebarLeftOff:u("layout-sidebar-left-off",60418),target:u("target",60408),indent:u("indent",60409),recordSmall:u("record-small",60410),errorSmall:u("error-small",60411),arrowCircleDown:u("arrow-circle-down",60412),arrowCircleLeft:u("arrow-circle-left",60413),arrowCircleRight:u("arrow-circle-right",60414),arrowCircleUp:u("arrow-circle-up",60415),heartFilled:u("heart-filled",60420),map:u("map",60421),mapFilled:u("map-filled",60422),circleSmall:u("circle-small",60423),bellSlash:u("bell-slash",60424),bellSlashDot:u("bell-slash-dot",60425),commentUnresolved:u("comment-unresolved",60426),gitPullRequestGoToChanges:u("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:u("git-pull-request-new-changes",60428),searchFuzzy:u("search-fuzzy",60429),commentDraft:u("comment-draft",60430),dialogError:u("dialog-error","error"),dialogWarning:u("dialog-warning","warning"),dialogInfo:u("dialog-info","info"),dialogClose:u("dialog-close","close"),treeItemExpanded:u("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:u("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:u("tree-filter-on-type-off","list-selection"),treeFilterClear:u("tree-filter-clear","close"),treeItemLoading:u("tree-item-loading","loading"),menuSelection:u("menu-selection","check"),menuSubmenu:u("menu-submenu","chevron-right"),menuBarMore:u("menubar-more","more"),scrollbarButtonLeft:u("scrollbar-button-left","triangle-left"),scrollbarButtonRight:u("scrollbar-button-right","triangle-right"),scrollbarButtonUp:u("scrollbar-button-up","triangle-up"),scrollbarButtonDown:u("scrollbar-button-down","triangle-down"),toolBarMore:u("toolbar-more","more"),quickInputBack:u("quick-input-back","arrow-left")}}),define(ye[23],De([1,0,9]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const g=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([p,y])=>{g[p]=y&&typeof y=="object"?A(y):y}),g}e.deepClone=A;function u(h){if(!h||typeof h!="object")return h;const g=[h];for(;g.length>0;){const p=g.shift();Object.freeze(p);for(const y in p)if(R.call(p,y)){const b=p[y];typeof b=="object"&&!Object.isFrozen(b)&&!(0,c.isTypedArray)(b)&&g.push(b)}}return h}e.deepFreeze=u;const R=Object.prototype.hasOwnProperty;function C(h,g){return P(h,g,new Set)}e.cloneAndChange=C;function P(h,g,p){if((0,c.isUndefinedOrNull)(h))return h;const y=g(h);if(typeof y<"u")return y;if(Array.isArray(h)){const b=[];for(const i of h)b.push(P(i,g,p));return b}if((0,c.isObject)(h)){if(p.has(h))throw new Error("Cannot clone recursive data-structure");p.add(h);const b={};for(const i in h)R.call(h,i)&&(b[i]=P(h[i],g,p));return p.delete(h),b}return h}function S(h,g,p=!0){return(0,c.isObject)(h)?((0,c.isObject)(g)&&Object.keys(g).forEach(y=>{y in h?p&&((0,c.isObject)(h[y])&&(0,c.isObject)(g[y])?S(h[y],g[y],p):h[y]=g[y]):h[y]=g[y]}),h):g}e.mixin=S;function I(h,g){if(h===g)return!0;if(h==null||g===null||g===void 0||typeof h!=typeof g||typeof h!="object"||Array.isArray(h)!==Array.isArray(g))return!1;let p,y;if(Array.isArray(h)){if(h.length!==g.length)return!1;for(p=0;p<h.length;p++)if(!I(h[p],g[p]))return!1}else{const b=[];for(y in h)b.push(y);b.sort();const i=[];for(y in g)i.push(y);if(i.sort(),!I(b,i))return!1;for(p=0;p<b.length;p++)if(!I(h[b[p]],g[b[p]]))return!1}return!0}e.equals=I;function L(h){const g=new Set;return JSON.stringify(h,(p,y)=>{if((0,c.isObject)(y)||Array.isArray(y)){if(g.has(y))return"[Circular]";g.add(y)}return y})}e.safeStringify=L;function k(h,g){const p=Object.create(null);return!h||!g||Object.keys(g).forEach(b=>{const i=h[b],o=g[b];I(i,o)||(p[b]=o)}),p}e.distinct=k;function v(h,g){const p=g.toLowerCase(),y=Object.keys(h).find(b=>b.toLowerCase()===p);return y?h[y]:h[g]}e.getCaseInsensitive=v;function T(h,g){const p=Object.create(null);for(const[y,b]of Object.entries(h))g(y,b)&&(p[y]=b);return p}e.filter=T;function E(h){let g=[],p=Object.getPrototypeOf(h);for(;Object.prototype!==p;)g=g.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return g}e.getAllPropertyNames=E;function f(h){const g=[];for(const p of E(h))typeof h[p]=="function"&&g.push(p);return g}e.getAllMethodNames=f;function d(h,g){const p=b=>function(){const i=Array.prototype.slice.call(arguments,0);return g(b,i)},y={};for(const b of h)y[b]=p(b);return y}e.createProxyObject=d}),define(ye[51],De([1,0,67]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var A;(function(C){function P(S){return S&&typeof S=="object"&&typeof S.id=="string"}C.isThemeColor=P})(A=e.ThemeColor||(e.ThemeColor={}));function u(C){return{id:C}}e.themeColorFromId=u;var R;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function S(g){const p=P.exec(g.id);if(!p)return S(c.Codicon.error);const[,y,b]=p,i=["codicon","codicon-"+y];return b&&i.push("codicon-modifier-"+b.substring(1)),i}C.asClassNameArray=S;function I(g){return S(g).join(" ")}C.asClassName=I;function L(g){return"."+S(g).join(".")}C.asCSSSelector=L;function k(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||A.isThemeColor(g.color))}C.isThemeIcon=k;const v=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function T(g){const p=v.exec(g);if(!p)return;const[,y]=p;return{id:y}}C.fromString=T;function E(g){return{id:g}}C.fromId=E;function f(g,p){let y=g.id;const b=y.lastIndexOf("~");return b!==-1&&(y=y.substring(0,b)),p&&(y=`${y}~${p}`),{id:y}}C.modify=f;function d(g){const p=g.id.lastIndexOf("~");if(p!==-1)return g.id.substring(p+1)}C.getModifier=d;function h(g,p){return g.id===p.id&&g.color?.id===p.color?.id}C.isEqual=h})(R=e.ThemeIcon||(e.ThemeIcon={}))}),define(ye[104],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var c;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(c=e.Constants||(e.Constants={}));function A(R){return R<0?0:R>255?255:R|0}e.toUint8=A;function u(R){return R<0?0:R>4294967295?4294967295:R|0}e.toUint32=u}),define(ye[30],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(u){return c.test(u)}e.isUUID=A,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let u;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?u=crypto.getRandomValues.bind(crypto):u=function(P){for(let S=0;S<P.length;S++)P[S]=Math.floor(Math.random()*256);return P};const R=new Uint8Array(16),C=[];for(let P=0;P<256;P++)C.push(P.toString(16).padStart(2,"0"));return function(){u(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let S=0,I="";return I+=C[R[S++]],I+=C[R[S++]],I+=C[R[S++]],I+=C[R[S++]],I+="-",I+=C[R[S++]],I+=C[R[S++]],I+="-",I+=C[R[S++]],I+=C[R[S++]],I+="-",I+=C[R[S++]],I+=C[R[S++]],I+="-",I+=C[R[S++]],I+=C[R[S++]],I+=C[R[S++]],I+=C[R[S++]],I+=C[R[S++]],I+=C[R[S++]],I}}()}),define(ye[149],De([1,0,15,30]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function u(P){return{id:(0,A.generateUuid)(),asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}e.createStringDataTransferItem=u;function R(P,S,I){return{id:(0,A.generateUuid)(),asString:async()=>"",asFile:()=>({name:P,uri:S,data:I}),value:void 0}}e.createFileDataTransferItem=R;class C{constructor(){this.a=new Map}get size(){return this.a.size}has(S){return this.a.has(this.b(S))}get(S){return this.a.get(this.b(S))?.[0]}append(S,I){const L=this.a.get(S);L?L.push(I):this.a.set(this.b(S),[I])}replace(S,I){this.a.set(this.b(S),[I])}delete(S){this.a.delete(this.b(S))}*entries(){for(const[S,I]of this.a.entries())for(const L of I)yield[S,L]}values(){return Array.from(this.a.values()).flat()}forEach(S){for(const[I,L]of this.entries())S(L,I)}b(S){return S.toLowerCase()}}e.VSDataTransfer=C,e.UriList=Object.freeze({create:P=>(0,c.distinct)(P.map(S=>S.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.UriList.split(P).filter(S=>!S.startsWith("#"))})}),define(ye[105],De([1,0,104]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class A{constructor(P){const S=(0,c.toUint8)(P);this.c=S,this.a=A.d(S),this.b=new Map}static d(P){const S=new Uint8Array(256);return S.fill(P),S}set(P,S){const I=(0,c.toUint8)(S);P>=0&&P<256?this.a[P]=I:this.b.set(P,I)}get(P){return P>=0&&P<256?this.a[P]:this.b.get(P)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=A;var u;(function(C){C[C.False=0]="False",C[C.True=1]="True"})(u||(u={}));class R{constructor(){this.a=new A(0)}add(P){this.a.set(P,1)}has(P){return this.a.get(P)===1}clear(){return this.a.clear()}}e.CharacterSet=R}),define(ye[52],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class c{constructor(u,R){this.lineNumber=u,this.column=R}with(u=this.lineNumber,R=this.column){return u===this.lineNumber&&R===this.column?this:new c(u,R)}delta(u=0,R=0){return this.with(this.lineNumber+u,this.column+R)}equals(u){return c.equals(this,u)}static equals(u,R){return!u&&!R?!0:!!u&&!!R&&u.lineNumber===R.lineNumber&&u.column===R.column}isBefore(u){return c.isBefore(this,u)}static isBefore(u,R){return u.lineNumber<R.lineNumber?!0:R.lineNumber<u.lineNumber?!1:u.column<R.column}isBeforeOrEqual(u){return c.isBeforeOrEqual(this,u)}static isBeforeOrEqual(u,R){return u.lineNumber<R.lineNumber?!0:R.lineNumber<u.lineNumber?!1:u.column<=R.column}static compare(u,R){const C=u.lineNumber|0,P=R.lineNumber|0;if(C===P){const S=u.column|0,I=R.column|0;return S-I}return C-P}clone(){return new c(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(u){return new c(u.lineNumber,u.column)}static isIPosition(u){return u&&typeof u.lineNumber=="number"&&typeof u.column=="number"}}e.Position=c}),define(ye[32],De([1,0,52]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class A{constructor(R,C,P,S){R>P||R===P&&C>S?(this.startLineNumber=P,this.startColumn=S,this.endLineNumber=R,this.endColumn=C):(this.startLineNumber=R,this.startColumn=C,this.endLineNumber=P,this.endColumn=S)}isEmpty(){return A.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return A.containsPosition(this,R)}static containsPosition(R,C){return!(C.lineNumber<R.startLineNumber||C.lineNumber>R.endLineNumber||C.lineNumber===R.startLineNumber&&C.column<R.startColumn||C.lineNumber===R.endLineNumber&&C.column>R.endColumn)}static strictContainsPosition(R,C){return!(C.lineNumber<R.startLineNumber||C.lineNumber>R.endLineNumber||C.lineNumber===R.startLineNumber&&C.column<=R.startColumn||C.lineNumber===R.endLineNumber&&C.column>=R.endColumn)}containsRange(R){return A.containsRange(this,R)}static containsRange(R,C){return!(C.startLineNumber<R.startLineNumber||C.endLineNumber<R.startLineNumber||C.startLineNumber>R.endLineNumber||C.endLineNumber>R.endLineNumber||C.startLineNumber===R.startLineNumber&&C.startColumn<R.startColumn||C.endLineNumber===R.endLineNumber&&C.endColumn>R.endColumn)}strictContainsRange(R){return A.strictContainsRange(this,R)}static strictContainsRange(R,C){return!(C.startLineNumber<R.startLineNumber||C.endLineNumber<R.startLineNumber||C.startLineNumber>R.endLineNumber||C.endLineNumber>R.endLineNumber||C.startLineNumber===R.startLineNumber&&C.startColumn<=R.startColumn||C.endLineNumber===R.endLineNumber&&C.endColumn>=R.endColumn)}plusRange(R){return A.plusRange(this,R)}static plusRange(R,C){let P,S,I,L;return C.startLineNumber<R.startLineNumber?(P=C.startLineNumber,S=C.startColumn):C.startLineNumber===R.startLineNumber?(P=C.startLineNumber,S=Math.min(C.startColumn,R.startColumn)):(P=R.startLineNumber,S=R.startColumn),C.endLineNumber>R.endLineNumber?(I=C.endLineNumber,L=C.endColumn):C.endLineNumber===R.endLineNumber?(I=C.endLineNumber,L=Math.max(C.endColumn,R.endColumn)):(I=R.endLineNumber,L=R.endColumn),new A(P,S,I,L)}intersectRanges(R){return A.intersectRanges(this,R)}static intersectRanges(R,C){let P=R.startLineNumber,S=R.startColumn,I=R.endLineNumber,L=R.endColumn;const k=C.startLineNumber,v=C.startColumn,T=C.endLineNumber,E=C.endColumn;return P<k?(P=k,S=v):P===k&&(S=Math.max(S,v)),I>T?(I=T,L=E):I===T&&(L=Math.min(L,E)),P>I||P===I&&S>L?null:new A(P,S,I,L)}equalsRange(R){return A.equalsRange(this,R)}static equalsRange(R,C){return!R&&!C?!0:!!R&&!!C&&R.startLineNumber===C.startLineNumber&&R.startColumn===C.startColumn&&R.endLineNumber===C.endLineNumber&&R.endColumn===C.endColumn}getEndPosition(){return A.getEndPosition(this)}static getEndPosition(R){return new c.Position(R.endLineNumber,R.endColumn)}getStartPosition(){return A.getStartPosition(this)}static getStartPosition(R){return new c.Position(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,C){return new A(this.startLineNumber,this.startColumn,R,C)}setStartPosition(R,C){return new A(R,C,this.endLineNumber,this.endColumn)}collapseToStart(){return A.collapseToStart(this)}static collapseToStart(R){return new A(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return A.collapseToEnd(this)}static collapseToEnd(R){return new A(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new A(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,C=R){return new A(R.lineNumber,R.column,C.lineNumber,C.column)}static lift(R){return R?new A(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,C){return!(R.endLineNumber<C.startLineNumber||R.endLineNumber===C.startLineNumber&&R.endColumn<C.startColumn||C.endLineNumber<R.startLineNumber||C.endLineNumber===R.startLineNumber&&C.endColumn<R.startColumn)}static areIntersecting(R,C){return!(R.endLineNumber<C.startLineNumber||R.endLineNumber===C.startLineNumber&&R.endColumn<=C.startColumn||C.endLineNumber<R.startLineNumber||C.endLineNumber===R.startLineNumber&&C.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,C){if(R&&C){const I=R.startLineNumber|0,L=C.startLineNumber|0;if(I===L){const k=R.startColumn|0,v=C.startColumn|0;if(k===v){const T=R.endLineNumber|0,E=C.endLineNumber|0;if(T===E){const f=R.endColumn|0,d=C.endColumn|0;return f-d}return T-E}return k-v}return I-L}return(R?1:0)-(C?1:0)}static compareRangesUsingEnds(R,C){return R.endLineNumber===C.endLineNumber?R.endColumn===C.endColumn?R.startLineNumber===C.startLineNumber?R.startColumn-C.startColumn:R.startLineNumber-C.startLineNumber:R.endColumn-C.endColumn:R.endLineNumber-C.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.Range=A}),define(ye[150],De([1,0,52,32]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var u;(function(C){C[C.LTR=0]="LTR",C[C.RTL=1]="RTL"})(u=e.SelectionDirection||(e.SelectionDirection={}));class R extends A.Range{constructor(P,S,I,L){super(P,S,I,L),this.selectionStartLineNumber=P,this.selectionStartColumn=S,this.positionLineNumber=I,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(P){return R.selectionsEqual(this,P)}static selectionsEqual(P,S){return P.selectionStartLineNumber===S.selectionStartLineNumber&&P.selectionStartColumn===S.selectionStartColumn&&P.positionLineNumber===S.positionLineNumber&&P.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(P,S){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,P,S):new R(P,S,this.startLineNumber,this.startColumn)}getPosition(){return new c.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new c.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(P,S){return this.getDirection()===0?new R(P,S,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,P,S)}static fromPositions(P,S=P){return new R(P.lineNumber,P.column,S.lineNumber,S.column)}static fromRange(P,S){return S===0?new R(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):new R(P.endLineNumber,P.endColumn,P.startLineNumber,P.startColumn)}static liftSelection(P){return new R(P.selectionStartLineNumber,P.selectionStartColumn,P.positionLineNumber,P.positionColumn)}static selectionsArrEqual(P,S){if(P&&!S||!P&&S)return!1;if(!P&&!S)return!0;if(P.length!==S.length)return!1;for(let I=0,L=P.length;I<L;I++)if(!this.selectionsEqual(P[I],S[I]))return!1;return!0}static isISelection(P){return P&&typeof P.selectionStartLineNumber=="number"&&typeof P.selectionStartColumn=="number"&&typeof P.positionLineNumber=="number"&&typeof P.positionColumn=="number"}static createWithDirection(P,S,I,L,k){return k===0?new R(P,S,I,L):new R(I,L,P,S)}}e.Selection=R}),define(ye[151],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ye[152],De([1,0,105]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var A;(function(C){C[C.Regular=0]="Regular",C[C.Whitespace=1]="Whitespace",C[C.WordSeparator=2]="WordSeparator"})(A=e.WordCharacterClass||(e.WordCharacterClass={}));class u extends c.CharacterClassifier{constructor(P){super(0);for(let S=0,I=P.length;S<I;S++)this.set(P.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=u;function R(C){const P={};return S=>(P.hasOwnProperty(S)||(P[S]=C(S)),P[S])}e.getMapForWordSeparators=R(C=>new u(C))}),define(ye[106],De([1,0,64,6,66]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(k=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const T of e.USUAL_WORD_SEPARATORS)k.indexOf(T)>=0||(v+="\\"+T);return v+="\\s]+)",new RegExp(v,"g")}e.DEFAULT_WORD_REGEXP=R();function C(k){let v=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)v=k;else{let T="g";k.ignoreCase&&(T+="i"),k.multiline&&(T+="m"),k.unicode&&(T+="u"),v=new RegExp(k.source,T)}return v.lastIndex=0,v}e.ensureValidWordDefinition=C;const P=new u.LinkedList;P.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function S(k){const v=P.unshift(k);return(0,A.toDisposable)(v)}e.setDefaultGetWordAtTextConfig=S;function I(k,v,T,E,f){if(f||(f=c.Iterable.first(P)),T.length>f.maxLen){let y=k-f.maxLen/2;return y<0?y=0:E+=y,T=T.substring(y,k+f.maxLen/2),I(k,v,T,E,f)}const d=Date.now(),h=k-1-E;let g=-1,p=null;for(let y=1;!(Date.now()-d>=f.timeBudget);y++){const b=h-f.windowSize*y;v.lastIndex=Math.max(0,b);const i=L(v,T,h,g);if(!i&&p||(p=i,b<=0))break;g=b}if(p){const y={word:p[0],startColumn:E+1+p.index,endColumn:E+1+p.index+p[0].length};return v.lastIndex=0,y}return null}e.getWordAtText=I;function L(k,v,T,E){let f;for(;f=k.exec(v);){const d=f.index||0;if(d<=T&&k.lastIndex>=T)return f;if(E>0&&d>E)return null}return null}}),define(ye[153],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(c=e.IndentAction||(e.IndentAction={}));class A{constructor(P){if(this.e=null,this.f=!1,this.open=P.open,this.close=P.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(P.notIn))for(let S=0,I=P.notIn.length;S<I;S++)switch(P.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(P){switch(P){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(P,S){if(P.getTokenCount()===0)return!0;const I=P.findTokenIndexAtOffset(S-2),L=P.getStandardTokenType(I);return this.isOK(L)}g(P,S){for(let I=P;I<=S;I++){const L=String.fromCharCode(I);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=A;class u{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of P)R(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),R(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),R(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),R(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&R(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=u;function R(C,P,S){C.has(P)?C.get(P).push(S):C.set(P,[S])}}),define(ye[154],De([1,0,105]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var A;(function(T){T[T.Invalid=0]="Invalid",T[T.Start=1]="Start",T[T.H=2]="H",T[T.HT=3]="HT",T[T.HTT=4]="HTT",T[T.HTTP=5]="HTTP",T[T.F=6]="F",T[T.FI=7]="FI",T[T.FIL=8]="FIL",T[T.BeforeColon=9]="BeforeColon",T[T.AfterColon=10]="AfterColon",T[T.AlmostThere=11]="AlmostThere",T[T.End=12]="End",T[T.Accept=13]="Accept",T[T.LastKnownState=14]="LastKnownState"})(A=e.State||(e.State={}));class u{constructor(E,f,d){const h=new Uint8Array(E*f);for(let g=0,p=E*f;g<p;g++)h[g]=d;this.a=h,this.rows=E,this.cols=f}get(E,f){return this.a[E*this.cols+f]}set(E,f,d){this.a[E*this.cols+f]=d}}class R{constructor(E){let f=0,d=0;for(let g=0,p=E.length;g<p;g++){const[y,b,i]=E[g];b>f&&(f=b),y>d&&(d=y),i>d&&(d=i)}f++,d++;const h=new u(d,f,0);for(let g=0,p=E.length;g<p;g++){const[y,b,i]=E[g];h.set(y,b,i)}this.a=h,this.b=f}nextState(E,f){return f<0||f>=this.b?0:this.a.get(E,f)}}e.StateMachine=R;let C=null;function P(){return C===null&&(C=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),C}var S;(function(T){T[T.None=0]="None",T[T.ForceTermination=1]="ForceTermination",T[T.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let I=null;function L(){if(I===null){I=new c.CharacterClassifier(0);const T=`, 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let f=0;f<T.length;f++)I.set(T.charCodeAt(f),1);const E=".;:";for(let f=0;f<E.length;f++)I.set(E.charCodeAt(f),2)}return I}class k{static a(E,f,d,h,g){let p=g-1;do{const y=f.charCodeAt(p);if(E.get(y)!==2)break;p--}while(p>h);if(h>0){const y=f.charCodeAt(h-1),b=f.charCodeAt(p);(y===40&&b===41||y===91&&b===93||y===123&&b===125)&&p--}return{range:{startLineNumber:d,startColumn:h+1,endLineNumber:d,endColumn:p+2},url:f.substring(h,p+1)}}static computeLinks(E,f=P()){const d=L(),h=[];for(let g=1,p=E.getLineCount();g<=p;g++){const y=E.getLineContent(g),b=y.length;let i=0,o=0,s=0,l=1,r=!1,m=!1,n=!1,t=!1;for(;i<b;){let a=!1;const w=y.charCodeAt(i);if(l===13){let D;switch(w){case 40:r=!0,D=0;break;case 41:D=r?0:1;break;case 91:n=!0,m=!0,D=0;break;case 93:n=!1,D=m?0:1;break;case 123:t=!0,D=0;break;case 125:D=t?0:1;break;case 39:case 34:case 96:s===w?D=1:s===39||s===34||s===96?D=0:D=1;break;case 42:D=s===42?1:0;break;case 124:D=s===124?1:0;break;case 32:D=n?0:1;break;default:D=d.get(w)}D===1&&(h.push(k.a(d,y,g,o,i)),a=!0)}else if(l===12){let D;w===91?(m=!0,D=0):D=d.get(w),D===1?a=!0:l=13}else l=f.nextState(l,w),l===0&&(a=!0);a&&(l=1,r=!1,m=!1,t=!1,o=i+1,s=w),i++}l===13&&h.push(k.a(d,y,g,o,b))}return h}}e.LinkComputer=k;function v(T){return!T||typeof T.getLineCount!="function"||typeof T.getLineContent!="function"?[]:k.computeLinks(T)}e.computeLinks=v}),define(ye[107],De([1,0,23]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var A;(function(p){p[p.Left=1]="Left",p[p.Center=2]="Center",p[p.Right=4]="Right",p[p.Full=7]="Full"})(A=e.OverviewRulerLane||(e.OverviewRulerLane={}));var u;(function(p){p[p.Inline=1]="Inline",p[p.Gutter=2]="Gutter"})(u=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(p){p[p.Both=0]="Both",p[p.Right=1]="Right",p[p.Left=2]="Left",p[p.None=3]="None"})(R=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var C;(function(p){p[p.TextDefined=0]="TextDefined",p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var P;(function(p){p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(P=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(p){p[p.LF=0]="LF",p[p.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class I{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(y){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,y.tabSize|0),y.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,y.indentSize|0),this.a=!1),this.insertSpaces=Boolean(y.insertSpaces),this.defaultEOL=y.defaultEOL|0,this.trimAutoWhitespace=Boolean(y.trimAutoWhitespace),this.bracketPairColorizationOptions=y.bracketPairColorizationOptions}equals(y){return this.tabSize===y.tabSize&&this.a===y.a&&this.indentSize===y.indentSize&&this.insertSpaces===y.insertSpaces&&this.defaultEOL===y.defaultEOL&&this.trimAutoWhitespace===y.trimAutoWhitespace&&(0,c.equals)(this.bracketPairColorizationOptions,y.bracketPairColorizationOptions)}createChangeEvent(y){return{tabSize:this.tabSize!==y.tabSize,indentSize:this.indentSize!==y.indentSize,insertSpaces:this.insertSpaces!==y.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==y.trimAutoWhitespace}}}e.TextModelResolvedOptions=I;class L{constructor(y,b){this._findMatchBrand=void 0,this.range=y,this.matches=b}}e.FindMatch=L;var k;(function(p){p[p.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",p[p.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",p[p.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",p[p.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function v(p){return p&&typeof p.read=="function"}e.isITextSnapshot=v;var T;(function(p){p[p.Left=0]="Left",p[p.Right=1]="Right",p[p.None=2]="None",p[p.LeftOfInjectedText=3]="LeftOfInjectedText",p[p.RightOfInjectedText=4]="RightOfInjectedText"})(T=e.PositionAffinity||(e.PositionAffinity={}));var E;(function(p){p[p.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E=e.ModelConstants||(e.ModelConstants={}));class f{constructor(y,b,i,o,s,l){this.identifier=y,this.range=b,this.text=i,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=s,this._isTracked=l}}e.ValidAnnotatedEditOperation=f;class d{constructor(y,b,i){this.regex=y,this.wordSeparators=b,this.simpleSearch=i}}e.SearchData=d;class h{constructor(y,b,i){this.reverseEdits=y,this.changes=b,this.trimAutoWhitespaceLineNumbers=i}}e.ApplyEditsResult=h;function g(p){return!p.isTooLargeForSyncing()&&!p.isForSimpleWidget}e.shouldSynchronizeModel=g}),define(ye[155],De([1,0,15,104]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class u{constructor(S){this.a=S,this.b=new Uint32Array(S.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(S,I){S=(0,A.toUint32)(S);const L=this.a,k=this.b,v=I.length;return v===0?!1:(this.a=new Uint32Array(L.length+v),this.a.set(L.subarray(0,S),0),this.a.set(L.subarray(S),S+v),this.a.set(I,S),S-1<this.c[0]&&(this.c[0]=S-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(k.subarray(0,this.c[0]+1)),!0)}setValue(S,I){return S=(0,A.toUint32)(S),I=(0,A.toUint32)(I),this.a[S]===I?!1:(this.a[S]=I,S-1<this.c[0]&&(this.c[0]=S-1),!0)}removeValues(S,I){S=(0,A.toUint32)(S),I=(0,A.toUint32)(I);const L=this.a,k=this.b;if(S>=L.length)return!1;const v=L.length-S;return I>=v&&(I=v),I===0?!1:(this.a=new Uint32Array(L.length-I),this.a.set(L.subarray(0,S),0),this.a.set(L.subarray(S+I),S),this.b=new Uint32Array(this.a.length),S-1<this.c[0]&&(this.c[0]=S-1),this.c[0]>=0&&this.b.set(k.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(S){return S<0?0:(S=(0,A.toUint32)(S),this.d(S))}d(S){if(S<=this.c[0])return this.b[S];let I=this.c[0]+1;I===0&&(this.b[0]=this.a[0],I++),S>=this.a.length&&(S=this.a.length-1);for(let L=I;L<=S;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],S),this.b[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let I=0,L=this.a.length-1,k=0,v=0,T=0;for(;I<=L;)if(k=I+(L-I)/2|0,v=this.b[k],T=v-this.a[k],S<T)L=k-1;else if(S>=v)I=k+1;else break;return new C(k,S-T)}}e.PrefixSumComputer=u;class R{constructor(S){this.a=S,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(S){return this.g(),S===0?0:this.d[S-1]}getIndexOf(S){this.g();const I=this.e[S],L=I>0?this.d[I-1]:0;return new C(I,S-L)}removeValues(S,I){this.a.splice(S,I),this.f(S)}insertValues(S,I){this.a=(0,c.arrayInsert)(this.a,S,I),this.f(S)}f(S){this.b=!1,this.c=Math.min(this.c,S-1)}g(){if(!this.b){for(let S=this.c+1,I=this.a.length;S<I;S++){const L=this.a[S],k=S>0?this.d[S-1]:0;this.d[S]=k+L;for(let v=0;v<L;v++)this.e[k+v]=S}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(S,I){this.a[S]!==I&&(this.a[S]=I,this.f(S))}}e.ConstantTimePrefixSumComputer=R;class C{constructor(S,I){this.index=S,this.remainder=I,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=I}}e.PrefixSumIndexOfResult=C}),define(ye[156],De([16,17]),function(ne,e){return ne.create("vs/base/common/actions",e)}),define(ye[157],De([16,17]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(ye[158],De([1,0,157]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,u=A*60,R=u*24,C=R*7,P=R*30,S=R*365;function I(k,v,T,E){typeof k!="number"&&(k=k.getTime());const f=Math.round((new Date().getTime()-k)/1e3);if(f<-30)return(0,c.localize)(0,null,I(new Date().getTime()+f*1e3,!1));if(!E&&f<30)return(0,c.localize)(1,null);let d;return f<A?(d=f,v?d===1?T?(0,c.localize)(2,null,d):(0,c.localize)(3,null,d):T?(0,c.localize)(4,null,d):(0,c.localize)(5,null,d):d===1?T?(0,c.localize)(6,null,d):(0,c.localize)(7,null,d):T?(0,c.localize)(8,null,d):(0,c.localize)(9,null,d)):f<u?(d=Math.floor(f/A),v?d===1?T?(0,c.localize)(10,null,d):(0,c.localize)(11,null,d):T?(0,c.localize)(12,null,d):(0,c.localize)(13,null,d):d===1?T?(0,c.localize)(14,null,d):(0,c.localize)(15,null,d):T?(0,c.localize)(16,null,d):(0,c.localize)(17,null,d)):f<R?(d=Math.floor(f/u),v?d===1?T?(0,c.localize)(18,null,d):(0,c.localize)(19,null,d):T?(0,c.localize)(20,null,d):(0,c.localize)(21,null,d):d===1?T?(0,c.localize)(22,null,d):(0,c.localize)(23,null,d):T?(0,c.localize)(24,null,d):(0,c.localize)(25,null,d)):f<C?(d=Math.floor(f/R),v?d===1?(0,c.localize)(26,null,d):(0,c.localize)(27,null,d):d===1?(0,c.localize)(28,null,d):(0,c.localize)(29,null,d)):f<P?(d=Math.floor(f/C),v?d===1?T?(0,c.localize)(30,null,d):(0,c.localize)(31,null,d):T?(0,c.localize)(32,null,d):(0,c.localize)(33,null,d):d===1?T?(0,c.localize)(34,null,d):(0,c.localize)(35,null,d):T?(0,c.localize)(36,null,d):(0,c.localize)(37,null,d)):f<S?(d=Math.floor(f/P),v?d===1?T?(0,c.localize)(38,null,d):(0,c.localize)(39,null,d):T?(0,c.localize)(40,null,d):(0,c.localize)(41,null,d):d===1?T?(0,c.localize)(42,null,d):(0,c.localize)(43,null,d):T?(0,c.localize)(44,null,d):(0,c.localize)(45,null,d)):(d=Math.floor(f/S),v?d===1?T?(0,c.localize)(46,null,d):(0,c.localize)(47,null,d):T?(0,c.localize)(48,null,d):(0,c.localize)(49,null,d):d===1?T?(0,c.localize)(50,null,d):(0,c.localize)(51,null,d):T?(0,c.localize)(52,null,d):(0,c.localize)(53,null,d))}e.fromNow=I;function L(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(ye[159],De([16,17]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(ye[45],De([1,0,15,9,159]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(k,v){return v&&(k.stack||k.stacktrace)?u.localize(0,null,P(k),C(k.stack)||C(k.stacktrace)):P(k)}function C(k){return Array.isArray(k)?k.join(`
`):k}function P(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?u.localize(1,null,k.message):k.message||u.localize(2,null)}function S(k=null,v=!1){if(!k)return u.localize(3,null);if(Array.isArray(k)){const T=c.coalesce(k),E=S(T[0],v);return T.length>1?u.localize(4,null,E,T.length):E}if(A.isString(k))return k;if(k.detail){const T=k.detail;if(T.error)return R(T.error,v);if(T.exception)return R(T.exception,v)}return k.stack?R(k,v):k.message?k.message:u.localize(5,null)}e.toErrorMessage=S;function I(k){const v=k;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=I;function L(k,v){let T;return typeof k=="string"?T=new Error(k):T=k,T.actions=v,T}e.createErrorWithActions=L}),define(ye[160],De([16,17]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(ye[12],De([1,0,160]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let A=!1,u=!1,R=!1,C=!1,P=!1,S=!1,I=!1,L=!1,k=!1,v=!1,T,E=e.LANGUAGE_DEFAULT,f,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const g=typeof h?.versions?.electron=="string",p=g&&h?.type==="renderer";if(typeof navigator=="object"&&!p)d=navigator.userAgent,A=d.indexOf("Windows")>=0,u=d.indexOf("Macintosh")>=0,L=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=d.indexOf("Linux")>=0,v=d?.indexOf("Mobi")>=0,S=!0,T=c.getConfiguredDefaultLocale(c.localize(0,null))||e.LANGUAGE_DEFAULT,E=T;else if(typeof h=="object"){A=h.platform==="win32",u=h.platform==="darwin",R=h.platform==="linux",C=R&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,I=g,k=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,T=e.LANGUAGE_DEFAULT,E=e.LANGUAGE_DEFAULT;const n=h.env.VSCODE_NLS_CONFIG;if(n)try{const t=JSON.parse(n),a=t.availableLanguages["*"];T=t.locale,E=a||e.LANGUAGE_DEFAULT,f=t._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var y;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(y=e.Platform||(e.Platform={}));function b(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let i=0;u?i=1:A?i=3:R&&(i=2),e.isWindows=A,e.isMacintosh=u,e.isLinux=R,e.isLinuxSnap=C,e.isNative=P,e.isElectron=I,e.isWeb=S,e.isWebWorker=S&&typeof e.globals.importScripts=="function",e.isIOS=L,e.isMobile=v,e.isCI=k,e.platform=i,e.userAgent=d,e.language=E;var o;(function(n){function t(){return e.language}n.value=t;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=a;function w(){return e.language==="en"}n.isDefault=w})(o=e.Language||(e.Language={})),e.locale=T,e.translationsConfigFile=f,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const n=[];e.globals.addEventListener("message",a=>{if(a.data&&a.data.vscodeScheduleAsyncWork)for(let w=0,D=n.length;w<D;w++){const F=n[w];if(F.id===a.data.vscodeScheduleAsyncWork){n.splice(w,1),F.callback();return}}});let t=0;return a=>{const w=++t;n.push({id:w,callback:a}),e.globals.postMessage({vscodeScheduleAsyncWork:w},"*")}}return n=>setTimeout(n)})();var s;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=u||L?2:A?1:3;let l=!0,r=!1;function m(){if(!r){r=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,l=new Uint16Array(n.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=m,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ye[36],De([1,0,12]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let A;if(typeof c.globals.vscode<"u"&&typeof c.globals.vscode.process<"u"){const u=c.globals.vscode.process;A={get platform(){return u.platform},get arch(){return u.arch},get env(){return u.env},cwd(){return u.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return c.isWindows?"win32":c.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.arch=A.arch}),define(ye[10],De([1,0,36]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,u=97,R=90,C=122,P=46,S=47,I=92,L=58,k=63;class v extends Error{constructor(o,s,l){let r;typeof s=="string"&&s.indexOf("not ")===0?(r="must not be",s=s.replace(/^not /,"")):r="must be";const m=o.indexOf(".")!==-1?"property":"argument";let n=`The "${o}" ${m} ${r} of type ${s}`;n+=`. Received type ${typeof l}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function T(i,o){if(i===null||typeof i!="object")throw new v(o,"Object",i)}function E(i,o){if(typeof i!="string")throw new v(o,"string",i)}const f=c.platform==="win32";function d(i){return i===S||i===I}function h(i){return i===S}function g(i){return i>=A&&i<=R||i>=u&&i<=C}function p(i,o,s,l){let r="",m=0,n=-1,t=0,a=0;for(let w=0;w<=i.length;++w){if(w<i.length)a=i.charCodeAt(w);else{if(l(a))break;a=S}if(l(a)){if(!(n===w-1||t===1))if(t===2){if(r.length<2||m!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const D=r.lastIndexOf(s);D===-1?(r="",m=0):(r=r.slice(0,D),m=r.length-1-r.lastIndexOf(s)),n=w,t=0;continue}else if(r.length!==0){r="",m=0,n=w,t=0;continue}}o&&(r+=r.length>0?`${s}..`:"..",m=2)}else r.length>0?r+=`${s}${i.slice(n+1,w)}`:r=i.slice(n+1,w),m=w-n-1;n=w,t=0}else a===P&&t!==-1?++t:t=-1}return r}function y(i,o){T(o,"pathObject");const s=o.dir||o.root,l=o.base||`${o.name||""}${o.ext||""}`;return s?s===o.root?`${s}${l}`:`${s}${i}${l}`:l}e.win32={resolve(...i){let o="",s="",l=!1;for(let r=i.length-1;r>=-1;r--){let m;if(r>=0){if(m=i[r],E(m,"path"),m.length===0)continue}else o.length===0?m=c.cwd():(m=c.env[`=${o}`]||c.cwd(),(m===void 0||m.slice(0,2).toLowerCase()!==o.toLowerCase()&&m.charCodeAt(2)===I)&&(m=`${o}\\`));const n=m.length;let t=0,a="",w=!1;const D=m.charCodeAt(0);if(n===1)d(D)&&(t=1,w=!0);else if(d(D))if(w=!0,d(m.charCodeAt(1))){let F=2,x=F;for(;F<n&&!d(m.charCodeAt(F));)F++;if(F<n&&F!==x){const q=m.slice(x,F);for(x=F;F<n&&d(m.charCodeAt(F));)F++;if(F<n&&F!==x){for(x=F;F<n&&!d(m.charCodeAt(F));)F++;(F===n||F!==x)&&(a=`\\\\${q}\\${m.slice(x,F)}`,t=F)}}}else t=1;else g(D)&&m.charCodeAt(1)===L&&(a=m.slice(0,2),t=2,n>2&&d(m.charCodeAt(2))&&(w=!0,t=3));if(a.length>0)if(o.length>0){if(a.toLowerCase()!==o.toLowerCase())continue}else o=a;if(l){if(o.length>0)break}else if(s=`${m.slice(t)}\\${s}`,l=w,w&&o.length>0)break}return s=p(s,!l,"\\",d),l?`${o}\\${s}`:`${o}${s}`||"."},normalize(i){E(i,"path");const o=i.length;if(o===0)return".";let s=0,l,r=!1;const m=i.charCodeAt(0);if(o===1)return h(m)?"\\":i;if(d(m))if(r=!0,d(i.charCodeAt(1))){let t=2,a=t;for(;t<o&&!d(i.charCodeAt(t));)t++;if(t<o&&t!==a){const w=i.slice(a,t);for(a=t;t<o&&d(i.charCodeAt(t));)t++;if(t<o&&t!==a){for(a=t;t<o&&!d(i.charCodeAt(t));)t++;if(t===o)return`\\\\${w}\\${i.slice(a)}\\`;t!==a&&(l=`\\\\${w}\\${i.slice(a,t)}`,s=t)}}}else s=1;else g(m)&&i.charCodeAt(1)===L&&(l=i.slice(0,2),s=2,o>2&&d(i.charCodeAt(2))&&(r=!0,s=3));let n=s<o?p(i.slice(s),!r,"\\",d):"";return n.length===0&&!r&&(n="."),n.length>0&&d(i.charCodeAt(o-1))&&(n+="\\"),l===void 0?r?`\\${n}`:n:r?`${l}\\${n}`:`${l}${n}`},isAbsolute(i){E(i,"path");const o=i.length;if(o===0)return!1;const s=i.charCodeAt(0);return d(s)||o>2&&g(s)&&i.charCodeAt(1)===L&&d(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,s;for(let m=0;m<i.length;++m){const n=i[m];E(n,"path"),n.length>0&&(o===void 0?o=s=n:o+=`\\${n}`)}if(o===void 0)return".";let l=!0,r=0;if(typeof s=="string"&&d(s.charCodeAt(0))){++r;const m=s.length;m>1&&d(s.charCodeAt(1))&&(++r,m>2&&(d(s.charCodeAt(2))?++r:l=!1))}if(l){for(;r<o.length&&d(o.charCodeAt(r));)r++;r>=2&&(o=`\\${o.slice(r)}`)}return e.win32.normalize(o)},relative(i,o){if(E(i,"from"),E(o,"to"),i===o)return"";const s=e.win32.resolve(i),l=e.win32.resolve(o);if(s===l||(i=s.toLowerCase(),o=l.toLowerCase(),i===o))return"";let r=0;for(;r<i.length&&i.charCodeAt(r)===I;)r++;let m=i.length;for(;m-1>r&&i.charCodeAt(m-1)===I;)m--;const n=m-r;let t=0;for(;t<o.length&&o.charCodeAt(t)===I;)t++;let a=o.length;for(;a-1>t&&o.charCodeAt(a-1)===I;)a--;const w=a-t,D=n<w?n:w;let F=-1,x=0;for(;x<D;x++){const M=i.charCodeAt(r+x);if(M!==o.charCodeAt(t+x))break;M===I&&(F=x)}if(x!==D){if(F===-1)return l}else{if(w>D){if(o.charCodeAt(t+x)===I)return l.slice(t+x+1);if(x===2)return l.slice(t+x)}n>D&&(i.charCodeAt(r+x)===I?F=x:x===2&&(F=3)),F===-1&&(F=0)}let q="";for(x=r+F+1;x<=m;++x)(x===m||i.charCodeAt(x)===I)&&(q+=q.length===0?"..":"\\..");return t+=F,q.length>0?`${q}${l.slice(t,a)}`:(l.charCodeAt(t)===I&&++t,l.slice(t,a))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.win32.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===I){if(o.charCodeAt(1)===I){const s=o.charCodeAt(2);if(s!==k&&s!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(g(o.charCodeAt(0))&&o.charCodeAt(1)===L&&o.charCodeAt(2)===I)return`\\\\?\\${o}`;return i},dirname(i){E(i,"path");const o=i.length;if(o===0)return".";let s=-1,l=0;const r=i.charCodeAt(0);if(o===1)return d(r)?i:".";if(d(r)){if(s=l=1,d(i.charCodeAt(1))){let t=2,a=t;for(;t<o&&!d(i.charCodeAt(t));)t++;if(t<o&&t!==a){for(a=t;t<o&&d(i.charCodeAt(t));)t++;if(t<o&&t!==a){for(a=t;t<o&&!d(i.charCodeAt(t));)t++;if(t===o)return i;t!==a&&(s=l=t+1)}}}}else g(r)&&i.charCodeAt(1)===L&&(s=o>2&&d(i.charCodeAt(2))?3:2,l=s);let m=-1,n=!0;for(let t=o-1;t>=l;--t)if(d(i.charCodeAt(t))){if(!n){m=t;break}}else n=!1;if(m===-1){if(s===-1)return".";m=s}return i.slice(0,m)},basename(i,o){o!==void 0&&E(o,"ext"),E(i,"path");let s=0,l=-1,r=!0,m;if(i.length>=2&&g(i.charCodeAt(0))&&i.charCodeAt(1)===L&&(s=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let n=o.length-1,t=-1;for(m=i.length-1;m>=s;--m){const a=i.charCodeAt(m);if(d(a)){if(!r){s=m+1;break}}else t===-1&&(r=!1,t=m+1),n>=0&&(a===o.charCodeAt(n)?--n===-1&&(l=m):(n=-1,l=t))}return s===l?l=t:l===-1&&(l=i.length),i.slice(s,l)}for(m=i.length-1;m>=s;--m)if(d(i.charCodeAt(m))){if(!r){s=m+1;break}}else l===-1&&(r=!1,l=m+1);return l===-1?"":i.slice(s,l)},extname(i){E(i,"path");let o=0,s=-1,l=0,r=-1,m=!0,n=0;i.length>=2&&i.charCodeAt(1)===L&&g(i.charCodeAt(0))&&(o=l=2);for(let t=i.length-1;t>=o;--t){const a=i.charCodeAt(t);if(d(a)){if(!m){l=t+1;break}continue}r===-1&&(m=!1,r=t+1),a===P?s===-1?s=t:n!==1&&(n=1):s!==-1&&(n=-1)}return s===-1||r===-1||n===0||n===1&&s===r-1&&s===l+1?"":i.slice(s,r)},format:y.bind(null,"\\"),parse(i){E(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const s=i.length;let l=0,r=i.charCodeAt(0);if(s===1)return d(r)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(d(r)){if(l=1,d(i.charCodeAt(1))){let F=2,x=F;for(;F<s&&!d(i.charCodeAt(F));)F++;if(F<s&&F!==x){for(x=F;F<s&&d(i.charCodeAt(F));)F++;if(F<s&&F!==x){for(x=F;F<s&&!d(i.charCodeAt(F));)F++;F===s?l=F:F!==x&&(l=F+1)}}}}else if(g(r)&&i.charCodeAt(1)===L){if(s<=2)return o.root=o.dir=i,o;if(l=2,d(i.charCodeAt(2))){if(s===3)return o.root=o.dir=i,o;l=3}}l>0&&(o.root=i.slice(0,l));let m=-1,n=l,t=-1,a=!0,w=i.length-1,D=0;for(;w>=l;--w){if(r=i.charCodeAt(w),d(r)){if(!a){n=w+1;break}continue}t===-1&&(a=!1,t=w+1),r===P?m===-1?m=w:D!==1&&(D=1):m!==-1&&(D=-1)}return t!==-1&&(m===-1||D===0||D===1&&m===t-1&&m===n+1?o.base=o.name=i.slice(n,t):(o.name=i.slice(n,m),o.base=i.slice(n,t),o.ext=i.slice(m,t))),n>0&&n!==l?o.dir=i.slice(0,n-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const b=(()=>{if(f){const i=/\\/g;return()=>{const o=c.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>c.cwd()})();e.posix={resolve(...i){let o="",s=!1;for(let l=i.length-1;l>=-1&&!s;l--){const r=l>=0?i[l]:b();E(r,"path"),r.length!==0&&(o=`${r}/${o}`,s=r.charCodeAt(0)===S)}return o=p(o,!s,"/",h),s?`/${o}`:o.length>0?o:"."},normalize(i){if(E(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===S,s=i.charCodeAt(i.length-1)===S;return i=p(i,!o,"/",h),i.length===0?o?"/":s?"./":".":(s&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return E(i,"path"),i.length>0&&i.charCodeAt(0)===S},join(...i){if(i.length===0)return".";let o;for(let s=0;s<i.length;++s){const l=i[s];E(l,"path"),l.length>0&&(o===void 0?o=l:o+=`/${l}`)}return o===void 0?".":e.posix.normalize(o)},relative(i,o){if(E(i,"from"),E(o,"to"),i===o||(i=e.posix.resolve(i),o=e.posix.resolve(o),i===o))return"";const s=1,l=i.length,r=l-s,m=1,n=o.length-m,t=r<n?r:n;let a=-1,w=0;for(;w<t;w++){const F=i.charCodeAt(s+w);if(F!==o.charCodeAt(m+w))break;F===S&&(a=w)}if(w===t)if(n>t){if(o.charCodeAt(m+w)===S)return o.slice(m+w+1);if(w===0)return o.slice(m+w)}else r>t&&(i.charCodeAt(s+w)===S?a=w:w===0&&(a=0));let D="";for(w=s+a+1;w<=l;++w)(w===l||i.charCodeAt(w)===S)&&(D+=D.length===0?"..":"/..");return`${D}${o.slice(m+a)}`},toNamespacedPath(i){return i},dirname(i){if(E(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===S;let s=-1,l=!0;for(let r=i.length-1;r>=1;--r)if(i.charCodeAt(r)===S){if(!l){s=r;break}}else l=!1;return s===-1?o?"/":".":o&&s===1?"//":i.slice(0,s)},basename(i,o){o!==void 0&&E(o,"ext"),E(i,"path");let s=0,l=-1,r=!0,m;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let n=o.length-1,t=-1;for(m=i.length-1;m>=0;--m){const a=i.charCodeAt(m);if(a===S){if(!r){s=m+1;break}}else t===-1&&(r=!1,t=m+1),n>=0&&(a===o.charCodeAt(n)?--n===-1&&(l=m):(n=-1,l=t))}return s===l?l=t:l===-1&&(l=i.length),i.slice(s,l)}for(m=i.length-1;m>=0;--m)if(i.charCodeAt(m)===S){if(!r){s=m+1;break}}else l===-1&&(r=!1,l=m+1);return l===-1?"":i.slice(s,l)},extname(i){E(i,"path");let o=-1,s=0,l=-1,r=!0,m=0;for(let n=i.length-1;n>=0;--n){const t=i.charCodeAt(n);if(t===S){if(!r){s=n+1;break}continue}l===-1&&(r=!1,l=n+1),t===P?o===-1?o=n:m!==1&&(m=1):o!==-1&&(m=-1)}return o===-1||l===-1||m===0||m===1&&o===l-1&&o===s+1?"":i.slice(o,l)},format:y.bind(null,"/"),parse(i){E(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const s=i.charCodeAt(0)===S;let l;s?(o.root="/",l=1):l=0;let r=-1,m=0,n=-1,t=!0,a=i.length-1,w=0;for(;a>=l;--a){const D=i.charCodeAt(a);if(D===S){if(!t){m=a+1;break}continue}n===-1&&(t=!1,n=a+1),D===P?r===-1?r=a:w!==1&&(w=1):r!==-1&&(w=-1)}if(n!==-1){const D=m===0&&s?1:m;r===-1||w===0||w===1&&r===n-1&&r===m+1?o.base=o.name=i.slice(D,n):(o.name=i.slice(D,r),o.base=i.slice(D,n),o.ext=i.slice(r,n))}return m>0?o.dir=i.slice(0,m-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=f?e.win32.normalize:e.posix.normalize,e.isAbsolute=f?e.win32.isAbsolute:e.posix.isAbsolute,e.join=f?e.win32.join:e.posix.join,e.resolve=f?e.win32.resolve:e.posix.resolve,e.relative=f?e.win32.relative:e.posix.relative,e.dirname=f?e.win32.dirname:e.posix.dirname,e.basename=f?e.win32.basename:e.posix.basename,e.extname=f?e.win32.extname:e.posix.extname,e.format=f?e.win32.format:e.posix.format,e.parse=f?e.win32.parse:e.posix.parse,e.toNamespacedPath=f?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=f?e.win32.sep:e.posix.sep,e.delimiter=f?e.win32.delimiter:e.posix.delimiter}),define(ye[108],De([1,0,65,10]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const u=new c.Lazy(()=>{const t=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:t,collatorIsNumeric:t.resolvedOptions().numeric}}),R=new c.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new c.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(t,a,w=!1){const D=t||"",F=a||"",x=u.value.collator.compare(D,F);return u.value.collatorIsNumeric&&x===0&&D!==F?D<F?-1:1:x}e.compareFileNames=P;function S(t,a){const w=R.value.collator;return t=t||"",a=a||"",y(w,t,a)}e.compareFileNamesDefault=S;function I(t,a){const w=R.value.collator;return t=t||"",a=a||"",s(t,a)||y(w,t,a)}e.compareFileNamesUpper=I;function L(t,a){const w=R.value.collator;return t=t||"",a=a||"",o(t,a)||y(w,t,a)}e.compareFileNamesLower=L;function k(t,a){return t=t||"",a=a||"",t===a?0:t<a?-1:1}e.compareFileNamesUnicode=k;function v(t,a){const[w,D]=g(t),[F,x]=g(a);let q=u.value.collator.compare(D,x);if(q===0){if(u.value.collatorIsNumeric&&D!==x)return D<x?-1:1;if(q=u.value.collator.compare(w,F),u.value.collatorIsNumeric&&q===0&&w!==F)return w<F?-1:1}return q}e.compareFileExtensions=v;function T(t,a){t=t||"",a=a||"";const w=p(t),D=p(a),F=R.value.collator,x=C.value.collator;return y(x,w,D)||y(F,t,a)}e.compareFileExtensionsDefault=T;function E(t,a){t=t||"",a=a||"";const w=p(t),D=p(a),F=R.value.collator,x=C.value.collator;return y(x,w,D)||s(t,a)||y(F,t,a)}e.compareFileExtensionsUpper=E;function f(t,a){t=t||"",a=a||"";const w=p(t),D=p(a),F=R.value.collator,x=C.value.collator;return y(x,w,D)||o(t,a)||y(F,t,a)}e.compareFileExtensionsLower=f;function d(t,a){t=t||"",a=a||"";const w=p(t).toLowerCase(),D=p(a).toLowerCase();return w!==D?w<D?-1:1:t!==a?t<a?-1:1:0}e.compareFileExtensionsUnicode=d;const h=/^(.*?)(\.([^.]*))?$/;function g(t,a=!1){const w=t?h.exec(t):[];let D=[w&&w[1]||"",w&&w[3]||""];return a&&(!D[0]&&D[1]||D[0]&&D[0].charAt(0)===".")&&(D=[D[0]+"."+D[1],""]),D}function p(t){const a=t?h.exec(t):[];return a&&a[1]&&a[1].charAt(0)!=="."&&a[3]||""}function y(t,a,w){const D=t.compare(a,w);return D!==0?D:a.length!==w.length?a.length<w.length?-1:1:0}function b(t){const a=t.charAt(0);return a.toLocaleUpperCase()!==a}function i(t){const a=t.charAt(0);return a.toLocaleLowerCase()!==a}function o(t,a){return b(t)&&i(a)?-1:i(t)&&b(a)?1:0}function s(t,a){return i(t)&&b(a)?-1:b(t)&&i(a)?1:0}function l(t,a,w=!1){return w||(t=t&&t.toLowerCase(),a=a&&a.toLowerCase()),t===a?0:t<a?-1:1}function r(t,a,w=!1){const D=t.split(A.sep),F=a.split(A.sep),x=D.length-1,q=F.length-1;let M,B;for(let O=0;;O++){if(M=x===O,B=q===O,M&&B)return P(D[O],F[O],w);if(M)return-1;if(B)return 1;const U=l(D[O],F[O],w);if(U!==0)return U}}e.comparePaths=r;function m(t,a,w){const D=t.toLowerCase(),F=a.toLowerCase(),x=n(t,a,w);if(x)return x;const q=D.endsWith(w),M=F.endsWith(w);if(q!==M)return q?-1:1;const B=P(D,F);return B!==0?B:D.localeCompare(F)}e.compareAnything=m;function n(t,a,w){const D=t.toLowerCase(),F=a.toLowerCase(),x=D.startsWith(w),q=F.startsWith(w);if(x!==q)return x?-1:1;if(x&&q){if(D.length<F.length)return-1;if(D.length>F.length)return 1}return 0}e.compareByPrefix=n}),define(ye[86],De([1,0,10]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},u={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(L){const k=(0,c.extname)(L),v=A[k.toLowerCase()];return v!==void 0?v:C(L)}e.getMediaOrTextMime=R;function C(L){const k=(0,c.extname)(L);return u[k.toLowerCase()]}e.getMediaMime=C;function P(L){for(const k in u)if(u[k]===L)return k}e.getExtensionForMimeType=P;const S=/^(.+)\/(.+?)(;.+)?$/;function I(L,k){const v=S.exec(L);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:k?void 0:L}e.normalizeMimeType=I}),define(ye[109],De([1,0,12]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var A;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(A=e.Source||(e.Source={}));var u;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(u=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(P,...S){const I=S.reduce((v,T)=>(v[T]=!0,v),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(v=>!I[v]).forEach(v=>{for(let T=0;T<L.length;T++)if(v.search(L[T])!==-1){delete P[v];break}})}e.sanitizeProcessEnvironment=R;function C(P){!P||(delete P.DEBUG,c.isMacintosh&&delete P.DYLD_LIBRARY_PATH,c.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=C}),define(ye[43],De([1,0,12]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=c.globals.performance&&typeof c.globals.performance.now=="function";class u{static create(C=!0){return new u(C)}constructor(C){this.a=A&&C,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?c.globals.performance.now():Date.now()}}e.StopWatch=u}),define(ye[3],De([1,0,11,63,6,66,43]),function(ne,e,c,A,u,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,S=!1;var I;(function(m){m.None=()=>u.Disposable.None;function n(ve){if(S){const{onDidAddListener:ke}=ve,Oe=E.create();let oe=0;ve.onDidAddListener=()=>{++oe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Oe.print()),ke?.()}}}function t(ve,ke){return O(ve,()=>{},0,void 0,void 0,ke)}m.defer=t;function a(ve){return(ke,Oe=null,oe)=>{let ae=!1,fe;return fe=ve(Z=>{if(!ae)return fe?fe.dispose():ae=!0,ke.call(Oe,Z)},null,oe),ae&&fe.dispose(),fe}}m.once=a;function w(ve,ke,Oe){return B((oe,ae=null,fe)=>ve(Z=>oe.call(ae,ke(Z)),null,fe),Oe)}m.map=w;function D(ve,ke,Oe){return B((oe,ae=null,fe)=>ve(Z=>{ke(Z),oe.call(ae,Z)},null,fe),Oe)}m.forEach=D;function F(ve,ke,Oe){return B((oe,ae=null,fe)=>ve(Z=>ke(Z)&&oe.call(ae,Z),null,fe),Oe)}m.filter=F;function x(ve){return ve}m.signal=x;function q(...ve){return(ke,Oe=null,oe)=>(0,u.combinedDisposable)(...ve.map(ae=>ae(fe=>ke.call(Oe,fe),null,oe)))}m.any=q;function M(ve,ke,Oe,oe){let ae=Oe;return w(ve,fe=>(ae=ke(ae,fe),ae),oe)}m.reduce=M;function B(ve,ke){let Oe;const oe={onWillAddFirstListener(){Oe=ve(ae.fire,ae)},onDidRemoveLastListener(){Oe?.dispose()}};ke||n(oe);const ae=new d(oe);return ke?.add(ae),ae.event}function O(ve,ke,Oe=100,oe=!1,ae,fe){let Z,le,re,N=0;const H={leakWarningThreshold:ae,onWillAddFirstListener(){Z=ve(_=>{N++,le=ke(le,_),oe&&!re&&(K.fire(le),le=void 0);const he=()=>{const we=le;le=void 0,re=void 0,(!oe||N>1)&&K.fire(we),N=0};typeof Oe=="number"?(clearTimeout(re),re=setTimeout(he,Oe)):re===void 0&&(re=0,queueMicrotask(he))})},onDidRemoveLastListener(){Z.dispose()}};fe||n(H);const K=new d(H);return fe?.add(K),K.event}m.debounce=O;function U(ve,ke=0,Oe){return m.debounce(ve,(oe,ae)=>oe?(oe.push(ae),oe):[ae],ke,void 0,void 0,Oe)}m.accumulate=U;function z(ve,ke=(oe,ae)=>oe===ae,Oe){let oe=!0,ae;return F(ve,fe=>{const Z=oe||!ke(fe,ae);return oe=!1,ae=fe,Z},Oe)}m.latch=z;function j(ve,ke,Oe){return[m.filter(ve,ke,Oe),m.filter(ve,oe=>!ke(oe),Oe)]}m.split=j;function de(ve,ke=!1,Oe=[]){let oe=Oe.slice(),ae=ve(le=>{oe?oe.push(le):Z.fire(le)});const fe=()=>{oe?.forEach(le=>Z.fire(le)),oe=null},Z=new d({onWillAddFirstListener(){ae||(ae=ve(le=>Z.fire(le)))},onDidAddFirstListener(){oe&&(ke?setTimeout(fe):fe())},onDidRemoveLastListener(){ae&&ae.dispose(),ae=null}});return Z.event}m.buffer=de;class V{constructor(ke){this.event=ke,this.c=new u.DisposableStore}map(ke){return new V(w(this.event,ke,this.c))}forEach(ke){return new V(D(this.event,ke,this.c))}filter(ke){return new V(F(this.event,ke,this.c))}reduce(ke,Oe){return new V(M(this.event,ke,Oe,this.c))}latch(){return new V(z(this.event,void 0,this.c))}debounce(ke,Oe=100,oe=!1,ae){return new V(O(this.event,ke,Oe,oe,ae,this.c))}on(ke,Oe,oe){return this.event(ke,Oe,oe)}once(ke,Oe,oe){return a(this.event)(ke,Oe,oe)}dispose(){this.c.dispose()}}function X(ve){return new V(ve)}m.chain=X;function J(ve,ke,Oe=oe=>oe){const oe=(...le)=>Z.fire(Oe(...le)),ae=()=>ve.on(ke,oe),fe=()=>ve.removeListener(ke,oe),Z=new d({onWillAddFirstListener:ae,onDidRemoveLastListener:fe});return Z.event}m.fromNodeEventEmitter=J;function te(ve,ke,Oe=oe=>oe){const oe=(...le)=>Z.fire(Oe(...le)),ae=()=>ve.addEventListener(ke,oe),fe=()=>ve.removeEventListener(ke,oe),Z=new d({onWillAddFirstListener:ae,onDidRemoveLastListener:fe});return Z.event}m.fromDOMEventEmitter=te;function ee(ve){return new Promise(ke=>a(ve)(ke))}m.toPromise=ee;function Q(ve,ke){return ke(void 0),ve(Oe=>ke(Oe))}m.runAndSubscribe=Q;function Y(ve,ke){let Oe=null;function oe(fe){Oe?.dispose(),Oe=new u.DisposableStore,ke(fe,Oe)}oe(void 0);const ae=ve(fe=>oe(fe));return(0,u.toDisposable)(()=>{ae.dispose(),Oe?.dispose()})}m.runAndSubscribeWithStore=Y;class ie{constructor(ke,Oe){this.obs=ke,this.c=0,this.d=!1;const oe={onWillAddFirstListener:()=>{ke.addObserver(this)},onDidRemoveLastListener:()=>{ke.removeObserver(this)}};Oe||n(oe),this.emitter=new d(oe),Oe&&Oe.add(this.emitter)}beginUpdate(ke){this.c++}handleChange(ke,Oe){this.d=!0}endUpdate(ke){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function pe(ve,ke){return new ie(ve,ke).emitter.event}m.fromObservable=pe})(I=e.Event||(e.Event={}));class L{constructor(n){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${n}_${L.c++}`,L.all.add(this)}start(n){this.d=new C.StopWatch(!0),this.listenerCount=n}stop(){if(this.d){const n=this.d.elapsed();this.durations.push(n),this.elapsedOverall+=n,this.invocationCount+=1,this.d=void 0}}}L.all=new Set,L.c=0,e.EventProfiling=L;let k=-1;function v(m){const n=k;return k=m,{dispose(){k=n}}}e.setGlobalLeakWarningThreshold=v;class T{constructor(n,t=Math.random().toString(18).slice(2,5)){this.threshold=n,this.name=t,this.d=0}dispose(){this.c?.clear()}check(n,t){const a=this.threshold;if(a<=0||t<a)return;this.c||(this.c=new Map);const w=this.c.get(n.value)||0;if(this.c.set(n.value,w+1),this.d-=1,this.d<=0){this.d=a*.5;let D,F=0;for(const[x,q]of this.c)(!D||F<q)&&(D=x,F=q);console.warn(`[${this.name}] potential listener LEAK detected, having ${t} listeners already. MOST frequent listener (${F}):`),console.warn(D)}return()=>{const D=this.c.get(n.value)||0;this.c.set(n.value,D-1)}}}class E{static create(){return new E(new Error().stack??"")}constructor(n){this.value=n}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class f{constructor(n,t,a){this.callback=n,this.callbackThis=t,this.stack=a,this.subscription=new u.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class d{constructor(n){this.j=!1,this.d=n,this.f=k>0||this.d?.leakWarningThreshold?new T(this.d?.leakWarningThreshold??k):void 0,this.g=this.d?._profName?new L(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const n=Array.from(this.q);queueMicrotask(()=>{for(const t of n)t.subscription.isset()&&(t.subscription.unset(),t.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(n,t,a)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),u.Disposable.None;const w=this.q.isEmpty();w&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let D,F;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(F=E.create(),D=this.f.check(F,this.q.size+1)),P&&(F=F??E.create());const x=new f(n,t,F),q=this.q.push(x);w&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,n,t);const M=x.subscription.set(()=>{D?.(),this.j||(q(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return a instanceof u.DisposableStore?a.add(M):Array.isArray(a)&&a.push(M),M}),this.l}fire(n){if(this.q){this.m||(this.m=new g);for(const t of this.q)this.m.push(this,t,n);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=d;class h{constructor(){this.c=new R.LinkedList}get size(){return this.c.size}push(n,t,a){this.c.push(new p(n,t,a))}clear(n){const t=new R.LinkedList;for(const a of this.c)a.emitter!==n&&t.push(a);this.c=t}deliver(){for(;this.c.size>0;){const n=this.c.shift();try{n.listener.invoke(n.event)}catch(t){(0,c.onUnexpectedError)(t)}}}}e.EventDeliveryQueue=h;class g extends h{clear(n){this.c.clear()}}class p{constructor(n,t,a){this.emitter=n,this.listener=t,this.event=a}}class y extends d{async fireAsync(n,t,a){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const w of this.q)this.c.push([w,n]);for(;this.c.size>0&&!t.isCancellationRequested;){const[w,D]=this.c.shift(),F=[],x={...D,token:t,waitUntil:q=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");a&&(q=a(q,w.callback)),F.push(q)}};try{w.invoke(x)}catch(q){(0,c.onUnexpectedError)(q);continue}Object.freeze(F),await Promise.allSettled(F).then(q=>{for(const M of q)M.status==="rejected"&&(0,c.onUnexpectedError)(M.reason)})}}}}e.AsyncEmitter=y;class b extends d{constructor(n){super(n),this.h=0,this.s=new R.LinkedList,this.t=n?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const n=Array.from(this.s);this.s.clear(),super.fire(this.t(n))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(n){this.q&&(this.h!==0?this.s.push(n):super.fire(n))}}e.PauseableEmitter=b;class i extends b{constructor(n){super(n),this.c=n.delay??100}fire(n){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(n)}}e.DebounceEmitter=i;class o extends d{constructor(n){super(n),this.c=[],this.h=n?.merge}fire(n){!this.hasListeners()||(this.c.push(n),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(t=>super.fire(t)),this.c=[]}))}}e.MicrotaskEmitter=o;class s{constructor(){this.d=!1,this.f=[],this.c=new d({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(n){const t={event:n,listener:null};this.f.push(t),this.d&&this.j(t);const a=()=>{this.d&&this.k(t);const w=this.f.indexOf(t);this.f.splice(w,1)};return(0,u.toDisposable)((0,A.once)(a))}g(){this.d=!0,this.f.forEach(n=>this.j(n))}h(){this.d=!1,this.f.forEach(n=>this.k(n))}j(n){n.listener=n.event(t=>this.c.fire(t))}k(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=s;class l{constructor(){this.c=[]}wrapEvent(n){return(t,a,w)=>n(D=>{const F=this.c[this.c.length-1];F?F.push(()=>t.call(a,D)):t.call(a,D)},void 0,w)}bufferEvents(n){const t=[];this.c.push(t);const a=n();return this.c.pop(),t.forEach(w=>w()),a}}e.EventBufferer=l;class r{constructor(){this.c=!1,this.d=I.None,this.f=u.Disposable.None,this.g=new d({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(n){this.d=n,this.c&&(this.f.dispose(),this.f=n(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=r}),define(ye[161],De([1,0,3,6,156]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class R extends A.Disposable{constructor(v,T="",E="",f=!0,d){super(),this.h=this.B(new c.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=v,this.m=T,this.u=E,this.w=f,this.C=d}get id(){return this.j}get label(){return this.m}set label(v){this.D(v)}D(v){this.m!==v&&(this.m=v,this.h.fire({label:v}))}get tooltip(){return this.n||""}set tooltip(v){this.F(v)}F(v){this.n!==v&&(this.n=v,this.h.fire({tooltip:v}))}get class(){return this.u}set class(v){this.G(v)}G(v){this.u!==v&&(this.u=v,this.h.fire({class:v}))}get enabled(){return this.w}set enabled(v){this.H(v)}H(v){this.w!==v&&(this.w=v,this.h.fire({enabled:v}))}get checked(){return this.z}set checked(v){this.I(v)}I(v){this.z!==v&&(this.z=v,this.h.fire({checked:v}))}async run(v,T){this.C&&await this.C(v)}}e.Action=R;class C extends A.Disposable{constructor(){super(...arguments),this.f=this.B(new c.Emitter),this.onWillRun=this.f.event,this.h=this.B(new c.Emitter),this.onDidRun=this.h.event}async run(v,T){if(!v.enabled)return;this.f.fire({action:v});let E;try{await this.runAction(v,T)}catch(f){E=f}this.h.fire({action:v,error:E})}async runAction(v,T){await v.run(T)}}e.ActionRunner=C;class P{constructor(){this.id=P.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let T=[];for(const E of v)E.length&&(T.length?T=[...T,new P,...E]:T=E);return T}async run(){}}P.ID="vs.actions.separator",e.Separator=P;class S{get actions(){return this.a}constructor(v,T,E,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=T,this.class=f,this.a=E}async run(){}}e.SubmenuAction=S;class I extends R{constructor(){super(I.ID,u.localize(0,null),void 0,!1)}}I.ID="vs.actions.empty",e.EmptySubmenuAction=I;function L(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async()=>k.run(),tooltip:k.label}}e.toAction=L}),define(ye[21],De([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(P,S){const I=setTimeout(P.bind(S),0);return{dispose(){clearTimeout(I)}}});var u;(function(P){function S(I){return I===P.None||I===P.Cancelled||I instanceof R?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}P.isCancellationToken=S,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:c.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(u=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new c.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(S){this.a=void 0,this.b=void 0,this.b=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=u.Cancelled}dispose(S=!1){S&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=u.None}}e.CancellationTokenSource=C}),define(ye[162],De([1,0,21]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class A{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new c.CancellationTokenSource,S=this.b(P.token);return this.a={promise:S,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=A;class u{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const S=JSON.stringify(P);return this.b!==S&&(this.b=S,this.a=this.c(P)),this.a}}e.LRUCachedFunction=u;class R{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const S=this.b(P);return this.a.set(P,S),S}}e.CachedFunction=R}),define(ye[8],De([1,0,162,65]),function(ne,e,c,A){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R($){return!$||typeof $!="string"?!0:$.trim().length===0}e.isFalsyOrWhitespace=R;const C=/{(\d+)}/g;function P($,...ue){return ue.length===0?$:$.replace(C,function(Ie,Le){const $e=parseInt(Le,10);return isNaN($e)||$e<0||$e>=ue.length?Ie:ue[$e]})}e.format=P;const S=/{([^}]+)}/g;function I($,ue){return $.replace(S,(Ie,Le)=>ue[Le]??Ie)}e.format2=I;function L($){return $.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.escape=L;function k($){return $.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function v($,ue){let Ie=0;const Le=ue.charCodeAt(0);for(let $e=$.length-1;$e>=0;$e--)$.charCodeAt($e)===Le&&Ie++;return Ie}e.count=v;function T($,ue,Ie="\u2026"){return $.length<=ue?$:`${$.substr(0,ue)}${Ie}`}e.truncate=T;function E($,ue=" "){const Ie=f($,ue);return d(Ie,ue)}e.trim=E;function f($,ue){if(!$||!ue)return $;const Ie=ue.length;if(Ie===0||$.length===0)return $;let Le=0;for(;$.indexOf(ue,Le)===Le;)Le=Le+Ie;return $.substring(Le)}e.ltrim=f;function d($,ue){if(!$||!ue)return $;const Ie=ue.length,Le=$.length;if(Ie===0||Le===0)return $;let $e=Le,Ke=-1;for(;Ke=$.lastIndexOf(ue,$e-1),!(Ke===-1||Ke+Ie!==$e);){if(Ke===0)return"";$e=Ke}return $.substring(0,$e)}e.rtrim=d;function h($){return $.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function g($){return $.replace(/\*/g,"")}e.stripWildcards=g;function p($,ue,Ie={}){if(!$)throw new Error("Cannot create regex from empty string");ue||($=k($)),Ie.wholeWord&&(/\B/.test($.charAt(0))||($="\\b"+$),/\B/.test($.charAt($.length-1))||($=$+"\\b"));let Le="";return Ie.global&&(Le+="g"),Ie.matchCase||(Le+="i"),Ie.multiline&&(Le+="m"),Ie.unicode&&(Le+="u"),new RegExp($,Le)}e.createRegExp=p;function y($){return $.source==="^"||$.source==="^$"||$.source==="$"||$.source==="^\\s*$"?!1:!!($.exec("")&&$.lastIndex===0)}e.regExpLeadsToEndlessLoop=y;function b($){return!!$.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function i($){return($.global?"g":"")+($.ignoreCase?"i":"")+($.multiline?"m":"")+($.unicode?"u":"")}e.regExpFlags=i;function o($){return $.split(/\r\n|\r|\n/)}e.splitLines=o;function s($){for(let ue=0,Ie=$.length;ue<Ie;ue++){const Le=$.charCodeAt(ue);if(Le!==32&&Le!==9)return ue}return-1}e.firstNonWhitespaceIndex=s;function l($,ue=0,Ie=$.length){for(let Le=ue;Le<Ie;Le++){const $e=$.charCodeAt(Le);if($e!==32&&$e!==9)return $.substring(ue,Le)}return $.substring(ue,Ie)}e.getLeadingWhitespace=l;function r($,ue=$.length-1){for(let Ie=ue;Ie>=0;Ie--){const Le=$.charCodeAt(Ie);if(Le!==32&&Le!==9)return Ie}return-1}e.lastNonWhitespaceIndex=r;function m($,ue,Ie){const Le=[];let $e=0;for(const Ke of $.matchAll(ue)){if(Le.push($.slice($e,Ke.index)),Ke.index===void 0)throw new Error("match.index should be defined");$e=Ke.index+Ke[0].length,Le.push(Ie(Ke[0],...Ke.slice(1),Ke.index,$,Ke.groups))}return Le.push($.slice($e)),Promise.all(Le).then(Ke=>Ke.join(""))}e.replaceAsync=m;function n($,ue){return $<ue?-1:$>ue?1:0}e.compare=n;function t($,ue,Ie=0,Le=$.length,$e=0,Ke=ue.length){for(;Ie<Le&&$e<Ke;Ie++,$e++){const gt=$.charCodeAt(Ie),ct=ue.charCodeAt($e);if(gt<ct)return-1;if(gt>ct)return 1}const Ze=Le-Ie,pt=Ke-$e;return Ze<pt?-1:Ze>pt?1:0}e.compareSubstring=t;function a($,ue){return w($,ue,0,$.length,0,ue.length)}e.compareIgnoreCase=a;function w($,ue,Ie=0,Le=$.length,$e=0,Ke=ue.length){for(;Ie<Le&&$e<Ke;Ie++,$e++){let gt=$.charCodeAt(Ie),ct=ue.charCodeAt($e);if(gt===ct)continue;if(gt>=128||ct>=128)return t($.toLowerCase(),ue.toLowerCase(),Ie,Le,$e,Ke);F(gt)&&(gt-=32),F(ct)&&(ct-=32);const Et=gt-ct;if(Et!==0)return Et}const Ze=Le-Ie,pt=Ke-$e;return Ze<pt?-1:Ze>pt?1:0}e.compareSubstringIgnoreCase=w;function D($){return $>=48&&$<=57}e.isAsciiDigit=D;function F($){return $>=97&&$<=122}e.isLowerAsciiLetter=F;function x($){return $>=65&&$<=90}e.isUpperAsciiLetter=x;function q($,ue){return $.length===ue.length&&w($,ue)===0}e.equalsIgnoreCase=q;function M($,ue){const Ie=ue.length;return ue.length>$.length?!1:w($,ue,0,Ie)===0}e.startsWithIgnoreCase=M;function B($,ue){const Ie=Math.min($.length,ue.length);let Le;for(Le=0;Le<Ie;Le++)if($.charCodeAt(Le)!==ue.charCodeAt(Le))return Le;return Ie}e.commonPrefixLength=B;function O($,ue){const Ie=Math.min($.length,ue.length);let Le;const $e=$.length-1,Ke=ue.length-1;for(Le=0;Le<Ie;Le++)if($.charCodeAt($e-Le)!==ue.charCodeAt(Ke-Le))return Le;return Ie}e.commonSuffixLength=O;function U($){return 55296<=$&&$<=56319}e.isHighSurrogate=U;function z($){return 56320<=$&&$<=57343}e.isLowSurrogate=z;function j($,ue){return($-55296<<10)+(ue-56320)+65536}e.computeCodePoint=j;function de($,ue,Ie){const Le=$.charCodeAt(Ie);if(U(Le)&&Ie+1<ue){const $e=$.charCodeAt(Ie+1);if(z($e))return j(Le,$e)}return Le}e.getNextCodePoint=de;function V($,ue){const Ie=$.charCodeAt(ue-1);if(z(Ie)&&ue>1){const Le=$.charCodeAt(ue-2);if(U(Le))return j(Le,Ie)}return Ie}class X{get offset(){return this.e}constructor(ue,Ie=0){this.c=ue,this.d=ue.length,this.e=Ie}setOffset(ue){this.e=ue}prevCodePoint(){const ue=V(this.c,this.e);return this.e-=ue>=65536?2:1,ue}nextCodePoint(){const ue=de(this.c,this.d,this.e);return this.e+=ue>=65536?2:1,ue}eol(){return this.e>=this.d}}e.CodePointIterator=X;class J{get offset(){return this.c.offset}constructor(ue,Ie=0){this.c=new X(ue,Ie)}nextGraphemeLength(){const ue=et.getInstance(),Ie=this.c,Le=Ie.offset;let $e=ue.getGraphemeBreakType(Ie.nextCodePoint());for(;!Ie.eol();){const Ke=Ie.offset,Ze=ue.getGraphemeBreakType(Ie.nextCodePoint());if(Ve($e,Ze)){Ie.setOffset(Ke);break}$e=Ze}return Ie.offset-Le}prevGraphemeLength(){const ue=et.getInstance(),Ie=this.c,Le=Ie.offset;let $e=ue.getGraphemeBreakType(Ie.prevCodePoint());for(;Ie.offset>0;){const Ke=Ie.offset,Ze=ue.getGraphemeBreakType(Ie.prevCodePoint());if(Ve(Ze,$e)){Ie.setOffset(Ke);break}$e=Ze}return Le-Ie.offset}eol(){return this.c.eol()}}e.GraphemeIterator=J;function te($,ue){return new J($,ue).nextGraphemeLength()}e.nextCharLength=te;function ee($,ue){return new J($,ue).prevGraphemeLength()}e.prevCharLength=ee;function Q($,ue){ue>0&&z($.charCodeAt(ue))&&ue--;const Ie=ue+te($,ue);return[Ie-ee($,Ie),Ie]}e.getCharContainingOffset=Q;function Y($){const ue=new J($);let Ie=0;for(;!ue.eol();)Ie++,ue.nextGraphemeLength();return Ie}e.charCount=Y;let ie;function pe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ve($){return ie||(ie=pe()),ie.test($)}e.containsRTL=ve;const ke=/^[\t\n\r\x20-\x7E]*$/;function Oe($){return ke.test($)}e.isBasicASCII=Oe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function oe($){return e.UNUSUAL_LINE_TERMINATORS.test($)}e.containsUnusualLineTerminators=oe;function ae($){return $>=11904&&$<=55215||$>=63744&&$<=64255||$>=65281&&$<=65374}e.isFullWidthCharacter=ae;function fe($){return $>=127462&&$<=127487||$===8986||$===8987||$===9200||$===9203||$>=9728&&$<=10175||$===11088||$===11093||$>=127744&&$<=128591||$>=128640&&$<=128764||$>=128992&&$<=129008||$>=129280&&$<=129535||$>=129648&&$<=129782}e.isEmojiImprecise=fe;function Z($,ue){if($.length<ue)return $;const Ie=/\b/g;let Le=0;for(;Ie.test($)&&!($.length-Ie.lastIndex<ue);)Le=Ie.lastIndex,Ie.lastIndex+=1;return $.substring(Le).replace(/^\s/,"")}e.lcut=Z;const le=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,N=/\x1b\[0?m/g;function H($){return $&&($=$.replace(le,""),$=$.replace(re,""),$=$.replace(N,"")),$}e.removeAnsiEscapeCodes=H,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function K($){return!!($&&$.length>0&&$.charCodeAt(0)===65279)}e.startsWithUTF8BOM=K;function _($){return K($)?$.substr(1):$}e.stripUTF8BOM=_;function he($,ue){if(!$||!ue||$.length<ue.length)return!1;const Ie=ue.length,Le=$.toLowerCase();let $e=0,Ke=-1;for(;$e<Ie;){const Ze=Le.indexOf(ue[$e],Ke+1);if(Ze<0)return!1;Ke=Ze,$e++}return!0}e.fuzzyContains=he;function we($,ue=!1){return $?(ue&&($=$.replace(/\\./g,"")),$.toLowerCase()!==$):!1}e.containsUppercaseCharacter=we;function Ae($){return $.charAt(0).toUpperCase()+$.slice(1)}e.uppercaseFirstLetter=Ae;function be($,ue=1){if(ue===0)return"";let Ie=-1;do Ie=$.indexOf(`
`,Ie+1),ue--;while(ue>0&&Ie>=0);return Ie===-1?$:($[Ie-1]==="\r"&&Ie--,$.substr(0,Ie))}e.getNLines=be;function Ce($){return $=$%(2*26),$<26?String.fromCharCode(97+$):String.fromCharCode(65+$-26)}e.singleLetterHash=Ce;function Te($){return et.getInstance().getGraphemeBreakType($)}e.getGraphemeBreakType=Te;function Ve($,ue){return $===0?ue!==5&&ue!==7:$===2&&ue===3?!1:$===4||$===2||$===3||ue===4||ue===2||ue===3?!0:!($===8&&(ue===8||ue===9||ue===11||ue===12)||($===11||$===9)&&(ue===9||ue===10)||($===12||$===10)&&ue===10||ue===5||ue===13||ue===7||$===1||$===13&&ue===14||$===6&&ue===6)}var xe;(function($){$[$.Other=0]="Other",$[$.Prepend=1]="Prepend",$[$.CR=2]="CR",$[$.LF=3]="LF",$[$.Control=4]="Control",$[$.Extend=5]="Extend",$[$.Regional_Indicator=6]="Regional_Indicator",$[$.SpacingMark=7]="SpacingMark",$[$.L=8]="L",$[$.V=9]="V",$[$.T=10]="T",$[$.LV=11]="LV",$[$.LVT=12]="LVT",$[$.ZWJ=13]="ZWJ",$[$.Extended_Pictographic=14]="Extended_Pictographic"})(xe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class et{static getInstance(){return et.c||(et.c=new et),et.c}constructor(){this.d=Qe()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const Ie=this.d,Le=Ie.length/3;let $e=1;for(;$e<=Le;)if(ue<Ie[3*$e])$e=2*$e;else if(ue>Ie[3*$e+1])$e=2*$e+1;else return Ie[3*$e+2];return 0}}et.c=null;function Qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function nt($,ue){if($===0)return 0;const Ie=st($,ue);if(Ie!==void 0)return Ie;const Le=new X(ue,$);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=nt;function st($,ue){const Ie=new X(ue,$);let Le=Ie.prevCodePoint();for(;ht(Le)||Le===65039||Le===8419;){if(Ie.offset===0)return;Le=Ie.prevCodePoint()}if(!fe(Le))return;let $e=Ie.offset;return $e>0&&Ie.prevCodePoint()===8205&&($e=Ie.offset),$e}function ht($){return 127995<=$&&$<=127999}var Ue;(function($){$[$.zwj=8205]="zwj",$[$.emojiVariantSelector=65039]="emojiVariantSelector",$[$.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={})),e.noBreakWhitespace="\xA0";class rt{static getInstance(ue){return rt.d.get(Array.from(ue))}static getLocales(){return rt.e.value}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}u=rt,rt.c=new A.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),rt.d=new c.LRUCachedFunction($=>{function ue(ct){const Et=new Map;for(let tt=0;tt<ct.length;tt+=2)Et.set(ct[tt],ct[tt+1]);return Et}function Ie(ct,Et){const tt=new Map(ct);for(const[ft,At]of Et)tt.set(ft,At);return tt}function Le(ct,Et){if(!ct)return Et;const tt=new Map;for(const[ft,At]of ct)Et.has(ft)&&tt.set(ft,At);return tt}const $e=u.c.value;let Ke=$.filter(ct=>!ct.startsWith("_")&&ct in $e);Ke.length===0&&(Ke=["_default"]);let Ze;for(const ct of Ke){const Et=ue($e[ct]);Ze=Le(Ze,Et)}const pt=ue($e._common),gt=Ie(pt,Ze);return new rt(gt)}),rt.e=new A.Lazy(()=>Object.keys(rt.c.value).filter($=>!$.startsWith("_"))),e.AmbiguousCharacters=rt;class ce{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(ce.c())),this.d}static isInvisibleCharacter(ue){return ce.e().has(ue)}static get codePoints(){return ce.e()}}ce.d=void 0,e.InvisibleCharacters=ce}),define(ye[33],De([1,0,10,12,8,9]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(r){return r===47||r===92}e.isPathSeparator=C;function P(r){return r.replace(/[\\/]/g,c.posix.sep)}e.toSlashes=P;function S(r){return r.indexOf("/")===-1&&(r=P(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=S;function I(r,m=c.posix.sep){if(!r)return"";const n=r.length,t=r.charCodeAt(0);if(C(t)){if(C(r.charCodeAt(1))&&!C(r.charCodeAt(2))){let w=3;const D=w;for(;w<n&&!C(r.charCodeAt(w));w++);if(D!==w&&!C(r.charCodeAt(w+1))){for(w+=1;w<n;w++)if(C(r.charCodeAt(w)))return r.slice(0,w+1).replace(/[\\/]/g,m)}}return m}else if(h(t)&&r.charCodeAt(1)===58)return C(r.charCodeAt(2))?r.slice(0,2)+m:r.slice(0,2);let a=r.indexOf("://");if(a!==-1){for(a+=3;a<n;a++)if(C(r.charCodeAt(a)))return r.slice(0,a+1)}return""}e.getRoot=I;function L(r){if(!A.isWindows||!r||r.length<5)return!1;let m=r.charCodeAt(0);if(m!==92||(m=r.charCodeAt(1),m!==92))return!1;let n=2;const t=n;for(;n<r.length&&(m=r.charCodeAt(n),m!==92);n++);return!(t===n||(m=r.charCodeAt(n+1),isNaN(m)||m===92))}e.isUNC=L;const k=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,T=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function E(r,m=A.isWindows){const n=m?k:v;return!(!r||r.length===0||/^\s+$/.test(r)||(n.lastIndex=0,n.test(r))||m&&T.test(r)||r==="."||r===".."||m&&r[r.length-1]==="."||m&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=E;function f(r,m,n){const t=r===m;return!n||t?t:!r||!m?!1:(0,u.equalsIgnoreCase)(r,m)}e.isEqual=f;function d(r,m,n,t=c.sep){if(r===m)return!0;if(!r||!m||m.length>r.length)return!1;if(n){if(!(0,u.startsWithIgnoreCase)(r,m))return!1;if(m.length===r.length)return!0;let w=m.length;return m.charAt(m.length-1)===t&&w--,r.charAt(w)===t}return m.charAt(m.length-1)!==t&&(m+=t),r.indexOf(m)===0}e.isEqualOrParent=d;function h(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=h;function g(r,m){return A.isWindows&&r.endsWith(":")&&(r+=c.sep),(0,c.isAbsolute)(r)||(r=(0,c.join)(m,r)),r=(0,c.normalize)(r),A.isWindows?(r=(0,u.rtrim)(r,c.sep),r.endsWith(":")&&(r+=c.sep)):(r=(0,u.rtrim)(r,c.sep),r||(r=c.sep)),r}e.sanitizeFilePath=g;function p(r){const m=(0,c.normalize)(r);return A.isWindows?r.length>3?!1:y(m)&&(r.length===2||m.charCodeAt(2)===92):m===c.posix.sep}e.isRootOrDriveLetter=p;function y(r,m=A.isWindows){return m?h(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=y;function b(r){return y(r)?r[0]:void 0}e.getDriveLetter=b;function i(r,m,n){return m.length>r.length?-1:r===m?0:(n&&(r=r.toLowerCase(),m=m.toLowerCase()),r.indexOf(m))}e.indexOfPath=i;function o(r){const m=r.split(":");let n,t,a;for(const w of m){const D=Number(w);(0,R.isNumber)(D)?t===void 0?t=D:a===void 0&&(a=D):n=n?[n,w].join(":"):w}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:t!==void 0?t:void 0,column:a!==void 0?a:t!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function l(r,m,n=8){let t="";for(let w=0;w<n;w++)t+=s.charAt(Math.floor(Math.random()*s.length));let a;return m?a=`${m}-${t}`:a=t,r?(0,c.join)(r,a):a}e.randomPath=l}),define(ye[110],De([1,0,28,8]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function u(...re){return function(N,H){for(let K=0,_=re.length;K<_;K++){const he=re[K](N,H);if(he)return he}return null}}e.or=u,e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(re,N,H){if(!H||H.length<N.length)return null;let K;return re?K=A.startsWithIgnoreCase(H,N):K=H.indexOf(N)===0,K?N.length>0?[{start:0,end:N.length}]:[]:null}function C(re,N){const H=N.toLowerCase().indexOf(re.toLowerCase());return H===-1?null:[{start:H,end:H+re.length}]}e.matchesContiguousSubString=C;function P(re,N){return S(re.toLowerCase(),N.toLowerCase(),0,0)}e.matchesSubString=P;function S(re,N,H,K){if(H===re.length)return[];if(K===N.length)return null;if(re[H]===N[K]){let _=null;return(_=S(re,N,H+1,K+1))?h({start:K,end:K+1},_):null}return S(re,N,H,K+1)}function I(re){return 97<=re&&re<=122}function L(re){return 65<=re&&re<=90}e.isUpper=L;function k(re){return 48<=re&&re<=57}function v(re){return re===32||re===9||re===10||re===13}const T=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(re=>T.add(re.charCodeAt(0)));function E(re){return v(re)||T.has(re)}function f(re,N){return re===N||E(re)&&E(N)}function d(re){return I(re)||L(re)||k(re)}function h(re,N){return N.length===0?N=[re]:re.end===N[0].start?N[0].start=re.start:N.unshift(re),N}function g(re,N){for(let H=N;H<re.length;H++){const K=re.charCodeAt(H);if(L(K)||k(K)||H>0&&!d(re.charCodeAt(H-1)))return H}return re.length}function p(re,N,H,K){if(H===re.length)return[];if(K===N.length)return null;if(re[H]!==N[K].toLowerCase())return null;{let _=null,he=K+1;for(_=p(re,N,H+1,K+1);!_&&(he=g(N,he))<N.length;)_=p(re,N,H+1,he),he++;return _===null?null:h({start:K,end:K+1},_)}}function y(re){let N=0,H=0,K=0,_=0,he=0;for(let Te=0;Te<re.length;Te++)he=re.charCodeAt(Te),L(he)&&N++,I(he)&&H++,d(he)&&K++,k(he)&&_++;const we=N/re.length,Ae=H/re.length,be=K/re.length,Ce=_/re.length;return{upperPercent:we,lowerPercent:Ae,alphaPercent:be,numericPercent:Ce}}function b(re){const{upperPercent:N,lowerPercent:H}=re;return H===0&&N>.6}function i(re){const{upperPercent:N,lowerPercent:H,alphaPercent:K,numericPercent:_}=re;return H>.2&&N<.8&&K>.6&&_<.2}function o(re){let N=0,H=0,K=0,_=0;for(let he=0;he<re.length;he++)K=re.charCodeAt(he),L(K)&&N++,I(K)&&H++,v(K)&&_++;return(N===0||H===0)&&_===0?re.length<=30:N<=5}function s(re,N){if(!N||(N=N.trim(),N.length===0)||!o(re)||N.length>60)return null;const H=y(N);if(!i(H)){if(!b(H))return null;N=N.toLowerCase()}let K=null,_=0;for(re=re.toLowerCase();_<N.length&&(K=p(re,N,0,_))===null;)_=g(N,_+1);return K}e.matchesCamelCase=s;function l(re,N,H=!1){if(!N||N.length===0)return null;let K=null,_=0;for(re=re.toLowerCase(),N=N.toLowerCase();_<N.length&&(K=r(re,N,0,_,H))===null;)_=m(N,_+1);return K}e.matchesWords=l;function r(re,N,H,K,_){if(H===re.length)return[];if(K===N.length)return null;if(f(re.charCodeAt(H),N.charCodeAt(K))){let he=null,we=K+1;if(he=r(re,N,H+1,K+1,_),!_)for(;!he&&(we=m(N,we))<N.length;)he=r(re,N,H+1,we,_),we++;return he?re.charCodeAt(H)!==N.charCodeAt(K)?he:h({start:K,end:K+1},he):null}else return null}function m(re,N){for(let H=N;H<re.length;H++)if(E(re.charCodeAt(H))||H>0&&E(re.charCodeAt(H-1)))return H;return re.length}const n=u(e.matchesPrefix,s,C),t=u(e.matchesPrefix,s,P),a=new c.LRUCache(1e4);function w(re,N,H=!1){if(typeof re!="string"||typeof N!="string")return null;let K=a.get(re);K||(K=new RegExp(A.convertSimple2RegExpPattern(re),"i"),a.set(re,K));const _=K.exec(N);return _?[{start:_.index,end:_.index+_[0].length}]:H?t(re,N):n(re,N)}e.matchesFuzzy=w;function D(re,N){const H=ke(re,re.toLowerCase(),0,N,N.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return H?x(H):null}e.matchesFuzzy2=D;function F(re,N,H,K,_,he){const we=Math.min(13,re.length);for(;H<we;H++){const Ae=ke(re,N,H,K,_,he,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ae)return Ae}return[0,he]}e.anyScore=F;function x(re){if(typeof re>"u")return[];const N=[],H=re[1];for(let K=re.length-1;K>1;K--){const _=re[K]+H,he=N[N.length-1];he&&he.end===_?he.end=_+1:N.push({start:_,end:_+1})}return N}e.createMatches=x;const q=128;function M(){const re=[],N=[];for(let H=0;H<=q;H++)N[H]=0;for(let H=0;H<=q;H++)re.push(N.slice(0));return re}function B(re){const N=[];for(let H=0;H<=re;H++)N[H]=0;return N}const O=B(2*q),U=B(2*q),z=M(),j=M(),de=M(),V=!1;function X(re,N,H,K,_){function he(Ae,be,Ce=" "){for(;Ae.length<be;)Ae=Ce+Ae;return Ae}let we=` |   |${K.split("").map(Ae=>he(Ae,3)).join("|")}
`;for(let Ae=0;Ae<=H;Ae++)Ae===0?we+=" |":we+=`${N[Ae-1]}|`,we+=re[Ae].slice(0,_+1).map(be=>he(be.toString(),3)).join("|")+`
`;return we}function J(re,N,H,K){re=re.substr(N),H=H.substr(K),console.log(X(j,re,re.length,H,H.length)),console.log(X(de,re,re.length,H,H.length)),console.log(X(z,re,re.length,H,H.length))}function te(re,N){if(N<0||N>=re.length)return!1;const H=re.codePointAt(N);switch(H){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!A.isEmojiImprecise(H)}}function ee(re,N){if(N<0||N>=re.length)return!1;switch(re.charCodeAt(N)){case 32:case 9:return!0;default:return!1}}function Q(re,N,H){return N[re]!==H[re]}function Y(re,N,H,K,_,he,we=!1){for(;N<H&&_<he;)re[N]===K[_]&&(we&&(O[N]=_),N+=1),_+=1;return N===H}e.isPatternInWord=Y;var ie;(function(re){re[re.Diag=1]="Diag",re[re.Left=2]="Left",re[re.LeftLeft=3]="LeftLeft"})(ie||(ie={}));var pe;(function(re){re.Default=[-100,0];function N(H){return!H||H.length===2&&H[0]===-100&&H[1]===0}re.isDefault=N})(pe=e.FuzzyScore||(e.FuzzyScore={}));class ve{constructor(N,H){this.firstMatchCanBeWeak=N,this.boostFullMatch=H}}ve.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=ve;function ke(re,N,H,K,_,he,we=ve.default){const Ae=re.length>q?q:re.length,be=K.length>q?q:K.length;if(H>=Ae||he>=be||Ae-H>be-he||!Y(N,H,Ae,_,he,be,!0))return;Oe(Ae,be,H,he,N,_);let Ce=1,Te=1,Ve=H,xe=he;const et=[!1];for(Ce=1,Ve=H;Ve<Ae;Ce++,Ve++){const Ue=O[Ve],rt=U[Ve],ce=Ve+1<Ae?U[Ve+1]:be;for(Te=Ue-he+1,xe=Ue;xe<ce;Te++,xe++){let $=Number.MIN_SAFE_INTEGER,ue=!1;xe<=rt&&($=oe(re,N,Ve,H,K,_,xe,be,he,z[Ce-1][Te-1]===0,et));let Ie=0;$!==Number.MAX_SAFE_INTEGER&&(ue=!0,Ie=$+j[Ce-1][Te-1]);const Le=xe>Ue,$e=Le?j[Ce][Te-1]+(z[Ce][Te-1]>0?-5:0):0,Ke=xe>Ue+1&&z[Ce][Te-1]>0,Ze=Ke?j[Ce][Te-2]+(z[Ce][Te-2]>0?-5:0):0;if(Ke&&(!Le||Ze>=$e)&&(!ue||Ze>=Ie))j[Ce][Te]=Ze,de[Ce][Te]=3,z[Ce][Te]=0;else if(Le&&(!ue||$e>=Ie))j[Ce][Te]=$e,de[Ce][Te]=2,z[Ce][Te]=0;else if(ue)j[Ce][Te]=Ie,de[Ce][Te]=1,z[Ce][Te]=z[Ce-1][Te-1]+1;else throw new Error("not possible")}}if(V&&J(re,H,K,he),!et[0]&&!we.firstMatchCanBeWeak)return;Ce--,Te--;const Qe=[j[Ce][Te],he];let nt=0,st=0;for(;Ce>=1;){let Ue=Te;do{const rt=de[Ce][Ue];if(rt===3)Ue=Ue-2;else if(rt===2)Ue=Ue-1;else break}while(Ue>=1);nt>1&&N[H+Ce-1]===_[he+Te-1]&&!Q(Ue+he-1,K,_)&&nt+1>z[Ce][Ue]&&(Ue=Te),Ue===Te?nt++:nt=1,st||(st=Ue),Ce--,Te=Ue-1,Qe.push(Te)}be===Ae&&we.boostFullMatch&&(Qe[0]+=2);const ht=st-Ae;return Qe[0]-=ht,Qe}e.fuzzyScore=ke;function Oe(re,N,H,K,_,he){let we=re-1,Ae=N-1;for(;we>=H&&Ae>=K;)_[we]===he[Ae]&&(U[we]=Ae,we--),Ae--}function oe(re,N,H,K,_,he,we,Ae,be,Ce,Te){if(N[H]!==he[we])return Number.MIN_SAFE_INTEGER;let Ve=1,xe=!1;return we===H-K?Ve=re[H]===_[we]?7:5:Q(we,_,he)&&(we===0||!Q(we-1,_,he))?(Ve=re[H]===_[we]?7:5,xe=!0):te(he,we)&&(we===0||!te(he,we-1))?Ve=5:(te(he,we-1)||ee(he,we-1))&&(Ve=5,xe=!0),Ve>1&&H===K&&(Te[0]=!0),xe||(xe=Q(we,_,he)||te(he,we-1)||ee(he,we-1)),H===K?we>be&&(Ve-=xe?3:5):Ce?Ve+=xe?2:0:Ve+=xe?0:1,we+1===Ae&&(Ve-=xe?3:5),Ve}function ae(re,N,H,K,_,he,we){return Z(re,N,H,K,_,he,!0,we)}e.fuzzyScoreGracefulAggressive=ae;function fe(re,N,H,K,_,he,we){return Z(re,N,H,K,_,he,!1,we)}e.fuzzyScoreGraceful=fe;function Z(re,N,H,K,_,he,we,Ae){let be=ke(re,N,H,K,_,he,Ae);if(be&&!we)return be;if(re.length>=3){const Ce=Math.min(7,re.length-1);for(let Te=H+1;Te<Ce;Te++){const Ve=le(re,Te);if(Ve){const xe=ke(Ve,Ve.toLowerCase(),H,K,_,he,Ae);xe&&(xe[0]-=3,(!be||xe[0]>be[0])&&(be=xe))}}}return be}function le(re,N){if(N+1>=re.length)return;const H=re[N],K=re[N+1];if(H!==K)return re.slice(0,N)+K+H+re.slice(N+2)}}),define(ye[87],De([1,0,8]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function A(h){return u(h,0)}e.hash=A;function u(h,g){switch(typeof h){case"object":return h===null?R(349,g):Array.isArray(h)?S(h,g):I(h,g);case"string":return P(h,g);case"boolean":return C(h,g);case"number":return R(h,g);case"undefined":return R(937,g);default:return R(617,g)}}e.doHash=u;function R(h,g){return(g<<5)-g+h|0}e.numberHash=R;function C(h,g){return R(h?433:863,g)}function P(h,g){g=R(149417,g);for(let p=0,y=h.length;p<y;p++)g=R(h.charCodeAt(p),g);return g}e.stringHash=P;function S(h,g){return g=R(104579,g),h.reduce((p,y)=>u(y,p),g)}function I(h,g){return g=R(181387,g),Object.keys(h).sort().reduce((p,y)=>(p=P(y,p),u(h[y],p)),g)}class L{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=u(g,this.g),this.g}}e.Hasher=L;var k;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function v(h,g,p=32){const y=p-g,b=~((1<<y)-1);return(h<<g|(b&h)>>>y)>>>0}function T(h,g=0,p=h.byteLength,y=0){for(let b=0;b<p;b++)h[g+b]=y}function E(h,g,p="0"){for(;h.length<g;)h=p+h;return h}function f(h,g=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(p=>p.toString(16).padStart(2,"0")).join(""):E((h>>>0).toString(16),g/4)}e.toHexString=f;class d{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const p=g.length;if(p===0)return;const y=this.p;let b=this.r,i=this.u,o,s;for(i!==0?(o=i,s=-1,i=0):(o=g.charCodeAt(0),s=0);;){let l=o;if(c.isHighSurrogate(o))if(s+1<p){const r=g.charCodeAt(s+1);c.isLowSurrogate(r)?(s++,l=c.computeCodePoint(o,r)):l=65533}else{i=o;break}else c.isLowSurrogate(o)&&(l=65533);if(b=this.w(y,b,l),s++,s<p)o=g.charCodeAt(s);else break}this.r=b,this.u=i}w(g,p,y){return y<128?g[p++]=y:y<2048?(g[p++]=192|(y&1984)>>>6,g[p++]=128|(y&63)>>>0):y<65536?(g[p++]=224|(y&61440)>>>12,g[p++]=128|(y&4032)>>>6,g[p++]=128|(y&63)>>>0):(g[p++]=240|(y&1835008)>>>18,g[p++]=128|(y&258048)>>>12,g[p++]=128|(y&4032)>>>6,g[p++]=128|(y&63)>>>0),p>=64&&(this.y(),p-=64,this.t+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),f(this.h)+f(this.l)+f(this.m)+f(this.n)+f(this.o)}x(){this.p[this.r++]=128,T(this.p,this.r),this.r>56&&(this.y(),T(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=d.g,p=this.q;for(let n=0;n<64;n+=4)g.setUint32(n,p.getUint32(n,!1),!1);for(let n=64;n<320;n+=4)g.setUint32(n,v(g.getUint32(n-12,!1)^g.getUint32(n-32,!1)^g.getUint32(n-56,!1)^g.getUint32(n-64,!1),1),!1);let y=this.h,b=this.l,i=this.m,o=this.n,s=this.o,l,r,m;for(let n=0;n<80;n++)n<20?(l=b&i|~b&o,r=1518500249):n<40?(l=b^i^o,r=1859775393):n<60?(l=b&i|b&o|i&o,r=2400959708):(l=b^i^o,r=3395469782),m=v(y,5)+l+s+r+g.getUint32(n*4,!1)&4294967295,s=o,o=i,i=v(b,30),b=y,y=m;this.h=this.h+y&4294967295,this.l=this.l+b&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+s&4294967295}}d.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=d}),define(ye[111],De([1,0,108,110,87,10,12,8]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,I=[S,[]];function L(z,j,de,V){if(!z||!j)return I;const X=z.length,J=j.length;if(X<J)return I;const te=z.toLowerCase();return k(j,de,J,z,te,X,V)}e.scoreFuzzy=L;function k(z,j,de,V,X,J,te){const ee=[],Q=[];for(let ve=0;ve<de;ve++){const ke=ve*J,Oe=ke-J,oe=ve>0,ae=z[ve],fe=j[ve];for(let Z=0;Z<J;Z++){const le=Z>0,re=ke+Z,N=re-1,H=Oe+Z-1,K=le?ee[N]:0,_=oe&&le?ee[H]:0,he=oe&&le?Q[H]:0;let we;!_&&oe?we=0:we=v(ae,fe,V,X,Z,he),we&&_+we>=K&&(te||oe||X.startsWith(j,Z))?(Q[re]=he+1,ee[re]=_+we):(Q[re]=S,ee[re]=K)}}const Y=[];let ie=de-1,pe=J-1;for(;ie>=0&&pe>=0;){const ve=ie*J+pe;Q[ve]===S||(Y.push(pe),ie--),pe--}return[ee[de*J-1],Y.reverse()]}function v(z,j,de,V,X,J){let te=0;if(!T(j,V[X]))return te;if(te+=1,J>0&&(te+=J*5),z===de[X]&&(te+=1),X===0)te+=8;else{const ee=E(de.charCodeAt(X-1));ee?te+=ee:(0,A.isUpper)(de.charCodeAt(X))&&J===0&&(te+=2)}return te}function T(z,j){return z===j?!0:z==="/"||z==="\\"?j==="/"||j==="\\":!1}function E(z){switch(z){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const f=[void 0,[]];function d(z,j,de=0,V=0){const X=j;return X.values&&X.values.length>1?h(z,X.values,de,V):g(z,j,de,V)}e.scoreFuzzy2=d;function h(z,j,de,V){let X=0;const J=[];for(const te of j){const[ee,Q]=g(z,te,de,V);if(typeof ee!="number")return f;X+=ee,J.push(...Q)}return[X,t(J)]}function g(z,j,de,V){const X=(0,A.fuzzyScore)(j.original,j.originalLowercase,de,z,z.toLowerCase(),V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return X?[X[0],(0,A.createMatches)(X)]:f}const p=Object.freeze({score:0}),y=1<<18,b=1<<17,i=1<<16;function o(z,j,de,V){const X=V.values?V.values:[V];return(0,u.hash)({[V.normalized]:{values:X.map(te=>({value:te.normalized,expectContiguousMatch:te.expectContiguousMatch})),label:z,description:j,allowNonContiguousMatches:de}})}function s(z,j,de,V,X){if(!z||!j.normalized)return p;const J=V.getItemLabel(z);if(!J)return p;const te=V.getItemDescription(z),ee=o(J,te,de,j),Q=X[ee];if(Q)return Q;const Y=l(J,te,V.getItemPath(z),j,de);return X[ee]=Y,Y}e.scoreItemFuzzy=s;function l(z,j,de,V,X){const J=!de||!V.containsPathSeparator;return de&&(C.isLinux?V.pathNormalized===de:(0,P.equalsIgnoreCase)(V.pathNormalized,de))?{score:y,labelMatch:[{start:0,end:z.length}],descriptionMatch:j?[{start:0,end:j.length}]:void 0}:V.values&&V.values.length>1?r(z,j,de,V.values,J,X):m(z,j,de,V,J,X)}function r(z,j,de,V,X,J){let te=0;const ee=[],Q=[];for(const Y of V){const{score:ie,labelMatch:pe,descriptionMatch:ve}=m(z,j,de,Y,X,J);if(ie===S)return p;te+=ie,pe&&ee.push(...pe),ve&&Q.push(...ve)}return{score:te,labelMatch:t(ee),descriptionMatch:t(Q)}}function m(z,j,de,V,X,J){if(X||!j){const[te,ee]=L(z,V.normalized,V.normalizedLowercase,J&&!V.expectContiguousMatch);if(te){const Q=(0,A.matchesPrefix)(V.normalized,z);let Y;return Q?(Y=b,Y+=Math.round(V.normalized.length/z.length*100)):Y=i,{score:Y+te,labelMatch:Q||n(ee)}}}if(j){let te=j;de&&(te=`${j}${R.sep}`);const ee=te.length,Q=`${te}${z}`,[Y,ie]=L(Q,V.normalized,V.normalizedLowercase,J&&!V.expectContiguousMatch);if(Y){const pe=n(ie),ve=[],ke=[];return pe.forEach(Oe=>{Oe.start<ee&&Oe.end>ee?(ve.push({start:0,end:Oe.end-ee}),ke.push({start:Oe.start,end:ee})):Oe.start>=ee?ve.push({start:Oe.start-ee,end:Oe.end-ee}):ke.push(Oe)}),{score:Y,labelMatch:ve,descriptionMatch:ke}}}return p}function n(z){const j=[];if(!z)return j;let de;for(const V of z)de&&de.end===V?de.end+=1:(de={start:V,end:V+1},j.push(de));return j}function t(z){const j=z.sort((X,J)=>X.start-J.start),de=[];let V;for(const X of j)!V||!a(V,X)?(V=X,de.push(X)):(V.start=Math.min(V.start,X.start),V.end=Math.max(V.end,X.end));return de}function a(z,j){return!(z.end<j.start||j.end<z.start)}function w(z,j,de,V,X,J){const te=s(z,de,V,X,J),ee=s(j,de,V,X,J),Q=te.score,Y=ee.score;if((Q===y||Y===y)&&Q!==Y)return Q===y?-1:1;if(Q>i||Y>i){if(Q!==Y)return Q>Y?-1:1;if(Q<b&&Y<b){const ae=F(te.labelMatch,ee.labelMatch);if(ae!==0)return ae}const Oe=X.getItemLabel(z)||"",oe=X.getItemLabel(j)||"";if(Oe.length!==oe.length)return Oe.length-oe.length}if(Q!==Y)return Q>Y?-1:1;const ie=Array.isArray(te.labelMatch)&&te.labelMatch.length>0,pe=Array.isArray(ee.labelMatch)&&ee.labelMatch.length>0;if(ie&&!pe)return-1;if(pe&&!ie)return 1;const ve=D(z,te,X),ke=D(j,ee,X);return ve&&ke&&ve!==ke?ke>ve?-1:1:x(z,j,de,X)}e.compareItemsByFuzzyScore=w;function D(z,j,de){let V=-1,X=-1;if(j.descriptionMatch&&j.descriptionMatch.length?V=j.descriptionMatch[0].start:j.labelMatch&&j.labelMatch.length&&(V=j.labelMatch[0].start),j.labelMatch&&j.labelMatch.length){if(X=j.labelMatch[j.labelMatch.length-1].end,j.descriptionMatch&&j.descriptionMatch.length){const J=de.getItemDescription(z);J&&(X+=J.length)}}else j.descriptionMatch&&j.descriptionMatch.length&&(X=j.descriptionMatch[j.descriptionMatch.length-1].end);return X-V}function F(z,j){if(!z&&!j||(!z||!z.length)&&(!j||!j.length))return 0;if(!j||!j.length)return-1;if(!z||!z.length)return 1;const de=z[0].start,X=z[z.length-1].end-de,J=j[0].start,ee=j[j.length-1].end-J;return X===ee?0:ee<X?1:-1}function x(z,j,de,V){const X=V.getItemLabel(z)||"",J=V.getItemLabel(j)||"",te=V.getItemDescription(z),ee=V.getItemDescription(j),Q=X.length+(te?te.length:0),Y=J.length+(ee?ee.length:0);if(Q!==Y)return Q-Y;const ie=V.getItemPath(z),pe=V.getItemPath(j);return ie&&pe&&ie.length!==pe.length?ie.length-pe.length:X!==J?(0,c.compareAnything)(X,J,de.normalized):te&&ee&&te!==ee?(0,c.compareAnything)(te,ee,de.normalized):ie&&pe&&ie!==pe?(0,c.compareAnything)(ie,pe,de.normalized):0}function q(z){return z.startsWith('"')&&z.endsWith('"')}const M=" ";function B(z){typeof z!="string"&&(z="");const j=z.toLowerCase(),{pathNormalized:de,normalized:V,normalizedLowercase:X}=O(z),J=de.indexOf(R.sep)>=0,te=q(z);let ee;const Q=z.split(M);if(Q.length>1)for(const Y of Q){const ie=q(Y),{pathNormalized:pe,normalized:ve,normalizedLowercase:ke}=O(Y);ve&&(ee||(ee=[]),ee.push({original:Y,originalLowercase:Y.toLowerCase(),pathNormalized:pe,normalized:ve,normalizedLowercase:ke,expectContiguousMatch:ie}))}return{original:z,originalLowercase:j,pathNormalized:de,normalized:V,normalizedLowercase:X,values:ee,containsPathSeparator:J,expectContiguousMatch:te}}e.prepareQuery=B;function O(z){let j;C.isWindows?j=z.replace(/\//g,R.sep):j=z.replace(/\\/g,R.sep);const de=(0,P.stripWildcards)(j).replace(/\s|"/g,"");return{pathNormalized:j,normalized:de,normalizedLowercase:de.toLowerCase()}}function U(z){return Array.isArray(z)?B(z.map(j=>j.original).join(M)):B(z.original)}e.pieceToQuery=U}),define(ye[163],De([1,0,110,8,51]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const R="$(",C=new RegExp(`\\$\\(${u.ThemeIcon.iconNameExpression}(?:${u.ThemeIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(`(\\\\)?${C.source}`,"g");function S(h){return h.replace(P,(g,p)=>p?g:`\\${g}`)}e.escapeIcons=S;const I=new RegExp(`\\\\${C.source}`,"g");function L(h){return h.replace(I,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=L;const k=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function v(h){return h.indexOf(R)===-1?h:h.replace(k,(g,p,y,b)=>y?g:p||b||"")}e.stripIcons=v;function T(h){return h?h.replace(/\$\((.*?)\)/g,(g,p)=>` ${p} `).trim():""}e.getCodiconAriaLabel=T;const E=new RegExp(`\\$\\(${u.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(h){E.lastIndex=0;let g="";const p=[];let y=0;for(;;){const b=E.lastIndex,i=E.exec(h),o=h.substring(b,i?.index);if(o.length>0){g+=o;for(let s=0;s<o.length;s++)p.push(y)}if(!i)break;y+=i[0].length}return{text:g,iconOffsets:p}}e.parseLabelWithIcons=f;function d(h,g,p=!1){const{text:y,iconOffsets:b}=g;if(!b||b.length===0)return(0,c.matchesFuzzy)(h,y,p);const i=(0,A.ltrim)(y," "),o=y.length-i.length,s=(0,c.matchesFuzzy)(h,i,p);if(s)for(const l of s){const r=b[l.start+o]+o;l.start+=r,l.end+=r}return s}e.matchesFuzzyIconAware=d}),define(ye[37],De([1,0,8]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(u){u[u.Ignore=0]="Ignore",u[u.Info=1]="Info",u[u.Warning=2]="Warning",u[u.Error=3]="Error"})(A||(A={})),function(u){const R="error",C="warning",P="warn",S="info",I="ignore";function L(v){return v?c.equalsIgnoreCase(R,v)?u.Error:c.equalsIgnoreCase(C,v)||c.equalsIgnoreCase(P,v)?u.Warning:c.equalsIgnoreCase(S,v)?u.Info:u.Ignore:u.Ignore}u.fromValue=L;function k(v){switch(v){case u.Error:return R;case u.Warning:return C;case u.Info:return S;default:return I}}u.toString=k}(A||(A={})),e.default=A}),define(ye[68],De([1,0,15,8]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class u{constructor(){this.b="",this.c=0}reset(T){return this.b=T,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(T){const E=T.charCodeAt(0),f=this.b.charCodeAt(this.c);return E-f}value(){return this.b[this.c]}}e.StringIterator=u;class R{constructor(T=!0){this.e=T}reset(T){return this.b=T,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let T=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(T)this.c++;else break;else T=!1;return this}cmp(T){return this.e?(0,A.compareSubstring)(T,this.b,0,T.length,this.c,this.d):(0,A.compareSubstringIgnoreCase)(T,this.b,0,T.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class C{constructor(T=!0,E=!0){this.f=T,this.g=E}reset(T){this.d=0,this.e=0,this.b=T,this.c=T.length;for(let E=T.length-1;E>=0;E--,this.c--){const f=this.b.charCodeAt(E);if(!(f===47||this.f&&f===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let T=!0;for(;this.e<this.c;this.e++){const E=this.b.charCodeAt(this.e);if(E===47||this.f&&E===92)if(T)this.d++;else break;else T=!1}return this}cmp(T){return this.g?(0,A.compareSubstring)(T,this.b,0,T.length,this.d,this.e):(0,A.compareSubstringIgnoreCase)(T,this.b,0,T.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=C;var P;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(P||(P={}));class S{constructor(T,E){this.f=T,this.g=E,this.d=[],this.e=0}reset(T){return this.c=T,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(T)),this.b.reset(T.path),this.b.value()&&this.d.push(3)),this.g(T)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(T){if(this.d[this.e]===1)return(0,A.compareIgnoreCase)(T,this.c.scheme);if(this.d[this.e]===2)return(0,A.compareIgnoreCase)(T,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(T);if(this.d[this.e]===4)return(0,A.compare)(T,this.c.query);if(this.d[this.e]===5)return(0,A.compare)(T,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=S;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const T=this.right;return this.right=T.left,T.left=this,this.updateHeight(),T.updateHeight(),T}rotateRight(){const T=this.left;return this.left=T.right,T.right=this,this.updateHeight(),T.updateHeight(),T}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(L||(L={}));class k{static forUris(T=()=>!1,E=()=>!1){return new k(new S(T,E))}static forPaths(T=!1){return new k(new C(void 0,!T))}static forStrings(){return new k(new u)}static forConfigKeys(){return new k(new R)}constructor(T){this.b=T}clear(){this.c=void 0}fill(T,E){if(E){const f=E.slice(0);(0,c.shuffle)(f);for(const d of f)this.set(d,T)}else{const f=T.slice(0);(0,c.shuffle)(f);for(const d of f)this.set(d[0],d[1])}}set(T,E){const f=this.b.reset(T);let d;this.c||(this.c=new I,this.c.segment=f.value());const h=[];for(d=this.c;;){const p=f.cmp(d.segment);if(p>0)d.left||(d.left=new I,d.left.segment=f.value()),h.push([-1,d]),d=d.left;else if(p<0)d.right||(d.right=new I,d.right.segment=f.value()),h.push([1,d]),d=d.right;else if(f.hasNext())f.next(),d.mid||(d.mid=new I,d.mid.segment=f.value()),h.push([0,d]),d=d.mid;else break}const g=d.value;d.value=E,d.key=T;for(let p=h.length-1;p>=0;p--){const y=h[p][1];y.updateHeight();const b=y.balanceFactor();if(b<-1||b>1){const i=h[p][0],o=h[p+1][0];if(i===1&&o===1)h[p][1]=y.rotateLeft();else if(i===-1&&o===-1)h[p][1]=y.rotateRight();else if(i===1&&o===-1)y.right=h[p+1][1]=h[p+1][1].rotateRight(),h[p][1]=y.rotateLeft();else if(i===-1&&o===1)y.left=h[p+1][1]=h[p+1][1].rotateLeft(),h[p][1]=y.rotateRight();else throw new Error;if(p>0)switch(h[p-1][0]){case-1:h[p-1][1].left=h[p][1];break;case 1:h[p-1][1].right=h[p][1];break;case 0:h[p-1][1].mid=h[p][1];break}else this.c=h[0][1]}}return g}get(T){return this.d(T)?.value}d(T){const E=this.b.reset(T);let f=this.c;for(;f;){const d=E.cmp(f.segment);if(d>0)f=f.left;else if(d<0)f=f.right;else if(E.hasNext())E.next(),f=f.mid;else break}return f}has(T){const E=this.d(T);return!(E?.value===void 0&&E?.mid===void 0)}delete(T){return this.e(T,!1)}deleteSuperstr(T){return this.e(T,!0)}e(T,E){const f=this.b.reset(T),d=[];let h=this.c;for(;h;){const g=f.cmp(h.segment);if(g>0)d.push([-1,h]),h=h.left;else if(g<0)d.push([1,h]),h=h.right;else if(f.hasNext())f.next(),d.push([0,h]),h=h.mid;else break}if(!!h){if(E?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const g=this.f(h.right);if(g.key){const{key:p,value:y,segment:b}=g;this.e(g.key,!1),h.key=p,h.value=y,h.segment=b}}else{const g=h.left??h.right;if(d.length>0){const[p,y]=d[d.length-1];switch(p){case-1:y.left=g;break;case 0:y.mid=g;break;case 1:y.right=g;break}}else this.c=g}for(let g=d.length-1;g>=0;g--){const p=d[g][1];p.updateHeight();const y=p.balanceFactor();if(y>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),d[g][1]=p.rotateLeft()):y<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),d[g][1]=p.rotateRight()),g>0)switch(d[g-1][0]){case-1:d[g-1][1].left=d[g][1];break;case 1:d[g-1][1].right=d[g][1];break;case 0:d[g-1][1].mid=d[g][1];break}else this.c=d[0][1]}}}f(T){for(;T.left;)T=T.left;return T}findSubstr(T){const E=this.b.reset(T);let f=this.c,d;for(;f;){const h=E.cmp(f.segment);if(h>0)f=f.left;else if(h<0)f=f.right;else if(E.hasNext())E.next(),d=f.value||d,f=f.mid;else break}return f&&f.value||d}findSuperstr(T){return this.g(T,!1)}g(T,E){const f=this.b.reset(T);let d=this.c;for(;d;){const h=f.cmp(d.segment);if(h>0)d=d.left;else if(h<0)d=d.right;else if(f.hasNext())f.next(),d=d.mid;else return d.mid?this.h(d.mid):E?d.value:void 0}}hasElementOrSubtree(T){return this.g(T,!0)!==void 0}forEach(T){for(const[E,f]of this)T(f,E)}*[Symbol.iterator](){yield*this.h(this.c)}h(T){const E=[];return this.j(T,E),E[Symbol.iterator]()}j(T,E){!T||(T.left&&this.j(T.left,E),T.value&&E.push([T.key,T.value]),T.mid&&this.j(T.mid,E),T.right&&this.j(T.right,E))}_isBalanced(){const T=E=>{if(!E)return!0;const f=E.balanceFactor();return f<-1||f>1?!1:T(E.left)&&T(E.right)};return T(this.c)}}e.TernarySearchTree=k}),define(ye[2],De([1,0,10,12]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const u=/^\w[\w\d+.-]*$/,R=/^\//,C=/^\/\//;function P(s,l){if(!s.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!u.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!R.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(s,l){return!s&&!l?"file":s}function I(s,l){switch(s){case"https":case"http":case"file":l?l[0]!==k&&(l=k+l):l=k;break}return l}const L="",k="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class T{static isUri(l){return l instanceof T?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}constructor(l,r,m,n,t,a=!1){typeof l=="object"?(this.scheme=l.scheme||L,this.authority=l.authority||L,this.path=l.path||L,this.query=l.query||L,this.fragment=l.fragment||L):(this.scheme=S(l,a),this.authority=r||L,this.path=I(this.scheme,m||L),this.query=n||L,this.fragment=t||L,P(this,a))}get fsPath(){return p(this,!1)}with(l){if(!l)return this;let{scheme:r,authority:m,path:n,query:t,fragment:a}=l;return r===void 0?r=this.scheme:r===null&&(r=L),m===void 0?m=this.authority:m===null&&(m=L),n===void 0?n=this.path:n===null&&(n=L),t===void 0?t=this.query:t===null&&(t=L),a===void 0?a=this.fragment:a===null&&(a=L),r===this.scheme&&m===this.authority&&n===this.path&&t===this.query&&a===this.fragment?this:new f(r,m,n,t,a)}static parse(l,r=!1){const m=v.exec(l);return m?new f(m[2]||L,o(m[4]||L),o(m[5]||L),o(m[7]||L),o(m[9]||L),r):new f(L,L,L,L,L)}static file(l){let r=L;if(A.isWindows&&(l=l.replace(/\\/g,k)),l[0]===k&&l[1]===k){const m=l.indexOf(k,2);m===-1?(r=l.substring(2),l=k):(r=l.substring(2,m),l=l.substring(m)||k)}return new f("file",r,l,L,L)}static from(l){const r=new f(l.scheme,l.authority,l.path,l.query,l.fragment);return P(r,!0),r}static joinPath(l,...r){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return A.isWindows&&l.scheme==="file"?m=T.file(c.win32.join(p(l,!0),...r)).path:m=c.posix.join(l.path,...r),l.with({path:m})}toString(l=!1){return y(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof T)return l;{const r=new f(l);return r._formatted=l.external,r._fsPath=l._sep===E?l.fsPath:null,r}}else return l}}e.URI=T;const E=A.isWindows?1:void 0;class f extends T{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(l=!1){return l?y(this,!0):(this._formatted||(this._formatted=y(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=E),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(s,l,r){let m,n=-1;for(let t=0;t<s.length;t++){const a=s.charCodeAt(t);if(a>=97&&a<=122||a>=65&&a<=90||a>=48&&a<=57||a===45||a===46||a===95||a===126||l&&a===47||r&&a===91||r&&a===93||r&&a===58)n!==-1&&(m+=encodeURIComponent(s.substring(n,t)),n=-1),m!==void 0&&(m+=s.charAt(t));else{m===void 0&&(m=s.substr(0,t));const w=d[a];w!==void 0?(n!==-1&&(m+=encodeURIComponent(s.substring(n,t)),n=-1),m+=w):n===-1&&(n=t)}}return n!==-1&&(m+=encodeURIComponent(s.substring(n))),m!==void 0?m:s}function g(s){let l;for(let r=0;r<s.length;r++){const m=s.charCodeAt(r);m===35||m===63?(l===void 0&&(l=s.substr(0,r)),l+=d[m]):l!==void 0&&(l+=s[r])}return l!==void 0?l:s}function p(s,l){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?l?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,A.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=p;function y(s,l){const r=l?g:h;let m="",{scheme:n,authority:t,path:a,query:w,fragment:D}=s;if(n&&(m+=n,m+=":"),(t||n==="file")&&(m+=k,m+=k),t){let F=t.indexOf("@");if(F!==-1){const x=t.substr(0,F);t=t.substr(F+1),F=x.lastIndexOf(":"),F===-1?m+=r(x,!1,!1):(m+=r(x.substr(0,F),!1,!1),m+=":",m+=r(x.substr(F+1),!1,!0)),m+="@"}t=t.toLowerCase(),F=t.lastIndexOf(":"),F===-1?m+=r(t,!1,!0):(m+=r(t.substr(0,F),!1,!0),m+=t.substr(F))}if(a){if(a.length>=3&&a.charCodeAt(0)===47&&a.charCodeAt(2)===58){const F=a.charCodeAt(1);F>=65&&F<=90&&(a=`/${String.fromCharCode(F+32)}:${a.substr(3)}`)}else if(a.length>=2&&a.charCodeAt(1)===58){const F=a.charCodeAt(0);F>=65&&F<=90&&(a=`${String.fromCharCode(F+32)}:${a.substr(2)}`)}m+=r(a,!0,!1)}return w&&(m+="?",m+=r(w,!1,!1)),D&&(m+="#",m+=l?D:h(D,!1,!1)),m}function b(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+b(s.substr(3)):s}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(s){return s.match(i)?s.replace(i,l=>b(l)):s}}),define(ye[69],De([1,0,22,8,2]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(I){return JSON.stringify(I,P)}e.stringify=R;function C(I){let L=JSON.parse(I);return L=S(L),L}e.parse=C;function P(I,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,A.regExpFlags)(L)}:L}function S(I,L=0){if(!I||L>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return u.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 16:return new Date(I.source)}if(I instanceof c.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let k=0;k<I.length;++k)I[k]=S(I[k],L+1);else for(const k in I)Object.hasOwnProperty.call(I,k)&&(I[k]=S(I[k],L+1))}return I}e.revive=S}),define(ye[18],De([1,0,11,12,2]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.vscodeUserData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls",I.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(L){this.d=L}setDelegate(L){this.e=L}setServerRootPath(L){this.f=`${L}/${R.vscodeRemoteResource}`}set(L,k,v){this.a[L]=k,this.b[L]=v}setConnectionToken(L,k){this.c[L]=k}getPreferredWebSchema(){return this.d}rewrite(L){if(this.e)try{return this.e(L)}catch(d){return c.onUnexpectedError(d),L}const k=L.authority;let v=this.a[k];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const T=this.b[k],E=this.c[k];let f=`path=${encodeURIComponent(L.path)}`;return typeof E=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(E)}`),u.URI.from({scheme:A.isWeb?this.d:R.vscodeRemoteResource,authority:`${v}:${T}`,path:this.f,query:f})}}e.RemoteAuthorities=new C,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(L){const k=this.b(L,ne);return this.uriToBrowserUri(k)}uriToBrowserUri(L){return L.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===R.file&&(A.isNative||A.isWebWorker&&A.globals.origin===`${R.vscodeFileResource}://${P.a}`)?L.with({scheme:R.vscodeFileResource,authority:L.authority||P.a,query:null,fragment:null}):L}asFileUri(L){const k=this.b(L,ne);return this.uriToFileUri(k)}uriToFileUri(L){return L.scheme===R.vscodeFileResource?L.with({scheme:R.file,authority:L.authority!==P.a?L.authority:null,query:null,fragment:null}):L}b(L,k){return u.URI.isUri(L)?L:u.URI.parse(k.toUrl(L))}}P.a="vscode-app",e.FileAccess=new P;var S;(function(I){const L=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);I.CoopAndCoep=Object.freeze(L.get("3"));const k="vscode-coi";function v(E){let f;typeof E=="string"?f=new URL(E).searchParams:E instanceof URL?f=E.searchParams:u.URI.isUri(E)&&(f=new URL(E.toString(!0)).searchParams);const d=f?.get(k);if(!!d)return L.get(d)}I.getHeadersFromQuery=v;function T(E,f,d){if(!globalThis.crossOriginIsolated)return;const h=f&&d?"3":d?"2":"1";E instanceof URLSearchParams?E.set(k,h):E[k]=h}I.addSearchParam=T})(S=e.COI||(e.COI={}))}),define(ye[24],De([1,0,33,18,10,12,8,2]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(T){return(0,P.uriToFsPath)(T,!0)}e.originalFSPath=S;class I{constructor(E){this.a=E}compare(E,f,d=!1){return E===f?0:(0,C.compare)(this.getComparisonKey(E,d),this.getComparisonKey(f,d))}isEqual(E,f,d=!1){return E===f?!0:!E||!f?!1:this.getComparisonKey(E,d)===this.getComparisonKey(f,d)}getComparisonKey(E,f=!1){return E.with({path:this.a(E)?E.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(E){return this.a(E)}isEqualOrParent(E,f,d=!1){if(E.scheme===f.scheme){if(E.scheme===A.Schemas.file)return c.isEqualOrParent(S(E),S(f),this.a(E))&&E.query===f.query&&(d||E.fragment===f.fragment);if((0,e.isEqualAuthority)(E.authority,f.authority))return c.isEqualOrParent(E.path,f.path,this.a(E),"/")&&E.query===f.query&&(d||E.fragment===f.fragment)}return!1}joinPath(E,...f){return P.URI.joinPath(E,...f)}basenameOrAuthority(E){return(0,e.basename)(E)||E.authority}basename(E){return u.posix.basename(E.path)}extname(E){return u.posix.extname(E.path)}dirname(E){if(E.path.length===0)return E;let f;return E.scheme===A.Schemas.file?f=P.URI.file(u.dirname(S(E))).path:(f=u.posix.dirname(E.path),E.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${E.toString})) resulted in a relative path`),f="/")),E.with({path:f})}normalizePath(E){if(!E.path.length)return E;let f;return E.scheme===A.Schemas.file?f=P.URI.file(u.normalize(S(E))).path:f=u.posix.normalize(E.path),E.with({path:f})}relativePath(E,f){if(E.scheme!==f.scheme||!(0,e.isEqualAuthority)(E.authority,f.authority))return;if(E.scheme===A.Schemas.file){const g=u.relative(S(E),S(f));return R.isWindows?c.toSlashes(g):g}let d=E.path||"/";const h=f.path||"/";if(this.a(E)){let g=0;for(const p=Math.min(d.length,h.length);g<p&&!(d.charCodeAt(g)!==h.charCodeAt(g)&&d.charAt(g).toLowerCase()!==h.charAt(g).toLowerCase());g++);d=h.substr(0,g)+d.substr(g)}return u.posix.relative(d,h)}resolvePath(E,f){if(E.scheme===A.Schemas.file){const d=P.URI.file(u.resolve(S(E),f));return E.with({authority:d.authority,path:d.path})}return f=c.toPosixPath(f),E.with({path:u.posix.resolve(E.path,f)})}isAbsolutePath(E){return!!E.path&&E.path[0]==="/"}isEqualAuthority(E,f){return E===f||E!==void 0&&f!==void 0&&(0,C.equalsIgnoreCase)(E,f)}hasTrailingPathSeparator(E,f=u.sep){if(E.scheme===A.Schemas.file){const d=S(E);return d.length>c.getRoot(d).length&&d[d.length-1]===f}else{const d=E.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(E.fsPath)}}removeTrailingPathSeparator(E,f=u.sep){return(0,e.hasTrailingPathSeparator)(E,f)?E.with({path:E.path.substr(0,E.path.length-1)}):E}addTrailingPathSeparator(E,f=u.sep){let d=!1;if(E.scheme===A.Schemas.file){const h=S(E);d=h!==void 0&&h.length===c.getRoot(h).length&&h[h.length-1]===f}else{f="/";const h=E.path;d=h.length===1&&h.charCodeAt(h.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(E,f)?E.with({path:E.path+"/"}):E}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(T=>T.scheme===A.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new I(T=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(T,E){const f=[];for(let d=0;d<T.length;d++){const h=E(T[d]);T.some((g,p)=>p===d?!1:(0,e.isEqualOrParent)(h,E(g)))||f.push(T[d])}return f}e.distinctParents=L;var k;(function(T){T.META_DATA_LABEL="label",T.META_DATA_DESCRIPTION="description",T.META_DATA_SIZE="size",T.META_DATA_MIME="mime";function E(f){const d=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(p=>{const[y,b]=p.split(":");y&&b&&d.set(y,b)});const g=f.path.substring(0,f.path.indexOf(";"));return g&&d.set(T.META_DATA_MIME,g),d}T.parseMetaData=E})(k=e.DataUri||(e.DataUri={}));function v(T,E,f){if(E){let d=T.path;return d&&d[0]!==u.posix.sep&&(d=u.posix.sep+d),T.with({scheme:f,authority:E,path:d})}return T.with({scheme:f})}e.toLocalResource=v}),define(ye[19],De([1,0,21,11,3,6,24,12,148]),function(ne,e,c,A,u,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(Y){return!!Y&&typeof Y.then=="function"}e.isThenable=I;function L(Y){const ie=new c.CancellationTokenSource,pe=Y(ie.token),ve=new Promise((ke,Oe)=>{const oe=ie.token.onCancellationRequested(()=>{oe.dispose(),ie.dispose(),Oe(new A.CancellationError)});Promise.resolve(pe).then(ae=>{oe.dispose(),ie.dispose(),ke(ae)},ae=>{oe.dispose(),ie.dispose(),Oe(ae)})});return new class{cancel(){ie.cancel()}then(ke,Oe){return ve.then(ke,Oe)}catch(ke){return this.then(void 0,ke)}finally(ke){return ve.finally(ke)}}}e.createCancelablePromise=L;function k(Y,ie,pe){return new Promise((ve,ke)=>{const Oe=ie.onCancellationRequested(()=>{Oe.dispose(),ve(pe)});Y.then(ve,ke).finally(()=>Oe.dispose())})}e.raceCancellation=k;function v(Y,ie){return new Promise((pe,ve)=>{const ke=ie.onCancellationRequested(()=>{ke.dispose(),ve(new A.CancellationError)});Y.then(pe,ve).finally(()=>ke.dispose())})}e.raceCancellationError=v;async function T(Y){let ie=-1;const pe=Y.map((ke,Oe)=>ke.then(oe=>(ie=Oe,oe))),ve=await Promise.race(pe);return Y.forEach((ke,Oe)=>{Oe!==ie&&ke.cancel()}),ve}e.raceCancellablePromises=T;function E(Y,ie,pe){let ve;const ke=setTimeout(()=>{ve?.(void 0),pe?.()},ie);return Promise.race([Y.finally(()=>clearTimeout(ke)),new Promise(Oe=>ve=Oe)])}e.raceTimeout=E;function f(Y){return new Promise((ie,pe)=>{const ve=Y();I(ve)?ve.then(ie,pe):ie(ve)})}e.asPromise=f;class d{constructor(){this.a=null,this.b=null,this.d=null}queue(ie){if(this.a){if(this.d=ie,!this.b){const pe=()=>{this.b=null;const ve=this.queue(this.d);return this.d=null,ve};this.b=new Promise(ve=>{this.a.then(pe,pe).then(ve)})}return new Promise((pe,ve)=>{this.b.then(pe,ve)})}return this.a=ie(),new Promise((pe,ve)=>{this.a.then(ke=>{this.a=null,pe(ke)},ke=>{this.a=null,ve(ke)})})}}e.Throttler=d;class h{constructor(){this.a=Promise.resolve(null)}queue(ie){return this.a=this.a.then(()=>ie(),()=>ie())}}e.Sequencer=h;class g{constructor(){this.a=new Map}queue(ie,pe){const ke=(this.a.get(ie)??Promise.resolve()).catch(()=>{}).then(pe).finally(()=>{this.a.get(ie)===ke&&this.a.delete(ie)});return this.a.set(ie,ke),ke}}e.SequencerByKey=g;const p=(Y,ie)=>{let pe=!0;const ve=setTimeout(()=>{pe=!1,ie()},Y);return{isTriggered:()=>pe,dispose:()=>{clearTimeout(ve),pe=!1}}},y=Y=>{let ie=!0;return queueMicrotask(()=>{ie&&(ie=!1,Y())}),{isTriggered:()=>ie,dispose:()=>{ie=!1}}};class b{constructor(ie){this.defaultDelay=ie,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ie,pe=this.defaultDelay){this.g=ie,this.h(),this.b||(this.b=new Promise((ke,Oe)=>{this.d=ke,this.f=Oe}).then(()=>{if(this.b=null,this.d=null,this.g){const ke=this.g;return this.g=null,ke()}}));const ve=()=>{this.a=null,this.d?.(null)};return this.a=pe===S.MicrotaskDelay?y(ve):p(pe,ve),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=b;class i{constructor(ie){this.a=new b(ie),this.b=new d}trigger(ie,pe){return this.a.trigger(()=>this.b.queue(ie),pe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=i;class o{constructor(){this.a=!1,this.b=new Promise((ie,pe)=>{this.d=ie})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=o;class s extends o{constructor(ie){super(),this.f=setTimeout(()=>this.open(),ie)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=s;function l(Y,ie){return ie?new Promise((pe,ve)=>{const ke=setTimeout(()=>{Oe.dispose(),pe()},Y),Oe=ie.onCancellationRequested(()=>{clearTimeout(ke),Oe.dispose(),ve(new A.CancellationError)})}):L(pe=>l(Y,pe))}e.timeout=l;function r(Y,ie=0){const pe=setTimeout(Y,ie);return(0,R.toDisposable)(()=>clearTimeout(pe))}e.disposableTimeout=r;function m(Y){const ie=[];let pe=0;const ve=Y.length;function ke(){return pe<ve?Y[pe++]():null}function Oe(oe){oe!=null&&ie.push(oe);const ae=ke();return ae?ae.then(Oe):Promise.resolve(ie)}return Promise.resolve(null).then(Oe)}e.sequence=m;function n(Y,ie=ve=>!!ve,pe=null){let ve=0;const ke=Y.length,Oe=()=>{if(ve>=ke)return Promise.resolve(pe);const oe=Y[ve++];return Promise.resolve(oe()).then(fe=>ie(fe)?Promise.resolve(fe):Oe())};return Oe()}e.first=n;function t(Y,ie=ve=>!!ve,pe=null){if(Y.length===0)return Promise.resolve(pe);let ve=Y.length;const ke=()=>{ve=-1;for(const Oe of Y)Oe.cancel?.()};return new Promise((Oe,oe)=>{for(const ae of Y)ae.then(fe=>{--ve>=0&&ie(fe)?(ke(),Oe(fe)):ve===0&&Oe(pe)}).catch(fe=>{--ve>=0&&(ke(),oe(fe))})})}e.firstParallel=t;class a{constructor(ie){this.a=0,this.d=ie,this.f=[],this.b=0,this.g=new u.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(ie){return this.a++,new Promise((pe,ve)=>{this.f.push({factory:ie,c:pe,e:ve}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ie=this.f.shift();this.b++;const pe=ie.factory();pe.then(ie.c,ie.e),pe.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=a;class w extends a{constructor(){super(1)}}e.Queue=w;class D{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const ie=new V;return this.b.add(ie),ie.p}d(){for(const[,ie]of this.a)if(ie.size>0)return!1;return!0}queueFor(ie,pe=C.extUri){const ve=pe.getComparisonKey(ie);let ke=this.a.get(ve);return ke||(ke=new w,u.Event.once(ke.onDrained)(()=>{ke?.dispose(),this.a.delete(ve),this.f()}),this.a.set(ve,ke)),ke}f(){!this.d()||this.g()}g(){for(const ie of this.b)ie.complete();this.b.clear()}dispose(){for(const[,ie]of this.a)ie.dispose();this.a.clear(),this.g()}}e.ResourceQueue=D;class F{constructor(ie,pe){this.a=-1,typeof ie=="function"&&typeof pe=="number"&&this.setIfNotSet(ie,pe)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ie,pe){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ie()},pe)}setIfNotSet(ie,pe){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ie()},pe))}}e.TimeoutTimer=F;class x{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(ie,pe){this.cancel(),this.a=setInterval(()=>{ie()},pe)}}e.IntervalTimer=x;class q{constructor(ie,pe){this.b=-1,this.a=ie,this.d=pe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ie=this.d){this.cancel(),this.b=setTimeout(this.f,ie)}get delay(){return this.d}set delay(ie){this.d=ie}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=q;class M{constructor(ie,pe){pe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${pe}ms is not a multiple of 1000ms.`),this.a=ie,this.b=pe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ie=this.b){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ie/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=M;class B extends q{constructor(ie,pe){super(ie,pe),this.j=[]}work(ie){this.j.push(ie),this.isScheduled()||this.schedule()}h(){const ie=this.j;this.j=[],this.a?.(ie)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=B;class O extends R.Disposable{constructor(ie,pe){super(),this.g=ie,this.h=pe,this.a=[],this.b=this.B(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(ie){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ie.length>this.g.maxBufferedWork)return!1}else if(this.pending+ie.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const pe of ie)this.a.push(pe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Y=>{(0,P.setTimeout0)(()=>{if(ie)return;const pe=Date.now()+15;Y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e.runWhenIdle=(Y,ie)=>{const pe=requestIdleCallback(Y,typeof ie=="number"?{timeout:ie}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,cancelIdleCallback(pe))}}}}();class U{constructor(ie){this.d=!1,this.a=()=>{try{this.f=ie()}catch(pe){this.g=pe}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=U;async function z(Y,ie,pe){let ve;for(let ke=0;ke<pe;ke++)try{return await Y()}catch(Oe){ve=Oe,await l(ie)}throw ve}e.retry=z;class j{hasPending(ie){return this.a?typeof ie=="number"?this.a.taskId===ie:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(ie,pe,ve){return this.a={taskId:ie,cancel:()=>ve?.(),promise:pe},pe.then(()=>this.d(ie),()=>this.d(ie)),pe}d(ie){this.a&&ie===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ie=this.b;this.b=void 0,ie.run().then(ie.promiseResolve,ie.promiseReject)}}setNext(ie){if(this.b)this.b.run=ie;else{let pe,ve;const ke=new Promise((Oe,oe)=>{pe=Oe,ve=oe});this.b={run:ie,promise:ke,promiseResolve:pe,promiseReject:ve}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=j;class de{constructor(ie,pe=()=>Date.now()){this.d=ie,this.f=pe,this.a=0,this.b=0}increment(){const ie=this.f();return ie-this.a>this.d&&(this.a=ie,this.b=0),this.b++,this.b}}e.IntervalCounter=de;class V{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((ie,pe)=>{this.a=ie,this.b=pe})}complete(ie){return new Promise(pe=>{this.a(ie),this.f=!0,pe()})}error(ie){return new Promise(pe=>{this.b(ie),this.d=!0,pe()})}cancel(){new Promise(ie=>{this.b(new A.CancellationError),this.d=!0,ie()})}}e.DeferredPromise=V;var X;(function(Y){async function ie(ve){let ke;const Oe=await Promise.all(ve.map(oe=>oe.then(ae=>ae,ae=>{ke||(ke=ae)})));if(typeof ke<"u")throw ke;return Oe}Y.settled=ie;function pe(ve){return new Promise(async(ke,Oe)=>{try{await ve(ke,Oe)}catch(oe){Oe(oe)}})}Y.withAsyncBody=pe})(X=e.Promises||(e.Promises={}));var J;(function(Y){Y[Y.Initial=0]="Initial",Y[Y.DoneOK=1]="DoneOK",Y[Y.DoneError=2]="DoneError"})(J||(J={}));class te{static fromArray(ie){return new te(pe=>{pe.emitMany(ie)})}static fromPromise(ie){return new te(async pe=>{pe.emitMany(await ie)})}static fromPromises(ie){return new te(async pe=>{await Promise.all(ie.map(async ve=>pe.emitOne(await ve)))})}static merge(ie){return new te(async pe=>{await Promise.all(ie.map(async ve=>{for await(const ke of ve)pe.emitOne(ke)}))})}constructor(ie){this.a=0,this.b=[],this.d=null,this.f=new u.Emitter,queueMicrotask(async()=>{const pe={emitOne:ve=>this.g(ve),emitMany:ve=>this.h(ve),reject:ve=>this.k(ve)};try{await Promise.resolve(ie(pe)),this.j()}catch(ve){this.k(ve)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let ie=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ie<this.b.length)return{done:!1,value:this.b[ie++]};if(this.a===1)return{done:!0,value:void 0};await u.Event.toPromise(this.f.event)}while(!0)}}}static map(ie,pe){return new te(async ve=>{for await(const ke of ie)ve.emitOne(pe(ke))})}map(ie){return te.map(this,ie)}static filter(ie,pe){return new te(async ve=>{for await(const ke of ie)pe(ke)&&ve.emitOne(ke)})}filter(ie){return te.filter(this,ie)}static coalesce(ie){return te.filter(ie,pe=>!!pe)}coalesce(){return te.coalesce(this)}static async toPromise(ie){const pe=[];for await(const ve of ie)pe.push(ve);return pe}toPromise(){return te.toPromise(this)}g(ie){this.a===0&&(this.b.push(ie),this.f.fire())}h(ie){this.a===0&&(this.b=this.b.concat(ie),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ie){this.a===0&&(this.a=2,this.d=ie,this.f.fire())}}te.EMPTY=te.fromArray([]),e.AsyncIterableObject=te;class ee extends te{constructor(ie,pe){super(pe),this.l=ie}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ee;function Q(Y){const ie=new c.CancellationTokenSource,pe=Y(ie.token);return new ee(ie,async ve=>{const ke=ie.token.onCancellationRequested(()=>{ke.dispose(),ie.dispose(),ve.reject(new A.CancellationError)});try{for await(const Oe of pe){if(ie.token.isCancellationRequested)return;ve.emitOne(Oe)}ke.dispose(),ie.dispose()}catch(Oe){ke.dispose(),ie.dispose(),ve.reject(Oe)}})}e.createCancelableAsyncIterable=Q}),define(ye[38],De([1,0,15,19,33,28,10,12,8]),function(ne,e,c,A,u,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",k="[^/\\\\]",v=/\//g;function T(de,V){switch(de){case 0:return"";case 1:return`${k}*?`;default:return`(?:${L}|${k}+${L}${V?`|${L}${k}+`:""})*?`}}function E(de,V){if(!de)return[];const X=[];let J=!1,te=!1,ee="";for(const Q of de){switch(Q){case V:if(!J&&!te){X.push(ee),ee="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":te=!0;break;case"]":te=!1;break}ee+=Q}return ee&&X.push(ee),X}e.splitGlobAware=E;function f(de){if(!de)return"";let V="";const X=E(de,e.GLOB_SPLIT);if(X.every(J=>J===e.GLOBSTAR))V=".*";else{let J=!1;X.forEach((te,ee)=>{if(te===e.GLOBSTAR){if(J)return;V+=T(2,ee===X.length-1)}else{let Q=!1,Y="",ie=!1,pe="";for(const ve of te){if(ve!=="}"&&Q){Y+=ve;continue}if(ie&&(ve!=="]"||!pe)){let ke;ve==="-"?ke=ve:(ve==="^"||ve==="!")&&!pe?ke="^":ve===e.GLOB_SPLIT?ke="":ke=(0,S.escapeRegExpCharacters)(ve),pe+=ke;continue}switch(ve){case"{":Q=!0;continue;case"[":ie=!0;continue;case"}":{V+=`(?:${E(Y,",").map(oe=>f(oe)).join("|")})`,Q=!1,Y="";break}case"]":{V+="["+pe+"]",ie=!1,pe="";break}case"?":V+=k;continue;case"*":V+=T(1);continue;default:V+=(0,S.escapeRegExpCharacters)(ve)}}ee<X.length-1&&(X[ee+1]!==e.GLOBSTAR||ee+2<X.length)&&(V+=L)}J=te===e.GLOBSTAR})}return V}const d=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,p=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,b=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.LRUCache(1e4),o=function(){return!1},s=function(){return null};function l(de,V){if(!de)return s;let X;typeof de!="string"?X=de.pattern:X=de,X=X.trim();const J=`${X}_${!!V.trimForExclusions}`;let te=i.get(J);if(te)return r(te,de);let ee;return d.test(X)?te=n(X.substr(4),X):(ee=h.exec(m(X,V)))?te=t(ee[1],X):(V.trimForExclusions?p:g).test(X)?te=a(X,V):(ee=y.exec(m(X,V)))?te=w(ee[1].substr(1),X,!0):(ee=b.exec(m(X,V)))?te=w(ee[1],X,!1):te=D(X),i.set(J,te),r(te,de)}function r(de,V){if(typeof V=="string")return de;const X=function(J,te){return(0,u.isEqualOrParent)(J,V.base,!P.isLinux)?de((0,S.ltrim)(J.substr(V.base.length),C.sep),te):null};return X.allBasenames=de.allBasenames,X.allPaths=de.allPaths,X.basenames=de.basenames,X.patterns=de.patterns,X}function m(de,V){return V.trimForExclusions&&de.endsWith("/**")?de.substr(0,de.length-2):de}function n(de,V){return function(X,J){return typeof X=="string"&&X.endsWith(de)?V:null}}function t(de,V){const X=`/${de}`,J=`\\${de}`,te=function(Q,Y){return typeof Q!="string"?null:Y?Y===de?V:null:Q===de||Q.endsWith(X)||Q.endsWith(J)?V:null},ee=[de];return te.basenames=ee,te.patterns=[V],te.allBasenames=ee,te}function a(de,V){const X=z(de.slice(1,-1).split(",").map(Y=>l(Y,V)).filter(Y=>Y!==s),de),J=X.length;if(!J)return s;if(J===1)return X[0];const te=function(Y,ie){for(let pe=0,ve=X.length;pe<ve;pe++)if(X[pe](Y,ie))return de;return null},ee=X.find(Y=>!!Y.allBasenames);ee&&(te.allBasenames=ee.allBasenames);const Q=X.reduce((Y,ie)=>ie.allPaths?Y.concat(ie.allPaths):Y,[]);return Q.length&&(te.allPaths=Q),te}function w(de,V,X){const J=C.sep===C.posix.sep,te=J?de:de.replace(v,C.sep),ee=C.sep+te,Q=C.posix.sep+de;let Y;return X?Y=function(ie,pe){return typeof ie=="string"&&(ie===te||ie.endsWith(ee)||!J&&(ie===de||ie.endsWith(Q)))?V:null}:Y=function(ie,pe){return typeof ie=="string"&&(ie===te||!J&&ie===de)?V:null},Y.allPaths=[(X?"*/":"./")+de],Y}function D(de){try{const V=new RegExp(`^${f(de)}$`);return function(X){return V.lastIndex=0,typeof X=="string"&&V.test(X)?de:null}}catch{return s}}function F(de,V,X){return!de||typeof V!="string"?!1:x(de)(V,void 0,X)}e.match=F;function x(de,V={}){if(!de)return o;if(typeof de=="string"||q(de)){const X=l(de,V);if(X===s)return o;const J=function(te,ee){return!!X(te,ee)};return X.allBasenames&&(J.allBasenames=X.allBasenames),X.allPaths&&(J.allPaths=X.allPaths),J}return O(de,V)}e.parse=x;function q(de){const V=de;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.isRelativePattern=q;function M(de){return de.allBasenames||[]}e.getBasenameTerms=M;function B(de){return de.allPaths||[]}e.getPathTerms=B;function O(de,V){const X=z(Object.getOwnPropertyNames(de).map(Y=>U(Y,de[Y],V)).filter(Y=>Y!==s)),J=X.length;if(!J)return s;if(!X.some(Y=>!!Y.requiresSiblings)){if(J===1)return X[0];const Y=function(ve,ke){let Oe;for(let oe=0,ae=X.length;oe<ae;oe++){const fe=X[oe](ve,ke);if(typeof fe=="string")return fe;(0,A.isThenable)(fe)&&(Oe||(Oe=[]),Oe.push(fe))}return Oe?(async()=>{for(const oe of Oe){const ae=await oe;if(typeof ae=="string")return ae}return null})():null},ie=X.find(ve=>!!ve.allBasenames);ie&&(Y.allBasenames=ie.allBasenames);const pe=X.reduce((ve,ke)=>ke.allPaths?ve.concat(ke.allPaths):ve,[]);return pe.length&&(Y.allPaths=pe),Y}const te=function(Y,ie,pe){let ve,ke;for(let Oe=0,oe=X.length;Oe<oe;Oe++){const ae=X[Oe];ae.requiresSiblings&&pe&&(ie||(ie=(0,C.basename)(Y)),ve||(ve=ie.substr(0,ie.length-(0,C.extname)(Y).length)));const fe=ae(Y,ie,ve,pe);if(typeof fe=="string")return fe;(0,A.isThenable)(fe)&&(ke||(ke=[]),ke.push(fe))}return ke?(async()=>{for(const Oe of ke){const oe=await Oe;if(typeof oe=="string")return oe}return null})():null},ee=X.find(Y=>!!Y.allBasenames);ee&&(te.allBasenames=ee.allBasenames);const Q=X.reduce((Y,ie)=>ie.allPaths?Y.concat(ie.allPaths):Y,[]);return Q.length&&(te.allPaths=Q),te}function U(de,V,X){if(V===!1)return s;const J=l(de,X);if(J===s)return s;if(typeof V=="boolean")return J;if(V){const te=V.when;if(typeof te=="string"){const ee=(Q,Y,ie,pe)=>{if(!pe||!J(Q,Y))return null;const ve=te.replace("$(basename)",()=>ie),ke=pe(ve);return(0,A.isThenable)(ke)?ke.then(Oe=>Oe?de:null):ke?de:null};return ee.requiresSiblings=!0,ee}}return J}function z(de,V){const X=de.filter(Y=>!!Y.basenames);if(X.length<2)return de;const J=X.reduce((Y,ie)=>{const pe=ie.basenames;return pe?Y.concat(pe):Y},[]);let te;if(V){te=[];for(let Y=0,ie=J.length;Y<ie;Y++)te.push(V)}else te=X.reduce((Y,ie)=>{const pe=ie.patterns;return pe?Y.concat(pe):Y},[]);const ee=function(Y,ie){if(typeof Y!="string")return null;if(!ie){let ve;for(ve=Y.length;ve>0;ve--){const ke=Y.charCodeAt(ve-1);if(ke===47||ke===92)break}ie=Y.substr(ve)}const pe=J.indexOf(ie);return pe!==-1?te[pe]:null};ee.basenames=J,ee.patterns=te,ee.allBasenames=J;const Q=de.filter(Y=>!Y.basenames);return Q.push(ee),Q}function j(de,V){return(0,c.equals)(de,V,(X,J)=>typeof X=="string"&&typeof J=="string"?X===J:typeof X!="string"&&typeof J!="string"?X.base===J.base&&X.pattern===J.pattern:!1)}e.patternsEquals=j}),define(ye[112],De([1,0,11,163,24,8,2]),function(ne,e,c,A,u,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(h="",g=!1){if(this.value=h,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(h,g=0){return this.value+=v(this.supportThemeIcons?(0,A.escapeIcons)(h):h).replace(/([ \t]+)/g,(p,y)=>"&nbsp;".repeat(y.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,g){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(h,g,p){return this.value+="[",this.value+=this.c(g,"]"),this.value+="](",this.value+=this.c(String(h),")"),p&&(this.value+=` "${this.c(this.c(p,'"'),")")}"`),this.value+=")",this}c(h,g){const p=new RegExp((0,R.escapeRegExpCharacters)(g),"g");return h.replace(p,(y,b)=>h.charAt(b-1)!=="\\"?`\\${y}`:y)}}e.MarkdownString=S;function I(d){return L(d)?!d.value:Array.isArray(d)?d.every(I):!0}e.isEmptyMarkdownString=I;function L(d){return d instanceof S?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function k(d,h){return d===h?!0:!d||!h?!1:d.value===h.value&&d.isTrusted===h.isTrusted&&d.supportThemeIcons===h.supportThemeIcons&&d.supportHtml===h.supportHtml&&(d.baseUri===h.baseUri||!!d.baseUri&&!!h.baseUri&&(0,u.isEqual)(C.URI.from(d.baseUri),C.URI.from(h.baseUri)))}e.markdownStringEqual=k;function v(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=v;function T(d){return d.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=T;function E(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=E;function f(d){const h=[],g=d.split("|").map(y=>y.trim());d=g[0];const p=g[1];if(p){const y=/height=(\d+)/.exec(p),b=/width=(\d+)/.exec(p),i=y?y[1]:"",o=b?b[1]:"",s=isFinite(parseInt(o)),l=isFinite(parseInt(i));s&&h.push(`width="${o}"`),l&&h.push(`height="${i}"`)}return{href:d,dimensions:h}}e.parseHrefAndDimensions=f}),define(ye[113],De([1,0,15,33,10,12,24,8]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(s,l){const{os:r,tildify:m,relative:n}=l;if(n){const w=I(s,n,r);if(typeof w=="string")return w}let t=s.fsPath;if(r===1&&!R.isWindows?t=t.replace(/\//g,"\\"):r!==1&&R.isWindows&&(t=t.replace(/\\/g,"/")),r!==1&&m?.userHome){const w=m.userHome.fsPath;let D;s.scheme!==m.userHome.scheme&&s.path.startsWith(u.posix.sep)?D=m.userHome.with({path:s.path}).fsPath:D=s.fsPath,t=v(D,w,r)}return(r===1?u.win32:u.posix).normalize(L(t,r===1))}e.getPathLabel=S;function I(s,l,r){const m=r===1?u.win32:u.posix,n=r===3?C.extUri:C.extUriIgnorePathCase,t=l.getWorkspace(),a=(0,c.firstOrDefault)(t.folders);if(!a)return;s.scheme!==a.uri.scheme&&s.path.startsWith(u.posix.sep)&&(s=a.uri.with({path:s.path}));const w=l.getWorkspaceFolder(s);if(!w)return;let D;if(n.isEqual(w.uri,s)?D="":D=n.relativePath(w.uri,s)??"",D&&(D=m.normalize(D)),t.folders.length>1&&!l.noPrefix){const F=w.name?w.name:n.basenameOrAuthority(w.uri);D=D?`${F} \u2022 ${D}`:F}return D}function L(s,l=R.isWindows){return(0,A.hasDriveLetter)(s,l)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=L;let k=Object.create(null);function v(s,l,r=R.OS){if(r===1||!s||!l)return s;let m=k.original===l?k.normalized:void 0;m||(m=l,R.isWindows&&(m=(0,A.toSlashes)(m)),m=`${(0,P.rtrim)(m,u.posix.sep)}${u.posix.sep}`,k={original:l,normalized:m});let n=s;return R.isWindows&&(n=(0,A.toSlashes)(n)),(r===3?n.startsWith(m):(0,P.startsWithIgnoreCase)(n,m))?`~/${n.substr(m.length)}`:s}e.tildify=v;function T(s,l){return s.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=T;const E="\u2026",f="\\\\",d="~";function h(s,l=u.sep){const r=new Array(s.length);let m=!1;for(let n=0;n<s.length;n++){const t=s[n];if(t===""){r[n]=`.${l}`;continue}if(!t){r[n]=t;continue}m=!0;let a="",w=t;w.indexOf(f)===0?(a=w.substr(0,w.indexOf(f)+f.length),w=w.substr(w.indexOf(f)+f.length)):w.indexOf(l)===0?(a=w.substr(0,w.indexOf(l)+l.length),w=w.substr(w.indexOf(l)+l.length)):w.indexOf(d)===0&&(a=w.substr(0,w.indexOf(d)+d.length),w=w.substr(w.indexOf(d)+d.length));const D=w.split(l);for(let F=1;m&&F<=D.length;F++)for(let x=D.length-F;m&&x>=0;x--){m=!1;let q=D.slice(x,x+F).join(l);for(let M=0;!m&&M<s.length;M++)if(M!==n&&s[M]&&s[M].indexOf(q)>-1){const B=x+F===D.length,O=x>0&&s[M].indexOf(l)>-1?l+q:q,U=s[M].endsWith(O);m=!B||U}if(!m){let M="";(D[0].endsWith(":")||a!=="")&&(x===1&&(x=0,F++,q=D[0]+l+q),x>0&&(M=D[0]+l),M=a+M),x>0&&(M=M+E+l),M=M+q,x+F<D.length&&(M=M+l+E),r[n]=M}}m&&(r[n]=t)}return r}e.shorten=h;var g;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function p(s,l=Object.create(null)){const r=[];let m=!1,n="";for(const t of s)if(t==="$"||m&&t==="{")n&&r.push({value:n,type:g.TEXT}),n="",m=!0;else if(t==="}"&&m){const a=l[n];if(typeof a=="string")a.length&&r.push({value:a,type:g.VARIABLE});else if(a){const w=r[r.length-1];(!w||w.type!==g.SEPARATOR)&&r.push({value:a.label,type:g.SEPARATOR})}n="",m=!1}else n+=t;return n&&!m&&r.push({value:n,type:g.TEXT}),r.filter((t,a)=>{if(t.type===g.SEPARATOR){const w=r[a-1],D=r[a+1];return[w,D].every(F=>F&&(F.type===g.VARIABLE||F.type===g.TEXT)&&F.value.length>0)}return!0}).map(t=>t.value).join("")}e.template=p;function y(s,l){return R.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):s.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.mnemonicMenuLabel=y;function b(s,l){return R.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,""):R.isWindows?s.replace(/&&|&/g,r=>r==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=b;function i(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=i;function o(s){const l=s.indexOf("/")!==-1?u.posix:u.win32,r=l.basename(s),m=l.dirname(s);return r.length?{name:r,parentPath:m}:{name:m,parentPath:""}}e.splitName=o}),define(ye[114],De([1,0,22,2]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function u(k){return k.toJSON()}class R{constructor(v){this.a=v}transformIncoming(v){const T=this.a.transformIncoming(v);return T===v?v:u(A.URI.from(T))}transformOutgoing(v){const T=this.a.transformOutgoing(v);return T===v?v:u(A.URI.from(T))}transformOutgoingURI(v){const T=this.a.transformOutgoing(v);return T===v?v:A.URI.from(T)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function C(k,v,T){if(!k||T>200)return null;if(typeof k=="object"){if(k instanceof A.URI)return v.transformOutgoing(k);for(const E in k)if(Object.hasOwnProperty.call(k,E)){const f=C(k[E],v,T+1);f!==null&&(k[E]=f)}}return null}function P(k,v){const T=C(k,v,0);return T===null?k:T}e.transformOutgoingURIs=P;function S(k,v,T,E){if(!k||E>200)return null;if(typeof k=="object"){if(k.$mid===1)return T?A.URI.revive(v.transformIncoming(k)):v.transformIncoming(k);if(k instanceof c.VSBuffer)return null;for(const f in k)if(Object.hasOwnProperty.call(k,f)){const d=S(k[f],v,T,E+1);d!==null&&(k[f]=d)}}return null}function I(k,v){const T=S(k,v,!1,0);return T===null?k:T}e.transformIncomingURIs=I;function L(k,v){const T=S(k,v,!0,0);return T===null?k:T}e.transformAndReviveIncomingURIs=L}),define(ye[29],De([1,0,70,88,318,19,33,85,10,12,24,2]),function(ne,e,c,A,u,R,C,P,S,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function T(O,U=v.UNLINK){if((0,C.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return U===v.UNLINK?f(O):E(O)}async function E(O){try{const U=(0,C.randomPath)((0,A.tmpdir)());try{await c.promises.rename(O,U)}catch(z){return z.code==="ENOENT"?void 0:f(O)}f(U).catch(z=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function f(O){return(0,u.promisify)(c.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function d(O){if((0,C.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");c.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=d;async function h(O,U){return y(await(U?g(O):(0,u.promisify)(c.readdir)(O)))}async function g(O){try{return await(0,u.promisify)(c.readdir)(O,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const U=[],z=await h(O);for(const j of z){let de=!1,V=!1,X=!1;try{const J=await e.Promises.lstat((0,S.join)(O,j));de=J.isFile(),V=J.isDirectory(),X=J.isSymbolicLink()}catch(J){console.warn("[node.js fs] unexpected error from lstat after readdir: ",J)}U.push({name:j,isFile:()=>de,isDirectory:()=>V,isSymbolicLink:()=>X})}return U}function p(O){return y(c.readdirSync(O))}e.readdirSync=p;function y(O){return O.map(U=>typeof U=="string"?I.isMacintosh?(0,P.normalizeNFC)(U):U:(U.name=I.isMacintosh?(0,P.normalizeNFC)(U.name):U.name,U))}async function b(O){const U=await h(O),z=[];for(const j of U)await o.existsDirectory((0,S.join)(O,j))&&z.push(j);return z}function i(O,U=1e3){return new Promise(z=>{let j=!1;const de=setInterval(()=>{j||(j=!0,c.access(O,V=>{j=!1,V&&(clearInterval(de),z(void 0))}))},U)})}e.whenDeleted=i;var o;(function(O){async function U(de){let V;try{if(V=await e.Promises.lstat(de),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(de),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(I.isWindows&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(de)),symbolicLink:{dangling:!1}}}catch(J){if(J.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw J}throw X}}O.stat=U;async function z(de){try{const{stat:V,symbolicLink:X}=await O.stat(de);return V.isFile()&&X?.dangling!==!0}catch{}return!1}O.existsFile=z;async function j(de){try{const{stat:V,symbolicLink:X}=await O.stat(de);return V.isDirectory()&&X?.dangling!==!0}catch{}return!1}O.existsDirectory=j})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new R.ResourceQueue;function l(O,U,z){return s.queueFor(k.URI.file(O),L.extUriBiasedIgnorePathCase).queue(()=>{const j=a(z);return new Promise((de,V)=>n(O,U,j,X=>X?V(X):de()))})}let r=!0;function m(O){r=O}e.configureFlushOnWrite=m;function n(O,U,z,j){if(!r)return c.writeFile(O,U,{mode:z.mode,flag:z.flag},j);c.open(O,z.flag,z.mode,(de,V)=>{if(de)return j(de);c.writeFile(V,U,X=>{if(X)return c.close(V,()=>j(X));c.fdatasync(V,J=>(J&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",J),m(!1)),c.close(V,te=>j(te))))})})}function t(O,U,z){const j=a(z);if(!r)return c.writeFileSync(O,U,{mode:j.mode,flag:j.flag});const de=c.openSync(O,j.flag,j.mode);try{c.writeFileSync(de,U);try{c.fdatasyncSync(de)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),m(!1)}}finally{c.closeSync(de)}}e.writeFileSync=t;function a(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function w(O,U){if(O!==U)try{await e.Promises.rename(O,U)}catch(z){if(O.toLowerCase()!==U.toLowerCase()&&z.code==="EXDEV"||O.endsWith("."))await D(O,U,{preserveSymlinks:!1}),await T(O,v.MOVE);else throw z}}async function D(O,U,z){return x(O,U,{root:{source:O,target:U},options:z,handledSourcePaths:new Set})}const F=511;async function x(O,U,z){if(z.handledSourcePaths.has(O))return;z.handledSourcePaths.add(O);const{stat:j,symbolicLink:de}=await o.stat(O);if(de){if(z.options.preserveSymlinks)try{return await B(O,U,z)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(de.dangling)return}return j.isDirectory()?q(O,U,j.mode&F,z):M(O,U,j.mode&F)}async function q(O,U,z,j){await e.Promises.mkdir(U,{recursive:!0,mode:z});const de=await h(O);for(const V of de)await x((0,S.join)(O,V),(0,S.join)(U,V),j)}async function M(O,U,z){await e.Promises.copyFile(O,U),await e.Promises.chmod(U,z)}async function B(O,U,z){let j=await e.Promises.readlink(O);(0,C.isEqualOrParent)(j,z.root.source,!I.isLinux)&&(j=(0,S.join)(z.root.target,j.substr(z.root.source.length+1))),await e.Promises.symlink(j,U)}e.Promises=new class{get access(){return(0,u.promisify)(c.access)}get stat(){return(0,u.promisify)(c.stat)}get lstat(){return(0,u.promisify)(c.lstat)}get utimes(){return(0,u.promisify)(c.utimes)}get read(){return(O,U,z,j,de)=>new Promise((V,X)=>{c.read(O,U,z,j,de,(J,te,ee)=>J?X(J):V({bytesRead:te,buffer:ee}))})}get readFile(){return(0,u.promisify)(c.readFile)}get write(){return(O,U,z,j,de)=>new Promise((V,X)=>{c.write(O,U,z,j,de,(J,te,ee)=>J?X(J):V({bytesWritten:te,buffer:ee}))})}get appendFile(){return(0,u.promisify)(c.appendFile)}get fdatasync(){return(0,u.promisify)(c.fdatasync)}get truncate(){return(0,u.promisify)(c.truncate)}get rename(){return(0,u.promisify)(c.rename)}get copyFile(){return(0,u.promisify)(c.copyFile)}get open(){return(0,u.promisify)(c.open)}get close(){return(0,u.promisify)(c.close)}get symlink(){return(0,u.promisify)(c.symlink)}get readlink(){return(0,u.promisify)(c.readlink)}get chmod(){return(0,u.promisify)(c.chmod)}get mkdir(){return(0,u.promisify)(c.mkdir)}get unlink(){return(0,u.promisify)(c.unlink)}get rmdir(){return(0,u.promisify)(c.rmdir)}get realpath(){return(0,u.promisify)(c.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return b}get writeFile(){return l}get rm(){return T}get move(){return w}get copy(){return D}}}),define(ye[115],De([1,0,70,10,12,8,29]),function(ne,e,c,A,u,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(v){if(u.isLinux)return v;const T=(0,A.dirname)(v);if(v===T)return v;const E=((0,A.basename)(v)||v).toLowerCase();try{const d=(0,C.readdirSync)(T).filter(h=>h.toLowerCase()===E);if(d.length===1){const h=P(T);if(h)return(0,A.join)(h,d[0])}else if(d.length>1){const h=d.indexOf(E);if(h>=0){const g=P(T);if(g)return(0,A.join)(g,d[h])}}}catch{}return null}e.realcaseSync=P;async function S(v){if(u.isLinux)return v;const T=(0,A.dirname)(v);if(v===T)return v;const E=((0,A.basename)(v)||v).toLowerCase();try{const d=(await C.Promises.readdir(T)).filter(h=>h.toLowerCase()===E);if(d.length===1){const h=await S(T);if(h)return(0,A.join)(h,d[0])}else if(d.length>1){const h=d.indexOf(E);if(h>=0){const g=await S(T);if(g)return(0,A.join)(g,d[h])}}}catch{}return null}e.realcase=S;async function I(v){try{return await C.Promises.realpath(v)}catch{const E=k(v);return await C.Promises.access(E,c.constants.R_OK),E}}e.realpath=I;function L(v){try{return c.realpathSync(v)}catch{const E=k(v);return c.accessSync(E,c.constants.R_OK),E}}e.realpathSync=L;function k(v){return(0,R.rtrim)((0,A.normalize)(v),A.sep)}}),define(ye[116],De([1,0,10,12,36,109,9,29]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function S(k=u.env){return k.comspec||"cmd.exe"}e.getWindowsShell=S;function I(k){let v=[],T=!1;const E=function(f){if(T){v.push(f);return}(!k.send(f,h=>{if(h&&console.error(h),T=!1,v.length>0){const g=v.slice(0);v=[],g.forEach(p=>E(p))}})||A.isWindows)&&(T=!0)};return{send:E}}e.createQueuedSender=I;var L;(function(k){async function v(T,E,f){if(c.isAbsolute(T))return T;if(E===void 0&&(E=u.cwd()),c.dirname(T)!=="."||(f===void 0&&C.isString(u.env.PATH)&&(f=u.env.PATH.split(c.delimiter)),f===void 0||f.length===0))return c.join(E,T);async function h(g){if(await P.Promises.exists(g)){let p;try{p=await P.Promises.stat(g)}catch(y){y.message.startsWith("EACCES")&&(p=await P.Promises.lstat(g))}return p?!p.isDirectory():!1}return!1}for(const g of f){let p;if(c.isAbsolute(g)?p=c.join(g,T):p=c.join(E,g,T),await h(p))return p;let y=p+".com";if(await h(y)||(y=p+".exe",await h(y)))return y}return c.join(E,T)}k.findExecutable=v})(L=e.win32||(e.win32={}))});var qe=this&&this.__decorate||function(ne,e,c,A){var u=arguments.length,R=u<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,c):A,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(ne,e,c,A);else for(var P=ne.length-1;P>=0;P--)(C=ne[P])&&(R=(u<3?C(R):u>3?C(e,c,R):C(e,c))||R);return u>3&&R&&Object.defineProperty(e,c,R),R};define(ye[117],De([1,0,15,19,22,21,62,11,3,6,69,8,9]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var T;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(T||(T={}));function E(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(f||(f={}));function d(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(h||(h={}));function g(V){let X=0;for(let J=0;;J+=7){const te=V.read(1);if(X|=(te.buffer[0]&127)<<J,!(te.buffer[0]&128))return X}}const p=s(0);function y(V,X){if(X===0){V.write(p);return}let J=0;for(let ee=X;ee!==0;ee=ee>>>7)J++;const te=u.VSBuffer.alloc(J);for(let ee=0;X!==0;ee++)te.buffer[ee]=X&127,X=X>>>7,X>0&&(te.buffer[ee]|=128);V.write(te)}class b{constructor(X){this.b=X,this.a=0}read(X){const J=this.b.slice(this.a,this.a+X);return this.a+=J.byteLength,J}}e.BufferReader=b;class i{constructor(){this.a=[]}get buffer(){return u.VSBuffer.concat(this.a)}write(X){this.a.push(X)}}e.BufferWriter=i;var o;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(o||(o={}));function s(V){const X=u.VSBuffer.alloc(1);return X.writeUInt8(V,0),X}const l={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object),Uint:s(o.Int)},r=typeof Buffer<"u";function m(V,X){if(typeof X>"u")V.write(l.Undefined);else if(typeof X=="string"){const J=u.VSBuffer.fromString(X);V.write(l.String),y(V,J.byteLength),V.write(J)}else if(r&&Buffer.isBuffer(X)){const J=u.VSBuffer.wrap(X);V.write(l.Buffer),y(V,J.byteLength),V.write(J)}else if(X instanceof u.VSBuffer)V.write(l.VSBuffer),y(V,X.byteLength),V.write(X);else if(Array.isArray(X)){V.write(l.Array),y(V,X.length);for(const J of X)m(V,J)}else if(typeof X=="number"&&(X|0)===X)V.write(l.Uint),y(V,X);else{const J=u.VSBuffer.fromString(JSON.stringify(X));V.write(l.Object),y(V,J.byteLength),V.write(J)}}e.serialize=m;function n(V){switch(V.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return V.read(g(V)).toString();case o.Buffer:return V.read(g(V)).buffer;case o.VSBuffer:return V.read(g(V));case o.Array:{const J=g(V),te=[];for(let ee=0;ee<J;ee++)te.push(n(V));return te}case o.Object:return JSON.parse(V.read(g(V)).toString());case o.Int:return g(V)}}e.deserialize=n;class t{constructor(X,J,te=null,ee=1e3){this.h=X,this.j=J,this.k=te,this.l=ee,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Q=>this.q(Q)),this.m({type:200})}registerChannel(X,J){this.b.set(X,J),setTimeout(()=>this.w(X),0)}m(X){switch(X.type){case 200:{const J=this.o([X.type]);this.k?.logOutgoing(J,0,1,d(X.type));return}case 201:case 202:case 204:case 203:{const J=this.o([X.type,X.id],X.data);this.k?.logOutgoing(J,X.id,1,d(X.type),X.data);return}}}o(X,J=void 0){const te=new i;return m(te,X),m(te,J),this.p(te.buffer)}p(X){try{return this.h.send(X),X.byteLength}catch{return 0}}q(X){const J=new b(X),te=n(J),ee=n(J),Q=te[0];switch(Q){case 100:return this.k?.logIncoming(X.byteLength,te[1],1,`${E(Q)}: ${te[2]}.${te[3]}`,ee),this.s({type:Q,id:te[1],channelName:te[2],name:te[3],arg:ee});case 102:return this.k?.logIncoming(X.byteLength,te[1],1,`${E(Q)}: ${te[2]}.${te[3]}`,ee),this.t({type:Q,id:te[1],channelName:te[2],name:te[3],arg:ee});case 101:return this.k?.logIncoming(X.byteLength,te[1],1,`${E(Q)}`),this.u({type:Q,id:te[1]});case 103:return this.k?.logIncoming(X.byteLength,te[1],1,`${E(Q)}`),this.u({type:Q,id:te[1]})}}s(X){const J=this.b.get(X.channelName);if(!J){this.v(X);return}const te=new R.CancellationTokenSource;let ee;try{ee=J.call(this.j,X.name,X.arg,te.token)}catch(ie){ee=Promise.reject(ie)}const Q=X.id;ee.then(ie=>{this.m({id:Q,data:ie,type:201}),this.d.delete(X.id)},ie=>{ie instanceof Error?this.m({id:Q,data:{message:ie.message,name:ie.name,stack:ie.stack?ie.stack.split?ie.stack.split(`
`):ie.stack:void 0},type:202}):this.m({id:Q,data:ie,type:203}),this.d.delete(X.id)});const Y=(0,I.toDisposable)(()=>te.cancel());this.d.set(X.id,Y)}t(X){const J=this.b.get(X.channelName);if(!J){this.v(X);return}const te=X.id,Q=J.listen(this.j,X.name,X.arg)(Y=>this.m({id:te,data:Y,type:204}));this.d.set(X.id,Q)}u(X){const J=this.d.get(X.id);J&&(J.dispose(),this.d.delete(X.id))}v(X){let J=this.g.get(X.channelName);J||(J=[],this.g.set(X.channelName,J));const te=setTimeout(()=>{console.error(`Unknown channel: ${X.channelName}`),X.type===100&&this.m({id:X.id,data:{name:"Unknown channel",message:`Channel name '${X.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);J.push({request:X,timeoutTimer:te})}w(X){const J=this.g.get(X);if(J){for(const te of J)switch(clearTimeout(te.timeoutTimer),te.request.type){case 100:this.s(te.request);break;case 102:this.t(te.request);break}this.g.delete(X)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,I.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=t;var a;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(a=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(X,J=null){this.l=X,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(te=>this.s(te)),this.j=J}getChannel(X){const J=this;return{call(te,ee,Q){return J.a?Promise.reject(new P.CancellationError):J.m(X,te,ee,Q)},listen(te,ee){return J.a?S.Event.None:J.o(X,te,ee)}}}m(X,J,te,ee=R.CancellationToken.None){const Q=this.g++,ie={id:Q,type:100,channelName:X,name:J,arg:te};if(ee.isCancellationRequested)return Promise.reject(new P.CancellationError);let pe;return new Promise((ke,Oe)=>{if(ee.isCancellationRequested)return Oe(new P.CancellationError);const oe=()=>{const le=re=>{switch(re.type){case 201:this.f.delete(Q),ke(re.data);break;case 202:{this.f.delete(Q);const N=new Error(re.data.message);N.stack=Array.isArray(re.data.stack)?re.data.stack.join(`
`):re.data.stack,N.name=re.data.name,Oe(N);break}case 203:this.f.delete(Q),Oe(re.data);break}};this.f.set(Q,le),this.p(ie)};let ae=null;this.b===h.Idle?oe():(ae=(0,A.createCancelablePromise)(le=>this.u()),ae.then(()=>{ae=null,oe()}));const fe=()=>{ae?(ae.cancel(),ae=null):this.p({id:Q,type:101}),Oe(new P.CancellationError)},Z=ee.onCancellationRequested(fe);pe=(0,I.combinedDisposable)((0,I.toDisposable)(fe),Z),this.d.add(pe)}).finally(()=>{this.d.delete(pe)})}o(X,J,te){const ee=this.g++,Y={id:ee,type:102,channelName:X,name:J,arg:te};let ie=null;const pe=new S.Emitter({onWillAddFirstListener:()=>{ie=(0,A.createCancelablePromise)(ke=>this.u()),ie.then(()=>{ie=null,this.d.add(pe),this.p(Y)})},onDidRemoveLastListener:()=>{ie?(ie.cancel(),ie=null):(this.d.delete(pe),this.p({id:ee,type:103}))}}),ve=ke=>pe.fire(ke.data);return this.f.set(ee,ve),pe.event}p(X){switch(X.type){case 100:case 102:{const J=this.q([X.type,X.id,X.channelName,X.name],X.arg);this.j?.logOutgoing(J,X.id,0,`${E(X.type)}: ${X.channelName}.${X.name}`,X.arg);return}case 101:case 103:{const J=this.q([X.type,X.id]);this.j?.logOutgoing(J,X.id,0,E(X.type));return}}}q(X,J=void 0){const te=new i;return m(te,X),m(te,J),this.r(te.buffer)}r(X){try{return this.l.send(X),X.byteLength}catch{return 0}}s(X){const J=new b(X),te=n(J),ee=n(J),Q=te[0];switch(Q){case 200:return this.j?.logIncoming(X.byteLength,0,0,d(Q)),this.t({type:te[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(X.byteLength,te[1],0,d(Q),ee),this.t({type:te[0],id:te[1],data:ee})}}t(X){if(X.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(X.id)?.(X)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,I.dispose)(this.d.values()),this.d.clear()}}qe([C.memoize],w.prototype,"onDidInitializePromise",null),e.ChannelClient=w;class D{get connections(){const X=[];return this.f.forEach(J=>X.push(J)),X}constructor(X){this.a=new Map,this.f=new Set,this.g=new S.Emitter,this.onDidAddConnection=this.g.event,this.h=new S.Emitter,this.onDidRemoveConnection=this.h.event,X(({protocol:J,onDidClientDisconnect:te})=>{S.Event.once(J.onMessage)(Q=>{const Y=new b(Q),ie=n(Y),pe=new t(J,ie),ve=new w(J);this.a.forEach((Oe,oe)=>pe.registerChannel(oe,Oe));const ke={channelServer:pe,channelClient:ve,ctx:ie};this.f.add(ke),this.g.fire(ke),te(()=>{pe.dispose(),ve.dispose(),this.f.delete(ke),this.h.fire(ke)})})})}getChannel(X,J){const te=this;return{call(ee,Q,Y){let ie;if((0,v.isFunction)(J)){const ve=(0,c.getRandomElement)(te.connections.filter(J));ie=ve?Promise.resolve(ve):S.Event.toPromise(S.Event.filter(te.onDidAddConnection,J))}else ie=J.routeCall(te,ee,Q);const pe=ie.then(ve=>ve.channelClient.getChannel(X));return x(pe).call(ee,Q,Y)},listen(ee,Q){if((0,v.isFunction)(J))return te.j(X,J,ee,Q);const Y=J.routeEvent(te,ee,Q).then(ie=>ie.channelClient.getChannel(X));return x(Y).listen(ee,Q)}}}j(X,J,te,ee){const Q=this;let Y=new I.DisposableStore;const ie=new S.Emitter({onWillAddFirstListener:()=>{Y=new I.DisposableStore;const pe=new S.EventMultiplexer,ve=new Map,ke=oe=>{const fe=oe.channelClient.getChannel(X).listen(te,ee),Z=pe.add(fe);ve.set(oe,Z)},Oe=oe=>{const ae=ve.get(oe);!ae||(ae.dispose(),ve.delete(oe))};Q.connections.filter(J).forEach(ke),S.Event.filter(Q.onDidAddConnection,J)(ke,void 0,Y),Q.onDidRemoveConnection(Oe,void 0,Y),pe.event(ie.fire,ie,Y),Y.add(pe)},onDidRemoveLastListener:()=>{Y.dispose()}});return ie.event}registerChannel(X,J){this.a.set(X,J),this.f.forEach(te=>{te.channelServer.registerChannel(X,J)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=D;class F{constructor(X,J,te=null){const ee=new i;m(ee,J),X.send(ee.buffer),this.a=new w(X,te),this.d=new t(X,J,te)}getChannel(X){return this.a.getChannel(X)}registerChannel(X,J){this.d.registerChannel(X,J)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=F;function x(V){return{call(X,J,te){return V.then(ee=>ee.call(X,J,te))},listen(X,J){const te=new S.Relay;return V.then(ee=>te.input=ee.listen(X,J)),te.event}}}e.getDelayedChannel=x;function q(V){let X=!1;return{call(J,te,ee){return X?V.call(J,te,ee):(0,A.timeout)(0).then(()=>X=!0).then(()=>V.call(J,te,ee))},listen(J,te){if(X)return V.listen(J,te);const ee=new S.Relay;return(0,A.timeout)(0).then(()=>X=!0).then(()=>ee.input=V.listen(J,te)),ee.event}}}e.getNextTickChannel=q;class M{constructor(X){this.a=X}routeCall(X){return this.b(X)}routeEvent(X){return this.b(X)}async b(X){for(const J of X.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await S.Event.toPromise(X.onDidAddConnection),await this.b(X)}}e.StaticRouter=M;var B;(function(V){function X(Q,Y){const ie=Q,pe=Y&&Y.disableMarshalling,ve=new Map;for(const ke in ie)te(ke)&&ve.set(ke,S.Event.buffer(ie[ke],!0));return new class{listen(ke,Oe,oe){const ae=ve.get(Oe);if(ae)return ae;if(ee(Oe)){const fe=ie[Oe];if(typeof fe=="function")return fe.call(ie,oe)}throw new Error(`Event not found: ${Oe}`)}call(ke,Oe,oe){const ae=ie[Oe];if(typeof ae=="function"){if(!pe&&Array.isArray(oe))for(let fe=0;fe<oe.length;fe++)oe[fe]=(0,L.revive)(oe[fe]);return ae.apply(ie,oe)}throw new Error(`Method not found: ${Oe}`)}}}V.fromService=X;function J(Q,Y){const ie=Y&&Y.disableMarshalling;return new Proxy({},{get(pe,ve){if(typeof ve=="string")return Y?.properties?.has(ve)?Y.properties.get(ve):ee(ve)?function(ke){return Q.listen(ve,ke)}:te(ve)?Q.listen(ve):async function(...ke){let Oe;Y&&!(0,v.isUndefinedOrNull)(Y.context)?Oe=[Y.context,...ke]:Oe=ke;const oe=await Q.call(ve,Oe);return ie?oe:(0,L.revive)(oe)};throw new Error(`Property not found: ${String(ve)}`)}})}V.toService=J;function te(Q){return Q[0]==="o"&&Q[1]==="n"&&k.isUpperAsciiLetter(Q.charCodeAt(2))}function ee(Q){return/^onDynamic/.test(Q)&&k.isUpperAsciiLetter(Q.charCodeAt(9))}})(B=e.ProxyChannel||(e.ProxyChannel={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const X=V.toString();if(X!=="[object Object]")return X}return V}function z(V){return Array.isArray(V)?V.map(U):U(V)}function j(V,X,J,te,ee,Q,Y){Y=z(Y);const ie=O[ee],pe=ie[te%ie.length];let ve=[`%c[${V}]%c[${String(X).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(te).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${pe}`];/\($/.test(Q)?(ve=ve.concat(Y),ve.push(")")):ve.push(Y),console.log.apply(console,ve)}class de{constructor(X,J){this.d=X,this.f=J,this.a=0,this.b=0}logOutgoing(X,J,te,ee,Q){this.b+=X,j(this.d,this.b,X,J,te,ee,Q)}logIncoming(X,J,te,ee,Q){this.a+=X,j(this.f,this.a,X,J,te,ee,Q)}}e.IPCLogger=de}),define(ye[118],De([1,0,19,22,3,6,117]),function(ne,e,c,A,u,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(w){w.Created="created",w.Read="read",w.Write="write",w.Open="open",w.Error="error",w.Close="close",w.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",w.NodeEndReceived="nodeEndReceived",w.NodeEndSent="nodeEndSent",w.NodeDrainBegin="nodeDrainBegin",w.NodeDrainEnd="nodeDrainEnd",w.zlibInflateError="zlibInflateError",w.zlibInflateData="zlibInflateData",w.zlibInflateInitialWrite="zlibInflateInitialWrite",w.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",w.zlibInflateWrite="zlibInflateWrite",w.zlibInflateFlushFired="zlibInflateFlushFired",w.zlibDeflateError="zlibDeflateError",w.zlibDeflateData="zlibDeflateData",w.zlibDeflateWrite="zlibDeflateWrite",w.zlibDeflateFlushFired="zlibDeflateFlushFired",w.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",w.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",w.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",w.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",w.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",w.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",w.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",w.ProtocolHeaderRead="protocolHeaderRead",w.ProtocolMessageRead="protocolMessageRead",w.ProtocolHeaderWrite="protocolHeaderWrite",w.ProtocolMessageWrite="protocolMessageWrite",w.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var S;(function(w){w.enableDiagnostics=!1,w.records=[];const D=new WeakMap;let F=0;function x(M,B){if(!D.has(M)){const O=String(++F);D.set(M,O)}return D.get(M)}function q(M,B,O,U){if(!w.enableDiagnostics)return;const z=x(M,B);if(U instanceof A.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const j=A.VSBuffer.alloc(U.byteLength);j.set(U),w.records.push({timestamp:Date.now(),id:z,label:B,type:O,buff:j})}else w.records.push({timestamp:Date.now(),id:z,label:B,type:O,data:U})}w.traceSocketEvent=q})(S=e.SocketDiagnostics||(e.SocketDiagnostics={}));var I;(function(w){w[w.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",w[w.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(I=e.SocketCloseEventType||(e.SocketCloseEventType={}));let L=null;function k(){return L||(L=A.VSBuffer.alloc(0)),L}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(D){this.a.push(D),this.b+=D.byteLength}read(D){return this.c(D,!0)}peek(D){return this.c(D,!1)}c(D,F){if(D===0)return k();if(D>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===D){const B=this.a[0];return F&&(this.a.shift(),this.b-=D),B}if(this.a[0].byteLength>D){const B=this.a[0].slice(0,D);return F&&(this.a[0]=this.a[0].slice(D),this.b-=D),B}const x=A.VSBuffer.alloc(D);let q=0,M=0;for(;D>0;){const B=this.a[M];if(B.byteLength>D){const O=B.slice(0,D);x.set(O,q),q+=D,F&&(this.a[M]=B.slice(D),this.b-=D),D-=D}else x.set(B,q),q+=B.byteLength,F?(this.a.shift(),this.b-=B.byteLength):M++,D-=B.byteLength}return x}}e.ChunkStream=v;var T;(function(w){w[w.None=0]="None",w[w.Regular=1]="Regular",w[w.Control=2]="Control",w[w.Ack=3]="Ack",w[w.Disconnect=5]="Disconnect",w[w.ReplayRequest=6]="ReplayRequest",w[w.Pause=7]="Pause",w[w.Resume=8]="Resume",w[w.KeepAlive=9]="KeepAlive",w[w.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",w[w.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(T||(T={}));function E(w){switch(w){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var f;(function(w){w[w.HeaderLength=13]="HeaderLength",w[w.AcknowledgeTime=2e3]="AcknowledgeTime",w[w.TimeoutTime=2e4]="TimeoutTime",w[w.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",w[w.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",w[w.KeepAliveSendTime=5e3]="KeepAliveSendTime",w[w.LatencySampleTime=6e4]="LatencySampleTime",w[w.LatencySampleCount=5]="LatencySampleCount",w[w.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",w[w.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(D,F,x,q){this.type=D,this.id=F,this.ack=x,this.data=q,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends R.Disposable{constructor(D){super(),this.f=this.B(new u.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=D,this.b=!1,this.c=new v,this.B(this.a.onData(F=>this.acceptChunk(F))),this.lastReadTime=Date.now()}acceptChunk(D){if(!(!D||D.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(D);this.c.byteLength>=this.g.readLen;){const F=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=F.readUInt32BE(9),this.g.messageType=F.readUInt8(0),this.g.id=F.readUInt32BE(1),this.g.ack=F.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:E(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const x=this.g.messageType,q=this.g.id,M=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",F),this.f.fire(new d(x,q,M,F)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(D){this.k=null,this.a=!1,this.b=!1,this.c=D,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(D){if(this.a)return;D.writtenTime=Date.now(),this.lastWriteTime=Date.now();const F=A.VSBuffer.alloc(13);F.writeUInt8(D.type,0),F.writeUInt32BE(D.id,1),F.writeUInt32BE(D.ack,5),F.writeUInt32BE(D.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:E(D.type),id:D.id,ack:D.ack,messageSize:D.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",D.data),this.j(F,D.data)}g(D,F){const x=this.f===0;return this.d.push(D,F),this.f+=D.byteLength+F.byteLength,x}h(){const D=A.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,D}j(D,F){this.g(D,F)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const D=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:D.byteLength}),this.c.write(D)}}class p extends R.Disposable{constructor(D){super(),this.f=new u.Emitter,this.onMessage=this.f.event,this.g=new u.Emitter,this.onDidDispose=this.g.event,this.a=D,this.b=this.B(new g(this.a)),this.c=this.B(new h(this.a)),this.B(this.c.onMessage(F=>{F.type===1&&this.f.fire(F.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(D){this.b.write(new d(1,0,0,D))}}e.Protocol=p;class y extends C.IPCClient{static fromSocket(D,F){return new y(new p(D),F)}get onDidDispose(){return this.b.onDidDispose}constructor(D,F,x=null){super(D,F,x),this.b=D}dispose(){super.dispose();const D=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),D.end()}}e.Client=y;class b{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new u.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(D){this.b?this.d.length>0?this.d.push(D):this.a.fire(D):this.d.push(D)}flushBuffer(){this.d=[]}}e.BufferedEmitter=b;class i{constructor(D){this.data=D,this.next=null}}class o{constructor(){this.a=null,this.b=null}length(){let D=0,F=this.a;for(;F;)F=F.next,D++;return D}peek(){return this.a?this.a.data:null}toArray(){const D=[];let F=0,x=this.a;for(;x;)D[F++]=x.data,x=x.next;return D}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(D){const F=new i(D);if(!this.a){this.a=F,this.b=F;return}this.b.next=F,this.b=F}}class s{static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const D=Date.now();for(let F=0;F<s.a;F++)this.c[F]=D-1e3*F;setInterval(()=>{for(let F=s.a;F>=1;F--)this.c[F]=this.c[F-1];this.c[0]=Date.now()},1e3)}d(){const D=Date.now(),F=(1+s.a)*1e3;let x=0;for(let q=0;q<s.a;q++)D-this.c[q]<=F&&x++;return 1-x/s.a}hasHighLoad(){return this.d()>=.5}}s.a=10,s.b=null;var l;(function(w){w[w.Good=0]="Good",w[w.Poor=1]="Poor"})(l=e.ConnectionHealth||(e.ConnectionHealth={}));function r(w){switch(w){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=r;class m{constructor(D){this.connectionHealth=D}}e.ConnectionHealthChangedEvent=m;class n{constructor(D,F){this.roundTripTime=D,this.recentHighRoundTripCount=F}}e.HighRoundTripTimeEvent=n;class t{get unacknowledgedCount(){return this.c-this.d}constructor(D){this.x=new b,this.onControlMessage=this.x.event,this.y=new b,this.onMessage=this.y.event,this.z=new b,this.onDidDispose=this.z.event,this.A=new b,this.onSocketClose=this.A.event,this.B=new b,this.onSocketTimeout=this.B.event,this.C=new b,this.onHighRoundTripTime=this.C.event,this.D=new b,this.onDidChangeConnectionHealth=this.D.event,this.u=D.loadEstimator??s.getInstance(),this.v=D.measureRoundTripTime??!1,this.w=D.sendKeepAlive??!0,this.a=!1,this.b=new o,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new R.DisposableStore,this.o=D.socket,this.p=this.t.add(new g(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(F=>this.E(F))),this.t.add(this.o.onClose(F=>this.A.fire(F))),this.r=this.t.add(new a),this.t.add(this.r.onSendLatencyRequest(F=>this.J(F))),this.t.add(this.r.onHighRoundTripTime(F=>this.C.fire(F))),this.t.add(this.r.onDidChangeConnectionHealth(F=>this.D.fire(F))),this.v&&this.r.start(),D.initialChunk&&this.q.acceptChunk(D.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const D=new d(5,0,0,k());this.p.write(D),this.p.flush()}sendPause(){const D=new d(7,0,0,k());this.p.write(D)}sendResume(){const D=new d(8,0,0,k());this.p.write(D)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(D,F){this.a=!0,this.t.dispose(),this.t=new R.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=D,this.p=this.t.add(new g(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(x=>this.E(x))),this.t.add(this.o.onClose(x=>this.A.fire(x))),this.r=this.t.add(new a),this.t.add(this.r.onSendLatencyRequest(x=>this.J(x))),this.t.add(this.r.onHighRoundTripTime(x=>this.C.fire(x))),this.t.add(this.r.onDidChangeConnectionHealth(x=>this.D.fire(x))),this.q.acceptChunk(F)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const D=new d(3,0,this.h,k());this.p.write(D);const F=this.b.toArray();for(let x=0,q=F.length;x<q;x++)this.p.write(F[x]);this.G()}acceptDisconnect(){this.z.fire()}E(D){if(D.ack>this.d){this.d=D.ack;do{const F=this.b.peek();if(F&&F.id<=D.ack)this.b.pop();else break}while(!0)}switch(D.type){case 0:break;case 1:{if(D.id>this.g)if(D.id!==this.g+1){const F=Date.now();F-this.m>1e4&&(this.m=F,this.p.write(new d(6,0,0,k())))}else this.g=D.id,this.j=Date.now(),this.F(),this.y.fire(D.data);break}case 2:{this.x.fire(D.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const F=this.b.toArray();for(let x=0,q=F.length;x<q;x++)this.p.write(F[x]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(D.data);break}case 11:{this.r.handleResponse(D.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(D){const F=++this.c;this.h=this.g;const x=new d(1,F,this.h,D);this.b.push(x),this.a||(this.p.write(x),this.G())}sendControl(D){const F=new d(2,0,0,D);this.p.write(F)}F(){if(this.g<=this.h||this.k)return;const D=Date.now()-this.j;if(D>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-D+5)}G(){if(this.c<=this.d||this.f||this.a)return;const D=this.b.peek(),F=Date.now()-D.writtenTime,x=Date.now()-this.q.lastReadTime,q=Date.now()-this.n;if(F>=2e4&&x>=2e4&&q>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:F,timeSinceLastReceivedSomeData:x});return}const M=Math.max(2e4-F,2e4-x,2e4-q,500);this.f=setTimeout(()=>{this.f=null,this.G()},M)}H(){if(this.g<=this.h)return;this.h=this.g;const D=new d(3,0,this.h,k());this.p.write(D)}I(){this.h=this.g;const D=new d(9,0,this.h,k());this.p.write(D)}J(D){this.h=this.g;const F=new d(10,0,this.h,D);this.p.write(F)}K(D){this.h=this.g;const F=new d(11,0,this.h,D);this.p.write(F)}}e.PersistentProtocol=t;class a extends R.Disposable{constructor(){super(),this.a=this.B(new u.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new u.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new u.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new c.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},D=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const D=++this.h,F=A.VSBuffer.alloc(4);F.writeUInt32BE(D,0),this.a.fire(F)},6e4)}handleResponse(D){if(D.byteLength!==4)return;const F=D.readUInt32BE(0);if(this.g<=0||F!==this.h)return;const x=Date.now()-this.g,q=this.k++;this.j[q%this.j.length]=x;const M=this.l,B=this.j.filter(O=>O>=1e3).length;this.l=B>=3?1:0,x>1e3&&this.b.fire(new n(x,B)),M!==this.l&&this.c.fire(this.l)}}}),define(ye[119],De([1,0,22,11,3,6,10,12,30,117,118]),function(ne,e,c,A,u,R,C,P,S,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function k(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class v{traceSocketEvent(n,t){L.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,n,t)}constructor(n,t=""){this.f=!0,this.debugLabel=t,this.socket=n,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=a=>{if(this.traceSocketEvent("error",{code:a?.code,message:a?.message}),a){if(a.code==="EPIPE")return;(0,A.onUnexpectedError)(a)}},this.socket.on("error",this.a),this.b=a=>{this.traceSocketEvent("close",{hadError:a}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(n){const t=a=>{this.traceSocketEvent("read",a),n(c.VSBuffer.wrap(a))};return this.socket.on("data",t),{dispose:()=>this.socket.off("data",t)}}onClose(n){const t=a=>{n({type:0,hadError:a,error:void 0})};return this.socket.on("close",t),{dispose:()=>this.socket.off("close",t)}}onEnd(n){const t=()=>{n()};return this.socket.on("end",t),{dispose:()=>this.socket.off("end",t)}}write(n){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",n),this.socket.write(n.buffer,t=>{if(t){if(t.code==="EPIPE")return;(0,A.onUnexpectedError)(t)}})}catch(t){if(t.code==="EPIPE")return;(0,A.onUnexpectedError)(t)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((n,t)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),n();return}const a=()=>{this.socket.off("close",a),this.socket.off("end",a),this.socket.off("error",a),this.socket.off("timeout",a),this.socket.off("drain",a),this.traceSocketEvent("nodeDrainEnd"),n()};this.socket.on("close",a),this.socket.on("end",a),this.socket.on("error",a),this.socket.on("timeout",a),this.socket.on("drain",a)})}}e.NodeSocket=v;var T;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize"})(T||(T={}));var E;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(E||(E={}));class f extends R.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(n,t){this.socket.traceSocketEvent(n,t)}constructor(n,t,a,w){super(),this.f=this.B(new u.Emitter),this.g=this.B(new u.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=n,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:t,inflateBytesLength:a?.byteLength||0,recordInflateBytes:w}),this.a=this.B(new d(this,t,a,w,this.f,(D,F)=>this.k(D,F))),this.B(this.a.onError(D=>{console.error(D),(0,A.onUnexpectedError)(D),this.g.fire({type:0,hadError:!0,error:D})})),this.b=new L.ChunkStream,this.B(this.socket.onData(D=>this.l(D))),this.B(this.socket.onClose(D=>this.g.fire(D)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(n){return this.f.event(n)}onClose(n){return this.g.event(n)}onEnd(n){return this.socket.onEnd(n)}write(n){this.a.writeMessage(n)}k(n,t){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",n);let a=2;n.byteLength<126?a+=0:n.byteLength<2**16?a+=2:a+=8;const w=c.VSBuffer.alloc(a);if(t?w.writeUInt8(194,0):w.writeUInt8(130,0),n.byteLength<126)w.writeUInt8(n.byteLength,1);else if(n.byteLength<2**16){w.writeUInt8(126,1);let D=1;w.writeUInt8(n.byteLength>>>8&255,++D),w.writeUInt8(n.byteLength>>>0&255,++D)}else{w.writeUInt8(127,1);let D=1;w.writeUInt8(0,++D),w.writeUInt8(0,++D),w.writeUInt8(0,++D),w.writeUInt8(0,++D),w.writeUInt8(n.byteLength>>>24&255,++D),w.writeUInt8(n.byteLength>>>16&255,++D),w.writeUInt8(n.byteLength>>>8&255,++D),w.writeUInt8(n.byteLength>>>0&255,++D)}this.socket.write(c.VSBuffer.concat([w,n]))}end(){this.h=!0,this.socket.end()}l(n){if(n.byteLength!==0){for(this.b.acceptChunk(n);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const t=this.b.peek(this.j.readLen),a=t.readUInt8(0),w=(a&128)>>>7,D=(a&64)>>>6,F=t.readUInt8(1),x=(F&128)>>>7,q=F&127;this.j.state=2,this.j.readLen=2+(x?4:0)+(q===126?2:0)+(q===127?8:0),this.j.fin=w,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(D)),this.j.firstFrameOfMessage=Boolean(w),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const t=this.b.read(this.j.readLen),a=t.readUInt8(1),w=(a&128)>>>7;let D=a&127,F=1;D===126?D=t.readUInt8(++F)*2**8+t.readUInt8(++F):D===127&&(D=t.readUInt8(++F)*0+t.readUInt8(++F)*0+t.readUInt8(++F)*0+t.readUInt8(++F)*0+t.readUInt8(++F)*2**24+t.readUInt8(++F)*2**16+t.readUInt8(++F)*2**8+t.readUInt8(++F));let x=0;w&&(x=t.readUInt8(++F)*2**24+t.readUInt8(++F)*2**16+t.readUInt8(++F)*2**8+t.readUInt8(++F)),this.j.state=3,this.j.readLen=D,this.j.mask=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const t=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",t),p(t,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",t),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(t,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await u.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=f;class d extends R.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:c.VSBuffer.alloc(0)}constructor(n,t,a,w,D,F){super(),this.k=n,this.l=D,this.m=F,this.a=this.B(new u.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new u.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,t?(this.b=this.B(new h(this.k,w,a,{windowBits:15})),this.f=this.B(new g(this.k,{windowBits:15})),this.B(this.b.onError(x=>this.a.fire(x))),this.B(this.f.onError(x=>this.a.fire(x)))):(this.b=null,this.f=null)}writeMessage(n){this.g.push(n),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const n=this.g.shift();if(this.f){const t=await this.r(this.f,n);this.m(t,!0)}else this.m(n,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(n,t){return new Promise((a,w)=>{n.write(t),n.flush(D=>a(D))})}acceptFrame(n,t,a){this.h.push({data:n,isCompressed:t,isLastFrameOfMessage:a}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const n=this.h.shift();if(this.b&&n.isCompressed){const t=await this.u(this.b,n.data,n.isLastFrameOfMessage);this.l.fire(t)}else this.l.fire(n.data)}this.s=!1}}u(n,t,a){return new Promise((w,D)=>{n.write(t),a&&n.write(c.VSBuffer.fromByteArray([0,0,255,255])),n.flush(F=>w(F))})}}class h extends R.Disposable{get recordedInflateBytes(){return this.j?c.VSBuffer.concat(this.f):c.VSBuffer.alloc(0)}constructor(n,t,a,w){super(),this.h=n,this.j=t,this.a=this.B(new u.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=k().zlib.createInflateRaw(w),this.b.on("error",D=>{this.h.traceSocketEvent("zlibInflateError",{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.h.traceSocketEvent("zlibInflateData",D),this.g.push(c.VSBuffer.wrap(D))}),a&&(this.h.traceSocketEvent("zlibInflateInitialWrite",a.buffer),this.b.write(a.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(n){this.j&&this.f.push(n.clone()),this.h.traceSocketEvent("zlibInflateWrite",n),this.b.write(n.buffer)}flush(n){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const t=c.VSBuffer.concat(this.g);this.g.length=0,n(t)})}}class g extends R.Disposable{constructor(n,t){super(),this.g=n,this.a=this.B(new u.Emitter),this.onError=this.a.event,this.f=[],this.b=k().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",a=>{this.g.traceSocketEvent("zlibDeflateError",{message:a?.message,code:a?.code}),this.a.fire(a)}),this.b.on("data",a=>{this.g.traceSocketEvent("zlibDeflateData",a),this.f.push(c.VSBuffer.wrap(a))})}write(n){this.g.traceSocketEvent("zlibDeflateWrite",n.buffer),this.b.write(n.buffer)}flush(n){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let t=c.VSBuffer.concat(this.f);this.f.length=0,t=t.slice(0,t.byteLength-4),n(t)})}}function p(m,n){if(n===0)return;const t=m.byteLength>>>2;for(let q=0;q<t;q++){const M=m.readUInt32BE(q*4);m.writeUInt32BE(M^n,q*4)}const a=t*4,w=m.byteLength-a,D=n>>>24&255,F=n>>>16&255,x=n>>>8&255;w>=1&&m.writeUInt8(m.readUInt8(a)^D,a),w>=2&&m.writeUInt8(m.readUInt8(a+1)^F,a+1),w>=3&&m.writeUInt8(m.readUInt8(a+2)^x,a+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const y={[2]:107,[1]:103};function b(){const m=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;let n;return e.XDG_RUNTIME_DIR?n=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${m}.sock`):n=(0,C.join)(k().os.tmpdir(),`vscode-ipc-${m}.sock`),o(n),n}e.createRandomIPCHandle=b;function i(m,n,t){const a=k().crypto.createHash("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${a}-${t}-${n}-sock`;let w;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?w=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${a.substr(0,8)}-${t}-${n}.sock`):w=(0,C.join)(m,`${t}-${n}.sock`),o(w),w}e.createStaticIPCHandle=i;function o(m){const n=y[P.platform];typeof n=="number"&&m.length>=n&&console.warn(`WARNING: IPC handle "${m}" is longer than ${n} chars, try a shorter --user-data-dir`)}class s extends I.IPCServer{static b(n){const t=u.Event.fromNodeEventEmitter(n,"connection");return u.Event.map(t,a=>({protocol:new L.Protocol(new v(a,"ipc-server-connection")),onDidClientDisconnect:u.Event.once(u.Event.fromNodeEventEmitter(a,"close"))}))}constructor(n){super(s.b(n)),this.d=n}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=s;function l(m){return new Promise((n,t)=>{const a=k().net.createServer();a.on("error",t),a.listen(m,()=>{a.removeListener("error",t),n(new s(a))})})}e.serve=l;function r(m,n){return new Promise((t,a)=>{const w=k().net.createConnection(m,()=>{w.removeListener("error",a),t(L.Client.fromSocket(new v(w,`ipc-client${n}`),n))});w.once("error",a)})}e.connect=r}),define(ye[164],De([1,0,38,10]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function u(R,C,P,S,I,L){if(Array.isArray(R)){let k=0;for(const v of R){const T=u(v,C,P,S,I,L);if(T===10)return T;T>k&&(k=T)}return k}else{if(typeof R=="string")return S?R==="*"?5:R===P?10:0:0;if(R){const{language:k,pattern:v,scheme:T,hasAccessToAllModels:E,notebookType:f}=R;if(!S&&!E)return 0;f&&I&&(C=I);let d=0;if(T)if(T===C.scheme)d=10;else if(T==="*")d=5;else return 0;if(k)if(k===P)d=10;else if(k==="*")d=Math.max(d,5);else return 0;if(f)if(f===L)d=10;else if(f==="*"&&L!==void 0)d=Math.max(d,5);else return 0;if(v){let h;if(typeof v=="string"?h=v:h={...v,base:(0,A.normalize)(v.base)},h===C.fsPath||(0,c.match)(h,C.fsPath))d=10;else return 0}return d}else return 0}}e.score=u}),define(ye[165],De([1,0,8,52,155]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class R{constructor(P,S,I,L){this.c=P,this.d=S,this.f=I,this.g=L,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(P){P.eol&&P.eol!==this.f&&(this.f=P.eol,this.h=null);const S=P.changes;for(const I of S)this.n(I.range),this.o(new A.Position(I.range.startLineNumber,I.range.startColumn),I.text);this.g=P.versionId,this.j=null}k(){if(!this.h){const P=this.f.length,S=this.d.length,I=new Uint32Array(S);for(let L=0;L<S;L++)I[L]=this.d[L].length+P;this.h=new u.PrefixSumComputer(I)}}l(P,S){this.d[P]=S,this.h&&this.h.setValue(P,this.d[P].length+this.f.length)}n(P){if(P.startLineNumber===P.endLineNumber){if(P.startColumn===P.endColumn)return;this.l(P.startLineNumber-1,this.d[P.startLineNumber-1].substring(0,P.startColumn-1)+this.d[P.startLineNumber-1].substring(P.endColumn-1));return}this.l(P.startLineNumber-1,this.d[P.startLineNumber-1].substring(0,P.startColumn-1)+this.d[P.endLineNumber-1].substring(P.endColumn-1)),this.d.splice(P.startLineNumber,P.endLineNumber-P.startLineNumber),this.h&&this.h.removeValues(P.startLineNumber,P.endLineNumber-P.startLineNumber)}o(P,S){if(S.length===0)return;const I=(0,c.splitLines)(S);if(I.length===1){this.l(P.lineNumber-1,this.d[P.lineNumber-1].substring(0,P.column-1)+I[0]+this.d[P.lineNumber-1].substring(P.column-1));return}I[I.length-1]+=this.d[P.lineNumber-1].substring(P.column-1),this.l(P.lineNumber-1,this.d[P.lineNumber-1].substring(0,P.column-1)+I[0]);const L=new Uint32Array(I.length-1);for(let k=1;k<I.length;k++)this.d.splice(P.lineNumber+k-1,0,I[k]),L[k-1]=I[k].length+this.f.length;this.h&&this.h.insertValues(P.lineNumber,L)}}e.MirrorTextModel=R}),define(ye[166],De([1,0,8,152,52,32,107]),function(ne,e,c,A,u,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class S{constructor(g,p,y,b){this.searchString=g,this.isRegex=p,this.matchCase=y,this.wordSeparators=b}parseSearchRequest(){if(this.searchString==="")return null;let g;this.isRegex?g=I(this.searchString):g=this.searchString.indexOf(`
`)>=0;let p=null;try{p=c.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:g,global:!0,unicode:!0})}catch{return null}if(!p)return null;let y=!this.isRegex&&!g;return y&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(y=this.matchCase),new C.SearchData(p,this.wordSeparators?(0,A.getMapForWordSeparators)(this.wordSeparators):null,y?this.searchString:null)}}e.SearchParams=S;function I(h){if(!h||h.length===0)return!1;for(let g=0,p=h.length;g<p;g++){const y=h.charCodeAt(g);if(y===10)return!0;if(y===92){if(g++,g>=p)break;const b=h.charCodeAt(g);if(b===110||b===114||b===87)return!0}}return!1}e.isMultilineRegexSource=I;function L(h,g,p){if(!p)return new C.FindMatch(h,null);const y=[];for(let b=0,i=g.length;b<i;b++)y[b]=g[b];return new C.FindMatch(h,y)}e.createFindMatch=L;class k{constructor(g){const p=[];let y=0;for(let b=0,i=g.length;b<i;b++)g.charCodeAt(b)===10&&(p[y++]=b);this.a=p}findLineFeedCountBeforeOffset(g){const p=this.a;let y=0,b=p.length-1;if(b===-1||g<=p[0])return 0;for(;y<b;){const i=y+((b-y)/2>>0);p[i]>=g?b=i-1:p[i+1]>=g?(y=i,b=i):y=i+1}return y+1}}class v{static findMatches(g,p,y,b,i){const o=p.parseSearchRequest();return o?o.regex.multiline?this.b(g,y,new d(o.wordSeparators,o.regex),b,i):this.c(g,y,o,b,i):[]}static a(g,p,y,b,i,o){let s,l=0;b?(l=b.findLineFeedCountBeforeOffset(i),s=p+i+l):s=p+i;let r;if(b){const a=b.findLineFeedCountBeforeOffset(i+o.length)-l;r=s+o.length+a}else r=s+o.length;const m=g.getPositionAt(s),n=g.getPositionAt(r);return new R.Range(m.lineNumber,m.column,n.lineNumber,n.column)}static b(g,p,y,b,i){const o=g.getOffsetAt(p.getStartPosition()),s=g.getValueInRange(p,1),l=g.getEOL()===`\r
`?new k(s):null,r=[];let m=0,n;for(y.reset(0);n=y.next(s);)if(r[m++]=L(this.a(g,o,s,l,n.index,n[0]),n,b),m>=i)return r;return r}static c(g,p,y,b,i){const o=[];let s=0;if(p.startLineNumber===p.endLineNumber){const r=g.getLineContent(p.startLineNumber).substring(p.startColumn-1,p.endColumn-1);return s=this.d(y,r,p.startLineNumber,p.startColumn-1,s,o,b,i),o}const l=g.getLineContent(p.startLineNumber).substring(p.startColumn-1);s=this.d(y,l,p.startLineNumber,p.startColumn-1,s,o,b,i);for(let r=p.startLineNumber+1;r<p.endLineNumber&&s<i;r++)s=this.d(y,g.getLineContent(r),r,0,s,o,b,i);if(s<i){const r=g.getLineContent(p.endLineNumber).substring(0,p.endColumn-1);s=this.d(y,r,p.endLineNumber,0,s,o,b,i)}return o}static d(g,p,y,b,i,o,s,l){const r=g.wordSeparators;if(!s&&g.simpleSearch){const t=g.simpleSearch,a=t.length,w=p.length;let D=-a;for(;(D=p.indexOf(t,D+a))!==-1;)if((!r||f(r,p,w,D,a))&&(o[i++]=new C.FindMatch(new R.Range(y,D+1+b,y,D+1+a+b),null),i>=l))return i;return i}const m=new d(g.wordSeparators,g.regex);let n;m.reset(0);do if(n=m.next(p),n&&(o[i++]=L(new R.Range(y,n.index+1+b,y,n.index+1+n[0].length+b),n,s),i>=l))return i;while(n);return i}static findNextMatch(g,p,y,b){const i=p.parseSearchRequest();if(!i)return null;const o=new d(i.wordSeparators,i.regex);return i.regex.multiline?this.e(g,y,o,b):this.f(g,y,o,b)}static e(g,p,y,b){const i=new u.Position(p.lineNumber,1),o=g.getOffsetAt(i),s=g.getLineCount(),l=g.getValueInRange(new R.Range(i.lineNumber,i.column,s,g.getLineMaxColumn(s)),1),r=g.getEOL()===`\r
`?new k(l):null;y.reset(p.column-1);const m=y.next(l);return m?L(this.a(g,o,l,r,m.index,m[0]),m,b):p.lineNumber!==1||p.column!==1?this.e(g,new u.Position(1,1),y,b):null}static f(g,p,y,b){const i=g.getLineCount(),o=p.lineNumber,s=g.getLineContent(o),l=this.g(y,s,o,p.column,b);if(l)return l;for(let r=1;r<=i;r++){const m=(o+r-1)%i,n=g.getLineContent(m+1),t=this.g(y,n,m+1,1,b);if(t)return t}return null}static g(g,p,y,b,i){g.reset(b-1);const o=g.next(p);return o?L(new R.Range(y,o.index+1,y,o.index+1+o[0].length),o,i):null}static findPreviousMatch(g,p,y,b){const i=p.parseSearchRequest();if(!i)return null;const o=new d(i.wordSeparators,i.regex);return i.regex.multiline?this.h(g,y,o,b):this.j(g,y,o,b)}static h(g,p,y,b){const i=this.b(g,new R.Range(1,1,p.lineNumber,p.column),y,b,10*P);if(i.length>0)return i[i.length-1];const o=g.getLineCount();return p.lineNumber!==o||p.column!==g.getLineMaxColumn(o)?this.h(g,new u.Position(o,g.getLineMaxColumn(o)),y,b):null}static j(g,p,y,b){const i=g.getLineCount(),o=p.lineNumber,s=g.getLineContent(o).substring(0,p.column-1),l=this.k(y,s,o,b);if(l)return l;for(let r=1;r<=i;r++){const m=(i+o-r-1)%i,n=g.getLineContent(m+1),t=this.k(y,n,m+1,b);if(t)return t}return null}static k(g,p,y,b){let i=null,o;for(g.reset(0);o=g.next(p);)i=L(new R.Range(y,o.index+1,y,o.index+1+o[0].length),o,b);return i}}e.TextModelSearch=v;function T(h,g,p,y,b){if(y===0)return!0;const i=g.charCodeAt(y-1);if(h.get(i)!==0||i===13||i===10)return!0;if(b>0){const o=g.charCodeAt(y);if(h.get(o)!==0)return!0}return!1}function E(h,g,p,y,b){if(y+b===p)return!0;const i=g.charCodeAt(y+b);if(h.get(i)!==0||i===13||i===10)return!0;if(b>0){const o=g.charCodeAt(y+b-1);if(h.get(o)!==0)return!0}return!1}function f(h,g,p,y,b){return T(h,g,p,y,b)&&E(h,g,p,y,b)}e.isValidMatch=f;class d{constructor(g,p){this._wordSeparators=g,this.a=p,this.b=-1,this.c=0}reset(g){this.a.lastIndex=g,this.b=-1,this.c=0}next(g){const p=g.length;let y;do{if(this.b+this.c===p||(y=this.a.exec(g),!y))return null;const b=y.index,i=y[0].length;if(b===this.b&&i===this.c){if(i===0){c.getNextCodePoint(g,p,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=b,this.c=i,!this._wordSeparators||f(this._wordSeparators,g,p,b,i))return y}while(y);return null}}e.Searcher=d}),define(ye[120],De([1,0,22,12]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var u;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(u||(u={}));function R(k){for(let v=0,T=k.length;v<T;v+=4){const E=k[v+0],f=k[v+1],d=k[v+2],h=k[v+3];k[v+0]=h,k[v+1]=d,k[v+2]=f,k[v+3]=E}}function C(k){const v=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return A.isLittleEndian()||R(v),c.VSBuffer.wrap(v)}function P(k){const v=k.buffer;if(A.isLittleEndian()||R(v),v.byteOffset%4===0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const T=new Uint8Array(v.byteLength);return T.set(v),new Uint32Array(T.buffer,T.byteOffset,T.length/4)}}function S(k){const v=new Uint32Array(I(k));let T=0;if(v[T++]=k.id,k.type==="full")v[T++]=1,v[T++]=k.data.length,v.set(k.data,T),T+=k.data.length;else{v[T++]=2,v[T++]=k.deltas.length;for(const E of k.deltas)v[T++]=E.start,v[T++]=E.deleteCount,E.data?(v[T++]=E.data.length,v.set(E.data,T),T+=E.data.length):v[T++]=0}return C(v)}e.encodeSemanticTokensDto=S;function I(k){let v=0;if(v+=1+1,k.type==="full")v+=1+k.data.length;else{v+=1,v+=(1+1+1)*k.deltas.length;for(const T of k.deltas)T.data&&(v+=T.data.length)}return v}function L(k){const v=P(k);let T=0;const E=v[T++];if(v[T++]===1){const g=v[T++],p=v.subarray(T,T+g);return T+=g,{id:E,type:"full",data:p}}const d=v[T++],h=[];for(let g=0;g<d;g++){const p=v[T++],y=v[T++],b=v[T++];let i;b>0&&(i=v.subarray(T,T+b),T+=b),h[g]={start:p,deleteCount:y,data:i}}return{id:E,type:"delta",deltas:h}}e.decodeSemanticTokensDto=L}),define(ye[167],De([1,0,3,6]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class u{constructor(){this.a=new Map,this.b=new Map,this.c=new c.Emitter,this.onDidChange=this.c.event,this.d=null}fire(P){this.c.fire({changedLanguages:P,changedColorMap:!1})}register(P,S){return this.a.set(P,S),this.fire([P]),(0,A.toDisposable)(()=>{this.a.get(P)===S&&(this.a.delete(P),this.fire([P]))})}registerFactory(P,S){this.b.get(P)?.dispose();const I=new R(this,P,S);return this.b.set(P,I),(0,A.toDisposable)(()=>{const L=this.b.get(P);!L||L!==I||(this.b.delete(P),L.dispose())})}async getOrCreate(P){const S=this.get(P);if(S)return S;const I=this.b.get(P);return!I||I.isResolved?null:(await I.resolve(),this.get(P))}get(P){return this.a.get(P)||null}isResolved(P){if(this.get(P))return!0;const I=this.b.get(P);return!!(!I||I.isResolved)}setColorMap(P){this.d=P,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=u;class R extends A.Disposable{get isResolved(){return this.c}constructor(P,S,I){super(),this.f=P,this.g=S,this.h=I,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const P=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,P&&!this.a&&this.B(this.f.register(this.g,P))}}}),define(ye[71],De([1,0,67,2,32,167]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class C{constructor(a,w,D){this._tokenBrand=void 0,this.offset=a,this.type=w,this.language=D}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=C;class P{constructor(a,w){this._tokenizationResultBrand=void 0,this.tokens=a,this.endState=w}}e.TokenizationResult=P;class S{constructor(a,w){this._encodedTokenizationResultBrand=void 0,this.tokens=a,this.endState=w}}e.EncodedTokenizationResult=S;var I;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(I=e.CompletionItemKind||(e.CompletionItemKind={}));var L;(function(t){const a=new Map;a.set(0,c.Codicon.symbolMethod),a.set(1,c.Codicon.symbolFunction),a.set(2,c.Codicon.symbolConstructor),a.set(3,c.Codicon.symbolField),a.set(4,c.Codicon.symbolVariable),a.set(5,c.Codicon.symbolClass),a.set(6,c.Codicon.symbolStruct),a.set(7,c.Codicon.symbolInterface),a.set(8,c.Codicon.symbolModule),a.set(9,c.Codicon.symbolProperty),a.set(10,c.Codicon.symbolEvent),a.set(11,c.Codicon.symbolOperator),a.set(12,c.Codicon.symbolUnit),a.set(13,c.Codicon.symbolValue),a.set(15,c.Codicon.symbolEnum),a.set(14,c.Codicon.symbolConstant),a.set(15,c.Codicon.symbolEnum),a.set(16,c.Codicon.symbolEnumMember),a.set(17,c.Codicon.symbolKeyword),a.set(27,c.Codicon.symbolSnippet),a.set(18,c.Codicon.symbolText),a.set(19,c.Codicon.symbolColor),a.set(20,c.Codicon.symbolFile),a.set(21,c.Codicon.symbolReference),a.set(22,c.Codicon.symbolCustomColor),a.set(23,c.Codicon.symbolFolder),a.set(24,c.Codicon.symbolTypeParameter),a.set(25,c.Codicon.account),a.set(26,c.Codicon.issues);function w(x){let q=a.get(x);return q||(console.info("No codicon found for CompletionItemKind "+x),q=c.Codicon.symbolProperty),q}t.toIcon=w;const D=new Map;D.set("method",0),D.set("function",1),D.set("constructor",2),D.set("field",3),D.set("variable",4),D.set("class",5),D.set("struct",6),D.set("interface",7),D.set("module",8),D.set("property",9),D.set("event",10),D.set("operator",11),D.set("unit",12),D.set("value",13),D.set("constant",14),D.set("enum",15),D.set("enum-member",16),D.set("enumMember",16),D.set("keyword",17),D.set("snippet",27),D.set("text",18),D.set("color",19),D.set("file",20),D.set("reference",21),D.set("customcolor",22),D.set("folder",23),D.set("type-parameter",24),D.set("typeParameter",24),D.set("account",25),D.set("issue",26);function F(x,q){let M=D.get(x);return typeof M>"u"&&!q&&(M=9),M}t.fromString=F})(L=e.CompletionItemKinds||(e.CompletionItemKinds={}));var k;(function(t){t[t.Deprecated=1]="Deprecated"})(k=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var T;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(T=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var f;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(f=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var h;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(h=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function g(t){return t&&A.URI.isUri(t.uri)&&u.Range.isIRange(t.range)&&(u.Range.isIRange(t.originSelectionRange)||u.Range.isIRange(t.targetSelectionRange))}e.isLocationLink=g;var p;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(p=e.SymbolKind||(e.SymbolKind={}));var y;(function(t){t[t.Deprecated=1]="Deprecated"})(y=e.SymbolTag||(e.SymbolTag={}));var b;(function(t){const a=new Map;a.set(0,c.Codicon.symbolFile),a.set(1,c.Codicon.symbolModule),a.set(2,c.Codicon.symbolNamespace),a.set(3,c.Codicon.symbolPackage),a.set(4,c.Codicon.symbolClass),a.set(5,c.Codicon.symbolMethod),a.set(6,c.Codicon.symbolProperty),a.set(7,c.Codicon.symbolField),a.set(8,c.Codicon.symbolConstructor),a.set(9,c.Codicon.symbolEnum),a.set(10,c.Codicon.symbolInterface),a.set(11,c.Codicon.symbolFunction),a.set(12,c.Codicon.symbolVariable),a.set(13,c.Codicon.symbolConstant),a.set(14,c.Codicon.symbolString),a.set(15,c.Codicon.symbolNumber),a.set(16,c.Codicon.symbolBoolean),a.set(17,c.Codicon.symbolArray),a.set(18,c.Codicon.symbolObject),a.set(19,c.Codicon.symbolKey),a.set(20,c.Codicon.symbolNull),a.set(21,c.Codicon.symbolEnumMember),a.set(22,c.Codicon.symbolStruct),a.set(23,c.Codicon.symbolEvent),a.set(24,c.Codicon.symbolOperator),a.set(25,c.Codicon.symbolTypeParameter);function w(D){let F=a.get(D);return F||(console.info("No codicon found for SymbolKind "+D),F=c.Codicon.symbolProperty),F}t.toIcon=w})(b=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(a){this.value=a}}i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region"),e.FoldingRangeKind=i;var o;(function(t){function a(w){return!w||typeof w!="object"?!1:typeof w.id=="string"&&typeof w.title=="string"}t.is=a})(o=e.Command||(e.Command={}));var s;(function(t){t[t.Collapsed=0]="Collapsed",t[t.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var l;(function(t){t[t.Unresolved=0]="Unresolved",t[t.Resolved=1]="Resolved"})(l=e.CommentThreadState||(e.CommentThreadState={}));var r;(function(t){t[t.Editing=0]="Editing",t[t.Preview=1]="Preview"})(r=e.CommentMode||(e.CommentMode={}));var m;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(m=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new R.TokenizationRegistry;var n;(function(t){t[t.None=0]="None",t[t.Option=1]="Option",t[t.Default=2]="Default",t[t.Preferred=3]="Preferred"})(n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ye[168],De([16,17]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(ye[121],De([1,0,168,12,106,15,23,151]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(ce){ce[ce.None=0]="None",ce[ce.Keep=1]="Keep",ce[ce.Brackets=2]="Brackets",ce[ce.Advanced=3]="Advanced",ce[ce.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class I{constructor($){this.c=$}hasChanged($){return this.c[$]}}e.ConfigurationChangedEvent=I;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class k{constructor($,ue,Ie,Le){this.id=$,this.name=ue,this.defaultValue=Ie,this.schema=Le}applyUpdate($,ue){return T($,ue)}compute($,ue,Ie){return Ie}}class v{constructor($,ue){this.newValue=$,this.didChange=ue}}e.ApplyUpdateResult=v;function T(ce,$){if(typeof ce!="object"||typeof $!="object"||!ce||!$)return new v($,ce!==$);if(Array.isArray(ce)||Array.isArray($)){const Ie=Array.isArray(ce)&&Array.isArray($)&&R.equals(ce,$);return new v($,!Ie)}let ue=!1;for(const Ie in $)if($.hasOwnProperty(Ie)){const Le=T(ce[Ie],$[Ie]);Le.didChange&&(ce[Ie]=Le.newValue,ue=!0)}return new v(ce,ue)}class E{constructor($){this.schema=void 0,this.id=$,this.name="_never_",this.defaultValue=void 0}applyUpdate($,ue){return T($,ue)}validate($){return this.defaultValue}}class f{constructor($,ue,Ie,Le){this.id=$,this.name=ue,this.defaultValue=Ie,this.schema=Le}applyUpdate($,ue){return T($,ue)}validate($){return typeof $>"u"?this.defaultValue:$}compute($,ue,Ie){return Ie}}function d(ce,$){return typeof ce>"u"?$:ce==="false"?!1:Boolean(ce)}e.boolean=d;class h extends f{constructor($,ue,Ie,Le=void 0){typeof Le<"u"&&(Le.type="boolean",Le.default=Ie),super($,ue,Ie,Le)}validate($){return d($,this.defaultValue)}}function g(ce,$,ue,Ie){if(typeof ce>"u")return $;let Le=parseInt(ce,10);return isNaN(Le)?$:(Le=Math.max(ue,Le),Le=Math.min(Ie,Le),Le|0)}e.clampedInt=g;class p extends f{static clampedInt($,ue,Ie,Le){return g($,ue,Ie,Le)}constructor($,ue,Ie,Le,$e,Ke=void 0){typeof Ke<"u"&&(Ke.type="integer",Ke.default=Ie,Ke.minimum=Le,Ke.maximum=$e),super($,ue,Ie,Ke),this.minimum=Le,this.maximum=$e}validate($){return p.clampedInt($,this.defaultValue,this.minimum,this.maximum)}}class y extends f{static clamp($,ue,Ie){return $<ue?ue:$>Ie?Ie:$}static float($,ue){if(typeof $=="number")return $;if(typeof $>"u")return ue;const Ie=parseFloat($);return isNaN(Ie)?ue:Ie}constructor($,ue,Ie,Le,$e){typeof $e<"u"&&($e.type="number",$e.default=Ie),super($,ue,Ie,$e),this.validationFn=Le}validate($){return this.validationFn(y.float($,this.defaultValue))}}class b extends f{static string($,ue){return typeof $!="string"?ue:$}constructor($,ue,Ie,Le=void 0){typeof Le<"u"&&(Le.type="string",Le.default=Ie),super($,ue,Ie,Le)}validate($){return b.string($,this.defaultValue)}}function i(ce,$,ue){return typeof ce!="string"||ue.indexOf(ce)===-1?$:ce}e.stringSet=i;class o extends f{constructor($,ue,Ie,Le,$e=void 0){typeof $e<"u"&&($e.type="string",$e.enum=Le,$e.default=Ie),super($,ue,Ie,$e),this.c=Le}validate($){return i($,this.defaultValue,this.c)}}class s extends k{constructor($,ue,Ie,Le,$e,Ke,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=$e,Ze.default=Le),super($,ue,Ie,Ze),this.c=$e,this.d=Ke}validate($){return typeof $!="string"?this.defaultValue:this.c.indexOf($)===-1?this.defaultValue:this.d($)}}function l(ce){switch(ce){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",tags:["accessibility"],description:c.localize(3,null)})}validate($){switch($){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute($,ue,Ie){return Ie===0?$.accessibilitySupport:Ie}}class m extends k{constructor(){const $={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",$,{"editor.comments.insertSpace":{type:"boolean",default:$.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:$.ignoreEmptyLines,description:c.localize(5,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{insertSpace:d(ue.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(ue.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(ce){ce[ce.Hidden=0]="Hidden",ce[ce.Blink=1]="Blink",ce[ce.Smooth=2]="Smooth",ce[ce.Phase=3]="Phase",ce[ce.Expand=4]="Expand",ce[ce.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function t(ce){switch(ce){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var a;(function(ce){ce[ce.Line=1]="Line",ce[ce.Block=2]="Block",ce[ce.Underline=3]="Underline",ce[ce.LineThin=4]="LineThin",ce[ce.BlockOutline=5]="BlockOutline",ce[ce.UnderlineThin=6]="UnderlineThin"})(a=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function w(ce){switch(ce){case a.Line:return"line";case a.Block:return"block";case a.Underline:return"underline";case a.LineThin:return"line-thin";case a.BlockOutline:return"block-outline";case a.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function D(ce){switch(ce){case"line":return a.Line;case"block":return a.Block;case"underline":return a.Underline;case"line-thin":return a.LineThin;case"block-outline":return a.BlockOutline;case"underline-thin":return a.UnderlineThin}}class F extends E{constructor(){super(135)}compute($,ue,Ie){const Le=["monaco-editor"];return ue.get(36)&&Le.push(ue.get(36)),$.extraEditorClassName&&Le.push($.extraEditorClassName),ue.get(70)==="default"?Le.push("mouse-default"):ue.get(70)==="copy"&&Le.push("mouse-copy"),ue.get(105)&&Le.push("showUnused"),ue.get(133)&&Le.push("showDeprecated"),Le.join(" ")}}class x extends h{constructor(){super(34,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute($,ue,Ie){return Ie&&$.emptySelectionClipboard}}class q extends k{constructor(){const $={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",$,{"editor.find.cursorMoveOnType":{type:"boolean",default:$.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:$.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:$.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:$.globalFindClipboard,description:c.localize(16,null),included:A.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:$.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:$.loop,description:c.localize(18,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{cursorMoveOnType:d(ue.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof $.seedSearchStringFromSelection=="boolean"?$.seedSearchStringFromSelection?"always":"never":i(ue.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof $.autoFindInSelection=="boolean"?$.autoFindInSelection?"always":"never":i(ue.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(ue.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(ue.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(ue.loop,this.defaultValue.loop)}}}class M extends k{constructor(){super(48,"fontLigatures",M.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate($){return typeof $>"u"?this.defaultValue:typeof $=="string"?$==="false"?M.OFF:$==="true"?M.ON:$:Boolean($)?M.ON:M.OFF}}M.OFF='"liga" off, "calt" off',M.ON='"liga" on, "calt" on',e.EditorFontLigatures=M;class B extends k{constructor(){super(51,"fontVariations",B.OFF,{anyOf:[{type:"boolean",description:c.localize(22,null)},{type:"string",description:c.localize(23,null)}],description:c.localize(24,null),default:!1})}validate($){return typeof $>"u"?this.defaultValue:typeof $=="string"?$==="false"?B.OFF:$==="true"?B.TRANSLATE:$:Boolean($)?B.TRANSLATE:B.OFF}compute($,ue,Ie){return $.fontInfo.fontVariationSettings}}B.OFF="normal",B.TRANSLATE="translate",e.EditorFontVariations=B;class O extends E{constructor(){super(47)}compute($,ue,Ie){return $.fontInfo}}class U extends f{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(25,null)})}validate($){const ue=y.float($,this.defaultValue);return ue===0?e.EDITOR_FONT_DEFAULTS.fontSize:y.clamp(ue,6,100)}compute($,ue,Ie){return $.fontInfo.fontSize}}class z extends k{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.d,maximum:z.e,errorMessage:c.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(27,null)})}validate($){return $==="normal"||$==="bold"?$:String(p.clampedInt($,e.EDITOR_FONT_DEFAULTS.fontWeight,z.d,z.e))}}z.c=["normal","bold","100","200","300","400","500","600","700","800","900"],z.d=1,z.e=1e3;class j extends k{constructor(){const $={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ue={type:"string",enum:["peek","gotoAndPeek","goto"],default:$.multiple,enumDescriptions:[c.localize(28,null),c.localize(29,null),c.localize(30,null)]},Ie=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",$,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(32,null),...ue},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(33,null),...ue},"editor.gotoLocation.multipleDeclarations":{description:c.localize(34,null),...ue},"editor.gotoLocation.multipleImplementations":{description:c.localize(35,null),...ue},"editor.gotoLocation.multipleReferences":{description:c.localize(36,null),...ue},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:$.alternativeDefinitionCommand,enum:Ie,description:c.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:$.alternativeTypeDefinitionCommand,enum:Ie,description:c.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:$.alternativeDeclarationCommand,enum:Ie,description:c.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:$.alternativeImplementationCommand,enum:Ie,description:c.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:$.alternativeReferenceCommand,enum:Ie,description:c.localize(41,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{multiple:i(ue.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ue.multipleDefinitions??i(ue.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ue.multipleTypeDefinitions??i(ue.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ue.multipleDeclarations??i(ue.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ue.multipleImplementations??i(ue.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ue.multipleReferences??i(ue.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:b.string(ue.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:b.string(ue.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:b.string(ue.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:b.string(ue.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:b.string(ue.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class de extends k{constructor(){const $={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",$,{"editor.hover.enabled":{type:"boolean",default:$.enabled,description:c.localize(42,null)},"editor.hover.delay":{type:"number",default:$.delay,minimum:0,maximum:1e4,description:c.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:$.sticky,description:c.localize(44,null)},"editor.hover.above":{type:"boolean",default:$.above,description:c.localize(45,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{enabled:d(ue.enabled,this.defaultValue.enabled),delay:p.clampedInt(ue.delay,this.defaultValue.delay,0,1e4),sticky:d(ue.sticky,this.defaultValue.sticky),above:d(ue.above,this.defaultValue.above)}}}var V;(function(ce){ce[ce.None=0]="None",ce[ce.Text=1]="Text",ce[ce.Blocks=2]="Blocks"})(V=e.RenderMinimap||(e.RenderMinimap={}));class X extends E{constructor(){super(138)}compute($,ue,Ie){return X.computeLayout(ue,{memory:$.memory,outerWidth:$.outerWidth,outerHeight:$.outerHeight,isDominatedByLongLines:$.isDominatedByLongLines,lineHeight:$.fontInfo.lineHeight,viewLineCount:$.viewLineCount,lineNumbersDigitCount:$.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:$.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:$.fontInfo.maxDigitWidth,pixelRatio:$.pixelRatio})}static computeContainedMinimapLineCount($){const ue=$.height/$.lineHeight,Ie=Math.floor($.paddingTop/$.lineHeight);let Le=Math.floor($.paddingBottom/$.lineHeight);$.scrollBeyondLastLine&&(Le=Math.max(Le,ue-1));const $e=(Ie+$.viewLineCount+Le)/($.pixelRatio*$.height),Ke=Math.floor($.viewLineCount/$e);return{typicalViewportLineCount:ue,extraLinesBeforeFirstLine:Ie,extraLinesBeyondLastLine:Le,desiredRatio:$e,minimapLineCount:Ke}}static c($,ue){const Ie=$.outerWidth,Le=$.outerHeight,$e=$.pixelRatio;if(!$.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor($e*Le),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Le};const Ke=ue.stableMinimapLayoutInput,Ze=Ke&&$.outerHeight===Ke.outerHeight&&$.lineHeight===Ke.lineHeight&&$.typicalHalfwidthCharacterWidth===Ke.typicalHalfwidthCharacterWidth&&$.pixelRatio===Ke.pixelRatio&&$.scrollBeyondLastLine===Ke.scrollBeyondLastLine&&$.paddingTop===Ke.paddingTop&&$.paddingBottom===Ke.paddingBottom&&$.minimap.enabled===Ke.minimap.enabled&&$.minimap.side===Ke.minimap.side&&$.minimap.size===Ke.minimap.size&&$.minimap.showSlider===Ke.minimap.showSlider&&$.minimap.renderCharacters===Ke.minimap.renderCharacters&&$.minimap.maxColumn===Ke.minimap.maxColumn&&$.minimap.scale===Ke.minimap.scale&&$.verticalScrollbarWidth===Ke.verticalScrollbarWidth&&$.isViewportWrapping===Ke.isViewportWrapping,pt=$.lineHeight,gt=$.typicalHalfwidthCharacterWidth,ct=$.scrollBeyondLastLine,Et=$.minimap.renderCharacters;let tt=$e>=2?Math.round($.minimap.scale*2):$.minimap.scale;const ft=$.minimap.maxColumn,At=$.minimap.size,Kt=$.minimap.side,Rt=$.verticalScrollbarWidth,mt=$.viewLineCount,Tt=$.remainingWidth,$t=$.isViewportWrapping,Nt=Et?2:3;let Xe=Math.floor($e*Le);const Mt=Xe/$e;let Ut=!1,Wt=!1,bt=Nt*tt,Re=tt/$e,Ne=1;if(At==="fill"||At==="fit"){const{typicalViewportLineCount:it,extraLinesBeforeFirstLine:lt,extraLinesBeyondLastLine:Pt,desiredRatio:St,minimapLineCount:yt}=X.computeContainedMinimapLineCount({viewLineCount:mt,scrollBeyondLastLine:ct,paddingTop:$.paddingTop,paddingBottom:$.paddingBottom,height:Le,lineHeight:pt,pixelRatio:$e});if(mt/yt>1)Ut=!0,Wt=!0,tt=1,bt=1,Re=tt/$e;else{let Dt=!1,Ct=tt+1;if(At==="fit"){const qt=Math.ceil((lt+mt+Pt)*bt);$t&&Ze&&Tt<=ue.stableFitRemainingWidth?(Dt=!0,Ct=ue.stableFitMaxMinimapScale):Dt=qt>Xe}if(At==="fill"||Dt){Ut=!0;const qt=tt;bt=Math.min(pt*$e,Math.max(1,Math.floor(1/St))),$t&&Ze&&Tt<=ue.stableFitRemainingWidth&&(Ct=ue.stableFitMaxMinimapScale),tt=Math.min(Ct,Math.max(1,Math.floor(bt/Nt))),tt>qt&&(Ne=Math.min(2,tt/qt)),Re=tt/$e/Ne,Xe=Math.ceil(Math.max(it,lt+mt+Pt)*bt),$t?(ue.stableMinimapLayoutInput=$,ue.stableFitRemainingWidth=Tt,ue.stableFitMaxMinimapScale=tt):(ue.stableMinimapLayoutInput=null,ue.stableFitRemainingWidth=0)}}}const Se=Math.floor(ft*Re),se=Math.min(Se,Math.max(0,Math.floor((Tt-Rt-2)*Re/(gt+Re)))+e.MINIMAP_GUTTER_WIDTH);let Fe=Math.floor($e*se);const He=Fe/$e;Fe=Math.floor(Fe*Ne);const _e=Et?1:2,je=Kt==="left"?0:Ie-se-Rt;return{renderMinimap:_e,minimapLeft:je,minimapWidth:se,minimapHeightIsEditorHeight:Ut,minimapIsSampling:Wt,minimapScale:tt,minimapLineHeight:bt,minimapCanvasInnerWidth:Fe,minimapCanvasInnerHeight:Xe,minimapCanvasOuterWidth:He,minimapCanvasOuterHeight:Mt}}static computeLayout($,ue){const Ie=ue.outerWidth|0,Le=ue.outerHeight|0,$e=ue.lineHeight|0,Ke=ue.lineNumbersDigitCount|0,Ze=ue.typicalHalfwidthCharacterWidth,pt=ue.maxDigitWidth,gt=ue.pixelRatio,ct=ue.viewLineCount,Et=$.get(130),tt=Et==="inherit"?$.get(129):Et,ft=tt==="inherit"?$.get(125):tt,At=$.get(128),Kt=ue.isDominatedByLongLines,Rt=$.get(54),mt=$.get(64).renderType!==0,Tt=$.get(65),$t=$.get(99),Nt=$.get(80),Xe=$.get(69),Mt=$.get(97),Ut=Mt.verticalScrollbarSize,Wt=Mt.verticalHasArrows,bt=Mt.arrowSize,Re=Mt.horizontalScrollbarSize,Ne=$.get(40),Se=$.get(104)!=="never";let se=$.get(62);Ne&&Se&&(se+=16);let Fe=0;if(mt){const wt=Math.max(Ke,Tt);Fe=Math.round(wt*pt)}let He=0;Rt&&(He=$e);let _e=0,je=_e+He,it=je+Fe,lt=it+se;const Pt=Ie-He-Fe-se;let St=!1,yt=!1,kt=-1;tt==="inherit"&&Kt?(St=!0,yt=!0):ft==="on"||ft==="bounded"?yt=!0:ft==="wordWrapColumn"&&(kt=At);const Dt=X.c({outerWidth:Ie,outerHeight:Le,lineHeight:$e,typicalHalfwidthCharacterWidth:Ze,pixelRatio:gt,scrollBeyondLastLine:$t,paddingTop:Nt.top,paddingBottom:Nt.bottom,minimap:Xe,verticalScrollbarWidth:Ut,viewLineCount:ct,remainingWidth:Pt,isViewportWrapping:yt},ue.memory||new L);Dt.renderMinimap!==0&&Dt.minimapLeft===0&&(_e+=Dt.minimapWidth,je+=Dt.minimapWidth,it+=Dt.minimapWidth,lt+=Dt.minimapWidth);const Ct=Pt-Dt.minimapWidth,qt=Math.max(1,Math.floor((Ct-Ut-2)/Ze)),Jt=Wt?bt:0;return yt&&(kt=Math.max(1,qt),ft==="bounded"&&(kt=Math.min(kt,At))),{width:Ie,height:Le,glyphMarginLeft:_e,glyphMarginWidth:He,lineNumbersLeft:je,lineNumbersWidth:Fe,decorationsLeft:it,decorationsWidth:se,contentLeft:lt,contentWidth:Ct,minimap:Dt,viewportColumn:qt,isWordWrapMinified:St,isViewportWrapping:yt,wrappingColumn:kt,verticalScrollbarWidth:Ut,horizontalScrollbarHeight:Re,overviewRuler:{top:Jt,width:Ut,height:Le-2*Jt,right:0}}}}e.EditorLayoutInfoComputer=X;class J extends k{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(46,null),c.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(48,null)}})}validate($){return i($,"simple",["simple","advanced"])}compute($,ue,Ie){return ue.get(2)===2?"advanced":Ie}}class te extends k{constructor(){const $={enabled:!0};super(61,"lightbulb",$,{"editor.lightbulb.enabled":{type:"boolean",default:$.enabled,description:c.localize(49,null)}})}validate($){return!$||typeof $!="object"?this.defaultValue:{enabled:d($.enabled,this.defaultValue.enabled)}}}class ee extends k{constructor(){const $={enabled:!1,maxLineCount:5};super(109,"stickyScroll",$,{"editor.stickyScroll.enabled":{type:"boolean",default:$.enabled,description:c.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:$.maxLineCount,minimum:1,maximum:10,description:c.localize(51,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{enabled:d(ue.enabled,this.defaultValue.enabled),maxLineCount:p.clampedInt(ue.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class Q extends k{constructor(){const $={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",$,{"editor.inlayHints.enabled":{type:"string",default:$.enabled,description:c.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(53,null),c.localize(54,null,A.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(55,null,A.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:$.fontSize,markdownDescription:c.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:$.fontFamily,markdownDescription:c.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:$.padding,description:c.localize(59,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return typeof ue.enabled=="boolean"&&(ue.enabled=ue.enabled?"on":"off"),{enabled:i(ue.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:p.clampedInt(ue.fontSize,this.defaultValue.fontSize,0,100),fontFamily:b.string(ue.fontFamily,this.defaultValue.fontFamily),padding:d(ue.padding,this.defaultValue.padding)}}}class Y extends k{constructor(){super(62,"lineDecorationsWidth",10)}validate($){return typeof $=="string"&&/^\d+(\.\d+)?ch$/.test($)?-parseFloat($.substring(0,$.length-2)):p.clampedInt($,this.defaultValue,0,1e3)}compute($,ue,Ie){return Ie<0?p.clampedInt(-Ie*$.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ie}}class ie extends y{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,$=>y.clamp($,0,150),{markdownDescription:c.localize(60,null)})}compute($,ue,Ie){return $.fontInfo.lineHeight}}class pe extends k{constructor(){const $={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",$,{"editor.minimap.enabled":{type:"boolean",default:$.enabled,description:c.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:$.autohide,description:c.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(63,null),c.localize(64,null),c.localize(65,null)],default:$.size,description:c.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:$.side,description:c.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:$.showSlider,description:c.localize(68,null)},"editor.minimap.scale":{type:"number",default:$.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:$.renderCharacters,description:c.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:$.maxColumn,description:c.localize(71,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{enabled:d(ue.enabled,this.defaultValue.enabled),autohide:d(ue.autohide,this.defaultValue.autohide),size:i(ue.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(ue.side,this.defaultValue.side,["right","left"]),showSlider:i(ue.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(ue.renderCharacters,this.defaultValue.renderCharacters),scale:p.clampedInt(ue.scale,1,1,3),maxColumn:p.clampedInt(ue.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ve(ce){return ce==="ctrlCmd"?A.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ke extends k{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(73,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{top:p.clampedInt(ue.top,0,0,1e3),bottom:p.clampedInt(ue.bottom,0,0,1e3)}}}class Oe extends k{constructor(){const $={enabled:!0,cycle:!0};super(81,"parameterHints",$,{"editor.parameterHints.enabled":{type:"boolean",default:$.enabled,description:c.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:$.cycle,description:c.localize(75,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{enabled:d(ue.enabled,this.defaultValue.enabled),cycle:d(ue.cycle,this.defaultValue.cycle)}}}class oe extends E{constructor(){super(136)}compute($,ue,Ie){return $.pixelRatio}}class ae extends k{constructor(){const $={other:"on",comments:"off",strings:"off"},ue=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(76,null),c.localize(77,null),c.localize(78,null)]}];super(84,"quickSuggestions",$,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ue,default:$.strings,description:c.localize(79,null)},comments:{anyOf:ue,default:$.comments,description:c.localize(80,null)},other:{anyOf:ue,default:$.other,description:c.localize(81,null)}},default:$,markdownDescription:c.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=$}validate($){if(typeof $=="boolean"){const gt=$?"on":"off";return{comments:gt,strings:gt,other:gt}}if(!$||typeof $!="object")return this.defaultValue;const{other:ue,comments:Ie,strings:Le}=$,$e=["on","inline","off"];let Ke,Ze,pt;return typeof ue=="boolean"?Ke=ue?"on":"off":Ke=i(ue,this.defaultValue.other,$e),typeof Ie=="boolean"?Ze=Ie?"on":"off":Ze=i(Ie,this.defaultValue.comments,$e),typeof Le=="boolean"?pt=Le?"on":"off":pt=i(Le,this.defaultValue.strings,$e),{other:Ke,comments:Ze,strings:pt}}}var fe;(function(ce){ce[ce.Off=0]="Off",ce[ce.On=1]="On",ce[ce.Relative=2]="Relative",ce[ce.Interval=3]="Interval",ce[ce.Custom=4]="Custom"})(fe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Z extends k{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(83,null),c.localize(84,null),c.localize(85,null),c.localize(86,null)],default:"on",description:c.localize(87,null)})}validate($){let ue=this.defaultValue.renderType,Ie=this.defaultValue.renderFn;return typeof $<"u"&&(typeof $=="function"?(ue=4,Ie=$):$==="interval"?ue=3:$==="relative"?ue=2:$==="on"?ue=1:ue=0),{renderType:ue,renderFn:Ie}}}function le(ce){const $=ce.get(92);return $==="editable"?ce.get(86):$!=="on"}e.filterValidationDecorations=le;class re extends k{constructor(){const $=[],ue={type:"number",description:c.localize(88,null)};super(96,"rulers",$,{type:"array",items:{anyOf:[ue,{type:["object"],properties:{column:ue,color:{type:"string",description:c.localize(89,null),format:"color-hex"}}}]},default:$,description:c.localize(90,null)})}validate($){if(Array.isArray($)){const ue=[];for(const Ie of $)if(typeof Ie=="number")ue.push({column:p.clampedInt(Ie,0,0,1e4),color:null});else if(Ie&&typeof Ie=="object"){const Le=Ie;ue.push({column:p.clampedInt(Le.column,0,0,1e4),color:Le.color})}return ue.sort((Ie,Le)=>Ie.column-Le.column),ue}return this.defaultValue}}function N(ce,$){if(typeof ce!="string")return $;switch(ce){case"hidden":return 2;case"visible":return 3;default:return 1}}class H extends k{constructor(){const $={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",$,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(91,null),c.localize(92,null),c.localize(93,null)],default:"auto",description:c.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(95,null),c.localize(96,null),c.localize(97,null)],default:"auto",description:c.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:$.verticalScrollbarSize,description:c.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:$.horizontalScrollbarSize,description:c.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:$.scrollByPage,description:c.localize(101,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$,Ie=p.clampedInt(ue.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Le=p.clampedInt(ue.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:p.clampedInt(ue.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:N(ue.vertical,this.defaultValue.vertical),horizontal:N(ue.horizontal,this.defaultValue.horizontal),useShadows:d(ue.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(ue.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(ue.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(ue.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(ue.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ie,horizontalSliderSize:p.clampedInt(ue.horizontalSliderSize,Ie,0,1e3),verticalScrollbarSize:Le,verticalSliderSize:p.clampedInt(ue.verticalSliderSize,Le,0,1e3),scrollByPage:d(ue.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends k{constructor(){const $={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",$,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.nonBasicASCII,description:c.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:$.invisibleCharacters,description:c.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:$.ambiguousCharacters,description:c.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.includeComments,description:c.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.includeStrings,description:c.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:$.allowedCharacters,description:c.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:$.allowedLocales,description:c.localize(108,null)}})}applyUpdate($,ue){let Ie=!1;ue.allowedCharacters&&$&&(C.equals($.allowedCharacters,ue.allowedCharacters)||($={...$,allowedCharacters:ue.allowedCharacters},Ie=!0)),ue.allowedLocales&&$&&(C.equals($.allowedLocales,ue.allowedLocales)||($={...$,allowedLocales:ue.allowedLocales},Ie=!0));const Le=super.applyUpdate($,ue);return Ie?new v(Le.newValue,!0):Le}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{nonBasicASCII:Ae(ue.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(ue.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(ue.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ae(ue.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ae(ue.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c($.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c($.allowedLocales,this.defaultValue.allowedLocales)}}c($,ue){if(typeof $!="object"||!$)return ue;const Ie={};for(const[Le,$e]of Object.entries($))$e===!0&&(Ie[Le]=!0);return Ie}}class _ extends k{constructor(){const $={enabled:!0,mode:"subwordSmart",showToolbar:"onHover"};super(59,"inlineSuggest",$,{"editor.inlineSuggest.enabled":{type:"boolean",default:$.enabled,description:c.localize(109,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:$.showToolbar,enum:["always","onHover"],enumDescriptions:[c.localize(110,null),c.localize(111,null)],description:c.localize(112,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{enabled:d(ue.enabled,this.defaultValue.enabled),mode:i(ue.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:i(ue.showToolbar,this.defaultValue.showToolbar,["always","onHover"])}}}class he extends k{constructor(){const $={enabled:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",$,{"editor.bracketPairColorization.enabled":{type:"boolean",default:$.enabled,markdownDescription:c.localize(113,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:$.independentColorPoolPerBracketType,description:c.localize(114,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{enabled:d(ue.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d(ue.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class we extends k{constructor(){const $={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",$,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(115,null),c.localize(116,null),c.localize(117,null)],default:$.bracketPairs,description:c.localize(118,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(119,null),c.localize(120,null),c.localize(121,null)],default:$.bracketPairsHorizontal,description:c.localize(122,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:$.highlightActiveBracketPair,description:c.localize(123,null)},"editor.guides.indentation":{type:"boolean",default:$.indentation,description:c.localize(124,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(125,null),c.localize(126,null),c.localize(127,null)],default:$.highlightActiveIndentation,description:c.localize(128,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{bracketPairs:Ae(ue.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ae(ue.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(ue.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(ue.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ae(ue.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ae(ce,$,ue){const Ie=ue.indexOf(ce);return Ie===-1?$:ue[Ie]}class be extends k{constructor(){const $={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",$,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(129,null),c.localize(130,null)],default:$.insertMode,description:c.localize(131,null)},"editor.suggest.filterGraceful":{type:"boolean",default:$.filterGraceful,description:c.localize(132,null)},"editor.suggest.localityBonus":{type:"boolean",default:$.localityBonus,description:c.localize(133,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:$.shareSuggestSelections,markdownDescription:c.localize(134,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[c.localize(135,null),c.localize(136,null),c.localize(137,null),c.localize(138,null)],default:$.selectionMode,markdownDescription:c.localize(139,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:$.snippetsPreventQuickSuggestions,description:c.localize(140,null)},"editor.suggest.showIcons":{type:"boolean",default:$.showIcons,description:c.localize(141,null)},"editor.suggest.showStatusBar":{type:"boolean",default:$.showStatusBar,description:c.localize(142,null)},"editor.suggest.preview":{type:"boolean",default:$.preview,description:c.localize(143,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:$.showInlineDetails,description:c.localize(144,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(145,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(146,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(147,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(148,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(149,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(150,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(151,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(152,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(153,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(154,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(155,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(156,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(157,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(158,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(159,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(160,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(161,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(162,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(163,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(164,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(165,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(166,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(167,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(168,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(169,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(170,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(171,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(172,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(173,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(174,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(175,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(176,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{insertMode:i(ue.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(ue.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(ue.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(ue.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(ue.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:i(ue.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:d(ue.showIcons,this.defaultValue.showIcons),showStatusBar:d(ue.showStatusBar,this.defaultValue.showStatusBar),preview:d(ue.preview,this.defaultValue.preview),previewMode:i(ue.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(ue.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(ue.showMethods,this.defaultValue.showMethods),showFunctions:d(ue.showFunctions,this.defaultValue.showFunctions),showConstructors:d(ue.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(ue.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:d(ue.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:d(ue.showFields,this.defaultValue.showFields),showVariables:d(ue.showVariables,this.defaultValue.showVariables),showClasses:d(ue.showClasses,this.defaultValue.showClasses),showStructs:d(ue.showStructs,this.defaultValue.showStructs),showInterfaces:d(ue.showInterfaces,this.defaultValue.showInterfaces),showModules:d(ue.showModules,this.defaultValue.showModules),showProperties:d(ue.showProperties,this.defaultValue.showProperties),showEvents:d(ue.showEvents,this.defaultValue.showEvents),showOperators:d(ue.showOperators,this.defaultValue.showOperators),showUnits:d(ue.showUnits,this.defaultValue.showUnits),showValues:d(ue.showValues,this.defaultValue.showValues),showConstants:d(ue.showConstants,this.defaultValue.showConstants),showEnums:d(ue.showEnums,this.defaultValue.showEnums),showEnumMembers:d(ue.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(ue.showKeywords,this.defaultValue.showKeywords),showWords:d(ue.showWords,this.defaultValue.showWords),showColors:d(ue.showColors,this.defaultValue.showColors),showFiles:d(ue.showFiles,this.defaultValue.showFiles),showReferences:d(ue.showReferences,this.defaultValue.showReferences),showFolders:d(ue.showFolders,this.defaultValue.showFolders),showTypeParameters:d(ue.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(ue.showSnippets,this.defaultValue.showSnippets),showUsers:d(ue.showUsers,this.defaultValue.showUsers),showIssues:d(ue.showIssues,this.defaultValue.showIssues)}}}class Ce extends k{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(177,null),default:!0,type:"boolean"}})}validate($){return!$||typeof $!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d($.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Te extends E{constructor(){super(137)}compute($,ue,Ie){return ue.get(86)?!0:$.tabFocusMode}}var Ve;(function(ce){ce[ce.None=0]="None",ce[ce.Same=1]="Same",ce[ce.Indent=2]="Indent",ce[ce.DeepIndent=3]="DeepIndent"})(Ve=e.WrappingIndent||(e.WrappingIndent={}));class xe extends k{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(178,null),c.localize(179,null),c.localize(180,null),c.localize(181,null)],description:c.localize(182,null),default:"same"}})}validate($){switch($){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute($,ue,Ie){return ue.get(2)===2?0:Ie}}class et extends E{constructor(){super(139)}compute($,ue,Ie){const Le=ue.get(138);return{isDominatedByLongLines:$.isDominatedByLongLines,isWordWrapMinified:Le.isWordWrapMinified,isViewportWrapping:Le.isViewportWrapping,wrappingColumn:Le.wrappingColumn}}}class Qe extends k{constructor(){const $={enabled:!0};super(33,"dropIntoEditor",$,{"editor.dropIntoEditor.enabled":{type:"boolean",default:$.enabled,markdownDescription:c.localize(183,null)}})}validate($){return!$||typeof $!="object"?this.defaultValue:{enabled:d($.enabled,this.defaultValue.enabled)}}}const nt="Consolas, 'Courier New', monospace",st="Menlo, Monaco, 'Courier New', monospace",ht="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.isMacintosh?st:A.isLinux?ht:nt,fontWeight:"normal",fontSize:A.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(ce){return e.editorOptionsRegistry[ce.id]=ce,ce}var rt;(function(ce){ce[ce.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ce[ce.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ce[ce.accessibilitySupport=2]="accessibilitySupport",ce[ce.accessibilityPageSize=3]="accessibilityPageSize",ce[ce.ariaLabel=4]="ariaLabel",ce[ce.autoClosingBrackets=5]="autoClosingBrackets",ce[ce.autoClosingDelete=6]="autoClosingDelete",ce[ce.autoClosingOvertype=7]="autoClosingOvertype",ce[ce.autoClosingQuotes=8]="autoClosingQuotes",ce[ce.autoIndent=9]="autoIndent",ce[ce.automaticLayout=10]="automaticLayout",ce[ce.autoSurround=11]="autoSurround",ce[ce.bracketPairColorization=12]="bracketPairColorization",ce[ce.guides=13]="guides",ce[ce.codeLens=14]="codeLens",ce[ce.codeLensFontFamily=15]="codeLensFontFamily",ce[ce.codeLensFontSize=16]="codeLensFontSize",ce[ce.colorDecorators=17]="colorDecorators",ce[ce.colorDecoratorsLimit=18]="colorDecoratorsLimit",ce[ce.columnSelection=19]="columnSelection",ce[ce.comments=20]="comments",ce[ce.contextmenu=21]="contextmenu",ce[ce.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",ce[ce.cursorBlinking=23]="cursorBlinking",ce[ce.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",ce[ce.cursorStyle=25]="cursorStyle",ce[ce.cursorSurroundingLines=26]="cursorSurroundingLines",ce[ce.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",ce[ce.cursorWidth=28]="cursorWidth",ce[ce.disableLayerHinting=29]="disableLayerHinting",ce[ce.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",ce[ce.domReadOnly=31]="domReadOnly",ce[ce.dragAndDrop=32]="dragAndDrop",ce[ce.dropIntoEditor=33]="dropIntoEditor",ce[ce.emptySelectionClipboard=34]="emptySelectionClipboard",ce[ce.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",ce[ce.extraEditorClassName=36]="extraEditorClassName",ce[ce.fastScrollSensitivity=37]="fastScrollSensitivity",ce[ce.find=38]="find",ce[ce.fixedOverflowWidgets=39]="fixedOverflowWidgets",ce[ce.folding=40]="folding",ce[ce.foldingStrategy=41]="foldingStrategy",ce[ce.foldingHighlight=42]="foldingHighlight",ce[ce.foldingImportsByDefault=43]="foldingImportsByDefault",ce[ce.foldingMaximumRegions=44]="foldingMaximumRegions",ce[ce.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",ce[ce.fontFamily=46]="fontFamily",ce[ce.fontInfo=47]="fontInfo",ce[ce.fontLigatures=48]="fontLigatures",ce[ce.fontSize=49]="fontSize",ce[ce.fontWeight=50]="fontWeight",ce[ce.fontVariations=51]="fontVariations",ce[ce.formatOnPaste=52]="formatOnPaste",ce[ce.formatOnType=53]="formatOnType",ce[ce.glyphMargin=54]="glyphMargin",ce[ce.gotoLocation=55]="gotoLocation",ce[ce.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",ce[ce.hover=57]="hover",ce[ce.inDiffEditor=58]="inDiffEditor",ce[ce.inlineSuggest=59]="inlineSuggest",ce[ce.letterSpacing=60]="letterSpacing",ce[ce.lightbulb=61]="lightbulb",ce[ce.lineDecorationsWidth=62]="lineDecorationsWidth",ce[ce.lineHeight=63]="lineHeight",ce[ce.lineNumbers=64]="lineNumbers",ce[ce.lineNumbersMinChars=65]="lineNumbersMinChars",ce[ce.linkedEditing=66]="linkedEditing",ce[ce.links=67]="links",ce[ce.matchBrackets=68]="matchBrackets",ce[ce.minimap=69]="minimap",ce[ce.mouseStyle=70]="mouseStyle",ce[ce.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",ce[ce.mouseWheelZoom=72]="mouseWheelZoom",ce[ce.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",ce[ce.multiCursorModifier=74]="multiCursorModifier",ce[ce.multiCursorPaste=75]="multiCursorPaste",ce[ce.multiCursorLimit=76]="multiCursorLimit",ce[ce.occurrencesHighlight=77]="occurrencesHighlight",ce[ce.overviewRulerBorder=78]="overviewRulerBorder",ce[ce.overviewRulerLanes=79]="overviewRulerLanes",ce[ce.padding=80]="padding",ce[ce.parameterHints=81]="parameterHints",ce[ce.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",ce[ce.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",ce[ce.quickSuggestions=84]="quickSuggestions",ce[ce.quickSuggestionsDelay=85]="quickSuggestionsDelay",ce[ce.readOnly=86]="readOnly",ce[ce.renameOnType=87]="renameOnType",ce[ce.renderControlCharacters=88]="renderControlCharacters",ce[ce.renderFinalNewline=89]="renderFinalNewline",ce[ce.renderLineHighlight=90]="renderLineHighlight",ce[ce.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",ce[ce.renderValidationDecorations=92]="renderValidationDecorations",ce[ce.renderWhitespace=93]="renderWhitespace",ce[ce.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",ce[ce.roundedSelection=95]="roundedSelection",ce[ce.rulers=96]="rulers",ce[ce.scrollbar=97]="scrollbar",ce[ce.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",ce[ce.scrollBeyondLastLine=99]="scrollBeyondLastLine",ce[ce.scrollPredominantAxis=100]="scrollPredominantAxis",ce[ce.selectionClipboard=101]="selectionClipboard",ce[ce.selectionHighlight=102]="selectionHighlight",ce[ce.selectOnLineNumbers=103]="selectOnLineNumbers",ce[ce.showFoldingControls=104]="showFoldingControls",ce[ce.showUnused=105]="showUnused",ce[ce.snippetSuggestions=106]="snippetSuggestions",ce[ce.smartSelect=107]="smartSelect",ce[ce.smoothScrolling=108]="smoothScrolling",ce[ce.stickyScroll=109]="stickyScroll",ce[ce.stickyTabStops=110]="stickyTabStops",ce[ce.stopRenderingLineAfter=111]="stopRenderingLineAfter",ce[ce.suggest=112]="suggest",ce[ce.suggestFontSize=113]="suggestFontSize",ce[ce.suggestLineHeight=114]="suggestLineHeight",ce[ce.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",ce[ce.suggestSelection=116]="suggestSelection",ce[ce.tabCompletion=117]="tabCompletion",ce[ce.tabIndex=118]="tabIndex",ce[ce.unicodeHighlighting=119]="unicodeHighlighting",ce[ce.unusualLineTerminators=120]="unusualLineTerminators",ce[ce.useShadowDOM=121]="useShadowDOM",ce[ce.useTabStops=122]="useTabStops",ce[ce.wordBreak=123]="wordBreak",ce[ce.wordSeparators=124]="wordSeparators",ce[ce.wordWrap=125]="wordWrap",ce[ce.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",ce[ce.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",ce[ce.wordWrapColumn=128]="wordWrapColumn",ce[ce.wordWrapOverride1=129]="wordWrapOverride1",ce[ce.wordWrapOverride2=130]="wordWrapOverride2",ce[ce.wrappingIndent=131]="wrappingIndent",ce[ce.wrappingStrategy=132]="wrappingStrategy",ce[ce.showDeprecated=133]="showDeprecated",ce[ce.inlayHints=134]="inlayHints",ce[ce.editorClassName=135]="editorClassName",ce[ce.pixelRatio=136]="pixelRatio",ce[ce.tabFocusMode=137]="tabFocusMode",ce[ce.layoutInfo=138]="layoutInfo",ce[ce.wrappingInfo=139]="wrappingInfo"})(rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(184,null)})),acceptSuggestionOnEnter:Ue(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(185,null),""],markdownDescription:c.localize(186,null)})),accessibilitySupport:Ue(new r),accessibilityPageSize:Ue(new p(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(187,null),tags:["accessibility"]})),ariaLabel:Ue(new b(4,"ariaLabel",c.localize(188,null))),autoClosingBrackets:Ue(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(189,null),c.localize(190,null),""],description:c.localize(191,null)})),autoClosingDelete:Ue(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(192,null),""],description:c.localize(193,null)})),autoClosingOvertype:Ue(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(194,null),""],description:c.localize(195,null)})),autoClosingQuotes:Ue(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(196,null),c.localize(197,null),""],description:c.localize(198,null)})),autoIndent:Ue(new s(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[c.localize(199,null),c.localize(200,null),c.localize(201,null),c.localize(202,null),c.localize(203,null)],description:c.localize(204,null)})),automaticLayout:Ue(new h(10,"automaticLayout",!1)),autoSurround:Ue(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(205,null),c.localize(206,null),c.localize(207,null),""],description:c.localize(208,null)})),bracketPairColorization:Ue(new he),bracketPairGuides:Ue(new we),stickyTabStops:Ue(new h(110,"stickyTabStops",!1,{description:c.localize(209,null)})),codeLens:Ue(new h(14,"codeLens",!0,{description:c.localize(210,null)})),codeLensFontFamily:Ue(new b(15,"codeLensFontFamily","",{description:c.localize(211,null)})),codeLensFontSize:Ue(new p(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(212,null)})),colorDecorators:Ue(new h(17,"colorDecorators",!0,{description:c.localize(213,null)})),colorDecoratorsLimit:Ue(new p(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(214,null)})),columnSelection:Ue(new h(19,"columnSelection",!1,{description:c.localize(215,null)})),comments:Ue(new m),contextmenu:Ue(new h(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new h(22,"copyWithSyntaxHighlighting",!0,{description:c.localize(216,null)})),cursorBlinking:Ue(new s(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],t,{description:c.localize(217,null)})),cursorSmoothCaretAnimation:Ue(new o(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(218,null),c.localize(219,null),c.localize(220,null)],description:c.localize(221,null)})),cursorStyle:Ue(new s(25,"cursorStyle",a.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],D,{description:c.localize(222,null)})),cursorSurroundingLines:Ue(new p(26,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(223,null)})),cursorSurroundingLinesStyle:Ue(new o(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(224,null),c.localize(225,null)],description:c.localize(226,null)})),cursorWidth:Ue(new p(28,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(227,null)})),disableLayerHinting:Ue(new h(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new h(30,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new h(31,"domReadOnly",!1)),dragAndDrop:Ue(new h(32,"dragAndDrop",!0,{description:c.localize(228,null)})),emptySelectionClipboard:Ue(new x),dropIntoEditor:Ue(new Qe),stickyScroll:Ue(new ee),experimentalWhitespaceRendering:Ue(new o(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(229,null),c.localize(230,null),c.localize(231,null)],description:c.localize(232,null)})),extraEditorClassName:Ue(new b(36,"extraEditorClassName","")),fastScrollSensitivity:Ue(new y(37,"fastScrollSensitivity",5,ce=>ce<=0?5:ce,{markdownDescription:c.localize(233,null)})),find:Ue(new q),fixedOverflowWidgets:Ue(new h(39,"fixedOverflowWidgets",!1)),folding:Ue(new h(40,"folding",!0,{description:c.localize(234,null)})),foldingStrategy:Ue(new o(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(235,null),c.localize(236,null)],description:c.localize(237,null)})),foldingHighlight:Ue(new h(42,"foldingHighlight",!0,{description:c.localize(238,null)})),foldingImportsByDefault:Ue(new h(43,"foldingImportsByDefault",!1,{description:c.localize(239,null)})),foldingMaximumRegions:Ue(new p(44,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(240,null)})),unfoldOnClickAfterEndOfLine:Ue(new h(45,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(241,null)})),fontFamily:Ue(new b(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(242,null)})),fontInfo:Ue(new O),fontLigatures2:Ue(new M),fontSize:Ue(new U),fontWeight:Ue(new z),fontVariations:Ue(new B),formatOnPaste:Ue(new h(52,"formatOnPaste",!1,{description:c.localize(243,null)})),formatOnType:Ue(new h(53,"formatOnType",!1,{description:c.localize(244,null)})),glyphMargin:Ue(new h(54,"glyphMargin",!0,{description:c.localize(245,null)})),gotoLocation:Ue(new j),hideCursorInOverviewRuler:Ue(new h(56,"hideCursorInOverviewRuler",!1,{description:c.localize(246,null)})),hover:Ue(new de),inDiffEditor:Ue(new h(58,"inDiffEditor",!1)),letterSpacing:Ue(new y(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ce=>y.clamp(ce,-5,20),{description:c.localize(247,null)})),lightbulb:Ue(new te),lineDecorationsWidth:Ue(new Y),lineHeight:Ue(new ie),lineNumbers:Ue(new Z),lineNumbersMinChars:Ue(new p(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new h(66,"linkedEditing",!1,{description:c.localize(248,null)})),links:Ue(new h(67,"links",!0,{description:c.localize(249,null)})),matchBrackets:Ue(new o(68,"matchBrackets","always",["always","near","never"],{description:c.localize(250,null)})),minimap:Ue(new pe),mouseStyle:Ue(new o(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new y(71,"mouseWheelScrollSensitivity",1,ce=>ce===0?1:ce,{markdownDescription:c.localize(251,null)})),mouseWheelZoom:Ue(new h(72,"mouseWheelZoom",!1,{markdownDescription:c.localize(252,null)})),multiCursorMergeOverlapping:Ue(new h(73,"multiCursorMergeOverlapping",!0,{description:c.localize(253,null)})),multiCursorModifier:Ue(new s(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ve,{markdownEnumDescriptions:[c.localize(254,null),c.localize(255,null)],markdownDescription:c.localize(256,null)})),multiCursorPaste:Ue(new o(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(257,null),c.localize(258,null)],markdownDescription:c.localize(259,null)})),multiCursorLimit:Ue(new p(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(260,null)})),occurrencesHighlight:Ue(new h(77,"occurrencesHighlight",!0,{description:c.localize(261,null)})),overviewRulerBorder:Ue(new h(78,"overviewRulerBorder",!0,{description:c.localize(262,null)})),overviewRulerLanes:Ue(new p(79,"overviewRulerLanes",3,0,3)),padding:Ue(new ke),parameterHints:Ue(new Oe),peekWidgetDefaultFocus:Ue(new o(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(263,null),c.localize(264,null)],description:c.localize(265,null)})),definitionLinkOpensInPeek:Ue(new h(83,"definitionLinkOpensInPeek",!1,{description:c.localize(266,null)})),quickSuggestions:Ue(new ae),quickSuggestionsDelay:Ue(new p(85,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(267,null)})),readOnly:Ue(new h(86,"readOnly",!1)),renameOnType:Ue(new h(87,"renameOnType",!1,{description:c.localize(268,null),markdownDeprecationMessage:c.localize(269,null)})),renderControlCharacters:Ue(new h(88,"renderControlCharacters",!0,{description:c.localize(270,null),restricted:!0})),renderFinalNewline:Ue(new o(89,"renderFinalNewline",A.isLinux?"dimmed":"on",["off","on","dimmed"],{description:c.localize(271,null)})),renderLineHighlight:Ue(new o(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(272,null)],description:c.localize(273,null)})),renderLineHighlightOnlyWhenFocus:Ue(new h(91,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(274,null)})),renderValidationDecorations:Ue(new o(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new o(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(275,null),c.localize(276,null),c.localize(277,null),""],description:c.localize(278,null)})),revealHorizontalRightPadding:Ue(new p(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new h(95,"roundedSelection",!0,{description:c.localize(279,null)})),rulers:Ue(new re),scrollbar:Ue(new H),scrollBeyondLastColumn:Ue(new p(98,"scrollBeyondLastColumn",4,0,1073741824,{description:c.localize(280,null)})),scrollBeyondLastLine:Ue(new h(99,"scrollBeyondLastLine",!0,{description:c.localize(281,null)})),scrollPredominantAxis:Ue(new h(100,"scrollPredominantAxis",!0,{description:c.localize(282,null)})),selectionClipboard:Ue(new h(101,"selectionClipboard",!0,{description:c.localize(283,null),included:A.isLinux})),selectionHighlight:Ue(new h(102,"selectionHighlight",!0,{description:c.localize(284,null)})),selectOnLineNumbers:Ue(new h(103,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new o(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(285,null),c.localize(286,null),c.localize(287,null)],description:c.localize(288,null)})),showUnused:Ue(new h(105,"showUnused",!0,{description:c.localize(289,null)})),showDeprecated:Ue(new h(133,"showDeprecated",!0,{description:c.localize(290,null)})),inlayHints:Ue(new Q),snippetSuggestions:Ue(new o(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(291,null),c.localize(292,null),c.localize(293,null),c.localize(294,null)],description:c.localize(295,null)})),smartSelect:Ue(new Ce),smoothScrolling:Ue(new h(108,"smoothScrolling",!1,{description:c.localize(296,null)})),stopRenderingLineAfter:Ue(new p(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new be),inlineSuggest:Ue(new _),suggestFontSize:Ue(new p(113,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(297,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new p(114,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(298,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new h(115,"suggestOnTriggerCharacters",!0,{description:c.localize(299,null)})),suggestSelection:Ue(new o(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(300,null),c.localize(301,null),c.localize(302,null)],description:c.localize(303,null)})),tabCompletion:Ue(new o(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(304,null),c.localize(305,null),c.localize(306,null)],description:c.localize(307,null)})),tabIndex:Ue(new p(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new K),unusualLineTerminators:Ue(new o(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(308,null),c.localize(309,null),c.localize(310,null)],description:c.localize(311,null)})),useShadowDOM:Ue(new h(121,"useShadowDOM",!0)),useTabStops:Ue(new h(122,"useTabStops",!0,{description:c.localize(312,null)})),wordBreak:Ue(new o(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(313,null),c.localize(314,null)],description:c.localize(315,null)})),wordSeparators:Ue(new b(124,"wordSeparators",u.USUAL_WORD_SEPARATORS,{description:c.localize(316,null)})),wordWrap:Ue(new o(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(317,null),c.localize(318,null),c.localize(319,null),c.localize(320,null)],description:c.localize(321,null)})),wordWrapBreakAfterCharacters:Ue(new b(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new b(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new p(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(322,null)})),wordWrapOverride1:Ue(new o(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new o(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new F),pixelRatio:Ue(new oe),tabFocusMode:Ue(new Te),layoutInfo:Ue(new X),wrappingInfo:Ue(new et),wrappingIndent:Ue(new xe),wrappingStrategy:Ue(new J)}}),define(ye[169],De([16,17]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[170],De([16,17]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[171],De([16,17]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[172],De([16,17]),function(ne,e){return ne.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ye[173],De([16,17]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(ye[174],De([16,17]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(ye[175],De([16,17]),function(ne,e){return ne.create("vs/platform/theme/common/iconRegistry",e)}),define(ye[176],De([16,17]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(ye[177],De([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[178],De([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[179],De([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(ye[180],De([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[181],De([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ye[182],De([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[183],De([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[184],De([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[185],De([16,17]),function(ne,e){return ne.create("vs/workbench/api/node/extHostDebugService",e)}),define(ye[186],De([16,17]),function(ne,e){return ne.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ye[187],De([16,17]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(ye[188],De([16,17]),function(ne,e){return ne.create("vs/workbench/common/views",e)}),define(ye[189],De([16,17]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[190],De([16,17]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/debug",e)}),define(ye[191],De([16,17]),function(ne,e){return ne.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ye[192],De([16,17]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ye[193],De([16,17]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ye[194],De([16,17]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[195],De([16,17]),function(ne,e){return ne.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ye[196],De([16,17]),function(ne,e){return ne.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ye[197],De([1,0,11]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class A{constructor(){this.a=new Map}register(R,C){this.a.set(R,C)}updateManifest(R){if(!(typeof R.main>"u"&&typeof R.browser>"u")&&(R.activationEvents===void 0&&Object.assign(R,{activationEvents:[]}),!(!Array.isArray(R.activationEvents)||!R.contributes)))for(const C in R.contributes){const P=this.a.get(C);if(!P)continue;const S=R.contributes[C],I=Array.isArray(S)?S:[S];try{P(I,R.activationEvents)}catch(L){(0,c.onUnexpectedError)(L)}}}}e.ImplicitActivationEventsImpl=A,e.ImplicitActivationEvents=new A}),define(ye[198],De([1,0,24,37,171,319]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function S(h){return h=h.trim(),h==="*"||C.test(h)}e.isValidVersionStr=S;function I(h){if(!S(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=h.match(C);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=I;function L(h){if(!h)return null;const g=h.majorBase,p=h.majorMustEqual,y=h.minorBase;let b=h.minorMustEqual;const i=h.patchBase;let o=h.patchMustEqual;h.hasCaret&&(g===0||(b=!1),o=!1);let s=0;if(h.preRelease){const l=P.exec(h.preRelease);if(l){const[,r,m,n]=l;s=Date.UTC(Number(r),Number(m)-1,Number(n))}}return{majorBase:g,majorMustEqual:p,minorBase:y,minorMustEqual:b,patchBase:i,patchMustEqual:o,isMinimum:h.hasGreaterEquals,notBefore:s}}e.normalizeVersion=L;function k(h,g,p){let y;typeof h=="string"?y=L(I(h)):y=h;let b;g instanceof Date?b=g.getTime():typeof g=="string"&&(b=new Date(g).getTime());let i;if(typeof p=="string"?i=L(I(p)):i=p,!y||!i)return!1;const o=y.majorBase,s=y.minorBase,l=y.patchBase;let r=i.majorBase,m=i.minorBase,n=i.patchBase;const t=i.notBefore;let a=i.majorMustEqual,w=i.minorMustEqual,D=i.patchMustEqual;return i.isMinimum?o>r?!0:o<r?!1:s>m?!0:s<m||b&&b<t?!1:l>=n:(o===1&&r===0&&(!a||!w||!D)&&(r=1,m=0,n=0,a=!0,w=!1,D=!1),o<r?!1:o>r?!a:s<m?!1:s>m?!w:l<n?!1:l>n?!D:!(b&&b<t))}e.isValidVersion=k;function v(h,g,p,y,b){const i=[];if(typeof y.publisher<"u"&&typeof y.publisher!="string")return i.push([A.default.Error,u.localize(0,null)]),i;if(typeof y.name!="string")return i.push([A.default.Error,u.localize(1,null,"name")]),i;if(typeof y.version!="string")return i.push([A.default.Error,u.localize(2,null,"version")]),i;if(!y.engines)return i.push([A.default.Error,u.localize(3,null,"engines")]),i;if(typeof y.engines.vscode!="string")return i.push([A.default.Error,u.localize(4,null,"engines.vscode")]),i;if(typeof y.extensionDependencies<"u"&&!d(y.extensionDependencies))return i.push([A.default.Error,u.localize(5,null,"extensionDependencies")]),i;if(typeof y.activationEvents<"u"){if(!d(y.activationEvents))return i.push([A.default.Error,u.localize(6,null,"activationEvents")]),i;if(typeof y.main>"u"&&typeof y.browser>"u")return i.push([A.default.Error,u.localize(7,null,"activationEvents","main")]),i}if(typeof y.extensionKind<"u"&&typeof y.main>"u"&&i.push([A.default.Warning,u.localize(8,null,"extensionKind")]),typeof y.main<"u"){if(typeof y.main!="string")return i.push([A.default.Error,u.localize(9,null,"main")]),i;{const l=(0,c.joinPath)(p,y.main);(0,c.isEqualOrParent)(l,p)||i.push([A.default.Warning,u.localize(10,null,l.path,p.path)])}if(typeof y.activationEvents>"u")return i.push([A.default.Error,u.localize(11,null,"activationEvents","main")]),i}if(typeof y.browser<"u"){if(typeof y.browser!="string")return i.push([A.default.Error,u.localize(12,null,"browser")]),i;{const l=(0,c.joinPath)(p,y.browser);(0,c.isEqualOrParent)(l,p)||i.push([A.default.Warning,u.localize(13,null,l.path,p.path)])}if(typeof y.activationEvents>"u")return i.push([A.default.Error,u.localize(14,null,"activationEvents","browser")]),i}if(!R.valid(y.version))return i.push([A.default.Error,u.localize(15,null)]),i;const o=[];if(!T(h,g,y,b,o))for(const l of o)i.push([A.default.Error,l]);return i}e.validateExtensionManifest=v;function T(h,g,p,y,b){return y||typeof p.main>"u"&&typeof p.browser>"u"?!0:f(h,g,p.engines.vscode,b)}e.isValidExtensionVersion=T;function E(h,g,p){return h==="*"||f(g,p,h)}e.isEngineValid=E;function f(h,g,p,y=[]){const b=L(I(p));if(!b)return y.push(u.localize(16,null,p)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return y.push(u.localize(17,null,p)),!1}else if(!b.majorMustEqual)return y.push(u.localize(18,null,p)),!1;return k(h,g,b)?!0:(y.push(u.localize(19,null,h,p)),!1)}function d(h){if(!Array.isArray(h))return!1;for(let g=0,p=h.length;g<p;g++)if(typeof h[g]!="string")return!1;return!0}}),define(ye[122],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(u,R=[],C=!1){this.ctor=u,this.staticArguments=R,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=c}),define(ye[89],De([1,0,122]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const A=[];var u;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(u=e.InstantiationType||(e.InstantiationType={}));function R(P,S,I){S instanceof c.SyncDescriptor||(S=new c.SyncDescriptor(S,[],Boolean(I))),A.push([P,S])}e.registerSingleton=R;function C(){return A}e.getSingletonServiceDescriptors=C}),define(ye[199],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(R,C){this.key=R,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=c;class A{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const C of this.a.values())C.outgoing.size===0&&R.push(C);return R}insertEdge(R,C){const P=this.lookupOrInsertNode(R),S=this.lookupOrInsertNode(C);P.outgoing.set(S.key,S),S.incoming.set(P.key,P)}removeNode(R){const C=this.b(R);this.a.delete(C);for(const P of this.a.values())P.outgoing.delete(C),P.incoming.delete(C)}lookupOrInsertNode(R){const C=this.b(R);let P=this.a.get(C);return P||(P=new c(C,R),this.a.set(C,P)),P}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[C,P]of this.a)R.push(`${C}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,C]of this.a){const P=new Set([R]),S=this.c(C,P);if(S)return S}}c(R,C){for(const[P,S]of R.outgoing){if(C.has(P))return[...C,P].join(" -> ");C.add(P);const I=this.c(S,C);if(I)return I;C.delete(P)}}}e.Graph=A}),define(ye[4],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var c;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function P(S){return S[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=P})(c=e._util||(e._util={})),e.IInstantiationService=u("instantiationService");function A(C,P,S){P[c.DI_TARGET]===P?P[c.DI_DEPENDENCIES].push({id:C,index:S}):(P[c.DI_DEPENDENCIES]=[{id:C,index:S}],P[c.DI_TARGET]=P)}function u(C){if(c.serviceIds.has(C))return c.serviceIds.get(C);const P=function(S,I,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(P,S,L)};return P.toString=()=>C,c.serviceIds.set(C,P),P}e.createDecorator=u;function R(C){return C}e.refineServiceDecorator=R}),define(ye[53],De([1,0,9,2,4]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,u.createDecorator)("configurationService");function R(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof A.URI)}e.isConfigurationOverrides=R;function C(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof A.URI)}e.isConfigurationUpdateOverrides=C;var P;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function I(d,h){const g=Object.create(null);for(const p in d)L(g,p,d[p],h);return g}e.toValuesTree=I;function L(d,h,g,p){const y=h.split("."),b=y.pop();let i=d;for(let o=0;o<y.length;o++){const s=y[o];let l=i[s];switch(typeof l){case"undefined":l=i[s]=Object.create(null);break;case"object":break;default:p(`Ignoring ${h} as ${y.slice(0,o+1).join(".")} is ${JSON.stringify(l)}`);return}i=l}if(typeof i=="object"&&i!==null)try{i[b]=g}catch{p(`Ignoring ${h} as ${y.join(".")} is ${JSON.stringify(i)}`)}else p(`Ignoring ${h} as ${y.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=L;function k(d,h){const g=h.split(".");v(d,g)}e.removeFromValueTree=k;function v(d,h){const g=h.shift();if(h.length===0){delete d[g];return}if(Object.keys(d).indexOf(g)!==-1){const p=d[g];typeof p=="object"&&!Array.isArray(p)&&(v(p,h),Object.keys(p).length===0&&delete d[g])}}function T(d,h,g){function p(i,o){let s=i;for(const l of o){if(typeof s!="object"||s===null)return;s=s[l]}return s}const y=h.split("."),b=p(d,y);return typeof b>"u"?g:b}e.getConfigurationValue=T;function E(d,h,g){Object.keys(h).forEach(p=>{p!=="__proto__"&&(p in d?c.isObject(d[p])&&c.isObject(h[p])?E(d[p],h[p],g):g&&(d[p]=h[p]):d[p]=h[p])})}e.merge=E;function f(d){return d.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=f}),define(ye[54],De([1,0,12,8,4]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",c.isMacintosh),R.set("isLinux",c.isLinux),R.set("isWindows",c.isWindows),R.set("isWeb",c.isWeb),R.set("isMacNative",c.isMacintosh&&!c.isWeb),R.set("isEdge",c.isEdge),R.set("isFirefox",c.isFirefox),R.set("isChrome",c.isChrome),R.set("isSafari",c.isSafari);const C=Object.prototype.hasOwnProperty;var P;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return k.INSTANCE}static true(){return v.INSTANCE}static has(M){return T.create(M)}static equals(M,B){return E.create(M,B)}static notEquals(M,B){return h.create(M,B)}static regex(M,B){return s.create(M,B)}static in(M,B){return f.create(M,B)}static notIn(M,B){return d.create(M,B)}static not(M){return g.create(M)}static and(...M){return m.create(M,null,!0)}static or(...M){return n.create(M,null,!0)}static greater(M,B){return y.create(M,B)}static greaterEquals(M,B){return b.create(M,B)}static smaller(M,B){return i.create(M,B)}static smallerEquals(M,B){return o.create(M,B)}static deserialize(M,B=!1){if(!!M)return this.c(M,B)}static c(M,B){const O=M.split("||");return n.create(O.map(U=>this.d(U,B)),null,!0)}static d(M,B){const O=M.split("&&");return m.create(O.map(U=>this.f(U,B)),null,!0)}static f(M,B){if(M=M.trim(),M.indexOf("!=")>=0){const O=M.split("!=");return h.create(O[0].trim(),this.g(O[1],B))}if(M.indexOf("==")>=0){const O=M.split("==");return E.create(O[0].trim(),this.g(O[1],B))}if(M.indexOf("=~")>=0){const O=M.split("=~");return s.create(O[0].trim(),this.h(O[1],B))}if(M.indexOf(" not in ")>=0){const O=M.split(" not in ");return d.create(O[0].trim(),this.g(O[1],B))}if(M.indexOf(" in ")>=0){const O=M.split(" in ");return f.create(O[0].trim(),this.g(O[1],B))}if(/^[^<=>]+>=[^<=>]+$/.test(M)){const O=M.split(">=");return b.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(M)){const O=M.split(">");return y.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(M)){const O=M.split("<=");return o.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(M)){const O=M.split("<");return i.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(M)?g.create(M.substr(1).trim()):T.create(M)}static g(M,B){if(M=M.trim(),M==="true")return!0;if(M==="false")return!1;const O=/^'([^']*)'$/.exec(M);return O?O[1].trim():M}static h(M,B){if((0,A.isFalsyOrWhitespace)(M)){if(B)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const O=M.indexOf("/"),U=M.lastIndexOf("/");if(O===U||O<0){if(B)throw new Error(`bad regexp-value '${M}', missing /-enclosure`);return console.warn(`bad regexp-value '${M}', missing /-enclosure`),null}const z=M.slice(O+1,U),j=M[U+1]==="i"?"i":"";try{return new RegExp(z,j)}catch(de){if(B)throw new Error(`bad regexp-value '${M}', parse error: ${de}`);return console.warn(`bad regexp-value '${M}', parse error: ${de}`),null}}}e.ContextKeyExpr=S;function I(q,M){const B=q?q.substituteConstants():void 0,O=M?M.substituteConstants():void 0;return!B&&!O?!0:!B||!O?!1:B.equals(O)}e.expressionsAreEqualWithConstantSubstitution=I;function L(q,M){return q.cmp(M)}class k{constructor(){this.type=0}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!1}serialize(){return"false"}keys(){return[]}map(M){return this}negate(){return v.INSTANCE}}k.INSTANCE=new k,e.ContextKeyFalseExpr=k;class v{constructor(){this.type=1}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!0}serialize(){return"true"}keys(){return[]}map(M){return this}negate(){return k.INSTANCE}}v.INSTANCE=new v,e.ContextKeyTrueExpr=v;class T{static create(M,B=null){const O=R.get(M);return typeof O=="boolean"?O?v.INSTANCE:k.INSTANCE:new T(M,B)}constructor(M,B){this.key=M,this.c=B,this.type=2}cmp(M){return M.type!==this.type?this.type-M.type:a(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=R.get(this.key);return typeof M=="boolean"?M?v.INSTANCE:k.INSTANCE:this}evaluate(M){return!!M.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(M){return M.mapDefined(this.key)}negate(){return this.c||(this.c=g.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=T;class E{static create(M,B,O=null){if(typeof B=="boolean")return B?T.create(M,O):g.create(M,O);const U=R.get(M);return typeof U=="boolean"?B===(U?"true":"false")?v.INSTANCE:k.INSTANCE:new E(M,B,O)}constructor(M,B,O){this.c=M,this.d=B,this.f=O,this.type=4}cmp(M){return M.type!==this.type?this.type-M.type:w(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=R.get(this.c);if(typeof M=="boolean"){const B=M?"true":"false";return this.d===B?v.INSTANCE:k.INSTANCE}return this}evaluate(M){return M.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(M){return M.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=E;class f{static create(M,B){return new f(M,B)}constructor(M,B){this.d=M,this.f=B,this.type=10,this.c=null}cmp(M){return M.type!==this.type?this.type-M.type:w(this.d,this.f,M.d,M.f)}equals(M){return M.type===this.type?this.d===M.d&&this.f===M.f:!1}substituteConstants(){return this}evaluate(M){const B=M.getValue(this.f),O=M.getValue(this.d);return Array.isArray(B)?B.includes(O):typeof O=="string"&&typeof B=="object"&&B!==null?C.call(B,O):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(M){return M.mapIn(this.d,this.f)}negate(){return this.c||(this.c=d.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=f;class d{static create(M,B){return new d(M,B)}constructor(M,B){this.d=M,this.f=B,this.type=11,this.c=f.create(M,B)}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(M){return M.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=d;class h{static create(M,B,O=null){if(typeof B=="boolean")return B?g.create(M,O):T.create(M,O);const U=R.get(M);return typeof U=="boolean"?B===(U?"true":"false")?k.INSTANCE:v.INSTANCE:new h(M,B,O)}constructor(M,B,O){this.c=M,this.d=B,this.f=O,this.type=5}cmp(M){return M.type!==this.type?this.type-M.type:w(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=R.get(this.c);if(typeof M=="boolean"){const B=M?"true":"false";return this.d===B?k.INSTANCE:v.INSTANCE}return this}evaluate(M){return M.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(M){return M.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=h;class g{static create(M,B=null){const O=R.get(M);return typeof O=="boolean"?O?k.INSTANCE:v.INSTANCE:new g(M,B)}constructor(M,B){this.c=M,this.d=B,this.type=3}cmp(M){return M.type!==this.type?this.type-M.type:a(this.c,M.c)}equals(M){return M.type===this.type?this.c===M.c:!1}substituteConstants(){const M=R.get(this.c);return typeof M=="boolean"?M?k.INSTANCE:v.INSTANCE:this}evaluate(M){return!M.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(M){return M.mapNot(this.c)}negate(){return this.d||(this.d=T.create(this.c,this)),this.d}}e.ContextKeyNotExpr=g;function p(q,M){if(typeof q=="string"){const B=parseFloat(q);isNaN(B)||(q=B)}return typeof q=="string"||typeof q=="number"?M(q):k.INSTANCE}class y{static create(M,B,O=null){return p(B,U=>new y(M,U,O))}constructor(M,B,O){this.c=M,this.d=B,this.f=O,this.type=12}cmp(M){return M.type!==this.type?this.type-M.type:w(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=o.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=y;class b{static create(M,B,O=null){return p(B,U=>new b(M,U,O))}constructor(M,B,O){this.c=M,this.d=B,this.f=O,this.type=13}cmp(M){return M.type!==this.type?this.type-M.type:w(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=b;class i{static create(M,B,O=null){return p(B,U=>new i(M,U,O))}constructor(M,B,O){this.c=M,this.d=B,this.f=O,this.type=14}cmp(M){return M.type!==this.type?this.type-M.type:w(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=i;class o{static create(M,B,O=null){return p(B,U=>new o(M,U,O))}constructor(M,B,O){this.c=M,this.d=B,this.f=O,this.type=15}cmp(M){return M.type!==this.type?this.type-M.type:w(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=o;class s{static create(M,B){return new s(M,B)}constructor(M,B){this.d=M,this.f=B,this.type=7,this.c=null}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.d<M.d)return-1;if(this.d>M.d)return 1;const B=this.f?this.f.source:"",O=M.f?M.f.source:"";return B<O?-1:B>O?1:0}equals(M){if(M.type===this.type){const B=this.f?this.f.source:"",O=M.f?M.f.source:"";return this.d===M.d&&B===O}return!1}substituteConstants(){return this}evaluate(M){const B=M.getValue(this.d);return this.f?this.f.test(B):!1}serialize(){const M=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${M}`}keys(){return[this.d]}map(M){return M.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=l.create(this)),this.c}}e.ContextKeyRegexExpr=s;class l{static create(M){return new l(M)}constructor(M){this.c=M,this.type=8}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(M){return new l(this.c.map(M))}negate(){return this.c}}e.ContextKeyNotRegexExpr=l;function r(q){let M=null;for(let B=0,O=q.length;B<O;B++){const U=q[B].substituteConstants();if(q[B]!==U&&M===null){M=[];for(let z=0;z<B;z++)M[z]=q[z]}M!==null&&(M[B]=U)}return M===null?q:M}class m{static create(M,B,O){return m.d(M,B,O)}constructor(M,B){this.expr=M,this.c=B,this.type=6}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let B=0,O=this.expr.length;B<O;B++){const U=L(this.expr[B],M.expr[B]);if(U!==0)return U}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].equals(M.expr[B]))return!1;return!0}return!1}substituteConstants(){const M=r(this.expr);return M===this.expr?this:m.create(M,this.c,!1)}evaluate(M){for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].evaluate(M))return!1;return!0}static d(M,B,O){const U=[];let z=!1;for(const j of M)if(!!j){if(j.type===1){z=!0;continue}if(j.type===0)return k.INSTANCE;if(j.type===6){U.push(...j.expr);continue}U.push(j)}if(U.length===0&&z)return v.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(L);for(let j=1;j<U.length;j++)U[j-1].equals(U[j])&&(U.splice(j,1),j--);if(U.length===1)return U[0];for(;U.length>1;){const j=U[U.length-1];if(j.type!==9)break;U.pop();const de=U.pop(),V=U.length===0,X=n.create(j.expr.map(J=>m.create([J,de],null,O)),null,V);X&&(U.push(X),U.sort(L))}if(U.length===1)return U[0];if(O){for(let j=0;j<U.length;j++)for(let de=j+1;de<U.length;de++)if(U[j].negate().equals(U[de]))return k.INSTANCE;if(U.length===1)return U[0]}return new m(U,B)}}serialize(){return this.expr.map(M=>M.serialize()).join(" && ")}keys(){const M=[];for(const B of this.expr)M.push(...B.keys());return M}map(M){return new m(this.expr.map(B=>B.map(M)),null)}negate(){if(!this.c){const M=[];for(const B of this.expr)M.push(B.negate());this.c=n.create(M,this,!0)}return this.c}}class n{static create(M,B,O){return n.d(M,B,O)}constructor(M,B){this.expr=M,this.c=B,this.type=9}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let B=0,O=this.expr.length;B<O;B++){const U=L(this.expr[B],M.expr[B]);if(U!==0)return U}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].equals(M.expr[B]))return!1;return!0}return!1}substituteConstants(){const M=r(this.expr);return M===this.expr?this:n.create(M,this.c,!1)}evaluate(M){for(let B=0,O=this.expr.length;B<O;B++)if(this.expr[B].evaluate(M))return!0;return!1}static d(M,B,O){let U=[],z=!1;if(M){for(let j=0,de=M.length;j<de;j++){const V=M[j];if(!!V){if(V.type===0){z=!0;continue}if(V.type===1)return v.INSTANCE;if(V.type===9){U=U.concat(V.expr);continue}U.push(V)}}if(U.length===0&&z)return k.INSTANCE;U.sort(L)}if(U.length!==0){if(U.length===1)return U[0];for(let j=1;j<U.length;j++)U[j-1].equals(U[j])&&(U.splice(j,1),j--);if(U.length===1)return U[0];if(O){for(let j=0;j<U.length;j++)for(let de=j+1;de<U.length;de++)if(U[j].negate().equals(U[de]))return v.INSTANCE;if(U.length===1)return U[0]}return new n(U,B)}}serialize(){return this.expr.map(M=>M.serialize()).join(" || ")}keys(){const M=[];for(const B of this.expr)M.push(...B.keys());return M}map(M){return new n(this.expr.map(B=>B.map(M)),null)}negate(){if(!this.c){const M=[];for(const B of this.expr)M.push(B.negate());for(;M.length>1;){const B=M.shift(),O=M.shift(),U=[];for(const z of x(B))for(const j of x(O))U.push(m.create([z,j],null,!1));M.unshift(n.create(U,null,!1))}this.c=n.create(M,this,!0)}return this.c}}class t extends T{static all(){return t.d.values()}constructor(M,B,O){super(M,null),this.f=B,typeof O=="object"?t.d.push({...O,key:M}):O!==!0&&t.d.push({key:M,description:O,type:B!=null?typeof B:void 0})}bindTo(M){return M.createKey(this.key,this.f)}getValue(M){return M.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(M){return E.create(this.key,M)}notEqualsTo(M){return h.create(this.key,M)}}t.d=[],e.RawContextKey=t,e.IContextKeyService=(0,u.createDecorator)("contextKeyService");function a(q,M){return q<M?-1:q>M?1:0}function w(q,M,B,O){return q<B?-1:q>B?1:M<O?-1:M>O?1:0}function D(q,M){if(q.type===0||M.type===1)return!0;if(q.type===9)return M.type===9?F(q.expr,M.expr):!1;if(M.type===9){for(const B of M.expr)if(D(q,B))return!0;return!1}if(q.type===6){if(M.type===6)return F(M.expr,q.expr);for(const B of q.expr)if(D(B,M))return!0;return!1}return q.equals(M)}e.implies=D;function F(q,M){let B=0,O=0;for(;B<q.length&&O<M.length;){const U=q[B].cmp(M[O]);if(U<0)return!1;U===0&&B++,O++}return B===q.length}function x(q){return q.type===9?q.expr:[q]}}),define(ye[200],De([1,0,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[123],De([1,0,170,4]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough";function u(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=u;function R(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function C(h,g){switch(h){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function P(h,g){return g==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function S(h,g,p){return P(g,p)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===p?!0:I(p).includes(h)}e.isTargetPlatformCompatible=S;function I(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function L(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=L;var k;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var v;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var T;(function(h){h.Install="install",h.Uninstall="uninstall"})(T=e.StatisticType||(e.StatisticType={}));var E;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var f;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal",h.Signature="Signature"})(f=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class d extends Error{constructor(g,p){super(g),this.code=p,this.name=p}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,c.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,c.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ye[201],De([1,0,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,c.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,c.createDecorator)("externalTerminal")}),define(ye[202],De([1,0,46,18,10,12,109,29,116,172,201]),function(ne,e,c,A,u,R,C,P,S,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=I.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:T.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class T extends v{openTerminal(y,b){return this.spawnTerminal(c,y,S.getWindowsShell(),b)}spawnTerminal(y,b,i,o){const s=b.windowsExec||T.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const l=u.basename(s,".exe").toLowerCase();if(l==="cmder")return y.spawn(s,o?[o]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return s.indexOf(" ")>=0&&r.push('""'),r.push(s),l==="wt"&&r.push("-d ."),new Promise((m,n)=>{const t=d(process),a=y.spawn(i,r,{cwd:o,env:t});a.on("error",n),a.on("exit",()=>m())})}runInTerminal(y,b,i,o,s){const l="windowsExec"in s&&s.windowsExec?s.windowsExec:T.getDefaultTerminalWindows();return new Promise((r,m)=>{const n=`"${b} - ${k}"`,t=`""${i.join('" "')}" & pause"`,a=Object.assign({},d(process),o);Object.keys(a).filter(q=>a[q]===null).forEach(q=>delete a[q]);const w={cwd:b,env:a,windowsVerbatimArguments:!0};let D,F;u.basename(l,".exe")==="wt"?(D=l,F=["-d",".",T.b,"/c",t]):(D=T.b,F=["/c","start",n,"/wait",l,"/c",t]),c.spawn(D,F,w).on("error",q=>{m(h(q))}),r(void 0)})}static getDefaultTerminalWindows(){if(!T.d){const y=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");T.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${y?"Sysnative":"System32"}\\cmd.exe`}return T.d}}T.b="cmd.exe",e.WindowsExternalTerminalService=T;class E extends v{openTerminal(y,b){return this.spawnTerminal(c,y,b)}runInTerminal(y,b,i,o,s){const l=s.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((r,m)=>{if(l===L.DEFAULT_TERMINAL_OSX||l==="iTerm.app"){const n=l===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",a=[A.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${n}.scpt`).fsPath,"-t",y||k,"-w",b];for(const F of i)a.push("-a"),a.push(F);if(o){const F=Object.assign({},d(process),o);for(const x in F){const q=F[x];q===null?(a.push("-u"),a.push(x)):(a.push("-e"),a.push(`${x}=${q}`))}}let w="";const D=c.spawn(E.b,a);D.on("error",F=>{m(h(F))}),D.stderr.on("data",F=>{w+=F.toString()}),D.on("exit",F=>{if(F===0)r(void 0);else if(w){const x=w.split(`
`,1);m(new Error(x[0]))}else m(new Error(I.localize(1,null,n,F)))})}else m(new Error(I.localize(2,null,l)))})}spawnTerminal(y,b,i){const o=b.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((s,l)=>{const r=["-a",o];i&&r.push(i);const m=d(process),n=y.spawn("/usr/bin/open",r,{cwd:i,env:m});n.on("error",l),n.on("exit",()=>s())})}}E.b="/usr/bin/osascript",e.MacExternalTerminalService=E;class f extends v{openTerminal(y,b){return this.spawnTerminal(c,y,b)}runInTerminal(y,b,i,o,s){const l=s.linuxExec?Promise.resolve(s.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((r,m)=>{const n=[];l.then(t=>{t.indexOf("gnome-terminal")>=0?n.push("-x"):n.push("-e"),n.push("bash"),n.push("-c");const a=`${g(i)}; echo; read -p "${f.b}" -n1;`;n.push(`''${a}''`);const w=Object.assign({},d(process),o);Object.keys(w).filter(q=>w[q]===null).forEach(q=>delete w[q]);const D={cwd:b,env:w};let F="";const x=c.spawn(t,n,D);x.on("error",q=>{m(h(q))}),x.stderr.on("data",q=>{F+=q.toString()}),x.on("exit",q=>{if(q===0)r(void 0);else if(F){const M=F.split(`
`,1);m(new Error(M[0]))}else m(new Error(I.localize(4,null,t,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!f.d)if(!R.isLinux)f.d=Promise.resolve("xterm");else{const y=await P.Promises.exists("/etc/debian_version");f.d=new Promise(b=>{y?b("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?b("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?b("konsole"):process.env.COLORTERM?b(process.env.COLORTERM):process.env.TERM?b(process.env.TERM):b("xterm")})}return f.d}spawnTerminal(y,b,i){const o=b.linuxExec?Promise.resolve(b.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((s,l)=>{o.then(r=>{const m=d(process),n=y.spawn(r,[],{cwd:i,env:m});n.on("error",l),n.on("exit",()=>s())})})}}f.b=I.localize(3,null),e.LinuxExternalTerminalService=f;function d(p){const y={...p.env};return(0,C.sanitizeProcessEnvironment)(y),y}function h(p){return"errno"in p&&p.errno==="ENOENT"&&"path"in p&&typeof p.path=="string"?new Error(I.localize(5,null,p.path)):p}function g(p){let y="";for(const b of p)b.indexOf(" ")>=0?y+='"'+b+'"':y+=b,y+=" ";return y}}),define(ye[44],De([1,0,68,10,8,9,2,173,4,12]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function L(V){return V.create===!0}e.isFileOpenForWriteOptions=L;var k;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(k=e.FileType||(e.FileType={}));var v;(function(V){V[V.Readonly=1]="Readonly"})(v=e.FilePermission||(e.FilePermission={}));var T;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileClone=32768]="FileClone"})(T=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=E;function f(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=f;function d(V){return!!(V.capabilities&32768)}e.hasFileCloneCapability=d;function h(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function g(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=g;function p(V){return E(V)?!!(V.capabilities&16384):!1}e.hasFileAtomicReadCapability=p;var y;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(y=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(X,J){super(X),this.code=J}}e.FileSystemProviderError=b;function i(V,X){const J=new b(V.toString(),X);return s(J,X),J}e.createFileSystemProviderError=i;function o(V){return V||i((0,P.localize)(0,null),y.Unknown)}e.ensureFileSystemProviderError=o;function s(V,X){return V.name=X?`${X} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=s;function l(V){if(!V)return y.Unknown;if(V instanceof b)return V.code;const X=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!X)return y.Unknown;switch(X[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileExceedsMemoryLimit:return y.FileExceedsMemoryLimit;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}e.toFileSystemProviderErrorCode=l;function r(V){if(V instanceof D)return V.fileOperationResult;switch(l(V)){case y.FileNotFound:return 1;case y.FileIsADirectory:return 0;case y.FileNotADirectory:return 10;case y.FileWriteLocked:return 5;case y.NoPermissions:return 6;case y.FileExists:return 4;case y.FileExceedsMemoryLimit:return 9;case y.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var m;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(m=e.FileOperation||(e.FileOperation={}));class n{constructor(X,J,te){this.resource=X,this.operation=J,this.target=te}isOperation(X){return this.operation===X}}e.FileOperationEvent=n;var t;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(t=e.FileChangeType||(e.FileChangeType={}));class a{constructor(X,J){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const te=new Map;for(const ee of X){const Q=te.get(ee.type);switch(Q?Q.push([ee.resource,ee]):te.set(ee.type,[[ee.resource,ee]]),ee.type){case 1:this.rawAdded.push(ee.resource);break;case 0:this.rawUpdated.push(ee.resource);break;case 2:this.rawDeleted.push(ee.resource);break}}for(const[ee,Q]of te)switch(ee){case 1:this.a=c.TernarySearchTree.forUris(()=>J),this.a.fill(Q);break;case 0:this.b=c.TernarySearchTree.forUris(()=>J),this.b.fill(Q);break;case 2:this.c=c.TernarySearchTree.forUris(()=>J),this.c.fill(Q);break}}contains(X,...J){return this.d(X,{includeChildren:!1},...J)}affects(X,...J){return this.d(X,{includeChildren:!0},...J)}d(X,J,...te){if(!X)return!1;const ee=te.length>0;return!!((!ee||te.includes(1))&&(this.a?.get(X)||J.includeChildren&&this.a?.findSuperstr(X))||(!ee||te.includes(0))&&(this.b?.get(X)||J.includeChildren&&this.b?.findSuperstr(X))||(!ee||te.includes(2))&&(this.c?.findSubstr(X)||J.includeChildren&&this.c?.findSuperstr(X)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=a;function w(V,X,J){return!V||!X||V===X||X.length>V.length?!1:(X.charAt(X.length-1)!==A.sep&&(X+=A.sep),J?(0,u.startsWithIgnoreCase)(V,X):V.indexOf(X)===0)}e.isParent=w;class D extends Error{constructor(X,J,te){super(X),this.fileOperationResult=J,this.options=te}}e.FileOperationError=D;class F extends D{constructor(X,J,te,ee){super(X,J,ee),this.fileOperationResult=J,this.size=te}}e.TooLargeFileOperationError=F;class x extends D{constructor(X,J,te){super(X,2,te),this.stat=J}}e.NotModifiedSinceFileOperationError=x;var q;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(q=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var M;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(M=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function B(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=B;async function O(V,X){if(!X.hasProvider(C.URI.from({scheme:V.scheme})))return new Promise(J=>{const te=X.onDidChangeFileSystemProviderRegistrations(ee=>{ee.scheme===V.scheme&&ee.added&&(te.dispose(),J())})})}e.whenProviderRegistered=O,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(X){return(0,R.isNumber)(X)||(X=0),X<U.KB?(0,P.localize)(1,null,X.toFixed(0)):X<U.MB?(0,P.localize)(2,null,(X/U.KB).toFixed(2)):X<U.GB?(0,P.localize)(3,null,(X/U.MB).toFixed(2)):X<U.TB?(0,P.localize)(4,null,(X/U.GB).toFixed(2)):(0,P.localize)(5,null,(X/U.TB).toFixed(2))}}U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB,e.ByteSize=U;var z;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(z=e.Arch||(e.Arch={}));function j(V){return{maxFileSize:V===0?300*U.MB:16*U.GB,maxHeapSize:V===0?700*U.MB:2*700*U.MB}}e.getPlatformFileLimits=j;function de(V){return I.isWeb?V?10*U.MB:50*U.MB:V?100*U.MB:1024*U.MB}e.getLargeFileConfirmationLimit=de}),define(ye[90],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(...u){this.a=new Map;for(const[R,C]of u)this.set(R,C)}set(u,R){const C=this.a.get(u);return this.a.set(u,R),C}has(u){return this.a.has(u)}get(u){return this.a.get(u)}}e.ServiceCollection=c}),define(ye[203],De([1,0,19,11,6,122,199,4,90,66]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const L=!1;class k extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class v{constructor(d=new S.ServiceCollection,h=!1,g,p=L){this.f=d,this.g=h,this.h=g,this.i=p,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=p?g?._globalGraph??new C.Graph(y=>y):void 0}createChild(d){return new v(d,this.g,this,this.i)}invokeFunction(d,...h){const g=E.traceInvocation(this.i,d);let p=!1;try{return d({get:b=>{if(p)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(b,g);if(!i)throw new Error(`[invokeFunction] unknown service '${b}'`);return i}},...h)}finally{p=!0,g.stop()}}createInstance(d,...h){let g,p;return d instanceof R.SyncDescriptor?(g=E.traceCreation(this.i,d.ctor),p=this.j(d.ctor,d.staticArguments.concat(h),g)):(g=E.traceCreation(this.i,d),p=this.j(d,h,g)),g.stop(),p}j(d,h=[],g){const p=P._util.getServiceDependencies(d).sort((i,o)=>i.index-o.index),y=[];for(const i of p){const o=this.m(i.id,g);o||this.u(`[createInstance] ${d.name} depends on UNKNOWN service ${i.id}.`,!1),y.push(o)}const b=p.length>0?p[0].index:h.length;if(h.length!==b){console.trace(`[createInstance] First service dependency of ${d.name} at position ${b+1} conflicts with ${h.length} static arguments`);const i=b-h.length;i>0?h=h.concat(new Array(i)):h=h.slice(0,b)}return Reflect.construct(d,h.concat(y))}k(d,h){if(this.f.get(d)instanceof R.SyncDescriptor)this.f.set(d,h);else if(this.h)this.h.k(d,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(d){const h=this.f.get(d);return!h&&this.h?this.h.l(d):h}m(d,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const g=this.l(d);return g instanceof R.SyncDescriptor?this.q(d,g,h.branch(d,!0)):(h.branch(d,!1),g)}q(d,h,g){if(this.o.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.o.add(d);try{return this.r(d,h,g)}finally{this.o.delete(d)}}r(d,h,g){const p=new C.Graph(i=>i.id.toString());let y=0;const b=[{id:d,desc:h,_trace:g}];for(;b.length;){const i=b.pop();if(p.lookupOrInsertNode(i),y++>1e3)throw new k(p);for(const o of P._util.getServiceDependencies(i.desc.ctor)){const s=this.l(o.id);if(s||this.u(`[createInstance] ${d} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),s instanceof R.SyncDescriptor){const l={id:o.id,desc:s,_trace:i._trace.branch(o.id,!0)};p.insertEdge(i,l),b.push(l)}}}for(;;){const i=p.roots();if(i.length===0){if(!p.isEmpty())throw new k(p);break}for(const{data:o}of i){if(this.l(o.id)instanceof R.SyncDescriptor){const l=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,l)}p.removeNode(o)}}return this.l(d)}s(d,h,g=[],p,y){if(this.f.get(d)instanceof R.SyncDescriptor)return this.t(d,h,g,p,y);if(this.h)return this.h.s(d,h,g,p,y);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(d,h,g=[],p,y){if(p){const b=new v(void 0,this.g,this,this.i);b.c=String(d);const i=new Map,o=new c.IdleValue(()=>{const s=b.j(h,g,y);for(const[l,r]of i){const m=s[l];if(typeof m=="function")for(const n of r)m.apply(s,n)}return i.clear(),s});return new Proxy(Object.create(null),{get(s,l){if(!o.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let n=i.get(l);return n||(n=new I.LinkedList,i.set(l,n)),(a,w,D)=>{const F=n.push([a,w,D]);return(0,u.toDisposable)(F)}}if(l in s)return s[l];const r=o.value;let m=r[l];return typeof m!="function"||(m=m.bind(r),s[l]=m),m},set(s,l,r){return o.value[l]=r,!0},getPrototypeOf(s){return h.prototype}})}else return this.j(h,g,y)}u(d,h){if(h&&console.warn(d),this.g)throw new Error(d)}}e.InstantiationService=v;var T;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(T||(T={}));class E{static traceInvocation(d,h){return d?new E(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):E.c}static traceCreation(d,h){return d?new E(1,h.name):E.c}constructor(d,h){this.type=d,this.name=h,this.g=Date.now(),this.h=[]}branch(d,h){const g=new E(3,d.toString());return this.h.push([d,h,g]),g}stop(){const d=Date.now()-this.g;E.f+=d;let h=!1;function g(y,b){const i=[],o=new Array(y+1).join("	");for(const[s,l,r]of b.h)if(l&&r){h=!0,i.push(`${o}CREATES -> ${s}`);const m=g(y+1,r);m&&i.push(m)}else i.push(`${o}uses -> ${s}`);return i.join(`
`)}const p=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${E.f.toFixed(2)}ms)`];(d>2||h)&&E.all.add(p.join(`
`))}}E.all=new Set,E.c=new class extends E{constructor(){super(0,null)}stop(){}branch(){return this}},E.f=0,e.Trace=E}),define(ye[13],De([1,0,45,3,6,28,12,9,2,4]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function L(){return new Date().toISOString()}function k(n){return(0,P.isNumber)(n)}e.isLogLevel=k;var v;(function(n){n[n.Off=0]="Off",n[n.Trace=1]="Trace",n[n.Debug=2]="Debug",n[n.Info=3]="Info",n[n.Warning=4]="Warning",n[n.Error=5]="Error"})(v=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=v.Info;function T(n,t,a){switch(t){case v.Trace:n.trace(a);break;case v.Debug:n.debug(a);break;case v.Info:n.info(a);break;case v.Warning:n.warn(a);break;case v.Error:n.error(a);break;case v.Off:break;default:throw new Error(`Invalid log level ${t}`)}}e.log=T;function E(n){let t="";for(let a=0;a<n.length;a++){let w=n[a];if(typeof w=="object")try{w=JSON.stringify(w)}catch{}t+=(a>0?" ":"")+w}return t}e.format=E;class f extends u.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new A.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(t){this.b!==t&&(this.b=t,this.c.fire(this.b))}getLevel(){return this.b}f(t){return this.b!==v.Off&&this.b<=t}}e.AbstractLogger=f;class d extends f{constructor(t){super(),this.h=t}f(t){return this.h||super.f(t)}trace(t,...a){this.f(v.Trace)&&this.g(v.Trace,E([t,...a]))}debug(t,...a){this.f(v.Debug)&&this.g(v.Debug,E([t,...a]))}info(t,...a){this.f(v.Info)&&this.g(v.Info,E([t,...a]))}warn(t,...a){this.f(v.Warning)&&this.g(v.Warning,E([t,...a]))}error(t,...a){if(this.f(v.Error))if(t instanceof Error){const w=Array.prototype.slice.call(arguments);w[0]=t.stack,this.g(v.Error,E(w))}else this.g(v.Error,E([t,...a]))}flush(){}}e.AbstractMessageLogger=d;class h extends f{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t),this.g=!C.isWindows}trace(t,...a){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${L()}]\x1B[0m`,t,...a):console.log(`[main ${L()}]`,t,...a))}debug(t,...a){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${L()}]\x1B[0m`,t,...a):console.log(`[main ${L()}]`,t,...a))}info(t,...a){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${L()}]\x1B[0m`,t,...a):console.log(`[main ${L()}]`,t,...a))}warn(t,...a){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${L()}]\x1B[0m`,t,...a):console.warn(`[main ${L()}]`,t,...a))}error(t,...a){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${L()}]\x1B[0m`,t,...a):console.error(`[main ${L()}]`,t,...a))}dispose(){}flush(){}}e.ConsoleMainLogger=h;class g extends f{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t)}trace(t,...a){this.f(v.Trace)&&console.log("%cTRACE","color: #888",t,...a)}debug(t,...a){this.f(v.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",t,...a)}info(t,...a){this.f(v.Info)&&console.log("%c INFO","color: #33f",t,...a)}warn(t,...a){this.f(v.Warning)&&console.log("%c WARN","color: #993",t,...a)}error(t,...a){this.f(v.Error)&&console.log("%c  ERR","color: #f33",t,...a)}dispose(){}flush(){}}e.ConsoleLogger=g;class p extends f{constructor(t,a=e.DEFAULT_LOG_LEVEL){super(),this.g=t,this.setLevel(a)}trace(t,...a){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(t),...a])}debug(t,...a){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(t),...a])}info(t,...a){this.f(v.Info)&&this.g.log(v.Info,[this.h(t),...a])}warn(t,...a){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(t),...a])}error(t,...a){this.f(v.Error)&&this.g.log(v.Error,[this.h(t),...a])}h(t){return typeof t=="string"?t:(0,c.toErrorMessage)(t,this.f(v.Trace))}dispose(){}flush(){}}e.AdapterLogger=p;class y extends f{constructor(t){super(),this.g=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const a of this.g)a.setLevel(t);super.setLevel(t)}trace(t,...a){for(const w of this.g)w.trace(t,...a)}debug(t,...a){for(const w of this.g)w.debug(t,...a)}info(t,...a){for(const w of this.g)w.info(t,...a)}warn(t,...a){for(const w of this.g)w.warn(t,...a)}error(t,...a){for(const w of this.g)w.error(t,...a)}flush(){for(const t of this.g)t.flush()}dispose(){for(const t of this.g)t.dispose()}}e.MultiplexLogger=y;class b extends u.Disposable{constructor(t,a){if(super(),this.j=t,this.b=new R.ResourceMap,this.c=new R.ResourceMap,this.f=this.B(new A.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new A.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new A.Emitter),this.onDidChangeVisibility=this.h.event,a)for(const w of a)this.c.set(w.resource,w)}getLogger(t){return this.b.get(t)}createLogger(t,a){let w=this.b.get(t);const D=a?.logLevel==="always"?v.Trace:a?.logLevel;return w||(w=this.k(t,D??this.getLogLevel(t)??this.j,a),this.b.set(t,w)),this.registerLogger({resource:t,id:a?.id??t.toString(),logLevel:D,name:a?.name,hidden:a?.hidden,extensionId:a?.extensionId}),w}setLogLevel(t,a){if(S.URI.isUri(t)){const w=t,D=a,F=this.c.get(w);F&&D!==F.logLevel&&(F.logLevel=D===this.j?void 0:D,this.b.get(w)?.setLevel(D),this.c.set(F.resource,F),this.g.fire([w,D]))}else{this.j=t;for(const[w,D]of this.b.entries())this.c.get(w)?.logLevel===void 0&&D.setLevel(this.j);this.g.fire(this.j)}}setVisibility(t,a){const w=this.c.get(t);w&&a!==!w.hidden&&(w.hidden=!a,this.c.set(w.resource,w),this.h.fire([t,a]))}getLogLevel(t){let a;return t&&(a=this.c.get(t)?.logLevel),a??this.j}registerLogger(t){const a=this.c.get(t.resource);a?a.hidden!==t.hidden&&this.setVisibility(t.resource,!t.hidden):(this.c.set(t.resource,t),this.f.fire({added:[t],removed:[]}))}deregisterLogger(t){const a=this.c.get(t);if(a){this.c.delete(t);const w=this.b.get(t);w&&(this.b.delete(t),w.dispose()),this.f.fire({added:[],removed:[a]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(t){return this.c.get(t)}dispose(){this.b.forEach(t=>t.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=b;class i{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(t){}getLevel(){return v.Info}trace(t,...a){}debug(t,...a){}info(t,...a){}warn(t,...a){}error(t,...a){}critical(t,...a){}dispose(){}flush(){}}e.NullLogger=i;class o extends i{}e.NullLogService=o;class s extends b{constructor(){super(v.Info)}k(t,a,w){return new i}}e.NullLoggerService=s;function l(n){if(n.verbose)return v.Trace;if(typeof n.logLevel=="string"){const t=m(n.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function r(n){switch(n){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.LogLevelToString=r;function m(n){switch(n){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.parseLogLevel=m}),define(ye[204],De([1,0,6,13]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class u extends c.Disposable{constructor(C,P=[]){super(),this.a=new A.MultiplexLogger([C,...P]),this.B(C.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...P){this.a.trace(C,...P)}debug(C,...P){this.a.debug(C,...P)}info(C,...P){this.a.info(C,...P)}warn(C,...P){this.a.warn(C,...P)}error(C,...P){this.a.error(C,...P)}flush(){this.a.flush()}}e.LogService=u}),define(ye[205],De([1,0,44,13]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var u;(function(I){I[I.Trace=0]="Trace",I[I.Debug=1]="Debug",I[I.Info=2]="Info",I[I.Warning=3]="Warning",I[I.Error=4]="Error",I[I.Critical=5]="Critical",I[I.Off=6]="Off"})(u||(u={}));async function R(I,L,k,v,T){try{const E=await new Promise((d,h)=>{ne(["spdlog"],d,h)});E.setFlushOn(u.Trace);const f=await E.createAsyncRotatingLogger(I,L,k,v);return T?f.clearFormatters():f.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),f}catch(E){console.error(E)}return null}function C(I,L,k){switch(L){case A.LogLevel.Trace:I.trace(k);break;case A.LogLevel.Debug:I.debug(k);break;case A.LogLevel.Info:I.info(k);break;case A.LogLevel.Warning:I.warn(k);break;case A.LogLevel.Error:I.error(k);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function P(I,L){switch(L){case A.LogLevel.Trace:I.setLevel(u.Trace);break;case A.LogLevel.Debug:I.setLevel(u.Debug);break;case A.LogLevel.Info:I.setLevel(u.Info);break;case A.LogLevel.Warning:I.setLevel(u.Warning);break;case A.LogLevel.Error:I.setLevel(u.Error);break;case A.LogLevel.Off:I.setLevel(u.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class S extends A.AbstractMessageLogger{constructor(L,k,v,T,E){super(),this.k=[],this.setLevel(E),this.l=this.n(L,k,v,T),this.B(this.onDidChangeLogLevel(f=>{this.m&&P(this.m,f)}))}async n(L,k,v,T){const E=v?6:1,f=30/E*c.ByteSize.MB,d=await R(L,k,f,E,T);if(d){this.m=d,P(this.m,this.getLevel());for(const{level:h,message:g}of this.k)C(this.m,h,g);this.k=[]}}g(L,k){this.m?C(this.m,L,k):this.getLevel()<=L&&this.k.push({level:L,message:k})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=S}),define(ye[124],De([1,0,37,174,4]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(R=e.MarkerTag||(e.MarkerTag={}));var C;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function I(E,f){return f-E}S.compare=I;const L=Object.create(null);L[S.Error]=(0,A.localize)(0,null),L[S.Warning]=(0,A.localize)(1,null),L[S.Info]=(0,A.localize)(2,null);function k(E){return L[E]||""}S.toString=k;function v(E){switch(E){case c.default.Error:return S.Error;case c.default.Warning:return S.Warning;case c.default.Info:return S.Info;case c.default.Ignore:return S.Hint}}S.fromSeverity=v;function T(E){switch(E){case S.Error:return c.default.Error;case S.Warning:return c.default.Warning;case S.Info:return c.default.Info;case S.Hint:return c.default.Ignore}}S.toSeverity=T}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(S){const I="";function L(v){return k(v,!0)}S.makeKey=L;function k(v,T){const E=[I];return v.source?E.push(v.source.replace("\xA6","\\\xA6")):E.push(I),v.code?typeof v.code=="string"?E.push(v.code.replace("\xA6","\\\xA6")):E.push(v.code.value.replace("\xA6","\\\xA6")):E.push(I),v.severity!==void 0&&v.severity!==null?E.push(C.toString(v.severity)):E.push(I),v.message&&T?E.push(v.message.replace("\xA6","\\\xA6")):E.push(I),v.startLineNumber!==void 0&&v.startLineNumber!==null?E.push(v.startLineNumber.toString()):E.push(I),v.startColumn!==void 0&&v.startColumn!==null?E.push(v.startColumn.toString()):E.push(I),v.endLineNumber!==void 0&&v.endLineNumber!==null?E.push(v.endLineNumber.toString()):E.push(I),v.endColumn!==void 0&&v.endColumn!==null?E.push(v.endColumn.toString()):E.push(I),E.push(I),E.join("\xA6")}S.makeKeyOptionalMessage=k})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,u.createDecorator)("markerService")}),define(ye[206],De([1,0,3,37,4]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=A.default,e.INotificationService=(0,u.createDecorator)("notificationService");var R;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(R=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new S,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=P;class S{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=S}),define(ye[125],De([1,0,8,2,4]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,u.createDecorator)("openerService");function R(I,L){return A.URI.isUri(I)?(0,c.equalsIgnoreCase)(I.scheme,L):(0,c.startsWithIgnoreCase)(I,L+":")}e.matchesScheme=R;function C(I,...L){return L.some(k=>R(I,k))}e.matchesSomeScheme=C;function P(I,L){return I.with({fragment:`${L.startLineNumber},${L.startColumn}${L.endLineNumber?`-${L.endLineNumber}${L.endColumn?`,${L.endColumn}`:""}`:""}`})}e.withSelection=P;function S(I){let L;const k=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(I.fragment);return k&&(L={startLineNumber:parseInt(k[1]),startColumn:k[2]?parseInt(k[2]):1,endLineNumber:k[4]?parseInt(k[4]):void 0,endColumn:k[4]?k[5]?parseInt(k[5]):1:void 0},I=I.with({fragment:""})),{selection:L,uri:I}}e.extractSelection=S}),define(ye[207],De([1,0,12,36]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let u;if(typeof c.globals.vscode<"u"&&typeof c.globals.vscode.context<"u"){const R=c.globals.vscode.context.configuration();if(R)u=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(u=globalThis._VSCODE_PRODUCT_JSON,A.env.VSCODE_DEV&&Object.assign(u,{nameShort:`${u.nameShort} Dev`,nameLong:`${u.nameLong} Dev`,dataFolderName:`${u.dataFolderName}-dev`,serverDataFolderName:u.serverDataFolderName?`${u.serverDataFolderName}-dev`:void 0}),!u.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(u,{version:R.version})}}else u={},Object.keys(u).length===0&&Object.assign(u,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=u}),define(ye[208],De([1,0,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,c.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var We=this&&this.__param||function(ne,e){return function(c,A){e(c,A,ne)}};define(ye[126],De([1,0,19,21,6,4]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,R.createDecorator)("progressService");var C;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{get value(){return this.a}constructor(k){this.b=k}report(k){this.a=k,this.b(this.a)}}P.None=Object.freeze({report(){}}),e.Progress=P;let S=class extends u.Disposable{constructor(k,v){super(),this.a=new c.DeferredPromise,v.withProgress(k,T=>(this.b=T,this.c&&T.report(this.c),this.a.p)),this.B((0,u.toDisposable)(()=>this.a.complete()))}report(k){this.b?this.b.report(k):this.c=k}};S=qe([We(1,e.IProgressService)],S),e.UnmanagedProgress=S;class I extends u.Disposable{constructor(k){super(),this.g=k,this.a=0,this.b=this.B(new u.DisposableStore)}start(k){this.stop();const v=++this.a,T=new A.CancellationTokenSource;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},k),this.b.add((0,u.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,u.toDisposable)(()=>T.cancel())),this.b.add((0,u.toDisposable)(()=>this.c?this.c.done():void 0)),{id:v,token:T.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(k){this.a===k&&this.b.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,R.createDecorator)("editorProgressService")}),define(ye[39],De([1,0,50,9]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class u{constructor(){this.a=new Map}add(C,P){c.ok(A.isString(C)),c.ok(A.isObject(P)),c.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,P)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.Registry=new u}),define(ye[91],De([1,0,3,39]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function u(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class R{constructor(){this.b=new c.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,I){this.a[u(S)]=I,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const C=new R;A.Registry.add(e.Extensions.JSONContribution,C)}),define(ye[127],De([1,0,15,3,9,169,53,91,39]),function(ne,e,c,A,u,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=S.Registry.as(P.Extensions.JSONContribution);class v{constructor(){this.h=new Set,this.i=new A.Emitter,this.onDidSchemaChange=this.i.event,this.j=new A.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const s=new Set;this.n(i,o,s),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(i){const o=new Set;this.o(i,o),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const s=new Set;this.o(o,s),this.n(i,!1,s),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const s=[];for(const{overrides:l,source:r}of i)for(const m in l)if(o.add(m),e.OVERRIDE_PROPERTY_REGEX.test(m)){const n=this.a.get(m),t=n?.valuesSources??new Map;if(r)for(const F of Object.keys(l[m]))t.set(F,r);const a={...n?.value||{},...l[m]};this.a.set(m,{source:r,value:a,valuesSources:t});const w=(0,C.getLanguageTagSettingPlainKey)(m),D={type:"object",default:a,description:R.localize(1,null,w),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:a,source:u.isString(r)?void 0:r,defaultValueSource:r};s.push(...f(m)),this.d[m]=D,this.b.properties[m]=D}else{this.a.set(m,{value:l[m],source:r});const n=this.d[m];n&&(this.w(m,n),this.r(m,n))}this.m(s)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:s,source:l}of i)for(const r in s){const m=this.a.get(r),n=u.isString(l)?l:l?.id,t=u.isString(m?.source)?m?.source:m?.source?.id;if(n===t)if(o.add(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}}this.u()}deltaConfiguration(i){let o=!1;const s=new Set;i.removedDefaults&&(this.l(i.removedDefaults,s),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,s),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,s),i.addedConfigurations&&this.n(i.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,s){i.forEach(l=>{this.p(l,o,l.extensionInfo,l.restrictedProperties,void 0,s),this.c.push(l),this.q(l)})}o(i,o){const s=l=>{if(l.properties)for(const r in l.properties){o.add(r);const m=this.d[r];m?.policy?.name&&this.e.delete(m.policy.name),delete this.d[r],this.s(r,l.properties[r])}l.allOf?.forEach(r=>s(r))};for(const l of i){s(l);const r=this.c.indexOf(l);r!==-1&&this.c.splice(r,1)}}p(i,o=!0,s,l,r=3,m){r=u.isUndefinedOrNull(i.scope)?r:i.scope;const n=i.properties;if(n)for(const a in n){const w=n[a];if(o&&p(a,w)){delete n[a];continue}if(w.source=s,w.defaultDefaultValue=n[a].default,this.w(a,w),e.OVERRIDE_PROPERTY_REGEX.test(a)?w.scope=void 0:(w.scope=u.isUndefinedOrNull(w.scope)?r:w.scope,w.restricted=u.isUndefinedOrNull(w.restricted)?!!l?.includes(a):w.restricted),n[a].hasOwnProperty("included")&&!n[a].included){this.f[a]=n[a],delete n[a];continue}else this.d[a]=n[a],n[a].policy?.name&&this.e.set(n[a].policy.name,a);!n[a].deprecationMessage&&n[a].markdownDeprecationMessage&&(n[a].deprecationMessage=n[a].markdownDeprecationMessage),m.add(a)}const t=i.allOf;if(t)for(const a of t)this.p(a,o,s,l,r,m)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=s=>{const l=s.properties;if(l)for(const m in l)this.r(m,l[m]);s.allOf?.forEach(o)};o(i)}r(i,o){switch(e.allSettings.properties[i]=o,o.scope){case 1:e.applicationSettings.properties[i]=o;break;case 2:e.machineSettings.properties[i]=o;break;case 6:e.machineOverridableSettings.properties[i]=o;break;case 3:e.windowSettings.properties[i]=o;break;case 4:e.resourceSettings.properties[i]=o;break;case 5:e.resourceSettings.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.allSettings.properties[i],o.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,s={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(o,s),e.allSettings.properties[o]=s,e.applicationSettings.properties[o]=s,e.machineSettings.properties[o]=s,e.machineOverridableSettings.properties[o]=s,e.windowSettings.properties[o]=s,e.resourceSettings.properties[o]=s}}v(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,o){const s=this.a.get(i);let l=s?.value,r=s?.source;u.isUndefined(l)&&(l=o.defaultDefaultValue,r=void 0),u.isUndefined(l)&&(l=h(o.type)),o.default=l,o.defaultValueSource=r}}const T="\\[([^\\]]+)\\]",E=new RegExp(T,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${T})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function f(b){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(b)){let o=E.exec(b);for(;o?.length;){const s=o[1].trim();s&&i.push(s),o=E.exec(b)}}return(0,c.distinct)(i)}e.overrideIdentifiersFromKey=f;function d(b){return b.reduce((i,o)=>`${i}[${o}]`,"")}e.keyFromOverrideIdentifiers=d;function h(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const g=new v;S.Registry.add(e.Extensions.Configuration,g);function p(b,i){return b.trim()?e.OVERRIDE_PROPERTY_REGEX.test(b)?R.localize(7,null,b):g.getConfigurationProperties()[b]!==void 0?R.localize(8,null,b):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,b,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}e.validateProperty=p;function y(){const b=[],i=g.getConfigurationProperties();for(const o of Object.keys(i))b.push([o,i[o].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=y}),define(ye[209],De([1,0,15,3,146,6,28,23,9,2,53,127,39]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function T(o){return Object.isFrozen(o)?o:P.deepFreeze(o)}class E{constructor(s={},l=[],r=[],m){this.b=s,this.c=l,this.d=r,this.raw=m,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(l=>{if(l instanceof E)return l;const r=new f("");return r.parseRaw(l),r.configurationModel});this.f=s.reduce((l,r)=>r===l?r:l.merge(r),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,L.getConfigurationValue)(this.contents,s):this.contents}inspect(s,l){const r=this.rawConfiguration.getValue(s),m=l?this.rawConfiguration.getOverrideValue(s,l):void 0,n=l?this.rawConfiguration.override(l).getValue(s):r;return{value:r,override:m,merged:n}}getOverrideValue(s,l){const r=this.i(l);return r?s?(0,L.getConfigurationValue)(r,s):r:void 0}getKeysForOverrideIdentifier(s){const l=[];for(const r of this.overrides)r.identifiers.includes(s)&&l.push(...r.keys);return c.distinct(l)}getAllOverrideIdentifiers(){const s=[];for(const l of this.overrides)s.push(...l.identifiers);return c.distinct(s)}override(s){let l=this.a.get(s);return l||(l=this.g(s),this.a.set(s,l)),l}merge(...s){const l=P.deepClone(this.contents),r=P.deepClone(this.overrides),m=[...this.keys],n=this.raw?.length?[...this.raw]:[this];for(const t of s)if(n.push(...t.raw?.length?t.raw:[t]),!t.isEmpty()){this.h(l,t.contents);for(const a of t.overrides){const[w]=r.filter(D=>c.equals(D.identifiers,a.identifiers));w?(this.h(w.contents,a.contents),w.keys.push(...a.keys),w.keys=c.distinct(w.keys)):r.push(P.deepClone(a))}for(const a of t.keys)m.indexOf(a)===-1&&m.push(a)}return new E(l,m,r,n.every(t=>t instanceof E)?void 0:n)}g(s){const l=this.i(s);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const r={};for(const m of c.distinct([...Object.keys(this.contents),...Object.keys(l)])){let n=this.contents[m];const t=l[m];t&&(typeof n=="object"&&typeof t=="object"?(n=P.deepClone(n),this.h(n,t)):n=t),r[m]=n}return new E(r,this.keys,this.overrides)}h(s,l){for(const r of Object.keys(l)){if(r in s&&S.isObject(s[r])&&S.isObject(l[r])){this.h(s[r],l[r]);continue}s[r]=P.deepClone(l[r])}}i(s){let l=null,r=null;const m=n=>{n&&(r?this.h(r,n):r=P.deepClone(n))};for(const n of this.overrides)c.equals(n.identifiers,[s])?l=n.contents:n.identifiers.includes(s)&&m(n.contents);return m(l),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,l){this.j(s,l,!0)}setValue(s,l){this.j(s,l,!1)}removeValue(s){const l=this.keys.indexOf(s);l!==-1&&(this.keys.splice(l,1),(0,L.removeFromValueTree)(this.contents,s),k.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(r=>c.equals(r.identifiers,(0,k.overrideIdentifiersFromKey)(s))),1))}j(s,l,r){(0,L.addToValueTree)(this.contents,s,l,m=>console.error(m)),r=r||this.keys.indexOf(s)===-1,r&&this.keys.push(s),k.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,k.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,L.toValuesTree)(this.contents[s],m=>console.error(m))})}}e.ConfigurationModel=E;class f{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new E}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,l){if(!S.isUndefinedOrNull(s)){const r=this.g(s);this.parseRaw(r,l)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,l){this.a=s;const{contents:r,keys:m,overrides:n,restricted:t,hasExcludedProperties:a}=this.h(s,l);this.b=new E(r,m,n,a?[s]:void 0),this.c=t||[]}g(s){let l={},r=null,m=[];const n=[],t=[];function a(D){Array.isArray(m)?m.push(D):r!==null&&(m[r]=D)}const w={onObjectBegin:()=>{const D={};a(D),n.push(m),m=D,r=null},onObjectProperty:D=>{r=D},onObjectEnd:()=>{m=n.pop()},onArrayBegin:()=>{const D=[];a(D),n.push(m),m=D,r=null},onArrayEnd:()=>{m=n.pop()},onLiteralValue:a,onError:(D,F,x)=>{t.push({error:D,offset:F,length:x})}};if(s)try{u.visit(s,w),l=m[0]||{}}catch(D){console.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return l}h(s,l){const r=v.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),m=this.i(s,r,!0,l);s=m.raw;const n=(0,L.toValuesTree)(s,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),t=Object.keys(s),a=this.j(s,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:n,keys:t,overrides:a,restricted:m.restricted,hasExcludedProperties:m.hasExcludedProperties}}i(s,l,r,m){let n=!1;if(!m?.scopes&&!m?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:n};const t={},a=[];for(const w in s)if(k.OVERRIDE_PROPERTY_REGEX.test(w)&&r){const D=this.i(s[w],l,!1,m);t[w]=D.raw,n=n||D.hasExcludedProperties,a.push(...D.restricted)}else{const D=l[w],F=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&a.push(w),(F===void 0||m.scopes===void 0||m.scopes.includes(F))&&!(m.skipRestricted&&D?.restricted)?t[w]=s[w]:n=!0}return{raw:t,restricted:a,hasExcludedProperties:n}}j(s,l){const r=[];for(const m of Object.keys(s))if(k.OVERRIDE_PROPERTY_REGEX.test(m)){const n={};for(const t in s[m])n[t]=s[m][t];r.push({identifiers:(0,k.overrideIdentifiersFromKey)(m),keys:Object.keys(n),contents:(0,L.toValuesTree)(n,l)})}return r}}e.ConfigurationModelParser=f;class d extends R.Disposable{constructor(s,l,r,m){super(),this.f=s,this.g=l,this.h=m,this.c=this.B(new A.Emitter),this.onDidChange=this.c.event,this.a=new f(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(A.Event.any(A.Event.filter(this.h.onDidFilesChange,n=>n.contains(this.f)),A.Event.filter(this.h.onDidRunOperation,n=>(n.isOperation(0)||n.isOperation(3)||n.isOperation(1)||n.isOperation(4))&&r.isEqual(n.resource,s)))(()=>this.c.fire()))}async loadConfiguration(){try{const s=await this.h.readFile(this.f);return this.a.parse(s.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new E}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=d;class h{constructor(s,l,r,m,n,t,a,w,D,F,x,q,M){this.a=s,this.b=l,this.c=r,this.overrideIdentifiers=m,this.d=n,this.f=t,this.g=a,this.h=w,this.i=D,this.j=F,this.k=x,this.l=q,this.m=M}get value(){return T(this.c)}n(s,l,r){const m=s.inspect(l,r);return{get value(){return T(m.value)},get override(){return T(m.override)},get merged(){return T(m.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class g{constructor(s,l,r,m,n=new E,t=new E,a=new C.ResourceMap,w=new E,D=new C.ResourceMap){this.c=s,this.d=l,this.f=r,this.g=m,this.h=n,this.i=t,this.j=a,this.l=w,this.m=D,this.a=null,this.b=new C.ResourceMap,this.n=null}getValue(s,l,r){return this.q(s,l,r).getValue(s)}updateValue(s,l,r={}){let m;r.resource?(m=this.m.get(r.resource),m||(m=new E,this.m.set(r.resource,m))):m=this.l,l===void 0?m.removeValue(s):m.setValue(s,l),r.resource||(this.a=null)}inspect(s,l,r){const m=this.q(s,l,r),n=this.u(l.resource,r),t=l.resource?this.m.get(l.resource)||this.l:this.l,a=new Set;for(const w of m.overrides)for(const D of w.identifiers)m.getOverrideValue(s,D)!==void 0&&a.add(D);return new h(s,l,m.getValue(s),a.size?[...a]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,n||void 0,t)}keys(s){const l=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,l){this.j.set(s,l),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,l){const r=[];if(!l){const{added:m,updated:n,removed:t}=b(this.c,s);l=[...m,...n,...t]}for(const m of l)for(const n of(0,k.overrideIdentifiersFromKey)(m)){const t=this.c.getKeysForOverrideIdentifier(n),a=s.getKeysForOverrideIdentifier(n),w=[...a.filter(D=>t.indexOf(D)===-1),...t.filter(D=>a.indexOf(D)===-1),...t.filter(D=>!P.equals(this.c.override(n).getValue(D),s.override(n).getValue(D)))];r.push([n,w])}return this.updateDefaultConfiguration(s),{keys:l,overrides:r}}compareAndUpdatePolicyConfiguration(s){const{added:l,updated:r,removed:m}=b(this.d,s),n=[...l,...r,...m];return n.length&&this.updatePolicyConfiguration(s),{keys:n,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:l,updated:r,removed:m,overrides:n}=b(this.applicationConfiguration,s),t=[...l,...r,...m];return t.length&&this.updateApplicationConfiguration(s),{keys:t,overrides:n}}compareAndUpdateLocalUserConfiguration(s){const{added:l,updated:r,removed:m,overrides:n}=b(this.localUserConfiguration,s),t=[...l,...r,...m];return t.length&&this.updateLocalUserConfiguration(s),{keys:t,overrides:n}}compareAndUpdateRemoteUserConfiguration(s){const{added:l,updated:r,removed:m,overrides:n}=b(this.remoteUserConfiguration,s),t=[...l,...r,...m];return t.length&&this.updateRemoteUserConfiguration(s),{keys:t,overrides:n}}compareAndUpdateWorkspaceConfiguration(s){const{added:l,updated:r,removed:m,overrides:n}=b(this.workspaceConfiguration,s),t=[...l,...r,...m];return t.length&&this.updateWorkspaceConfiguration(s),{keys:t,overrides:n}}compareAndUpdateFolderConfiguration(s,l){const r=this.p.get(s),{added:m,updated:n,removed:t,overrides:a}=b(r,l),w=[...m,...n,...t];return(w.length||!r)&&this.updateFolderConfiguration(s,l),{keys:w,overrides:a}}compareAndDeleteFolderConfiguration(s){const l=this.p.get(s);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:r,updated:m,removed:n,overrides:t}=b(l,void 0);return{keys:[...r,...m,...n],overrides:t}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,l,r){let m=this.r(l,r);return l.overrideIdentifier&&(m=m.override(l.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(m=m.merge(this.d)),m}r({resource:s},l){let r=this.s();if(l&&s){const m=l.getFolder(s);m&&(r=this.t(m.uri)||r);const n=this.m.get(s);n&&(r=r.merge(n))}return r}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let l=this.b.get(s);if(!l){const r=this.s(),m=this.j.get(s);m?(l=r.merge(m),this.b.set(s,l)):l=r}return l}u(s,l){if(l&&s){const r=l.getFolder(s);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,l)=>{const{contents:r,overrides:m,keys:n}=this.j.get(l);return s.push([l,{contents:r,overrides:m,keys:n}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(l=>s.add(l)),this.userConfiguration.keys.forEach(l=>s.add(l)),this.i.keys.forEach(l=>s.add(l)),this.j.forEach(l=>l.keys.forEach(r=>s.add(r))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(l=>s.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>s.add(l)),this.i.getAllOverrideIdentifiers().forEach(l=>s.add(l)),this.j.forEach(l=>l.getAllOverrideIdentifiers().forEach(r=>s.add(r))),[...s.values()]}w(s){const l=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(r=>l.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>l.add(r)),this.i.getKeysForOverrideIdentifier(s).forEach(r=>l.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(s).forEach(m=>l.add(m))),[...l.values()]}static parse(s){const l=this.x(s.defaults),r=this.x(s.policy),m=this.x(s.application),n=this.x(s.user),t=this.x(s.workspace),a=s.folders.reduce((w,D)=>(w.set(I.URI.revive(D[0]),this.x(D[1])),w),new C.ResourceMap);return new g(l,r,m,n,new E,t,a,new E,new C.ResourceMap)}static x(s){return new E(s.contents,s.keys,s.overrides)}}e.Configuration=g;function p(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,l=new Map;for(const m of o)m.keys.forEach(n=>s.add(n)),m.overrides.forEach(([n,t])=>{const a=(0,C.getOrSet)(l,n,new Set);t.forEach(w=>a.add(w))});const r=[];return l.forEach((m,n)=>r.push([n,[...m.values()]])),{keys:[...s.values()],overrides:r}}e.mergeChanges=p;class y{constructor(s,l,r,m){this.change=s,this.f=l,this.g=r,this.h=m,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const n of s.keys)this.affectedKeys.add(n);for(const[,n]of s.overrides)for(const t of n)this.affectedKeys.add(t);this.d=this.a;for(const n of this.affectedKeys)this.d+=n+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=g.parse(this.f.data)),this.i}affectsConfiguration(s,l){const r=this.a+s,m=this.d.indexOf(r);if(m<0)return!1;const n=m+r.length;if(n>=this.d.length)return!1;const t=this.d.charCodeAt(n);if(t!==this.b&&t!==this.c)return!1;if(l){const a=this.previousConfiguration?this.previousConfiguration.getValue(s,l,this.f?.workspace):void 0,w=this.g.getValue(s,l,this.h);return!P.equals(a,w)}return!0}}e.ConfigurationChangeEvent=y;function b(o,s){const{added:l,removed:r,updated:m}=i(s?.rawConfiguration,o?.rawConfiguration),n=[],t=o?.getAllOverrideIdentifiers()||[],a=s?.getAllOverrideIdentifiers()||[];if(s){const w=a.filter(D=>!t.includes(D));for(const D of w)n.push([D,s.getKeysForOverrideIdentifier(D)])}if(o){const w=t.filter(D=>!a.includes(D));for(const D of w)n.push([D,o.getKeysForOverrideIdentifier(D)])}if(s&&o){for(const w of t)if(a.includes(w)){const D=i({contents:o.getOverrideValue(void 0,w)||{},keys:o.getKeysForOverrideIdentifier(w)},{contents:s.getOverrideValue(void 0,w)||{},keys:s.getKeysForOverrideIdentifier(w)});n.push([w,[...D.added,...D.removed,...D.updated]])}}return{added:l,removed:r,updated:m,overrides:n}}function i(o,s){const l=o?s?o.keys.filter(n=>s.keys.indexOf(n)===-1):[...o.keys]:[],r=s?o?s.keys.filter(n=>o.keys.indexOf(n)===-1):[...s.keys]:[],m=[];if(o&&s){for(const n of s.keys)if(o.keys.indexOf(n)!==-1){const t=(0,L.getConfigurationValue)(s.contents,n),a=(0,L.getConfigurationValue)(o.contents,n);P.equals(t,a)||m.push(n)}}return{added:l,removed:r,updated:m}}}),define(ye[128],De([1,0,11,4]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,A.createDecorator)("remoteAuthorityResolverService");var u;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(u=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends c.ErrorNoTelemetry{static isNotAvailable(S){return S instanceof R&&S._code===u.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof R&&S._code===u.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof R&&S._code===u.NoResolverFound}static isHandled(S){return S instanceof R&&S.isHandled}constructor(S,I=u.Unknown,L){super(S),this._message=S,this._code=I,this._detail=L,this.isHandled=I===u.NotAvailable&&L===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R;function C(P){const S=P.indexOf("+");return S===-1?P:P.substring(0,S)}e.getRemoteAuthorityPrefix=C}),define(ye[72],De([1,0,18]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function A(I){return I.scheme===c.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=A;function u(I){if(!I)return;const L=I.indexOf("+");return L<0?I:I.substr(0,L)}e.getRemoteName=u;function R(I){return`/${I.quality??"oss"}-${I.commit??"dev"}`}e.getRemoteServerRootPath=R;function C(I){const{host:L,port:k}=S(I);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:k}}e.parseAuthorityWithPort=C;function P(I,L){let{host:k,port:v}=S(I);return typeof v>"u"&&(v=L),{host:k,port:v}}e.parseAuthorityWithOptionalPort=P;function S(I){const L=I.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const k=I.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const v=I.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:I,port:void 0}}}),define(ye[26],De([1,0,8,4,72]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=R;function C(E){return E&&typeof E=="object"&&typeof E.id=="string"&&(!E.uuid||typeof E.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var S;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class I{constructor(f){this.value=f,this.c=f.toLowerCase()}static equals(f,d){if(typeof f>"u"||f===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof f=="string"||typeof d=="string"){const h=typeof f=="string"?f:f.value,g=typeof d=="string"?d:d.value;return c.equalsIgnoreCase(h,g)}return f.c===d.c}static toKey(f){return typeof f=="string"?f.toLowerCase():f.c}}e.ExtensionIdentifier=I;function L(E){return k(E)}e.isApplicationScopedExtension=L;function k(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function v(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function T(E,f){if(f){const d=`onResolveRemoteAuthority:${(0,u.getRemoteName)(f)}`;return E.activationEvents?.indexOf(d)!==-1}return!1}e.isResolverExtension=T,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[210],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class c{constructor(){this.b=new Map}c(){return new Promise((u,R)=>ne(["vsda"],u,R))}async createNewMessage(u){try{const R=await this.c(),C=new R.validator;if(C){const P=String(c.a++);return this.b.set(P,C),{id:P,data:C.createNewMessage(u)}}}catch{}return{id:"",data:u}}async validate(u,R){if(!u.id)return!0;const C=this.b.get(u.id);if(!C)return!1;this.b.delete(u.id);try{return C.validate(R)==="ok"}catch{return!1}}async sign(u){try{const R=await this.c(),C=new R.signer;if(C)return C.sign(u)}catch{}return u}}c.a=1,e.SignService=c}),define(ye[211],De([1,0,12,36,2,30]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function C(I){if(c.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}async function P(I,L,k,v,T,E,f,d,h,g){const p=Object.create(null);p["common.machineId"]=f,p.sessionID=(0,R.generateUuid)()+Date.now(),p.commitHash=T,p.version=E,p["common.platformVersion"]=(L||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,c.PlatformToString)(c.platform),p["common.nodePlatform"]=A.platform,p["common.nodeArch"]=v,p["common.product"]=g||"desktop",d&&(p["common.msftInternal"]=d);let y=0;const b=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-b,enumerable:!0},"common.sequence":{get:()=>y++,enumerable:!0}}),c.isLinuxSnap&&(p["common.snap"]="true");const i=C(k);i&&(p["common.platformDetail"]=i);try{const o=await I.readFile(u.URI.file(h));p["common.source"]=o.value.toString().slice(0,30)}catch{}return p}e.resolveCommonProperties=P;function S(I){const L=A.env.USERDNSDOMAIN;if(!L)return!1;const k=L.toLowerCase();return I.some(v=>k===v)}e.verifyMicrosoftInternalDomain=S}),define(ye[212],De([1,0,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,c.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,c.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var A;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(A=e.TelemetryLevel||(e.TelemetryLevel={}));var u;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(u=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ye[73],De([1,0,23,9,3,53,72,211,212]),function(ne,e,c,A,u,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class I{constructor(n){this.value=n}}e.TelemetryTrustedValue=I;class L{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(n,t){return Promise.resolve(void 0)}publicLog2(n,t){return this.publicLog(n,t)}publicLogError(n,t){return Promise.resolve(void 0)}publicLogError2(n,t){return this.publicLogError(n,t)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=L,e.NullTelemetryService=new L;class k{async publicLog(n,t,a){}async publicLogError(n,t,a){}}e.NullEndpointTelemetryService=k,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(m,n){return u.Event.debounce(n.onDidChangeConfiguration,(a,w)=>{const D=a?new Set([...a.affectedKeys,...w.affectedKeys]):w.affectedKeys;return{...w,affectedKeys:D}},1e3,!0)(a=>{a.source!==7&&m.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(a.source),configurationKeys:y(a.affectedKeys)})})}e.configurationTelemetry=v;function T(m,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!m.enableTelemetry||n.extensionTestsLocationURI)}e.supportsTelemetry=T;function E(m,n){return!(n.isBuilt||n.disableTelemetry||m.enableTelemetry&&m.aiConfig?.ariaKey)}e.isLoggingOnly=E;function f(m){const n=m.getValue(S.TELEMETRY_SETTING_ID),t=m.getValue(S.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(m.getValue(S.TELEMETRY_OLD_SETTING_ID)===!1||t===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=f;function d(m){const n={},t={},a={};p(m,a);for(let w in a){w=w.length>150?w.substr(w.length-149):w;const D=a[w];typeof D=="number"?t[w]=D:typeof D=="boolean"?t[w]=D?1:0:typeof D=="string"?(D.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${D.length}`),n[w]=D.substring(0,8191)):typeof D<"u"&&D!==null&&(n[w]=D)}return{properties:n,measurements:t}}e.validateTelemetryData=d;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function g(m){if(!m)return"none";const n=(0,C.getRemoteName)(m);return h.has(n)?n:"other"}e.cleanRemoteAuthority=g;function p(m,n,t=0,a){if(!!m)for(const w of Object.getOwnPropertyNames(m)){const D=m[w],F=a?a+w:w;Array.isArray(D)?n[F]=(0,c.safeStringify)(D):D instanceof Date?n[F]=D.toISOString():(0,A.isObject)(D)?t<2?p(D,n,t+1,F+"."):n[F]=(0,c.safeStringify)(D):n[F]=D}}function y(m){if(!m)return[];const n=[];return b(n,"",m),n}function b(m,n,t){t&&typeof t=="object"&&!Array.isArray(t)?Object.keys(t).forEach(a=>b(m,n?`${n}.${a}`:a,t[a])):m.push(n)}function i(m,n){const t=m.msftInternalDomains||[],a=n.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(t)||a}e.isInternalTelemetry=i;function o(m){return[m.appRoot,m.extensionsPath,m.userHome.fsPath,m.tmpDir.fsPath,m.userDataPath]}e.getPiiPathsFromEnvironment=o;function s(m,n){if(!m||!m.includes("/")&&!m.includes("\\"))return m;let t=m;const a=[];for(const x of n)for(;;){const q=x.exec(m);if(!q)break;a.push([q.index,x.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,D=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let F=0;for(t="";;){const x=D.exec(m);if(!x)break;const q=a.some(([M,B])=>x.index<B&&M<D.lastIndex);!w.test(x[0])&&!q&&(t+=m.substring(F,x.index)+"<REDACTED: user-file-path>",F=D.lastIndex)}return F<m.length&&(t+=m.substr(F)),t}function l(m){if(!m)return m;const n=m.toLowerCase(),t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of t)if(a.regex.test(n))return`<REDACTED: ${a.label}>`;return m}function r(m,n){return(0,c.cloneAndChange)(m,t=>{if(t instanceof I)return t.value;if(typeof t=="string"){let a=t.replaceAll("%20"," ");a=s(a,n);for(const w of n)a=a.replace(w,"");return a=l(a),a}})}e.cleanData=r}),define(ye[213],De([1,0,8,123,26,12,2,11,36,73]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function L(s,l){return s.uuid&&l.uuid?s.uuid===l.uuid:s.id===l.id?!0:(0,c.compareIgnoreCase)(s.id,l.id)===0}e.areSameExtensions=L;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(l){const r=l.manifest?l.manifest.version:l.version,m=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new v(l.identifier,r,m)}static parse(l){const r=k.exec(l);return r&&r[1]&&r[2]?new v({id:r[1]},r[2],r[4]||void 0):null}constructor(l,r,m="undefined"){this.version=r,this.targetPlatform=m,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof v?L(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.ExtensionKey=v;const T=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(s){const l=T.exec(s);return l&&l[1]?[d(l[1]),l[2]]:[d(s),void 0]}e.getIdAndVersion=E;function f(s,l){return`${s}.${l}`}e.getExtensionId=f;function d(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=d;function h(s,l){return d(f(s,l))}e.getGalleryExtensionId=h;function g(s,l){const r=[],m=n=>{for(const t of r)if(t.some(a=>L(l(a),l(n))))return t;return null};for(const n of s){const t=m(n);t?t.push(n):r.push([n])}return r}e.groupByExtension=g;function p(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function y(s){return{id:new I.TelemetryTrustedValue(s.identifier.id),name:new I.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new u.ExtensionIdentifier("pprice.better-merge");function b(s,l){const r=[],m=l.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const n=m.shift();if(n&&r.every(t=>!L(t.identifier,{id:n}))){const t=s.filter(a=>L(a.identifier,{id:n}));t.length===1&&(r.push(t[0]),m.push(...t[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=b;async function i(s,l){if(!R.isLinux)return!1;let r;try{r=(await s.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await s.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(n){l.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(n))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=i;async function o(s,l){const r=await i(s,l),m=(0,A.getTargetPlatform)(r?"alpine":R.platform,S.arch);return l.debug("ComputeTargetPlatform:",m),m}e.computeTargetPlatform=o}),define(ye[214],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function c(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=c;function A(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=A;function u(C){return Array.from(C.entries()).map(P=>[P[0],c(P[1].map)])}e.serializeEnvironmentVariableCollections=u;function R(C){return new Map(C.map(P=>[P[0],{map:A(P[1])}]))}e.deserializeEnvironmentVariableCollections=R}),define(ye[215],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(u){this.b=u,this.a=new Map}dispose(){for(const u of this.a.values())u.dispose()}startBuffering(u,R,C=5){const P=R(S=>{const I=typeof S=="string"?S:S.data;let L=this.a.get(u);if(L){L.data.push(I);return}const k=setTimeout(()=>this.flushBuffer(u),C);L={data:[I],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(u),P.dispose()}},this.a.set(u,L)});return P}stopBuffering(u){this.a.get(u)?.dispose()}flushBuffer(u){const R=this.a.get(u);R&&(this.a.delete(u),this.b(u,R.data.join("")))}}e.TerminalDataBufferer=c}),define(ye[216],De([1,0,19,67,51,3,9,2,175,91,39]),function(ne,e,c,A,u,R,C,P,S,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var k;(function(y){function b(i,o){let s=i.defaults;for(;u.ThemeIcon.isThemeIcon(s);){const l=E.getIcon(s.id);if(!l)return;s=l.defaults}return s}y.getDefinition=b})(k=e.IconContribution||(e.IconContribution={}));var v;(function(y){function b(o){return{weight:o.weight,style:o.style,src:o.src.map(s=>({format:s.format,location:s.location.toString()}))}}y.toJSONObject=b;function i(o){const s=l=>(0,C.isString)(l)?l:void 0;if(o&&Array.isArray(o.src)&&o.src.every(l=>(0,C.isString)(l.format)&&(0,C.isString)(l.location)))return{weight:s(o.weight),style:s(o.style),src:o.src.map(l=>({format:l.format,location:P.URI.parse(l.location)}))}}y.fromJSONObject=i})(v=e.IconFontDefinition||(e.IconFontDefinition={}));class T{constructor(){this.a=new R.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${u.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(b,i,o,s){const l=this.b[b];if(l){if(o&&!l.description){l.description=o,this.d.properties[b].markdownDescription=`${o} $(${b})`;const n=this.e.enum.indexOf(b);n!==-1&&(this.e.enumDescriptions[n]=o),this.a.fire()}return l}const r={id:b,description:o,defaults:i,deprecationMessage:s};this.b[b]=r;const m={$ref:"#/definitions/icons"};return s&&(m.deprecationMessage=s),o&&(m.markdownDescription=`${o}: $(${b})`),this.d.properties[b]=m,this.e.enum.push(b),this.e.enumDescriptions.push(o||""),this.a.fire(),{id:b}}deregisterIcon(b){delete this.b[b],delete this.d.properties[b];const i=this.e.enum.indexOf(b);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(b=>this.b[b])}getIcon(b){return this.b[b]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(b,i){const o=this.f[b];return o||(this.f[b]=i,this.a.fire(),i)}deregisterIconFont(b){delete this.f[b]}getIconFont(b){return this.f[b]}toString(){const b=(l,r)=>l.id.localeCompare(r.id),i=l=>{for(;u.ThemeIcon.isThemeIcon(l.defaults);)l=this.b[l.defaults.id];return`codicon codicon-${l?l.id:""}`},o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(l=>this.b[l]);for(const l of s.filter(r=>!!r.description).sort(b))o.push(`|<i class="${i(l)}"></i>|${l.id}|${u.ThemeIcon.isThemeIcon(l.defaults)?l.defaults.id:l.id}|${l.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const l of s.filter(r=>!u.ThemeIcon.isThemeIcon(r.defaults)).sort(b))o.push(`|<i class="${i(l)}"></i>|${l.id}|`);return o.join(`
`)}}const E=new T;L.Registry.add(e.Extensions.IconContribution,E);function f(y,b,i,o){return E.registerIcon(y,b,i,o)}e.registerIcon=f;function d(){return E}e.getIconRegistry=d;function h(){const y=(0,A.getCodiconFontCharacters)();for(const b in y){const i="\\"+y[b].toString(16);E.registerIcon(b,{fontCharacter:i})}}h(),e.iconsSchemaId="vscode://schemas/icons";const g=L.Registry.as(I.Extensions.JSONContribution);g.registerSchema(e.iconsSchemaId,E.getIconSchema());const p=new c.RunOnceScheduler(()=>g.notifySchemaChanged(e.iconsSchemaId),200);E.onDidChange(()=>{p.isScheduled()||p.schedule()}),e.widgetClose=f("widget-close",A.Codicon.close,(0,S.localize)(2,null)),e.gotoPreviousLocation=f("goto-previous-location",A.Codicon.arrowUp,(0,S.localize)(3,null)),e.gotoNextLocation=f("goto-next-location",A.Codicon.arrowDown,(0,S.localize)(4,null)),e.syncing=u.ThemeIcon.modify(A.Codicon.sync,"spin"),e.spinningLoading=u.ThemeIcon.modify(A.Codicon.loading,"spin")}),define(ye[129],De([1,0,3,53,4,13]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,u.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,u.createDecorator)("sharedTunnelsService");var C;(function(f){f.Http="http",f.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=k;function v(f,d,h,g){if(h===1)return!1;if(h===2&&k(d)){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(p?.length===4&&parseInt(p[1])>=18)return!1}return f<1024}e.isPortPrivileged=v;class T{constructor(d,h,g){this.remoteAddress=d,this.localAddress=h,this.b=g,this.a=new c.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=T;let E=class{constructor(d,h){this.i=d,this.j=h,this.a=new c.Emitter,this.onTunnelOpened=this.a.event,this.b=new c.Emitter,this.onTunnelClosed=this.b.event,this.c=new c.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const d=this.j.getValue("remote.localPortHost");return!d||d==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(d){return this.e=d,d?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this.f=d.elevation,this.g=d.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const d=[],h=Array.from(this.d.values());for(const g of h){const p=Array.from(g.values());for(const y of p){const b=await y.value;b&&d.push(b)}}return d}async dispose(){for(const d of this.d.values()){for(const{value:h}of d.values())await h.then(g=>g?.dispose());d.clear()}this.d.clear()}setEnvironmentTunnel(d,h,g,p,y){this.o(d,h,Promise.resolve({tunnelRemoteHost:d,tunnelRemotePort:h,localAddress:g,privacy:p,protocol:y,dispose:()=>Promise.resolve()}))}async getExistingTunnel(d,h){(k(d)||L(d))&&(d=e.LOCALHOST_ADDRESSES[0]);const g=this.q(d,h);if(g)return++g.refcount,g.value}openTunnel(d,h,g,p,y,b=!1,i,o){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${g} on local port ${y}.`),!d)return;if(h||(h="localhost"),p||(p=this.k),this.e&&this.h.has(g)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.r(d,h,g,p,y,b,i,o);return s?s.then(l=>{if(!l){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(h,g);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.m(l);return(l.tunnelRemoteHost!==h||l.tunnelRemotePort!==g)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(r),r}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}m(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const h=this.d.get(d.tunnelRemoteHost);if(h){const g=h.get(d.tunnelRemotePort);g&&(g.refcount--,await this.n(d.tunnelRemoteHost,d.tunnelRemotePort,g))}}}}async n(d,h,g){if(g.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${h}.`);const p=g.value.then(async y=>{y&&(await y.dispose(!0),this.b.fire({host:y.tunnelRemoteHost,port:y.tunnelRemotePort}))});return this.d.has(d)&&this.d.get(d).delete(h),p}}async closeTunnel(d,h){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${h} `);const g=this.d.get(d);if(g&&g.has(h)){const p=g.get(h);p.refcount=0,await this.n(d,h,p)}}o(d,h,g){this.d.has(d)||this.d.set(d,new Map),this.d.get(d).set(h,{refcount:1,value:g})}async p(d,h){const g=this.d.get(d);g&&(await g.get(h)||g.delete(h),g.size===0&&this.d.delete(d))}q(d,h){const g=[d];L(d)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):k(d)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const p=g.map(y=>this.d.get(y));for(const y of p){const b=y?.get(h);if(b)return b}}canTunnel(d){return!!I(d)}s(d,h,g,p,y,b,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${g} on local port ${p}.`);const o=g;this.h.add(o);const s=p===void 0?g:p,l={elevationRequired:y?this.isPortPrivileged(s):!1},r={remoteAddress:{host:h,port:g},localAddressPort:p,privacy:b,public:b?b!==P.Private:void 0,protocol:i},m=d.forwardPort(r,l);return m?(this.o(h,g,m),m.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(o)})):this.h.delete(o),m}};E=qe([We(0,R.ILogService),We(1,A.IConfigurationService)],E),e.AbstractTunnelService=E}),define(ye[217],De([1,0,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,c.createDecorator)("editSessionIdentityService");var A;(function(u){u[u.Complete=100]="Complete",u[u.Partial=50]="Partial",u[u.None=0]="None"})(A=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(ye[218],De([1,0,18]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function A(S){return S.scheme!==c.Schemas.file&&S.scheme!==c.Schemas.vscodeRemote}e.isVirtualResource=A;function u(S){if(S.folders.length)return S.folders.every(I=>A(I.uri))?S.folders[0].uri:void 0;if(S.configuration&&A(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=u;function R(S){return u(S)?.scheme}e.getVirtualWorkspaceScheme=R;function C(S){return u(S)?.authority}e.getVirtualWorkspaceAuthority=C;function P(S){return u(S)!==void 0}e.isVirtualWorkspace=P}),define(ye[47],De([1,0,176,10,68,24,2,4,18]),function(ne,e,c,A,u,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function I(s){const l=s;return typeof l?.id=="string"&&C.URI.isUri(l.uri)}e.isSingleFolderWorkspaceIdentifier=I;function L(s){return typeof s?.id=="string"&&!I(s)&&!v(s)}e.isEmptyWorkspaceIdentifier=L,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function k(s,l){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,A.basename)(s)}:l?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=k;function v(s){const l=s;return typeof l?.id=="string"&&C.URI.isUri(l.configPath)}e.isWorkspaceIdentifier=v;function T(s){const l=s;if(l?.uri)return{id:l.id,uri:C.URI.revive(l.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:C.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=T;var E;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function f(s){const l=s;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.isWorkspace=f;function d(s){const l=s;return!!(l&&typeof l=="object"&&C.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.isWorkspaceFolder=d;class h{constructor(l,r,m,n,t){this.h=l,this.j=m,this.k=n,this.l=t,this.c=u.TernarySearchTree.forUris(this.l,()=>!0),this.folders=r}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=u.TernarySearchTree.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class g{constructor(l,r){this.raw=r,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,R.joinPath)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function p(s){return new g({uri:s,index:0,name:(0,R.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,c.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function y(s,l){return R.extUriBiasedIgnorePathCase.isEqualOrParent(s,l.untitledWorkspacesHome)}e.isUntitledWorkspace=y;function b(s){let l;return C.URI.isUri(s)?l=s:l=s.configuration,l?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=b;function i(s,l){return!y(s,l)&&!b(s)}e.isSavedWorkspace=i;function o(s){return(typeof s=="string"?(0,A.extname)(s):(0,R.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=o}),define(ye[74],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{constructor(u){this.d=u,this.b=new Map,this.c=1}add(u){const R=this.c++;return this.b.set(R,u),this.e(),R}get(u,R){return this.b.has(u)?this.b.get(u)[R]:void 0}delete(u){this.b.delete(u),this.e()}e(){!c.a||console.log(`${this.d} cache size - ${this.b.size}`)}}c.a=!1,e.Cache=c}),define(ye[48],De([1,0,18,24,4]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this.a=new Set(Object.keys(c.Schemas)),this.b=new Map,this.extUri=new A.ExtUri(P=>{const S=this.b.get(P.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(P,S){S===null?this.b.delete(P.scheme):this.b.set(P.scheme,S)}isFreeScheme(P){return!this.b.has(P)&&!this.a.has(P)}getCapabilities(P){return this.b.get(P)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,u.createDecorator)("IExtHostFileSystemInfo")}),define(ye[25],De([1,0,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(ye[219],De([1,0,13,204,25]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends A.LogService{constructor(P,S){super(P.createLogger(S.logFile,{name:S.logName}))}};R=qe([We(0,c.ILoggerService),We(1,u.IExtHostInitDataService)],R),e.ExtHostLogService=R}),define(ye[220],De([1,0,19]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class A{constructor(C,P,S){this.h=new Map,this.a=C,this.b=P,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(I=>(this.f=I,this)),this.g=this.c.onDidChangeStorage(I=>{I.shared===this.b&&I.key===this.a&&(this.f=I.value)}),this.i=new c.RunOnceScheduler(()=>{const I=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of I.values())L.complete()}catch(L){for(const k of I.values())k.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this.d}get(C,P){let S=this.f[C];return typeof S>"u"&&(S=P),S}update(C,P){this.f[C]=P;const S=this.h.get(C);if(S!==void 0)return S.p;const I=new c.DeferredPromise;return this.h.set(C,I),this.i.isScheduled()||this.i.schedule(),I.p}dispose(){this.g.dispose()}}e.ExtensionMemento=A;class u extends A{setKeysForSync(C){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},C)}constructor(C,P){super(C.identifier.value,!0,P),this.j=C}}e.ExtensionGlobalMemento=u}),define(ye[221],De([1,0,3,2]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class u{constructor(C){this.c=C,this.a=new c.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new c.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(C,P,S,I){const k=this.c.getNotebookDocument(A.URI.revive(C)).acceptModelChanged(P.value,S,I);this.b.fire(k)}$acceptDirtyStateChanged(C,P){this.c.getNotebookDocument(A.URI.revive(C)).acceptDirty(P)}$acceptModelSaved(C){const P=this.c.getNotebookDocument(A.URI.revive(C));this.a.fire(P.apiNotebook)}}e.ExtHostNotebookDocuments=u}),define(ye[20],De([1,0,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class A{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.ExtHostRpcService=A});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!u:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(ne,c):u?u.value=c:e.set(ne,c),c},Be=this&&this.__classPrivateFieldGet||function(ne,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[222],De([1,0,26,3]),function(ne,e,c,A){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class R{constructor(P,S){u.set(this,void 0),this.b=new A.Emitter,this.onDidChange=this.b.event,this.a=c.ExtensionIdentifier.toKey(P.identifier),Je(this,u,S,"f"),Be(this,u,"f").onDidChangePassword(I=>{I.extensionId===this.a&&this.b.fire({key:I.key})})}get(P){return Be(this,u,"f").get(this.a,P)}store(P,S){return Be(this,u,"f").store(this.a,P,S)}delete(P){return Be(this,u,"f").delete(this.a,P)}}e.ExtensionSecrets=R,u=new WeakMap}),define(ye[55],De([1,0,4,129,3,20]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var C;(function(S){function I(k){return{remoteAddress:k.remoteAddress,localAddress:k.localAddress,public:!!k.public,privacy:k.privacy??(k.public?A.TunnelPrivacyId.Public:A.TunnelPrivacyId.Private),protocol:k.protocol}}S.fromApiTunnel=I;function L(k){return{remoteAddress:{host:k.tunnelRemoteHost,port:k.tunnelRemotePort},localAddress:k.localAddress,public:k.privacy!==A.TunnelPrivacyId.ConstantPrivate&&k.privacy!==A.TunnelPrivacyId.ConstantPrivate,privacy:k.privacy,protocol:k.protocol}}S.fromServiceTunnel=L})(C=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,c.createDecorator)("IExtHostTunnelService");let P=class{constructor(I){this.onDidChangeTunnels=new u.Emitter().event}async $applyCandidateFilter(I){return I}async openTunnel(I,L){}async getTunnels(){return[]}async setTunnelFactory(I){return{dispose:()=>{}}}registerPortsAttributesProvider(I,L){return{dispose:()=>{}}}async $providePortAttributes(I,L,k,v,T){return[]}async $forwardPort(I,L){}async $closeTunnel(I){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=qe([We(0,R.IExtHostRpcService)],P),e.ExtHostTunnelService=P}),define(ye[56],De([1,0,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class A{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=A}),define(ye[223],De([1,0,22]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class A{constructor(){this.buffers=[]}add(S){let I=this.buffers.indexOf(S);return I<0&&(I=this.buffers.length,this.buffers.push(S)),I}}function u(P,S){if(S.serializeBuffersForPostMessage){const I=new A,L=(T,E)=>{if(E instanceof ArrayBuffer){const f=I.add(E);return{$$vscode_array_buffer_reference$$:!0,index:f}}else if(ArrayBuffer.isView(E)){const f=R(E);if(f){const d=I.add(E.buffer);return{$$vscode_array_buffer_reference$$:!0,index:d,view:{type:f,byteLength:E.byteLength,byteOffset:E.byteOffset}}}}return E},k=JSON.stringify(P,L),v=I.buffers.map(T=>{const E=new Uint8Array(T);return c.VSBuffer.wrap(E)});return{message:k,buffers:v}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=u;function R(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(P,S){const I=S.map(v=>{const T=new ArrayBuffer(v.byteLength);return new Uint8Array(T).set(v.buffer),T}),L=S.length?(v,T)=>{if(T&&typeof T=="object"&&T.$$vscode_array_buffer_reference$$){const E=T,{index:f}=E,d=I[f];if(E.view)switch(E.view.type){case 1:return new Int8Array(d,E.view.byteOffset,E.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,E.view.byteOffset,E.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,E.view.byteOffset,E.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,E.view.byteOffset,E.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,E.view.byteOffset,E.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,E.view.byteOffset,E.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,E.view.byteOffset,E.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,E.view.byteOffset,E.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,E.view.byteOffset,E.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,E.view.byteOffset,E.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,E.view.byteOffset,E.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return T}:void 0;return{message:JSON.parse(P,L),arrayBuffers:I}}e.deserializeWebviewMessage=C}),define(ye[224],De([1,0,114]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function A(R){return{transformIncoming:C=>C.scheme==="vscode-remote"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="file"?{scheme:"vscode-local",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoing:C=>C.scheme==="file"?{scheme:"vscode-remote",authority:R,path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="vscode-local"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoingScheme:C=>C==="file"?"vscode-remote":C==="vscode-local"?"file":C}}function u(R){return new c.URITransformer(A(R))}e.createURITransformer=u}),define(ye[130],De([1,0,187,9,2,6,4,39,44,18,45,161,37]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var T;(function(Q){Q[Q.PROGRAMMATIC=1]="PROGRAMMATIC",Q[Q.USER=2]="USER",Q[Q.EDIT=3]="EDIT",Q[Q.NAVIGATION=4]="NAVIGATION",Q[Q.JUMP=5]="JUMP"})(T=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var E;(function(Q){Q[Q.IDENTICAL=1]="IDENTICAL",Q[Q.SIMILAR=2]="SIMILAR",Q[Q.DIFFERENT=3]="DIFFERENT"})(E=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function f(Q){const Y=Q;return!!Y&&typeof Y.getSelection=="function"&&!!Y.onDidChangeSelection}e.isEditorPaneWithSelection=f;function d(Q,Y,ie){for(const pe of ie.visibleEditorPanes)if(pe.group.id===Y&&Q.matches(pe.input))return pe.getViewState()}e.findViewStateForEditor=d;function h(Q){if(t(Q))return!1;const Y=Q;return u.URI.isUri(Y?.resource)}e.isResourceEditorInput=h;function g(Q){if(t(Q))return!1;const Y=Q;return Y?.original!==void 0&&Y.modified!==void 0}e.isResourceDiffEditorInput=g;function p(Q){if(t(Q)||g(Q))return!1;const Y=Q;return Y?.primary!==void 0&&Y.secondary!==void 0}e.isResourceSideBySideEditorInput=p;function y(Q){if(t(Q))return!1;const Y=Q;return Y?Y.resource===void 0||Y.resource.scheme===I.Schemas.untitled||Y.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=y;const b=/Untitled-\d+/;function i(Q){return Q.scheme===I.Schemas.untitled&&Q.path.length>1&&!b.test(Q.path)}e.isUntitledWithAssociatedResource=i;function o(Q){if(t(Q))return!1;const Y=Q;return u.URI.isUri(Y?.base?.resource)&&u.URI.isUri(Y?.input1?.resource)&&u.URI.isUri(Y?.input2?.resource)&&u.URI.isUri(Y?.result?.resource)}e.isResourceMergeEditorInput=o;var s;(function(Q){Q[Q.SHORT=0]="SHORT",Q[Q.MEDIUM=1]="MEDIUM",Q[Q.LONG=2]="LONG"})(s=e.Verbosity||(e.Verbosity={}));var l;(function(Q){Q[Q.EXPLICIT=1]="EXPLICIT",Q[Q.AUTO=2]="AUTO",Q[Q.FOCUS_CHANGE=3]="FOCUS_CHANGE",Q[Q.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l=e.SaveReason||(e.SaveReason={}));class r{constructor(){this.a=new Map}registerSource(Y,ie){let pe=this.a.get(Y);return pe||(pe={source:Y,label:ie},this.a.set(Y,pe)),pe.source}getSourceLabel(Y){return this.a.get(Y)?.label??Y}}e.SaveSourceRegistry=new r;var m;(function(Q){Q[Q.None=0]="None",Q[Q.Readonly=2]="Readonly",Q[Q.Untitled=4]="Untitled",Q[Q.Singleton=8]="Singleton",Q[Q.RequiresTrust=16]="RequiresTrust",Q[Q.CanSplitInGroup=32]="CanSplitInGroup",Q[Q.ForceDescription=64]="ForceDescription",Q[Q.CanDropIntoEditor=128]="CanDropIntoEditor",Q[Q.MultipleEditors=256]="MultipleEditors"})(m=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class n extends R.Disposable{}e.AbstractEditorInput=n;function t(Q){return Q instanceof n}e.isEditorInput=t;function a(Q){const Y=Q;return u.URI.isUri(Y?.preferredResource)}function w(Q){const Y=Q;return t(Y?.primary)&&t(Y?.secondary)}e.isSideBySideEditorInput=w;function D(Q){const Y=Q;return t(Y?.modified)&&t(Y?.original)}e.isDiffEditorInput=D;function F(Q,Y,ie,pe,ve){return ee(pe,[(0,k.toAction)({id:"workbench.action.openLargeFile",label:(0,c.localize)(2,null),run:()=>{const ke={...ie,limits:{size:Number.MAX_VALUE}};Q.openEditor(Y,ke)}}),(0,k.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,c.localize)(3,null),run:()=>ve.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.createTooLargeFileError=F;function x(Q){return t(Q?.editor)}e.isEditorInputWithOptions=x;function q(Q){const Y=Q;return x(Q)&&Y?.group!==void 0}e.isEditorInputWithOptionsAndGroup=q;function M(Q){const Y=Q;return typeof Y?.groupId=="number"&&t(Y.editor)}e.isEditorIdentifier=M;var B;(function(Q){Q[Q.UNKNOWN=0]="UNKNOWN",Q[Q.REPLACE=1]="REPLACE",Q[Q.MOVE=2]="MOVE",Q[Q.UNPIN=3]="UNPIN"})(B=e.EditorCloseContext||(e.EditorCloseContext={}));var O;(function(Q){Q[Q.GROUP_ACTIVE=0]="GROUP_ACTIVE",Q[Q.GROUP_INDEX=1]="GROUP_INDEX",Q[Q.GROUP_LOCKED=2]="GROUP_LOCKED",Q[Q.EDITOR_OPEN=3]="EDITOR_OPEN",Q[Q.EDITOR_CLOSE=4]="EDITOR_CLOSE",Q[Q.EDITOR_MOVE=5]="EDITOR_MOVE",Q[Q.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",Q[Q.EDITOR_LABEL=7]="EDITOR_LABEL",Q[Q.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",Q[Q.EDITOR_PIN=9]="EDITOR_PIN",Q[Q.EDITOR_STICKY=10]="EDITOR_STICKY",Q[Q.EDITOR_DIRTY=11]="EDITOR_DIRTY",Q[Q.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(O=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var U;(function(Q){Q[Q.PRIMARY=1]="PRIMARY",Q[Q.SECONDARY=2]="SECONDARY",Q[Q.BOTH=3]="BOTH",Q[Q.ANY=4]="ANY"})(U=e.SideBySideEditor||(e.SideBySideEditor={}));class z{getOriginalUri(Y,ie){if(!Y)return;if(o(Y))return e.EditorResourceAccessor.getOriginalUri(Y.result,ie);if(ie?.supportSideBySide){const{primary:ve,secondary:ke}=this.a(Y);if(ve&&ke){if(ie?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(ve,{filterByScheme:ie.filterByScheme}),secondary:this.getOriginalUri(ke,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===U.ANY)return this.getOriginalUri(ve,{filterByScheme:ie.filterByScheme})??this.getOriginalUri(ke,{filterByScheme:ie.filterByScheme});Y=ie.supportSideBySide===U.PRIMARY?ve:ke}}if(g(Y)||p(Y)||o(Y))return;const pe=a(Y)?Y.preferredResource:Y.resource;return!pe||!ie||!ie.filterByScheme?pe:this.b(pe,ie.filterByScheme)}a(Y){return w(Y)||p(Y)?{primary:Y.primary,secondary:Y.secondary}:D(Y)||g(Y)?{primary:Y.modified,secondary:Y.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Y,ie){if(!Y)return;if(o(Y))return e.EditorResourceAccessor.getCanonicalUri(Y.result,ie);if(ie?.supportSideBySide){const{primary:ve,secondary:ke}=this.a(Y);if(ve&&ke){if(ie?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(ve,{filterByScheme:ie.filterByScheme}),secondary:this.getCanonicalUri(ke,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===U.ANY)return this.getCanonicalUri(ve,{filterByScheme:ie.filterByScheme})??this.getCanonicalUri(ke,{filterByScheme:ie.filterByScheme});Y=ie.supportSideBySide===U.PRIMARY?ve:ke}}if(g(Y)||p(Y)||o(Y))return;const pe=Y.resource;return!pe||!ie||!ie.filterByScheme?pe:this.b(pe,ie.filterByScheme)}b(Y,ie){if(Array.isArray(ie)){if(ie.some(pe=>Y.scheme===pe))return Y}else if(ie===Y.scheme)return Y}}e.EditorResourceAccessor=new z;var j;(function(Q){Q[Q.LEFT=0]="LEFT",Q[Q.RIGHT=1]="RIGHT"})(j=e.CloseDirection||(e.CloseDirection={}));class de{constructor(){this.c=new Map,this.d=new Map}start(Y){const ie=this.a=Y.get(C.IInstantiationService);for(const[pe,ve]of this.c)this.e(pe,ve,ie);this.c.clear()}e(Y,ie,pe){const ve=pe.createInstance(ie);this.d.set(Y,ve)}registerFileEditorFactory(Y){if(this.b)throw new Error("Can only register one file editor factory.");this.b=Y}getFileEditorFactory(){return(0,A.assertIsDefined)(this.b)}registerEditorSerializer(Y,ie){if(this.c.has(Y)||this.d.has(Y))throw new Error(`A editor serializer with type ID '${Y}' was already registered.`);return this.a?this.e(Y,ie,this.a):this.c.set(Y,ie),(0,R.toDisposable)(()=>{this.c.delete(Y),this.d.delete(Y)})}getEditorSerializer(Y){return this.d.get(typeof Y=="string"?Y:Y.typeId)}}P.Registry.add(e.EditorExtensions.EditorFactory,new de);async function V(Q,Y,ie){return!Q||!Q.length?[]:await Promise.all(Q.map(async pe=>{const ve=u.URI.revive(pe.fileUri);if(!ve){ie.info("Cannot resolve the path because it is not valid.",pe);return}if(!await Y.canHandleResource(ve)){ie.info("Cannot resolve the path because it cannot be handled",pe);return}let Oe=pe.exists,oe=pe.type;if(typeof Oe!="boolean"||typeof oe!="number")try{oe=(await Y.stat(ve)).isDirectory?S.FileType.Directory:S.FileType.Unknown,Oe=!0}catch(fe){ie.error(fe),Oe=!1}if(!Oe&&pe.openOnlyIfExists){ie.info("Cannot resolve the path because it does not exist",pe);return}if(oe===S.FileType.Directory){ie.info("Cannot resolve the path because it is a directory",pe);return}const ae={...pe.options,pinned:!0};return Oe?{resource:ve,options:ae}:{resource:ve,options:ae,forceUntitled:!0}}))}e.pathsToEditors=V;var X;(function(Q){Q[Q.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Q[Q.SEQUENTIAL=1]="SEQUENTIAL"})(X=e.EditorsOrder||(e.EditorsOrder={}));function J(Q){const Y=Q;if(!Y)return!1;const ie=Y;if(ie.modified)return J(ie.modified);const pe=Y;return!!(pe.contributionsState&&pe.viewState&&Array.isArray(pe.cursorState))}e.isTextEditorViewState=J;function te(Q){return(0,L.isErrorWithActions)(Q)}e.isEditorOpenError=te;function ee(Q,Y,ie){const pe=(0,L.createErrorWithActions)(Q,Y);return pe.forceMessage=ie?.forceMessage,pe.forceSeverity=ie?.forceSeverity,pe.allowDialog=ie?.allowDialog,pe}e.createEditorOpenError=ee}),define(ye[225],De([1,0,3,188,4,6,28,39,15,61,23,67,216]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,v.registerIcon)("default-view-icon",k.Codicon.window,(0,A.localize)(0,null));var T;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(T=e.Extensions||(e.Extensions={}));var E;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(E=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function f(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=f;class d extends R.Disposable{constructor(){super(...arguments),this.c=this.B(new c.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new c.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,S.flatten)([...this.g.values()])}registerViewContainer(l,r,m){const n=this.get(l.id);if(n)return n;const t=l;return t.openCommandActionDescriptor=m?.doNotRegisterOpenCommand?void 0:t.openCommandActionDescriptor??{id:t.id},(0,C.getOrSet)(this.g,r,[]).push(t),m?.isDefault&&this.h.push(t),this.c.fire({viewContainer:t,viewContainerLocation:r}),t}deregisterViewContainer(l){for(const r of this.g.keys()){const m=this.g.get(r),n=m?.indexOf(l);if(n!==-1){m?.splice(n,1),m.length===0&&this.g.delete(r),this.f.fire({viewContainer:l,viewContainerLocation:r});return}}}get(l){return this.all.filter(r=>r.id===l)[0]}getViewContainers(l){return[...this.g.get(l)||[]]}getViewContainerLocation(l){return[...this.g.keys()].filter(r=>this.getViewContainers(r).filter(m=>m?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.h.find(r=>this.getViewContainerLocation(r)===l)}}P.Registry.add(T.ViewContainersRegistry,new d);var h;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(h=e.ViewContentGroups||(e.ViewContentGroups={}));function g(s,l){const r=s.group??h.More,m=l.group??h.More;return r!==m?r.localeCompare(m):(s.order??5)-(l.order??5)}class p extends R.Disposable{constructor(){super(...arguments),this.c=this.B(new c.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new c.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new c.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new c.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new I.SetMap}registerViews(l,r){this.registerViews2([{views:l,viewContainer:r}])}registerViews2(l){l.forEach(({views:r,viewContainer:m})=>this.l(r,m)),this.c.fire(l)}deregisterViews(l,r){const m=this.m(l,r);m.length&&this.f.fire({views:m,viewContainer:r})}moveViews(l,r){for(const m of this.j.keys())if(m!==r){const n=this.m(l,m);n.length&&(this.l(n,r),this.g.fire({views:n,from:m,to:r}))}}getViews(l){return this.j.get(l)||[]}getView(l){for(const r of this.i){const m=(this.j.get(r)||[]).filter(n=>n.id===l)[0];if(m)return m}return null}getViewContainer(l){for(const r of this.i)if((this.j.get(r)||[]).filter(n=>n.id===l)[0])return r;return null}registerViewWelcomeContent(l,r){return this.k.add(l,r),this.h.fire(l),(0,R.toDisposable)(()=>{this.k.delete(l,r),this.h.fire(l)})}registerViewWelcomeContent2(l,r){const m=new Map;for(const[n,t]of r)this.k.add(l,t),m.set(n,(0,R.toDisposable)(()=>{this.k.delete(l,t),this.h.fire(l)}));return this.h.fire(l),m}getViewWelcomeContent(l){const r=[];return this.k.forEach(l,m=>r.push(m)),r.sort(g)}l(l,r){let m=this.j.get(r);m||(m=[],this.j.set(r,m),this.i.push(r));for(const n of l){if(this.getView(n.id)!==null)throw new Error((0,A.localize)(1,null,n.id));m.push(n)}}m(l,r){const m=this.j.get(r);if(!m)return[];const n=[],t=[];for(const a of m)l.includes(a)?n.push(a):t.push(a);return n.length&&(t.length?this.j.set(r,t):(this.j.delete(r),this.i.splice(this.i.indexOf(r),1))),n}}P.Registry.add(T.ViewsRegistry,new p),e.IViewsService=(0,u.createDecorator)("viewsService"),e.IViewDescriptorService=(0,u.createDecorator)("viewDescriptorService");var y;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(y=e.ViewVisibilityState||(e.ViewVisibilityState={}));var b;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(b=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(l,r){this.c=!1,this.d=!1,(0,L.mixin)(this,l),this.d=!!r,this.resolve=async m=>{if(r&&!this.c){const n=await r(m);n&&(this.tooltip=this.tooltip??n.tooltip,this.command=this.command??n.command)}m.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i;class o extends Error{constructor(l){super((0,A.localize)(2,null,l))}}e.NoTreeViewError=o}),define(ye[131],De([1,0,3,19,189]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new c.Emitter,this.n=new c.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(P){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=P}onEvent(P){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=P}onRequest(P){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=P}sendResponse(P){P.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.s("response",P)}sendRequest(P,S,I,L){const k={command:P};if(S&&Object.keys(S).length>0&&(k.arguments=S),this.s("request",k),typeof L=="number"){const v=setTimeout(()=>{clearTimeout(v);const T=this.f.get(k.seq);if(T){this.f.delete(k.seq);const E={type:"response",seq:0,request_seq:k.seq,success:!1,command:P,message:(0,u.localize)(0,null,L,P)};T(E)}},L)}return I&&this.f.set(k.seq,I),k.seq}acceptMessage(P){this.j?this.j(P):(this.k.push(P),this.k.length===1&&this.q())}o(P,S){return P.type!=="event"||S.type!=="event"}async q(){let P;for(;this.k.length;){if((!P||this.o(this.k[0],P))&&await(0,A.timeout)(0),P=this.k.shift(),!P)return;switch(P.type){case"event":this.i?.(P);break;case"request":this.g?.(P);break;case"response":{const S=P,I=this.f.get(S.request_seq);I&&(this.f.delete(S.request_seq),I(S));break}}}}s(P,S){S.type=P,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const P=new Map;this.f.forEach((S,I)=>P.set(I,S)),await(0,A.timeout)(500),P.forEach((S,I)=>{S({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.f.delete(I)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=R}),define(ye[226],De([1,0,190,54,4]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new A.RawContextKey("debugType",void 0,{type:"string",description:c.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new A.RawContextKey("debugConfigurationType",void 0,{type:"string",description:c.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new A.RawContextKey("debugState","inactive",{type:"string",description:c.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new A.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:c.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new A.RawContextKey("hasDebugged",!1,{type:"boolean",description:c.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new A.RawContextKey("inDebugMode",!1,{type:"boolean",description:c.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new A.RawContextKey("inDebugRepl",!1,{type:"boolean",description:c.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new A.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:c.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new A.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:c.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new A.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:c.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new A.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:c.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new A.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:c.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new A.RawContextKey("variablesFocused",!0,{type:"boolean",description:c.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new A.RawContextKey("expressionSelected",!1,{type:"boolean",description:c.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new A.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:c.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new A.RawContextKey("callStackItemType",void 0,{type:"string",description:c.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new A.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:c.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new A.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:c.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new A.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:c.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new A.RawContextKey("watchItemType",void 0,{type:"string",description:c.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new A.RawContextKey("canViewMemory",void 0,{type:"boolean",description:c.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new A.RawContextKey("breakpointItemType",void 0,{type:"string",description:c.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new A.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:c.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new A.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:c.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new A.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:c.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new A.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:c.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new A.RawContextKey("stepBackSupported",!1,{type:"boolean",description:c.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new A.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:c.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new A.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:c.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new A.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:c.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new A.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:c.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new A.RawContextKey("breakpointsExist",!1,{type:"boolean",description:c.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new A.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:c.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new A.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:c.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new A.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:c.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new A.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:c.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new A.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:c.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new A.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:c.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new A.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:c.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new A.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:c.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new A.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:c.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new A.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:c.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new A.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:c.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new A.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:c.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new A.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:c.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new A.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:c.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new A.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:c.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new A.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:c.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new A.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:c.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new A.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:c.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new A.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:c.localize(50,null)});const R=v=>c.localize(51,null,v);e.debuggerDisabledMessage=R,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:c.localize(52,null)};var C;(function(v){v[v.Inactive=0]="Inactive",v[v.Initializing=1]="Initializing",v[v.Stopped=2]="Stopped",v[v.Running=3]="Running"})(C=e.State||(e.State={}));function P(v){switch(v){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=P;var S;(function(v){v[v.Valid=0]="Valid",v[v.Unreadable=1]="Unreadable",v[v.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var I;(function(v){v[v.Initial=1]="Initial",v[v.Dynamic=2]="Dynamic"})(I=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var L;(function(v){v.UnverifiedBreakpoints="unverifiedBreakpoints"})(L=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,u.createDecorator)("debugService");var k;(function(v){v[v.CONDITION=0]="CONDITION",v[v.HIT_COUNT=1]="HIT_COUNT",v[v.LOG_MESSAGE=2]="LOG_MESSAGE"})(k=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ye[227],De([1,0,8,2,10,23,18,32,21,15]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const L=/{([^}]+)}/g;function k(n,t,a){return n.replace(L,function(w,D){return t&&D.length>0&&D[0]!=="_"?w:a&&a.hasOwnProperty(D)?a[D]:w})}e.formatPII=k;function v(n){const t={};for(const a of Object.keys(n))a.startsWith("!")||(t[a]=n[a]);return t}e.filterExceptionsFromTelemetry=v;function T(n){return n.configuration.request==="attach"&&!E(n)&&(!n.parentSession||T(n.parentSession))}e.isSessionAttach=T;function E(n){let t=n.configuration.type;if(!!t)return t==="vslsShare"&&(t=n.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(t,"extensionhost")||(0,c.equalsIgnoreCase)(t,"pwa-extensionhost")?n:n.parentSession?E(n.parentSession):void 0}e.getExtensionHostDebugSession=E;function f(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=f;function d(n,t,a){let w,D=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let x=null;for(;x=F.exec(n);){const q=x.index+1,M=q+x[0].length;if(q<=t&&M>=a){w=x[0],D=q;break}}if(w){const q=/\w+/g;let M=null;for(;(M=q.exec(w))&&!(M.index+1+D+M[0].length>=a););M&&(w=w.substring(0,q.lastIndex))}return w?{start:D,end:D+w.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=d;async function h(n,t,a,w){if(n.evaluatableExpressionProvider.has(t)){const D=n.evaluatableExpressionProvider.ordered(t),F=(0,I.coalesce)(await Promise.all(D.map(async x=>{try{return await x.provideEvaluatableExpression(t,a,w??S.CancellationToken.None)}catch{return}})));if(F.length>0){let x=F[0].expression;const q=F[0].range;return x||(x=t.getLineContent(a.lineNumber).substring(q.startColumn-1,q.endColumn-1)),{range:q,matchingExpression:x}}}else{const D=t.getLineContent(a.lineNumber),{start:F,end:x}=d(D,a.column,a.column),q=D.substring(F-1,x);return{matchingExpression:q,range:new P.Range(a.lineNumber,F,a.lineNumber,F+q.length)}}return null}e.getEvaluatableExpressionAtPosition=h;const g=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function p(n){return!!(n&&n.match(g))}e.isUri=p;function y(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(p(n.path))return A.URI.parse(n.path);if((0,u.isAbsolute)(n.path))return A.URI.file(n.path)}return n.path}function b(n){if(typeof n.path=="object"){const t=A.URI.revive(n.path);if(t)return t.scheme===C.Schemas.file?t.fsPath:t.toString()}return n.path}function i(n,t){const a=t?y:b,w=(0,R.deepClone)(n);return s(w,(D,F)=>{D&&F&&(F.path=a(F))}),w}e.convertToDAPaths=i;function o(n,t){const a=t?y:b,w=(0,R.deepClone)(n);return s(w,(D,F)=>{!D&&F&&(F.path=a(F))}),w}e.convertToVSCPaths=o;function s(n,t){switch(n.type){case"event":{const a=n;switch(a.event){case"output":t(!1,a.body.source);break;case"loadedSource":t(!1,a.body.source);break;case"breakpoint":t(!1,a.body.breakpoint.source);break;default:break}break}case"request":{const a=n;switch(a.command){case"setBreakpoints":t(!0,a.arguments.source);break;case"breakpointLocations":t(!0,a.arguments.source);break;case"source":t(!0,a.arguments.source);break;case"gotoTargets":t(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(w=>t(!1,w));break;default:break}break}case"response":{const a=n;if(a.success&&a.body)switch(a.command){case"stackTrace":a.body.stackFrames.forEach(w=>t(!1,w.source));break;case"loadedSources":a.body.sources.forEach(w=>t(!1,w));break;case"scopes":a.body.scopes.forEach(w=>t(!1,w.source));break;case"setFunctionBreakpoints":a.body.breakpoints.forEach(w=>t(!1,w.source));break;case"setBreakpoints":a.body.breakpoints.forEach(w=>t(!1,w.source));break;case"disassemble":a.body?.instructions.forEach(D=>t(!1,D.location));break;default:break}break}}}function l(n){return n.filter(t=>!t.presentation?.hidden).sort((t,a)=>t.presentation?a.presentation?t.presentation.group?a.presentation.group?t.presentation.group!==a.presentation.group?t.presentation.group.localeCompare(a.presentation.group):r(t.presentation.order,a.presentation.order):-1:a.presentation.group?1:r(t.presentation.order,a.presentation.order):-1:a.presentation?1:0)}e.getVisibleAndSorted=l;function r(n,t){return typeof n!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:n-t}async function m(n,t){const a=n.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorLanguageId});if(a!=="none"&&(await t.saveAll(),a==="allEditorsInActiveGroup")){const w=t.activeEditorPane;w&&w.input.resource?.scheme===C.Schemas.untitled&&await t.save({editor:w.input,groupId:w.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=m}),define(ye[228],De([1,0,46,229,23,10,12,8,29,191,131]),function(ne,e,c,A,u,R,C,P,S,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class k extends L.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(h,g){this.p=g,this.r=Buffer.allocUnsafe(0),this.t=-1,h.on("data",p=>this.w(p))}sendMessage(h){if(this.p){const g=JSON.stringify(h);this.p.write(`Content-Length: ${Buffer.byteLength(g,"utf8")}${k.a}${g}`,"utf8")}}w(h){for(this.r=Buffer.concat([this.r,h]);;){if(this.t>=0){if(this.r.length>=this.t){const g=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,g.length>0)try{this.acceptMessage(JSON.parse(g))}catch(p){this.m.fire(new Error((p.message||p)+`
`+g))}continue}}else{const g=this.r.indexOf(k.a);if(g!==-1){const y=this.r.toString("utf8",0,g).split(k.b);for(const b of y){const i=b.split(k.l);i[0]==="Content-Length"&&(this.t=Number(i[1]))}this.r=this.r.slice(g+k.a.length);continue}}break}}}k.a=`\r
\r
`,k.b=/\r?\n/,k.l=/: */,e.StreamDebugAdapter=k;class v extends k{startSession(){return new Promise((h,g)=>{let p=!1;this.x=this.y(()=>{this.v(this.x,this.x),h(),p=!0}),this.x.on("close",()=>{p?this.m.fire(new Error("connection closed")):g(new Error("connection closed"))}),this.x.on("error",y=>{p?this.m.fire(y):g(y)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=v;class T extends v{constructor(h){super(),this.z=h}y(h){return A.createConnection(this.z.port,this.z.host||"127.0.0.1",h)}}e.SocketDebugAdapter=T;class E extends v{constructor(h){super(),this.z=h}y(h){return A.createConnection(this.z.path,h)}}e.NamedPipeDebugAdapter=E;class f extends k{constructor(h,g){super(),this.y=h,this.z=g}async startSession(){const h=this.y.command,g=this.y.args,p=this.y.options||{};try{if(h)if(R.isAbsolute(h)){if(!await S.Promises.exists(h))throw new Error(I.localize(0,null,h))}else h.indexOf("/")<0&&h.indexOf("\\")<0;else throw new Error(I.localize(1,null,this.z));let y=process.env;if(p.env&&Object.keys(p.env).length>0&&(y=u.mixin(u.deepClone(process.env),p.env)),h==="node")if(Array.isArray(g)&&g.length>0){const b=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:y,execArgv:b?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};p.cwd&&(i.cwd=p.cwd);const o=c.fork(g[0],g.slice(1),i);if(!o.pid)throw new Error(I.localize(2,null,g[0]));this.x=o}else throw new Error(I.localize(3,null));else{const b={env:y};p.cwd&&(b.cwd=p.cwd),this.x=c.spawn(h,g,b)}this.x.on("error",b=>{this.m.fire(b)}),this.x.on("exit",(b,i)=>{this.n.fire(b)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",b=>{this.m.fire(b)}),this.x.stdin.on("error",b=>{this.m.fire(b)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(y){this.m.fire(y)}}async stopSession(){return this.x?(await this.u(),C.isWindows?new Promise((h,g)=>{const p=c.exec(`taskkill /F /T /PID ${this.x.pid}`,function(y,b,i){if(y)return g(y)});p.on("exit",h),p.on("error",g)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(h,g){if(!h)return;const p=Object.create(null);h.runtime&&(h.runtime.indexOf("./")===0?p.runtime=R.join(g,h.runtime):p.runtime=h.runtime),h.runtimeArgs&&(p.runtimeArgs=h.runtimeArgs),h.program&&(R.isAbsolute(h.program)?p.program=h.program:p.program=R.join(g,h.program)),h.args&&(p.args=h.args);const y=h;return y.win&&(p.win=f.A(y.win,g)),y.winx86&&(p.winx86=f.A(y.winx86,g)),y.windows&&(p.windows=f.A(y.windows,g)),y.osx&&(p.osx=f.A(y.osx,g)),y.linux&&(p.linux=f.A(y.linux,g)),p}static platformAdapterExecutable(h,g){let p=Object.create(null);g=g.toLowerCase();for(const l of h)if(l.contributes){const r=l.contributes.debuggers;r&&r.length>0&&r.filter(m=>typeof m.type=="string"&&P.equalsIgnoreCase(m.type,g)).forEach(m=>{const n=f.A(m,l.extensionLocation.fsPath);p=u.mixin(p,n,l.isBuiltin)})}let y;C.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?y=p.winx86||p.win||p.windows:C.isWindows?y=p.win||p.windows:C.isMacintosh?y=p.osx:C.isLinux&&(y=p.linux),y=y||p;const b=y.program||p.program,i=y.args||p.args,o=y.runtime||p.runtime,s=y.runtimeArgs||p.runtimeArgs;if(o)return{type:"executable",command:o,args:(s||[]).concat(typeof b=="string"?[b]:[]).concat(i||[])};if(b)return{type:"executable",command:b,args:i||[]}}}e.ExecutableDebugAdapter=f}),define(ye[230],De([1,0,46,33,12]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function R(I,L){return new Promise((k,v)=>{let T="";const E=c.spawn(I,L);E.pid&&E.stdout.on("data",f=>{T+=f.toString()}),E.on("error",f=>{v(f)}),E.on("close",f=>{k(T)})})}async function C(I){if(I)if(u.isWindows){const L=await new Promise((k,v)=>{ne(["windows-process-tree"],k,v)});return new Promise(k=>{L.getProcessTree(I,v=>{k(!!v&&v.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(I)]).then(L=>{const k=L.trim();return!(k.length===0||k.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=C;var P;(function(I){I[I.cmd=0]="cmd",I[I.powershell=1]="powershell",I[I.bash=2]="bash"})(P||(P={}));function S(I,L,k,v,T){I=I.trim().toLowerCase();let E;I.indexOf("powershell")>=0||I.indexOf("pwsh")>=0?E=1:I.indexOf("cmd.exe")>=0?E=0:I.indexOf("bash")>=0?E=2:u.isWindows?E=0:E=2;let f,d=" ";switch(E){case 1:if(f=h=>(h=h.replace(/\'/g,"''"),h.length>0&&h.charAt(h.length-1)==="\\"?`'${h}\\'`:`'${h}'`),v){const h=(0,A.getDriveLetter)(v);h&&(d+=`${h}:; `),d+=`cd ${f(v)}; `}if(T)for(const h in T){const g=T[h];g===null?d+=`Remove-Item env:${h}; `:d+=`\${env:${h}}='${g}'; `}if(L.length>0){const h=L.shift(),g=k?h:f(h);d+=g[0]==="'"?`& ${g} `:`${g} `;for(const p of L)d+=p==="<"||p===">"||k?p:f(p),d+=" "}break;case 0:if(f=h=>(h=h.replace(/\"/g,'""'),h=h.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(g=>h.includes(g))||h.length===0?`"${h}"`:h),v){const h=(0,A.getDriveLetter)(v);h&&(d+=`${h}: && `),d+=`cd ${f(v)} && `}if(T){d+='cmd /C "';for(const h in T){let g=T[h];g===null?d+=`set "${h}=" && `:(g=g.replace(/[&^|<>]/g,p=>`^${p}`),d+=`set "${h}=${g}" && `)}}for(const h of L)d+=h==="<"||h===">"||k?h:f(h),d+=" ";T&&(d+='"');break;case 2:{f=g=>(g=g.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),g.length===0?'""':g);const h=g=>/[^\w@%\/+=,.:^-]/.test(g)?`'${g.replace(/'/g,"'\\''")}'`:g;if(v&&(d+=`cd ${f(v)} ; `),T){d+="/usr/bin/env";for(const g in T){const p=T[g];p===null?d+=` -u ${h(g)}`:d+=` ${h(`${g}=${p}`)}`}d+=" "}for(const g of L)d+=g==="<"||g===">"||k?g:f(g),d+=" ";break}}return d}e.prepareCommand=S}),define(ye[92],De([1,0,22,38,64,86,18,10,12,54]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var L;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.latex,R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.latex,R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(U){U[U.Running=1]="Running",U[U.Idle=2]="Idle"})(k=e.NotebookRunState||(e.NotebookRunState={}));var v;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(v=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var T;(function(U){U[U.WithHardKernelDependency=0]="WithHardKernelDependency",U[U.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",U[U.Pure=2]="Pure",U[U.Never=3]="Never"})(T=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var E;(function(U){U.Always="always",U.Never="never",U.Optional="optional"})(E=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(U){U[U.ModelChange=1]="ModelChange",U[U.Move=2]="Move",U[U.ChangeCellLanguage=5]="ChangeCellLanguage",U[U.Initialize=6]="Initialize",U[U.ChangeCellMetadata=7]="ChangeCellMetadata",U[U.Output=8]="Output",U[U.OutputItem=9]="OutputItem",U[U.ChangeCellContent=10]="ChangeCellContent",U[U.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",U[U.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",U[U.ChangeCellMime=13]="ChangeCellMime",U[U.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(U){U[U.Handle=0]="Handle",U[U.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(U){U[U.Replace=1]="Replace",U[U.Output=2]="Output",U[U.Metadata=3]="Metadata",U[U.CellLanguage=4]="CellLanguage",U[U.DocumentMetadata=5]="DocumentMetadata",U[U.Move=6]="Move",U[U.OutputItems=7]="OutputItems",U[U.PartialMetadata=8]="PartialMetadata",U[U.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));var g;(function(U){U.scheme=C.Schemas.vscodeNotebookCell;const z=["W","X","Y","Z","a","b","c","d","e","f"],j=new RegExp(`^[${z.join("")}]+`),de=7;function V(Y,ie){const pe=ie.toString(de),ke=`${pe.length<z.length?z[pe.length-1]:"z"}${pe}s${(0,c.encodeBase64)(c.VSBuffer.fromString(Y.scheme),!0,!0)}`;return Y.with({scheme:U.scheme,fragment:ke})}U.generate=V;function X(Y){if(Y.scheme!==U.scheme)return;const ie=Y.fragment.indexOf("s");if(ie<0)return;const pe=parseInt(Y.fragment.substring(0,ie).replace(j,""),de),ve=(0,c.decodeBase64)(Y.fragment.substring(ie+1)).toString();if(!isNaN(pe))return{handle:pe,notebook:Y.with({scheme:ve,fragment:null})}}U.parse=X;function J(Y,ie){return Y.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`op${ie??""},${Y.scheme!==C.Schemas.file?Y.scheme:""}`})}U.generateCellOutputUri=J;function te(Y){if(Y.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const ie=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Y.fragment);if(!ie)return;const pe=ie[1]&&ie[1]!==""?ie[1]:void 0,ve=ie[2];return{outputId:pe,notebook:Y.with({scheme:ve||C.Schemas.file,fragment:null})}}U.parseCellOutputUri=te;function ee(Y,ie,pe){return U.generate(Y,ie).with({scheme:pe})}U.generateCellPropertyUri=ee;function Q(Y,ie){if(Y.scheme===ie)return U.parse(Y.with({scheme:U.scheme}))}U.parseCellPropertyUri=Q})(g=e.CellUri||(e.CellUri={}));const p=U=>S.isWindows?U.replace(/\//g,"\\"):U;class y{constructor(z=[],j=e.NOTEBOOK_DISPLAY_ORDER){this.e=j,this.d=[...new Set(z)].map(de=>({pattern:de,matches:A.parse(p(de))}))}sort(z){const j=new Map(u.Iterable.map(z,V=>[V,p(V)]));let de=[];for(const{matches:V}of this.d)for(const[X,J]of j)if(V(J)){de.push(X),j.delete(X);break}return j.size&&(de=de.concat([...j.keys()].sort((V,X)=>this.e.indexOf(V)-this.e.indexOf(X)))),de}prioritize(z,j){const de=this.f(z);if(de===-1){this.d.unshift({pattern:z,matches:A.parse(p(z))});return}const V=new Set(j.map(J=>this.f(J,de)));V.delete(-1);const X=Array.from(V).sort();this.d.splice(de+1,0,...X.map(J=>this.d[J]));for(let J=X.length-1;J>=0;J--)this.d.splice(X[J],1)}toArray(){return this.d.map(z=>z.pattern)}f(z,j=this.d.length){const de=p(z);for(let V=0;V<j;V++)if(this.d[V].matches(de))return V;return-1}}e.MimeTypeDisplayOrder=y;function b(U,z,j,de=(V,X)=>V===X){const V=[];function X(ee,Q,Y){if(Q===0&&Y.length===0)return;const ie=V[V.length-1];ie&&ie.start+ie.deleteCount===ee?(ie.deleteCount+=Q,ie.toInsert.push(...Y)):V.push({start:ee,deleteCount:Q,toInsert:Y})}let J=0,te=0;for(;;){if(J===U.length){X(J,0,z.slice(te));break}if(te===z.length){X(J,U.length-J,[]);break}const ee=U[J],Q=z[te];if(de(ee,Q)){J+=1,te+=1;continue}j(Q)?(X(J,1,[]),J+=1):(X(J,0,[Q]),te+=1)}return V}e.diff=b,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new I.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(U){U.default="default",U.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(U){const z=U;return!!((typeof z.include=="string"||A.isRelativePattern(z.include))&&(typeof z.exclude=="string"||A.isRelativePattern(z.exclude)))}e.isDocumentExcludePattern=o;function s(U,z,j){if(Array.isArray(U.viewType)&&U.viewType.indexOf(z)>=0||U.viewType===z)return!0;if(U.filenamePattern){const de=o(U.filenamePattern)?U.filenamePattern.include:U.filenamePattern,V=o(U.filenamePattern)?U.filenamePattern.exclude:void 0;if(A.match(de,(0,P.basename)(j.fsPath).toLowerCase()))return!(V&&A.match(V,(0,P.basename)(j.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",logging:"notebook.logging"};var l;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(l=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class r{static create(z){return`${r.d}${z}`}static parse(z){if(z.startsWith(r.d))return z.substring(r.d.length)}}r.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=r;function m(U){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(U)}e.isTextStreamMime=m;const n=new TextDecoder;function t(U){const z=[];let j=!1;for(const de of U)(z.length===0||j)&&(z.push(de),j=!0);return F(z),O(c.VSBuffer.concat(z.map(de=>c.VSBuffer.wrap(de))))}e.compressOutputItemStreams=t;const a=`${String.fromCharCode(27)}[A`,w=a.split("").map(U=>U.charCodeAt(0)),D=10;function F(U){U.forEach((z,j)=>{if(j===0||z.length<a.length)return;const de=U[j-1],V=z.subarray(0,a.length);if(V[0]===w[0]&&V[1]===w[1]&&V[2]===w[2]){const X=de.lastIndexOf(D);if(X===-1)return;U[j-1]=de.subarray(0,X),U[j]=z.subarray(a.length)}})}function x(U){let z=U;do U=z,z=U.replace(/[^\n]\x08/gm,"");while(z.length<U.length);return U}function q(U){for(U=U.replace(/\r+\n/gm,`
`);U.search(/\r[^$]/g)>-1;){const z=U.match(/^(.*)\r+/m)[1];let j=U.match(/\r+(.*)$/m)[1];j=j+z.slice(j.length,z.length),U=U.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,j)}return U}const M="\b".charCodeAt(0),B="\r".charCodeAt(0);function O(U){return!U.buffer.includes(M)&&!U.buffer.includes(B)?U:c.VSBuffer.fromString(q(x(n.decode(U.buffer))))}}),define(ye[231],De([1,0,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var A;(function(u){u[u.Output=1]="Output",u[u.OutputItems=2]="OutputItems",u[u.ExecutionState=3]="ExecutionState"})(A=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(ye[57],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(R){R.Delimiter="\0"})(c=e.TestIdPathParts||(e.TestIdPathParts={}));var A;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(A=e.TestPosition||(e.TestPosition={}));class u{static fromExtHostTestItem(C,P,S=C.parent){if(C._isRoot)return new u([P]);const I=[C.id];for(let L=S;L&&L.id!==P;L=L.parent)I.push(L.id);return I.push(P),new u(I.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const P=C.indexOf("\0");return P===-1?C:C.slice(0,P)}static fromString(C){return new u(C.split("\0"))}static join(C,P){return new u([...C.path,P])}static joinToString(C,P){return C.toString()+"\0"+P}static parentId(C){const P=C.lastIndexOf("\0");return P===-1?void 0:C.slice(0,P)}static localId(C){const P=C.lastIndexOf("\0");return P===-1?C:C.slice(P+1)}static compare(C,P){return C===P?0:P.startsWith(C+"\0")?2:C.startsWith(P+"\0")?3:1}constructor(C,P=C.length){if(this.path=C,this.d=P,C.length===0||P<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new u(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let C=1;C<=this.d;C++)yield new u(this.path,C)}*idsToRoot(){for(let C=this.d;C>0;C--)yield new u(this.path,C)}compare(C){if(typeof C=="string")return u.compare(this.toString(),C);for(let P=0;P<C.d&&P<this.d;P++)if(C.path[P]!==this.path[P])return 1;return C.d>this.d?2:C.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let C=1;C<this.d;C++)this.c+="\0",this.c+=this.path[C]}return this.c}}e.TestId=u}),define(ye[75],De([1,0,2,32,57]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var R;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(R=e.TestResultState||(e.TestResultState={}));var C;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable",n[n.SupportsContinuousRun=64]="SupportsContinuousRun"})(C=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const P=n=>"runIn"in n;e.isStartControllerTests=P;var S;(function(n){n.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),n.deserialize=t=>({range:A.Range.lift(t.range),uri:c.URI.revive(t.uri)})})(S=e.IRichLocation||(e.IRichLocation={}));var I;(function(n){n[n.Error=0]="Error",n[n.Output=1]="Output"})(I=e.TestMessageType||(e.TestMessageType={}));var L;(function(n){n.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&S.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&S.deserialize(t.location)})})(L=e.ITestErrorMessage||(e.ITestErrorMessage={}));const k=(n,t)=>`${t?"s":"e"}${n}`;e.getMarkId=k;var v;(function(n){n.serialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&S.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&S.deserialize(t.location)})})(v=e.ITestOutputMessage||(e.ITestOutputMessage={}));var T;(function(n){n.serialize=t=>t.type===0?L.serialize(t):v.serialize(t),n.deserialize=t=>t.type===0?L.deserialize(t):v.deserialize(t)})(T=e.ITestMessage||(e.ITestMessage={}));var E;(function(n){n.serializeWithoutMessages=t=>({state:t.state,duration:t.duration,messages:[]}),n.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(T.serialize)}),n.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(T.deserialize)})})(E=e.ITestTaskState||(e.ITestTaskState={}));const f="\0",d=(n,t)=>n+f+t;e.namespaceTestTag=d;const h=n=>{const t=n.indexOf(f);return{ctrlId:n.slice(0,t),tagId:n.slice(t+1)}};e.denamespaceTestTag=h;var g;(function(n){n.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),n.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?c.URI.revive(t.uri):void 0,range:t.range?A.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(g=e.ITestItem||(e.ITestItem={}));var p;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(p=e.TestItemExpandState||(e.TestItemExpandState={}));var y;(function(n){n.serialize=t=>({expand:t.expand,item:g.serialize(t.item)}),n.deserialize=t=>({controllerId:u.TestId.root(t.item.extId),expand:t.expand,item:g.deserialize(t.item)})})(y=e.InternalTestItem||(e.InternalTestItem={}));var b;(function(n){n.serialize=t=>{let a;return t.item&&(a={},t.item.label!==void 0&&(a.label=t.item.label),t.item.tags!==void 0&&(a.tags=t.item.tags),t.item.busy!==void 0&&(a.busy=t.item.busy),t.item.uri!==void 0&&(a.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(a.range=t.item.range?.toJSON()),t.item.description!==void 0&&(a.description=t.item.description),t.item.error!==void 0&&(a.error=t.item.error),t.item.sortText!==void 0&&(a.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:a}},n.deserialize=t=>{let a;return t.item&&(a={},t.item.label!==void 0&&(a.label=t.item.label),t.item.tags!==void 0&&(a.tags=t.item.tags),t.item.busy!==void 0&&(a.busy=t.item.busy),t.item.range!==void 0&&(a.range=t.item.range?A.Range.lift(t.item.range):null),t.item.description!==void 0&&(a.description=t.item.description),t.item.error!==void 0&&(a.error=t.item.error),t.item.sortText!==void 0&&(a.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:a}}})(b=e.ITestItemUpdate||(e.ITestItemUpdate={}));const i=(n,t)=>{t.expand!==void 0&&(n.expand=t.expand),t.item!==void 0&&(n.item=n.item?Object.assign(n.item,t.item):t.item)};e.applyTestItemUpdate=i;var o;(function(n){n.serializeWithoutMessages=t=>({...y.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(E.serializeWithoutMessages),retired:t.retired}),n.serialize=t=>({...y.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(E.serialize),retired:t.retired}),n.deserialize=t=>({...y.deserialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(E.deserialize),retired:!0})})(o=e.TestResultItem||(e.TestResultItem={}));var s;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(s=e.DetailType||(e.DetailType={}));var l;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.DocumentSynced=2]="DocumentSynced",n[n.Remove=3]="Remove",n[n.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",n[n.Retire=5]="Retire",n[n.AddTag=6]="AddTag",n[n.RemoveTag=7]="RemoveTag"})(l=e.TestDiffOpType||(e.TestDiffOpType={}));var r;(function(n){n.deserialize=t=>t.op===0?{op:t.op,item:y.deserialize(t.item)}:t.op===1?{op:t.op,item:b.deserialize(t.item)}:t.op===2?{op:t.op,uri:c.URI.revive(t.uri),docv:t.docv}:t,n.serialize=t=>t.op===0?{op:t.op,item:y.serialize(t.item)}:t.op===1?{op:t.op,item:b.serialize(t.item)}:t})(r=e.TestsDiffOp||(e.TestsDiffOp={}));class m{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(t){const a=this.o();for(const w of t)switch(w.op){case 0:this.j(y.deserialize(w.item),a);break;case 1:this.k(b.deserialize(w.item),a);break;case 3:this.l(w.itemId,a);break;case 5:this.m(w.itemId);break;case 4:this.updatePendingRoots(w.amount);break;case 6:this.c.set(w.tag.id,w.tag);break;case 7:this.c.delete(w.id);break}a.complete?.()}j(t,a){const w=u.TestId.parentId(t.item.extId)?.toString();let D;if(!w)D=this.p(t),this.f.add(D),this.d.set(t.item.extId,D);else if(this.d.has(w)){const F=this.d.get(w);F.children.add(t.item.extId),D=this.p(t,F),this.d.set(t.item.extId,D)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(t)}`);return}return a.add?.(D),t.expand===2&&this.g++,D}k(t,a){const w=this.d.get(t.extId);if(!!w)return t.expand!==void 0&&(w.expand===2&&this.g--,t.expand===2&&this.g++),(0,e.applyTestItemUpdate)(w,t),a.update?.(w),w}l(t,a){const w=this.d.get(t);if(!w)return;const D=u.TestId.parentId(w.item.extId)?.toString();D?this.d.get(D).children.delete(w.item.extId):this.f.delete(w);const F=[[t]];for(;F.length;)for(const x of F.pop()){const q=this.d.get(x);q&&(F.push(q.children),this.d.delete(x),a.remove?.(q,q!==w),q.expand===2&&this.g--)}}m(t){}updatePendingRoots(t){this.h+=t}o(){return{}}}e.AbstractIncrementalTestCollection=m}),define(ye[93],De([1,0,19,3,6,50,75,57]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk",g[g.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const I=(g,p)=>g===p,k=Object.entries({range:(g,p)=>g===p?!0:!g||!p?!1:g.equalsRange(p),busy:I,label:I,description:I,error:I,sortText:I,tags:(g,p)=>!(g.length!==p.length||g.some(y=>!p.includes(y)))}),v=(g,p)=>{let y;for(const[b,i]of k)i(g[b],p[b])||(y?y[b]=p[b]:y={[b]:p[b]});return y};class T extends u.Disposable{get root(){return this.m.root}constructor(p){super(),this.m=p,this.f=this.B(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new A.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(p){this.h=p;for(const y of this.tree.values())this.G(y)}collectDiff(){const p=this.k;return this.k=[],p}pushDiff(p){switch(p.op){case 2:{for(const y of this.k)if(y.op===2&&y.uri===p.uri){y.docv=p.docv;return}break}case 1:{const y=this.k[this.k.length-1];if(y){if(y.op===1&&y.item.extId===p.item.extId){(0,C.applyTestItemUpdate)(y.item,p.item);return}if(y.op===0&&y.item.item.extId===p.item.extId){(0,C.applyTestItemUpdate)(y.item,p.item);return}}break}}this.k.push(p),this.f.isScheduled()||this.f.schedule()}expand(p,y){const b=this.tree.get(p);if(!!b){if((b.expandLevels===void 0||y>b.expandLevels)&&(b.expandLevels=y),b.expand===1){const i=this.I(b);return i.isOpen()?this.H(b,y-1):i.wait().then(()=>this.H(b,y-1))}else if(b.expand===3)return b.resolveBarrier?.isOpen()===!1?b.resolveBarrier.wait().then(()=>this.H(b,y-1)):this.H(b,y-1)}}dispose(){for(const p of this.tree.values())this.m.getApiFor(p.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(p,y){switch(y.op){case 3:this.L(P.TestId.joinToString(p.fullId,y.id));break;case 0:this.u(y.item,p);break;case 5:for(const b of y.ops)this.p(p,b);break;case 1:this.w(y.new,y.old,p.fullId.toString());break;case 2:this.G(p);break;case 4:this.pushDiff({op:1,item:{extId:p.fullId.toString(),item:y.update}});break;case 6:this.s(p.actual.uri);break;default:(0,R.assertNever)(y)}}s(p){p&&this.pushDiff({op:2,uri:p,docv:this.m.getDocumentVersion(p)})}u(p,y){const b=P.TestId.fromExtHostTestItem(p,this.root.id,y?.actual),i=this.m.getApiFor(p);i.parent&&i.parent!==y?.actual&&this.m.getChildren(i.parent).delete(p.id);let o=this.tree.get(b.toString());if(!o){o={fullId:b,actual:p,expandLevels:y?.expandLevels?y.expandLevels-1:void 0,expand:0},p.tags.forEach(this.y,this),this.tree.set(o.fullId.toString(),o),this.C(p,y),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:o.expand,item:this.m.toITestItem(p)}}),this.F(p,o,y);return}if(o.actual===p){this.D(p,o,y);return}if(o.actual.uri?.toString()!==p.uri?.toString())return this.L(b.toString()),this.u(p,y);const s=this.m.getChildren(o.actual),l=o.actual,r=v(this.m.toITestItem(l),this.m.toITestItem(p));this.m.getApiFor(l).listener=void 0,o.actual=p,o.expand=0,r&&(r.hasOwnProperty("tags")&&(this.w(p.tags,l.tags,b.toString()),delete r.tags),this.p(o,{op:4,update:r})),this.F(p,o,y);for(const[m,n]of s)this.m.getChildren(p).get(n.id)||this.L(P.TestId.joinToString(b,n.id));this.s(o.actual.uri)}w(p,y,b){const i=new Set(y.map(o=>o.id));for(const o of p)i.delete(o.id)||this.y(o);this.pushDiff({op:1,item:{extId:b,item:{tags:p.map(o=>(0,C.namespaceTestTag)(this.m.controllerId,o.id))}}}),i.forEach(this.z,this)}y(p){const y=this.j.get(p.id);y?y.refCount++:(this.j.set(p.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,C.namespaceTestTag)(this.m.controllerId,p.id)}}))}z(p){const y=this.j.get(p);y&&!--y.refCount&&(this.j.delete(p),this.pushDiff({op:7,id:(0,C.namespaceTestTag)(this.m.controllerId,p)}))}C(p,y){this.m.getApiFor(p).parent=y&&y.actual!==this.root?y.actual:void 0}D(p,y,b){this.C(p,b);const i=this.m.getApiFor(p);i.parent=b?.actual,i.listener=o=>this.p(y,o),this.G(y)}F(p,y,b){this.D(p,y,b);for(const[i,o]of this.m.getChildren(p))this.u(o,y)}G(p){let y;this.h?p.resolveBarrier?y=p.resolveBarrier.isOpen()?3:2:y=p.actual.canResolveChildren?1:0:y=0,y!==p.expand&&(p.expand=y,this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:y}}),y===1&&p.expandLevels!==void 0&&this.I(p))}H(p,y){if(y<0)return;const b=[];for(const[i,o]of this.m.getChildren(p.actual)){const s=this.expand(P.TestId.joinToString(p.fullId,o.id),y);(0,c.isThenable)(s)&&b.push(s)}if(b.length)return Promise.all(b).then(()=>{})}I(p){if(p.resolveBarrier)return p.resolveBarrier;if(!this.h){const o=new c.Barrier;return o.open(),o}p.expand=2,this.J(p);const y=p.resolveBarrier=new c.Barrier,b=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,o)};let i;try{i=this.h(p.actual===this.root?void 0:p.actual)}catch(o){b(o)}return(0,c.isThenable)(i)?i.catch(b).then(()=>{y.open(),this.G(p)}):(y.open(),this.G(p)),p.resolveBarrier}J(p){this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:p.expand}})}L(p){const y=this.tree.get(p);if(!y)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:p});const b=[y];for(;b.length;){const i=b.pop();if(!!i){this.m.getApiFor(i.actual).listener=void 0;for(const o of i.actual.tags)this.z(o.id);this.tree.delete(i.fullId.toString());for(const[o,s]of this.m.getChildren(i.actual))b.push(this.tree.get(P.TestId.joinToString(i.fullId,s.id)))}}}flushDiff(){const p=this.collectDiff();p.length&&this.g.fire(p)}}e.TestItemCollection=T;class E extends Error{constructor(p){super(`Attempted to insert a duplicate test item ID ${p}`)}}e.DuplicateTestItemError=E;class f extends Error{constructor(p){super(`TestItem with ID "${p}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class d extends Error{constructor(p,y,b){super(`TestItem with ID "${p}" is from controller "${y}" and cannot be added as a child of an item from controller "${b}".`)}}e.MixedTestItemController=d;const h=(g,p,y)=>{let b=new Map;return{get size(){return b.size},forEach(i,o){for(const s of b.values())i.call(o,s,this)},[Symbol.iterator](){return b.entries()},replace(i){const o=new Map,s=new Set(b.keys()),l={op:5,ops:[]};for(const r of i){if(!(r instanceof y))throw new f(r.id);const m=p(r).controllerId;if(m!==g.controllerId)throw new d(r.id,m,g.controllerId);if(o.has(r.id))throw new E(r.id);o.set(r.id,r),s.delete(r.id),l.ops.push({op:0,item:r})}for(const r of s.keys())l.ops.push({op:3,id:r});g.listener?.(l),b=o},add(i){if(!(i instanceof y))throw new f(i.id);b.set(i.id,i),g.listener?.({op:0,item:i})},delete(i){b.delete(i)&&g.listener?.({op:3,id:i})},get(i){return b.get(i)},toJSON(){return Array.from(b.values())}}};e.createTestItemChildren=h}),define(ye[132],De([1,0,93]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const A=new WeakMap,u=(C,P)=>{const S={controllerId:P};return A.set(C,S),S};e.createPrivateApiFor=u;const R=C=>{const P=A.get(C);if(!P)throw new c.InvalidTestItemError(C?.id||"<unknown>");return P};e.getPrivateApiFor=R}),define(ye[94],De([1,0,18,2]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function u(P,S){return P.scheme===c.Schemas.http||P.scheme===c.Schemas.https?P:(S&&S.authority&&S.isRemote&&P.scheme===c.Schemas.file&&(P=A.URI.from({scheme:c.Schemas.vscodeRemote,authority:S.authority,path:P.path})),A.URI.from({scheme:c.Schemas.https,authority:`${P.scheme}+${R(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=u;function R(P){return P.replace(/./g,S=>{const I=S.charCodeAt(0);return I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57?S:"-"+I.toString(16).padStart(4,"0")})}function C(P){return P.replace(/-([0-9a-f]{4})/g,(S,I)=>String.fromCharCode(parseInt(I,16)))}e.decodeAuthority=C}),define(ye[232],De([1,0,3,6,94]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class R{constructor(P,S,I){this.d=P,this.e=S,this.f=I,this.a=0,this.b=new A.DisposableStore,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const L=S.getVisibleTextEditors();for(const k of this.c.values())L.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(P=>P.inset.dispose()),this.b.dispose()}createWebviewEditorInset(P,S,I,L,k){let v;for(const p of this.e.getVisibleTextEditors(!0))if(p.value===P){v=p;break}if(!v)throw new Error("not a visible editor");const T=this,E=this.a++,f=new c.Emitter,d=new c.Emitter,h=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(p){return(0,u.asWebviewUri)(p,T.f)}get cspSource(){return u.webviewGenericCspSource}set options(p){this.b=p,T.d.$setOptions(E,p)}get options(){return this.b}set html(p){this.a=p,T.d.$setHtml(E,p)}get html(){return this.a}get onDidReceiveMessage(){return f.event}postMessage(p){return T.d.$postMessage(E,p)}},g=new class{constructor(){this.editor=P,this.line=S,this.height=I,this.webview=h,this.onDidDispose=d.event}dispose(){T.c.has(E)&&(T.c.delete(E),T.d.$disposeEditorInset(E),d.fire(),d.dispose(),f.dispose())}};return this.d.$createEditorInset(E,v.id,v.value.document.uri,S+1,I,L||{},k.identifier,k.extensionLocation),this.c.set(E,{editor:P,inset:g,onDidReceiveMessage:f}),g}$onDidDispose(P){const S=this.c.get(P);S&&S.inset.dispose()}$onDidReceiveMessage(P,S){this.c.get(P)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=R}),define(ye[233],De([1,0,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,c.createDecorator)("configurationResolverService");var A;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(A=e.VariableKind||(e.VariableKind={}));class u extends Error{constructor(C,P){super(P),this.variable=C}}e.VariableError=u}),define(ye[234],De([1,0,10,36,9,23,12,113,194,233,8]),function(ne,e,c,A,u,R,C,P,S,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(T,E,f,d){this.g=new Map,this.a=T,this.b=E,this.d=f,d&&(this.c=d.then(h=>this.h(h)))}h(T){if(C.isWindows){const E=Object.create(null);return Object.keys(T).forEach(f=>{E[f.toLowerCase()]=T[f]}),E}return T}resolveWithEnvironment(T,E,f){return this.j({env:this.h(T),userHome:void 0},E?E.uri:void 0,f)}async resolveAsync(T,E){const f={env:await this.c,userHome:await this.d};return this.j(f,T?T.uri:void 0,E)}async i(T,E,f,d){const h=R.deepClone(E);C.isWindows&&h.windows?Object.keys(h.windows).forEach(p=>h[p]=h.windows[p]):C.isMacintosh&&h.osx?Object.keys(h.osx).forEach(p=>h[p]=h.osx[p]):C.isLinux&&h.linux&&Object.keys(h.linux).forEach(p=>h[p]=h.linux[p]),delete h.windows,delete h.osx,delete h.linux;const g={env:await this.c,userHome:await this.d};return this.j(g,T?T.uri:void 0,h,f,d)}async resolveAnyAsync(T,E,f){return this.i(T,E,f)}async resolveAnyMap(T,E,f){const d=new Map;return{newConfig:await this.i(T,E,f,d),resolvedVariables:d}}resolveWithInteractionReplace(T,E,f,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(T,E,f,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(T,E){if(this.g.has(T))throw new Error("Variable "+T+" is contributed twice.");this.g.set(T,E)}async j(T,E,f,d,h){if(u.isString(f))return this.l(T,E,f,d,h);if(Array.isArray(f))return Promise.all(f.map(g=>this.j(T,E,g,d,h)));if(u.isObject(f)){const g=Object.create(null),p=await Promise.all(Object.keys(f).map(async y=>[await this.l(T,E,y,d,h),await this.j(T,E,f[y],d,h)]));for(const[y,b]of p)g[y]=b;return g}return f}l(T,E,f,d,h){return(0,L.replaceAsync)(f,k.VARIABLE_REGEXP,async(g,p)=>{if(p.includes(k.VARIABLE_LHS))return g;let y=await this.n(T,g,p,E,d);return h?.set(p,y),y!==g&&u.isString(y)&&y.match(k.VARIABLE_REGEXP)&&(y=await this.l(T,E,y,d,h)),y})}m(T){return this.b?this.b.getUriLabel(T,{noPrefix:!0}):T.fsPath}async n(T,E,f,d,h){let g;const p=f.split(":");p.length>1&&(f=p[0],g=p[1]);const y=o=>{const s=this.a.getFilePath();if(s)return(0,P.normalizeDriveLetter)(s);throw new I.VariableError(o,(0,S.localize)(0,null,E))},b=o=>{const s=y(o);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,P.normalizeDriveLetter)(l)}throw new I.VariableError(o,(0,S.localize)(1,null,E,c.basename(s)))},i=o=>{if(g){const s=this.a.getFolderUri(g);if(s)return s;throw new I.VariableError(o,(0,S.localize)(2,null,E,g))}if(d)return d;throw this.a.getWorkspaceFolderCount()>1?new I.VariableError(o,(0,S.localize)(3,null,E)):new I.VariableError(o,(0,S.localize)(4,null,E))};switch(f){case"env":if(g){if(T.env){const o=T.env[C.isWindows?g.toLowerCase():g];if(u.isString(o))return o}return""}throw new I.VariableError(I.VariableKind.Env,(0,S.localize)(5,null,E));case"config":if(g){const o=this.a.getConfigurationValue(d,g);if(u.isUndefinedOrNull(o))throw new I.VariableError(I.VariableKind.Config,(0,S.localize)(6,null,E,g));if(u.isObject(o))throw new I.VariableError(I.VariableKind.Config,(0,S.localize)(7,null,E,g));return o}throw new I.VariableError(I.VariableKind.Config,(0,S.localize)(8,null,E));case"command":return this.o(I.VariableKind.Command,E,g,h,"command");case"input":return this.o(I.VariableKind.Input,E,g,h,"input");case"extensionInstallFolder":if(g){const o=await this.a.getExtension(g);if(!o)throw new I.VariableError(I.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,E,g));return this.m(o.extensionLocation)}throw new I.VariableError(I.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,E));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.m(i(I.VariableKind.WorkspaceFolder)));case"cwd":return d||g?(0,P.normalizeDriveLetter)(this.m(i(I.VariableKind.Cwd))):A.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,P.normalizeDriveLetter)(c.basename(this.m(i(I.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(T.userHome)return T.userHome;throw new I.VariableError(I.VariableKind.UserHome,(0,S.localize)(11,null,E))}case"lineNumber":{const o=this.a.getLineNumber();if(o)return o;throw new I.VariableError(I.VariableKind.LineNumber,(0,S.localize)(12,null,E))}case"selectedText":{const o=this.a.getSelectedText();if(o)return o;throw new I.VariableError(I.VariableKind.SelectedText,(0,S.localize)(13,null,E))}case"file":return y(I.VariableKind.File);case"fileWorkspaceFolder":return b(I.VariableKind.FileWorkspaceFolder);case"relativeFile":return d||g?c.relative(this.m(i(I.VariableKind.RelativeFile)),y(I.VariableKind.RelativeFile)):y(I.VariableKind.RelativeFile);case"relativeFileDirname":{const o=c.dirname(y(I.VariableKind.RelativeFileDirname));if(d||g){const s=c.relative(this.m(i(I.VariableKind.RelativeFileDirname)),o);return s.length===0?".":s}return o}case"fileDirname":return c.dirname(y(I.VariableKind.FileDirname));case"fileExtname":return c.extname(y(I.VariableKind.FileExtname));case"fileBasename":return c.basename(y(I.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=c.basename(y(I.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-c.extname(o).length)}case"fileDirnameBasename":return c.basename(c.dirname(y(I.VariableKind.FileDirnameBasename)));case"execPath":{const o=this.a.getExecPath();return o||E}case"execInstallFolder":{const o=this.a.getAppRoot();return o||E}case"pathSeparator":return c.sep;default:try{const o=g?`${f}:${g}`:f;return this.o(I.VariableKind.Unknown,E,o,h,void 0)}catch{return E}}}}o(T,E,f,d,h){if(f&&d){const g=h===void 0?d[f]:d[h+":"+f];if(typeof g=="string")return g;throw new I.VariableError(T,(0,S.localize)(14,null,E))}return E}}k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=k}),define(ye[133],De([1,0,4,130]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var u;(function(E){E[E.UP=0]="UP",E[E.DOWN=1]="DOWN",E[E.LEFT=2]="LEFT",E[E.RIGHT=3]="RIGHT"})(u=e.GroupDirection||(e.GroupDirection={}));var R;(function(E){E[E.HORIZONTAL=0]="HORIZONTAL",E[E.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(E){E[E.FIRST=0]="FIRST",E[E.LAST=1]="LAST",E[E.NEXT=2]="NEXT",E[E.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var P;(function(E){E[E.MAXIMIZE=0]="MAXIMIZE",E[E.EVEN=1]="EVEN",E[E.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(E){E[E.COPY_EDITORS=0]="COPY_EDITORS",E[E.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function I(E){const f=E;return(0,A.isEditorInput)(f?.editor)&&(0,A.isEditorInput)(f?.replacement)}e.isEditorReplacement=I;var L;(function(E){E[E.CREATION_TIME=0]="CREATION_TIME",E[E.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",E[E.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(E){E[E.NEW_EDITOR=1]="NEW_EDITOR",E[E.MOVE_EDITOR=2]="MOVE_EDITOR",E[E.COPY_EDITOR=3]="COPY_EDITOR"})(k=e.OpenEditorContext||(e.OpenEditorContext={}));function v(E){const f=E;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.isEditorGroup=v;function T(E){return E.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=T}),define(ye[235],De([1,0,4,133]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function u(R){const C=R;return typeof R=="number"||(0,A.isEditorGroup)(C)}e.isPreferredGroup=u}),define(ye[236],De([1,0,4,200]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(A.IEnvironmentService)}),define(ye[134],De([1,0,26,3,10]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class R{constructor(k){this.removedDueToLooping=k}}e.DeltaExtensionsResult=R;class C{static isHostExtension(k,v,T){if(v.getExtensionDescription(k))return!1;const E=T.getExtensionDescription(k);return E?!!((E.main||E.browser)&&E.api==="none"):!1}constructor(k){this.c=new A.Emitter,this.onDidChange=this.c.event,this.d=k,this.h()}h(){this.d.sort(S),this.e=new Map,this.f=[],this.g=new Map;for(const k of this.d){if(this.e.has(c.ExtensionIdentifier.toKey(k.identifier))){console.error("Extension `"+k.identifier.value+"` is already registered");continue}if(this.e.set(c.ExtensionIdentifier.toKey(k.identifier),k),this.f.push(k),Array.isArray(k.activationEvents))for(let v of k.activationEvents)v==="onUri"&&(v=`onUri:${c.ExtensionIdentifier.toKey(k.identifier)}`),this.g.has(v)||this.g.set(v,[]),this.g.get(v).push(k)}}set(k){this.d=k,this.h(),this.c.fire(void 0)}deltaExtensions(k,v){this.d=I(this.d,v),this.d=this.d.concat(k);const T=C.j(this.d);return this.d=I(this.d,T.map(E=>E.identifier)),this.h(),this.c.fire(void 0),new R(T)}static j(k){const v=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(h){this.d.has(h)||(this.d.add(h),this.e.push(h))}addArc(h,g){this.addNode(h),this.addNode(g),this.c.has(h)?this.c.get(h).push(g):this.c.set(h,[g])}getArcs(h){return this.c.has(h)?this.c.get(h):[]}hasOnlyGoodArcs(h,g){const p=v.getArcs(h);for(let y=0;y<p.length;y++)if(!g.has(p[y]))return!1;return!0}getNodes(){return this.e}},T=new Map;for(const h of k){const g=c.ExtensionIdentifier.toKey(h.identifier);if(T.set(g,h),h.extensionDependencies)for(const p of h.extensionDependencies){const y=c.ExtensionIdentifier.toKey(p);v.addArc(g,y)}}const E=new Set;v.getNodes().filter(h=>v.getArcs(h).length===0).forEach(h=>E.add(h));const f=v.getNodes().filter(h=>!E.has(h));let d;do{d=!1;for(let h=0;h<f.length;h++){const g=f[h];v.hasOnlyGoodArcs(g,E)&&(f.splice(h,1),h--,E.add(g),d=!0)}}while(d);return f.map(h=>T.get(h))}containsActivationEvent(k){return this.g.has(k)}containsExtension(k){return this.e.has(c.ExtensionIdentifier.toKey(k))}getExtensionDescriptionsForActivationEvent(k){const v=this.g.get(k);return v?v.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(k){const v=this.e.get(c.ExtensionIdentifier.toKey(k));return v||void 0}getExtensionDescriptionByUUID(k){for(const v of this.f)if(v.uuid===k)return v}getExtensionDescriptionByIdOrUUID(k,v){return this.getExtensionDescription(k)??(v?this.getExtensionDescriptionByUUID(v):void 0)}}e.ExtensionDescriptionRegistry=C;var P;(function(L){L[L.Builtin=0]="Builtin",L[L.User=1]="User",L[L.Dev=2]="Dev"})(P||(P={}));function S(L,k){const v=L.isBuiltin?0:L.isUnderDevelopment?2:1,T=k.isBuiltin?0:k.isUnderDevelopment?2:1;if(v!==T)return v-T;const E=u.posix.basename(L.extensionLocation.path),f=u.posix.basename(k.extensionLocation.path);return E<f?-1:E>f?1:0}function I(L,k){const v=new Set;return k.forEach(T=>v.add(c.ExtensionIdentifier.toKey(T))),L.filter(T=>!v.has(c.ExtensionIdentifier.toKey(T.identifier)))}}),define(ye[237],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var c;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(c=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class A{constructor(k){this.pipeName=k,this.type=1}serialize(k){k[A.ENV_KEY]=this.pipeName}}A.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK",e.IPCExtHostConnection=A;class u{constructor(){this.type=2}serialize(k){k[u.ENV_KEY]="1"}}u.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET",e.SocketExtHostConnection=u;class R{constructor(){this.type=3}serialize(k){k[R.ENV_KEY]="1"}}R.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT",e.MessagePortExtHostConnection=R;function C(L){delete L[A.ENV_KEY],delete L[u.ENV_KEY],delete L[R.ENV_KEY]}function P(L,k){C(k),L.serialize(k)}e.writeExtHostConnection=P;function S(L){if(L[A.ENV_KEY])return I(L,new A(L[A.ENV_KEY]));if(L[u.ENV_KEY])return I(L,new u);if(L[R.ENV_KEY])return I(L,new R);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=S;function I(L,k){return C(L),k}}),define(ye[95],De([1,0,22]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var A;(function(I){I[I.Desktop=1]="Desktop",I[I.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var u;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(u=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var R;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(R=e.MessageType||(e.MessageType={}));function C(I){const L=c.VSBuffer.alloc(1);switch(I){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=C;function P(I,L){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=P;var S;(function(I){I.Start="START_NATIVE_LOG",I.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(ye[96],De([1,0,4,3,13,25,95,72,73,23,2,6,181]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let T=class extends k.Disposable{constructor(h,g){super(),this.m=h,this.n=g,this.a=this.B(new A.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new A.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.l=new Map,this.j=L.URI.revive(this.m.environment.extensionTelemetryLogResource),this.i=this.m.environment.isExtensionTelemetryLoggingOnly,this.k=g.createLogger(this.j,{id:S.extensionTelemetryLogChannelId,name:(0,v.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(g.onDidChangeLogLevel(p=>{(0,u.isLogLevel)(p)&&this.p()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}p(){this.n.setVisibility(this.j,this.g&&this.n.getLogLevel()===u.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(h,g,p){const y=this.getTelemetryDetails(),b=new E(g,p,h,this.k,this.i,this.getBuiltInCommonProperties(h),{isUsageEnabled:y.isUsageEnabled,isErrorsEnabled:y.isErrorsEnabled});return this.l.set(h.identifier.value,b),b.apiTelemetryLogger}$initializeTelemetryLevel(h,g,p){this.f=h,this.g=g,this.c=p??{usage:!0,error:!0},this.p()}getBuiltInCommonProperties(h){const g={};switch(g["common.extname"]=`${h.publisher}.${h.name}`,g["common.extversion"]=h.version,g["common.vscodemachineid"]=this.m.telemetryInfo.machineId,g["common.vscodesessionid"]=this.m.telemetryInfo.sessionId,g["common.vscodeversion"]=this.m.version,g["common.isnewappinstall"]=f(this.m.telemetryInfo.firstSessionDate),g["common.product"]=this.m.environment.appHost,this.m.uiKind){case C.UIKind.Web:g["common.uikind"]="web";break;case C.UIKind.Desktop:g["common.uikind"]="desktop";break;default:g["common.uikind"]="unknown"}return g["common.remotename"]=(0,P.getRemoteName)((0,S.cleanRemoteAuthority)(this.m.remote.authority)),g}$onDidChangeTelemetryLevel(h){this.h=this.getTelemetryConfiguration(),this.f=h;const g=this.getTelemetryDetails();this.l.forEach(p=>{p.updateTelemetryEnablements(g.isUsageEnabled,g.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.p()}onExtensionError(h,g){const p=this.l.get(h.value);return!p||p.ignoreUnhandledExtHostErrors?!1:(p.logError(g),!0)}};T=qe([We(0,R.IExtHostInitDataService),We(1,u.ILoggerService)],T),e.ExtHostTelemetry=T;class E{static validateSender(h){if(typeof h!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof h.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof h.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof h.flush<"u"&&typeof h.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(h,g,p,y,b,i,o){this.g=p,this.h=y,this.i=b,this.j=i,this.b=new A.Emitter,this.ignoreUnhandledExtHostErrors=g?.ignoreUnhandledErrors??!1,this.c=g?.ignoreBuiltInCommonProperties??!1,this.d=g?.additionalCommonProperties,this.a=h,this.e={isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}}updateTelemetryEnablements(h,g){this.f&&(this.e={isUsageEnabled:h,isErrorsEnabled:g},this.b.fire(this.f))}mixInCommonPropsAndCleanData(h){let g=h.properties??h;return g=(0,S.cleanData)(g,[]),this.d&&(g=(0,I.mixin)(g,this.d)),this.c||(g=(0,I.mixin)(g,this.j)),h.properties?h.properties=g:h=g,h}k(h,g){this.g.publisher==="vscode"?h=this.g.name+"/"+h:h=this.g.identifier.value+"/"+h,g=this.mixInCommonPropsAndCleanData(g||{}),this.i||this.a.sendEventData(h,g),this.h.trace(h,g)}logUsage(h,g){!this.e.isUsageEnabled||this.k(h,g)}logError(h,g){!this.e.isErrorsEnabled||(typeof h=="string"?this.k(h,g):this.a.sendErrorData(h,g))}get apiTelemetryLogger(){if(!this.f){const h=this,g={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h.e.isUsageEnabled},get isErrorsEnabled(){return h.e.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h.b.event.bind(h)};this.f=Object.freeze(g)}return this.f}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=E;function f(d){const h=Date.now()-new Date(d).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.isNewAppInstall=f,e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(ye[27],De([1,0,3,2,4,26,213]),function(ne,e,c,A,u,R,C){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:A.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,u.createDecorator)("extensionService");class S{constructor(m){this.affinity=m,this.kind=1}equals(m){return this.kind===m.kind&&this.affinity===m.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class I{constructor(m){this.affinity=m,this.kind=2}equals(m){return this.kind===m.kind&&this.affinity===m.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=I;class L{constructor(){this.kind=3,this.affinity=0}equals(m){return this.kind===m.kind}asString(){return"Remote"}}e.RemoteRunningLocation=L;class k{constructor(m){this.dependency=m}}e.MissingExtensionDependency=k;var v;(function(r){r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(v=e.ExtensionHostKind||(e.ExtensionHostKind={}));function T(r){if(r===null)return"None";switch(r){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=T;class E{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(m,n){const t=[],a=[],w=[],D=[],F=h(this.c),x=h(m),q=(U,z)=>U.extensionLocation.toString()===z.extensionLocation.toString()||U.isBuiltin===z.isBuiltin||U.isUserBuiltin===z.isUserBuiltin||U.isUnderDevelopment===z.isUnderDevelopment;for(const U of this.c){const z=x.get(R.ExtensionIdentifier.toKey(U.identifier));if(!z){t.push(U.identifier),F.delete(R.ExtensionIdentifier.toKey(U.identifier));continue}if(!q(U,z)){t.push(U.identifier),F.delete(R.ExtensionIdentifier.toKey(U.identifier));continue}}for(const U of m){const z=F.get(R.ExtensionIdentifier.toKey(U.identifier));if(!z){a.push(U);continue}if(!q(z,U)){t.push(z.identifier),F.delete(R.ExtensionIdentifier.toKey(z.identifier));continue}}const M=d(this.d),B=d(n);for(const U of this.d)B.has(R.ExtensionIdentifier.toKey(U))||w.push(U);for(const U of n)M.has(R.ExtensionIdentifier.toKey(U))||D.push(U);const O={toRemove:t,toAdd:a,myToRemove:w,myToAdd:D};return this.delta(O),O}delta(m){const{toRemove:n,toAdd:t,myToRemove:a,myToAdd:w}=m,D=d(n),F=d(a);for(let x=0;x<this.c.length;x++)D.has(R.ExtensionIdentifier.toKey(this.c[x].identifier))&&(this.c.splice(x,1),x--);for(let x=0;x<this.d.length;x++)F.has(R.ExtensionIdentifier.toKey(this.d[x]))&&(this.d.splice(x,1),x--);for(const x of t)this.c.push(x);for(const x of w)this.d.push(x)}containsExtension(m){for(const n of this.d)if(R.ExtensionIdentifier.equals(n,m))return!0;return!1}}e.ExtensionHostExtensions=E;class f{constructor(m){if(this[P]="ExtensionIdentifierSet",this.c=new Map,this.d=R.ExtensionIdentifier.toKey,m)for(const n of m)this.add(n)}get size(){return this.c.size}add(m){return this.c.set(this.d(m),m),this}clear(){this.c.clear()}delete(m){return this.c.delete(this.d(m))}has(m){return this.c.has(this.d(m))}forEach(m,n){this.c.forEach(t=>m.call(n,t,t,this))}*entries(){for(const[m,n]of this.c)yield[n,n]}keys(){return this.c.values()}values(){return this.c.values()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=f;function d(r){const m=new Set;for(const n of r)m.add(R.ExtensionIdentifier.toKey(n));return m}e.extensionIdentifiersArrayToSet=d;function h(r){const m=new Map;for(const n of r)m.set(R.ExtensionIdentifier.toKey(n.identifier),n);return m}function g(r,m){return r.enabledApiProposals?r.enabledApiProposals.includes(m):!1}e.isProposedApiEnabled=g;function p(r,m){if(!g(r,m))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${m}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${m}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=p;class y{constructor(m,n,t,a){this.codeLoadingTime=m,this.activateCallTime=n,this.activateResolvedTime=t,this.activationReason=a}}e.ActivationTimes=y;class b{constructor(m,n){this.description=m,this.value=n}}e.ExtensionPointContribution=b,e.ExtensionHostLogFileName="exthost";var i;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(i=e.ActivationKind||(e.ActivationKind={}));function o(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}e.toExtension=o;function s(r,m){return{identifier:new R.ExtensionIdentifier((0,C.getExtensionId)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!m,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform,browserNlsBundleUris:r.browserNlsBundleUris}}e.toExtensionDescription=s;class l{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None,this.extensions=[]}activateByEvent(m){return Promise.resolve(void 0)}activationEventIsDone(m){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(m){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(m,n){return Promise.resolve(0)}getInspectPorts(m,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(m){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=l}),define(ye[238],De([1,0,11,134,26,27,13,19]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class S{constructor(h,g,p,y){this.startup=h,this.codeLoadingTime=g,this.activateCallTime=p,this.activateResolvedTime=y}}S.NONE=new S(!1,-1,-1,-1),e.ExtensionActivationTimes=S;class I{constructor(h){this.a=h,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(h,g){return h===-1||g===-1?-1:g-h}build(){return new S(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=I;class L{constructor(h,g,p,y,b,i){this.activationFailed=h,this.activationFailedError=g,this.activationTimes=p,this.module=y,this.exports=b,this.subscriptions=i}}e.ActivatedExtension=L;class k extends L{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class v extends L{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=v;class T extends L{constructor(h){super(!0,h,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let E=class{constructor(h,g,p,y){this.g=y,this.a=h,this.b=g,this.c=p,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[h,g]of this.d)g.dispose()}isActivated(h){const g=this.d.get(u.ExtensionIdentifier.toKey(h));return Boolean(g&&g.value)}getActivatedExtension(h){const g=this.d.get(u.ExtensionIdentifier.toKey(h));if(!g||!g.value)throw new Error(`Extension '${h.value}' is not known or not activated`);return g.value}async activateByEvent(h,g){if(this.f[h])return;const p=this.a.getExtensionDescriptionsForActivationEvent(h);await this.h(p.map(y=>({id:y.identifier,reason:{startup:g,extensionId:y.identifier,activationEvent:h}}))),this.f[h]=!0}activateById(h,g){const p=this.a.getExtensionDescription(h);if(!p)throw new Error(`Extension '${h}' is not known`);return this.h([{id:p.identifier,reason:g}])}async h(h){const g=h.filter(p=>!this.isActivated(p.id)).map(p=>this.j(p));await Promise.all(g.map(p=>p.wait()))}j(h){if(this.d.has(u.ExtensionIdentifier.toKey(h.id)))return this.d.get(u.ExtensionIdentifier.toKey(h.id));if(this.l(h.id))return this.k(h,null,[],null);const g=this.a.getExtensionDescription(h.id);if(!g){const b=new Error(`Cannot activate unknown extension '${h.id.value}'`),i=this.k(h,null,[],new T(b));return this.c.onExtensionActivationError(h.id,b,new R.MissingExtensionDependency(h.id.value)),i}const p=[],y=typeof g.extensionDependencies>"u"?[]:g.extensionDependencies;for(const b of y){if(this.m(b))continue;const i=this.d.get(u.ExtensionIdentifier.toKey(b));if(i){p.push(i);continue}if(this.l(b)){p.push(this.j({id:this.b.getExtensionDescription(b).identifier,reason:h.reason}));continue}const o=this.a.getExtensionDescription(b);if(o){if(!o.main&&!o.browser)continue;p.push(this.j({id:o.identifier,reason:h.reason}));continue}const s=g.displayName||g.identifier.value,l=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${b}'`),r=this.k(h,g.displayName,[],new T(l));return this.c.onExtensionActivationError(g.identifier,l,new R.MissingExtensionDependency(b)),r}return this.k(h,g.displayName,p,null)}k(h,g,p,y){const b=new f(h.id,g,h.reason,p,y,this.c,this.g);return this.d.set(u.ExtensionIdentifier.toKey(h.id),b),b}l(h){return A.ExtensionDescriptionRegistry.isHostExtension(h,this.a,this.b)}m(h){const g=this.b.getExtensionDescription(h);return g?!g.main&&!g.browser:!1}};E=qe([We(3,C.ILogService)],E),e.ExtensionsActivator=E;let f=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(h,g,p,y,b,i,o){this.c=h,this.d=g,this.f=p,this.g=y,this.h=b,this.j=i,this.k=o,this.a=new P.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let h=0;h<this.g.length;h++){const g=this.g[h];if(g.value&&!g.value.activationFailed){this.g.splice(h,1),h--;continue}if(g.value&&g.value.activationFailed){const p=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${g.friendlyName}' failed to activate`);p.detail=g.value.activationFailedError,this.h=new T(p),this.j.onExtensionActivationError(this.c,p,null);return}}this.g.length>0&&await Promise.race(this.g.map(h=>h.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(h){const g=new Error;if(h&&h.name&&(g.name=h.name),h&&h.message?g.message=`Activating extension '${this.c.value}' failed: ${h.message}.`:g.message=`Activating extension '${this.c.value}' failed: ${h}.`,h&&h.stack&&(g.stack=h.stack),this.h=new T(g),this.b&&c.isCancellationError(h))return;this.j.onExtensionActivationError(this.c,g,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(h)}}};f=qe([We(6,C.ILogService)],f)});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!u:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(ne,c):u?u.value=c:e.set(ne,c),c},Be=this&&this.__classPrivateFieldGet||function(ne,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[7],De([1,0,15,11,112,28,86,8,9,2,30,44,128,92,27]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E){"use strict";var f,d,h,g,p,y,b,i,o,s,l,r,m,n,t,a,w,D,F,x,q,M,B;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function O(G){return Object.assign(G,{apply:function(){const me=arguments.length===1?[]:arguments[1];return Reflect.construct(G,me,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(G,[]);{const[me,...Pe]=arguments;return Reflect.construct(G,Pe,me.constructor)}}})}var U;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(U=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var z;(function(G){G[G.Command=0]="Command",G[G.Opener=1]="Opener"})(z=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let j=y=class{static from(...W){let me=W;return new y(function(){if(me){for(const Pe of me)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();me=void 0}})}constructor(W){f.set(this,void 0),Je(this,f,W,"f")}dispose(){typeof Be(this,f,"f")=="function"&&(Be(this,f,"f").call(this),Je(this,f,void 0,"f"))}};f=new WeakMap,j=y=qe([O],j),e.Disposable=j;let de=b=class{static Min(...W){if(W.length===0)throw new TypeError;let me=W[0];for(let Pe=1;Pe<W.length;Pe++){const Ge=W[Pe];Ge.isBefore(me)&&(me=Ge)}return me}static Max(...W){if(W.length===0)throw new TypeError;let me=W[0];for(let Pe=1;Pe<W.length;Pe++){const Ge=W[Pe];Ge.isAfter(me)&&(me=Ge)}return me}static isPosition(W){if(!W)return!1;if(W instanceof b)return!0;const{line:me,character:Pe}=W;return typeof me=="number"&&typeof Pe=="number"}static of(W){if(W instanceof b)return W;if(this.isPosition(W))return new b(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,me){if(W<0)throw(0,A.illegalArgument)("line must be non-negative");if(me<0)throw(0,A.illegalArgument)("character must be non-negative");this.c=W,this.e=me}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,me=0){if(W===null||me===null)throw(0,A.illegalArgument)();let Pe;return typeof W>"u"?Pe=0:typeof W=="number"?Pe=W:(Pe=typeof W.lineDelta=="number"?W.lineDelta:0,me=typeof W.characterDelta=="number"?W.characterDelta:0),Pe===0&&me===0?this:new b(this.line+Pe,this.character+me)}with(W,me=this.character){if(W===null||me===null)throw(0,A.illegalArgument)();let Pe;return typeof W>"u"?Pe=this.line:typeof W=="number"?Pe=W:(Pe=typeof W.line=="number"?W.line:this.line,me=typeof W.character=="number"?W.character:this.character),Pe===this.line&&me===this.character?this:new b(Pe,me)}toJSON(){return{line:this.line,character:this.character}}};de=b=qe([O],de),e.Position=de;let V=i=class{static isRange(W){return W instanceof i?!0:W?de.isPosition(W.start)&&de.isPosition(W.end):!1}static of(W){if(W instanceof i)return W;if(this.isRange(W))return new i(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,me,Pe,Ge){let Ye,at;if(typeof W=="number"&&typeof me=="number"&&typeof Pe=="number"&&typeof Ge=="number"?(Ye=new de(W,me),at=new de(Pe,Ge)):de.isPosition(W)&&de.isPosition(me)&&(Ye=de.of(W),at=de.of(me)),!Ye||!at)throw new Error("Invalid arguments");Ye.isBefore(at)?(this.c=Ye,this.e=at):(this.c=at,this.e=Ye)}contains(W){return i.isRange(W)?this.contains(W.start)&&this.contains(W.end):de.isPosition(W)?!(de.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const me=de.Max(W.start,this.c),Pe=de.Min(W.end,this.e);if(!me.isAfter(Pe))return new i(me,Pe)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const me=de.Min(W.start,this.c),Pe=de.Max(W.end,this.end);return new i(me,Pe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,me=this.end){if(W===null||me===null)throw(0,A.illegalArgument)();let Pe;return W?de.isPosition(W)?Pe=W:(Pe=W.start||this.start,me=W.end||this.end):Pe=this.start,Pe.isEqual(this.c)&&me.isEqual(this.end)?this:new i(Pe,me)}toJSON(){return[this.start,this.end]}};V=i=qe([O],V),e.Range=V;let X=o=class extends V{static isSelection(W){return W instanceof o?!0:W?V.isRange(W)&&de.isPosition(W.anchor)&&de.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,me,Pe,Ge){let Ye,at;if(typeof W=="number"&&typeof me=="number"&&typeof Pe=="number"&&typeof Ge=="number"?(Ye=new de(W,me),at=new de(Pe,Ge)):de.isPosition(W)&&de.isPosition(me)&&(Ye=de.of(W),at=de.of(me)),!Ye||!at)throw new Error("Invalid arguments");super(Ye,at),this.f=Ye,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};X=o=qe([O],X),e.Selection=X;class J{constructor(W,me,Pe){if(typeof W!="string"||W.length===0)throw(0,A.illegalArgument)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,A.illegalArgument)("port");if(typeof Pe<"u"&&(typeof Pe!="string"||Pe.length===0||!/^[0-9A-Za-z_\-]+$/.test(Pe)))throw(0,A.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(me),this.connectionToken=Pe}}e.ResolvedAuthority=J;class te extends Error{static NotAvailable(W,me){return new te(W,v.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(W){return new te(W,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,me=v.RemoteAuthorityResolverErrorCode.Unknown,Pe){super(W),this._message=W,this._code=me,this._detail=Pe,Object.setPrototypeOf(this,te.prototype)}}e.RemoteAuthorityResolverError=te;var ee;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(ee=e.EndOfLine||(e.EndOfLine={}));var Q;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(Q=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let Y=s=class{static isTextEdit(W){return W instanceof s?!0:W?V.isRange(W)&&typeof W.newText=="string":!1}static replace(W,me){return new s(W,me)}static insert(W,me){return s.replace(new V(W,W),me)}static delete(W){return s.replace(W,"")}static setEndOfLine(W){const me=new s(new V(new de(0,0),new de(0,0)),"");return me.newEol=W,me}get range(){return this.c}set range(W){if(W&&!V.isRange(W))throw(0,A.illegalArgument)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,A.illegalArgument)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,A.illegalArgument)("newEol");this.f=W}constructor(W,me){this.c=W,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};Y=s=qe([O],Y),e.TextEdit=Y;let ie=l=class{static isNotebookCellEdit(W){return W instanceof l?!0:W?xt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,me){return new l(W,me)}static insertCells(W,me){return new l(new xt(W,W),me)}static deleteCells(W){return new l(W,[])}static updateCellMetadata(W,me){const Pe=new l(new xt(W,W),[]);return Pe.newCellMetadata=me,Pe}static updateNotebookMetadata(W){const me=new l(new xt(0,0),[]);return me.newNotebookMetadata=W,me}constructor(W,me){this.range=W,this.newCells=me}};ie=l=qe([O],ie),e.NotebookEdit=ie;class pe{static isSnippetTextEdit(W){return W instanceof pe?!0:W?V.isRange(W.range)&&Oe.isSnippetString(W.snippet):!1}static replace(W,me){return new pe(W,me)}static insert(W,me){return pe.replace(new V(W,W),me)}constructor(W,me){this.range=W,this.snippet=me}}e.SnippetTextEdit=pe;var ve;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(ve=e.FileEditType||(e.FileEditType={}));let ke=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,me,Pe,Ge){this.c.push({_type:1,from:W,to:me,options:Pe,metadata:Ge})}createFile(W,me,Pe){this.c.push({_type:1,from:void 0,to:W,options:me,metadata:Pe})}deleteFile(W,me,Pe){this.c.push({_type:1,from:W,to:void 0,options:me,metadata:Pe})}e(W,me,Pe){this.c.push({_type:3,metadata:Pe,uri:W,edit:{editType:5,metadata:me},notebookMetadata:me})}f(W,me,Pe,Ge){const Ye=me.start,at=me.end;(Ye!==at||Pe.length>0)&&this.c.push({_type:5,uri:W,index:Ye,count:at-Ye,cells:Pe,metadata:Ge})}g(W,me,Pe,Ge){this.c.push({_type:3,metadata:Ge,uri:W,edit:{editType:8,index:me,metadata:Pe}})}replace(W,me,Pe,Ge){this.c.push({_type:2,uri:W,edit:new Y(me,Pe),metadata:Ge})}insert(W,me,Pe,Ge){this.replace(W,new V(me,me),Pe,Ge)}delete(W,me,Pe){this.replace(W,me,"",Pe)}has(W){return this.c.some(me=>me._type===2&&me.uri.toString()===W.toString())}set(W,me){if(me)for(const Pe of me){if(!Pe)continue;let Ge,Ye;Array.isArray(Pe)?(Ge=Pe[0],Ye=Pe[1]):Ge=Pe,ie.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(W,Ge.range.start,Ge.newCellMetadata,Ye):Ge.newNotebookMetadata?this.e(W,Ge.newNotebookMetadata,Ye):this.f(W,Ge.range,Ge.newCells,Ye):pe.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:W,range:Ge.range,edit:Ge.snippet,metadata:Ye}):this.c.push({_type:2,uri:W,edit:Ge,metadata:Ye})}else{for(let Pe=0;Pe<this.c.length;Pe++){const Ge=this.c[Pe];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===W.toString()&&(this.c[Pe]=void 0);break}}(0,c.coalesceInPlace)(this.c)}}get(W){const me=[];for(const Pe of this.c)Pe._type===2&&Pe.uri.toString()===W.toString()&&me.push(Pe.edit);return me}entries(){const W=new R.ResourceMap;for(const me of this.c)if(me._type===2){let Pe=W.get(me.uri);Pe||(Pe=[me.uri,[]],W.set(me.uri,Pe)),Pe[1].push(me.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ke=qe([O],ke),e.WorkspaceEdit=ke;let Oe=r=class{static isSnippetString(W){return W instanceof r?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=r.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,me=this.e++){if(typeof W=="function"){const Pe=new r;Pe.e=this.e,W(Pe),this.e=Pe.e,W=Pe.value}else W=r.c(W);return this.value+="${",this.value+=me,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,me=this.e++){const Pe=W.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable(W,me){if(typeof me=="function"){const Pe=new r;Pe.e=this.e,me(Pe),this.e=Pe.e,me=Pe.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,me&&(this.value+=":",this.value+=me),this.value+="}",this}};Oe=r=qe([O],Oe),e.SnippetString=Oe;var oe;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(oe=e.DiagnosticTag||(e.DiagnosticTag={}));var ae;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(ae=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let fe=m=class{static isLocation(W){return W instanceof m?!0:W?V.isRange(W.range)&&I.URI.isUri(W.uri):!1}constructor(W,me){if(this.uri=W,me)if(V.isRange(me))this.range=V.of(me);else if(de.isPosition(me))this.range=new V(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};fe=m=qe([O],fe),e.Location=fe;let Z=class{static is(W){return W?typeof W.message=="string"&&W.location&&V.isRange(W.location.range)&&I.URI.isUri(W.location.uri):!1}constructor(W,me){this.location=W,this.message=me}static isEqual(W,me){return W===me?!0:!W||!me?!1:W.message===me.message&&W.location.range.isEqual(me.location.range)&&W.location.uri.toString()===me.location.uri.toString()}};Z=qe([O],Z),e.DiagnosticRelatedInformation=Z;let le=class{constructor(W,me,Pe=ae.Error){if(!V.isRange(W))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=W,this.message=me,this.severity=Pe}toJSON(){return{severity:ae[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,me){return W===me?!0:!W||!me?!1:W.message===me.message&&W.severity===me.severity&&W.code===me.code&&W.severity===me.severity&&W.source===me.source&&W.range.isEqual(me.range)&&(0,c.equals)(W.tags,me.tags)&&(0,c.equals)(W.relatedInformation,me.relatedInformation,Z.isEqual)}};le=qe([O],le),e.Diagnostic=le;let re=class{constructor(W,me){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=me}};re=qe([O],re),e.Hover=re;var N;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(N=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let H=class{constructor(W,me=N.Text){this.range=W,this.kind=me}toJSON(){return{range:this.range,kind:N[this.kind]}}};H=qe([O],H),e.DocumentHighlight=H;var K;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(K=e.SymbolKind||(e.SymbolKind={}));var _;(function(G){G[G.Deprecated=1]="Deprecated"})(_=e.SymbolTag||(e.SymbolTag={}));let he=n=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,me,Pe,Ge,Ye){this.name=W,this.kind=me,this.containerName=Ye,typeof Pe=="string"&&(this.containerName=Pe),Ge instanceof fe?this.location=Ge:Pe instanceof V&&(this.location=new fe(Ge,Pe)),n.validate(this)}toJSON(){return{name:this.name,kind:K[this.kind],location:this.location,containerName:this.containerName}}};he=n=qe([O],he),e.SymbolInformation=he;let we=t=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(t.validate)}constructor(W,me,Pe,Ge,Ye){this.name=W,this.detail=me,this.kind=Pe,this.range=Ge,this.selectionRange=Ye,this.children=[],t.validate(this)}};we=t=qe([O],we),e.DocumentSymbol=we;var Ae;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(Ae=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let be=class{constructor(W,me){this.title=W,this.kind=me}};be=qe([O],be),e.CodeAction=be;let Ce=a=class{constructor(W){this.value=W}append(W){return new a(this.value?this.value+a.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+a.c)}};Ce.c=".",Ce=a=qe([O],Ce),e.CodeActionKind=Ce,Ce.Empty=new Ce(""),Ce.QuickFix=Ce.Empty.append("quickfix"),Ce.Refactor=Ce.Empty.append("refactor"),Ce.RefactorExtract=Ce.Refactor.append("extract"),Ce.RefactorInline=Ce.Refactor.append("inline"),Ce.RefactorMove=Ce.Refactor.append("move"),Ce.RefactorRewrite=Ce.Refactor.append("rewrite"),Ce.Source=Ce.Empty.append("source"),Ce.SourceOrganizeImports=Ce.Source.append("organizeImports"),Ce.SourceFixAll=Ce.Source.append("fixAll");let Te=class{constructor(W,me){if(this.range=W,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Te=qe([O],Te),e.SelectionRange=Te;class Ve{constructor(W,me,Pe,Ge,Ye,at){this.kind=W,this.name=me,this.detail=Pe,this.uri=Ge,this.range=Ye,this.selectionRange=at}}e.CallHierarchyItem=Ve;class xe{constructor(W,me){this.fromRanges=me,this.from=W}}e.CallHierarchyIncomingCall=xe;class et{constructor(W,me){this.fromRanges=me,this.to=W}}e.CallHierarchyOutgoingCall=et;var Qe;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(Qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let nt=class{constructor(W,me){this.range=W,this.command=me}get isResolved(){return!!this.command}};nt=qe([O],nt),e.CodeLens=nt;let st=w=class{static isMarkdownString(W){return W instanceof w?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,me=!1){d.set(this,void 0),Je(this,d,new u.MarkdownString(W,{supportThemeIcons:me}),"f")}get value(){return Be(this,d,"f").value}set value(W){Be(this,d,"f").value=W}get isTrusted(){return Be(this,d,"f").isTrusted}set isTrusted(W){Be(this,d,"f").isTrusted=W}get supportThemeIcons(){return Be(this,d,"f").supportThemeIcons}set supportThemeIcons(W){Be(this,d,"f").supportThemeIcons=W}get supportHtml(){return Be(this,d,"f").supportHtml}set supportHtml(W){Be(this,d,"f").supportHtml=W}get baseUri(){return Be(this,d,"f").baseUri}set baseUri(W){Be(this,d,"f").baseUri=W}appendText(W){return Be(this,d,"f").appendText(W),this}appendMarkdown(W){return Be(this,d,"f").appendMarkdown(W),this}appendCodeblock(W,me){return Be(this,d,"f").appendCodeblock(me??"",W),this}};d=new WeakMap,st=w=qe([O],st),e.MarkdownString=st;let ht=class{constructor(W,me){this.label=W,this.documentation=me}};ht=qe([O],ht),e.ParameterInformation=ht;let Ue=class{constructor(W,me){this.label=W,this.documentation=me,this.parameters=[]}};Ue=qe([O],Ue),e.SignatureInformation=Ue;let rt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};rt=qe([O],rt),e.SignatureHelp=rt;var ce;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(ce=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var $;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})($=e.InlayHintKind||(e.InlayHintKind={}));let ue=class{constructor(W){this.value=W}};ue=qe([O],ue),e.InlayHintLabelPart=ue;let Ie=class{constructor(W,me,Pe){this.position=W,this.label=me,this.kind=Pe}};Ie=qe([O],Ie),e.InlayHint=Ie;var Le;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Le=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var $e;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})($e=e.CompletionItemKind||(e.CompletionItemKind={}));var Ke;(function(G){G[G.Deprecated=1]="Deprecated"})(Ke=e.CompletionItemTag||(e.CompletionItemTag={}));let Ze=class{constructor(W,me){this.label=W,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&$e[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ze=qe([O],Ze),e.CompletionItem=Ze;let pt=class{constructor(W=[],me=!1){this.items=W,this.isIncomplete=me}};pt=qe([O],pt),e.CompletionList=pt;let gt=class{constructor(W,me,Pe){this.insertText=W,this.range=me,this.command=Pe}};gt=qe([O],gt),e.InlineSuggestion=gt;let ct=class{constructor(W){this.commands=void 0,this.items=W}};ct=qe([O],ct),e.InlineSuggestionList=ct;var Et;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(Et=e.ViewColumn||(e.ViewColumn={}));var tt;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(tt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ft;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative"})(ft=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var At;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(At=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Kt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Kt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Rt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(Rt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var mt;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(mt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Tt;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(Tt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(G){function W(me){switch(me){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=W}(Rt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let $t=class{constructor(W,me){if(me&&!I.URI.isUri(me))throw(0,A.illegalArgument)("target");if(!V.isRange(W)||W.isEmpty)throw(0,A.illegalArgument)("range");this.range=W,this.target=me}};$t=qe([O],$t),e.DocumentLink=$t;let Nt=class{constructor(W,me,Pe,Ge){this.red=W,this.green=me,this.blue=Pe,this.alpha=Ge}};Nt=qe([O],Nt),e.Color=Nt;let Xe=class{constructor(W,me){if(me&&!(me instanceof Nt))throw(0,A.illegalArgument)("color");if(!V.isRange(W)||W.isEmpty)throw(0,A.illegalArgument)("range");this.range=W,this.color=me}};Xe=qe([O],Xe),e.ColorInformation=Xe;let Mt=class{constructor(W){if(!W||typeof W!="string")throw(0,A.illegalArgument)("label");this.label=W}};Mt=qe([O],Mt),e.ColorPresentation=Mt;var Ut;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(Ut=e.ColorFormat||(e.ColorFormat={}));var Wt;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(Wt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var bt;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(bt=e.TerminalExitReason||(e.TerminalExitReason={}));class Re{constructor(W,me,Pe){if(this.startIndex=W,this.length=me,this.tooltip=Pe,typeof W!="number"||W<0)throw(0,A.illegalArgument)("startIndex");if(typeof me!="number"||me<1)throw(0,A.illegalArgument)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,A.illegalArgument)("tooltip")}}e.TerminalLink=Re;class Ne{constructor(W){this.uri=W}}e.TerminalQuickFixOpener=Ne;class Se{constructor(W){this.terminalCommand=W}}e.TerminalQuickFixCommand=Se;var se;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(se=e.TerminalLocation||(e.TerminalLocation={}));class Fe{constructor(W){if(this.options=W,typeof W!="object")throw(0,A.illegalArgument)("options")}}e.TerminalProfile=Fe;var He;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(He=e.TaskRevealKind||(e.TaskRevealKind={}));var _e;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(_e=e.TaskPanelKind||(e.TaskPanelKind={}));let je=D=class{static from(W){switch(W){case"clean":return D.Clean;case"build":return D.Build;case"rebuild":return D.Rebuild;case"test":return D.Test;default:return}}constructor(W,me){if(this.label=me,typeof W!="string"||typeof me!="string")throw(0,A.illegalArgument)("name");this.c=W}get id(){return this.c}};je.Clean=new D("clean","Clean"),je.Build=new D("build","Build"),je.Rebuild=new D("rebuild","Rebuild"),je.Test=new D("test","Test"),je=D=qe([O],je),e.TaskGroup=je;function it(G){let W="";for(let me=0;me<G.length;me++)W+=G[me].replace(/,/g,",,")+",";return W}let lt=class{constructor(W,me,Pe){if(typeof W!="string")throw(0,A.illegalArgument)("process");this.e=[],this.c=W,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Pe):this.f=me)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,A.illegalArgument)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const me of this.e)W.push(me);return it(W)}};lt=qe([O],lt),e.ProcessExecution=lt;let Pt=class{constructor(W,me,Pe){if(this.f=[],Array.isArray(me)){if(!W)throw(0,A.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,A.illegalArgument)("command");this.e=W,this.f=me,this.g=Pe}else{if(typeof W!="string")throw(0,A.illegalArgument)("commandLine");this.c=W,this.g=me}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,A.illegalArgument)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,A.illegalArgument)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)W.push(typeof me=="string"?me:me.value);return it(W)}};Pt=qe([O],Pt),e.ShellExecution=Pt;var St;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(St=e.ShellQuoting||(e.ShellQuoting={}));var yt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(yt=e.TaskScope||(e.TaskScope={}));class kt{constructor(W){this.c=W}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(W){this.c=W}get callback(){return this.c}}e.CustomExecution=kt;let Dt=F=class{constructor(W,me,Pe,Ge,Ye,at){this.j=!1,this.k=this.definition=W;let dt;typeof me=="string"?(this.m=this.name=me,this.t=this.source=Pe,this.execution=Ge,dt=Ye,this.j=!0):me===yt.Global||me===yt.Workspace?(this.target=me,this.m=this.name=Pe,this.t=this.source=Ge,this.execution=Ye,dt=at):(this.target=me,this.m=this.name=Pe,this.t=this.source=Ge,this.execution=Ye,dt=at),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof lt?this.k={type:F.e,id:this.n.computeId()}:this.n instanceof Pt?this.k={type:F.f,id:this.n.computeId()}:this.n instanceof kt?this.k={type:F.c,id:this.n.computeId()}:this.k={type:F.g,id:(0,L.generateUuid)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,A.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=W}get scope(){return this.l}set target(W){this.y(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,A.illegalArgument)("name");this.y(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.y(),this.n=W;const me=this.k.type;(F.g===me||F.e===me||F.f===me||F.c===me)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.y(),this.o=W,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.y(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,A.illegalArgument)("source must be a string of length > 0");this.y(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.y(),this.u=W}get detail(){return this.x}set detail(W){W===null&&(W=void 0),this.x=W}get presentationOptions(){return this.v}set presentationOptions(W){W==null&&(W=Object.create(null)),this.y(),this.v=W}get runOptions(){return this.w}set runOptions(W){W==null&&(W=Object.create(null)),this.y(),this.w=W}};Dt.c="customExecution",Dt.e="process",Dt.f="shell",Dt.g="$empty",Dt=F=qe([O],Dt),e.Task=Dt;var Ct;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(Ct=e.ProgressLocation||(e.ProgressLocation={}));var qt;(function(G){function W(me){const Pe=me;return(0,S.isNumber)(Pe.value)?Pe.tooltip&&!(0,S.isString)(Pe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Pe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Pe.value),!1)}G.isViewBadge=W})(qt=e.ViewBadge||(e.ViewBadge={}));let Jt=x=class{static isTreeItem(W,me){if(W instanceof x)return!0;const Pe=W;if(Pe.label!==void 0&&!(0,S.isString)(Pe.label)&&!Pe.label?.label)return console.log("INVALID tree item, invalid label",Pe.label),!1;if(Pe.id!==void 0&&!(0,S.isString)(Pe.id))return console.log("INVALID tree item, invalid id",Pe.id),!1;if(Pe.iconPath!==void 0&&!(0,S.isString)(Pe.iconPath)&&!I.URI.isUri(Pe.iconPath)&&(!Pe.iconPath||!(0,S.isString)(Pe.iconPath.id))){const Ge=Pe.iconPath;if(!Ge||!(0,S.isString)(Ge.light)&&!I.URI.isUri(Ge.light)&&!(0,S.isString)(Ge.dark)&&!I.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",Pe.iconPath),!1}if(Pe.description!==void 0&&!(0,S.isString)(Pe.description)&&typeof Pe.description!="boolean")return console.log("INVALID tree item, invalid description",Pe.description),!1;if(Pe.resourceUri!==void 0&&!I.URI.isUri(Pe.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Pe.resourceUri),!1;if(Pe.tooltip!==void 0&&!(0,S.isString)(Pe.tooltip)&&!(Pe.tooltip instanceof st))return console.log("INVALID tree item, invalid tooltip",Pe.tooltip),!1;if(Pe.command!==void 0&&!Pe.command.command)return console.log("INVALID tree item, invalid command",Pe.command),!1;if(Pe.collapsibleState!==void 0&&Pe.collapsibleState<wt.None&&Pe.collapsibleState>wt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Pe.collapsibleState),!1;if(Pe.contextValue!==void 0&&!(0,S.isString)(Pe.contextValue))return console.log("INVALID tree item, invalid contextValue",Pe.contextValue),!1;if(Pe.accessibilityInformation!==void 0&&!Pe.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Pe.accessibilityInformation),!1;if(Pe.checkboxState!==void 0){(0,E.checkProposedApiEnabled)(me,"treeItemCheckbox");const Ge=(0,S.isNumber)(Pe.checkboxState)?Pe.checkboxState:(0,S.isObject)(Pe.checkboxState)&&(0,S.isNumber)(Pe.checkboxState.state)?Pe.checkboxState.state:void 0,Ye=!(0,S.isNumber)(Pe.checkboxState)&&(0,S.isObject)(Pe.checkboxState)?Pe.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==si.Checked&&Ge!==si.Unchecked||Ye!==void 0&&!(0,S.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",Pe.checkboxState),!1}return!0}constructor(W,me=wt.None){this.collapsibleState=me,I.URI.isUri(W)?this.resourceUri=W:this.label=W}};Jt=x=qe([O],Jt),e.TreeItem=Jt;var wt;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(wt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var si;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(si=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let oi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W,me){this.value=W,this.id=me??(0,L.generateUuid)()}};oi=qe([O],oi),e.DataTransferItem=oi;let Zt=class{constructor(W){h.set(this,new Map);for(const[me,Pe]of W??[]){const Ge=Be(this,h,"f").get(me);Ge?Ge.push(Pe):Be(this,h,"f").set(me,[Pe])}}get(W){return Be(this,h,"f").get(W)?.[0]}set(W,me){Be(this,h,"f").set(W,[me])}forEach(W,me){for(const[Pe,Ge]of Be(this,h,"f"))for(const Ye of Ge)W.call(me,Ye,Pe,this)}*[(h=new WeakMap,Symbol.iterator)](){for(const[W,me]of Be(this,h,"f"))for(const Pe of me)yield[W,Pe]}};Zt=qe([O],Zt),e.DataTransfer=Zt;let bi=class{constructor(W){this.insertText=W}};bi=qe([O],bi),e.DocumentDropEdit=bi;let Lt=class{constructor(W){this.insertText=W}};Lt=qe([O],Lt),e.DocumentPasteEdit=Lt;let Ht=class{constructor(W,me){this.id=W,this.color=me}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};Ht=qe([O],Ht),e.ThemeIcon=Ht,Ht.File=new Ht("file"),Ht.Folder=new Ht("folder");let vi=class{constructor(W){this.id=W}};vi=qe([O],vi),e.ThemeColor=vi;var ai;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(ai=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ei=class{get base(){return this.c}set base(W){this.c=W,this.e=I.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,me){if(typeof W!="string"&&(!W||!I.URI.isUri(W)&&!I.URI.isUri(W.uri)))throw(0,A.illegalArgument)("base");if(typeof me!="string")throw(0,A.illegalArgument)("pattern");typeof W=="string"?this.baseUri=I.URI.file(W):I.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ei=qe([O],ei),e.RelativePattern=ei;const ut=new WeakMap;function Bi(G,W){ut.set(G,W)}e.setBreakpointId=Bi;let Bt=class{constructor(W,me,Pe,Ge){this.enabled=typeof W=="boolean"?W:!0,typeof me=="string"&&(this.condition=me),typeof Pe=="string"&&(this.hitCondition=Pe),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=ut.get(this)??(0,L.generateUuid)()),this.c}};Bt=qe([O],Bt),e.Breakpoint=Bt;let Qt=class extends Bt{constructor(W,me,Pe,Ge,Ye){if(super(me,Pe,Ge,Ye),W===null)throw(0,A.illegalArgument)("location");this.location=W}};Qt=qe([O],Qt),e.SourceBreakpoint=Qt;let ci=class extends Bt{constructor(W,me,Pe,Ge,Ye){super(me,Pe,Ge,Ye),this.functionName=W}};ci=qe([O],ci),e.FunctionBreakpoint=ci;let wi=class extends Bt{constructor(W,me,Pe,Ge,Ye,at,dt){if(super(Ge,Ye,at,dt),!me)throw(0,A.illegalArgument)("dataId");this.label=W,this.dataId=me,this.canPersist=Pe}};wi=qe([O],wi),e.DataBreakpoint=wi;let Ei=class{constructor(W,me,Pe){this.command=W,this.args=me||[],this.options=Pe}};Ei=qe([O],Ei),e.DebugAdapterExecutable=Ei;let li=class{constructor(W,me){this.port=W,this.host=me}};li=qe([O],li),e.DebugAdapterServer=li;let Si=class{constructor(W){this.path=W}};Si=qe([O],Si),e.DebugAdapterNamedPipeServer=Si;let ui=class{constructor(W){this.implementation=W}};ui=qe([O],ui),e.DebugAdapterInlineImplementation=ui;let ti=class{constructor(W,me){this.range=W,this.expression=me}};ti=qe([O],ti),e.EvaluatableExpression=ti;var $i;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})($i=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ii=class{constructor(W,me){this.range=W,this.text=me}};ii=qe([O],ii),e.InlineValueText=ii;let ni=class{constructor(W,me,Pe=!0){this.range=W,this.variableName=me,this.caseSensitiveLookup=Pe}};ni=qe([O],ni),e.InlineValueVariableLookup=ni;let yi=class{constructor(W,me){this.range=W,this.expression=me}};yi=qe([O],yi),e.InlineValueEvaluatableExpression=yi;let Di=class{constructor(W,me){this.frameId=W,this.stoppedLocation=me}};Di=qe([O],Di),e.InlineValueContext=Di;var ri;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(ri=e.FileChangeType||(e.FileChangeType={}));let Ci=q=class extends Error{static FileExists(W){return new q(W,k.FileSystemProviderErrorCode.FileExists,q.FileExists)}static FileNotFound(W){return new q(W,k.FileSystemProviderErrorCode.FileNotFound,q.FileNotFound)}static FileNotADirectory(W){return new q(W,k.FileSystemProviderErrorCode.FileNotADirectory,q.FileNotADirectory)}static FileIsADirectory(W){return new q(W,k.FileSystemProviderErrorCode.FileIsADirectory,q.FileIsADirectory)}static NoPermissions(W){return new q(W,k.FileSystemProviderErrorCode.NoPermissions,q.NoPermissions)}static Unavailable(W){return new q(W,k.FileSystemProviderErrorCode.Unavailable,q.Unavailable)}constructor(W,me=k.FileSystemProviderErrorCode.Unknown,Pe){super(I.URI.isUri(W)?W.toString(!0):W),this.code=Pe?.name??"Unknown",(0,k.markAsFileSystemProviderError)(this,me),Object.setPrototypeOf(this,q.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}};Ci=q=qe([O],Ci),e.FileSystemError=Ci;let Ii=class{constructor(W,me,Pe){this.start=W,this.end=me,this.kind=Pe}};Ii=qe([O],Ii),e.FoldingRange=Ii;var zi;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(zi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Wi;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Hi;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(Hi=e.CommentMode||(e.CommentMode={}));var ki;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(ki=e.CommentThreadState||(e.CommentThreadState={}));class Ri{constructor(W,me=[]){this.tokenTypes=W,this.tokenModifiers=me}}e.SemanticTokensLegend=Ri;function Li(G){return typeof G>"u"||(0,S.isStringArray)(G)}class ze{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let me=0,Pe=W.tokenTypes.length;me<Pe;me++)this.j.set(W.tokenTypes[me],me);for(let me=0,Pe=W.tokenModifiers.length;me<Pe;me++)this.k.set(W.tokenModifiers[me],me)}}push(W,me,Pe,Ge,Ye){if(typeof W=="number"&&typeof me=="number"&&typeof Pe=="number"&&typeof Ge=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(W,me,Pe,Ge,Ye);if(V.isRange(W)&&typeof me=="string"&&Li(Pe))return this.m(W,me,Pe);throw(0,A.illegalArgument)()}m(W,me,Pe){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(me))throw new Error("`tokenType` is not in the provided legend");const Ge=W.start.line,Ye=W.start.character,at=W.end.character-W.start.character,dt=this.j.get(me);let Ft=0;if(Pe)for(const Vt of Pe){if(!this.k.has(Vt))throw new Error("`tokenModifier` is not in the provided legend");const Gt=this.k.get(Vt);Ft|=1<<Gt>>>0}this.n(Ge,Ye,at,dt,Ft)}n(W,me,Pe,Ge,Ye){if(this.f&&(W<this.c||W===this.c&&me<this.e)){this.f=!1;const Ft=this.g.length/5|0;let Vt=0,Gt=0;for(let Xt=0;Xt<Ft;Xt++){let _t=this.g[5*Xt],Pi=this.g[5*Xt+1];_t===0?(_t=Vt,Pi+=Gt):_t+=Vt,this.g[5*Xt]=_t,this.g[5*Xt+1]=Pi,Vt=_t,Gt=Pi}}let at=W,dt=me;this.f&&this.h>0&&(at-=this.c,at===0&&(dt-=this.e)),this.g[this.h++]=at,this.g[this.h++]=dt,this.g[this.h++]=Pe,this.g[this.h++]=Ge,this.g[this.h++]=Ye,this.c=W,this.e=me}static o(W){const me=[],Pe=W.length/5|0;for(let dt=0;dt<Pe;dt++)me[dt]=dt;me.sort((dt,Ft)=>{const Vt=W[5*dt],Gt=W[5*Ft];if(Vt===Gt){const Xt=W[5*dt+1],_t=W[5*Ft+1];return Xt-_t}return Vt-Gt});const Ge=new Uint32Array(W.length);let Ye=0,at=0;for(let dt=0;dt<Pe;dt++){const Ft=5*me[dt],Vt=W[Ft+0],Gt=W[Ft+1],Xt=W[Ft+2],_t=W[Ft+3],Pi=W[Ft+4],sn=Vt-Ye,Rn=sn===0?Gt-at:Gt,Ai=5*dt;Ge[Ai+0]=sn,Ge[Ai+1]=Rn,Ge[Ai+2]=Xt,Ge[Ai+3]=_t,Ge[Ai+4]=Pi,Ye=Vt,at=Gt}return Ge}build(W){return this.f?new jt(new Uint32Array(this.g),W):new jt(ze.o(this.g),W)}}e.SemanticTokensBuilder=ze;class jt{constructor(W,me){this.resultId=me,this.data=W}}e.SemanticTokens=jt;class Oi{constructor(W,me,Pe){this.start=W,this.deleteCount=me,this.data=Pe}}e.SemanticTokensEdit=Oi;class vt{constructor(W,me){this.resultId=me,this.edits=W}}e.SemanticTokensEdits=vt;var ji;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(ji=e.DebugConsoleMode||(e.DebugConsoleMode={}));let di=class{constructor(){}};di.Back={iconPath:new Ht("arrow-left")},di=qe([O],di),e.QuickInputButtons=di;var Ni;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Ni=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Vi;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(Vi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var hi;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(hi=e.ExtensionKind||(e.ExtensionKind={}));class qi{static validate(W){if(typeof W.badge=="string"){let me=(0,P.nextCharLength)(W.badge,0);if(me<W.badge.length&&(me+=(0,P.nextCharLength)(W.badge,me)),W.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Ht.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,me,Pe){this.badge=W,this.tooltip=me,this.color=Pe}}e.FileDecoration=qi;let Ti=class{constructor(W){this.kind=W}};Ti=qe([O],Ti),e.ColorTheme=Ti;var xi;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(xi=e.ColorThemeKind||(e.ColorThemeKind={}));class xt{static isNotebookRange(W){return W instanceof xt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,me){if(W<0)throw(0,A.illegalArgument)("start must be positive");if(me<0)throw(0,A.illegalArgument)("end must be positive");W<=me?(this.c=W,this.e=me):(this.c=me,this.e=W)}with(W){let me=this.c,Pe=this.e;return W.start!==void 0&&(me=W.start),W.end!==void 0&&(Pe=W.end),me===this.c&&Pe===this.e?this:new xt(me,Pe)}}e.NotebookRange=xt;class fi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(me=>fi.isNotebookCellData(me))}static isNotebookCellData(W){return!0}constructor(W,me,Pe,Ge,Ye,at,dt){this.kind=W,this.value=me,this.languageId=Pe,this.mime=Ge,this.outputs=Ye??[],this.metadata=at,this.executionSummary=dt,fi.validate(this)}}e.NotebookCellData=fi;class Gi{constructor(W){this.cells=W}}e.NotebookData=Gi;class zt{static isNotebookCellOutputItem(W){return W instanceof zt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const me={name:W.name,message:W.message,stack:W.stack};return zt.json(me,"application/vnd.code.notebook.error")}static stdout(W){return zt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return zt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,me="application/octet-stream"){return new zt(W,me)}static text(W,me=C.Mimes.text){const Pe=Be(zt,g,"f",p).encode(String(W));return new zt(Pe,me)}static json(W,me="text/x-json"){const Pe=JSON.stringify(W,void 0,"	");return zt.text(Pe,me)}constructor(W,me){this.data=W,this.mime=me;const Pe=(0,C.normalizeMimeType)(me,!0);if(!Pe)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}}g=zt,p={value:new TextEncoder},e.NotebookCellOutputItem=zt;class mi{static isNotebookCellOutput(W){return W instanceof mi?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,me=!1){const Pe=new Set,Ge=new Set;for(let Ye=0;Ye<W.length;Ye++){const at=W[Ye],dt=(0,C.normalizeMimeType)(at.mime);if(!Pe.has(dt)||(0,T.isTextStreamMime)(dt)){Pe.add(dt);continue}Ge.add(Ye),me&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?W:W.filter((Ye,at)=>!Ge.has(at))}constructor(W,me,Pe){this.items=mi.ensureUniqueMimeTypes(W,!0),typeof me=="string"?(this.id=me,this.metadata=Pe):(this.id=(0,L.generateUuid)(),this.metadata=me??Pe)}}e.NotebookCellOutput=mi;var Ki;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(Ki=e.NotebookCellKind||(e.NotebookCellKind={}));var Xi;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(Xi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ge;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(ge=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ee;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Ee=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Me{constructor(W,me){this.text=W,this.alignment=me}}e.NotebookCellStatusBarItem=Me;var ot;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(ot=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var It;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(It=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Ot{constructor(W,me=[]){this.uri=W,this.provides=(0,c.asArray)(me)}}e.NotebookRendererScript=Ot;class ln{constructor(W){this.label=W}}e.NotebookKernelSourceAction=ln;let Qi=class{constructor(W,me){this.label=W,this.timestamp=me}};Qi=qe([O],Qi),e.TimelineItem=Qi;var un;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(un=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(W,me){this.ranges=W,this.wordPattern=me}}e.LinkedEditingRanges=fn;class mn{constructor(W,me){this.c=W,this.e=me}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=mn;var gn;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(gn=e.TestResultState||(e.TestResultState={}));var pn;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(pn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Fi=class{constructor(W=void 0,me=void 0,Pe=void 0){this.include=W,this.exclude=me,this.profile=Pe}};Fi=qe([O],Fi),e.TestRunRequest=Fi;let _i=class extends Fi{constructor(W=void 0,me=void 0,Pe=void 0,Ge=!1){super(W,me,Pe),this.continuous=Ge}};_i=qe([O],_i),e.TestRunRequest2=_i;let Yi=M=class{static diff(W,me,Pe){const Ge=new M(W);return Ge.expectedOutput=me,Ge.actualOutput=Pe,Ge}constructor(W){this.message=W}};Yi=M=qe([O],Yi),e.TestMessage=Yi;let Ji=class{constructor(W){this.id=W}};Ji=qe([O],Ji),e.TestTag=Ji;let gi=class{constructor(W,me){this.covered=W,this.total=me}};gi=qe([O],gi),e.CoveredCount=gi;let Zi=B=class{static fromDetails(W,me){const Pe=new gi(0,0),Ge=new gi(0,0),Ye=new gi(0,0);for(const dt of me)if("branches"in dt){Pe.total+=1,Pe.covered+=dt.executionCount>0?1:0;for(const Ft of dt.branches)Ge.total+=1,Ge.covered+=Ft.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=dt.executionCount>0?1:0;const at=new B(W,Pe,Ge.total>0?Ge:void 0,Ye.total>0?Ye:void 0);return at.detailedCoverage=me,at}constructor(W,me,Pe,Ge){this.uri=W,this.statementCoverage=me,this.branchCoverage=Pe,this.functionCoverage=Ge}};Zi=B=qe([O],Zi),e.FileCoverage=Zi;let en=class{constructor(W,me,Pe=[]){this.executionCount=W,this.location=me,this.branches=Pe}};en=qe([O],en),e.StatementCoverage=en;let tn=class{constructor(W,me){this.executionCount=W,this.location=me}};tn=qe([O],tn),e.BranchCoverage=tn;let nn=class{constructor(W,me){this.executionCount=W,this.location=me}};nn=qe([O],nn),e.FunctionCoverage=nn;var bn;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(bn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var vn;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(vn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var wn;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(wn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class En{constructor(W,me,Pe,Ge,Ye,at){this.kind=W,this.name=me,this.detail=Pe,this.uri=Ge,this.range=Ye,this.selectionRange=at}}e.TypeHierarchyItem=En;class Sn{constructor(W){this.uri=W}}e.TextTabInput=Sn;class yn{constructor(W,me){this.original=W,this.modified=me}}e.TextDiffTabInput=yn;class Dn{constructor(W,me,Pe,Ge){this.base=W,this.input1=me,this.input2=Pe,this.result=Ge}}e.TextMergeTabInput=Dn;class Cn{constructor(W,me){this.uri=W,this.viewType=me}}e.CustomEditorTabInput=Cn;class In{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=In;class kn{constructor(W,me){this.uri=W,this.notebookType=me}}e.NotebookEditorTabInput=kn;class Tn{constructor(W,me,Pe){this.original=W,this.modified=me,this.notebookType=Pe}}e.NotebookDiffEditorTabInput=Tn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class An{constructor(W,me){this.uri=W,this.inputBoxUri=me}}e.InteractiveWindowInput=An}),define(ye[135],De([1,0,50,18,8,165,106,7,15]),function(ne,e,c,A,u,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const I=new Map;function L(E,f){f?I.set(E,f):I.delete(E)}e.setWordDefinitionFor=L;function k(E){return I.get(E)}class v extends R.MirrorTextModel{constructor(f,d,h,g,p,y,b,i){super(d,h,g,p),this.m=f,this.p=y,this.q=b,this.notebook=i,this.b=!1}dispose(){(0,c.ok)(!this.b),this.b=!0,this.q=!1}equalLines(f){return(0,S.equals)(this.d,f)}get document(){if(!this.a){const f=this;this.a={get uri(){return f.c},get fileName(){return f.c.fsPath},get isUntitled(){return f.c.scheme===A.Schemas.untitled},get languageId(){return f.p},get version(){return f.g},get isClosed(){return f.b},get isDirty(){return f.q},save(){return f.r()},getText(d){return d?f.s(d):f.getText()},get eol(){return f.f===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return f.d.length},lineAt(d){return f.t(d)},offsetAt(d){return f.u(d)},positionAt(d){return f.v(d)},validateRange(d){return f.w(d)},validatePosition(d){return f.x(d)},getWordRangeAtPosition(d,h){return f.y(d,h)}}}return Object.freeze(this.a)}_acceptLanguageId(f){(0,c.ok)(!this.b),this.p=f}_acceptIsDirty(f){(0,c.ok)(!this.b),this.q=f}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(f){const d=this.w(f);if(d.isEmpty)return"";if(d.isSingleLine)return this.d[d.start.line].substring(d.start.character,d.end.character);const h=this.f,g=d.start.line,p=d.end.line,y=[];y.push(this.d[g].substring(d.start.character));for(let b=g+1;b<p;b++)y.push(this.d[b]);return y.push(this.d[p].substring(0,d.end.character)),y.join(h)}t(f){let d;if(f instanceof P.Position?d=f.line:typeof f=="number"&&(d=f),typeof d!="number"||d<0||d>=this.d.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new T(d,this.d[d],d===this.d.length-1)}u(f){return f=this.x(f),this.k(),this.h.getPrefixSum(f.line-1)+f.character}v(f){f=Math.floor(f),f=Math.max(0,f),this.k();const d=this.h.getIndexOf(f),h=this.d[d.index].length;return new P.Position(d.index,Math.min(d.remainder,h))}w(f){if(!(f instanceof P.Range))throw new Error("Invalid argument");const d=this.x(f.start),h=this.x(f.end);return d===f.start&&h===f.end?f:new P.Range(d.line,d.character,h.line,h.character)}x(f){if(!(f instanceof P.Position))throw new Error("Invalid argument");if(this.d.length===0)return f.with(0,0);let{line:d,character:h}=f,g=!1;if(d<0)d=0,h=0,g=!0;else if(d>=this.d.length)d=this.d.length-1,h=this.d[d].length,g=!0;else{const p=this.d[d].length;h<0?(h=0,g=!0):h>p&&(h=p,g=!0)}return g?new P.Position(d,h):f}y(f,d){const h=this.x(f);if(!d)d=k(this.p);else if((0,u.regExpLeadsToEndlessLoop)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const g=(0,C.getWordAtText)(h.character+1,(0,C.ensureValidWordDefinition)(d),this.d[h.line],0);if(g)return new P.Range(h.line,g.startColumn-1,h.line,g.endColumn-1)}}e.ExtHostDocumentData=v;class T{constructor(f,d,h){this.a=f,this.b=d,this.c=h}get lineNumber(){return this.a}get text(){return this.b}get range(){return new P.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new P.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=T}),define(ye[239],De([1,0,7,20,3]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let R=class{constructor(P){this.a=new c.ColorTheme(c.ColorThemeKind.Dark),this.b=new u.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(P){let S;switch(P){case"light":S=c.ColorThemeKind.Light;break;case"hcDark":S=c.ColorThemeKind.HighContrast;break;case"hcLight":S=c.ColorThemeKind.HighContrastLight;break;default:S=c.ColorThemeKind.Dark}this.a=new c.ColorTheme(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};R=qe([We(0,A.IExtHostRpcService)],R),e.ExtHostTheming=R}),define(ye[14],De([1,0,15,22,149,63,112,28,147,69,86,23,9,2,32,71,124,132,130,92,57,75,235,7]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,f,d,h,g,p,y,b,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(Re){function Ne(se){const{selectionStartLineNumber:Fe,selectionStartColumn:He,positionLineNumber:_e,positionColumn:je}=se,it=new o.Position(Fe-1,He-1),lt=new o.Position(_e-1,je-1);return new o.Selection(it,lt)}Re.to=Ne;function Se(se){const{anchor:Fe,active:He}=se;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Re.from=Se})(s=e.Selection||(e.Selection={}));var l;(function(Re){function Ne(se){if(!se)return;const{start:Fe,end:He}=se;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Re.from=Ne;function Se(se){if(!se)return;const{startLineNumber:Fe,startColumn:He,endLineNumber:_e,endColumn:je}=se;return new o.Range(Fe-1,He-1,_e-1,je-1)}Re.to=Se})(l=e.Range||(e.Range={}));var r;(function(Re){function Ne(Se){switch(Se){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}Re.to=Ne})(r=e.TokenType||(e.TokenType={}));var m;(function(Re){function Ne(se){return new o.Position(se.lineNumber-1,se.column-1)}Re.to=Ne;function Se(se){return{lineNumber:se.line+1,column:se.character+1}}Re.from=Se})(m=e.Position||(e.Position={}));var n;(function(Re){function Ne(Fe,He){return(0,c.coalesce)((0,c.asArray)(Fe).map(_e=>Se(_e,He)))}Re.from=Ne;function Se(Fe,He){if(typeof Fe=="string")return{$serialized:!0,language:Fe};if(Fe)return{$serialized:!0,language:Fe.language,scheme:se(Fe.scheme,He),pattern:$.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType}}function se(Fe,He){return He&&typeof Fe=="string"?He.transformOutgoingScheme(Fe):Fe}})(n=e.DocumentSelector||(e.DocumentSelector={}));var t;(function(Re){function Ne(se){switch(se){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}Re.from=Ne;function Se(se){switch(se){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}Re.to=Se})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var a;(function(Re){function Ne(se){let Fe;return se.code&&((0,v.isString)(se.code)||(0,v.isNumber)(se.code)?Fe=String(se.code):Fe={value:String(se.code.value),target:se.code.target}),{...l.from(se.range),message:se.message,source:se.source,code:Fe,severity:D.from(se.severity),relatedInformation:se.relatedInformation&&se.relatedInformation.map(w.from),tags:Array.isArray(se.tags)?(0,c.coalesce)(se.tags.map(t.from)):void 0}}Re.from=Ne;function Se(se){const Fe=new o.Diagnostic(l.to(se),se.message,D.to(se.severity));return Fe.source=se.source,Fe.code=(0,v.isString)(se.code)?se.code:se.code?.value,Fe.relatedInformation=se.relatedInformation&&se.relatedInformation.map(w.to),Fe.tags=se.tags&&(0,c.coalesce)(se.tags.map(t.to)),Fe}Re.to=Se})(a=e.Diagnostic||(e.Diagnostic={}));var w;(function(Re){function Ne(se){return{...l.from(se.location.range),message:se.message,resource:se.location.uri}}Re.from=Ne;function Se(se){return new o.DiagnosticRelatedInformation(new o.Location(se.resource,l.to(se)),se.message)}Re.to=Se})(w=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var D;(function(Re){function Ne(se){switch(se){case o.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}Re.from=Ne;function Se(se){switch(se){case d.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}Re.to=Se})(D=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var F;(function(Re){function Ne(se){return typeof se=="number"&&se>=o.ViewColumn.One?se-1:se===o.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}Re.from=Ne;function Se(se){if(typeof se=="number"&&se>=0)return se+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=Se})(F=e.ViewColumn||(e.ViewColumn={}));function x(Re){return typeof Re.range<"u"}function q(Re){return Re.length===0?!0:!!x(Re[0])}e.isDecorationOptionsArr=q;var M;(function(Re){function Ne(je){return je.map(Re.from)}Re.fromMany=Ne;function Se(je){return je&&typeof je=="object"&&typeof je.language=="string"&&typeof je.value=="string"}function se(je){let it;if(Se(je)){const{language:yt,value:kt}=je;it={value:"```"+yt+`
`+kt+"\n```\n"}}else o.MarkdownString.isMarkdownString(je)?it={value:je.value,isTrusted:je.isTrusted,supportThemeIcons:je.supportThemeIcons,supportHtml:je.supportHtml,baseUri:je.baseUri}:typeof je=="string"?it={value:je}:it={value:""};const lt=Object.create(null);it.uris=lt;const Pt=yt=>{try{let kt=T.URI.parse(yt,!0);kt=kt.with({query:Fe(kt.query,lt)}),lt[yt]=kt}catch{}return""},St=new S.marked.Renderer;return St.link=Pt,St.image=yt=>typeof yt=="string"?Pt(C.parseHrefAndDimensions(yt).href):"",(0,S.marked)(it.value,{renderer:St}),it}Re.from=se;function Fe(je,it){if(!je)return je;let lt;try{lt=(0,I.parse)(je)}catch{}if(!lt)return je;let Pt=!1;return lt=(0,k.cloneAndChange)(lt,St=>{if(T.URI.isUri(St)){const yt=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[yt]=St,Pt=!0,yt}else return}),Pt?JSON.stringify(lt):je}function He(je){const it=new o.MarkdownString(je.value,je.supportThemeIcons);return it.isTrusted=je.isTrusted,it.supportHtml=je.supportHtml,it.baseUri=je.baseUri?T.URI.from(je.baseUri):void 0,it}Re.to=He;function _e(je){if(!!je)return typeof je=="string"?je:Re.from(je)}Re.fromStrict=_e})(M=e.MarkdownString||(e.MarkdownString={}));function B(Re){return q(Re)?Re.map(Ne=>({range:l.from(Ne.range),hoverMessage:Array.isArray(Ne.hoverMessage)?M.fromMany(Ne.hoverMessage):Ne.hoverMessage?M.from(Ne.hoverMessage):void 0,renderOptions:Ne.renderOptions})):Re.map(Ne=>({range:l.from(Ne)}))}e.fromRangeOrRangeWithMessage=B;function O(Re){return typeof Re>"u"?Re:typeof Re=="string"?T.URI.file(Re):Re}e.pathOrURIToURI=O;var U;(function(Re){function Ne(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?O(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Re.from=Ne})(U=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var z;(function(Re){function Ne(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?O(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?U.from(Se.before):void 0,after:Se.after?U.from(Se.after):void 0}}Re.from=Ne})(z=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var j;(function(Re){function Ne(Se){if(typeof Se>"u")return Se;switch(Se){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=Ne})(j=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var de;(function(Re){function Ne(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?j.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?z.from(Se.light):void 0,dark:Se.dark?z.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?O(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?U.from(Se.before):void 0,after:Se.after?U.from(Se.after):void 0}}Re.from=Ne})(de=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var V;(function(Re){function Ne(se){return{text:se.newText,eol:se.newEol&&st.from(se.newEol),range:l.from(se.range)}}Re.from=Ne;function Se(se){const Fe=new o.TextEdit(l.to(se.range),se.text);return Fe.newEol=typeof se.eol>"u"?void 0:st.to(se.eol),Fe}Re.to=Se})(V=e.TextEdit||(e.TextEdit={}));var X;(function(Re){function Ne(se,Fe){const He={edits:[]};if(se instanceof o.WorkspaceEdit){const _e=new P.ResourceSet;for(const je of se._allEntries())je._type===1&&T.URI.isUri(je.to)&&je.from===void 0&&_e.add(je.to);for(const je of se._allEntries())je._type===1?He.edits.push({oldResource:je.from,newResource:je.to,options:{...je.options,contentsBase64:je.options?.contents&&(0,A.encodeBase64)(A.VSBuffer.wrap(je.options.contents))},metadata:je.metadata}):je._type===2?He.edits.push({resource:je.uri,textEdit:V.from(je.edit),versionId:_e.has(je.uri)?void 0:Fe?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===6?He.edits.push({resource:je.uri,textEdit:{range:l.from(je.range),text:je.edit.value,insertAsSnippet:!0},versionId:_e.has(je.uri)?void 0:Fe?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===3?He.edits.push({metadata:je.metadata,resource:je.uri,cellEdit:je.edit,notebookMetadata:je.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(je.uri)}):je._type===5&&He.edits.push({metadata:je.metadata,resource:je.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(je.uri),cellEdit:{editType:1,index:je.index,count:je.count,cells:je.cells.map(pt.from)}})}return He}Re.from=Ne;function Se(se){const Fe=new o.WorkspaceEdit;for(const He of se.edits)He.textEdit?Fe.replace(T.URI.revive(He.resource),l.to(He.textEdit.range),He.textEdit.text):Fe.renameFile(T.URI.revive(He.oldResource),T.URI.revive(He.newResource),He.options);return Fe}Re.to=Se})(X=e.WorkspaceEdit||(e.WorkspaceEdit={}));var J;(function(Re){const Ne=Object.create(null);Ne[o.SymbolKind.File]=0,Ne[o.SymbolKind.Module]=1,Ne[o.SymbolKind.Namespace]=2,Ne[o.SymbolKind.Package]=3,Ne[o.SymbolKind.Class]=4,Ne[o.SymbolKind.Method]=5,Ne[o.SymbolKind.Property]=6,Ne[o.SymbolKind.Field]=7,Ne[o.SymbolKind.Constructor]=8,Ne[o.SymbolKind.Enum]=9,Ne[o.SymbolKind.Interface]=10,Ne[o.SymbolKind.Function]=11,Ne[o.SymbolKind.Variable]=12,Ne[o.SymbolKind.Constant]=13,Ne[o.SymbolKind.String]=14,Ne[o.SymbolKind.Number]=15,Ne[o.SymbolKind.Boolean]=16,Ne[o.SymbolKind.Array]=17,Ne[o.SymbolKind.Object]=18,Ne[o.SymbolKind.Key]=19,Ne[o.SymbolKind.Null]=20,Ne[o.SymbolKind.EnumMember]=21,Ne[o.SymbolKind.Struct]=22,Ne[o.SymbolKind.Event]=23,Ne[o.SymbolKind.Operator]=24,Ne[o.SymbolKind.TypeParameter]=25;function Se(Fe){return typeof Ne[Fe]=="number"?Ne[Fe]:6}Re.from=Se;function se(Fe){for(const He in Ne)if(Ne[He]===Fe)return Number(He);return o.SymbolKind.Property}Re.to=se})(J=e.SymbolKind||(e.SymbolKind={}));var te;(function(Re){function Ne(se){switch(se){case o.SymbolTag.Deprecated:return 1}}Re.from=Ne;function Se(se){switch(se){case 1:return o.SymbolTag.Deprecated}}Re.to=Se})(te=e.SymbolTag||(e.SymbolTag={}));var ee;(function(Re){function Ne(se){return{name:se.name,kind:J.from(se.kind),tags:se.tags&&se.tags.map(te.from),containerName:se.containerName,location:ve.from(se.location)}}Re.from=Ne;function Se(se){const Fe=new o.SymbolInformation(se.name,J.to(se.kind),se.containerName,ve.to(se.location));return Fe.tags=se.tags&&se.tags.map(te.to),Fe}Re.to=Se})(ee=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Q;(function(Re){function Ne(se){const Fe={name:se.name||"!!MISSING: name!!",detail:se.detail,range:l.from(se.range),selectionRange:l.from(se.selectionRange),kind:J.from(se.kind),tags:se.tags?.map(te.from)??[]};return se.children&&(Fe.children=se.children.map(Ne)),Fe}Re.from=Ne;function Se(se){const Fe=new o.DocumentSymbol(se.name,se.detail,J.to(se.kind),l.to(se.range),l.to(se.selectionRange));return(0,c.isNonEmptyArray)(se.tags)&&(Fe.tags=se.tags.map(te.to)),se.children&&(Fe.children=se.children.map(Se)),Fe}Re.to=Se})(Q=e.DocumentSymbol||(e.DocumentSymbol={}));var Y;(function(Re){function Ne(se){const Fe=new o.CallHierarchyItem(J.to(se.kind),se.name,se.detail||"",T.URI.revive(se.uri),l.to(se.range),l.to(se.selectionRange));return Fe._sessionId=se._sessionId,Fe._itemId=se._itemId,Fe}Re.to=Ne;function Se(se,Fe,He){if(Fe=Fe??se._sessionId,He=He??se._itemId,Fe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:He,name:se.name,detail:se.detail,kind:J.from(se.kind),uri:se.uri,range:l.from(se.range),selectionRange:l.from(se.selectionRange),tags:se.tags?.map(te.from)}}Re.from=Se})(Y=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ie;(function(Re){function Ne(Se){return new o.CallHierarchyIncomingCall(Y.to(Se.from),Se.fromRanges.map(se=>l.to(se)))}Re.to=Ne})(ie=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var pe;(function(Re){function Ne(Se){return new o.CallHierarchyOutgoingCall(Y.to(Se.to),Se.fromRanges.map(se=>l.to(se)))}Re.to=Ne})(pe=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ve;(function(Re){function Ne(se){return{range:se.range&&l.from(se.range),uri:se.uri}}Re.from=Ne;function Se(se){return new o.Location(T.URI.revive(se.uri),l.to(se.range))}Re.to=Se})(ve=e.location||(e.location={}));var ke;(function(Re){function Ne(se){const Fe=se,He=se;return{originSelectionRange:Fe.originSelectionRange?l.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:He.uri,range:l.from(Fe.targetRange?Fe.targetRange:He.range),targetSelectionRange:Fe.targetSelectionRange?l.from(Fe.targetSelectionRange):void 0}}Re.from=Ne;function Se(se){return{targetUri:T.URI.revive(se.uri),targetRange:l.to(se.range),targetSelectionRange:se.targetSelectionRange?l.to(se.targetSelectionRange):void 0,originSelectionRange:se.originSelectionRange?l.to(se.originSelectionRange):void 0}}Re.to=Se})(ke=e.DefinitionLink||(e.DefinitionLink={}));var Oe;(function(Re){function Ne(se){return{range:l.from(se.range),contents:M.fromMany(se.contents)}}Re.from=Ne;function Se(se){return new o.Hover(se.contents.map(M.to),l.to(se.range))}Re.to=Se})(Oe=e.Hover||(e.Hover={}));var oe;(function(Re){function Ne(se){return{range:l.from(se.range),expression:se.expression}}Re.from=Ne;function Se(se){return new o.EvaluatableExpression(l.to(se.range),se.expression)}Re.to=Se})(oe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ae;(function(Re){function Ne(se){if(se instanceof o.InlineValueText)return{type:"text",range:l.from(se.range),text:se.text};if(se instanceof o.InlineValueVariableLookup)return{type:"variable",range:l.from(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};if(se instanceof o.InlineValueEvaluatableExpression)return{type:"expression",range:l.from(se.range),expression:se.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Ne;function Se(se){switch(se.type){case"text":return{range:l.to(se.range),text:se.text};case"variable":return{range:l.to(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};case"expression":return{range:l.to(se.range),expression:se.expression}}}Re.to=Se})(ae=e.InlineValue||(e.InlineValue={}));var fe;(function(Re){function Ne(se){return{frameId:se.frameId,stoppedLocation:l.from(se.stoppedLocation)}}Re.from=Ne;function Se(se){return new o.InlineValueContext(se.frameId,l.to(se.stoppedLocation))}Re.to=Se})(fe=e.InlineValueContext||(e.InlineValueContext={}));var Z;(function(Re){function Ne(se){return{range:l.from(se.range),kind:se.kind}}Re.from=Ne;function Se(se){return new o.DocumentHighlight(l.to(se.range),se.kind)}Re.to=Se})(Z=e.DocumentHighlight||(e.DocumentHighlight={}));var le;(function(Re){function Ne(Se){switch(Se){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}Re.to=Ne})(le=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var re;(function(Re){function Ne(Se){return{triggerKind:le.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Re.to=Ne})(re=e.CompletionContext||(e.CompletionContext={}));var N;(function(Re){function Ne(se){switch(se){case o.CompletionItemTag.Deprecated:return 1}}Re.from=Ne;function Se(se){switch(se){case 1:return o.CompletionItemTag.Deprecated}}Re.to=Se})(N=e.CompletionItemTag||(e.CompletionItemTag={}));var H;(function(Re){const Ne=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function Se(He){return Ne.get(He)??9}Re.from=Se;const se=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Fe(He){return se.get(He)??o.CompletionItemKind.Property}Re.to=Fe})(H=e.CompletionItemKind||(e.CompletionItemKind={}));var K;(function(Re){function Ne(Se,se){const Fe=new o.CompletionItem(Se.label);return Fe.insertText=Se.insertText,Fe.kind=H.to(Se.kind),Fe.tags=Se.tags?.map(N.to),Fe.detail=Se.detail,Fe.documentation=C.isMarkdownString(Se.documentation)?M.to(Se.documentation):Se.documentation,Fe.sortText=Se.sortText,Fe.filterText=Se.filterText,Fe.preselect=Se.preselect,Fe.commitCharacters=Se.commitCharacters,E.Range.isIRange(Se.range)?Fe.range=l.to(Se.range):typeof Se.range=="object"&&(Fe.range={inserting:l.to(Se.range.insert),replacing:l.to(Se.range.replace)}),Fe.keepWhitespace=typeof Se.insertTextRules>"u"?!1:Boolean(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Fe.insertText=new o.SnippetString(Se.insertText):(Fe.insertText=Se.insertText,Fe.textEdit=Fe.range instanceof o.Range?new o.TextEdit(Fe.range,Fe.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Se.additionalTextEdits.map(He=>V.to(He))),Fe.command=se&&Se.command?se.fromInternal(Se.command):void 0,Fe}Re.to=Ne})(K=e.CompletionItem||(e.CompletionItem={}));var _;(function(Re){function Ne(se){if(typeof se.label!="string"&&!Array.isArray(se.label))throw new TypeError("Invalid label");return{label:se.label,documentation:M.fromStrict(se.documentation)}}Re.from=Ne;function Se(se){return{label:se.label,documentation:C.isMarkdownString(se.documentation)?M.to(se.documentation):se.documentation}}Re.to=Se})(_=e.ParameterInformation||(e.ParameterInformation={}));var he;(function(Re){function Ne(se){return{label:se.label,documentation:M.fromStrict(se.documentation),parameters:Array.isArray(se.parameters)?se.parameters.map(_.from):[],activeParameter:se.activeParameter}}Re.from=Ne;function Se(se){return{label:se.label,documentation:C.isMarkdownString(se.documentation)?M.to(se.documentation):se.documentation,parameters:Array.isArray(se.parameters)?se.parameters.map(_.to):[],activeParameter:se.activeParameter}}Re.to=Se})(he=e.SignatureInformation||(e.SignatureInformation={}));var we;(function(Re){function Ne(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(he.from):[]}}Re.from=Ne;function Se(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(he.to):[]}}Re.to=Se})(we=e.SignatureHelp||(e.SignatureHelp={}));var Ae;(function(Re){function Ne(Se,se){const Fe=new o.InlayHint(m.to(se.position),typeof se.label=="string"?se.label:se.label.map(be.to.bind(void 0,Se)),se.kind&&Ce.to(se.kind));return Fe.textEdits=se.textEdits&&se.textEdits.map(V.to),Fe.tooltip=C.isMarkdownString(se.tooltip)?M.to(se.tooltip):se.tooltip,Fe.paddingLeft=se.paddingLeft,Fe.paddingRight=se.paddingRight,Fe}Re.to=Ne})(Ae=e.InlayHint||(e.InlayHint={}));var be;(function(Re){function Ne(Se,se){const Fe=new o.InlayHintLabelPart(se.label);return Fe.tooltip=C.isMarkdownString(se.tooltip)?M.to(se.tooltip):se.tooltip,f.Command.is(se.command)&&(Fe.command=Se.fromInternal(se.command)),se.location&&(Fe.location=ve.to(se.location)),Fe}Re.to=Ne})(be=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ce;(function(Re){function Ne(se){return se}Re.from=Ne;function Se(se){return se}Re.to=Se})(Ce=e.InlayHintKind||(e.InlayHintKind={}));var Te;(function(Re){function Ne(se){return{range:l.from(se.range),url:se.target,tooltip:se.tooltip}}Re.from=Ne;function Se(se){let Fe;if(se.url)try{Fe=typeof se.url=="string"?T.URI.parse(se.url,!0):T.URI.revive(se.url)}catch{}return new o.DocumentLink(l.to(se.range),Fe)}Re.to=Se})(Te=e.DocumentLink||(e.DocumentLink={}));var Ve;(function(Re){function Ne(se){const Fe=new o.ColorPresentation(se.label);return se.textEdit&&(Fe.textEdit=V.to(se.textEdit)),se.additionalTextEdits&&(Fe.additionalTextEdits=se.additionalTextEdits.map(He=>V.to(He))),Fe}Re.to=Ne;function Se(se){return{label:se.label,textEdit:se.textEdit?V.from(se.textEdit):void 0,additionalTextEdits:se.additionalTextEdits?se.additionalTextEdits.map(Fe=>V.from(Fe)):void 0}}Re.from=Se})(Ve=e.ColorPresentation||(e.ColorPresentation={}));var xe;(function(Re){function Ne(se){return new o.Color(se[0],se[1],se[2],se[3])}Re.to=Ne;function Se(se){return[se.red,se.green,se.blue,se.alpha]}Re.from=Se})(xe=e.Color||(e.Color={}));var et;(function(Re){function Ne(se){return{range:l.from(se.range)}}Re.from=Ne;function Se(se){return new o.SelectionRange(l.to(se.range))}Re.to=Se})(et=e.SelectionRange||(e.SelectionRange={}));var Qe;(function(Re){function Ne(Se){switch(Se){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}Re.to=Ne})(Qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(Re){function Ne(se){switch(se){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=Ne;function Se(se){switch(se){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}Re.to=Se})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var st;(function(Re){function Ne(se){if(se===o.EndOfLine.CRLF)return 1;if(se===o.EndOfLine.LF)return 0}Re.from=Ne;function Se(se){if(se===1)return o.EndOfLine.CRLF;if(se===0)return o.EndOfLine.LF}Re.to=Se})(st=e.EndOfLine||(e.EndOfLine={}));var ht;(function(Re){function Ne(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=Ne})(ht=e.ProgressLocation||(e.ProgressLocation={}));var Ue;(function(Re){function Ne(Se){const se={start:Se.start+1,end:Se.end+1};return Se.kind&&(se.kind=rt.from(Se.kind)),se}Re.from=Ne})(Ue=e.FoldingRange||(e.FoldingRange={}));var rt;(function(Re){function Ne(Se){if(Se)switch(Se){case o.FoldingRangeKind.Comment:return f.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports:return f.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region:return f.FoldingRangeKind.Region}}Re.from=Ne})(rt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ce;(function(Re){function Ne(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?l.from(Se.selection):void 0,override:typeof Se.override=="boolean"?g.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Re.from=Ne})(ce=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var $;(function(Re){function Ne(He){return He instanceof o.RelativePattern?He.toJSON():typeof He=="string"?He:Se(He)||se(He)?new o.RelativePattern(He.baseUri??He.base,He.pattern).toJSON():He}Re.from=Ne;function Se(He){const _e=He;return _e?T.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function se(He){const _e=He;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Fe(He){return typeof He=="string"?He:new o.RelativePattern(T.URI.revive(He.baseUri),He.pattern)}Re.to=Fe})($=e.GlobPattern||(e.GlobPattern={}));var ue;(function(Re){function Ne(Se){if(Se){if(Array.isArray(Se))return Se.map(Ne);if(typeof Se=="string")return Se;{const se=Se;return{language:se.language,scheme:se.scheme,pattern:$.from(se.pattern),exclusive:se.exclusive,notebookType:se.notebookType}}}else return}Re.from=Ne})(ue=e.LanguageSelector||(e.LanguageSelector={}));var Ie;(function(Re){function Ne(se){return{start:se.start,end:se.end}}Re.from=Ne;function Se(se){return new o.NotebookRange(se.start,se.end)}Re.to=Se})(Ie=e.NotebookRange||(e.NotebookRange={}));var Le;(function(Re){function Ne(se){return{timing:typeof se.runStartTime=="number"&&typeof se.runEndTime=="number"?{startTime:se.runStartTime,endTime:se.runEndTime}:void 0,executionOrder:se.executionOrder,success:se.lastRunSuccess}}Re.to=Ne;function Se(se){return{lastRunSuccess:se.success,runStartTime:se.timing?.startTime,runEndTime:se.timing?.endTime,executionOrder:se.executionOrder}}Re.from=Se})(Le=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var $e;(function(Re){function Ne(Se){if(Se===p.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(Se===p.NotebookCellExecutionState.Pending)return;if(Se===p.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Re.to=Ne})($e=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ke;(function(Re){function Ne(se){switch(se){case o.NotebookCellKind.Markup:return p.CellKind.Markup;case o.NotebookCellKind.Code:default:return p.CellKind.Code}}Re.from=Ne;function Se(se){switch(se){case p.CellKind.Markup:return o.NotebookCellKind.Markup;case p.CellKind.Code:default:return o.NotebookCellKind.Code}}Re.to=Se})(Ke=e.NotebookCellKind||(e.NotebookCellKind={}));var Ze;(function(Re){function Ne(se){const Fe={metadata:se.metadata??Object.create(null),cells:[]};for(const He of se.cells)o.NotebookCellData.validate(He),Fe.cells.push(pt.from(He));return Fe}Re.from=Ne;function Se(se){const Fe=new o.NotebookData(se.cells.map(pt.to));return(0,v.isEmptyObject)(se.metadata)||(Fe.metadata=se.metadata),Fe}Re.to=Se})(Ze=e.NotebookData||(e.NotebookData={}));var pt;(function(Re){function Ne(se){return{cellKind:Ke.from(se.kind),language:se.languageId,mime:se.mime,source:se.value,metadata:se.metadata,internalMetadata:Le.from(se.executionSummary??{}),outputs:se.outputs?se.outputs.map(ct.from):[]}}Re.from=Ne;function Se(se){return new o.NotebookCellData(Ke.to(se.cellKind),se.source,se.language,se.mime,se.outputs?se.outputs.map(ct.to):void 0,se.metadata,se.internalMetadata?Le.to(se.internalMetadata):void 0)}Re.to=Se})(pt=e.NotebookCellData||(e.NotebookCellData={}));var gt;(function(Re){function Ne(se){return{mime:se.mime,valueBytes:A.VSBuffer.wrap(se.data)}}Re.from=Ne;function Se(se){return new o.NotebookCellOutputItem(se.valueBytes.buffer,se.mime)}Re.to=Se})(gt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ct;(function(Re){function Ne(se){return{outputId:se.id,items:se.items.map(gt.from),metadata:se.metadata}}Re.from=Ne;function Se(se){const Fe=se.items.map(gt.to);return new o.NotebookCellOutput(Fe,se.outputId,se.metadata)}Re.to=Se})(ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Et;(function(Re){function Ne(Fe){return se(Fe)?{include:(0,v.withNullAsUndefined)($.from(Fe.include)),exclude:(0,v.withNullAsUndefined)($.from(Fe.exclude))}:(0,v.withNullAsUndefined)($.from(Fe))}Re.from=Ne;function Se(Fe){return se(Fe)?{include:$.to(Fe.include),exclude:$.to(Fe.exclude)}:$.to(Fe)}Re.to=Se;function se(Fe){const He=Fe;return He?!(0,v.isUndefinedOrNull)(He.include)&&!(0,v.isUndefinedOrNull)(He.exclude):!1}})(Et=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var tt;(function(Re){function Ne(Se,se,Fe){const He=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:se.toInternal(He,Fe),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Re.from=Ne})(tt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ft;(function(Re){function Ne(Se,se,Fe){const He=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:se.toInternal(He,Fe),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Re.from=Ne})(ft=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var At;(function(Re){function Ne(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Re.from=Ne})(At=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Kt;(function(Re){function Ne(se){return{uri:se.uri,provides:se.provides}}Re.from=Ne;function Se(se){return new o.NotebookRendererScript(T.URI.revive(se.uri),se.provides)}Re.to=Se})(Kt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Rt;(function(Re){function Ne(se){return{message:M.fromStrict(se.message)||"",type:0,expected:se.expectedOutput,actual:se.actualOutput,location:se.location&&{range:l.from(se.location.range),uri:se.location.uri}}}Re.from=Ne;function Se(se){const Fe=new o.TestMessage(typeof se.message=="string"?se.message:M.to(se.message));return Fe.actualOutput=se.actual,Fe.expectedOutput=se.expected,Fe.location=se.location?ve.to(se.location):void 0,Fe}Re.to=Se})(Rt=e.TestMessage||(e.TestMessage={}));var mt;(function(Re){Re.namespace=b.namespaceTestTag,Re.denamespace=b.denamespaceTestTag})(mt=e.TestTag||(e.TestTag={}));var Tt;(function(Re){function Ne(se){const Fe=(0,h.getPrivateApiFor)(se).controllerId;return{extId:y.TestId.fromExtHostTestItem(se,Fe).toString(),label:se.label,uri:T.URI.revive(se.uri),busy:se.busy,tags:se.tags.map(He=>mt.namespace(Fe,He.id)),range:E.Range.lift(l.from(se.range)),description:se.description||null,sortText:se.sortText||null,error:se.error&&M.fromStrict(se.error)||null}}Re.from=Ne;function Se(se){return{parent:void 0,error:void 0,id:y.TestId.fromString(se.extId).localId,label:se.label,uri:T.URI.revive(se.uri),tags:(se.tags||[]).map(Fe=>{const{tagId:He}=mt.denamespace(Fe);return new o.TestTag(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:l.to(se.range||void 0),canResolveChildren:!1,busy:se.busy,description:se.description||void 0,sortText:se.sortText||void 0}}Re.toPlain=Se})(Tt=e.TestItem||(e.TestItem={})),function(Re){function Ne(se){return{id:se.id}}Re.from=Ne;function Se(se){return new o.TestTag(se.id)}Re.to=Se}(mt=e.TestTag||(e.TestTag={}));var $t;(function(Re){const Ne=(se,Fe)=>{const He=[];for(const[je,it]of Fe)y.TestId.compare(it.item.extId,je)===2&&(Fe.delete(je),He.push(it));const _e={...Tt.toPlain(se.item),parent:void 0,taskStates:se.tasks.map(je=>({state:je.state,duration:je.duration,messages:je.messages.filter(it=>it.type===0).map(Rt.to)})),children:He.map(je=>Ne(je,Fe))};for(const je of _e.children)je.parent=_e;return _e};function Se(se){const Fe=[],He=new Map;for(const _e of se.items){He.set(_e.item.extId,_e);const je=y.TestId.root(_e.item.extId);se.request.targets.some(it=>it.controllerId===je&&it.testIds.includes(_e.item.extId))&&Fe.push(_e)}return{completedAt:se.completedAt,results:Fe.map(_e=>Ne(_e,He))}}Re.to=Se})($t=e.TestResults||(e.TestResults={}));var Nt;(function(Re){function Ne(He){return{covered:He.covered,total:He.covered}}function Se(He){return"line"in He?m.from(He):l.from(He)}function se(He){return"branches"in He?{count:He.executionCount,location:Se(He.location),type:1,branches:He.branches.length?He.branches.map(_e=>({count:_e.executionCount,location:_e.location&&Se(_e.location)})):void 0}:{type:0,count:He.executionCount,location:Se(He.location)}}Re.fromDetailed=se;function Fe(He){return{uri:He.uri,statement:Ne(He.statementCoverage),branch:He.branchCoverage&&Ne(He.branchCoverage),function:He.functionCoverage&&Ne(He.functionCoverage),details:He.detailedCoverage?.map(se)}}Re.fromFile=Fe})(Nt=e.TestCoverage||(e.TestCoverage={}));var Xe;(function(Re){function Ne(Se){switch(Se){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}Re.to=Ne})(Xe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Mt;(function(Re){function Ne(se){const Fe=new o.TypeHierarchyItem(J.to(se.kind),se.name,se.detail||"",T.URI.revive(se.uri),l.to(se.range),l.to(se.selectionRange));return Fe._sessionId=se._sessionId,Fe._itemId=se._itemId,Fe}Re.to=Ne;function Se(se,Fe,He){if(Fe=Fe??se._sessionId,He=He??se._itemId,Fe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:He,kind:J.from(se.kind),name:se.name,detail:se.detail??"",uri:se.uri,range:l.from(se.range),selectionRange:l.from(se.selectionRange),tags:se.tags?.map(te.from)}}Re.from=Se})(Mt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ut;(function(Re){function Ne(Se){if(!!Se)return{value:Se.value,tooltip:Se.tooltip}}Re.from=Ne})(Ut=e.ViewBadge||(e.ViewBadge={}));var Wt;(function(Re){function Ne(He,_e,je){const it=_e.fileData;return it?new class extends o.DataTransferItem{asFile(){return{name:it.name,uri:T.URI.revive(it.uri),data:(0,R.once)(()=>je())}}}("",_e.id):He===L.Mimes.uriList&&_e.uriListData?new o.DataTransferItem(Fe(_e.uriListData)):new o.DataTransferItem(_e.asString)}Re.to=Ne;async function Se(He,_e){const je=await _e.asString();if(He===L.Mimes.uriList)return{id:_e.id,asString:"",fileData:void 0,uriListData:se(je)};const it=_e.asFile();return{id:_e.id,asString:je,fileData:it?{name:it.name,uri:it.uri}:void 0}}Re.from=Se;function se(He){return u.UriList.split(He).map(_e=>{if(_e.startsWith("#"))return _e;try{return T.URI.parse(_e)}catch{}return _e})}function Fe(He){return u.UriList.create(He.map(_e=>typeof _e=="string"?_e:T.URI.revive(_e)))}})(Wt=e.DataTransferItem||(e.DataTransferItem={}));var bt;(function(Re){function Ne(se,Fe){const He=se.items.map(([_e,je])=>[_e,Wt.to(_e,je,()=>Fe(je.id))]);return new o.DataTransfer(He)}Re.toDataTransfer=Ne;async function Se(se){const Fe={items:[]},He=[];return se.forEach((_e,je)=>{He.push((async()=>{Fe.items.push([je,await Wt.from(je,_e)])})())}),await Promise.all(He),Fe}Re.toDataTransferDTO=Se})(bt=e.DataTransfer||(e.DataTransfer={}))}),define(ye[240],De([1,0,2,11,7,14,66]),function(ne,e,c,A,u,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(I,L,k,v={timeout:1500,errors:3}){this.c=I,this.d=L,this.f=k,this.g=v,this.a=new C.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(L,k,v)=>{const E={dispose:this.a.push([L,k,I])};return Array.isArray(v)&&v.push(E),E}}async $participateInSave(I,L){const k=c.URI.revive(I);let v=!1;const T=setTimeout(()=>v=!0,this.g.timeout),E=[];try{for(const f of[...this.a]){if(v)break;const d=this.d.getDocument(k),h=await this.h(f,{document:d,reason:R.TextDocumentSaveReason.to(L)});E.push(h)}}finally{clearTimeout(T)}return E}h([I,L,k],v){const T=this.b.get(I);return typeof T=="number"&&T>this.g.errors?Promise.resolve(!1):this.i(k,I,L,v).then(()=>!0,E=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error(E),!(E instanceof Error)||E.message!=="concurrent_edits"){const f=this.b.get(I);this.b.set(I,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,L,k,v){const T=[],E=Date.now(),{document:f,reason:d}=v,{version:h}=f,g=Object.freeze({document:f,reason:d,waitUntil(p){if(Object.isFrozen(T))throw(0,A.illegalState)("waitUntil can not be called async");T.push(Promise.resolve(p))}});try{L.apply(k,[g])}catch(p){return Promise.reject(p)}return Object.freeze(T),new Promise((p,y)=>{const b=setTimeout(()=>y(new Error("timeout")),this.g.timeout);return Promise.all(T).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-E}ms`),clearTimeout(b),p(i)}).catch(i=>{clearTimeout(b),y(i)})}).then(p=>{const y={edits:[]};for(const b of p)if(Array.isArray(b)&&b.every(i=>i instanceof u.TextEdit))for(const{newText:i,newEol:o,range:s}of b)y.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:s&&R.Range.from(s),text:i,eol:o&&R.EndOfLine.from(o)}});if(y.edits.length!==0)return h===f.version?this.f.$tryApplyWorkspaceEdit(y):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(ye[241],De([1,0,18,2,14,7,92]),function(ne,e,c,A,u,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class P{constructor(k,v,T,E){this.start=k,this.deletedCount=v,this.deletedItems=T,this.items=E}asApiEvent(){return{range:new R.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(k,v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,v,T){this.notebook=k,this.h=v,this.j=T,this.handle=T.handle,this.uri=A.URI.revive(T.uri),this.cellKind=T.cellKind,this.a=T.outputs.map(u.NotebookCellOutput.to),this.e=T.internalMetadata??{},this.b=Object.freeze(T.metadata??{}),this.d=Object.freeze(u.NotebookCellExecutionSummary.to(T.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,v=this.h.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const T={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:u.NotebookCellKind.to(this.j.cellKind),document:v.document,get mime(){return k.g},set mime(E){k.g=E},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(T)}return this.f}setOutputs(k){this.a=k.map(u.NotebookCellOutput.to)}setOutputItems(k,v,T){const E=T.map(u.NotebookCellOutputItem.to),f=this.a.find(d=>d.id===k);if(f&&(v||(f.items.length=0),f.items.push(...E),f.items.length>1&&f.items.every(d=>C.isTextStreamMime(d.mime)))){const d=new Map,h=[];f.items.forEach(g=>{let p;d.has(g.mime)?p=d.get(g.mime):(p=[],d.set(g.mime,p),h.push(g.mime)),p.push(g.data)}),f.items.length=0,h.forEach(g=>{const p=C.compressOutputItemStreams(d.get(g));f.items.push({mime:g,data:p.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(u.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.ExtHostCell=S;class I{constructor(k,v,T,E,f){this.k=k,this.l=v,this.m=T,this.uri=E,this.handle=I.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=f.viewType,this.f=Object.freeze(f.metadata??Object.create(null)),this.r([[0,0,f.cells]],!0,void 0),this.g=f.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const k=this,v={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===c.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(T){return T=k.n(T),k.b[T].apiCell},getCells(T){return(T?k.p(T):k.b).map(f=>f.apiCell)},save(){return k.q()}};this.e=Object.freeze(v)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,v,T){this.g=k.versionId,this.h=v,this.acceptDocumentPropertiesChanged({metadata:T});const E={notebook:this.apiNotebook,metadata:T,cellChanges:[],contentChanges:[]},f=[];for(const h of k.rawEvents)h.kind===C.NotebookCellsChangeType.ModelChange?this.r(h.changes,!1,E.contentChanges):h.kind===C.NotebookCellsChangeType.Move?this.s(h.index,h.length,h.newIdx,E.contentChanges):h.kind===C.NotebookCellsChangeType.Output?(this.t(h.index,h.outputs),f.push({cell:this.b[h.index].apiCell,outputs:this.b[h.index].apiCell.outputs})):h.kind===C.NotebookCellsChangeType.OutputItem?(this.u(h.index,h.outputId,h.append,h.outputItems),f.push({cell:this.b[h.index].apiCell,outputs:this.b[h.index].apiCell.outputs})):h.kind===C.NotebookCellsChangeType.ChangeCellLanguage?(this.v(h.index,h.language),f.push({cell:this.b[h.index].apiCell,document:this.b[h.index].apiCell.document})):h.kind===C.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this.b[h.index].apiCell,document:this.b[h.index].apiCell.document}):h.kind===C.NotebookCellsChangeType.ChangeCellMime?this.w(h.index,h.mime):h.kind===C.NotebookCellsChangeType.ChangeCellMetadata?(this.x(h.index,h.metadata),f.push({cell:this.b[h.index].apiCell,metadata:this.b[h.index].apiCell.metadata})):h.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(h.index,h.internalMetadata),f.push({cell:this.b[h.index].apiCell,executionSummary:this.b[h.index].apiCell.executionSummary}));const d=new Map;for(let h=0;h<f.length;h++){const g=f[h],p=d.get(g.cell);if(p===void 0){const y=E.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...g});d.set(g.cell,y-1)}else E.cellChanges[p]={...E.cellChanges[p],...g}}return Object.freeze(E),Object.freeze(E.cellChanges),Object.freeze(E.contentChanges),E}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let v=k.start|0,T=k.end|0;return v<0&&(v=0),T>this.b.length&&(T=this.b.length),k.with({start:v,end:T})}p(k){k=this.o(k);const v=[];for(let T=k.start;T<k.end;T++)v.push(this.b[T]);return v}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,v,T){if(this.j)return;const E=[],f=[],d=[];if(k.reverse().forEach(h=>{const p=h[2].map(i=>{const o=new S(this,this.l,i);return v||f.push(S.asModelAddData(this.apiNotebook,i)),o}),y=new P(h[0],h[1],[],p),b=this.b.splice(h[0],h[1],...p);for(const i of b)d.push(i.uri),y.deletedItems.push(i.apiCell);E.push(y)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:d}),T)for(const h of E)T.push(h.asApiEvent())}s(k,v,T,E){const f=this.b.splice(k,v);this.b.splice(T,0,...f);const d=[new P(k,v,f.map(h=>h.apiCell),[]),new P(T,0,[],f)];for(const h of d)E.push(h.asApiEvent())}t(k,v){this.b[k].setOutputs(v)}u(k,v,T,E){this.b[k].setOutputItems(v,T,E)}v(k,v){const T=this.b[k];T.apiCell.document.languageId!==v&&this.m.$acceptModelLanguageChanged(T.uri,v)}w(k,v){const T=this.b[k];T.apiCell.mime=v}x(k,v){this.b[k].setMetadata(v)}y(k,v){this.b[k].setInternalMetadata(v)}getCellFromApiCell(k){return this.b.find(v=>v.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(v=>v.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}I.a=0,e.ExtHostNotebookDocument=I}),define(ye[136],De([1,0,11,14,7]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class R{constructor(P,S,I,L,k,v){this.id=P,this.f=S,this.notebookData=I,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=L,this.c=v}get apiEditor(){if(!this.e){const P=this;this.e={get notebook(){return P.notebookData.apiNotebook},get selection(){return P.a[0]},set selection(S){this.selections=[S]},get selections(){return P.a},set selections(S){if(!Array.isArray(S)||!S.every(u.NotebookRange.isNotebookRange))throw(0,c.illegalArgument)("selections");P.a=S,P.g(S)},get visibleRanges(){return P.b},revealRange(S,I){P.f.$tryRevealRange(P.id,A.NotebookRange.from(S),I??u.NotebookEditorRevealType.Default)},get viewColumn(){return P.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(P){this.d=P}_acceptVisibleRanges(P){this.b=P}_acceptSelections(P){this.a=P}g(P){this.f.$trySetSelections(this.id,P.map(A.NotebookRange.from))}_acceptViewColumn(P){this.c=P}}R.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=R}),define(ye[242],De([1,0,3,13,14]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let R=class{constructor(P,S){this.c=P,this.d=S,this.a=new c.Emitter,this.b=new c.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(P,S){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",P,S);const I=this.d.getEditorById(P);S.visibleRanges&&I._acceptVisibleRanges(S.visibleRanges.ranges.map(u.NotebookRange.to)),S.selections&&I._acceptSelections(S.selections.selections.map(u.NotebookRange.to)),S.visibleRanges&&this.b.fire({notebookEditor:I.apiEditor,visibleRanges:I.apiEditor.visibleRanges}),S.selections&&this.a.fire(Object.freeze({notebookEditor:I.apiEditor,selections:I.apiEditor.selections}))}$acceptEditorViewColumns(P){for(const S in P)this.d.getEditorById(S)._acceptViewColumn(u.ViewColumn.to(P[S]))}};R=qe([We(0,A.ILogService)],R),e.ExtHostNotebookEditors=R}),define(ye[243],De([1,0,14,126,179,21,62,11]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(v){this.b=0,this.c=new Map,this.a=v}async withProgress(v,T,E){const f=this.b++,{title:d,location:h,cancellable:g}=T,p={label:(0,u.localize)(0,null,v.displayName||v.name),id:v.identifier.value};return this.a.$startProgress(f,{location:c.ProgressLocation.from(h),title:d,source:p,cancellable:g},v.isUnderDevelopment?void 0:v.identifier.value).catch(P.onUnexpectedExternalError),this.d(f,E,!!g)}d(v,T,E){let f;E&&(f=new R.CancellationTokenSource,this.c.set(v,f));const d=g=>{this.a.$progressEnd(g),this.c.delete(g),f?.dispose()};let h;try{h=T(new L(this.a,v),E&&f?f.token:R.CancellationToken.None)}catch(g){throw d(v),g}return h.then(g=>d(v),g=>d(v)),h}$acceptProgressCanceled(v){const T=this.c.get(v);T&&(T.cancel(),this.c.delete(v))}}e.ExtHostProgress=S;function I(k,v){return k.message=v.message,typeof v.increment=="number"&&(typeof k.increment=="number"?k.increment+=v.increment:k.increment=v.increment),k}class L extends A.Progress{constructor(v,T){super(E=>this.throttledReport(E)),this.c=v,this.d=T}throttledReport(v){this.c.$progressReport(this.d,v)}}qe([(0,C.throttle)(100,(k,v)=>I(k,v),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(ye[137],De([1,0,32,132,57,93,75,14,2]),function(ne,e,c,A,u,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const I=(p,y,b,i)=>{let o=y;return{enumerable:!0,configurable:!1,get(){return o},set(s){if(!b(o,s)){const l=o;o=s,p.listener?.(i(s,l))}}}},L=(p,y)=>p===y,k={range:(p,y)=>p===y?!0:!p||!y?!1:p.isEqual(y),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(p,y)=>!(p.length!==y.length||p.some(b=>!y.find(i=>b.id===i.id)))},v=p=>y=>({op:4,update:p(y)}),T=(p,y)=>({range:(()=>{let b;const i=v(o=>({range:c.Range.lift(P.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return b},set(o){p.listener?.({op:6}),k.range(b,o)||(b=o,p.listener?.(i(o)))}}})(),label:I(p,y,k.label,v(b=>({label:b}))),description:I(p,void 0,k.description,v(b=>({description:b}))),sortText:I(p,void 0,k.sortText,v(b=>({sortText:b}))),canResolveChildren:I(p,!1,k.canResolveChildren,b=>({op:2,state:b})),busy:I(p,!1,k.busy,v(b=>({busy:b}))),error:I(p,void 0,k.error,v(b=>({error:P.MarkdownString.fromStrict(b)||null}))),tags:I(p,[],k.tags,(b,i)=>({op:1,new:b.map(P.TestTag.from),old:i.map(P.TestTag.from)}))}),E=p=>{const y=u.TestId.fromString(p.extId),b=new d(y.controllerId,y.localId,p.label,S.URI.revive(p.uri)||void 0);return b.range=P.Range.to(p.range||void 0),b.description=p.description||void 0,b.sortText=p.sortText||void 0,b.tags=p.tags.map(i=>P.TestTag.to({id:(0,C.denamespaceTestTag)(i).tagId})),b},f=p=>{let y;for(const b of p.tests){const i=E(b.item);(0,A.getPrivateApiFor)(i).parent=y,y=i}return y};e.toItemFromContext=f;class d{constructor(y,b,i,o){if(b.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(b)} symbol`);const s=(0,A.createPrivateApiFor)(this,y);Object.defineProperties(this,{id:{value:b,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof h?void 0:s.parent}},children:{value:(0,R.createTestItemChildren)(s,A.getPrivateApiFor,d),enumerable:!0,writable:!1},...T(s,i)})}}e.TestItemImpl=d;class h extends d{constructor(y,b){super(y,y,b,void 0),this._isRoot=!0}}e.TestItemRootImpl=h;class g extends R.TestItemCollection{constructor(y,b,i){super({controllerId:y,getDocumentVersion:o=>o&&i.getDocument(o)?.version,getApiFor:A.getPrivateApiFor,getChildren:o=>o.children,root:new h(y,b),toITestItem:P.TestItem.from})}}e.ExtHostTestItemCollection=g}),define(ye[138],De([1,0,50,11,101,14,7]),function(ne,e,c,A,u,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class P{constructor(v,T,E){const f=P.c.nextId();v.$registerTextEditorDecorationType(T.identifier,f,R.DecorationRenderOptions.from(E)),this.value=Object.freeze({key:f,dispose(){v.$removeTextEditorDecorationType(f)}})}}P.c=new u.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=P;class S{constructor(v,T){this.g=[],this.h=void 0,this.j=!1,this.c=v,this.d=v.version,this.e=T.undoStopBefore,this.f=T.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(v,T){this.k();let E=null;if(v instanceof C.Position)E=new C.Range(v,v);else if(v instanceof C.Range)E=v;else throw new Error("Unrecognized location");this.l(E,T,!1)}insert(v,T){this.k(),this.l(new C.Range(v,v),T,!0)}delete(v){this.k();let T=null;if(v instanceof C.Range)T=v;else throw new Error("Unrecognized location");this.l(T,null,!0)}l(v,T,E){const f=this.c.validateRange(v);this.g.push({range:f,text:T,forceMoveMarkers:E})}setEndOfLine(v){if(this.k(),v!==C.EndOfLine.LF&&v!==C.EndOfLine.CRLF)throw(0,A.illegalArgument)("endOfLine");this.h=v}}class I{constructor(v,T,E,f){this.c=v,this.d=T,this._accept(E),this.e=f;const d=this;this.value={get tabSize(){return d.f},set tabSize(h){d.m(h)},get indentSize(){return d.g},set indentSize(h){d.o(h)},get insertSpaces(){return d.h},set insertSpaces(h){d.q(h)},get cursorStyle(){return d.j},set cursorStyle(h){d.s(h)},get lineNumbers(){return d.k},set lineNumbers(h){d.t(h)}}}_accept(v){this.f=v.tabSize,this.g=v.indentSize,this.h=v.insertSpaces,this.j=v.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to(v.lineNumbers)}l(v){if(v==="auto")return"auto";if(typeof v=="number"){const T=Math.floor(v);return T>0?T:null}if(typeof v=="string"){const T=parseInt(v,10);return isNaN(T)?null:T>0?T:null}return null}m(v){const T=this.l(v);if(T!==null){if(typeof T=="number"){if(this.f===T)return;this.f=T}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:T}))}}n(v){if(v==="tabSize")return"tabSize";if(typeof v=="number"){const T=Math.floor(v);return T>0?T:null}if(typeof v=="string"){const T=parseInt(v,10);return isNaN(T)?null:T>0?T:null}return null}o(v){const T=this.n(v);if(T!==null){if(typeof T=="number"){if(this.g===T)return;this.g=T}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:T}))}}p(v){return v==="auto"?"auto":v==="false"?!1:Boolean(v)}q(v){const T=this.p(v);if(typeof T=="boolean"){if(this.h===T)return;this.h=T}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:T}))}s(v){this.j!==v&&(this.j=v,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:v})))}t(v){this.k!==v&&(this.k=v,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(v)})))}assign(v){const T={};let E=!1;if(typeof v.tabSize<"u"){const f=this.l(v.tabSize);f==="auto"?(E=!0,T.tabSize=f):typeof f=="number"&&this.f!==f&&(this.f=f,E=!0,T.tabSize=f)}if(typeof v.indentSize<"u"){const f=this.n(v.indentSize);f==="tabSize"?(E=!0,T.indentSize=f):typeof f=="number"&&this.g!==f&&(this.g=f,E=!0,T.indentSize=f)}if(typeof v.insertSpaces<"u"){const f=this.p(v.insertSpaces);f==="auto"?(E=!0,T.insertSpaces=f):this.h!==f&&(this.h=f,E=!0,T.insertSpaces=f)}typeof v.cursorStyle<"u"&&this.j!==v.cursorStyle&&(this.j=v.cursorStyle,E=!0,T.cursorStyle=v.cursorStyle),typeof v.lineNumbers<"u"&&this.k!==v.lineNumbers&&(this.k=v.lineNumbers,E=!0,T.lineNumbers=R.TextEditorLineNumbersStyle.from(v.lineNumbers)),E&&this.u("setOptions",this.c.$trySetOptions(this.d,T))}u(v,T){T.catch(E=>{this.e.warn(`ExtHostTextEditorOptions '${v}' failed:'`),this.e.warn(E)})}}e.ExtHostTextEditorOptions=I;class L{constructor(v,T,E,f,d,h,g,p){this.id=v,this.j=T,this.k=E,this.g=!1,this.h=new Set,this.c=d,this.d=new I(this.j,this.id,h,E),this.e=g,this.f=p;const y=this;this.value=Object.freeze({get document(){return f.value},set document(b){throw(0,A.readonly)("document")},get selection(){return y.c&&y.c[0]},set selection(b){if(!(b instanceof C.Selection))throw(0,A.illegalArgument)("selection");y.c=[b],y.l()},get selections(){return y.c},set selections(b){if(!Array.isArray(b)||b.some(i=>!(i instanceof C.Selection)))throw(0,A.illegalArgument)("selections");y.c=b,y.l()},get visibleRanges(){return y.e},set visibleRanges(b){throw(0,A.readonly)("visibleRanges")},get options(){return y.d.value},set options(b){y.g||y.d.assign(b)},get viewColumn(){return y.f},set viewColumn(b){throw(0,A.readonly)("viewColumn")},edit(b,i={undoStopBefore:!0,undoStopAfter:!0}){if(y.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const o=new S(f.value,i);return b(o),y.m(o)},insertSnippet(b,i,o={undoStopBefore:!0,undoStopAfter:!0}){if(y.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!i||Array.isArray(i)&&i.length===0)s=y.c.map(l=>R.Range.from(l));else if(i instanceof C.Position){const{lineNumber:l,column:r}=R.Position.from(i);s=[{startLineNumber:l,startColumn:r,endLineNumber:l,endColumn:r}]}else if(i instanceof C.Range)s=[R.Range.from(i)];else{s=[];for(const l of i)if(l instanceof C.Range)s.push(R.Range.from(l));else{const{lineNumber:r,column:m}=R.Position.from(l);s.push({startLineNumber:r,startColumn:m,endLineNumber:r,endColumn:m})}}return T.$tryInsertSnippet(v,f.value.version,b.value,s,o)},setDecorations(b,i){const o=i.length===0;o&&!y.h.has(b.key)||(o?y.h.delete(b.key):y.h.add(b.key),y.n(()=>{if(R.isDecorationOptionsArr(i))return T.$trySetDecorations(v,b.key,R.fromRangeOrRangeWithMessage(i));{const s=new Array(4*i.length);for(let l=0,r=i.length;l<r;l++){const m=i[l];s[4*l]=m.start.line+1,s[4*l+1]=m.start.character+1,s[4*l+2]=m.end.line+1,s[4*l+3]=m.end.character+1}return T.$trySetDecorationsFast(v,b.key,s)}}))},revealRange(b,i){y.n(()=>T.$tryRevealRange(v,R.Range.from(b),i||C.TextEditorRevealType.Default))},show(b){T.$tryShowEditor(v,R.ViewColumn.from(b))},hide(){T.$tryHideEditor(v)}})}dispose(){(0,c.ok)(!this.g),this.g=!0}_acceptOptions(v){(0,c.ok)(!this.g),this.d._accept(v)}_acceptVisibleRanges(v){(0,c.ok)(!this.g),this.e=v}_acceptViewColumn(v){(0,c.ok)(!this.g),this.f=v}_acceptSelections(v){(0,c.ok)(!this.g),this.c=v}async l(){const v=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,v)),this.value}m(v){const T=v.finalize();if(T.edits.length===0&&!T.setEndOfLine)return Promise.resolve(!0);const E=T.edits.map(d=>d.range);E.sort((d,h)=>d.end.line===h.end.line?d.end.character===h.end.character?d.start.line===h.start.line?d.start.character-h.start.character:d.start.line-h.start.line:d.end.character-h.end.character:d.end.line-h.end.line);for(let d=0,h=E.length-1;d<h;d++){const g=E[d].end;if(E[d+1].start.isBefore(g))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=T.edits.map(d=>({range:R.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,T.documentVersionId,f,{setEndOfLine:typeof T.setEndOfLine=="number"?R.EndOfLine.from(T.setEndOfLine):void 0,undoStopBefore:T.undoStopBefore,undoStopAfter:T.undoStopAfter})}n(v){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,T=>(T instanceof Error&&T.name==="DISPOSED"||this.k.warn(T),null))}}e.ExtHostTextEditor=L}),define(ye[244],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ye[245],De([1,0,195,11,37,123,91,39,26,244,208,197]),function(ne,e,c,A,u,R,C,P,S,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const v=P.Registry.as(C.Extensions.JSONContribution);class T{constructor(b,i,o){this.a=b,this.b=i,this.c=o}d(b,i){this.a({type:b,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(b){this.d(u.default.Error,b)}warn(b){this.d(u.default.Warning,b)}info(b){this.d(u.default.Info,b)}}e.ExtensionMessageCollector=T;class E{static a(b){const i=new Set;for(let o=0,s=b.length;o<s;o++)i.add(S.ExtensionIdentifier.toKey(b[o].description.identifier));return i}static compute(b,i){if(!b||!b.length)return new E(i,[]);if(!i||!i.length)return new E([],b);const o=this.a(b),s=this.a(i),l=i.filter(m=>!o.has(S.ExtensionIdentifier.toKey(m.description.identifier))),r=b.filter(m=>!s.has(S.ExtensionIdentifier.toKey(m.description.identifier)));return new E(l,r)}constructor(b,i){this.added=b,this.removed=i}}e.ExtensionPointUserDelta=E;class f{constructor(b,i){this.name=b,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(b){if(this.a!==null)throw new Error("Handler already set!");this.a=b,this.d()}acceptUsers(b){this.c=E.compute(this.b,b),this.b=b,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(b){(0,A.onUnexpectedError)(b)}}}e.ExtensionPoint=f;const d={type:"string",enum:["ui","workspace"],enumDescriptions:[c.localize(0,null),c.localize(1,null)]},h="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:c.localize(2,null),properties:{vscode:{type:"string",description:c.localize(3,null),default:"^1.22.0"}}},publisher:{description:c.localize(4,null),type:"string"},displayName:{description:c.localize(5,null),type:"string"},categories:{description:c.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:c.localize(7,null)}]}},galleryBanner:{type:"object",description:c.localize(8,null),properties:{color:{description:c.localize(9,null),type:"string"},theme:{description:c.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:c.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:c.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:c.localize(13,null)},enabledApiProposals:{markdownDescription:c.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}},api:{markdownDescription:c.localize(15,null),type:"string",enum:["none"],enumDescriptions:[c.localize(16,null)]},activationEvents:{description:c.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:c.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:c.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:c.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:c.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:c.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:c.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:c.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:c.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:c.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:c.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:c.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:c.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:c.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:c.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:c.localize(32,null)},{label:"onUri",body:"onUri",description:c.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:c.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:c.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:c.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:c.localize(37,null)},{label:"onRenderer",description:c.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:c.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:c.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:c.localize(41,null)},{label:"*",description:c.localize(42,null),body:"*"}]}},badges:{type:"array",description:c.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:c.localize(44,null)},href:{type:"string",description:c.localize(45,null)},description:{type:"string",description:c.localize(46,null)}}}},markdown:{type:"string",description:c.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:c.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:c.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:c.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:c.localize(51,null),type:"array",items:d,default:["workspace"],defaultSnippets:[{body:["ui"],description:c.localize(52,null)},{body:["workspace"],description:c.localize(53,null)},{body:["ui","workspace"],description:c.localize(54,null)},{body:["workspace","ui"],description:c.localize(55,null)},{body:[],description:c.localize(56,null)}]},capabilities:{description:c.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:c.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:c.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(60,null),c.localize(61,null),c.localize(62,null)]},description:{type:"string",markdownDescription:c.localize(63,null)}}},untrustedWorkspaces:{description:c.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:c.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(66,null),c.localize(67,null),c.localize(68,null)]},restrictedConfigurations:{description:c.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:c.localize(70,null)}}}}},sponsor:{description:c.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:c.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:c.localize(73,null),type:"string"},"vscode:uninstall":{description:c.localize(74,null),type:"string"}}},icon:{type:"string",description:c.localize(75,null)},l10n:{type:"string",description:c.localize(76,null)}}};class g{constructor(){this.a=new Map}registerExtensionPoint(b){if(this.a.has(b.extensionPoint))throw new Error("Duplicate extension point: "+b.extensionPoint);const i=new f(b.extensionPoint,b.defaultExtensionKind);return this.a.set(b.extensionPoint,i),b.activationEventsGenerator&&k.ImplicitActivationEvents.register(b.extensionPoint,b.activationEventsGenerator),e.schema.properties.contributes.properties[b.extensionPoint]=b.jsonSchema,v.registerSchema(h,e.schema),i}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=g;const p={ExtensionsRegistry:"ExtensionsRegistry"};P.Registry.add(p.ExtensionsRegistry,new g),e.ExtensionsRegistry=P.Registry.as(p.ExtensionsRegistry),v.registerSchema(h,e.schema),v.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:c.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}}]}}}})}),define(ye[246],De([1,0,192,9,23,245,54,3]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:c.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:c.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:c.localize(2,null),default:""}}};var I;(function(v){function T(E,f,d){if(!E)return;const h=A.isString(E.type)?E.type:void 0;if(!h||h.length===0){d.error(c.localize(3,null));return}const g=[];if(Array.isArray(E.required))for(const p of E.required)A.isString(p)&&g.push(p);return{extensionId:f.value,taskType:h,required:g,properties:E.properties?u.deepClone(E.properties):{},when:E.when?C.ContextKeyExpr.deserialize(E.when):void 0}}v.from=T})(I||(I={}));const L=R.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:c.localize(4,null),type:"array",items:S}});class k{constructor(){this.d=new P.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((T,E)=>{L.setHandler((f,d)=>{this.c=void 0;try{for(const h of d.removed){const g=h.value;for(const p of g)this.a&&p.type&&this.a[p.type]&&delete this.a[p.type]}for(const h of d.added){const g=h.value;for(const p of g){const y=I.from(p,h.description.identifier,h.collector);y&&(this.a[y.taskType]=y)}}(d.removed.length>0||d.added.length>0)&&this.d.fire()}catch{}T(void 0)})})}onReady(){return this.b}get(T){return this.a[T]}all(){return Object.keys(this.a).map(T=>this.a[T])}getJsonSchema(){if(this.c===void 0){const T=[];for(const E of this.all()){const f={type:"object",additionalProperties:!1};E.required.length>0&&(f.required=E.required.slice(0)),E.properties!==void 0?f.properties=u.deepClone(E.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[E.taskType]},T.push(f)}this.c={oneOf:T}}return this.c}}e.TaskDefinitionRegistry=new k}),define(ye[247],De([1,0,193,9,24,23,54,246]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new C.RawContextKey("taskRunning",!1,c.localize(0,null)),e.TASKS_CATEGORY={value:c.localize(1,null),original:"Tasks"};var S;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(O){function U(z){if(!z)return O.Strong;switch(z.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=U}(S=e.ShellQuoting||(e.ShellQuoting={}));var I;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(I=e.CommandOptions||(e.CommandOptions={}));var L;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(L=e.RevealKind||(e.RevealKind={})),function(O){function U(z){switch(z.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=U}(L=e.RevealKind||(e.RevealKind={}));var k;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(k=e.RevealProblemKind||(e.RevealProblemKind={})),function(O){function U(z){switch(z.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=U}(k=e.RevealProblemKind||(e.RevealProblemKind={}));var v;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(v=e.PanelKind||(e.PanelKind={})),function(O){function U(z){switch(z.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=U}(v=e.PanelKind||(e.PanelKind={}));var T;(function(O){O.defaults={echo:!0,reveal:L.Always,revealProblems:k.Never,focus:!1,panel:v.Shared,showReuseMessage:!0,clear:!1}})(T=e.PresentationOptions||(e.PresentationOptions={}));var E;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(E=e.RuntimeType||(e.RuntimeType={})),function(O){function U(j){switch(j.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=U;function z(j){switch(j){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=z}(E=e.RuntimeType||(e.RuntimeType={}));var f;(function(O){function U(z){return A.isString(z)?z:z.value}O.value=U})(f=e.CommandString||(e.CommandString={}));var d;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function U(j){return j===O.Clean._id||j===O.Build._id||j===O.Rebuild._id||j===O.Test._id}O.is=U;function z(j){if(j!==void 0)return A.isString(j)?U(j)?{_id:j,isDefault:!1}:void 0:j}O.from=z})(d=e.TaskGroup||(e.TaskGroup={}));var h;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(h=e.TaskScope||(e.TaskScope={}));var g;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function U(z){switch(z){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=U})(g=e.TaskSourceKind||(e.TaskSourceKind={}));var p;(function(O){O.parallel="parallel",O.sequence="sequence"})(p=e.DependsOrder||(e.DependsOrder={}));var y;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(y=e.RunOnOptions||(e.RunOnOptions={}));var b;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:y.default,instanceLimit:1}})(b=e.RunOptions||(e.RunOptions={}));class i{constructor(U,z,j,de,V,X){this._label="",this._id=U,z&&(this._label=z),j&&(this.type=j),this.runOptions=de,this.configurationProperties=V,this._source=X}getDefinition(U){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const U={folder:this.d(),id:this._id};return JSON.stringify(U)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,z=!1){if(U===void 0)return!1;if(A.isString(U))return U===this._label||U===this.configurationProperties.identifier||z&&U===this._id;const j=this.getDefinition(!0);return j!==void 0&&j._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this.c===void 0&&(this.c=[]),U&&(this.c=this.c.concat(U))}get taskLoadMessages(){return this.c}}e.CommonTask=i;class o extends i{constructor(U,z,j,de,V,X,J,te){super(U,j,void 0,J,te,z),this.command={},this._source=z,this.hasDefinedMatchers=X,V&&(this.command=V)}clone(){return new o(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case E.Shell:z="shell";break;case E.Process:z="process";break;case E.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is(U){return U instanceof o}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const U=this.d();if(!U)return;let z=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(z+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:z};return JSON.stringify(j)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?u.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(U){return new o(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.CustomTask=o;class s extends i{constructor(U,z,j,de,V,X,J){super(U,j,de,X,J,z),this._source=z,this.configures=V}static is(U){return U instanceof s}f(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?u.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const U=this.d();if(!U)return;let z=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(z+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:z};return JSON.stringify(j)}}e.ConfiguringTask=s;class l extends i{constructor(U,z,j,de,V,X,J,te,ee){super(U,j,de,te,ee,z),this.defines=V,this.hasDefinedMatchers=J,this.command=X,this.icon=ee.icon,this.hide=ee.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof l}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.d(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(U){return new l(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.ContributedTask=l;class r extends i{constructor(U,z,j,de,V,X){super(U,j,de,V,X,z),this._source=z}clone(){return new r(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof r}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(U){return new r(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.InMemoryTask=r;var m;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(m=e.ExecutionEngine||(e.ExecutionEngine={})),function(O){O._default=O.Terminal}(m=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class t{constructor(U){this.c=new Map;for(let z=0;z<U.length;z++)this.c.set(U[z].uri.toString(),z)}compare(U,z){const j=U.getWorkspaceFolder(),de=z.getWorkspaceFolder();if(j&&de){let V=this.c.get(j.uri.toString());V=V===void 0?0:V+1;let X=this.c.get(de.uri.toString());return X=X===void 0?0:X+1,V===X?U._label.localeCompare(z._label):V-X}else return!j&&de?-1:j&&!de?1:0}}e.TaskSorter=t;var a;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(a=e.TaskEventKind||(e.TaskEventKind={}));var w;(function(O){O.SingleRun="singleRun",O.Background="background"})(w=e.TaskRunType||(e.TaskRunType={}));var D;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(D=e.TaskRunSource||(e.TaskRunSource={}));var F;(function(O){function U(z,j,de,V){if(j){const X={kind:z,taskId:j._id,taskName:j.configurationProperties.name,runType:j.configurationProperties.isBackground?"background":"singleRun",group:j.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:de,__task:j};return z==="start"?X.resolvedVariables=V:z==="processStarted"?X.processId=V:z==="processEnded"&&(X.exitCode=V),Object.freeze(X)}else return Object.freeze({kind:"changed"})}O.create=U})(F=e.TaskEvent||(e.TaskEvent={}));var x;(function(O){function U(j){const de=Object.keys(j).sort();let V="";for(const X of de){let J=j[X];J instanceof Object?J=U(J):typeof J=="string"&&(J=J.replace(/,/g,",,")),V+=X+","+J+","}return V}function z(j){const V={_key:U(j),type:j.taskType};return Object.assign(V,j),V}O.create=z})(x=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var q;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(q=e.TaskSettingId||(e.TaskSettingId={}));var M;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(M=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var B;(function(O){function U(z,j){const de=P.TaskDefinitionRegistry.get(z.type);if(de===void 0){const te=R.deepClone(z);return delete te._key,x.create(te)}const V=Object.create(null);V.type=de.taskType;const X=new Set;de.required.forEach(te=>X.add(te));const J=de.properties;for(const te of Object.keys(J)){const ee=z[te];if(ee!=null)V[te]=ee;else if(X.has(te)){const Q=J[te];if(Q.default!==void 0)V[te]=R.deepClone(Q.default);else switch(Q.type){case"boolean":V[te]=!1;break;case"number":case"integer":V[te]=0;break;case"string":V[te]="";break;default:j.error(c.localize(2,null,JSON.stringify(z,void 0,0),te));return}}}return x.create(V)}O.createTaskIdentifier=U})(B=e.TaskDefinition||(e.TaskDefinition={}))}),define(ye[248],De([1,0,11]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class A{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((C,P)=>{this.b=C,this.d=P,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(C){this.f||this.h||(this.f=!0,this.g=C,this.a&&this.b(C))}resolveErr(C){this.f||this.h||(this.h=!0,this.i=C,this.a?this.d(C):(0,c.onUnexpectedError)(C))}then(C,P){return this.j().then(C,P)}catch(C){return this.j().then(void 0,C)}finally(C){return this.j().finally(C)}}e.LazyPromise=A;class u extends A{constructor(){super(),this.h=!0,this.i=new c.CancellationError}}e.CanceledLazyPromise=u}),define(ye[58],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class c{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++c.count}}c.count=0,e.ProxyIdentifier=c;const A=[];function u(P){const S=new c(P);return A[S.nid]=S,S}e.createProxyIdentifier=u;function R(P){return A[P].sid}e.getStringIdentifierForProxy=R;class C{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=C}),define(ye[5],De([1,0,58]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var A;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var u;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput"})(u=e.TabInputKind||(e.TabInputKind={}));var R;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(R=e.TabModelOperationKind||(e.TabModelOperationKind={}));var C;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var P;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(P=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var I;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(I=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var L;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(L=e.CandidatePortSource||(e.CandidatePortSource={}));class k{static mixin(d){return d._id=k.a++,d}}k.a=0,e.IdObject=k;var v;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(v=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var T;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(T=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var E;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,c.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,c.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,c.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,c.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,c.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,c.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,c.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,c.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,c.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,c.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,c.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,c.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,c.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,c.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,c.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,c.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,c.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,c.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,c.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,c.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,c.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,c.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,c.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,c.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,c.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,c.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,c.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,c.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,c.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,c.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,c.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,c.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,c.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,c.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,c.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,c.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,c.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,c.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,c.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,c.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,c.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,c.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,c.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,c.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,c.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,c.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,c.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,c.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,c.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,c.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,c.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,c.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,c.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,c.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,c.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,c.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,c.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,c.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,c.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,c.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,c.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,c.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,c.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,c.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,c.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,c.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,c.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,c.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,c.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,c.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,c.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,c.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,c.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,c.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,c.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,c.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,c.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,c.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,c.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,c.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,c.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,c.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,c.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,c.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,c.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,c.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,c.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,c.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,c.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,c.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,c.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,c.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,c.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,c.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,c.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,c.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,c.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,c.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,c.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,c.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,c.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,c.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,c.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,c.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,c.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,c.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,c.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,c.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,c.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,c.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,c.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,c.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,c.createProxyIdentifier)("ExtHostLocalization")}}),define(ye[76],De([1,0,4,13,5,20]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(S,I){this.c=I,this.a=new Set,this.b=S.getProxy(u.MainContext.MainThreadTelemetry)}report(S,I,L){const k=this.d(S,I);this.a.has(k)||(this.a.add(k),I.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:S}))}d(S,I){return`${S}-${I.identifier.value}`}};C=qe([We(0,R.IExtHostRpcService),We(1,A.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(P,S,I){}})}),define(ye[249],De([1,0,3,5,7,26]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(S){this.b=new Map,this.c=[],this.d=new c.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=S.getProxy(A.MainContext.MainThreadAuthentication)}$setProviders(S){return this.c=S,Promise.resolve()}async getSession(S,I,L,k={}){const v=R.ExtensionIdentifier.toKey(S.identifier),T=this.f.get(v)||[],E=[...L].sort().join(" ");let f=T.find(d=>d.providerId===I&&d.scopes===E);if(f)return f.result;{const d=this.g(S,v,I,L,k);f={providerId:I,scopes:E,result:d},T.push(f),this.f.set(v,T);try{await d}finally{const h=T.findIndex(g=>g.providerId===I&&g.scopes===E);h>-1&&(T.splice(h),this.f.set(v,T))}return d}}async g(S,I,L,k,v={}){await this.a.$ensureProvider(L);const T=S.displayName||S.name;return this.a.$getSession(L,k,I,T,v)}async removeSession(S,I){const L=this.b.get(S);return L?L.provider.removeSession(I):this.a.$removeSession(S,I)}registerAuthenticationProvider(S,I,L,k){if(this.b.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this.b.set(S,{label:I,provider:L,options:k??{supportsMultipleAccounts:!1}}),this.c.find(T=>T.id===S)||this.c.push({id:S,label:I});const v=L.onDidChangeSessions(T=>{this.a.$sendDidChangeSessions(S,{added:T.added??[],changed:T.changed??[],removed:T.removed??[]})});return this.a.$registerAuthenticationProvider(S,I,k?.supportsMultipleAccounts??!1),new u.Disposable(()=>{v.dispose(),this.b.delete(S);const T=this.c.findIndex(E=>E.id===S);T>-1&&this.c.splice(T),this.a.$unregisterAuthenticationProvider(S)})}$createSession(S,I){const L=this.b.get(S);if(L)return Promise.resolve(L.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,I){const L=this.b.get(S);if(L)return Promise.resolve(L.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,I){const L=this.b.get(S);if(L)return Promise.resolve(L.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,I){return this.d.fire({provider:{id:S,label:I}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(ye[250],De([1,0,5,20,14]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let R=class{constructor(P,S){this.a=P.getProxy(c.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>S.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(P,S,I){const L=u.WorkspaceEdit.from(P,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,I?.isRefactoring??!1)}};R=qe([We(0,A.IExtHostRpcService)],R),e.ExtHostBulkEdits=R}),define(ye[251],De([1,0,5]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class A{constructor(R){const C=R.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(P){return C.$writeText(P)}})}}e.ExtHostClipboard=A});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!u:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(ne,c):u?u.value=c:e.set(ne,c),c},Be=this&&this.__classPrivateFieldGet||function(ne,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[40],De([1,0,9,7,14,23,5,15,13,69,32,52,2,6,4,20,137,22,58,45,43,73]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,f,d,h,g,p,y,b){"use strict";var i,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{constructor(a,w){i.set(this,void 0),this.b=new Map,this.c=new Map,o.set(this,void 0),Je(this,i,a.getProxy(C.MainContext.MainThreadCommands),"f"),this.d=w,Je(this,o,a.getProxy(C.MainContext.MainThreadTelemetry),"f"),this.converter=new l(this,D=>{const F=this.c.get(D);return F?.result===m.Void?F:void 0},w),this.f=[{processArgument(D){return(0,I.revive)(D)}},{processArgument(D){return(0,R.cloneAndChange)(D,function(F){if(L.Range.isIRange(F))return u.Range.to(F);if(k.Position.isIPosition(F))return u.Position.to(F);if(L.Range.isIRange(F.range)&&v.URI.isUri(F.uri))return u.location.to(F);if(F instanceof h.VSBuffer)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(a){this.f.push(a)}registerApiCommand(a){const w=this.registerCommand(!1,a.id,async(...D)=>{const F=a.args.map((q,M)=>{if(!q.validate(D[M]))throw new Error(`Invalid argument '${q.name}' when running '${a.id}', received: ${D[M]}`);return q.convert(D[M])}),x=await this.executeCommand(a.internalId,...F);return a.result.convert(x,D,this.converter)},void 0,{description:a.description,args:a.args,returns:a.result.description});return this.c.set(a.id,a),new A.Disposable(()=>{w.dispose(),this.c.delete(a.id)})}registerCommand(a,w,D,F,x,q){if(this.d.trace("ExtHostCommands#registerCommand",w),!w.trim().length)throw new Error("invalid id");if(this.b.has(w))throw new Error(`command '${w}' already exists`);return this.b.set(w,{callback:D,thisArg:F,description:x,extension:q}),a&&Be(this,i,"f").$registerCommand(w),new A.Disposable(()=>{this.b.delete(w)&&a&&Be(this,i,"f").$unregisterCommand(w)})}executeCommand(a,...w){return this.d.trace("ExtHostCommands#executeCommand",a),this.g(a,w,!0)}async g(a,w,D){if(this.b.has(a))return Be(this,i,"f").$fireCommandActivationEvent(a),this.h(a,w,!1);{let F=!1;const x=(0,R.cloneAndChange)(w,function(q){if(q instanceof A.Position)return u.Position.from(q);if(q instanceof A.Range)return u.Range.from(q);if(q instanceof A.Location)return u.location.from(q);if(A.NotebookRange.isNotebookRange(q))return u.NotebookRange.from(q);if(q instanceof ArrayBuffer)return F=!0,h.VSBuffer.wrap(new Uint8Array(q));if(q instanceof Uint8Array)return F=!0,h.VSBuffer.wrap(q);if(q instanceof h.VSBuffer)return F=!0,q;if(!Array.isArray(q))return q});try{const q=await Be(this,i,"f").$executeCommand(a,F?new g.SerializableObjectWithBuffers(x):x,D);return(0,I.revive)(q)}catch(q){if(q instanceof Error&&q.message==="$executeCommand:retry")return this.g(a,w,!1);throw q}}}async h(a,w,D){const F=this.b.get(a);if(!F)throw new Error("Unknown command");const{callback:x,thisArg:q,description:M}=F;if(M)for(let O=0;O<M.args.length;O++)try{(0,c.validateConstraint)(w[O],M.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${a}' failed. Illegal argument '${M.args[O].name}' - ${M.args[O].description}`)}const B=y.StopWatch.create();try{return await x.apply(q,w)}catch(O){if(a===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...w);U&&(a=U.command)}throw this.d.error(O,a,F.extension?.identifier),D?new class extends Error{constructor(){super((0,p.toErrorMessage)(O)),this.id=a,this.source=F.extension?.displayName??F.extension?.name}}:O}finally{this.j(F,a,B.elapsed())}}j(a,w,D){!a.extension||Be(this,o,"f").$publicLog2("Extension:ActionExecuted",{extensionId:a.extension.identifier.value,id:new b.TelemetryTrustedValue(w),duration:D})}$executeContributedCommand(a,...w){this.d.trace("ExtHostCommands#$executeContributedCommand",a);const D=this.b.get(a);return D?(w=w.map(F=>this.f.reduce((x,q)=>q.processArgument(x,D.extension?.identifier),F)),this.h(a,w,!0)):Promise.reject(new Error(`Contributed command '${a}' does not exist.`))}getCommands(a=!1){return this.d.trace("ExtHostCommands#getCommands",a),Be(this,i,"f").$getCommands().then(w=>(a&&(w=w.filter(D=>D[0]!=="_")),w))}$getContributedCommandHandlerDescriptions(){const a=Object.create(null);for(const[w,D]of this.b){const{description:F}=D;F&&(a[w]=F)}return Promise.resolve(a)}};i=new WeakMap,o=new WeakMap,s=qe([We(0,f.IExtHostRpcService),We(1,S.ILogService)],s),e.ExtHostCommands=s,e.IExtHostCommands=(0,E.createDecorator)("IExtHostCommands");class l{constructor(a,w,D){this.d=a,this.f=w,this.g=D,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(a,w){if(!a)return;const D={$ident:void 0,id:a.command,title:a.title,tooltip:a.tooltip};if(!a.command)return D;const F=this.f(a.command);if(F)D.id=F.internalId,D.arguments=F.args.map((x,q)=>x.convert(a.arguments&&a.arguments[q]));else if((0,P.isNonEmptyArray)(a.arguments)){const x=`${a.command}/${++this.c}`;this.b.set(x,a),w.add((0,T.toDisposable)(()=>{this.b.delete(x),this.g.trace("CommandsConverter#DISPOSE",x)})),D.$ident=x,D.id=this.delegatingCommandId,D.arguments=[x],this.g.trace("CommandsConverter#CREATE",a.command,x)}return D}fromInternal(a){return typeof a.$ident=="string"?this.b.get(a.$ident):{command:a.id,title:a.title,arguments:a.arguments}}getActualCommand(...a){return this.b.get(a[0])}h(...a){const w=this.getActualCommand(...a);return this.g.trace("CommandsConverter#EXECUTE",a[0],w?w.command:"MISSING"),w?this.d.executeCommand(w.command,...w.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${a[0]}`)}}e.CommandsConverter=l;class r{constructor(a,w,D,F){this.name=a,this.description=w,this.validate=D,this.convert=F}optional(){return new r(this.name,`(optional) ${this.description}`,a=>a==null||this.validate(a),a=>a===void 0?void 0:a===null?null:this.convert(a))}with(a,w){return new r(a??this.name,w??this.description,this.validate,this.convert)}}r.Uri=new r("uri","Uri of a text document",t=>v.URI.isUri(t),t=>t),r.Position=new r("position","A position in a text document",t=>A.Position.isPosition(t),u.Position.from),r.Range=new r("range","A range in a text document",t=>A.Range.isRange(t),u.Range.from),r.Selection=new r("selection","A selection in a text document",t=>A.Selection.isSelection(t),u.Selection.from),r.Number=new r("number","",t=>typeof t=="number",t=>t),r.String=new r("string","",t=>typeof t=="string",t=>t),r.CallHierarchyItem=new r("item","A call hierarchy item",t=>t instanceof A.CallHierarchyItem,u.CallHierarchyItem.from),r.TypeHierarchyItem=new r("item","A type hierarchy item",t=>t instanceof A.TypeHierarchyItem,u.TypeHierarchyItem.from),r.TestItem=new r("testItem","A VS Code TestItem",t=>t instanceof d.TestItemImpl,u.TestItem.from),e.ApiCommandArgument=r;class m{constructor(a,w){this.description=a,this.convert=w}}m.Void=new m("no result",t=>t),e.ApiCommandResult=m;class n{constructor(a,w,D,F,x){this.id=a,this.internalId=w,this.description=D,this.args=F,this.result=x}}e.ApiCommand=n}),define(ye[252],De([1,0,2,14,7,71,40,15,120,125,18]),function(ne,e,c,A,u,R,C,P,S,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const k=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",T(A.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(f,d)=>{if((0,P.isFalsyOrEmpty)(f))return;class h extends u.SymbolInformation{static to(p){const y=new h(p.name,A.SymbolKind.to(p.kind),p.containerName||"",new u.Location(d[0],A.Range.to(p.range)));return y.detail=p.detail,y.range=y.location.range,y.selectionRange=A.Range.to(p.selectionRange),y.children=p.children?p.children.map(h.to):[],y}}return f.map(h.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(A.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(A.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",f=>typeof f=="string",f=>f),new C.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(A.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(A.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(A.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",f=>Array.isArray(f)&&f.every(d=>u.Position.isPosition(d)),f=>f.map(A.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",f=>f.map(d=>{let h;for(const g of d.reverse())h=new u.SelectionRange(A.Range.to(g),h);return h}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",f=>f.map(A.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",f=>f.map(A.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",f=>f.map(A.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",f=>f.map(A.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",f=>{if(!!f)return{range:A.Range.to(f.range),placeholder:f.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",f=>{if(!!f){if(f.rejectReason)throw new Error(f.rejectReason);return A.WorkspaceEdit.to(f)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",f=>f.map(A.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",f=>{if(!!f)return new u.SemanticTokensLegend(f.tokenTypes,f.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",f=>{if(!f)return;const d=(0,S.decodeSemanticTokensDto)(f);if(d.type==="full")return new u.SemanticTokens(d.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",f=>{if(!!f)return new u.SemanticTokensLegend(f.tokenTypes,f.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",f=>{if(!f)return;const d=(0,S.decodeSemanticTokensDto)(f);if(d.type==="full")return new u.SemanticTokens(d.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(f,d,h)=>{if(!f)return new u.CompletionList([]);const g=f.suggestions.map(p=>A.CompletionItem.to(p,h));return new u.CompletionList(g,f.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",f=>{if(f)return A.SignatureHelp.to(f)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(f,d,h)=>T(g=>new u.CodeLens(A.Range.to(g.range),g.command&&h.fromInternal(g.command)))(f))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",f=>u.Range.isRange(f),f=>u.Selection.isSelection(f)?A.Selection.from(f):A.Range.from(f)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(f,d,h)=>T(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(g.command)}else{const p=new u.CodeAction(g.title,g.kind?new u.CodeActionKind(g.kind):void 0);return g.edit&&(p.edit=A.WorkspaceEdit.to(g.edit)),g.command&&(p.command=h.fromInternal(g.command)),p.isPreferred=g.isPreferred,p}})(f))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",f=>f?f.map(d=>new u.ColorInformation(A.Range.to(d.range),A.Color.to(d.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",f=>f instanceof u.Color,A.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",f=>!0,f=>({uri:f.uri,range:A.Range.from(f.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",f=>f?f.map(A.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(f,d,h)=>f.map(A.InlayHint.to.bind(void 0,h)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",T(f=>({viewType:f.viewType,displayName:f.displayName,options:{transientOutputs:f.options.transientOutputs,transientCellMetadata:f.options.transientCellMetadata,transientDocumentMetadata:f.options.transientDocumentMetadata},filenamePattern:f.filenamePattern.map(d=>A.NotebookExclusiveDocumentPattern.to(d))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",f=>f.map(A.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new C.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",f=>c.URI.isUri(f)||typeof f=="string"&&(0,I.matchesSomeScheme)(f,L.Schemas.http,L.Schemas.https),f=>f),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="number"||typeof f=="object",f=>f&&(typeof f=="number"?[A.ViewColumn.from(f),void 0]:[A.ViewColumn.from(f.viewColumn),A.TextEditorOpenOptions.from(f)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="number"||typeof f=="object",f=>f&&(typeof f=="number"?[A.ViewColumn.from(f),void 0]:[A.ViewColumn.from(f.viewColumn),A.TextEditorOpenOptions.from(f)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="object",f=>f&&[A.ViewColumn.from(f.viewColumn),A.TextEditorOpenOptions.from(f)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(A.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(A.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(A.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void),new C.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[C.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],C.ApiCommandResult.Void),new C.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[C.ApiCommandArgument.String.with("name","The context key name"),new C.ApiCommandArgument("value","The context key value",()=>!0,f=>f)],C.ApiCommandResult.Void)];class v{static register(d){k.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=v;function T(f){return d=>{if(Array.isArray(d))return d.map(f)}}function E(f){if(!Array.isArray(f))return;const d=[];for(const h of f)R.isLocationLink(h)?d.push(A.DefinitionLink.to(h)):d.push(A.location.to(h));return d}}),define(ye[253],De([1,0,19,62,3,6,2,71,26,14,7,5]),function(ne,e,c,A,u,R,C,P,S,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function v(T,E,f){const d=T.getProxy(k.MainContext.MainThreadComments);class h{constructor(){this.b=new Map,this.c=new Map,E.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const m=this.b.get(r.handle);return m?m.value:r}else if(r&&r.$mid===7){const m=this.b.get(r.commentControlHandle);if(!m)return r;const n=m.getCommentThread(r.commentThreadHandle);return n?n.value:r}else if(r&&(r.$mid===9||r.$mid===8)){const m=this.b.get(r.thread.commentControlHandle);if(!m)return r;const n=m.getCommentThread(r.thread.commentThreadHandle);return n?r.$mid===8?n.value:{thread:n.value,text:r.text}:r}else if(r&&r.$mid===10){const m=this.b.get(r.thread.commentControlHandle);if(!m)return r;const n=m.getCommentThread(r.thread.commentThreadHandle);if(!n)return r;const t=r.commentUniqueId,a=n.getCommentByUniqueId(t);return a||r}else if(r&&r.$mid===11){const m=this.b.get(r.thread.commentControlHandle);if(!m)return r;const n=m.getCommentThread(r.thread.commentThreadHandle);if(!n)return r;const t=r.text,a=r.commentUniqueId,w=n.getCommentByUniqueId(a);return w?(typeof w.body=="string"?w.body=t:w.body=new L.MarkdownString(t),w):r}return r}})}createCommentController(r,m,n){const t=h.a++,a=new p(r,t,m,n);this.b.set(a.handle,a);const w=this.c.get(S.ExtensionIdentifier.toKey(r.identifier))||[];return w.push(a),this.c.set(S.ExtensionIdentifier.toKey(r.identifier),w),a.value}$createCommentThreadTemplate(r,m,n){const t=this.b.get(r);!t||t.$createCommentThreadTemplate(m,n)}async $updateCommentThreadTemplate(r,m,n){const t=this.b.get(r);!t||t.$updateCommentThreadTemplate(m,n)}$deleteCommentThread(r,m){this.b.get(r)?.$deleteCommentThread(m)}$provideCommentingRanges(r,m,n){const t=this.b.get(r);if(!t||!t.commentingRangeProvider)return Promise.resolve(void 0);const a=f.getDocument(C.URI.revive(m));return(0,c.asPromise)(()=>t.commentingRangeProvider.provideCommentingRanges(a,n)).then(w=>w?w.map(D=>I.Range.from(D)):void 0)}$toggleReaction(r,m,n,t,a){const w=this.b.get(r);return!w||!w.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const D=w.getCommentThread(m);if(D){const F=D.getCommentByUniqueId(t.uniqueIdInThread);if(w!==void 0&&F&&w.reactionHandler)return w.reactionHandler(F,i(a))}return Promise.resolve(void 0)})}dispose(){}}h.a=0;class g{set threadId(r){this.n=r}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(r){r.isEqual(this.p)||(this.p=r,this.b.range=r,this.c.fire())}get range(){return this.p}set canReply(r){this.d!==r&&(this.d=r,this.b.canReply=r,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(r){this.e=r,this.b.label=r,this.c.fire()}get contextValue(){return this.f}set contextValue(r){this.f=r,this.b.contextValue=r,this.c.fire()}get comments(){return this.q}set comments(r){this.q=r,this.b.comments=r,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(r){this.g=r,this.b.collapsibleState=r,this.c.fire()}get state(){return this.h}set state(r){this.h=r,this.b.state=r,this.c.fire()}get isDisposed(){return this.j}constructor(r,m,n,t,a,w,D,F){this.m=m,this.n=n,this.o=t,this.p=a,this.q=w,this.extensionDescription=D,this.r=F,this.handle=g.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new u.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.MutableDisposable,this.l.value=new R.DisposableStore,this.n===void 0&&(this.n=`${r}.${this.handle}`),d.$createCommentThread(m,this.handle,this.n,this.o,I.Range.from(this.p),D.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=w,this.i.push({dispose:()=>{d.$deleteCommentThread(m,this.handle)}});const x=this;this.value={get uri(){return x.uri},get range(){return x.range},set range(q){x.range=q},get comments(){return x.comments},set comments(q){x.comments=q},get collapsibleState(){return x.collapsibleState},set collapsibleState(q){x.collapsibleState=q},get canReply(){return x.canReply},set canReply(q){x.canReply=q},get contextValue(){return x.contextValue},set contextValue(q){x.contextValue=q},get label(){return x.label},set label(q){x.label=q},get state(){return x.state},set state(q){x.state=q},dispose:()=>{x.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.DisposableStore);const r=n=>Object.prototype.hasOwnProperty.call(this.b,n),m={};r("range")&&(m.range=I.Range.from(this.p)),r("label")&&(m.label=this.label),r("contextValue")&&(m.contextValue=this.contextValue??null),r("comments")&&(m.comments=this.q.map(n=>y(this,n,this.k))),r("collapsibleState")&&(m.collapseState=o(this.g)),r("canReply")&&(m.canReply=this.canReply),r("state")&&(m.state=s(this.h)),r("isTemplate")&&(m.isTemplate=this.r),this.b={},d.$updateCommentThread(this.m,this.handle,this.n,this.o,m)}getCommentByUniqueId(r){for(const m of this.k){const n=m[0],t=m[1];if(r===t)return n}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(r=>r.dispose())}}g.a=0,qe([(0,A.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null);class p{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(r){this.b=r,d.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(r){this.c=r,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!r})}get options(){return this.d}set options(r){this.d=r,d.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(r,m,n,t){this.f=r,this.g=m,this.h=n,this.i=t,this.a=new Map,d.$registerCommentController(this.handle,n,t);const a=this;this.value=Object.freeze({id:a.id,label:a.label,get options(){return a.options},set options(w){a.options=w},get commentingRangeProvider(){return a.commentingRangeProvider},set commentingRangeProvider(w){a.commentingRangeProvider=w},get reactionHandler(){return a.reactionHandler},set reactionHandler(w){a.reactionHandler=w},createCommentThread(w,D,F){return a.createCommentThread(w,D,F).value},dispose:()=>{a.dispose()}}),this.e=[],this.e.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}createCommentThread(r,m,n,t){if(typeof r=="string"){const a=new g(this.id,this.handle,r,m,n,t,this.f,!1);return this.a.set(a.handle,a),a}else{const a=new g(this.id,this.handle,void 0,r,m,n,this.f,!1);return this.a.set(a.handle,a),a}}$createCommentThreadTemplate(r,m){const n=new g(this.id,this.handle,void 0,C.URI.revive(r),I.Range.to(m),[],this.f,!0);return n.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this.a.set(n.handle,n),n}$updateCommentThreadTemplate(r,m){const n=this.a.get(r);n&&(n.range=I.Range.to(m))}$deleteCommentThread(r){this.a.get(r)?.dispose(),this.a.delete(r)}getCommentThread(r){return this.a.get(r)}dispose(){this.a.forEach(r=>{r.dispose()}),this.e.forEach(r=>r.dispose())}}function y(l,r,m){let n=m.get(r);n||(n=++l.commentHandle,m.set(r,n));const t=r.author&&r.author.iconPath?r.author.iconPath.toString():void 0;return{mode:r.mode,contextValue:r.contextValue,uniqueIdInThread:n,body:typeof r.body=="string"?r.body:I.MarkdownString.from(r.body),userName:r.author.name,userIconPath:t,label:r.label,commentReactions:r.reactions?r.reactions.map(a=>b(a)):void 0,timestamp:r.timestamp?.toJSON()}}function b(l){return{label:l.label,iconPath:l.iconPath?I.pathOrURIToURI(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function i(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?C.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function o(l){if(l!==void 0)switch(l){case L.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}function s(l){if(l!==void 0)switch(l){case L.CommentThreadState.Unresolved:return P.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return P.CommentThreadState.Resolved}return P.CommentThreadState.Unresolved}return new h}e.createExtHostComments=v}),define(ye[254],De([1,0,23,5,25,20]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let C=class{constructor(L,k){this.a=L.getProxy(A.MainContext.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(L,k){const v=this,T=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){v.e(L,k,T,arguments)}})}e(L,k,v,T){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:S(T,this.b)}),this.c&&this.f(L,v,T)}};C=qe([We(0,R.IExtHostRpcService),We(1,u.IExtHostInitDataService)],C),e.AbstractExtHostConsoleForwarder=C;const P=1e5;function S(I,L){const k=[];if(I.length)for(let v=0;v<I.length;v++){let T=I[v];if(typeof T>"u")T="undefined";else if(T instanceof Error){const E=T;E.stack?T=E.stack:T=E.toString()}k.push(T)}if(L){const v=new Error().stack;v&&k.push({__$stack:v.split(`
`).slice(3).join(`
`)})}try{const v=(0,c.safeStringify)(k);return v.length>P?"Output omitted for a large object that exceeds the limits":v}catch(v){return`Output omitted for an object that cannot be inspected ('${v.toString()}')`}}}),define(ye[139],De([1,0,2,5,7,4,20,13,15,8,10,27]),function(ne,e,c,A,u,R,C,P,S,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let v=class Mi{constructor(E,f){this.h=f,this.f=new Map,this.g=E.getProxy(A.MainContext.MainThreadDecorations)}registerFileDecorationProvider(E,f){const d=Mi.c++;this.f.set(d,{provider:E,extensionDescription:f}),this.g.$registerDecorationProvider(d,f.identifier.value);const h=E.onDidChangeFileDecorations&&E.onDidChangeFileDecorations(g=>{if(!g){this.g.$onDidChange(d,null);return}const p=(0,S.asArray)(g);if(p.length<=Mi.d){this.g.$onDidChange(d,p);return}this.h.warn("[Decorations] CAPPING events from decorations provider",f.identifier.value,p.length);const y=p.map(o=>({uri:o,rank:(0,I.count)(o.path,"/")})),b=(0,S.groupBy)(y,(o,s)=>o.rank-s.rank||(0,I.compare)(o.uri.path,s.uri.path)),i=[];e:for(const o of b){let s;for(const l of o){const r=(0,L.dirname)(l.uri.path);if(s!==r&&(s=r,i.push(l.uri)>=Mi.d))break e}}this.g.$onDidChange(d,i)});return new u.Disposable(()=>{h?.dispose(),this.g.$unregisterDecorationProvider(d),this.f.delete(d)})}async $provideDecorations(E,f,d){if(!this.f.has(E))return Object.create(null);const h=Object.create(null),{provider:g,extensionDescription:p}=this.f.get(E);return await Promise.all(f.map(async y=>{try{const{uri:b,id:i}=y,o=await Promise.resolve(g.provideFileDecoration(c.URI.revive(b),d));if(!o)return;try{u.FileDecoration.validate(o),o.badge&&typeof o.badge!="string"&&(0,k.checkProposedApiEnabled)(p,"codiconDecoration"),h[i]=[o.propagate,o.tooltip,o.badge,o.color]}catch(s){this.h.warn(`INVALID decoration from extension '${p}': ${s}`)}}catch(b){this.h.error(b)}})),h}};v.c=0,v.d=250,v=qe([We(0,C.IExtHostRpcService),We(1,P.ILogService)],v),e.ExtHostDecorations=v,e.IExtHostDecorations=(0,R.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!u:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(ne,c):u?u.value=c:e.set(ne,c),c},Be=this&&this.__classPrivateFieldGet||function(ne,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[255],De([1,0,177,124,2,5,7,14,3,13,28,48]),function(ne,e,c,A,u,R,C,P,S,I,L,k){"use strict";var v,T,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class f{constructor(g,p,y,b,i,o,s){this.d=g,this.e=p,this.f=y,this.g=b,v.set(this,void 0),T.set(this,void 0),E.set(this,void 0),this.c=!1,Je(this,E,new L.ResourceMap(l=>i.getComparisonKey(l)),"f"),Je(this,v,o,"f"),Je(this,T,s,"f")}dispose(){this.c||(Be(this,T,"f").fire([...Be(this,E,"f").keys()]),Be(this,v,"f")?.$clear(this.e),Be(this,E,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(g,p){if(!g){this.clear();return}this.h();let y=[];if(u.URI.isUri(g)){if(!p){this.delete(g);return}Be(this,E,"f").set(g,p.slice()),y=[g]}else if(Array.isArray(g)){y=[];let i;g=[...g].sort(f.j);for(const o of g){const[s,l]=o;if((!i||s.toString()!==i.toString())&&(i&&Be(this,E,"f").get(i).length===0&&Be(this,E,"f").delete(i),i=s,y.push(s),Be(this,E,"f").set(s,[])),l)Be(this,E,"f").get(s)?.push(...l);else{const r=Be(this,E,"f").get(s);r&&(r.length=0)}}}if(Be(this,T,"f").fire(y),!Be(this,v,"f"))return;const b=[];for(const i of y){let o=[];const s=Be(this,E,"f").get(i);if(s)if(s.length>this.f){o=[];const l=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(const m of s)if(m.severity===l[r]&&o.push({...P.Diagnostic.from(m),modelVersionId:this.g(i)})===this.f)break e;o.push({severity:A.MarkerSeverity.Info,message:(0,c.localize)(0,null,s.length-this.f),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=s.map(l=>({...P.Diagnostic.from(l),modelVersionId:this.g(i)}));b.push([i,o])}Be(this,v,"f").$changeMany(this.e,b)}delete(g){this.h(),Be(this,T,"f").fire([g]),Be(this,E,"f").delete(g),Be(this,v,"f")?.$changeMany(this.e,[[g,void 0]])}clear(){this.h(),Be(this,T,"f").fire([...Be(this,E,"f").keys()]),Be(this,E,"f").clear(),Be(this,v,"f")?.$clear(this.e)}forEach(g,p){this.h();for(const[y,b]of this)g.call(p,y,b,this)}*[(v=new WeakMap,T=new WeakMap,E=new WeakMap,Symbol.iterator)](){this.h();for(const g of Be(this,E,"f").keys())yield[g,this.get(g)]}get(g){this.h();const p=Be(this,E,"f").get(g);return Array.isArray(p)?Object.freeze(p.slice(0)):[]}has(g){return this.h(),Array.isArray(Be(this,E,"f").get(g))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(g,p){return g[0].toString()<p[0].toString()?-1:g[0].toString()>p[0].toString()?1:0}}e.DiagnosticCollection=f;let d=class pi{static _mapper(g){const p=new L.ResourceMap;for(const y of g)p.set(y,y);return{uris:Object.freeze(Array.from(p.values()))}}constructor(g,p,y,b){this.h=p,this.j=y,this.k=b,this.f=new Map,this.g=new S.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.g.event,pi._mapper),this.e=g.getProxy(R.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(g,p){const{f:y,e:b,g:i,h:o,j:s,k:l}=this,r=new class{$changeMany(t,a){b.$changeMany(t,a),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,t,a.length===0?"CLEARING":a)}$clear(t){b.$clear(t),o.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,t)}dispose(){b.dispose()}};let m;if(!p)p="_generated_diagnostic_collection_name_#"+pi.c++,m=p;else if(!y.has(p))m=p;else{this.h.warn(`DiagnosticCollection with name '${p}' does already exist.`);do m=p+pi.c++;while(y.has(m))}return new class extends f{constructor(){super(p,m,pi.d,t=>l.getDocument(t)?.version,s.extUri,r,i),y.set(m,this)}dispose(){super.dispose(),y.delete(m)}}}getDiagnostics(g){if(g)return this.l(g);{const p=new Map,y=[];for(const b of this.f.values())b.forEach((i,o)=>{let s=p.get(i.toString());typeof s>"u"&&(s=y.length,p.set(i.toString(),s),y.push([i,[]])),y[s][1]=y[s][1].concat(...o)});return y}}l(g){let p=[];for(const y of this.f.values())y.has(g)&&(p=p.concat(y.get(g)));return p}$acceptMarkersChange(g){if(!this.m){const p="_generated_mirror",y=new f(p,p,pi.d,b=>{},this.j.extUri,void 0,this.g);this.f.set(p,y),this.m=y}for(const[p,y]of g)this.m.set(u.URI.revive(p),y.map(P.Diagnostic.to))}};d.c=0,d.d=1e3,d=qe([We(1,I.ILogService),We(2,k.IExtHostFileSystemInfo)],d),e.ExtHostDiagnostics=d}),define(ye[256],De([1,0,2,5]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class u{constructor(C){this.a=C.getProxy(A.MainContext.MainThreadDialogs)}showOpenDialog(C){return this.a.$showOpenDialog(C).then(P=>P?P.map(S=>c.URI.revive(S)):void 0)}showSaveDialog(C){return this.a.$showSaveDialog(C).then(P=>P?c.URI.revive(P):void 0)}}e.ExtHostDialogs=u}),define(ye[257],De([1,0,11,2,7,5,18,21,8]),function(ne,e,c,A,u,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(k,v,T){this.d=v,this.e=T,this.b=new Map,this.c=k.getProxy(R.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,v){if(Object.keys(C.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const T=I.a++;this.b.set(T,v),this.c.$registerTextContentProvider(T,k);let E;return typeof v.onDidChange=="function"&&(E=v.onDidChange(f=>{if(f.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this.d.getDocument(f)&&this.$provideTextDocumentContent(T,f).then(d=>{if(!d&&typeof d!="string")return;const h=this.d.getDocument(f);if(!h)return;const g=(0,S.splitLines)(d);if(!h.equalLines(g))return this.c.$onVirtualDocumentChange(f,d)},c.onUnexpectedError)})),new u.Disposable(()=>{this.b.delete(T)&&this.c.$unregisterTextContentProvider(T),E&&(E.dispose(),E=void 0)})}$provideTextDocumentContent(k,v){const T=this.b.get(k);return T?Promise.resolve(T.provideTextDocumentContent(A.URI.revive(v),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}I.a=0,e.ExtHostDocumentContentProvider=I}),define(ye[258],De([1,0,3,6,2,5,135,14,9,23,7]),function(ne,e,c,A,u,R,C,P,S,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class k{constructor(T,E){this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter,this.d=new c.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new A.DisposableStore,this.h=new Map,this.f=T.getProxy(R.MainContext.MainThreadDocuments),this.g=E,this.g.onDidRemoveDocuments(f=>{for(const d of f)this.b.fire(d.document)},void 0,this.e),this.g.onDidAddDocuments(f=>{for(const d of f)this.a.fire(d.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(T){if(!T)return;const E=this.g.getDocument(T);if(E)return E}getDocument(T){const E=this.getDocumentData(T);if(!E?.document)throw new Error(`Unable to retrieve document from URI '${T}'`);return E.document}ensureDocumentData(T){const E=this.g.getDocument(T);if(E)return Promise.resolve(E);let f=this.h.get(T.toString());return f||(f=this.f.$tryOpenDocument(T).then(d=>{this.h.delete(T.toString());const h=u.URI.revive(d);return(0,S.assertIsDefined)(this.g.getDocument(h))},d=>(this.h.delete(T.toString()),Promise.reject(d))),this.h.set(T.toString(),f)),f}createDocumentData(T){return this.f.$tryCreateDocument(T).then(E=>u.URI.revive(E))}$acceptModelLanguageChanged(T,E){const f=u.URI.revive(T),d=this.g.getDocument(f);if(!d)throw new Error("unknown document");this.b.fire(d.document),d._acceptLanguageId(E),this.a.fire(d.document)}$acceptModelSaved(T){const E=u.URI.revive(T),f=this.g.getDocument(E);if(!f)throw new Error("unknown document");this.$acceptDirtyStateChanged(T,!1),this.d.fire(f.document)}$acceptDirtyStateChanged(T,E){const f=u.URI.revive(T),d=this.g.getDocument(f);if(!d)throw new Error("unknown document");d._acceptIsDirty(E),this.c.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(T,E,f){const d=u.URI.revive(T),h=this.g.getDocument(d);if(!h)throw new Error("unknown document");h._acceptIsDirty(f),h.onEvents(E);let g;E.isUndoing?g=L.TextDocumentChangeReason.Undo:E.isRedoing&&(g=L.TextDocumentChangeReason.Redo),this.c.fire((0,I.deepFreeze)({document:h.document,contentChanges:E.changes.map(p=>({range:P.Range.to(p.range),rangeOffset:p.rangeOffset,rangeLength:p.rangeLength,text:p.text})),reason:g}))}setWordDefinitionFor(T,E){(0,C.setWordDefinitionFor)(T,E)}}e.ExtHostDocuments=k}),define(ye[59],De([1,0,50,3,6,2,4,5,135,20,138,14,13,28,18,64,65]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class h{constructor(y){this.value=y,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let g=class{constructor(y,b){this.h=y,this.i=b,this.a=null,this.b=new Map,this.c=new T.ResourceMap,this.d=new A.Emitter,this.e=new A.Emitter,this.f=new A.Emitter,this.g=new A.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(y){this.acceptDocumentsAndEditorsDelta(y)}acceptDocumentsAndEditorsDelta(y){const b=[],i=[],o=[];if(y.removedDocuments)for(const s of y.removedDocuments){const l=R.URI.revive(s),r=this.c.get(l);r?.unref()&&(this.c.delete(l),b.push(r.value))}if(y.addedDocuments)for(const s of y.addedDocuments){const l=R.URI.revive(s.uri);let r=this.c.get(l);if(r&&l.scheme!==E.Schemas.vscodeNotebookCell&&l.scheme!==E.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);r||(r=new h(new S.ExtHostDocumentData(this.h.getProxy(P.MainContext.MainThreadDocuments),l,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(l,r),i.push(r.value)),r.ref()}if(y.removedEditors)for(const s of y.removedEditors){const l=this.b.get(s);this.b.delete(s),l&&o.push(l)}if(y.addedEditors)for(const s of y.addedEditors){const l=R.URI.revive(s.documentUri);c.ok(this.c.has(l),`document '${l}' does not exist`),c.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const r=this.c.get(l).value,m=new L.ExtHostTextEditor(s.id,this.h.getProxy(P.MainContext.MainThreadTextEditors),this.i,new d.Lazy(()=>r.document),s.selections.map(k.Selection.to),s.options,s.visibleRanges.map(n=>k.Range.to(n)),typeof s.editorPosition=="number"?k.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,m)}y.newActiveEditor!==void 0&&(c.ok(y.newActiveEditor===null||this.b.has(y.newActiveEditor),`active editor '${y.newActiveEditor}' does not exist`),this.a=y.newActiveEditor),(0,u.dispose)(b),(0,u.dispose)(o),y.removedDocuments&&this.e.fire(b),y.addedDocuments&&this.d.fire(i),(y.removedEditors||y.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),y.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(y){return this.c.get(y)?.value}allDocuments(){return f.Iterable.map(this.c.values(),y=>y.value)}getEditor(y){return this.b.get(y)}activeEditor(y){if(!this.a)return;const b=this.b.get(this.a);return y?b:b?.value}allEditors(){return[...this.b.values()]}};g=qe([We(0,I.IExtHostRpcService),We(1,v.ILogService)],g),e.ExtHostDocumentsAndEditors=g,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[60],De([1,0,14,5,2,3,4,7,20,9,61]),function(ne,e,c,A,u,R,C,P,S,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class k{constructor(d,h,g){this.e=g,this.d=h,this.acceptDtoUpdate(d)}get apiObject(){if(!this.a){const d=this,h={get isActive(){return d.b.id===d.e()},get label(){return d.b.label},get input(){return d.c},get isDirty(){return d.b.isDirty},get isPinned(){return d.b.isPinned},get isPreview(){return d.b.isPreview},get group(){return d.d.apiObject}};this.a=Object.freeze(h)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(d){this.b=d,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new P.TextTabInput(u.URI.revive(this.b.input.uri));case 2:return new P.TextDiffTabInput(u.URI.revive(this.b.input.original),u.URI.revive(this.b.input.modified));case 3:return new P.TextMergeTabInput(u.URI.revive(this.b.input.base),u.URI.revive(this.b.input.input1),u.URI.revive(this.b.input.input2),u.URI.revive(this.b.input.result));case 6:return new P.CustomEditorTabInput(u.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new P.WebviewEditorTabInput(this.b.input.viewType);case 4:return new P.NotebookEditorTabInput(u.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new P.NotebookDiffEditorTabInput(u.URI.revive(this.b.input.original),u.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new P.TerminalEditorTabInput;case 9:return new P.InteractiveWindowInput(u.URI.revive(this.b.input.uri),u.URI.revive(this.b.input.inputBoxUri));default:return}}}class v{constructor(d,h){this.c=[],this.d="",this.b=d,this.e=h;for(const g of d.tabs)g.isActive&&(this.d=g.id),this.c.push(new k(g,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const d=this,h={get isActive(){return d.b.groupId===d.e()},get viewColumn(){return c.ViewColumn.to(d.b.viewColumn)},get activeTab(){return d.c.find(g=>g.tabId===d.d)?.apiObject},get tabs(){return Object.freeze(d.c.map(g=>g.apiObject))}};this.a=Object.freeze(h)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(d){this.b=d}acceptTabOperation(d){if(d.kind===0){const g=new k(d.tabDto,this,()=>this.activeTabId());return this.c.splice(d.index,0,g),d.tabDto.isActive&&(this.d=g.tabId),g}else if(d.kind===1){const g=this.c.splice(d.index,1)[0];if(!g)throw new Error(`Tab close updated received for index ${d.index} which does not exist`);return g.tabId===this.d&&(this.d=""),g}else if(d.kind===3){if(d.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const g=this.c.splice(d.oldIndex,1)[0];if(!g)throw new Error(`Tab move updated received for index ${d.oldIndex} which does not exist`);return this.c.splice(d.index,0,g),g}const h=this.c.find(g=>g.tabId===d.tabDto.id);if(!h)throw new Error("INVALID tab");return d.tabDto.isActive?this.d=d.tabDto.id:this.d===d.tabDto.id&&!d.tabDto.isActive&&(this.d=""),h.acceptDtoUpdate(d.tabDto),h}activeTabId(){return this.d}}let T=class{constructor(d){this.b=new R.Emitter,this.c=new R.Emitter,this.e=[],this.a=d.getProxy(A.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const d=this,h={onDidChangeTabGroups:d.c.event,onDidChangeTabs:d.b.event,get all(){return Object.freeze(d.e.map(g=>g.apiObject))},get activeTabGroup(){const g=d.d;return(0,I.assertIsDefined)(d.e.find(y=>y.groupId===g)?.apiObject)},close:async(g,p)=>{const y=Array.isArray(g)?g:[g];return y.length?E(y[0])?this.j(y,p):this.i(y,p):!0}};this.f=Object.freeze(h)}return this.f}$acceptEditorTabModel(d){const h=new Set(this.e.map(s=>s.groupId)),g=new Set(d.map(s=>s.groupId)),p=(0,L.diffSets)(h,g),y=this.e.filter(s=>p.removed.includes(s.groupId)).map(s=>s.apiObject),b=[],i=[];this.e=d.map(s=>{const l=new v(s,()=>this.d);return p.added.includes(l.groupId)?b.push(l.apiObject):i.push(l.apiObject),l});const o=(0,I.assertIsDefined)(d.find(s=>s.isActive===!0)?.groupId);o!==void 0&&this.d!==o&&(this.d=o),this.c.fire(Object.freeze({opened:b,closed:y,changed:i}))}$acceptTabGroupUpdate(d){const h=this.e.find(g=>g.groupId===d.groupId);if(!h)throw new Error("Update Group IPC call received before group creation.");h.acceptGroupDtoUpdate(d),d.isActive&&(this.d=d.groupId),this.c.fire(Object.freeze({changed:[h.apiObject],opened:[],closed:[]}))}$acceptTabOperation(d){const h=this.e.find(p=>p.groupId===d.groupId);if(!h)throw new Error("Update Tabs IPC call received before group creation.");const g=h.acceptTabOperation(d);switch(d.kind){case 0:this.b.fire(Object.freeze({opened:[g.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[g.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[g.apiObject]}));return}}g(d){for(const h of this.e)for(const g of h.tabs)if(g.apiObject===d)return g}h(d){return this.e.find(h=>h.apiObject===d)}async i(d,h){const g=[];for(const p of d){const y=this.g(p);if(!y)throw new Error("Tab close: Invalid tab not found!");g.push(y.tabId)}return this.a.$closeTab(g,h)}async j(d,h){const g=[];for(const p of d){const y=this.h(p);if(!y)throw new Error("Group close: Invalid group not found!");g.push(y.groupId)}return this.a.$closeGroup(g,h)}};T=qe([We(0,S.IExtHostRpcService)],T),e.ExtHostEditorTabs=T;function E(f){return f.tabs!==void 0}}),define(ye[259],De([1,0,2,5,6,7,14,154,8,22,27]),function(ne,e,c,A,u,R,C,P,S,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class k{constructor(){this.a=[]}add(E){this.b=void 0,this.a.push(E)}delete(E){const f=this.a.indexOf(E);f>=0&&(this.a.splice(f,1),this.b=void 0)}c(){if(!this.b){const E=this.a.sort(),f=[];let d,h,g=14,p=14;for(const y of E){let b=d?(0,S.commonPrefixLength)(d,y):0;for(b===0?h=1:h=p;b<y.length;b++)b+1===y.length?(g=p,p=9):p+=1,f.push([h,y.toUpperCase().charCodeAt(b),p]),f.push([h,y.toLowerCase().charCodeAt(b),p]),h=p;d=y,p=g}f.push([9,58,10]),f.push([10,47,12]),this.b=new P.StateMachine(f)}}provideDocumentLinks(E){this.c();const f=[],d=P.LinkComputer.computeLinks({getLineContent(h){return E.lineAt(h-1).text},getLineCount(){return E.lineCount}},this.b);for(const h of d){const g=C.DocumentLink.to(h);g.target&&f.push(g)}return f}}class v{constructor(E,f){this.i=f,this.b=new k,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=E.getProxy(A.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(E,f,d,h={}){if(this.d.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(E,"*",this.b));const g=this.h++;this.b.add(f),this.d.add(f),this.c.set(g,d);let p=2;h.isCaseSensitive&&(p+=1024),h.isReadonly&&(p+=2048),typeof d.copy=="function"&&(p+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&((0,L.checkProposedApiEnabled)(E,"fsChunks"),p+=4),this.a.$registerFileSystemProvider(g,f,p).catch(b=>{console.error(`FAILED to register filesystem provider of ${E.identifier.value}-extension for the scheme ${f}`),console.error(b)});const y=d.onDidChangeFile(b=>{const i=[];for(const o of b){const{uri:s,type:l}=o;if(s.scheme!==f)continue;let r;switch(l){case R.FileChangeType.Changed:r=0;break;case R.FileChangeType.Created:r=1;break;case R.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:s,type:r})}this.a.$onFileSystemChange(g,i)});return(0,u.toDisposable)(()=>{y.dispose(),this.b.delete(f),this.d.delete(f),this.c.delete(g),this.a.$unregisterProvider(g)})}static j(E){const{type:f,ctime:d,mtime:h,size:g,permissions:p}=E;return{type:f,ctime:d,mtime:h,size:g,permissions:p}}$stat(E,f){return Promise.resolve(this.k(E).stat(c.URI.revive(f))).then(d=>v.j(d))}$readdir(E,f){return Promise.resolve(this.k(E).readDirectory(c.URI.revive(f)))}$readFile(E,f){return Promise.resolve(this.k(E).readFile(c.URI.revive(f))).then(d=>I.VSBuffer.wrap(d))}$writeFile(E,f,d,h){return Promise.resolve(this.k(E).writeFile(c.URI.revive(f),d.buffer,h))}$delete(E,f,d){return Promise.resolve(this.k(E).delete(c.URI.revive(f),d))}$rename(E,f,d,h){return Promise.resolve(this.k(E).rename(c.URI.revive(f),c.URI.revive(d),h))}$copy(E,f,d,h){const g=this.k(E);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(c.URI.revive(f),c.URI.revive(d),h))}$mkdir(E,f){return Promise.resolve(this.k(E).createDirectory(c.URI.revive(f)))}$watch(E,f,d,h){const g=this.k(E).watch(c.URI.revive(d),h);this.f.set(f,g)}$unwatch(E,f){const d=this.f.get(f);d&&(d.dispose(),this.f.delete(f))}$open(E,f,d){const h=this.k(E);if(!h.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(h.open(c.URI.revive(f),d))}$close(E,f){const d=this.k(E);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(f))}$read(E,f,d,h){const g=this.k(E);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const p=I.VSBuffer.alloc(h);return Promise.resolve(g.read(f,d,p.buffer,0,h)).then(y=>p.slice(0,y))}$write(E,f,d,h){const g=this.k(E);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(f,d,h.buffer,0,h.byteLength))}k(E){const f=this.c.get(E);if(!f){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return f}}e.ExtHostFileSystem=v}),define(ye[77],De([1,0,5,44,7,22,4,20,48,6]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class Yt{constructor(v,T){this.b=new Map,this.a=v.getProxy(c.MainContext.MainThreadFileSystem);const E=this;this.value=Object.freeze({async stat(f){try{const d=E.b.get(f.scheme);if(!d)return await E.a.$stat(f);await E.a.$ensureActivation(f.scheme);const h=await d.stat(f);return{type:h.type,ctime:h.ctime,mtime:h.mtime,size:h.size,permissions:h.permissions}}catch(d){Yt.c(d)}},async readDirectory(f){try{const d=E.b.get(f.scheme);return d?(await E.a.$ensureActivation(f.scheme),(await d.readDirectory(f)).slice()):await E.a.$readdir(f)}catch(d){return Yt.c(d)}},async createDirectory(f){try{return await E.a.$mkdir(f)}catch(d){return Yt.c(d)}},async readFile(f){try{const d=E.b.get(f.scheme);return d?(await E.a.$ensureActivation(f.scheme),(await d.readFile(f)).slice()):(await E.a.$readFile(f)).buffer}catch(d){return Yt.c(d)}},async writeFile(f,d){try{return await E.a.$writeFile(f,R.VSBuffer.wrap(d))}catch(h){return Yt.c(h)}},async delete(f,d){try{const h=E.b.get(f.scheme);return h?(await E.a.$ensureActivation(f.scheme),await h.delete(f,{recursive:!1,...d})):await E.a.$delete(f,{recursive:!1,useTrash:!1,...d})}catch(h){return Yt.c(h)}},async rename(f,d,h){try{return await E.a.$rename(f,d,{overwrite:!1,...h})}catch(g){return Yt.c(g)}},async copy(f,d,h){try{return await E.a.$copy(f,d,{overwrite:!1,...h})}catch(g){return Yt.c(g)}},isWritableFileSystem(f){const d=T.getCapabilities(f);if(typeof d=="number")return!(d&2048)}})}static c(v){if(v instanceof u.FileSystemError)throw v;if(!(v instanceof Error))throw new u.FileSystemError(String(v));if(v.name==="ENOPRO"||v.message.includes("ENOPRO"))throw u.FileSystemError.Unavailable(v.message);switch(v.name){case A.FileSystemProviderErrorCode.FileExists:throw u.FileSystemError.FileExists(v.message);case A.FileSystemProviderErrorCode.FileNotFound:throw u.FileSystemError.FileNotFound(v.message);case A.FileSystemProviderErrorCode.FileNotADirectory:throw u.FileSystemError.FileNotADirectory(v.message);case A.FileSystemProviderErrorCode.FileIsADirectory:throw u.FileSystemError.FileIsADirectory(v.message);case A.FileSystemProviderErrorCode.NoPermissions:throw u.FileSystemError.NoPermissions(v.message);case A.FileSystemProviderErrorCode.Unavailable:throw u.FileSystemError.Unavailable(v.message);default:throw new u.FileSystemError(v.message,v.name)}}addFileSystemProvider(v,T){return this.b.set(v,T),(0,I.toDisposable)(()=>this.b.delete(v))}};L=qe([We(0,P.IExtHostRpcService),We(1,S.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[260],De([1,0,3,38,2,5,14,7]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(k,v,T,E,f,d,h,g){this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter;const p=this.h(k,T,f);this.g=0,d&&(this.g+=1),h&&(this.g+=2),g&&(this.g+=4);const y=(0,A.parse)(f),b=typeof f=="string",i=E(o=>{if(!d)for(const s of o.created){const l=u.URI.revive(s);y(l.fsPath)&&(!b||v.getWorkspaceFolder(l))&&this.a.fire(l)}if(!h)for(const s of o.changed){const l=u.URI.revive(s);y(l.fsPath)&&(!b||v.getWorkspaceFolder(l))&&this.b.fire(l)}if(!g)for(const s of o.deleted){const l=u.URI.revive(s);y(l.fsPath)&&(!b||v.getWorkspaceFolder(l))&&this.c.fire(l)}});this.d=P.Disposable.from(p,this.a,this.b,this.c,i)}h(k,v,T){const E=P.Disposable.from();if(typeof T=="string")return E;const f=k.getProxy(R.MainContext.MainThreadFileSystem);let d=!1;(T.pattern.includes(A.GLOBSTAR)||T.pattern.includes(A.GLOB_SPLIT))&&(d=!0);const h=Math.random();return f.$watch(v.identifier.value,h,T.baseUri,{recursive:d,excludes:[]}),P.Disposable.from({dispose:()=>f.$unwatch(h)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class I{constructor(k,v,T){this.j=k,this.k=v,this.l=T,this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter,this.d=new c.Emitter,this.g=new c.AsyncEmitter,this.h=new c.AsyncEmitter,this.i=new c.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(k,v,T,E,f,d){return new S(this.j,k,v,this.a.event,C.GlobPattern.from(T),E,f,d)}$onFileEvent(k){this.a.fire(k)}$onDidRunFileOperation(k,v){switch(k){case 2:this.b.fire(Object.freeze({files:v.map(T=>({oldUri:u.URI.revive(T.source),newUri:u.URI.revive(T.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(T=>u.URI.revive(T.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(T=>u.URI.revive(T.target))}));break;default:}}getOnWillRenameFileEvent(k){return this.m(k,this.g)}getOnWillCreateFileEvent(k){return this.m(k,this.h)}getOnWillDeleteFileEvent(k){return this.m(k,this.i)}m(k,v){return(T,E,f)=>{const d=function(g){T.call(E,g)};return d.extension=k,v.event(d,void 0,f)}}async $onWillRunFileOperation(k,v,T,E){switch(k){case 2:return await this.n(this.g,{files:v.map(f=>({oldUri:u.URI.revive(f.source),newUri:u.URI.revive(f.target)}))},T,E);case 1:return await this.n(this.i,{files:v.map(f=>u.URI.revive(f.target))},T,E);case 0:case 3:return await this.n(this.h,{files:v.map(f=>u.URI.revive(f.target))},T,E)}}async n(k,v,T,E){const f=new Set,d=[];if(await k.fireAsync(v,E,async(g,p)=>{const y=Date.now(),b=await Promise.resolve(g);b instanceof P.WorkspaceEdit&&(d.push([p.extension,b]),f.add(p.extension.displayName??p.extension.identifier.value)),Date.now()-y>T&&this.k.warn("SLOW file-participant",p.extension.identifier)}),E.isCancellationRequested||d.length===0)return;const h={edits:[]};for(const[,g]of d){const{edits:p}=C.WorkspaceEdit.from(g,{getTextDocumentVersion:y=>this.l.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}});h.edits=h.edits.concat(p)}return{edit:h,extensionNames:Array.from(f)}}}e.ExtHostFileSystemEventService=I}),define(ye[261],De([1,0,2,40]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class u{constructor(C,P,S,I,L){this.a=P,this.b=S,this.c=I;const k=new A.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new A.ApiCommandArgument("showOptions","Show Options",v=>!0,v=>v),new A.ApiCommandArgument("resource","Interactive resource Uri",v=>!0,v=>v),new A.ApiCommandArgument("controllerId","Notebook controller Id",v=>!0,v=>v),new A.ApiCommandArgument("title","Interactive editor title",v=>!0,v=>v)],new A.ApiCommandResult("Notebook and input URI",v=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",v.notebookEditorId),v.notebookEditorId!==void 0){const T=this.a.getEditorById(v.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",T.id),{notebookUri:c.URI.revive(v.notebookUri),inputUri:c.URI.revive(v.inputUri),notebookEditor:T.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",v.notebookUri,v.inputUri),{notebookUri:c.URI.revive(v.notebookUri),inputUri:c.URI.revive(v.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(C,P,S,I){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:S,uri:C,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(c.URI.revive(I))?.apiNotebook}]})}$willRemoveInteractiveDocument(C,P){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[C]})}}e.ExtHostInteractive=u}),define(ye[262],De([1,0,6,5]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class u{constructor(C){this.b=0,this.a=C.getProxy(A.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const P=this.b++;return this.a.$registerResourceLabelFormatter(P,C),(0,c.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=u}),define(ye[263],De([1,0,2,23,14,7,71,5,8,32,15,9,150,21,6,120,101,74,43,11,19,27]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,f,d,h,g,p,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class i{constructor(N,H){this.d=N,this.e=H}async provideDocumentSymbols(N,H){const K=this.d.getDocument(N),_=await this.e.provideDocumentSymbols(K,H);if(!(0,L.isFalsyOrEmpty)(_))return _[0]instanceof R.DocumentSymbol?_.map(u.DocumentSymbol.from):i.f(_)}static f(N){N=N.slice(0).sort((_,he)=>{let we=_.location.range.start.compareTo(he.location.range.start);return we===0&&(we=he.location.range.end.compareTo(_.location.range.end)),we});const H=[],K=[];for(const _ of N){const he={name:_.name||"!!MISSING: name!!",kind:u.SymbolKind.from(_.kind),tags:_.tags?.map(u.SymbolTag.from)||[],detail:"",containerName:_.containerName,range:u.Range.from(_.location.range),selectionRange:u.Range.from(_.location.range),children:[]};for(;;){if(K.length===0){K.push(he),H.push(he);break}const we=K[K.length-1];if(I.Range.containsRange(we.range,he.range)&&!I.Range.equalsRange(we.range,he.range)){we.children?.push(he),K.push(he);break}K.pop()}}return H}}class o{constructor(N,H,K){this.g=N,this.h=H,this.j=K,this.e=new h.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(N,H){const K=this.g.getDocument(N),_=await this.j.provideCodeLenses(K,H);if(!_||H.isCancellationRequested)return;const he=this.e.add(_),we=new E.DisposableStore;this.f.set(he,we);const Ae={cacheId:he,lenses:[]};for(let be=0;be<_.length;be++)Ae.lenses.push({cacheId:[he,be],range:u.Range.from(_[be].range),command:this.h.toInternal(_[be].command,we)});return Ae}async resolveCodeLens(N,H){const K=N.cacheId&&this.e.get(...N.cacheId);if(!K)return;let _;if(typeof this.j.resolveCodeLens!="function"||K.isResolved?_=K:_=await this.j.resolveCodeLens(K,H),_||(_=K),H.isCancellationRequested)return;const he=N.cacheId&&this.f.get(N.cacheId[0]);if(!!he)return N.command=this.h.toInternal(_.command??o.d,he),N}releaseCodeLenses(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}}o.d={command:"missing",title:"!!MISSING: command!!"};function s(re){return Array.isArray(re)?re.map(u.DefinitionLink.from):re?[u.DefinitionLink.from(re)]:[]}class l{constructor(N,H){this.d=N,this.e=H}async provideDefinition(N,H,K){const _=this.d.getDocument(N),he=u.Position.to(H),we=await this.e.provideDefinition(_,he,K);return s(we)}}class r{constructor(N,H){this.d=N,this.e=H}async provideDeclaration(N,H,K){const _=this.d.getDocument(N),he=u.Position.to(H),we=await this.e.provideDeclaration(_,he,K);return s(we)}}class m{constructor(N,H){this.d=N,this.e=H}async provideImplementation(N,H,K){const _=this.d.getDocument(N),he=u.Position.to(H),we=await this.e.provideImplementation(_,he,K);return s(we)}}class n{constructor(N,H){this.d=N,this.e=H}async provideTypeDefinition(N,H,K){const _=this.d.getDocument(N),he=u.Position.to(H),we=await this.e.provideTypeDefinition(_,he,K);return s(we)}}class t{constructor(N,H){this.d=N,this.e=H}async provideHover(N,H,K){const _=this.d.getDocument(N),he=u.Position.to(H),we=await this.e.provideHover(_,he,K);if(!(!we||(0,L.isFalsyOrEmpty)(we.contents)))return we.range||(we.range=_.getWordRangeAtPosition(he)),we.range||(we.range=new R.Range(he,he)),u.Hover.from(we)}}class a{constructor(N,H){this.d=N,this.e=H}async provideEvaluatableExpression(N,H,K){const _=this.d.getDocument(N),he=u.Position.to(H),we=await this.e.provideEvaluatableExpression(_,he,K);if(we)return u.EvaluatableExpression.from(we)}}class w{constructor(N,H){this.d=N,this.e=H}async provideInlineValues(N,H,K,_){const he=this.d.getDocument(N),we=await this.e.provideInlineValues(he,u.Range.to(H),u.InlineValueContext.to(K),_);if(Array.isArray(we))return we.map(Ae=>u.InlineValue.from(Ae))}}class D{constructor(N,H){this.d=N,this.e=H}async provideDocumentHighlights(N,H,K){const _=this.d.getDocument(N),he=u.Position.to(H),we=await this.e.provideDocumentHighlights(_,he,K);if(Array.isArray(we))return we.map(u.DocumentHighlight.from)}}class F{constructor(N,H){this.d=N,this.e=H}async provideLinkedEditingRanges(N,H,K){const _=this.d.getDocument(N),he=u.Position.to(H),we=await this.e.provideLinkedEditingRanges(_,he,K);if(we&&Array.isArray(we.ranges))return{ranges:(0,L.coalesce)(we.ranges.map(u.Range.from)),wordPattern:we.wordPattern}}}class x{constructor(N,H){this.d=N,this.e=H}async provideReferences(N,H,K,_){const he=this.d.getDocument(N),we=u.Position.to(H),Ae=await this.e.provideReferences(he,we,K,_);if(Array.isArray(Ae))return Ae.map(u.location.from)}}class q{constructor(N,H,K,_,he,we,Ae){this.g=N,this.h=H,this.j=K,this.k=_,this.l=he,this.m=we,this.n=Ae,this.e=new h.Cache("CodeAction"),this.f=new Map}async provideCodeActions(N,H,K,_){const he=this.g.getDocument(N),we=v.Selection.isISelection(H)?u.Selection.to(H):u.Range.to(H),Ae=[];for(const et of this.j.getDiagnostics(N))if(we.intersection(et.range)&&Ae.push(et)>q.d)break;const be={diagnostics:Ae,only:K.only?new R.CodeActionKind(K.only):void 0,triggerKind:u.CodeActionTriggerKind.to(K.trigger)},Ce=await this.k.provideCodeActions(he,we,be,_);if(!(0,L.isNonEmptyArray)(Ce)||_.isCancellationRequested)return;const Te=this.e.add(Ce),Ve=new E.DisposableStore;this.f.set(Te,Ve);const xe=[];for(let et=0;et<Ce.length;et++){const Qe=Ce[et];!Qe||(q.o(Qe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),xe.push({_isSynthetic:!0,title:Qe.title,command:this.h.toInternal(Qe,Ve)})):(be.only&&(Qe.kind?be.only.contains(Qe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action is of kind '${Qe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),xe.push({cacheId:[Te,et],title:Qe.title,command:Qe.command&&this.h.toInternal(Qe.command,Ve),diagnostics:Qe.diagnostics&&Qe.diagnostics.map(u.Diagnostic.from),edit:Qe.edit&&u.WorkspaceEdit.from(Qe.edit,void 0),kind:Qe.kind&&Qe.kind.value,isPreferred:Qe.isPreferred,disabled:Qe.disabled?.reason})))}return{cacheId:Te,actions:xe}}async resolveCodeAction(N,H){const[K,_]=N,he=this.e.get(K,_);if(!he||q.o(he)||!this.k.resolveCodeAction)return;const we=await this.k.resolveCodeAction(he,H)??he;return we?.edit?u.WorkspaceEdit.from(we.edit,void 0):void 0}releaseCodeActions(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}static o(N){return typeof N.command=="string"&&typeof N.title=="string"}}q.d=1e3;class M{constructor(N,H,K,_){this.d=N,this.e=H,this.f=K,this.g=_}async prepareDocumentPaste(N,H,K,_){if(!this.f.prepareDocumentPaste)return;const he=this.e.getDocument(N),we=H.map(be=>u.Range.to(be)),Ae=u.DataTransfer.toDataTransfer(K,()=>{throw new p.NotImplementedError});return await this.f.prepareDocumentPaste(he,we,Ae,_),u.DataTransfer.toDataTransferDTO(Ae)}async providePasteEdits(N,H,K,_,he){const we=this.e.getDocument(H),Ae=K.map(Te=>u.Range.to(Te)),be=u.DataTransfer.toDataTransfer(_,async Te=>(await this.d.$resolvePasteFileData(this.g,N,Te)).buffer),Ce=await this.f.provideDocumentPasteEdits(we,Ae,be,he);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?u.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class B{constructor(N,H){this.d=N,this.e=H}async provideDocumentFormattingEdits(N,H,K){const _=this.d.getDocument(N),he=await this.e.provideDocumentFormattingEdits(_,H,K);if(Array.isArray(he))return he.map(u.TextEdit.from)}}class O{constructor(N,H){this.d=N,this.e=H}async provideDocumentRangeFormattingEdits(N,H,K,_){const he=this.d.getDocument(N),we=u.Range.to(H),Ae=await this.e.provideDocumentRangeFormattingEdits(he,we,K,_);if(Array.isArray(Ae))return Ae.map(u.TextEdit.from)}}class U{constructor(N,H){this.d=N,this.e=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,H,K,_,he){const we=this.d.getDocument(N),Ae=u.Position.to(H),be=await this.e.provideOnTypeFormattingEdits(we,Ae,K,_,he);if(Array.isArray(be))return be.map(u.TextEdit.from)}}class z{constructor(N,H){this.e=N,this.f=H,this.d=new h.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(N,H){const K=await this.e.provideWorkspaceSymbols(N,H);if(!(0,L.isNonEmptyArray)(K))return{symbols:[]};const _=this.d.add(K),he={cacheId:_,symbols:[]};for(let we=0;we<K.length;we++){const Ae=K[we];if(!Ae||!Ae.name){this.f.warn("INVALID SymbolInformation",Ae);continue}he.symbols.push({...u.WorkspaceSymbol.from(Ae),cacheId:[_,we]})}return he}async resolveWorkspaceSymbol(N,H){if(typeof this.e.resolveWorkspaceSymbol!="function"||!N.cacheId)return N;const K=this.d.get(...N.cacheId);if(K){const _=await this.e.resolveWorkspaceSymbol(K,H);return _&&(0,A.mixin)(N,u.WorkspaceSymbol.from(_),!0)}}releaseWorkspaceSymbols(N){this.d.delete(N)}}class j{static supportsResolving(N){return typeof N.prepareRename=="function"}constructor(N,H,K){this.d=N,this.e=H,this.f=K}async provideRenameEdits(N,H,K,_){const he=this.d.getDocument(N),we=u.Position.to(H);try{const Ae=await this.e.provideRenameEdits(he,we,K,_);return Ae?u.WorkspaceEdit.from(Ae):void 0}catch(Ae){const be=j.g(Ae);return be?{rejectReason:be,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(N,H,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const _=this.d.getDocument(N),he=u.Position.to(H);try{const we=await this.e.prepareRename(_,he,K);let Ae,be;if(R.Range.isRange(we)?(Ae=we,be=_.getText(we)):(0,k.isObject)(we)&&(Ae=we.range,be=we.placeholder),!Ae||!be)return;if(Ae.start.line>he.line||Ae.end.line<he.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:u.Range.from(Ae),text:be}}catch(we){const Ae=j.g(we);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(we)}}static g(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class de{constructor(N,H){this.resultId=N,this.tokens=H}}class V{constructor(N,H){this.f=N,this.g=H,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(N,H,K){const _=this.f.getDocument(N),he=H!==0?this.d.get(H):null;let we=typeof he?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(_,he.resultId,K):await this.g.provideDocumentSemanticTokens(_,K);return he&&this.d.delete(H),we?(we=V.h(we),this.o(V.n(he,we),we)):null}async releaseDocumentSemanticColoring(N){this.d.delete(N)}static h(N){return V.j(N)?V.k(N)?N:new R.SemanticTokens(new Uint32Array(N.data),N.resultId):V.l(N)?V.m(N)?N:new R.SemanticTokensEdits(N.edits.map(H=>new R.SemanticTokensEdit(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),N.resultId):N}static j(N){return N&&!!N.data}static k(N){return N.data instanceof Uint32Array}static l(N){return N&&Array.isArray(N.edits)}static m(N){for(const H of N.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static n(N,H){if(!V.j(H)||!N||!N.tokens)return H;const K=N.tokens,_=K.length,he=H.data,we=he.length;let Ae=0;const be=Math.min(_,we);for(;Ae<be&&K[Ae]===he[Ae];)Ae++;if(Ae===_&&Ae===we)return new R.SemanticTokensEdits([],H.resultId);let Ce=0;const Te=be-Ae;for(;Ce<Te&&K[_-Ce-1]===he[we-Ce-1];)Ce++;return new R.SemanticTokensEdits([{start:Ae,deleteCount:_-Ae-Ce,data:he.subarray(Ae,we-Ce)}],H.resultId)}o(N,H){if(V.j(N)){const K=this.e++;return this.d.set(K,new de(N.resultId,N.data)),(0,f.encodeSemanticTokensDto)({id:K,type:"full",data:N.data})}if(V.l(N)){const K=this.e++;return V.j(H)?this.d.set(K,new de(H.resultId,H.data)):this.d.set(K,new de(N.resultId)),(0,f.encodeSemanticTokensDto)({id:K,type:"delta",deltas:(N.edits||[]).map(_=>({start:_.start,deleteCount:_.deleteCount,data:_.data}))})}return null}}class X{constructor(N,H){this.d=N,this.e=H}async provideDocumentRangeSemanticTokens(N,H,K){const _=this.d.getDocument(N),he=await this.e.provideDocumentRangeSemanticTokens(_,u.Range.to(H),K);return he?this.f(he):null}f(N){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:N.data})}}class J{static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}constructor(N,H,K,_,he){this.f=N,this.g=H,this.h=K,this.j=_,this.k=he,this.d=new h.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(N,H,K,_){const he=this.f.getDocument(N),we=u.Position.to(H),Ae=he.getWordRangeAtPosition(we)||new R.Range(we,we),be=Ae.with({end:we}),Ce=new g.StopWatch(!0),Te=await this.h.provideCompletionItems(he,we,_,u.CompletionContext.to(K));if(!Te||_.isCancellationRequested)return;const Ve=Array.isArray(Te)?new R.CompletionList(Te):Te,xe=J.supportsResolving(this.h)?this.d.add(Ve.items):this.d.add([]),et=new E.DisposableStore;this.e.set(xe,et);const Qe=[],nt={x:xe,b:Qe,a:{replace:u.Range.from(Ae),insert:u.Range.from(be)},c:Ve.isIncomplete||void 0,d:Ce.elapsed()};for(let st=0;st<Ve.items.length;st++){const ht=Ve.items[st],Ue=this.l(ht,[xe,st],be,Ae);Qe.push(Ue)}return nt}async resolveCompletionItem(N,H){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...N);if(!K)return;const _=await this.h.resolveCompletionItem(K,H);if(!!_)return this.l(_,N)}releaseCompletionItems(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,H,K,_){const he=this.e.get(H[0]);if(!he)throw Error("DisposableStore is missing...");const we=this.g.toInternal(N.command,he),Ae={x:H,a:N.label,b:N.kind!==void 0?u.CompletionItemKind.from(N.kind):void 0,m:N.tags&&N.tags.map(u.CompletionItemTag.from),c:N.detail,d:typeof N.documentation>"u"?void 0:u.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters?.join(""),l:N.additionalTextEdits&&N.additionalTextEdits.map(u.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};N.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae.h=N.textEdit.newText):typeof N.insertText=="string"?Ae.h=N.insertText:N.insertText instanceof R.SnippetString&&(Ae.h=N.insertText.value,Ae.i|=4);let be;return N.textEdit?be=N.textEdit.range:N.range&&(be=N.range),R.Range.isRange(be)?Ae.j=u.Range.from(be):be&&(!K?.isEqual(be.inserting)||!_?.isEqual(be.replacing))&&(Ae.j={insert:u.Range.from(be.inserting),replace:u.Range.from(be.replacing)}),Ae}}class te{async provideInlineCompletions(N,H,K,_){}disposeCompletions(N){}handleDidShowCompletionItem(N,H){}}class ee extends te{constructor(N,H,K,_){super(),this.f=N,this.g=H,this.h=K,this.j=_,this.d=new Q,this.e=(0,b.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[C.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[C.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,b.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(N,H,K,_){const he=this.g.getDocument(N),we=u.Position.to(H),Ae=await this.h.provideInlineCompletionItems(he,we,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:u.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},_);if(!Ae||_.isCancellationRequested)return;const be=Array.isArray(Ae)?Ae:Ae.items,Ce=this.e?Array.isArray(Ae)?[]:Ae.commands||[]:[];let Te;return{pid:this.d.createReferenceId({dispose(){Te?.dispose()},items:be}),items:be.map((xe,et)=>{let Qe;xe.command&&(Te||(Te=new E.DisposableStore),Qe=this.j.toInternal(xe.command,Te));const nt=xe.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:xe.filterText,range:xe.range?u.Range.from(xe.range):void 0,command:Qe,idx:et,completeBracketPairs:this.e?xe.completeBracketPairs:!1}}),commands:Ce.map(xe=>(Te||(Te=new E.DisposableStore),this.j.toInternal(xe,Te)))}}disposeCompletions(N){this.d.disposeReferenceId(N)?.dispose()}handleDidShowCompletionItem(N,H){const K=this.d.get(N)?.items[H];K&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(K)}}class Q{constructor(){this.d=new Map,this.e=1}createReferenceId(N){const H=this.e++;return this.d.set(H,N),H}disposeReferenceId(N){const H=this.d.get(N);return this.d.delete(N),H}get(N){return this.d.get(N)}}class Y{constructor(N,H){this.e=N,this.f=H,this.d=new h.Cache("SignatureHelp")}async provideSignatureHelp(N,H,K,_){const he=this.e.getDocument(N),we=u.Position.to(H),Ae=this.g(K),be=await this.f.provideSignatureHelp(he,we,_,Ae);if(be){const Ce=this.d.add([be]);return{...u.SignatureHelp.from(be),id:Ce}}}g(N){let H;if(N.activeSignatureHelp){const K=u.SignatureHelp.to(N.activeSignatureHelp),_=this.d.get(N.activeSignatureHelp.id,0);_?(H=_,H.activeSignature=K.activeSignature,H.activeParameter=K.activeParameter):H=K}return{...N,activeSignatureHelp:H}}releaseSignatureHelp(N){this.d.delete(N)}}class ie{constructor(N,H,K,_,he){this.f=N,this.g=H,this.h=K,this.j=_,this.k=he,this.d=new h.Cache("InlayHints"),this.e=new Map}async provideInlayHints(N,H,K){const _=this.f.getDocument(N),he=u.Range.to(H),we=await this.h.provideInlayHints(_,he,K);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${H}`);return}if(K.isCancellationRequested)return;const Ae=this.d.add(we);this.e.set(Ae,new E.DisposableStore);const be={hints:[],cacheId:Ae};for(let Ce=0;Ce<we.length;Ce++)this.l(we[Ce],he)&&be.hints.push(this.m(we[Ce],[Ae,Ce]));return this.j.trace(`[InlayHints] ${be.hints.length} inlay hints from '${this.k.identifier.value}' for ${H}`),be}async resolveInlayHint(N,H){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...N);if(!K)return;const _=await this.h.resolveInlayHint(K,H);if(!!_&&!!this.l(_))return this.m(_,N)}releaseHints(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,H){return N.label.length===0||Array.isArray(N.label)&&N.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",N),!1):!(H&&!H.contains(N.position))}m(N,H){const K=this.e.get(H[0]);if(!K)throw Error("DisposableStore is missing...");const _={label:"",cacheId:H,tooltip:u.MarkdownString.fromStrict(N.tooltip),position:u.Position.from(N.position),textEdits:N.textEdits&&N.textEdits.map(u.TextEdit.from),kind:N.kind&&u.InlayHintKind.from(N.kind),paddingLeft:N.paddingLeft,paddingRight:N.paddingRight};return typeof N.label=="string"?_.label=N.label:_.label=N.label.map(he=>{const we={label:he.value};return we.tooltip=u.MarkdownString.fromStrict(he.tooltip),R.Location.isLocation(he.location)&&(we.location=u.location.from(he.location)),he.command&&(we.command=this.g.toInternal(he.command,K)),we}),_}}class pe{constructor(N,H){this.e=N,this.f=H,this.d=new h.Cache("DocumentLink")}async provideLinks(N,H){const K=this.e.getDocument(N),_=await this.f.provideDocumentLinks(K,H);if(!(!Array.isArray(_)||_.length===0)&&!H.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:_.filter(pe.g).map(u.DocumentLink.from)};{const he=this.d.add(_),we={links:[],cacheId:he};for(let Ae=0;Ae<_.length;Ae++){if(!pe.g(_[Ae]))continue;const be=u.DocumentLink.from(_[Ae]);be.cacheId=[he,Ae],we.links.push(be)}return we}}}static g(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,H){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...N);if(!K)return;const _=await this.f.resolveDocumentLink(K,H);if(!(!_||!pe.g(_)))return u.DocumentLink.from(_)}releaseLinks(N){this.d.delete(N)}}class ve{constructor(N,H){this.d=N,this.e=H}async provideColors(N,H){const K=this.d.getDocument(N),_=await this.e.provideDocumentColors(K,H);return Array.isArray(_)?_.map(we=>({color:u.Color.from(we.color),range:u.Range.from(we.range)})):[]}async provideColorPresentations(N,H,K){const _=this.d.getDocument(N),he=u.Range.to(H.range),we=u.Color.to(H.color),Ae=await this.e.provideColorPresentations(we,{document:_,range:he},K);if(!!Array.isArray(Ae))return Ae.map(u.ColorPresentation.from)}}class ke{constructor(N,H){this.d=N,this.e=H}async provideFoldingRanges(N,H,K){const _=this.d.getDocument(N),he=await this.e.provideFoldingRanges(_,H,K);if(!!Array.isArray(he))return he.map(u.FoldingRange.from)}}class Oe{constructor(N,H,K){this.d=N,this.e=H,this.f=K}async provideSelectionRanges(N,H,K){const _=this.d.getDocument(N),he=H.map(u.Position.to),we=await this.e.provideSelectionRanges(_,he,K);if(!(0,L.isNonEmptyArray)(we))return[];if(we.length!==he.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let be=0;be<he.length;be++){const Ce=[];Ae.push(Ce);let Te=he[be],Ve=we[be];for(;;){if(!Ve.range.contains(Te))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(u.SelectionRange.from(Ve)),!Ve.parent)break;Te=Ve.range,Ve=Ve.parent}}return Ae}}class oe{constructor(N,H){this.f=N,this.g=H,this.d=new d.IdGenerator(""),this.e=new Map}async prepareSession(N,H,K){const _=this.f.getDocument(N),he=u.Position.to(H),we=await this.g.prepareCallHierarchy(_,he,K);if(!we)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(we)?we.map(be=>this.h(Ae,be)):[this.h(Ae,we)]}async provideCallsTo(N,H,K){const _=this.j(N,H);if(!_)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyIncomingCalls(_,K);if(!!he)return he.map(we=>({from:this.h(N,we.from),fromRanges:we.fromRanges.map(Ae=>u.Range.from(Ae))}))}async provideCallsFrom(N,H,K){const _=this.j(N,H);if(!_)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyOutgoingCalls(_,K);if(!!he)return he.map(we=>({to:this.h(N,we.to),fromRanges:we.fromRanges.map(Ae=>u.Range.from(Ae))}))}releaseSession(N){this.e.delete(N)}h(N,H){const K=this.e.get(N),_=u.CallHierarchyItem.from(H,N,K.size.toString(36));return K.set(_._itemId,H),_}j(N,H){return this.e.get(N)?.get(H)}}class ae{constructor(N,H){this.f=N,this.g=H,this.d=new d.IdGenerator(""),this.e=new Map}async prepareSession(N,H,K){const _=this.f.getDocument(N),he=u.Position.to(H),we=await this.g.prepareTypeHierarchy(_,he,K);if(!we)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(we)?we.map(be=>this.h(Ae,be)):[this.h(Ae,we)]}async provideSupertypes(N,H,K){const _=this.j(N,H);if(!_)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySupertypes(_,K);if(!!he)return he.map(we=>this.h(N,we))}async provideSubtypes(N,H,K){const _=this.j(N,H);if(!_)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySubtypes(_,K);if(!!he)return he.map(we=>this.h(N,we))}releaseSession(N){this.e.delete(N)}h(N,H){const K=this.e.get(N),_=u.TypeHierarchyItem.from(H,N,K.size.toString(36));return K.set(_._itemId,H),_}j(N,H){return this.e.get(N)?.get(H)}}class fe{constructor(N,H,K,_){this.d=N,this.e=H,this.f=K,this.g=_}async provideDocumentOnDropEdits(N,H,K,_,he){const we=this.e.getDocument(H),Ae=u.Position.to(K),be=u.DataTransfer.toDataTransfer(_,async Te=>(await this.d.$resolveDocumentOnDropFileData(this.g,N,Te)).buffer),Ce=await this.f.provideDocumentDropEdits(we,Ae,be,he);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?u.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class Z{constructor(N,H){this.adapter=N,this.extension=H}}class le{constructor(N,H,K,_,he,we,Ae,be){this.g=H,this.h=K,this.j=_,this.k=he,this.l=we,this.m=Ae,this.n=be,this.f=new Map,this.e=N.getProxy(P.MainContext.MainThreadLanguageFeatures)}o(N){return u.DocumentSelector.from(N,this.g)}p(N){return new R.Disposable(()=>{this.f.delete(N),this.e.$unregister(N)})}q(){return le.d++}async s(N,H,K,_,he,we=!1){const Ae=this.f.get(N);if(!Ae||!(Ae.adapter instanceof H))return _;const be=Date.now();we||this.l.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Ce=K(Ae.adapter,Ae.extension);return Promise.resolve(Ce).catch(Te=>{(0,p.isCancellationError)(Te)||(this.l.error(`[${Ae.extension.identifier.value}] provider FAILED`),this.l.error(Te),this.n.onExtensionError(Ae.extension.identifier,Te))}).finally(()=>{we||this.l.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-be}ms`)}),T.CancellationToken.isCancellationToken(he)?(0,y.raceCancellationError)(Ce,he):Ce}t(N,H){const K=this.q();return this.f.set(K,new Z(N,H)),K}static u(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,H,K,_){const he=this.t(new i(this.h,K),N),we=_&&_.label||le.u(N);return this.e.$registerDocumentSymbolProvider(he,this.o(H),we),this.p(he)}$provideDocumentSymbols(N,H,K){return this.s(N,i,_=>_.provideDocumentSymbols(c.URI.revive(H),K),void 0,K)}registerCodeLensProvider(N,H,K){const _=this.q(),he=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(_,new Z(new o(this.h,this.j.converter,K),N)),this.e.$registerCodeLensSupport(_,this.o(H),he);let we=this.p(_);if(he!==void 0){const Ae=K.onDidChangeCodeLenses(be=>this.e.$emitCodeLensEvent(he));we=R.Disposable.from(we,Ae)}return we}$provideCodeLenses(N,H,K){return this.s(N,o,_=>_.provideCodeLenses(c.URI.revive(H),K),void 0,K)}$resolveCodeLens(N,H,K){return this.s(N,o,_=>_.resolveCodeLens(H,K),void 0,void 0)}$releaseCodeLenses(N,H){this.s(N,o,K=>Promise.resolve(K.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(N,H,K){const _=this.t(new l(this.h,K),N);return this.e.$registerDefinitionSupport(_,this.o(H)),this.p(_)}$provideDefinition(N,H,K,_){return this.s(N,l,he=>he.provideDefinition(c.URI.revive(H),K,_),[],_)}registerDeclarationProvider(N,H,K){const _=this.t(new r(this.h,K),N);return this.e.$registerDeclarationSupport(_,this.o(H)),this.p(_)}$provideDeclaration(N,H,K,_){return this.s(N,r,he=>he.provideDeclaration(c.URI.revive(H),K,_),[],_)}registerImplementationProvider(N,H,K){const _=this.t(new m(this.h,K),N);return this.e.$registerImplementationSupport(_,this.o(H)),this.p(_)}$provideImplementation(N,H,K,_){return this.s(N,m,he=>he.provideImplementation(c.URI.revive(H),K,_),[],_)}registerTypeDefinitionProvider(N,H,K){const _=this.t(new n(this.h,K),N);return this.e.$registerTypeDefinitionSupport(_,this.o(H)),this.p(_)}$provideTypeDefinition(N,H,K,_){return this.s(N,n,he=>he.provideTypeDefinition(c.URI.revive(H),K,_),[],_)}registerHoverProvider(N,H,K,_){const he=this.t(new t(this.h,K),N);return this.e.$registerHoverProvider(he,this.o(H)),this.p(he)}$provideHover(N,H,K,_){return this.s(N,t,he=>he.provideHover(c.URI.revive(H),K,_),void 0,_)}registerEvaluatableExpressionProvider(N,H,K,_){const he=this.t(new a(this.h,K),N);return this.e.$registerEvaluatableExpressionProvider(he,this.o(H)),this.p(he)}$provideEvaluatableExpression(N,H,K,_){return this.s(N,a,he=>he.provideEvaluatableExpression(c.URI.revive(H),K,_),void 0,_)}registerInlineValuesProvider(N,H,K,_){const he=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new w(this.h,K),N);this.e.$registerInlineValuesProvider(we,this.o(H),he);let Ae=this.p(we);if(he!==void 0){const be=K.onDidChangeInlineValues(Ce=>this.e.$emitInlineValuesEvent(he));Ae=R.Disposable.from(Ae,be)}return Ae}$provideInlineValues(N,H,K,_,he){return this.s(N,w,we=>we.provideInlineValues(c.URI.revive(H),K,_,he),void 0,he)}registerDocumentHighlightProvider(N,H,K){const _=this.t(new D(this.h,K),N);return this.e.$registerDocumentHighlightProvider(_,this.o(H)),this.p(_)}$provideDocumentHighlights(N,H,K,_){return this.s(N,D,he=>he.provideDocumentHighlights(c.URI.revive(H),K,_),void 0,_)}registerLinkedEditingRangeProvider(N,H,K){const _=this.t(new F(this.h,K),N);return this.e.$registerLinkedEditingRangeProvider(_,this.o(H)),this.p(_)}$provideLinkedEditingRanges(N,H,K,_){return this.s(N,F,async he=>{const we=await he.provideLinkedEditingRanges(c.URI.revive(H),K,_);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?le.w(we.wordPattern):void 0}},void 0,_)}registerReferenceProvider(N,H,K){const _=this.t(new x(this.h,K),N);return this.e.$registerReferenceSupport(_,this.o(H)),this.p(_)}$provideReferences(N,H,K,_,he){return this.s(N,x,we=>we.provideReferences(c.URI.revive(H),K,_,he),void 0,he)}registerCodeActionProvider(N,H,K,_){const he=new E.DisposableStore,we=this.t(new q(this.h,this.j.converter,this.k,K,this.l,N,this.m),N);return this.e.$registerQuickFixSupport(we,this.o(H),{providedKinds:_?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:_?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this.j.converter.toInternal(Ae.command,he)}))},le.u(N),Boolean(K.resolveCodeAction)),he.add(this.p(we)),he}$provideCodeActions(N,H,K,_,he){return this.s(N,q,we=>we.provideCodeActions(c.URI.revive(H),K,_,he),void 0,he)}$resolveCodeAction(N,H,K){return this.s(N,q,_=>_.resolveCodeAction(H,K),void 0,void 0)}$releaseCodeActions(N,H){this.s(N,q,K=>Promise.resolve(K.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(N,H,K){const _=this.t(new B(this.h,K),N);return this.e.$registerDocumentFormattingSupport(_,this.o(H),N.identifier,N.displayName||N.name),this.p(_)}$provideDocumentFormattingEdits(N,H,K,_){return this.s(N,B,he=>he.provideDocumentFormattingEdits(c.URI.revive(H),K,_),void 0,_)}registerDocumentRangeFormattingEditProvider(N,H,K){const _=this.t(new O(this.h,K),N);return this.e.$registerRangeFormattingSupport(_,this.o(H),N.identifier,N.displayName||N.name),this.p(_)}$provideDocumentRangeFormattingEdits(N,H,K,_,he){return this.s(N,O,we=>we.provideDocumentRangeFormattingEdits(c.URI.revive(H),K,_,he),void 0,he)}registerOnTypeFormattingEditProvider(N,H,K,_){const he=this.t(new U(this.h,K),N);return this.e.$registerOnTypeFormattingSupport(he,this.o(H),_,N.identifier),this.p(he)}$provideOnTypeFormattingEdits(N,H,K,_,he,we){return this.s(N,U,Ae=>Ae.provideOnTypeFormattingEdits(c.URI.revive(H),K,_,he,we),void 0,we)}registerWorkspaceSymbolProvider(N,H){const K=this.t(new z(H,this.l),N);return this.e.$registerNavigateTypeSupport(K,typeof H.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(N,H,K){return this.s(N,z,_=>_.provideWorkspaceSymbols(H,K),{symbols:[]},K)}$resolveWorkspaceSymbol(N,H,K){return this.s(N,z,_=>_.resolveWorkspaceSymbol(H,K),void 0,void 0)}$releaseWorkspaceSymbols(N,H){this.s(N,z,K=>K.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(N,H,K){const _=this.t(new j(this.h,K,this.l),N);return this.e.$registerRenameSupport(_,this.o(H),j.supportsResolving(K)),this.p(_)}$provideRenameEdits(N,H,K,_,he){return this.s(N,j,we=>we.provideRenameEdits(c.URI.revive(H),K,_,he),void 0,he)}$resolveRenameLocation(N,H,K,_){return this.s(N,j,he=>he.resolveRenameLocation(c.URI.revive(H),K,_),void 0,_)}registerDocumentSemanticTokensProvider(N,H,K,_){const he=this.t(new V(this.h,K),N),we=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(he,this.o(H),_,we);let Ae=this.p(he);if(we){const be=K.onDidChangeSemanticTokens(Ce=>this.e.$emitDocumentSemanticTokensEvent(we));Ae=R.Disposable.from(Ae,be)}return Ae}$provideDocumentSemanticTokens(N,H,K,_){return this.s(N,V,he=>he.provideDocumentSemanticTokens(c.URI.revive(H),K,_),null,_)}$releaseDocumentSemanticTokens(N,H){this.s(N,V,K=>K.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(N,H,K,_){const he=this.t(new X(this.h,K),N);return this.e.$registerDocumentRangeSemanticTokensProvider(he,this.o(H),_),this.p(he)}$provideDocumentRangeSemanticTokens(N,H,K,_){return this.s(N,X,he=>he.provideDocumentRangeSemanticTokens(c.URI.revive(H),K,_),null,_)}registerCompletionItemProvider(N,H,K,_){const he=this.t(new J(this.h,this.j.converter,K,this.m,N),N);return this.e.$registerCompletionsProvider(he,this.o(H),_,J.supportsResolving(K),`${N.identifier.value}(${_.join("")})`),this.p(he)}$provideCompletionItems(N,H,K,_,he){return this.s(N,J,we=>we.provideCompletionItems(c.URI.revive(H),K,_,he),void 0,he)}$resolveCompletionItem(N,H,K){return this.s(N,J,_=>_.resolveCompletionItem(H,K),void 0,K)}$releaseCompletionItems(N,H){this.s(N,J,K=>K.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(N,H,K){const _=new ee(N,this.h,K,this.j.converter),he=this.t(_,N);return this.e.$registerInlineCompletionsSupport(he,this.o(H),_.supportsHandleDidShowCompletionItem),this.p(he)}$provideInlineCompletions(N,H,K,_,he){return this.s(N,te,we=>we.provideInlineCompletions(c.URI.revive(H),K,_,he),void 0,he)}$handleInlineCompletionDidShow(N,H,K){this.s(N,te,async _=>{_.handleDidShowCompletionItem(H,K)},void 0,void 0)}$freeInlineCompletionsList(N,H){this.s(N,te,async K=>{K.disposeCompletions(H)},void 0,void 0)}registerSignatureHelpProvider(N,H,K,_){const he=Array.isArray(_)?{triggerCharacters:_,retriggerCharacters:[]}:_,we=this.t(new Y(this.h,K),N);return this.e.$registerSignatureHelpProvider(we,this.o(H),he),this.p(we)}$provideSignatureHelp(N,H,K,_,he){return this.s(N,Y,we=>we.provideSignatureHelp(c.URI.revive(H),K,_,he),void 0,he)}$releaseSignatureHelp(N,H){this.s(N,Y,K=>K.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(N,H,K){const _=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,he=this.t(new ie(this.h,this.j.converter,K,this.l,N),N);this.e.$registerInlayHintsProvider(he,this.o(H),typeof K.resolveInlayHint=="function",_,le.u(N));let we=this.p(he);if(_!==void 0){const Ae=K.onDidChangeInlayHints(be=>this.e.$emitInlayHintsEvent(_));we=R.Disposable.from(we,Ae)}return we}$provideInlayHints(N,H,K,_){return this.s(N,ie,he=>he.provideInlayHints(c.URI.revive(H),K,_),void 0,_)}$resolveInlayHint(N,H,K){return this.s(N,ie,_=>_.resolveInlayHint(H,K),void 0,K)}$releaseInlayHints(N,H){this.s(N,ie,K=>K.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(N,H,K){const _=this.t(new pe(this.h,K),N);return this.e.$registerDocumentLinkProvider(_,this.o(H),typeof K.resolveDocumentLink=="function"),this.p(_)}$provideDocumentLinks(N,H,K){return this.s(N,pe,_=>_.provideLinks(c.URI.revive(H),K),void 0,K,H.scheme==="output")}$resolveDocumentLink(N,H,K){return this.s(N,pe,_=>_.resolveLink(H,K),void 0,void 0,!0)}$releaseDocumentLinks(N,H){this.s(N,pe,K=>K.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(N,H,K){const _=this.t(new ve(this.h,K),N);return this.e.$registerDocumentColorProvider(_,this.o(H)),this.p(_)}$provideDocumentColors(N,H,K){return this.s(N,ve,_=>_.provideColors(c.URI.revive(H),K),[],K)}$provideColorPresentations(N,H,K,_){return this.s(N,ve,he=>he.provideColorPresentations(c.URI.revive(H),K,_),void 0,_)}registerFoldingRangeProvider(N,H,K){const _=this.q(),he=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(_,new Z(new ke(this.h,K),N)),this.e.$registerFoldingRangeProvider(_,this.o(H),N.identifier,he);let we=this.p(_);if(he!==void 0){const Ae=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(he));we=R.Disposable.from(we,Ae)}return we}$provideFoldingRanges(N,H,K,_){return this.s(N,ke,he=>he.provideFoldingRanges(c.URI.revive(H),K,_),void 0,_)}registerSelectionRangeProvider(N,H,K){const _=this.t(new Oe(this.h,K,this.l),N);return this.e.$registerSelectionRangeProvider(_,this.o(H)),this.p(_)}$provideSelectionRanges(N,H,K,_){return this.s(N,Oe,he=>he.provideSelectionRanges(c.URI.revive(H),K,_),[],_)}registerCallHierarchyProvider(N,H,K){const _=this.t(new oe(this.h,K),N);return this.e.$registerCallHierarchyProvider(_,this.o(H)),this.p(_)}$prepareCallHierarchy(N,H,K,_){return this.s(N,oe,he=>Promise.resolve(he.prepareSession(c.URI.revive(H),K,_)),void 0,_)}$provideCallHierarchyIncomingCalls(N,H,K,_){return this.s(N,oe,he=>he.provideCallsTo(H,K,_),void 0,_)}$provideCallHierarchyOutgoingCalls(N,H,K,_){return this.s(N,oe,he=>he.provideCallsFrom(H,K,_),void 0,_)}$releaseCallHierarchy(N,H){this.s(N,oe,K=>Promise.resolve(K.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(N,H,K){const _=this.t(new ae(this.h,K),N);return this.e.$registerTypeHierarchyProvider(_,this.o(H)),this.p(_)}$prepareTypeHierarchy(N,H,K,_){return this.s(N,ae,he=>Promise.resolve(he.prepareSession(c.URI.revive(H),K,_)),void 0,_)}$provideTypeHierarchySupertypes(N,H,K,_){return this.s(N,ae,he=>he.provideSupertypes(H,K,_),void 0,_)}$provideTypeHierarchySubtypes(N,H,K,_){return this.s(N,ae,he=>he.provideSubtypes(H,K,_),void 0,_)}$releaseTypeHierarchy(N,H){this.s(N,ae,K=>Promise.resolve(K.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(N,H,K){const _=this.q();return this.f.set(_,new Z(new fe(this.e,this.h,K,_),N)),this.e.$registerDocumentOnDropEditProvider(_,this.o(H)),this.p(_)}$provideDocumentOnDropEdits(N,H,K,_,he,we){return this.s(N,fe,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(H,c.URI.revive(K),_,he,we)),void 0,void 0)}registerDocumentPasteEditProvider(N,H,K,_){const he=this.q();return this.f.set(he,new Z(new M(this.e,this.h,K,he),N)),this.e.$registerPasteEditProvider(he,this.o(H),!!K.prepareDocumentPaste,_.pasteMimeTypes),this.p(he)}$prepareDocumentPaste(N,H,K,_,he){return this.s(N,M,we=>we.prepareDocumentPaste(c.URI.revive(H),K,_,he),void 0,he)}$providePasteEdits(N,H,K,_,he,we){return this.s(N,M,Ae=>Ae.providePasteEdits(H,c.URI.revive(K),_,he,we),void 0,we)}static w(N){return{pattern:N.source,flags:(0,S.regExpFlags)(N)}}static y(N){return{decreaseIndentPattern:le.w(N.decreaseIndentPattern),increaseIndentPattern:le.w(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?le.w(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?le.w(N.unIndentedLinePattern):void 0}}static z(N){return{beforeText:le.w(N.beforeText),afterText:N.afterText?le.w(N.afterText):void 0,previousLineText:N.previousLineText?le.w(N.previousLineText):void 0,action:N.action}}static B(N){return N.map(le.z)}setLanguageConfiguration(N,H,K){const{wordPattern:_}=K;if(_&&(0,S.regExpLeadsToEndlessLoop)(_))throw new Error(`Invalid language configuration: wordPattern '${_}' is not allowed to match the empty string.`);_?this.h.setWordDefinitionFor(H,_):this.h.setWordDefinitionFor(H,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const he=this.q(),we={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?le.w(K.wordPattern):void 0,indentationRules:K.indentationRules?le.y(K.indentationRules):void 0,onEnterRules:K.onEnterRules?le.B(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport};return this.e.$setLanguageConfiguration(he,H,we),this.p(he)}$setWordDefinitions(N){for(const H of N)this.h.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}le.d=0,e.ExtHostLanguageFeatures=le}),define(ye[264],De([1,0,5,14,7,37,19,6]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(L,k,v,T){this.c=k,this.d=v,this.e=T,this.b=[],this.f=0,this.g=new Set,this.a=L.getProxy(c.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this.b=L}async getLanguages(){return this.b.slice(0)}async changeLanguage(L,k){await this.a.$changeLanguage(L,k);const v=this.c.getDocumentData(L);if(!v)throw new Error(`document '${L.toString()}' NOT found`);return v.document}async tokenAtPosition(L,k){const v=L.version,T=A.Position.from(k),E=await this.a.$tokensAtPosition(L.uri,T),f={type:u.StandardTokenType.Other,range:L.getWordRangeAtPosition(k)??new u.Range(k.line,k.character,k.line,k.character)};if(!E)return f;const d={range:A.Range.to(E.range),type:A.TokenType.to(E.type)};return!d.range.contains(k)||v!==L.version?f:d}createLanguageStatusItem(L,k,v){const T=this.f++,E=this.a,f=this.g,d=`${L.identifier.value}/${k}`;if(f.has(d))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);f.add(d);const h={selector:v,id:k,name:L.displayName??L.name,severity:u.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let g;const p=new P.DisposableStore,y=()=>{g?.dispose(),g=(0,C.disposableTimeout)(()=>{p.clear(),this.a.$setLanguageStatus(T,{id:d,name:h.name??L.displayName??L.name,source:L.displayName??L.name,selector:A.DocumentSelector.from(h.selector,this.e),label:h.text,detail:h.detail??"",severity:h.severity===u.LanguageStatusSeverity.Error?R.default.Error:h.severity===u.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:h.command&&this.d.toInternal(h.command,p),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},b={dispose(){p.dispose(),g?.dispose(),E.$removeLanguageStatus(T),f.delete(d)},get id(){return h.id},get name(){return h.name},set name(i){h.name=i,y()},get selector(){return h.selector},set selector(i){h.selector=i,y()},get text(){return h.text},set text(i){h.text=i,y()},get detail(){return h.detail},set detail(i){h.detail=i,y()},get severity(){return h.severity},set severity(i){h.severity=i,y()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(i){h.accessibilityInformation=i,y()},get command(){return h.command},set command(i){h.command=i,y()},get busy(){return h.busy},set busy(i){h.busy=i,y()}};return y(),b}}e.ExtHostLanguages=S}),define(ye[97],De([1,0,12,8,2,4,13,5,25,20]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let L=class{constructor(v,T,E){this.f=E,this.d=new Map,this.a=T.getProxy(P.MainContext.MainThreadLocalization),this.b=v.environment.appLanguage,this.c=this.b===c.LANGUAGE_DEFAULT}getMessage(v,T){const{message:E,args:f,comment:d}=T;if(this.c)return(0,A.format2)(E,f??{});let h=E;d&&d.length>0&&(h+=`/${Array.isArray(d)?d.join(""):d}`);const g=this.d.get(v)?.contents[h];return g||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${h}`),(0,A.format2)(g??E,f??{})}getBundle(v){return this.d.get(v)?.contents}getBundleUri(v){return this.d.get(v)?.uri}async initializeLocalizedMessages(v){if(this.c||!v.l10n&&!v.isBuiltin||this.d.has(v.identifier.value))return;let T;const E=await this.g(v);if(!E){this.f.error(`No bundle location found for extension ${v.identifier.value}`);return}try{const f=await this.a.$fetchBundleContents(E),d=JSON.parse(f);T=v.isBuiltin?d.contents?.bundle:d}catch(f){this.f.error(`Failed to load translations for ${v.identifier.value} from ${E}: ${f.message}`);return}T&&this.d.set(v.identifier.value,{contents:T,uri:E})}async g(v){if(v.isBuiltin){const T=await this.a.$fetchBuiltInBundleUri(v.identifier.value);return u.URI.revive(T)}return v.l10n?u.URI.joinPath(v.extensionLocation,v.l10n,`bundle.l10n.${this.b}.json`):void 0}};L=qe([We(0,S.IExtHostInitDataService),We(1,I.IExtHostRpcService),We(2,C.ILogService)],L),e.ExtHostLocalizationService=L,e.IExtHostLocalizationService=(0,R.createDecorator)("IExtHostLocalizationService")}),define(ye[140],De([1,0,13,5,25,20,2,69]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let S=class extends c.AbstractLoggerService{constructor(k,v){super(v.logLevel,v.loggers.map(T=>(0,P.revive)(T))),this.l=k.getProxy(A.MainContext.MainThreadLogger)}$setLogLevel(k,v){v?this.setLogLevel(C.URI.revive(v),k):this.setLogLevel(k)}setVisibility(k,v){super.setVisibility(k,v),this.l.$setVisibility(k,v)}k(k,v,T){return new I(this.l,k,v,T)}};S=qe([We(0,R.IExtHostRpcService),We(1,u.IExtHostInitDataService)],S),e.ExtHostLoggerService=S;class I extends c.AbstractMessageLogger{constructor(k,v,T,E){super(E?.logLevel==="always"),this.m=k,this.n=v,this.k=!1,this.l=[],this.setLevel(T),this.m.$createLogger(v,E).then(()=>{this.r(this.l),this.k=!0})}g(k,v){const T=[[k,v]];this.k?this.r(T):this.l.push(...T)}r(k){this.m.$log(this.n,k)}}}),define(ye[265],De([1,0,5,13,27]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function R(P){return P&&P.title}let C=class{constructor(S,I){this.b=I,this.a=S.getProxy(c.MainContext.MainThreadMessageService)}showMessage(S,I,L,k,v){const T={source:{identifier:S.identifier,label:S.displayName||S.name}};let E;typeof k=="string"||R(k)?E=[k,...v]:(T.modal=k?.modal,T.useCustom=k?.useCustom,T.detail=k?.detail,E=v),T.useCustom&&(0,u.checkProposedApiEnabled)(S,"resolvers");const f=[];for(let d=0;d<E.length;d++){const h=E[d];if(typeof h=="string")f.push({title:h,handle:d,isCloseAffordance:!1});else if(typeof h=="object"){const{title:g,isCloseAffordance:p}=h;f.push({title:g,isCloseAffordance:!!p,handle:d})}else this.b.warn("Invalid message item:",h)}return this.a.$showMessage(I,L,T,f).then(d=>{if(typeof d=="number")return E[d]})}};C=qe([We(1,A.ILogService)],C),e.ExtHostMessageService=C}),define(ye[266],De([1,0,22,3,6,28,8,9,2,74,5,40,14,7,58,241,136]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class h{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(p=>p.apiEditor)}constructor(p,y,b,i){this.q=b,this.r=i,this.f=new Map,this.g=new R.ResourceMap,this.h=new Map,this.j=new A.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new A.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new A.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new A.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=p.getProxy(L.MainContext.MainThreadNotebook),this.c=p.getProxy(L.MainContext.MainThreadNotebookDocuments),this.d=p.getProxy(L.MainContext.MainThreadNotebookEditors),this.i=y.converter,y.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===13){const s=o.notebookEditor?.notebookUri,l=o.cell.handle,m=this.g.get(s)?.getCell(l);if(m)return m.apiCell}if(o&&o.$mid===14){const s=o.uri,l=this.g.get(s);if(l)return l.apiNotebook}return o}}),h.x(y)}getEditorById(p){const y=this.h.get(p);if(!y)throw new Error(`unknown text editor: ${p}. known editors: ${[...this.h.keys()]} `);return y}getIdByEditor(p){for(const[y,b]of this.h)if(b.apiEditor===p)return y}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(p,y){const b=this.g.get(p);if(!b&&!y)throw new Error(`NO notebook document for '${p}'`);return b}static s(p,y){if(!y)return;const b=y.filenamePattern.map(i=>v.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(y.filenamePattern&&!b){console.warn(`Notebook content provider view options file name pattern is invalid ${y.filenamePattern}`);return}return{extension:p.identifier,providerDisplayName:p.displayName||p.name,displayName:y.displayName,filenamePattern:b,exclusive:y.exclusive||!1}}registerNotebookCellStatusBarItemProvider(p,y,b){const i=h.a++,o=typeof b.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(i,b),this.b.$registerNotebookCellStatusBarItemProvider(i,o,y);let s;return o!==void 0&&(s=b.onDidChangeCellStatusBarItems(l=>this.b.$emitCellStatusBarEvent(o))),new T.Disposable(()=>{this.f.delete(i),this.b.$unregisterNotebookCellStatusBarItemProvider(i,o),s?.dispose()})}async createNotebookDocument(p){const y=await this.c.$tryCreateNotebook({viewType:p.viewType,content:p.content&&v.NotebookData.from(p.content)});return S.URI.revive(y)}async openNotebookDocument(p){const y=this.g.get(p);if(y)return y.apiNotebook;const b=await this.c.$tryOpenNotebook(p),i=this.g.get(S.URI.revive(b));return(0,P.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(p,y){S.URI.isUri(p)&&(p=await this.openNotebookDocument(p));let b;typeof y=="object"?b={position:v.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selections:y.selections&&y.selections.map(v.NotebookRange.from),pinned:typeof y.preview=="boolean"?!y.preview:void 0}:b={preserveFocus:!1};const i=await this.d.$tryShowNotebookDocument(p.uri,p.notebookType,b),o=i&&this.h.get(i)?.apiEditor;if(o)return o;throw i?new Error(`Could NOT open editor for "${p.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${p.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(p,y,b,i){const o=this.f.get(p),s=S.URI.revive(y),l=this.g.get(s);if(!l||!o)return;const r=l.getCellFromIndex(b);if(!r)return;const m=await o.provideCellStatusBarItems(r.apiCell,i);if(!m)return;const n=new u.DisposableStore,t=this.p.add([n]),w=(Array.isArray(m)?m:[m]).map(D=>v.NotebookStatusBarItem.from(D,this.i,n));return{cacheId:t,items:w}}$releaseNotebookCellStatusBarItems(p){this.p.delete(p)}registerNotebookSerializer(p,y,b,i,o){if((0,C.isFalsyOrWhitespace)(y))throw new Error("viewType cannot be empty or just whitespace");const s=this.t++;return this.u.set(s,b),this.b.$registerNotebookSerializer(s,{id:p.identifier,location:p.extensionLocation},y,v.NotebookDocumentContentOptions.from(i),h.s(p,o)),(0,u.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(s)})}async $dataToNotebook(p,y,b){const i=this.u.get(p);if(!i)throw new Error("NO serializer found");const o=await i.deserializeNotebook(y.buffer,b);return new E.SerializableObjectWithBuffers(v.NotebookData.from(o))}async $notebookToData(p,y,b){const i=this.u.get(p);if(!i)throw new Error("NO serializer found");const o=await i.serializeNotebook(v.NotebookData.to(y.value),b);return c.VSBuffer.wrap(o)}w(p,y,b){if(this.h.has(y))throw new Error(`editor with id ALREADY EXSIST: ${y}`);const i=new d.ExtHostNotebookEditor(y,this.d,p,b.visibleRanges.map(v.NotebookRange.to),b.selections.map(v.NotebookRange.to),typeof b.viewColumn=="number"?v.ViewColumn.to(b.viewColumn):void 0);this.h.set(y,i)}$acceptDocumentAndEditorsDelta(p){if(p.value.removedDocuments)for(const b of p.value.removedDocuments){const i=S.URI.revive(b),o=this.g.get(i);o&&(o.dispose(),this.g.delete(i),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:o.apiNotebook.getCells().map(s=>s.document.uri)}),this.n.fire(o.apiNotebook));for(const s of this.h.values())s.notebookData.uri.toString()===i.toString()&&this.h.delete(s.id)}if(p.value.addedDocuments){const b=[];for(const i of p.value.addedDocuments){const o=S.URI.revive(i.uri);if(this.g.has(o))throw new Error(`adding EXISTING notebook ${o} `);const s=new f.ExtHostNotebookDocument(this.c,this.q,this.r,o,i);b.push(...i.cells.map(l=>f.ExtHostCell.asModelAddData(s.apiNotebook,l))),this.g.get(o)?.dispose(),this.g.set(o,s),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:b}),this.m.fire(s.apiNotebook)}}if(p.value.addedEditors)for(const b of p.value.addedEditors){if(this.h.has(b.id))return;const i=S.URI.revive(b.documentUri),o=this.g.get(i);o&&this.w(o,b.id,b)}const y=[];if(p.value.removedEditors)for(const b of p.value.removedEditors){const i=this.h.get(b);i&&(this.h.delete(b),this.k?.id===i.id&&(this.k=void 0),y.push(i))}if(p.value.visibleEditors){this.l=p.value.visibleEditors.map(i=>this.h.get(i)).filter(i=>!!i);const b=new Set;this.l.forEach(i=>b.add(i.id));for(const i of this.h.values()){const o=b.has(i.id);i._acceptVisibility(o)}this.l=[...this.h.values()].map(i=>i).filter(i=>i.visible),this.o.fire(this.visibleNotebookEditors)}p.value.newActiveEditor===null?this.k=void 0:p.value.newActiveEditor&&(this.k=this.h.get(p.value.newActiveEditor)),p.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(p){const y=k.ApiCommandArgument.String.with("notebookType","A notebook type"),b=new k.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[y,new k.ApiCommandArgument("data","Bytes to convert to data",o=>o instanceof Uint8Array,o=>c.VSBuffer.wrap(o))],new k.ApiCommandResult("Notebook Data",o=>v.NotebookData.to(o.value))),i=new k.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[y,new k.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",o=>!0,o=>new E.SerializableObjectWithBuffers(v.NotebookData.from(o)))],new k.ApiCommandResult("Bytes",o=>o.buffer));p.registerApiCommand(b),p.registerApiCommand(i)}}h.a=0,e.ExtHostNotebookController=h}),define(ye[267],De([1,0,15,19,21,3,6,28,2,26,13,74,5,40,14,7,94,231,27,58]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,f,d,h,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let y=class{constructor(r,m,n,t,a){this.k=m,this.l=n,this.m=t,this.n=a,this.b=new P.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new k.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=r.getProxy(v.MainContext.MainThreadNotebookKernels);const w=new T.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new T.ApiCommandArgument("options","Select kernel options",D=>!0,D=>{if(D&&"notebookEditor"in D&&"id"in D){const F=this.l.getIdByEditor(D.notebookEditor);return{id:D.id,extension:D.extension,notebookEditorId:F}}else if(D&&"notebookEditor"in D){const F=this.l.getIdByEditor(D.notebookEditor);if(F===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${D.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:F}}return D})],T.ApiCommandResult.Void);this.m.registerApiCommand(w)}createNotebookController(r,m,n,t,a,w){for(const te of this.h.values())if(te.controller.id===m&&I.ExtensionIdentifier.equals(r.identifier,te.extensionId))throw new Error(`notebook controller with id '${m}' ALREADY exist`);const D=this.i++,F=this;this.n.trace(`NotebookController[${D}], CREATED by ${r.identifier.value}, ${m}`);const x=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${r.identifier}'`);let q=!1;const M=new C.DisposableStore,B=new R.Emitter,O=new R.Emitter,U={id:s(r.identifier,m),notebookType:n,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:t||r.identifier.value,preloads:w?w.map(E.NotebookRendererScript.from):[]};let z=a??x,j;this.a.$addKernel(D,U).catch(te=>{console.log(te),q=!0});let de=0;const V=()=>{if(q)return;const te=++de;Promise.resolve().then(()=>{te===de&&this.a.$updateKernel(D,U)})},X=new P.ResourceMap,J={get id(){return m},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return U.label},set label(te){U.label=te??r.displayName??r.name,V()},get detail(){return U.detail??""},set detail(te){U.detail=te,V()},get description(){return U.description??""},set description(te){U.description=te,V()},get kind(){return(0,g.checkProposedApiEnabled)(r,"notebookControllerKind"),U.kind??""},set kind(te){(0,g.checkProposedApiEnabled)(r,"notebookControllerKind"),U.kind=te,V()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(te){U.supportedLanguages=te,V()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(te){U.supportsExecutionOrder=te,V()},get rendererScripts(){return U.preloads?U.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(te){z=te??x},get interruptHandler(){return j},set interruptHandler(te){j=te,U.supportsInterrupt=Boolean(te),V()},createNotebookCellExecution(te){if(q)throw new Error("notebook controller is DISPOSED");if(!X.has(te.notebook.uri))throw F.n.trace(`NotebookController[${D}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(ee=>ee.toString())),new Error(`notebook controller is NOT associated to notebook: ${te.notebook.uri.toString()}`);return F._createNotebookCellExecution(te,s(r.identifier,this.id))},dispose:()=>{q||(this.n.trace(`NotebookController[${D}], DISPOSED`),q=!0,this.h.delete(D),M.dispose(),B.dispose(),O.dispose(),this.a.$removeKernel(D))},updateNotebookAffinity(te,ee){ee===f.NotebookControllerAffinity2.Hidden&&(0,g.checkProposedApiEnabled)(r,"notebookControllerAffinityHidden"),F.a.$updateNotebookPriority(D,te.uri,ee)},onDidReceiveMessage:O.event,postMessage(te,ee){return(0,g.checkProposedApiEnabled)(r,"notebookMessaging"),F.a.$postMessage(D,ee&&F.l.getIdByEditor(ee),te)},asWebviewUri(te){return(0,g.checkProposedApiEnabled)(r,"notebookMessaging"),(0,d.asWebviewUri)(te,F.k.remote)}};return this.h.set(D,{extensionId:r.identifier,controller:J,onDidReceiveMessage:O,onDidChangeSelection:B,associatedNotebooks:X}),J}getIdByController(r){for(const[m,n]of this.h)if(n.controller===r)return s(n.extensionId,r.id);return null}createNotebookControllerDetectionTask(r,m){const n=this.d++,t=this;this.n.trace(`NotebookControllerDetectionTask[${n}], CREATED by ${r.identifier.value}`),this.a.$addKernelDetectionTask(n,m);const a={dispose:()=>{this.c.delete(n),t.a.$removeKernelDetectionTask(n)}};return this.c.set(n,a),a}registerKernelSourceActionProvider(r,m,n){const t=this.f++,a=typeof n.onDidChangeNotebookKernelSourceActions=="function"?t:void 0,w=this;this.e.set(t,n),this.n.trace(`NotebookKernelSourceActionProvider[${t}], CREATED by ${r.identifier.value}`),this.a.$addKernelSourceActionProvider(t,t,m);let D;return a!==void 0&&(D=n.onDidChangeNotebookKernelSourceActions(F=>this.a.$emitNotebookKernelSourceActionsChangeEvent(a))),{dispose:()=>{this.e.delete(t),w.a.$removeKernelSourceActionProvider(t,t),D?.dispose()}}}async $provideKernelSourceActions(r,m){const n=this.e.get(r);if(n){const t=new C.DisposableStore;return this.g.add([t]),(await n.provideNotebookKernelSourceActions(m)??[]).map(w=>E.NotebookKernelSourceAction.from(w,this.m.converter,t))}return[]}$acceptNotebookAssociation(r,m,n){const t=this.h.get(r);if(t){const a=this.l.getNotebookDocument(S.URI.revive(m));n?t.associatedNotebooks.set(a.uri,!0):t.associatedNotebooks.delete(a.uri),this.n.trace(`NotebookController[${r}] ASSOCIATE notebook`,a.uri.toString(),n),t.onDidChangeSelection.fire({selected:n,notebook:a.apiNotebook})}}async $executeCells(r,m,n){const t=this.h.get(r);if(!t)return;const a=this.l.getNotebookDocument(S.URI.revive(m)),w=[];for(const D of n){const F=a.getCell(D);F&&w.push(F.apiCell)}try{this.n.trace(`NotebookController[${r}] EXECUTE cells`,a.uri.toString(),w.length),await t.controller.executeHandler.call(t.controller,w,a.apiNotebook,t.controller)}catch(D){this.n.error(`NotebookController[${r}] execute cells FAILED`,D),console.error(D)}}async $cancelCells(r,m,n){const t=this.h.get(r);if(!t)return;const a=this.l.getNotebookDocument(S.URI.revive(m));if(t.controller.interruptHandler)await t.controller.interruptHandler.call(t.controller,a.apiNotebook);else for(const w of n){const D=a.getCell(w);D&&this.b.get(D.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,m,n){const t=this.h.get(r);if(!t)return;const a=this.l.getEditorById(m);t.onDidReceiveMessage.fire(Object.freeze({editor:a.apiEditor,message:n}))}$cellExecutionChanged(r,m,n){const a=this.l.getNotebookDocument(S.URI.revive(r)).getCell(m);if(a){const w=n?E.NotebookCellExecutionState.to(n):f.NotebookCellExecutionState.Idle;w!==void 0&&this.j.fire({cell:a.apiCell,state:w})}}_createNotebookCellExecution(r,m){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const t=this.l.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!t)throw new Error("invalid cell");if(this.b.has(t.uri))throw new Error(`duplicate execution for ${t.uri}`);const a=new i(m,t,this.a);this.b.set(t.uri,a);const w=a.onDidChangeState(()=>{a.state===b.Resolved&&(a.dispose(),w.dispose(),this.b.delete(t.uri))});return a.asApiObject()}};y=qe([We(4,L.ILogService)],y),e.ExtHostNotebookKernels=y;var b;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(b||(b={}));class i extends C.Disposable{get state(){return this.f}constructor(r,m,n){super(),this.j=m,this.k=n,this.b=i.a++,this.c=new R.Emitter,this.onDidChangeState=this.c.event,this.f=b.Init,this.g=this.B(new u.CancellationTokenSource),this.h=new o(10,t=>this.m(t)),this.i=m.internalMetadata.executionOrder,this.k.$createExecution(this.b,r,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(r){await this.h.addItem(r)}async m(r){const m=Array.isArray(r)?r:[r];return this.k.$updateExecution(this.b,new p.SerializableObjectWithBuffers(m))}n(){if(this.f===b.Init)throw new Error("Must call start before modifying cell output");if(this.f===b.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(r){let m=this.j;if(r&&(m=this.j.notebook.getCellFromApiCell(r)),!m)throw new Error("INVALID cell");return m.handle}s(r){return r.map(m=>{const n=f.NotebookCellOutput.ensureUniqueMimeTypes(m.items,!0);return n===m.items?E.NotebookCellOutput.from(m):E.NotebookCellOutput.from({items:n,id:m.id,metadata:m.metadata})})}async t(r,m,n){const t=this.r(m),a=this.s((0,c.asArray)(r));return this.l({editType:h.CellExecutionUpdateType.Output,cellHandle:t,append:n,outputs:a})}async w(r,m,n){return r=f.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(r),!0),this.l({editType:h.CellExecutionUpdateType.OutputItems,items:r.map(E.NotebookCellOutputItem.from),outputId:m.id,append:n})}asApiObject(){const r=this;return Object.freeze({get token(){return r.g.token},get cell(){return r.j.apiCell},get executionOrder(){return r.i},set executionOrder(n){r.i=n,r.m([{editType:h.CellExecutionUpdateType.ExecutionState,executionOrder:r.i}])},start(n){if(r.f===b.Resolved||r.f===b.Started)throw new Error("Cannot call start again");r.f=b.Started,r.c.fire(),r.m({editType:h.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,t){if(r.f===b.Resolved)throw new Error("Cannot call resolve twice");r.f=b.Resolved,r.c.fire(),r.h.flush(),r.k.$completeExecution(r.b,new p.SerializableObjectWithBuffers({runEndTime:t,lastRunSuccess:n}))},clearOutput(n){return r.n(),r.t([],n,!1)},appendOutput(n,t){return r.n(),r.t(n,t,!0)},replaceOutput(n,t){return r.n(),r.t(n,t,!1)},appendOutputItems(n,t){return r.n(),r.w(n,t,!0)},replaceOutputItems(n,t){return r.n(),r.w(n,t,!1)}})}}i.a=0;class o{constructor(r,m){this.d=r,this.e=m,this.a=[],this.b=Date.now()}addItem(r){return this.a.push(r),this.c||(this.c=new A.DeferredPromise,this.b=Date.now(),(0,A.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const r=this.c;this.c=void 0;const m=this.a;return this.a=[],this.e(m).finally(()=>r.complete())}}function s(l,r){return`${l.value}/${r}`}e.createKernelId=s}),define(ye[268],De([1,0,3,5,136]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(P,S){this.c=S,this.a=new Map,this.b=P.getProxy(A.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,S,I){const L=this.c.getEditorById(P);this.a.get(S)?.fire({editor:L.apiEditor,message:I})}createRendererMessaging(P,S){if(!P.contributes?.notebookRenderer?.some(L=>L.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(L,k,v)=>this.d(S).event(L,k,v),postMessage:(L,k)=>{u.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,k]=[k,L]);const v=k&&u.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);return this.b.$postMessage(v?.id,S,L)}}}d(P){let S=this.a.get(P);return S||(S=new c.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(P)}}),this.a.set(P,S),S)}}e.ExtHostNotebookRenderers=R}),define(ye[269],De([1,0,6,9,2,27,5]),function(ne,e,c,A,u,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class P{constructor(I){this.b=new Map,this.a=I.getProxy(C.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(I,L,k){if((0,R.checkProposedApiEnabled)(I,"profileContentHandlers"),this.b.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.b.set(L,k),this.a.$registerProfileContentHandler(L,k.name,k.description,I.identifier.value),(0,c.toDisposable)(()=>{this.b.delete(L),this.a.$unregisterProfileContentHandler(L)})}async $saveProfile(I,L,k,v){const T=this.b.get(I);if(!T)throw new Error(`Unknown handler with id: ${I}`);return T.saveProfile(L,k,v)}async $readProfile(I,L,k){const v=this.b.get(I);if(!v)throw new Error(`Unknown handler with id: ${I}`);return v.readProfile((0,A.isString)(L)?L:u.URI.revive(L),k)}}e.ExtHostProfileContentHandlers=P}),define(ye[270],De([1,0,2,5,19,14]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class C{constructor(S,I){this.d=I,this.c=new Map,this.b=S.getProxy(A.MainContext.MainThreadQuickDiff)}$provideOriginalResource(S,I,L){const k=c.URI.revive(I),v=this.c.get(S);return v?(0,u.asPromise)(()=>v.provideOriginalResource(k,L)).then(T=>T||null):Promise.resolve(null)}registerQuickDiffProvider(S,I,L,k){const v=C.a++;return this.c.set(v,I),this.b.$registerQuickDiffProvider(v,R.DocumentSelector.from(S,this.d),L,k),{dispose:()=>this.c.delete(v)}}}C.a=0,e.ExtHostQuickDiff=C}),define(ye[271],De([1,0,21,3,6,5,2,7,11,15,37,51]),function(ne,e,c,A,u,R,C,P,S,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function v(T,E,f){const d=T.getProxy(R.MainContext.MainThreadQuickOpen);class h{constructor(r,m){this.e=new Map,this.f=0,this.a=r,this.b=m}showQuickPick(r,m,n=c.CancellationToken.None){this.c=void 0;const t=Promise.resolve(r),a=++this.f,w=d.$show(a,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},n),D={},F=w.then(()=>D);return Promise.race([F,t]).then(x=>{if(x!==D)return t.then(q=>{const M=[];for(let B=0;B<q.length;B++){const O=q[B];typeof O=="string"?M.push({label:O,handle:B}):O.kind===P.QuickPickItemKind.Separator?M.push({type:"separator",label:O.label}):M.push({label:O.label,description:O.description,detail:O.detail,picked:O.picked,alwaysShow:O.alwaysShow,handle:B})}return m&&typeof m.onDidSelectItem=="function"&&(this.c=B=>{m.onDidSelectItem(q[B])}),d.$setItems(a,M),w.then(B=>{if(typeof B=="number")return q[B];if(Array.isArray(B))return B.map(O=>q[O])})})}).then(void 0,x=>{if(!(0,S.isCancellationError)(x))return d.$setError(a,x),Promise.reject(x)})}$onItemSelected(r){this.c?.(r)}showInput(r,m=c.CancellationToken.None){return this.d=r?.validateInput,d.$input(r,typeof this.d=="function",m).then(void 0,n=>{if(!(0,S.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(r){if(!this.d)return;const m=await this.d(r);if(!m||typeof m=="string")return m;let n;switch(m.severity){case P.InputBoxValidationSeverity.Info:n=L.default.Info;break;case P.InputBoxValidationSeverity.Warning:n=L.default.Warning;break;case P.InputBoxValidationSeverity.Error:n=L.default.Error;break;default:n=m.message?L.default.Error:L.default.Ignore;break}return{content:m.message,severity:n}}async showWorkspaceFolderPick(r,m=c.CancellationToken.None){const n=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!n)return;const t=await this.a.getWorkspaceFolders2();if(!!t)return t.find(a=>a.uri.toString()===n.uri.toString())}createQuickPick(r){const m=new o(r,()=>this.e.delete(m._id));return this.e.set(m._id,m),m}createInputBox(r){const m=new s(r,()=>this.e.delete(m._id));return this.e.set(m._id,m),m}$onDidChangeValue(r,m){this.e.get(r)?._fireDidChangeValue(m)}$onDidAccept(r){this.e.get(r)?._fireDidAccept()}$onDidChangeActive(r,m){const n=this.e.get(r);n instanceof o&&n._fireDidChangeActive(m)}$onDidChangeSelection(r,m){const n=this.e.get(r);n instanceof o&&n._fireDidChangeSelection(m)}$onDidTriggerButton(r,m){this.e.get(r)?._fireDidTriggerButton(m)}$onDidTriggerItemButton(r,m,n){const t=this.e.get(r);t instanceof o&&t._fireDidTriggerItemButton(m,n)}$onDidHide(r){this.e.get(r)?._fireDidHide()}}class g{constructor(r,m){this.x=r,this.y=m,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new A.Emitter,this.q=new A.Emitter,this.r=new A.Emitter,this.s=new A.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(r){this.b=r,this.z({title:r})}get step(){return this.c}set step(r){this.c=r,this.z({step:r})}get totalSteps(){return this.d}set totalSteps(r){this.d=r,this.z({totalSteps:r})}get enabled(){return this.g}set enabled(r){this.g=r,this.z({enabled:r})}get busy(){return this.j}set busy(r){this.j=r,this.z({busy:r})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(r){this.k=r,this.z({ignoreFocusOut:r})}get value(){return this.l}set value(r){this.l=r,this.z({value:r})}get placeholder(){return this.m}set placeholder(r){this.m=r,this.z({placeholder:r})}get buttons(){return this.n}set buttons(r){this.n=r.slice(),this.o.clear(),r.forEach((m,n)=>{const t=m===P.QuickInputButtons.Back?-1:n;this.o.set(t,m)}),this.z({buttons:r.map((m,n)=>({...i(m),tooltip:m.tooltip,handle:m===P.QuickInputButtons.Back?-1:n}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(r){this.l=r,this.q.fire(r)}_fireDidTriggerButton(r){const m=this.o.get(r);m&&this.r.fire(m)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,u.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),d.$dispose(this._id))}z(r){if(!this.v){for(const m of Object.keys(r)){const n=r[m];this.u[m]=n===void 0?null:n}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){d.$createOrUpdate(this.u),this.u={id:this._id}}}g.a=1;function p(l){if(l instanceof P.ThemeIcon)return{id:l.id};const r=b(l),m=y(l);return{dark:typeof r=="string"?C.URI.file(r):r,light:typeof m=="string"?C.URI.file(m):m}}function y(l){return typeof l=="object"&&"light"in l?l.light:l}function b(l){return typeof l=="object"&&"dark"in l?l.dark:l}function i(l){const r=p(l.iconPath);let m,n;return"id"in r?n=k.ThemeIcon.asClassName(r):m=r,{iconPath:m,iconClass:n}}class o extends g{constructor(r,m){super(r.identifier,m),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new A.Emitter,this.L=[],this.M=new A.Emitter,this.N=new A.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(r){this.B=r.slice(),this.C.clear(),this.D.clear(),r.forEach((n,t)=>{this.C.set(t,n),this.D.set(n,t)});const m=[];for(let n=0;n<r.length;n++){const t=r[n];t.kind===P.QuickPickItemKind.Separator?m.push({type:"separator",label:t.label}):m.push({handle:n,label:t.label,description:t.description,detail:t.detail,picked:t.picked,alwaysShow:t.alwaysShow,buttons:t.buttons?.map((a,w)=>({...i(a),tooltip:a.tooltip,handle:w}))})}this.z({items:m})}get canSelectMany(){return this.E}set canSelectMany(r){this.E=r,this.z({canSelectMany:r})}get matchOnDescription(){return this.F}set matchOnDescription(r){this.F=r,this.z({matchOnDescription:r})}get matchOnDetail(){return this.G}set matchOnDetail(r){this.G=r,this.z({matchOnDetail:r})}get sortByLabel(){return this.H}set sortByLabel(r){this.H=r,this.z({sortByLabel:r})}get keepScrollPosition(){return this.I}set keepScrollPosition(r){this.I=r,this.z({keepScrollPosition:r})}get activeItems(){return this.J}set activeItems(r){this.J=r.filter(m=>this.D.has(m)),this.z({activeItems:this.J.map(m=>this.D.get(m))})}get selectedItems(){return this.L}set selectedItems(r){this.L=r.filter(m=>this.D.has(m)),this.z({selectedItems:this.L.map(m=>this.D.get(m))})}_fireDidChangeActive(r){const m=(0,I.coalesce)(r.map(n=>this.C.get(n)));this.J=m,this.K.fire(m)}_fireDidChangeSelection(r){const m=(0,I.coalesce)(r.map(n=>this.C.get(n)));this.L=m,this.M.fire(m)}_fireDidTriggerItemButton(r,m){const n=this.C.get(r);if(!n||!n.buttons||!n.buttons.length)return;const t=n.buttons[m];t&&this.N.fire({button:t,item:n})}}class s extends g{constructor(r,m){super(r.identifier,m),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(r){this.B=r,this.z({password:r})}get prompt(){return this.C}set prompt(r){this.C=r,this.z({prompt:r})}get valueSelection(){return this.D}set valueSelection(r){this.D=r,this.z({valueSelection:r})}get validationMessage(){return this.E}set validationMessage(r){this.E=r,r?typeof r=="string"?this.z({validationMessage:r,severity:L.default.Error}):this.z({validationMessage:r.message,severity:r.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new h(E,f)}e.createExtHostQuickOpen=v});var Be=this&&this.__classPrivateFieldGet||function(ne,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(ne):A?A.value:e.get(ne)},Je=this&&this.__classPrivateFieldSet||function(ne,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!u:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(ne,c):u?u.value=c:e.set(ne,c),c};define(ye[272],De([1,0,2,3,62,6,19,5,15,108,13,26,51,14,27]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E){"use strict";var f,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(t){if(t)return typeof t.iconPath=="string"?c.URI.file(t.iconPath):c.URI.isUri(t.iconPath)||v.ThemeIcon.isThemeIcon(t.iconPath)?t.iconPath:void 0}function g(t,a){if(!t.iconPath&&!a.iconPath)return 0;if(t.iconPath){if(!a.iconPath)return 1}else return-1;const w=typeof t.iconPath=="string"?t.iconPath:c.URI.isUri(t.iconPath)?t.iconPath.fsPath:t.iconPath.id,D=typeof a.iconPath=="string"?a.iconPath:c.URI.isUri(a.iconPath)?a.iconPath.fsPath:a.iconPath.id;return(0,I.comparePaths)(w,D)}function p(t,a){let w=0;if(t.strikeThrough!==a.strikeThrough)return t.strikeThrough?1:-1;if(t.faded!==a.faded)return t.faded?1:-1;if(t.tooltip!==a.tooltip)return(t.tooltip||"").localeCompare(a.tooltip||"");if(w=g(t,a),w!==0)return w;if(t.light&&a.light)w=g(t.light,a.light);else{if(t.light)return 1;if(a.light)return-1}if(w!==0)return w;if(t.dark&&a.dark)w=g(t.dark,a.dark);else{if(t.dark)return 1;if(a.dark)return-1}return w}function y(t,a){if(t.command!==a.command)return t.command<a.command?-1:1;if(t.title!==a.title)return t.title<a.title?-1:1;if(t.tooltip!==a.tooltip){if(t.tooltip!==void 0&&a.tooltip!==void 0)return t.tooltip<a.tooltip?-1:1;if(t.tooltip!==void 0)return 1;if(a.tooltip!==void 0)return-1}if(t.arguments===a.arguments)return 0;if(t.arguments)if(a.arguments){if(t.arguments.length!==a.arguments.length)return t.arguments.length-a.arguments.length}else return 1;else return-1;for(let w=0;w<t.arguments.length;w++){const D=t.arguments[w],F=a.arguments[w];if(D!==F)return D<F?-1:1}return 0}function b(t,a){let w=(0,I.comparePaths)(t.resourceUri.fsPath,a.resourceUri.fsPath,!0);if(w!==0)return w;if(t.command&&a.command)w=y(t.command,a.command);else{if(t.command)return 1;if(a.command)return-1}if(w!==0)return w;if(t.decorations&&a.decorations)w=p(t.decorations,a.decorations);else{if(t.decorations)return 1;if(a.decorations)return-1}return w}function i(t,a){for(let w=0;w<t.length;w++)if(t[w]!==a[w])return!1;return!0}function o(t,a){return t.command===a.command&&t.title===a.title&&t.tooltip===a.tooltip&&(t.arguments&&a.arguments?i(t.arguments,a.arguments):t.arguments===a.arguments)}function s(t,a){return(0,S.equals)(t,a,o)}class l{get value(){return this.d}set value(a){a=a??"",Be(this,f,"f").$setInputBoxValue(this.l,a),this.m(a)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(a){Be(this,f,"f").$setInputBoxPlaceholder(this.l,a),this.f=a}get validateInput(){return(0,E.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(a){if((0,E.checkProposedApiEnabled)(this.k,"scmValidation"),a&&typeof a!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=a,Be(this,f,"f").$setValidationProviderIsEnabled(this.l,!!a)}get enabled(){return this.h}set enabled(a){a=!!a,this.h!==a&&(this.h=a,Be(this,f,"f").$setInputBoxEnablement(this.l,a))}get visible(){return this.j}set visible(a){a=!!a,this.j!==a&&(this.j=a,Be(this,f,"f").$setInputBoxVisibility(this.l,a))}constructor(a,w,D){this.k=a,this.l=D,f.set(this,void 0),this.d="",this.e=new A.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,f,w,"f")}showValidationMessage(a,w){(0,E.checkProposedApiEnabled)(this.k,"scmValidation"),Be(this,f,"f").$showValidationMessage(this.l,a,w)}$onInputBoxValueChange(a){this.m(a)}m(a){this.d=a,this.e.fire(a)}}e.ExtHostSCMInputBox=l,f=new WeakMap;class r{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(a){this.v=a,this.q.$updateGroupLabel(this.t,this.handle,a)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(a){this.p=a,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(a){this.f=[...a],this.k.fire()}constructor(a,w,D,F,x){this.q=a,this.s=w,this.t=D,this.u=F,this.v=x,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new A.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new A.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=r.d++}getResourceState(a){return this.g.get(a)}$executeResourceCommand(a,w){const D=this.h.get(a);return D?(0,C.asPromise)(()=>this.s.executeCommand(D.command,...D.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const a=[...this.f].sort(b),D=(0,S.sortedDiff)(this.o,a,b).map(q=>{const M=q.toInsert.map(B=>{const O=this.e++;this.g.set(O,B);const U=B.resourceUri;let z;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const ie=new R.DisposableStore;z=this.s.converter.toInternal(B.command,ie),this.j.set(O,ie)}else this.h.set(O,B.command);const j=h(B.decorations),de=B.decorations&&h(B.decorations.light)||j,V=B.decorations&&h(B.decorations.dark)||j,X=[de,V],J=B.decorations&&B.decorations.tooltip||"",te=B.decorations&&!!B.decorations.strikeThrough,ee=B.decorations&&!!B.decorations.faded,Q=B.contextValue||"";return{rawResource:[O,U,X,J,te,ee,Q,z],handle:O}});return{start:q.start,deleteCount:q.deleteCount,toInsert:M}}),F=D.map(({start:q,deleteCount:M,toInsert:B})=>[q,M,B.map(O=>O.rawResource)]),x=D.reverse();for(const{start:q,deleteCount:M,toInsert:B}of x){const O=B.map(z=>z.handle),U=this.n.splice(q,M,...O);for(const z of U)this.g.delete(z),this.h.delete(z),this.j.get(z)?.dispose(),this.j.delete(z)}return this.o=a,F}dispose(){this.l=!0,this.m.fire()}}r.d=0;class m{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(a){this.g!==a&&(this.g=a,Be(this,d,"f").$updateSourceControl(this.t,{count:a}))}get quickDiffProvider(){return this.h}set quickDiffProvider(a){this.h=a,Be(this,d,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!a})}get commitTemplate(){return this.j}set commitTemplate(a){a!==this.j&&(this.j=a,Be(this,d,"f").$updateSourceControl(this.t,{commitTemplate:a}))}get acceptInputCommand(){return this.l}set acceptInputCommand(a){this.k.value=new R.DisposableStore,this.l=a;const w=this.v.converter.toInternal(a,this.k.value);Be(this,d,"f").$updateSourceControl(this.t,{acceptInputCommand:w})}get actionButton(){return(0,E.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(a){(0,E.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new R.DisposableStore,this.n=a;const w=a!==void 0?{command:this.v.converter.toInternal(a.command,this.m.value),secondaryCommands:a.secondaryCommands?.map(D=>D.map(F=>this.v.converter.toInternal(F,this.m.value))),description:a.description,enabled:a.enabled}:void 0;Be(this,d,"f").$updateSourceControl(this.t,{actionButton:w??null})}get statusBarCommands(){return this.p}set statusBarCommands(a){if(this.p&&a&&s(this.p,a))return;this.o.value=new R.DisposableStore,this.p=a;const w=(a||[]).map(D=>this.v.converter.toInternal(D,this.o.value));Be(this,d,"f").$updateSourceControl(this.t,{statusBarCommands:w})}get selected(){return this.q}constructor(a,w,D,F,x,q){this.u=a,this.v=D,this.w=F,this.x=x,this.y=q,d.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new R.MutableDisposable,this.l=void 0,this.m=new R.MutableDisposable,this.o=new R.MutableDisposable,this.p=void 0,this.q=!1,this.s=new A.Emitter,this.onDidChangeSelection=this.s.event,this.t=m.d++,this.z=new Map,this.A=new Set,Je(this,d,w,"f"),this.f=new l(a,Be(this,d,"f"),this.t),Be(this,d,"f").$registerSourceControl(this.t,F,x,q)}createResourceGroup(a,w){const D=new r(Be(this,d,"f"),this.v,this.t,a,w),F=A.Event.once(D.onDidDispose)(()=>this.z.delete(D));return this.z.set(D,F),this.eventuallyAddResourceGroups(),D}eventuallyAddResourceGroups(){const a=[],w=[];for(const[D,F]of this.z){F.dispose();const x=D.onDidUpdateResourceStates(()=>{this.A.add(D),this.eventuallyUpdateResourceStates()});A.Event.once(D.onDidDispose)(()=>{this.A.delete(D),x.dispose(),this.e.delete(D.handle),Be(this,d,"f").$unregisterGroup(this.t,D.handle)}),a.push([D.handle,D.id,D.label,D.features]);const q=D._takeResourceStateSnapshot();q.length>0&&w.push([D.handle,q]),this.e.set(D.handle,D)}Be(this,d,"f").$registerGroups(this.t,a,w),this.z.clear()}eventuallyUpdateResourceStates(){const a=[];this.A.forEach(w=>{const D=w._takeResourceStateSnapshot();D.length!==0&&a.push([w.handle,D])}),a.length>0&&Be(this,d,"f").$spliceResourceStates(this.t,a),this.A.clear()}getResourceGroup(a){return this.e.get(a)}setSelectionState(a){this.q=a,this.s.fire(a)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(a=>a.dispose()),Be(this,d,"f").$unregisterSourceControl(this.t)}}d=new WeakMap,m.d=0,qe([(0,u.debounce)(100)],m.prototype,"eventuallyAddResourceGroups",null),qe([(0,u.debounce)(100)],m.prototype,"eventuallyUpdateResourceStates",null);let n=class on{get onDidChangeActiveProvider(){return this.j.event}constructor(a,w,D){this.l=w,this.m=D,this.g=new Map,this.h=new Map,this.j=new A.Emitter,this.e=a.getProxy(P.MainContext.MainThreadSCM),this.f=a.getProxy(P.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:F=>{if(F&&F.$mid===3){const x=this.g.get(F.sourceControlHandle);if(!x)return F;const q=x.getResourceGroup(F.groupHandle);return q?q.getResourceState(F.handle):F}else if(F&&F.$mid===4){const x=this.g.get(F.sourceControlHandle);return x?x.getResourceGroup(F.groupHandle):F}else if(F&&F.$mid===5){const x=this.g.get(F.handle);return x||F}return F}})}createSourceControl(a,w,D,F){this.m.trace("ExtHostSCM#createSourceControl",a.identifier.value,w,D,F),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:a.identifier.value});const x=on.d++,q=new m(a,this.e,this.l,w,D,F);this.g.set(x,q);const M=this.h.get(k.ExtensionIdentifier.toKey(a.identifier))||[];return M.push(q),this.h.set(k.ExtensionIdentifier.toKey(a.identifier),M),q}getLastInputBox(a){this.m.trace("ExtHostSCM#getLastInputBox",a.identifier.value);const w=this.h.get(k.ExtensionIdentifier.toKey(a.identifier)),D=w&&w[w.length-1];return D&&D.inputBox}$provideOriginalResource(a,w,D){const F=c.URI.revive(w);this.m.trace("ExtHostSCM#$provideOriginalResource",a,F.toString());const x=this.g.get(a);return!x||!x.quickDiffProvider||!x.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>x.quickDiffProvider.provideOriginalResource(F,D)).then(q=>q||null)}$onInputBoxValueChange(a,w){this.m.trace("ExtHostSCM#$onInputBoxValueChange",a);const D=this.g.get(a);return D&&D.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(a,w,D,F){this.m.trace("ExtHostSCM#$executeResourceCommand",a,w,D);const x=this.g.get(a);if(!x)return Promise.resolve(void 0);const q=x.getResourceGroup(w);return q?q.$executeResourceCommand(D,F):Promise.resolve(void 0)}$validateInput(a,w,D){this.m.trace("ExtHostSCM#$validateInput",a);const F=this.g.get(a);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>F.inputBox.validateInput(w,D)).then(x=>{if(!x)return Promise.resolve(void 0);const q=T.MarkdownString.fromStrict(x.message);return q?Promise.resolve([q,x.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(a){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",a),a!==void 0&&this.g.get(a)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=a,Promise.resolve(void 0)}};n.d=0,n=qe([We(2,L.ILogService)],n),e.ExtHostSCM=n}),define(ye[98],De([1,0,5,3,4]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class R{constructor(P){this.b=new A.Emitter,this.onDidChangePassword=this.b.event,this.a=P.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this.b.fire(P)}get(P,S){return this.a.$getPassword(P,S)}store(P,S,I){return this.a.$setPassword(P,S,I)}delete(P,S){return this.a.$deletePassword(P,S)}}e.ExtHostSecretState=R,e.IExtHostSecretState=(0,u.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!u:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(ne,c):u?u.value=c:e.set(ne,c),c},Be=this&&this.__classPrivateFieldGet||function(ne,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[273],De([1,0,7,5,180,6,14,9]),function(ne,e,c,A,u,R,C,P){"use strict";var S,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(E,f,d,h,g=c.StatusBarAlignment.Left,p){S.set(this,void 0),I.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new R.DisposableStore,Je(this,S,E,"f"),Je(this,I,f,"f"),this.c=L.a++,this.e=d,this.f=h,this.g=g,this.h=this.u(p)}u(E){if(!!(0,P.isNumber)(E))return E===Number.POSITIVE_INFINITY?Number.MAX_VALUE:E===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:E}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(E){this.k=E,this.v()}set name(E){this.m=E,this.v()}set tooltip(E){this.l=E,this.v()}set color(E){this.n=E,this.v()}set backgroundColor(E){E&&!L.b.has(E.id)&&(E=void 0),this.o=E,this.v()}set command(E){this.r?.fromApi!==E&&(this.p&&this.q.add(this.p),this.p=new R.DisposableStore,typeof E=="string"?this.r={fromApi:E,internal:Be(this,I,"f").toInternal({title:"",command:E},this.p)}:E?this.r={fromApi:E,internal:Be(this,I,"f").toInternal(E,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(E){this.t=E,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Be(this,S,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let E;this.e?this.f?E=`${this.e.identifier.value}.${this.f}`:E=this.e.identifier.value:E=this.f;let f;this.m?f=this.m:f=(0,u.localize)(0,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=L.b.get(this.o.id));const h=C.MarkdownString.fromStrict(this.l);Be(this,S,"f").$setEntry(this.c,E,f,this.k,h,this.r?.internal,d,this.o,this.g===c.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}S=new WeakMap,I=new WeakMap,L.a=0,L.b=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=L;class k{constructor(E){this.b=[],this.a=E.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,u.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(E){const f={message:E};return this.b.unshift(f),this.c(),new c.Disposable(()=>{const d=this.b.indexOf(f);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class v{constructor(E,f){this.a=E.getProxy(A.MainContext.MainThreadStatusBar),this.b=f,this.c=new k(this)}createStatusBarEntry(E,f,d,h){return new L(this.a,this.b,E,f,d,h)}setStatusBarMessage(E,f){const d=this.c.setMessage(E);let h;return typeof f=="number"?h=setTimeout(()=>d.dispose(),f):typeof f<"u"&&f.then(()=>d.dispose(),()=>d.dispose()),new c.Disposable(()=>{d.dispose(),clearTimeout(h)})}}e.ExtHostStatusBar=v}),define(ye[99],De([1,0,5,3,4]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class R{constructor(P,S){this.c=S,this.b=new A.Emitter,this.onDidChangeStorage=this.b.event,this.a=P.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,S){this.a.$registerExtensionStorageKeysToSync(P,S)}async initializeExtensionStorage(P,S,I){const L=await this.a.$initializeExtensionStorage(P,S);let k;return L&&(k=this.d(P,S,L)),k||I}setValue(P,S,I){return this.a.$setValue(P,S,I)}$acceptValue(P,S,I){const L=this.d(P,S,I);L&&this.b.fire({shared:P,key:S,value:L})}d(P,S,I){try{return JSON.parse(I)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${P}): ${L}`)}}}e.ExtHostStorage=R,e.IExtHostStorage=(0,u.createDecorator)("IExtHostStorage")}),define(ye[78],De([1,0,4,25,13,77,2]),function(ne,e,c,A,u,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let P=class{constructor(I,L,k){this.d=L,this.f=k,this.a=I.workspace??void 0,this.b=I.environment,this.whenReady=this.h().then(v=>this.c=v)}async g(I){return C.URI.joinPath(this.b.workspaceStorageHome,I)}async h(){if(!this.a)return Promise.resolve(void 0);const I=this.a.id,L=await this.g(I);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(C.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:C.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(I){if(this.c)return C.URI.joinPath(this.c,I.identifier.value)}globalValue(I){return C.URI.joinPath(this.b.globalStorageHome,I.identifier.value.toLowerCase())}onWillDeactivateAll(){}};P=qe([We(0,A.IExtHostInitDataService),We(1,u.ILogService),We(2,R.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(ye[41],De([1,0,3,5,4,2,20,6,7,182,11,214,21,30,215,51,9,19,14]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,f,d,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,u.createDecorator)("IExtHostTerminalService");class p{constructor(n,t,a,w){this.k=n,this._id=t,this.l=a,this.m=w,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(F=>this.f=F);const D=this;this.value={get name(){return D.m||""},get processId(){return D.b},get creationOptions(){return D.l},get exitStatus(){return D.h},get state(){return D.j},sendText(F,x=!0){D.o(),D.k.$sendText(D._id,F,x)},show(F){D.o(),D.k.$show(D._id,F)},hide(){D.o(),D.k.$hide(D._id)},dispose(){D.a||(D.a=!0,D.k.$dispose(D._id))},get dimensions(){if(!(D.d===void 0||D.g===void 0))return{columns:D.d,rows:D.g}}}}async create(n,t){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:n.name,shellPath:(0,d.withNullAsUndefined)(n.shellPath),shellArgs:(0,d.withNullAsUndefined)(n.shellArgs),cwd:(0,d.withNullAsUndefined)(n.cwd),env:(0,d.withNullAsUndefined)(n.env),icon:(0,d.withNullAsUndefined)(l(n.iconPath)),color:f.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,d.withNullAsUndefined)(n.message),strictEnv:(0,d.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,d.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,d.withNullAsUndefined)(t?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,d.withNullAsUndefined)(t?.useShellEnvironment),location:t?.location||this.n(n.location,t?.resolvedExtHostIdentifier),isTransient:(0,d.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,t,a,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:a,color:f.ThemeColor.isThemeColor(w)?w.id:void 0,location:this.n(n,t),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(n,t){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&t?{parentTerminal:t}:"viewColumn"in n?{viewColumn:g.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(n){this.m=n}setExitStatus(n,t){this.h=Object.freeze({code:n,reason:t})}setDimensions(n,t){return n===this.d&&t===this.g||n===0||t===0?!1:(this.d=n,this.g=t,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(n){this.f?(this.f(n),this.f=void 0):this.b.then(t=>{t!==n&&(this.b=Promise.resolve(n))})}}e.ExtHostTerminal=p;class y{get onProcessReady(){return this.b.event}constructor(n){this.g=n,this.id=0,this.shouldPersist=!1,this.a=new c.Emitter,this.onProcessData=this.a.event,this.b=new c.Emitter,this.d=new c.Emitter,this.onDidChangeProperty=this.d.event,this.f=new c.Emitter,this.onProcessExit=this.f.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,t){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${t}`)}async start(){}shutdown(){this.g.close()}input(n){this.g.handleInput?.(n)}resize(n,t){this.g.setDimensions?.({columns:n,rows:t})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this.g.onDidWrite(t=>this.a.fire(t)),this.g.onDidClose?.((t=void 0)=>{this.f.fire(t===void 0?void 0:t)}),this.g.onDidOverrideDimensions?.(t=>{t&&this.d.fire({type:"overrideDimensions",value:{cols:t.columns,rows:t.rows}})}),this.g.onDidChangeName?.(t=>{this.d.fire({type:"title",value:t})}),this.g.open(n||void 0),n&&this.g.setDimensions?.(n),this.b.fire({pid:-1,cwd:""})}}let b=1,i=class extends P.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(n=>n.value)}get onDidWriteTerminalData(){return this.I.event}constructor(n,t){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new c.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new c.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new c.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new c.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new c.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new c.Emitter,this.onDidChangeShell=this.J.event,this.a=t.getProxy(A.MainContext.MainThreadTerminalService),this.s=new E.TerminalDataBufferer(this.a.$sendProcessData),this.I=new c.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(n),this.B({dispose:()=>{for(const[a,w]of this.g)w.shutdown(!0)}})}getDefaultShell(n){return(n?this.n:this.m)?.path||""}getDefaultShellArgs(n){return(n?this.n:this.m)?.args||[]}createExtensionTerminal(n,t){const a=new p(this.a,(0,T.generateUuid)(),n,n.name),w=new y(n.pty);return a.createExtensionTerminal(n.location,this.L(n,t).resolvedExtHostIdentifier,l(n.iconPath),r(n.color)).then(D=>{const F=this.M(D,w);this.h[D]=F}),this.f.push(a),a.value}L(n,t){if(t=t||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const a=n.location.parentTerminal;if(a){const w=this.f.find(D=>D.value===a);w&&(t.resolvedExtHostIdentifier=w._id)}}else n.location&&typeof n.location!="object"?t.location=n.location:t.location&&typeof t.location=="object"&&"splitActiveTerminal"in t.location&&(t.location={splitActiveTerminal:!0});return t}attachPtyToTerminal(n,t){if(!this.O(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const w=new y(t),D=this.M(n,w);this.h[n]=D}async $acceptActiveTerminalChanged(n){const t=this.b;if(n===null){this.b=void 0,t!==this.b&&this.F.fire(this.b);return}const a=this.O(n);a&&(this.b=a,t!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(n,t){const a=this.O(n);a&&this.I.fire({terminal:a.value,data:t})}async $acceptTerminalDimensions(n,t,a){const w=this.O(n);w&&w.setDimensions(t,a)&&this.G.fire({terminal:w.value,dimensions:w.value.dimensions})}async $acceptTerminalMaximumDimensions(n,t,a){this.g.get(n)?.resize(t,a)}async $acceptTerminalTitleChange(n,t){const a=this.O(n);a&&(a.name=t)}async $acceptTerminalClosed(n,t,a){const w=this.Q(this.f,n);if(w!==null){const D=this.f.splice(w,1)[0];D.setExitStatus(t,a),this.C.fire(D.value)}}$acceptTerminalOpened(n,t,a,w){if(t){const x=this.Q(this.f,t);if(x!==null){this.f[x]._id=n,this.D.fire(this.terminals[x]),this.f[x].isOpen=!0;return}}const D={name:w.name,shellPath:w.executable,shellArgs:w.args,cwd:typeof w.cwd=="string"?w.cwd:R.URI.revive(w.cwd),env:w.env,hideFromUser:w.hideFromUser},F=new p(this.a,n,D,a);this.f.push(F),this.D.fire(F.value),F.isOpen=!0}async $acceptTerminalProcessId(n,t){this.O(n)?._setProcessId(t)}async $startExtensionTerminal(n,t){const a=this.O(n);if(!a)return{message:(0,I.localize)(0,null,n)};a.isOpen||await new Promise(D=>{const F=this.onDidOpenTerminal(async x=>{x===a.value&&(F.dispose(),D())})});const w=this.g.get(n);w?w.startSendingEvents(t):this.j[n]={initialDimensions:t}}M(n,t){const a=new P.DisposableStore;a.add(t.onProcessReady(D=>this.a.$sendProcessReady(n,D.pid,D.cwd))),a.add(t.onDidChangeProperty(D=>this.a.$sendProcessProperty(n,D))),this.s.startBuffering(n,t.onProcessData),a.add(t.onProcessExit(D=>this.N(n,D))),this.g.set(n,t);const w=this.j[n];return w&&t instanceof y&&(t.startSendingEvents(w.initialDimensions),delete this.j[n]),a}$acceptProcessAckDataEvent(n,t){this.g.get(n)?.acknowledgeDataEvent(t)}$acceptProcessInput(n,t){this.g.get(n)?.input(t)}$acceptTerminalInteraction(n){const t=this.O(n);t?.setInteractedWith()&&this.H.fire(t.value)}$acceptProcessResize(n,t,a){try{this.g.get(n)?.resize(t,a)}catch(w){if(w.code!=="EPIPE"&&w.code!=="ERR_IPC_CHANNEL_CLOSED")throw w}}$acceptProcessShutdown(n,t){this.g.get(n)?.shutdown(t)}$acceptProcessRequestInitialCwd(n){this.g.get(n)?.getInitialCwd().then(t=>this.a.$sendProcessProperty(n,{type:"initialCwd",value:t}))}$acceptProcessRequestCwd(n){this.g.get(n)?.getCwd().then(t=>this.a.$sendProcessProperty(n,{type:"cwd",value:t}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this.u.add(n),this.u.size===1&&this.a.$startLinkProvider(),new S.Disposable(()=>{this.u.delete(n),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(n,t,a){if(this.v.has(t))throw new Error(`Terminal profile provider "${t}" already registered`);return this.v.set(t,a),this.a.$registerProfileProvider(t,n.identifier.value),new S.Disposable(()=>{this.v.delete(t),this.a.$unregisterProfileProvider(t)})}registerTerminalQuickFixProvider(n,t,a){if(this.w.has(n))throw new Error(`Terminal quick fix provider "${n}" is already registered`);return this.w.set(n,a),this.a.$registerQuickFixProvider(n,t),new S.Disposable(()=>{this.w.delete(n),this.a.$unregisterQuickFixProvider(n)})}async $provideTerminalQuickFixes(n,t){const a=new v.CancellationTokenSource().token;if(a.isCancellationRequested)return;const w=this.w.get(n);if(!w)return;const D=await w.provideTerminalQuickFixes(t,a);if(D!==null)return D}async $createContributedProfileTerminal(n,t){const a=new v.CancellationTokenSource().token;let w=await this.v.get(n)?.provideTerminalProfile(a);if(!a.isCancellationRequested){if(w&&!("options"in w)&&(w={options:w}),!w||!("options"in w))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in w.options){this.createExtensionTerminal(w.options,t);return}this.createTerminalFromOptions(w.options,t)}}async $provideLinks(n,t){const a=this.O(n);if(!a)return[];this.y.delete(n),this.z.get(n)?.dispose(!0);const D=new v.CancellationTokenSource;this.z.set(n,D);const F=[],x={terminal:a.value,line:t},q=[];for(const O of this.u)q.push(h.Promises.withAsyncBody(async U=>{D.token.onCancellationRequested(()=>U({provider:O,links:[]}));const z=await O.provideTerminalLinks(x,D.token)||[];D.token.isCancellationRequested||U({provider:O,links:z})}));const M=await Promise.all(q);if(D.token.isCancellationRequested)return[];const B=new Map;for(const O of M)O&&O.links.length>0&&F.push(...O.links.map(U=>{const z={id:b++,startIndex:U.startIndex,length:U.length,label:U.tooltip};return B.set(z.id,{provider:O.provider,link:U}),z}));return this.y.set(n,B),F}$activateLink(n,t){const a=this.y.get(n)?.get(t);!a||a.provider.handleTerminalLink(a.link)}N(n,t){this.s.stopBuffering(n),this.g.delete(n),delete this.j[n];const a=this.h[n];a&&(a.dispose(),delete this.h[n]),this.a.$sendProcessExit(n,t)}O(n){return this.P(this.f,n)}P(n,t){const a=this.Q(n,t);return a!==null?n[a]:null}Q(n,t){let a=null;return n.some((w,D)=>w._id===t?(a=D,!0):!1),a}getEnvironmentVariableCollection(n){let t=this.l.get(n.identifier.value);return t||(t=new o,this.S(n.identifier.value,t)),t}R(n,t){const a=(0,k.serializeEnvironmentVariableCollection)(t.map);this.a.$setEnvironmentVariableCollection(n,t.persistent,a.length===0?void 0:a)}$initEnvironmentVariableCollections(n){n.forEach(t=>{const a=t[0],w=new o(t[1]);this.S(a,w)})}$acceptDefaultProfile(n,t){const a=this.m;this.m=n,this.n=t,a?.path!==n.path&&this.J.fire(n.path)}S(n,t){this.l.set(n,t),t.onDidChangeCollection(()=>{this.R(n,t)})}};i=qe([We(1,C.IExtHostRpcService)],i),e.BaseExtHostTerminalService=i;class o{get persistent(){return this.a}set persistent(n){this.a=n,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(n){this.map=new Map,this.a=!0,this.b=new c.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,t){this.d(n,{value:t,type:S.EnvironmentVariableMutatorType.Replace})}append(n,t){this.d(n,{value:t,type:S.EnvironmentVariableMutatorType.Append})}prepend(n,t){this.d(n,{value:t,type:S.EnvironmentVariableMutatorType.Prepend})}d(n,t){const a=this.map.get(n);(!a||a.value!==t.value||a.type!==t.type)&&(this.map.set(n,t),this.b.fire())}get(n){return this.map.get(n)}forEach(n,t){this.map.forEach((a,w)=>n.call(t,w,a,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let s=class extends i{constructor(n){super(!1,n)}createTerminal(n,t,a){throw new L.NotSupportedError}createTerminalFromOptions(n,t){throw new L.NotSupportedError}};s=qe([We(0,C.IExtHostRpcService)],s),e.WorkerExtHostTerminalService=s;function l(m){if(!(!m||typeof m=="string"))return"id"in m?{id:m.id,color:m.color}:m}function r(m){return f.ThemeColor.isThemeColor(m)?m:void 0}});var Be=this&&this.__classPrivateFieldGet||function(ne,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(ne):A?A.value:e.get(ne)},Je=this&&this.__classPrivateFieldSet||function(ne,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!u:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(ne,c):u?u.value=c:e.set(ne,c),c};define(ye[274],De([1,0,15,19,22,21,3,63,87,6,23,9,30,5,20,137,14,7,57,93,75,27]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,f,d,h,g,p,y,b){"use strict";var i,o;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(O,U,z){this.j=z,this.c=new C.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=O.getProxy(T.MainContext.MainThreadTesting),this.h=new x(this.f),this.g=new n(this.f),U.registerArgumentProcessor({processArgument:j=>{if(j?.$mid!==15)return j;const de=j,V=de.tests[de.tests.length-1].item.extId;return this.d.get(g.TestId.root(V))?.collection.tree.get(V)?.actual??(0,f.toItemFromContext)(j)}})}createTestController(O,U,z,j){if(this.d.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const de=new I.DisposableStore,V=de.add(new f.ExtHostTestItemCollection(U,z,this.j));V.root.label=z;const X=new Map,J=this.f,te={items:V.root.children,get label(){return z},set label(Q){z=Q,V.root.label=Q,J.$updateController(U,{label:z})},get refreshHandler(){return j},set refreshHandler(Q){j=Q,J.$updateController(U,{canRefresh:!!Q})},get id(){return U},createRunProfile:(Q,Y,ie,pe,ve,ke)=>{let Oe=(0,S.hash)(Q);for(;X.has(Oe);)Oe++;return ke!==void 0&&(0,b.checkProposedApiEnabled)(O,"testContinuousRun"),new q(this.f,X,U,Oe,Q,Y,ie,pe,ve,ke)},createTestItem(Q,Y,ie){return new f.TestItemImpl(U,Q,Y,ie)},createTestRun:(Q,Y,ie=!0)=>this.g.createTestRun(U,V,Q,Y,ie),set resolveHandler(Q){V.resolveHandler=Q},get resolveHandler(){return V.resolveHandler},dispose:()=>{de.dispose()}};J.$registerTestController(U,z,!!j),de.add((0,I.toDisposable)(()=>J.$unregisterTestController(U)));const ee={controller:te,collection:V,profiles:X};return this.d.set(U,ee),de.add((0,I.toDisposable)(()=>this.d.delete(U))),de.add(V.onDidGenerateDiff(Q=>J.$publishDiff(U,Q.map(y.TestsDiffOp.serialize)))),te}createTestObserver(){return this.h.checkout()}async runTests(O,U=R.CancellationToken.None){const z=t(O);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.d.get(z.controllerId);if(!j)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:O.include?.map(de=>g.TestId.fromExtHostTestItem(de,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:M[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:O.exclude?.map(de=>de.id)},U)}$syncTests(){for(const{collection:O}of this.d.values())O.flushDiff();return Promise.resolve()}$provideFileCoverage(O,U,z){return(0,c.mapFind)(this.g.trackers,de=>de.id===O?de.getCoverage(U):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(O,U,z,j){return(0,c.mapFind)(this.g.trackers,V=>V.id===O?V.getCoverage(U):void 0)?.resolveFileCoverage(z,j)??Promise.resolve([])}$configureRunProfile(O,U){this.d.get(O)?.profiles.get(U)?.configureHandler?.()}async $refreshTests(O,U){await this.d.get(O)?.controller.refreshHandler?.(U)}$publishTestResults(O){this.results=Object.freeze(O.map(U=>(0,L.deepFreeze)(d.TestResults.to(U))).concat(this.results).sort((U,z)=>z.completedAt-U.completedAt).slice(0,32)),this.c.fire()}async $expandTest(O,U){const z=this.d.get(g.TestId.fromString(O).controllerId)?.collection;z&&(await z.expand(O,U<0?1/0:U),z.flushDiff())}$acceptDiff(O){this.h.applyDiff(O.map(y.TestsDiffOp.deserialize))}async $runControllerTests(O,U){return Promise.all(O.map(z=>this.k(z,!1,U)))}async $startContinuousRun(O,U){const z=new R.CancellationTokenSource(U),j=await Promise.all(O.map(de=>this.k(de,!0,z.token)));return!U.isCancellationRequested&&!j.some(de=>de.error)&&await new Promise(de=>U.onCancellationRequested(de)),z.dispose(!0),j}async k(O,U,z){const j=this.d.get(O.controllerId);if(!j)return{};const{collection:de,profiles:V}=j,X=V.get(O.profileId);if(!X)return{};const J=O.testIds.map(Y=>de.tree.get(Y)).filter(k.isDefined),te=O.excludeExtIds.map(Y=>j.collection.tree.get(Y)).filter(k.isDefined).filter(Y=>J.some(ie=>ie.fullId.compare(Y.fullId)===2));if(!J.length)return{};const ee=new h.TestRunRequest2(J.some(Y=>Y.actual instanceof f.TestItemRootImpl)?void 0:J.map(Y=>Y.actual),te.map(Y=>Y.actual),X,U),Q=(0,y.isStartControllerTests)(O)&&this.g.prepareForMainThreadTestRun(ee,a.fromInternal(O,j.collection),z);try{return await X.runHandler(ee,z),{}}catch(Y){return{error:String(Y)}}finally{Q&&(Q.hasRunningTasks&&!z.isCancellationRequested&&await C.Event.toPromise(Q.onEnd),Q.dispose())}}$cancelExtensionTestRun(O){O===void 0?this.g.cancelAllRuns():this.g.cancelRunById(O)}};s=qe([We(0,E.IExtHostRpcService)],s),e.ExtHostTesting=s;const l=1e4;var r;(function(B){B[B.Running=0]="Running",B[B.Cancelling=1]="Cancelling",B[B.Ended=2]="Ended"})(r||(r={}));class m extends I.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(O,U,z){super(),this.k=O,this.l=U,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new C.Emitter),this.onEnd=this.j.event,this.h=this.B(new R.CancellationTokenSource(z));const j=this.B(new A.RunOnceScheduler(()=>this.m(),l));this.B(this.h.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(O){return this.f.get(O)?.coverage}createRun(O){const U=this.k.id,z=this.k.controllerId,j=(0,v.generateUuid)(),de=new w(this.l,U,j),V=ee=>(Q,...Y)=>{if(J){console.warn(`Setting the state of test "${Q.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(Q)||(this.s(Q),ee(Q,...Y))},X=(ee,Q)=>{const Y=Q instanceof Array?Q.map(d.TestMessage.from):[d.TestMessage.from(Q)];if(ee.uri&&ee.range){const ie={range:d.Range.from(ee.range),uri:ee.uri};for(const pe of Y)pe.location=pe.location||ie}this.l.$appendTestMessagesInRun(U,j,g.TestId.fromExtHostTestItem(ee,z).toString(),Y)};let J=!1;const te={isPersisted:this.k.isPersisted,token:this.h.token,name:O,get coverageProvider(){return de.coverageProvider},set coverageProvider(ee){de.coverageProvider=ee},enqueued:V(ee=>{this.l.$updateTestStateInRun(U,j,g.TestId.fromExtHostTestItem(ee,z).toString(),1)}),skipped:V(ee=>{this.l.$updateTestStateInRun(U,j,g.TestId.fromExtHostTestItem(ee,z).toString(),5)}),started:V(ee=>{this.l.$updateTestStateInRun(U,j,g.TestId.fromExtHostTestItem(ee,z).toString(),2)}),errored:V((ee,Q,Y)=>{X(ee,Q),this.l.$updateTestStateInRun(U,j,g.TestId.fromExtHostTestItem(ee,z).toString(),6,Y)}),failed:V((ee,Q,Y)=>{X(ee,Q),this.l.$updateTestStateInRun(U,j,g.TestId.fromExtHostTestItem(ee,z).toString(),4,Y)}),passed:V((ee,Q)=>{this.l.$updateTestStateInRun(U,j,g.TestId.fromExtHostTestItem(ee,this.k.controllerId).toString(),3,Q)}),appendOutput:(ee,Q,Y)=>{J||(Y&&(this.k.isIncluded(Y)?this.s(Y):Y=void 0),this.l.$appendOutputToRun(U,j,u.VSBuffer.fromString(ee),Q&&d.location.from(Q),Y&&g.TestId.fromExtHostTestItem(Y,z).toString()))},end:()=>{J||(J=!0,this.l.$finishedTestRunTask(U,j),this.f.delete(j),this.f.size||this.p())}};return this.f.set(j,{run:te,coverage:de}),this.l.$startedTestRunTask(U,{id:j,name:O,running:!0}),te}m(){for(const{run:O}of this.f.values())O.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(O){if(!(O instanceof f.TestItemImpl))throw new p.InvalidTestItemError(O.id);if(this.g.has(g.TestId.fromExtHostTestItem(O,this.k.controllerId).toString()))return;const U=[],z=this.k.colllection.root;for(;;){const j=d.TestItem.from(O);if(U.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),O===z))break;O=O.parent||z}this.l.$addTestsToRun(this.k.controllerId,this.k.id,U)}}class n{get trackers(){return this.c.values()}constructor(O){this.d=O,this.c=new Map}prepareForMainThreadTestRun(O,U,z){return this.f(O,U,z)}cancelRunById(O){for(const U of this.c.values())if(U.id===O){U.cancel();return}}cancelAllRuns(){for(const O of this.c.values())O.cancel()}createTestRun(O,U,z,j,de){const V=this.c.get(z);if(V)return V.createRun(j);const X=a.fromPublic(O,U,z,de),J=t(z);this.d.$startedExtensionTestRun({controllerId:O,continuous:!!z.continuous,profile:J&&{group:M[J.kind],id:J.profileId},exclude:z.exclude?.map(ee=>g.TestId.fromExtHostTestItem(ee,U.root.id).toString())??[],id:X.id,include:z.include?.map(ee=>g.TestId.fromExtHostTestItem(ee,U.root.id).toString())??[U.root.id],persist:de});const te=this.f(z,X);return te.onEnd(()=>{this.d.$finishedExtensionTestRun(X.id),te.dispose()}),te.createRun(j)}f(O,U,z){const j=new m(U,this.d,z);return this.c.set(O,j),j.onEnd(()=>this.c.delete(O)),j}}e.TestRunCoordinator=n;const t=B=>{if(!!B.profile){if(!(B.profile instanceof q))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return B.profile}};class a{static fromPublic(O,U,z,j){return new a(O,(0,v.generateUuid)(),z.include?.map(de=>g.TestId.fromExtHostTestItem(de,O).toString())??[O],z.exclude?.map(de=>g.TestId.fromExtHostTestItem(de,O).toString())??[],j,U)}static fromInternal(O,U){return new a(O.controllerId,O.runId,O.testIds,O.excludeExtIds,!0,U)}constructor(O,U,z,j,de,V){this.controllerId=O,this.id=U,this.isPersisted=de,this.colllection=V,this.c=z.map(X=>X+"\0"),this.d=j.map(X=>X+"\0")}isIncluded(O){const U=g.TestId.fromExtHostTestItem(O,this.controllerId).toString()+"\0";for(const z of this.d)if(U===z||U.startsWith(z))return!1;for(const z of this.c)if(U===z||U.startsWith(z))return!0;return!1}}e.TestRunDto=a;class w{set coverageProvider(O){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!O||(this.c=O,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(O,U,z){this.f=O,this.g=U,this.h=z}async provideFileCoverage(O){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(O))());try{return(await this.d)?.map(d.TestCoverage.fromFile)??[]}catch(U){throw this.d=void 0,U}}async resolveFileCoverage(O,U){const z=await this.d;let j=z?.[O];return!this.c||!z||!j?[]:(j.detailedCoverage||(j=z[O]=await this.c.resolveFileCoverage?.(j,U)??j),j.detailedCoverage?.map(d.TestCoverage.fromDetailed)??[])}}class D{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(O){this.h=O,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(O){this.c.add(O)}update(O){Object.assign(O.revived,d.TestItem.toPlain(O.item)),this.c.has(O)||this.d.add(O)}remove(O){if(this.c.has(O)){this.c.delete(O);return}this.d.delete(O);const U=g.TestId.parentId(O.item.extId);if(U&&this.g.has(U.toString())){this.g.add(O.item.extId);return}this.f.add(O)}getChangeEvent(){const{c:O,d:U,f:z}=this;return{get added(){return[...O].map(j=>j.revived)},get updated(){return[...U].map(j=>j.revived)},get removed(){return[...z].map(j=>j.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class F extends y.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new C.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(O){return this.d.get(O)}getMirroredTestDataByReference(O){return this.d.get(O.id)}p(O,U){return{...O,revived:d.TestItem.toPlain(O.item),depth:U?U.depth+1:0,children:new Set}}o(){return new D(this.q)}}class x{constructor(O){this.d=O}checkout(){this.c||(this.c=this.f());const O=this.c;return O.observers++,{onDidChangeTest:O.tests.onDidChangeTests,get tests(){return[...O.tests.rootTests].map(U=>U.revived)},dispose:(0,P.once)(()=>{--O.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(O){return this.c?.tests.getMirroredTestDataByReference(O)}applyDiff(O){this.c?.tests.apply(O)}f(){const O=new F;return this.d.$subscribeToDiffs(),{observers:0,tests:O}}}class q{get label(){return this.d}set label(O){O!==this.d&&(this.d=O,Be(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:O}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(O){O!==this.g&&(this.g=O,Be(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:O}))}get isDefault(){return this.f}set isDefault(O){O!==this.f&&(this.f=O,Be(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:O}))}get tag(){return this._tag}set tag(O){O?.id!==this._tag?.id&&(this._tag=O,Be(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:O?d.TestTag.namespace(this.controllerId,O.id):null}))}get configureHandler(){return this.c}set configureHandler(O){O!==this.c&&(this.c=O,Be(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!O}))}constructor(O,U,z,j,de,V,X,J=!1,te=void 0,ee=!1){this.controllerId=z,this.profileId=j,this.d=de,this.kind=V,this.runHandler=X,this.f=J,this._tag=te,this.g=ee,i.set(this,void 0),o.set(this,void 0),Je(this,i,O,"f"),Je(this,o,U,"f"),U.set(j,this);const Q=M[V];if(typeof Q!="number")throw new Error(`Unknown TestRunProfile.group ${V}`);Be(this,i,"f").$publishTestRunProfile({profileId:j,controllerId:z,tag:te?d.TestTag.namespace(this.controllerId,te.id):null,label:de,group:Q,isDefault:J,hasConfigurationHandler:!1,supportsContinuousRun:ee})}dispose(){Be(this,o,"f")?.delete(this.profileId)&&(Je(this,o,void 0,"f"),Be(this,i,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=q,i=new WeakMap,o=new WeakMap;const M={[h.TestRunProfileKind.Coverage]:8,[h.TestRunProfileKind.Debug]:4,[h.TestRunProfileKind.Run]:2}}),define(ye[275],De([1,0,15,3,5,138,14,7]),function(ne,e,c,A,u,R,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(L,k){this.i=k,this.a=new A.Emitter,this.b=new A.Emitter,this.c=new A.Emitter,this.d=new A.Emitter,this.f=new A.Emitter,this.g=new A.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=L.getProxy(u.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(v=>this.g.fire(v)),this.i.onDidChangeActiveTextEditor(v=>this.f.fire(v))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(L){const k=this.i.allEditors();return L?k:k.map(v=>v.value)}async showTextDocument(L,k,v){let T;typeof k=="number"?T={position:C.ViewColumn.from(k),preserveFocus:v}:typeof k=="object"?T={position:C.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?C.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:T={preserveFocus:!1};const E=await this.h.$tryShowTextDocument(L.uri,T),f=E&&this.i.getEditor(E);if(f)return f.value;throw E?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,k){return new R.TextEditorDecorationType(this.h,L,k).value}$acceptEditorPropertiesChanged(L,k){const v=this.i.getEditor(L);if(!v)throw new Error("unknown text editor");if(k.options&&v._acceptOptions(k.options),k.selections){const T=k.selections.selections.map(C.Selection.to);v._acceptSelections(T)}if(k.visibleRanges){const T=c.coalesce(k.visibleRanges.map(C.Range.to));v._acceptVisibleRanges(T)}if(k.options&&this.b.fire({textEditor:v.value,options:{...k.options,lineNumbers:C.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const T=P.TextEditorSelectionChangeKind.fromValue(k.selections.source),E=k.selections.selections.map(C.Selection.to);this.a.fire({textEditor:v.value,selections:E,kind:T})}if(k.visibleRanges){const T=c.coalesce(k.visibleRanges.map(C.Range.to));this.c.fire({textEditor:v.value,visibleRanges:T})}}$acceptEditorPositionData(L){for(const k in L){const v=this.i.getEditor(k);if(!v)throw new Error("Unknown text editor");const T=C.ViewColumn.to(L[k]);v.value.viewColumn!==T&&(v._acceptViewColumn(T),this.d.fire({textEditor:v.value,viewColumn:T}))}}getDiffInformation(L){return Promise.resolve(this.h.$getDiffInformation(L))}}e.ExtHostEditors=S}),define(ye[276],De([1,0,2,4,5,6,7,14,26,9]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,A.createDecorator)("IExtHostTimeline");class L{constructor(T,E){this.b=new Map,this.c=new Map,this.a=T.getProxy(u.MainContext.MainThreadTimeline),E.registerArgumentProcessor({processArgument:(f,d)=>{if(f&&f.$mid===12)if(this.b.get(f.source)&&S.ExtensionIdentifier.equals(d,this.b.get(f.source)?.extension)){const h=f.uri===void 0?void 0:c.URI.revive(f.uri);return this.c.get(f.source)?.get(k(h))?.get(f.handle)}else return;return f}})}async $getTimeline(T,E,f,d){return this.b.get(T)?.provider.provideTimeline(c.URI.revive(E),f,d)}registerTimelineProvider(T,E,f,d){const h=new R.DisposableStore,g=this.d(E.id,d,h).bind(this);let p;E.onDidChange&&(p=E.onDidChange(b=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:E.id}),this));const y=this.c;return this.f({...E,scheme:T,onDidChange:void 0,async provideTimeline(b,i,o){i?.resetCache&&(h.clear(),y.get(E.id)?.clear());const s=await E.provideTimeline(b,i,o);if(s==null)return;const l=g(b,i);return{...s,source:E.id,items:s.items.map(l)}},dispose(){for(const b of y.values())b.get(E.id)?.clear();p?.dispose(),h.dispose()}},f)}d(T,E,f){return(d,h)=>{let g;if(h?.cacheResults){let p=this.c.get(T);p===void 0&&(p=new Map,this.c.set(T,p));const y=k(d);g=p.get(y),g===void 0&&(g=new Map,p.set(y,g))}return p=>{const{iconPath:y,...b}=p,i=`${T}|${p.id??p.timestamp}`;g?.set(i,p);let o,s,l;p.iconPath&&(y instanceof C.ThemeIcon?l={id:y.id,color:y.color}:c.URI.isUri(y)?(o=y,s=y):{light:o,dark:s}=y);let r;return C.MarkdownString.isMarkdownString(b.tooltip)?r=P.MarkdownString.from(b.tooltip):(0,I.isString)(b.tooltip)?r=b.tooltip:C.MarkdownString.isMarkdownString(b.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=P.MarkdownString.from(b.detail)):(0,I.isString)(b.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=b.detail),{...b,id:b.id??void 0,handle:i,source:T,command:p.command?E.toInternal(p.command,f):void 0,icon:o,iconDark:s,themeIcon:l,tooltip:r,accessibilityInformation:p.accessibilityInformation}}}}f(T,E){if(this.b.get(T.id))throw new Error(`Timeline Provider ${T.id} already exists.`);return this.a.$registerTimelineProvider({id:T.id,label:T.label,scheme:T.scheme}),this.b.set(T.id,{provider:T,extension:E}),(0,R.toDisposable)(()=>{for(const d of this.c.values())d.get(T.id)?.clear();this.b.delete(T.id),this.a.$unregisterTimelineProvider(T.id),T.dispose()})}}e.ExtHostTimeline=L;function k(v){return v?.toString()}}),define(ye[277],De([1,0,6,18,2,5]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(S){this.c=new Map,this.b=S.getProxy(R.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,I,L,k){if(this.c.has(I))throw new Error(`Opener with id '${I}' already registered`);const v=k.schemes.find(T=>!C.a.has(T));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this.c.set(I,L),this.b.$registerUriOpener(I,k.schemes,S,k.label),(0,c.toDisposable)(()=>{this.c.delete(I),this.b.$unregisterUriOpener(I)})}async $canOpenUri(S,I,L){const k=this.c.get(S);if(!k)throw new Error(`Unknown opener with id: ${S}`);const v=u.URI.revive(I);return k.canOpenExternalUri(v,L)}async $openUri(S,I,L){const k=this.c.get(S);if(!k)throw new Error(`Unknown opener id: '${S}'`);return k.openExternalUri(u.URI.revive(I.resolvedUri),{sourceUri:u.URI.revive(I.sourceUri)},L)}}C.a=new Set([A.Schemas.http,A.Schemas.https]),e.ExtHostUriOpeners=C}),define(ye[278],De([1,0,5,2,6,11,26]),function(ne,e,c,A,u,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(I){this.c=new Set,this.d=new Map,this.b=I.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(I,L){if(this.c.has(C.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const k=P.a++;return this.c.add(C.ExtensionIdentifier.toKey(I)),this.d.set(k,L),this.b.$registerUriHandler(k,I),(0,u.toDisposable)(()=>{this.c.delete(C.ExtensionIdentifier.toKey(I)),this.d.delete(k),this.b.$unregisterUriHandler(k)})}$handleExternalUri(I,L){const k=this.d.get(I);if(!k)return Promise.resolve(void 0);try{k.handleUri(A.URI.revive(L))}catch(v){(0,R.onUnexpectedError)(v)}return Promise.resolve(void 0)}async createAppUri(I){return A.URI.revive(await this.b.$createAppUri(I))}}P.a=0,e.ExtHostUrls=P});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!u:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(ne,c):u?u.value=c:e.set(ne,c),c},Be=this&&this.__classPrivateFieldGet||function(ne,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[79],De([1,0,3,18,23,2,198,223,94,5]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";var L,k,v,T,E,f,d,h,g,p,y,b,i;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class o{constructor(D,F,x,q,M,B,O){L.set(this,void 0),k.set(this,void 0),v.set(this,void 0),T.set(this,void 0),E.set(this,void 0),f.set(this,void 0),d.set(this,""),h.set(this,void 0),g.set(this,!1),p.set(this,!1),y.set(this,void 0),b.set(this,void 0),this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,i.set(this,new c.Emitter),this._onDidDispose=Be(this,i,"f").event,Je(this,L,D,"f"),Je(this,k,F,"f"),Je(this,h,x,"f"),Je(this,T,q,"f"),Je(this,E,M,"f"),Je(this,f,B,"f"),Je(this,y,s(B),"f"),Je(this,b,l(B),"f"),Je(this,v,O,"f")}dispose(){Je(this,g,!0,"f"),Be(this,i,"f").fire(),Be(this,i,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(D){return Je(this,p,!0,"f"),(0,S.asWebviewUri)(D,Be(this,T,"f"))}get cspSource(){const D=Be(this,f,"f").extensionLocation;if(D.scheme===A.Schemas.https||D.scheme===A.Schemas.http){let F=D.toString();return F.endsWith("/")||(F+="/"),F+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.a(),Be(this,d,"f")}set html(D){this.a(),Be(this,d,"f")!==D&&(Je(this,d,D,"f"),Be(this,b,"f")&&!Be(this,p,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(D)&&(Je(this,p,!0,"f"),Be(this,v,"f").report("Webview vscode-resource: uris",Be(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,k,"f").$setHtml(Be(this,L,"f"),this.b(D)))}get options(){return this.a(),Be(this,h,"f")}set options(D){this.a(),u.equals(Be(this,h,"f"),D)||Be(this,k,"f").$setOptions(Be(this,L,"f"),n(Be(this,f,"f"),Be(this,E,"f"),D)),Je(this,h,D,"f")}async postMessage(D){if(Be(this,g,"f"))return!1;const F=(0,P.serializeWebviewMessage)(D,{serializeBuffersForPostMessage:Be(this,y,"f")});return Be(this,k,"f").$postMessage(Be(this,L,"f"),F.message,...F.buffers)}a(){if(Be(this,g,"f"))throw new Error("Webview is disposed")}b(D){if(!Be(this,b,"f"))return D;const F=Be(this,f,"f").extensionLocation?.scheme===A.Schemas.vscodeRemote,x=Be(this,f,"f").extensionLocation.scheme===A.Schemas.vscodeRemote?Be(this,f,"f").extensionLocation.authority:void 0;return D.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(q,M,B,O,U,z)=>{const j=R.URI.from({scheme:O||"file",path:decodeURIComponent(U)}),de=(0,S.asWebviewUri)(j,{isRemote:F,authority:x}).toString();return`${M}${de}${z}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(q,M,B,O,U,z)=>{const j=R.URI.from({scheme:O||"file",path:decodeURIComponent(U)}),de=(0,S.asWebviewUri)(j,{isRemote:F,authority:x}).toString();return`${M}${de}${z}`})}}e.ExtHostWebview=o,L=new WeakMap,k=new WeakMap,v=new WeakMap,T=new WeakMap,E=new WeakMap,f=new WeakMap,d=new WeakMap,h=new WeakMap,g=new WeakMap,p=new WeakMap,y=new WeakMap,b=new WeakMap,i=new WeakMap;function s(w){try{const D=(0,C.normalizeVersion)((0,C.parseVersion)(w.engines.vscode));return!!D&&D.majorBase>=1&&D.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=s;function l(w){try{const D=(0,C.normalizeVersion)((0,C.parseVersion)(w.engines.vscode));return D?D.majorBase<1||D.majorBase===1&&D.minorBase<60:!1}catch{return!1}}class r{constructor(D,F,x,q,M){this.c=F,this.d=x,this.e=q,this.f=M,this.b=new Map,this.a=D.getProxy(I.MainContext.MainThreadWebviews)}$onMessage(D,F,x){const q=this.g(D);if(q){const{message:M}=(0,P.deserializeWebviewMessage)(F,x.value);q._onMessageEmitter.fire(M)}}$onMissingCsp(D,F){this.e.warn(`${F} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(D,F,x){const q=new o(D,this.a,t(F),this.c,this.d,x,this.f);return this.b.set(D,q),q._onDidDispose(()=>{this.b.delete(D)}),q}deleteWebview(D){this.b.delete(D)}g(D){return this.b.get(D)}}e.ExtHostWebviews=r;function m(w){return{id:w.identifier,location:w.extensionLocation}}e.toExtensionData=m;function n(w,D,F){return{enableCommandUris:F.enableCommandUris,enableScripts:F.enableScripts,enableForms:F.enableForms,portMapping:F.portMapping,localResourceRoots:F.localResourceRoots||a(w,D)}}e.serializeWebviewOptions=n;function t(w){return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,enableForms:w.enableForms,portMapping:w.portMapping,localResourceRoots:w.localResourceRoots?.map(D=>R.URI.from(D))}}function a(w,D){return[...(D?.getWorkspaceFolders()||[]).map(F=>F.uri),w.extensionLocation]}}),define(ye[279],De([1,0,21,87,6,18,24,2,14,79,74,5,7]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class T{constructor(o,s){this.document=o,this.b=s,this.a=1,this.c=new L.Cache("custom documents")}addEdit(o){return this.c.add([o])}async undo(o,s){await this.f(o).undo(),s||this.disposeBackup()}async redo(o,s){await this.f(o).redo(),s||this.disposeBackup()}disposeEdits(o){for(const s of o)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const o=b(this.document.uri)+this.a++;return(0,C.joinPath)(this.b,o)}updateBackup(o){this.d?.delete(),this.d=o}disposeBackup(){this.d?.delete(),this.d=void 0}f(o){const s=this.c.get(o,0);if(!s)throw new Error("No edit found");return s}}class E{constructor(){this.a=new Map}get(o,s){return this.a.get(this.b(o,s))}add(o,s,l){const r=this.b(o,s.uri);if(this.a.has(r))throw new Error(`Document already exists for viewType:${o} resource:${s.uri}`);const m=new T(s,l);return this.a.set(r,m),m}delete(o,s){const l=this.b(o,s.uri);this.a.delete(l)}b(o,s){return`${o}@@@${s}`}}var f;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(f||(f={}));class d{constructor(){this.a=new Map}addTextProvider(o,s,l){return this.b(0,o,s,l)}addCustomProvider(o,s,l){return this.b(1,o,s,l)}get(o){return this.a.get(o)}b(o,s,l,r){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:o,extension:l,provider:r}),new v.Disposable(()=>this.a.delete(s))}}class h{constructor(o,s,l,r,m){this.d=s,this.f=l,this.g=r,this.h=m,this.b=new d,this.c=new E,this.a=o.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,s,l,r){const m=new u.DisposableStore;return p(l)?(m.add(this.b.addTextProvider(s,o,l)),this.a.$registerTextEditorProvider((0,I.toExtensionData)(o),s,r.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,I.shouldSerializeBuffersForPostMessage)(o))):(m.add(this.b.addCustomProvider(s,o,l)),g(l)&&m.add(l.onDidChangeCustomDocument(n=>{const t=this.i(s,n.document.uri);if(y(n)){const a=t.addEdit(n);this.a.$onDidEdit(n.document.uri,s,a,n.label)}else this.a.$onContentChange(n.document.uri,s)})),this.a.$registerCustomEditorProvider((0,I.toExtensionData)(o),s,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,I.shouldSerializeBuffersForPostMessage)(o))),v.Disposable.from(m,new v.Disposable(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(o,s,l,r,m){const n=this.b.get(s);if(!n)throw new Error(`No provider found for '${s}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${s}'`);const t=P.URI.revive(o),a=await n.provider.openCustomDocument(t,{backupId:l,untitledDocumentData:r?.buffer},m);let w;return g(n.provider)&&this.f&&(w=this.f.workspaceValue(n.extension)??this.f.globalValue(n.extension)),this.c.add(s,a,w),{editable:g(n.provider)}}async $disposeCustomDocument(o,s){const l=this.b.get(s);if(!l)throw new Error(`No provider found for '${s}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${s}'`);const r=P.URI.revive(o),{document:m}=this.i(s,r);this.c.delete(s,m),m.dispose()}async $resolveCustomEditor(o,s,l,r,m,n){const t=this.b.get(l);if(!t)throw new Error(`No provider found for '${l}'`);const a=S.ViewColumn.to(m),w=this.g.createNewWebview(s,r.contentOptions,t.extension),D=this.h.createNewWebviewPanel(s,l,r.title,a,r.options,w,!0),F=P.URI.revive(o);switch(t.type){case 1:{const{document:x}=this.i(l,F);return t.provider.resolveCustomEditor(x,D,n)}case 0:{const x=this.d.getDocument(F);return t.provider.resolveCustomTextEditor(x,D,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,s,l){this.i(s,o).disposeEdits(l)}async $onMoveCustomEditor(o,s,l){const r=this.b.get(l);if(!r)throw new Error(`No provider found for '${l}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const m=this.h.getWebviewPanel(o);if(!m)throw new Error("No webview found");const n=P.URI.revive(s),t=this.d.getDocument(n);await r.provider.moveCustomTextEditor(t,m,c.CancellationToken.None)}async $undo(o,s,l,r){return this.i(s,o).undo(l,r)}async $redo(o,s,l,r){return this.i(s,o).redo(l,r)}async $revert(o,s,l){const r=this.i(s,o);await this.j(s).revertCustomDocument(r.document,l),r.disposeBackup()}async $onSave(o,s,l){const r=this.i(s,o);await this.j(s).saveCustomDocument(r.document,l),r.disposeBackup()}async $onSaveAs(o,s,l,r){const m=this.i(s,o);return this.j(s).saveCustomDocumentAs(m.document,P.URI.revive(l),r)}async $backup(o,s,l){const r=this.i(s,o),n=await this.j(s).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},l);return r.updateBackup(n),n.id}i(o,s){const l=this.c.get(o,P.URI.revive(s));if(!l)throw new Error("No custom document found");return l}j(o){const l=this.b.get(o)?.provider;if(!l||!g(l))throw new Error("Custom document is not editable");return l}}e.ExtHostCustomEditors=h;function g(i){return!!i.onDidChangeCustomDocument}function p(i){return typeof i.resolveCustomTextEditor=="function"}function y(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function b(i){const o=i.scheme===R.Schemas.file||i.scheme===R.Schemas.untitled?i.fsPath:i.toString();return(0,A.hash)(o)+""}});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!u:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(ne,c):u?u.value=c:e.set(ne,c),c},Be=this&&this.__classPrivateFieldGet||function(ne,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[280],De([1,0,3,6,2,30,14,79,5,7]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";var L,k,v,T,E,f,d,h,g,p,y,b,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class o extends A.Disposable{constructor(m,n,t,a){super(),L.set(this,void 0),k.set(this,void 0),v.set(this,void 0),T.set(this,void 0),E.set(this,void 0),f.set(this,void 0),d.set(this,void 0),h.set(this,void 0),g.set(this,!0),p.set(this,void 0),y.set(this,!1),b.set(this,this.B(new c.Emitter)),this.onDidDispose=Be(this,b,"f").event,i.set(this,this.B(new c.Emitter)),this.onDidChangeViewState=Be(this,i,"f").event,Je(this,L,m,"f"),Je(this,k,n,"f"),Je(this,T,t,"f"),Je(this,v,a.viewType,"f"),Je(this,E,a.panelOptions,"f"),Je(this,h,a.viewColumn,"f"),Je(this,f,a.title,"f"),Je(this,p,a.active,"f")}dispose(){Be(this,y,"f")||(Je(this,y,!0,"f"),Be(this,b,"f").fire(),Be(this,k,"f").$disposeWebview(Be(this,L,"f")),Be(this,T,"f").dispose(),super.dispose())}get webview(){return this.c(),Be(this,T,"f")}get viewType(){return this.c(),Be(this,v,"f")}get title(){return this.c(),Be(this,f,"f")}set title(m){this.c(),Be(this,f,"f")!==m&&(Je(this,f,m,"f"),Be(this,k,"f").$setTitle(Be(this,L,"f"),m))}get iconPath(){return this.c(),Be(this,d,"f")}set iconPath(m){this.c(),Be(this,d,"f")!==m&&(Je(this,d,m,"f"),Be(this,k,"f").$setIconPath(Be(this,L,"f"),u.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return Be(this,E,"f")}get viewColumn(){if(this.c(),!(typeof Be(this,h,"f")=="number"&&Be(this,h,"f")<0))return Be(this,h,"f")}get active(){return this.c(),Be(this,p,"f")}get visible(){return this.c(),Be(this,g,"f")}_updateViewState(m){Be(this,y,"f")||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(Je(this,p,m.active,"f"),Je(this,g,m.visible,"f"),Je(this,h,m.viewColumn,"f"),Be(this,i,"f").fire({webviewPanel:this}))}reveal(m,n){this.c(),Be(this,k,"f").$reveal(Be(this,L,"f"),{viewColumn:typeof m>"u"?void 0:C.ViewColumn.from(m),preserveFocus:!!n})}c(){if(Be(this,y,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,k=new WeakMap,v=new WeakMap,T=new WeakMap,E=new WeakMap,f=new WeakMap,d=new WeakMap,h=new WeakMap,g=new WeakMap,p=new WeakMap,y=new WeakMap,b=new WeakMap,i=new WeakMap;class s{static c(){return(0,R.generateUuid)()}constructor(m,n,t){this.g=n,this.h=t,this.e=new Map,this.f=new Map,this.d=m.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(m,n,t,a,w={}){const D=typeof a=="object"?a.viewColumn:a,F={viewColumn:C.ViewColumn.from(D),preserveFocus:typeof a=="object"&&!!a.preserveFocus},x=(0,P.shouldSerializeBuffersForPostMessage)(m),q=s.c();this.d.$createWebviewPanel((0,P.toExtensionData)(m),q,n,{title:t,panelOptions:l(w),webviewOptions:(0,P.serializeWebviewOptions)(m,this.h,w),serializeBuffersForPostMessage:x},F);const M=this.g.createNewWebview(q,w,m);return this.createNewWebviewPanel(q,n,t,D,w,M,!0)}$onDidChangeWebviewPanelViewStates(m){const n=Object.keys(m);n.sort((t,a)=>{const w=m[t],D=m[a];return w.active?1:D.active?-1:+w.visible-+D.visible});for(const t of n){const a=this.getWebviewPanel(t);if(!a)continue;const w=m[t];a._updateViewState({active:w.active,visible:w.visible,viewColumn:C.ViewColumn.to(w.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this.e.delete(m),this.g.deleteWebview(m)}registerWebviewPanelSerializer(m,n,t){if(this.f.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.f.set(n,{serializer:t,extension:m}),this.d.$registerSerializer(n,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(m)}),new I.Disposable(()=>{this.f.delete(n),this.d.$unregisterSerializer(n)})}async $deserializeWebviewPanel(m,n,t,a){const w=this.f.get(n);if(!w)throw new Error(`No serializer found for '${n}'`);const{serializer:D,extension:F}=w,x=this.g.createNewWebview(m,t.webviewOptions,F),q=this.createNewWebviewPanel(m,n,t.title,a,t.panelOptions,x,t.active);await D.deserializeWebviewPanel(q,t.state)}createNewWebviewPanel(m,n,t,a,w,D,F){const x=new o(m,this.d,D,{viewType:n,title:t,viewColumn:a,panelOptions:w,active:F});return this.e.set(m,x),x}getWebviewPanel(m){return this.e.get(m)}}e.ExtHostWebviewPanels=s;function l(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!u:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(ne,c):u?u.value=c:e.set(ne,c),c},Be=this&&this.__classPrivateFieldGet||function(ne,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[281],De([1,0,3,6,79,14,5,7]),function(ne,e,c,A,u,R,C,P){"use strict";var S,I,L,k,v,T,E,f,d,h,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class p extends A.Disposable{constructor(i,o,s,l,r,m){super(),S.set(this,void 0),I.set(this,void 0),L.set(this,void 0),k.set(this,void 0),v.set(this,!1),T.set(this,void 0),E.set(this,void 0),f.set(this,void 0),d.set(this,void 0),h.set(this,this.B(new c.Emitter)),this.onDidChangeVisibility=Be(this,h,"f").event,g.set(this,this.B(new c.Emitter)),this.onDidDispose=Be(this,g,"f").event,Je(this,L,s,"f"),Je(this,E,l,"f"),Je(this,S,i,"f"),Je(this,I,o,"f"),Je(this,k,r,"f"),Je(this,T,m,"f")}dispose(){Be(this,v,"f")||(Je(this,v,!0,"f"),Be(this,g,"f").fire(),Be(this,k,"f").dispose(),super.dispose())}get title(){return this.a(),Be(this,E,"f")}set title(i){this.a(),Be(this,E,"f")!==i&&(Je(this,E,i,"f"),Be(this,I,"f").$setWebviewViewTitle(Be(this,S,"f"),i))}get description(){return this.a(),Be(this,f,"f")}set description(i){this.a(),Be(this,f,"f")!==i&&(Je(this,f,i,"f"),Be(this,I,"f").$setWebviewViewDescription(Be(this,S,"f"),i))}get visible(){return Be(this,T,"f")}get webview(){return Be(this,k,"f")}get viewType(){return Be(this,L,"f")}_setVisible(i){i===Be(this,T,"f")||Be(this,v,"f")||(Je(this,T,i,"f"),Be(this,h,"f").fire())}get badge(){return this.a(),Be(this,d,"f")}set badge(i){this.a(),!(i?.value===Be(this,d,"f")?.value&&i?.tooltip===Be(this,d,"f")?.tooltip)&&(Je(this,d,R.ViewBadge.from(i),"f"),Be(this,I,"f").$setWebviewViewBadge(Be(this,S,"f"),i))}show(i){this.a(),Be(this,I,"f").$show(Be(this,S,"f"),!!i)}a(){if(Be(this,v,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,I=new WeakMap,L=new WeakMap,k=new WeakMap,v=new WeakMap,T=new WeakMap,E=new WeakMap,f=new WeakMap,d=new WeakMap,h=new WeakMap,g=new WeakMap;class y{constructor(i,o){this.d=o,this.b=new Map,this.c=new Map,this.a=i.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,o,s,l){if(this.b.has(o))throw new Error(`View provider for '${o}' already registered`);return this.b.set(o,{provider:s,extension:i}),this.a.$registerWebviewViewProvider((0,u.toExtensionData)(i),o,{retainContextWhenHidden:l?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,u.shouldSerializeBuffersForPostMessage)(i)}),new P.Disposable(()=>{this.b.delete(o),this.a.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(i,o,s,l,r){const m=this.b.get(o);if(!m)throw new Error(`No view provider found for '${o}'`);const{provider:n,extension:t}=m,a=this.d.createNewWebview(i,{},t),w=new p(i,this.a,o,s,a,!0);this.c.set(i,w),await n.resolveWebviewView(w,{state:l},r)}async $onDidChangeWebviewViewVisibility(i,o){this.e(i)._setVisible(o)}async $disposeWebviewView(i){const o=this.e(i);this.c.delete(i),o.dispose(),this.d.deleteWebview(i)}e(i){const o=this.c.get(i);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=y}),define(ye[141],De([1,0,3,5,2,18,8,4,20]),function(ne,e,c,A,u,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class an{get state(){return this.d}constructor(k){this.c=new c.Emitter,this.onDidChangeWindowState=this.c.event,this.d=an.a,this.b=k.getProxy(A.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(v=>this.$onDidChangeWindowFocus(v))}$onDidChangeWindowFocus(k){k!==this.d.focused&&(this.d={...this.d,focused:k},this.c.fire(this.d))}openUri(k,v){let T;if(typeof k=="string"){T=k;try{k=u.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,C.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this.b.$openUri(k,T,v)}async asExternalUri(k,v){if((0,C.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const T=await this.b.$asExternalUri(k,v);return u.URI.from(T)}};I.a={focused:!0},I=qe([We(0,S.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(ye[282],De([1,0,119,283,70,40,2,13,47]),function(ne,e,c,A,u,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class I{constructor(v,T,E){this.b=v,this.c=T,this.f=E,this.a=A.createServer((f,d)=>this.h(f,d)),this.g().catch(f=>(T.error(f),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",v=>this.c.error(v))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(v,T){const E=(d,h)=>{T.writeHead(d,{"content-type":"application/json"}),T.end(JSON.stringify(h||null),g=>g&&this.c.error(g))},f=[];v.setEncoding("utf8"),v.on("data",d=>f.push(d)),v.on("end",async()=>{try{const d=JSON.parse(f.join(""));let h;switch(d.type){case"open":h=await this.i(d);break;case"openExternal":h=await this.j(d);break;case"status":h=await this.l(d);break;case"extensionManagement":h=await this.k(d);break;default:E(404,`Unknown message type: ${d.type}`);break}E(200,h)}catch(d){const h=d instanceof Error?d.message:JSON.stringify(d);E(500,h),this.c.error("Error while processing pipe request",d)}})}async i(v){const{fileURIs:T,folderURIs:E,forceNewWindow:f,diffMode:d,mergeMode:h,addMode:g,forceReuseWindow:p,gotoLineMode:y,waitMarkerFilePath:b,remoteAuthority:i}=v,o=[];if(Array.isArray(E))for(const m of E)try{o.push({folderUri:C.URI.parse(m)})}catch{}if(Array.isArray(T))for(const m of T)try{(0,S.hasWorkspaceFileExtension)(m)?o.push({workspaceUri:C.URI.parse(m)}):o.push({fileUri:C.URI.parse(m)})}catch{}const s=b?C.URI.file(b):void 0,r={forceNewWindow:f,diffMode:d,mergeMode:h,addMode:g,gotoLineMode:y,forceReuseWindow:p,preferNewWindow:!p&&!s&&!g,waitMarkerFileURI:s,remoteAuthority:i};return this.b.executeCommand("_remoteCLI.windowOpen",o,r),""}async j(v){for(const T of v.uris){const E=C.URI.parse(T),f=E.scheme==="file"?E:T;await this.b.executeCommand("_remoteCLI.openExternal",f)}}async k(v){const T=f=>f?.map(d=>/\.vsix$/i.test(d)?C.URI.parse(d):d),E={list:v.list,install:T(v.install),uninstall:T(v.uninstall),force:v.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",E)}async l(v){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&u.existsSync(this.f)&&u.unlinkSync(this.f)}}e.CLIServerBase=I;let L=class extends I{constructor(v,T){super(v,T,(0,c.createRandomIPCHandle)())}};L=qe([We(0,R.IExtHostCommands),We(1,P.ILogService)],L),e.CLIServer=L}),define(ye[284],De([1,0,254,25,20]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const R=1024*1024;let C=class extends c.AbstractExtHostConsoleForwarder{constructor(S,I){super(S,I),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(S,I,L){const k=S==="error"||S==="warn"?process.stderr:process.stdout;this.g=!0,k.write(`
START_NATIVE_LOG
`),I.apply(console,L),k.write(`
END_NATIVE_LOG
`),this.g=!1}j(S,I){const L=process[S],k=L.write;let v="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(T,E,f)=>{if(!this.g){v+=T.toString(E);const d=v.length>R?v.length:v.lastIndexOf(`
`);d!==-1&&(console[I](v.slice(0,d)),v=v.slice(d+1))}k.call(L,T,E,f)}})}};C=qe([We(0,u.IExtHostRpcService),We(1,A.IExtHostInitDataService)],C),e.ExtHostConsoleForwarder=C}),define(ye[285],De([1,0,10,88,30,40,6,5,2,20]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends C.Disposable{constructor(v,T){super();const E=v.getProxy(P.MainContext.MainThreadDownloadService);T.registerCommand(!1,"_workbench.downloadResource",async f=>{const d=S.URI.file((0,c.join)((0,A.tmpdir)(),(0,u.generateUuid)()));return await E.$download(f,d),d})}};L=qe([We(0,I.IExtHostRpcService),We(1,R.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(ye[286],De([1,0,140,18,205,30]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class C extends c.ExtHostLoggerService{k(S,I,L){return S.scheme===A.Schemas.file?new u.SpdLogLogger(L?.name||(0,R.generateUuid)(),S.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,I):super.k(S,I,L)}registerLogger(S){super.registerLogger(S),this.l.$registerLogger(S)}deregisterLogger(S){super.deregisterLogger(S),this.l.$deregisterLogger(S)}}e.ExtHostLoggerService=C}),define(ye[287],De([1,0,70,10,2,78,6,18,19,29]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends R.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(i){const o=await super.g(i);if(o.scheme!==P.Schemas.file)return o;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${o.fsPath}.`),o;const s=o.fsPath;let l=0;do{let r;l===0?r=s:r=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${l}`:`${s}-${l}`,await k(r);const m=A.join(r,"vscode.lock"),n=await f(this.d,m,!1);if(n)return this.i=n,process.on("exit",()=>{n.dispose()}),u.URI.file(r);l++}while(l<10);return o}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function k(b){try{await I.Promises.stat(b);return}catch{}try{await I.Promises.mkdir(b,{recursive:!0})}catch{}}const v=1e3,T=10*60*1e3;class E extends C.Disposable{constructor(i,o){super(),this.b=i,this.c=o,this.a=this.B(new S.IntervalTimer),this.a.cancelAndSet(async()=>{const s=await d(i,o);(!s||s.pid!==process.pid)&&(i.info(`Lock '${o}': The lock was lost unexpectedly.`),this.a.cancel());try{await I.Promises.utimes(o,new Date,new Date)}catch(l){i.error(l),i.info(`Lock '${o}': Could not update mtime.`)}},v)}dispose(){super.dispose();try{c.unlinkSync(this.c)}catch{}}async setWillRelease(i){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${i} ms.`);try{const o={pid:process.pid,willReleaseAt:Date.now()+i};await I.Promises.writeFile(this.c,JSON.stringify(o),{flag:"w"})}catch(o){this.b.error(o)}}}async function f(b,i,o){try{const l={pid:process.pid,willReleaseAt:0};await I.Promises.writeFile(i,JSON.stringify(l),{flag:"wx"})}catch(l){b.error(l)}const s=await d(b,i);return!s||s.pid!==process.pid?o?(b.info(`Lock '${i}': Could not acquire lock, giving up.`),null):(b.info(`Lock '${i}': Could not acquire lock, checking if the file is stale.`),p(b,i)):(b.info(`Lock '${i}': Lock acquired.`),new E(b,i))}async function d(b,i){let o;try{o=await I.Promises.readFile(i)}catch(s){return b.error(s),null}try{return JSON.parse(String(o))}catch(s){return b.error(s),null}}async function h(b,i){let o;try{o=await I.Promises.stat(i)}catch(s){return b.error(s),0}return o.mtime.getTime()}function g(b){try{return process.kill(b,0),!0}catch{return!1}}async function p(b,i){const o=await d(b,i);if(!o)return b.info(`Lock '${i}': Could not read pid of lock holder.`),y(b,i);if(o.willReleaseAt){let n=o.willReleaseAt-Date.now();if(n<5e3){for(n>0?b.info(`Lock '${i}': The lockfile is scheduled to be released in ${n} ms.`):b.info(`Lock '${i}': The lockfile is scheduled to have been released.`);n>0;){if(await(0,S.timeout)(Math.min(100,n)),await h(b,i)===0)return y(b,i);n=o.willReleaseAt-Date.now()}return y(b,i)}}if(!g(o.pid))return b.info(`Lock '${i}': The pid ${o.pid} appears to be gone.`),y(b,i);const s=await h(b,i),l=Date.now()-s;if(l<=T)return b.info(`Lock '${i}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;b.info(`Lock '${i}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const r=await h(b,i),m=Date.now()-r;return m<=T?(b.info(`Lock '${i}': The lock does not look stale, elapsed: ${m} ms, giving up.`),null):(b.info(`Lock '${i}': The lock looks stale even after waiting for 2s.`),y(b,i))}async function y(b,i){b.info(`Lock '${i}': Deleting a stale lock.`);try{await I.Promises.unlink(i)}catch{}return f(b,i,!0)}}),define(ye[288],De([1,0,30,20,41]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let R=class extends u.BaseExtHostTerminalService{constructor(P){super(!0,P)}createTerminal(P,S,I){return this.createTerminalFromOptions({name:P,shellPath:S,shellArgs:I})}createTerminalFromOptions(P,S){const I=new u.ExtHostTerminal(this.a,(0,c.generateUuid)(),P,P.name);return this.f.push(I),I.create(P,this.L(P,S)),I.value}};R=qe([We(0,A.IExtHostRpcService)],R),e.ExtHostTerminalService=R}),define(ye[289],De([1,0,5,20,186,6,25,2,46,24,29,7,12,55,3,129,102,13]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,f,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class g extends f.DisposableTunnel{}function p(n){const t=n.trim().split(`
`),a=[];return t.forEach(D=>{const F=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(D);F&&F.length>=3&&a.push({pid:parseInt(F[1],10),socket:parseInt(F[2],10)})}),a.reduce((D,F)=>(D[F.socket]=F,D),{})}e.getSockets=p;function y(...n){const t=[].concat(...n.map(i));return[...new Map(t.filter(a=>a.st==="0A").map(a=>{const w=a.local_address.split(":");return{socket:parseInt(a.inode,10),ip:b(w[0]),port:parseInt(w[1],16)}}).map(a=>[a.ip+":"+a.port,a])).values()]}e.loadListeningPorts=y;function b(n){let t="";if(n.length===8)for(let a=n.length-2;a>=0;a-=2)t+=parseInt(n.substr(a,2),16),a!==0&&(t+=".");else for(let a=n.length-4;a>=0;a-=4)t+=parseInt(n.substr(a,4),16).toString(16),a!==0&&(t+=":");return t}function i(n){const t=n.trim().split(`
`),a=t.shift().trim().split(/\s+/).filter(D=>D!=="rx_queue"&&D!=="tm->when");return t.map(D=>D.trim().split(/\s+/).reduce((F,x,q)=>(F[a[q]||q]=x,F),{}))}e.loadConnectionTable=i;function o(n){return!!n.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||n.indexOf("out/server-main.js")!==-1||n.indexOf("_productName=VSCode")!==-1}function s(n){const t=n.trim().split(`
`),a=[];return t.forEach(w=>{const D=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(w);D&&D.length>=4&&a.push({pid:parseInt(D[1],10),ppid:parseInt(D[2]),cmd:D[3]})}),a}e.getRootProcesses=s;async function l(n,t,a){const w=a.reduce((F,x)=>(F[x.pid]=x,F),{}),D=[];return n.forEach(({socket:F,ip:x,port:q})=>{const M=t[F]?t[F].pid:void 0,B=M?w[M]?.cmd:void 0;M&&B&&!o(B)&&D.push({host:x,port:q,detail:B,pid:M})}),D}e.findPorts=l;function r(n,t,a){const w=new Map,D=s(t);for(const F of n){const x=a.get(F.port);if(x){w.set(F.port,x);continue}const q=D.find(M=>M.cmd.includes(`${F.port}`));if(q){let M=q,B;do B=D.find(O=>O.ppid===M.pid),B&&(M=B);while(B);w.set(F.port,{host:F.ip,port:F.port,pid:M.pid,detail:M.cmd,ppid:M.ppid})}else w.set(F.port,{host:F.ip,port:F.port,ppid:Number.MAX_VALUE})}return w}e.tryFindRootPorts=r;let m=class extends R.Disposable{constructor(t,a,w){super(),this.n=w,this.c=()=>Promise.resolve(!0),this.f=new Map,this.g=new E.Emitter,this.onDidChangeTunnels=this.g.event,this.h=!1,this.j=new Map,this.k=0,this.l=new Map,this.a=t.getProxy(c.MainContext.MainThreadTunnelService),v.isLinux&&a.remote.isRemote&&a.remote.authority&&this.a.$setRemoteTunnelService(process.pid)}async openTunnel(t,a){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${t.identifier.value} called openTunnel API for ${a.remoteAddress.host}:${a.remoteAddress.port}.`);const w=await this.a.$openTunnel(a,t.displayName);if(w){const D=new g(w.remoteAddress,w.localAddress,()=>this.a.$closeTunnel(w.remoteAddress));return this.B(D),D}}async getTunnels(){return this.a.$getTunnels()}p(t){return Math.max(t*20,2e3)}r(){return this.k++}registerPortsAttributesProvider(t,a){const w=this.r();return this.l.set(w,{selector:t,provider:a}),this.a.$registerPortsAttributesProvider(t,w),new k.Disposable(()=>{this.l.delete(w),this.a.$unregisterPortsAttributesProvider(w)})}async $providePortAttributes(t,a,w,D,F){const x=[];for(const M of t){const B=this.l.get(M);if(!B)return[];x.push(...await Promise.all(a.map(async O=>B.provider.providePortAttributes(O,w,D,F))))}const q=x.filter(M=>!!M);return q.length>0?q.map(M=>({autoForwardAction:M.autoForwardAction,port:M.port})):[]}async $registerCandidateFinder(t){if(t&&this.h)return;this.h=t;const a=new d.MovingAverage;let w;for(;this.h;){const D=new Date().getTime(),F=(await this.findCandidatePorts()).filter(q=>(0,f.isLocalhost)(q.host)||(0,f.isAllInterfaces)(q.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${F.map(q=>q.port).join(", ")}`);const x=new Date().getTime()-D;a.update(x),(!w||JSON.stringify(w)!==JSON.stringify(F))&&(w=F,await this.a.$onFoundNewCandidates(w)),await new Promise(q=>setTimeout(()=>q(),this.p(a.value)))}}async setTunnelFactory(t){if(t){if(t.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(t.candidatePortSource),t.showCandidatePort&&(this.c=t.showCandidatePort,this.a.$setCandidateFilter()),t.tunnelFactory){this.b=t.tunnelFactory;let a=t.tunnelFeatures?.privacyOptions??[];t.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:u.localize(0,null),themeIcon:"lock"},{id:"public",label:u.localize(1,null),themeIcon:"eye"}]);const w=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,public:!!t.tunnelFeatures?.public,privacyOptions:a}:void 0;this.a.$setTunnelProvider(w)}}else this.b=void 0;return(0,R.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(t,a){if(this.f.has(t.host)){const w=this.f.get(t.host);w.has(t.port)&&(a&&w.get(t.port).disposeListener.dispose(),await w.get(t.port).tunnel.dispose(),w.delete(t.port))}}async $onDidTunnelsChange(){this.g.fire()}async $forwardPort(t,a){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const w=this.b(t,a);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),w!==void 0){const D=await w;this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.f.has(t.remoteAddress.host)||this.f.set(t.remoteAddress.host,new Map);const F=this.B(D.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(D.remoteAddress))));return this.f.get(t.remoteAddress.host).set(t.remoteAddress.port,{tunnel:D,disposeListener:F}),T.TunnelDtoConverter.fromApiTunnel(D)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(t){const a=await Promise.all(t.map(D=>this.c(D.host,D.port,D.detail??""))),w=t.filter((D,F)=>a[F]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${t.map(D=>D.port).join(", ")} to ${w.map(D=>D.port).join(", ")}`),w}async findCandidatePorts(){let t="",a="";try{t=await L.Promises.readFile("/proc/net/tcp","utf8"),a=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const w=y(t,a),D=await new Promise(z=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(j,de,V)=>{z(de)})}),F=p(D),x=await L.Promises.readdir("/proc"),q=[];for(const z of x)try{const j=Number(z),de=I.joinPath(P.URI.file("/proc"),z);if((await L.Promises.stat(de.fsPath)).isDirectory()&&!isNaN(j)){const X=await L.Promises.readlink(I.joinPath(de,"cwd").fsPath),J=await L.Promises.readFile(I.joinPath(de,"cmdline").fsPath,"utf8");q.push({pid:j,cwd:X,cmd:J})}}catch{}const M=[],B=w.filter(z=>{const j=F[z.socket];return j||M.push(z),j}),O=l(B,F,q);let U;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${M.length}`),M.length>0){const z=await new Promise(j=>{(0,S.exec)("ps -F -A -l | grep root",(de,V,X)=>{j(V)})});this.j=r(M,z,this.j),U=Array.from(this.j.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${U.map(j=>j.port).join(", ")}`)}return O.then(z=>U?z.concat(U):z)}};m=qe([We(0,A.IExtHostRpcService),We(1,C.IExtHostInitDataService),We(2,h.ILogService)],m),e.ExtHostTunnelService=m}),define(ye[290],De([1,0,19,22,21,11,3,6,114,248,58]),function(ne,e,c,A,u,R,C,P,S,I,L){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function v(w,D){try{return JSON.stringify(w,D)}catch{return"null"}}const T="$$ref$$",E={[T]:-1};class f{constructor(D,F){this.jsonString=D,this.referencedBuffers=F}}function d(w,D=null,F=!1){const x=[];return{jsonString:(F?v:JSON.stringify)(w,(M,B)=>{if(typeof B>"u")return E;if(typeof B=="object"){if(B instanceof A.VSBuffer){const O=x.push(B)-1;return{[T]:O}}if(D)return D(M,B)}return B}),referencedBuffers:x}}e.stringifyJsonWithBufferRefs=d;function h(w,D,F){return JSON.parse(w,(x,q)=>{if(q){const M=q[T];if(typeof M=="number")return D[M];if(F&&q.$mid===1)return F.transformIncoming(q)}return q})}e.parseJsonAndRestoreBufferRefs=h;function g(w,D){return JSON.stringify(w,D)}function p(w){return w?(D,F)=>F&&F.$mid===1?w.transformOutgoing(F):F:null}var y;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(y=e.RequestInitiator||(e.RequestInitiator={}));var b;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(b=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},o=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class l extends P.Disposable{constructor(D,F=null,x=null){super(),this[k]=!0,this.b=this.B(new C.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=D,this.f=F,this.g=x,this.h=p(this.g),this.j=!1,this.k=[],this.l=[];for(let q=0,M=L.ProxyIdentifier.count;q<M;q++)this.k[q]=null,this.l[q]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new c.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(q=>this.G(q))}dispose(){this.j=!0,Object.keys(this.s).forEach(D=>{this.s[D].resolveErr(R.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(D){this.u===0&&(this.v=Date.now()+l.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(D){this.v=Date.now()+l.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(D){this.t!==D&&(this.t=D,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(D){return this.g?(0,S.transformIncomingURIs)(D,this.g):D}getProxy(D){const{nid:F,sid:x}=D;return this.l[F]||(this.l[F]=this.F(F,x)),this.l[F]}F(D,F){const x={get:(q,M)=>(typeof M=="string"&&!q[M]&&M.charCodeAt(0)===36&&(q[M]=(...B)=>this.O(D,M,B)),M===s?F:q[M])};return new Proxy(Object.create(null),x)}set(D,F){return this.k[D.nid]=F,F}assertRegistered(D){for(let F=0,x=D.length;F<x;F++){const q=D[F];if(!this.k[q.nid])throw new Error(`Missing proxy instance ${q.sid}`)}}G(D){if(this.j)return;const F=D.byteLength,x=r.read(D,0),q=x.readUInt8(),M=x.readUInt32();switch(q){case 1:case 2:{let{rpcId:B,method:O,args:U}=n.deserializeRequestJSONArgs(x);this.g&&(U=(0,S.transformIncomingURIs)(U,this.g)),this.H(F,M,B,O,U,q===2);break}case 3:case 4:{let{rpcId:B,method:O,args:U}=n.deserializeRequestMixedArgs(x);this.g&&(U=(0,S.transformIncomingURIs)(U,this.g)),this.H(F,M,B,O,U,q===4);break}case 5:{this.f?.logIncoming(F,M,0,"ack"),this.z(M);break}case 6:{this.I(F,M);break}case 7:{this.J(F,M,void 0);break}case 9:{let B=n.deserializeReplyOKJSON(x);this.g&&(B=(0,S.transformIncomingURIs)(B,this.g)),this.J(F,M,B);break}case 10:{const B=n.deserializeReplyOKJSONWithBuffers(x,this.g);this.J(F,M,B);break}case 8:{const B=n.deserializeReplyOKVSBuffer(x);this.J(F,M,B);break}case 11:{let B=n.deserializeReplyErrError(x);this.g&&(B=(0,S.transformIncomingURIs)(B,this.g)),this.L(F,M,B);break}case 12:{this.L(F,M,void 0);break}default:console.error("received unexpected message"),console.error(D)}}H(D,F,x,q,M,B){this.f?.logIncoming(D,F,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(x)}.${q}(`,M);const O=String(F);let U,z;if(B){const de=new u.CancellationTokenSource;M.push(de.token),U=this.M(x,q,M),z=()=>de.cancel()}else U=this.M(x,q,M),z=i;this.p[O]=z;const j=n.serializeAcknowledged(F);this.f?.logOutgoing(j.byteLength,F,1,"ack"),this.c.send(j),U.then(de=>{delete this.p[O];const V=n.serializeReplyOK(F,de,this.h);this.f?.logOutgoing(V.byteLength,F,1,"reply:",de),this.c.send(V)},de=>{delete this.p[O];const V=n.serializeReplyErr(F,de);this.f?.logOutgoing(V.byteLength,F,1,"replyErr:",de),this.c.send(V)})}I(D,F){this.f?.logIncoming(D,F,1,"receiveCancel");const x=String(F);this.p[x]?.()}J(D,F,x){this.f?.logIncoming(D,F,0,"receiveReply:",x);const q=String(F);if(!this.s.hasOwnProperty(q))return;const M=this.s[q];delete this.s[q],M.resolveOk(x)}L(D,F,x){this.f?.logIncoming(D,F,0,"receiveReplyErr:",x);const q=String(F);if(!this.s.hasOwnProperty(q))return;const M=this.s[q];delete this.s[q];let B;x&&(x.$isError?(B=new Error,B.name=x.name,B.message=x.message,B.stack=x.stack):B=x),M.resolveErr(B)}M(D,F,x){try{return Promise.resolve(this.N(D,F,x))}catch(q){return Promise.reject(q)}}N(D,F,x){const q=this.k[D];if(!q)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(D));const M=q[F];if(typeof M!="function")throw new Error("Unknown method "+F+" on actor "+(0,L.getStringIdentifierForProxy)(D));return M.apply(q,x)}O(D,F,x){if(this.j)return new I.CanceledLazyPromise;let q=null;if(x.length>0&&u.CancellationToken.isCancellationToken(x[x.length-1])&&(q=x.pop()),q&&q.isCancellationRequested)return Promise.reject(R.canceled());const M=n.serializeRequestArguments(x,this.h),B=++this.m,O=String(B),U=new I.LazyPromise;q&&q.onCancellationRequested(()=>{const j=n.serializeCancel(B);this.f?.logOutgoing(j.byteLength,B,0,"cancel"),this.c.send(n.serializeCancel(B))}),this.s[O]=U,this.y(B);const z=n.serializeRequest(B,D,F,M,!!q);return this.f?.logOutgoing(z.byteLength,B,0,`request: ${(0,L.getStringIdentifierForProxy)(D)}.${F}(`,x),this.c.send(z),U}}k=o,l.a=3*1e3,e.RPCProtocol=l;class r{static alloc(D,F,x){const q=new r(A.VSBuffer.alloc(x+1+4),0);return q.writeUInt8(D),q.writeUInt32(F),q}static read(D,F){return new r(D,F)}get buffer(){return this.a}constructor(D,F){this.a=D,this.b=F}static sizeUInt8(){return 1}writeUInt8(D){this.a.writeUInt8(D,this.b),this.b+=1}readUInt8(){const D=this.a.readUInt8(this.b);return this.b+=1,D}writeUInt32(D){this.a.writeUInt32BE(D,this.b),this.b+=4}readUInt32(){const D=this.a.readUInt32BE(this.b);return this.b+=4,D}static sizeShortString(D){return 1+D.byteLength}writeShortString(D){this.a.writeUInt8(D.byteLength,this.b),this.b+=1,this.a.set(D,this.b),this.b+=D.byteLength}readShortString(){const D=this.a.readUInt8(this.b);this.b+=1;const x=this.a.slice(this.b,this.b+D).toString();return this.b+=D,x}static sizeLongString(D){return 4+D.byteLength}writeLongString(D){this.a.writeUInt32BE(D.byteLength,this.b),this.b+=4,this.a.set(D,this.b),this.b+=D.byteLength}readLongString(){const D=this.a.readUInt32BE(this.b);this.b+=4;const x=this.a.slice(this.b,this.b+D).toString();return this.b+=D,x}writeBuffer(D){this.a.writeUInt32BE(D.byteLength,this.b),this.b+=4,this.a.set(D,this.b),this.b+=D.byteLength}static sizeVSBuffer(D){return 4+D.byteLength}writeVSBuffer(D){this.a.writeUInt32BE(D.byteLength,this.b),this.b+=4,this.a.set(D,this.b),this.b+=D.byteLength}readVSBuffer(){const D=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+D);return this.b+=D,F}static sizeMixedArray(D){let F=0;F+=1;for(let x=0,q=D.length;x<q;x++){const M=D[x];switch(F+=1,M.type){case 1:F+=this.sizeLongString(M.value);break;case 2:F+=this.sizeVSBuffer(M.value);break;case 3:F+=this.sizeUInt32,F+=this.sizeLongString(M.value);for(let B=0;B<M.buffers.length;++B)F+=this.sizeVSBuffer(M.buffers[B]);break;case 4:break}}return F}writeMixedArray(D){this.a.writeUInt8(D.length,this.b),this.b+=1;for(let F=0,x=D.length;F<x;F++){const q=D[F];switch(q.type){case 1:this.writeUInt8(1),this.writeLongString(q.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(q.value);break;case 3:this.writeUInt8(3),this.writeUInt32(q.buffers.length),this.writeLongString(q.value);for(let M=0;M<q.buffers.length;++M)this.writeBuffer(q.buffers[M]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const D=this.a.readUInt8(this.b);this.b+=1;const F=new Array(D);for(let x=0;x<D;x++)switch(this.readUInt8()){case 1:F[x]=this.readLongString();break;case 2:F[x]=this.readVSBuffer();break;case 3:{const M=this.readUInt32(),B=this.readLongString(),O=[];for(let U=0;U<M;++U)O.push(this.readVSBuffer());F[x]=new L.SerializableObjectWithBuffers(h(B,O,null));break}case 4:F[x]=void 0;break}return F}}r.sizeUInt32=4;var m;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(m||(m={}));class n{static a(D){for(let F=0,x=D.length;F<x;F++)if(D[F]instanceof A.VSBuffer||D[F]instanceof L.SerializableObjectWithBuffers||typeof D[F]>"u")return!0;return!1}static serializeRequestArguments(D,F){if(this.a(D)){const x=[];for(let q=0,M=D.length;q<M;q++){const B=D[q];if(B instanceof A.VSBuffer)x[q]={type:2,value:B};else if(typeof B>"u")x[q]={type:4};else if(B instanceof L.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:U}=d(B.value,F);x[q]={type:3,value:A.VSBuffer.fromString(O),buffers:U}}else x[q]={type:1,value:A.VSBuffer.fromString(g(B,F))}}return{type:1,args:x}}return{type:0,args:g(D,F)}}static serializeRequest(D,F,x,q,M){switch(q.type){case 0:return this.b(D,F,x,q.args,M);case 1:return this.c(D,F,x,q.args,M)}}static b(D,F,x,q,M){const B=A.VSBuffer.fromString(x),O=A.VSBuffer.fromString(q);let U=0;U+=r.sizeUInt8(),U+=r.sizeShortString(B),U+=r.sizeLongString(O);const z=r.alloc(M?2:1,D,U);return z.writeUInt8(F),z.writeShortString(B),z.writeLongString(O),z.buffer}static deserializeRequestJSONArgs(D){const F=D.readUInt8(),x=D.readShortString(),q=D.readLongString();return{rpcId:F,method:x,args:JSON.parse(q)}}static c(D,F,x,q,M){const B=A.VSBuffer.fromString(x);let O=0;O+=r.sizeUInt8(),O+=r.sizeShortString(B),O+=r.sizeMixedArray(q);const U=r.alloc(M?4:3,D,O);return U.writeUInt8(F),U.writeShortString(B),U.writeMixedArray(q),U.buffer}static deserializeRequestMixedArgs(D){const F=D.readUInt8(),x=D.readShortString(),q=D.readMixedArray(),M=new Array(q.length);for(let B=0,O=q.length;B<O;B++){const U=q[B];typeof U=="string"?M[B]=JSON.parse(U):M[B]=U}return{rpcId:F,method:x,args:M}}static serializeAcknowledged(D){return r.alloc(5,D,0).buffer}static serializeCancel(D){return r.alloc(6,D,0).buffer}static serializeReplyOK(D,F,x){if(typeof F>"u")return this.d(D);if(F instanceof A.VSBuffer)return this.e(D,F);if(F instanceof L.SerializableObjectWithBuffers){const{jsonString:q,referencedBuffers:M}=d(F.value,x,!0);return this.g(D,q,M)}else return this.f(D,v(F,x))}static d(D){return r.alloc(7,D,0).buffer}static e(D,F){let x=0;x+=r.sizeVSBuffer(F);const q=r.alloc(8,D,x);return q.writeVSBuffer(F),q.buffer}static deserializeReplyOKVSBuffer(D){return D.readVSBuffer()}static f(D,F){const x=A.VSBuffer.fromString(F);let q=0;q+=r.sizeLongString(x);const M=r.alloc(9,D,q);return M.writeLongString(x),M.buffer}static g(D,F,x){const q=A.VSBuffer.fromString(F);let M=0;M+=r.sizeUInt32,M+=r.sizeLongString(q);for(const O of x)M+=r.sizeVSBuffer(O);const B=r.alloc(10,D,M);B.writeUInt32(x.length),B.writeLongString(q);for(const O of x)B.writeBuffer(O);return B.buffer}static deserializeReplyOKJSON(D){const F=D.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(D,F){const x=D.readUInt32(),q=D.readLongString(),M=[];for(let B=0;B<x;++B)M.push(D.readVSBuffer());return new L.SerializableObjectWithBuffers(h(q,M,F))}static serializeReplyErr(D,F){const x=F?v(R.transformErrorForSerialization(F),null):void 0;if(typeof x!="string")return this.h(D);const q=A.VSBuffer.fromString(x);let M=0;M+=r.sizeLongString(q);const B=r.alloc(11,D,M);return B.writeLongString(q),B.buffer}static deserializeReplyErrError(D){const F=D.readLongString();return JSON.parse(F)}static h(D){return r.alloc(12,D,0).buffer}}var t;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(t||(t={}));var a;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(a||(a={}))}),define(ye[291],De([1,0,3,39,54,4]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new u.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new u.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new u.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,R.createDecorator)(e.OUTPUT_SERVICE_ID);var C;(function(S){S[S.Append=1]="Append",S[S.Replace=2]="Replace",S[S.Clear=3]="Clear"})(C=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class P{constructor(){this.a=new Map,this.b=new c.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new c.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(I){this.a.has(I.id)||(this.a.set(I.id,I),this.b.fire(I.id))}getChannels(){const I=[];return this.a.forEach(L=>I.push(L)),I}getChannel(I){return this.a.get(I)}removeChannel(I){this.a.delete(I),this.c.fire(I)}}A.Registry.add(e.Extensions.OutputChannels,new P),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new u.RawContextKey("activeOutputChannel","")}),define(ye[142],De([1,0,5,4,20,26,13,291,77,25,48,158,22,9,44,3,6]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class h extends C.AbstractMessageLogger{get disposed(){return this.l}constructor(b,i,o,s,l){super(),this.id=b,this.name=i,this.m=o,this.n=s,this.extension=l,this.k=0,this.l=!1,this.visible=!1,this.setLevel(o.getLevel()),this.B(o.onDidChangeLogLevel(r=>this.setLevel(r)))}get logLevel(){return this.getLevel()}appendLine(b){this.append(b+`
`)}append(b){this.info(b)}clear(){const b=this.k;this.m.flush(),this.n.$update(this.id,P.OutputChannelUpdateMode.Clear,b)}replace(b){const i=this.k;this.info(b),this.n.$update(this.id,P.OutputChannelUpdateMode.Replace,i),this.visible&&this.m.flush()}show(b,i){this.m.flush(),this.n.$reveal(this.id,!!(typeof b=="boolean"?b:i))}hide(){this.n.$close(this.id)}g(b,i){this.k+=v.VSBuffer.fromString(i).byteLength,(0,C.log)(this.m,b,i),this.visible&&(this.m.flush(),this.n.$update(this.id,P.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class g extends h{appendLine(b){this.append(b)}}let p=class{constructor(b,i,o,s,l,r){this.i=i,this.j=o,this.k=s,this.l=l,this.m=r,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=b.getProxy(c.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(b){this.h=b;for(const[i,o]of this.g)o.visible=i===this.h}createOutputChannel(b,i,o){if(b=b.trim(),!b)throw new Error("illegal argument `name`. must not be falsy");const s=typeof i=="object"&&i.log,l=(0,T.isString)(i)?i:void 0;if((0,T.isString)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let r;const m=this.i.environment.extensionLogLevel?.find(([t])=>R.ExtensionIdentifier.equals(o.identifier,t))?.[1];m&&(r=(0,C.parseLogLevel)(m));const n=s?this.o(b,r,o):this.n(b,l,o);return n.then(t=>{this.g.set(t.id,t),t.visible=t.id===this.h}),s?this.r(b,r??this.m.getLevel(),n):this.q(b,n)}async n(b,i,o){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,l=this.k.extUri.joinPath(s,`${this.f++}-${b.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),m=await this.a.$register(b,l,i,o.identifier.value);return new h(m,b,r,this.a,o)}async o(b,i,o){const s=await this.p(o),l=this.k.extUri.joinPath(s,`${b.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=l.toString(),m=this.l.createLogger(l,{id:r,name:b,logLevel:i,extensionId:o.identifier.value});return new g(r,b,m,this.a,o)}p(b){let i=this.d.get(b.identifier.value);if(!i){const o=this.k.extUri.joinPath(this.i.logsLocation,b.identifier.value);this.d.set(b.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(o)}catch(s){if((0,E.toFileSystemProviderErrorCode)(s)!==E.FileSystemProviderErrorCode.FileExists)throw s}return o})())}return i}q(b,i){let o=!1;const s=()=>{if(o)throw new Error("Channel has been closed")};return{get name(){return b},append(l){s(),i.then(r=>r.append(l))},appendLine(l){s(),i.then(r=>r.appendLine(l))},clear(){s(),i.then(l=>l.clear())},replace(l){s(),i.then(r=>r.replace(l))},show(l,r){s(),i.then(m=>m.show(l,r))},hide(){s(),i.then(l=>l.hide())},dispose(){o=!0,i.then(l=>l.dispose())}}}r(b,i,o){const s=new d.DisposableStore,l=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},r=s.add(new f.Emitter);function m(n){i=n,r.fire(n)}return o.then(n=>{s.add(n),n.logLevel!==i&&m(n.logLevel),s.add(n.onDidChangeLogLevel(t=>m(t)))}),{...this.q(b,o),get logLevel(){return i},onDidChangeLogLevel:r.event,trace(n,...t){l(),o.then(a=>a.trace(n,...t))},debug(n,...t){l(),o.then(a=>a.debug(n,...t))},info(n,...t){l(),o.then(a=>a.info(n,...t))},warn(n,...t){l(),o.then(a=>a.warn(n,...t))},error(n,...t){l(),o.then(a=>a.error(n,...t))},dispose(){s.dispose()}}}};p=qe([We(0,u.IExtHostRpcService),We(1,I.IExtHostInitDataService),We(2,S.IExtHostConsumerFileSystem),We(3,L.IExtHostFileSystemInfo),We(4,C.ILoggerService),We(5,C.ILogService)],p),e.ExtHostOutputService=p,e.IExtHostOutputService=(0,A.createDecorator)("IExtHostOutputService")}),define(ye[292],De([1,0,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService")}),define(ye[293],De([1,0,33,18,10,12,24,2,4,218,47,236,292]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let T=class cn{constructor(f,d,h,g){this.d=f,this.e=d,this.f=h,this.g=g,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const p=await this.e.getEnvironment();return this.c=p?.userHome??f})()}hasValidBasename(f,d,h){return typeof d=="string"||typeof d>"u"?this.a.then(g=>this.h(f,g,d)):this.h(f,d,h)}h(f,d,h){return f.scheme===A.Schemas.file||f.scheme===A.Schemas.vscodeRemote?(0,c.isValidBasename)(h??(0,C.basename)(f),d===1):!0}get defaultUriScheme(){return cn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(f,d){if(f.remoteAuthority)return A.Schemas.vscodeRemote;const h=(0,I.getVirtualWorkspaceScheme)(d.getWorkspace());if(h)return h;const g=d.getWorkspace().folders[0];if(g)return g.uri.scheme;const p=d.getWorkspace().configuration;return p?p.scheme:A.Schemas.file}userHome(f){return f?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(f=>f===1?u.win32:u.posix)}async fileURI(f){let d="";if(await this.a===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const g=f.indexOf("/",2);g===-1?(d=f.substring(2),f="/"):(d=f.substring(2,g),f=f.substring(g)||"/")}return P.URI.from({scheme:A.Schemas.file,authority:d,path:f,query:"",fragment:""})}};T=qe([We(1,v.IRemoteAgentService),We(2,k.IWorkbenchEnvironmentService),We(3,L.IWorkspaceContextService)],T),e.AbstractPathService=T}),define(ye[80],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(C,P){this.line=C,this.character=P}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,P){return new c(0,0)}with(C){return new c(0,0)}}e.Position=c;class A{constructor(C,P,S,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(C,P),this.end=new c(S,I)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new A(0,0,0,0)}with(C){return new A(0,0,0,0)}}e.Range=A;var u;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(u=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ye[31],De([1,0,15,38,23,33,8,4,10,11,80,19]),function(ne,e,c,A,u,R,C,P,S,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const v="\u27EA ",T=" characters skipped \u27EB",E=(v.length+T.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var f;(function(J){J[J.file=0]="file",J[J.text=1]="text"})(f=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(J){J[J.File=1]="File",J[J.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function h(J){return!!J.preview}e.resultIsMatch=h;function g(J){return!!J.resource}e.isFileMatch=g;function p(J){return!!J.message}e.isProgressMessage=p;var y;(function(J){J[J.Normal=0]="Normal",J[J.NewSearchStarted=1]="NewSearchStarted"})(y=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class b{constructor(te){this.resource=te,this.results=[]}}e.FileMatch=b;class i{constructor(te,ee,Q){this.ranges=ee;const Y=Array.isArray(ee)?ee:[ee];if(Q&&Q.matchLines===1&&o(Y)){te=(0,C.getNLines)(te,Q.matchLines);let ie="",pe=0,ve=0;const ke=Math.floor(Q.charsPerLine/5),Oe=[];for(const oe of Y){const ae=Math.max(oe.startColumn-ke,0),fe=oe.startColumn+Q.charsPerLine;if(ae>ve+ke+E){const Z=v+(ae-ve)+T;ie+=Z+te.slice(ae,fe),pe+=ae-(ve+Z.length)}else ie+=te.slice(ve,fe);Oe.push(new l(0,oe.startColumn-pe,oe.endColumn-pe)),ve=fe}this.preview={text:ie,matches:Array.isArray(this.ranges)?Oe:Oe[0]}}else{const ie=Array.isArray(ee)?ee[0].startLineNumber:ee.startLineNumber;this.preview={text:te,matches:(0,c.mapArrayOrNot)(ee,pe=>new s(pe.startLineNumber-ie,pe.startColumn,pe.endLineNumber-ie,pe.endColumn))}}}}e.TextSearchMatch=i;function o(J){const te=J[0].startLineNumber;for(const ee of J)if(ee.startLineNumber!==te||ee.endLineNumber!==te)return!1;return!0}class s{constructor(te,ee,Q,Y){this.startLineNumber=te,this.startColumn=ee,this.endLineNumber=Q,this.endColumn=Y}}e.SearchRange=s;class l extends s{constructor(te,ee,Q){super(te,ee,te,Q)}}e.OneLineRange=l;var r;(function(J){J.List="list",J.Tree="tree"})(r=e.ViewMode||(e.ViewMode={}));var m;(function(J){J.Default="default",J.FileNames="fileNames",J.Type="type",J.Modified="modified",J.CountDescending="countDescending",J.CountAscending="countAscending"})(m=e.SearchSortOrder||(e.SearchSortOrder={}));function n(J,te=!0){const ee=J&&J.files&&J.files.exclude,Q=te&&J&&J.search&&J.search.exclude;if(!ee&&!Q)return;if(!ee||!Q)return ee||Q;let Y=Object.create(null);return Y=u.mixin(Y,u.deepClone(ee)),Y=u.mixin(Y,u.deepClone(Q),!0),Y}e.getExcludes=n;function t(J,te){return J.excludePattern&&A.match(J.excludePattern,te)?!1:J.includePattern||J.usingSearchPaths?J.includePattern&&A.match(J.includePattern,te)?!0:J.usingSearchPaths?!!J.folderQueries&&J.folderQueries.some(ee=>{const Q=ee.folder.fsPath;if(R.isEqualOrParent(te,Q)){const Y=S.relative(Q,te);return!ee.includePattern||!!A.match(ee.includePattern,Y)}else return!1}):!1:!0}e.pathIncludedInQuery=t;var a;(function(J){J[J.unknownEncoding=1]="unknownEncoding",J[J.regexParseError=2]="regexParseError",J[J.globParseError=3]="globParseError",J[J.invalidLiteral=4]="invalidLiteral",J[J.rgProcessError=5]="rgProcessError",J[J.other=6]="other",J[J.canceled=7]="canceled"})(a=e.SearchErrorCode||(e.SearchErrorCode={}));class w extends Error{constructor(te,ee){super(te),this.code=ee}}e.SearchError=w;function D(J){const te=J.message;if((0,I.isCancellationError)(J))return new w(te,a.canceled);try{const ee=JSON.parse(te);return new w(ee.message,ee.code)}catch{return new w(te,a.other)}}e.deserializeSearchError=D;function F(J){const te={message:J.message,code:J.code};return new Error(JSON.stringify(te))}e.serializeSearchError=F;function x(J){return J.type==="error"?!0:J.type==="success"}e.isSerializedSearchComplete=x;function q(J){return J.type==="success"}e.isSerializedSearchSuccess=q;function M(J){return!!J.path}e.isSerializedFileMatch=M;function B(J,te){const ee=J.searchPath?J.searchPath:J.relativePath;return(0,C.fuzzyContains)(ee,te)}e.isFilePatternMatch=B;class O{constructor(te){this.path=te,this.results=[]}addMatch(te){this.results.push(te)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=O;function U(J,te){const ee={...J||{},...te||{}};return Object.keys(ee).filter(Q=>{const Y=ee[Q];return typeof Y=="boolean"&&Y})}e.resolvePatternsForProvider=U;class z{constructor(te,ee){this.c=null,this.a={...te.excludePattern||{},...ee.excludePattern||{}},this.b=A.parse(this.a);let Q=te.includePattern;ee.includePattern&&(Q?Q={...Q,...ee.includePattern}:Q=ee.includePattern),Q&&(this.c=A.parse(Q))}matchesExcludesSync(te,ee,Q){return!!(this.b&&this.b(te,ee,Q))}includedInQuerySync(te,ee,Q){return!(this.b&&this.b(te,ee,Q)||this.c&&!this.c(te,ee,Q))}includedInQuery(te,ee,Q){const Y=this.b(te,ee,Q),ie=()=>this.c?!!this.c(te,ee,Q):!0;return(0,k.isThenable)(Y)?Y.then(pe=>pe?!1:ie()):ie()}hasSiblingExcludeClauses(){return j(this.a)}}e.QueryGlobTester=z;function j(J){for(const te in J)if(typeof J[te]!="boolean")return!0;return!1}function de(J){if(!J)return;let te;return ee=>(te||(te=(J()||Promise.resolve([])).then(Q=>Q?X(Q):{})),te.then(Q=>!!Q[ee]))}e.hasSiblingPromiseFn=de;function V(J){if(!J)return;let te;return ee=>{if(!te){const Q=J();te=Q?X(Q):{}}return!!te[ee]}}e.hasSiblingFn=V;function X(J){const te={};for(const ee of J)te[ee]=!0;return te}}),define(ye[34],De([1,0,15,19,21,3,6,68,18,102,24,8,9,2,184,4,13,206,47,48,25,20,14,7,56,31,5]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,f,d,h,g,p,y,b,i,o,s,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function m(q,M,B){return new L.ExtUri(O=>w(O,B)).isEqual(q,M)}function n(q,M,B){return m(q.uri,M.uri,B)?0:(0,k.compare)(q.uri.toString(),M.uri.toString())}function t(q,M,B){return q.index!==M.index?q.index<M.index?-1:1:m(q.uri,M.uri,B)?(0,k.compare)(q.name,M.name):(0,k.compare)(q.uri.toString(),M.uri.toString())}function a(q,M,B,O){const U=q.slice(0).sort((j,de)=>B(j,de,O)),z=M.slice(0).sort((j,de)=>B(j,de,O));return(0,c.delta)(U,z,(j,de)=>B(j,de,O))}function w(q,M){const B=M.getCapabilities(q.scheme);return!(B&&B&1024)}class D extends g.Workspace{static toExtHostWorkspace(M,B,O,U){if(!M)return{workspace:null,added:[],removed:[]};const{id:z,name:j,folders:de,configuration:V,transient:X,isUntitled:J}=M,te=[],ee=B;B?de.forEach((pe,ve)=>{const ke=T.URI.revive(pe.uri),Oe=D.o(O||B,ke,U);Oe?(Oe.name=pe.name,Oe.index=pe.index,te.push(Oe)):te.push({uri:ke,name:pe.name,index:ve})}):te.push(...de.map(({uri:pe,name:ve,index:ke})=>({uri:T.URI.revive(pe),name:ve,index:ke}))),te.sort((pe,ve)=>pe.index<ve.index?-1:1);const Q=new D(z,j,te,!!X,V?T.URI.revive(V):null,!!J,pe=>w(pe,U)),{added:Y,removed:ie}=a(ee?ee.workspaceFolders:[],Q.workspaceFolders,n,U);return{workspace:Q,added:Y,removed:ie}}static o(M,B,O){for(let U=0;U<M.folders.length;U++){const z=M.workspaceFolders[U];if(m(z.uri,B,O))return z}}constructor(M,B,O,U,z,j,de){super(M,O.map(V=>new g.WorkspaceFolder(V)),U,z,de),this.t=B,this.u=j,this.q=[],this.s=P.TernarySearchTree.forUris(de),O.forEach(V=>{this.q.push(V),this.s.set(V.uri,V)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(M,B){return B&&this.s.get(M)&&(M=(0,L.dirname)(M)),this.s.findSubstr(M)}resolveWorkspaceFolder(M){return this.s.get(M)}}let F=class{constructor(M,B,O,U,z){this.c=new R.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new R.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new R.AsyncEmitter,this.h=U,this.s=O,this.t=z,this.j=new I.Counter,this.k=new A.Barrier,this.o=M.getProxy(r.MainContext.MainThreadWorkspace),this.q=M.getProxy(r.MainContext.MainThreadMessageService);const j=B.workspace;this.l=j?new D(j.id,j.name,[],!!j.transient,j.configuration?T.URI.revive(j.configuration):null,!!j.isUntitled,de=>w(de,O)):void 0}$initializeWorkspace(M,B){this.v=B,this.$acceptWorkspaceData(M),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?T.URI.from({scheme:S.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(!!this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(M,B,O,...U){const z=[];if(Array.isArray(U)&&U.forEach(J=>{T.URI.isUri(J.uri)&&!z.some(te=>m(te.uri,J.uri,this.s))&&z.push({uri:J.uri,name:J.name||(0,L.basenameOrAuthority)(J.uri)})}),this.n||[B,O].some(J=>typeof J!="number"||J<0)||O===0&&z.length===0)return!1;const j=this.x?this.x.workspaceFolders:[];if(B+O>j.length)return!1;const de=j.slice(0);de.splice(B,O,...z.map(J=>({uri:J.uri,name:J.name||(0,L.basenameOrAuthority)(J.uri),index:void 0})));for(let J=0;J<de.length;J++){const te=de[J];if(de.some((ee,Q)=>Q!==J&&m(te.uri,ee.uri,this.s)))return!1}de.forEach((J,te)=>J.index=te);const{added:V,removed:X}=a(j,de,t,this.s);if(V.length===0&&X.length===0)return!1;if(this.o){const J=M.displayName||M.name;this.o.$updateWorkspaceFolders(J,B,O,z).then(void 0,te=>{this.n=void 0;const ee={source:{identifier:M.identifier,label:M.displayName||M.name}};this.q.$showMessage(h.Severity.Error,(0,E.localize)(0,null,J,te.toString()),ee,[])})}return this.y(de),!0}getWorkspaceFolder(M,B){if(!!this.x)return this.x.getWorkspaceFolder(M,B)}async getWorkspaceFolder2(M,B){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(M,B)}async resolveWorkspaceFolder(M){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(M)}getPath(){if(!this.x)return;const{folders:M}=this.x;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,B){let O,U="";if(typeof M=="string"?(O=T.URI.file(M),U=M):typeof M<"u"&&(O=M,U=M.fsPath),!O)return U;const z=this.getWorkspaceFolder(O,!0);if(!z)return U;typeof B>"u"&&this.x&&(B=this.x.folders.length>1);let j=(0,L.relativePath)(z.uri,O);return B&&z.name&&(j=`${z.name}/${j}`),j}y(M){this.x&&(this.n=D.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:M,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:B,added:O,removed:U}=D.toExtHostWorkspace(M,this.l,this.n,this.s);this.l=B||void 0,this.n=void 0,this.c.fire(Object.freeze({added:O,removed:U}))}findFiles(M,B,O,U,z=u.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let j;if(B===null?j=!1:B&&(typeof B=="string"?j=B:j=B.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:de,folder:V}=x(i.GlobPattern.from(M));return this.o.$startFileSearch((0,v.withUndefinedAsNull)(de),(0,v.withUndefinedAsNull)(V),(0,v.withUndefinedAsNull)(j),(0,v.withUndefinedAsNull)(O),z).then(X=>Array.isArray(X)?X.map(J=>T.URI.revive(J)):[])}async findTextInFiles(M,B,O,U,z=u.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const j=this.j.getNext(),de=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:V,folder:X}=x(i.GlobPattern.from(B.include)),J=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,te={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:de,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:V,excludePattern:J},ee=!1;if(this.u[j]=Q=>{if(ee)return;const Y=T.URI.revive(Q.resource);Q.results.forEach(ie=>{(0,l.resultIsMatch)(ie)?O({uri:Y,preview:{text:ie.preview.text,matches:(0,c.mapArrayOrNot)(ie.preview.matches,pe=>new o.Range(pe.startLineNumber,pe.startColumn,pe.endLineNumber,pe.endColumn))},ranges:(0,c.mapArrayOrNot)(ie.ranges,pe=>new o.Range(pe.startLineNumber,pe.startColumn,pe.endLineNumber,pe.endColumn))}):O({uri:Y,text:ie.text,lineNumber:ie.lineNumber})})},z.isCancellationRequested)return{};try{const Q=await this.o.$startTextSearch(M,(0,v.withUndefinedAsNull)(X),te,j,z);return delete this.u[j],Q||{}}catch(Q){throw delete this.u[j],Q}}$handleTextSearchResult(M,B){this.u[B]?.(M)}saveAll(M){return this.o.$saveAll(M)}resolveProxy(M){return this.o.$resolveProxy(M)}get trusted(){return this.v}requestWorkspaceTrust(M){return this.o.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(M,B){if(this.w.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.w.set(M,B);const O=this.t.transformOutgoingScheme(M),U=this.z++;return this.o.$registerEditSessionIdentityProvider(U,O),(0,C.toDisposable)(()=>{this.w.delete(M),this.o.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(M,B){this.h.info("Getting edit session identifier for workspaceFolder",M);const O=await this.resolveWorkspaceFolder(T.URI.revive(M));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const U=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!U),!U)return;const z=await U.provideEditSessionIdentity(O,B);if(this.h.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(M,B,O,U){this.h.info("Getting edit session identifier for workspaceFolder",M);const z=await this.resolveWorkspaceFolder(T.URI.revive(M));if(!z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const j=this.w.get(z.uri.scheme);if(this.h.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!j),!j)return;const de=await j.provideEditSessionIdentityMatch?.(B,O,U);if(this.h.info("Provider returned edit session identifier match result: ",de),!!de)return de}getOnWillCreateEditSessionIdentityEvent(M){return(B,O,U)=>{const z=function(de){B.call(O,de)};return z.extension=M,this.A.event(z,void 0,U)}}async $onWillCreateEditSessionIdentity(M,B,O){const U=await this.resolveWorkspaceFolder(T.URI.revive(M));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:U},B,async(z,j)=>{const de=Date.now();await Promise.resolve(z),Date.now()-de>O&&this.h.warn("SLOW edit session create-participant",j.extension.identifier)}),B.isCancellationRequested}};F=qe([We(0,b.IExtHostRpcService),We(1,y.IExtHostInitDataService),We(2,p.IExtHostFileSystemInfo),We(3,d.ILogService),We(4,s.IURITransformerService)],F),e.ExtHostWorkspace=F,e.IExtHostWorkspace=(0,f.createDecorator)("IExtHostWorkspace");function x(q){let M,B;return q&&(typeof q=="string"?M=q:(M=q.pattern,B=T.URI.revive(q.baseUri))),{includePattern:M,folder:B}}}),define(ye[35],De([1,0,23,3,34,5,7,209,127,9,19,4,20,13,2]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function f(o,s){if(s){const l=s.split(".");let r=o;for(let m=0;r&&m<l.length;m++)r=r[l[m]];return r}}function d(o){return o instanceof E.URI}function h(o){return o&&o.uri instanceof E.URI&&o.languageId&&typeof o.languageId=="string"}function g(o){return o&&!o.uri&&o.languageId&&typeof o.languageId=="string"}function p(o){return o&&o.uri instanceof E.URI&&(!o.name||typeof o.name=="string")&&(!o.index||typeof o.index=="number")}function y(o){if(d(o))return{resource:o};if(h(o))return{resource:o.uri,overrideIdentifier:o.languageId};if(g(o))return{overrideIdentifier:o.languageId};if(p(o))return{resource:o.uri};if(o===null)return{resource:null}}let b=class{constructor(s,l,r){this.a=s.getProxy(R.MainContext.MainThreadConfiguration),this.c=l,this.b=r,this.d=new L.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new i(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,l){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(s,l))}};b=qe([We(0,v.IExtHostRpcService),We(1,u.IExtHostWorkspace),We(2,T.ILogService)],b),e.ExtHostConfiguration=b;class i{constructor(s,l,r,m){this.a=new A.Emitter,this.b=s,this.f=m,this.c=l,this.e=P.Configuration.parse(r),this.d=this.k(r.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,l){const r={data:this.e.toData(),workspace:this.c.workspace};this.e=P.Configuration.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(l,r))}getConfiguration(s,l,r){const m=y(l)||{},n=this.g(s?f(this.e.getValue(void 0,m,this.c.workspace),s):this.e.getValue(void 0,m,this.c.workspace));s&&this.h(s,m,r?.identifier);function t(w){if(w==null)return null;if(typeof w=="boolean")return w?2:5;switch(w){case C.ConfigurationTarget.Global:return 2;case C.ConfigurationTarget.Workspace:return 5;case C.ConfigurationTarget.WorkspaceFolder:return 6}}const a={has(w){return typeof f(n,w)<"u"},get:(w,D)=>{this.h(s?`${s}.${w}`:w,m,r?.identifier);let F=f(n,w);if(typeof F>"u")F=D;else{let x;const q=(M,B)=>{let O;const U=()=>{x=x||(0,c.deepClone)(n),O=O||f(x,B)};return(0,I.isObject)(M)?new Proxy(M,{get:(z,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return U(),()=>O;if(x)return O=O||f(x,B),O[j];const de=z[j];return typeof j=="string"?q(de,`${B}.${j}`):de},set:(z,j,de)=>(U(),O&&(O[j]=de),!0),deleteProperty:(z,j)=>(U(),O&&delete O[j],!0),defineProperty:(z,j,de)=>(U(),O&&Object.defineProperty(O,j,de),!0)}):M};F=q(F,w)}return F},update:(w,D,F,x)=>{w=s?`${s}.${w}`:w;const q=t(F);return D!==void 0?this.b.$updateConfigurationOption(q,w,D,m,x):this.b.$removeConfigurationOption(q,w,m,x)},inspect:w=>{w=s?`${s}.${w}`:w;const D=this.e.inspect(w,m,this.c.workspace);if(D)return{key:w,defaultValue:(0,c.deepClone)(D.policy?.value??D.default?.value),globalValue:(0,c.deepClone)(D.user?.value??D.application?.value),workspaceValue:(0,c.deepClone)(D.workspace?.value),workspaceFolderValue:(0,c.deepClone)(D.workspaceFolder?.value),defaultLanguageValue:(0,c.deepClone)(D.default?.override),globalLanguageValue:(0,c.deepClone)(D.user?.override??D.application?.override),workspaceLanguageValue:(0,c.deepClone)(D.workspace?.override),workspaceFolderLanguageValue:(0,c.deepClone)(D.workspaceFolder?.override),languageIds:(0,c.deepClone)(D.overrideIdentifiers)}}};return typeof n=="object"&&(0,c.mixin)(a,n,!1),Object.freeze(a)}g(s){const l=r=>(0,I.isObject)(r)?new Proxy(r,{get:(m,n)=>l(m[n]),set:(m,n,t)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(m,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(m,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return l(s)}h(s,l,r){const m=S.OVERRIDE_PROPERTY_REGEX.test(s)?4:this.d.get(s),n=r?`[${r.value}] `:"";if(m===4){typeof l?.resource>"u"&&this.f.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){l?.resource&&this.f.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,l){const r=new P.ConfigurationChangeEvent(s,l,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(m,n)=>r.affectsConfiguration(m,y(n))})}k(s){return s.reduce((l,r)=>(l.set(r[0],r[1]),l),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!u:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(ne,c):u?u.value=c:e.set(ne,c),c},Be=this&&this.__classPrivateFieldGet||function(ne,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[81],De([1,0,2,19,3,5,7,34,59,35,21,41,20,25,4,18,12,13,76,247,11]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,f,d,h,g,p,y){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(M){function B(U){if(U!=null)return U}M.from=B;function O(U){if(U!=null)return U}M.to=O})(i||(i={}));var o;(function(M){function B(U){if(U!=null)return U}M.from=B;function O(U){if(U!=null)return U}M.to=O})(o||(o={}));var s;(function(M){function B(U){if(U!=null)return U}M.from=B;function O(U){if(U!=null)return U}M.to=O})(s||(s={}));var l;(function(M){function B(z){if(z){const j=z;return j&&!!j.process}else return!1}M.is=B;function O(z){if(z==null)return;const j={process:z.process,args:z.args};return z.options&&(j.options=s.from(z.options)),j}M.from=O;function U(z){if(z!=null)return new C.ProcessExecution(z.process,z.args,z.options)}M.to=U})(l||(l={}));var r;(function(M){function B(U){if(U!=null)return U}M.from=B;function O(U){if(U!=null)return U}M.to=O})(r||(r={}));var m;(function(M){function B(z){if(z){const j=z;return j&&(!!j.commandLine||!!j.command)}else return!1}M.is=B;function O(z){if(z==null)return;const j={};return z.commandLine!==void 0?j.commandLine=z.commandLine:(j.command=z.command,j.args=z.args),z.options&&(j.options=r.from(z.options)),j}M.from=O;function U(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new C.ShellExecution(z.commandLine,z.options):new C.ShellExecution(z.command,z.args?z.args:[],z.options)}M.to=U})(m||(m={}));var n;(function(M){function B(z){if(z){const j=z;return j&&j.customExecution==="customExecution"}else return!1}M.is=B;function O(z){return{customExecution:"customExecution"}}M.from=O;function U(z,j){return j.get(z)}M.to=U})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var t;(function(M){function B(O,U){let z;return O.scope!==void 0&&typeof O.scope!="number"?z=O.scope.uri:O.scope!==void 0&&typeof O.scope=="number"&&(O.scope===C.TaskScope.Workspace&&U&&U.workspaceFile?z=U.workspaceFile:z=p.USER_TASKS_GROUP_KEY),{id:O._id,workspaceFolder:z}}M.from=B})(t=e.TaskHandleDTO||(e.TaskHandleDTO={}));var a;(function(M){function B(O){if(O!=null)return{_id:O.id,isDefault:O.isDefault}}M.from=B})(a||(a={}));var w;(function(M){function B(z,j){if(z==null)return[];const de=[];for(const V of z){const X=O(V,j);X&&de.push(X)}return de}M.fromMany=B;function O(z,j){if(z==null)return;let de;z.execution instanceof C.ProcessExecution?de=l.from(z.execution):z.execution instanceof C.ShellExecution?de=m.from(z.execution):z.execution&&z.execution instanceof C.CustomExecution&&(de=n.from(z.execution));const V=i.from(z.definition);let X;return z.scope?typeof z.scope=="number"?X=z.scope:X=z.scope.uri:X=C.TaskScope.Workspace,!V||!X?void 0:{_id:z._id,definition:V,name:z.name,source:{extensionId:j.identifier.value,label:z.source,scope:X},execution:de,isBackground:z.isBackground,group:a.from(z.group),presentationOptions:o.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}M.from=O;async function U(z,j,de){if(z==null)return;let V;l.is(z.execution)?V=l.to(z.execution):m.is(z.execution)?V=m.to(z.execution):n.is(z.execution)&&(V=n.to(z._id,de));const X=i.to(z.definition);let J;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?J=z.source.scope:J=await j.resolveWorkspaceFolder(c.URI.revive(z.source.scope)):J=C.TaskScope.Workspace),!X||!J)return;const te=new C.Task(X,J,z.name,z.source.label,V,z.problemMatchers);return z.isBackground!==void 0&&(te.isBackground=z.isBackground),z.group!==void 0&&(te.group=C.TaskGroup.from(z.group._id),te.group&&z.group.isDefault&&(te.group=new C.TaskGroup(te.group.id,te.group.label),z.group.isDefault===!0&&(te.group.isDefault=z.group.isDefault))),z.presentationOptions&&(te.presentationOptions=o.to(z.presentationOptions)),z._id&&(te._id=z._id),z.detail&&(te.detail=z.detail),te}M.to=U})(w=e.TaskDTO||(e.TaskDTO={}));var D;(function(M){function B(U){return U}M.from=B;function O(U){if(!!U)return Object.assign(Object.create(null),U)}M.to=O})(D||(D={}));class F{constructor(B,O,U){this._id=O,this.a=U,b.set(this,void 0),Je(this,b,B,"f")}get task(){return this.a}terminate(){Be(this,b,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}b=new WeakMap;let x=class{constructor(B,O,U,z,j,de,V,X){this.q=new u.Emitter,this.r=new u.Emitter,this.s=new u.Emitter,this.t=new u.Emitter,this.a=B.getProxy(R.MainContext.MainThreadTask),this.b=U,this.c=z,this.d=j,this.e=de,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=V,this.g=X,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(B,O,U){if(!U)return new C.Disposable(()=>{});const z=this.w();return this.j.set(z,{type:O,provider:U,extension:B}),this.a.$registerTaskProvider(z,O),new C.Disposable(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(B,O){this.a.$registerTaskSystem(B,O)}fetchTasks(B){return this.a.$fetchTasks(D.from(B)).then(async O=>{const U=[];for(const z of O){const j=await w.to(z,this.b,this.m);j&&U.push(j)}return U})}get taskExecutions(){const B=[];return this.k.forEach(O=>B.push(O)),B}terminateTask(B){if(!(B instanceof F))throw new Error("No valid task execution provided");return this.a.$terminateTask(B._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(B,O,U){const z=this.m.get(B.id);z&&(this.o.set(B.id,z),this.e.attachPtyToTerminal(O,await z.callback(U))),this.p=B.id,this.q.fire({execution:await this.y(B)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(B){const O=await this.y(B);this.l.delete(B.id),this.k.delete(B.id),this.A(B),this.r.fire({execution:O})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(B){const O=await this.y(B.id);this.s.fire({execution:O,processId:B.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(B){const O=await this.y(B.id);this.t.fire({execution:O,exitCode:B.exitCode})}$provideTasks(B,O){const U=this.j.get(B);if(!U)return Promise.reject(new Error("no handler found"));const z=[],j=(0,A.asPromise)(()=>U.provider.provideTasks(L.CancellationToken.None)).then(de=>this.u(O,z,U,de));return new Promise(de=>{j.then(V=>{Promise.all(z).then(()=>{de(V)})})})}async $resolveTask(B,O){const U=this.j.get(B);if(!U)return Promise.reject(new Error("no handler found"));if(O.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${O.definition.type}] cannot be resolved by provider of type [${U.type}].`);const z=await w.to(O,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const j=await U.provider.resolveTask(z,L.CancellationToken.None);if(!j)return;this.z(j,U);const de=w.from(j,U.extension);if(!de)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(de.execution)&&await this.x(de,j,!0),await this.v(de)}w(){return this.h++}async x(B,O,U){const z=await this.a.$createTaskId(B);!U&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,O.execution)),this.m.set(z,O.execution)}async y(B,O){if(typeof B=="string"){const j=this.l.get(B);if(!j)throw new y.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return j}const U=this.l.get(B.id);if(U)return U;const z=new Promise((j,de)=>{function V(X,J,te){te?j(new F(X,J.id,te)):de("Unexpected: Task does not exist.")}O?V(this,B,O):w.to(B.task,this.b,this.m).then(X=>V(this,B,X))});return this.l.set(B.id,z),z.then(j=>(this.k.set(B.id,j),j),j=>Promise.reject(j))}z(B,O){B._deprecated&&this.g.report("Task.constructor",O.extension,"Use the Task constructor that takes a `scope` instead.")}A(B){this.o.get(B.id)&&this.o.delete(B.id),this.n.has(B.id)&&this.p!==B.id&&(this.m.delete(B.id),this.n.delete(B.id));const U=this.n.values();let z=U.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=U.next()}};x=qe([We(0,v.IExtHostRpcService),We(1,T.IExtHostInitDataService),We(2,P.IExtHostWorkspace),We(3,S.IExtHostDocumentsAndEditors),We(4,I.IExtHostConfiguration),We(5,k.IExtHostTerminalService),We(6,h.ILogService),We(7,g.IExtHostApiDeprecationService)],x),e.ExtHostTaskBase=x;let q=class extends x{constructor(B,O,U,z,j,de,V,X){super(B,O,U,z,j,de,V,X),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:d.PlatformToString(0)})}async executeTask(B,O){if(!O.execution)throw new Error("Tasks to execute must include an execution");const U=w.from(O,B);if(U===void 0)throw new Error("Task is not valid");if(n.is(U.execution))await this.x(U,O,!1);else throw new y.NotSupportedError;const z=await this.y(await this.a.$getTaskExecution(U),O);return this.a.$executeTask(U).catch(j=>{throw new Error(j)}),z}u(B,O,U,z){const j=[];if(z)for(const de of z){this.z(de,U),(!de.definition||!B[de.definition.type])&&this.f.warn(`The task [${de.source}, ${de.name}] uses an undefined task type. The task will be ignored in the future.`);const V=w.from(de,U.extension);V&&n.is(V.execution)?(j.push(V),O.push(this.x(V,de,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:j,extension:U.extension}}async v(B){if(n.is(B.execution))return B;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(B,O){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,O,U){}};q=qe([We(0,v.IExtHostRpcService),We(1,T.IExtHostInitDataService),We(2,P.IExtHostWorkspace),We(3,S.IExtHostDocumentsAndEditors),We(4,I.IExtHostConfiguration),We(5,k.IExtHostTerminalService),We(6,h.ILogService),We(7,g.IExtHostApiDeprecationService)],q),e.WorkerExtHostTask=q,e.IExtHostTask=(0,E.createDecorator)("IExtHostTask")}),define(ye[294],De([1,0,10,21,45,38,24,43,31]),function(ne,e,c,A,u,R,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(v,T,E){this.k=v,this.l=T,this.o=E,this.e=!1,this.f=0,this.g=!1,this.a=v.filePattern,this.b=v.includePattern&&R.parse(v.includePattern),this.c=v.maxResults||void 0,this.d=v.exists,this.h=new Set,this.j=v.excludePattern&&R.parse(v.excludePattern)}cancel(){this.g=!0,this.h.forEach(v=>v.cancel()),this.h=new Set}search(v){const T=this.k.folderQueries||[];return new Promise((E,f)=>{const d=h=>{this.f++,v(h)};if(this.g)return E({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(h=>{const g=h.toString(),p=c.basename(g);this.j&&this.j(g,p)||this.v(d,{base:h,basename:p})}),Promise.all(T.map(h=>this.p(h,d))).then(h=>{E({limitHit:this.e,stats:h[0]||void 0})},h=>{f(new Error((0,u.toErrorMessage)(h)))})})}async p(v,T){const E=new A.CancellationTokenSource,f=this.q(v),d=this.r(),h=new S.QueryGlobTester(this.k,v),g=!h.hasSiblingExcludeClauses();let p;try{this.h.add(E),p=P.StopWatch.create();const y=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},f,E.token),b=p.elapsed(),i=P.StopWatch.create();return this.g&&!this.e||(y&&y.forEach(o=>{const s=c.posix.relative(v.folder.path,o.path);if(g){const l=c.basename(o.path);this.v(T,{base:v.folder,relativePath:s,basename:l});return}this.s(d,v.folder,s,T)}),this.g&&!this.e)?null:(this.u(d,h,T),{providerTime:b,postProcessTime:i.elapsed()})}finally{E.dispose(),this.h.delete(E)}}q(v){const T=(0,S.resolvePatternsForProvider)(this.k.includePattern,v.includePattern),E=(0,S.resolvePatternsForProvider)(this.k.excludePattern,v.excludePattern);return{folder:v.folder,excludes:E,includes:T,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const v={rootEntries:[],pathToEntries:Object.create(null)};return v.pathToEntries["."]=v.rootEntries,v}s({pathToEntries:v},T,E,f){if(E===this.a){const h=c.basename(this.a);this.v(f,{base:T,relativePath:this.a,basename:h})}function d(h){const g=c.basename(h),p=c.dirname(h);let y=v[p];y||(y=v[p]=[],d(p)),y.push({base:T,relativePath:h,basename:g})}d(E)}u({rootEntries:v,pathToEntries:T},E,f){const d=this,h=this.a;function g(p){const y=(0,S.hasSiblingFn)(()=>p.map(b=>b.basename));for(let b=0,i=p.length;b<i;b++){const o=p[b],{relativePath:s,basename:l}=o;if(E.matchesExcludesSync(s,l,h!==l?y:void 0))continue;const r=T[s];if(r)g(r);else{if(s===h)continue;d.v(f,o)}if(d.e)break}}g(v)}v(v,T){(!this.b||T.relativePath&&this.b(T.relativePath,T.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||v(T))}}class L{constructor(){this.b=new Map}fileSearch(v,T,E,f){const d=this.c(v.cacheKey),h=new I(v,T,d&&d.token);let g=0;const p=y=>{g+=y.length,E(y.map(b=>this.d(b)))};return this.e(h,L.a,p,f).then(y=>({limitHit:y.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:g,detailStats:y.stats}}))}clearCache(v){this.c(v)?.cancel()}c(v){if(!!v)return this.b.has(v)||this.b.set(v,new A.CancellationTokenSource),this.b.get(v)}d(v){return v.relativePath?{resource:C.joinPath(v.base,v.relativePath)}:{resource:v.base}}e(v,T,E,f){f.onCancellationRequested(()=>{v.cancel()});const d=g=>{g&&(h.push(g),T>0&&h.length>=T&&(E(h),h=[]))};let h=[];return v.search(d).then(g=>(h.length&&E(h),g),g=>(h.length&&E(h),Promise.reject(g)))}}L.a=512,e.FileSearchManager=L}),define(ye[295],De([1,0,15,61,38,113,28,18,10,24,8,9,2,166,196,53,13,47,133,293,31]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,f,d,h,g,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let b=class{constructor(a,w,D,F,x){this.a=a,this.b=w,this.c=D,this.d=F,this.e=x}text(a,w,D={}){a=this.f(a,D);const F=this.a.getValue(),x=w&&w.some(M=>!this.a.getValue({resource:M}).search.useRipgrep);return{...this.h(w?.map(h.toWorkspaceFolder),D),type:2,contentPattern:a,previewOptions:D.previewOptions,maxFileSize:D.maxFileSize,usePCRE2:F.search.usePCRE2||x||!1,beforeContext:D.beforeContext,afterContext:D.afterContext,userDisabledExcludesAndIgnoreFiles:D.disregardExcludeSettings&&D.disregardIgnoreFiles}}f(a,w){const D=this.a.getValue();a.isRegExp&&(a.pattern=a.pattern.replace(/\r?\n/g,"\\n"));const F={...a,wordSeparators:D.editor.wordSeparators};return this.j(a,w)&&(F.isCaseSensitive=!0),this.k(a)&&(F.isMultiline=!0),F}file(a,w={}){return{...this.h(a,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey}}g(a,w){return a?(a=Array.isArray(a)?a.map(r):r(a),w?this.parseSearchPaths(a):{pattern:o(...Array.isArray(a)?a:[a])}):{}}h(a=[],w={}){const D=this.g(w.includePattern,w.expandPatterns),F=this.g(w.excludePattern,w.expandPatterns),x=a.length>1,q=(D.searchPaths&&D.searchPaths.length?D.searchPaths.map(O=>this.q(O,w,F)):a.map(O=>this.r(O,w,F,x))).filter(O=>!!O),M={_reason:w._reason,folderQueries:q,usingSearchPaths:!!(D.searchPaths&&D.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:F.pattern,includePattern:D.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const O=c.coalesce(c.flatten(this.c.groups.map(j=>j.editors.map(de=>de.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const U=O.filter(j=>(0,y.pathIncludedInQuery)(M,j.fsPath)),z=this.i(U);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(z)),{...M,...z}}const B=w.extraFileResources&&w.extraFileResources.filter(O=>(0,y.pathIncludedInQuery)(M,O.fsPath));return M.extraFileResources=B&&B.length?B:void 0,M}i(a){const w=[],D=new C.ResourceMap,F={};let x=!1;return a.forEach(q=>{if(q.scheme===P.Schemas.walkThrough)return;if((0,I.isAbsolutePath)(q)){const B=this.b.getWorkspaceFolder(q)?.uri??q.with({path:S.dirname(q.fsPath)});let O=D.get(B);O||(x=!0,O={folder:B,includePattern:{}},w.push(O),D.set(B,O));const U=S.relative(B.fsPath,q.fsPath);(0,k.assertIsDefined)(O.includePattern)[U.replace(/\\/g,"/")]=!0}else q.fsPath&&(x=!0,F[q.fsPath]=!0)}),{folderQueries:w,includePattern:F,usingSearchPaths:!0,excludePattern:x?void 0:{"**/*":!0}}}j(a,w){if(w.isSmartCase){if(a.isRegExp){if(L.containsUppercaseCharacter(a.pattern,!0))return!0}else if(L.containsUppercaseCharacter(a.pattern))return!0}return!!a.isCaseSensitive}k(a){return a.isMultiline||a.isRegExp&&(0,T.isMultilineRegexSource)(a.pattern)||a.pattern.indexOf(`
`)>=0?!0:!!a.isMultiline}parseSearchPaths(a){const w=z=>S.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),F=(Array.isArray(a)?a:s(a)).map(z=>{const j=this.e.resolvedUserHome;return j?(0,R.untildify)(z,j.scheme===P.Schemas.file?j.fsPath:j.path):z}),x=A.groupBy(F,z=>w(z)?"searchPaths":"exprSegments"),q=(x.exprSegments||[]).map(z=>L.rtrim(z,"/")).map(z=>L.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),l(z))),M={},B=this.m(x.searchPaths||[]);B&&B.length&&(M.searchPaths=B);const O=c.flatten(q),U=o(...O);return U&&(M.pattern=U),M}l(a,w){return w.disregardExcludeSettings?void 0:(0,y.getExcludes)(a,!w.disregardSearchExcludeSettings)}m(a){if(!a||!a.length)return[];const w=a.flatMap(F=>{let{pathPortion:x,globPortion:q}=i(F);return q&&(q=m(q)),this.n(x).flatMap(B=>this.o(B,q))}),D=new Map;return w.forEach(F=>{const x=F.searchPath.toString(),q=D.get(x);q?F.pattern&&(q.pattern=q.pattern||{},q.pattern[F.pattern]=!0):D.set(x,{searchPath:F.searchPath,pattern:F.pattern?o(F.pattern):void 0})}),Array.from(D.values())}n(a){if(S.isAbsolute(a)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==P.Schemas.file?[{searchPath:w[0].uri.with({path:a})}]:[{searchPath:v.URI.file(S.normalize(a))}]}if(this.b.getWorkbenchState()===2){const w=this.b.getWorkspace().folders[0].uri;if(a=r(a),a.startsWith("../")||a===".."){const F=S.posix.resolve(w.path,a);return[{searchPath:w.with({path:F})}]}const D=m(a);return[{searchPath:w,pattern:D}]}else{if(a==="./"||a===".\\")return[];{const w=a.replace(/^\.[\/\\]/,""),F=this.b.getWorkspace().folders.map(x=>{const q=w.match(new RegExp(`^${L.escapeRegExpCharacters(x.name)}(?:/(.*)|$)`));return q?{match:q,folder:x}:null}).filter(k.isDefined);if(F.length)return F.map(x=>{const q=x.match[1];return{searchPath:x.folder.uri,pattern:q&&m(q)}});{const x=a.match(/\.[\/\\](.+)[\/\\]?/),q=x?x[1]:a,M=E.localize(0,null,q);throw new Error(M)}}}}o(a,w){const D=a.pattern&&w?`${a.pattern}/${w}`:a.pattern||w,F=[{searchPath:a.searchPath,pattern:D}];return D&&!D.endsWith("**")&&F.push({searchPath:a.searchPath,pattern:D+"/**"}),F}q(a,w,D){const F=this.r((0,h.toWorkspaceFolder)(a.searchPath),w,D,!1);return F?{...F,includePattern:a.pattern}:null}r(a,w,D,F){let x;const q=v.URI.isUri(a)?a:a.uri;if(D.searchPaths){const z=D.searchPaths.filter(j=>(0,I.isEqual)(j.searchPath,q))[0];if(z&&!z.pattern)return null;z&&(x=z.pattern)}const M=this.a.getValue({resource:q}),O={...this.l(M,w)||{},...x||{}},U=v.URI.isUri(a)?(0,I.basename)(a):a.name;return{folder:q,folderName:F?U:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:M.files&&M.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!M.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!M.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!M.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!M.search.followSymlinks}}};b=qe([We(0,f.IConfigurationService),We(1,h.IWorkspaceContextService),We(2,g.IEditorGroupsService),We(3,d.ILogService),We(4,p.IPathService)],b),e.QueryBuilder=b;function i(t){const a=t.match(/[\*\{\}\(\)\[\]\?]/);if(a){const w=a.index,D=t.substr(0,w).match(/[/|\\][^/\\]*$/);if(D){let F=t.substr(0,D.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:t.substr((D.index||0)+1)}}}return{pathPortion:t}}function o(...t){return t.length?t.reduce((a,w)=>(a[w]=!0,a),Object.create(null)):void 0}function s(t){return u.splitGlobAware(t,",").map(a=>a.trim()).filter(a=>!!a.length)}function l(t){return[`**/${t}/**`,`**/${t}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function r(t){return t.replace(/\\/g,"/")}function m(t){return r(t).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(t,a){t=c.distinct(t,F=>F.toString());const w=[],D=a.getWorkspace();return t&&t.forEach(F=>{let x;if(a.getWorkbenchState()===2)x=(0,I.relativePath)(D.folders[0].uri,F),x&&x!=="."&&(x="./"+x);else{const q=a.getWorkspaceFolder(F);if(q){const M=q.name;if(D.folders.filter(O=>O.name===M).length===1){const O=(0,I.relativePath)(q.uri,F);O===""?x=`./${q.name}`:x=`./${q.name}/${O}`}else x=F.fsPath}}x&&w.push(x)}),w}e.resolveResourcesForSearchIncludes=n}),define(ye[296],De([1,0,24,2,21,11,4,295,31,47]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function k(f,d){const h=d.activationEvents;if(!h)return Promise.resolve(void 0);const g=[],p=[];for(const l of h)if(/^workspaceContains:/.test(l)){const r=l.substr(18);r.indexOf("*")>=0||r.indexOf("?")>=0||f.forceUsingSearch?p.push(r):g.push(r)}if(g.length===0&&p.length===0)return Promise.resolve(void 0);let y;const b=new Promise((l,r)=>{y=l}),i=l=>y({activationEvent:l}),o=Promise.all(g.map(l=>v(f,l,i))).then(()=>{}),s=T(f,d.identifier,p,i);return Promise.all([o,s]).then(()=>{y(void 0)}),b}e.checkActivateWorkspaceContainsExtension=k;async function v(f,d,h){for(const g of f.folders)if(await f.exists(c.joinPath(A.URI.revive(g),d))){h(`workspaceContains:${d}`);return}}async function T(f,d,h,g){if(h.length===0)return Promise.resolve(void 0);const p=new u.CancellationTokenSource,y=f.checkExists(f.folders,h,p.token),b=setTimeout(async()=>{p.cancel(),f.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},L);let i=!1;try{i=await y}catch(o){R.isCancellationError(o)||R.onUnexpectedError(o)}p.dispose(),clearTimeout(b),i&&g(`workspaceContains:${h.join(",")}`)}function E(f,d,h,g){const p=f.get(C.IInstantiationService),y=f.get(S.ISearchService),i=p.createInstance(P.QueryBuilder).file(d.map(o=>(0,I.toWorkspaceFolder)(A.URI.revive(o))),{_reason:"checkExists",includePattern:h,exists:!0});return y.fileSearch(i,g).then(o=>!!o.limitHit,o=>R.isCancellationError(o)?!1:Promise.reject(o))}e.checkGlobFileExists=E});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,A,u){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!u:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?u.call(ne,c):u?u.value=c:e.set(ne,c),c},Be=this&&this.__classPrivateFieldGet||function(ne,e,c,A){if(c==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?A:c==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[42],De([1,0,178,10,82,24,19,6,68,2,13,5,35,238,99,34,27,134,11,26,22,220,7,128,4,25,78,20,90,55,41,3,296,98,222,18,97,43]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,f,d,h,g,p,y,b,i,o,s,l,r,m,n,t,a,w,D,F,x,q,M,B){"use strict";var O,U,z;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let j=class Ui extends P.Disposable{constructor(ee,Q,Y,ie,pe,ve,ke,Oe,oe,ae,fe){super(),this.a=this.B(new w.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=Q,this.g=Y,this.f=ke,this.j=ie,this.k=pe,this.l=ve,this.m=oe,this.p=ae,this.s=fe,this.t=this.g.getProxy(k.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(k.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(k.MainContext.MainThreadExtensionService),this.w=new C.Barrier,this.y=new C.Barrier,this.z=new C.Barrier,this.C=new C.Barrier,this.F=new h.ExtensionDescriptionRegistry(this.f.allExtensions);const Z=(0,d.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new h.ExtensionDescriptionRegistry(X(this.F,Z)),this.G=new E.ExtHostStorage(this.g,this.l),this.H=new F.ExtHostSecretState(this.g),this.I=Oe,this.h=ee.createChild(new n.ServiceCollection([E.IExtHostStorage,this.G],[F.IExtHostSecretState,this.H])),this.J=this.B(new T.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(le,re,N)=>{this.v.$onExtensionActivationError(le,g.transformErrorForSerialization(re),N)},actualActivateExtension:async(le,re)=>{if(h.ExtensionDescriptionRegistry.isHostExtension(le,this.D,this.F))return await this.v.$activateExtension(le,re),new T.HostExtension;const N=this.D.getExtensionDescription(le);return this.Y(N,re)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),u.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(ee){g.onUnexpectedError(ee)}}async Q(){this.I.onWillDeactivateAll();let ee=[];try{ee=this.D.getAllExtensionDescriptions().map(pe=>pe.identifier).filter(pe=>this.isActivated(pe)).map(pe=>this.X(pe))}catch{}await Promise.all(ee)}terminate(ee,Q=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${ee}`),this.l.flush(),this.p.dispose(),this.J.dispose(),g.setUnexpectedErrorHandler(ie=>{this.l.error(ie)}),this.g.dispose();const Y=this.Q();Promise.race([(0,C.timeout)(5e3),Y]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${Q}`):this.l.info(`Extension host exiting with code ${Q}`),this.l.flush(),this.l.dispose(),this.c.exit(Q)})}isActivated(ee){return this.z.isOpen()?this.J.isActivated(ee):!1}async getExtension(ee){const Q=await this.v.$getExtension(ee);let Y;if(Q?.browserNlsBundleUris){Y={};for(const ie of Object.keys(Q.browserNlsBundleUris))Y[ie]=I.URI.revive(Q.browserNlsBundleUris[ie])}return Q&&{...Q,identifier:new p.ExtensionIdentifier(Q.identifier.value),extensionLocation:I.URI.revive(Q.extensionLocation),browserNlsBundleUris:Y}}R(ee,Q){return this.J.activateByEvent(ee,Q)}S(ee,Q){return this.J.activateById(ee,Q)}activateByIdWithErrors(ee,Q){return this.S(ee,Q).then(()=>{const Y=this.J.getActivatedExtension(ee);if(Y.activationFailed)return Promise.reject(Y.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(ee=>this.D)}getExtensionExports(ee){return this.z.isOpen()?this.J.getActivatedExtension(ee).exports:null}async U(ee){if(ee.scheme!==q.Schemas.file)return ee;const Q=await this.c.realpath(ee.fsPath);return I.URI.file(Q)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(ee=>new J(ee))),this.L}async W(ee){const Q=S.TernarySearchTree.forUris(Y=>R.extUriBiasedIgnorePathCase.ignorePathCasing(Y));return await Promise.all(ee.map(async Y=>{if(this.ob(Y)){const ie=await this.U(Y.extensionLocation);Q.set(ie,Y)}})),Q}X(ee){let Q=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(ee))return Q;const Y=this.J.getActivatedExtension(ee);if(!Y)return Q;try{typeof Y.module.deactivate=="function"&&(Q=Promise.resolve(Y.module.deactivate()).then(void 0,ie=>(this.l.error(ie),Promise.resolve(void 0))))}catch(ie){this.l.error(`An error occurred when deactivating the extension '${ee.value}':`),this.l.error(ie)}try{(0,P.dispose)(Y.subscriptions)}catch(ie){this.l.error(`An error occurred when deactivating the subscriptions for extension '${ee.value}':`),this.l.error(ie)}return Q}async Y(ee,Q){return this.f.remote.isRemote?this.v.$onWillActivateExtension(ee.identifier):await this.v.$onWillActivateExtension(ee.identifier),this.ab(ee,Q).then(Y=>{const ie=Y.activationTimes;return this.v.$onDidActivateExtension(ee.identifier,ie.codeLoadingTime,ie.activateCallTime,ie.activateResolvedTime,Q),this.Z(ee,Q,"success",ie),Y},Y=>{throw this.Z(ee,Q,"failure"),Y})}Z(ee,Q,Y,ie){const pe=de(ee,Q);this.u.$publicLog2("extensionActivationTimes",{...pe,...ie||{},outcome:Y})}ab(ee,Q){const Y=de(ee,Q);this.u.$publicLog2("activatePlugin",Y);const ie=this.ob(ee);if(!ie)return Promise.resolve(new T.EmptyExtension(T.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${ee.identifier.value}, startup: ${Q.startup}, activationEvent: '${Q.activationEvent}'${ee.identifier.value!==Q.extensionId.value?`, root cause: ${Q.extensionId.value}`:""}`),this.l.flush();const pe=new T.ExtensionActivationTimesBuilder(Q.startup);return Promise.all([this.pb(ee,(0,R.joinPath)(ee.extensionLocation,ie),pe),this.bb(ee)]).then(ve=>(u.mark(`code/extHost/willActivateExtension/${ee.identifier.value}`),Ui.cb(this.l,ee.identifier,ve[0],ve[1],pe))).then(ve=>(u.mark(`code/extHost/didActivateExtension/${ee.identifier.value}`),ve))}bb(ee){const Q=new b.ExtensionGlobalMemento(ee,this.G),Y=new b.ExtensionMemento(ee.identifier.value,!1,this.G),ie=new x.ExtensionSecrets(ee,this.H),pe=ee.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ve=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${ee.identifier.value}`),Promise.all([Q.whenReady,Y.whenReady,this.I.whenReady]).then(()=>{const ke=this;let Oe,oe;const ae=(0,d.isProposedApiEnabled)(ee,"ipc")?this.f.messagePorts?.get(p.ExtensionIdentifier.toKey(ee.identifier)):void 0;return Object.freeze({globalState:Q,workspaceState:Y,secrets:ie,subscriptions:[],get extensionUri(){return ee.extensionLocation},get extensionPath(){return ee.extensionLocation.fsPath},asAbsolutePath(fe){return A.join(ee.extensionLocation.fsPath,fe)},get storagePath(){return ke.I.workspaceValue(ee)?.fsPath},get globalStoragePath(){return ke.I.globalValue(ee).fsPath},get logPath(){return A.join(ke.f.logsLocation.fsPath,ee.identifier.value)},get logUri(){return I.URI.joinPath(ke.f.logsLocation,ee.identifier.value)},get storageUri(){return ke.I.workspaceValue(ee)},get globalStorageUri(){return ke.I.globalValue(ee)},get extensionMode(){return pe},get extension(){return Oe===void 0&&(Oe=new V(ke,ee.identifier,ee,ve,!1)),Oe},get extensionRuntime(){return(0,d.checkProposedApiEnabled)(ee,"extensionRuntime"),ke.extensionRuntime},get environmentVariableCollection(){return ke.p.getEnvironmentVariableCollection(ee)},get messagePassingProtocol(){if(!oe){if(!ae)return;const fe=w.Event.buffer(w.Event.fromDOMEventEmitter(ae,"message",Z=>Z.data));ae.start(),oe={onDidReceiveMessage:fe,postMessage:ae.postMessage.bind(ae)}}return oe}})})}static cb(ee,Q,Y,ie,pe){return Y=Y||{activate:void 0,deactivate:void 0},this.db(ee,Q,Y,ie,pe).then(ve=>new T.ActivatedExtension(!1,null,pe.build(),Y,ve,ie.subscriptions))}static db(ee,Q,Y,ie,pe){if(typeof Y.activate=="function")try{pe.activateCallStart(),ee.trace(`ExtensionService#_callActivateOptional ${Q.value}`);const ve=typeof global=="object"?global:self,ke=Y.activate.apply(ve,[ie]);return pe.activateCallStop(),pe.activateResolveStart(),Promise.resolve(ke).then(Oe=>(pe.activateResolveStop(),Oe))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(Y)}eb(ee,Q){this.S(ee.identifier,{startup:!1,extensionId:ee.identifier,activationEvent:Q}).then(void 0,Y=>{this.l.error(Y)})}fb(){this.v.$setPerformanceMarks(u.getMarks());for(const ee of this.D.getAllExtensionDescriptions())if(ee.activationEvents)for(const Q of ee.activationEvents)Q==="onStartupFinished"&&this.eb(ee,Q)}gb(){const ee=this.R("*",!0).then(void 0,pe=>{this.l.error(pe)});this.B(this.j.onDidChangeWorkspace(pe=>this.hb(pe.added)));const Q=this.j.workspace?this.j.workspace.folders:[],Y=this.hb(Q),ie=Promise.all([ee,Y]).then(()=>{});return Promise.race([ie,(0,C.timeout)(1e4)]).then(()=>{this.fb()}),ie}hb(ee){return ee.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(Q=>this.ib(ee,Q))).then(()=>{})}async ib(ee,Q){if(this.isActivated(Q.identifier))return;const Y=!this.f.remote.isRemote&&!!this.f.remote.authority,ie={logService:this.l,folders:ee.map(ve=>ve.uri),forceUsingSearch:Y,exists:ve=>this.c.exists(ve.fsPath),checkExists:(ve,ke,Oe)=>this.t.$checkExists(ve,ke,Oe)},pe=await(0,D.checkActivateWorkspaceContainsExtension)(ie,Q);if(!!pe)return this.S(Q.identifier,{startup:!0,extensionId:Q.identifier,activationEvent:pe.activationEvent}).then(void 0,ve=>this.l.error(ve))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(ee){throw console.error(ee),ee}}async jb(){const{extensionDevelopmentLocationURI:ee,extensionTestsLocationURI:Q}=this.f.environment;if(!ee||!Q)throw new Error(c.localize(0,null));const Y=await this.pb(null,Q,new T.ExtensionActivationTimesBuilder(!1));if(!Y||typeof Y.run!="function")throw new Error(c.localize(1,null,Q.toString()));return new Promise((ie,pe)=>{const ve=(oe,ae)=>{oe?pe(oe):ie(typeof ae=="number"&&ae>0?1:0)},ke=(0,R.originalFSPath)(Q),Oe=Y.run(ke,ve);Oe&&Oe.then&&Oe.then(()=>{ie(0)}).catch(oe=>{pe(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ee,Q){return this.M[ee]=Q,(0,P.toDisposable)(()=>{delete this.M[ee]})}async lb(ee){const Q=ee.indexOf("+");if(Q===-1)throw new Error("Not an authority that can be resolved!");const Y=ee.substr(0,Q);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${Y}`,!1),{authorityPrefix:Y,resolver:this.M[Y]}}async $resolveAuthority(ee,Q){const Y=B.StopWatch.create(!1),ie=()=>`[resolveAuthority(${(0,o.getRemoteAuthorityPrefix)(ee)},${Q})][${Y.elapsed()}ms] `,pe=ae=>this.l.info(`${ie()}${ae}`),ve=(ae,fe=void 0)=>this.l.error(`${ie()}${ae}`,fe);pe("activating resolver...");const{authorityPrefix:ke,resolver:Oe}=await this.lb(ee);if(!Oe)return ve("no resolver"),{type:"error",error:{code:o.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ke}.`,detail:void 0}};const oe=new C.IntervalTimer;try{pe("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(Oe)),oe.cancelAndSet(()=>pe("waiting..."),1e3),pe("invoking resolve()..."),u.mark(`code/extHost/willResolveAuthority/${ke}`);const ae=await Oe.resolve(ee,{resolveAttempt:Q});u.mark(`code/extHost/didResolveAuthorityOK/${ke}`),oe.dispose(),pe(`returned ${ae.host}:${ae.port}`);const fe={authority:ee,host:ae.host,port:ae.port,connectionToken:ae.connectionToken},Z={extensionHostEnv:ae.extensionHostEnv,isTrusted:ae.isTrusted,authenticationSession:ae.authenticationSessionForInitializingExtensions?{id:ae.authenticationSessionForInitializingExtensions.id,providerId:ae.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:fe,options:Z,tunnelInformation:{environmentTunnels:ae.environmentTunnels,features:ae.tunnelFeatures}}}}catch(ae){if(u.mark(`code/extHost/didResolveAuthorityError/${ke}`),oe.dispose(),ve("returned an error",ae),ae instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:ae._code,message:ae._message,detail:ae._detail}};throw ae}}async $getCanonicalURI(ee,Q){this.l.info(`$getCanonicalURI invoked for authority (${(0,o.getRemoteAuthorityPrefix)(ee)})`);const{resolver:Y}=await this.lb(ee);if(!Y)return null;const ie=I.URI.revive(Q);if(typeof Y.getCanonicalURI>"u")return ie;const pe=await(0,C.asPromise)(()=>Y.getCanonicalURI(ie));return pe||ie}static mb(ee,Q,Y){const ie=new h.ExtensionDescriptionRegistry(ee.getAllExtensionDescriptions());ie.deltaExtensions(Y.toAdd,Y.toRemove);const pe=(0,d.extensionIdentifiersArrayToSet)(Q.getAllExtensionDescriptions().map(ke=>ke.identifier));for(const ke of Y.myToRemove)pe.delete(p.ExtensionIdentifier.toKey(ke));for(const ke of Y.myToAdd)pe.add(p.ExtensionIdentifier.toKey(ke));const ve=X(ie,pe);return{globalRegistry:ie,myExtensions:ve}}$startExtensionHost(ee){ee.toAdd.forEach(ie=>ie.extensionLocation=I.URI.revive(ie.extensionLocation));const{globalRegistry:Q,myExtensions:Y}=Ui.mb(this.F,this.D,ee);return this.F.set(Q.getAllExtensionDescriptions()),this.D.set(Y),this.kb()}$activateByEvent(ee,Q){return Q===1?this.R(ee,!1):this.z.wait().then(Y=>this.R(ee,!1))}async $activate(ee,Q){return await this.z.wait(),this.D.getExtensionDescription(ee)?(await this.S(ee,Q),!0):!1}async $deltaExtensions(ee){ee.toAdd.forEach(ve=>ve.extensionLocation=I.URI.revive(ve.extensionLocation));const{globalRegistry:Q,myExtensions:Y}=Ui.mb(this.F,this.D,ee),ie=await this.W(Y);return(await this.getExtensionPathIndex()).setSearchTree(ie),this.F.set(Q.getAllExtensionDescriptions()),this.D.set(Y),Promise.resolve(void 0)}async $test_latency(ee){return ee}async $test_up(ee){return ee.byteLength}async $test_down(ee){const Q=y.VSBuffer.alloc(ee),Y=Math.random()%256;for(let ie=0;ie<ee;ie++)Q.writeUInt8(Y,ie);return Q}async $updateRemoteConnectionData(ee){this.P=ee,this.a.fire()}};j=qe([We(0,s.IInstantiationService),We(1,e.IHostUtils),We(2,m.IExtHostRpcService),We(3,f.IExtHostWorkspace),We(4,v.IExtHostConfiguration),We(5,L.ILogService),We(6,l.IExtHostInitDataService),We(7,r.IExtensionStoragePaths),We(8,t.IExtHostTunnelService),We(9,a.IExtHostTerminalService),We(10,M.IExtHostLocalizationService)],j),e.AbstractExtHostExtensionService=j;function de(te,ee){return{id:te.identifier.value,name:te.name,extensionVersion:te.version,publisherDisplayName:te.publisher,activationEvents:te.activationEvents?te.activationEvents.join(","):null,isBuiltin:te.isBuiltin,reason:ee.activationEvent,reasonId:ee.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class V{constructor(ee,Q,Y,ie,pe){O.set(this,void 0),U.set(this,void 0),z.set(this,void 0),Je(this,O,ee,"f"),Je(this,U,Q,"f"),Je(this,z,Y.identifier,"f"),this.id=Y.identifier.value,this.extensionUri=Y.extensionLocation,this.extensionPath=A.normalize((0,R.originalFSPath)(Y.extensionLocation)),this.packageJSON=Y,this.extensionKind=ie,this.isFromDifferentExtensionHost=pe}get isActive(){return Be(this,O,"f").isActivated(Be(this,z,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Be(this,O,"f").getExtensionExports(Be(this,z,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Be(this,O,"f").activateByIdWithErrors(Be(this,z,"f"),{startup:!1,extensionId:Be(this,U,"f"),activationEvent:"api"}),this.exports}}e.Extension=V,O=new WeakMap,U=new WeakMap,z=new WeakMap;function X(te,ee){return te.getAllExtensionDescriptions().filter(Q=>ee.has(p.ExtensionIdentifier.toKey(Q.identifier)))}class J{constructor(ee){this.a=ee}setSearchTree(ee){this.a=ee}findSubstr(ee){return this.a.findSubstr(ee)}forEach(ee){return this.a.forEach(ee)}}e.ExtensionPaths=J}),define(ye[297],De([1,0,82,2,5,35,27,26,20,25,4,42,36,13,8]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let f=class{constructor(b,i,o,s,l,r,m){this.c=b,this.d=i,this.e=o,this.f=s,this.g=l,this.h=r,this.i=m,this.a=new Map,this.b=[]}async install(){this.j(),c.mark("code/extHost/willWaitForConfig");const b=await this.f.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new h(this.c,i,this.d,b,this.i)),this.register(this.e.createInstance(g,i)),this.register(this.e.createInstance(d)),this.h.remote.isRemote&&this.register(this.e.createInstance(p,i,this.h.environment.appUriScheme))}register(b){if("nodeModuleName"in b)if(Array.isArray(b.nodeModuleName))for(const i of b.nodeModuleName)this.a.set(i,b);else this.a.set(b.nodeModuleName,b);typeof b.alternativeModuleName=="function"&&this.b.push(i=>b.alternativeModuleName(i))}};f=qe([We(2,L.IInstantiationService),We(3,R.IExtHostConfiguration),We(4,k.IExtHostExtensionService),We(5,I.IExtHostInitDataService),We(6,T.ILogService)],f),e.RequireInterceptor=f;let d=class rn{constructor(b){if(b.environment.appRoot&&rn.a.size){const i=(0,E.escapeRegExpCharacters)(this.c(b.environment.appRoot.fsPath)),o="[a-z0-9_.-]",s=`@${o}+\\/${o}+|${o}+`,l="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${l}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(b){if(!this.b)return;const i=this.b.exec(this.c(b));if(!i)return;const[,o,s,l]=i,r=rn.a.get(s);if(r!==void 0)return console.warn(`${s} as been renamed to ${r}, please update your imports`),o+r+l}c(b){return b.replace(/\\/g,"/")}};d.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),d=qe([We(0,I.IExtHostInitDataService)],d);class h{constructor(b,i,o,s,l){this.c=b,this.d=i,this.e=o,this.f=s,this.g=l,this.nodeModuleName="vscode",this.a=new Map}load(b,i){const o=this.d.findSubstr(i);if(o){let s=this.a.get(P.ExtensionIdentifier.toKey(o.identifier));return s||(s=this.c(o,this.e,this.f),this.a.set(P.ExtensionIdentifier.toKey(o.identifier),s)),s}if(!this.b){let s="";this.d.forEach((l,r)=>s+=`	${r} -> ${l.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${s}`),this.b=this.c(C.nullExtensionDescription,this.e,this.f)}return this.b}}let g=class{constructor(b,i,o){this.d=b,this.nodeModuleName="keytar",this.a=i.getProxy(u.MainContext.MainThreadTelemetry);const{environment:s}=o,l=i.getProxy(u.MainContext.MainThreadKeytar);if(s.appRoot){let r=s.appRoot.fsPath;v.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.b=new Set,this.b.add(`${r}/node_modules.asar/keytar`),this.b.add(`${r}/node_modules/keytar`)}this.c={getPassword:(r,m)=>l.$getPassword(r,m),setPassword:(r,m,n)=>l.$setPassword(r,m,n),deletePassword:(r,m)=>l.$deletePassword(r,m),findPassword:r=>l.$findPassword(r),findCredentials(r){return l.$findCredentials(r)}}}load(b,i){const o=this.d.findSubstr(i);return this.a.$publicLog2("shimming.keytar",{extension:o?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(b){const i=b.length;if(i<=7||!this.b)return;const o=i-7;if((b.charAt(o)==="/"||b.charAt(o)==="\\")&&b.endsWith("keytar")&&(b=b.replace(/\\/g,"/"),this.b.has(b)))return"keytar"}};g=qe([We(1,S.IExtHostRpcService),We(2,I.IExtHostInitDataService)],g);let p=class{constructor(b,i,o){this.e=b,this.f=i,this.nodeModuleName=["open","opn"],this.d=o.getProxy(u.MainContext.MainThreadTelemetry);const s=o.getProxy(u.MainContext.MainThreadWindow);this.c=(l,r)=>{const m=A.URI.parse(l);return r?this.g(l,r):m.scheme==="http"||m.scheme==="https"?s.$openUri(m,l,{allowTunneling:!0}):m.scheme==="mailto"||m.scheme===this.f?s.$openUri(m,l,{}):this.g(l,r)}}load(b,i,o){const s=this.e.findSubstr(i);return s&&(this.a=s.identifier.value,this.h()),this.b=o(b),this.c}g(b,i){return this.i(),this.b(b,i)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};p=qe([We(2,S.IExtHostRpcService)],p)}),define(ye[49],De([1,0,65,6,10,36,4,59,60,42,7,34,234,35]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,C.createDecorator)("IExtHostVariableResolverProvider");class E extends v.AbstractVariableResolverService{constructor(h,g,p,y,b,i,o){function s(){if(p){const l=p.activeEditor();if(l)return l.document.uri;const r=y.tabGroups.all.find(m=>m.isActive)?.activeTab;if(r!==void 0){if(r.input instanceof L.TextDiffTabInput||r.input instanceof L.NotebookDiffEditorTabInput)return r.input.modified;if(r.input instanceof L.TextTabInput||r.input instanceof L.NotebookEditorTabInput||r.input instanceof L.CustomEditorTabInput)return r.input.uri}}}super({getFolderUri:l=>{const r=i.folders.filter(m=>m.name===l);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(l,r)=>b.getConfiguration(void 0,l).get(r),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=s();if(l)return u.normalize(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(g){const l=s();if(l){const r=g.getWorkspaceFolder(l);if(r)return u.normalize(r.uri.fsPath)}}},getSelectedText:()=>{if(p){const l=p.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(p){const l=p.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>h.getExtension(l)},void 0,o?Promise.resolve(o):void 0,Promise.resolve(R.env))}}let f=class extends A.Disposable{constructor(h,g,p,y,b){super(),this.b=h,this.c=g,this.g=p,this.h=y,this.i=b,this.a=new c.Lazy(async()=>{const i=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new E(this.b,this.c,this.g,this.i,i,s,this.j())})}getResolver(){return this.a.value}j(){}};f=qe([We(0,I.IExtHostExtensionService),We(1,k.IExtHostWorkspace),We(2,P.IExtHostDocumentsAndEditors),We(3,T.IExtHostConfiguration),We(4,S.IExtHostEditorTabs)],f),e.ExtHostVariableResolverProviderService=f}),define(ye[83],De([1,0,19,3,9,2,4,5,60,42,20,7,34,131,227,35,49]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,C.createDecorator)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,l,r,m,n,t){this.D=l,this.E=r,this.F=m,this.G=n,this.H=t,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new A.Emitter,this.n=new A.Emitter,this.o=new A.Emitter,this.u=new A.Emitter,this.k=s.getProxy(P.MainContext.MainThreadDebugService),this.z=new A.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new p(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(a=>{a.onDidChange(w=>{this.I(a)}),this.I(a)})}asDebugSourceUri(s,l){const r=s;if(typeof r.sourceReference=="number"&&r.sourceReference>0){let m=`debug:${encodeURIComponent(r.path||"")}`,n="?";return l&&(m+=`${n}session=${encodeURIComponent(l.id)}`,n="&"),m+=`${n}ref=${r.sourceReference}`,R.URI.parse(m)}else{if(r.path)return R.URI.file(r.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(s){const l=[];for(const r of s.getAllExtensionDescriptions())if(r.contributes){const m=r.contributes.debuggers;if(m&&m.length>0)for(const n of m)(0,E.isDebuggerMainContribution)(n)&&l.push(n.type)}this.k.$registerDebugTypes(l)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const s=[];return this.w.forEach(l=>s.push(l)),s}addBreakpoints(s){this.T();const l=s.filter(n=>{const t=n.id;return this.w.has(t)?!1:(this.w.set(t,n),!0)});this.U(l,[],[]);const r=[],m=new Map;for(const n of l)if(n instanceof k.SourceBreakpoint){let t=m.get(n.location.uri.toString());t||(t={type:"sourceMulti",uri:n.location.uri,lines:[]},m.set(n.location.uri.toString(),t),r.push(t)),t.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof k.FunctionBreakpoint&&r.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this.k.$registerBreakpoints(r)}removeBreakpoints(s){this.T();const l=s.filter(t=>this.w.delete(t.id));this.U([],l,[]);const r=l.filter(t=>t instanceof k.SourceBreakpoint).map(t=>t.id),m=l.filter(t=>t instanceof k.FunctionBreakpoint).map(t=>t.id),n=l.filter(t=>t instanceof k.DataBreakpoint).map(t=>t.id);return this.k.$unregisterBreakpoints(r,m,n)}startDebugging(s,l,r){return this.k.$startDebugging(s?s.uri:void 0,l,{parentSessionID:r.parentSession?r.parentSession.id:void 0,lifecycleManagedByParent:r.lifecycleManagedByParent,repl:r.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:r.noDebug,compact:r.compact,suppressSaveBeforeStart:r.suppressSaveBeforeStart,suppressDebugStatusbar:r.suppressDebugStatusbar??r.debugUI?.simple,suppressDebugToolbar:r.suppressDebugToolbar??r.debugUI?.simple,suppressDebugView:r.suppressDebugView??r.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,l,r){if(!l)return new k.Disposable(()=>{});const m=this.d++;return this.f.push({type:s,handle:m,provider:l}),this.k.$registerDebugConfigurationProvider(s,r,!!l.provideDebugConfigurations,!!l.resolveDebugConfiguration,!!l.resolveDebugConfigurationWithSubstitutedVariables,m),new k.Disposable(()=>{this.f=this.f.filter(n=>n.provider!==l),this.k.$unregisterDebugConfigurationProvider(m)})}registerDebugAdapterDescriptorFactory(s,l,r){if(!r)return new k.Disposable(()=>{});if(!this.P(s,l))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${l}' debugger.`);if(this.M(l))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const m=this.g++;return this.h.push({type:l,handle:m,factory:r}),this.k.$registerDebugAdapterDescriptorFactory(l,m),new k.Disposable(()=>{this.h=this.h.filter(n=>n.factory!==r),this.k.$unregisterDebugAdapterDescriptorFactory(m)})}registerDebugAdapterTrackerFactory(s,l){if(!l)return new k.Disposable(()=>{});const r=this.i++;return this.j.push({type:s,handle:r,factory:l}),new k.Disposable(()=>{this.j=this.j.filter(m=>m.factory!==l)})}async $runInTerminal(s,l){return Promise.resolve(void 0)}async $substituteVariables(s,l){let r;const m=await this.W(s);return m&&(r={uri:m.uri,name:m.name,index:m.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(r,l)}J(s,l){if(s.type==="implementation")return new b(s.implementation)}K(){}async $startDASession(s,l){const r=this,m=await this.V(l);return this.R(this.M(m.type),m).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}' (extension might have failed to activate)`);const t=this.L(n),a=this.J(t,m);if(!a)throw new Error(`Couldn't create a debug adapter for type '${m.type}'.`);const w=a;return this.A.set(s,w),this.Q(m).then(D=>(D&&this.B.set(s,D),w.onMessage(async F=>{if(F.type==="request"&&F.command==="handshake"){const x=F,q={type:"response",seq:0,command:x.command,request_seq:x.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const M=await this.C.sign(x.arguments.value);q.body={signature:M},w.sendResponse(q)}else throw new Error("no signer")}catch(M){q.success=!1,q.message=M.message,w.sendResponse(q)}}else D&&D.onDidSendMessage&&D.onDidSendMessage(F),F=(0,E.convertToVSCPaths)(F,!0),r.k.$acceptDAMessage(s,F)}),w.onError(F=>{D&&D.onError&&D.onError(F),this.k.$acceptDAError(s,F.name,F.message,F.stack)}),w.onExit(F=>{D&&D.onExit&&D.onExit((0,u.withNullAsUndefined)(F),void 0),this.k.$acceptDAExit(s,(0,u.withNullAsUndefined)(F),void 0)}),D&&D.onWillStartSession&&D.onWillStartSession(),w.startSession()))})}$sendDAMessage(s,l){l=(0,E.convertToDAPaths)(l,!1);const r=this.B.get(s);r&&r.onWillReceiveMessage&&r.onWillReceiveMessage(l),this.A.get(s)?.sendMessage(l)}$stopDASession(s){const l=this.B.get(s);this.B.delete(s),l&&l.onWillStopSession&&l.onWillStopSession();const r=this.A.get(s);return this.A.delete(s),r?r.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const l=[],r=[],m=[];if(s.added)for(const n of s.added){const t=n.id;if(t&&!this.w.has(t)){let a;if(n.type==="function")a=new k.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")a=new k.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const w=R.URI.revive(n.uri);a=new k.SourceBreakpoint(new k.Location(w,new k.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}(0,k.setBreakpointId)(a,t),this.w.set(t,a),l.push(a)}}if(s.removed)for(const n of s.removed){const t=this.w.get(n);t&&(this.w.delete(n),r.push(t))}if(s.changed){for(const n of s.changed)if(n.id){const t=this.w.get(n.id);if(t){if(t instanceof k.FunctionBreakpoint&&n.type==="function"){const a=t;a.enabled=n.enabled,a.condition=n.condition,a.hitCondition=n.hitCondition,a.logMessage=n.logMessage,a.functionName=n.functionName}else if(t instanceof k.SourceBreakpoint&&n.type==="source"){const a=t;a.enabled=n.enabled,a.condition=n.condition,a.hitCondition=n.hitCondition,a.logMessage=n.logMessage,a.location=new k.Location(R.URI.revive(n.uri),new k.Position(n.line,n.character))}m.push(t)}}}this.U(l,r,m)}$provideDebugConfigurations(s,l,r){return(0,c.asPromise)(async()=>{const m=this.O(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.W(l);return m.provideDebugConfigurations(n,r)}).then(m=>{if(!m)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return m})}$resolveDebugConfiguration(s,l,r,m){return(0,c.asPromise)(async()=>{const n=this.O(s);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const t=await this.W(l);return n.resolveDebugConfiguration(t,r,m)})}$resolveDebugConfigurationWithSubstitutedVariables(s,l,r,m){return(0,c.asPromise)(async()=>{const n=this.O(s);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const t=await this.W(l);return n.resolveDebugConfigurationWithSubstitutedVariables(t,r,m)})}async $provideDebugAdapter(s,l){const r=this.N(s);if(!r)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const m=await this.V(l);return this.R(r,m).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}'`);return this.L(n)})}async $acceptDebugSessionStarted(s){const l=await this.V(s);this.m.fire(l)}async $acceptDebugSessionTerminated(s){const l=await this.V(s);l&&(this.n.fire(l),this.l.delete(l.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,l){(await this.V(s))?._acceptNameChanged(l)}async $acceptDebugSessionCustomEvent(s,l){const m={session:await this.V(s),event:l.event,body:l.body};this.u.fire(m)}L(s){if(s instanceof k.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof k.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}M(s){const l=this.h.filter(r=>r.type===s);if(l.length>0)return l[0].factory}N(s){const l=this.h.filter(r=>r.handle===s);if(l.length>0)return l[0].factory}O(s){const l=this.f.filter(r=>r.handle===s);if(l.length>0)return l[0].provider}P(s,l){if(s.contributes){const r=s.contributes.debuggers;if(r&&r.length>0){for(const m of r)if(m.label&&m.type&&m.type===l)return!0}}return!1}Q(s){const r=s.configuration.type,m=this.j.filter(n=>n.type===r||n.type==="*").map(n=>(0,c.asPromise)(()=>n.factory.createDebugAdapterTracker(s)).then(t=>t,t=>null));return Promise.race([Promise.all(m).then(n=>{const t=n.filter(a=>!!a);if(t.length>0)return new y(t)}),new Promise(n=>setTimeout(()=>n(void 0),1e3))]).catch(n=>{})}async R(s,l){const r=l.configuration.debugServer;if(typeof r=="number")return Promise.resolve(new k.DebugAdapterServer(r));if(s){const n=await this.E.getExtensionRegistry();return(0,c.asPromise)(()=>s.createDebugAdapterDescriptor(l,this.S(l,n))).then(t=>{if(t)return t})}const m=await this.E.getExtensionRegistry();return Promise.resolve(this.S(l,m))}S(s,l){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(s,l,r){(s.length>0||l.length>0||r.length>0)&&this.z.fire(Object.freeze({added:s,removed:l,changed:r}))}async V(s){if(s)if(typeof s=="string"){const l=this.l.get(s);if(l)return l}else{let l=this.l.get(s.id);if(!l){const r=await this.W(s.folderUri),m=s.parent?this.l.get(s.parent):void 0;l=new g(this.k,s.id,s.type,s.name,r,s.configuration,m),this.l.set(l.id,l),this.k.$sessionCached(l.id)}return l}throw new Error("cannot find session")}W(s){if(s){const l=R.URI.revive(s);return this.D.resolveWorkspaceFolder(l)}return Promise.resolve(void 0)}};h=qe([We(0,L.IExtHostRpcService),We(1,v.IExtHostWorkspace),We(2,I.IExtHostExtensionService),We(3,f.IExtHostConfiguration),We(4,S.IExtHostEditorTabs),We(5,d.IExtHostVariableResolverProvider)],h),e.ExtHostDebugServiceBase=h;class g{constructor(s,l,r,m,n,t,a){this.d=s,this.f=l,this.g=r,this.h=m,this.i=n,this.j=t,this.k=a}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,l){return this.d.$customDebugAdapterRequest(this.f,s,l)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.ExtHostDebugSession=g;class p{constructor(s){this.value=Object.freeze({append(l){s.$appendDebugConsole(l)},appendLine(l){this.append(l+`
`)}})}}e.ExtHostDebugConsole=p;class y{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(l=>l.onWillReceiveMessage?l.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(l=>l.onDidSendMessage?l.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(l=>l.onError?l.onError(s):void 0)}onExit(s,l){this.d.forEach(r=>r.onExit?r.onExit(s,l):void 0)}}class b extends T.AbstractDebugAdapter{constructor(s){super(),this.h=s,s.onDidSendMessage(l=>{this.acceptMessage(l)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let i=class extends h{constructor(s,l,r,m,n,t){super(s,l,r,m,n,t)}};i=qe([We(0,L.IExtHostRpcService),We(1,v.IExtHostWorkspace),We(2,I.IExtHostExtensionService),We(3,f.IExtHostConfiguration),We(4,S.IExtHostEditorTabs),We(5,d.IExtHostVariableResolverProvider)],i),e.WorkerExtHostDebugService=i}),define(ye[298],De([1,0,11,82,2,5,290,13,89,90,25,203,20,56,42,96]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class d{static async installEarlyHandler(p){const y=p.get(P.ILogService),i=p.get(v.IExtHostRpcService).getProxy(R.MainContext.MainThreadErrors);c.setUnexpectedErrorHandler(o=>{y.error(o);const s=c.transformErrorForSerialization(o);i.$onUnexpectedError(s)})}static async installFullHandler(p){const y=p.get(P.ILogService),b=p.get(v.IExtHostRpcService),i=p.get(E.IExtHostExtensionService),o=p.get(f.IExtHostTelemetry),s=b.getProxy(R.MainContext.MainThreadExtensionService),l=b.getProxy(R.MainContext.MainThreadErrors),r=await i.getExtensionPathIndex(),m=new WeakMap;Error.prepareStackTrace=(n,t)=>{let a="",w,D;for(const F of t)a+=`
	at ${F.toString()}`,D=F.getFileName(),!w&&D&&(w=r.findSubstr(u.URI.file(D)));return m.set(n,w?.identifier),`${n.name||"Error"}: ${n.message||""}${a}`},c.setUnexpectedErrorHandler(n=>{y.error(n);const t=c.transformErrorForSerialization(n),a=m.get(n);if(!a){l.$onUnexpectedError(t);return}s.$onExtensionRuntimeError(a,t);const w=o.onExtensionError(a,n);y.trace("forwarded error to extension?",w,a)})}}Error.stackTraceLimit=100;class h{constructor(p,y,b,i,o){this.a=b,this.b=new C.RPCProtocol(p,null,i),y=h.e(y,this.b);const s=new I.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());s.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...y,messagePorts:o}),s.set(v.IExtHostRpcService,new v.ExtHostRpcService(this.b)),s.set(T.IURITransformerService,new T.URITransformerService(i)),s.set(E.IHostUtils,b);const l=new k.InstantiationService(s,!0);l.invokeFunction(d.installEarlyHandler),this.d=l.invokeFunction(r=>r.get(P.ILogService)),A.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",y),this.c=l.invokeFunction(r=>r.get(E.IExtHostExtensionService)),this.c.initialize(),l.invokeFunction(d.installFullHandler)}async asBrowserUri(p){const y=this.b.getProxy(R.MainContext.MainThreadExtensionService);return u.URI.revive(await y.$asBrowserUri(p))}terminate(p){this.c.terminate(p)}static e(p,y){p.allExtensions.forEach(i=>{i.extensionLocation=u.URI.revive(y.transformIncomingURIs(i.extensionLocation));const o={};i.browserNlsBundleUris&&(Object.keys(i.browserNlsBundleUris).forEach(s=>o[s]=u.URI.revive(y.transformIncomingURIs(i.browserNlsBundleUris[s]))),i.browserNlsBundleUris=o)}),p.environment.appRoot=u.URI.revive(y.transformIncomingURIs(p.environment.appRoot));const b=p.environment.extensionDevelopmentLocationURI;return b&&(p.environment.extensionDevelopmentLocationURI=b.map(i=>u.URI.revive(y.transformIncomingURIs(i)))),p.environment.extensionTestsLocationURI=u.URI.revive(y.transformIncomingURIs(p.environment.extensionTestsLocationURI)),p.environment.globalStorageHome=u.URI.revive(y.transformIncomingURIs(p.environment.globalStorageHome)),p.environment.workspaceStorageHome=u.URI.revive(y.transformIncomingURIs(p.environment.workspaceStorageHome)),p.environment.extensionTelemetryLogResource=u.URI.revive(y.transformIncomingURIs(p.environment.extensionTelemetryLogResource)),p.nlsBaseUrl=u.URI.revive(y.transformIncomingURIs(p.nlsBaseUrl)),p.logsLocation=u.URI.revive(y.transformIncomingURIs(p.logsLocation)),p.logFile=u.URI.revive(y.transformIncomingURIs(p.logFile)),p.workspace=y.transformIncomingURIs(p.workspace),p}}e.ExtensionHostMain=h}),define(ye[299],De([1,0,19,12,185,202,210,83,60,42,20,41,7,49,34,228,230,35]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,f,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let g=class extends P.ExtHostDebugServiceBase{constructor(o,s,l,r,m,n,t){super(o,s,l,r,n,t),this.Z=m,this.X=new b}J(o,s){switch(o.type){case"server":return new f.SocketDebugAdapter(o);case"pipeServer":return new f.NamedPipeDebugAdapter(o);case"executable":return new f.ExecutableDebugAdapter(o,s.type)}return super.J(o,s)}S(o,s){const l=f.ExecutableDebugAdapter.platformAdapterExecutable(s.getAllExtensionDescriptions(),o.type);if(l)return new v.DebugAdapterExecutable(l.command,l.args,l.options)}K(){return new C.SignService}async $runInTerminal(o,s){if(o.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(M=>{this.X.onTerminalClosed(M)}));const l=await this.F.getConfigProvider(),r=this.Z.getDefaultShell(!0),m=this.Z.getDefaultShellArgs(!0),n=o.title||u.localize(0,null),t=JSON.stringify({shell:r,shellArgs:m});let a=await this.X.checkout(t,n),w,D=!1;if(a)w=o.cwd;else{const M={shellPath:r,shellArgs:m,cwd:o.cwd,name:n,iconPath:new v.ThemeIcon("debug")};D=!0,a=this.Z.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(a,t)}a.show(!0);const F=await a.processId;D?await new Promise(M=>setTimeout(M,1e3)):l.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?a.sendText("cls"):r.indexOf("bash")>=0?a.sendText("clear"):A.isWindows?a.sendText("cls"):a.sendText("clear"));const x=(0,d.prepareCommand)(r,o.args,!!o.argsCanBeInterpretedByShell,w,o.env);a.sendText(x);const q=this.onDidTerminateDebugSession(M=>{M.id===s&&(this.X.free(a),q.dispose())});return F}else if(o.kind==="external")return y(o,await this.F.getConfigProvider());return super.$runInTerminal(o,s)}};g=qe([We(0,L.IExtHostRpcService),We(1,E.IExtHostWorkspace),We(2,I.IExtHostExtensionService),We(3,h.IExtHostConfiguration),We(4,k.IExtHostTerminalService),We(5,S.IExtHostEditorTabs),We(6,T.IExtHostVariableResolverProvider)],g),e.ExtHostDebugService=g;let p;function y(i,o){if(!p)if(A.isWindows)p=new R.WindowsExternalTerminalService;else if(A.isMacintosh)p=new R.MacExternalTerminalService;else if(A.isLinux)p=new R.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const s=o.getConfiguration("terminal");return p.runInTerminal(i.title,i.cwd,i.args,i.env||{},s.external||{})}class b{constructor(){this.b=new Map}async checkout(o,s){const r=[...this.b.entries()].map(([m,n])=>(0,c.createCancelablePromise)(async t=>{if(m.name!==s||n.lastUsedAt!==-1&&await(0,d.hasChildProcesses)(await m.processId))return null;const a=Date.now();return n.lastUsedAt+b.a>a||t.isCancellationRequested||n.config!==o?null:(n.lastUsedAt=a,m)}));return await(0,c.firstParallel)(r,m=>!!m)}insert(o,s){this.b.set(o,{lastUsedAt:Date.now(),config:s})}free(o){const s=this.b.get(o);s&&(s.lastUsedAt=-1)}onTerminalClosed(o){this.b.delete(o)}}b.a=1e3}),define(ye[300],De([1,0,10,2,116,34,59,35,47,41,20,25,81,18,13,76,24,88,49]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,f,d,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let p=class extends v.ExtHostTaskBase{constructor(b,i,o,s,l,r,m,n,t){super(b,i,o,s,l,r,m,n),this.B=o,this.C=t,i.remote.isRemote&&i.remote.authority?this.registerTaskSystem(T.Schemas.vscodeRemote,{scheme:T.Schemas.vscodeRemote,authority:i.remote.authority,platform:process.platform}):this.registerTaskSystem(T.Schemas.file,{scheme:T.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(b,i){const o=i;if(!i.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const s=v.TaskHandleDTO.from(o,this.B),l=await this.a.$getTaskExecution(s);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.y(l,i);return this.a.$executeTask(s).catch(()=>{}),r}else{const s=v.TaskDTO.from(i,b);if(s===void 0)return Promise.reject(new Error("Task is not valid"));v.CustomExecutionDTO.is(s.execution)&&await this.x(s,i,!1);const l=await this.y(await this.a.$getTaskExecution(s),i);return this.a.$executeTask(s).catch(()=>{}),l}}u(b,i,o,s){const l=[];if(s)for(const r of s){this.z(r,o),(!r.definition||!b[r.definition.type])&&this.f.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const m=v.TaskDTO.from(r,o.extension);m&&(l.push(m),v.CustomExecutionDTO.is(m.execution)&&i.push(this.x(m,r,!0)))}return{tasks:l,extension:o.extension}}async v(b){return b}async F(b){let i=b&&b.length>0?b[0]:void 0;if(!i){const o=A.URI.file((0,h.homedir)());i=new S.WorkspaceFolder({uri:o,name:d.basename(o),index:0})}return{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(b,i){const o=A.URI.revive(b),s={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(o),r=await this.b.getWorkspaceFolders2()??[],m=await this.C.getResolver(),n=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(r);for(const t of i.variables)s.variables[t]=await m.resolveAsync(n,t);if(i.process!==void 0){let t;if(i.process.path!==void 0){t=i.process.path.split(c.delimiter);for(let a=0;a<t.length;a++)t[a]=await m.resolveAsync(n,t[a])}s.process=await u.win32.findExecutable(await m.resolveAsync(n,i.process.name),i.process.cwd!==void 0?await m.resolveAsync(n,i.process.cwd):void 0,t)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(b,i,o){return u.win32.findExecutable(b,i,o)}};p=qe([We(0,L.IExtHostRpcService),We(1,k.IExtHostInitDataService),We(2,R.IExtHostWorkspace),We(3,C.IExtHostDocumentsAndEditors),We(4,P.IExtHostConfiguration),We(5,I.IExtHostTerminalService),We(6,E.ILogService),We(7,f.IExtHostApiDeprecationService),We(8,g.IExtHostVariableResolverProvider)],p),e.ExtHostTask=p}),define(ye[301],De([1,0,88,49]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class u extends A.ExtHostVariableResolverProviderService{j(){return(0,c.homedir)()}}e.NodeExtHostVariableResolverProviderService=u}),define(ye[143],De([1,0,15,19,21,45,18,10,24,2,31]),function(ne,e,c,A,u,R,C,P,S,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class k{constructor(g,p,y,b){this.d=g,this.e=p,this.f=y,this.g=b,this.a=null,this.b=!1,this.c=0}search(g,p){const y=this.d.folderQueries||[],b=new u.CancellationTokenSource;return p.onCancellationRequested(()=>b.cancel()),new Promise((i,o)=>{this.a=new T(g);let s=!1;const l=(r,m)=>{if(!s&&!this.b){const n=this.h(r);f(r)&&typeof this.d.maxResults=="number"&&this.c+n>this.d.maxResults&&(this.b=!0,s=!0,b.cancel(),r=this.j(r,this.d.maxResults-this.c));const t=this.h(r);this.c+=t,(t>0||!f(r))&&this.a.add(r,m)}};Promise.all(y.map((r,m)=>this.k(r,n=>l(n,m),b.token))).then(r=>{b.dispose(),this.a.flush();const m=r.some(n=>!!n&&!!n.limitHit);i({limitHit:this.b||m,messages:(0,c.flatten)(r.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.g}})},r=>{b.dispose();const m=(0,R.toErrorMessage)(r);o(new Error(m))})})}h(g){return f(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}j(g,p){const y=Array.isArray(g.ranges)?g.ranges:[g.ranges],b=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:y.slice(0,p),preview:{matches:b.slice(0,p),text:g.preview.text},uri:g.uri}}async k(g,p,y){const b=new L.QueryGlobTester(this.d,g),i=[],o={report:r=>{if(!this.l(r))return;const m=g.folder.scheme===C.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.f.readdir(S.dirname(r.uri))):void 0,n=S.relativePath(g.folder,r.uri);if(n){const t=b.includedInQuery(n,P.basename(n),m);(0,A.isThenable)(t)?i.push(t.then(a=>{a&&p(r)})):t&&p(r)}}},s=this.n(g),l=await this.e.provideTextSearchResults(v(this.d.contentPattern),s,o,y);return i.length&&await Promise.all(i),l}l(g){if(f(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(g){const p=(0,L.resolvePatternsForProvider)(this.d.includePattern,g.includePattern),y=(0,L.resolvePatternsForProvider)(this.d.excludePattern,g.excludePattern),b={folder:I.URI.from(g.folder),excludes:y,includes:p,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.f.toCanonicalName(g.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return b.usePCRE2=this.d.usePCRE2,b}}e.TextSearchManager=k;function v(h){return{isCaseSensitive:h.isCaseSensitive||!1,isRegExp:h.isRegExp||!1,isWordMatch:h.isWordMatch||!1,isMultiline:h.isMultiline||!1,pattern:h.pattern}}class T{constructor(g){this.e=g,this.b=-1,this.d=null,this.a=new d(512,p=>this.g(p))}add(g,p){this.d&&(this.b!==p||!S.isEqual(this.c,g.uri))&&(this.f(),this.d=null),this.d||(this.b=p,this.d={resource:g.uri,results:[]}),this.d.results.push(E(g))}f(){const g=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,g)}flush(){this.f(),this.a.flush()}g(g){this.e(g)}}e.TextSearchResultsCollector=T;function E(h){return f(h)?{preview:{matches:(0,c.mapArrayOrNot)(h.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:h.preview.text},ranges:(0,c.mapArrayOrNot)(h.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:h.text,lineNumber:h.lineNumber}}function f(h){return!!h.preview}e.extensionResultIsMatch=f;class d{constructor(g,p){this.g=g,this.h=p,this.c=0,this.d=[],this.e=0}addItem(g,p){!g||this.j(g,p)}addItems(g,p){!g||this.k(g,p)}j(g,p){this.d.push(g),this.e+=p,this.l()}k(g,p){this.d=this.d.concat(g),this.e+=p,this.l()}l(){this.c<d.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},d.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}d.a=4e3,d.b=50,e.BatchedCollector=d}),define(ye[84],De([1,0,6,5,4,294,20,56,13,2,143]),function(ne,e,c,A,u,R,C,P,S,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,u.createDecorator)("IExtHostSearch");let k=class{constructor(f,d,h){this.k=f,this.l=d,this.n=h,this.c=this.k.getProxy(A.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.FileSearchManager}o(f){return this.l.transformOutgoingScheme(f)}registerTextSearchProvider(f,d){if(this.g.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this.g.add(f);const h=this.d++;return this.e.set(h,d),this.c.$registerTextSearchProvider(h,this.o(f)),(0,c.toDisposable)(()=>{this.g.delete(f),this.e.delete(h),this.c.$unregisterProvider(h)})}registerFileSearchProvider(f,d){if(this.i.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this.i.add(f);const h=this.d++;return this.h.set(h,d),this.c.$registerFileSearchProvider(h,this.o(f)),(0,c.toDisposable)(()=>{this.i.delete(f),this.h.delete(h),this.c.$unregisterProvider(h)})}$provideFileSearchResults(f,d,h,g){const p=v(h),y=this.h.get(f);if(y)return this.j.fileSearch(p,y,b=>{this.c.$handleFileMatch(f,d,b.map(i=>i.resource))},g);throw new Error("unknown provider: "+f)}$clearCache(f){return this.j.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,d,h,g){const p=this.e.get(f);if(!p||!p.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const y=v(h);return this.q(y,p).search(i=>this.c.$handleTextMatch(f,d,i),g)}$enableExtensionHostSearch(){}q(f,d){return new L.TextSearchManager(f,d,{readdir:h=>Promise.resolve([]),toCanonicalName:h=>h},"textSearchProvider")}};k=qe([We(0,C.IExtHostRpcService),We(1,P.IURITransformerService),We(2,S.ILogService)],k),e.ExtHostSearch=k;function v(E){return{...E,folderQueries:E.folderQueries&&E.folderQueries.map(T),extraFileResources:E.extraFileResources&&E.extraFileResources.map(f=>I.URI.revive(f))}}e.reviveQuery=v;function T(E){return{...E,folder:I.URI.revive(E.folder)}}}),define(ye[302],De([1,0,89,142,34,139,35,40,59,41,81,83,84,99,55,76,141,77,48,98,96,60,140,13,219,49,97]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,f,d,h,g,p,y,b,i,o,s,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(r.IExtHostLocalizationService,r.ExtHostLocalizationService,1),(0,c.registerSingleton)(o.ILoggerService,i.ExtHostLoggerService,1),(0,c.registerSingleton)(o.ILogService,s.ExtHostLogService,1),(0,c.registerSingleton)(f.IExtHostApiDeprecationService,f.ExtHostApiDeprecationService,1),(0,c.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands,0),(0,c.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration,0),(0,c.registerSingleton)(h.IExtHostConsumerFileSystem,h.ExtHostConsumerFileSystem,0),(0,c.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService,0),(0,c.registerSingleton)(R.IExtHostDecorations,R.ExtHostDecorations,0),(0,c.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,c.registerSingleton)(g.IExtHostFileSystemInfo,g.ExtHostFileSystemInfo,0),(0,c.registerSingleton)(A.IExtHostOutputService,A.ExtHostOutputService,1),(0,c.registerSingleton)(v.IExtHostSearch,v.ExtHostSearch,0),(0,c.registerSingleton)(T.IExtHostStorage,T.ExtHostStorage,0),(0,c.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,0),(0,c.registerSingleton)(I.IExtHostTerminalService,I.WorkerExtHostTerminalService,0),(0,c.registerSingleton)(E.IExtHostTunnelService,E.ExtHostTunnelService,0),(0,c.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow,0),(0,c.registerSingleton)(u.IExtHostWorkspace,u.ExtHostWorkspace,0),(0,c.registerSingleton)(p.IExtHostSecretState,p.ExtHostSecretState,0),(0,c.registerSingleton)(y.IExtHostTelemetry,y.ExtHostTelemetry,0),(0,c.registerSingleton)(b.IExtHostEditorTabs,b.ExtHostEditorTabs,0),(0,c.registerSingleton)(l.IExtHostVariableResolverProvider,l.ExtHostVariableResolverProviderService,0)}),define(ye[100],De([1,0,15,13,31,80]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function C(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=C;function P(k,v,T,E){const f=(0,c.mapArrayOrNot)(T,S),d=new u.TextSearchMatch(v,f,E),h=d.preview.matches;return{ranges:(0,c.mapArrayOrNot)(f,I),uri:k,preview:{text:d.preview.text,matches:(0,c.mapArrayOrNot)(h,I)}}}e.createTextSearchResult=P;function S(k){return new u.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function I(k){return new R.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let L=class{constructor(v,T){this.a=v,this.b=T}appendLine(v){this.b.debug(`${this.a}#search`,v)}};L=qe([We(1,A.ILogService)],L),e.OutputChannel=L}),define(ye[303],De([1,0,46,10,85,33,12,8,100,304]),function(ne,e,c,A,u,R,C,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const L=I.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(p,y,b,i){const o=v(p,y,b,i),s=y.folder.fsPath;return{cmd:c.spawn(L,o.args,{cwd:s}),rgDiskPath:L,siblingClauses:o.siblingClauses,rgArgs:o,cwd:s}}e.spawnRipgrepCmd=k;function v(p,y,b,i){const o=["--files","--hidden","--case-sensitive"];E([y],b,!1).forEach(l=>{const r=(0,S.anchorGlob)(l);if(o.push("-g",r),C.isMacintosh){const m=(0,u.normalizeNFD)(r);m!==r&&o.push("-g",m)}});const s=T([y],i,void 0,!1);return s.globArgs.forEach(l=>{const r=`!${(0,S.anchorGlob)(l)}`;if(o.push("-g",r),C.isMacintosh){const m=(0,u.normalizeNFD)(r);m!==r&&o.push("-g",m)}}),y.disregardIgnoreFiles!==!1?o.push("--no-ignore"):y.disregardParentIgnoreFiles!==!1&&o.push("--no-ignore-parent"),y.ignoreSymlinks||o.push("--follow"),p.exists&&o.push("--quiet"),o.push("--no-config"),y.disregardGlobalIgnoreFiles&&o.push("--no-ignore-global"),{args:o,siblingClauses:s.siblingClauses}}function T(p,y,b,i=!0){const o=[];let s={};return p.forEach(l=>{const r=Object.assign({},l.excludePattern||{},y||{}),m=f(r,i?l.folder.fsPath:void 0,b);o.push(...m.globArgs),m.siblingClauses&&(s=Object.assign(s,m.siblingClauses))}),{globArgs:o,siblingClauses:s}}function E(p,y,b=!0){const i=[];return p.forEach(o=>{const s=Object.assign({},y||{},o.includePattern||{}),l=f(s,b?o.folder.fsPath:void 0);i.push(...l.globArgs)}),i}function f(p,y,b){const i=[],o={};return Object.keys(p).forEach(s=>{if(b&&b.has(s)||!s)return;const l=p[s];s=h(y?d(y,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof l=="boolean"&&l?(s.startsWith("\\\\")&&(s+="**"),i.push(g(s))):l&&l.when&&(o[s]=l)}),{globArgs:i,siblingClauses:o}}function d(p,y){return A.isAbsolute(y)?y:A.join(p,y)}e.getAbsoluteGlob=d;function h(p){return p=P.rtrim(p,"\\"),P.rtrim(p,"/")}function g(p){return R.getRoot(p).toLowerCase()==="c:/"?p.replace(/^c:[/\\]/i,"/"):p}e.fixDriveC=g}),define(ye[305],De([1,0,46,70,10,306,15,45,38,85,33,12,43,8,9,29,31,303,111]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,f,d,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const p=new Set;process.on("exit",()=>{p.forEach(s=>s())});class y{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&S.parse(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,g.prepareQuery)(this.b).normalizedLowercase),this.u=l.excludePattern&&S.parse(l.excludePattern),this.t=new Map,l.folderQueries.forEach(r=>{const m=Object.assign({},r.excludePattern||{},this.a.excludePattern||{}),n=r.folder.fsPath;l.folderQueries.map(t=>t.folder.fsPath).filter(t=>t!==n).forEach(t=>{(0,L.isEqualOrParent)(t,n)&&(m[u.relative(n,t)]=!0)}),this.t.set(n,new i(m,n))})}cancel(){this.l=!0,p.forEach(l=>l())}walk(l,r,m,n,t){if(this.m=v.StopWatch.create(!1),this.l)return t(null,this.j);r.forEach(a=>{const w=u.basename(a.fsPath);this.u&&this.u(a.fsPath,w)||this.J(m,{relativePath:a.fsPath,searchPath:void 0})}),this.r=v.StopWatch.create(!1),this.w(l,(a,w)=>{this.x(this.y,this,a,m,n,D=>{if(D){const F=(0,P.toErrorMessage)(D);console.error(F),this.q.push(F),w(D,void 0)}else w(null,void 0)})},(a,w)=>{this.m.stop();const D=a?C.coalesce(a)[0]:null;t(D,this.j)})}w(l,r,m){const n=new Array(l.length),t=new Array(l.length);let a=!1,w=0;if(l.length===0)return m(null,[]);l.forEach((D,F)=>{r(D,(x,q)=>{if(x?(a=!0,n[F]=null,t[F]=x):(n[F]=q,t[F]=null),++w===l.length)return m(a?t:null,n)})})}x(l,r,...m){try{l.apply(r,m)}catch(n){m[m.length-1](n)}}y(l,r,m,n){const t=l.folder.fsPath,a=k.isMacintosh,w=()=>M&&M.kill();p.add(w);let D=z=>{p.delete(w),D=()=>{},n(z)},F="";const x=this.D(),q=(0,h.spawnRipgrepCmd)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression),M=q.cmd,B=!Object.keys(q.siblingClauses).length,O=q.rgArgs.args.map(z=>z.match(/^-/)?z:`'${z}'`).join(" ");let U=`${q.rgDiskPath} ${O}
 - cwd: ${q.cwd}`;q.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(q.rgArgs.siblingClauses)}`),m({message:U}),this.s=0,this.z(M,"utf8",m,(z,j,de)=>{if(z){D(z);return}if(this.j){D();return}const X=(F+(a?I.normalizeNFC(j||""):j)).split(`
`);if(de){const J=X.length;X[J-1]=X[J-1].trim(),X[J-1]||X.pop()}else F=X.pop()||"";if(X.length&&X[0].indexOf(`
`)!==-1){D(new Error("Splitting up files failed"));return}if(this.s+=X.length,B){for(const J of X)if(this.J(r,{base:t,relativePath:J,searchPath:this.N(l,J)}),this.j){w();break}(de||this.j)&&D();return}this.G(l,x,t,X,r),de&&(this.H(x,t,r),D())})}spawnFindCmd(l){const r=this.t.get(l.folder.fsPath),m=r.getBasenameTerms(),n=r.getPathTerms(),t=["-L","."];if(m.length||n.length){t.push("-not","(","(");for(const a of m)t.push("-name",a),t.push("-o");for(const a of n)t.push("-path",a),t.push("-o");t.pop(),t.push(")","-prune",")")}return t.push("-type","f"),c.spawn("find",t,{cwd:l.folder.fsPath})}readStdout(l,r,m){let n="";this.z(l,r,()=>{},(t,a,w)=>{if(t){m(t);return}n+=a,w&&m(null,n)})}z(l,r,m,n){let t=(D,F,x)=>{(D||x)&&(t=()=>{},this.r?.stop()),n(D,F,x)},a=!1;l.stdout?(this.A(l.stdout,r,t),l.stdout.once("data",()=>a=!0)):m({message:"stdout is null"});let w;l.stderr?w=this.B(l.stderr):m({message:"stderr is null"}),l.on("error",D=>{t(D)}),l.on("close",D=>{let F;!a&&(F=this.C(w,r))&&o(F)?t(new Error(`command failed with error code ${D}: ${this.C(w,r)}`)):(this.g&&D===0&&(this.j=!0),t(null,"",!0))})}A(l,r,m){const n=new R.StringDecoder(r);return l.on("data",t=>{m(null,n.write(t))}),n}B(l){const r=[];return l.on("data",m=>{r.push(m)}),r}C(l,r){const m=new R.StringDecoder(r);return l.map(n=>m.write(n)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:r},m,n,t){n.indexOf(this.b)!==-1&&this.J(t,{base:m,relativePath:this.b,searchPath:this.N(l,this.b)});const a=w=>{const D=u.basename(w),F=u.dirname(w);let x=r[F];x||(x=r[F]=[],a(F)),x.push({base:m,relativePath:w,basename:D,searchPath:this.N(l,w)})};n.forEach(a)}H({rootEntries:l,pathToEntries:r},m,n){const t=this,a=this.t.get(m),w=this.b;function D(F){t.o++;const x=(0,d.hasSiblingFn)(()=>F.map(q=>q.basename));for(let q=0,M=F.length;q<M;q++){const B=F[q],{relativePath:O,basename:U}=B;if(a.test(O,U,w!==U?x:void 0))continue;const z=r[O];if(z)D(z);else{if(t.p++,O===w)continue;t.J(n,B)}if(t.j)break}}D(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,r,m,n,t){const a=l.folder,w=(0,d.hasSiblingFn)(()=>m);this.w(m,(D,F)=>{if(this.l||this.j)return F(null);const x=r?[r,D].join(u.sep):D;if(this.t.get(l.folder.fsPath).test(x,D,this.a.filePattern!==D?w:void 0))return F(null);const q=[a.fsPath,x].join(u.sep);A.lstat(q,(M,B)=>{if(M||this.l||this.j)return F(null);this.L(q,B,(O,U)=>O||this.l||this.j?F(null):U.isDirectory()?(this.o++,this.M(q,B,(z,j)=>z||this.l||this.j||(j=j||"",this.v[j])?F(null):(this.v[j]=!0,f.Promises.readdir(q).then(de=>{if(this.l||this.j)return F(null);this.I(l,x,de,n,V=>F(V||null))},de=>{F(null)})))):(this.p++,x===this.b||this.h&&E.isNumber(U.size)&&U.size>this.h||this.J(n,{base:a.fsPath,relativePath:x,searchPath:this.N(l,x)}),F(null,void 0)))})},D=>{const F=D&&C.coalesce(D);return t(F&&F.length>0?F[0]:void 0)})}J(l,r){this.K(r)&&(!this.d||this.d(r.relativePath,u.basename(r.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(r))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,d.isFilePatternMatch)(l,this.c)}return!0}L(l,r,m){return r.isSymbolicLink()?A.stat(l,m):m(null,r)}M(l,r,m){return r.isSymbolicLink()?A.realpath(l,(n,t)=>n?m(n):m(null,t)):m(null,l)}N(l,r){return l.folderName?u.join(l.folderName,r):r}}e.FileWalker=y;class b{constructor(l){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.c=new y(l)}search(l,r,m){this.c.walk(this.a,this.b,l,r,(n,t)=>{m(n,{limitHit:t,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=b;class i{constructor(l,r){this.expression=l,this.c=r,this.d(l)}d(l){let r,m;Object.keys(l).filter(n=>l[n]).forEach(n=>{u.isAbsolute(n)?(r=r||S.getEmptyExpression(),r[n]=l[n]):(m=m||S.getEmptyExpression(),m[n]=l[n])}),this.a=r&&S.parse(r,{trimForExclusions:!0}),this.b=m&&S.parse(m,{trimForExclusions:!0})}test(l,r,m){return this.b&&this.b(l,r,m)||this.a&&this.a(u.join(this.c,l),r,m)}getBasenameTerms(){const l=[];return this.a&&l.push(...S.getBasenameTerms(this.a)),this.b&&l.push(...S.getBasenameTerms(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...S.getPathTerms(this.a)),this.b&&l.push(...S.getPathTerms(this.b)),l}}function o(s){const l=s.trim().split(`
`),r=l[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return T.uppercaseFirstLetter(l[l.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}}),define(ye[307],De([1,0,103,22]),function(ne,e,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function u(s){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(l=>l===s)}e.isUTFEncoding=u,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const R=512,C=512,P=512*8,S=512*128;var I;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(l,r){super(l),this.decodeStreamErrorKind=r}}e.DecodeStreamError=L;class k{static async create(l){let r;if(l!==e.UTF8)r=(await new Promise((n,t)=>{ne(["@vscode/iconv-lite-umd"],n,t)})).getDecoder(f(l));else{const m=new TextDecoder;r={write(n){return m.decode(n,{stream:!0})},end(){return m.decode()}}}return new k(r)}constructor(l){this.a=l}write(l){return this.a.write(l)}end(){return this.a.end()}}function v(s,l){const r=l.minBytesRequiredForDetection??l.guessEncoding?P:C;return new Promise((m,n)=>{const t=(0,c.newWriteableStream)(q=>q.join("")),a=[];let w=0,D;const F=async()=>{try{const q=await o({buffer:A.VSBuffer.concat(a),bytesRead:w},l.guessEncoding);if(q.seemsBinary&&l.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);q.encoding=await l.overwriteEncoding(q.encoding),D=await k.create(q.encoding);const M=D.write(A.VSBuffer.concat(a).buffer);t.write(M),a.length=0,w=0,m({stream:t,detected:q})}catch(q){x?.dispose(),t.destroy(),n(q)}},x=(0,c.listenStream)(s,{onData:async q=>{D?t.write(D.write(q.buffer)):(a.push(q),w+=q.byteLength,w>=r&&(s.pause(),await F(),setTimeout(()=>s.resume())))},onError:q=>t.error(q),onEnd:async()=>{D||await F(),t.end(D?.end())}})})}e.toDecodeStream=v;async function T(s,l,r){const n=(await new Promise((w,D)=>{ne(["@vscode/iconv-lite-umd"],w,D)})).getEncoder(f(l),r);let t=!1,a=!1;return{read(){if(a)return null;const w=s.read();if(typeof w!="string"){if(a=!0,!t&&r?.addBOM)switch(l){case e.UTF8:case e.UTF8_with_bom:return A.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return A.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return A.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const D=n.end();return D&&D.length>0?(t=!0,A.VSBuffer.wrap(D)):null}return t=!0,A.VSBuffer.wrap(n.write(w))}}}e.toEncodeReadable=T;async function E(s){return(await new Promise((r,m)=>{ne(["@vscode/iconv-lite-umd"],r,m)})).encodingExists(f(s))}e.encodingExists=E;function f(s){return s===e.UTF8_with_bom||s===null?e.UTF8:s}e.toNodeEncoding=f;function d(s,l){if(!s||l<e.UTF16be_BOM.length)return null;const r=s.readUInt8(0),m=s.readUInt8(1);if(r===e.UTF16be_BOM[0]&&m===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&m===e.UTF16le_BOM[1])return e.UTF16le;if(l<e.UTF8_BOM.length)return null;const n=s.readUInt8(2);return r===e.UTF8_BOM[0]&&m===e.UTF8_BOM[1]&&n===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=d;const h=["ascii","utf-16","utf-32"];async function g(s){const l=await new Promise((a,w)=>{ne(["jschardet"],a,w)}),r=s.slice(0,S),m=b(r.buffer),n=l.detect(m);if(!n||!n.encoding)return null;const t=n.encoding.toLowerCase();return 0<=h.indexOf(t)?null:y(n.encoding)}const p={ibm866:"cp866",big5:"cp950"};function y(s){const l=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return p[l]||l}function b(s){let l="";for(let r=0;r<s.length;r++)l+=String.fromCharCode(s[r]);return l}function i(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const l=s.match(/windows(\d+)/);return l?"windows-"+l[1]:s}}}e.toCanonicalName=i;function o({buffer:s,bytesRead:l},r){let m=d(s,l),n=!1;if(m!==e.UTF16be&&m!==e.UTF16le&&s){let t=!0,a=!0,w=!1;for(let D=0;D<l&&D<R;D++){const F=D%2===1,x=s.readUInt8(D)===0;if(x&&(w=!0),t&&(F&&!x||!F&&x)&&(t=!1),a&&(F&&x||!F&&!x)&&(a=!1),x&&!t&&!a)break}w&&(t?m=e.UTF16le:a?m=e.UTF16be:n=!0)}return r&&!n&&!m&&s?g(s.slice(0,l)).then(t=>({seemsBinary:!1,encoding:t})):{seemsBinary:n,encoding:m}}e.detectEncodingFromBuffer=o,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ye[144],De([1,0,307,29,143]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class R extends u.TextSearchManager{constructor(P,S,I=A,L="searchProcess"){super(P,S,{readdir:k=>I.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,c.toCanonicalName)(k)},L)}}e.NativeTextSearchManager=R}),define(ye[308],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class c{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(u){if(u&&this.a.has(u)){const R=this.a.get(u);return this.a.delete(u),R}}addDragOperationTransfer(u,R){this.a.set(u,R)}getRenderedTreeElement(u){if(this.b.has(u))return this.b.get(u)}addRenderedTreeItemElement(u,R){this.b.set(u,R)}removeRenderedTreeItemElement(u){this.b.has(u)&&this.b.delete(u)}}e.TreeviewsService=c}),define(ye[309],De([1,0,183,7,24,2,3,6,225,19,7,9,15,14,21,308,27]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(y,b){if((0,k.isString)(y))return{label:y};if(y&&typeof y=="object"&&typeof y.label=="string"){let i;return Array.isArray(y.highlights)&&(i=y.highlights.filter(o=>o.length===2&&typeof o[0]=="number"&&typeof o[1]=="number"),i=i.length?i:void 0),{label:y.label,highlights:i}}}class g{constructor(b,i,o){this.d=b,this.e=i,this.f=o,this.a=new Map,this.b=new f.TreeviewsService;function s(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:l=>s(l)?this.i(l):Array.isArray(l)&&l.length>0?l.map(r=>s(r)?this.i(r):r):l})}registerTreeDataProvider(b,i,o){const s=this.createTreeView(b,{treeDataProvider:i},o);return{dispose:()=>s.dispose()}}createTreeView(b,i,o){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=i.dragAndDropController?.dropMimeTypes??[],l=i.dragAndDropController?.dragMimeTypes??[],r=!!i.dragAndDropController?.handleDrag,m=!!i.dragAndDropController?.handleDrop,n=this.h(b,i,o),t=this.d.$registerTreeViewDataProvider(b,{showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:s,dragMimeTypes:l,hasHandleDrag:r,hasHandleDrop:m});return{get onDidCollapseElement(){return n.onDidCollapseElement},get onDidExpandElement(){return n.onDidExpandElement},get selection(){return n.selectedElements},get onDidChangeSelection(){return n.onDidChangeSelection},get visible(){return n.visible},get onDidChangeVisibility(){return n.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,d.checkProposedApiEnabled)(o,"treeItemCheckbox"),n.onDidChangeCheckboxState},get message(){return n.message},set message(a){n.message=a},get title(){return n.title},set title(a){n.title=a},get description(){return n.description},set description(a){n.description=a},get badge(){return n.badge},set badge(a){a!==void 0&&L.ViewBadge.isViewBadge(a)?n.badge={value:Math.floor(Math.abs(a.value)),tooltip:a.tooltip}:a===void 0&&(n.badge=void 0)},reveal:(a,w)=>n.reveal(a,w),dispose:async()=>{await t,this.a.delete(b),n.dispose()}}}$getChildren(b,i){const o=this.a.get(b);return o?o.getChildren(i):Promise.reject(new S.NoTreeViewError(b))}async $handleDrop(b,i,o,s,l,r,m,n){const t=this.a.get(b);if(!t)return Promise.reject(new S.NoTreeViewError(b));const a=T.DataTransfer.toDataTransfer(o,async w=>(await this.d.$resolveDropFileData(b,i,w)).buffer);return m===b&&n&&await this.g(a,t,n,l,r),t.onDrop(a,s,l)}async g(b,i,o,s,l){const r=this.b.removeDragOperationTransfer(l);if(r)(await r)?.forEach((m,n)=>{m&&b.set(n,m)});else if(l&&i.handleDrag){const m=i.handleDrag(o,b,s);this.b.addDragOperationTransfer(l,m),await m}return b}async $handleDrag(b,i,o,s){const l=this.a.get(b);if(!l)return Promise.reject(new S.NoTreeViewError(b));const r=await this.g(new A.DataTransfer,l,i,s,o);if(!!r)return T.DataTransfer.toDataTransferDTO(r)}async $hasResolve(b){const i=this.a.get(b);if(!i)throw new S.NoTreeViewError(b);return i.hasResolve}$resolve(b,i,o){const s=this.a.get(b);if(!s)throw new S.NoTreeViewError(b);return s.resolveTreeItem(i,o)}$setExpanded(b,i,o){const s=this.a.get(b);if(!s)throw new S.NoTreeViewError(b);s.setExpanded(i,o)}$setSelection(b,i){const o=this.a.get(b);if(!o)throw new S.NoTreeViewError(b);o.setSelection(i)}$setFocus(b,i){const o=this.a.get(b);if(!o)throw new S.NoTreeViewError(b);o.setFocus(i)}$setVisible(b,i){const o=this.a.get(b);if(!o)throw new S.NoTreeViewError(b);o.setVisible(i)}$changeCheckboxState(b,i){const o=this.a.get(b);if(!o)throw new S.NoTreeViewError(b);o.setCheckboxState(i)}h(b,i,o){const s=new p(b,i,this.d,this.e.converter,this.f,o);return this.a.set(b,s),s}i(b){const i=this.a.get(b.$treeViewId);return i&&"$treeItemHandle"in b?i.getExtensionElement(b.$treeItemHandle):i&&"$focusedTreeItem"in b&&b.$focusedTreeItem?i.focusedElement:null}}e.ExtHostTreeViews=g;class p extends P.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(b=>this.getExtensionElement(b)).filter(b=>!(0,k.isUndefinedOrNull)(b))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(b,i,o,s,l,r){if(super(),this.C=b,this.D=o,this.F=s,this.G=l,this.H=r,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new C.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new C.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new C.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new C.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new C.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new C.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new E.CancellationTokenSource,r.contributes&&r.contributes.views)for(const t in r.contributes.views)for(const a of r.contributes.views[t])a.id===b&&(this.J=a.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(t=>this.w.fire({message:!1,element:t})));let m,n;this.B(C.Event.debounce(this.w.event,(t,a)=>(t||(t={message:!1,elements:[]}),a.element!==!1&&(m||(m=new Promise(w=>n=w),this.y=this.y.then(()=>m)),Array.isArray(a.element)?t.elements.push(...a.element):t.elements.push(a.element)),a.message&&(t.message=!0),t),200,!0)(({message:t,elements:a})=>{a.length&&(this.z=this.z.then(()=>{const w=n;return m=null,this.U(a).then(()=>w())})),t&&this.D.$setMessage(this.C,this.I)}))}async getChildren(b){const i=b?this.getExtensionElement(b):void 0;if(b&&!i)return this.G.error(`No tree item with id '${b}' found.`),Promise.resolve([]);let o=this.Q(b);return o||(o=await this.R(i)),o?o.map(s=>s.item):void 0}getExtensionElement(b){return this.i.get(b)}reveal(b,i){i=i||{select:!0,focus:!1};const o=(0,k.isUndefinedOrNull)(i.select)?!0:i.select,s=(0,k.isUndefinedOrNull)(i.focus)?!1:i.focus,l=(0,k.isUndefinedOrNull)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):b?this.y.then(()=>this.N(b)).then(r=>this.P(b,r[r.length-1]).then(m=>this.D.$reveal(this.C,{item:m.item,parentChain:r.map(n=>n.item)},{select:o,focus:s,expand:l})),r=>this.G.error(r)):this.D.$reveal(this.C,void 0,{select:o,focus:s,expand:l})}get message(){return this.I}set message(b){this.I=b,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(b){this.J=b,this.D.$setTitle(this.C,b,this.L)}get description(){return this.L}set description(b){this.L=b,this.D.$setTitle(this.C,this.J,b)}get badge(){return this.M}set badge(b){this.M?.value===b?.value&&this.M?.tooltip===b?.tooltip||(this.M=T.ViewBadge.from(b),this.D.$setBadge(this.C,b))}setExpanded(b,i){const o=this.getExtensionElement(b);o&&(i?this.r.fire(Object.freeze({element:o})):this.s.fire(Object.freeze({element:o})))}setSelection(b){(0,v.equals)(this.l,b)||(this.l=b,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(b){this.m=b}setVisible(b){b!==this.k&&(this.k=b,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(b){const i=(await Promise.all(b.map(async o=>{const s=this.getExtensionElement(o.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:o.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(o=>o!==void 0);i.forEach(o=>{o.treeItem.checkboxState=o.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}),this.v.fire({items:i.map(o=>[o.extensionItem,o.newState])})}async handleDrag(b,i,o){const s=[];for(const l of b){const r=this.getExtensionElement(l);r&&s.push(r)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,i,o),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(b,i,o){const s=i?this.getExtensionElement(i):void 0;if(!(!s&&i||!this.g?.handleDrop))return(0,I.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(s,b,o):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(b,i){if(!this.f.resolveTreeItem)return;const o=this.i.get(b);if(o){const s=this.j.get(o);if(s){const l=await this.f.resolveTreeItem(s.extensionItem,o,i)??s.extensionItem;return this.db(l),s.item.tooltip=this.ab(l.tooltip),s.item.command=this.bb(s.disposableStore,l.command),s.item}}}N(b){return this.O(b).then(i=>i?this.N(i).then(o=>this.P(i,o[o.length-1]).then(s=>(o.push(s),o))):Promise.resolve([]))}O(b){const i=this.j.get(b);return i?Promise.resolve(i.parent?this.i.get(i.parent.item.handle):void 0):(0,I.asPromise)(()=>this.f.getParent(b))}P(b,i){const o=this.j.get(b);return o?Promise.resolve(o):(0,I.asPromise)(()=>this.f.getTreeItem(b)).then(s=>this.gb(b,s,i,!0)).then(s=>this.getChildren(i?i.item.handle:void 0).then(()=>{const l=this.getExtensionElement(s);if(l){const r=this.j.get(l);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${s}`)}))}Q(b){if(b){let i;if(typeof b=="string"){const o=this.getExtensionElement(b);i=o?this.j.get(o):void 0}else i=b;return i&&i.children||void 0}return this.h}async R(b){this.nb(b);const i=new E.CancellationTokenSource(this.S.token);try{const o=b?this.j.get(b):void 0,s=await this.f.getChildren(b);if(i.token.isCancellationRequested)return;const l=await Promise.all((0,v.coalesce)(s||[]).map(async r=>{const m=await this.f.getTreeItem(r);return m&&!i.token.isCancellationRequested?this.Z(r,m,o):null}));return i.token.isCancellationRequested?void 0:(0,v.coalesce)(l)}finally{i.dispose()}}U(b){if(b.some(o=>!o))return this.S.dispose(!0),this.S=new E.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const o=this.W(b);if(o.length)return this.X(o)}return Promise.resolve(void 0)}W(b){const i=new Set,o=b.map(l=>this.j.get(l));for(const l of o)if(l&&!i.has(l.item.handle)){let r=l;for(;r&&r.parent&&o.findIndex(m=>r&&r.parent&&m&&m.item.handle===r.parent.item.handle)===-1;){const m=this.i.get(r.parent.item.handle);r=m?this.j.get(m):void 0}r&&!r.parent&&i.add(l.item.handle)}const s=[];return i.forEach(l=>{const r=this.i.get(l);if(r){const m=this.j.get(r);m&&(!m.parent||!i.has(m.parent.item.handle))&&s.push(l)}}),s}X(b){const i={};return Promise.all(b.map(o=>this.Y(o).then(s=>{s&&(i[o]=s.item)}))).then(()=>Object.keys(i).length?this.D.$refresh(this.C,i):void 0)}Y(b){const i=this.getExtensionElement(b);if(i){const o=this.j.get(i);if(o)return this.nb(i),(0,I.asPromise)(()=>this.f.getTreeItem(i)).then(s=>{if(s){const l=this.eb(i,s,o.parent);return this.lb(i,l,o,o.parent),o.dispose(),l}return null})}return Promise.resolve(null)}Z(b,i,o){const s=this.eb(b,i,o);if(i.id&&this.i.has(s.item.handle))throw new Error((0,c.localize)(0,null,i.id));return this.kb(b,s),this.mb(s,o),s}ab(b){return L.MarkdownString.isMarkdownString(b)?T.MarkdownString.from(b):b}bb(b,i){return i?{...this.F.toInternal(i,b),originalId:i.command}:void 0}cb(b){if(!b.checkboxState)return;let i,o;return typeof b.checkboxState=="number"?i=b.checkboxState:(i=b.checkboxState.state,o=b.checkboxState.tooltip),{isChecked:i===L.TreeItemCheckboxState.Checked,tooltip:o}}db(b){if(!L.TreeItem.isTreeItem(b,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(b,i,o){this.db(i);const s=new P.DisposableStore,l=this.gb(b,i,o),r=this.hb(i);return{item:{handle:l,parentHandle:o?o.item.handle:void 0,label:h(i.label,this.H),description:i.description,resourceUri:i.resourceUri,tooltip:this.ab(i.tooltip),command:this.bb(s,i.command),contextValue:i.contextValue,icon:r,iconDark:this.ib(i)||r,themeIcon:this.fb(i),collapsibleState:(0,k.isUndefinedOrNull)(i.collapsibleState)?L.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.cb(i)},extensionItem:i,parent:o,children:void 0,disposableStore:s,dispose(){s.dispose()}}}fb(b){return b.iconPath instanceof L.ThemeIcon?b.iconPath:void 0}gb(b,{id:i,label:o,resourceUri:s},l,r){if(i)return`${p.b}/${i}`;const m=h(o,this.H),n=l?l.item.handle:p.a;let t=m?m.label:s?(0,u.basename)(s):"";t=t.indexOf("/")!==-1?t.replace("/","//"):t;const a=this.j.has(b)?this.j.get(b).item.handle:void 0,w=this.Q(l)||[];let D,F=0;do{if(D=`${n}/${F}:${t}`,r||!this.i.has(D)||a===D)break;F++}while(F<=w.length);return D}hb(b){if(b.iconPath&&!(b.iconPath instanceof L.ThemeIcon))return typeof b.iconPath=="string"||R.URI.isUri(b.iconPath)?this.jb(b.iconPath):this.jb(b.iconPath.light)}ib(b){if(b.iconPath&&!(b.iconPath instanceof L.ThemeIcon)&&b.iconPath.dark)return this.jb(b.iconPath.dark)}jb(b){return R.URI.isUri(b)?b:R.URI.file(b)}kb(b,i){this.i.set(i.item.handle,b),this.j.set(b,i)}lb(b,i,o,s){this.i.delete(i.item.handle),this.j.delete(b),i.item.handle!==o.item.handle&&this.i.delete(o.item.handle),this.kb(b,i);const l=this.Q(s)||[],r=l.filter(m=>m.item.handle===o.item.handle)[0];r&&l.splice(l.indexOf(r),1,i)}mb(b,i){i?(i.children||(i.children=[]),i.children.push(b)):(this.h||(this.h=[]),this.h.push(b))}nb(b){if(b){const i=this.j.get(b);if(i){if(i.children)for(const o of i.children){const s=this.i.get(o.item.handle);s&&this.ob(s)}i.children=void 0}}else this.pb()}ob(b){const i=this.j.get(b);if(i){if(i.children)for(const o of i.children){const s=this.i.get(o.item.handle);s&&this.ob(s)}this.j.delete(b),this.i.delete(i.item.handle),i.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(b=>b.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}p.a="0",p.b="1"}),define(ye[310],De([1,0,21,11,3,37,2,121,107,153,164,44,5,95,252,251,40,253,35,255,256,257,240,258,59,42,259,260,263,264,265,142,243,271,272,273,99,41,275,309,14,7,73,278,79,141,34,232,262,72,139,81,83,84,13,56,20,25,266,239,55,76,249,276,78,77,281,279,280,250,48,274,277,98,60,96,267,80,268,18,125,242,221,261,6,27,226,97,217,269,270]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,f,d,h,g,p,y,b,i,o,s,l,r,m,n,t,a,w,D,F,x,q,M,B,O,U,z,j,de,V,X,J,te,ee,Q,Y,ie,pe,ve,ke,Oe,oe,ae,fe,Z,le,re,N,H,K,_,he,we,Ae,be,Ce,Te,Ve,xe,et,Qe,nt,st,ht,Ue,rt,ce,$,ue,Ie,Le,$e,Ke,Ze,pt,gt,ct){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Et(tt){const ft=tt.get(fe.IExtHostInitDataService),At=tt.get(Te.IExtHostFileSystemInfo),Kt=tt.get(he.IExtHostConsumerFileSystem),Rt=tt.get(l.IExtHostExtensionService),mt=tt.get(te.IExtHostWorkspace),Tt=tt.get(nt.IExtHostTelemetry),$t=tt.get(g.IExtHostConfiguration),Nt=tt.get(oe.IURITransformerService),Xe=tt.get(ae.IExtHostRpcService),Mt=tt.get(M.IExtHostStorage),Ut=tt.get(_.IExtensionStoragePaths),Wt=tt.get(Oe.ILoggerService),bt=tt.get(Oe.ILogService),Re=tt.get(re.IExtHostTunnelService),Ne=tt.get(N.IExtHostApiDeprecationService),Se=tt.get(J.IExtHostWindow),se=tt.get(et.IExtHostSecretState),Fe=tt.get(Qe.IExtHostEditorTabs);Xe.set(v.ExtHostContext.ExtHostFileSystemInfo,At),Xe.set(v.ExtHostContext.ExtHostLogLevelServiceShape,Wt),Xe.set(v.ExtHostContext.ExtHostWorkspace,mt),Xe.set(v.ExtHostContext.ExtHostConfiguration,$t),Xe.set(v.ExtHostContext.ExtHostExtensionService,Rt),Xe.set(v.ExtHostContext.ExtHostStorage,Mt),Xe.set(v.ExtHostContext.ExtHostTunnelService,Re),Xe.set(v.ExtHostContext.ExtHostWindow,Se),Xe.set(v.ExtHostContext.ExtHostSecretState,se),Xe.set(v.ExtHostContext.ExtHostTelemetry,Tt),Xe.set(v.ExtHostContext.ExtHostEditorTabs,Fe);const He=Xe.set(v.ExtHostContext.ExtHostDecorations,tt.get(ie.IExtHostDecorations)),_e=Xe.set(v.ExtHostContext.ExtHostDocumentsAndEditors,tt.get(s.IExtHostDocumentsAndEditors)),je=Xe.set(v.ExtHostContext.ExtHostCommands,tt.get(d.IExtHostCommands)),it=Xe.set(v.ExtHostContext.ExtHostTerminalService,tt.get(B.IExtHostTerminalService)),lt=Xe.set(v.ExtHostContext.ExtHostDebugService,tt.get(ve.IExtHostDebugService)),Pt=Xe.set(v.ExtHostContext.ExtHostSearch,tt.get(ke.IExtHostSearch)),St=Xe.set(v.ExtHostContext.ExtHostTask,tt.get(pe.IExtHostTask)),yt=Xe.set(v.ExtHostContext.ExtHostOutputService,tt.get(w.IExtHostOutputService)),kt=Xe.set(v.ExtHostContext.ExtHostLocalization,tt.get(Ze.IExtHostLocalizationService)),Dt=Xe.set(v.ExtHostContext.ExtHostUrls,new V.ExtHostUrls(Xe)),Ct=Xe.set(v.ExtHostContext.ExtHostDocuments,new o.ExtHostDocuments(Xe,_e)),qt=Xe.set(v.ExtHostContext.ExtHostDocumentContentProviders,new b.ExtHostDocumentContentProvider(Xe,_e,bt)),Jt=Xe.set(v.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(bt,Ct,Xe.getProxy(v.MainContext.MainThreadBulkEdits))),wt=Xe.set(v.ExtHostContext.ExtHostNotebook,new Z.ExtHostNotebookController(Xe,je,_e,Ct)),si=Xe.set(v.ExtHostContext.ExtHostNotebookDocuments,new ue.ExtHostNotebookDocuments(wt)),oi=Xe.set(v.ExtHostContext.ExtHostNotebookEditors,new $.ExtHostNotebookEditors(bt,wt)),Zt=Xe.set(v.ExtHostContext.ExtHostNotebookKernels,new st.ExtHostNotebookKernels(Xe,ft,wt,je,bt)),bi=Xe.set(v.ExtHostContext.ExtHostNotebookRenderers,new Ue.ExtHostNotebookRenderers(Xe,wt)),Lt=Xe.set(v.ExtHostContext.ExtHostEditors,new O.ExtHostEditors(Xe,_e)),Ht=Xe.set(v.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(Xe.getProxy(v.MainContext.MainThreadTreeViews),je,bt)),vi=Xe.set(v.ExtHostContext.ExtHostEditorInsets,new ee.ExtHostEditorInsets(Xe.getProxy(v.MainContext.MainThreadEditorInsets),Lt,ft.remote)),ai=Xe.set(v.ExtHostContext.ExtHostDiagnostics,new p.ExtHostDiagnostics(Xe,bt,At,_e)),ei=Xe.set(v.ExtHostContext.ExtHostLanguages,new t.ExtHostLanguages(Xe,Ct,je.converter,Nt)),ut=Xe.set(v.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Xe,Nt,Ct,je,ai,bt,Ne,Tt)),Bi=Xe.set(v.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(Xe,ut)),Bt=Xe.set(v.ExtHostContext.ExtHostFileSystemEventService,new m.ExtHostFileSystemEventService(Xe,bt,_e)),Qt=Xe.set(v.ExtHostContext.ExtHostQuickOpen,(0,F.createExtHostQuickOpen)(Xe,mt,je)),ci=Xe.set(v.ExtHostContext.ExtHostSCM,new x.ExtHostSCM(Xe,je,bt)),wi=Xe.set(v.ExtHostContext.ExtHostQuickDiff,new ct.ExtHostQuickDiff(Xe,Nt)),Ei=Xe.set(v.ExtHostContext.ExtHostComments,(0,h.createExtHostComments)(Xe,je,Ct)),li=Xe.set(v.ExtHostContext.ExtHostProgress,new D.ExtHostProgress(Xe.getProxy(v.MainContext.MainThreadProgress))),Si=Xe.set(v.ExtHostContext.ExtHosLabelService,new Q.ExtHostLabelService(Xe)),ui=Xe.set(v.ExtHostContext.ExtHostTheming,new le.ExtHostTheming(Xe)),ti=Xe.set(v.ExtHostContext.ExtHostAuthentication,new H.ExtHostAuthentication(Xe)),$i=Xe.set(v.ExtHostContext.ExtHostTimeline,new K.ExtHostTimeline(Xe,je)),ii=Xe.set(v.ExtHostContext.ExtHostWebviews,new X.ExtHostWebviews(Xe,ft.remote,mt,bt,Ne)),ni=Xe.set(v.ExtHostContext.ExtHostWebviewPanels,new be.ExtHostWebviewPanels(Xe,ii,mt)),yi=Xe.set(v.ExtHostContext.ExtHostCustomEditors,new Ae.ExtHostCustomEditors(Xe,Ct,Ut,ii,ni)),Di=Xe.set(v.ExtHostContext.ExtHostWebviewViews,new we.ExtHostWebviewViews(Xe,ii)),ri=Xe.set(v.ExtHostContext.ExtHostTesting,new Ve.ExtHostTesting(Xe,je,_e)),Ci=Xe.set(v.ExtHostContext.ExtHostUriOpeners,new xe.ExtHostUriOpeners(Xe)),Ii=Xe.set(v.ExtHostContext.ExtHostProfileContentHandlers,new gt.ExtHostProfileContentHandlers(Xe));Xe.set(v.ExtHostContext.ExtHostInteractive,new Ie.ExtHostInteractive(Xe,wt,_e,je,bt));const zi=Object.values(v.ExtHostContext);Xe.assertRegistered(zi);const Wi=new Ce.ExtHostBulkEdits(Xe,_e),Hi=new f.ExtHostClipboard(Xe),ki=new a.ExtHostMessageService(Xe,bt),Ri=new y.ExtHostDialogs(Xe),Li=new q.ExtHostStatusBar(Xe,je.converter);return E.ExtHostApiCommands.register(je),function(ze,jt,Oi){const vt=function(){let ge=!ze.isUnderDevelopment;function Ee(){ge||(bt.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Me(ot){if(Array.isArray(ot))ot.forEach(Me);else if(typeof ot=="string")Ee();else{const It=ot;typeof It.scheme>"u"&&Ee(),typeof It.exclusive=="boolean"&&(0,$e.checkProposedApiEnabled)(ze,"documentFiltersExclusive")}return ot}}(),ji={getSession(ge,Ee,Me){return ti.getSession(ze,ge,Ee,Me)},async hasSession(ge,Ee){return(0,$e.checkProposedApiEnabled)(ze,"authSession"),!!await ti.getSession(ze,ge,Ee,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(ge,Ee,Me,ot){return ti.registerAuthenticationProvider(ge,Ee,Me,ot)}},di={registerCommand(ge,Ee,Me){return je.registerCommand(!0,ge,Ee,Me,void 0,ze)},registerTextEditorCommand(ge,Ee,Me){return je.registerCommand(!0,ge,(...ot)=>{const It=Lt.getActiveTextEditor();if(!It){bt.warn("Cannot execute "+ge+" because there is no active text editor.");return}return It.edit(Ot=>{Ee.apply(Me,[It,Ot,...ot])}).then(Ot=>{Ot||bt.warn("Edits from command "+ge+" were not applied.")},Ot=>{bt.warn("An error occurred while running command "+ge,Ot)})},void 0,void 0,ze)},registerDiffInformationCommand:(ge,Ee,Me)=>((0,$e.checkProposedApiEnabled)(ze,"diffCommand"),je.registerCommand(!0,ge,async(...ot)=>{const It=_e.activeEditor(!0);if(!It){bt.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Ot=await Lt.getDiffInformation(It.id);Ee.apply(Me,[Ot,...ot])},void 0,void 0,ze)),executeCommand(ge,...Ee){return je.executeCommand(ge,...Ee)},getCommands(ge=!1){return je.getCommands(ge)}},Ni={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return Hi.value},get shell(){return it.getDefaultShell(!1)},get onDidChangeShell(){return(0,$e.checkProposedApiEnabled)(ze,"envShellEvent"),it.onDidChangeShell},get isTelemetryEnabled(){return Tt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Tt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,$e.checkProposedApiEnabled)(ze,"telemetry"),Tt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,$e.checkProposedApiEnabled)(ze,"telemetry"),Tt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,nt.isNewAppInstall)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge){return nt.ExtHostTelemetryLogger.validateSender(ge),Tt.instantiateLogger(ze,ge)},openExternal(ge,Ee){return Se.openUri(ge,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===ft.environment.appUriScheme)return Dt.createAppUri(ge);try{return await Se.asExternalUri(ge,{allowTunneling:!!ft.remote.authority})}catch(Ee){if((0,ce.matchesScheme)(ge,rt.Schemas.http)||(0,ce.matchesScheme)(ge,rt.Schemas.https))return ge;throw Ee}},get remoteName(){return(0,Y.getRemoteName)(ft.remote.authority)},get remoteAuthority(){return(0,$e.checkProposedApiEnabled)(ze,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return bt.getLevel()},get onDidChangeLogLevel(){return bt.onDidChangeLogLevel}};ft.environment.extensionTestsLocationURI||Object.freeze(Ni);const Vi={createTestController(ge,Ee,Me){return ri.createTestController(ze,ge,Ee,Me)},createTestObserver(){return(0,$e.checkProposedApiEnabled)(ze,"testObserver"),ri.createTestObserver()},runTests(ge){return(0,$e.checkProposedApiEnabled)(ze,"testObserver"),ri.runTests(ge)},get onDidChangeTestResults(){return(0,$e.checkProposedApiEnabled)(ze,"testObserver"),ri.onResultsChanged},get testResults(){return(0,$e.checkProposedApiEnabled)(ze,"testObserver"),ri.results}},hi=ft.remote.isRemote?j.ExtensionKind.Workspace:j.ExtensionKind.UI,qi={getExtension(ge,Ee){(0,$e.isProposedApiEnabled)(ze,"extensionsAny")||(Ee=!1);const Me=jt.mine.getExtensionDescription(ge);if(Me)return new l.Extension(Rt,ze.identifier,Me,hi,!1);if(Ee){const ot=jt.all.getExtensionDescription(ge);if(ot)return new l.Extension(Rt,ze.identifier,ot,hi,!0)}},get all(){const ge=[];for(const Ee of jt.mine.getAllExtensionDescriptions())ge.push(new l.Extension(Rt,ze.identifier,Ee,hi,!1));return ge},get allAcrossExtensionHosts(){(0,$e.checkProposedApiEnabled)(ze,"extensionsAny");const ge=new $e.ExtensionIdentifierSet(jt.mine.getAllExtensionDescriptions().map(Me=>Me.identifier)),Ee=[];for(const Me of jt.all.getAllExtensionDescriptions()){const ot=!ge.has(Me.identifier);Ee.push(new l.Extension(Rt,ze.identifier,Me,hi,ot))}return Ee},get onDidChange(){return(0,$e.isProposedApiEnabled)(ze,"extensionsAny")?u.Event.any(jt.mine.onDidChange,jt.all.onDidChange):jt.mine.onDidChange}},Ti={createDiagnosticCollection(ge){return ai.createDiagnosticCollection(ze.identifier,ge)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:ge=>ai.getDiagnostics(ge),getLanguages(){return ei.getLanguages()},setTextDocumentLanguage(ge,Ee){return ei.changeLanguage(ge.uri,Ee)},match(ge,Ee){const Me=Ct.getDocumentData(Ee.uri)?.notebook;return(0,L.score)(z.LanguageSelector.from(ge),Ee.uri,Ee.languageId,!0,Me?.uri,Me?.notebookType)},registerCodeActionsProvider(ge,Ee,Me){return ut.registerCodeActionProvider(ze,vt(ge),Ee,Me)},registerDocumentPasteEditProvider(ge,Ee,Me){return(0,$e.checkProposedApiEnabled)(ze,"documentPaste"),ut.registerDocumentPasteEditProvider(ze,vt(ge),Ee,Me)},registerCodeLensProvider(ge,Ee){return ut.registerCodeLensProvider(ze,vt(ge),Ee)},registerDefinitionProvider(ge,Ee){return ut.registerDefinitionProvider(ze,vt(ge),Ee)},registerDeclarationProvider(ge,Ee){return ut.registerDeclarationProvider(ze,vt(ge),Ee)},registerImplementationProvider(ge,Ee){return ut.registerImplementationProvider(ze,vt(ge),Ee)},registerTypeDefinitionProvider(ge,Ee){return ut.registerTypeDefinitionProvider(ze,vt(ge),Ee)},registerHoverProvider(ge,Ee){return ut.registerHoverProvider(ze,vt(ge),Ee,ze.identifier)},registerEvaluatableExpressionProvider(ge,Ee){return ut.registerEvaluatableExpressionProvider(ze,vt(ge),Ee,ze.identifier)},registerInlineValuesProvider(ge,Ee){return ut.registerInlineValuesProvider(ze,vt(ge),Ee,ze.identifier)},registerDocumentHighlightProvider(ge,Ee){return ut.registerDocumentHighlightProvider(ze,vt(ge),Ee)},registerLinkedEditingRangeProvider(ge,Ee){return ut.registerLinkedEditingRangeProvider(ze,vt(ge),Ee)},registerReferenceProvider(ge,Ee){return ut.registerReferenceProvider(ze,vt(ge),Ee)},registerRenameProvider(ge,Ee){return ut.registerRenameProvider(ze,vt(ge),Ee)},registerDocumentSymbolProvider(ge,Ee,Me){return ut.registerDocumentSymbolProvider(ze,vt(ge),Ee,Me)},registerWorkspaceSymbolProvider(ge){return ut.registerWorkspaceSymbolProvider(ze,ge)},registerDocumentFormattingEditProvider(ge,Ee){return ut.registerDocumentFormattingEditProvider(ze,vt(ge),Ee)},registerDocumentRangeFormattingEditProvider(ge,Ee){return ut.registerDocumentRangeFormattingEditProvider(ze,vt(ge),Ee)},registerOnTypeFormattingEditProvider(ge,Ee,Me,...ot){return ut.registerOnTypeFormattingEditProvider(ze,vt(ge),Ee,[Me].concat(ot))},registerDocumentSemanticTokensProvider(ge,Ee,Me){return ut.registerDocumentSemanticTokensProvider(ze,vt(ge),Ee,Me)},registerDocumentRangeSemanticTokensProvider(ge,Ee,Me){return ut.registerDocumentRangeSemanticTokensProvider(ze,vt(ge),Ee,Me)},registerSignatureHelpProvider(ge,Ee,Me,...ot){return typeof Me=="object"?ut.registerSignatureHelpProvider(ze,vt(ge),Ee,Me):ut.registerSignatureHelpProvider(ze,vt(ge),Ee,typeof Me>"u"?[]:[Me,...ot])},registerCompletionItemProvider(ge,Ee,...Me){return ut.registerCompletionItemProvider(ze,vt(ge),Ee,Me)},registerInlineCompletionItemProvider(ge,Ee){return Ee.handleDidShowCompletionItem&&(0,$e.checkProposedApiEnabled)(ze,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(ze,vt(ge),Ee)},registerDocumentLinkProvider(ge,Ee){return ut.registerDocumentLinkProvider(ze,vt(ge),Ee)},registerColorProvider(ge,Ee){return ut.registerColorProvider(ze,vt(ge),Ee)},registerFoldingRangeProvider(ge,Ee){return ut.registerFoldingRangeProvider(ze,vt(ge),Ee)},registerSelectionRangeProvider(ge,Ee){return ut.registerSelectionRangeProvider(ze,ge,Ee)},registerCallHierarchyProvider(ge,Ee){return ut.registerCallHierarchyProvider(ze,ge,Ee)},registerTypeHierarchyProvider(ge,Ee){return ut.registerTypeHierarchyProvider(ze,ge,Ee)},setLanguageConfiguration:(ge,Ee)=>ut.setLanguageConfiguration(ze,ge,Ee),getTokenInformationAtPosition(ge,Ee){return(0,$e.checkProposedApiEnabled)(ze,"tokenInformation"),ei.tokenAtPosition(ge,Ee)},registerInlayHintsProvider(ge,Ee){return ut.registerInlayHintsProvider(ze,ge,Ee)},createLanguageStatusItem(ge,Ee){return ei.createLanguageStatusItem(ze,ge,Ee)},registerDocumentDropEditProvider(ge,Ee){return ut.registerDocumentOnDropEditProvider(ze,ge,Ee)}},xi={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return it.activeTerminal},get terminals(){return it.terminals},async showTextDocument(ge,Ee,Me){const ot=await(C.URI.isUri(ge)?Promise.resolve(xt.openTextDocument(ge)):Promise.resolve(ge));return Lt.showTextDocument(ot,Ee,Me)},createTextEditorDecorationType(ge){return Lt.createTextEditorDecorationType(ze,ge)},onDidChangeActiveTextEditor(ge,Ee,Me){return Lt.onDidChangeActiveTextEditor(ge,Ee,Me)},onDidChangeVisibleTextEditors(ge,Ee,Me){return Lt.onDidChangeVisibleTextEditors(ge,Ee,Me)},onDidChangeTextEditorSelection(ge,Ee,Me){return Lt.onDidChangeTextEditorSelection(ge,Ee,Me)},onDidChangeTextEditorOptions(ge,Ee,Me){return Lt.onDidChangeTextEditorOptions(ge,Ee,Me)},onDidChangeTextEditorVisibleRanges(ge,Ee,Me){return Lt.onDidChangeTextEditorVisibleRanges(ge,Ee,Me)},onDidChangeTextEditorViewColumn(ge,Ee,Me){return Lt.onDidChangeTextEditorViewColumn(ge,Ee,Me)},onDidCloseTerminal(ge,Ee,Me){return it.onDidCloseTerminal(ge,Ee,Me)},onDidOpenTerminal(ge,Ee,Me){return it.onDidOpenTerminal(ge,Ee,Me)},onDidChangeActiveTerminal(ge,Ee,Me){return it.onDidChangeActiveTerminal(ge,Ee,Me)},onDidChangeTerminalDimensions(ge,Ee,Me){return(0,$e.checkProposedApiEnabled)(ze,"terminalDimensions"),it.onDidChangeTerminalDimensions(ge,Ee,Me)},onDidChangeTerminalState(ge,Ee,Me){return it.onDidChangeTerminalState(ge,Ee,Me)},onDidWriteTerminalData(ge,Ee,Me){return(0,$e.checkProposedApiEnabled)(ze,"terminalDataWriteEvent"),it.onDidWriteTerminalData(ge,Ee,Me)},get state(){return Se.state},onDidChangeWindowState(ge,Ee,Me){return Se.onDidChangeWindowState(ge,Ee,Me)},showInformationMessage(ge,...Ee){return ki.showMessage(ze,R.default.Info,ge,Ee[0],Ee.slice(1))},showWarningMessage(ge,...Ee){return ki.showMessage(ze,R.default.Warning,ge,Ee[0],Ee.slice(1))},showErrorMessage(ge,...Ee){return ki.showMessage(ze,R.default.Error,ge,Ee[0],Ee.slice(1))},showQuickPick(ge,Ee,Me){return Qt.showQuickPick(ge,Ee,Me)},showWorkspaceFolderPick(ge){return Qt.showWorkspaceFolderPick(ge)},showInputBox(ge,Ee){return Qt.showInput(ge,Ee)},showOpenDialog(ge){return Ri.showOpenDialog(ge)},showSaveDialog(ge){return Ri.showSaveDialog(ge)},createStatusBarItem(ge,Ee,Me){let ot,It,Ot;return typeof ge=="string"?(ot=ge,It=Ee,Ot=Me):(It=ge,Ot=Ee),Li.createStatusBarEntry(ze,ot,It,Ot)},setStatusBarMessage(ge,Ee){return Li.setStatusBarMessage(ge,Ee)},withScmProgress(ge){return Ne.report("window.withScmProgress",ze,"Use 'withProgress' instead."),li.withProgress(ze,{location:j.ProgressLocation.SourceControl},(Ee,Me)=>ge({report(ot){}}))},withProgress(ge,Ee){return li.withProgress(ze,ge,Ee)},createOutputChannel(ge,Ee){return yt.createOutputChannel(ge,Ee,ze)},createWebviewPanel(ge,Ee,Me,ot){return ni.createWebviewPanel(ze,ge,Ee,Me,ot)},createWebviewTextEditorInset(ge,Ee,Me,ot){return(0,$e.checkProposedApiEnabled)(ze,"editorInsets"),vi.createWebviewEditorInset(ge,Ee,Me,ot,ze)},createTerminal(ge,Ee,Me){return typeof ge=="object"?"pty"in ge?it.createExtensionTerminal(ge):it.createTerminalFromOptions(ge):it.createTerminal(ge,Ee,Me)},registerTerminalLinkProvider(ge){return it.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,Ee){return it.registerProfileProvider(ze,ge,Ee)},registerTerminalQuickFixProvider(ge,Ee){return(0,$e.checkProposedApiEnabled)(ze,"terminalQuickFixProvider"),it.registerTerminalQuickFixProvider(ge,ze.identifier.value,Ee)},registerTreeDataProvider(ge,Ee){return Ht.registerTreeDataProvider(ge,Ee,ze)},createTreeView(ge,Ee){return Ht.createTreeView(ge,Ee,ze)},registerWebviewPanelSerializer:(ge,Ee)=>ni.registerWebviewPanelSerializer(ze,ge,Ee),registerCustomEditorProvider:(ge,Ee,Me={})=>yi.registerCustomEditorProvider(ze,ge,Ee,Me),registerFileDecorationProvider(ge){return He.registerFileDecorationProvider(ge,ze)},registerUriHandler(ge){return Dt.registerUriHandler(ze.identifier,ge)},createQuickPick(){return Qt.createQuickPick(ze)},createInputBox(){return Qt.createInputBox(ze)},get activeColorTheme(){return ui.activeColorTheme},onDidChangeActiveColorTheme(ge,Ee,Me){return ui.onDidChangeActiveColorTheme(ge,Ee,Me)},registerWebviewViewProvider(ge,Ee,Me){return Di.registerWebviewViewProvider(ze,ge,Ee,Me?.webviewOptions)},get activeNotebookEditor(){return wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,Ee,Me){return wt.onDidChangeActiveNotebookEditor(ge,Ee,Me)},get visibleNotebookEditors(){return wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ge,Ee,Me){return oi.onDidChangeNotebookEditorSelection(ge,Ee,Me)},onDidChangeNotebookEditorVisibleRanges(ge,Ee,Me){return oi.onDidChangeNotebookEditorVisibleRanges(ge,Ee,Me)},showNotebookDocument(ge,Ee){return wt.showNotebookDocument(ge,Ee)},registerExternalUriOpener(ge,Ee,Me){return(0,$e.checkProposedApiEnabled)(ze,"externalUriOpener"),Ci.registerExternalUriOpener(ze.identifier,ge,Ee,Me)},registerProfileContentHandler(ge,Ee){return(0,$e.checkProposedApiEnabled)(ze,"profileContentHandlers"),Ii.registrProfileContentHandler(ze,ge,Ee)},registerQuickDiffProvider(ge,Ee,Me,ot){return(0,$e.checkProposedApiEnabled)(ze,"quickDiffProvider"),wi.registerQuickDiffProvider(vt(ge),Ee,Me,ot)},get tabGroups(){return Fe.tabGroups}},xt={get rootPath(){return Ne.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(ge){throw A.readonly()},getWorkspaceFolder(ge){return mt.getWorkspaceFolder(ge)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(ge){throw A.readonly()},get workspaceFile(){return mt.workspaceFile},set workspaceFile(ge){throw A.readonly()},updateWorkspaceFolders:(ge,Ee,...Me)=>mt.updateWorkspaceFolders(ze,ge,Ee||0,...Me),onDidChangeWorkspaceFolders:function(ge,Ee,Me){return mt.onDidChangeWorkspace(ge,Ee,Me)},asRelativePath:(ge,Ee)=>mt.getRelativePath(ge,Ee),findFiles:(ge,Ee,Me,ot)=>mt.findFiles(ge,Ee,Me,ze.identifier,ot),findTextInFiles:(ge,Ee,Me,ot)=>{(0,$e.checkProposedApiEnabled)(ze,"findTextInFiles");let It,Ot;return typeof Ee=="object"?(It=Ee,Ot=Me):(It={},Ot=Ee,ot=Me),mt.findTextInFiles(ge,It||{},Ot,ze.identifier,ot)},saveAll:ge=>mt.saveAll(ge),applyEdit(ge,Ee){return Wi.applyWorkspaceEdit(ge,ze,Ee)},createFileSystemWatcher:(ge,Ee,Me,ot)=>Bt.createFileSystemWatcher(mt,ze,ge,Ee,Me,ot),get textDocuments(){return Ct.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw A.readonly()},openTextDocument(ge){let Ee;const Me=ge;if(typeof ge=="string")Ee=Promise.resolve(C.URI.file(ge));else if(C.URI.isUri(ge))Ee=Promise.resolve(ge);else if(!Me||typeof Me=="object")Ee=Ct.createDocumentData(Me);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(ot=>Ct.ensureDocumentData(ot).then(It=>It.document))},onDidOpenTextDocument:(ge,Ee,Me)=>Ct.onDidAddDocument(ge,Ee,Me),onDidCloseTextDocument:(ge,Ee,Me)=>Ct.onDidRemoveDocument(ge,Ee,Me),onDidChangeTextDocument:(ge,Ee,Me)=>Ct.onDidChangeDocument(ge,Ee,Me),onDidSaveTextDocument:(ge,Ee,Me)=>Ct.onDidSaveDocument(ge,Ee,Me),onWillSaveTextDocument:(ge,Ee,Me)=>Jt.getOnWillSaveTextDocumentEvent(ze)(ge,Ee,Me),get notebookDocuments(){return wt.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,Ee){let Me;if(C.URI.isUri(ge))Me=ge,await wt.openNotebookDocument(ge);else if(typeof ge=="string")Me=C.URI.revive(await wt.createNotebookDocument({viewType:ge,content:Ee}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(Me).apiNotebook},onDidSaveNotebookDocument(ge,Ee,Me){return si.onDidSaveNotebookDocument(ge,Ee,Me)},onDidChangeNotebookDocument(ge,Ee,Me){return si.onDidChangeNotebookDocument(ge,Ee,Me)},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(ge,Ee,Me,ot){return wt.registerNotebookSerializer(ze,ge,Ee,Me,(0,$e.isProposedApiEnabled)(ze,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(ge,Ee,Me)=>Oi.onDidChangeConfiguration(ge,Ee,Me),getConfiguration(ge,Ee){return Ee=arguments.length===1?void 0:Ee,Oi.getConfiguration(ge,Ee,ze)},registerTextDocumentContentProvider(ge,Ee){return qt.registerTextDocumentContentProvider(ge,Ee)},registerTaskProvider:(ge,Ee)=>(Ne.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider(ze,ge,Ee)),registerFileSystemProvider(ge,Ee,Me){return(0,Le.combinedDisposable)(Bi.registerFileSystemProvider(ze,ge,Ee,Me),Kt.addFileSystemProvider(ge,Ee))},get fs(){return Kt.value},registerFileSearchProvider:(ge,Ee)=>((0,$e.checkProposedApiEnabled)(ze,"fileSearchProvider"),Pt.registerFileSearchProvider(ge,Ee)),registerTextSearchProvider:(ge,Ee)=>((0,$e.checkProposedApiEnabled)(ze,"textSearchProvider"),Pt.registerTextSearchProvider(ge,Ee)),registerRemoteAuthorityResolver:(ge,Ee)=>((0,$e.checkProposedApiEnabled)(ze,"resolvers"),Rt.registerRemoteAuthorityResolver(ge,Ee)),registerResourceLabelFormatter:ge=>((0,$e.checkProposedApiEnabled)(ze,"resolvers"),Si.$registerResourceLabelFormatter(ge)),onDidCreateFiles:(ge,Ee,Me)=>Bt.onDidCreateFile(ge,Ee,Me),onDidDeleteFiles:(ge,Ee,Me)=>Bt.onDidDeleteFile(ge,Ee,Me),onDidRenameFiles:(ge,Ee,Me)=>Bt.onDidRenameFile(ge,Ee,Me),onWillCreateFiles:(ge,Ee,Me)=>Bt.getOnWillCreateFileEvent(ze)(ge,Ee,Me),onWillDeleteFiles:(ge,Ee,Me)=>Bt.getOnWillDeleteFileEvent(ze)(ge,Ee,Me),onWillRenameFiles:(ge,Ee,Me)=>Bt.getOnWillRenameFileEvent(ze)(ge,Ee,Me),openTunnel:ge=>((0,$e.checkProposedApiEnabled)(ze,"tunnels"),Re.openTunnel(ze,ge).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,$e.checkProposedApiEnabled)(ze,"tunnels"),Re.getTunnels()},onDidChangeTunnels:(ge,Ee,Me)=>((0,$e.checkProposedApiEnabled)(ze,"tunnels"),Re.onDidChangeTunnels(ge,Ee,Me)),registerPortAttributesProvider:(ge,Ee)=>((0,$e.checkProposedApiEnabled)(ze,"portsAttributes"),Re.registerPortsAttributesProvider(ge,Ee)),registerTimelineProvider:(ge,Ee)=>((0,$e.checkProposedApiEnabled)(ze,"timeline"),$i.registerTimelineProvider(ge,Ee,ze.identifier,je.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:ge=>((0,$e.checkProposedApiEnabled)(ze,"workspaceTrust"),mt.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,Ee,Me)=>mt.onDidGrantWorkspaceTrust(ge,Ee,Me),registerEditSessionIdentityProvider:(ge,Ee)=>((0,$e.checkProposedApiEnabled)(ze,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(ge,Ee)),onWillCreateEditSessionIdentity:(ge,Ee,Me)=>((0,$e.checkProposedApiEnabled)(ze,"editSessionIdentityProvider"),mt.getOnWillCreateEditSessionIdentityEvent(ze)(ge,Ee,Me))},fi={get inputBox(){return Ne.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),ci.getLastInputBox(ze)},createSourceControl(ge,Ee,Me){return ci.createSourceControl(ze,ge,Ee,Me)}},Gi={createCommentController(ge,Ee){return Ei.createCommentController(ze,ge,Ee)}},zt={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(ge,Ee,Me){return lt.onDidStartDebugSession(ge,Ee,Me)},onDidTerminateDebugSession(ge,Ee,Me){return lt.onDidTerminateDebugSession(ge,Ee,Me)},onDidChangeActiveDebugSession(ge,Ee,Me){return lt.onDidChangeActiveDebugSession(ge,Ee,Me)},onDidReceiveDebugSessionCustomEvent(ge,Ee,Me){return lt.onDidReceiveDebugSessionCustomEvent(ge,Ee,Me)},onDidChangeBreakpoints(ge,Ee,Me){return lt.onDidChangeBreakpoints(ge,Ee,Me)},registerDebugConfigurationProvider(ge,Ee,Me){return lt.registerDebugConfigurationProvider(ge,Ee,Me||Ke.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,Ee){return lt.registerDebugAdapterDescriptorFactory(ze,ge,Ee)},registerDebugAdapterTrackerFactory(ge,Ee){return lt.registerDebugAdapterTrackerFactory(ge,Ee)},startDebugging(ge,Ee,Me){return!Me||typeof Me=="object"&&"configuration"in Me?lt.startDebugging(ge,Ee,{parentSession:Me}):lt.startDebugging(ge,Ee,Me||{})},stopDebugging(ge){return lt.stopDebugging(ge)},addBreakpoints(ge){return lt.addBreakpoints(ge)},removeBreakpoints(ge){return lt.removeBreakpoints(ge)},asDebugSourceUri(ge,Ee){return lt.asDebugSourceUri(ge,Ee)}},mi={registerTaskProvider:(ge,Ee)=>St.registerTaskProvider(ze,ge,Ee),fetchTasks:ge=>St.fetchTasks(ge),executeTask:ge=>St.executeTask(ze,ge),get taskExecutions(){return St.taskExecutions},onDidStartTask:(ge,Ee,Me)=>St.onDidStartTask(ge,Ee,Me),onDidEndTask:(ge,Ee,Me)=>St.onDidEndTask(ge,Ee,Me),onDidStartTaskProcess:(ge,Ee,Me)=>St.onDidStartTaskProcess(ge,Ee,Me),onDidEndTaskProcess:(ge,Ee,Me)=>St.onDidEndTaskProcess(ge,Ee,Me)},Ki={createNotebookController(ge,Ee,Me,ot,It){return Zt.createNotebookController(ze,ge,Ee,Me,ot,(0,$e.isProposedApiEnabled)(ze,"notebookMessaging")?It:void 0)},registerNotebookCellStatusBarItemProvider:(ge,Ee)=>wt.registerNotebookCellStatusBarItemProvider(ze,ge,Ee),createRendererMessaging(ge){return bi.createRendererMessaging(ze,ge)},createNotebookControllerDetectionTask(ge){return(0,$e.checkProposedApiEnabled)(ze,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(ze,ge)},registerKernelSourceActionProvider(ge,Ee){return(0,$e.checkProposedApiEnabled)(ze,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(ze,ge,Ee)},onDidChangeNotebookCellExecutionState(ge,Ee,Me){return(0,$e.checkProposedApiEnabled)(ze,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(ge,Ee,Me)}},Xi={t(...ge){if(typeof ge[0]=="string"){const Ee=ge.shift(),Me=!ge||typeof ge[0]!="object"?ge:ge[0];return kt.getMessage(ze.identifier.value,{message:Ee,args:Me})}return kt.getMessage(ze.identifier.value,ge[0])},get bundle(){return kt.getBundle(ze.identifier.value)},get uri(){return kt.getBundleUri(ze.identifier.value)}};return{version:ft.version,authentication:ji,commands:di,comments:Gi,debug:zt,env:Ni,extensions:qi,l10n:Xi,languages:Ti,notebooks:Ki,scm:fi,tasks:mi,tests:Vi,window:xi,workspace:xt,Breakpoint:j.Breakpoint,TerminalOutputAnchor:j.TerminalOutputAnchor,CallHierarchyIncomingCall:j.CallHierarchyIncomingCall,CallHierarchyItem:j.CallHierarchyItem,CallHierarchyOutgoingCall:j.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:v.CandidatePortSource,CodeAction:j.CodeAction,CodeActionKind:j.CodeActionKind,CodeActionTriggerKind:j.CodeActionTriggerKind,CodeLens:j.CodeLens,Color:j.Color,ColorInformation:j.ColorInformation,ColorPresentation:j.ColorPresentation,ColorThemeKind:j.ColorThemeKind,CommentMode:j.CommentMode,CommentThreadCollapsibleState:j.CommentThreadCollapsibleState,CommentThreadState:j.CommentThreadState,CompletionItem:j.CompletionItem,CompletionItemKind:j.CompletionItemKind,CompletionItemTag:j.CompletionItemTag,CompletionList:j.CompletionList,CompletionTriggerKind:j.CompletionTriggerKind,ConfigurationTarget:j.ConfigurationTarget,CustomExecution:j.CustomExecution,DebugAdapterExecutable:j.DebugAdapterExecutable,DebugAdapterInlineImplementation:j.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:j.DebugAdapterNamedPipeServer,DebugAdapterServer:j.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ke.DebugConfigurationProviderTriggerKind,DebugConsoleMode:j.DebugConsoleMode,DecorationRangeBehavior:j.DecorationRangeBehavior,Diagnostic:j.Diagnostic,DiagnosticRelatedInformation:j.DiagnosticRelatedInformation,DiagnosticSeverity:j.DiagnosticSeverity,DiagnosticTag:j.DiagnosticTag,Disposable:j.Disposable,DocumentHighlight:j.DocumentHighlight,DocumentHighlightKind:j.DocumentHighlightKind,DocumentLink:j.DocumentLink,DocumentSymbol:j.DocumentSymbol,EndOfLine:j.EndOfLine,EnvironmentVariableMutatorType:j.EnvironmentVariableMutatorType,EvaluatableExpression:j.EvaluatableExpression,InlineValueText:j.InlineValueText,InlineValueVariableLookup:j.InlineValueVariableLookup,InlineValueEvaluatableExpression:j.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:j.InlineCompletionTriggerKind,EventEmitter:u.Emitter,ExtensionKind:j.ExtensionKind,ExtensionMode:j.ExtensionMode,ExternalUriOpenerPriority:j.ExternalUriOpenerPriority,FileChangeType:j.FileChangeType,FileDecoration:j.FileDecoration,FileDecoration2:j.FileDecoration,FileSystemError:j.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:j.FoldingRange,FoldingRangeKind:j.FoldingRangeKind,FunctionBreakpoint:j.FunctionBreakpoint,InlineCompletionItem:j.InlineSuggestion,InlineCompletionList:j.InlineSuggestionList,Hover:j.Hover,IndentAction:I.IndentAction,Location:j.Location,MarkdownString:j.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:j.ParameterInformation,PortAutoForwardAction:j.PortAutoForwardAction,Position:j.Position,ProcessExecution:j.ProcessExecution,ProgressLocation:j.ProgressLocation,QuickInputButtons:j.QuickInputButtons,Range:j.Range,RelativePattern:j.RelativePattern,Selection:j.Selection,SelectionRange:j.SelectionRange,SemanticTokens:j.SemanticTokens,SemanticTokensBuilder:j.SemanticTokensBuilder,SemanticTokensEdit:j.SemanticTokensEdit,SemanticTokensEdits:j.SemanticTokensEdits,SemanticTokensLegend:j.SemanticTokensLegend,ShellExecution:j.ShellExecution,ShellQuoting:j.ShellQuoting,SignatureHelp:j.SignatureHelp,SignatureHelpTriggerKind:j.SignatureHelpTriggerKind,SignatureInformation:j.SignatureInformation,SnippetString:j.SnippetString,SourceBreakpoint:j.SourceBreakpoint,StandardTokenType:j.StandardTokenType,StatusBarAlignment:j.StatusBarAlignment,SymbolInformation:j.SymbolInformation,SymbolKind:j.SymbolKind,SymbolTag:j.SymbolTag,Task:j.Task,TaskGroup:j.TaskGroup,TaskPanelKind:j.TaskPanelKind,TaskRevealKind:j.TaskRevealKind,TaskScope:j.TaskScope,TerminalLink:j.TerminalLink,TerminalQuickFixCommand:j.TerminalQuickFixCommand,TerminalQuickFixOpener:j.TerminalQuickFixOpener,TerminalLocation:j.TerminalLocation,TerminalProfile:j.TerminalProfile,TerminalExitReason:j.TerminalExitReason,TerminalQuickFixType:j.TerminalQuickFixType,TextDocumentSaveReason:j.TextDocumentSaveReason,TextEdit:j.TextEdit,SnippetTextEdit:j.SnippetTextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:j.TextEditorLineNumbersStyle,TextEditorRevealType:j.TextEditorRevealType,TextEditorSelectionChangeKind:j.TextEditorSelectionChangeKind,TextDocumentChangeReason:j.TextDocumentChangeReason,ThemeColor:j.ThemeColor,ThemeIcon:j.ThemeIcon,TreeItem:j.TreeItem,TreeItem2:j.TreeItem,TreeItemCheckboxState:j.TreeItemCheckboxState,TreeItemCollapsibleState:j.TreeItemCollapsibleState,TypeHierarchyItem:j.TypeHierarchyItem,UIKind:T.UIKind,Uri:C.URI,ViewColumn:j.ViewColumn,WorkspaceEdit:j.WorkspaceEdit,DocumentDropEdit:j.DocumentDropEdit,DocumentPasteEdit:j.DocumentPasteEdit,InlayHint:j.InlayHint,InlayHintLabelPart:j.InlayHintLabelPart,InlayHintKind:j.InlayHintKind,RemoteAuthorityResolverError:j.RemoteAuthorityResolverError,ResolvedAuthority:j.ResolvedAuthority,SourceControlInputBoxValidationType:j.SourceControlInputBoxValidationType,ExtensionRuntime:j.ExtensionRuntime,TimelineItem:j.TimelineItem,NotebookRange:j.NotebookRange,NotebookCellKind:j.NotebookCellKind,NotebookCellExecutionState:j.NotebookCellExecutionState,NotebookCellData:j.NotebookCellData,NotebookData:j.NotebookData,NotebookRendererScript:j.NotebookRendererScript,NotebookCellStatusBarAlignment:j.NotebookCellStatusBarAlignment,NotebookEditorRevealType:j.NotebookEditorRevealType,NotebookCellOutput:j.NotebookCellOutput,NotebookCellOutputItem:j.NotebookCellOutputItem,NotebookCellStatusBarItem:j.NotebookCellStatusBarItem,NotebookControllerAffinity:j.NotebookControllerAffinity,NotebookControllerAffinity2:j.NotebookControllerAffinity2,NotebookEdit:j.NotebookEdit,NotebookKernelSourceAction:j.NotebookKernelSourceAction,PortAttributes:j.PortAttributes,LinkedEditingRanges:j.LinkedEditingRanges,TestResultState:j.TestResultState,TestRunRequest:j.TestRunRequest,TestRunRequest2:j.TestRunRequest2,TestMessage:j.TestMessage,TestTag:j.TestTag,TestRunProfileKind:j.TestRunProfileKind,TextSearchCompleteMessageType:ht.TextSearchCompleteMessageType,DataTransfer:j.DataTransfer,DataTransferItem:j.DataTransferItem,CoveredCount:j.CoveredCount,FileCoverage:j.FileCoverage,StatementCoverage:j.StatementCoverage,BranchCoverage:j.BranchCoverage,FunctionCoverage:j.FunctionCoverage,WorkspaceTrustState:j.WorkspaceTrustState,LanguageStatusSeverity:j.LanguageStatusSeverity,QuickPickItemKind:j.QuickPickItemKind,InputBoxValidationSeverity:j.InputBoxValidationSeverity,TabInputText:j.TextTabInput,TabInputTextDiff:j.TextDiffTabInput,TabInputTextMerge:j.TextMergeTabInput,TabInputCustom:j.CustomEditorTabInput,TabInputNotebook:j.NotebookEditorTabInput,TabInputNotebookDiff:j.NotebookDiffEditorTabInput,TabInputWebview:j.WebviewEditorTabInput,TabInputTerminal:j.TerminalEditorTabInput,TabInputInteractiveWindow:j.InteractiveWindowInput,TelemetryTrustedValue:de.TelemetryTrustedValue,LogLevel:Oe.LogLevel,EditSessionIdentityMatch:pt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Et}),define(ye[311],De([1,0,283,320,321,2,322]),function(ne,e,c,A,u,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function P(k,v,T,E,f,d){const h=d.environment.useHostProxy,g=typeof h=="boolean"?h:!d.remote.isRemote,p=(0,C.createProxyResolver)({resolveProxy:b=>k.resolveProxy(b),getHttpProxySetting:()=>v.getConfiguration("http").get("proxy"),log:(b,i,...o)=>{switch(b){case C.LogLevel.Trace:E.trace(i,...o);break;case C.LogLevel.Debug:E.debug(i,...o);break;case C.LogLevel.Info:E.info(i,...o);break;case C.LogLevel.Warning:E.warn(i,...o);break;case C.LogLevel.Error:E.error(i,...o);break;case C.LogLevel.Critical:E.error(i,...o);break;case C.LogLevel.Off:break;default:s(b,i,o);break}function s(l,r,...m){E.error("Unknown log level",l),E.error(r,...m)}},getLogLevel:()=>E.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:g,env:process.env}),y=S(v,p);return L(T,y)}e.connectProxyResolver=P;function S(k,v){const T={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(f=>{T.config=k.getConfiguration("http").get("proxySupport")||"off"});const E={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(f=>{E.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},c,(0,C.createHttpPatch)(c,v,{config:"off"},E,!0)),on:Object.assign({},c,(0,C.createHttpPatch)(c,v,{config:"on"},E,!0)),override:Object.assign({},c,(0,C.createHttpPatch)(c,v,{config:"override"},E,!0)),onRequest:Object.assign({},c,(0,C.createHttpPatch)(c,v,T,E,!0)),default:Object.assign(c,(0,C.createHttpPatch)(c,v,T,E,!1))},https:{off:Object.assign({},A,(0,C.createHttpPatch)(A,v,{config:"off"},E,!0)),on:Object.assign({},A,(0,C.createHttpPatch)(A,v,{config:"on"},E,!0)),override:Object.assign({},A,(0,C.createHttpPatch)(A,v,{config:"override"},E,!0)),onRequest:Object.assign({},A,(0,C.createHttpPatch)(A,v,T,E,!0)),default:Object.assign(A,(0,C.createHttpPatch)(A,v,T,E,!1))},tls:Object.assign(u,(0,C.createTlsPatch)(u))}}const I=new Map;function L(k,v){return k.getExtensionPathIndex().then(T=>{const E=globalThis._VSCODE_NODE_MODULES.module,f=E._load;E._load=function(h,g,p){if(h==="tls")return v.tls;if(h!=="http"&&h!=="https")return f.apply(this,arguments);const y=v[h],b=T.findSubstr(R.URI.file(g.filename));let i=I.get(b);if(i||I.set(b,i={}),!i[h]){const o=y.default;i[h]={...o}}return i[h]}})}}),define(ye[312],De([1,0,82,310,297,311,42,285,2,18,7,282,115,284]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class E extends u.RequireInterceptor{j(){const h=this,g=globalThis._VSCODE_NODE_MODULES.module,p=g._load;g._load=function(o,s,l){return o=b(o),h.a.has(o)?h.a.get(o).load(o,S.URI.file((0,v.realpathSync)(s.filename)),r=>p.apply(this,[r,s,l])):p.apply(this,arguments)};const y=g._resolveLookupPaths;g._resolveLookupPaths=(i,o)=>y.call(this,b(i),o);const b=i=>{for(const o of h.b){const s=o(i);if(s){i=s;break}}return i}}}class f extends C.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async nb(){this.h.createInstance(T.ExtHostConsoleForwarder);const h=this.h.invokeFunction(A.createApiFactoryAndRegisterActors);if(this.h.createInstance(P.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const y=this.h.createInstance(k.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=y.ipcHandlePath}await this.h.createInstance(E,h,{mine:this.D,all:this.F}).install(),c.mark("code/extHost/didInitAPI");const p=await this.k.getConfigProvider();await(0,R.connectProxyResolver)(this.j,p,this,this.l,this.u,this.f),c.mark("code/extHost/didInitProxyResolver")}ob(h){return h.main}async pb(h,g,p){if(g.scheme!==I.Schemas.file)throw new Error(`Cannot load URI: '${g}', must be of file-scheme`);let y=null;p.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${g.toString(!0)}`),this.l.flush();const b=h?.identifier.value;h&&await this.s.initializeLocalizedMessages(h);try{b&&c.mark(`code/extHost/willLoadExtensionCode/${b}`),y=ne.__$__nodeRequire(g.fsPath)}finally{b&&c.mark(`code/extHost/didLoadExtensionCode/${b}`),p.codeLoadingStop()}return y}async $setRemoteEnvironment(h){if(!!this.f.remote.isRemote)for(const g in h){const p=h[g];p===null?delete process.env[g]:process.env[g]=p}}}e.ExtHostExtensionService=f}),define(ye[145],De([1,0,46,323,306,15,61,38,10,8,2,31,80,324,304,100]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const d=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class h{constructor(a){this.a=a}provideTextSearchResults(a,w,D,F){return this.a.appendLine(`provideTextSearchResults ${a.pattern}, ${JSON.stringify({...w,folder:w.folder.toString()})}`),new Promise((x,q)=>{F.onCancellationRequested(()=>V());const M=o(a,w),B=w.folder.fsPath,O=M.map(Q=>Q.match(/^-/)?Q:`'${Q}'`).join(" ");this.a.appendLine(`${d} ${O}
 - cwd: ${B}`);let U=c.spawn(d,M,{cwd:B});U.on("error",Q=>{console.error(Q),this.a.appendLine("Error: "+(Q&&Q.message)),q((0,k.serializeSearchError)(new k.SearchError(Q&&Q.message,k.SearchErrorCode.rgProcessError)))});let z=!1;const j=new y(w.maxResults,B,w.previewOptions);j.on("result",Q=>{z=!0,J="",D.report(Q)});let de=!1;const V=()=>{de=!0,U?.kill(),j?.cancel()};let X=!1;j.on("hitLimit",()=>{X=!0,V()});let J="";U.stdout.on("data",Q=>{j.handleData(Q),z||(J+=Q)});let te=!1;U.stdout.once("data",()=>te=!0);let ee="";U.stderr.on("data",Q=>{const Y=Q.toString();this.a.appendLine(Y),ee.length+Y.length<1e6&&(ee+=Y)}),U.on("close",()=>{if(this.a.appendLine(te?"Got data from stdout":"No data from stdout"),this.a.appendLine(z?"Got result from parser":"No result from parser"),J&&this.a.appendLine(`Got data without result: ${J}`),this.a.appendLine(""),de)x({limitHit:X});else{j.flush(),U=null;let Q;ee&&!te&&(Q=g(ee))?q((0,k.serializeSearchError)(new k.SearchError(Q.message,Q.code))):x({limitHit:X})}})})}}e.RipgrepTextSearchEngine=h;function g(t){const a=t.split(`
`),w=a[0].trim();if(a.some(F=>F.startsWith("regex parse error")))return new k.SearchError(p(a),k.SearchErrorCode.regexParseError);const D=w.match(/grep config error: unknown encoding: (.*)/);if(D)return new k.SearchError(`Unknown encoding: ${D[1]}`,k.SearchErrorCode.unknownEncoding);if(w.startsWith("error parsing glob"))return new k.SearchError(w.charAt(0).toUpperCase()+w.substr(1),k.SearchErrorCode.globParseError);if(w.startsWith("the literal"))return new k.SearchError(w.charAt(0).toUpperCase()+w.substr(1),k.SearchErrorCode.invalidLiteral);if(w.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(w,k.SearchErrorCode.regexParseError)}function p(t){const a=["Regex parse error"],w=t.filter(D=>D.startsWith("PCRE2:"));if(w.length>=1){const D=w[0].replace("PCRE2:","");if(D.indexOf(":")!==-1&&D.split(":").length>=2){const F=D.split(":")[1];a.push(":"+F)}}return a.join("")}class y extends A.EventEmitter{constructor(a,w,D){super(),this.g=a,this.h=w,this.j=D,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new u.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(a,w){return super.on(a,w),this}handleData(a){if(this.b)return;const w=typeof a=="string"?a:this.d.write(a);this.k(w)}k(a){let w=a.indexOf(`
`);const D=this.a+a;if(w>=0)w+=this.a.length;else{this.a=D;return}let F=0;for(;w>=0;)this.m(D.substring(F,w).trim()),F=w+1,w=D.indexOf(`
`,F);this.a=D.substring(F)}m(a){if(this.b||!a)return;let w;try{w=JSON.parse(a)}catch{throw new Error(`malformed line from rg: ${a}`)}if(w.type==="match"){const D=b(w.data.path),F=L.URI.file(S.join(this.h,D)),x=this.n(w.data,F);this.p(x),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(w.type==="context"){const D=b(w.data.path),F=L.URI.file(S.join(this.h,D));this.o(w.data,F).forEach(q=>this.p(q))}}n(a,w){const D=a.line_number-1,F=b(a.lines),x=Buffer.from(F);let q=0,M=0,B=D;a.submatches.length===0&&a.submatches.push(F.length?{start:0,end:1,match:{text:F[0]}}:{start:0,end:0,match:{text:""}});const O=(0,R.coalesce)(a.submatches.map((U,z)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const j=b(U.match),de=x.slice(q,U.start).toString(),V=i(de),X=V.numLines>0?V.lastLineLength:V.lastLineLength+M,J=i(j),te=V.numLines+B,ee=J.numLines+te,Q=J.numLines>0?J.lastLineLength:J.lastLineLength+X;return q=U.end,M=Q,B=ee,new v.Range(te,X,ee,Q)}));return(0,f.createTextSearchResult)(w,F,O,this.j)}o(a,w){const D=b(a.lines),F=a.line_number;return D.replace(/\r?\n$/,"").split(`
`).map((x,q)=>({text:x,uri:w,lineNumber:F+q}))}p(a){this.emit("result",a)}}e.RipgrepParser=y;function b(t){return t.bytes?Buffer.from(t.bytes,"base64").toString():t.text}function i(t){const a=/\n/g;let w=0,D=-1,F;for(;F=a.exec(t);)w++,D=F.index;const x=D>=0?t.length-D-1:t.length;return{numLines:w,lastLineLength:x}}function o(t,a){const w=["--hidden"];w.push(t.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:D,otherIncludes:F}=(0,C.groupBy)(a.includes,q=>q.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const q=new Set;F.forEach(M=>{q.add(M)}),w.push("-g","!*"),q.forEach(M=>{s(M).map(f.anchorGlob).forEach(B=>{w.push("-g",B)})})}D&&D.length&&D.forEach(q=>{w.push("-g",q)}),a.excludes.map(f.anchorGlob).forEach(q=>w.push("-g",`!${q}`)),a.maxFileSize&&w.push("--max-filesize",a.maxFileSize+""),a.useIgnoreFiles?a.useParentIgnoreFiles||w.push("--no-ignore-parent"):w.push("--no-ignore"),a.followSymlinks&&w.push("--follow"),a.encoding&&a.encoding!=="utf8"&&w.push("--encoding",a.encoding),t.pattern==="--"&&(t.isRegExp=!0,t.pattern="\\-\\-"),t.isMultiline&&!t.isRegExp&&(t.pattern=(0,I.escapeRegExpCharacters)(t.pattern),t.isRegExp=!0),a.usePCRE2&&w.push("--pcre2"),w.push("--crlf"),t.isRegExp&&(t.pattern=l(t.pattern),w.push("--engine","auto"));let x;if(t.isWordMatch){const M=(0,I.createRegExp)(t.pattern,!!t.isRegExp,{wholeWord:t.isWordMatch}).source.replace(/\\\//g,"/");w.push("--regexp",M)}else if(t.isRegExp){let q=m(t.pattern);q=n(q),w.push("--regexp",q)}else x=t.pattern,w.push("--fixed-strings");return w.push("--no-config"),a.useGlobalIgnoreFiles||w.push("--no-ignore-global"),w.push("--json"),t.isMultiline&&w.push("--multiline"),a.beforeContext&&w.push("--before-context",a.beforeContext+""),a.afterContext&&w.push("--after-context",a.afterContext+""),w.push("--"),x&&w.push(x),w.push("."),w}function s(t){const a=(0,P.splitGlobAware)(t,"/");return a.map((w,D)=>a.slice(0,D+1).join("/"))}function l(t){const a=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;t.match(a);)t=t.replace(a,"$1\\x{$2}");const w=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;t.match(w);)t=t.replace(w,"$1\\x{$2}");return t}e.unicodeEscapesToPCRE2=l;const r=t=>t.type==="Assertion"&&t.kind==="lookbehind";function m(t){let a;try{a=new T.RegExpParser().parsePattern(t)}catch{return t}let w="",D=0;const F=(M,B,O)=>{w+=t.slice(D,M)+O,D=B},x=[];return new T.RegExpVisitor({onCharacterEnter(M){if(M.raw!=="\\n")return;const B=x[0];if(!B)F(M.start,M.end,"\\r?\\n");else if(!x.some(r))if(B.type==="CharacterClass")if(B.negate){const O=t.slice(B.start+2,M.start)+t.slice(M.end,B.end-1);B.parent?.type==="Quantifier"?F(B.start,B.end,O?`[^${O}]`:"."):F(B.start,B.end,"(?!\\r?\\n"+(O?`|[${O}]`:"")+")")}else{const O=t.slice(B.start+1,M.start)+t.slice(M.end,B.end-1);F(B.start,B.end,O===""?"\\r?\\n":`(?:[${O}]|\\r?\\n)`)}else B.type==="Quantifier"&&F(M.start,M.end,"(?:\\r?\\n)")},onQuantifierEnter(M){x.unshift(M)},onQuantifierLeave(){x.shift()},onCharacterClassRangeEnter(M){x.unshift(M)},onCharacterClassRangeLeave(){x.shift()},onCharacterClassEnter(M){x.unshift(M)},onCharacterClassLeave(){x.shift()},onAssertionEnter(M){r(M)&&x.push(M)},onAssertionLeave(M){x[0]===M&&x.shift()}}).visit(a),w+=t.slice(D),w}e.fixRegexNewline=m;function n(t){return t.replace(/\n/g,"\\r?\\n")}e.fixNewline=n}),define(ye[313],De([1,0,21,145,126,18]),function(ne,e,c,A,u,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class C{constructor(I){this.b=I,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(I,L,k,v){const T=new A.RipgrepTextSearchEngine(this.b);if(L.folder.scheme===R.Schemas.vscodeUserData){const E={...L,folder:L.folder.with({scheme:R.Schemas.file})},f=new u.Progress(d=>k.report({...d,uri:d.uri.with({scheme:L.folder.scheme})}));return this.c(v,d=>T.provideTextSearchResults(I,E,f,d))}else return this.c(v,E=>T.provideTextSearchResults(I,L,k,E))}async c(I,L){const k=P(I);this.a.add(k);const v=await L(k.token);return this.a.delete(k),v}d(){this.a.forEach(I=>I.cancel())}}e.RipgrepSearchProvider=C;function P(S){const I=new c.CancellationTokenSource;return S.onCancellationRequested(()=>I.cancel()),I}}),define(ye[314],De([1,0,29,145,144]),function(ne,e,c,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class R{constructor(S){this.a=S}search(S,I,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(T){L({message:T})}},v=new u.NativeTextSearchManager(this.a,new A.RipgrepTextSearchEngine(k),c);return new Promise((T,E)=>v.search(f=>{I(f.map(C))},S).then(f=>T({limitHit:f.limitHit,type:"success",stats:f.stats}),E))}}e.TextSearchEngineAdapter=R;function C(P){return{path:P.resource&&P.resource.fsPath,results:P.results,numMatches:(P.results||[]).reduce((S,I)=>{if(I.ranges){const L=I;return S+(Array.isArray(L.ranges)?L.ranges.length:1)}else return S+1},0)}}}),define(ye[315],De([1,0,15,19,11,3,111,10,43,2,44,31,305,314]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class E{constructor(y="searchProcess"){this.d=y,this.b=Object.create(null)}fileSearch(y){let b;const i=h(y),o=new R.Emitter({onDidAddFirstListener:()=>{b=(0,A.createCancelablePromise)(s=>this.doFileSearchWithEngine(v.Engine,i,l=>o.fire(l),s)),b.then(s=>o.fire(s),s=>o.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{b.cancel()}});return o.event}textSearch(y){let b;const i=h(y),o=new R.Emitter({onDidAddFirstListener:()=>{b=(0,A.createCancelablePromise)(s=>this.f(i,l=>o.fire(l),s)),b.then(s=>o.fire(s),s=>o.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{b.cancel()}});return o.event}f(y,b,i){return y.maxFileSize=(0,L.getPlatformFileLimits)(process.arch==="ia32"?0:1).maxFileSize,new T.TextSearchEngineAdapter(y).search(i,b,b)}doFileSearch(y,b,i){return this.doFileSearchWithEngine(v.Engine,y,b,i)}doFileSearchWithEngine(y,b,i,o,s=E.a){let l=0;const r=n=>{Array.isArray(n)?(l+=n.length,i(n.map(t=>this.g(t)))):n.relativePath?(l++,i(this.g(n))):i(n)};if(b.sortByScore){let n=this.k(b,r,o);if(!n){const t=b.maxResults?Object.assign({},b,{maxResults:null}):b,a=new y(t);n=this.h(a,b,i,r,o)}return new Promise((t,a)=>{n.then(([w,D])=>{const F=D.map(x=>this.g(x));this.n(F,i,s),t(w)},a)})}const m=new y(b);return this.q(m,r,s,o).then(n=>({limitHit:n.limitHit,type:"success",stats:{detailStats:n.stats,type:this.d,fromCache:!1,resultCount:l,sortingTime:void 0}}))}g(y){return{path:y.base?(0,P.join)(y.base,y.relativePath):y.relativePath}}h(y,b,i,o,s){const l=new R.Emitter;let r=(0,A.createCancelablePromise)(n=>{let t=[];const a=w=>{Array.isArray(w)?t=w:(o(w),l.fire(w))};return this.q(y,a,-1,n).then(w=>[w,t])}),m;if(b.cacheKey){m=this.j(b.cacheKey);const n={promise:r,event:l.event,resolved:!1};m.resultsToSearchCache[b.filePattern||""]=n,r.then(()=>{n.resolved=!0},t=>{delete m.resultsToSearchCache[b.filePattern||""]}),r=this.r(r)}return r.then(([n,t])=>{const a=m?m.scorerCache:Object.create(null),w=(typeof b.maxResults!="number"||b.maxResults>0)&&S.StopWatch.create(!1);return this.l(b,t,a,s).then(D=>{const F=w?w.elapsed():-1;return[{type:"success",stats:{detailStats:n.stats,sortingTime:F,fromCache:!1,type:this.d,workspaceFolderCount:b.folderQueries.length,resultCount:D.length},messages:n.messages,limitHit:n.limitHit||typeof b.maxResults=="number"&&t.length>b.maxResults},D]})})}j(y){const b=this.b[y];return b||(this.b[y]=new f)}k(y,b,i){const o=y.cacheKey&&this.b[y.cacheKey];if(!o)return;const s=this.o(o,y.filePattern||"",b,i);if(s)return s.then(([l,r,m])=>{const n=S.StopWatch.create(!1);return this.l(y,r,o.scorerCache,i).then(t=>{const a=n.elapsed(),w={fromCache:!0,detailStats:m,type:this.d,resultCount:r.length,sortingTime:a};return[{type:"success",limitHit:l.limitHit||typeof y.maxResults=="number"&&r.length>y.maxResults,stats:w},t]})})}l(y,b,i,o){const s=(0,C.prepareQuery)(y.filePattern||""),l=(m,n)=>(0,C.compareItemsByFuzzyScore)(m,n,s,!0,d,i),r=typeof y.maxResults=="number"?y.maxResults:Number.MAX_VALUE;return c.topAsync(b,l,r,1e4,o)}n(y,b,i){if(i&&i>0)for(let o=0;o<y.length;o+=i)b(y.slice(o,o+i));else b(y)}o(y,b,i,o){const s=S.StopWatch.create(!1),l=b.indexOf(P.sep)>=0;let r;for(const a in y.resultsToSearchCache)if(b.startsWith(a)){if(l&&a.indexOf(P.sep)<0&&a!=="")continue;const w=y.resultsToSearchCache[a];r={promise:this.r(w.promise),event:w.event,resolved:w.resolved};break}if(!r)return null;const m=s.elapsed(),n=S.StopWatch.create(!1),t=r.event(i);return o&&o.onCancellationRequested(()=>{t.dispose()}),r.promise.then(([a,w])=>{if(o&&o.isCancellationRequested)throw(0,u.canceled)();const D=[],F=(0,C.prepareQuery)(b).normalizedLowercase;for(const x of w)!(0,k.isFilePatternMatch)(x,F)||D.push(x);return[a,D,{cacheWasResolved:r.resolved,cacheLookupTime:m,cacheFilterTime:n.elapsed(),cacheEntryCount:w.length}]})}q(y,b,i,o){return new Promise((s,l)=>{let r=[];o?.onCancellationRequested(()=>y.cancel()),y.search(m=>{m&&(i?(r.push(m),i>0&&r.length>=i&&(b(r),r=[])):b(m))},m=>{b(m)},(m,n)=>{r.length&&b(r),m?l(m):s(n)})})}clearCache(y){return delete this.b[y],Promise.resolve(void 0)}r(y){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(b,i){return y.then(b,i)}catch(b){return this.then(void 0,b)}finally(b){return y.finally(b)}}}}E.a=512,e.SearchService=E;class f{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const d=new class{getItemLabel(p){return(0,P.basename)(p.relativePath)}getItemDescription(p){return(0,P.dirname)(p.relativePath)}getItemPath(p){return p.relativePath}};function h(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(g),extraFileResources:p.extraFileResources&&p.extraFileResources.map(y=>I.URI.revive(y))}}function g(p){return{...p,folder:I.URI.revive(p.folder)}}}),define(ye[316],De([1,0,6,18,2,29,13,25,20,84,56,31,315,313,100,144]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let d=class extends I.ExtHostSearch{constructor(g,p,y,b){super(g,y,b),this.s=R,this.t=-1,this.v=null,this.w=!1;const i=new E.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(A.Schemas.vscodeUserData,new T.RipgrepSearchProvider(i)),p.remote.isRemote&&p.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const g=new E.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(A.Schemas.file,new T.RipgrepSearchProvider(g)),this.y(A.Schemas.file,new v.SearchService("fileSearchProvider"))}y(g,p){const y=this.d++;return this.v=p,this.t=y,this.c.$registerFileSearchProvider(y,this.o(g)),(0,c.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(y)})}$provideFileSearchResults(g,p,y,b){const i=(0,I.reviveQuery)(y);return g===this.t?this.z(g,p,i,b):super.$provideFileSearchResults(g,p,y,b)}z(g,p,y,b){const i=o=>{if((0,k.isSerializedFileMatch)(o)&&(o=[o]),Array.isArray(o)){this.c.$handleFileMatch(g,p,o.map(s=>u.URI.file(s.path)));return}o.message&&this.n.debug("ExtHostSearch",o.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(y,i,b)}$clearCache(g){return this.v?.clearCache(g),super.$clearCache(g)}q(g,p){return new f.NativeTextSearchManager(g,p,void 0,"textSearchProvider")}};d=qe([We(0,S.IExtHostRpcService),We(1,P.IExtHostInitDataService),We(2,L.IURITransformerService),We(3,C.ILogService)],d),e.NativeExtHostSearch=d}),define(ye[317],De([1,0,89,288,300,299,316,312,289,83,42,84,81,41,55,78,287,286,13,301,49]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,f,d,h,g,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(L.IExtHostExtensionService,P.ExtHostExtensionService,0),(0,c.registerSingleton)(g.ILoggerService,h.ExtHostLoggerService,1),(0,c.registerSingleton)(f.IExtensionStoragePaths,d.ExtensionStoragePaths,0),(0,c.registerSingleton)(I.IExtHostDebugService,R.ExtHostDebugService,0),(0,c.registerSingleton)(k.IExtHostSearch,C.NativeExtHostSearch,0),(0,c.registerSingleton)(v.IExtHostTask,u.ExtHostTask,0),(0,c.registerSingleton)(T.IExtHostTerminalService,A.ExtHostTerminalService,0),(0,c.registerSingleton)(E.IExtHostTunnelService,S.ExtHostTunnelService,0),(0,c.registerSingleton)(y.IExtHostVariableResolverProvider,p.NodeExtHostVariableResolverProviderService,0)}),define(ye[325],De([1,0,229,326,82,11,118,119,207,95,298,22,29,115,19,121,224,237,302,317]),function(ne,e,c,A,u,R,C,P,S,I,L,k,v,T,E,f,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let m=0;m<process.execArgv.length;m++)process.execArgv[m]==="--inspect-port=0"&&(process.execArgv.splice(m,1),m--)}();const g=A(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const r=globalThis._VSCODE_NODE_MODULES.module,m=r._load;r._load=function(n){if(n==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return m.apply(this,arguments)}})();const p=process.exit.bind(process);function y(r){process.exit=function(m){if(r)p(m);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const m=new Error("An extension called process.crash() and this was prevented.");console.warn(m.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let b=function(r){p()};function i(){const r=(0,h.readExtHostConnection)(process.env);if(r.type===3)return new Promise((m,n)=>{const t=a=>{const w=a[0],D=new C.BufferedEmitter;w.on("message",F=>D.fire(k.VSBuffer.wrap(F.data))),w.on("close",()=>{b("renderer closed the MessagePort")}),w.start(),m({onMessage:D.event,send:F=>w.postMessage(F.buffer)})};process.parentPort.on("message",a=>t(a.ports))});if(r.type===2)return new Promise((m,n)=>{let t=null;const a=setTimeout(()=>{b("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),w=108e5,D=3e5,F=new E.ProcessTimeRunOnceScheduler(()=>b("renderer disconnected for too long (1)"),w),x=new E.ProcessTimeRunOnceScheduler(()=>b("renderer disconnected for too long (2)"),D);process.on("message",(M,B)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){B.setNoDelay(!0);const O=k.VSBuffer.wrap(Buffer.from(M.initialDataChunk,"base64"));let U;if(M.skipWebSocketFrames)U=new P.NodeSocket(B,"extHost-socket");else{const z=k.VSBuffer.wrap(Buffer.from(M.inflateBytes,"base64"));U=new P.WebSocketNodeSocket(new P.NodeSocket(B,"extHost-socket"),M.permessageDeflate,z,!1)}t?(F.cancel(),x.cancel(),t.beginAcceptReconnection(U,O),t.endAcceptReconnection(),t.sendResume()):(clearTimeout(a),t=new C.PersistentProtocol({socket:U,initialChunk:O}),t.sendResume(),t.onDidDispose(()=>b("renderer disconnected")),m(t),t.onSocketClose(()=>{F.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(x.isScheduled())return;F.isScheduled()&&x.schedule()}});const q={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(q)});{const m=r.pipeName;return new Promise((n,t)=>{const a=c.createConnection(m,()=>{a.removeListener("error",t);const w=new C.PersistentProtocol({socket:new P.NodeSocket(a,"extHost-renderer")});w.sendResume(),n(w)});a.once("error",t),a.on("close",()=>{b("renderer closed the socket")})})}}async function o(){const r=await i();return new class{constructor(){this.a=new C.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,r.onMessage(m=>{(0,I.isMessageOfType)(m,2)?(this.b=!0,b("received terminate message from renderer")):this.a.fire(m)})}send(m){this.b||r.send(m)}async drain(){if(r.drain)return r.drain()}}}function s(r){return new Promise(m=>{const n=r.onMessage(t=>{n.dispose();const a=JSON.parse(t.toString()),w=a.commit,D=S.default.commit;if(w&&D&&w!==D&&p(55),a.parentPid){let F=0;setInterval(function(){try{process.kill(a.parentPid,0),F=0}catch(q){q&&q.code==="EPERM"?(F++,F>=3&&b(`parent process ${a.parentPid} does not exist anymore (3 x EPERM): ${q.message} (code: ${q.code}) (errno: ${q.errno})`)):b(`parent process ${a.parentPid} does not exist anymore: ${q.message} (code: ${q.code}) (errno: ${q.errno})`)}},1e3);let x;try{x=globalThis._VSCODE_NODE_MODULES["native-watchdog"],x.start(a.parentPid)}catch(q){(0,R.onUnexpectedError)(q)}}r.send((0,I.createMessageOfType)(0)),m({protocol:r,initData:a})});r.send((0,I.createMessageOfType)(1))})}async function l(){const r=[];process.on("unhandledRejection",(F,x)=>{r.push(x),setTimeout(()=>{const q=r.indexOf(x);q>=0&&x.catch(M=>{r.splice(q,1),(0,R.isCancellationError)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),F&&(0,R.onUnexpectedError)(F))})},1e3)}),process.on("rejectionHandled",F=>{const x=r.indexOf(F);x>=0&&r.splice(x,1)}),process.on("uncaughtException",function(F){(0,R.isSigPipeError)(F)||(0,R.onUnexpectedError)(F)}),u.mark("code/extHost/willConnectToRenderer");const m=await o();u.mark("code/extHost/didConnectToRenderer");const n=await s(m);u.mark("code/extHost/didWaitForInitData");const{initData:t}=n;y(!!t.environment.extensionTestsLocationURI),t.environment.useHostProxy=g.useHostProxy!==void 0?g.useHostProxy!=="false":void 0,t.environment.skipWorkspaceStorageLock=(0,f.boolean)(g.skipWorkspaceStorageLock,!1);const a=new class{constructor(){this.pid=process.pid}exit(x){p(x)}exists(x){return v.Promises.exists(x)}realpath(x){return(0,T.realpath)(x)}};let w=null;t.remote.authority&&g.transformURIs&&(w=(0,d.createURITransformer)(t.remote.authority));const D=new L.ExtensionHostMain(n.protocol,t,a,w);b=F=>D.terminate(F)}l().catch(r=>console.log(r))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ac229ad6e485f87b5c172a909c5aafe333cad9ce/core/vs/workbench/api/node/extensionHostProcess.js.map
