/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/arrays","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/base/common/stopwatch","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/lazy","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],ke=function(te){for(var e=[],n=0,C=te.length;n<C;n++)e[n]=Ce[te[n]];return e};define(Ce[62],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function n(S,R){const y=Object.create(null);for(const k of S){const N=R(k);let w=y[N];w||(w=y[N]=[]),w.push(k)}return y}e.groupBy=n;function C(S,R){const y=[],k=[];for(const N of S)R.has(N)||y.push(N);for(const N of R)S.has(N)||k.push(N);return{removed:y,added:k}}e.diffSets=C;function D(S,R){const y=[],k=[];for(const[N,w]of S)R.has(N)||y.push(w);for(const[N,w]of R)S.has(N)||k.push(w);return{removed:y,added:k}}e.diffMaps=D;class M{constructor(){this.a=new Map}add(R,y){let k=this.a.get(R);k||(k=new Set,this.a.set(R,k)),k.add(y)}delete(R,y){const k=this.a.get(R);!k||(k.delete(y),k.size===0&&this.a.delete(R))}forEach(R,y){const k=this.a.get(R);!k||k.forEach(y)}}e.SetMap=M}),define(Ce[63],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function n(S){return(R,y,k)=>{let N=null,w=null;if(typeof k.value=="function"?(N="value",w=k.value):typeof k.get=="function"&&(N="get",w=k.get),!w)throw new Error("not supported");k[N]=S(w,y)}}function C(S,R,y){let k=null,N=null;if(typeof y.value=="function"?(k="value",N=y.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(k="get",N=y.get),!N)throw new Error("not supported");const w=`$memoize$${R}`;y[k]=function(...f){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,f)}),this[w]}}e.memoize=C;function D(S,R,y){return n((k,N)=>{const w=`$debounce$${N}`,f=`$debounce$result$${N}`;return function(...b){this[f]||(this[f]=y?y():void 0),clearTimeout(this[w]),R&&(this[f]=R(this[f],...b),b=[this[f]]),this[w]=setTimeout(()=>{k.apply(this,b),this[f]=y?y():void 0},S)}})}e.debounce=D;function M(S,R,y){return n((k,N)=>{const w=`$throttle$timer$${N}`,f=`$throttle$result$${N}`,b=`$throttle$lastRun$${N}`,m=`$throttle$pending$${N}`;return function(...a){if(this[f]||(this[f]=y?y():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),R&&(this[f]=R(this[f],...a)),this[m])return;const o=this[b]+S;o<=Date.now()?(this[b]=Date.now(),k.apply(this,[this[f]]),this[f]=y?y():void 0):(this[m]=!0,this[w]=setTimeout(()=>{this[m]=!1,this[b]=Date.now(),k.apply(this,[this[f]]),this[f]=y?y():void 0},o-Date.now()))}})}e.throttle=M}),define(Ce[83],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class n{constructor(D){this.a=D,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=n,e.defaultGenerator=new n("id#")}),define(Ce[111],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n=e.ScanError||(e.ScanError={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function S(t,h=!1){let r=0;const u=t.length;let i="",p=0,c=16,s=0;function d(B){let P=0,F=0;for(;P<B;){const V=t.charCodeAt(r);if(V>=48&&V<=57)F=F*16+V-48;else if(V>=65&&V<=70)F=F*16+V-65+10;else if(V>=97&&V<=102)F=F*16+V-97+10;else break;r++,P++}return P<B&&(F=-1),F}function T(B){r=B,i="",p=0,c=16,s=0}function O(){const B=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&k(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&k(t.charCodeAt(r)))for(r++;r<t.length&&k(t.charCodeAt(r));)r++;else return s=3,t.substring(B,r);let P=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&k(t.charCodeAt(r))){for(r++;r<t.length&&k(t.charCodeAt(r));)r++;P=r}else s=3;return t.substring(B,P)}function H(){let B="",P=r;for(;;){if(r>=u){B+=t.substring(P,r),s=2;break}const F=t.charCodeAt(r);if(F===34){B+=t.substring(P,r),r++;break}if(F===92){if(B+=t.substring(P,r),r++,r>=u){s=2;break}switch(t.charCodeAt(r++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const j=d(4);j>=0?B+=String.fromCharCode(j):s=4;break}default:s=5}P=r;continue}if(F>=0&&F<=31)if(y(F)){B+=t.substring(P,r),s=2;break}else s=6;r++}return B}function J(){if(i="",s=0,p=r,r>=u)return p=u,c=17;let B=t.charCodeAt(r);if(R(B)){do r++,i+=String.fromCharCode(B),B=t.charCodeAt(r);while(R(B));return c=15}if(y(B))return r++,i+=String.fromCharCode(B),B===13&&t.charCodeAt(r)===10&&(r++,i+=`
`),c=14;switch(B){case 123:return r++,c=1;case 125:return r++,c=2;case 91:return r++,c=3;case 93:return r++,c=4;case 58:return r++,c=6;case 44:return r++,c=5;case 34:return r++,i=H(),c=10;case 47:{const P=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<u&&!y(t.charCodeAt(r));)r++;return i=t.substring(P,r),c=12}if(t.charCodeAt(r+1)===42){r+=2;const F=u-1;let V=!1;for(;r<F;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,V=!0;break}r++}return V||(r++,s=1),i=t.substring(P,r),c=13}return i+=String.fromCharCode(B),r++,c=16}case 45:if(i+=String.fromCharCode(B),r++,r===u||!k(t.charCodeAt(r)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=O(),c=11;default:for(;r<u&&K(B);)r++,B=t.charCodeAt(r);if(p!==r){switch(i=t.substring(p,r),i){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return i+=String.fromCharCode(B),r++,c=16}}function K(B){if(R(B)||y(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let B;do B=J();while(B>=12&&B<=15);return B}return{setPosition:T,getPosition:()=>r,scan:h?L:J,getToken:()=>c,getTokenValue:()=>i,getTokenOffset:()=>p,getTokenLength:()=>r-p,getTokenError:()=>s}}e.createScanner=S;function R(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var N;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(N||(N={}));function w(t,h){const r=[],u=new Object;let i;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function s(d,T,O,H){p.value=d,p.offset=T,p.length=O,p.type=H,p.colonOffset=void 0,i=p}try{E(t,{onObjectBegin:(d,T)=>{if(h<=d)throw u;i=void 0,c=h>d,r.push("")},onObjectProperty:(d,T,O)=>{if(h<T||(s(d,T,O,"property"),r[r.length-1]=d,h<=T+O))throw u},onObjectEnd:(d,T)=>{if(h<=d)throw u;i=void 0,r.pop()},onArrayBegin:(d,T)=>{if(h<=d)throw u;i=void 0,r.push(0)},onArrayEnd:(d,T)=>{if(h<=d)throw u;i=void 0,r.pop()},onLiteralValue:(d,T,O)=>{if(h<T||(s(d,T,O,v(d)),h<=T+O))throw u},onSeparator:(d,T,O)=>{if(h<=T)throw u;if(d===":"&&i&&i.type==="property")i.colonOffset=T,c=!1,i=void 0;else if(d===","){const H=r[r.length-1];typeof H=="number"?r[r.length-1]=H+1:(c=!0,r[r.length-1]=""),i=void 0}}})}catch(d){if(d!==u)throw d}return{path:r,previousNode:i,isAtPropertyKey:c,matches:d=>{let T=0;for(let O=0;T<d.length&&O<r.length;O++)if(d[T]===r[O]||d[T]==="*")T++;else if(d[T]!=="**")return!1;return T===d.length}}}e.getLocation=w;function f(t,h=[],r=M.DEFAULT){let u=null,i=[];const p=[];function c(d){Array.isArray(i)?i.push(d):u!==null&&(i[u]=d)}return E(t,{onObjectBegin:()=>{const d={};c(d),p.push(i),i=d,u=null},onObjectProperty:d=>{u=d},onObjectEnd:()=>{i=p.pop()},onArrayBegin:()=>{const d=[];c(d),p.push(i),i=d,u=null},onArrayEnd:()=>{i=p.pop()},onLiteralValue:c,onError:(d,T,O)=>{h.push({error:d,offset:T,length:O})}},r),i[0]}e.parse=f;function b(t,h=[],r=M.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(d){u.type==="property"&&(u.length=d-u.offset,u=u.parent)}function p(d){return u.children.push(d),d}E(t,{onObjectBegin:d=>{u=p({type:"object",offset:d,length:-1,parent:u,children:[]})},onObjectProperty:(d,T,O)=>{u=p({type:"property",offset:T,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:d,offset:T,length:O,parent:u})},onObjectEnd:(d,T)=>{u.length=d+T-u.offset,u=u.parent,i(d+T)},onArrayBegin:(d,T)=>{u=p({type:"array",offset:d,length:-1,parent:u,children:[]})},onArrayEnd:(d,T)=>{u.length=d+T-u.offset,u=u.parent,i(d+T)},onLiteralValue:(d,T,O)=>{p({type:v(d),offset:T,length:O,parent:u,value:d}),i(T+O)},onSeparator:(d,T,O)=>{u.type==="property"&&(d===":"?u.colonOffset=T:d===","&&i(T))},onError:(d,T,O)=>{h.push({error:d,offset:T,length:O})}},r);const s=u.children[0];return s&&delete s.parent,s}e.parseTree=b;function m(t,h){if(!t)return;let r=t;for(const u of h)if(typeof u=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let i=!1;for(const p of r.children)if(Array.isArray(p.children)&&p.children[0].value===u){r=p.children[1],i=!0;break}if(!i)return}else{const i=u;if(r.type!=="array"||i<0||!Array.isArray(r.children)||i>=r.children.length)return;r=r.children[i]}return r}e.findNodeAtLocation=m;function a(t){if(!t.parent||!t.parent.children)return[];const h=a(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;h.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&h.push(r)}return h}e.getNodePath=a;function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const h=Object.create(null);for(const r of t.children){const u=r.children[1];u&&(h[r.children[0].value]=o(u))}return h}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=o;function l(t,h,r=!1){return h>=t.offset&&h<t.offset+t.length||r&&h===t.offset+t.length}e.contains=l;function g(t,h,r=!1){if(l(t,h,r)){const u=t.children;if(Array.isArray(u))for(let i=0;i<u.length&&u[i].offset<=h;i++){const p=g(u[i],h,r);if(p)return p}return t}}e.findNodeAtOffset=g;function E(t,h,r=M.DEFAULT){const u=S(t,!1);function i(se){return se?()=>se(u.getTokenOffset(),u.getTokenLength()):()=>!0}function p(se){return se?Z=>se(Z,u.getTokenOffset(),u.getTokenLength()):()=>!0}const c=i(h.onObjectBegin),s=p(h.onObjectProperty),d=i(h.onObjectEnd),T=i(h.onArrayBegin),O=i(h.onArrayEnd),H=p(h.onLiteralValue),J=p(h.onSeparator),K=i(h.onComment),L=p(h.onError),B=r&&r.disallowComments,P=r&&r.allowTrailingComma;function F(){for(;;){const se=u.scan();switch(u.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:B||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(se){case 12:case 13:B?V(10):K();break;case 16:V(1);break;case 15:case 14:break;default:return se}}}function V(se,Z=[],X=[]){if(L(se),Z.length+X.length>0){let ee=u.getToken();for(;ee!==17;){if(Z.indexOf(ee)!==-1){F();break}else if(X.indexOf(ee)!==-1)break;ee=F()}}}function j(se){const Z=u.getTokenValue();return se?H(Z):s(Z),F(),!0}function le(){switch(u.getToken()){case 11:{let se=0;try{se=JSON.parse(u.getTokenValue()),typeof se!="number"&&(V(2),se=0)}catch{V(2)}H(se);break}case 7:H(null);break;case 8:H(!0);break;case 9:H(!1);break;default:return!1}return F(),!0}function _(){return u.getToken()!==10?(V(3,[],[2,5]),!1):(j(!1),u.getToken()===6?(J(":"),F(),ue()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function be(){c(),F();let se=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(se||V(4,[],[]),J(","),F(),u.getToken()===2&&P)break}else se&&V(6,[],[]);_()||V(4,[],[2,5]),se=!0}return d(),u.getToken()!==2?V(7,[2],[]):F(),!0}function de(){T(),F();let se=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(se||V(4,[],[]),J(","),F(),u.getToken()===4&&P)break}else se&&V(6,[],[]);ue()||V(4,[],[4,5]),se=!0}return O(),u.getToken()!==4?V(8,[4],[]):F(),!0}function ue(){switch(u.getToken()){case 3:return de();case 1:return be();case 10:return j(!0);default:return le()}}return F(),u.getToken()===17?r.allowEmptyContent?!0:(V(4,[],[]),!1):ue()?(u.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=E;function A(t,h){const r=S(t),u=[];let i,p=0,c;do switch(c=r.getPosition(),i=r.scan(),i){case 12:case 13:case 17:p!==c&&u.push(t.substring(p,c)),h!==void 0&&u.push(r.getTokenValue().replace(/[^\r\n]/g,h)),p=r.getPosition();break}while(i!==17);return u.join("")}e.stripComments=A;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(Ce[28],ke([1,0]),function(te,e){"use strict";var n,C,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function M(m,a,o){let l=m.get(a);return l===void 0&&(l=o,m.set(a,l)),l}e.getOrSet=M;function S(m){const a=[];return m.forEach((o,l)=>{a.push(`${l} => ${o}`)}),`Map(${m.size}) {${a.join(", ")}}`}e.mapToString=S;function R(m){const a=[];return m.forEach(o=>{a.push(o)}),`Set(${m.size}) {${a.join(", ")}}`}e.setToString=R;class y{constructor(a,o){this.uri=a,this.value=o}}class k{constructor(a,o){this[n]="ResourceMap",a instanceof k?(this.b=new Map(a.b),this.c=o??k.a):(this.b=new Map,this.c=a??k.a)}set(a,o){return this.b.set(this.c(a),new y(a,o)),this}get(a){return this.b.get(this.c(a))?.value}has(a){return this.b.has(this.c(a))}get size(){return this.b.size}clear(){this.b.clear()}delete(a){return this.b.delete(this.c(a))}forEach(a,o){typeof o<"u"&&(a=a.bind(o));for(const[l,g]of this.b)a(g.value,g.uri,this)}*values(){for(const a of this.b.values())yield a.value}*keys(){for(const a of this.b.values())yield a.uri}*entries(){for(const a of this.b.values())yield[a.uri,a.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.b)yield[a.uri,a.value]}}k.a=m=>m.toString(),e.ResourceMap=k;class N{constructor(a,o){this[C]="ResourceSet",!a||typeof a=="function"?this.a=new k(a):(this.a=new k(o),a.forEach(this.add,this))}get size(){return this.a.size}add(a){return this.a.set(a,a),this}clear(){this.a.clear()}delete(a){return this.a.delete(a)}forEach(a,o){this.a.forEach((l,g)=>a.call(o,g,g,this))}has(a){return this.a.has(a)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=N;var w;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class f{constructor(){this[D]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(a){return this.a.has(a)}get(a,o=0){const l=this.a.get(a);if(!!l)return o!==0&&this.j(l,o),l.value}set(a,o,l=0){let g=this.a.get(a);if(g)g.value=o,l!==0&&this.j(g,l);else{switch(g={key:a,value:o,next:void 0,previous:void 0},l){case 0:this.h(g);break;case 1:this.g(g);break;case 2:this.h(g);break;default:this.h(g);break}this.a.set(a,g),this.d++}return this}delete(a){return!!this.remove(a)}remove(a){const o=this.a.get(a);if(!!o)return this.a.delete(a),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const a=this.b;return this.a.delete(a.key),this.i(a),this.d--,a.value}forEach(a,o){const l=this.e;let g=this.b;for(;g;){if(o?a.bind(o)(g.value,g.key,this):a(g.value,g.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const a=this,o=this.e;let l=this.b;const g={[Symbol.iterator](){return g},next(){if(a.e!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:l.key,done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return g}values(){const a=this,o=this.e;let l=this.b;const g={[Symbol.iterator](){return g},next(){if(a.e!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:l.value,done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return g}entries(){const a=this,o=this.e;let l=this.b;const g={[Symbol.iterator](){return g},next(){if(a.e!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:[l.key,l.value],done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return g}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(a){if(a>=this.size)return;if(a===0){this.clear();return}let o=this.b,l=this.size;for(;o&&l>a;)this.a.delete(o.key),o=o.next,l--;this.b=o,this.d=l,o&&(o.previous=void 0),this.e++}g(a){if(!this.b&&!this.c)this.c=a;else if(this.b)a.next=this.b,this.b.previous=a;else throw new Error("Invalid list");this.b=a,this.e++}h(a){if(!this.b&&!this.c)this.b=a;else if(this.c)a.previous=this.c,this.c.next=a;else throw new Error("Invalid list");this.c=a,this.e++}i(a){if(a===this.b&&a===this.c)this.b=void 0,this.c=void 0;else if(a===this.b){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this.b=a.next}else if(a===this.c){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this.c=a.previous}else{const o=a.next,l=a.previous;if(!o||!l)throw new Error("Invalid list");o.previous=l,l.next=o}a.next=void 0,a.previous=void 0,this.e++}j(a,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(a===this.b)return;const l=a.next,g=a.previous;a===this.c?(g.next=void 0,this.c=g):(l.previous=g,g.next=l),a.previous=void 0,a.next=this.b,this.b.previous=a,this.b=a,this.e++}else if(o===2){if(a===this.c)return;const l=a.next,g=a.previous;a===this.b?(l.previous=void 0,this.b=l):(l.previous=g,g.next=l),a.next=void 0,a.previous=this.c,this.c.next=a,this.c=a,this.e++}}}toJSON(){const a=[];return this.forEach((o,l)=>{a.push([l,o])}),a}fromJSON(a){this.clear();for(const[o,l]of a)this.set(o,l)}}e.LinkedMap=f;class b extends f{constructor(a,o=1){super(),this.k=a,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(a){this.k=a,this.m()}get ratio(){return this.l}set ratio(a){this.l=Math.min(Math.max(0,a),1),this.m()}get(a,o=2){return super.get(a,o)}peek(a){return super.get(a,0)}set(a,o){return super.set(a,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=b}),function(te,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ce[112],ke([0]),e):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(Pe,Se){for(var Ie=0;Ie<Se.length;Ie++){var oe=Se[Ie];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(Pe,oe.key,oe)}}function n(Pe,Se,Ie){return Se&&e(Pe.prototype,Se),Ie&&e(Pe,Ie),Object.defineProperty(Pe,"prototype",{writable:!1}),Pe}function C(Pe,Se){if(!!Pe){if(typeof Pe=="string")return D(Pe,Se);var Ie=Object.prototype.toString.call(Pe).slice(8,-1);if(Ie==="Object"&&Pe.constructor&&(Ie=Pe.constructor.name),Ie==="Map"||Ie==="Set")return Array.from(Pe);if(Ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ie))return D(Pe,Se)}}function D(Pe,Se){(Se==null||Se>Pe.length)&&(Se=Pe.length);for(var Ie=0,oe=new Array(Se);Ie<Se;Ie++)oe[Ie]=Pe[Ie];return oe}function M(Pe,Se){var Ie=typeof Symbol<"u"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(Ie)return(Ie=Ie.call(Pe)).next.bind(Ie);if(Array.isArray(Pe)||(Ie=C(Pe))||Se&&Pe&&typeof Pe.length=="number"){Ie&&(Pe=Ie);var oe=0;return function(){return oe>=Pe.length?{done:!0}:{done:!1,value:Pe[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function S(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=S();function R(Pe){te.defaults=Pe}var y=/[&<>"']/,k=/[&<>"']/g,N=/[<>"']|&(?!#?\w+;)/,w=/[<>"']|&(?!#?\w+;)/g,f={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(Se){return f[Se]};function m(Pe,Se){if(Se){if(y.test(Pe))return Pe.replace(k,b)}else if(N.test(Pe))return Pe.replace(w,b);return Pe}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Pe){return Pe.replace(a,function(Se,Ie){return Ie=Ie.toLowerCase(),Ie==="colon"?":":Ie.charAt(0)==="#"?Ie.charAt(1)==="x"?String.fromCharCode(parseInt(Ie.substring(2),16)):String.fromCharCode(+Ie.substring(1)):""})}var l=/(^|[^\[])\^/g;function g(Pe,Se){Pe=typeof Pe=="string"?Pe:Pe.source,Se=Se||"";var Ie={replace:function(ce,Y){return Y=Y.source||Y,Y=Y.replace(l,"$1"),Pe=Pe.replace(ce,Y),Ie},getRegex:function(){return new RegExp(Pe,Se)}};return Ie}var E=/[^\w:]/g,A=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(Pe,Se,Ie){if(Pe){var oe;try{oe=decodeURIComponent(o(Ie)).replace(E,"").toLowerCase()}catch{return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}Se&&!A.test(Ie)&&(Ie=i(Se,Ie));try{Ie=encodeURI(Ie).replace(/%25/g,"%")}catch{return null}return Ie}var t={},h=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(Pe,Se){t[" "+Pe]||(h.test(Pe)?t[" "+Pe]=Pe+"/":t[" "+Pe]=d(Pe,"/",!0)),Pe=t[" "+Pe];var Ie=Pe.indexOf(":")===-1;return Se.substring(0,2)==="//"?Ie?Se:Pe.replace(r,"$1")+Se:Se.charAt(0)==="/"?Ie?Se:Pe.replace(u,"$1")+Se:Pe+Se}var p={exec:function(){}};function c(Pe){for(var Se=1,Ie,oe;Se<arguments.length;Se++){Ie=arguments[Se];for(oe in Ie)Object.prototype.hasOwnProperty.call(Ie,oe)&&(Pe[oe]=Ie[oe])}return Pe}function s(Pe,Se){var Ie=Pe.replace(/\|/g,function(Y,I,$){for(var W=!1,q=I;--q>=0&&$[q]==="\\";)W=!W;return W?"|":" |"}),oe=Ie.split(/ \|/),ce=0;if(oe[0].trim()||oe.shift(),oe.length>0&&!oe[oe.length-1].trim()&&oe.pop(),oe.length>Se)oe.splice(Se);else for(;oe.length<Se;)oe.push("");for(;ce<oe.length;ce++)oe[ce]=oe[ce].trim().replace(/\\\|/g,"|");return oe}function d(Pe,Se,Ie){var oe=Pe.length;if(oe===0)return"";for(var ce=0;ce<oe;){var Y=Pe.charAt(oe-ce-1);if(Y===Se&&!Ie)ce++;else if(Y!==Se&&Ie)ce++;else break}return Pe.slice(0,oe-ce)}function T(Pe,Se){if(Pe.indexOf(Se[1])===-1)return-1;for(var Ie=Pe.length,oe=0,ce=0;ce<Ie;ce++)if(Pe[ce]==="\\")ce++;else if(Pe[ce]===Se[0])oe++;else if(Pe[ce]===Se[1]&&(oe--,oe<0))return ce;return-1}function O(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function H(Pe,Se){if(Se<1)return"";for(var Ie="";Se>1;)Se&1&&(Ie+=Pe),Se>>=1,Pe+=Pe;return Ie+Pe}function J(Pe,Se,Ie,oe){var ce=Se.href,Y=Se.title?m(Se.title):null,I=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){oe.state.inLink=!0;var $={type:"link",raw:Ie,href:ce,title:Y,text:I,tokens:oe.inlineTokens(I)};return oe.state.inLink=!1,$}return{type:"image",raw:Ie,href:ce,title:Y,text:m(I)}}function K(Pe,Se){var Ie=Pe.match(/^(\s+)(?:```)/);if(Ie===null)return Se;var oe=Ie[1];return Se.split(`
`).map(function(ce){var Y=ce.match(/^\s+/);if(Y===null)return ce;var I=Y[0];return I.length>=oe.length?ce.slice(oe.length):ce}).join(`
`)}var L=function(){function Pe(Ie){this.options=Ie||te.defaults}var Se=Pe.prototype;return Se.space=function(oe){var ce=this.rules.block.newline.exec(oe);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},Se.code=function(oe){var ce=this.rules.block.code.exec(oe);if(ce){var Y=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?Y:d(Y,`
`)}}},Se.fences=function(oe){var ce=this.rules.block.fences.exec(oe);if(ce){var Y=ce[0],I=K(Y,ce[3]||"");return{type:"code",raw:Y,lang:ce[2]?ce[2].trim():ce[2],text:I}}},Se.heading=function(oe){var ce=this.rules.block.heading.exec(oe);if(ce){var Y=ce[2].trim();if(/#$/.test(Y)){var I=d(Y,"#");(this.options.pedantic||!I||/ $/.test(I))&&(Y=I.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:Y,tokens:this.lexer.inline(Y)}}},Se.hr=function(oe){var ce=this.rules.block.hr.exec(oe);if(ce)return{type:"hr",raw:ce[0]}},Se.blockquote=function(oe){var ce=this.rules.block.blockquote.exec(oe);if(ce){var Y=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(Y,[]),text:Y}}},Se.list=function(oe){var ce=this.rules.block.list.exec(oe);if(ce){var Y,I,$,W,q,ie,fe,ye,ae,ve,Ee,We,He=ce[1].trim(),tt=He.length>1,Xe={type:"list",raw:"",ordered:tt,start:tt?+He.slice(0,-1):"",loose:!1,items:[]};He=tt?"\\d{1,9}\\"+He.slice(-1):"\\"+He,this.options.pedantic&&(He=tt?He:"[*+-]");for(var et=new RegExp("^( {0,3}"+He+")((?:[	 ][^\\n]*)?(?:\\n|$))");oe&&(We=!1,!(!(ce=et.exec(oe))||this.rules.block.hr.test(oe)));){if(Y=ce[0],oe=oe.substring(Y.length),ye=ce[2].split(`
`,1)[0],ae=oe.split(`
`,1)[0],this.options.pedantic?(W=2,Ee=ye.trimLeft()):(W=ce[2].search(/[^ ]/),W=W>4?1:W,Ee=ye.slice(W),W+=ce[1].length),ie=!1,!ye&&/^ *$/.test(ae)&&(Y+=ae+`
`,oe=oe.substring(ae.length+1),We=!0),!We)for(var it=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),dt=new RegExp("^ {0,"+Math.min(3,W-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Fe=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:```|~~~)"),ot=new RegExp("^ {0,"+Math.min(3,W-1)+"}#");oe&&(ve=oe.split(`
`,1)[0],ye=ve,this.options.pedantic&&(ye=ye.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Fe.test(ye)||ot.test(ye)||it.test(ye)||dt.test(oe)));){if(ye.search(/[^ ]/)>=W||!ye.trim())Ee+=`
`+ye.slice(W);else if(!ie)Ee+=`
`+ye;else break;!ie&&!ye.trim()&&(ie=!0),Y+=ve+`
`,oe=oe.substring(ve.length+1)}Xe.loose||(fe?Xe.loose=!0:/\n *\n *$/.test(Y)&&(fe=!0)),this.options.gfm&&(I=/^\[[ xX]\] /.exec(Ee),I&&($=I[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:Y,task:!!I,checked:$,loose:!1,text:Ee}),Xe.raw+=Y}Xe.items[Xe.items.length-1].raw=Y.trimRight(),Xe.items[Xe.items.length-1].text=Ee.trimRight(),Xe.raw=Xe.raw.trimRight();var Q=Xe.items.length;for(q=0;q<Q;q++){this.lexer.state.top=!1,Xe.items[q].tokens=this.lexer.blockTokens(Xe.items[q].text,[]);var G=Xe.items[q].tokens.filter(function(Me){return Me.type==="space"}),pe=G.every(function(Me){for(var ze=Me.raw.split(""),Ve=0,_e=M(ze),nt;!(nt=_e()).done;){var vt=nt.value;if(vt===`
`&&(Ve+=1),Ve>1)return!0}return!1});!Xe.loose&&G.length&&pe&&(Xe.loose=!0,Xe.items[q].loose=!0)}return Xe}},Se.html=function(oe){var ce=this.rules.block.html.exec(oe);if(ce){var Y={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var I=this.options.sanitizer?this.options.sanitizer(ce[0]):m(ce[0]);Y.type="paragraph",Y.text=I,Y.tokens=this.lexer.inline(I)}return Y}},Se.def=function(oe){var ce=this.rules.block.def.exec(oe);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var Y=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Y,raw:ce[0],href:ce[2],title:ce[3]}}},Se.table=function(oe){var ce=this.rules.block.table.exec(oe);if(ce){var Y={type:"table",header:s(ce[1]).map(function(fe){return{text:fe}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Y.header.length===Y.align.length){Y.raw=ce[0];var I=Y.align.length,$,W,q,ie;for($=0;$<I;$++)/^ *-+: *$/.test(Y.align[$])?Y.align[$]="right":/^ *:-+: *$/.test(Y.align[$])?Y.align[$]="center":/^ *:-+ *$/.test(Y.align[$])?Y.align[$]="left":Y.align[$]=null;for(I=Y.rows.length,$=0;$<I;$++)Y.rows[$]=s(Y.rows[$],Y.header.length).map(function(fe){return{text:fe}});for(I=Y.header.length,W=0;W<I;W++)Y.header[W].tokens=this.lexer.inline(Y.header[W].text);for(I=Y.rows.length,W=0;W<I;W++)for(ie=Y.rows[W],q=0;q<ie.length;q++)ie[q].tokens=this.lexer.inline(ie[q].text);return Y}}},Se.lheading=function(oe){var ce=this.rules.block.lheading.exec(oe);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},Se.paragraph=function(oe){var ce=this.rules.block.paragraph.exec(oe);if(ce){var Y=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:Y,tokens:this.lexer.inline(Y)}}},Se.text=function(oe){var ce=this.rules.block.text.exec(oe);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},Se.escape=function(oe){var ce=this.rules.inline.escape.exec(oe);if(ce)return{type:"escape",raw:ce[0],text:m(ce[1])}},Se.tag=function(oe){var ce=this.rules.inline.tag.exec(oe);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):m(ce[0]):ce[0]}},Se.link=function(oe){var ce=this.rules.inline.link.exec(oe);if(ce){var Y=ce[2].trim();if(!this.options.pedantic&&/^</.test(Y)){if(!/>$/.test(Y))return;var I=d(Y.slice(0,-1),"\\");if((Y.length-I.length)%2===0)return}else{var $=T(ce[2],"()");if($>-1){var W=ce[0].indexOf("!")===0?5:4,q=W+ce[1].length+$;ce[2]=ce[2].substring(0,$),ce[0]=ce[0].substring(0,q).trim(),ce[3]=""}}var ie=ce[2],fe="";if(this.options.pedantic){var ye=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ie);ye&&(ie=ye[1],fe=ye[3])}else fe=ce[3]?ce[3].slice(1,-1):"";return ie=ie.trim(),/^</.test(ie)&&(this.options.pedantic&&!/>$/.test(Y)?ie=ie.slice(1):ie=ie.slice(1,-1)),J(ce,{href:ie&&ie.replace(this.rules.inline._escapes,"$1"),title:fe&&fe.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},Se.reflink=function(oe,ce){var Y;if((Y=this.rules.inline.reflink.exec(oe))||(Y=this.rules.inline.nolink.exec(oe))){var I=(Y[2]||Y[1]).replace(/\s+/g," ");if(I=ce[I.toLowerCase()],!I||!I.href){var $=Y[0].charAt(0);return{type:"text",raw:$,text:$}}return J(Y,I,Y[0],this.lexer)}},Se.emStrong=function(oe,ce,Y){Y===void 0&&(Y="");var I=this.rules.inline.emStrong.lDelim.exec(oe);if(!!I&&!(I[3]&&Y.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var $=I[1]||I[2]||"";if(!$||$&&(Y===""||this.rules.inline.punctuation.exec(Y))){var W=I[0].length-1,q,ie,fe=W,ye=0,ae=I[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ae.lastIndex=0,ce=ce.slice(-1*oe.length+W);(I=ae.exec(ce))!=null;)if(q=I[1]||I[2]||I[3]||I[4]||I[5]||I[6],!!q){if(ie=q.length,I[3]||I[4]){fe+=ie;continue}else if((I[5]||I[6])&&W%3&&!((W+ie)%3)){ye+=ie;continue}if(fe-=ie,!(fe>0)){if(ie=Math.min(ie,ie+fe+ye),Math.min(W,ie)%2){var ve=oe.slice(1,W+I.index+ie);return{type:"em",raw:oe.slice(0,W+I.index+ie+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}var Ee=oe.slice(2,W+I.index+ie-1);return{type:"strong",raw:oe.slice(0,W+I.index+ie+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}}}}},Se.codespan=function(oe){var ce=this.rules.inline.code.exec(oe);if(ce){var Y=ce[2].replace(/\n/g," "),I=/[^ ]/.test(Y),$=/^ /.test(Y)&&/ $/.test(Y);return I&&$&&(Y=Y.substring(1,Y.length-1)),Y=m(Y,!0),{type:"codespan",raw:ce[0],text:Y}}},Se.br=function(oe){var ce=this.rules.inline.br.exec(oe);if(ce)return{type:"br",raw:ce[0]}},Se.del=function(oe){var ce=this.rules.inline.del.exec(oe);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},Se.autolink=function(oe,ce){var Y=this.rules.inline.autolink.exec(oe);if(Y){var I,$;return Y[2]==="@"?(I=m(this.options.mangle?ce(Y[1]):Y[1]),$="mailto:"+I):(I=m(Y[1]),$=I),{type:"link",raw:Y[0],text:I,href:$,tokens:[{type:"text",raw:I,text:I}]}}},Se.url=function(oe,ce){var Y;if(Y=this.rules.inline.url.exec(oe)){var I,$;if(Y[2]==="@")I=m(this.options.mangle?ce(Y[0]):Y[0]),$="mailto:"+I;else{var W;do W=Y[0],Y[0]=this.rules.inline._backpedal.exec(Y[0])[0];while(W!==Y[0]);I=m(Y[0]),Y[1]==="www."?$="http://"+I:$=I}return{type:"link",raw:Y[0],text:I,href:$,tokens:[{type:"text",raw:I,text:I}]}}},Se.inlineText=function(oe,ce){var Y=this.rules.inline.text.exec(oe);if(Y){var I;return this.lexer.state.inRawBlock?I=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):m(Y[0]):Y[0]:I=m(this.options.smartypants?ce(Y[0]):Y[0]),{type:"text",raw:Y[0],text:I}}},Pe}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:p,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=g(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=g(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=g(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=g(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=g(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=g(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=c({},B),B.gfm=c({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=g(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=g(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=c({},B.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:p,paragraph:g(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var P={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:p,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:p,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};P._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",P.punctuation=g(P.punctuation).replace(/punctuation/g,P._punctuation).getRegex(),P.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,P.escapedEmSt=/\\\*|\\_/g,P._comment=g(B._comment).replace("(?:-->|$)","-->").getRegex(),P.emStrong.lDelim=g(P.emStrong.lDelim).replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimAst=g(P.emStrong.rDelimAst,"g").replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimUnd=g(P.emStrong.rDelimUnd,"g").replace(/punct/g,P._punctuation).getRegex(),P._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,P._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,P._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,P.autolink=g(P.autolink).replace("scheme",P._scheme).replace("email",P._email).getRegex(),P._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,P.tag=g(P.tag).replace("comment",P._comment).replace("attribute",P._attribute).getRegex(),P._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,P._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,P._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,P.link=g(P.link).replace("label",P._label).replace("href",P._href).replace("title",P._title).getRegex(),P.reflink=g(P.reflink).replace("label",P._label).replace("ref",B._label).getRegex(),P.nolink=g(P.nolink).replace("ref",B._label).getRegex(),P.reflinkSearch=g(P.reflinkSearch,"g").replace("reflink",P.reflink).replace("nolink",P.nolink).getRegex(),P.normal=c({},P),P.pedantic=c({},P.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",P._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",P._label).getRegex()}),P.gfm=c({},P.normal,{escape:g(P.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),P.gfm.url=g(P.gfm.url,"i").replace("email",P.gfm._extended_email).getRegex(),P.breaks=c({},P.gfm,{br:g(P.br).replace("{2,}","*").getRegex(),text:g(P.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(Pe){var Se="",Ie,oe,ce=Pe.length;for(Ie=0;Ie<ce;Ie++)oe=Pe.charCodeAt(Ie),Math.random()>.5&&(oe="x"+oe.toString(16)),Se+="&#"+oe+";";return Se}var j=function(){function Pe(Ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ie||te.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:B.normal,inline:P.normal};this.options.pedantic?(oe.block=B.pedantic,oe.inline=P.pedantic):this.options.gfm&&(oe.block=B.gfm,this.options.breaks?oe.inline=P.breaks:oe.inline=P.gfm),this.tokenizer.rules=oe}Pe.lex=function(oe,ce){var Y=new Pe(ce);return Y.lex(oe)},Pe.lexInline=function(oe,ce){var Y=new Pe(ce);return Y.inlineTokens(oe)};var Se=Pe.prototype;return Se.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`),this.blockTokens(oe,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},Se.blockTokens=function(oe,ce){var Y=this;ce===void 0&&(ce=[]),this.options.pedantic?oe=oe.replace(/\t/g,"    ").replace(/^ +$/gm,""):oe=oe.replace(/^( *)(\t+)/gm,function(fe,ye,ae){return ye+"    ".repeat(ae.length)});for(var I,$,W,q;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(fe){return(I=fe.call({lexer:Y},oe,ce))?(oe=oe.substring(I.raw.length),ce.push(I),!0):!1}))){if(I=this.tokenizer.space(oe)){oe=oe.substring(I.raw.length),I.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(I);continue}if(I=this.tokenizer.code(oe)){oe=oe.substring(I.raw.length),$=ce[ce.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue[this.inlineQueue.length-1].src=$.text):ce.push(I);continue}if(I=this.tokenizer.fences(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.heading(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.hr(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.blockquote(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.list(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.html(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.def(oe)){oe=oe.substring(I.raw.length),$=ce[ce.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+I.raw,$.text+=`
`+I.raw,this.inlineQueue[this.inlineQueue.length-1].src=$.text):this.tokens.links[I.tag]||(this.tokens.links[I.tag]={href:I.href,title:I.title});continue}if(I=this.tokenizer.table(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.lheading(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(W=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var fe=1/0,ye=oe.slice(1),ae=void 0;Y.options.extensions.startBlock.forEach(function(ve){ae=ve.call({lexer:this},ye),typeof ae=="number"&&ae>=0&&(fe=Math.min(fe,ae))}),fe<1/0&&fe>=0&&(W=oe.substring(0,fe+1))}(),this.state.top&&(I=this.tokenizer.paragraph(W))){$=ce[ce.length-1],q&&$.type==="paragraph"?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):ce.push(I),q=W.length!==oe.length,oe=oe.substring(I.raw.length);continue}if(I=this.tokenizer.text(oe)){oe=oe.substring(I.raw.length),$=ce[ce.length-1],$&&$.type==="text"?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):ce.push(I);continue}if(oe){var ie="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(ie);break}else throw new Error(ie)}}return this.state.top=!0,ce},Se.inline=function(oe,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:oe,tokens:ce}),ce},Se.inlineTokens=function(oe,ce){var Y=this;ce===void 0&&(ce=[]);var I,$,W,q=oe,ie,fe,ye;if(this.tokens.links){var ae=Object.keys(this.tokens.links);if(ae.length>0)for(;(ie=this.tokenizer.rules.inline.reflinkSearch.exec(q))!=null;)ae.includes(ie[0].slice(ie[0].lastIndexOf("[")+1,-1))&&(q=q.slice(0,ie.index)+"["+H("a",ie[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ie=this.tokenizer.rules.inline.blockSkip.exec(q))!=null;)q=q.slice(0,ie.index)+"["+H("a",ie[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ie=this.tokenizer.rules.inline.escapedEmSt.exec(q))!=null;)q=q.slice(0,ie.index)+"++"+q.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(fe||(ye=""),fe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ee){return(I=Ee.call({lexer:Y},oe,ce))?(oe=oe.substring(I.raw.length),ce.push(I),!0):!1}))){if(I=this.tokenizer.escape(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.tag(oe)){oe=oe.substring(I.raw.length),$=ce[ce.length-1],$&&I.type==="text"&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):ce.push(I);continue}if(I=this.tokenizer.link(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(I.raw.length),$=ce[ce.length-1],$&&I.type==="text"&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):ce.push(I);continue}if(I=this.tokenizer.emStrong(oe,q,ye)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.codespan(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.br(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.del(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.autolink(oe,V)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(!this.state.inLink&&(I=this.tokenizer.url(oe,V))){oe=oe.substring(I.raw.length),ce.push(I);continue}if(W=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var Ee=1/0,We=oe.slice(1),He=void 0;Y.options.extensions.startInline.forEach(function(tt){He=tt.call({lexer:this},We),typeof He=="number"&&He>=0&&(Ee=Math.min(Ee,He))}),Ee<1/0&&Ee>=0&&(W=oe.substring(0,Ee+1))}(),I=this.tokenizer.inlineText(W,F)){oe=oe.substring(I.raw.length),I.raw.slice(-1)!=="_"&&(ye=I.raw.slice(-1)),fe=!0,$=ce[ce.length-1],$&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):ce.push(I);continue}if(oe){var ve="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(ve);break}else throw new Error(ve)}}return ce},n(Pe,null,[{key:"rules",get:function(){return{block:B,inline:P}}}]),Pe}(),le=function(){function Pe(Ie){this.options=Ie||te.defaults}var Se=Pe.prototype;return Se.code=function(oe,ce,Y){var I=(ce||"").match(/\S*/)[0];if(this.options.highlight){var $=this.options.highlight(oe,I);$!=null&&$!==oe&&(Y=!0,oe=$)}return oe=oe.replace(/\n$/,"")+`
`,I?'<pre><code class="'+this.options.langPrefix+m(I,!0)+'">'+(Y?oe:m(oe,!0))+`</code></pre>
`:"<pre><code>"+(Y?oe:m(oe,!0))+`</code></pre>
`},Se.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},Se.html=function(oe){return oe},Se.heading=function(oe,ce,Y,I){if(this.options.headerIds){var $=this.options.headerPrefix+I.slug(Y);return"<h"+ce+' id="'+$+'">'+oe+"</h"+ce+`>
`}return"<h"+ce+">"+oe+"</h"+ce+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(oe,ce,Y){var I=ce?"ol":"ul",$=ce&&Y!==1?' start="'+Y+'"':"";return"<"+I+$+`>
`+oe+"</"+I+`>
`},Se.listitem=function(oe){return"<li>"+oe+`</li>
`},Se.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(oe){return"<p>"+oe+`</p>
`},Se.table=function(oe,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+ce+`</table>
`},Se.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},Se.tablecell=function(oe,ce){var Y=ce.header?"th":"td",I=ce.align?"<"+Y+' align="'+ce.align+'">':"<"+Y+">";return I+oe+("</"+Y+`>
`)},Se.strong=function(oe){return"<strong>"+oe+"</strong>"},Se.em=function(oe){return"<em>"+oe+"</em>"},Se.codespan=function(oe){return"<code>"+oe+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(oe){return"<del>"+oe+"</del>"},Se.link=function(oe,ce,Y){if(oe=v(this.options.sanitize,this.options.baseUrl,oe),oe===null)return Y;var I='<a href="'+m(oe)+'"';return ce&&(I+=' title="'+ce+'"'),I+=">"+Y+"</a>",I},Se.image=function(oe,ce,Y){if(oe=v(this.options.sanitize,this.options.baseUrl,oe),oe===null)return Y;var I='<img src="'+oe+'" alt="'+Y+'"';return ce&&(I+=' title="'+ce+'"'),I+=this.options.xhtml?"/>":">",I},Se.text=function(oe){return oe},Pe}(),_=function(){function Pe(){}var Se=Pe.prototype;return Se.strong=function(oe){return oe},Se.em=function(oe){return oe},Se.codespan=function(oe){return oe},Se.del=function(oe){return oe},Se.html=function(oe){return oe},Se.text=function(oe){return oe},Se.link=function(oe,ce,Y){return""+Y},Se.image=function(oe,ce,Y){return""+Y},Se.br=function(){return""},Pe}(),be=function(){function Pe(){this.seen={}}var Se=Pe.prototype;return Se.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(oe,ce){var Y=oe,I=0;if(this.seen.hasOwnProperty(Y)){I=this.seen[oe];do I++,Y=oe+"-"+I;while(this.seen.hasOwnProperty(Y))}return ce||(this.seen[oe]=I,this.seen[Y]=0),Y},Se.slug=function(oe,ce){ce===void 0&&(ce={});var Y=this.serialize(oe);return this.getNextSafeSlug(Y,ce.dryrun)},Pe}(),de=function(){function Pe(Ie){this.options=Ie||te.defaults,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _,this.slugger=new be}Pe.parse=function(oe,ce){var Y=new Pe(ce);return Y.parse(oe)},Pe.parseInline=function(oe,ce){var Y=new Pe(ce);return Y.parseInline(oe)};var Se=Pe.prototype;return Se.parse=function(oe,ce){ce===void 0&&(ce=!0);var Y="",I,$,W,q,ie,fe,ye,ae,ve,Ee,We,He,tt,Xe,et,it,dt,Fe,ot,Q=oe.length;for(I=0;I<Q;I++){if(Ee=oe[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(ot=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),ot!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ee.type))){Y+=ot||"";continue}switch(Ee.type){case"space":continue;case"hr":{Y+=this.renderer.hr();continue}case"heading":{Y+=this.renderer.heading(this.parseInline(Ee.tokens),Ee.depth,o(this.parseInline(Ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{Y+=this.renderer.code(Ee.text,Ee.lang,Ee.escaped);continue}case"table":{for(ae="",ye="",q=Ee.header.length,$=0;$<q;$++)ye+=this.renderer.tablecell(this.parseInline(Ee.header[$].tokens),{header:!0,align:Ee.align[$]});for(ae+=this.renderer.tablerow(ye),ve="",q=Ee.rows.length,$=0;$<q;$++){for(fe=Ee.rows[$],ye="",ie=fe.length,W=0;W<ie;W++)ye+=this.renderer.tablecell(this.parseInline(fe[W].tokens),{header:!1,align:Ee.align[W]});ve+=this.renderer.tablerow(ye)}Y+=this.renderer.table(ae,ve);continue}case"blockquote":{ve=this.parse(Ee.tokens),Y+=this.renderer.blockquote(ve);continue}case"list":{for(We=Ee.ordered,He=Ee.start,tt=Ee.loose,q=Ee.items.length,ve="",$=0;$<q;$++)et=Ee.items[$],it=et.checked,dt=et.task,Xe="",et.task&&(Fe=this.renderer.checkbox(it),tt?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=Fe+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=Fe+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:Fe}):Xe+=Fe),Xe+=this.parse(et.tokens,tt),ve+=this.renderer.listitem(Xe,dt,it);Y+=this.renderer.list(ve,We,He);continue}case"html":{Y+=this.renderer.html(Ee.text);continue}case"paragraph":{Y+=this.renderer.paragraph(this.parseInline(Ee.tokens));continue}case"text":{for(ve=Ee.tokens?this.parseInline(Ee.tokens):Ee.text;I+1<Q&&oe[I+1].type==="text";)Ee=oe[++I],ve+=`
`+(Ee.tokens?this.parseInline(Ee.tokens):Ee.text);Y+=ce?this.renderer.paragraph(ve):ve;continue}default:{var G='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(G);return}else throw new Error(G)}}}return Y},Se.parseInline=function(oe,ce){ce=ce||this.renderer;var Y="",I,$,W,q=oe.length;for(I=0;I<q;I++){if($=oe[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[$.type]&&(W=this.options.extensions.renderers[$.type].call({parser:this},$),W!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes($.type))){Y+=W||"";continue}switch($.type){case"escape":{Y+=ce.text($.text);break}case"html":{Y+=ce.html($.text);break}case"link":{Y+=ce.link($.href,$.title,this.parseInline($.tokens,ce));break}case"image":{Y+=ce.image($.href,$.title,$.text);break}case"strong":{Y+=ce.strong(this.parseInline($.tokens,ce));break}case"em":{Y+=ce.em(this.parseInline($.tokens,ce));break}case"codespan":{Y+=ce.codespan($.text);break}case"br":{Y+=ce.br();break}case"del":{Y+=ce.del(this.parseInline($.tokens,ce));break}case"text":{Y+=ce.text($.text);break}default:{var ie='Token with "'+$.type+'" type was not found.';if(this.options.silent){console.error(ie);return}else throw new Error(ie)}}}return Y},Pe}();function ue(Pe,Se,Ie){if(typeof Pe>"u"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof Se=="function"&&(Ie=Se,Se=null),Se=c({},ue.defaults,Se||{}),O(Se),Ie){var oe=Se.highlight,ce;try{ce=j.lex(Pe,Se)}catch(q){return Ie(q)}var Y=function(ie){var fe;if(!ie)try{Se.walkTokens&&ue.walkTokens(ce,Se.walkTokens),fe=de.parse(ce,Se)}catch(ye){ie=ye}return Se.highlight=oe,ie?Ie(ie):Ie(null,fe)};if(!oe||oe.length<3||(delete Se.highlight,!ce.length))return Y();var I=0;ue.walkTokens(ce,function(q){q.type==="code"&&(I++,setTimeout(function(){oe(q.text,q.lang,function(ie,fe){if(ie)return Y(ie);fe!=null&&fe!==q.text&&(q.text=fe,q.escaped=!0),I--,I===0&&Y()})},0))}),I===0&&Y();return}function $(q){if(q.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+m(q.message+"",!0)+"</pre>";throw q}try{var W=j.lex(Pe,Se);if(Se.walkTokens){if(Se.async)return Promise.all(ue.walkTokens(W,Se.walkTokens)).then(function(){return de.parse(W,Se)}).catch($);ue.walkTokens(W,Se.walkTokens)}return de.parse(W,Se)}catch(q){$(q)}}ue.options=ue.setOptions=function(Pe){return c(ue.defaults,Pe),R(ue.defaults),ue},ue.getDefaults=S,ue.defaults=te.defaults,ue.use=function(){for(var Pe=arguments.length,Se=new Array(Pe),Ie=0;Ie<Pe;Ie++)Se[Ie]=arguments[Ie];var oe=c.apply(void 0,[{}].concat(Se)),ce=ue.defaults.extensions||{renderers:{},childTokens:{}},Y;Se.forEach(function(I){if(I.extensions&&(Y=!0,I.extensions.forEach(function(W){if(!W.name)throw new Error("extension name required");if(W.renderer){var q=ce.renderers?ce.renderers[W.name]:null;q?ce.renderers[W.name]=function(){for(var ie=arguments.length,fe=new Array(ie),ye=0;ye<ie;ye++)fe[ye]=arguments[ye];var ae=W.renderer.apply(this,fe);return ae===!1&&(ae=q.apply(this,fe)),ae}:ce.renderers[W.name]=W.renderer}if(W.tokenizer){if(!W.level||W.level!=="block"&&W.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[W.level]?ce[W.level].unshift(W.tokenizer):ce[W.level]=[W.tokenizer],W.start&&(W.level==="block"?ce.startBlock?ce.startBlock.push(W.start):ce.startBlock=[W.start]:W.level==="inline"&&(ce.startInline?ce.startInline.push(W.start):ce.startInline=[W.start]))}W.childTokens&&(ce.childTokens[W.name]=W.childTokens)})),I.renderer&&function(){var W=ue.defaults.renderer||new le,q=function(ye){var ae=W[ye];W[ye]=function(){for(var ve=arguments.length,Ee=new Array(ve),We=0;We<ve;We++)Ee[We]=arguments[We];var He=I.renderer[ye].apply(W,Ee);return He===!1&&(He=ae.apply(W,Ee)),He}};for(var ie in I.renderer)q(ie);oe.renderer=W}(),I.tokenizer&&function(){var W=ue.defaults.tokenizer||new L,q=function(ye){var ae=W[ye];W[ye]=function(){for(var ve=arguments.length,Ee=new Array(ve),We=0;We<ve;We++)Ee[We]=arguments[We];var He=I.tokenizer[ye].apply(W,Ee);return He===!1&&(He=ae.apply(W,Ee)),He}};for(var ie in I.tokenizer)q(ie);oe.tokenizer=W}(),I.walkTokens){var $=ue.defaults.walkTokens;oe.walkTokens=function(W){var q=[];return q.push(I.walkTokens.call(this,W)),$&&(q=q.concat($.call(this,W))),q}}Y&&(oe.extensions=ce),ue.setOptions(oe)})},ue.walkTokens=function(Pe,Se){for(var Ie=[],oe=function(){var $=Y.value;switch(Ie=Ie.concat(Se.call(ue,$)),$.type){case"table":{for(var W=M($.header),q;!(q=W()).done;){var ie=q.value;Ie=Ie.concat(ue.walkTokens(ie.tokens,Se))}for(var fe=M($.rows),ye;!(ye=fe()).done;)for(var ae=ye.value,ve=M(ae),Ee;!(Ee=ve()).done;){var We=Ee.value;Ie=Ie.concat(ue.walkTokens(We.tokens,Se))}break}case"list":{Ie=Ie.concat(ue.walkTokens($.items,Se));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[$.type]?ue.defaults.extensions.childTokens[$.type].forEach(function(He){Ie=Ie.concat(ue.walkTokens($[He],Se))}):$.tokens&&(Ie=Ie.concat(ue.walkTokens($.tokens,Se)))}},ce=M(Pe),Y;!(Y=ce()).done;)oe();return Ie},ue.parseInline=function(Pe,Se){if(typeof Pe>"u"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");Se=c({},ue.defaults,Se||{}),O(Se);try{var Ie=j.lexInline(Pe,Se);return Se.walkTokens&&ue.walkTokens(Ie,Se.walkTokens),de.parseInline(Ie,Se)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+m(oe.message+"",!0)+"</pre>";throw oe}},ue.Parser=de,ue.parser=de.parse,ue.Renderer=le,ue.TextRenderer=_,ue.Lexer=j,ue.lexer=j.lex,ue.Tokenizer=L,ue.Slugger=be,ue.parse=ue;var se=ue.options,Z=ue.setOptions,X=ue.use,ee=ue.walkTokens,he=ue.parseInline,Te=ue,Ne=de.parse,Ke=j.lex;te.Lexer=j,te.Parser=de,te.Renderer=le,te.Slugger=be,te.TextRenderer=_,te.Tokenizer=L,te.getDefaults=S,te.lexer=Ke,te.marked=ue,te.options=se,te.parse=Te,te.parseInline=he,te.parser=Ne,te.setOptions=Z,te.use=X,te.walkTokens=ee,Object.defineProperty(te,"__esModule",{value:!0})}),define(Ce[113],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function n(R,y,k){return Math.min(Math.max(R,y),k)}e.clamp=n;function C(R,y){return(y+R%y)%y}e.rot=C;class D{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=D;class M{constructor(){this.a=1,this.b=0}update(y){return this.b=this.b+(y-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=M;class S{constructor(y){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(y),this.c.fill(0,0,y)}update(y){const k=this.c[this.d];return this.c[this.d]=y,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=y,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=S}),function(){function te(D){const M=[];typeof D=="number"&&M.push("code/timeOrigin",D);function S(y){M.push(y,Date.now())}function R(){const y=[];for(let k=0;k<M.length;k+=2)y.push({name:M[k],startTime:M[k+1]});return y}return{mark:S,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const S of performance.getEntriesByType("mark"))M.push({name:S.name,startTime:Math.round(D+S.startTime)});return M}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function n(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=n(C))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var C in n)(typeof exports=="object"?exports:te)[C]=n[C]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function n(C){if(e[C])return e[C].exports;var D=e[C]={i:C,l:!1,exports:{}};return te[C].call(D.exports,D,D.exports,n),D.l=!0,D.exports}return n.m=te,n.c=e,n.d=function(C,D,M){n.o(C,D)||Object.defineProperty(C,D,{enumerable:!0,get:M})},n.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},n.t=function(C,D){if(1&D&&(C=n(C)),8&D||4&D&&typeof C=="object"&&C&&C.__esModule)return C;var M=Object.create(null);if(n.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:C}),2&D&&typeof C!="string")for(var S in C)n.d(M,S,function(R){return C[R]}.bind(null,S));return M},n.n=function(C){var D=C&&C.__esModule?function(){return C.default}:function(){return C};return n.d(D,"a",D),D},n.o=function(C,D){return Object.prototype.hasOwnProperty.call(C,D)},n.p="",n(n.s=0)}([function(te,e,n){(function(C){var D;e=te.exports=X,D=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,S=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],y=e.src=[],k=0,N=k++;y[N]="0|[1-9]\\d*";var w=k++;y[w]="[0-9]+";var f=k++;y[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=k++;y[b]="("+y[N]+")\\.("+y[N]+")\\.("+y[N]+")";var m=k++;y[m]="("+y[w]+")\\.("+y[w]+")\\.("+y[w]+")";var a=k++;y[a]="(?:"+y[N]+"|"+y[f]+")";var o=k++;y[o]="(?:"+y[w]+"|"+y[f]+")";var l=k++;y[l]="(?:-("+y[a]+"(?:\\."+y[a]+")*))";var g=k++;y[g]="(?:-?("+y[o]+"(?:\\."+y[o]+")*))";var E=k++;y[E]="[0-9A-Za-z-]+";var A=k++;y[A]="(?:\\+("+y[E]+"(?:\\."+y[E]+")*))";var v=k++,t="v?"+y[b]+y[l]+"?"+y[A]+"?";y[v]="^"+t+"$";var h="[v=\\s]*"+y[m]+y[g]+"?"+y[A]+"?",r=k++;y[r]="^"+h+"$";var u=k++;y[u]="((?:<|>)?=?)";var i=k++;y[i]=y[w]+"|x|X|\\*";var p=k++;y[p]=y[N]+"|x|X|\\*";var c=k++;y[c]="[v=\\s]*("+y[p]+")(?:\\.("+y[p]+")(?:\\.("+y[p]+")(?:"+y[l]+")?"+y[A]+"?)?)?";var s=k++;y[s]="[v=\\s]*("+y[i]+")(?:\\.("+y[i]+")(?:\\.("+y[i]+")(?:"+y[g]+")?"+y[A]+"?)?)?";var d=k++;y[d]="^"+y[u]+"\\s*"+y[c]+"$";var T=k++;y[T]="^"+y[u]+"\\s*"+y[s]+"$";var O=k++;y[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var H=k++;y[H]="(?:~>?)";var J=k++;y[J]="(\\s*)"+y[H]+"\\s+",R[J]=new RegExp(y[J],"g");var K=k++;y[K]="^"+y[H]+y[c]+"$";var L=k++;y[L]="^"+y[H]+y[s]+"$";var B=k++;y[B]="(?:\\^)";var P=k++;y[P]="(\\s*)"+y[B]+"\\s+",R[P]=new RegExp(y[P],"g");var F=k++;y[F]="^"+y[B]+y[c]+"$";var V=k++;y[V]="^"+y[B]+y[s]+"$";var j=k++;y[j]="^"+y[u]+"\\s*("+h+")$|^$";var le=k++;y[le]="^"+y[u]+"\\s*("+t+")$|^$";var _=k++;y[_]="(\\s*)"+y[u]+"\\s*("+h+"|"+y[c]+")",R[_]=new RegExp(y[_],"g");var be=k++;y[be]="^\\s*("+y[c]+")\\s+-\\s+("+y[c]+")\\s*$";var de=k++;y[de]="^\\s*("+y[s]+")\\s+-\\s+("+y[s]+")\\s*$";var ue=k++;y[ue]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)D(se,y[se]),R[se]||(R[se]=new RegExp(y[se]));function Z(ae,ve){if(ae instanceof X)return ae;if(typeof ae!="string"||ae.length>M||!(ve?R[r]:R[v]).test(ae))return null;try{return new X(ae,ve)}catch{return null}}function X(ae,ve){if(ae instanceof X){if(ae.loose===ve)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof X))return new X(ae,ve);D("SemVer",ae,ve),this.loose=ve;var Ee=ae.trim().match(ve?R[r]:R[v]);if(!Ee)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+Ee[1],this.minor=+Ee[2],this.patch=+Ee[3],this.major>S||this.major<0)throw new TypeError("Invalid major version");if(this.minor>S||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>S||this.patch<0)throw new TypeError("Invalid patch version");Ee[4]?this.prerelease=Ee[4].split(".").map(function(We){if(/^[0-9]+$/.test(We)){var He=+We;if(He>=0&&He<S)return He}return We}):this.prerelease=[],this.build=Ee[5]?Ee[5].split("."):[],this.format()}e.parse=Z,e.valid=function(ae,ve){var Ee=Z(ae,ve);return Ee?Ee.version:null},e.clean=function(ae,ve){var Ee=Z(ae.trim().replace(/^[=v]+/,""),ve);return Ee?Ee.version:null},e.SemVer=X,X.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},X.prototype.toString=function(){return this.version},X.prototype.compare=function(ae){return D("SemVer.compare",this.version,this.loose,ae),ae instanceof X||(ae=new X(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},X.prototype.compareMain=function(ae){return ae instanceof X||(ae=new X(ae,this.loose)),he(this.major,ae.major)||he(this.minor,ae.minor)||he(this.patch,ae.patch)},X.prototype.comparePre=function(ae){if(ae instanceof X||(ae=new X(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var ve=0;do{var Ee=this.prerelease[ve],We=ae.prerelease[ve];if(D("prerelease compare",ve,Ee,We),Ee===void 0&&We===void 0)return 0;if(We===void 0)return 1;if(Ee===void 0)return-1;if(Ee!==We)return he(Ee,We)}while(++ve)},X.prototype.inc=function(ae,ve){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ve);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ve);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ve),this.inc("pre",ve);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ve),this.inc("pre",ve);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ee=this.prerelease.length;--Ee>=0;)typeof this.prerelease[Ee]=="number"&&(this.prerelease[Ee]++,Ee=-2);Ee===-1&&this.prerelease.push(0)}ve&&(this.prerelease[0]===ve?isNaN(this.prerelease[1])&&(this.prerelease=[ve,0]):this.prerelease=[ve,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,ve,Ee,We){typeof Ee=="string"&&(We=Ee,Ee=void 0);try{return new X(ae,Ee).inc(ve,We).version}catch{return null}},e.diff=function(ae,ve){if(Pe(ae,ve))return null;var Ee=Z(ae),We=Z(ve);if(Ee.prerelease.length||We.prerelease.length){for(var He in Ee)if((He==="major"||He==="minor"||He==="patch")&&Ee[He]!==We[He])return"pre"+He;return"prerelease"}for(var He in Ee)if((He==="major"||He==="minor"||He==="patch")&&Ee[He]!==We[He])return He},e.compareIdentifiers=he;var ee=/^[0-9]+$/;function he(ae,ve){var Ee=ee.test(ae),We=ee.test(ve);return Ee&&We&&(ae=+ae,ve=+ve),Ee&&!We?-1:We&&!Ee?1:ae<ve?-1:ae>ve?1:0}function Te(ae,ve,Ee){return new X(ae,Ee).compare(new X(ve,Ee))}function Ne(ae,ve,Ee){return Te(ae,ve,Ee)>0}function Ke(ae,ve,Ee){return Te(ae,ve,Ee)<0}function Pe(ae,ve,Ee){return Te(ae,ve,Ee)===0}function Se(ae,ve,Ee){return Te(ae,ve,Ee)!==0}function Ie(ae,ve,Ee){return Te(ae,ve,Ee)>=0}function oe(ae,ve,Ee){return Te(ae,ve,Ee)<=0}function ce(ae,ve,Ee,We){var He;switch(ve){case"===":typeof ae=="object"&&(ae=ae.version),typeof Ee=="object"&&(Ee=Ee.version),He=ae===Ee;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof Ee=="object"&&(Ee=Ee.version),He=ae!==Ee;break;case"":case"=":case"==":He=Pe(ae,Ee,We);break;case"!=":He=Se(ae,Ee,We);break;case">":He=Ne(ae,Ee,We);break;case">=":He=Ie(ae,Ee,We);break;case"<":He=Ke(ae,Ee,We);break;case"<=":He=oe(ae,Ee,We);break;default:throw new TypeError("Invalid operator: "+ve)}return He}function Y(ae,ve){if(ae instanceof Y){if(ae.loose===ve)return ae;ae=ae.value}if(!(this instanceof Y))return new Y(ae,ve);D("comparator",ae,ve),this.loose=ve,this.parse(ae),this.semver===I?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ae,ve){return he(ve,ae)},e.major=function(ae,ve){return new X(ae,ve).major},e.minor=function(ae,ve){return new X(ae,ve).minor},e.patch=function(ae,ve){return new X(ae,ve).patch},e.compare=Te,e.compareLoose=function(ae,ve){return Te(ae,ve,!0)},e.rcompare=function(ae,ve,Ee){return Te(ve,ae,Ee)},e.sort=function(ae,ve){return ae.sort(function(Ee,We){return e.compare(Ee,We,ve)})},e.rsort=function(ae,ve){return ae.sort(function(Ee,We){return e.rcompare(Ee,We,ve)})},e.gt=Ne,e.lt=Ke,e.eq=Pe,e.neq=Se,e.gte=Ie,e.lte=oe,e.cmp=ce,e.Comparator=Y;var I={};function $(ae,ve){if(ae instanceof $)return ae.loose===ve?ae:new $(ae.raw,ve);if(ae instanceof Y)return new $(ae.value,ve);if(!(this instanceof $))return new $(ae,ve);if(this.loose=ve,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(Ee){return this.parseRange(Ee.trim())},this).filter(function(Ee){return Ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function W(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function q(ae,ve,Ee,We,He,tt,Xe,et,it,dt,Fe,ot,Q){return((ve=W(Ee)?"":W(We)?">="+Ee+".0.0":W(He)?">="+Ee+"."+We+".0":">="+ve)+" "+(et=W(it)?"":W(dt)?"<"+(+it+1)+".0.0":W(Fe)?"<"+it+"."+(+dt+1)+".0":ot?"<="+it+"."+dt+"."+Fe+"-"+ot:"<="+et)).trim()}function ie(ae,ve){for(var Ee=0;Ee<ae.length;Ee++)if(!ae[Ee].test(ve))return!1;if(ve.prerelease.length){for(Ee=0;Ee<ae.length;Ee++)if(D(ae[Ee].semver),ae[Ee].semver!==I&&ae[Ee].semver.prerelease.length>0){var We=ae[Ee].semver;if(We.major===ve.major&&We.minor===ve.minor&&We.patch===ve.patch)return!0}return!1}return!0}function fe(ae,ve,Ee){try{ve=new $(ve,Ee)}catch{return!1}return ve.test(ae)}function ye(ae,ve,Ee,We){var He,tt,Xe,et,it;switch(ae=new X(ae,We),ve=new $(ve,We),Ee){case">":He=Ne,tt=oe,Xe=Ke,et=">",it=">=";break;case"<":He=Ke,tt=Ie,Xe=Ne,et="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(fe(ae,ve,We))return!1;for(var dt=0;dt<ve.set.length;++dt){var Fe=ve.set[dt],ot=null,Q=null;if(Fe.forEach(function(G){G.semver===I&&(G=new Y(">=0.0.0")),ot=ot||G,Q=Q||G,He(G.semver,ot.semver,We)?ot=G:Xe(G.semver,Q.semver,We)&&(Q=G)}),ot.operator===et||ot.operator===it||(!Q.operator||Q.operator===et)&&tt(ae,Q.semver)||Q.operator===it&&Xe(ae,Q.semver))return!1}return!0}Y.prototype.parse=function(ae){var ve=this.loose?R[j]:R[le],Ee=ae.match(ve);if(!Ee)throw new TypeError("Invalid comparator: "+ae);this.operator=Ee[1],this.operator==="="&&(this.operator=""),Ee[2]?this.semver=new X(Ee[2],this.loose):this.semver=I},Y.prototype.toString=function(){return this.value},Y.prototype.test=function(ae){return D("Comparator.test",ae,this.loose),this.semver===I||(typeof ae=="string"&&(ae=new X(ae,this.loose)),ce(ae,this.operator,this.semver,this.loose))},Y.prototype.intersects=function(ae,ve){if(!(ae instanceof Y))throw new TypeError("a Comparator is required");var Ee;if(this.operator==="")return Ee=new $(ae.value,ve),fe(this.value,Ee,ve);if(ae.operator==="")return Ee=new $(this.value,ve),fe(ae.semver,Ee,ve);var We=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),He=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),tt=this.semver.version===ae.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),et=ce(this.semver,"<",ae.semver,ve)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),it=ce(this.semver,">",ae.semver,ve)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return We||He||tt&&Xe||et||it},e.Range=$,$.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},$.prototype.toString=function(){return this.range},$.prototype.parseRange=function(ae){var ve=this.loose;ae=ae.trim(),D("range",ae,ve);var Ee=ve?R[de]:R[be];ae=ae.replace(Ee,q),D("hyphen replace",ae),ae=ae.replace(R[_],"$1$2$3"),D("comparator trim",ae,R[_]),ae=(ae=(ae=ae.replace(R[J],"$1~")).replace(R[P],"$1^")).split(/\s+/).join(" ");var We=ve?R[j]:R[le],He=ae.split(" ").map(function(tt){return function(Xe,et){return D("comp",Xe),Xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(ot,Q){D("caret",ot,Q);var G=Q?R[V]:R[F];return ot.replace(G,function(pe,Me,ze,Ve,_e){var nt;return D("caret",ot,pe,Me,ze,Ve,_e),W(Me)?nt="":W(ze)?nt=">="+Me+".0.0 <"+(+Me+1)+".0.0":W(Ve)?nt=Me==="0"?">="+Me+"."+ze+".0 <"+Me+"."+(+ze+1)+".0":">="+Me+"."+ze+".0 <"+(+Me+1)+".0.0":_e?(D("replaceCaret pr",_e),_e.charAt(0)!=="-"&&(_e="-"+_e),nt=Me==="0"?ze==="0"?">="+Me+"."+ze+"."+Ve+_e+" <"+Me+"."+ze+"."+(+Ve+1):">="+Me+"."+ze+"."+Ve+_e+" <"+Me+"."+(+ze+1)+".0":">="+Me+"."+ze+"."+Ve+_e+" <"+(+Me+1)+".0.0"):(D("no pr"),nt=Me==="0"?ze==="0"?">="+Me+"."+ze+"."+Ve+" <"+Me+"."+ze+"."+(+Ve+1):">="+Me+"."+ze+"."+Ve+" <"+Me+"."+(+ze+1)+".0":">="+Me+"."+ze+"."+Ve+" <"+(+Me+1)+".0.0"),D("caret return",nt),nt})}(Fe,dt)}).join(" ")}(Xe,et),D("caret",Xe),Xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(ot,Q){var G=Q?R[L]:R[K];return ot.replace(G,function(pe,Me,ze,Ve,_e){var nt;return D("tilde",ot,pe,Me,ze,Ve,_e),W(Me)?nt="":W(ze)?nt=">="+Me+".0.0 <"+(+Me+1)+".0.0":W(Ve)?nt=">="+Me+"."+ze+".0 <"+Me+"."+(+ze+1)+".0":_e?(D("replaceTilde pr",_e),_e.charAt(0)!=="-"&&(_e="-"+_e),nt=">="+Me+"."+ze+"."+Ve+_e+" <"+Me+"."+(+ze+1)+".0"):nt=">="+Me+"."+ze+"."+Ve+" <"+Me+"."+(+ze+1)+".0",D("tilde return",nt),nt})}(Fe,dt)}).join(" ")}(Xe,et),D("tildes",Xe),Xe=function(it,dt){return D("replaceXRanges",it,dt),it.split(/\s+/).map(function(Fe){return function(ot,Q){ot=ot.trim();var G=Q?R[T]:R[d];return ot.replace(G,function(pe,Me,ze,Ve,_e,nt){D("xRange",ot,pe,Me,ze,Ve,_e,nt);var vt=W(ze),wt=vt||W(Ve),Ct=wt||W(_e);return Me==="="&&Ct&&(Me=""),vt?pe=Me===">"||Me==="<"?"<0.0.0":"*":Me&&Ct?(wt&&(Ve=0),Ct&&(_e=0),Me===">"?(Me=">=",wt?(ze=+ze+1,Ve=0,_e=0):Ct&&(Ve=+Ve+1,_e=0)):Me==="<="&&(Me="<",wt?ze=+ze+1:Ve=+Ve+1),pe=Me+ze+"."+Ve+"."+_e):wt?pe=">="+ze+".0.0 <"+(+ze+1)+".0.0":Ct&&(pe=">="+ze+"."+Ve+".0 <"+ze+"."+(+Ve+1)+".0"),D("xRange return",pe),pe})}(Fe,dt)}).join(" ")}(Xe,et),D("xrange",Xe),Xe=function(it,dt){return D("replaceStars",it,dt),it.trim().replace(R[ue],"")}(Xe,et),D("stars",Xe),Xe}(tt,ve)}).join(" ").split(/\s+/);return this.loose&&(He=He.filter(function(tt){return!!tt.match(We)})),He=He.map(function(tt){return new Y(tt,ve)})},$.prototype.intersects=function(ae,ve){if(!(ae instanceof $))throw new TypeError("a Range is required");return this.set.some(function(Ee){return Ee.every(function(We){return ae.set.some(function(He){return He.every(function(tt){return We.intersects(tt,ve)})})})})},e.toComparators=function(ae,ve){return new $(ae,ve).set.map(function(Ee){return Ee.map(function(We){return We.value}).join(" ").trim().split(" ")})},$.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new X(ae,this.loose));for(var ve=0;ve<this.set.length;ve++)if(ie(this.set[ve],ae))return!0;return!1},e.satisfies=fe,e.maxSatisfying=function(ae,ve,Ee){var We=null,He=null;try{var tt=new $(ve,Ee)}catch{return null}return ae.forEach(function(Xe){tt.test(Xe)&&(We&&He.compare(Xe)!==-1||(He=new X(We=Xe,Ee)))}),We},e.minSatisfying=function(ae,ve,Ee){var We=null,He=null;try{var tt=new $(ve,Ee)}catch{return null}return ae.forEach(function(Xe){tt.test(Xe)&&(We&&He.compare(Xe)!==1||(He=new X(We=Xe,Ee)))}),We},e.validRange=function(ae,ve){try{return new $(ae,ve).range||"*"}catch{return null}},e.ltr=function(ae,ve,Ee){return ye(ae,ve,"<",Ee)},e.gtr=function(ae,ve,Ee){return ye(ae,ve,">",Ee)},e.outside=ye,e.prerelease=function(ae,ve){var Ee=Z(ae,ve);return Ee&&Ee.prerelease.length?Ee.prerelease:null},e.intersects=function(ae,ve,Ee){return ae=new $(ae,Ee),ve=new $(ve,Ee),ae.intersects(ve)},e.coerce=function(ae){if(ae instanceof X)return ae;if(typeof ae!="string")return null;var ve=ae.match(R[O]);return ve==null?null:Z((ve[1]||"0")+"."+(ve[2]||"0")+"."+(ve[3]||"0"))}}).call(this,n(1))},function(te,e){var n,C,D=te.exports={};function M(){throw new Error("setTimeout has not been defined")}function S(){throw new Error("clearTimeout has not been defined")}function R(o){if(n===setTimeout)return setTimeout(o,0);if((n===M||!n)&&setTimeout)return n=setTimeout,setTimeout(o,0);try{return n(o,0)}catch{try{return n.call(null,o,0)}catch{return n.call(this,o,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:M}catch{n=M}try{C=typeof clearTimeout=="function"?clearTimeout:S}catch{C=S}})();var y,k=[],N=!1,w=-1;function f(){N&&y&&(N=!1,y.length?k=y.concat(k):w=-1,k.length&&b())}function b(){if(!N){var o=R(f);N=!0;for(var l=k.length;l;){for(y=k,k=[];++w<l;)y&&y[w].run();w=-1,l=k.length}y=null,N=!1,function(g){if(C===clearTimeout)return clearTimeout(g);if((C===S||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(g);try{C(g)}catch{try{return C.call(null,g)}catch{return C.call(this,g)}}}(o)}}function m(o,l){this.fun=o,this.array=l}function a(){}D.nextTick=function(o){var l=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)l[g-1]=arguments[g];k.push(new m(o,l)),k.length!==1||N||R(b)},m.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=a,D.addListener=a,D.once=a,D.off=a,D.removeListener=a,D.removeAllListeners=a,D.emit=a,D.prependListener=a,D.prependOnceListener=a,D.listeners=function(o){return[]},D.binding=function(o){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(o){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(Ce[114],ke([1,0,12,6]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(A){const v=A;return v?typeof v.read=="function":!1}e.isReadable=D;function M(A){const v=A;return v?[v.on,v.pause,v.resume,v.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=M;function S(A){const v=A;return v?M(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.isReadableBufferedStream=S;function R(A,v){return new y(A,v)}e.newWriteableStream=R;class y{constructor(v,t){this.e=v,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(v){if(!this.a.destroyed){if(this.a.flowing)this.g(v);else if(this.b.data.push(v),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(v){this.a.destroyed||(this.a.flowing?this.h(v):this.b.error.push(v))}end(v){this.a.destroyed||(typeof v<"u"&&this.write(v),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(v){this.c.data.slice(0).forEach(t=>t(v))}h(v){this.c.error.length===0?(0,n.onUnexpectedError)(v):this.c.error.slice(0).forEach(t=>t(v))}i(){this.c.end.slice(0).forEach(v=>v())}on(v,t){if(!this.a.destroyed)switch(v){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(v,t){if(this.a.destroyed)return;let h;switch(v){case"data":h=this.c.data;break;case"end":h=this.c.end;break;case"error":h=this.c.error;break}if(h){const r=h.indexOf(t);r>=0&&h.splice(r,1)}}j(){if(this.b.data.length>0){const v=this.e(this.b.data);this.g(v),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(h=>h())}}k(){if(this.c.error.length>0){for(const v of this.b.error)this.h(v);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(A,v){const t=[];let h;for(;(h=A.read())!==null;)t.push(h);return v(t)}e.consumeReadable=k;function N(A,v,t){const h=[];let r;for(;(r=A.read())!==null&&h.length<t;)h.push(r);return r===null&&h.length>0?v(h):{read:()=>{if(h.length>0)return h.shift();if(typeof r<"u"){const u=r;return r=void 0,u}return A.read()}}}e.peekReadable=N;function w(A,v){return new Promise((t,h)=>{const r=[];f(A,{onData:u=>{v&&r.push(u)},onError:u=>{v?h(u):t(void 0)},onEnd:()=>{t(v?v(r):void 0)}})})}e.consumeStream=w;function f(A,v){let t=!1;return A.on("error",h=>{t||v.onError(h)}),A.on("end",()=>{t||v.onEnd()}),A.on("data",h=>{t||v.onData(h)}),(0,C.toDisposable)(()=>t=!0)}e.listenStream=f;function b(A,v){return new Promise((t,h)=>{const r=new C.DisposableStore,u=[],i=s=>{if(u.push(s),u.length>v)return r.dispose(),A.pause(),t({stream:A,buffer:u,ended:!1})},p=s=>h(s),c=()=>t({stream:A,buffer:u,ended:!0});r.add((0,C.toDisposable)(()=>A.removeListener("error",p))),A.on("error",p),r.add((0,C.toDisposable)(()=>A.removeListener("end",c))),A.on("end",c),r.add((0,C.toDisposable)(()=>A.removeListener("data",i))),A.on("data",i)})}e.peekStream=b;function m(A,v){const t=R(v);return t.end(A),t}e.toStream=m;function a(){const A=R(()=>{throw new Error("not supported")});return A.end(),A}e.emptyStream=a;function o(A){let v=!1;return{read:()=>v?null:(v=!0,A)}}e.toReadable=o;function l(A,v,t){const h=R(t);return f(A,{onData:r=>h.write(v.data(r)),onError:r=>h.error(v.error?v.error(r):r),onEnd:()=>h.end()}),h}e.transform=l;function g(A,v,t){let h=!1;return{read:()=>{const r=v.read();return h?r:(h=!0,r!==null?t([A,r]):A)}}}e.prefixedReadable=g;function E(A,v,t){let h=!1;const r=R(t);return f(v,{onData:u=>h?r.write(u):(h=!0,r.write(t([A,u]))),onError:u=>r.error(u),onEnd:()=>{h||(h=!0,r.write(A)),r.end()}}),r}e.prefixedStream=E}),define(Ce[23],ke([1,0,114]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer<"u";let D,M;class S{static alloc(s){return C?new S(Buffer.allocUnsafe(s)):new S(new Uint8Array(s))}static wrap(s){return C&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new S(s)}static fromString(s,d){return!(d?.dontUseNodeBuffer||!1)&&C?new S(Buffer.from(s)):(D||(D=new TextEncoder),new S(D.encode(s)))}static fromByteArray(s){const d=S.alloc(s.length);for(let T=0,O=s.length;T<O;T++)d.buffer[T]=s[T];return d}static concat(s,d){if(typeof d>"u"){d=0;for(let H=0,J=s.length;H<J;H++)d+=s[H].byteLength}const T=S.alloc(d);let O=0;for(let H=0,J=s.length;H<J;H++){const K=s[H];T.set(K,O),O+=K.byteLength}return T}constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}clone(){const s=S.alloc(this.byteLength);return s.set(this),s}toString(){return C?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(s,d){return new S(this.buffer.subarray(s,d))}set(s,d){if(s instanceof S)this.buffer.set(s.buffer,d);else if(s instanceof Uint8Array)this.buffer.set(s,d);else if(s instanceof ArrayBuffer)this.buffer.set(new Uint8Array(s),d);else if(ArrayBuffer.isView(s))this.buffer.set(new Uint8Array(s.buffer,s.byteOffset,s.byteLength),d);else throw new Error("Unknown argument 'array'")}readUInt32BE(s){return k(this.buffer,s)}writeUInt32BE(s,d){N(this.buffer,s,d)}readUInt32LE(s){return w(this.buffer,s)}writeUInt32LE(s,d){f(this.buffer,s,d)}readUInt8(s){return b(this.buffer,s)}writeUInt8(s,d){m(this.buffer,s,d)}}e.VSBuffer=S;function R(c,s){return c[s+0]<<0>>>0|c[s+1]<<8>>>0}e.readUInt16LE=R;function y(c,s,d){c[d+0]=s&255,s=s>>>8,c[d+1]=s&255}e.writeUInt16LE=y;function k(c,s){return c[s]*2**24+c[s+1]*2**16+c[s+2]*2**8+c[s+3]}e.readUInt32BE=k;function N(c,s,d){c[d+3]=s,s=s>>>8,c[d+2]=s,s=s>>>8,c[d+1]=s,s=s>>>8,c[d]=s}e.writeUInt32BE=N;function w(c,s){return c[s+0]<<0>>>0|c[s+1]<<8>>>0|c[s+2]<<16>>>0|c[s+3]<<24>>>0}e.readUInt32LE=w;function f(c,s,d){c[d+0]=s&255,s=s>>>8,c[d+1]=s&255,s=s>>>8,c[d+2]=s&255,s=s>>>8,c[d+3]=s&255}e.writeUInt32LE=f;function b(c,s){return c[s]}e.readUInt8=b;function m(c,s,d){c[d]=s}e.writeUInt8=m;function a(c){return n.consumeReadable(c,s=>S.concat(s))}e.readableToBuffer=a;function o(c){return n.toReadable(c)}e.bufferToReadable=o;function l(c){return n.consumeStream(c,s=>S.concat(s))}e.streamToBuffer=l;async function g(c){return c.ended?S.concat(c.buffer):S.concat([...c.buffer,await l(c.stream)])}e.bufferedStreamToBuffer=g;function E(c){return n.toStream(c,s=>S.concat(s))}e.bufferToStream=E;function A(c){return n.transform(c,{data:s=>typeof s=="string"?S.fromString(s):S.wrap(s)},s=>S.concat(s))}e.streamToBufferReadableStream=A;function v(c){return n.newWriteableStream(s=>S.concat(s),c)}e.newWriteableBufferStream=v;function t(c,s){return n.prefixedReadable(c,s,d=>S.concat(d))}e.prefixedBufferReadable=t;function h(c,s){return n.prefixedStream(c,s,d=>S.concat(d))}e.prefixedBufferStream=h;function r(c){let s=0,d=0,T=0;const O=new Uint8Array(Math.floor(c.length/4*3)),H=K=>{switch(d){case 3:O[T++]=s|K,d=0;break;case 2:O[T++]=s|K>>>2,s=K<<6,d=3;break;case 1:O[T++]=s|K>>>4,s=K<<4,d=2;break;default:s=K<<2,d=1}};for(let K=0;K<c.length;K++){const L=c.charCodeAt(K);if(L>=65&&L<=90)H(L-65);else if(L>=97&&L<=122)H(L-97+26);else if(L>=48&&L<=57)H(L-48+52);else if(L===43||L===45)H(62);else if(L===47||L===95)H(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${c[K]}`)}}const J=T;for(;d>0;)H(0);return S.wrap(O).slice(0,J)}e.decodeBase64=r;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:c},s=!0,d=!1){const T=d?i:u;let O="";const H=c.byteLength%3;let J=0;for(;J<c.byteLength-H;J+=3){const K=c[J+0],L=c[J+1],B=c[J+2];O+=T[K>>>2],O+=T[(K<<4|L>>>4)&63],O+=T[(L<<2|B>>>6)&63],O+=T[B&63]}if(H===1){const K=c[J+0];O+=T[K>>>2],O+=T[K<<4&63],s&&(O+="==")}else if(H===2){const K=c[J+0],L=c[J+1];O+=T[K>>>2],O+=T[(K<<4|L>>>4)&63],O+=T[L<<2&63],s&&(O+="=")}return O}e.encodeBase64=p}),define(Ce[115],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Ce[38],ke([1,0,84]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var C;(function(S){function R(y){return y&&typeof y=="object"&&typeof y.id=="string"}S.isThemeColor=R})(C=e.ThemeColor||(e.ThemeColor={}));function D(S){return{id:S}}e.themeColorFromId=D;var M;(function(S){S.iconNameSegment="[A-Za-z0-9]+",S.iconNameExpression="[A-Za-z0-9-]+",S.iconModifierExpression="~[A-Za-z]+",S.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${S.iconNameExpression})(${S.iconModifierExpression})?$`);function y(g){const E=R.exec(g.id);if(!E)return y(n.Codicon.error);const[,A,v]=E,t=["codicon","codicon-"+A];return v&&t.push("codicon-modifier-"+v.substring(1)),t}S.asClassNameArray=y;function k(g){return y(g).join(" ")}S.asClassName=k;function N(g){return"."+y(g).join(".")}S.asCSSSelector=N;function w(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||C.isThemeColor(g.color))}S.isThemeIcon=w;const f=new RegExp(`^\\$\\((${S.iconNameExpression}(?:${S.iconModifierExpression})?)\\)$`);function b(g){const E=f.exec(g);if(!E)return;const[,A]=E;return{id:A}}S.fromString=b;function m(g){return{id:g}}S.fromId=m;function a(g,E){let A=g.id;const v=A.lastIndexOf("~");return v!==-1&&(A=A.substring(0,v)),E&&(A=`${A}~${E}`),{id:A}}S.modify=a;function o(g){const E=g.id.lastIndexOf("~");if(E!==-1)return g.id.substring(E+1)}S.getModifier=o;function l(g,E){return g.id===E.id&&g.color?.id===E.color?.id}S.isEqual=l})(M=e.ThemeIcon||(e.ThemeIcon={}))}),define(Ce[34],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(D){return n.test(D)}e.isUUID=C,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(R){for(let y=0;y<R.length;y++)R[y]=Math.floor(Math.random()*256);return R};const M=new Uint8Array(16),S=[];for(let R=0;R<256;R++)S.push(R.toString(16).padStart(2,"0"));return function(){D(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let y=0,k="";return k+=S[M[y++]],k+=S[M[y++]],k+=S[M[y++]],k+=S[M[y++]],k+="-",k+=S[M[y++]],k+=S[M[y++]],k+="-",k+=S[M[y++]],k+=S[M[y++]],k+="-",k+=S[M[y++]],k+=S[M[y++]],k+="-",k+=S[M[y++]],k+=S[M[y++]],k+=S[M[y++]],k+=S[M[y++]],k+=S[M[y++]],k+=S[M[y++]],k}}()}),define(Ce[116],ke([1,0,15,34]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function D(R){return{id:(0,C.generateUuid)(),asString:async()=>R,asFile:()=>{},value:typeof R=="string"?R:void 0}}e.createStringDataTransferItem=D;function M(R,y,k){return{id:(0,C.generateUuid)(),asString:async()=>"",asFile:()=>({name:R,uri:y,data:k}),value:void 0}}e.createFileDataTransferItem=M;class S{constructor(){this.a=new Map}get size(){return this.a.size}has(y){return this.a.has(this.b(y))}get(y){return this.a.get(this.b(y))?.[0]}append(y,k){const N=this.a.get(y);N?N.push(k):this.a.set(this.b(y),[k])}replace(y,k){this.a.set(this.b(y),[k])}delete(y){this.a.delete(this.b(y))}*entries(){for(const[y,k]of this.a.entries())for(const N of k)yield[y,N]}values(){return Array.from(this.a.values()).flat()}forEach(y){for(const[k,N]of this.entries())y(N,k)}b(y){return y.toLowerCase()}}e.VSDataTransfer=S,e.UriList=Object.freeze({create:R=>(0,n.distinct)(R.map(y=>y.toString())).join(`\r
`),split:R=>R.split(`\r
`),parse:R=>e.UriList.split(R).filter(y=>!y.startsWith("#"))})}),define(Ce[117],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[118],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var n;(function(S){S[S.None=0]="None",S[S.Indent=1]="Indent",S[S.IndentOutdent=2]="IndentOutdent",S[S.Outdent=3]="Outdent"})(n=e.IndentAction||(e.IndentAction={}));class C{constructor(R){if(this.e=null,this.f=!1,this.open=R.open,this.close=R.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(R.notIn))for(let y=0,k=R.notIn.length;y<k;y++)switch(R.notIn[y]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(R){switch(R){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(R,y){if(R.getTokenCount()===0)return!0;const k=R.findTokenIndexAtOffset(y-2),N=R.getStandardTokenType(k);return this.isOK(N)}g(R,y){for(let k=R;k<=y;k++){const N=String.fromCharCode(k);if(!this.open.includes(N)&&!this.close.includes(N))return N}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=C;class D{constructor(R){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of R)M(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),M(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),M(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),M(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&M(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=D;function M(S,R,y){S.has(R)?S.get(R).push(y):S.set(R,[y])}}),define(Ce[119],ke([13,14]),function(te,e){return te.create("vs/base/common/actions",e)}),define(Ce[120],ke([13,14]),function(te,e){return te.create("vs/base/common/date",e)}),define(Ce[121],ke([1,0,120]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const C=60,D=C*60,M=D*24,S=M*7,R=M*30,y=M*365;function k(w,f,b,m){typeof w!="number"&&(w=w.getTime());const a=Math.round((new Date().getTime()-w)/1e3);if(a<-30)return(0,n.localize)(0,null,k(new Date().getTime()+a*1e3,!1));if(!m&&a<30)return(0,n.localize)(1,null);let o;return a<C?(o=a,f?o===1?b?(0,n.localize)(2,null,o):(0,n.localize)(3,null,o):b?(0,n.localize)(4,null,o):(0,n.localize)(5,null,o):o===1?b?(0,n.localize)(6,null,o):(0,n.localize)(7,null,o):b?(0,n.localize)(8,null,o):(0,n.localize)(9,null,o)):a<D?(o=Math.floor(a/C),f?o===1?b?(0,n.localize)(10,null,o):(0,n.localize)(11,null,o):b?(0,n.localize)(12,null,o):(0,n.localize)(13,null,o):o===1?b?(0,n.localize)(14,null,o):(0,n.localize)(15,null,o):b?(0,n.localize)(16,null,o):(0,n.localize)(17,null,o)):a<M?(o=Math.floor(a/D),f?o===1?b?(0,n.localize)(18,null,o):(0,n.localize)(19,null,o):b?(0,n.localize)(20,null,o):(0,n.localize)(21,null,o):o===1?b?(0,n.localize)(22,null,o):(0,n.localize)(23,null,o):b?(0,n.localize)(24,null,o):(0,n.localize)(25,null,o)):a<S?(o=Math.floor(a/M),f?o===1?(0,n.localize)(26,null,o):(0,n.localize)(27,null,o):o===1?(0,n.localize)(28,null,o):(0,n.localize)(29,null,o)):a<R?(o=Math.floor(a/S),f?o===1?b?(0,n.localize)(30,null,o):(0,n.localize)(31,null,o):b?(0,n.localize)(32,null,o):(0,n.localize)(33,null,o):o===1?b?(0,n.localize)(34,null,o):(0,n.localize)(35,null,o):b?(0,n.localize)(36,null,o):(0,n.localize)(37,null,o)):a<y?(o=Math.floor(a/R),f?o===1?b?(0,n.localize)(38,null,o):(0,n.localize)(39,null,o):b?(0,n.localize)(40,null,o):(0,n.localize)(41,null,o):o===1?b?(0,n.localize)(42,null,o):(0,n.localize)(43,null,o):b?(0,n.localize)(44,null,o):(0,n.localize)(45,null,o)):(o=Math.floor(a/y),f?o===1?b?(0,n.localize)(46,null,o):(0,n.localize)(47,null,o):b?(0,n.localize)(48,null,o):(0,n.localize)(49,null,o):o===1?b?(0,n.localize)(50,null,o):(0,n.localize)(51,null,o):b?(0,n.localize)(52,null,o):(0,n.localize)(53,null,o))}e.fromNow=k;function N(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=N}),define(Ce[122],ke([13,14]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(Ce[39],ke([1,0,15,9,122]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(w,f){return f&&(w.stack||w.stacktrace)?D.localize(0,null,R(w),S(w.stack)||S(w.stacktrace)):R(w)}function S(w){return Array.isArray(w)?w.join(`
`):w}function R(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?D.localize(1,null,w.message):w.message||D.localize(2,null)}function y(w=null,f=!1){if(!w)return D.localize(3,null);if(Array.isArray(w)){const b=n.coalesce(w),m=y(b[0],f);return b.length>1?D.localize(4,null,m,b.length):m}if(C.isString(w))return w;if(w.detail){const b=w.detail;if(b.error)return M(b.error,f);if(b.exception)return M(b.exception,f)}return w.stack?M(w,f):w.message?w.message:D.localize(5,null)}e.toErrorMessage=y;function k(w){const f=w;return f instanceof Error&&Array.isArray(f.actions)}e.isErrorWithActions=k;function N(w,f){let b;return typeof w=="string"?b=new Error(w):b=w,b.actions=f,b}e.createErrorWithActions=N}),define(Ce[123],ke([1,0,85,19]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new n.Lazy(()=>{const s=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:s,collatorIsNumeric:s.resolvedOptions().numeric}}),M=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),S=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function R(s,d,T=!1){const O=s||"",H=d||"",J=D.value.collator.compare(O,H);return D.value.collatorIsNumeric&&J===0&&O!==H?O<H?-1:1:J}e.compareFileNames=R;function y(s,d){const T=M.value.collator;return s=s||"",d=d||"",A(T,s,d)}e.compareFileNamesDefault=y;function k(s,d){const T=M.value.collator;return s=s||"",d=d||"",r(s,d)||A(T,s,d)}e.compareFileNamesUpper=k;function N(s,d){const T=M.value.collator;return s=s||"",d=d||"",h(s,d)||A(T,s,d)}e.compareFileNamesLower=N;function w(s,d){return s=s||"",d=d||"",s===d?0:s<d?-1:1}e.compareFileNamesUnicode=w;function f(s,d){const[T,O]=g(s),[H,J]=g(d);let K=D.value.collator.compare(O,J);if(K===0){if(D.value.collatorIsNumeric&&O!==J)return O<J?-1:1;if(K=D.value.collator.compare(T,H),D.value.collatorIsNumeric&&K===0&&T!==H)return T<H?-1:1}return K}e.compareFileExtensions=f;function b(s,d){s=s||"",d=d||"";const T=E(s),O=E(d),H=M.value.collator,J=S.value.collator;return A(J,T,O)||A(H,s,d)}e.compareFileExtensionsDefault=b;function m(s,d){s=s||"",d=d||"";const T=E(s),O=E(d),H=M.value.collator,J=S.value.collator;return A(J,T,O)||r(s,d)||A(H,s,d)}e.compareFileExtensionsUpper=m;function a(s,d){s=s||"",d=d||"";const T=E(s),O=E(d),H=M.value.collator,J=S.value.collator;return A(J,T,O)||h(s,d)||A(H,s,d)}e.compareFileExtensionsLower=a;function o(s,d){s=s||"",d=d||"";const T=E(s).toLowerCase(),O=E(d).toLowerCase();return T!==O?T<O?-1:1:s!==d?s<d?-1:1:0}e.compareFileExtensionsUnicode=o;const l=/^(.*?)(\.([^.]*))?$/;function g(s,d=!1){const T=s?l.exec(s):[];let O=[T&&T[1]||"",T&&T[3]||""];return d&&(!O[0]&&O[1]||O[0]&&O[0].charAt(0)===".")&&(O=[O[0]+"."+O[1],""]),O}function E(s){const d=s?l.exec(s):[];return d&&d[1]&&d[1].charAt(0)!=="."&&d[3]||""}function A(s,d,T){const O=s.compare(d,T);return O!==0?O:d.length!==T.length?d.length<T.length?-1:1:0}function v(s){const d=s.charAt(0);return d.toLocaleUpperCase()!==d}function t(s){const d=s.charAt(0);return d.toLocaleLowerCase()!==d}function h(s,d){return v(s)&&t(d)?-1:t(s)&&v(d)?1:0}function r(s,d){return t(s)&&v(d)?-1:v(s)&&t(d)?1:0}function u(s,d,T=!1){return T||(s=s&&s.toLowerCase(),d=d&&d.toLowerCase()),s===d?0:s<d?-1:1}function i(s,d,T=!1){const O=s.split(C.sep),H=d.split(C.sep),J=O.length-1,K=H.length-1;let L,B;for(let P=0;;P++){if(L=J===P,B=K===P,L&&B)return R(O[P],H[P],T);if(L)return-1;if(B)return 1;const F=u(O[P],H[P],T);if(F!==0)return F}}e.comparePaths=i;function p(s,d,T){const O=s.toLowerCase(),H=d.toLowerCase(),J=c(s,d,T);if(J)return J;const K=O.endsWith(T),L=H.endsWith(T);if(K!==L)return K?-1:1;const B=R(O,H);return B!==0?B:O.localeCompare(H)}e.compareAnything=p;function c(s,d,T){const O=s.toLowerCase(),H=d.toLowerCase(),J=O.startsWith(T),K=H.startsWith(T);if(J!==K)return J?-1:1;if(J&&K){if(O.length<H.length)return-1;if(O.length>H.length)return 1}return 0}e.compareByPrefix=c}),define(Ce[64],ke([1,0,19]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(N){const w=(0,n.extname)(N),f=C[w.toLowerCase()];return f!==void 0?f:S(N)}e.getMediaOrTextMime=M;function S(N){const w=(0,n.extname)(N);return D[w.toLowerCase()]}e.getMediaMime=S;function R(N){for(const w in D)if(D[w]===N)return w}e.getExtensionForMimeType=R;const y=/^(.+)\/(.+?)(;.+)?$/;function k(N,w){const f=y.exec(N);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:w?void 0:N}e.normalizeMimeType=k}),define(Ce[124],ke([1,0,4,6,119]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class M extends C.Disposable{constructor(f,b="",m="",a=!0,o){super(),this.h=this.B(new n.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=f,this.m=b,this.u=m,this.w=a,this.C=o}get id(){return this.j}get label(){return this.m}set label(f){this.D(f)}D(f){this.m!==f&&(this.m=f,this.h.fire({label:f}))}get tooltip(){return this.n||""}set tooltip(f){this.F(f)}F(f){this.n!==f&&(this.n=f,this.h.fire({tooltip:f}))}get class(){return this.u}set class(f){this.G(f)}G(f){this.u!==f&&(this.u=f,this.h.fire({class:f}))}get enabled(){return this.w}set enabled(f){this.H(f)}H(f){this.w!==f&&(this.w=f,this.h.fire({enabled:f}))}get checked(){return this.z}set checked(f){this.I(f)}I(f){this.z!==f&&(this.z=f,this.h.fire({checked:f}))}async run(f,b){this.C&&await this.C(f)}}e.Action=M;class S extends C.Disposable{constructor(){super(...arguments),this.f=this.B(new n.Emitter),this.onWillRun=this.f.event,this.h=this.B(new n.Emitter),this.onDidRun=this.h.event}async run(f,b){if(!f.enabled)return;this.f.fire({action:f});let m;try{await this.runAction(f,b)}catch(a){m=a}this.h.fire({action:f,error:m})}async runAction(f,b){await f.run(b)}}e.ActionRunner=S;class R{constructor(){this.id=R.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...f){let b=[];for(const m of f)m.length&&(b.length?b=[...b,new R,...m]:b=m);return b}async run(){}}R.ID="vs.actions.separator",e.Separator=R;class y{get actions(){return this.a}constructor(f,b,m,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=f,this.label=b,this.class=a,this.a=m}async run(){}}e.SubmenuAction=y;class k extends M{constructor(){super(k.ID,D.localize(0,null),void 0,!1)}}k.ID="vs.actions.empty",e.EmptySubmenuAction=k;function N(w){return{id:w.id,label:w.label,class:void 0,enabled:w.enabled??!0,checked:w.checked??!1,run:async()=>w.run(),tooltip:w.label}}e.toAction=N}),define(Ce[40],ke([1,0,19,21,10,9]),function(te,e,n,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function S(i){return i===47||i===92}e.isPathSeparator=S;function R(i){return i.replace(/[\\/]/g,n.posix.sep)}e.toSlashes=R;function y(i){return i.indexOf("/")===-1&&(i=R(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=y;function k(i,p=n.posix.sep){if(!i)return"";const c=i.length,s=i.charCodeAt(0);if(S(s)){if(S(i.charCodeAt(1))&&!S(i.charCodeAt(2))){let T=3;const O=T;for(;T<c&&!S(i.charCodeAt(T));T++);if(O!==T&&!S(i.charCodeAt(T+1))){for(T+=1;T<c;T++)if(S(i.charCodeAt(T)))return i.slice(0,T+1).replace(/[\\/]/g,p)}}return p}else if(l(s)&&i.charCodeAt(1)===58)return S(i.charCodeAt(2))?i.slice(0,2)+p:i.slice(0,2);let d=i.indexOf("://");if(d!==-1){for(d+=3;d<c;d++)if(S(i.charCodeAt(d)))return i.slice(0,d+1)}return""}e.getRoot=k;function N(i){if(!C.isWindows||!i||i.length<5)return!1;let p=i.charCodeAt(0);if(p!==92||(p=i.charCodeAt(1),p!==92))return!1;let c=2;const s=c;for(;c<i.length&&(p=i.charCodeAt(c),p!==92);c++);return!(s===c||(p=i.charCodeAt(c+1),isNaN(p)||p===92))}e.isUNC=N;const w=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(i,p=C.isWindows){const c=p?w:f;return!(!i||i.length===0||/^\s+$/.test(i)||(c.lastIndex=0,c.test(i))||p&&b.test(i)||i==="."||i===".."||p&&i[i.length-1]==="."||p&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=m;function a(i,p,c){const s=i===p;return!c||s?s:!i||!p?!1:(0,D.equalsIgnoreCase)(i,p)}e.isEqual=a;function o(i,p,c,s=n.sep){if(i===p)return!0;if(!i||!p||p.length>i.length)return!1;if(c){if(!(0,D.startsWithIgnoreCase)(i,p))return!1;if(p.length===i.length)return!0;let T=p.length;return p.charAt(p.length-1)===s&&T--,i.charAt(T)===s}return p.charAt(p.length-1)!==s&&(p+=s),i.indexOf(p)===0}e.isEqualOrParent=o;function l(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=l;function g(i,p){return C.isWindows&&i.endsWith(":")&&(i+=n.sep),(0,n.isAbsolute)(i)||(i=(0,n.join)(p,i)),i=(0,n.normalize)(i),C.isWindows?(i=(0,D.rtrim)(i,n.sep),i.endsWith(":")&&(i+=n.sep)):(i=(0,D.rtrim)(i,n.sep),i||(i=n.sep)),i}e.sanitizeFilePath=g;function E(i){const p=(0,n.normalize)(i);return C.isWindows?i.length>3?!1:A(p)&&(i.length===2||p.charCodeAt(2)===92):p===n.posix.sep}e.isRootOrDriveLetter=E;function A(i,p=C.isWindows){return p?l(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=A;function v(i){return A(i)?i[0]:void 0}e.getDriveLetter=v;function t(i,p,c){return p.length>i.length?-1:i===p?0:(c&&(i=i.toLowerCase(),p=p.toLowerCase()),i.indexOf(p))}e.indexOfPath=t;function h(i){const p=i.split(":");let c,s,d;for(const T of p){const O=Number(T);(0,M.isNumber)(O)?s===void 0?s=O:d===void 0&&(d=O):c=c?[c,T].join(":"):T}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:s!==void 0?s:void 0,column:d!==void 0?d:s!==void 0?1:void 0}}e.parseLineAndColumnAware=h;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function u(i,p,c=8){let s="";for(let T=0;T<c;T++)s+=r.charAt(Math.floor(Math.random()*r.length));let d;return p?d=`${p}-${s}`:d=s,i?(0,n.join)(i,d):d}e.randomPath=u}),define(Ce[125],ke([1,0,28,10]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...Y){return function(I,$){for(let W=0,q=Y.length;W<q;W++){const ie=Y[W](I,$);if(ie)return ie}return null}}e.or=D,e.matchesStrictPrefix=M.bind(void 0,!1),e.matchesPrefix=M.bind(void 0,!0);function M(Y,I,$){if(!$||$.length<I.length)return null;let W;return Y?W=C.startsWithIgnoreCase($,I):W=$.indexOf(I)===0,W?I.length>0?[{start:0,end:I.length}]:[]:null}function S(Y,I){const $=I.toLowerCase().indexOf(Y.toLowerCase());return $===-1?null:[{start:$,end:$+Y.length}]}e.matchesContiguousSubString=S;function R(Y,I){return y(Y.toLowerCase(),I.toLowerCase(),0,0)}e.matchesSubString=R;function y(Y,I,$,W){if($===Y.length)return[];if(W===I.length)return null;if(Y[$]===I[W]){let q=null;return(q=y(Y,I,$+1,W+1))?l({start:W,end:W+1},q):null}return y(Y,I,$,W+1)}function k(Y){return 97<=Y&&Y<=122}function N(Y){return 65<=Y&&Y<=90}e.isUpper=N;function w(Y){return 48<=Y&&Y<=57}function f(Y){return Y===32||Y===9||Y===10||Y===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Y=>b.add(Y.charCodeAt(0)));function m(Y){return f(Y)||b.has(Y)}function a(Y,I){return Y===I||m(Y)&&m(I)}function o(Y){return k(Y)||N(Y)||w(Y)}function l(Y,I){return I.length===0?I=[Y]:Y.end===I[0].start?I[0].start=Y.start:I.unshift(Y),I}function g(Y,I){for(let $=I;$<Y.length;$++){const W=Y.charCodeAt($);if(N(W)||w(W)||$>0&&!o(Y.charCodeAt($-1)))return $}return Y.length}function E(Y,I,$,W){if($===Y.length)return[];if(W===I.length)return null;if(Y[$]!==I[W].toLowerCase())return null;{let q=null,ie=W+1;for(q=E(Y,I,$+1,W+1);!q&&(ie=g(I,ie))<I.length;)q=E(Y,I,$+1,ie),ie++;return q===null?null:l({start:W,end:W+1},q)}}function A(Y){let I=0,$=0,W=0,q=0,ie=0;for(let Ee=0;Ee<Y.length;Ee++)ie=Y.charCodeAt(Ee),N(ie)&&I++,k(ie)&&$++,o(ie)&&W++,w(ie)&&q++;const fe=I/Y.length,ye=$/Y.length,ae=W/Y.length,ve=q/Y.length;return{upperPercent:fe,lowerPercent:ye,alphaPercent:ae,numericPercent:ve}}function v(Y){const{upperPercent:I,lowerPercent:$}=Y;return $===0&&I>.6}function t(Y){const{upperPercent:I,lowerPercent:$,alphaPercent:W,numericPercent:q}=Y;return $>.2&&I<.8&&W>.6&&q<.2}function h(Y){let I=0,$=0,W=0,q=0;for(let ie=0;ie<Y.length;ie++)W=Y.charCodeAt(ie),N(W)&&I++,k(W)&&$++,f(W)&&q++;return(I===0||$===0)&&q===0?Y.length<=30:I<=5}function r(Y,I){if(!I||(I=I.trim(),I.length===0)||!h(Y)||I.length>60)return null;const $=A(I);if(!t($)){if(!v($))return null;I=I.toLowerCase()}let W=null,q=0;for(Y=Y.toLowerCase();q<I.length&&(W=E(Y,I,0,q))===null;)q=g(I,q+1);return W}e.matchesCamelCase=r;function u(Y,I,$=!1){if(!I||I.length===0)return null;let W=null,q=0;for(Y=Y.toLowerCase(),I=I.toLowerCase();q<I.length&&(W=i(Y,I,0,q,$))===null;)q=p(I,q+1);return W}e.matchesWords=u;function i(Y,I,$,W,q){if($===Y.length)return[];if(W===I.length)return null;if(a(Y.charCodeAt($),I.charCodeAt(W))){let ie=null,fe=W+1;if(ie=i(Y,I,$+1,W+1,q),!q)for(;!ie&&(fe=p(I,fe))<I.length;)ie=i(Y,I,$+1,fe,q),fe++;return ie?Y.charCodeAt($)!==I.charCodeAt(W)?ie:l({start:W,end:W+1},ie):null}else return null}function p(Y,I){for(let $=I;$<Y.length;$++)if(m(Y.charCodeAt($))||$>0&&m(Y.charCodeAt($-1)))return $;return Y.length}const c=D(e.matchesPrefix,r,S),s=D(e.matchesPrefix,r,R),d=new n.LRUCache(1e4);function T(Y,I,$=!1){if(typeof Y!="string"||typeof I!="string")return null;let W=d.get(Y);W||(W=new RegExp(C.convertSimple2RegExpPattern(Y),"i"),d.set(Y,W));const q=W.exec(I);return q?[{start:q.index,end:q.index+q[0].length}]:$?s(Y,I):c(Y,I)}e.matchesFuzzy=T;function O(Y,I){const $=Ne(Y,Y.toLowerCase(),0,I,I.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return $?J($):null}e.matchesFuzzy2=O;function H(Y,I,$,W,q,ie){const fe=Math.min(13,Y.length);for(;$<fe;$++){const ye=Ne(Y,I,$,W,q,ie,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ye)return ye}return[0,ie]}e.anyScore=H;function J(Y){if(typeof Y>"u")return[];const I=[],$=Y[1];for(let W=Y.length-1;W>1;W--){const q=Y[W]+$,ie=I[I.length-1];ie&&ie.end===q?ie.end=q+1:I.push({start:q,end:q+1})}return I}e.createMatches=J;const K=128;function L(){const Y=[],I=[];for(let $=0;$<=K;$++)I[$]=0;for(let $=0;$<=K;$++)Y.push(I.slice(0));return Y}function B(Y){const I=[];for(let $=0;$<=Y;$++)I[$]=0;return I}const P=B(2*K),F=B(2*K),V=L(),j=L(),le=L(),_=!1;function be(Y,I,$,W,q){function ie(ye,ae,ve=" "){for(;ye.length<ae;)ye=ve+ye;return ye}let fe=` |   |${W.split("").map(ye=>ie(ye,3)).join("|")}
`;for(let ye=0;ye<=$;ye++)ye===0?fe+=" |":fe+=`${I[ye-1]}|`,fe+=Y[ye].slice(0,q+1).map(ae=>ie(ae.toString(),3)).join("|")+`
`;return fe}function de(Y,I,$,W){Y=Y.substr(I),$=$.substr(W),console.log(be(j,Y,Y.length,$,$.length)),console.log(be(le,Y,Y.length,$,$.length)),console.log(be(V,Y,Y.length,$,$.length))}function ue(Y,I){if(I<0||I>=Y.length)return!1;const $=Y.codePointAt(I);switch($){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!C.isEmojiImprecise($)}}function se(Y,I){if(I<0||I>=Y.length)return!1;switch(Y.charCodeAt(I)){case 32:case 9:return!0;default:return!1}}function Z(Y,I,$){return I[Y]!==$[Y]}function X(Y,I,$,W,q,ie,fe=!1){for(;I<$&&q<ie;)Y[I]===W[q]&&(fe&&(P[I]=q),I+=1),q+=1;return I===$}e.isPatternInWord=X;var ee;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(ee||(ee={}));var he;(function(Y){Y.Default=[-100,0];function I($){return!$||$.length===2&&$[0]===-100&&$[1]===0}Y.isDefault=I})(he=e.FuzzyScore||(e.FuzzyScore={}));class Te{constructor(I,$){this.firstMatchCanBeWeak=I,this.boostFullMatch=$}}Te.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=Te;function Ne(Y,I,$,W,q,ie,fe=Te.default){const ye=Y.length>K?K:Y.length,ae=W.length>K?K:W.length;if($>=ye||ie>=ae||ye-$>ae-ie||!X(I,$,ye,q,ie,ae,!0))return;Ke(ye,ae,$,ie,I,q);let ve=1,Ee=1,We=$,He=ie;const tt=[!1];for(ve=1,We=$;We<ye;ve++,We++){const Fe=P[We],ot=F[We],Q=We+1<ye?F[We+1]:ae;for(Ee=Fe-ie+1,He=Fe;He<Q;Ee++,He++){let G=Number.MIN_SAFE_INTEGER,pe=!1;He<=ot&&(G=Pe(Y,I,We,$,W,q,He,ae,ie,V[ve-1][Ee-1]===0,tt));let Me=0;G!==Number.MAX_SAFE_INTEGER&&(pe=!0,Me=G+j[ve-1][Ee-1]);const ze=He>Fe,Ve=ze?j[ve][Ee-1]+(V[ve][Ee-1]>0?-5:0):0,_e=He>Fe+1&&V[ve][Ee-1]>0,nt=_e?j[ve][Ee-2]+(V[ve][Ee-2]>0?-5:0):0;if(_e&&(!ze||nt>=Ve)&&(!pe||nt>=Me))j[ve][Ee]=nt,le[ve][Ee]=3,V[ve][Ee]=0;else if(ze&&(!pe||Ve>=Me))j[ve][Ee]=Ve,le[ve][Ee]=2,V[ve][Ee]=0;else if(pe)j[ve][Ee]=Me,le[ve][Ee]=1,V[ve][Ee]=V[ve-1][Ee-1]+1;else throw new Error("not possible")}}if(_&&de(Y,$,W,ie),!tt[0]&&!fe.firstMatchCanBeWeak)return;ve--,Ee--;const Xe=[j[ve][Ee],ie];let et=0,it=0;for(;ve>=1;){let Fe=Ee;do{const ot=le[ve][Fe];if(ot===3)Fe=Fe-2;else if(ot===2)Fe=Fe-1;else break}while(Fe>=1);et>1&&I[$+ve-1]===q[ie+Ee-1]&&!Z(Fe+ie-1,W,q)&&et+1>V[ve][Fe]&&(Fe=Ee),Fe===Ee?et++:et=1,it||(it=Fe),ve--,Ee=Fe-1,Xe.push(Ee)}ae===ye&&fe.boostFullMatch&&(Xe[0]+=2);const dt=it-ye;return Xe[0]-=dt,Xe}e.fuzzyScore=Ne;function Ke(Y,I,$,W,q,ie){let fe=Y-1,ye=I-1;for(;fe>=$&&ye>=W;)q[fe]===ie[ye]&&(F[fe]=ye,fe--),ye--}function Pe(Y,I,$,W,q,ie,fe,ye,ae,ve,Ee){if(I[$]!==ie[fe])return Number.MIN_SAFE_INTEGER;let We=1,He=!1;return fe===$-W?We=Y[$]===q[fe]?7:5:Z(fe,q,ie)&&(fe===0||!Z(fe-1,q,ie))?(We=Y[$]===q[fe]?7:5,He=!0):ue(ie,fe)&&(fe===0||!ue(ie,fe-1))?We=5:(ue(ie,fe-1)||se(ie,fe-1))&&(We=5,He=!0),We>1&&$===W&&(Ee[0]=!0),He||(He=Z(fe,q,ie)||ue(ie,fe-1)||se(ie,fe-1)),$===W?fe>ae&&(We-=He?3:5):ve?We+=He?2:0:We+=He?0:1,fe+1===ye&&(We-=He?3:5),We}function Se(Y,I,$,W,q,ie,fe){return oe(Y,I,$,W,q,ie,!0,fe)}e.fuzzyScoreGracefulAggressive=Se;function Ie(Y,I,$,W,q,ie,fe){return oe(Y,I,$,W,q,ie,!1,fe)}e.fuzzyScoreGraceful=Ie;function oe(Y,I,$,W,q,ie,fe,ye){let ae=Ne(Y,I,$,W,q,ie,ye);if(ae&&!fe)return ae;if(Y.length>=3){const ve=Math.min(7,Y.length-1);for(let Ee=$+1;Ee<ve;Ee++){const We=ce(Y,Ee);if(We){const He=Ne(We,We.toLowerCase(),$,W,q,ie,ye);He&&(He[0]-=3,(!ae||He[0]>ae[0])&&(ae=He))}}}return ae}function ce(Y,I){if(I+1>=Y.length)return;const $=Y[I],W=Y[I+1];if($!==W)return Y.slice(0,I)+W+$+Y.slice(I+2)}}),define(Ce[126],ke([1,0,125,10,38]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const M="$(",S=new RegExp(`\\$\\(${D.ThemeIcon.iconNameExpression}(?:${D.ThemeIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${S.source}`,"g");function y(l){return l.replace(R,(g,E)=>E?g:`\\${g}`)}e.escapeIcons=y;const k=new RegExp(`\\\\${S.source}`,"g");function N(l){return l.replace(k,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=N;const w=new RegExp(`(\\s)?(\\\\)?${S.source}(\\s)?`,"g");function f(l){return l.indexOf(M)===-1?l:l.replace(w,(g,E,A,v)=>A?g:E||v||"")}e.stripIcons=f;function b(l){return l?l.replace(/\$\((.*?)\)/g,(g,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=b;const m=new RegExp(`\\$\\(${D.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(l){m.lastIndex=0;let g="";const E=[];let A=0;for(;;){const v=m.lastIndex,t=m.exec(l),h=l.substring(v,t?.index);if(h.length>0){g+=h;for(let r=0;r<h.length;r++)E.push(A)}if(!t)break;A+=t[0].length}return{text:g,iconOffsets:E}}e.parseLabelWithIcons=a;function o(l,g,E=!1){const{text:A,iconOffsets:v}=g;if(!v||v.length===0)return(0,n.matchesFuzzy)(l,A,E);const t=(0,C.ltrim)(A," "),h=A.length-t.length,r=(0,n.matchesFuzzy)(l,t,E);if(r)for(const u of r){const i=v[u.start+h]+h;u.start+=i,u.end+=i}return r}e.matchesFuzzyIconAware=o}),define(Ce[29],ke([1,0,10]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(C||(C={})),function(D){const M="error",S="warning",R="warn",y="info",k="ignore";function N(f){return f?n.equalsIgnoreCase(M,f)?D.Error:n.equalsIgnoreCase(S,f)||n.equalsIgnoreCase(R,f)?D.Warning:n.equalsIgnoreCase(y,f)?D.Info:D.Ignore:D.Ignore}D.fromValue=N;function w(f){switch(f){case D.Error:return M;case D.Warning:return S;case D.Info:return y;default:return k}}D.toString=w}(C||(C={})),e.default=C}),define(Ce[48],ke([1,0,15,10]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class D{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const m=b.charCodeAt(0),a=this.b.charCodeAt(this.c);return m-a}value(){return this.b[this.c]}}e.StringIterator=D;class M{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,C.compareSubstring)(b,this.b,0,b.length,this.c,this.d):(0,C.compareSubstringIgnoreCase)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=M;class S{constructor(b=!0,m=!0){this.f=b,this.g=m}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let m=b.length-1;m>=0;m--,this.c--){const a=this.b.charCodeAt(m);if(!(a===47||this.f&&a===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,C.compareSubstring)(b,this.b,0,b.length,this.d,this.e):(0,C.compareSubstringIgnoreCase)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=S;var R;(function(f){f[f.Scheme=1]="Scheme",f[f.Authority=2]="Authority",f[f.Path=3]="Path",f[f.Query=4]="Query",f[f.Fragment=5]="Fragment"})(R||(R={}));class y{constructor(b,m){this.f=b,this.g=m,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new S(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,C.compareIgnoreCase)(b,this.c.scheme);if(this.d[this.e]===2)return(0,C.compareIgnoreCase)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,C.compare)(b,this.c.query);if(this.d[this.e]===5)return(0,C.compare)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=y;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var N;(function(f){f[f.Left=-1]="Left",f[f.Mid=0]="Mid",f[f.Right=1]="Right"})(N||(N={}));class w{static forUris(b=()=>!1,m=()=>!1){return new w(new y(b,m))}static forPaths(b=!1){return new w(new S(void 0,!b))}static forStrings(){return new w(new D)}static forConfigKeys(){return new w(new M)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,m){if(m){const a=m.slice(0);(0,n.shuffle)(a);for(const o of a)this.set(o,b)}else{const a=b.slice(0);(0,n.shuffle)(a);for(const o of a)this.set(o[0],o[1])}}set(b,m){const a=this.b.reset(b);let o;this.c||(this.c=new k,this.c.segment=a.value());const l=[];for(o=this.c;;){const E=a.cmp(o.segment);if(E>0)o.left||(o.left=new k,o.left.segment=a.value()),l.push([-1,o]),o=o.left;else if(E<0)o.right||(o.right=new k,o.right.segment=a.value()),l.push([1,o]),o=o.right;else if(a.hasNext())a.next(),o.mid||(o.mid=new k,o.mid.segment=a.value()),l.push([0,o]),o=o.mid;else break}const g=o.value;o.value=m,o.key=b;for(let E=l.length-1;E>=0;E--){const A=l[E][1];A.updateHeight();const v=A.balanceFactor();if(v<-1||v>1){const t=l[E][0],h=l[E+1][0];if(t===1&&h===1)l[E][1]=A.rotateLeft();else if(t===-1&&h===-1)l[E][1]=A.rotateRight();else if(t===1&&h===-1)A.right=l[E+1][1]=l[E+1][1].rotateRight(),l[E][1]=A.rotateLeft();else if(t===-1&&h===1)A.left=l[E+1][1]=l[E+1][1].rotateLeft(),l[E][1]=A.rotateRight();else throw new Error;if(E>0)switch(l[E-1][0]){case-1:l[E-1][1].left=l[E][1];break;case 1:l[E-1][1].right=l[E][1];break;case 0:l[E-1][1].mid=l[E][1];break}else this.c=l[0][1]}}return g}get(b){return this.d(b)?.value}d(b){const m=this.b.reset(b);let a=this.c;for(;a;){const o=m.cmp(a.segment);if(o>0)a=a.left;else if(o<0)a=a.right;else if(m.hasNext())m.next(),a=a.mid;else break}return a}has(b){const m=this.d(b);return!(m?.value===void 0&&m?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,m){const a=this.b.reset(b),o=[];let l=this.c;for(;l;){const g=a.cmp(l.segment);if(g>0)o.push([-1,l]),l=l.left;else if(g<0)o.push([1,l]),l=l.right;else if(a.hasNext())a.next(),o.push([0,l]),l=l.mid;else break}if(!!l){if(m?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const g=this.f(l.right);if(g.key){const{key:E,value:A,segment:v}=g;this.e(g.key,!1),l.key=E,l.value=A,l.segment=v}}else{const g=l.left??l.right;if(o.length>0){const[E,A]=o[o.length-1];switch(E){case-1:A.left=g;break;case 0:A.mid=g;break;case 1:A.right=g;break}}else this.c=g}for(let g=o.length-1;g>=0;g--){const E=o[g][1];E.updateHeight();const A=E.balanceFactor();if(A>1?(E.right.balanceFactor()>=0||(E.right=E.right.rotateRight()),o[g][1]=E.rotateLeft()):A<-1&&(E.left.balanceFactor()<=0||(E.left=E.left.rotateLeft()),o[g][1]=E.rotateRight()),g>0)switch(o[g-1][0]){case-1:o[g-1][1].left=o[g][1];break;case 1:o[g-1][1].right=o[g][1];break;case 0:o[g-1][1].mid=o[g][1];break}else this.c=o[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const m=this.b.reset(b);let a=this.c,o;for(;a;){const l=m.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(m.hasNext())m.next(),o=a.value||o,a=a.mid;else break}return a&&a.value||o}findSuperstr(b){return this.g(b,!1)}g(b,m){const a=this.b.reset(b);let o=this.c;for(;o;){const l=a.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(a.hasNext())a.next(),o=o.mid;else return o.mid?this.h(o.mid):m?o.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[m,a]of this)b(a,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const m=[];return this.j(b,m),m[Symbol.iterator]()}j(b,m){!b||(b.left&&this.j(b.left,m),b.value&&m.push([b.key,b.value]),b.mid&&this.j(b.mid,m),b.right&&this.j(b.right,m))}_isBalanced(){const b=m=>{if(!m)return!0;const a=m.balanceFactor();return a<-1||a>1?!1:b(m.left)&&b(m.right)};return b(this.c)}}e.TernarySearchTree=w}),define(Ce[65],ke([1,0,23,10,2]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(k){return JSON.stringify(k,R)}e.stringify=M;function S(k){let N=JSON.parse(k);return N=y(N),N}e.parse=S;function R(k,N){return N instanceof RegExp?{$mid:2,source:N.source,flags:(0,C.regExpFlags)(N)}:N}function y(k,N=0){if(!k||N>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return D.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 16:return new Date(k.source)}if(k instanceof n.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let w=0;w<k.length;++w)k[w]=y(k[w],N+1);else for(const w in k)Object.hasOwnProperty.call(k,w)&&(k[w]=y(k[w],N+1))}return k}e.revive=y}),define(Ce[16],ke([1,0,12,21,2]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var M;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.vscodeUserData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls",k.vscodeSourceControl="vscode-scm"})(M=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class S{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(N){this.d=N}setDelegate(N){this.e=N}setServerRootPath(N){this.f=`${N}/${M.vscodeRemoteResource}`}set(N,w,f){this.a[N]=w,this.b[N]=f}setConnectionToken(N,w){this.c[N]=w}getPreferredWebSchema(){return this.d}rewrite(N){if(this.e)try{return this.e(N)}catch(o){return n.onUnexpectedError(o),N}const w=N.authority;let f=this.a[w];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const b=this.b[w],m=this.c[w];let a=`path=${encodeURIComponent(N.path)}`;return typeof m=="string"&&(a+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),D.URI.from({scheme:C.isWeb?this.d:M.vscodeRemoteResource,authority:`${f}:${b}`,path:this.f,query:a})}}e.RemoteAuthorities=new S,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class R{asBrowserUri(N){const w=this.b(N,te);return this.uriToBrowserUri(w)}uriToBrowserUri(N){return N.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(N):N.scheme===M.file&&(C.isNative||C.isWebWorker&&C.globals.origin===`${M.vscodeFileResource}://${R.a}`)?N.with({scheme:M.vscodeFileResource,authority:N.authority||R.a,query:null,fragment:null}):N}asFileUri(N){const w=this.b(N,te);return this.uriToFileUri(w)}uriToFileUri(N){return N.scheme===M.vscodeFileResource?N.with({scheme:M.file,authority:N.authority!==R.a?N.authority:null,query:null,fragment:null}):N}b(N,w){return D.URI.isUri(N)?N:D.URI.parse(w.toUrl(N))}}R.a="vscode-app",e.FileAccess=new R;var y;(function(k){const N=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);k.CoopAndCoep=Object.freeze(N.get("3"));const w="vscode-coi";function f(m){let a;typeof m=="string"?a=new URL(m).searchParams:m instanceof URL?a=m.searchParams:D.URI.isUri(m)&&(a=new URL(m.toString(!0)).searchParams);const o=a?.get(w);if(!!o)return N.get(o)}k.getHeadersFromQuery=f;function b(m,a,o){if(!globalThis.crossOriginIsolated)return;const l=a&&o?"3":o?"2":"1";m instanceof URLSearchParams?m.set(w,l):m[w]=l}k.addSearchParam=b})(y=e.COI||(e.COI={}))}),define(Ce[24],ke([1,0,40,16,19,21,10,2]),function(te,e,n,C,D,M,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(b){return(0,R.uriToFsPath)(b,!0)}e.originalFSPath=y;class k{constructor(m){this.a=m}compare(m,a,o=!1){return m===a?0:(0,S.compare)(this.getComparisonKey(m,o),this.getComparisonKey(a,o))}isEqual(m,a,o=!1){return m===a?!0:!m||!a?!1:this.getComparisonKey(m,o)===this.getComparisonKey(a,o)}getComparisonKey(m,a=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,a,o=!1){if(m.scheme===a.scheme){if(m.scheme===C.Schemas.file)return n.isEqualOrParent(y(m),y(a),this.a(m))&&m.query===a.query&&(o||m.fragment===a.fragment);if((0,e.isEqualAuthority)(m.authority,a.authority))return n.isEqualOrParent(m.path,a.path,this.a(m),"/")&&m.query===a.query&&(o||m.fragment===a.fragment)}return!1}joinPath(m,...a){return R.URI.joinPath(m,...a)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return D.posix.basename(m.path)}extname(m){return D.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let a;return m.scheme===C.Schemas.file?a=R.URI.file(D.dirname(y(m))).path:(a=D.posix.dirname(m.path),m.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),a="/")),m.with({path:a})}normalizePath(m){if(!m.path.length)return m;let a;return m.scheme===C.Schemas.file?a=R.URI.file(D.normalize(y(m))).path:a=D.posix.normalize(m.path),m.with({path:a})}relativePath(m,a){if(m.scheme!==a.scheme||!(0,e.isEqualAuthority)(m.authority,a.authority))return;if(m.scheme===C.Schemas.file){const g=D.relative(y(m),y(a));return M.isWindows?n.toSlashes(g):g}let o=m.path||"/";const l=a.path||"/";if(this.a(m)){let g=0;for(const E=Math.min(o.length,l.length);g<E&&!(o.charCodeAt(g)!==l.charCodeAt(g)&&o.charAt(g).toLowerCase()!==l.charAt(g).toLowerCase());g++);o=l.substr(0,g)+o.substr(g)}return D.posix.relative(o,l)}resolvePath(m,a){if(m.scheme===C.Schemas.file){const o=R.URI.file(D.resolve(y(m),a));return m.with({authority:o.authority,path:o.path})}return a=n.toPosixPath(a),m.with({path:D.posix.resolve(m.path,a)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,a){return m===a||m!==void 0&&a!==void 0&&(0,S.equalsIgnoreCase)(m,a)}hasTrailingPathSeparator(m,a=D.sep){if(m.scheme===C.Schemas.file){const o=y(m);return o.length>n.getRoot(o).length&&o[o.length-1]===a}else{const o=m.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,a=D.sep){return(0,e.hasTrailingPathSeparator)(m,a)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,a=D.sep){let o=!1;if(m.scheme===C.Schemas.file){const l=y(m);o=l!==void 0&&l.length===n.getRoot(l).length&&l[l.length-1]===a}else{a="/";const l=m.path;o=l.length===1&&l.charCodeAt(l.length-1)===47}return!o&&!(0,e.hasTrailingPathSeparator)(m,a)?m.with({path:m.path+"/"}):m}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(b=>b.scheme===C.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new k(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function N(b,m){const a=[];for(let o=0;o<b.length;o++){const l=m(b[o]);b.some((g,E)=>E===o?!1:(0,e.isEqualOrParent)(l,m(g)))||a.push(b[o])}return a}e.distinctParents=N;var w;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function m(a){const o=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(E=>{const[A,v]=E.split(":");A&&v&&o.set(A,v)});const g=a.path.substring(0,a.path.indexOf(";"));return g&&o.set(b.META_DATA_MIME,g),o}b.parseMetaData=m})(w=e.DataUri||(e.DataUri={}));function f(b,m,a){if(m){let o=b.path;return o&&o[0]!==D.posix.sep&&(o=D.posix.sep+o),b.with({scheme:a,authority:m,path:o})}return b.with({scheme:a})}e.toLocalResource=f}),define(Ce[17],ke([1,0,20,12,4,6,24,21,115]),function(te,e,n,C,D,M,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function k(X){return!!X&&typeof X.then=="function"}e.isThenable=k;function N(X){const ee=new n.CancellationTokenSource,he=X(ee.token),Te=new Promise((Ne,Ke)=>{const Pe=ee.token.onCancellationRequested(()=>{Pe.dispose(),ee.dispose(),Ke(new C.CancellationError)});Promise.resolve(he).then(Se=>{Pe.dispose(),ee.dispose(),Ne(Se)},Se=>{Pe.dispose(),ee.dispose(),Ke(Se)})});return new class{cancel(){ee.cancel()}then(Ne,Ke){return Te.then(Ne,Ke)}catch(Ne){return this.then(void 0,Ne)}finally(Ne){return Te.finally(Ne)}}}e.createCancelablePromise=N;function w(X,ee,he){return new Promise((Te,Ne)=>{const Ke=ee.onCancellationRequested(()=>{Ke.dispose(),Te(he)});X.then(Te,Ne).finally(()=>Ke.dispose())})}e.raceCancellation=w;function f(X,ee){return new Promise((he,Te)=>{const Ne=ee.onCancellationRequested(()=>{Ne.dispose(),Te(new C.CancellationError)});X.then(he,Te).finally(()=>Ne.dispose())})}e.raceCancellationError=f;async function b(X){let ee=-1;const he=X.map((Ne,Ke)=>Ne.then(Pe=>(ee=Ke,Pe))),Te=await Promise.race(he);return X.forEach((Ne,Ke)=>{Ke!==ee&&Ne.cancel()}),Te}e.raceCancellablePromises=b;function m(X,ee,he){let Te;const Ne=setTimeout(()=>{Te?.(void 0),he?.()},ee);return Promise.race([X.finally(()=>clearTimeout(Ne)),new Promise(Ke=>Te=Ke)])}e.raceTimeout=m;function a(X){return new Promise((ee,he)=>{const Te=X();k(Te)?Te.then(ee,he):ee(Te)})}e.asPromise=a;class o{constructor(){this.a=null,this.b=null,this.d=null}queue(ee){if(this.a){if(this.d=ee,!this.b){const he=()=>{this.b=null;const Te=this.queue(this.d);return this.d=null,Te};this.b=new Promise(Te=>{this.a.then(he,he).then(Te)})}return new Promise((he,Te)=>{this.b.then(he,Te)})}return this.a=ee(),new Promise((he,Te)=>{this.a.then(Ne=>{this.a=null,he(Ne)},Ne=>{this.a=null,Te(Ne)})})}}e.Throttler=o;class l{constructor(){this.a=Promise.resolve(null)}queue(ee){return this.a=this.a.then(()=>ee(),()=>ee())}}e.Sequencer=l;class g{constructor(){this.a=new Map}queue(ee,he){const Ne=(this.a.get(ee)??Promise.resolve()).catch(()=>{}).then(he).finally(()=>{this.a.get(ee)===Ne&&this.a.delete(ee)});return this.a.set(ee,Ne),Ne}}e.SequencerByKey=g;const E=(X,ee)=>{let he=!0;const Te=setTimeout(()=>{he=!1,ee()},X);return{isTriggered:()=>he,dispose:()=>{clearTimeout(Te),he=!1}}},A=X=>{let ee=!0;return queueMicrotask(()=>{ee&&(ee=!1,X())}),{isTriggered:()=>ee,dispose:()=>{ee=!1}}};class v{constructor(ee){this.defaultDelay=ee,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ee,he=this.defaultDelay){this.g=ee,this.h(),this.b||(this.b=new Promise((Ne,Ke)=>{this.d=Ne,this.f=Ke}).then(()=>{if(this.b=null,this.d=null,this.g){const Ne=this.g;return this.g=null,Ne()}}));const Te=()=>{this.a=null,this.d?.(null)};return this.a=he===y.MicrotaskDelay?A(Te):E(he,Te),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=v;class t{constructor(ee){this.a=new v(ee),this.b=new o}trigger(ee,he){return this.a.trigger(()=>this.b.queue(ee),he)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class h{constructor(){this.a=!1,this.b=new Promise((ee,he)=>{this.d=ee})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=h;class r extends h{constructor(ee){super(),this.f=setTimeout(()=>this.open(),ee)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function u(X,ee){return ee?new Promise((he,Te)=>{const Ne=setTimeout(()=>{Ke.dispose(),he()},X),Ke=ee.onCancellationRequested(()=>{clearTimeout(Ne),Ke.dispose(),Te(new C.CancellationError)})}):N(he=>u(X,he))}e.timeout=u;function i(X,ee=0){const he=setTimeout(X,ee);return(0,M.toDisposable)(()=>clearTimeout(he))}e.disposableTimeout=i;function p(X){const ee=[];let he=0;const Te=X.length;function Ne(){return he<Te?X[he++]():null}function Ke(Pe){Pe!=null&&ee.push(Pe);const Se=Ne();return Se?Se.then(Ke):Promise.resolve(ee)}return Promise.resolve(null).then(Ke)}e.sequence=p;function c(X,ee=Te=>!!Te,he=null){let Te=0;const Ne=X.length,Ke=()=>{if(Te>=Ne)return Promise.resolve(he);const Pe=X[Te++];return Promise.resolve(Pe()).then(Ie=>ee(Ie)?Promise.resolve(Ie):Ke())};return Ke()}e.first=c;function s(X,ee=Te=>!!Te,he=null){if(X.length===0)return Promise.resolve(he);let Te=X.length;const Ne=()=>{Te=-1;for(const Ke of X)Ke.cancel?.()};return new Promise((Ke,Pe)=>{for(const Se of X)Se.then(Ie=>{--Te>=0&&ee(Ie)?(Ne(),Ke(Ie)):Te===0&&Ke(he)}).catch(Ie=>{--Te>=0&&(Ne(),Pe(Ie))})})}e.firstParallel=s;class d{constructor(ee){this.a=0,this.d=ee,this.f=[],this.b=0,this.g=new D.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(ee){return this.a++,new Promise((he,Te)=>{this.f.push({factory:ee,c:he,e:Te}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ee=this.f.shift();this.b++;const he=ee.factory();he.then(ee.c,ee.e),he.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=d;class T extends d{constructor(){super(1)}}e.Queue=T;class O{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const ee=new _;return this.b.add(ee),ee.p}d(){for(const[,ee]of this.a)if(ee.size>0)return!1;return!0}queueFor(ee,he=S.extUri){const Te=he.getComparisonKey(ee);let Ne=this.a.get(Te);return Ne||(Ne=new T,D.Event.once(Ne.onDrained)(()=>{Ne?.dispose(),this.a.delete(Te),this.f()}),this.a.set(Te,Ne)),Ne}f(){!this.d()||this.g()}g(){for(const ee of this.b)ee.complete();this.b.clear()}dispose(){for(const[,ee]of this.a)ee.dispose();this.a.clear(),this.g()}}e.ResourceQueue=O;class H{constructor(ee,he){this.a=-1,typeof ee=="function"&&typeof he=="number"&&this.setIfNotSet(ee,he)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ee,he){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ee()},he)}setIfNotSet(ee,he){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ee()},he))}}e.TimeoutTimer=H;class J{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(ee,he){this.cancel(),this.a=setInterval(()=>{ee()},he)}}e.IntervalTimer=J;class K{constructor(ee,he){this.b=-1,this.a=ee,this.d=he,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ee=this.d){this.cancel(),this.b=setTimeout(this.f,ee)}get delay(){return this.d}set delay(ee){this.d=ee}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=K;class L{constructor(ee,he){he%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${he}ms is not a multiple of 1000ms.`),this.a=ee,this.b=he,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ee=this.b){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ee/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=L;class B extends K{constructor(ee,he){super(ee,he),this.j=[]}work(ee){this.j.push(ee),this.isScheduled()||this.schedule()}h(){const ee=this.j;this.j=[],this.a?.(ee)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=B;class P extends M.Disposable{constructor(ee,he){super(),this.g=ee,this.h=he,this.a=[],this.b=this.B(new M.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(ee){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ee.length>this.g.maxBufferedWork)return!1}else if(this.pending+ee.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const he of ee)this.a.push(he);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=P,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=X=>{(0,R.setTimeout0)(()=>{if(ee)return;const he=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.runWhenIdle=(X,ee)=>{const he=requestIdleCallback(X,typeof ee=="number"?{timeout:ee}:void 0);let Te=!1;return{dispose(){Te||(Te=!0,cancelIdleCallback(he))}}}}();class F{constructor(ee){this.d=!1,this.a=()=>{try{this.f=ee()}catch(he){this.g=he}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=F;async function V(X,ee,he){let Te;for(let Ne=0;Ne<he;Ne++)try{return await X()}catch(Ke){Te=Ke,await u(ee)}throw Te}e.retry=V;class j{hasPending(ee){return this.a?typeof ee=="number"?this.a.taskId===ee:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(ee,he,Te){return this.a={taskId:ee,cancel:()=>Te?.(),promise:he},he.then(()=>this.d(ee),()=>this.d(ee)),he}d(ee){this.a&&ee===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ee=this.b;this.b=void 0,ee.run().then(ee.promiseResolve,ee.promiseReject)}}setNext(ee){if(this.b)this.b.run=ee;else{let he,Te;const Ne=new Promise((Ke,Pe)=>{he=Ke,Te=Pe});this.b={run:ee,promise:Ne,promiseResolve:he,promiseReject:Te}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=j;class le{constructor(ee,he=()=>Date.now()){this.d=ee,this.f=he,this.a=0,this.b=0}increment(){const ee=this.f();return ee-this.a>this.d&&(this.a=ee,this.b=0),this.b++,this.b}}e.IntervalCounter=le;class _{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((ee,he)=>{this.a=ee,this.b=he})}complete(ee){return new Promise(he=>{this.a(ee),this.f=!0,he()})}error(ee){return new Promise(he=>{this.b(ee),this.d=!0,he()})}cancel(){new Promise(ee=>{this.b(new C.CancellationError),this.d=!0,ee()})}}e.DeferredPromise=_;var be;(function(X){async function ee(Te){let Ne;const Ke=await Promise.all(Te.map(Pe=>Pe.then(Se=>Se,Se=>{Ne||(Ne=Se)})));if(typeof Ne<"u")throw Ne;return Ke}X.settled=ee;function he(Te){return new Promise(async(Ne,Ke)=>{try{await Te(Ne,Ke)}catch(Pe){Ke(Pe)}})}X.withAsyncBody=he})(be=e.Promises||(e.Promises={}));var de;(function(X){X[X.Initial=0]="Initial",X[X.DoneOK=1]="DoneOK",X[X.DoneError=2]="DoneError"})(de||(de={}));class ue{static fromArray(ee){return new ue(he=>{he.emitMany(ee)})}static fromPromise(ee){return new ue(async he=>{he.emitMany(await ee)})}static fromPromises(ee){return new ue(async he=>{await Promise.all(ee.map(async Te=>he.emitOne(await Te)))})}static merge(ee){return new ue(async he=>{await Promise.all(ee.map(async Te=>{for await(const Ne of Te)he.emitOne(Ne)}))})}constructor(ee){this.a=0,this.b=[],this.d=null,this.f=new D.Emitter,queueMicrotask(async()=>{const he={emitOne:Te=>this.g(Te),emitMany:Te=>this.h(Te),reject:Te=>this.k(Te)};try{await Promise.resolve(ee(he)),this.j()}catch(Te){this.k(Te)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let ee=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ee<this.b.length)return{done:!1,value:this.b[ee++]};if(this.a===1)return{done:!0,value:void 0};await D.Event.toPromise(this.f.event)}while(!0)}}}static map(ee,he){return new ue(async Te=>{for await(const Ne of ee)Te.emitOne(he(Ne))})}map(ee){return ue.map(this,ee)}static filter(ee,he){return new ue(async Te=>{for await(const Ne of ee)he(Ne)&&Te.emitOne(Ne)})}filter(ee){return ue.filter(this,ee)}static coalesce(ee){return ue.filter(ee,he=>!!he)}coalesce(){return ue.coalesce(this)}static async toPromise(ee){const he=[];for await(const Te of ee)he.push(Te);return he}toPromise(){return ue.toPromise(this)}g(ee){this.a===0&&(this.b.push(ee),this.f.fire())}h(ee){this.a===0&&(this.b=this.b.concat(ee),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ee){this.a===0&&(this.a=2,this.d=ee,this.f.fire())}}ue.EMPTY=ue.fromArray([]),e.AsyncIterableObject=ue;class se extends ue{constructor(ee,he){super(he),this.l=ee}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=se;function Z(X){const ee=new n.CancellationTokenSource,he=X(ee.token);return new se(ee,async Te=>{const Ne=ee.token.onCancellationRequested(()=>{Ne.dispose(),ee.dispose(),Te.reject(new C.CancellationError)});try{for await(const Ke of he){if(ee.token.isCancellationRequested)return;Te.emitOne(Ke)}Ne.dispose(),ee.dispose()}catch(Ke){Ne.dispose(),ee.dispose(),Te.reject(Ke)}})}e.createCancelableAsyncIterable=Z}),define(Ce[35],ke([1,0,15,17,40,28,19,21,10]),function(te,e,n,C,D,M,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const N="[/\\\\]",w="[^/\\\\]",f=/\//g;function b(le,_){switch(le){case 0:return"";case 1:return`${w}*?`;default:return`(?:${N}|${w}+${N}${_?`|${N}${w}+`:""})*?`}}function m(le,_){if(!le)return[];const be=[];let de=!1,ue=!1,se="";for(const Z of le){switch(Z){case _:if(!de&&!ue){be.push(se),se="";continue}break;case"{":de=!0;break;case"}":de=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}se+=Z}return se&&be.push(se),be}e.splitGlobAware=m;function a(le){if(!le)return"";let _="";const be=m(le,e.GLOB_SPLIT);if(be.every(de=>de===e.GLOBSTAR))_=".*";else{let de=!1;be.forEach((ue,se)=>{if(ue===e.GLOBSTAR){if(de)return;_+=b(2,se===be.length-1)}else{let Z=!1,X="",ee=!1,he="";for(const Te of ue){if(Te!=="}"&&Z){X+=Te;continue}if(ee&&(Te!=="]"||!he)){let Ne;Te==="-"?Ne=Te:(Te==="^"||Te==="!")&&!he?Ne="^":Te===e.GLOB_SPLIT?Ne="":Ne=(0,y.escapeRegExpCharacters)(Te),he+=Ne;continue}switch(Te){case"{":Z=!0;continue;case"[":ee=!0;continue;case"}":{_+=`(?:${m(X,",").map(Pe=>a(Pe)).join("|")})`,Z=!1,X="";break}case"]":{_+="["+he+"]",ee=!1,he="";break}case"?":_+=w;continue;case"*":_+=b(1);continue;default:_+=(0,y.escapeRegExpCharacters)(Te)}}se<be.length-1&&(be[se+1]!==e.GLOBSTAR||se+2<be.length)&&(_+=N)}de=ue===e.GLOBSTAR})}return _}const o=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,E=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,A=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.LRUCache(1e4),h=function(){return!1},r=function(){return null};function u(le,_){if(!le)return r;let be;typeof le!="string"?be=le.pattern:be=le,be=be.trim();const de=`${be}_${!!_.trimForExclusions}`;let ue=t.get(de);if(ue)return i(ue,le);let se;return o.test(be)?ue=c(be.substr(4),be):(se=l.exec(p(be,_)))?ue=s(se[1],be):(_.trimForExclusions?E:g).test(be)?ue=d(be,_):(se=A.exec(p(be,_)))?ue=T(se[1].substr(1),be,!0):(se=v.exec(p(be,_)))?ue=T(se[1],be,!1):ue=O(be),t.set(de,ue),i(ue,le)}function i(le,_){if(typeof _=="string")return le;const be=function(de,ue){return(0,D.isEqualOrParent)(de,_.base,!R.isLinux)?le((0,y.ltrim)(de.substr(_.base.length),S.sep),ue):null};return be.allBasenames=le.allBasenames,be.allPaths=le.allPaths,be.basenames=le.basenames,be.patterns=le.patterns,be}function p(le,_){return _.trimForExclusions&&le.endsWith("/**")?le.substr(0,le.length-2):le}function c(le,_){return function(be,de){return typeof be=="string"&&be.endsWith(le)?_:null}}function s(le,_){const be=`/${le}`,de=`\\${le}`,ue=function(Z,X){return typeof Z!="string"?null:X?X===le?_:null:Z===le||Z.endsWith(be)||Z.endsWith(de)?_:null},se=[le];return ue.basenames=se,ue.patterns=[_],ue.allBasenames=se,ue}function d(le,_){const be=V(le.slice(1,-1).split(",").map(X=>u(X,_)).filter(X=>X!==r),le),de=be.length;if(!de)return r;if(de===1)return be[0];const ue=function(X,ee){for(let he=0,Te=be.length;he<Te;he++)if(be[he](X,ee))return le;return null},se=be.find(X=>!!X.allBasenames);se&&(ue.allBasenames=se.allBasenames);const Z=be.reduce((X,ee)=>ee.allPaths?X.concat(ee.allPaths):X,[]);return Z.length&&(ue.allPaths=Z),ue}function T(le,_,be){const de=S.sep===S.posix.sep,ue=de?le:le.replace(f,S.sep),se=S.sep+ue,Z=S.posix.sep+le;let X;return be?X=function(ee,he){return typeof ee=="string"&&(ee===ue||ee.endsWith(se)||!de&&(ee===le||ee.endsWith(Z)))?_:null}:X=function(ee,he){return typeof ee=="string"&&(ee===ue||!de&&ee===le)?_:null},X.allPaths=[(be?"*/":"./")+le],X}function O(le){try{const _=new RegExp(`^${a(le)}$`);return function(be){return _.lastIndex=0,typeof be=="string"&&_.test(be)?le:null}}catch{return r}}function H(le,_,be){return!le||typeof _!="string"?!1:J(le)(_,void 0,be)}e.match=H;function J(le,_={}){if(!le)return h;if(typeof le=="string"||K(le)){const be=u(le,_);if(be===r)return h;const de=function(ue,se){return!!be(ue,se)};return be.allBasenames&&(de.allBasenames=be.allBasenames),be.allPaths&&(de.allPaths=be.allPaths),de}return P(le,_)}e.parse=J;function K(le){const _=le;return _?typeof _.base=="string"&&typeof _.pattern=="string":!1}e.isRelativePattern=K;function L(le){return le.allBasenames||[]}e.getBasenameTerms=L;function B(le){return le.allPaths||[]}e.getPathTerms=B;function P(le,_){const be=V(Object.getOwnPropertyNames(le).map(X=>F(X,le[X],_)).filter(X=>X!==r)),de=be.length;if(!de)return r;if(!be.some(X=>!!X.requiresSiblings)){if(de===1)return be[0];const X=function(Te,Ne){let Ke;for(let Pe=0,Se=be.length;Pe<Se;Pe++){const Ie=be[Pe](Te,Ne);if(typeof Ie=="string")return Ie;(0,C.isThenable)(Ie)&&(Ke||(Ke=[]),Ke.push(Ie))}return Ke?(async()=>{for(const Pe of Ke){const Se=await Pe;if(typeof Se=="string")return Se}return null})():null},ee=be.find(Te=>!!Te.allBasenames);ee&&(X.allBasenames=ee.allBasenames);const he=be.reduce((Te,Ne)=>Ne.allPaths?Te.concat(Ne.allPaths):Te,[]);return he.length&&(X.allPaths=he),X}const ue=function(X,ee,he){let Te,Ne;for(let Ke=0,Pe=be.length;Ke<Pe;Ke++){const Se=be[Ke];Se.requiresSiblings&&he&&(ee||(ee=(0,S.basename)(X)),Te||(Te=ee.substr(0,ee.length-(0,S.extname)(X).length)));const Ie=Se(X,ee,Te,he);if(typeof Ie=="string")return Ie;(0,C.isThenable)(Ie)&&(Ne||(Ne=[]),Ne.push(Ie))}return Ne?(async()=>{for(const Ke of Ne){const Pe=await Ke;if(typeof Pe=="string")return Pe}return null})():null},se=be.find(X=>!!X.allBasenames);se&&(ue.allBasenames=se.allBasenames);const Z=be.reduce((X,ee)=>ee.allPaths?X.concat(ee.allPaths):X,[]);return Z.length&&(ue.allPaths=Z),ue}function F(le,_,be){if(_===!1)return r;const de=u(le,be);if(de===r)return r;if(typeof _=="boolean")return de;if(_){const ue=_.when;if(typeof ue=="string"){const se=(Z,X,ee,he)=>{if(!he||!de(Z,X))return null;const Te=ue.replace("$(basename)",()=>ee),Ne=he(Te);return(0,C.isThenable)(Ne)?Ne.then(Ke=>Ke?le:null):Ne?le:null};return se.requiresSiblings=!0,se}}return de}function V(le,_){const be=le.filter(X=>!!X.basenames);if(be.length<2)return le;const de=be.reduce((X,ee)=>{const he=ee.basenames;return he?X.concat(he):X},[]);let ue;if(_){ue=[];for(let X=0,ee=de.length;X<ee;X++)ue.push(_)}else ue=be.reduce((X,ee)=>{const he=ee.patterns;return he?X.concat(he):X},[]);const se=function(X,ee){if(typeof X!="string")return null;if(!ee){let Te;for(Te=X.length;Te>0;Te--){const Ne=X.charCodeAt(Te-1);if(Ne===47||Ne===92)break}ee=X.substr(Te)}const he=de.indexOf(ee);return he!==-1?ue[he]:null};se.basenames=de,se.patterns=ue,se.allBasenames=de;const Z=le.filter(X=>!X.basenames);return Z.push(se),Z}function j(le,_){return(0,n.equals)(le,_,(be,de)=>typeof be=="string"&&typeof de=="string"?be===de:typeof be!="string"&&typeof de!="string"?be.base===de.base&&be.pattern===de.pattern:!1)}e.patternsEquals=j}),define(Ce[86],ke([1,0,12,126,24,10,2]),function(te,e,n,C,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var R;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(R=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(l="",g=!1){if(this.value=l,typeof this.value!="string")throw(0,n.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(l,g=0){return this.value+=f(this.supportThemeIcons?(0,C.escapeIcons)(l):l).replace(/([ \t]+)/g,(E,A)=>"&nbsp;".repeat(A.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,g){return this.value+="\n```",this.value+=l,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(l,g,E){return this.value+="[",this.value+=this.c(g,"]"),this.value+="](",this.value+=this.c(String(l),")"),E&&(this.value+=` "${this.c(this.c(E,'"'),")")}"`),this.value+=")",this}c(l,g){const E=new RegExp((0,M.escapeRegExpCharacters)(g),"g");return l.replace(E,(A,v)=>l.charAt(v-1)!=="\\"?`\\${A}`:A)}}e.MarkdownString=y;function k(o){return N(o)?!o.value:Array.isArray(o)?o.every(k):!0}e.isEmptyMarkdownString=k;function N(o){return o instanceof y?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=N;function w(o,l){return o===l?!0:!o||!l?!1:o.value===l.value&&o.isTrusted===l.isTrusted&&o.supportThemeIcons===l.supportThemeIcons&&o.supportHtml===l.supportHtml&&(o.baseUri===l.baseUri||!!o.baseUri&&!!l.baseUri&&(0,D.isEqual)(S.URI.from(o.baseUri),S.URI.from(l.baseUri)))}e.markdownStringEqual=w;function f(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=f;function b(o){return o.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=b;function m(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=m;function a(o){const l=[],g=o.split("|").map(A=>A.trim());o=g[0];const E=g[1];if(E){const A=/height=(\d+)/.exec(E),v=/width=(\d+)/.exec(E),t=A?A[1]:"",h=v?v[1]:"",r=isFinite(parseInt(h)),u=isFinite(parseInt(t));r&&l.push(`width="${h}"`),u&&l.push(`height="${t}"`)}return{href:o,dimensions:l}}e.parseHrefAndDimensions=a}),define(Ce[87],ke([1,0,15,40,19,21,24,10]),function(te,e,n,C,D,M,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(r,u){const{os:i,tildify:p,relative:c}=u;if(c){const T=k(r,c,i);if(typeof T=="string")return T}let s=r.fsPath;if(i===1&&!M.isWindows?s=s.replace(/\//g,"\\"):i!==1&&M.isWindows&&(s=s.replace(/\\/g,"/")),i!==1&&p?.userHome){const T=p.userHome.fsPath;let O;r.scheme!==p.userHome.scheme&&r.path.startsWith(D.posix.sep)?O=p.userHome.with({path:r.path}).fsPath:O=r.fsPath,s=f(O,T,i)}return(i===1?D.win32:D.posix).normalize(N(s,i===1))}e.getPathLabel=y;function k(r,u,i){const p=i===1?D.win32:D.posix,c=i===3?S.extUri:S.extUriIgnorePathCase,s=u.getWorkspace(),d=(0,n.firstOrDefault)(s.folders);if(!d)return;r.scheme!==d.uri.scheme&&r.path.startsWith(D.posix.sep)&&(r=d.uri.with({path:r.path}));const T=u.getWorkspaceFolder(r);if(!T)return;let O;if(c.isEqual(T.uri,r)?O="":O=c.relativePath(T.uri,r)??"",O&&(O=p.normalize(O)),s.folders.length>1&&!u.noPrefix){const H=T.name?T.name:c.basenameOrAuthority(T.uri);O=O?`${H} \u2022 ${O}`:H}return O}function N(r,u=M.isWindows){return(0,C.hasDriveLetter)(r,u)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=N;let w=Object.create(null);function f(r,u,i=M.OS){if(i===1||!r||!u)return r;let p=w.original===u?w.normalized:void 0;p||(p=u,M.isWindows&&(p=(0,C.toSlashes)(p)),p=`${(0,R.rtrim)(p,D.posix.sep)}${D.posix.sep}`,w={original:u,normalized:p});let c=r;return M.isWindows&&(c=(0,C.toSlashes)(c)),(i===3?c.startsWith(p):(0,R.startsWithIgnoreCase)(c,p))?`~/${c.substr(p.length)}`:r}e.tildify=f;function b(r,u){return r.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=b;const m="\u2026",a="\\\\",o="~";function l(r,u=D.sep){const i=new Array(r.length);let p=!1;for(let c=0;c<r.length;c++){const s=r[c];if(s===""){i[c]=`.${u}`;continue}if(!s){i[c]=s;continue}p=!0;let d="",T=s;T.indexOf(a)===0?(d=T.substr(0,T.indexOf(a)+a.length),T=T.substr(T.indexOf(a)+a.length)):T.indexOf(u)===0?(d=T.substr(0,T.indexOf(u)+u.length),T=T.substr(T.indexOf(u)+u.length)):T.indexOf(o)===0&&(d=T.substr(0,T.indexOf(o)+o.length),T=T.substr(T.indexOf(o)+o.length));const O=T.split(u);for(let H=1;p&&H<=O.length;H++)for(let J=O.length-H;p&&J>=0;J--){p=!1;let K=O.slice(J,J+H).join(u);for(let L=0;!p&&L<r.length;L++)if(L!==c&&r[L]&&r[L].indexOf(K)>-1){const B=J+H===O.length,P=J>0&&r[L].indexOf(u)>-1?u+K:K,F=r[L].endsWith(P);p=!B||F}if(!p){let L="";(O[0].endsWith(":")||d!=="")&&(J===1&&(J=0,H++,K=O[0]+u+K),J>0&&(L=O[0]+u),L=d+L),J>0&&(L=L+m+u),L=L+K,J+H<O.length&&(L=L+u+m),i[c]=L}}p&&(i[c]=s)}return i}e.shorten=l;var g;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function E(r,u=Object.create(null)){const i=[];let p=!1,c="";for(const s of r)if(s==="$"||p&&s==="{")c&&i.push({value:c,type:g.TEXT}),c="",p=!0;else if(s==="}"&&p){const d=u[c];if(typeof d=="string")d.length&&i.push({value:d,type:g.VARIABLE});else if(d){const T=i[i.length-1];(!T||T.type!==g.SEPARATOR)&&i.push({value:d.label,type:g.SEPARATOR})}c="",p=!1}else c+=s;return c&&!p&&i.push({value:c,type:g.TEXT}),i.filter((s,d)=>{if(s.type===g.SEPARATOR){const T=i[d-1],O=i[d+1];return[T,O].every(H=>H&&(H.type===g.VARIABLE||H.type===g.TEXT)&&H.value.length>0)}return!0}).map(s=>s.value).join("")}e.template=E;function A(r,u){return M.isMacintosh||u?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):r.replace(/&&|&/g,i=>i==="&"?"&&":"&")}e.mnemonicMenuLabel=A;function v(r,u){return M.isMacintosh||u?r.replace(/\(&&\w\)|&&/g,""):M.isWindows?r.replace(/&&|&/g,i=>i==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=v;function t(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=t;function h(r){const u=r.indexOf("/")!==-1?D.posix:D.win32,i=u.basename(r),p=u.dirname(r);return i.length?{name:i,parentPath:p}:{name:p,parentPath:""}}e.splitName=h}),define(Ce[127],ke([1,0,23,2]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function D(w){return w.toJSON()}class M{constructor(f){this.a=f}transformIncoming(f){const b=this.a.transformIncoming(f);return b===f?f:D(C.URI.from(b))}transformOutgoing(f){const b=this.a.transformOutgoing(f);return b===f?f:D(C.URI.from(b))}transformOutgoingURI(f){const b=this.a.transformOutgoing(f);return b===f?f:C.URI.from(b)}transformOutgoingScheme(f){return this.a.transformOutgoingScheme(f)}}e.URITransformer=M,e.DefaultURITransformer=new class{transformIncoming(w){return w}transformOutgoing(w){return w}transformOutgoingURI(w){return w}transformOutgoingScheme(w){return w}};function S(w,f,b){if(!w||b>200)return null;if(typeof w=="object"){if(w instanceof C.URI)return f.transformOutgoing(w);for(const m in w)if(Object.hasOwnProperty.call(w,m)){const a=S(w[m],f,b+1);a!==null&&(w[m]=a)}}return null}function R(w,f){const b=S(w,f,0);return b===null?w:b}e.transformOutgoingURIs=R;function y(w,f,b,m){if(!w||m>200)return null;if(typeof w=="object"){if(w.$mid===1)return b?C.URI.revive(f.transformIncoming(w)):f.transformIncoming(w);if(w instanceof n.VSBuffer)return null;for(const a in w)if(Object.hasOwnProperty.call(w,a)){const o=y(w[a],f,b,m+1);o!==null&&(w[a]=o)}}return null}function k(w,f){const b=y(w,f,!1,0);return b===null?w:b}e.transformIncomingURIs=k;function N(w,f){const b=y(w,f,!0,0);return b===null?w:b}e.transformAndReviveIncomingURIs=N}),define(Ce[128],ke([1,0,35,19]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(M,S,R,y,k,N){if(Array.isArray(M)){let w=0;for(const f of M){const b=D(f,S,R,y,k,N);if(b===10)return b;b>w&&(w=b)}return w}else{if(typeof M=="string")return y?M==="*"?5:M===R?10:0:0;if(M){const{language:w,pattern:f,scheme:b,hasAccessToAllModels:m,notebookType:a}=M;if(!y&&!m)return 0;a&&k&&(S=k);let o=0;if(b)if(b===S.scheme)o=10;else if(b==="*")o=5;else return 0;if(w)if(w===R)o=10;else if(w==="*")o=Math.max(o,5);else return 0;if(a)if(a===N)o=10;else if(a==="*"&&N!==void 0)o=Math.max(o,5);else return 0;if(f){let l;if(typeof f=="string"?l=f:l={...f,base:(0,C.normalize)(f.base)},l===S.fsPath||(0,n.match)(l,S.fsPath))o=10;else return 0}return o}else return 0}}e.score=D}),define(Ce[88],ke([1,0,23,21]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(w){w[w.Full=1]="Full",w[w.Delta=2]="Delta"})(D||(D={}));function M(w){for(let f=0,b=w.length;f<b;f+=4){const m=w[f+0],a=w[f+1],o=w[f+2],l=w[f+3];w[f+0]=l,w[f+1]=o,w[f+2]=a,w[f+3]=m}}function S(w){const f=new Uint8Array(w.buffer,w.byteOffset,w.length*4);return C.isLittleEndian()||M(f),n.VSBuffer.wrap(f)}function R(w){const f=w.buffer;if(C.isLittleEndian()||M(f),f.byteOffset%4===0)return new Uint32Array(f.buffer,f.byteOffset,f.length/4);{const b=new Uint8Array(f.byteLength);return b.set(f),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function y(w){const f=new Uint32Array(k(w));let b=0;if(f[b++]=w.id,w.type==="full")f[b++]=1,f[b++]=w.data.length,f.set(w.data,b),b+=w.data.length;else{f[b++]=2,f[b++]=w.deltas.length;for(const m of w.deltas)f[b++]=m.start,f[b++]=m.deleteCount,m.data?(f[b++]=m.data.length,f.set(m.data,b),b+=m.data.length):f[b++]=0}return S(f)}e.encodeSemanticTokensDto=y;function k(w){let f=0;if(f+=1+1,w.type==="full")f+=1+w.data.length;else{f+=1,f+=(1+1+1)*w.deltas.length;for(const b of w.deltas)b.data&&(f+=b.data.length)}return f}function N(w){const f=R(w);let b=0;const m=f[b++];if(f[b++]===1){const g=f[b++],E=f.subarray(b,b+g);return b+=g,{id:m,type:"full",data:E}}const o=f[b++],l=[];for(let g=0;g<o;g++){const E=f[b++],A=f[b++],v=f[b++];let t;v>0&&(t=f.subarray(b,b+v),b+=v),l[g]={start:E,deleteCount:A,data:t}}return{id:m,type:"delta",deltas:l}}e.decodeSemanticTokensDto=N}),define(Ce[129],ke([13,14]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(Ce[130],ke([1,0,129,21,131,15,22,117]),function(te,e,n,C,D,M,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(G){this.c=G}hasChanged(G){return this.c[G]}}e.ConfigurationChangedEvent=k;class N{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=N;class w{constructor(G,pe,Me,ze){this.id=G,this.name=pe,this.defaultValue=Me,this.schema=ze}applyUpdate(G,pe){return b(G,pe)}compute(G,pe,Me){return Me}}class f{constructor(G,pe){this.newValue=G,this.didChange=pe}}e.ApplyUpdateResult=f;function b(Q,G){if(typeof Q!="object"||typeof G!="object"||!Q||!G)return new f(G,Q!==G);if(Array.isArray(Q)||Array.isArray(G)){const Me=Array.isArray(Q)&&Array.isArray(G)&&M.equals(Q,G);return new f(G,!Me)}let pe=!1;for(const Me in G)if(G.hasOwnProperty(Me)){const ze=b(Q[Me],G[Me]);ze.didChange&&(Q[Me]=ze.newValue,pe=!0)}return new f(Q,pe)}class m{constructor(G){this.schema=void 0,this.id=G,this.name="_never_",this.defaultValue=void 0}applyUpdate(G,pe){return b(G,pe)}validate(G){return this.defaultValue}}class a{constructor(G,pe,Me,ze){this.id=G,this.name=pe,this.defaultValue=Me,this.schema=ze}applyUpdate(G,pe){return b(G,pe)}validate(G){return typeof G>"u"?this.defaultValue:G}compute(G,pe,Me){return Me}}function o(Q,G){return typeof Q>"u"?G:Q==="false"?!1:Boolean(Q)}e.boolean=o;class l extends a{constructor(G,pe,Me,ze=void 0){typeof ze<"u"&&(ze.type="boolean",ze.default=Me),super(G,pe,Me,ze)}validate(G){return o(G,this.defaultValue)}}function g(Q,G,pe,Me){if(typeof Q>"u")return G;let ze=parseInt(Q,10);return isNaN(ze)?G:(ze=Math.max(pe,ze),ze=Math.min(Me,ze),ze|0)}e.clampedInt=g;class E extends a{static clampedInt(G,pe,Me,ze){return g(G,pe,Me,ze)}constructor(G,pe,Me,ze,Ve,_e=void 0){typeof _e<"u"&&(_e.type="integer",_e.default=Me,_e.minimum=ze,_e.maximum=Ve),super(G,pe,Me,_e),this.minimum=ze,this.maximum=Ve}validate(G){return E.clampedInt(G,this.defaultValue,this.minimum,this.maximum)}}class A extends a{static clamp(G,pe,Me){return G<pe?pe:G>Me?Me:G}static float(G,pe){if(typeof G=="number")return G;if(typeof G>"u")return pe;const Me=parseFloat(G);return isNaN(Me)?pe:Me}constructor(G,pe,Me,ze,Ve){typeof Ve<"u"&&(Ve.type="number",Ve.default=Me),super(G,pe,Me,Ve),this.validationFn=ze}validate(G){return this.validationFn(A.float(G,this.defaultValue))}}class v extends a{static string(G,pe){return typeof G!="string"?pe:G}constructor(G,pe,Me,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.default=Me),super(G,pe,Me,ze)}validate(G){return v.string(G,this.defaultValue)}}function t(Q,G,pe){return typeof Q!="string"||pe.indexOf(Q)===-1?G:Q}e.stringSet=t;class h extends a{constructor(G,pe,Me,ze,Ve=void 0){typeof Ve<"u"&&(Ve.type="string",Ve.enum=ze,Ve.default=Me),super(G,pe,Me,Ve),this.c=ze}validate(G){return t(G,this.defaultValue,this.c)}}class r extends w{constructor(G,pe,Me,ze,Ve,_e,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=Ve,nt.default=ze),super(G,pe,Me,nt),this.c=Ve,this.d=_e}validate(G){return typeof G!="string"?this.defaultValue:this.c.indexOf(G)===-1?this.defaultValue:this.d(G)}}function u(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends w{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[n.localize(0,null),n.localize(1,null),n.localize(2,null)],default:"auto",tags:["accessibility"],description:n.localize(3,null)})}validate(G){switch(G){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(G,pe,Me){return Me===0?G.accessibilitySupport:Me}}class p extends w{constructor(){const G={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",G,{"editor.comments.insertSpace":{type:"boolean",default:G.insertSpace,description:n.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:G.ignoreEmptyLines,description:n.localize(5,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const pe=G;return{insertSpace:o(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var c;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(c=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(d=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function T(Q){switch(Q){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=T;function O(Q){switch(Q){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class H extends m{constructor(){super(135)}compute(G,pe,Me){const ze=["monaco-editor"];return pe.get(36)&&ze.push(pe.get(36)),G.extraEditorClassName&&ze.push(G.extraEditorClassName),pe.get(70)==="default"?ze.push("mouse-default"):pe.get(70)==="copy"&&ze.push("mouse-copy"),pe.get(105)&&ze.push("showUnused"),pe.get(133)&&ze.push("showDeprecated"),ze.join(" ")}}class J extends l{constructor(){super(34,"emptySelectionClipboard",!0,{description:n.localize(6,null)})}compute(G,pe,Me){return Me&&G.emptySelectionClipboard}}class K extends w{constructor(){const G={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",G,{"editor.find.cursorMoveOnType":{type:"boolean",default:G.cursorMoveOnType,description:n.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:G.seedSearchStringFromSelection,enumDescriptions:[n.localize(8,null),n.localize(9,null),n.localize(10,null)],description:n.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:G.autoFindInSelection,enumDescriptions:[n.localize(12,null),n.localize(13,null),n.localize(14,null)],description:n.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:G.globalFindClipboard,description:n.localize(16,null),included:C.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:G.addExtraSpaceOnTop,description:n.localize(17,null)},"editor.find.loop":{type:"boolean",default:G.loop,description:n.localize(18,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const pe=G;return{cursorMoveOnType:o(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof G.seedSearchStringFromSelection=="boolean"?G.seedSearchStringFromSelection?"always":"never":t(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof G.autoFindInSelection=="boolean"?G.autoFindInSelection?"always":"never":t(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(pe.loop,this.defaultValue.loop)}}}class L extends w{constructor(){super(48,"fontLigatures",L.OFF,{anyOf:[{type:"boolean",description:n.localize(19,null)},{type:"string",description:n.localize(20,null)}],description:n.localize(21,null),default:!1})}validate(G){return typeof G>"u"?this.defaultValue:typeof G=="string"?G==="false"?L.OFF:G==="true"?L.ON:G:Boolean(G)?L.ON:L.OFF}}L.OFF='"liga" off, "calt" off',L.ON='"liga" on, "calt" on',e.EditorFontLigatures=L;class B extends w{constructor(){super(51,"fontVariations",B.OFF,{anyOf:[{type:"boolean",description:n.localize(22,null)},{type:"string",description:n.localize(23,null)}],description:n.localize(24,null),default:!1})}validate(G){return typeof G>"u"?this.defaultValue:typeof G=="string"?G==="false"?B.OFF:G==="true"?B.TRANSLATE:G:Boolean(G)?B.TRANSLATE:B.OFF}compute(G,pe,Me){return G.fontInfo.fontVariationSettings}}B.OFF="normal",B.TRANSLATE="translate",e.EditorFontVariations=B;class P extends m{constructor(){super(47)}compute(G,pe,Me){return G.fontInfo}}class F extends a{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:n.localize(25,null)})}validate(G){const pe=A.float(G,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:A.clamp(pe,6,100)}compute(G,pe,Me){return G.fontInfo.fontSize}}class V extends w{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.d,maximum:V.e,errorMessage:n.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:n.localize(27,null)})}validate(G){return G==="normal"||G==="bold"?G:String(E.clampedInt(G,e.EDITOR_FONT_DEFAULTS.fontWeight,V.d,V.e))}}V.c=["normal","bold","100","200","300","400","500","600","700","800","900"],V.d=1,V.e=1e3;class j extends w{constructor(){const G={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:G.multiple,enumDescriptions:[n.localize(28,null),n.localize(29,null),n.localize(30,null)]},Me=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",G,{"editor.gotoLocation.multiple":{deprecationMessage:n.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:n.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:n.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:n.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:n.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:n.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:G.alternativeDefinitionCommand,enum:Me,description:n.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:G.alternativeTypeDefinitionCommand,enum:Me,description:n.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:G.alternativeDeclarationCommand,enum:Me,description:n.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:G.alternativeImplementationCommand,enum:Me,description:n.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:G.alternativeReferenceCommand,enum:Me,description:n.localize(41,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const pe=G;return{multiple:t(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??t(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??t(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??t(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??t(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??t(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:v.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:v.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:v.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:v.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:v.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class le extends w{constructor(){const G={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",G,{"editor.hover.enabled":{type:"boolean",default:G.enabled,description:n.localize(42,null)},"editor.hover.delay":{type:"number",default:G.delay,minimum:0,maximum:1e4,description:n.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:G.sticky,description:n.localize(44,null)},"editor.hover.above":{type:"boolean",default:G.above,description:n.localize(45,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const pe=G;return{enabled:o(pe.enabled,this.defaultValue.enabled),delay:E.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:o(pe.sticky,this.defaultValue.sticky),above:o(pe.above,this.defaultValue.above)}}}var _;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(_=e.RenderMinimap||(e.RenderMinimap={}));class be extends m{constructor(){super(138)}compute(G,pe,Me){return be.computeLayout(pe,{memory:G.memory,outerWidth:G.outerWidth,outerHeight:G.outerHeight,isDominatedByLongLines:G.isDominatedByLongLines,lineHeight:G.fontInfo.lineHeight,viewLineCount:G.viewLineCount,lineNumbersDigitCount:G.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:G.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:G.fontInfo.maxDigitWidth,pixelRatio:G.pixelRatio})}static computeContainedMinimapLineCount(G){const pe=G.height/G.lineHeight,Me=Math.floor(G.paddingTop/G.lineHeight);let ze=Math.floor(G.paddingBottom/G.lineHeight);G.scrollBeyondLastLine&&(ze=Math.max(ze,pe-1));const Ve=(Me+G.viewLineCount+ze)/(G.pixelRatio*G.height),_e=Math.floor(G.viewLineCount/Ve);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:Me,extraLinesBeyondLastLine:ze,desiredRatio:Ve,minimapLineCount:_e}}static c(G,pe){const Me=G.outerWidth,ze=G.outerHeight,Ve=G.pixelRatio;if(!G.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ve*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const _e=pe.stableMinimapLayoutInput,nt=_e&&G.outerHeight===_e.outerHeight&&G.lineHeight===_e.lineHeight&&G.typicalHalfwidthCharacterWidth===_e.typicalHalfwidthCharacterWidth&&G.pixelRatio===_e.pixelRatio&&G.scrollBeyondLastLine===_e.scrollBeyondLastLine&&G.paddingTop===_e.paddingTop&&G.paddingBottom===_e.paddingBottom&&G.minimap.enabled===_e.minimap.enabled&&G.minimap.side===_e.minimap.side&&G.minimap.size===_e.minimap.size&&G.minimap.showSlider===_e.minimap.showSlider&&G.minimap.renderCharacters===_e.minimap.renderCharacters&&G.minimap.maxColumn===_e.minimap.maxColumn&&G.minimap.scale===_e.minimap.scale&&G.verticalScrollbarWidth===_e.verticalScrollbarWidth&&G.isViewportWrapping===_e.isViewportWrapping,vt=G.lineHeight,wt=G.typicalHalfwidthCharacterWidth,Ct=G.scrollBeyondLastLine,jt=G.minimap.renderCharacters;let rt=Ve>=2?Math.round(G.minimap.scale*2):G.minimap.scale;const mt=G.minimap.maxColumn,Ft=G.minimap.size,Gt=G.minimap.side,Pt=G.verticalScrollbarWidth,ht=G.viewLineCount,kt=G.remainingWidth,$t=G.isViewportWrapping,Ot=jt?2:3;let Ge=Math.floor(Ve*ze);const Nt=Ge/Ve;let Mt=!1,zt=!1,ft=Ot*rt,De=rt/Ve,Ae=1;if(Ft==="fill"||Ft==="fit"){const{typicalViewportLineCount:Ze,extraLinesBeforeFirstLine:ct,extraLinesBeyondLastLine:Tt,desiredRatio:bt,minimapLineCount:Et}=be.computeContainedMinimapLineCount({viewLineCount:ht,scrollBeyondLastLine:Ct,paddingTop:G.paddingTop,paddingBottom:G.paddingBottom,height:ze,lineHeight:vt,pixelRatio:Ve});if(ht/Et>1)Mt=!0,zt=!0,rt=1,ft=1,De=rt/Ve;else{let St=!1,yt=rt+1;if(Ft==="fit"){const qt=Math.ceil((ct+ht+Tt)*ft);$t&&nt&&kt<=pe.stableFitRemainingWidth?(St=!0,yt=pe.stableFitMaxMinimapScale):St=qt>Ge}if(Ft==="fill"||St){Mt=!0;const qt=rt;ft=Math.min(vt*Ve,Math.max(1,Math.floor(1/bt))),$t&&nt&&kt<=pe.stableFitRemainingWidth&&(yt=pe.stableFitMaxMinimapScale),rt=Math.min(yt,Math.max(1,Math.floor(ft/Ot))),rt>qt&&(Ae=Math.min(2,rt/qt)),De=rt/Ve/Ae,Ge=Math.ceil(Math.max(Ze,ct+ht+Tt)*ft),$t?(pe.stableMinimapLayoutInput=G,pe.stableFitRemainingWidth=kt,pe.stableFitMaxMinimapScale=rt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const ge=Math.floor(mt*De),x=Math.min(ge,Math.max(0,Math.floor((kt-Pt-2)*De/(wt+De)))+e.MINIMAP_GUTTER_WIDTH);let Re=Math.floor(Ve*x);const $e=Re/Ve;Re=Math.floor(Re*Ae);const Qe=jt?1:2,Be=Gt==="left"?0:Me-x-Pt;return{renderMinimap:Qe,minimapLeft:Be,minimapWidth:x,minimapHeightIsEditorHeight:Mt,minimapIsSampling:zt,minimapScale:rt,minimapLineHeight:ft,minimapCanvasInnerWidth:Re,minimapCanvasInnerHeight:Ge,minimapCanvasOuterWidth:$e,minimapCanvasOuterHeight:Nt}}static computeLayout(G,pe){const Me=pe.outerWidth|0,ze=pe.outerHeight|0,Ve=pe.lineHeight|0,_e=pe.lineNumbersDigitCount|0,nt=pe.typicalHalfwidthCharacterWidth,vt=pe.maxDigitWidth,wt=pe.pixelRatio,Ct=pe.viewLineCount,jt=G.get(130),rt=jt==="inherit"?G.get(129):jt,mt=rt==="inherit"?G.get(125):rt,Ft=G.get(128),Gt=pe.isDominatedByLongLines,Pt=G.get(54),ht=G.get(64).renderType!==0,kt=G.get(65),$t=G.get(99),Ot=G.get(80),Ge=G.get(69),Nt=G.get(97),Mt=Nt.verticalScrollbarSize,zt=Nt.verticalHasArrows,ft=Nt.arrowSize,De=Nt.horizontalScrollbarSize,Ae=G.get(40),ge=G.get(104)!=="never";let x=G.get(62);Ae&&ge&&(x+=16);let Re=0;if(ht){const pt=Math.max(_e,kt);Re=Math.round(pt*vt)}let $e=0;Pt&&($e=Ve);let Qe=0,Be=Qe+$e,Ze=Be+Re,ct=Ze+x;const Tt=Me-$e-Re-x;let bt=!1,Et=!1,It=-1;rt==="inherit"&&Gt?(bt=!0,Et=!0):mt==="on"||mt==="bounded"?Et=!0:mt==="wordWrapColumn"&&(It=Ft);const St=be.c({outerWidth:Me,outerHeight:ze,lineHeight:Ve,typicalHalfwidthCharacterWidth:nt,pixelRatio:wt,scrollBeyondLastLine:$t,paddingTop:Ot.top,paddingBottom:Ot.bottom,minimap:Ge,verticalScrollbarWidth:Mt,viewLineCount:Ct,remainingWidth:Tt,isViewportWrapping:Et},pe.memory||new N);St.renderMinimap!==0&&St.minimapLeft===0&&(Qe+=St.minimapWidth,Be+=St.minimapWidth,Ze+=St.minimapWidth,ct+=St.minimapWidth);const yt=Tt-St.minimapWidth,qt=Math.max(1,Math.floor((yt-Mt-2)/nt)),Jt=zt?ft:0;return Et&&(It=Math.max(1,qt),mt==="bounded"&&(It=Math.min(It,Ft))),{width:Me,height:ze,glyphMarginLeft:Qe,glyphMarginWidth:$e,lineNumbersLeft:Be,lineNumbersWidth:Re,decorationsLeft:Ze,decorationsWidth:x,contentLeft:ct,contentWidth:yt,minimap:St,viewportColumn:qt,isWordWrapMinified:bt,isViewportWrapping:Et,wrappingColumn:It,verticalScrollbarWidth:Mt,horizontalScrollbarHeight:De,overviewRuler:{top:Jt,width:Mt,height:ze-2*Jt,right:0}}}}e.EditorLayoutInfoComputer=be;class de extends w{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[n.localize(46,null),n.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:n.localize(48,null)}})}validate(G){return t(G,"simple",["simple","advanced"])}compute(G,pe,Me){return pe.get(2)===2?"advanced":Me}}class ue extends w{constructor(){const G={enabled:!0};super(61,"lightbulb",G,{"editor.lightbulb.enabled":{type:"boolean",default:G.enabled,description:n.localize(49,null)}})}validate(G){return!G||typeof G!="object"?this.defaultValue:{enabled:o(G.enabled,this.defaultValue.enabled)}}}class se extends w{constructor(){const G={enabled:!1,maxLineCount:5};super(109,"stickyScroll",G,{"editor.stickyScroll.enabled":{type:"boolean",default:G.enabled,description:n.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:G.maxLineCount,minimum:1,maximum:10,description:n.localize(51,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const pe=G;return{enabled:o(pe.enabled,this.defaultValue.enabled),maxLineCount:E.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class Z extends w{constructor(){const G={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",G,{"editor.inlayHints.enabled":{type:"string",default:G.enabled,description:n.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[n.localize(53,null),n.localize(54,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(55,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:G.fontSize,markdownDescription:n.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:G.fontFamily,markdownDescription:n.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:G.padding,description:n.localize(59,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const pe=G;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:t(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:E.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:v.string(pe.fontFamily,this.defaultValue.fontFamily),padding:o(pe.padding,this.defaultValue.padding)}}}class X extends w{constructor(){super(62,"lineDecorationsWidth",10)}validate(G){return typeof G=="string"&&/^\d+(\.\d+)?ch$/.test(G)?-parseFloat(G.substring(0,G.length-2)):E.clampedInt(G,this.defaultValue,0,1e3)}compute(G,pe,Me){return Me<0?E.clampedInt(-Me*G.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Me}}class ee extends A{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,G=>A.clamp(G,0,150),{markdownDescription:n.localize(60,null)})}compute(G,pe,Me){return G.fontInfo.lineHeight}}class he extends w{constructor(){const G={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",G,{"editor.minimap.enabled":{type:"boolean",default:G.enabled,description:n.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:G.autohide,description:n.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[n.localize(63,null),n.localize(64,null),n.localize(65,null)],default:G.size,description:n.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:G.side,description:n.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:G.showSlider,description:n.localize(68,null)},"editor.minimap.scale":{type:"number",default:G.scale,minimum:1,maximum:3,enum:[1,2,3],description:n.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:G.renderCharacters,description:n.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:G.maxColumn,description:n.localize(71,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const pe=G;return{enabled:o(pe.enabled,this.defaultValue.enabled),autohide:o(pe.autohide,this.defaultValue.autohide),size:t(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:t(pe.side,this.defaultValue.side,["right","left"]),showSlider:t(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(pe.renderCharacters,this.defaultValue.renderCharacters),scale:E.clampedInt(pe.scale,1,1,3),maxColumn:E.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Te(Q){return Q==="ctrlCmd"?C.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Ne extends w{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(73,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const pe=G;return{top:E.clampedInt(pe.top,0,0,1e3),bottom:E.clampedInt(pe.bottom,0,0,1e3)}}}class Ke extends w{constructor(){const G={enabled:!0,cycle:!0};super(81,"parameterHints",G,{"editor.parameterHints.enabled":{type:"boolean",default:G.enabled,description:n.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:G.cycle,description:n.localize(75,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const pe=G;return{enabled:o(pe.enabled,this.defaultValue.enabled),cycle:o(pe.cycle,this.defaultValue.cycle)}}}class Pe extends m{constructor(){super(136)}compute(G,pe,Me){return G.pixelRatio}}class Se extends w{constructor(){const G={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[n.localize(76,null),n.localize(77,null),n.localize(78,null)]}];super(84,"quickSuggestions",G,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:G.strings,description:n.localize(79,null)},comments:{anyOf:pe,default:G.comments,description:n.localize(80,null)},other:{anyOf:pe,default:G.other,description:n.localize(81,null)}},default:G,markdownDescription:n.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=G}validate(G){if(typeof G=="boolean"){const wt=G?"on":"off";return{comments:wt,strings:wt,other:wt}}if(!G||typeof G!="object")return this.defaultValue;const{other:pe,comments:Me,strings:ze}=G,Ve=["on","inline","off"];let _e,nt,vt;return typeof pe=="boolean"?_e=pe?"on":"off":_e=t(pe,this.defaultValue.other,Ve),typeof Me=="boolean"?nt=Me?"on":"off":nt=t(Me,this.defaultValue.comments,Ve),typeof ze=="boolean"?vt=ze?"on":"off":vt=t(ze,this.defaultValue.strings,Ve),{other:_e,comments:nt,strings:vt}}}var Ie;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(Ie=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class oe extends w{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[n.localize(83,null),n.localize(84,null),n.localize(85,null),n.localize(86,null)],default:"on",description:n.localize(87,null)})}validate(G){let pe=this.defaultValue.renderType,Me=this.defaultValue.renderFn;return typeof G<"u"&&(typeof G=="function"?(pe=4,Me=G):G==="interval"?pe=3:G==="relative"?pe=2:G==="on"?pe=1:pe=0),{renderType:pe,renderFn:Me}}}function ce(Q){const G=Q.get(92);return G==="editable"?Q.get(86):G!=="on"}e.filterValidationDecorations=ce;class Y extends w{constructor(){const G=[],pe={type:"number",description:n.localize(88,null)};super(96,"rulers",G,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:n.localize(89,null),format:"color-hex"}}}]},default:G,description:n.localize(90,null)})}validate(G){if(Array.isArray(G)){const pe=[];for(const Me of G)if(typeof Me=="number")pe.push({column:E.clampedInt(Me,0,0,1e4),color:null});else if(Me&&typeof Me=="object"){const ze=Me;pe.push({column:E.clampedInt(ze.column,0,0,1e4),color:ze.color})}return pe.sort((Me,ze)=>Me.column-ze.column),pe}return this.defaultValue}}function I(Q,G){if(typeof Q!="string")return G;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class $ extends w{constructor(){const G={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",G,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(91,null),n.localize(92,null),n.localize(93,null)],default:"auto",description:n.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(95,null),n.localize(96,null),n.localize(97,null)],default:"auto",description:n.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:G.verticalScrollbarSize,description:n.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:G.horizontalScrollbarSize,description:n.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:G.scrollByPage,description:n.localize(101,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const pe=G,Me=E.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=E.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:E.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:I(pe.vertical,this.defaultValue.vertical),horizontal:I(pe.horizontal,this.defaultValue.horizontal),useShadows:o(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Me,horizontalSliderSize:E.clampedInt(pe.horizontalSliderSize,Me,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:E.clampedInt(pe.verticalSliderSize,ze,0,1e3),scrollByPage:o(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class W extends w{constructor(){const G={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",G,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:G.nonBasicASCII,description:n.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:G.invisibleCharacters,description:n.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:G.ambiguousCharacters,description:n.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:G.includeComments,description:n.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:G.includeStrings,description:n.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:G.allowedCharacters,description:n.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:G.allowedLocales,description:n.localize(108,null)}})}applyUpdate(G,pe){let Me=!1;pe.allowedCharacters&&G&&(S.equals(G.allowedCharacters,pe.allowedCharacters)||(G={...G,allowedCharacters:pe.allowedCharacters},Me=!0)),pe.allowedLocales&&G&&(S.equals(G.allowedLocales,pe.allowedLocales)||(G={...G,allowedLocales:pe.allowedLocales},Me=!0));const ze=super.applyUpdate(G,pe);return Me?new f(ze.newValue,!0):ze}validate(G){if(!G||typeof G!="object")return this.defaultValue;const pe=G;return{nonBasicASCII:ye(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ye(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ye(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(G.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(G.allowedLocales,this.defaultValue.allowedLocales)}}c(G,pe){if(typeof G!="object"||!G)return pe;const Me={};for(const[ze,Ve]of Object.entries(G))Ve===!0&&(Me[ze]=!0);return Me}}class q extends w{constructor(){const G={enabled:!0,mode:"subwordSmart",showToolbar:"onHover"};super(59,"inlineSuggest",G,{"editor.inlineSuggest.enabled":{type:"boolean",default:G.enabled,description:n.localize(109,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:G.showToolbar,enum:["always","onHover"],enumDescriptions:[n.localize(110,null),n.localize(111,null)],description:n.localize(112,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const pe=G;return{enabled:o(pe.enabled,this.defaultValue.enabled),mode:t(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:t(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover"])}}}class ie extends w{constructor(){const G={enabled:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",G,{"editor.bracketPairColorization.enabled":{type:"boolean",default:G.enabled,markdownDescription:n.localize(113,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:G.independentColorPoolPerBracketType,description:n.localize(114,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const pe=G;return{enabled:o(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class fe extends w{constructor(){const G={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",G,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(115,null),n.localize(116,null),n.localize(117,null)],default:G.bracketPairs,description:n.localize(118,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(119,null),n.localize(120,null),n.localize(121,null)],default:G.bracketPairsHorizontal,description:n.localize(122,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:G.highlightActiveBracketPair,description:n.localize(123,null)},"editor.guides.indentation":{type:"boolean",default:G.indentation,description:n.localize(124,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[n.localize(125,null),n.localize(126,null),n.localize(127,null)],default:G.highlightActiveIndentation,description:n.localize(128,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const pe=G;return{bracketPairs:ye(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ye(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:ye(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ye(Q,G,pe){const Me=pe.indexOf(Q);return Me===-1?G:pe[Me]}class ae extends w{constructor(){const G={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",G,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[n.localize(129,null),n.localize(130,null)],default:G.insertMode,description:n.localize(131,null)},"editor.suggest.filterGraceful":{type:"boolean",default:G.filterGraceful,description:n.localize(132,null)},"editor.suggest.localityBonus":{type:"boolean",default:G.localityBonus,description:n.localize(133,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:G.shareSuggestSelections,markdownDescription:n.localize(134,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[n.localize(135,null),n.localize(136,null),n.localize(137,null),n.localize(138,null)],default:G.selectionMode,markdownDescription:n.localize(139,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:G.snippetsPreventQuickSuggestions,description:n.localize(140,null)},"editor.suggest.showIcons":{type:"boolean",default:G.showIcons,description:n.localize(141,null)},"editor.suggest.showStatusBar":{type:"boolean",default:G.showStatusBar,description:n.localize(142,null)},"editor.suggest.preview":{type:"boolean",default:G.preview,description:n.localize(143,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:G.showInlineDetails,description:n.localize(144,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:n.localize(145,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:n.localize(146,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:n.localize(147,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:n.localize(148,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:n.localize(149,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:n.localize(150,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:n.localize(151,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:n.localize(152,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:n.localize(153,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:n.localize(154,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:n.localize(155,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:n.localize(156,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:n.localize(157,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:n.localize(158,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:n.localize(159,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:n.localize(160,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:n.localize(161,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:n.localize(162,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:n.localize(163,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:n.localize(164,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:n.localize(165,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:n.localize(166,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:n.localize(167,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:n.localize(168,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:n.localize(169,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:n.localize(170,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:n.localize(171,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:n.localize(172,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:n.localize(173,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:n.localize(174,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:n.localize(175,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:n.localize(176,null)}})}validate(G){if(!G||typeof G!="object")return this.defaultValue;const pe=G;return{insertMode:t(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:t(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(pe.showIcons,this.defaultValue.showIcons),showStatusBar:o(pe.showStatusBar,this.defaultValue.showStatusBar),preview:o(pe.preview,this.defaultValue.preview),previewMode:t(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(pe.showMethods,this.defaultValue.showMethods),showFunctions:o(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:o(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(pe.showFields,this.defaultValue.showFields),showVariables:o(pe.showVariables,this.defaultValue.showVariables),showClasses:o(pe.showClasses,this.defaultValue.showClasses),showStructs:o(pe.showStructs,this.defaultValue.showStructs),showInterfaces:o(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:o(pe.showModules,this.defaultValue.showModules),showProperties:o(pe.showProperties,this.defaultValue.showProperties),showEvents:o(pe.showEvents,this.defaultValue.showEvents),showOperators:o(pe.showOperators,this.defaultValue.showOperators),showUnits:o(pe.showUnits,this.defaultValue.showUnits),showValues:o(pe.showValues,this.defaultValue.showValues),showConstants:o(pe.showConstants,this.defaultValue.showConstants),showEnums:o(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:o(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(pe.showKeywords,this.defaultValue.showKeywords),showWords:o(pe.showWords,this.defaultValue.showWords),showColors:o(pe.showColors,this.defaultValue.showColors),showFiles:o(pe.showFiles,this.defaultValue.showFiles),showReferences:o(pe.showReferences,this.defaultValue.showReferences),showFolders:o(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:o(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(pe.showSnippets,this.defaultValue.showSnippets),showUsers:o(pe.showUsers,this.defaultValue.showUsers),showIssues:o(pe.showIssues,this.defaultValue.showIssues)}}}class ve extends w{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:n.localize(177,null),default:!0,type:"boolean"}})}validate(G){return!G||typeof G!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(G.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Ee extends m{constructor(){super(137)}compute(G,pe,Me){return pe.get(86)?!0:G.tabFocusMode}}var We;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(We=e.WrappingIndent||(e.WrappingIndent={}));class He extends w{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[n.localize(178,null),n.localize(179,null),n.localize(180,null),n.localize(181,null)],description:n.localize(182,null),default:"same"}})}validate(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(G,pe,Me){return pe.get(2)===2?0:Me}}class tt extends m{constructor(){super(139)}compute(G,pe,Me){const ze=pe.get(138);return{isDominatedByLongLines:G.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}class Xe extends w{constructor(){const G={enabled:!0};super(33,"dropIntoEditor",G,{"editor.dropIntoEditor.enabled":{type:"boolean",default:G.enabled,markdownDescription:n.localize(183,null)}})}validate(G){return!G||typeof G!="object"?this.defaultValue:{enabled:o(G.enabled,this.defaultValue.enabled)}}}const et="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",dt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.isMacintosh?it:C.isLinux?dt:et,fontWeight:"normal",fontSize:C.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var ot;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.autoClosingBrackets=5]="autoClosingBrackets",Q[Q.autoClosingDelete=6]="autoClosingDelete",Q[Q.autoClosingOvertype=7]="autoClosingOvertype",Q[Q.autoClosingQuotes=8]="autoClosingQuotes",Q[Q.autoIndent=9]="autoIndent",Q[Q.automaticLayout=10]="automaticLayout",Q[Q.autoSurround=11]="autoSurround",Q[Q.bracketPairColorization=12]="bracketPairColorization",Q[Q.guides=13]="guides",Q[Q.codeLens=14]="codeLens",Q[Q.codeLensFontFamily=15]="codeLensFontFamily",Q[Q.codeLensFontSize=16]="codeLensFontSize",Q[Q.colorDecorators=17]="colorDecorators",Q[Q.colorDecoratorsLimit=18]="colorDecoratorsLimit",Q[Q.columnSelection=19]="columnSelection",Q[Q.comments=20]="comments",Q[Q.contextmenu=21]="contextmenu",Q[Q.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=23]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=25]="cursorStyle",Q[Q.cursorSurroundingLines=26]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=28]="cursorWidth",Q[Q.disableLayerHinting=29]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",Q[Q.domReadOnly=31]="domReadOnly",Q[Q.dragAndDrop=32]="dragAndDrop",Q[Q.dropIntoEditor=33]="dropIntoEditor",Q[Q.emptySelectionClipboard=34]="emptySelectionClipboard",Q[Q.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",Q[Q.extraEditorClassName=36]="extraEditorClassName",Q[Q.fastScrollSensitivity=37]="fastScrollSensitivity",Q[Q.find=38]="find",Q[Q.fixedOverflowWidgets=39]="fixedOverflowWidgets",Q[Q.folding=40]="folding",Q[Q.foldingStrategy=41]="foldingStrategy",Q[Q.foldingHighlight=42]="foldingHighlight",Q[Q.foldingImportsByDefault=43]="foldingImportsByDefault",Q[Q.foldingMaximumRegions=44]="foldingMaximumRegions",Q[Q.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=46]="fontFamily",Q[Q.fontInfo=47]="fontInfo",Q[Q.fontLigatures=48]="fontLigatures",Q[Q.fontSize=49]="fontSize",Q[Q.fontWeight=50]="fontWeight",Q[Q.fontVariations=51]="fontVariations",Q[Q.formatOnPaste=52]="formatOnPaste",Q[Q.formatOnType=53]="formatOnType",Q[Q.glyphMargin=54]="glyphMargin",Q[Q.gotoLocation=55]="gotoLocation",Q[Q.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",Q[Q.hover=57]="hover",Q[Q.inDiffEditor=58]="inDiffEditor",Q[Q.inlineSuggest=59]="inlineSuggest",Q[Q.letterSpacing=60]="letterSpacing",Q[Q.lightbulb=61]="lightbulb",Q[Q.lineDecorationsWidth=62]="lineDecorationsWidth",Q[Q.lineHeight=63]="lineHeight",Q[Q.lineNumbers=64]="lineNumbers",Q[Q.lineNumbersMinChars=65]="lineNumbersMinChars",Q[Q.linkedEditing=66]="linkedEditing",Q[Q.links=67]="links",Q[Q.matchBrackets=68]="matchBrackets",Q[Q.minimap=69]="minimap",Q[Q.mouseStyle=70]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=72]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=74]="multiCursorModifier",Q[Q.multiCursorPaste=75]="multiCursorPaste",Q[Q.multiCursorLimit=76]="multiCursorLimit",Q[Q.occurrencesHighlight=77]="occurrencesHighlight",Q[Q.overviewRulerBorder=78]="overviewRulerBorder",Q[Q.overviewRulerLanes=79]="overviewRulerLanes",Q[Q.padding=80]="padding",Q[Q.parameterHints=81]="parameterHints",Q[Q.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=84]="quickSuggestions",Q[Q.quickSuggestionsDelay=85]="quickSuggestionsDelay",Q[Q.readOnly=86]="readOnly",Q[Q.renameOnType=87]="renameOnType",Q[Q.renderControlCharacters=88]="renderControlCharacters",Q[Q.renderFinalNewline=89]="renderFinalNewline",Q[Q.renderLineHighlight=90]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=92]="renderValidationDecorations",Q[Q.renderWhitespace=93]="renderWhitespace",Q[Q.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",Q[Q.roundedSelection=95]="roundedSelection",Q[Q.rulers=96]="rulers",Q[Q.scrollbar=97]="scrollbar",Q[Q.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=99]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=100]="scrollPredominantAxis",Q[Q.selectionClipboard=101]="selectionClipboard",Q[Q.selectionHighlight=102]="selectionHighlight",Q[Q.selectOnLineNumbers=103]="selectOnLineNumbers",Q[Q.showFoldingControls=104]="showFoldingControls",Q[Q.showUnused=105]="showUnused",Q[Q.snippetSuggestions=106]="snippetSuggestions",Q[Q.smartSelect=107]="smartSelect",Q[Q.smoothScrolling=108]="smoothScrolling",Q[Q.stickyScroll=109]="stickyScroll",Q[Q.stickyTabStops=110]="stickyTabStops",Q[Q.stopRenderingLineAfter=111]="stopRenderingLineAfter",Q[Q.suggest=112]="suggest",Q[Q.suggestFontSize=113]="suggestFontSize",Q[Q.suggestLineHeight=114]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",Q[Q.suggestSelection=116]="suggestSelection",Q[Q.tabCompletion=117]="tabCompletion",Q[Q.tabIndex=118]="tabIndex",Q[Q.unicodeHighlighting=119]="unicodeHighlighting",Q[Q.unusualLineTerminators=120]="unusualLineTerminators",Q[Q.useShadowDOM=121]="useShadowDOM",Q[Q.useTabStops=122]="useTabStops",Q[Q.wordBreak=123]="wordBreak",Q[Q.wordSeparators=124]="wordSeparators",Q[Q.wordWrap=125]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=128]="wordWrapColumn",Q[Q.wordWrapOverride1=129]="wordWrapOverride1",Q[Q.wordWrapOverride2=130]="wordWrapOverride2",Q[Q.wrappingIndent=131]="wrappingIndent",Q[Q.wrappingStrategy=132]="wrappingStrategy",Q[Q.showDeprecated=133]="showDeprecated",Q[Q.inlayHints=134]="inlayHints",Q[Q.editorClassName=135]="editorClassName",Q[Q.pixelRatio=136]="pixelRatio",Q[Q.tabFocusMode=137]="tabFocusMode",Q[Q.layoutInfo=138]="layoutInfo",Q[Q.wrappingInfo=139]="wrappingInfo"})(ot=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new l(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:n.localize(184,null)})),acceptSuggestionOnEnter:Fe(new h(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",n.localize(185,null),""],markdownDescription:n.localize(186,null)})),accessibilitySupport:Fe(new i),accessibilityPageSize:Fe(new E(3,"accessibilityPageSize",10,1,1073741824,{description:n.localize(187,null),tags:["accessibility"]})),ariaLabel:Fe(new v(4,"ariaLabel",n.localize(188,null))),autoClosingBrackets:Fe(new h(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(189,null),n.localize(190,null),""],description:n.localize(191,null)})),autoClosingDelete:Fe(new h(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",n.localize(192,null),""],description:n.localize(193,null)})),autoClosingOvertype:Fe(new h(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",n.localize(194,null),""],description:n.localize(195,null)})),autoClosingQuotes:Fe(new h(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(196,null),n.localize(197,null),""],description:n.localize(198,null)})),autoIndent:Fe(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[n.localize(199,null),n.localize(200,null),n.localize(201,null),n.localize(202,null),n.localize(203,null)],description:n.localize(204,null)})),automaticLayout:Fe(new l(10,"automaticLayout",!1)),autoSurround:Fe(new h(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[n.localize(205,null),n.localize(206,null),n.localize(207,null),""],description:n.localize(208,null)})),bracketPairColorization:Fe(new ie),bracketPairGuides:Fe(new fe),stickyTabStops:Fe(new l(110,"stickyTabStops",!1,{description:n.localize(209,null)})),codeLens:Fe(new l(14,"codeLens",!0,{description:n.localize(210,null)})),codeLensFontFamily:Fe(new v(15,"codeLensFontFamily","",{description:n.localize(211,null)})),codeLensFontSize:Fe(new E(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:n.localize(212,null)})),colorDecorators:Fe(new l(17,"colorDecorators",!0,{description:n.localize(213,null)})),colorDecoratorsLimit:Fe(new E(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:n.localize(214,null)})),columnSelection:Fe(new l(19,"columnSelection",!1,{description:n.localize(215,null)})),comments:Fe(new p),contextmenu:Fe(new l(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new l(22,"copyWithSyntaxHighlighting",!0,{description:n.localize(216,null)})),cursorBlinking:Fe(new r(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:n.localize(217,null)})),cursorSmoothCaretAnimation:Fe(new h(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[n.localize(218,null),n.localize(219,null),n.localize(220,null)],description:n.localize(221,null)})),cursorStyle:Fe(new r(25,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],O,{description:n.localize(222,null)})),cursorSurroundingLines:Fe(new E(26,"cursorSurroundingLines",0,0,1073741824,{description:n.localize(223,null)})),cursorSurroundingLinesStyle:Fe(new h(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[n.localize(224,null),n.localize(225,null)],description:n.localize(226,null)})),cursorWidth:Fe(new E(28,"cursorWidth",0,0,1073741824,{markdownDescription:n.localize(227,null)})),disableLayerHinting:Fe(new l(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new l(30,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new l(31,"domReadOnly",!1)),dragAndDrop:Fe(new l(32,"dragAndDrop",!0,{description:n.localize(228,null)})),emptySelectionClipboard:Fe(new J),dropIntoEditor:Fe(new Xe),stickyScroll:Fe(new se),experimentalWhitespaceRendering:Fe(new h(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[n.localize(229,null),n.localize(230,null),n.localize(231,null)],description:n.localize(232,null)})),extraEditorClassName:Fe(new v(36,"extraEditorClassName","")),fastScrollSensitivity:Fe(new A(37,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:n.localize(233,null)})),find:Fe(new K),fixedOverflowWidgets:Fe(new l(39,"fixedOverflowWidgets",!1)),folding:Fe(new l(40,"folding",!0,{description:n.localize(234,null)})),foldingStrategy:Fe(new h(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[n.localize(235,null),n.localize(236,null)],description:n.localize(237,null)})),foldingHighlight:Fe(new l(42,"foldingHighlight",!0,{description:n.localize(238,null)})),foldingImportsByDefault:Fe(new l(43,"foldingImportsByDefault",!1,{description:n.localize(239,null)})),foldingMaximumRegions:Fe(new E(44,"foldingMaximumRegions",5e3,10,65e3,{description:n.localize(240,null)})),unfoldOnClickAfterEndOfLine:Fe(new l(45,"unfoldOnClickAfterEndOfLine",!1,{description:n.localize(241,null)})),fontFamily:Fe(new v(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:n.localize(242,null)})),fontInfo:Fe(new P),fontLigatures2:Fe(new L),fontSize:Fe(new F),fontWeight:Fe(new V),fontVariations:Fe(new B),formatOnPaste:Fe(new l(52,"formatOnPaste",!1,{description:n.localize(243,null)})),formatOnType:Fe(new l(53,"formatOnType",!1,{description:n.localize(244,null)})),glyphMargin:Fe(new l(54,"glyphMargin",!0,{description:n.localize(245,null)})),gotoLocation:Fe(new j),hideCursorInOverviewRuler:Fe(new l(56,"hideCursorInOverviewRuler",!1,{description:n.localize(246,null)})),hover:Fe(new le),inDiffEditor:Fe(new l(58,"inDiffEditor",!1)),letterSpacing:Fe(new A(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>A.clamp(Q,-5,20),{description:n.localize(247,null)})),lightbulb:Fe(new ue),lineDecorationsWidth:Fe(new X),lineHeight:Fe(new ee),lineNumbers:Fe(new oe),lineNumbersMinChars:Fe(new E(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new l(66,"linkedEditing",!1,{description:n.localize(248,null)})),links:Fe(new l(67,"links",!0,{description:n.localize(249,null)})),matchBrackets:Fe(new h(68,"matchBrackets","always",["always","near","never"],{description:n.localize(250,null)})),minimap:Fe(new he),mouseStyle:Fe(new h(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new A(71,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:n.localize(251,null)})),mouseWheelZoom:Fe(new l(72,"mouseWheelZoom",!1,{markdownDescription:n.localize(252,null)})),multiCursorMergeOverlapping:Fe(new l(73,"multiCursorMergeOverlapping",!0,{description:n.localize(253,null)})),multiCursorModifier:Fe(new r(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Te,{markdownEnumDescriptions:[n.localize(254,null),n.localize(255,null)],markdownDescription:n.localize(256,null)})),multiCursorPaste:Fe(new h(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[n.localize(257,null),n.localize(258,null)],markdownDescription:n.localize(259,null)})),multiCursorLimit:Fe(new E(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:n.localize(260,null)})),occurrencesHighlight:Fe(new l(77,"occurrencesHighlight",!0,{description:n.localize(261,null)})),overviewRulerBorder:Fe(new l(78,"overviewRulerBorder",!0,{description:n.localize(262,null)})),overviewRulerLanes:Fe(new E(79,"overviewRulerLanes",3,0,3)),padding:Fe(new Ne),parameterHints:Fe(new Ke),peekWidgetDefaultFocus:Fe(new h(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[n.localize(263,null),n.localize(264,null)],description:n.localize(265,null)})),definitionLinkOpensInPeek:Fe(new l(83,"definitionLinkOpensInPeek",!1,{description:n.localize(266,null)})),quickSuggestions:Fe(new Se),quickSuggestionsDelay:Fe(new E(85,"quickSuggestionsDelay",10,0,1073741824,{description:n.localize(267,null)})),readOnly:Fe(new l(86,"readOnly",!1)),renameOnType:Fe(new l(87,"renameOnType",!1,{description:n.localize(268,null),markdownDeprecationMessage:n.localize(269,null)})),renderControlCharacters:Fe(new l(88,"renderControlCharacters",!0,{description:n.localize(270,null),restricted:!0})),renderFinalNewline:Fe(new h(89,"renderFinalNewline",C.isLinux?"dimmed":"on",["off","on","dimmed"],{description:n.localize(271,null)})),renderLineHighlight:Fe(new h(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",n.localize(272,null)],description:n.localize(273,null)})),renderLineHighlightOnlyWhenFocus:Fe(new l(91,"renderLineHighlightOnlyWhenFocus",!1,{description:n.localize(274,null)})),renderValidationDecorations:Fe(new h(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new h(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",n.localize(275,null),n.localize(276,null),n.localize(277,null),""],description:n.localize(278,null)})),revealHorizontalRightPadding:Fe(new E(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new l(95,"roundedSelection",!0,{description:n.localize(279,null)})),rulers:Fe(new Y),scrollbar:Fe(new $),scrollBeyondLastColumn:Fe(new E(98,"scrollBeyondLastColumn",4,0,1073741824,{description:n.localize(280,null)})),scrollBeyondLastLine:Fe(new l(99,"scrollBeyondLastLine",!0,{description:n.localize(281,null)})),scrollPredominantAxis:Fe(new l(100,"scrollPredominantAxis",!0,{description:n.localize(282,null)})),selectionClipboard:Fe(new l(101,"selectionClipboard",!0,{description:n.localize(283,null),included:C.isLinux})),selectionHighlight:Fe(new l(102,"selectionHighlight",!0,{description:n.localize(284,null)})),selectOnLineNumbers:Fe(new l(103,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new h(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[n.localize(285,null),n.localize(286,null),n.localize(287,null)],description:n.localize(288,null)})),showUnused:Fe(new l(105,"showUnused",!0,{description:n.localize(289,null)})),showDeprecated:Fe(new l(133,"showDeprecated",!0,{description:n.localize(290,null)})),inlayHints:Fe(new Z),snippetSuggestions:Fe(new h(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[n.localize(291,null),n.localize(292,null),n.localize(293,null),n.localize(294,null)],description:n.localize(295,null)})),smartSelect:Fe(new ve),smoothScrolling:Fe(new l(108,"smoothScrolling",!1,{description:n.localize(296,null)})),stopRenderingLineAfter:Fe(new E(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new ae),inlineSuggest:Fe(new q),suggestFontSize:Fe(new E(113,"suggestFontSize",0,0,1e3,{markdownDescription:n.localize(297,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new E(114,"suggestLineHeight",0,0,1e3,{markdownDescription:n.localize(298,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new l(115,"suggestOnTriggerCharacters",!0,{description:n.localize(299,null)})),suggestSelection:Fe(new h(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[n.localize(300,null),n.localize(301,null),n.localize(302,null)],description:n.localize(303,null)})),tabCompletion:Fe(new h(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[n.localize(304,null),n.localize(305,null),n.localize(306,null)],description:n.localize(307,null)})),tabIndex:Fe(new E(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new W),unusualLineTerminators:Fe(new h(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[n.localize(308,null),n.localize(309,null),n.localize(310,null)],description:n.localize(311,null)})),useShadowDOM:Fe(new l(121,"useShadowDOM",!0)),useTabStops:Fe(new l(122,"useTabStops",!0,{description:n.localize(312,null)})),wordBreak:Fe(new h(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[n.localize(313,null),n.localize(314,null)],description:n.localize(315,null)})),wordSeparators:Fe(new v(124,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:n.localize(316,null)})),wordWrap:Fe(new h(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[n.localize(317,null),n.localize(318,null),n.localize(319,null),n.localize(320,null)],description:n.localize(321,null)})),wordWrapBreakAfterCharacters:Fe(new v(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new v(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new E(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:n.localize(322,null)})),wordWrapOverride1:Fe(new h(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new h(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new H),pixelRatio:Fe(new Pe),tabFocusMode:Fe(new Ee),layoutInfo:Fe(new be),wrappingInfo:Fe(new tt),wrappingIndent:Fe(new He),wrappingStrategy:Fe(new de)}}),define(Ce[132],ke([13,14]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[133],ke([13,14]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[134],ke([13,14]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[135],ke([13,14]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(Ce[136],ke([13,14]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(Ce[137],ke([13,14]),function(te,e){return te.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[138],ke([13,14]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(Ce[139],ke([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[140],ke([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[141],ke([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(Ce[142],ke([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[143],ke([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[144],ke([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[145],ke([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[146],ke([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[147],ke([13,14]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(Ce[148],ke([13,14]),function(te,e){return te.create("vs/workbench/common/views",e)}),define(Ce[149],ke([13,14]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[150],ke([13,14]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[151],ke([13,14]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[152],ke([13,14]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[153],ke([13,14]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[154],ke([13,14]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[155],ke([13,14]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[156],ke([1,0,12]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class C{constructor(){this.a=new Map}register(M,S){this.a.set(M,S)}updateManifest(M){if(!(typeof M.main>"u"&&typeof M.browser>"u")&&(M.activationEvents===void 0&&Object.assign(M,{activationEvents:[]}),!(!Array.isArray(M.activationEvents)||!M.contributes)))for(const S in M.contributes){const R=this.a.get(S);if(!R)continue;const y=M.contributes[S],k=Array.isArray(y)?y:[y];try{R(k,M.activationEvents)}catch(N){(0,n.onUnexpectedError)(N)}}}}e.ImplicitActivationEventsImpl=C,e.ImplicitActivationEvents=new C}),define(Ce[157],ke([1,0,24,29,134,257]),function(te,e,n,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const S=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function y(l){return l=l.trim(),l==="*"||S.test(l)}e.isValidVersionStr=y;function k(l){if(!y(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=l.match(S);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=k;function N(l){if(!l)return null;const g=l.majorBase,E=l.majorMustEqual,A=l.minorBase;let v=l.minorMustEqual;const t=l.patchBase;let h=l.patchMustEqual;l.hasCaret&&(g===0||(v=!1),h=!1);let r=0;if(l.preRelease){const u=R.exec(l.preRelease);if(u){const[,i,p,c]=u;r=Date.UTC(Number(i),Number(p)-1,Number(c))}}return{majorBase:g,majorMustEqual:E,minorBase:A,minorMustEqual:v,patchBase:t,patchMustEqual:h,isMinimum:l.hasGreaterEquals,notBefore:r}}e.normalizeVersion=N;function w(l,g,E){let A;typeof l=="string"?A=N(k(l)):A=l;let v;g instanceof Date?v=g.getTime():typeof g=="string"&&(v=new Date(g).getTime());let t;if(typeof E=="string"?t=N(k(E)):t=E,!A||!t)return!1;const h=A.majorBase,r=A.minorBase,u=A.patchBase;let i=t.majorBase,p=t.minorBase,c=t.patchBase;const s=t.notBefore;let d=t.majorMustEqual,T=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?h>i?!0:h<i?!1:r>p?!0:r<p||v&&v<s?!1:u>=c:(h===1&&i===0&&(!d||!T||!O)&&(i=1,p=0,c=0,d=!0,T=!1,O=!1),h<i?!1:h>i?!d:r<p?!1:r>p?!T:u<c?!1:u>c?!O:!(v&&v<s))}e.isValidVersion=w;function f(l,g,E,A,v){const t=[];if(typeof A.publisher<"u"&&typeof A.publisher!="string")return t.push([C.default.Error,D.localize(0,null)]),t;if(typeof A.name!="string")return t.push([C.default.Error,D.localize(1,null,"name")]),t;if(typeof A.version!="string")return t.push([C.default.Error,D.localize(2,null,"version")]),t;if(!A.engines)return t.push([C.default.Error,D.localize(3,null,"engines")]),t;if(typeof A.engines.vscode!="string")return t.push([C.default.Error,D.localize(4,null,"engines.vscode")]),t;if(typeof A.extensionDependencies<"u"&&!o(A.extensionDependencies))return t.push([C.default.Error,D.localize(5,null,"extensionDependencies")]),t;if(typeof A.activationEvents<"u"){if(!o(A.activationEvents))return t.push([C.default.Error,D.localize(6,null,"activationEvents")]),t;if(typeof A.main>"u"&&typeof A.browser>"u")return t.push([C.default.Error,D.localize(7,null,"activationEvents","main")]),t}if(typeof A.extensionKind<"u"&&typeof A.main>"u"&&t.push([C.default.Warning,D.localize(8,null,"extensionKind")]),typeof A.main<"u"){if(typeof A.main!="string")return t.push([C.default.Error,D.localize(9,null,"main")]),t;{const u=(0,n.joinPath)(E,A.main);(0,n.isEqualOrParent)(u,E)||t.push([C.default.Warning,D.localize(10,null,u.path,E.path)])}if(typeof A.activationEvents>"u")return t.push([C.default.Error,D.localize(11,null,"activationEvents","main")]),t}if(typeof A.browser<"u"){if(typeof A.browser!="string")return t.push([C.default.Error,D.localize(12,null,"browser")]),t;{const u=(0,n.joinPath)(E,A.browser);(0,n.isEqualOrParent)(u,E)||t.push([C.default.Warning,D.localize(13,null,u.path,E.path)])}if(typeof A.activationEvents>"u")return t.push([C.default.Error,D.localize(14,null,"activationEvents","browser")]),t}if(!M.valid(A.version))return t.push([C.default.Error,D.localize(15,null)]),t;const h=[];if(!b(l,g,A,v,h))for(const u of h)t.push([C.default.Error,u]);return t}e.validateExtensionManifest=f;function b(l,g,E,A,v){return A||typeof E.main>"u"&&typeof E.browser>"u"?!0:a(l,g,E.engines.vscode,v)}e.isValidExtensionVersion=b;function m(l,g,E){return l==="*"||a(g,E,l)}e.isEngineValid=m;function a(l,g,E,A=[]){const v=N(k(E));if(!v)return A.push(D.localize(16,null,E)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return A.push(D.localize(17,null,E)),!1}else if(!v.majorMustEqual)return A.push(D.localize(18,null,E)),!1;return w(l,g,v)?!0:(A.push(D.localize(19,null,l,E)),!1)}function o(l){if(!Array.isArray(l))return!1;for(let g=0,E=l.length;g<E;g++)if(typeof l[g]!="string")return!1;return!0}}),define(Ce[89],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class n{constructor(D,M=[],S=!1){this.ctor=D,this.staticArguments=M,this.supportsDelayedInstantiation=S}}e.SyncDescriptor=n}),define(Ce[66],ke([1,0,89]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const C=[];var D;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function M(R,y,k){y instanceof n.SyncDescriptor||(y=new n.SyncDescriptor(y,[],Boolean(k))),C.push([R,y])}e.registerSingleton=M;function S(){return C}e.getSingletonServiceDescriptors=S}),define(Ce[158],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class n{constructor(M,S){this.key=M,this.data=S,this.incoming=new Map,this.outgoing=new Map}}e.Node=n;class C{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const S of this.a.values())S.outgoing.size===0&&M.push(S);return M}insertEdge(M,S){const R=this.lookupOrInsertNode(M),y=this.lookupOrInsertNode(S);R.outgoing.set(y.key,y),y.incoming.set(R.key,R)}removeNode(M){const S=this.b(M);this.a.delete(S);for(const R of this.a.values())R.outgoing.delete(S),R.incoming.delete(S)}lookupOrInsertNode(M){const S=this.b(M);let R=this.a.get(S);return R||(R=new n(S,M),this.a.set(S,R)),R}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[S,R]of this.a)M.push(`${S}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,S]of this.a){const R=new Set([M]),y=this.c(S,R);if(y)return y}}c(M,S){for(const[R,y]of M.outgoing){if(S.has(R))return[...S,R].join(" -> ");S.add(R);const k=this.c(y,S);if(k)return k;S.delete(R)}}}e.Graph=C}),define(Ce[3],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var n;(function(S){S.serviceIds=new Map,S.DI_TARGET="$di$target",S.DI_DEPENDENCIES="$di$dependencies";function R(y){return y[S.DI_DEPENDENCIES]||[]}S.getServiceDependencies=R})(n=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function C(S,R,y){R[n.DI_TARGET]===R?R[n.DI_DEPENDENCIES].push({id:S,index:y}):(R[n.DI_DEPENDENCIES]=[{id:S,index:y}],R[n.DI_TARGET]=R)}function D(S){if(n.serviceIds.has(S))return n.serviceIds.get(S);const R=function(y,k,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(R,y,N)};return R.toString=()=>S,n.serviceIds.set(S,R),R}e.createDecorator=D;function M(S){return S}e.refineServiceDecorator=M}),define(Ce[41],ke([1,0,9,2,3]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function M(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof C.URI)}e.isConfigurationOverrides=M;function S(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof C.URI)}e.isConfigurationUpdateOverrides=S;var R;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function k(o,l){const g=Object.create(null);for(const E in o)N(g,E,o[E],l);return g}e.toValuesTree=k;function N(o,l,g,E){const A=l.split("."),v=A.pop();let t=o;for(let h=0;h<A.length;h++){const r=A[h];let u=t[r];switch(typeof u){case"undefined":u=t[r]=Object.create(null);break;case"object":break;default:E(`Ignoring ${l} as ${A.slice(0,h+1).join(".")} is ${JSON.stringify(u)}`);return}t=u}if(typeof t=="object"&&t!==null)try{t[v]=g}catch{E(`Ignoring ${l} as ${A.join(".")} is ${JSON.stringify(t)}`)}else E(`Ignoring ${l} as ${A.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=N;function w(o,l){const g=l.split(".");f(o,g)}e.removeFromValueTree=w;function f(o,l){const g=l.shift();if(l.length===0){delete o[g];return}if(Object.keys(o).indexOf(g)!==-1){const E=o[g];typeof E=="object"&&!Array.isArray(E)&&(f(E,l),Object.keys(E).length===0&&delete o[g])}}function b(o,l,g){function E(t,h){let r=t;for(const u of h){if(typeof r!="object"||r===null)return;r=r[u]}return r}const A=l.split("."),v=E(o,A);return typeof v>"u"?g:v}e.getConfigurationValue=b;function m(o,l,g){Object.keys(l).forEach(E=>{E!=="__proto__"&&(E in o?n.isObject(o[E])&&n.isObject(l[E])?m(o[E],l[E],g):g&&(o[E]=l[E]):o[E]=l[E])})}e.merge=m;function a(o){return o.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=a}),define(Ce[42],ke([1,0,21,10,3]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const M=new Map;M.set("false",!1),M.set("true",!0),M.set("isMac",n.isMacintosh),M.set("isLinux",n.isLinux),M.set("isWindows",n.isWindows),M.set("isWeb",n.isWeb),M.set("isMacNative",n.isMacintosh&&!n.isWeb),M.set("isEdge",n.isEdge),M.set("isFirefox",n.isFirefox),M.set("isChrome",n.isChrome),M.set("isSafari",n.isSafari);const S=Object.prototype.hasOwnProperty;var R;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(R=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return w.INSTANCE}static true(){return f.INSTANCE}static has(L){return b.create(L)}static equals(L,B){return m.create(L,B)}static notEquals(L,B){return l.create(L,B)}static regex(L,B){return r.create(L,B)}static in(L,B){return a.create(L,B)}static notIn(L,B){return o.create(L,B)}static not(L){return g.create(L)}static and(...L){return p.create(L,null,!0)}static or(...L){return c.create(L,null,!0)}static greater(L,B){return A.create(L,B)}static greaterEquals(L,B){return v.create(L,B)}static smaller(L,B){return t.create(L,B)}static smallerEquals(L,B){return h.create(L,B)}static deserialize(L,B=!1){if(!!L)return this.c(L,B)}static c(L,B){const P=L.split("||");return c.create(P.map(F=>this.d(F,B)),null,!0)}static d(L,B){const P=L.split("&&");return p.create(P.map(F=>this.f(F,B)),null,!0)}static f(L,B){if(L=L.trim(),L.indexOf("!=")>=0){const P=L.split("!=");return l.create(P[0].trim(),this.g(P[1],B))}if(L.indexOf("==")>=0){const P=L.split("==");return m.create(P[0].trim(),this.g(P[1],B))}if(L.indexOf("=~")>=0){const P=L.split("=~");return r.create(P[0].trim(),this.h(P[1],B))}if(L.indexOf(" not in ")>=0){const P=L.split(" not in ");return o.create(P[0].trim(),this.g(P[1],B))}if(L.indexOf(" in ")>=0){const P=L.split(" in ");return a.create(P[0].trim(),this.g(P[1],B))}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const P=L.split(">=");return v.create(P[0].trim(),P[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const P=L.split(">");return A.create(P[0].trim(),P[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const P=L.split("<=");return h.create(P[0].trim(),P[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const P=L.split("<");return t.create(P[0].trim(),P[1].trim())}return/^\!\s*/.test(L)?g.create(L.substr(1).trim()):b.create(L)}static g(L,B){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;const P=/^'([^']*)'$/.exec(L);return P?P[1].trim():L}static h(L,B){if((0,C.isFalsyOrWhitespace)(L)){if(B)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const P=L.indexOf("/"),F=L.lastIndexOf("/");if(P===F||P<0){if(B)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}const V=L.slice(P+1,F),j=L[F+1]==="i"?"i":"";try{return new RegExp(V,j)}catch(le){if(B)throw new Error(`bad regexp-value '${L}', parse error: ${le}`);return console.warn(`bad regexp-value '${L}', parse error: ${le}`),null}}}e.ContextKeyExpr=y;function k(K,L){const B=K?K.substituteConstants():void 0,P=L?L.substituteConstants():void 0;return!B&&!P?!0:!B||!P?!1:B.equals(P)}e.expressionsAreEqualWithConstantSubstitution=k;function N(K,L){return K.cmp(L)}class w{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return f.INSTANCE}}w.INSTANCE=new w,e.ContextKeyFalseExpr=w;class f{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return w.INSTANCE}}f.INSTANCE=new f,e.ContextKeyTrueExpr=f;class b{static create(L,B=null){const P=M.get(L);return typeof P=="boolean"?P?f.INSTANCE:w.INSTANCE:new b(L,B)}constructor(L,B){this.key=L,this.c=B,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:d(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=M.get(this.key);return typeof L=="boolean"?L?f.INSTANCE:w.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.c||(this.c=g.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=b;class m{static create(L,B,P=null){if(typeof B=="boolean")return B?b.create(L,P):g.create(L,P);const F=M.get(L);return typeof F=="boolean"?B===(F?"true":"false")?f.INSTANCE:w.INSTANCE:new m(L,B,P)}constructor(L,B,P){this.c=L,this.d=B,this.f=P,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:T(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=M.get(this.c);if(typeof L=="boolean"){const B=L?"true":"false";return this.d===B?f.INSTANCE:w.INSTANCE}return this}evaluate(L){return L.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(L){return L.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=m;class a{static create(L,B){return new a(L,B)}constructor(L,B){this.d=L,this.f=B,this.type=10,this.c=null}cmp(L){return L.type!==this.type?this.type-L.type:T(this.d,this.f,L.d,L.f)}equals(L){return L.type===this.type?this.d===L.d&&this.f===L.f:!1}substituteConstants(){return this}evaluate(L){const B=L.getValue(this.f),P=L.getValue(this.d);return Array.isArray(B)?B.includes(P):typeof P=="string"&&typeof B=="object"&&B!==null?S.call(B,P):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(L){return L.mapIn(this.d,this.f)}negate(){return this.c||(this.c=o.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=a;class o{static create(L,B){return new o(L,B)}constructor(L,B){this.d=L,this.f=B,this.type=11,this.c=a.create(L,B)}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(L){return L.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=o;class l{static create(L,B,P=null){if(typeof B=="boolean")return B?g.create(L,P):b.create(L,P);const F=M.get(L);return typeof F=="boolean"?B===(F?"true":"false")?w.INSTANCE:f.INSTANCE:new l(L,B,P)}constructor(L,B,P){this.c=L,this.d=B,this.f=P,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:T(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=M.get(this.c);if(typeof L=="boolean"){const B=L?"true":"false";return this.d===B?w.INSTANCE:f.INSTANCE}return this}evaluate(L){return L.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(L){return L.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=m.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=l;class g{static create(L,B=null){const P=M.get(L);return typeof P=="boolean"?P?w.INSTANCE:f.INSTANCE:new g(L,B)}constructor(L,B){this.c=L,this.d=B,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:d(this.c,L.c)}equals(L){return L.type===this.type?this.c===L.c:!1}substituteConstants(){const L=M.get(this.c);return typeof L=="boolean"?L?w.INSTANCE:f.INSTANCE:this}evaluate(L){return!L.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(L){return L.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.ContextKeyNotExpr=g;function E(K,L){if(typeof K=="string"){const B=parseFloat(K);isNaN(B)||(K=B)}return typeof K=="string"||typeof K=="number"?L(K):w.INSTANCE}class A{static create(L,B,P=null){return E(B,F=>new A(L,F,P))}constructor(L,B,P){this.c=L,this.d=B,this.f=P,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:T(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=A;class v{static create(L,B,P=null){return E(B,F=>new v(L,F,P))}constructor(L,B,P){this.c=L,this.d=B,this.f=P,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:T(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=t.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=v;class t{static create(L,B,P=null){return E(B,F=>new t(L,F,P))}constructor(L,B,P){this.c=L,this.d=B,this.f=P,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:T(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=t;class h{static create(L,B,P=null){return E(B,F=>new h(L,F,P))}constructor(L,B,P){this.c=L,this.d=B,this.f=P,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:T(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=h;class r{static create(L,B){return new r(L,B)}constructor(L,B){this.d=L,this.f=B,this.type=7,this.c=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.d<L.d)return-1;if(this.d>L.d)return 1;const B=this.f?this.f.source:"",P=L.f?L.f.source:"";return B<P?-1:B>P?1:0}equals(L){if(L.type===this.type){const B=this.f?this.f.source:"",P=L.f?L.f.source:"";return this.d===L.d&&B===P}return!1}substituteConstants(){return this}evaluate(L){const B=L.getValue(this.d);return this.f?this.f.test(B):!1}serialize(){const L=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${L}`}keys(){return[this.d]}map(L){return L.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=u.create(this)),this.c}}e.ContextKeyRegexExpr=r;class u{static create(L){return new u(L)}constructor(L){this.c=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(L){return new u(this.c.map(L))}negate(){return this.c}}e.ContextKeyNotRegexExpr=u;function i(K){let L=null;for(let B=0,P=K.length;B<P;B++){const F=K[B].substituteConstants();if(K[B]!==F&&L===null){L=[];for(let V=0;V<B;V++)L[V]=K[V]}L!==null&&(L[B]=F)}return L===null?K:L}class p{static create(L,B,P){return p.d(L,B,P)}constructor(L,B){this.expr=L,this.c=B,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let B=0,P=this.expr.length;B<P;B++){const F=N(this.expr[B],L.expr[B]);if(F!==0)return F}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let B=0,P=this.expr.length;B<P;B++)if(!this.expr[B].equals(L.expr[B]))return!1;return!0}return!1}substituteConstants(){const L=i(this.expr);return L===this.expr?this:p.create(L,this.c,!1)}evaluate(L){for(let B=0,P=this.expr.length;B<P;B++)if(!this.expr[B].evaluate(L))return!1;return!0}static d(L,B,P){const F=[];let V=!1;for(const j of L)if(!!j){if(j.type===1){V=!0;continue}if(j.type===0)return w.INSTANCE;if(j.type===6){F.push(...j.expr);continue}F.push(j)}if(F.length===0&&V)return f.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(N);for(let j=1;j<F.length;j++)F[j-1].equals(F[j])&&(F.splice(j,1),j--);if(F.length===1)return F[0];for(;F.length>1;){const j=F[F.length-1];if(j.type!==9)break;F.pop();const le=F.pop(),_=F.length===0,be=c.create(j.expr.map(de=>p.create([de,le],null,P)),null,_);be&&(F.push(be),F.sort(N))}if(F.length===1)return F[0];if(P){for(let j=0;j<F.length;j++)for(let le=j+1;le<F.length;le++)if(F[j].negate().equals(F[le]))return w.INSTANCE;if(F.length===1)return F[0]}return new p(F,B)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const B of this.expr)L.push(...B.keys());return L}map(L){return new p(this.expr.map(B=>B.map(L)),null)}negate(){if(!this.c){const L=[];for(const B of this.expr)L.push(B.negate());this.c=c.create(L,this,!0)}return this.c}}class c{static create(L,B,P){return c.d(L,B,P)}constructor(L,B){this.expr=L,this.c=B,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let B=0,P=this.expr.length;B<P;B++){const F=N(this.expr[B],L.expr[B]);if(F!==0)return F}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let B=0,P=this.expr.length;B<P;B++)if(!this.expr[B].equals(L.expr[B]))return!1;return!0}return!1}substituteConstants(){const L=i(this.expr);return L===this.expr?this:c.create(L,this.c,!1)}evaluate(L){for(let B=0,P=this.expr.length;B<P;B++)if(this.expr[B].evaluate(L))return!0;return!1}static d(L,B,P){let F=[],V=!1;if(L){for(let j=0,le=L.length;j<le;j++){const _=L[j];if(!!_){if(_.type===0){V=!0;continue}if(_.type===1)return f.INSTANCE;if(_.type===9){F=F.concat(_.expr);continue}F.push(_)}}if(F.length===0&&V)return w.INSTANCE;F.sort(N)}if(F.length!==0){if(F.length===1)return F[0];for(let j=1;j<F.length;j++)F[j-1].equals(F[j])&&(F.splice(j,1),j--);if(F.length===1)return F[0];if(P){for(let j=0;j<F.length;j++)for(let le=j+1;le<F.length;le++)if(F[j].negate().equals(F[le]))return f.INSTANCE;if(F.length===1)return F[0]}return new c(F,B)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const B of this.expr)L.push(...B.keys());return L}map(L){return new c(this.expr.map(B=>B.map(L)),null)}negate(){if(!this.c){const L=[];for(const B of this.expr)L.push(B.negate());for(;L.length>1;){const B=L.shift(),P=L.shift(),F=[];for(const V of J(B))for(const j of J(P))F.push(p.create([V,j],null,!1));L.unshift(c.create(F,null,!1))}this.c=c.create(L,this,!0)}return this.c}}class s extends b{static all(){return s.d.values()}constructor(L,B,P){super(L,null),this.f=B,typeof P=="object"?s.d.push({...P,key:L}):P!==!0&&s.d.push({key:L,description:P,type:B!=null?typeof B:void 0})}bindTo(L){return L.createKey(this.key,this.f)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return m.create(this.key,L)}notEqualsTo(L){return l.create(this.key,L)}}s.d=[],e.RawContextKey=s,e.IContextKeyService=(0,D.createDecorator)("contextKeyService");function d(K,L){return K<L?-1:K>L?1:0}function T(K,L,B,P){return K<B?-1:K>B?1:L<P?-1:L>P?1:0}function O(K,L){if(K.type===0||L.type===1)return!0;if(K.type===9)return L.type===9?H(K.expr,L.expr):!1;if(L.type===9){for(const B of L.expr)if(O(K,B))return!0;return!1}if(K.type===6){if(L.type===6)return H(L.expr,K.expr);for(const B of K.expr)if(O(B,L))return!0;return!1}return K.equals(L)}e.implies=O;function H(K,L){let B=0,P=0;for(;B<K.length&&P<L.length;){const F=K[B].cmp(L[P]);if(F<0)return!1;F===0&&B++,P++}return B===K.length}function J(K){return K.type===9?K.expr:[K]}}),define(Ce[159],ke([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,n.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,n.refineServiceDecorator)(e.IEnvironmentService)}),define(Ce[90],ke([1,0,133,3]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough";function D(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function M(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function S(l,g){switch(l){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=S;function R(l,g){return g==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function y(l,g,E){return R(g,E)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===E?!0:k(E).includes(l)}e.isTargetPlatformCompatible=y;function k(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function N(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=N;var w;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var f;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(f=e.SortOrder||(e.SortOrder={}));var b;(function(l){l.Install="install",l.Uninstall="uninstall"})(b=e.StatisticType||(e.StatisticType={}));var m;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var a;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(a=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class o extends Error{constructor(g,E){super(g),this.code=E,this.name=E}}e.ExtensionManagementError=o,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,n.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Ce[43],ke([1,0,48,19,10,9,2,135,3,21]),function(te,e,n,C,D,M,S,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function N(_){return _.create===!0}e.isFileOpenForWriteOptions=N;var w;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(w=e.FileType||(e.FileType={}));var f;(function(_){_[_.Readonly=1]="Readonly"})(f=e.FilePermission||(e.FilePermission={}));var b;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileClone=32768]="FileClone"})(b=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(_){return!!(_.capabilities&2)}e.hasReadWriteCapability=m;function a(_){return!!(_.capabilities&8)}e.hasFileFolderCopyCapability=a;function o(_){return!!(_.capabilities&32768)}e.hasFileCloneCapability=o;function l(_){return!!(_.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function g(_){return!!(_.capabilities&16)}e.hasFileReadStreamCapability=g;function E(_){return m(_)?!!(_.capabilities&16384):!1}e.hasFileAtomicReadCapability=E;var A;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(A=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(be,de){super(be),this.code=de}}e.FileSystemProviderError=v;function t(_,be){const de=new v(_.toString(),be);return r(de,be),de}e.createFileSystemProviderError=t;function h(_){return _||t((0,R.localize)(0,null),A.Unknown)}e.ensureFileSystemProviderError=h;function r(_,be){return _.name=be?`${be} (FileSystemError)`:"FileSystemError",_}e.markAsFileSystemProviderError=r;function u(_){if(!_)return A.Unknown;if(_ instanceof v)return _.code;const be=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!be)return A.Unknown;switch(be[1]){case A.FileExists:return A.FileExists;case A.FileIsADirectory:return A.FileIsADirectory;case A.FileNotADirectory:return A.FileNotADirectory;case A.FileNotFound:return A.FileNotFound;case A.FileExceedsMemoryLimit:return A.FileExceedsMemoryLimit;case A.FileTooLarge:return A.FileTooLarge;case A.FileWriteLocked:return A.FileWriteLocked;case A.NoPermissions:return A.NoPermissions;case A.Unavailable:return A.Unavailable}return A.Unknown}e.toFileSystemProviderErrorCode=u;function i(_){if(_ instanceof O)return _.fileOperationResult;switch(u(_)){case A.FileNotFound:return 1;case A.FileIsADirectory:return 0;case A.FileNotADirectory:return 10;case A.FileWriteLocked:return 5;case A.NoPermissions:return 6;case A.FileExists:return 4;case A.FileExceedsMemoryLimit:return 9;case A.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var p;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(p=e.FileOperation||(e.FileOperation={}));class c{constructor(be,de,ue){this.resource=be,this.operation=de,this.target=ue}isOperation(be){return this.operation===be}}e.FileOperationEvent=c;var s;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class d{constructor(be,de){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ue=new Map;for(const se of be){const Z=ue.get(se.type);switch(Z?Z.push([se.resource,se]):ue.set(se.type,[[se.resource,se]]),se.type){case 1:this.rawAdded.push(se.resource);break;case 0:this.rawUpdated.push(se.resource);break;case 2:this.rawDeleted.push(se.resource);break}}for(const[se,Z]of ue)switch(se){case 1:this.a=n.TernarySearchTree.forUris(()=>de),this.a.fill(Z);break;case 0:this.b=n.TernarySearchTree.forUris(()=>de),this.b.fill(Z);break;case 2:this.c=n.TernarySearchTree.forUris(()=>de),this.c.fill(Z);break}}contains(be,...de){return this.d(be,{includeChildren:!1},...de)}affects(be,...de){return this.d(be,{includeChildren:!0},...de)}d(be,de,...ue){if(!be)return!1;const se=ue.length>0;return!!((!se||ue.includes(1))&&(this.a?.get(be)||de.includeChildren&&this.a?.findSuperstr(be))||(!se||ue.includes(0))&&(this.b?.get(be)||de.includeChildren&&this.b?.findSuperstr(be))||(!se||ue.includes(2))&&(this.c?.findSubstr(be)||de.includeChildren&&this.c?.findSuperstr(be)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=d;function T(_,be,de){return!_||!be||_===be||be.length>_.length?!1:(be.charAt(be.length-1)!==C.sep&&(be+=C.sep),de?(0,D.startsWithIgnoreCase)(_,be):_.indexOf(be)===0)}e.isParent=T;class O extends Error{constructor(be,de,ue){super(be),this.fileOperationResult=de,this.options=ue}}e.FileOperationError=O;class H extends O{constructor(be,de,ue,se){super(be,de,se),this.fileOperationResult=de,this.size=ue}}e.TooLargeFileOperationError=H;class J extends O{constructor(be,de,ue){super(be,2,ue),this.stat=de}}e.NotModifiedSinceFileOperationError=J;var K;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",_[_.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(K=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var L;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(L=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function B(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.etag=B;async function P(_,be){if(!be.hasProvider(S.URI.from({scheme:_.scheme})))return new Promise(de=>{const ue=be.onDidChangeFileSystemProviderRegistrations(se=>{se.scheme===_.scheme&&se.added&&(ue.dispose(),de())})})}e.whenProviderRegistered=P,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(be){return(0,M.isNumber)(be)||(be=0),be<F.KB?(0,R.localize)(1,null,be.toFixed(0)):be<F.MB?(0,R.localize)(2,null,(be/F.KB).toFixed(2)):be<F.GB?(0,R.localize)(3,null,(be/F.MB).toFixed(2)):be<F.TB?(0,R.localize)(4,null,(be/F.GB).toFixed(2)):(0,R.localize)(5,null,(be/F.TB).toFixed(2))}}F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB,e.ByteSize=F;var V;(function(_){_[_.IA32=0]="IA32",_[_.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function j(_){return{maxFileSize:_===0?300*F.MB:16*F.GB,maxHeapSize:_===0?700*F.MB:2*700*F.MB}}e.getPlatformFileLimits=j;function le(_){return k.isWeb?_?10*F.MB:50*F.MB:_?100*F.MB:1024*F.MB}e.getLargeFileConfirmationLimit=le}),define(Ce[67],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class n{constructor(...D){this.a=new Map;for(const[M,S]of D)this.set(M,S)}set(D,M){const S=this.a.get(D);return this.a.set(D,M),S}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.ServiceCollection=n}),define(Ce[160],ke([1,0,17,12,6,89,158,3,67,161]),function(te,e,n,C,D,M,S,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const N=!1;class w extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class f{constructor(o=new y.ServiceCollection,l=!1,g,E=N){this.f=o,this.g=l,this.h=g,this.i=E,this.o=new Set,this.f.set(R.IInstantiationService,this),this._globalGraph=E?g?._globalGraph??new S.Graph(A=>A):void 0}createChild(o){return new f(o,this.g,this,this.i)}invokeFunction(o,...l){const g=m.traceInvocation(this.i,o);let E=!1;try{return o({get:v=>{if(E)throw(0,C.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(v,g);if(!t)throw new Error(`[invokeFunction] unknown service '${v}'`);return t}},...l)}finally{E=!0,g.stop()}}createInstance(o,...l){let g,E;return o instanceof M.SyncDescriptor?(g=m.traceCreation(this.i,o.ctor),E=this.j(o.ctor,o.staticArguments.concat(l),g)):(g=m.traceCreation(this.i,o),E=this.j(o,l,g)),g.stop(),E}j(o,l=[],g){const E=R._util.getServiceDependencies(o).sort((t,h)=>t.index-h.index),A=[];for(const t of E){const h=this.m(t.id,g);h||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),A.push(h)}const v=E.length>0?E[0].index:l.length;if(l.length!==v){console.trace(`[createInstance] First service dependency of ${o.name} at position ${v+1} conflicts with ${l.length} static arguments`);const t=v-l.length;t>0?l=l.concat(new Array(t)):l=l.slice(0,v)}return Reflect.construct(o,l.concat(A))}k(o,l){if(this.f.get(o)instanceof M.SyncDescriptor)this.f.set(o,l);else if(this.h)this.h.k(o,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const l=this.f.get(o);return!l&&this.h?this.h.l(o):l}m(o,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const g=this.l(o);return g instanceof M.SyncDescriptor?this.q(o,g,l.branch(o,!0)):(l.branch(o,!1),g)}q(o,l,g){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,l,g)}finally{this.o.delete(o)}}r(o,l,g){const E=new S.Graph(t=>t.id.toString());let A=0;const v=[{id:o,desc:l,_trace:g}];for(;v.length;){const t=v.pop();if(E.lookupOrInsertNode(t),A++>1e3)throw new w(E);for(const h of R._util.getServiceDependencies(t.desc.ctor)){const r=this.l(h.id);if(r||this.u(`[createInstance] ${o} depends on ${h.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(h.id)),r instanceof M.SyncDescriptor){const u={id:h.id,desc:r,_trace:t._trace.branch(h.id,!0)};E.insertEdge(t,u),v.push(u)}}}for(;;){const t=E.roots();if(t.length===0){if(!E.isEmpty())throw new w(E);break}for(const{data:h}of t){if(this.l(h.id)instanceof M.SyncDescriptor){const u=this.s(h.id,h.desc.ctor,h.desc.staticArguments,h.desc.supportsDelayedInstantiation,h._trace);this.k(h.id,u)}E.removeNode(h)}}return this.l(o)}s(o,l,g=[],E,A){if(this.f.get(o)instanceof M.SyncDescriptor)return this.t(o,l,g,E,A);if(this.h)return this.h.s(o,l,g,E,A);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(o,l,g=[],E,A){if(E){const v=new f(void 0,this.g,this,this.i);v.c=String(o);const t=new Map,h=new n.IdleValue(()=>{const r=v.j(l,g,A);for(const[u,i]of t){const p=r[u];if(typeof p=="function")for(const c of i)p.apply(r,c)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,u){if(!h.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let c=t.get(u);return c||(c=new k.LinkedList,t.set(u,c)),(d,T,O)=>{const H=c.push([d,T,O]);return(0,D.toDisposable)(H)}}if(u in r)return r[u];const i=h.value;let p=i[u];return typeof p!="function"||(p=p.bind(i),r[u]=p),p},set(r,u,i){return h.value[u]=i,!0},getPrototypeOf(r){return l.prototype}})}else return this.j(l,g,A)}u(o,l){if(l&&console.warn(o),this.g)throw new Error(o)}}e.InstantiationService=f;var b;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(b||(b={}));class m{static traceInvocation(o,l){return o?new m(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(o,l){return o?new m(1,l.name):m.c}constructor(o,l){this.type=o,this.name=l,this.g=Date.now(),this.h=[]}branch(o,l){const g=new m(3,o.toString());return this.h.push([o,l,g]),g}stop(){const o=Date.now()-this.g;m.f+=o;let l=!1;function g(A,v){const t=[],h=new Array(A+1).join("	");for(const[r,u,i]of v.h)if(u&&i){l=!0,t.push(`${h}CREATES -> ${r}`);const p=g(A+1,i);p&&t.push(p)}else t.push(`${h}uses -> ${r}`);return t.join(`
`)}const E=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(o>2||l)&&m.all.add(E.join(`
`))}}m.all=new Set,m.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}},m.f=0,e.Trace=m}),define(Ce[11],ke([1,0,39,4,6,28,21,9,2,3]),function(te,e,n,C,D,M,S,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function N(){return new Date().toISOString()}function w(c){return(0,R.isNumber)(c)}e.isLogLevel=w;var f;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;function b(c,s,d){switch(s){case f.Trace:c.trace(d);break;case f.Debug:c.debug(d);break;case f.Info:c.info(d);break;case f.Warning:c.warn(d);break;case f.Error:c.error(d);break;case f.Off:break;default:throw new Error(`Invalid log level ${s}`)}}e.log=b;function m(c){let s="";for(let d=0;d<c.length;d++){let T=c[d];if(typeof T=="object")try{T=JSON.stringify(T)}catch{}s+=(d>0?" ":"")+T}return s}e.format=m;class a extends D.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new C.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(s){this.b!==s&&(this.b=s,this.c.fire(this.b))}getLevel(){return this.b}f(s){return this.b!==f.Off&&this.b<=s}}e.AbstractLogger=a;class o extends a{constructor(s){super(),this.h=s}f(s){return this.h||super.f(s)}trace(s,...d){this.f(f.Trace)&&this.g(f.Trace,m([s,...d]))}debug(s,...d){this.f(f.Debug)&&this.g(f.Debug,m([s,...d]))}info(s,...d){this.f(f.Info)&&this.g(f.Info,m([s,...d]))}warn(s,...d){this.f(f.Warning)&&this.g(f.Warning,m([s,...d]))}error(s,...d){if(this.f(f.Error))if(s instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=s.stack,this.g(f.Error,m(T))}else this.g(f.Error,m([s,...d]))}flush(){}}e.AbstractMessageLogger=o;class l extends a{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s),this.g=!S.isWindows}trace(s,...d){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${N()}]\x1B[0m`,s,...d):console.log(`[main ${N()}]`,s,...d))}debug(s,...d){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${N()}]\x1B[0m`,s,...d):console.log(`[main ${N()}]`,s,...d))}info(s,...d){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${N()}]\x1B[0m`,s,...d):console.log(`[main ${N()}]`,s,...d))}warn(s,...d){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${N()}]\x1B[0m`,s,...d):console.warn(`[main ${N()}]`,s,...d))}error(s,...d){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${N()}]\x1B[0m`,s,...d):console.error(`[main ${N()}]`,s,...d))}dispose(){}flush(){}}e.ConsoleMainLogger=l;class g extends a{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s)}trace(s,...d){this.f(f.Trace)&&console.log("%cTRACE","color: #888",s,...d)}debug(s,...d){this.f(f.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",s,...d)}info(s,...d){this.f(f.Info)&&console.log("%c INFO","color: #33f",s,...d)}warn(s,...d){this.f(f.Warning)&&console.log("%c WARN","color: #993",s,...d)}error(s,...d){this.f(f.Error)&&console.log("%c  ERR","color: #f33",s,...d)}dispose(){}flush(){}}e.ConsoleLogger=g;class E extends a{constructor(s,d=e.DEFAULT_LOG_LEVEL){super(),this.g=s,this.setLevel(d)}trace(s,...d){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(s),...d])}debug(s,...d){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(s),...d])}info(s,...d){this.f(f.Info)&&this.g.log(f.Info,[this.h(s),...d])}warn(s,...d){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(s),...d])}error(s,...d){this.f(f.Error)&&this.g.log(f.Error,[this.h(s),...d])}h(s){return typeof s=="string"?s:(0,n.toErrorMessage)(s,this.f(f.Trace))}dispose(){}flush(){}}e.AdapterLogger=E;class A extends a{constructor(s){super(),this.g=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const d of this.g)d.setLevel(s);super.setLevel(s)}trace(s,...d){for(const T of this.g)T.trace(s,...d)}debug(s,...d){for(const T of this.g)T.debug(s,...d)}info(s,...d){for(const T of this.g)T.info(s,...d)}warn(s,...d){for(const T of this.g)T.warn(s,...d)}error(s,...d){for(const T of this.g)T.error(s,...d)}flush(){for(const s of this.g)s.flush()}dispose(){for(const s of this.g)s.dispose()}}e.MultiplexLogger=A;class v extends D.Disposable{constructor(s,d){if(super(),this.j=s,this.b=new M.ResourceMap,this.c=new M.ResourceMap,this.f=this.B(new C.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new C.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new C.Emitter),this.onDidChangeVisibility=this.h.event,d)for(const T of d)this.c.set(T.resource,T)}getLogger(s){return this.b.get(s)}createLogger(s,d){let T=this.b.get(s);const O=d?.logLevel==="always"?f.Trace:d?.logLevel;return T||(T=this.k(s,O??this.getLogLevel(s)??this.j,d),this.b.set(s,T)),this.registerLogger({resource:s,id:d?.id??s.toString(),logLevel:O,name:d?.name,hidden:d?.hidden,extensionId:d?.extensionId}),T}setLogLevel(s,d){if(y.URI.isUri(s)){const T=s,O=d,H=this.c.get(T);H&&O!==H.logLevel&&(H.logLevel=O===this.j?void 0:O,this.b.get(T)?.setLevel(O),this.c.set(H.resource,H),this.g.fire([T,O]))}else{this.j=s;for(const[T,O]of this.b.entries())this.c.get(T)?.logLevel===void 0&&O.setLevel(this.j);this.g.fire(this.j)}}setVisibility(s,d){const T=this.c.get(s);T&&d!==!T.hidden&&(T.hidden=!d,this.c.set(T.resource,T),this.h.fire([s,d]))}getLogLevel(s){let d;return s&&(d=this.c.get(s)?.logLevel),d??this.j}registerLogger(s){const d=this.c.get(s.resource);d?d.hidden!==s.hidden&&this.setVisibility(s.resource,!s.hidden):(this.c.set(s.resource,s),this.f.fire({added:[s],removed:[]}))}deregisterLogger(s){const d=this.c.get(s);if(d){this.c.delete(s);const T=this.b.get(s);T&&(this.b.delete(s),T.dispose()),this.f.fire({added:[],removed:[d]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(s){return this.c.get(s)}dispose(){this.b.forEach(s=>s.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=v;class t{constructor(){this.onDidChangeLogLevel=new C.Emitter().event}setLevel(s){}getLevel(){return f.Info}trace(s,...d){}debug(s,...d){}info(s,...d){}warn(s,...d){}error(s,...d){}critical(s,...d){}dispose(){}flush(){}}e.NullLogger=t;class h extends t{}e.NullLogService=h;class r extends v{constructor(){super(f.Info)}k(s,d,T){return new t}}e.NullLoggerService=r;function u(c){if(c.verbose)return f.Trace;if(typeof c.logLevel=="string"){const s=p(c.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function i(c){switch(c){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}e.LogLevelToString=i;function p(c){switch(c){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.parseLogLevel=p}),define(Ce[162],ke([1,0,6,11]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class D extends n.Disposable{constructor(S,R=[]){super(),this.a=new C.MultiplexLogger([S,...R]),this.B(S.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(S){this.a.setLevel(S)}getLevel(){return this.a.getLevel()}trace(S,...R){this.a.trace(S,...R)}debug(S,...R){this.a.debug(S,...R)}info(S,...R){this.a.info(S,...R)}warn(S,...R){this.a.warn(S,...R)}error(S,...R){this.a.error(S,...R)}flush(){this.a.flush()}}e.LogService=D}),define(Ce[91],ke([1,0,29,136,3]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(M=e.MarkerTag||(e.MarkerTag={}));var S;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(S=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function k(m,a){return a-m}y.compare=k;const N=Object.create(null);N[y.Error]=(0,C.localize)(0,null),N[y.Warning]=(0,C.localize)(1,null),N[y.Info]=(0,C.localize)(2,null);function w(m){return N[m]||""}y.toString=w;function f(m){switch(m){case n.default.Error:return y.Error;case n.default.Warning:return y.Warning;case n.default.Info:return y.Info;case n.default.Ignore:return y.Hint}}y.fromSeverity=f;function b(m){switch(m){case y.Error:return n.default.Error;case y.Warning:return n.default.Warning;case y.Info:return n.default.Info;case y.Hint:return n.default.Ignore}}y.toSeverity=b}(S=e.MarkerSeverity||(e.MarkerSeverity={}));var R;(function(y){const k="";function N(f){return w(f,!0)}y.makeKey=N;function w(f,b){const m=[k];return f.source?m.push(f.source.replace("\xA6","\\\xA6")):m.push(k),f.code?typeof f.code=="string"?m.push(f.code.replace("\xA6","\\\xA6")):m.push(f.code.value.replace("\xA6","\\\xA6")):m.push(k),f.severity!==void 0&&f.severity!==null?m.push(S.toString(f.severity)):m.push(k),f.message&&b?m.push(f.message.replace("\xA6","\\\xA6")):m.push(k),f.startLineNumber!==void 0&&f.startLineNumber!==null?m.push(f.startLineNumber.toString()):m.push(k),f.startColumn!==void 0&&f.startColumn!==null?m.push(f.startColumn.toString()):m.push(k),f.endLineNumber!==void 0&&f.endLineNumber!==null?m.push(f.endLineNumber.toString()):m.push(k),f.endColumn!==void 0&&f.endColumn!==null?m.push(f.endColumn.toString()):m.push(k),m.push(k),m.join("\xA6")}y.makeKeyOptionalMessage=w})(R=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(Ce[163],ke([1,0,4,29,3]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=C.default,e.INotificationService=(0,D.createDecorator)("notificationService");var M;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(M=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var S;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(S=e.NotificationsFilter||(e.NotificationsFilter={}));class R{constructor(){this.progress=new y,this.onDidClose=n.Event.None,this.onDidChangeVisibility=n.Event.None}updateSeverity(N){}updateMessage(N){}updateActions(N){}close(){}}e.NoOpNotification=R;class y{infinite(){}done(){}total(N){}worked(N){}}e.NoOpProgress=y}),define(Ce[92],ke([1,0,10,2,3]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,D.createDecorator)("openerService");function M(k,N){return C.URI.isUri(k)?(0,n.equalsIgnoreCase)(k.scheme,N):(0,n.startsWithIgnoreCase)(k,N+":")}e.matchesScheme=M;function S(k,...N){return N.some(w=>M(k,w))}e.matchesSomeScheme=S;function R(k,N){return k.with({fragment:`${N.startLineNumber},${N.startColumn}${N.endLineNumber?`-${N.endLineNumber}${N.endColumn?`,${N.endColumn}`:""}`:""}`})}e.withSelection=R;function y(k){let N;const w=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(k.fragment);return w&&(N={startLineNumber:parseInt(w[1]),startColumn:w[2]?parseInt(w[2]):1,endLineNumber:w[4]?parseInt(w[4]):void 0,endColumn:w[4]?w[5]?parseInt(w[5]):1:void 0},k=k.with({fragment:""})),{selection:N,uri:k}}e.extractSelection=y}),define(Ce[164],ke([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,n.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(te,e,n,C){var D=arguments.length,M=D<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,n):C,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(te,e,n,C);else for(var R=te.length-1;R>=0;R--)(S=te[R])&&(M=(D<3?S(M):D>3?S(e,n,M):S(e,n))||M);return D>3&&M&&Object.defineProperty(e,n,M),M},je=this&&this.__param||function(te,e){return function(n,C){e(n,C,te)}};define(Ce[165],ke([1,0,17,20,6,3]),function(te,e,n,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,M.createDecorator)("progressService");var S;(function(N){N[N.Explorer=1]="Explorer",N[N.Scm=3]="Scm",N[N.Extensions=5]="Extensions",N[N.Window=10]="Window",N[N.Notification=15]="Notification",N[N.Dialog=20]="Dialog"})(S=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class R{get value(){return this.a}constructor(w){this.b=w}report(w){this.a=w,this.b(this.a)}}R.None=Object.freeze({report(){}}),e.Progress=R;let y=class extends D.Disposable{constructor(w,f){super(),this.a=new n.DeferredPromise,f.withProgress(w,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,D.toDisposable)(()=>this.a.complete()))}report(w){this.b?this.b.report(w):this.c=w}};y=qe([je(1,e.IProgressService)],y),e.UnmanagedProgress=y;class k extends D.Disposable{constructor(w){super(),this.g=w,this.a=0,this.b=this.B(new D.DisposableStore)}start(w){this.stop();const f=++this.a,b=new C.CancellationTokenSource;return this.f=setTimeout(()=>{f===this.a&&(this.c=this.g.show(!0))},w),this.b.add((0,D.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,D.toDisposable)(()=>b.cancel())),this.b.add((0,D.toDisposable)(()=>this.c?this.c.done():void 0)),{id:f,token:b.token,stop:()=>this.h(f),isCurrent:()=>this.a===f}}stop(){this.h(this.a)}h(w){this.a===w&&this.b.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,M.createDecorator)("editorProgressService")}),define(Ce[30],ke([1,0,49,9]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.a=new Map}add(S,R){n.ok(C.isString(S)),n.ok(C.isObject(R)),n.ok(!this.a.has(S),"There is already an extension with this id"),this.a.set(S,R)}knows(S){return this.a.has(S)}as(S){return this.a.get(S)||null}}e.Registry=new D}),define(Ce[68],ke([1,0,4,30]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class M{constructor(){this.b=new n.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,k){this.a[D(y)]=k,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const S=new M;C.Registry.add(e.Extensions.JSONContribution,S)}),define(Ce[93],ke([1,0,15,4,9,132,41,68,30]),function(te,e,n,C,D,M,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var N;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(N=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=y.Registry.as(R.Extensions.JSONContribution);class f{constructor(){this.h=new Set,this.i=new C.Emitter,this.onDidSchemaChange=this.i.event,this.j=new C.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,h=!0){this.registerConfigurations([t],h)}registerConfigurations(t,h=!0){const r=new Set;this.n(t,h,r),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const h=new Set;this.o(t,h),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:h})}updateConfigurations({add:t,remove:h}){const r=new Set;this.o(h,r),this.n(t,!1,r),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const h=new Set;this.k(t,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:!0})}k(t,h){const r=[];for(const{overrides:u,source:i}of t)for(const p in u)if(h.add(p),e.OVERRIDE_PROPERTY_REGEX.test(p)){const c=this.a.get(p),s=c?.valuesSources??new Map;if(i)for(const H of Object.keys(u[p]))s.set(H,i);const d={...c?.value||{},...u[p]};this.a.set(p,{source:i,value:d,valuesSources:s});const T=(0,S.getLanguageTagSettingPlainKey)(p),O={type:"object",default:d,description:M.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:d,source:D.isString(i)?void 0:i,defaultValueSource:i};r.push(...a(p)),this.d[p]=O,this.b.properties[p]=O}else{this.a.set(p,{value:u[p],source:i});const c=this.d[p];c&&(this.w(p,c),this.r(p,c))}this.m(r)}deregisterDefaultConfigurations(t){const h=new Set;this.l(t,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:!0})}l(t,h){for(const{overrides:r,source:u}of t)for(const i in r){const p=this.a.get(i),c=D.isString(u)?u:u?.id,s=D.isString(p?.source)?p?.source:p?.source?.id;if(c===s)if(h.add(i),this.a.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.d[i],delete this.b.properties[i];else{const d=this.d[i];d&&(this.w(i,d),this.r(i,d))}}this.u()}deltaConfiguration(t){let h=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),h=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),h=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:h})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const h of t)this.h.add(h);this.u()}n(t,h,r){t.forEach(u=>{this.p(u,h,u.extensionInfo,u.restrictedProperties,void 0,r),this.c.push(u),this.q(u)})}o(t,h){const r=u=>{if(u.properties)for(const i in u.properties){h.add(i);const p=this.d[i];p?.policy?.name&&this.e.delete(p.policy.name),delete this.d[i],this.s(i,u.properties[i])}u.allOf?.forEach(i=>r(i))};for(const u of t){r(u);const i=this.c.indexOf(u);i!==-1&&this.c.splice(i,1)}}p(t,h=!0,r,u,i=3,p){i=D.isUndefinedOrNull(t.scope)?i:t.scope;const c=t.properties;if(c)for(const d in c){const T=c[d];if(h&&E(d,T)){delete c[d];continue}if(T.source=r,T.defaultDefaultValue=c[d].default,this.w(d,T),e.OVERRIDE_PROPERTY_REGEX.test(d)?T.scope=void 0:(T.scope=D.isUndefinedOrNull(T.scope)?i:T.scope,T.restricted=D.isUndefinedOrNull(T.restricted)?!!u?.includes(d):T.restricted),c[d].hasOwnProperty("included")&&!c[d].included){this.f[d]=c[d],delete c[d];continue}else this.d[d]=c[d],c[d].policy?.name&&this.e.set(c[d].policy.name,d);!c[d].deprecationMessage&&c[d].markdownDeprecationMessage&&(c[d].deprecationMessage=c[d].markdownDeprecationMessage),p.add(d)}const s=t.allOf;if(s)for(const d of s)this.p(d,h,r,u,i,p)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const h=r=>{const u=r.properties;if(u)for(const p in u)this.r(p,u[p]);r.allOf?.forEach(h)};h(t)}r(t,h){switch(e.allSettings.properties[t]=h,h.scope){case 1:e.applicationSettings.properties[t]=h;break;case 2:e.machineSettings.properties[t]=h;break;case 6:e.machineOverridableSettings.properties[t]=h;break;case 3:e.windowSettings.properties[t]=h;break;case 4:e.resourceSettings.properties[t]=h;break;case 5:e.resourceSettings.properties[t]=h,this.g.properties[t]=h;break}}s(t,h){switch(delete e.allSettings.properties[t],h.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const h=`[${t}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(h,r),e.allSettings.properties[h]=r,e.applicationSettings.properties[h]=r,e.machineSettings.properties[h]=r,e.machineOverridableSettings.properties[h]=r,e.windowSettings.properties[h]=r,e.resourceSettings.properties[h]=r}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,h){const r=this.a.get(t);let u=r?.value,i=r?.source;D.isUndefined(u)&&(u=h.defaultDefaultValue,i=void 0),D.isUndefined(u)&&(u=l(h.type)),h.default=u,h.defaultValueSource=i}}const b="\\[([^\\]]+)\\]",m=new RegExp(b,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${b})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function a(v){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(v)){let h=m.exec(v);for(;h?.length;){const r=h[1].trim();r&&t.push(r),h=m.exec(v)}}return(0,n.distinct)(t)}e.overrideIdentifiersFromKey=a;function o(v){return v.reduce((t,h)=>`${t}[${h}]`,"")}e.keyFromOverrideIdentifiers=o;function l(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const g=new f;y.Registry.add(e.Extensions.Configuration,g);function E(v,t){return v.trim()?e.OVERRIDE_PROPERTY_REGEX.test(v)?M.localize(7,null,v):g.getConfigurationProperties()[v]!==void 0?M.localize(8,null,v):t.policy?.name&&g.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,v,t.policy?.name,g.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}e.validateProperty=E;function A(){const v=[],t=g.getConfigurationProperties();for(const h of Object.keys(t))v.push([h,t[h].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=A}),define(Ce[166],ke([1,0,15,4,111,6,28,22,9,2,41,93,30]),function(te,e,n,C,D,M,S,R,y,k,N,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function b(h){return Object.isFrozen(h)?h:R.deepFreeze(h)}class m{constructor(r={},u=[],i=[],p){this.b=r,this.c=u,this.d=i,this.raw=p,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(u=>{if(u instanceof m)return u;const i=new a("");return i.parseRaw(u),i.configurationModel});this.f=r.reduce((u,i)=>i===u?i:u.merge(i),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,N.getConfigurationValue)(this.contents,r):this.contents}inspect(r,u){const i=this.rawConfiguration.getValue(r),p=u?this.rawConfiguration.getOverrideValue(r,u):void 0,c=u?this.rawConfiguration.override(u).getValue(r):i;return{value:i,override:p,merged:c}}getOverrideValue(r,u){const i=this.i(u);return i?r?(0,N.getConfigurationValue)(i,r):i:void 0}getKeysForOverrideIdentifier(r){const u=[];for(const i of this.overrides)i.identifiers.includes(r)&&u.push(...i.keys);return n.distinct(u)}getAllOverrideIdentifiers(){const r=[];for(const u of this.overrides)r.push(...u.identifiers);return n.distinct(r)}override(r){let u=this.a.get(r);return u||(u=this.g(r),this.a.set(r,u)),u}merge(...r){const u=R.deepClone(this.contents),i=R.deepClone(this.overrides),p=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const s of r)if(c.push(...s.raw?.length?s.raw:[s]),!s.isEmpty()){this.h(u,s.contents);for(const d of s.overrides){const[T]=i.filter(O=>n.equals(O.identifiers,d.identifiers));T?(this.h(T.contents,d.contents),T.keys.push(...d.keys),T.keys=n.distinct(T.keys)):i.push(R.deepClone(d))}for(const d of s.keys)p.indexOf(d)===-1&&p.push(d)}return new m(u,p,i,c.every(s=>s instanceof m)?void 0:c)}g(r){const u=this.i(r);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const i={};for(const p of n.distinct([...Object.keys(this.contents),...Object.keys(u)])){let c=this.contents[p];const s=u[p];s&&(typeof c=="object"&&typeof s=="object"?(c=R.deepClone(c),this.h(c,s)):c=s),i[p]=c}return new m(i,this.keys,this.overrides)}h(r,u){for(const i of Object.keys(u)){if(i in r&&y.isObject(r[i])&&y.isObject(u[i])){this.h(r[i],u[i]);continue}r[i]=R.deepClone(u[i])}}i(r){let u=null,i=null;const p=c=>{c&&(i?this.h(i,c):i=R.deepClone(c))};for(const c of this.overrides)n.equals(c.identifiers,[r])?u=c.contents:c.identifiers.includes(r)&&p(c.contents);return p(u),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,u){this.j(r,u,!0)}setValue(r,u){this.j(r,u,!1)}removeValue(r){const u=this.keys.indexOf(r);u!==-1&&(this.keys.splice(u,1),(0,N.removeFromValueTree)(this.contents,r),w.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(i=>n.equals(i.identifiers,(0,w.overrideIdentifiersFromKey)(r))),1))}j(r,u,i){(0,N.addToValueTree)(this.contents,r,u,p=>console.error(p)),i=i||this.keys.indexOf(r)===-1,i&&this.keys.push(r),w.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,w.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,N.toValuesTree)(this.contents[r],p=>console.error(p))})}}e.ConfigurationModel=m;class a{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,u){if(!y.isUndefinedOrNull(r)){const i=this.g(r);this.parseRaw(i,u)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,u){this.a=r;const{contents:i,keys:p,overrides:c,restricted:s,hasExcludedProperties:d}=this.h(r,u);this.b=new m(i,p,c,d?[r]:void 0),this.c=s||[]}g(r){let u={},i=null,p=[];const c=[],s=[];function d(O){Array.isArray(p)?p.push(O):i!==null&&(p[i]=O)}const T={onObjectBegin:()=>{const O={};d(O),c.push(p),p=O,i=null},onObjectProperty:O=>{i=O},onObjectEnd:()=>{p=c.pop()},onArrayBegin:()=>{const O=[];d(O),c.push(p),p=O,i=null},onArrayEnd:()=>{p=c.pop()},onLiteralValue:d,onError:(O,H,J)=>{s.push({error:O,offset:H,length:J})}};if(r)try{D.visit(r,T),u=p[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return u}h(r,u){const i=f.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),p=this.i(r,i,!0,u);r=p.raw;const c=(0,N.toValuesTree)(r,T=>console.error(`Conflict in settings file ${this.f}: ${T}`)),s=Object.keys(r),d=this.j(r,T=>console.error(`Conflict in settings file ${this.f}: ${T}`));return{contents:c,keys:s,overrides:d,restricted:p.restricted,hasExcludedProperties:p.hasExcludedProperties}}i(r,u,i,p){let c=!1;if(!p?.scopes&&!p?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:c};const s={},d=[];for(const T in r)if(w.OVERRIDE_PROPERTY_REGEX.test(T)&&i){const O=this.i(r[T],u,!1,p);s[T]=O.raw,c=c||O.hasExcludedProperties,d.push(...O.restricted)}else{const O=u[T],H=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&d.push(T),(H===void 0||p.scopes===void 0||p.scopes.includes(H))&&!(p.skipRestricted&&O?.restricted)?s[T]=r[T]:c=!0}return{raw:s,restricted:d,hasExcludedProperties:c}}j(r,u){const i=[];for(const p of Object.keys(r))if(w.OVERRIDE_PROPERTY_REGEX.test(p)){const c={};for(const s in r[p])c[s]=r[p][s];i.push({identifiers:(0,w.overrideIdentifiersFromKey)(p),keys:Object.keys(c),contents:(0,N.toValuesTree)(c,u)})}return i}}e.ConfigurationModelParser=a;class o extends M.Disposable{constructor(r,u,i,p){super(),this.f=r,this.g=u,this.h=p,this.c=this.B(new C.Emitter),this.onDidChange=this.c.event,this.a=new a(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(i.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(C.Event.any(C.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),C.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&i.isEqual(c.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new m}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=o;class l{constructor(r,u,i,p,c,s,d,T,O,H,J,K,L){this.a=r,this.b=u,this.c=i,this.overrideIdentifiers=p,this.d=c,this.f=s,this.g=d,this.h=T,this.i=O,this.j=H,this.k=J,this.l=K,this.m=L}get value(){return b(this.c)}n(r,u,i){const p=r.inspect(u,i);return{get value(){return b(p.value)},get override(){return b(p.override)},get merged(){return b(p.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class g{constructor(r,u,i,p,c=new m,s=new m,d=new S.ResourceMap,T=new m,O=new S.ResourceMap){this.c=r,this.d=u,this.f=i,this.g=p,this.h=c,this.i=s,this.j=d,this.l=T,this.m=O,this.a=null,this.b=new S.ResourceMap,this.n=null}getValue(r,u,i){return this.q(r,u,i).getValue(r)}updateValue(r,u,i={}){let p;i.resource?(p=this.m.get(i.resource),p||(p=new m,this.m.set(i.resource,p))):p=this.l,u===void 0?p.removeValue(r):p.setValue(r,u),i.resource||(this.a=null)}inspect(r,u,i){const p=this.q(r,u,i),c=this.u(u.resource,i),s=u.resource?this.m.get(u.resource)||this.l:this.l,d=new Set;for(const T of p.overrides)for(const O of T.identifiers)p.getOverrideValue(r,O)!==void 0&&d.add(O);return new l(r,u,p.getValue(r),d.size?[...d]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this.i:void 0,c||void 0,s)}keys(r){const u=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:u?u.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,u){this.j.set(r,u),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,u){const i=[];if(!u){const{added:p,updated:c,removed:s}=v(this.c,r);u=[...p,...c,...s]}for(const p of u)for(const c of(0,w.overrideIdentifiersFromKey)(p)){const s=this.c.getKeysForOverrideIdentifier(c),d=r.getKeysForOverrideIdentifier(c),T=[...d.filter(O=>s.indexOf(O)===-1),...s.filter(O=>d.indexOf(O)===-1),...s.filter(O=>!R.equals(this.c.override(c).getValue(O),r.override(c).getValue(O)))];i.push([c,T])}return this.updateDefaultConfiguration(r),{keys:u,overrides:i}}compareAndUpdatePolicyConfiguration(r){const{added:u,updated:i,removed:p}=v(this.d,r),c=[...u,...i,...p];return c.length&&this.updatePolicyConfiguration(r),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:u,updated:i,removed:p,overrides:c}=v(this.applicationConfiguration,r),s=[...u,...i,...p];return s.length&&this.updateApplicationConfiguration(r),{keys:s,overrides:c}}compareAndUpdateLocalUserConfiguration(r){const{added:u,updated:i,removed:p,overrides:c}=v(this.localUserConfiguration,r),s=[...u,...i,...p];return s.length&&this.updateLocalUserConfiguration(r),{keys:s,overrides:c}}compareAndUpdateRemoteUserConfiguration(r){const{added:u,updated:i,removed:p,overrides:c}=v(this.remoteUserConfiguration,r),s=[...u,...i,...p];return s.length&&this.updateRemoteUserConfiguration(r),{keys:s,overrides:c}}compareAndUpdateWorkspaceConfiguration(r){const{added:u,updated:i,removed:p,overrides:c}=v(this.workspaceConfiguration,r),s=[...u,...i,...p];return s.length&&this.updateWorkspaceConfiguration(r),{keys:s,overrides:c}}compareAndUpdateFolderConfiguration(r,u){const i=this.p.get(r),{added:p,updated:c,removed:s,overrides:d}=v(i,u),T=[...p,...c,...s];return(T.length||!i)&&this.updateFolderConfiguration(r,u),{keys:T,overrides:d}}compareAndDeleteFolderConfiguration(r){const u=this.p.get(r);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:i,updated:p,removed:c,overrides:s}=v(u,void 0);return{keys:[...i,...p,...c],overrides:s}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,u,i){let p=this.r(u,i);return u.overrideIdentifier&&(p=p.override(u.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(p=p.merge(this.d)),p}r({resource:r},u){let i=this.s();if(u&&r){const p=u.getFolder(r);p&&(i=this.t(p.uri)||i);const c=this.m.get(r);c&&(i=i.merge(c))}return i}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let u=this.b.get(r);if(!u){const i=this.s(),p=this.j.get(r);p?(u=i.merge(p),this.b.set(r,u)):u=i}return u}u(r,u){if(u&&r){const i=u.getFolder(r);if(i)return this.j.get(i.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,u)=>{const{contents:i,overrides:p,keys:c}=this.j.get(u);return r.push([u,{contents:i,overrides:p,keys:c}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(u=>r.add(u)),this.userConfiguration.keys.forEach(u=>r.add(u)),this.i.keys.forEach(u=>r.add(u)),this.j.forEach(u=>u.keys.forEach(i=>r.add(i))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(u=>r.add(u)),this.userConfiguration.getAllOverrideIdentifiers().forEach(u=>r.add(u)),this.i.getAllOverrideIdentifiers().forEach(u=>r.add(u)),this.j.forEach(u=>u.getAllOverrideIdentifiers().forEach(i=>r.add(i))),[...r.values()]}w(r){const u=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(i=>u.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(i=>u.add(i)),this.i.getKeysForOverrideIdentifier(r).forEach(i=>u.add(i)),this.j.forEach(i=>i.getKeysForOverrideIdentifier(r).forEach(p=>u.add(p))),[...u.values()]}static parse(r){const u=this.x(r.defaults),i=this.x(r.policy),p=this.x(r.application),c=this.x(r.user),s=this.x(r.workspace),d=r.folders.reduce((T,O)=>(T.set(k.URI.revive(O[0]),this.x(O[1])),T),new S.ResourceMap);return new g(u,i,p,c,new m,s,d,new m,new S.ResourceMap)}static x(r){return new m(r.contents,r.keys,r.overrides)}}e.Configuration=g;function E(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const r=new Set,u=new Map;for(const p of h)p.keys.forEach(c=>r.add(c)),p.overrides.forEach(([c,s])=>{const d=(0,S.getOrSet)(u,c,new Set);s.forEach(T=>d.add(T))});const i=[];return u.forEach((p,c)=>i.push([c,[...p.values()]])),{keys:[...r.values()],overrides:i}}e.mergeChanges=E;class A{constructor(r,u,i,p){this.change=r,this.f=u,this.g=i,this.h=p,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const c of r.keys)this.affectedKeys.add(c);for(const[,c]of r.overrides)for(const s of c)this.affectedKeys.add(s);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=g.parse(this.f.data)),this.i}affectsConfiguration(r,u){const i=this.a+r,p=this.d.indexOf(i);if(p<0)return!1;const c=p+i.length;if(c>=this.d.length)return!1;const s=this.d.charCodeAt(c);if(s!==this.b&&s!==this.c)return!1;if(u){const d=this.previousConfiguration?this.previousConfiguration.getValue(r,u,this.f?.workspace):void 0,T=this.g.getValue(r,u,this.h);return!R.equals(d,T)}return!0}}e.ConfigurationChangeEvent=A;function v(h,r){const{added:u,removed:i,updated:p}=t(r?.rawConfiguration,h?.rawConfiguration),c=[],s=h?.getAllOverrideIdentifiers()||[],d=r?.getAllOverrideIdentifiers()||[];if(r){const T=d.filter(O=>!s.includes(O));for(const O of T)c.push([O,r.getKeysForOverrideIdentifier(O)])}if(h){const T=s.filter(O=>!d.includes(O));for(const O of T)c.push([O,h.getKeysForOverrideIdentifier(O)])}if(r&&h){for(const T of s)if(d.includes(T)){const O=t({contents:h.getOverrideValue(void 0,T)||{},keys:h.getKeysForOverrideIdentifier(T)},{contents:r.getOverrideValue(void 0,T)||{},keys:r.getKeysForOverrideIdentifier(T)});c.push([T,[...O.added,...O.removed,...O.updated]])}}return{added:u,removed:i,updated:p,overrides:c}}function t(h,r){const u=h?r?h.keys.filter(c=>r.keys.indexOf(c)===-1):[...h.keys]:[],i=r?h?r.keys.filter(c=>h.keys.indexOf(c)===-1):[...r.keys]:[],p=[];if(h&&r){for(const c of r.keys)if(h.keys.indexOf(c)!==-1){const s=(0,N.getConfigurationValue)(r.contents,c),d=(0,N.getConfigurationValue)(h.contents,c);R.equals(s,d)||p.push(c)}}return{added:u,removed:i,updated:p}}}),define(Ce[94],ke([1,0,12,3]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,C.createDecorator)("remoteAuthorityResolverService");var D;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends n.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof M&&y._code===D.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof M&&y._code===D.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof M&&y._code===D.NoResolverFound}static isHandled(y){return y instanceof M&&y.isHandled}constructor(y,k=D.Unknown,N){super(y),this._message=y,this._code=k,this._detail=N,this.isHandled=k===D.NotAvailable&&N===!0,Object.setPrototypeOf(this,M.prototype)}}e.RemoteAuthorityResolverError=M;function S(R){const y=R.indexOf("+");return y===-1?R:R.substring(0,y)}e.getRemoteAuthorityPrefix=S}),define(Ce[50],ke([1,0,16]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function C(k){return k.scheme===n.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=C;function D(k){if(!k)return;const N=k.indexOf("+");return N<0?k:k.substr(0,N)}e.getRemoteName=D;function M(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=M;function S(k){const{host:N,port:w}=y(k);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:N,port:w}}e.parseAuthorityWithPort=S;function R(k,N){let{host:w,port:f}=y(k);return typeof f>"u"&&(f=N),{host:w,port:f}}e.parseAuthorityWithOptionalPort=R;function y(k){const N=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(N)return{host:N[1],port:parseInt(N[2],10)};const w=k.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const f=k.match(/(.*):(\d+)$/);return f?{host:f[1],port:parseInt(f[2],10)}:{host:k,port:void 0}}}),define(Ce[25],ke([1,0,10,3,50]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=M;function S(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=S,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));var y;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));class k{constructor(a){this.value=a,this.c=a.toLowerCase()}static equals(a,o){if(typeof a>"u"||a===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof a=="string"||typeof o=="string"){const l=typeof a=="string"?a:a.value,g=typeof o=="string"?o:o.value;return n.equalsIgnoreCase(l,g)}return a.c===o.c}static toKey(a){return typeof a=="string"?a.toLowerCase():a.c}}e.ExtensionIdentifier=k;function N(m){return w(m)}e.isApplicationScopedExtension=N;function w(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function f(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=f;function b(m,a){if(a){const o=`onResolveRemoteAuthority:${(0,D.getRemoteName)(a)}`;return m.activationEvents?.indexOf(o)!==-1}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ce[167],ke([1,0,21,51,2,34]),function(te,e,n,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function S(k){if(n.platform===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}async function R(k,N,w,f,b,m,a,o,l,g){const E=Object.create(null);E["common.machineId"]=a,E.sessionID=(0,M.generateUuid)()+Date.now(),E.commitHash=b,E.version=m,E["common.platformVersion"]=(N||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,n.PlatformToString)(n.platform),E["common.nodePlatform"]=C.platform,E["common.nodeArch"]=f,E["common.product"]=g||"desktop",o&&(E["common.msftInternal"]=o);let A=0;const v=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-v,enumerable:!0},"common.sequence":{get:()=>A++,enumerable:!0}}),n.isLinuxSnap&&(E["common.snap"]="true");const t=S(w);t&&(E["common.platformDetail"]=t);try{const h=await k.readFile(D.URI.file(l));E["common.source"]=h.value.toString().slice(0,30)}catch{}return E}e.resolveCommonProperties=R;function y(k){const N=C.env.USERDNSDOMAIN;if(!N)return!1;const w=N.toLowerCase();return k.some(f=>w===f)}e.verifyMicrosoftInternalDomain=y}),define(Ce[168],ke([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,n.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,n.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var C;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(C=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ce[52],ke([1,0,22,9,4,41,50,167,168]),function(te,e,n,C,D,M,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class k{constructor(c){this.value=c}}e.TelemetryTrustedValue=k;class N{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(c,s){return Promise.resolve(void 0)}publicLog2(c,s){return this.publicLog(c,s)}publicLogError(c,s){return Promise.resolve(void 0)}publicLogError2(c,s){return this.publicLogError(c,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=N,e.NullTelemetryService=new N;class w{async publicLog(c,s,d){}async publicLogError(c,s,d){}}e.NullEndpointTelemetryService=w,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(p,c){return D.Event.debounce(c.onDidChangeConfiguration,(d,T)=>{const O=d?new Set([...d.affectedKeys,...T.affectedKeys]):T.affectedKeys;return{...T,affectedKeys:O}},1e3,!0)(d=>{d.source!==7&&p.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(d.source),configurationKeys:A(d.affectedKeys)})})}e.configurationTelemetry=f;function b(p,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!p.enableTelemetry||c.extensionTestsLocationURI)}e.supportsTelemetry=b;function m(p,c){return!(c.isBuilt||c.disableTelemetry||p.enableTelemetry&&p.aiConfig?.ariaKey)}e.isLoggingOnly=m;function a(p){const c=p.getValue(y.TELEMETRY_SETTING_ID),s=p.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(p.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=a;function o(p){const c={},s={},d={};E(p,d);for(let T in d){T=T.length>150?T.substr(T.length-149):T;const O=d[T];typeof O=="number"?s[T]=O:typeof O=="boolean"?s[T]=O?1:0:typeof O=="string"?(O.length>8192&&console.warn(`Telemetry property: ${T} has been trimmed to 8192, the original length is ${O.length}`),c[T]=O.substring(0,8191)):typeof O<"u"&&O!==null&&(c[T]=O)}return{properties:c,measurements:s}}e.validateTelemetryData=o;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function g(p){if(!p)return"none";const c=(0,S.getRemoteName)(p);return l.has(c)?c:"other"}e.cleanRemoteAuthority=g;function E(p,c,s=0,d){if(!!p)for(const T of Object.getOwnPropertyNames(p)){const O=p[T],H=d?d+T:T;Array.isArray(O)?c[H]=(0,n.safeStringify)(O):O instanceof Date?c[H]=O.toISOString():(0,C.isObject)(O)?s<2?E(O,c,s+1,H+"."):c[H]=(0,n.safeStringify)(O):c[H]=O}}function A(p){if(!p)return[];const c=[];return v(c,"",p),c}function v(p,c,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(d=>v(p,c?`${c}.${d}`:d,s[d])):p.push(c)}function t(p,c){const s=p.msftInternalDomains||[],d=c.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(s)||d}e.isInternalTelemetry=t;function h(p){return[p.appRoot,p.extensionsPath,p.userHome.fsPath,p.tmpDir.fsPath,p.userDataPath]}e.getPiiPathsFromEnvironment=h;function r(p,c){if(!p||!p.includes("/")&&!p.includes("\\"))return p;let s=p;const d=[];for(const J of c)for(;;){const K=J.exec(p);if(!K)break;d.push([K.index,J.lastIndex])}const T=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,O=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let H=0;for(s="";;){const J=O.exec(p);if(!J)break;const K=d.some(([L,B])=>J.index<B&&L<O.lastIndex);!T.test(J[0])&&!K&&(s+=p.substring(H,J.index)+"<REDACTED: user-file-path>",H=O.lastIndex)}return H<p.length&&(s+=p.substr(H)),s}function u(p){if(!p)return p;const c=p.toLowerCase(),s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of s)if(d.regex.test(c))return`<REDACTED: ${d.label}>`;return p}function i(p,c){return(0,n.cloneAndChange)(p,s=>{if(s instanceof k)return s.value;if(typeof s=="string"){let d=s.replaceAll("%20"," ");d=r(d,c);for(const T of c)d=d.replace(T,"");return d=u(d),d}})}e.cleanData=i}),define(Ce[169],ke([1,0,10,90,25,21,2,12,51,52]),function(te,e,n,C,D,M,S,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function N(r,u){return r.uuid&&u.uuid?r.uuid===u.uuid:r.id===u.id?!0:(0,n.compareIgnoreCase)(r.id,u.id)===0}e.areSameExtensions=N;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class f{static create(u){const i=u.manifest?u.manifest.version:u.version,p=u.manifest?u.targetPlatform:u.properties.targetPlatform;return new f(u.identifier,i,p)}static parse(u){const i=w.exec(u);return i&&i[1]&&i[2]?new f({id:i[1]},i[2],i[4]||void 0):null}constructor(u,i,p="undefined"){this.version=i,this.targetPlatform=p,this.id=u.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(u){return u instanceof f?N(this,u)&&this.version===u.version&&this.targetPlatform===u.targetPlatform:!1}}e.ExtensionKey=f;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(r){const u=b.exec(r);return u&&u[1]?[o(u[1]),u[2]]:[o(r),void 0]}e.getIdAndVersion=m;function a(r,u){return`${r}.${u}`}e.getExtensionId=a;function o(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=o;function l(r,u){return o(a(r,u))}e.getGalleryExtensionId=l;function g(r,u){const i=[],p=c=>{for(const s of i)if(s.some(d=>N(u(d),u(c))))return s;return null};for(const c of r){const s=p(c);s?s.push(c):i.push([c])}return i}e.groupByExtension=g;function E(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=E;function A(r){return{id:new k.TelemetryTrustedValue(r.identifier.id),name:new k.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=A,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function v(r,u){const i=[],p=u.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const c=p.shift();if(c&&i.every(s=>!N(s.identifier,{id:c}))){const s=r.filter(d=>N(d.identifier,{id:c}));s.length===1&&(i.push(s[0]),p.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=v;async function t(r,u){if(!M.isLinux)return!1;let i;try{i=(await r.readFile(S.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await r.readFile(S.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){u.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(c))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=t;async function h(r,u){const i=await t(r,u),p=(0,C.getTargetPlatform)(i?"alpine":M.platform,y.arch);return u.debug("ComputeTargetPlatform:",p),p}e.computeTargetPlatform=h}),define(Ce[170],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function n(S){return[...S.entries()]}e.serializeEnvironmentVariableCollection=n;function C(S){return new Map(S)}e.deserializeEnvironmentVariableCollection=C;function D(S){return Array.from(S.entries()).map(R=>[R[0],n(R[1].map)])}e.serializeEnvironmentVariableCollections=D;function M(S){return new Map(S.map(R=>[R[0],{map:C(R[1])}]))}e.deserializeEnvironmentVariableCollections=M}),define(Ce[171],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class n{constructor(D){this.b=D,this.a=new Map}dispose(){for(const D of this.a.values())D.dispose()}startBuffering(D,M,S=5){const R=M(y=>{const k=typeof y=="string"?y:y.data;let N=this.a.get(D);if(N){N.data.push(k);return}const w=setTimeout(()=>this.flushBuffer(D),S);N={data:[k],timeoutId:w,dispose:()=>{clearTimeout(w),this.flushBuffer(D),R.dispose()}},this.a.set(D,N)});return R}stopBuffering(D){this.a.get(D)?.dispose()}flushBuffer(D){const M=this.a.get(D);M&&(this.a.delete(D),this.b(D,M.data.join("")))}}e.TerminalDataBufferer=n}),define(Ce[172],ke([1,0,17,84,38,4,9,2,137,68,30]),function(te,e,n,C,D,M,S,R,y,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var w;(function(A){function v(t,h){let r=t.defaults;for(;D.ThemeIcon.isThemeIcon(r);){const u=m.getIcon(r.id);if(!u)return;r=u.defaults}return r}A.getDefinition=v})(w=e.IconContribution||(e.IconContribution={}));var f;(function(A){function v(h){return{weight:h.weight,style:h.style,src:h.src.map(r=>({format:r.format,location:r.location.toString()}))}}A.toJSONObject=v;function t(h){const r=u=>(0,S.isString)(u)?u:void 0;if(h&&Array.isArray(h.src)&&h.src.every(u=>(0,S.isString)(u.format)&&(0,S.isString)(u.location)))return{weight:r(h.weight),style:r(h.style),src:h.src.map(u=>({format:u.format,location:R.URI.parse(u.location)}))}}A.fromJSONObject=t})(f=e.IconFontDefinition||(e.IconFontDefinition={}));class b{constructor(){this.a=new M.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${D.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(v,t,h,r){const u=this.b[v];if(u){if(h&&!u.description){u.description=h,this.d.properties[v].markdownDescription=`${h} $(${v})`;const c=this.e.enum.indexOf(v);c!==-1&&(this.e.enumDescriptions[c]=h),this.a.fire()}return u}const i={id:v,description:h,defaults:t,deprecationMessage:r};this.b[v]=i;const p={$ref:"#/definitions/icons"};return r&&(p.deprecationMessage=r),h&&(p.markdownDescription=`${h}: $(${v})`),this.d.properties[v]=p,this.e.enum.push(v),this.e.enumDescriptions.push(h||""),this.a.fire(),{id:v}}deregisterIcon(v){delete this.b[v],delete this.d.properties[v];const t=this.e.enum.indexOf(v);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(v=>this.b[v])}getIcon(v){return this.b[v]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(v,t){const h=this.f[v];return h||(this.f[v]=t,this.a.fire(),t)}deregisterIconFont(v){delete this.f[v]}getIconFont(v){return this.f[v]}toString(){const v=(u,i)=>u.id.localeCompare(i.id),t=u=>{for(;D.ThemeIcon.isThemeIcon(u.defaults);)u=this.b[u.defaults.id];return`codicon codicon-${u?u.id:""}`},h=[];h.push("| preview     | identifier                        | default codicon ID                | description"),h.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.b).map(u=>this.b[u]);for(const u of r.filter(i=>!!i.description).sort(v))h.push(`|<i class="${t(u)}"></i>|${u.id}|${D.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);h.push("| preview     | identifier                        "),h.push("| ----------- | --------------------------------- |");for(const u of r.filter(i=>!D.ThemeIcon.isThemeIcon(i.defaults)).sort(v))h.push(`|<i class="${t(u)}"></i>|${u.id}|`);return h.join(`
`)}}const m=new b;N.Registry.add(e.Extensions.IconContribution,m);function a(A,v,t,h){return m.registerIcon(A,v,t,h)}e.registerIcon=a;function o(){return m}e.getIconRegistry=o;function l(){const A=(0,C.getCodiconFontCharacters)();for(const v in A){const t="\\"+A[v].toString(16);m.registerIcon(v,{fontCharacter:t})}}l(),e.iconsSchemaId="vscode://schemas/icons";const g=N.Registry.as(k.Extensions.JSONContribution);g.registerSchema(e.iconsSchemaId,m.getIconSchema());const E=new n.RunOnceScheduler(()=>g.notifySchemaChanged(e.iconsSchemaId),200);m.onDidChange(()=>{E.isScheduled()||E.schedule()}),e.widgetClose=a("widget-close",C.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=a("goto-previous-location",C.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=a("goto-next-location",C.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=D.ThemeIcon.modify(C.Codicon.sync,"spin"),e.spinningLoading=D.ThemeIcon.modify(C.Codicon.loading,"spin")}),define(Ce[173],ke([1,0,4,41,3,11]),function(te,e,n,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var S;(function(a){a.Http="http",a.Https="https"})(S=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(a){if(a.scheme!=="http"&&a.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(!!o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function N(a){return e.LOCALHOST_ADDRESSES.indexOf(a)>=0}e.isLocalhost=N,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(a){return e.ALL_INTERFACES_ADDRESSES.indexOf(a)>=0}e.isAllInterfaces=w;function f(a,o,l,g){if(l===1)return!1;if(l===2&&w(o)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(E?.length===4&&parseInt(E[1])>=18)return!1}return a<1024}e.isPortPrivileged=f;class b{constructor(o,l,g){this.remoteAddress=o,this.localAddress=l,this.b=g,this.a=new n.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=b;let m=class{constructor(o,l){this.i=o,this.j=l,this.a=new n.Emitter,this.onTunnelOpened=this.a.event,this.b=new n.Emitter,this.onTunnelClosed=this.b.event,this.c=new n.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const o=this.j.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.e=o,o?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.f=o.elevation,this.g=o.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const o=[],l=Array.from(this.d.values());for(const g of l){const E=Array.from(g.values());for(const A of E){const v=await A.value;v&&o.push(v)}}return o}async dispose(){for(const o of this.d.values()){for(const{value:l}of o.values())await l.then(g=>g?.dispose());o.clear()}this.d.clear()}setEnvironmentTunnel(o,l,g,E,A){this.o(o,l,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:l,localAddress:g,privacy:E,protocol:A,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,l){(w(o)||N(o))&&(o=e.LOCALHOST_ADDRESSES[0]);const g=this.q(o,l);if(g)return++g.refcount,g.value}openTunnel(o,l,g,E,A,v=!1,t,h){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${g} on local port ${A}.`),!o)return;if(l||(l="localhost"),E||(E=this.k),this.e&&this.h.has(g)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(o,l,g,E,A,v,t,h);return r?r.then(u=>{if(!u){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(l,g);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.m(u);return(u.tunnelRemoteHost!==l||u.tunnelRemotePort!==g)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(i),i}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const l=this.d.get(o.tunnelRemoteHost);if(l){const g=l.get(o.tunnelRemotePort);g&&(g.refcount--,await this.n(o.tunnelRemoteHost,o.tunnelRemotePort,g))}}}}async n(o,l,g){if(g.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${l}.`);const E=g.value.then(async A=>{A&&(await A.dispose(!0),this.b.fire({host:A.tunnelRemoteHost,port:A.tunnelRemotePort}))});return this.d.has(o)&&this.d.get(o).delete(l),E}}async closeTunnel(o,l){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${l} `);const g=this.d.get(o);if(g&&g.has(l)){const E=g.get(l);E.refcount=0,await this.n(o,l,E)}}o(o,l,g){this.d.has(o)||this.d.set(o,new Map),this.d.get(o).set(l,{refcount:1,value:g})}async p(o,l){const g=this.d.get(o);g&&(await g.get(l)||g.delete(l),g.size===0&&this.d.delete(o))}q(o,l){const g=[o];N(o)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):w(o)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const E=g.map(A=>this.d.get(A));for(const A of E){const v=A?.get(l);if(v)return v}}canTunnel(o){return!!k(o)}s(o,l,g,E,A,v,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${g} on local port ${E}.`);const h=g;this.h.add(h);const r=E===void 0?g:E,u={elevationRequired:A?this.isPortPrivileged(r):!1},i={remoteAddress:{host:l,port:g},localAddressPort:E,privacy:v,public:v?v!==R.Private:void 0,protocol:t},p=o.forwardPort(i,u);return p?(this.o(l,g,p),p.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(h)})):this.h.delete(h),p}};m=qe([je(0,M.ILogService),je(1,C.IConfigurationService)],m),e.AbstractTunnelService=m}),define(Ce[174],ke([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,n.createDecorator)("editSessionIdentityService");var C;(function(D){D[D.Complete=100]="Complete",D[D.Partial=50]="Partial",D[D.None=0]="None"})(C=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Ce[175],ke([1,0,16]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function C(y){return y.scheme!==n.Schemas.file&&y.scheme!==n.Schemas.vscodeRemote}e.isVirtualResource=C;function D(y){if(y.folders.length)return y.folders.every(k=>C(k.uri))?y.folders[0].uri:void 0;if(y.configuration&&C(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=D;function M(y){return D(y)?.scheme}e.getVirtualWorkspaceScheme=M;function S(y){return D(y)?.authority}e.getVirtualWorkspaceAuthority=S;function R(y){return D(y)!==void 0}e.isVirtualWorkspace=R}),define(Ce[53],ke([1,0,138,19,48,24,2,3,16]),function(te,e,n,C,D,M,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function k(r){const u=r;return typeof u?.id=="string"&&S.URI.isUri(u.uri)}e.isSingleFolderWorkspaceIdentifier=k;function N(r){return typeof r?.id=="string"&&!k(r)&&!f(r)}e.isEmptyWorkspaceIdentifier=N,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(r,u){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,C.basename)(r)}:u?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const i=r;return i.configuration?{id:i.id,configPath:i.configuration}:i.folders.length===1?{id:i.id,uri:i.folders[0].uri}:{id:i.id}}e.toWorkspaceIdentifier=w;function f(r){const u=r;return typeof u?.id=="string"&&S.URI.isUri(u.configPath)}e.isWorkspaceIdentifier=f;function b(r){const u=r;if(u?.uri)return{id:u.id,uri:S.URI.revive(u.uri)};const i=r;if(i?.configPath)return{id:i.id,configPath:S.URI.revive(i.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=b;var m;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(m=e.WorkbenchState||(e.WorkbenchState={}));function a(r){const u=r;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}e.isWorkspace=a;function o(r){const u=r;return!!(u&&typeof u=="object"&&S.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}e.isWorkspaceFolder=o;class l{constructor(u,i,p,c,s){this.h=u,this.j=p,this.k=c,this.l=s,this.c=D.TernarySearchTree.forUris(this.l,()=>!0),this.folders=i}update(u){this.h=u.id,this.k=u.configuration,this.j=u.transient,this.l=u.l,this.folders=u.folders}get folders(){return this.g}set folders(u){this.g=u,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(u){this.k=u}getFolder(u){return u&&this.c.findSubstr(u)||null}n(){this.c=D.TernarySearchTree.forUris(this.l,()=>!0);for(const u of this.folders)this.c.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class g{constructor(u,i){this.raw=i,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,M.joinPath)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function E(r){return new g({uri:r,index:0,name:(0,M.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=E,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,n.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function A(r,u){return M.extUriBiasedIgnorePathCase.isEqualOrParent(r,u.untitledWorkspacesHome)}e.isUntitledWorkspace=A;function v(r){let u;return S.URI.isUri(r)?u=r:u=r.configuration,u?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=v;function t(r,u){return!A(r,u)&&!v(r)}e.isSavedWorkspace=t;function h(r){return(typeof r=="string"?(0,C.extname)(r):(0,M.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=h}),define(Ce[54],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class n{constructor(D){this.d=D,this.b=new Map,this.c=1}add(D){const M=this.c++;return this.b.set(M,D),this.e(),M}get(D,M){return this.b.has(D)?this.b.get(D)[M]:void 0}delete(D){this.b.delete(D),this.e()}e(){!n.a||console.log(`${this.d} cache size - ${this.b.size}`)}}n.a=!1,e.Cache=n}),define(Ce[36],ke([1,0,16,24,3]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class M{constructor(){this.a=new Set(Object.keys(n.Schemas)),this.b=new Map,this.extUri=new C.ExtUri(R=>{const y=this.b.get(R.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(R,y){y===null?this.b.delete(R.scheme):this.b.set(R.scheme,y)}isFreeScheme(R){return!this.b.has(R)&&!this.a.has(R)}getCapabilities(R){return this.b.get(R)}}e.ExtHostFileSystemInfo=M,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(Ce[26],ke([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,n.createDecorator)("IExtHostInitDataService")}),define(Ce[176],ke([1,0,11,162,26]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let M=class extends C.LogService{constructor(R,y){super(R.createLogger(y.logFile,{name:y.logName}))}};M=qe([je(0,n.ILoggerService),je(1,D.IExtHostInitDataService)],M),e.ExtHostLogService=M}),define(Ce[177],ke([1,0,17]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class C{constructor(S,R,y){this.h=new Map,this.a=S,this.b=R,this.c=y,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new n.RunOnceScheduler(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const N of k.values())N.complete()}catch(N){for(const w of k.values())w.error(N)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,S])=>S!==void 0).map(([S])=>S)}get whenReady(){return this.d}get(S,R){let y=this.f[S];return typeof y>"u"&&(y=R),y}update(S,R){this.f[S]=R;const y=this.h.get(S);if(y!==void 0)return y.p;const k=new n.DeferredPromise;return this.h.set(S,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.ExtensionMemento=C;class D extends C{setKeysForSync(S){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},S)}constructor(S,R){super(S.identifier.value,!0,R),this.j=S}}e.ExtensionGlobalMemento=D}),define(Ce[178],ke([1,0,4,2]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class D{constructor(S){this.c=S,this.a=new n.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new n.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(S,R,y,k){const w=this.c.getNotebookDocument(C.URI.revive(S)).acceptModelChanged(R.value,y,k);this.b.fire(w)}$acceptDirtyStateChanged(S,R){this.c.getNotebookDocument(C.URI.revive(S)).acceptDirty(R)}$acceptModelSaved(S){const R=this.c.getNotebookDocument(C.URI.revive(S));this.a.fire(R.apiNotebook)}}e.ExtHostNotebookDocuments=D}),define(Ce[18],ke([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,n.createDecorator)("IExtHostRpcService");class C{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.ExtHostRpcService=C});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[179],ke([1,0,25,4]),function(te,e,n,C){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class M{constructor(R,y){D.set(this,void 0),this.b=new C.Emitter,this.onDidChange=this.b.event,this.a=n.ExtensionIdentifier.toKey(R.identifier),Je(this,D,y,"f"),Le(this,D,"f").onDidChangePassword(k=>{k.extensionId===this.a&&this.b.fire({key:k.key})})}get(R){return Le(this,D,"f").get(this.a,R)}store(R,y){return Le(this,D,"f").store(this.a,R,y)}delete(R){return Le(this,D,"f").delete(this.a,R)}}e.ExtensionSecrets=M,D=new WeakMap}),define(Ce[69],ke([1,0,3,173,4,18]),function(te,e,n,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var S;(function(y){function k(w){return{remoteAddress:w.remoteAddress,localAddress:w.localAddress,public:!!w.public,privacy:w.privacy??(w.public?C.TunnelPrivacyId.Public:C.TunnelPrivacyId.Private),protocol:w.protocol}}y.fromApiTunnel=k;function N(w){return{remoteAddress:{host:w.tunnelRemoteHost,port:w.tunnelRemotePort},localAddress:w.localAddress,public:w.privacy!==C.TunnelPrivacyId.ConstantPrivate&&w.privacy!==C.TunnelPrivacyId.ConstantPrivate,privacy:w.privacy,protocol:w.protocol}}y.fromServiceTunnel=N})(S=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,n.createDecorator)("IExtHostTunnelService");let R=class{constructor(k){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,N){}async getTunnels(){return[]}async setTunnelFactory(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,N){return{dispose:()=>{}}}async $providePortAttributes(k,N,w,f,b){return[]}async $forwardPort(k,N){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};R=qe([je(0,M.IExtHostRpcService)],R),e.ExtHostTunnelService=R}),define(Ce[55],ke([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,n.createDecorator)("IURITransformerService");class C{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=S=>S,this.transformOutgoing=S=>S,this.transformOutgoingURI=S=>S,this.transformOutgoingScheme=S=>S)}}e.URITransformerService=C}),define(Ce[180],ke([1,0,23]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class C{constructor(){this.buffers=[]}add(y){let k=this.buffers.indexOf(y);return k<0&&(k=this.buffers.length,this.buffers.push(y)),k}}function D(R,y){if(y.serializeBuffersForPostMessage){const k=new C,N=(b,m)=>{if(m instanceof ArrayBuffer){const a=k.add(m);return{$$vscode_array_buffer_reference$$:!0,index:a}}else if(ArrayBuffer.isView(m)){const a=M(m);if(a){const o=k.add(m.buffer);return{$$vscode_array_buffer_reference$$:!0,index:o,view:{type:a,byteLength:m.byteLength,byteOffset:m.byteOffset}}}}return m},w=JSON.stringify(R,N),f=k.buffers.map(b=>{const m=new Uint8Array(b);return n.VSBuffer.wrap(m)});return{message:w,buffers:f}}else return{message:JSON.stringify(R),buffers:[]}}e.serializeWebviewMessage=D;function M(R){switch(R.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function S(R,y){const k=y.map(f=>{const b=new ArrayBuffer(f.byteLength);return new Uint8Array(b).set(f.buffer),b}),N=y.length?(f,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const m=b,{index:a}=m,o=k[a];if(m.view)switch(m.view.type){case 1:return new Int8Array(o,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return b}:void 0;return{message:JSON.parse(R,N),arrayBuffers:k}}e.deserializeWebviewMessage=S}),define(Ce[95],ke([1,0,147,9,2,6,3,30,43,16,39,124,29]),function(te,e,n,C,D,M,S,R,y,k,N,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,n.localize)(0,null),providerDisplayName:(0,n.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var b;(function(Z){Z[Z.PROGRAMMATIC=1]="PROGRAMMATIC",Z[Z.USER=2]="USER",Z[Z.EDIT=3]="EDIT",Z[Z.NAVIGATION=4]="NAVIGATION",Z[Z.JUMP=5]="JUMP"})(b=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var m;(function(Z){Z[Z.IDENTICAL=1]="IDENTICAL",Z[Z.SIMILAR=2]="SIMILAR",Z[Z.DIFFERENT=3]="DIFFERENT"})(m=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function a(Z){const X=Z;return!!X&&typeof X.getSelection=="function"&&!!X.onDidChangeSelection}e.isEditorPaneWithSelection=a;function o(Z,X,ee){for(const he of ee.visibleEditorPanes)if(he.group.id===X&&Z.matches(he.input))return he.getViewState()}e.findViewStateForEditor=o;function l(Z){if(s(Z))return!1;const X=Z;return D.URI.isUri(X?.resource)}e.isResourceEditorInput=l;function g(Z){if(s(Z))return!1;const X=Z;return X?.original!==void 0&&X.modified!==void 0}e.isResourceDiffEditorInput=g;function E(Z){if(s(Z)||g(Z))return!1;const X=Z;return X?.primary!==void 0&&X.secondary!==void 0}e.isResourceSideBySideEditorInput=E;function A(Z){if(s(Z))return!1;const X=Z;return X?X.resource===void 0||X.resource.scheme===k.Schemas.untitled||X.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=A;const v=/Untitled-\d+/;function t(Z){return Z.scheme===k.Schemas.untitled&&Z.path.length>1&&!v.test(Z.path)}e.isUntitledWithAssociatedResource=t;function h(Z){if(s(Z))return!1;const X=Z;return D.URI.isUri(X?.base?.resource)&&D.URI.isUri(X?.input1?.resource)&&D.URI.isUri(X?.input2?.resource)&&D.URI.isUri(X?.result?.resource)}e.isResourceMergeEditorInput=h;var r;(function(Z){Z[Z.SHORT=0]="SHORT",Z[Z.MEDIUM=1]="MEDIUM",Z[Z.LONG=2]="LONG"})(r=e.Verbosity||(e.Verbosity={}));var u;(function(Z){Z[Z.EXPLICIT=1]="EXPLICIT",Z[Z.AUTO=2]="AUTO",Z[Z.FOCUS_CHANGE=3]="FOCUS_CHANGE",Z[Z.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u=e.SaveReason||(e.SaveReason={}));class i{constructor(){this.a=new Map}registerSource(X,ee){let he=this.a.get(X);return he||(he={source:X,label:ee},this.a.set(X,he)),he.source}getSourceLabel(X){return this.a.get(X)?.label??X}}e.SaveSourceRegistry=new i;var p;(function(Z){Z[Z.None=0]="None",Z[Z.Readonly=2]="Readonly",Z[Z.Untitled=4]="Untitled",Z[Z.Singleton=8]="Singleton",Z[Z.RequiresTrust=16]="RequiresTrust",Z[Z.CanSplitInGroup=32]="CanSplitInGroup",Z[Z.ForceDescription=64]="ForceDescription",Z[Z.CanDropIntoEditor=128]="CanDropIntoEditor",Z[Z.MultipleEditors=256]="MultipleEditors"})(p=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class c extends M.Disposable{}e.AbstractEditorInput=c;function s(Z){return Z instanceof c}e.isEditorInput=s;function d(Z){const X=Z;return D.URI.isUri(X?.preferredResource)}function T(Z){const X=Z;return s(X?.primary)&&s(X?.secondary)}e.isSideBySideEditorInput=T;function O(Z){const X=Z;return s(X?.modified)&&s(X?.original)}e.isDiffEditorInput=O;function H(Z,X,ee,he,Te){return se(he,[(0,w.toAction)({id:"workbench.action.openLargeFile",label:(0,n.localize)(2,null),run:()=>{const Ne={...ee,limits:{size:Number.MAX_VALUE}};Z.openEditor(X,Ne)}}),(0,w.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,n.localize)(3,null),run:()=>Te.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:f.default.Warning})}e.createTooLargeFileError=H;function J(Z){return s(Z?.editor)}e.isEditorInputWithOptions=J;function K(Z){const X=Z;return J(Z)&&X?.group!==void 0}e.isEditorInputWithOptionsAndGroup=K;function L(Z){const X=Z;return typeof X?.groupId=="number"&&s(X.editor)}e.isEditorIdentifier=L;var B;(function(Z){Z[Z.UNKNOWN=0]="UNKNOWN",Z[Z.REPLACE=1]="REPLACE",Z[Z.MOVE=2]="MOVE",Z[Z.UNPIN=3]="UNPIN"})(B=e.EditorCloseContext||(e.EditorCloseContext={}));var P;(function(Z){Z[Z.GROUP_ACTIVE=0]="GROUP_ACTIVE",Z[Z.GROUP_INDEX=1]="GROUP_INDEX",Z[Z.GROUP_LOCKED=2]="GROUP_LOCKED",Z[Z.EDITOR_OPEN=3]="EDITOR_OPEN",Z[Z.EDITOR_CLOSE=4]="EDITOR_CLOSE",Z[Z.EDITOR_MOVE=5]="EDITOR_MOVE",Z[Z.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",Z[Z.EDITOR_LABEL=7]="EDITOR_LABEL",Z[Z.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",Z[Z.EDITOR_PIN=9]="EDITOR_PIN",Z[Z.EDITOR_STICKY=10]="EDITOR_STICKY",Z[Z.EDITOR_DIRTY=11]="EDITOR_DIRTY",Z[Z.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(P=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var F;(function(Z){Z[Z.PRIMARY=1]="PRIMARY",Z[Z.SECONDARY=2]="SECONDARY",Z[Z.BOTH=3]="BOTH",Z[Z.ANY=4]="ANY"})(F=e.SideBySideEditor||(e.SideBySideEditor={}));class V{getOriginalUri(X,ee){if(!X)return;if(h(X))return e.EditorResourceAccessor.getOriginalUri(X.result,ee);if(ee?.supportSideBySide){const{primary:Te,secondary:Ne}=this.a(X);if(Te&&Ne){if(ee?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(Te,{filterByScheme:ee.filterByScheme}),secondary:this.getOriginalUri(Ne,{filterByScheme:ee.filterByScheme})};if(ee?.supportSideBySide===F.ANY)return this.getOriginalUri(Te,{filterByScheme:ee.filterByScheme})??this.getOriginalUri(Ne,{filterByScheme:ee.filterByScheme});X=ee.supportSideBySide===F.PRIMARY?Te:Ne}}if(g(X)||E(X)||h(X))return;const he=d(X)?X.preferredResource:X.resource;return!he||!ee||!ee.filterByScheme?he:this.b(he,ee.filterByScheme)}a(X){return T(X)||E(X)?{primary:X.primary,secondary:X.secondary}:O(X)||g(X)?{primary:X.modified,secondary:X.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(X,ee){if(!X)return;if(h(X))return e.EditorResourceAccessor.getCanonicalUri(X.result,ee);if(ee?.supportSideBySide){const{primary:Te,secondary:Ne}=this.a(X);if(Te&&Ne){if(ee?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(Te,{filterByScheme:ee.filterByScheme}),secondary:this.getCanonicalUri(Ne,{filterByScheme:ee.filterByScheme})};if(ee?.supportSideBySide===F.ANY)return this.getCanonicalUri(Te,{filterByScheme:ee.filterByScheme})??this.getCanonicalUri(Ne,{filterByScheme:ee.filterByScheme});X=ee.supportSideBySide===F.PRIMARY?Te:Ne}}if(g(X)||E(X)||h(X))return;const he=X.resource;return!he||!ee||!ee.filterByScheme?he:this.b(he,ee.filterByScheme)}b(X,ee){if(Array.isArray(ee)){if(ee.some(he=>X.scheme===he))return X}else if(ee===X.scheme)return X}}e.EditorResourceAccessor=new V;var j;(function(Z){Z[Z.LEFT=0]="LEFT",Z[Z.RIGHT=1]="RIGHT"})(j=e.CloseDirection||(e.CloseDirection={}));class le{constructor(){this.c=new Map,this.d=new Map}start(X){const ee=this.a=X.get(S.IInstantiationService);for(const[he,Te]of this.c)this.e(he,Te,ee);this.c.clear()}e(X,ee,he){const Te=he.createInstance(ee);this.d.set(X,Te)}registerFileEditorFactory(X){if(this.b)throw new Error("Can only register one file editor factory.");this.b=X}getFileEditorFactory(){return(0,C.assertIsDefined)(this.b)}registerEditorSerializer(X,ee){if(this.c.has(X)||this.d.has(X))throw new Error(`A editor serializer with type ID '${X}' was already registered.`);return this.a?this.e(X,ee,this.a):this.c.set(X,ee),(0,M.toDisposable)(()=>{this.c.delete(X),this.d.delete(X)})}getEditorSerializer(X){return this.d.get(typeof X=="string"?X:X.typeId)}}R.Registry.add(e.EditorExtensions.EditorFactory,new le);async function _(Z,X,ee){return!Z||!Z.length?[]:await Promise.all(Z.map(async he=>{const Te=D.URI.revive(he.fileUri);if(!Te){ee.info("Cannot resolve the path because it is not valid.",he);return}if(!await X.canHandleResource(Te)){ee.info("Cannot resolve the path because it cannot be handled",he);return}let Ke=he.exists,Pe=he.type;if(typeof Ke!="boolean"||typeof Pe!="number")try{Pe=(await X.stat(Te)).isDirectory?y.FileType.Directory:y.FileType.Unknown,Ke=!0}catch(Ie){ee.error(Ie),Ke=!1}if(!Ke&&he.openOnlyIfExists){ee.info("Cannot resolve the path because it does not exist",he);return}if(Pe===y.FileType.Directory){ee.info("Cannot resolve the path because it is a directory",he);return}const Se={...he.options,pinned:!0};return Ke?{resource:Te,options:Se}:{resource:Te,options:Se,forceUntitled:!0}}))}e.pathsToEditors=_;var be;(function(Z){Z[Z.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Z[Z.SEQUENTIAL=1]="SEQUENTIAL"})(be=e.EditorsOrder||(e.EditorsOrder={}));function de(Z){const X=Z;if(!X)return!1;const ee=X;if(ee.modified)return de(ee.modified);const he=X;return!!(he.contributionsState&&he.viewState&&Array.isArray(he.cursorState))}e.isTextEditorViewState=de;function ue(Z){return(0,N.isErrorWithActions)(Z)}e.isEditorOpenError=ue;function se(Z,X,ee){const he=(0,N.createErrorWithActions)(Z,X);return he.forceMessage=ee?.forceMessage,he.forceSeverity=ee?.forceSeverity,he.allowDialog=ee?.allowDialog,he}e.createEditorOpenError=se}),define(Ce[181],ke([1,0,4,148,3,6,28,30,15,62,22,84,172]),function(te,e,n,C,D,M,S,R,y,k,N,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",w.Codicon.window,(0,C.localize)(0,null));var b;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(b=e.Extensions||(e.Extensions={}));var m;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(m=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function a(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=a;class o extends M.Disposable{constructor(){super(...arguments),this.c=this.B(new n.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new n.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,y.flatten)([...this.g.values()])}registerViewContainer(u,i,p){const c=this.get(u.id);if(c)return c;const s=u;return s.openCommandActionDescriptor=p?.doNotRegisterOpenCommand?void 0:s.openCommandActionDescriptor??{id:s.id},(0,S.getOrSet)(this.g,i,[]).push(s),p?.isDefault&&this.h.push(s),this.c.fire({viewContainer:s,viewContainerLocation:i}),s}deregisterViewContainer(u){for(const i of this.g.keys()){const p=this.g.get(i),c=p?.indexOf(u);if(c!==-1){p?.splice(c,1),p.length===0&&this.g.delete(i),this.f.fire({viewContainer:u,viewContainerLocation:i});return}}}get(u){return this.all.filter(i=>i.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(i=>this.getViewContainers(i).filter(p=>p?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(i=>this.getViewContainerLocation(i)===u)}}R.Registry.add(b.ViewContainersRegistry,new o);var l;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(l=e.ViewContentGroups||(e.ViewContentGroups={}));function g(r,u){const i=r.group??l.More,p=u.group??l.More;return i!==p?i.localeCompare(p):(r.order??5)-(u.order??5)}class E extends M.Disposable{constructor(){super(...arguments),this.c=this.B(new n.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new n.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new n.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new n.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new k.SetMap}registerViews(u,i){this.registerViews2([{views:u,viewContainer:i}])}registerViews2(u){u.forEach(({views:i,viewContainer:p})=>this.l(i,p)),this.c.fire(u)}deregisterViews(u,i){const p=this.m(u,i);p.length&&this.f.fire({views:p,viewContainer:i})}moveViews(u,i){for(const p of this.j.keys())if(p!==i){const c=this.m(u,p);c.length&&(this.l(c,i),this.g.fire({views:c,from:p,to:i}))}}getViews(u){return this.j.get(u)||[]}getView(u){for(const i of this.i){const p=(this.j.get(i)||[]).filter(c=>c.id===u)[0];if(p)return p}return null}getViewContainer(u){for(const i of this.i)if((this.j.get(i)||[]).filter(c=>c.id===u)[0])return i;return null}registerViewWelcomeContent(u,i){return this.k.add(u,i),this.h.fire(u),(0,M.toDisposable)(()=>{this.k.delete(u,i),this.h.fire(u)})}registerViewWelcomeContent2(u,i){const p=new Map;for(const[c,s]of i)this.k.add(u,s),p.set(c,(0,M.toDisposable)(()=>{this.k.delete(u,s),this.h.fire(u)}));return this.h.fire(u),p}getViewWelcomeContent(u){const i=[];return this.k.forEach(u,p=>i.push(p)),i.sort(g)}l(u,i){let p=this.j.get(i);p||(p=[],this.j.set(i,p),this.i.push(i));for(const c of u){if(this.getView(c.id)!==null)throw new Error((0,C.localize)(1,null,c.id));p.push(c)}}m(u,i){const p=this.j.get(i);if(!p)return[];const c=[],s=[];for(const d of p)u.includes(d)?c.push(d):s.push(d);return c.length&&(s.length?this.j.set(i,s):(this.j.delete(i),this.i.splice(this.i.indexOf(i),1))),c}}R.Registry.add(b.ViewsRegistry,new E),e.IViewsService=(0,D.createDecorator)("viewsService"),e.IViewDescriptorService=(0,D.createDecorator)("viewDescriptorService");var A;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(A=e.ViewVisibilityState||(e.ViewVisibilityState={}));var v;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(v=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class t{constructor(u,i){this.c=!1,this.d=!1,(0,N.mixin)(this,u),this.d=!!i,this.resolve=async p=>{if(i&&!this.c){const c=await i(p);c&&(this.tooltip=this.tooltip??c.tooltip,this.command=this.command??c.command)}p.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=t;class h extends Error{constructor(u){super((0,C.localize)(2,null,u))}}e.NoTreeViewError=h}),define(Ce[182],ke([1,0,4,17,149]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new n.Emitter,this.n=new n.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(R){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=R}onEvent(R){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=R}onRequest(R){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=R}sendResponse(R){R.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${R.command}`)):this.s("response",R)}sendRequest(R,y,k,N){const w={command:R};if(y&&Object.keys(y).length>0&&(w.arguments=y),this.s("request",w),typeof N=="number"){const f=setTimeout(()=>{clearTimeout(f);const b=this.f.get(w.seq);if(b){this.f.delete(w.seq);const m={type:"response",seq:0,request_seq:w.seq,success:!1,command:R,message:(0,D.localize)(0,null,N,R)};b(m)}},N)}return k&&this.f.set(w.seq,k),w.seq}acceptMessage(R){this.j?this.j(R):(this.k.push(R),this.k.length===1&&this.q())}o(R,y){return R.type!=="event"||y.type!=="event"}async q(){let R;for(;this.k.length;){if((!R||this.o(this.k[0],R))&&await(0,C.timeout)(0),R=this.k.shift(),!R)return;switch(R.type){case"event":this.i?.(R);break;case"request":this.g?.(R);break;case"response":{const y=R,k=this.f.get(y.request_seq);k&&(this.f.delete(y.request_seq),k(y));break}}}}s(R,y){y.type=R,y.seq=this.d++,this.sendMessage(y)}async u(){if(this.f.size===0)return Promise.resolve();const R=new Map;this.f.forEach((y,k)=>R.set(k,y)),await(0,C.timeout)(500),R.forEach((y,k)=>{y({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=M}),define(Ce[183],ke([1,0,150,42,3]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new C.RawContextKey("debugType",void 0,{type:"string",description:n.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new C.RawContextKey("debugConfigurationType",void 0,{type:"string",description:n.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new C.RawContextKey("debugState","inactive",{type:"string",description:n.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new C.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:n.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new C.RawContextKey("hasDebugged",!1,{type:"boolean",description:n.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new C.RawContextKey("inDebugMode",!1,{type:"boolean",description:n.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new C.RawContextKey("inDebugRepl",!1,{type:"boolean",description:n.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new C.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:n.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new C.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:n.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new C.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:n.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new C.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:n.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new C.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:n.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new C.RawContextKey("variablesFocused",!0,{type:"boolean",description:n.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new C.RawContextKey("expressionSelected",!1,{type:"boolean",description:n.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new C.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:n.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new C.RawContextKey("callStackItemType",void 0,{type:"string",description:n.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new C.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:n.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new C.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:n.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new C.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:n.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new C.RawContextKey("watchItemType",void 0,{type:"string",description:n.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new C.RawContextKey("canViewMemory",void 0,{type:"boolean",description:n.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new C.RawContextKey("breakpointItemType",void 0,{type:"string",description:n.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new C.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:n.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new C.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:n.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new C.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:n.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new C.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:n.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new C.RawContextKey("stepBackSupported",!1,{type:"boolean",description:n.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new C.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:n.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new C.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:n.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new C.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:n.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new C.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:n.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new C.RawContextKey("breakpointsExist",!1,{type:"boolean",description:n.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new C.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:n.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new C.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:n.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new C.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:n.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new C.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:n.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new C.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:n.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new C.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:n.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new C.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:n.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new C.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:n.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new C.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:n.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new C.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:n.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new C.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:n.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new C.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:n.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new C.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:n.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new C.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:n.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new C.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:n.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new C.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:n.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new C.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:n.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new C.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:n.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new C.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:n.localize(50,null)});const M=f=>n.localize(51,null,f);e.debuggerDisabledMessage=M,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:n.localize(52,null)};var S;(function(f){f[f.Inactive=0]="Inactive",f[f.Initializing=1]="Initializing",f[f.Stopped=2]="Stopped",f[f.Running=3]="Running"})(S=e.State||(e.State={}));function R(f){switch(f){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=R;var y;(function(f){f[f.Valid=0]="Valid",f[f.Unreadable=1]="Unreadable",f[f.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var k;(function(f){f[f.Initial=1]="Initial",f[f.Dynamic=2]="Dynamic"})(k=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var N;(function(f){f.UnverifiedBreakpoints="unverifiedBreakpoints"})(N=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,D.createDecorator)("debugService");var w;(function(f){f[f.CONDITION=0]="CONDITION",f[f.HIT_COUNT=1]="HIT_COUNT",f[f.LOG_MESSAGE=2]="LOG_MESSAGE"})(w=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ce[184],ke([1,0,10,2,19,22,16,44,20,15]),function(te,e,n,C,D,M,S,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const N=/{([^}]+)}/g;function w(c,s,d){return c.replace(N,function(T,O){return s&&O.length>0&&O[0]!=="_"?T:d&&d.hasOwnProperty(O)?d[O]:T})}e.formatPII=w;function f(c){const s={};for(const d of Object.keys(c))d.startsWith("!")||(s[d]=c[d]);return s}e.filterExceptionsFromTelemetry=f;function b(c){return c.configuration.request==="attach"&&!m(c)&&(!c.parentSession||b(c.parentSession))}e.isSessionAttach=b;function m(c){let s=c.configuration.type;if(!!s)return s==="vslsShare"&&(s=c.configuration.adapterProxy.configuration.type),(0,n.equalsIgnoreCase)(s,"extensionhost")||(0,n.equalsIgnoreCase)(s,"pwa-extensionhost")?c:c.parentSession?m(c.parentSession):void 0}e.getExtensionHostDebugSession=m;function a(c){return c.type&&(c.label||c.program||c.runtime)}e.isDebuggerMainContribution=a;function o(c,s,d){let T,O=0;const H=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let J=null;for(;J=H.exec(c);){const K=J.index+1,L=K+J[0].length;if(K<=s&&L>=d){T=J[0],O=K;break}}if(T){const K=/\w+/g;let L=null;for(;(L=K.exec(T))&&!(L.index+1+O+L[0].length>=d););L&&(T=T.substring(0,K.lastIndex))}return T?{start:O,end:O+T.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=o;async function l(c,s,d,T){if(c.evaluatableExpressionProvider.has(s)){const O=c.evaluatableExpressionProvider.ordered(s),H=(0,k.coalesce)(await Promise.all(O.map(async J=>{try{return await J.provideEvaluatableExpression(s,d,T??y.CancellationToken.None)}catch{return}})));if(H.length>0){let J=H[0].expression;const K=H[0].range;return J||(J=s.getLineContent(d.lineNumber).substring(K.startColumn-1,K.endColumn-1)),{range:K,matchingExpression:J}}}else{const O=s.getLineContent(d.lineNumber),{start:H,end:J}=o(O,d.column,d.column),K=O.substring(H-1,J);return{matchingExpression:K,range:new R.Range(d.lineNumber,H,d.lineNumber,H+K.length)}}return null}e.getEvaluatableExpressionAtPosition=l;const g=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function E(c){return!!(c&&c.match(g))}e.isUri=E;function A(c){if(typeof c.path=="string"&&!(typeof c.sourceReference=="number"&&c.sourceReference>0)){if(E(c.path))return C.URI.parse(c.path);if((0,D.isAbsolute)(c.path))return C.URI.file(c.path)}return c.path}function v(c){if(typeof c.path=="object"){const s=C.URI.revive(c.path);if(s)return s.scheme===S.Schemas.file?s.fsPath:s.toString()}return c.path}function t(c,s){const d=s?A:v,T=(0,M.deepClone)(c);return r(T,(O,H)=>{O&&H&&(H.path=d(H))}),T}e.convertToDAPaths=t;function h(c,s){const d=s?A:v,T=(0,M.deepClone)(c);return r(T,(O,H)=>{!O&&H&&(H.path=d(H))}),T}e.convertToVSCPaths=h;function r(c,s){switch(c.type){case"event":{const d=c;switch(d.event){case"output":s(!1,d.body.source);break;case"loadedSource":s(!1,d.body.source);break;case"breakpoint":s(!1,d.body.breakpoint.source);break;default:break}break}case"request":{const d=c;switch(d.command){case"setBreakpoints":s(!0,d.arguments.source);break;case"breakpointLocations":s(!0,d.arguments.source);break;case"source":s(!0,d.arguments.source);break;case"gotoTargets":s(!0,d.arguments.source);break;case"launchVSCode":d.arguments.args.forEach(T=>s(!1,T));break;default:break}break}case"response":{const d=c;if(d.success&&d.body)switch(d.command){case"stackTrace":d.body.stackFrames.forEach(T=>s(!1,T.source));break;case"loadedSources":d.body.sources.forEach(T=>s(!1,T));break;case"scopes":d.body.scopes.forEach(T=>s(!1,T.source));break;case"setFunctionBreakpoints":d.body.breakpoints.forEach(T=>s(!1,T.source));break;case"setBreakpoints":d.body.breakpoints.forEach(T=>s(!1,T.source));break;case"disassemble":d.body?.instructions.forEach(O=>s(!1,O.location));break;default:break}break}}}function u(c){return c.filter(s=>!s.presentation?.hidden).sort((s,d)=>s.presentation?d.presentation?s.presentation.group?d.presentation.group?s.presentation.group!==d.presentation.group?s.presentation.group.localeCompare(d.presentation.group):i(s.presentation.order,d.presentation.order):-1:d.presentation.group?1:i(s.presentation.order,d.presentation.order):-1:d.presentation?1:0)}e.getVisibleAndSorted=u;function i(c,s){return typeof c!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:c-s}async function p(c,s){const d=c.getValue("debug.saveBeforeStart",{overrideIdentifier:s.activeTextEditorLanguageId});if(d!=="none"&&(await s.saveAll(),d==="allEditorsInActiveGroup")){const T=s.activeEditorPane;T&&T.input.resource?.scheme===S.Schemas.untitled&&await s.save({editor:T.input,groupId:T.group.id})}await c.reloadConfiguration()}e.saveAllBeforeDebugStart=p}),define(Ce[70],ke([1,0,23,35,185,64,16,19,21,42]),function(te,e,n,C,D,M,S,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var N;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(N=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var w;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(w=e.NotebookRunState||(e.NotebookRunState={}));var f;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(f=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var b;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(b=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var a;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(a=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var l;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(l=e.CellEditType||(e.CellEditType={}));var g;(function(F){F.scheme=S.Schemas.vscodeNotebookCell;const V=["W","X","Y","Z","a","b","c","d","e","f"],j=new RegExp(`^[${V.join("")}]+`),le=7;function _(X,ee){const he=ee.toString(le),Ne=`${he.length<V.length?V[he.length-1]:"z"}${he}s${(0,n.encodeBase64)(n.VSBuffer.fromString(X.scheme),!0,!0)}`;return X.with({scheme:F.scheme,fragment:Ne})}F.generate=_;function be(X){if(X.scheme!==F.scheme)return;const ee=X.fragment.indexOf("s");if(ee<0)return;const he=parseInt(X.fragment.substring(0,ee).replace(j,""),le),Te=(0,n.decodeBase64)(X.fragment.substring(ee+1)).toString();if(!isNaN(he))return{handle:he,notebook:X.with({scheme:Te,fragment:null})}}F.parse=be;function de(X,ee){return X.with({scheme:S.Schemas.vscodeNotebookCellOutput,fragment:`op${ee??""},${X.scheme!==S.Schemas.file?X.scheme:""}`})}F.generateCellOutputUri=de;function ue(X){if(X.scheme!==S.Schemas.vscodeNotebookCellOutput)return;const ee=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(X.fragment);if(!ee)return;const he=ee[1]&&ee[1]!==""?ee[1]:void 0,Te=ee[2];return{outputId:he,notebook:X.with({scheme:Te||S.Schemas.file,fragment:null})}}F.parseCellOutputUri=ue;function se(X,ee,he){return F.generate(X,ee).with({scheme:he})}F.generateCellPropertyUri=se;function Z(X,ee){if(X.scheme===ee)return F.parse(X.with({scheme:F.scheme}))}F.parseCellPropertyUri=Z})(g=e.CellUri||(e.CellUri={}));const E=F=>y.isWindows?F.replace(/\//g,"\\"):F;class A{constructor(V=[],j=e.NOTEBOOK_DISPLAY_ORDER){this.e=j,this.d=[...new Set(V)].map(le=>({pattern:le,matches:C.parse(E(le))}))}sort(V){const j=new Map(D.Iterable.map(V,_=>[_,E(_)]));let le=[];for(const{matches:_}of this.d)for(const[be,de]of j)if(_(de)){le.push(be),j.delete(be);break}return j.size&&(le=le.concat([...j.keys()].sort((_,be)=>this.e.indexOf(_)-this.e.indexOf(be)))),le}prioritize(V,j){const le=this.f(V);if(le===-1){this.d.unshift({pattern:V,matches:C.parse(E(V))});return}const _=new Set(j.map(de=>this.f(de,le)));_.delete(-1);const be=Array.from(_).sort();this.d.splice(le+1,0,...be.map(de=>this.d[de]));for(let de=be.length-1;de>=0;de--)this.d.splice(be[de],1)}toArray(){return this.d.map(V=>V.pattern)}f(V,j=this.d.length){const le=E(V);for(let _=0;_<j;_++)if(this.d[_].matches(le))return _;return-1}}e.MimeTypeDisplayOrder=A;function v(F,V,j,le=(_,be)=>_===be){const _=[];function be(se,Z,X){if(Z===0&&X.length===0)return;const ee=_[_.length-1];ee&&ee.start+ee.deleteCount===se?(ee.deleteCount+=Z,ee.toInsert.push(...X)):_.push({start:se,deleteCount:Z,toInsert:X})}let de=0,ue=0;for(;;){if(de===F.length){be(de,0,V.slice(ue));break}if(ue===V.length){be(de,F.length-de,[]);break}const se=F[de],Z=V[ue];if(le(se,Z)){de+=1,ue+=1;continue}j(Z)?(be(de,1,[]),de+=1):(be(de,0,[Z]),ue+=1)}return _}e.diff=v,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(F){F.default="default",F.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function h(F){const V=F;return!!((typeof V.include=="string"||C.isRelativePattern(V.include))&&(typeof V.exclude=="string"||C.isRelativePattern(V.exclude)))}e.isDocumentExcludePattern=h;function r(F,V,j){if(Array.isArray(F.viewType)&&F.viewType.indexOf(V)>=0||F.viewType===V)return!0;if(F.filenamePattern){const le=h(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,_=h(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(C.match(le,(0,R.basename)(j.fsPath).toLowerCase()))return!(_&&C.match(_,(0,R.basename)(j.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",logging:"notebook.logging"};var u;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(u=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class i{static create(V){return`${i.d}${V}`}static parse(V){if(V.startsWith(i.d))return V.substring(i.d.length)}}i.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=i;function p(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}e.isTextStreamMime=p;const c=new TextDecoder;function s(F){const V=[];let j=!1;for(const le of F)(V.length===0||j)&&(V.push(le),j=!0);return H(V),P(n.VSBuffer.concat(V.map(le=>n.VSBuffer.wrap(le))))}e.compressOutputItemStreams=s;const d=`${String.fromCharCode(27)}[A`,T=d.split("").map(F=>F.charCodeAt(0)),O=10;function H(F){F.forEach((V,j)=>{if(j===0||V.length<d.length)return;const le=F[j-1],_=V.subarray(0,d.length);if(_[0]===T[0]&&_[1]===T[1]&&_[2]===T[2]){const be=le.lastIndexOf(O);if(be===-1)return;F[j-1]=le.subarray(0,be),F[j]=V.subarray(d.length)}})}function J(F){let V=F;do F=V,V=F.replace(/[^\n]\x08/gm,"");while(V.length<F.length);return F}function K(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const V=F.match(/^(.*)\r+/m)[1];let j=F.match(/\r+(.*)$/m)[1];j=j+V.slice(j.length,V.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,j)}return F}const L="\b".charCodeAt(0),B="\r".charCodeAt(0);function P(F){return!F.buffer.includes(L)&&!F.buffer.includes(B)?F:n.VSBuffer.fromString(K(J(c.decode(F.buffer))))}}),define(Ce[186],ke([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var C;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState"})(C=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,n.createDecorator)("INotebookExecutionService")}),define(Ce[45],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var n;(function(M){M.Delimiter="\0"})(n=e.TestIdPathParts||(e.TestIdPathParts={}));var C;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(C=e.TestPosition||(e.TestPosition={}));class D{static fromExtHostTestItem(S,R,y=S.parent){if(S._isRoot)return new D([R]);const k=[S.id];for(let N=y;N&&N.id!==R;N=N.parent)k.push(N.id);return k.push(R),new D(k.reverse())}static isRoot(S){return!S.includes("\0")}static root(S){const R=S.indexOf("\0");return R===-1?S:S.slice(0,R)}static fromString(S){return new D(S.split("\0"))}static join(S,R){return new D([...S.path,R])}static joinToString(S,R){return S.toString()+"\0"+R}static parentId(S){const R=S.lastIndexOf("\0");return R===-1?void 0:S.slice(0,R)}static localId(S){const R=S.lastIndexOf("\0");return R===-1?S:S.slice(R+1)}static compare(S,R){return S===R?0:R.startsWith(S+"\0")?2:S.startsWith(R+"\0")?3:1}constructor(S,R=S.length){if(this.path=S,this.d=R,S.length===0||R<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new D(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let S=1;S<=this.d;S++)yield new D(this.path,S)}*idsToRoot(){for(let S=this.d;S>0;S--)yield new D(this.path,S)}compare(S){if(typeof S=="string")return D.compare(this.toString(),S);for(let R=0;R<S.d&&R<this.d;R++)if(S.path[R]!==this.path[R])return 1;return S.d>this.d?2:S.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let S=1;S<this.d;S++)this.c+="\0",this.c+=this.path[S]}return this.c}}e.TestId=D}),define(Ce[56],ke([1,0,2,44,45]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var M;(function(c){c[c.Unset=0]="Unset",c[c.Queued=1]="Queued",c[c.Running=2]="Running",c[c.Passed=3]="Passed",c[c.Failed=4]="Failed",c[c.Skipped=5]="Skipped",c[c.Errored=6]="Errored"})(M=e.TestResultState||(e.TestResultState={}));var S;(function(c){c[c.Run=2]="Run",c[c.Debug=4]="Debug",c[c.Coverage=8]="Coverage",c[c.HasNonDefaultProfile=16]="HasNonDefaultProfile",c[c.HasConfigurable=32]="HasConfigurable",c[c.SupportsContinuousRun=64]="SupportsContinuousRun"})(S=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const R=c=>"runIn"in c;e.isStartControllerTests=R;var y;(function(c){c.serialize=s=>({range:s.range.toJSON(),uri:s.uri.toJSON()}),c.deserialize=s=>({range:C.Range.lift(s.range),uri:n.URI.revive(s.uri)})})(y=e.IRichLocation||(e.IRichLocation={}));var k;(function(c){c[c.Error=0]="Error",c[c.Output=1]="Output"})(k=e.TestMessageType||(e.TestMessageType={}));var N;(function(c){c.serialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&y.serialize(s.location)}),c.deserialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&y.deserialize(s.location)})})(N=e.ITestErrorMessage||(e.ITestErrorMessage={}));const w=(c,s)=>`${s?"s":"e"}${c}`;e.getMarkId=w;var f;(function(c){c.serialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&y.serialize(s.location)}),c.deserialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&y.deserialize(s.location)})})(f=e.ITestOutputMessage||(e.ITestOutputMessage={}));var b;(function(c){c.serialize=s=>s.type===0?N.serialize(s):f.serialize(s),c.deserialize=s=>s.type===0?N.deserialize(s):f.deserialize(s)})(b=e.ITestMessage||(e.ITestMessage={}));var m;(function(c){c.serializeWithoutMessages=s=>({state:s.state,duration:s.duration,messages:[]}),c.serialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(b.serialize)}),c.deserialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(b.deserialize)})})(m=e.ITestTaskState||(e.ITestTaskState={}));const a="\0",o=(c,s)=>c+a+s;e.namespaceTestTag=o;const l=c=>{const s=c.indexOf(a);return{ctrlId:c.slice(0,s),tagId:c.slice(s+1)}};e.denamespaceTestTag=l;var g;(function(c){c.serialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?.toJSON(),range:s.range?.toJSON()||null,description:s.description,error:s.error,sortText:s.sortText}),c.deserialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?n.URI.revive(s.uri):void 0,range:s.range?C.Range.lift(s.range):null,description:s.description,error:s.error,sortText:s.sortText})})(g=e.ITestItem||(e.ITestItem={}));var E;(function(c){c[c.NotExpandable=0]="NotExpandable",c[c.Expandable=1]="Expandable",c[c.BusyExpanding=2]="BusyExpanding",c[c.Expanded=3]="Expanded"})(E=e.TestItemExpandState||(e.TestItemExpandState={}));var A;(function(c){c.serialize=s=>({expand:s.expand,item:g.serialize(s.item)}),c.deserialize=s=>({controllerId:D.TestId.root(s.item.extId),expand:s.expand,item:g.deserialize(s.item)})})(A=e.InternalTestItem||(e.InternalTestItem={}));var v;(function(c){c.serialize=s=>{let d;return s.item&&(d={},s.item.label!==void 0&&(d.label=s.item.label),s.item.tags!==void 0&&(d.tags=s.item.tags),s.item.busy!==void 0&&(d.busy=s.item.busy),s.item.uri!==void 0&&(d.uri=s.item.uri?.toJSON()),s.item.range!==void 0&&(d.range=s.item.range?.toJSON()),s.item.description!==void 0&&(d.description=s.item.description),s.item.error!==void 0&&(d.error=s.item.error),s.item.sortText!==void 0&&(d.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:d}},c.deserialize=s=>{let d;return s.item&&(d={},s.item.label!==void 0&&(d.label=s.item.label),s.item.tags!==void 0&&(d.tags=s.item.tags),s.item.busy!==void 0&&(d.busy=s.item.busy),s.item.range!==void 0&&(d.range=s.item.range?C.Range.lift(s.item.range):null),s.item.description!==void 0&&(d.description=s.item.description),s.item.error!==void 0&&(d.error=s.item.error),s.item.sortText!==void 0&&(d.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:d}}})(v=e.ITestItemUpdate||(e.ITestItemUpdate={}));const t=(c,s)=>{s.expand!==void 0&&(c.expand=s.expand),s.item!==void 0&&(c.item=c.item?Object.assign(c.item,s.item):s.item)};e.applyTestItemUpdate=t;var h;(function(c){c.serializeWithoutMessages=s=>({...A.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(m.serializeWithoutMessages),retired:s.retired}),c.serialize=s=>({...A.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(m.serialize),retired:s.retired}),c.deserialize=s=>({...A.deserialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(m.deserialize),retired:!0})})(h=e.TestResultItem||(e.TestResultItem={}));var r;(function(c){c[c.Function=0]="Function",c[c.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var u;(function(c){c[c.Add=0]="Add",c[c.Update=1]="Update",c[c.DocumentSynced=2]="DocumentSynced",c[c.Remove=3]="Remove",c[c.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",c[c.Retire=5]="Retire",c[c.AddTag=6]="AddTag",c[c.RemoveTag=7]="RemoveTag"})(u=e.TestDiffOpType||(e.TestDiffOpType={}));var i;(function(c){c.deserialize=s=>s.op===0?{op:s.op,item:A.deserialize(s.item)}:s.op===1?{op:s.op,item:v.deserialize(s.item)}:s.op===2?{op:s.op,uri:n.URI.revive(s.uri),docv:s.docv}:s,c.serialize=s=>s.op===0?{op:s.op,item:A.serialize(s.item)}:s.op===1?{op:s.op,item:v.serialize(s.item)}:s})(i=e.TestsDiffOp||(e.TestsDiffOp={}));class p{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(s){const d=this.o();for(const T of s)switch(T.op){case 0:this.j(A.deserialize(T.item),d);break;case 1:this.k(v.deserialize(T.item),d);break;case 3:this.l(T.itemId,d);break;case 5:this.m(T.itemId);break;case 4:this.updatePendingRoots(T.amount);break;case 6:this.c.set(T.tag.id,T.tag);break;case 7:this.c.delete(T.id);break}d.complete?.()}j(s,d){const T=D.TestId.parentId(s.item.extId)?.toString();let O;if(!T)O=this.p(s),this.f.add(O),this.d.set(s.item.extId,O);else if(this.d.has(T)){const H=this.d.get(T);H.children.add(s.item.extId),O=this.p(s,H),this.d.set(s.item.extId,O)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(s)}`);return}return d.add?.(O),s.expand===2&&this.g++,O}k(s,d){const T=this.d.get(s.extId);if(!!T)return s.expand!==void 0&&(T.expand===2&&this.g--,s.expand===2&&this.g++),(0,e.applyTestItemUpdate)(T,s),d.update?.(T),T}l(s,d){const T=this.d.get(s);if(!T)return;const O=D.TestId.parentId(T.item.extId)?.toString();O?this.d.get(O).children.delete(T.item.extId):this.f.delete(T);const H=[[s]];for(;H.length;)for(const J of H.pop()){const K=this.d.get(J);K&&(H.push(K.children),this.d.delete(J),d.remove?.(K,K!==T),K.expand===2&&this.g--)}}m(s){}updatePendingRoots(s){this.h+=s}o(){return{}}}e.AbstractIncrementalTestCollection=p}),define(Ce[71],ke([1,0,17,4,6,49,56,45]),function(te,e,n,C,D,M,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk",g[g.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const k=(g,E)=>g===E,w=Object.entries({range:(g,E)=>g===E?!0:!g||!E?!1:g.equalsRange(E),busy:k,label:k,description:k,error:k,sortText:k,tags:(g,E)=>!(g.length!==E.length||g.some(A=>!E.includes(A)))}),f=(g,E)=>{let A;for(const[v,t]of w)t(g[v],E[v])||(A?A[v]=E[v]:A={[v]:E[v]});return A};class b extends D.Disposable{get root(){return this.m.root}constructor(E){super(),this.m=E,this.f=this.B(new n.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new C.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(E){this.h=E;for(const A of this.tree.values())this.G(A)}collectDiff(){const E=this.k;return this.k=[],E}pushDiff(E){switch(E.op){case 2:{for(const A of this.k)if(A.op===2&&A.uri===E.uri){A.docv=E.docv;return}break}case 1:{const A=this.k[this.k.length-1];if(A){if(A.op===1&&A.item.extId===E.item.extId){(0,S.applyTestItemUpdate)(A.item,E.item);return}if(A.op===0&&A.item.item.extId===E.item.extId){(0,S.applyTestItemUpdate)(A.item,E.item);return}}break}}this.k.push(E),this.f.isScheduled()||this.f.schedule()}expand(E,A){const v=this.tree.get(E);if(!!v){if((v.expandLevels===void 0||A>v.expandLevels)&&(v.expandLevels=A),v.expand===1){const t=this.I(v);return t.isOpen()?this.H(v,A-1):t.wait().then(()=>this.H(v,A-1))}else if(v.expand===3)return v.resolveBarrier?.isOpen()===!1?v.resolveBarrier.wait().then(()=>this.H(v,A-1)):this.H(v,A-1)}}dispose(){for(const E of this.tree.values())this.m.getApiFor(E.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(E,A){switch(A.op){case 3:this.L(R.TestId.joinToString(E.fullId,A.id));break;case 0:this.u(A.item,E);break;case 5:for(const v of A.ops)this.p(E,v);break;case 1:this.w(A.new,A.old,E.fullId.toString());break;case 2:this.G(E);break;case 4:this.pushDiff({op:1,item:{extId:E.fullId.toString(),item:A.update}});break;case 6:this.s(E.actual.uri);break;default:(0,M.assertNever)(A)}}s(E){E&&this.pushDiff({op:2,uri:E,docv:this.m.getDocumentVersion(E)})}u(E,A){const v=R.TestId.fromExtHostTestItem(E,this.root.id,A?.actual),t=this.m.getApiFor(E);t.parent&&t.parent!==A?.actual&&this.m.getChildren(t.parent).delete(E.id);let h=this.tree.get(v.toString());if(!h){h={fullId:v,actual:E,expandLevels:A?.expandLevels?A.expandLevels-1:void 0,expand:0},E.tags.forEach(this.y,this),this.tree.set(h.fullId.toString(),h),this.C(E,A),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:h.expand,item:this.m.toITestItem(E)}}),this.F(E,h,A);return}if(h.actual===E){this.D(E,h,A);return}if(h.actual.uri?.toString()!==E.uri?.toString())return this.L(v.toString()),this.u(E,A);const r=this.m.getChildren(h.actual),u=h.actual,i=f(this.m.toITestItem(u),this.m.toITestItem(E));this.m.getApiFor(u).listener=void 0,h.actual=E,h.expand=0,i&&(i.hasOwnProperty("tags")&&(this.w(E.tags,u.tags,v.toString()),delete i.tags),this.p(h,{op:4,update:i})),this.F(E,h,A);for(const[p,c]of r)this.m.getChildren(E).get(c.id)||this.L(R.TestId.joinToString(v,c.id));this.s(h.actual.uri)}w(E,A,v){const t=new Set(A.map(h=>h.id));for(const h of E)t.delete(h.id)||this.y(h);this.pushDiff({op:1,item:{extId:v,item:{tags:E.map(h=>(0,S.namespaceTestTag)(this.m.controllerId,h.id))}}}),t.forEach(this.z,this)}y(E){const A=this.j.get(E.id);A?A.refCount++:(this.j.set(E.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,S.namespaceTestTag)(this.m.controllerId,E.id)}}))}z(E){const A=this.j.get(E);A&&!--A.refCount&&(this.j.delete(E),this.pushDiff({op:7,id:(0,S.namespaceTestTag)(this.m.controllerId,E)}))}C(E,A){this.m.getApiFor(E).parent=A&&A.actual!==this.root?A.actual:void 0}D(E,A,v){this.C(E,v);const t=this.m.getApiFor(E);t.parent=v?.actual,t.listener=h=>this.p(A,h),this.G(A)}F(E,A,v){this.D(E,A,v);for(const[t,h]of this.m.getChildren(E))this.u(h,A)}G(E){let A;this.h?E.resolveBarrier?A=E.resolveBarrier.isOpen()?3:2:A=E.actual.canResolveChildren?1:0:A=0,A!==E.expand&&(E.expand=A,this.pushDiff({op:1,item:{extId:E.fullId.toString(),expand:A}}),A===1&&E.expandLevels!==void 0&&this.I(E))}H(E,A){if(A<0)return;const v=[];for(const[t,h]of this.m.getChildren(E.actual)){const r=this.expand(R.TestId.joinToString(E.fullId,h.id),A);(0,n.isThenable)(r)&&v.push(r)}if(v.length)return Promise.all(v).then(()=>{})}I(E){if(E.resolveBarrier)return E.resolveBarrier;if(!this.h){const h=new n.Barrier;return h.open(),h}E.expand=2,this.J(E);const A=E.resolveBarrier=new n.Barrier,v=h=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,h)};let t;try{t=this.h(E.actual===this.root?void 0:E.actual)}catch(h){v(h)}return(0,n.isThenable)(t)?t.catch(v).then(()=>{A.open(),this.G(E)}):(A.open(),this.G(E)),E.resolveBarrier}J(E){this.pushDiff({op:1,item:{extId:E.fullId.toString(),expand:E.expand}})}L(E){const A=this.tree.get(E);if(!A)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:E});const v=[A];for(;v.length;){const t=v.pop();if(!!t){this.m.getApiFor(t.actual).listener=void 0;for(const h of t.actual.tags)this.z(h.id);this.tree.delete(t.fullId.toString());for(const[h,r]of this.m.getChildren(t.actual))v.push(this.tree.get(R.TestId.joinToString(t.fullId,r.id)))}}}flushDiff(){const E=this.collectDiff();E.length&&this.g.fire(E)}}e.TestItemCollection=b;class m extends Error{constructor(E){super(`Attempted to insert a duplicate test item ID ${E}`)}}e.DuplicateTestItemError=m;class a extends Error{constructor(E){super(`TestItem with ID "${E}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=a;class o extends Error{constructor(E,A,v){super(`TestItem with ID "${E}" is from controller "${A}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=o;const l=(g,E,A)=>{let v=new Map;return{get size(){return v.size},forEach(t,h){for(const r of v.values())t.call(h,r,this)},[Symbol.iterator](){return v.entries()},replace(t){const h=new Map,r=new Set(v.keys()),u={op:5,ops:[]};for(const i of t){if(!(i instanceof A))throw new a(i.id);const p=E(i).controllerId;if(p!==g.controllerId)throw new o(i.id,p,g.controllerId);if(h.has(i.id))throw new m(i.id);h.set(i.id,i),r.delete(i.id),u.ops.push({op:0,item:i})}for(const i of r.keys())u.ops.push({op:3,id:i});g.listener?.(u),v=h},add(t){if(!(t instanceof A))throw new a(t.id);v.set(t.id,t),g.listener?.({op:0,item:t})},delete(t){v.delete(t)&&g.listener?.({op:3,id:t})},get(t){return v.get(t)},toJSON(){return Array.from(v.values())}}};e.createTestItemChildren=l}),define(Ce[96],ke([1,0,71]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const C=new WeakMap,D=(S,R)=>{const y={controllerId:R};return C.set(S,y),y};e.createPrivateApiFor=D;const M=S=>{const R=C.get(S);if(!R)throw new n.InvalidTestItemError(S?.id||"<unknown>");return R};e.getPrivateApiFor=M}),define(Ce[72],ke([1,0,16,2]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function D(R,y){return R.scheme===n.Schemas.http||R.scheme===n.Schemas.https?R:(y&&y.authority&&y.isRemote&&R.scheme===n.Schemas.file&&(R=C.URI.from({scheme:n.Schemas.vscodeRemote,authority:y.authority,path:R.path})),C.URI.from({scheme:n.Schemas.https,authority:`${R.scheme}+${M(R.authority)}.${e.webviewRootResourceAuthority}`,path:R.path,fragment:R.fragment,query:R.query}))}e.asWebviewUri=D;function M(R){return R.replace(/./g,y=>{const k=y.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?y:"-"+k.toString(16).padStart(4,"0")})}function S(R){return R.replace(/-([0-9a-f]{4})/g,(y,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=S}),define(Ce[187],ke([1,0,4,6,72]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class M{constructor(R,y,k){this.d=R,this.e=y,this.f=k,this.a=0,this.b=new C.DisposableStore,this.c=new Map,this.b.add(y.onDidChangeVisibleTextEditors(()=>{const N=y.getVisibleTextEditors();for(const w of this.c.values())N.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this.c.forEach(R=>R.inset.dispose()),this.b.dispose()}createWebviewEditorInset(R,y,k,N,w){let f;for(const E of this.e.getVisibleTextEditors(!0))if(E.value===R){f=E;break}if(!f)throw new Error("not a visible editor");const b=this,m=this.a++,a=new n.Emitter,o=new n.Emitter,l=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(E){return(0,D.asWebviewUri)(E,b.f)}get cspSource(){return D.webviewGenericCspSource}set options(E){this.b=E,b.d.$setOptions(m,E)}get options(){return this.b}set html(E){this.a=E,b.d.$setHtml(m,E)}get html(){return this.a}get onDidReceiveMessage(){return a.event}postMessage(E){return b.d.$postMessage(m,E)}},g=new class{constructor(){this.editor=R,this.line=y,this.height=k,this.webview=l,this.onDidDispose=o.event}dispose(){b.c.has(m)&&(b.c.delete(m),b.d.$disposeEditorInset(m),o.fire(),o.dispose(),a.dispose())}};return this.d.$createEditorInset(m,f.id,f.value.document.uri,y+1,k,N||{},w.identifier,w.extensionLocation),this.c.set(m,{editor:R,inset:g,onDidReceiveMessage:a}),g}$onDidDispose(R){const y=this.c.get(R);y&&y.inset.dispose()}$onDidReceiveMessage(R,y){this.c.get(R)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=M}),define(Ce[188],ke([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,n.createDecorator)("configurationResolverService");var C;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(C=e.VariableKind||(e.VariableKind={}));class D extends Error{constructor(S,R){super(R),this.variable=S}}e.VariableError=D}),define(Ce[189],ke([1,0,19,51,9,22,21,87,153,188,10]),function(te,e,n,C,D,M,S,R,y,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class w{constructor(b,m,a,o){this.g=new Map,this.a=b,this.b=m,this.d=a,o&&(this.c=o.then(l=>this.h(l)))}h(b){if(S.isWindows){const m=Object.create(null);return Object.keys(b).forEach(a=>{m[a.toLowerCase()]=b[a]}),m}return b}resolveWithEnvironment(b,m,a){return this.j({env:this.h(b),userHome:void 0},m?m.uri:void 0,a)}async resolveAsync(b,m){const a={env:await this.c,userHome:await this.d};return this.j(a,b?b.uri:void 0,m)}async i(b,m,a,o){const l=M.deepClone(m);S.isWindows&&l.windows?Object.keys(l.windows).forEach(E=>l[E]=l.windows[E]):S.isMacintosh&&l.osx?Object.keys(l.osx).forEach(E=>l[E]=l.osx[E]):S.isLinux&&l.linux&&Object.keys(l.linux).forEach(E=>l[E]=l.linux[E]),delete l.windows,delete l.osx,delete l.linux;const g={env:await this.c,userHome:await this.d};return this.j(g,b?b.uri:void 0,l,a,o)}async resolveAnyAsync(b,m,a){return this.i(b,m,a)}async resolveAnyMap(b,m,a){const o=new Map;return{newConfig:await this.i(b,m,a,o),resolvedVariables:o}}resolveWithInteractionReplace(b,m,a,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,m,a,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,m){if(this.g.has(b))throw new Error("Variable "+b+" is contributed twice.");this.g.set(b,m)}async j(b,m,a,o,l){if(D.isString(a))return this.l(b,m,a,o,l);if(Array.isArray(a))return Promise.all(a.map(g=>this.j(b,m,g,o,l)));if(D.isObject(a)){const g=Object.create(null),E=await Promise.all(Object.keys(a).map(async A=>[await this.l(b,m,A,o,l),await this.j(b,m,a[A],o,l)]));for(const[A,v]of E)g[A]=v;return g}return a}l(b,m,a,o,l){return(0,N.replaceAsync)(a,w.VARIABLE_REGEXP,async(g,E)=>{if(E.includes(w.VARIABLE_LHS))return g;let A=await this.n(b,g,E,m,o);return l?.set(E,A),A!==g&&D.isString(A)&&A.match(w.VARIABLE_REGEXP)&&(A=await this.l(b,m,A,o,l)),A})}m(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async n(b,m,a,o,l){let g;const E=a.split(":");E.length>1&&(a=E[0],g=E[1]);const A=h=>{const r=this.a.getFilePath();if(r)return(0,R.normalizeDriveLetter)(r);throw new k.VariableError(h,(0,y.localize)(0,null,m))},v=h=>{const r=A(h);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return(0,R.normalizeDriveLetter)(u)}throw new k.VariableError(h,(0,y.localize)(1,null,m,n.basename(r)))},t=h=>{if(g){const r=this.a.getFolderUri(g);if(r)return r;throw new k.VariableError(h,(0,y.localize)(2,null,m,g))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new k.VariableError(h,(0,y.localize)(3,null,m)):new k.VariableError(h,(0,y.localize)(4,null,m))};switch(a){case"env":if(g){if(b.env){const h=b.env[S.isWindows?g.toLowerCase():g];if(D.isString(h))return h}return""}throw new k.VariableError(k.VariableKind.Env,(0,y.localize)(5,null,m));case"config":if(g){const h=this.a.getConfigurationValue(o,g);if(D.isUndefinedOrNull(h))throw new k.VariableError(k.VariableKind.Config,(0,y.localize)(6,null,m,g));if(D.isObject(h))throw new k.VariableError(k.VariableKind.Config,(0,y.localize)(7,null,m,g));return h}throw new k.VariableError(k.VariableKind.Config,(0,y.localize)(8,null,m));case"command":return this.o(k.VariableKind.Command,m,g,l,"command");case"input":return this.o(k.VariableKind.Input,m,g,l,"input");case"extensionInstallFolder":if(g){const h=await this.a.getExtension(g);if(!h)throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,m,g));return this.m(h.extensionLocation)}throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,m));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,R.normalizeDriveLetter)(this.m(t(k.VariableKind.WorkspaceFolder)));case"cwd":return o||g?(0,R.normalizeDriveLetter)(this.m(t(k.VariableKind.Cwd))):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,R.normalizeDriveLetter)(n.basename(this.m(t(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new k.VariableError(k.VariableKind.UserHome,(0,y.localize)(11,null,m))}case"lineNumber":{const h=this.a.getLineNumber();if(h)return h;throw new k.VariableError(k.VariableKind.LineNumber,(0,y.localize)(12,null,m))}case"selectedText":{const h=this.a.getSelectedText();if(h)return h;throw new k.VariableError(k.VariableKind.SelectedText,(0,y.localize)(13,null,m))}case"file":return A(k.VariableKind.File);case"fileWorkspaceFolder":return v(k.VariableKind.FileWorkspaceFolder);case"relativeFile":return o||g?n.relative(this.m(t(k.VariableKind.RelativeFile)),A(k.VariableKind.RelativeFile)):A(k.VariableKind.RelativeFile);case"relativeFileDirname":{const h=n.dirname(A(k.VariableKind.RelativeFileDirname));if(o||g){const r=n.relative(this.m(t(k.VariableKind.RelativeFileDirname)),h);return r.length===0?".":r}return h}case"fileDirname":return n.dirname(A(k.VariableKind.FileDirname));case"fileExtname":return n.extname(A(k.VariableKind.FileExtname));case"fileBasename":return n.basename(A(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const h=n.basename(A(k.VariableKind.FileBasenameNoExtension));return h.slice(0,h.length-n.extname(h).length)}case"fileDirnameBasename":return n.basename(n.dirname(A(k.VariableKind.FileDirnameBasename)));case"execPath":{const h=this.a.getExecPath();return h||m}case"execInstallFolder":{const h=this.a.getAppRoot();return h||m}case"pathSeparator":return n.sep;default:try{const h=g?`${a}:${g}`:a;return this.o(k.VariableKind.Unknown,m,h,l,void 0)}catch{return m}}}}o(b,m,a,o,l){if(a&&o){const g=l===void 0?o[a]:o[l+":"+a];if(typeof g=="string")return g;throw new k.VariableError(b,(0,y.localize)(14,null,m))}return m}}w.VARIABLE_LHS="${",w.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=w}),define(Ce[97],ke([1,0,3,95]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,n.createDecorator)("editorGroupsService");var D;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var M;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(M=e.GroupOrientation||(e.GroupOrientation={}));var S;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(S=e.GroupLocation||(e.GroupLocation={}));var R;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EVEN=1]="EVEN",m[m.TOGGLE=2]="TOGGLE"})(R=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function k(m){const a=m;return(0,C.isEditorInput)(a?.editor)&&(0,C.isEditorInput)(a?.replacement)}e.isEditorReplacement=k;var N;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(N=e.GroupsOrder||(e.GroupsOrder={}));var w;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(w=e.OpenEditorContext||(e.OpenEditorContext={}));function f(m){const a=m;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}e.isEditorGroup=f;function b(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=b}),define(Ce[190],ke([1,0,3,97]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,n.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(M){const S=M;return typeof M=="number"||(0,C.isEditorGroup)(S)}e.isPreferredGroup=D}),define(Ce[191],ke([1,0,3,159]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,n.refineServiceDecorator)(C.IEnvironmentService)}),define(Ce[98],ke([1,0,25,4,19]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class M{constructor(w){this.removedDueToLooping=w}}e.DeltaExtensionsResult=M;class S{static isHostExtension(w,f,b){if(f.getExtensionDescription(w))return!1;const m=b.getExtensionDescription(w);return m?!!((m.main||m.browser)&&m.api==="none"):!1}constructor(w){this.c=new C.Emitter,this.onDidChange=this.c.event,this.d=w,this.h()}h(){this.d.sort(y),this.e=new Map,this.f=[],this.g=new Map;for(const w of this.d){if(this.e.has(n.ExtensionIdentifier.toKey(w.identifier))){console.error("Extension `"+w.identifier.value+"` is already registered");continue}if(this.e.set(n.ExtensionIdentifier.toKey(w.identifier),w),this.f.push(w),Array.isArray(w.activationEvents))for(let f of w.activationEvents)f==="onUri"&&(f=`onUri:${n.ExtensionIdentifier.toKey(w.identifier)}`),this.g.has(f)||this.g.set(f,[]),this.g.get(f).push(w)}}set(w){this.d=w,this.h(),this.c.fire(void 0)}deltaExtensions(w,f){this.d=k(this.d,f),this.d=this.d.concat(w);const b=S.j(this.d);return this.d=k(this.d,b.map(m=>m.identifier)),this.h(),this.c.fire(void 0),new M(b)}static j(w){const f=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(l){this.d.has(l)||(this.d.add(l),this.e.push(l))}addArc(l,g){this.addNode(l),this.addNode(g),this.c.has(l)?this.c.get(l).push(g):this.c.set(l,[g])}getArcs(l){return this.c.has(l)?this.c.get(l):[]}hasOnlyGoodArcs(l,g){const E=f.getArcs(l);for(let A=0;A<E.length;A++)if(!g.has(E[A]))return!1;return!0}getNodes(){return this.e}},b=new Map;for(const l of w){const g=n.ExtensionIdentifier.toKey(l.identifier);if(b.set(g,l),l.extensionDependencies)for(const E of l.extensionDependencies){const A=n.ExtensionIdentifier.toKey(E);f.addArc(g,A)}}const m=new Set;f.getNodes().filter(l=>f.getArcs(l).length===0).forEach(l=>m.add(l));const a=f.getNodes().filter(l=>!m.has(l));let o;do{o=!1;for(let l=0;l<a.length;l++){const g=a[l];f.hasOnlyGoodArcs(g,m)&&(a.splice(l,1),l--,m.add(g),o=!0)}}while(o);return a.map(l=>b.get(l))}containsActivationEvent(w){return this.g.has(w)}containsExtension(w){return this.e.has(n.ExtensionIdentifier.toKey(w))}getExtensionDescriptionsForActivationEvent(w){const f=this.g.get(w);return f?f.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(w){const f=this.e.get(n.ExtensionIdentifier.toKey(w));return f||void 0}getExtensionDescriptionByUUID(w){for(const f of this.f)if(f.uuid===w)return f}getExtensionDescriptionByIdOrUUID(w,f){return this.getExtensionDescription(w)??(f?this.getExtensionDescriptionByUUID(f):void 0)}}e.ExtensionDescriptionRegistry=S;var R;(function(N){N[N.Builtin=0]="Builtin",N[N.User=1]="User",N[N.Dev=2]="Dev"})(R||(R={}));function y(N,w){const f=N.isBuiltin?0:N.isUnderDevelopment?2:1,b=w.isBuiltin?0:w.isUnderDevelopment?2:1;if(f!==b)return f-b;const m=D.posix.basename(N.extensionLocation.path),a=D.posix.basename(w.extensionLocation.path);return m<a?-1:m>a?1:0}function k(N,w){const f=new Set;return w.forEach(b=>f.add(n.ExtensionIdentifier.toKey(b))),N.filter(b=>!f.has(n.ExtensionIdentifier.toKey(b.identifier)))}}),define(Ce[73],ke([1,0,23]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var C;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var D;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(D=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var M;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(M=e.MessageType||(e.MessageType={}));function S(k){const N=n.VSBuffer.alloc(1);switch(k){case 0:N.writeUInt8(1,0);break;case 1:N.writeUInt8(2,0);break;case 2:N.writeUInt8(3,0);break}return N}e.createMessageOfType=S;function R(k,N){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return N===0;case 2:return N===1;case 3:return N===2;default:return!1}}e.isMessageOfType=R;var y;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(y=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ce[74],ke([1,0,3,4,11,26,73,50,52,22,2,6,143]),function(te,e,n,C,D,M,S,R,y,k,N,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let b=class extends w.Disposable{constructor(l,g){super(),this.m=l,this.n=g,this.a=this.B(new C.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new C.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.l=new Map,this.j=N.URI.revive(this.m.environment.extensionTelemetryLogResource),this.i=this.m.environment.isExtensionTelemetryLoggingOnly,this.k=g.createLogger(this.j,{id:y.extensionTelemetryLogChannelId,name:(0,f.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(g.onDidChangeLogLevel(E=>{(0,D.isLogLevel)(E)&&this.p()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}p(){this.n.setVisibility(this.j,this.g&&this.n.getLogLevel()===D.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(l,g,E){const A=this.getTelemetryDetails(),v=new m(g,E,l,this.k,this.i,this.getBuiltInCommonProperties(l),{isUsageEnabled:A.isUsageEnabled,isErrorsEnabled:A.isErrorsEnabled});return this.l.set(l.identifier.value,v),v.apiTelemetryLogger}$initializeTelemetryLevel(l,g,E){this.f=l,this.g=g,this.c=E??{usage:!0,error:!0},this.p()}getBuiltInCommonProperties(l){const g={};switch(g["common.extname"]=`${l.publisher}.${l.name}`,g["common.extversion"]=l.version,g["common.vscodemachineid"]=this.m.telemetryInfo.machineId,g["common.vscodesessionid"]=this.m.telemetryInfo.sessionId,g["common.vscodeversion"]=this.m.version,g["common.isnewappinstall"]=a(this.m.telemetryInfo.firstSessionDate),g["common.product"]=this.m.environment.appHost,this.m.uiKind){case S.UIKind.Web:g["common.uikind"]="web";break;case S.UIKind.Desktop:g["common.uikind"]="desktop";break;default:g["common.uikind"]="unknown"}return g["common.remotename"]=(0,R.getRemoteName)((0,y.cleanRemoteAuthority)(this.m.remote.authority)),g}$onDidChangeTelemetryLevel(l){this.h=this.getTelemetryConfiguration(),this.f=l;const g=this.getTelemetryDetails();this.l.forEach(E=>{E.updateTelemetryEnablements(g.isUsageEnabled,g.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.p()}onExtensionError(l,g){const E=this.l.get(l.value);return!E||E.ignoreUnhandledExtHostErrors?!1:(E.logError(g),!0)}};b=qe([je(0,M.IExtHostInitDataService),je(1,D.ILoggerService)],b),e.ExtHostTelemetry=b;class m{static validateSender(l){if(typeof l!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof l.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof l.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof l.flush<"u"&&typeof l.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(l,g,E,A,v,t,h){this.g=E,this.h=A,this.i=v,this.j=t,this.b=new C.Emitter,this.ignoreUnhandledExtHostErrors=g?.ignoreUnhandledErrors??!1,this.c=g?.ignoreBuiltInCommonProperties??!1,this.d=g?.additionalCommonProperties,this.a=l,this.e={isUsageEnabled:h.isUsageEnabled,isErrorsEnabled:h.isErrorsEnabled}}updateTelemetryEnablements(l,g){this.f&&(this.e={isUsageEnabled:l,isErrorsEnabled:g},this.b.fire(this.f))}mixInCommonPropsAndCleanData(l){let g=l.properties??l;return g=(0,y.cleanData)(g,[]),this.d&&(g=(0,k.mixin)(g,this.d)),this.c||(g=(0,k.mixin)(g,this.j)),l.properties?l.properties=g:l=g,l}k(l,g){this.g.publisher==="vscode"?l=this.g.name+"/"+l:l=this.g.identifier.value+"/"+l,g=this.mixInCommonPropsAndCleanData(g||{}),this.i||this.a.sendEventData(l,g),this.h.trace(l,g)}logUsage(l,g){!this.e.isUsageEnabled||this.k(l,g)}logError(l,g){!this.e.isErrorsEnabled||(typeof l=="string"?this.k(l,g):this.a.sendErrorData(l,g))}get apiTelemetryLogger(){if(!this.f){const l=this,g={logUsage:l.logUsage.bind(l),get isUsageEnabled(){return l.e.isUsageEnabled},get isErrorsEnabled(){return l.e.isErrorsEnabled},logError:l.logError.bind(l),dispose:l.dispose.bind(l),onDidChangeEnableStates:l.b.event.bind(l)};this.f=Object.freeze(g)}return this.f}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=m;function a(o){const l=Date.now()-new Date(o).getTime();return isNaN(l)?!1:l<1e3*60*60*24}e.isNewAppInstall=a,e.IExtHostTelemetry=(0,n.createDecorator)("IExtHostTelemetry")}),define(Ce[27],ke([1,0,4,2,3,25,169]),function(te,e,n,C,D,M,S){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new M.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:C.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class y{constructor(p){this.affinity=p,this.kind=1}equals(p){return this.kind===p.kind&&this.affinity===p.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=y;class k{constructor(p){this.affinity=p,this.kind=2}equals(p){return this.kind===p.kind&&this.affinity===p.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=k;class N{constructor(){this.kind=3,this.affinity=0}equals(p){return this.kind===p.kind}asString(){return"Remote"}}e.RemoteRunningLocation=N;class w{constructor(p){this.dependency=p}}e.MissingExtensionDependency=w;var f;(function(i){i[i.LocalProcess=1]="LocalProcess",i[i.LocalWebWorker=2]="LocalWebWorker",i[i.Remote=3]="Remote"})(f=e.ExtensionHostKind||(e.ExtensionHostKind={}));function b(i){if(i===null)return"None";switch(i){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=b;class m{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(p,c){const s=[],d=[],T=[],O=[],H=l(this.c),J=l(p),K=(F,V)=>F.extensionLocation.toString()===V.extensionLocation.toString()||F.isBuiltin===V.isBuiltin||F.isUserBuiltin===V.isUserBuiltin||F.isUnderDevelopment===V.isUnderDevelopment;for(const F of this.c){const V=J.get(M.ExtensionIdentifier.toKey(F.identifier));if(!V){s.push(F.identifier),H.delete(M.ExtensionIdentifier.toKey(F.identifier));continue}if(!K(F,V)){s.push(F.identifier),H.delete(M.ExtensionIdentifier.toKey(F.identifier));continue}}for(const F of p){const V=H.get(M.ExtensionIdentifier.toKey(F.identifier));if(!V){d.push(F);continue}if(!K(V,F)){s.push(V.identifier),H.delete(M.ExtensionIdentifier.toKey(V.identifier));continue}}const L=o(this.d),B=o(c);for(const F of this.d)B.has(M.ExtensionIdentifier.toKey(F))||T.push(F);for(const F of c)L.has(M.ExtensionIdentifier.toKey(F))||O.push(F);const P={toRemove:s,toAdd:d,myToRemove:T,myToAdd:O};return this.delta(P),P}delta(p){const{toRemove:c,toAdd:s,myToRemove:d,myToAdd:T}=p,O=o(c),H=o(d);for(let J=0;J<this.c.length;J++)O.has(M.ExtensionIdentifier.toKey(this.c[J].identifier))&&(this.c.splice(J,1),J--);for(let J=0;J<this.d.length;J++)H.has(M.ExtensionIdentifier.toKey(this.d[J]))&&(this.d.splice(J,1),J--);for(const J of s)this.c.push(J);for(const J of T)this.d.push(J)}containsExtension(p){for(const c of this.d)if(M.ExtensionIdentifier.equals(c,p))return!0;return!1}}e.ExtensionHostExtensions=m;class a{constructor(p){if(this[R]="ExtensionIdentifierSet",this.c=new Map,this.d=M.ExtensionIdentifier.toKey,p)for(const c of p)this.add(c)}get size(){return this.c.size}add(p){return this.c.set(this.d(p),p),this}clear(){this.c.clear()}delete(p){return this.c.delete(this.d(p))}has(p){return this.c.has(this.d(p))}forEach(p,c){this.c.forEach(s=>p.call(c,s,s,this))}*entries(){for(const[p,c]of this.c)yield[c,c]}keys(){return this.c.values()}values(){return this.c.values()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=a;function o(i){const p=new Set;for(const c of i)p.add(M.ExtensionIdentifier.toKey(c));return p}e.extensionIdentifiersArrayToSet=o;function l(i){const p=new Map;for(const c of i)p.set(M.ExtensionIdentifier.toKey(c.identifier),c);return p}function g(i,p){return i.enabledApiProposals?i.enabledApiProposals.includes(p):!1}e.isProposedApiEnabled=g;function E(i,p){if(!g(i,p))throw new Error(`Extension '${i.identifier.value}' CANNOT use API proposal: ${p}.
Its package.json#enabledApiProposals-property declares: ${i.enabledApiProposals?.join(", ")??"[]"} but NOT ${p}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${i.identifier.value}`)}e.checkProposedApiEnabled=E;class A{constructor(p,c,s,d){this.codeLoadingTime=p,this.activateCallTime=c,this.activateResolvedTime=s,this.activationReason=d}}e.ActivationTimes=A;class v{constructor(p,c){this.description=p,this.value=c}}e.ExtensionPointContribution=v,e.ExtensionHostLogFileName="exthost";var t;(function(i){i[i.Normal=0]="Normal",i[i.Immediate=1]="Immediate"})(t=e.ActivationKind||(e.ActivationKind={}));function h(i){return{type:i.isBuiltin?0:1,isBuiltin:i.isBuiltin||i.isUserBuiltin,identifier:{id:(0,S.getGalleryExtensionId)(i.publisher,i.name),uuid:i.uuid},manifest:i,location:i.extensionLocation,targetPlatform:i.targetPlatform,validations:[],isValid:!0}}e.toExtension=h;function r(i,p){return{identifier:new M.ExtensionIdentifier((0,S.getExtensionId)(i.manifest.publisher,i.manifest.name)),isBuiltin:i.type===0,isUserBuiltin:i.type===1&&i.isBuiltin,isUnderDevelopment:!!p,extensionLocation:i.location,...i.manifest,uuid:i.identifier.uuid,targetPlatform:i.targetPlatform,browserNlsBundleUris:i.browserNlsBundleUris}}e.toExtensionDescription=r;class u{constructor(){this.onDidRegisterExtensions=n.Event.None,this.onDidChangeExtensionsStatus=n.Event.None,this.onDidChangeExtensions=n.Event.None,this.onWillActivateByEvent=n.Event.None,this.onDidChangeResponsiveChange=n.Event.None,this.extensions=[]}activateByEvent(p){return Promise.resolve(void 0)}activationEventIsDone(p){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(p){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(p,c){return Promise.resolve(0)}getInspectPorts(p,c){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(p){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=u}),define(Ce[192],ke([1,0,12,98,25,27,11,17]),function(te,e,n,C,D,M,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{constructor(l,g,E,A){this.startup=l,this.codeLoadingTime=g,this.activateCallTime=E,this.activateResolvedTime=A}}y.NONE=new y(!1,-1,-1,-1),e.ExtensionActivationTimes=y;class k{constructor(l){this.a=l,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(l,g){return l===-1||g===-1?-1:g-l}build(){return new y(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=k;class N{constructor(l,g,E,A,v,t){this.activationFailed=l,this.activationFailedError=g,this.activationTimes=E,this.module=A,this.exports=v,this.subscriptions=t}}e.ActivatedExtension=N;class w extends N{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=w;class f extends N{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=f;class b extends N{constructor(l){super(!0,l,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let m=class{constructor(l,g,E,A){this.g=A,this.a=l,this.b=g,this.c=E,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[l,g]of this.d)g.dispose()}isActivated(l){const g=this.d.get(D.ExtensionIdentifier.toKey(l));return Boolean(g&&g.value)}getActivatedExtension(l){const g=this.d.get(D.ExtensionIdentifier.toKey(l));if(!g||!g.value)throw new Error(`Extension '${l.value}' is not known or not activated`);return g.value}async activateByEvent(l,g){if(this.f[l])return;const E=this.a.getExtensionDescriptionsForActivationEvent(l);await this.h(E.map(A=>({id:A.identifier,reason:{startup:g,extensionId:A.identifier,activationEvent:l}}))),this.f[l]=!0}activateById(l,g){const E=this.a.getExtensionDescription(l);if(!E)throw new Error(`Extension '${l}' is not known`);return this.h([{id:E.identifier,reason:g}])}async h(l){const g=l.filter(E=>!this.isActivated(E.id)).map(E=>this.j(E));await Promise.all(g.map(E=>E.wait()))}j(l){if(this.d.has(D.ExtensionIdentifier.toKey(l.id)))return this.d.get(D.ExtensionIdentifier.toKey(l.id));if(this.l(l.id))return this.k(l,null,[],null);const g=this.a.getExtensionDescription(l.id);if(!g){const v=new Error(`Cannot activate unknown extension '${l.id.value}'`),t=this.k(l,null,[],new b(v));return this.c.onExtensionActivationError(l.id,v,new M.MissingExtensionDependency(l.id.value)),t}const E=[],A=typeof g.extensionDependencies>"u"?[]:g.extensionDependencies;for(const v of A){if(this.m(v))continue;const t=this.d.get(D.ExtensionIdentifier.toKey(v));if(t){E.push(t);continue}if(this.l(v)){E.push(this.j({id:this.b.getExtensionDescription(v).identifier,reason:l.reason}));continue}const h=this.a.getExtensionDescription(v);if(h){if(!h.main&&!h.browser)continue;E.push(this.j({id:h.identifier,reason:l.reason}));continue}const r=g.displayName||g.identifier.value,u=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${v}'`),i=this.k(l,g.displayName,[],new b(u));return this.c.onExtensionActivationError(g.identifier,u,new M.MissingExtensionDependency(v)),i}return this.k(l,g.displayName,E,null)}k(l,g,E,A){const v=new a(l.id,g,l.reason,E,A,this.c,this.g);return this.d.set(D.ExtensionIdentifier.toKey(l.id),v),v}l(l){return C.ExtensionDescriptionRegistry.isHostExtension(l,this.a,this.b)}m(l){const g=this.b.getExtensionDescription(l);return g?!g.main&&!g.browser:!1}};m=qe([je(3,S.ILogService)],m),e.ExtensionsActivator=m;let a=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(l,g,E,A,v,t,h){this.c=l,this.d=g,this.f=E,this.g=A,this.h=v,this.j=t,this.k=h,this.a=new R.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let l=0;l<this.g.length;l++){const g=this.g[l];if(g.value&&!g.value.activationFailed){this.g.splice(l,1),l--;continue}if(g.value&&g.value.activationFailed){const E=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${g.friendlyName}' failed to activate`);E.detail=g.value.activationFailedError,this.h=new b(E),this.j.onExtensionActivationError(this.c,E,null);return}}this.g.length>0&&await Promise.race(this.g.map(l=>l.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(l){const g=new Error;if(l&&l.name&&(g.name=l.name),l&&l.message?g.message=`Activating extension '${this.c.value}' failed: ${l.message}.`:g.message=`Activating extension '${this.c.value}' failed: ${l}.`,l&&l.stack&&(g.stack=l.stack),this.h=new b(g),this.b&&n.isCancellationError(l))return;this.j.onExtensionActivationError(this.c,g,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(l)}}};a=qe([je(6,S.ILogService)],a)});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[7],ke([1,0,15,12,86,28,64,10,9,2,34,43,94,70,27]),function(te,e,n,C,D,M,S,R,y,k,N,w,f,b,m){"use strict";var a,o,l,g,E,A,v,t,h,r,u,i,p,c,s,d,T,O,H,J,K,L,B;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(z){return Object.assign(z,{apply:function(){const ne=arguments.length===1?[]:arguments[1];return Reflect.construct(z,ne,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(z,[]);{const[ne,...we]=arguments;return Reflect.construct(z,we,ne.constructor)}}})}var F;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(F=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var V;(function(z){z[z.Command=0]="Command",z[z.Opener=1]="Opener"})(V=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let j=A=class{static from(...U){let ne=U;return new A(function(){if(ne){for(const we of ne)we&&typeof we.dispose=="function"&&we.dispose();ne=void 0}})}constructor(U){a.set(this,void 0),Je(this,a,U,"f")}dispose(){typeof Le(this,a,"f")=="function"&&(Le(this,a,"f").call(this),Je(this,a,void 0,"f"))}};a=new WeakMap,j=A=qe([P],j),e.Disposable=j;let le=v=class{static Min(...U){if(U.length===0)throw new TypeError;let ne=U[0];for(let we=1;we<U.length;we++){const xe=U[we];xe.isBefore(ne)&&(ne=xe)}return ne}static Max(...U){if(U.length===0)throw new TypeError;let ne=U[0];for(let we=1;we<U.length;we++){const xe=U[we];xe.isAfter(ne)&&(ne=xe)}return ne}static isPosition(U){if(!U)return!1;if(U instanceof v)return!0;const{line:ne,character:we}=U;return typeof ne=="number"&&typeof we=="number"}static of(U){if(U instanceof v)return U;if(this.isPosition(U))return new v(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(U,ne){if(U<0)throw(0,C.illegalArgument)("line must be non-negative");if(ne<0)throw(0,C.illegalArgument)("character must be non-negative");this.c=U,this.e=ne}isBefore(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<U.e}isBeforeOrEqual(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<=U.e}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this.c===U.c&&this.e===U.e}compareTo(U){return this.c<U.c?-1:this.c>U.line?1:this.e<U.e?-1:this.e>U.e?1:0}translate(U,ne=0){if(U===null||ne===null)throw(0,C.illegalArgument)();let we;return typeof U>"u"?we=0:typeof U=="number"?we=U:(we=typeof U.lineDelta=="number"?U.lineDelta:0,ne=typeof U.characterDelta=="number"?U.characterDelta:0),we===0&&ne===0?this:new v(this.line+we,this.character+ne)}with(U,ne=this.character){if(U===null||ne===null)throw(0,C.illegalArgument)();let we;return typeof U>"u"?we=this.line:typeof U=="number"?we=U:(we=typeof U.line=="number"?U.line:this.line,ne=typeof U.character=="number"?U.character:this.character),we===this.line&&ne===this.character?this:new v(we,ne)}toJSON(){return{line:this.line,character:this.character}}};le=v=qe([P],le),e.Position=le;let _=t=class{static isRange(U){return U instanceof t?!0:U?le.isPosition(U.start)&&le.isPosition(U.end):!1}static of(U){if(U instanceof t)return U;if(this.isRange(U))return new t(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(U,ne,we,xe){let Ye,at;if(typeof U=="number"&&typeof ne=="number"&&typeof we=="number"&&typeof xe=="number"?(Ye=new le(U,ne),at=new le(we,xe)):le.isPosition(U)&&le.isPosition(ne)&&(Ye=le.of(U),at=le.of(ne)),!Ye||!at)throw new Error("Invalid arguments");Ye.isBefore(at)?(this.c=Ye,this.e=at):(this.c=at,this.e=Ye)}contains(U){return t.isRange(U)?this.contains(U.start)&&this.contains(U.end):le.isPosition(U)?!(le.of(U).isBefore(this.c)||this.e.isBefore(U)):!1}isEqual(U){return this.c.isEqual(U.c)&&this.e.isEqual(U.e)}intersection(U){const ne=le.Max(U.start,this.c),we=le.Min(U.end,this.e);if(!ne.isAfter(we))return new t(ne,we)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const ne=le.Min(U.start,this.c),we=le.Max(U.end,this.end);return new t(ne,we)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(U,ne=this.end){if(U===null||ne===null)throw(0,C.illegalArgument)();let we;return U?le.isPosition(U)?we=U:(we=U.start||this.start,ne=U.end||this.end):we=this.start,we.isEqual(this.c)&&ne.isEqual(this.end)?this:new t(we,ne)}toJSON(){return[this.start,this.end]}};_=t=qe([P],_),e.Range=_;let be=h=class extends _{static isSelection(U){return U instanceof h?!0:U?_.isRange(U)&&le.isPosition(U.anchor)&&le.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(U,ne,we,xe){let Ye,at;if(typeof U=="number"&&typeof ne=="number"&&typeof we=="number"&&typeof xe=="number"?(Ye=new le(U,ne),at=new le(we,xe)):le.isPosition(U)&&le.isPosition(ne)&&(Ye=le.of(U),at=le.of(ne)),!Ye||!at)throw new Error("Invalid arguments");super(Ye,at),this.f=Ye,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};be=h=qe([P],be),e.Selection=be;class de{constructor(U,ne,we){if(typeof U!="string"||U.length===0)throw(0,C.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,C.illegalArgument)("port");if(typeof we<"u"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z_\-]+$/.test(we)))throw(0,C.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(ne),this.connectionToken=we}}e.ResolvedAuthority=de;class ue extends Error{static NotAvailable(U,ne){return new ue(U,f.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(U){return new ue(U,f.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,ne=f.RemoteAuthorityResolverErrorCode.Unknown,we){super(U),this._message=U,this._code=ne,this._detail=we,Object.setPrototypeOf(this,ue.prototype)}}e.RemoteAuthorityResolverError=ue;var se;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(se=e.EndOfLine||(e.EndOfLine={}));var Z;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(Z=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let X=r=class{static isTextEdit(U){return U instanceof r?!0:U?_.isRange(U)&&typeof U.newText=="string":!1}static replace(U,ne){return new r(U,ne)}static insert(U,ne){return r.replace(new _(U,U),ne)}static delete(U){return r.replace(U,"")}static setEndOfLine(U){const ne=new r(new _(new le(0,0),new le(0,0)),"");return ne.newEol=U,ne}get range(){return this.c}set range(U){if(U&&!_.isRange(U))throw(0,C.illegalArgument)("range");this.c=U}get newText(){return this.e||""}set newText(U){if(U&&typeof U!="string")throw(0,C.illegalArgument)("newText");this.e=U}get newEol(){return this.f}set newEol(U){if(U&&typeof U!="number")throw(0,C.illegalArgument)("newEol");this.f=U}constructor(U,ne){this.c=U,this.e=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};X=r=qe([P],X),e.TextEdit=X;let ee=u=class{static isNotebookCellEdit(U){return U instanceof u?!0:U?Kt.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,ne){return new u(U,ne)}static insertCells(U,ne){return new u(new Kt(U,U),ne)}static deleteCells(U){return new u(U,[])}static updateCellMetadata(U,ne){const we=new u(new Kt(U,U),[]);return we.newCellMetadata=ne,we}static updateNotebookMetadata(U){const ne=new u(new Kt(0,0),[]);return ne.newNotebookMetadata=U,ne}constructor(U,ne){this.range=U,this.newCells=ne}};ee=u=qe([P],ee),e.NotebookEdit=ee;class he{static isSnippetTextEdit(U){return U instanceof he?!0:U?_.isRange(U.range)&&Ke.isSnippetString(U.snippet):!1}static replace(U,ne){return new he(U,ne)}static insert(U,ne){return he.replace(new _(U,U),ne)}constructor(U,ne){this.range=U,this.snippet=ne}}e.SnippetTextEdit=he;var Te;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(Te=e.FileEditType||(e.FileEditType={}));let Ne=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(U,ne,we,xe){this.c.push({_type:1,from:U,to:ne,options:we,metadata:xe})}createFile(U,ne,we){this.c.push({_type:1,from:void 0,to:U,options:ne,metadata:we})}deleteFile(U,ne,we){this.c.push({_type:1,from:U,to:void 0,options:ne,metadata:we})}e(U,ne,we){this.c.push({_type:3,metadata:we,uri:U,edit:{editType:5,metadata:ne},notebookMetadata:ne})}f(U,ne,we,xe){const Ye=ne.start,at=ne.end;(Ye!==at||we.length>0)&&this.c.push({_type:5,uri:U,index:Ye,count:at-Ye,cells:we,metadata:xe})}g(U,ne,we,xe){this.c.push({_type:3,metadata:xe,uri:U,edit:{editType:8,index:ne,metadata:we}})}replace(U,ne,we,xe){this.c.push({_type:2,uri:U,edit:new X(ne,we),metadata:xe})}insert(U,ne,we,xe){this.replace(U,new _(ne,ne),we,xe)}delete(U,ne,we){this.replace(U,ne,"",we)}has(U){return this.c.some(ne=>ne._type===2&&ne.uri.toString()===U.toString())}set(U,ne){if(ne)for(const we of ne){if(!we)continue;let xe,Ye;Array.isArray(we)?(xe=we[0],Ye=we[1]):xe=we,ee.isNotebookCellEdit(xe)?xe.newCellMetadata?this.g(U,xe.range.start,xe.newCellMetadata,Ye):xe.newNotebookMetadata?this.e(U,xe.newNotebookMetadata,Ye):this.f(U,xe.range,xe.newCells,Ye):he.isSnippetTextEdit(xe)?this.c.push({_type:6,uri:U,range:xe.range,edit:xe.snippet,metadata:Ye}):this.c.push({_type:2,uri:U,edit:xe,metadata:Ye})}else{for(let we=0;we<this.c.length;we++){const xe=this.c[we];switch(xe._type){case 2:case 6:case 3:case 5:xe.uri.toString()===U.toString()&&(this.c[we]=void 0);break}}(0,n.coalesceInPlace)(this.c)}}get(U){const ne=[];for(const we of this.c)we._type===2&&we.uri.toString()===U.toString()&&ne.push(we.edit);return ne}entries(){const U=new M.ResourceMap;for(const ne of this.c)if(ne._type===2){let we=U.get(ne.uri);we||(we=[ne.uri,[]],U.set(ne.uri,we)),we[1].push(ne.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Ne=qe([P],Ne),e.WorkspaceEdit=Ne;let Ke=i=class{static isSnippetString(U){return U instanceof i?!0:U?typeof U.value=="string":!1}static c(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this.e=1,this.value=U||""}appendText(U){return this.value+=i.c(U),this}appendTabstop(U=this.e++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,ne=this.e++){if(typeof U=="function"){const we=new i;we.e=this.e,U(we),this.e=we.e,U=we.value}else U=i.c(U);return this.value+="${",this.value+=ne,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,ne=this.e++){const we=U.map(xe=>xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(U,ne){if(typeof ne=="function"){const we=new i;we.e=this.e,ne(we),this.e=we.e,ne=we.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};Ke=i=qe([P],Ke),e.SnippetString=Ke;var Pe;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(Pe=e.DiagnosticTag||(e.DiagnosticTag={}));var Se;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(Se=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Ie=p=class{static isLocation(U){return U instanceof p?!0:U?_.isRange(U.range)&&k.URI.isUri(U.uri):!1}constructor(U,ne){if(this.uri=U,ne)if(_.isRange(ne))this.range=_.of(ne);else if(le.isPosition(ne))this.range=new _(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};Ie=p=qe([P],Ie),e.Location=Ie;let oe=class{static is(U){return U?typeof U.message=="string"&&U.location&&_.isRange(U.location.range)&&k.URI.isUri(U.location.uri):!1}constructor(U,ne){this.location=U,this.message=ne}static isEqual(U,ne){return U===ne?!0:!U||!ne?!1:U.message===ne.message&&U.location.range.isEqual(ne.location.range)&&U.location.uri.toString()===ne.location.uri.toString()}};oe=qe([P],oe),e.DiagnosticRelatedInformation=oe;let ce=class{constructor(U,ne,we=Se.Error){if(!_.isRange(U))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=U,this.message=ne,this.severity=we}toJSON(){return{severity:Se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,ne){return U===ne?!0:!U||!ne?!1:U.message===ne.message&&U.severity===ne.severity&&U.code===ne.code&&U.severity===ne.severity&&U.source===ne.source&&U.range.isEqual(ne.range)&&(0,n.equals)(U.tags,ne.tags)&&(0,n.equals)(U.relatedInformation,ne.relatedInformation,oe.isEqual)}};ce=qe([P],ce),e.Diagnostic=ce;let Y=class{constructor(U,ne){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=ne}};Y=qe([P],Y),e.Hover=Y;var I;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(I=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let $=class{constructor(U,ne=I.Text){this.range=U,this.kind=ne}toJSON(){return{range:this.range,kind:I[this.kind]}}};$=qe([P],$),e.DocumentHighlight=$;var W;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(W=e.SymbolKind||(e.SymbolKind={}));var q;(function(z){z[z.Deprecated=1]="Deprecated"})(q=e.SymbolTag||(e.SymbolTag={}));let ie=c=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,ne,we,xe,Ye){this.name=U,this.kind=ne,this.containerName=Ye,typeof we=="string"&&(this.containerName=we),xe instanceof Ie?this.location=xe:we instanceof _&&(this.location=new Ie(xe,we)),c.validate(this)}toJSON(){return{name:this.name,kind:W[this.kind],location:this.location,containerName:this.containerName}}};ie=c=qe([P],ie),e.SymbolInformation=ie;let fe=s=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(s.validate)}constructor(U,ne,we,xe,Ye){this.name=U,this.detail=ne,this.kind=we,this.range=xe,this.selectionRange=Ye,this.children=[],s.validate(this)}};fe=s=qe([P],fe),e.DocumentSymbol=fe;var ye;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(ye=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(U,ne){this.title=U,this.kind=ne}};ae=qe([P],ae),e.CodeAction=ae;let ve=d=class{constructor(U){this.value=U}append(U){return new d(this.value?this.value+d.c+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+d.c)}};ve.c=".",ve=d=qe([P],ve),e.CodeActionKind=ve,ve.Empty=new ve(""),ve.QuickFix=ve.Empty.append("quickfix"),ve.Refactor=ve.Empty.append("refactor"),ve.RefactorExtract=ve.Refactor.append("extract"),ve.RefactorInline=ve.Refactor.append("inline"),ve.RefactorMove=ve.Refactor.append("move"),ve.RefactorRewrite=ve.Refactor.append("rewrite"),ve.Source=ve.Empty.append("source"),ve.SourceOrganizeImports=ve.Source.append("organizeImports"),ve.SourceFixAll=ve.Source.append("fixAll");let Ee=class{constructor(U,ne){if(this.range=U,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ee=qe([P],Ee),e.SelectionRange=Ee;class We{constructor(U,ne,we,xe,Ye,at){this.kind=U,this.name=ne,this.detail=we,this.uri=xe,this.range=Ye,this.selectionRange=at}}e.CallHierarchyItem=We;class He{constructor(U,ne){this.fromRanges=ne,this.from=U}}e.CallHierarchyIncomingCall=He;class tt{constructor(U,ne){this.fromRanges=ne,this.to=U}}e.CallHierarchyOutgoingCall=tt;var Xe;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(Xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(U,ne){this.range=U,this.command=ne}get isResolved(){return!!this.command}};et=qe([P],et),e.CodeLens=et;let it=T=class{static isMarkdownString(U){return U instanceof T?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,ne=!1){o.set(this,void 0),Je(this,o,new D.MarkdownString(U,{supportThemeIcons:ne}),"f")}get value(){return Le(this,o,"f").value}set value(U){Le(this,o,"f").value=U}get isTrusted(){return Le(this,o,"f").isTrusted}set isTrusted(U){Le(this,o,"f").isTrusted=U}get supportThemeIcons(){return Le(this,o,"f").supportThemeIcons}set supportThemeIcons(U){Le(this,o,"f").supportThemeIcons=U}get supportHtml(){return Le(this,o,"f").supportHtml}set supportHtml(U){Le(this,o,"f").supportHtml=U}get baseUri(){return Le(this,o,"f").baseUri}set baseUri(U){Le(this,o,"f").baseUri=U}appendText(U){return Le(this,o,"f").appendText(U),this}appendMarkdown(U){return Le(this,o,"f").appendMarkdown(U),this}appendCodeblock(U,ne){return Le(this,o,"f").appendCodeblock(ne??"",U),this}};o=new WeakMap,it=T=qe([P],it),e.MarkdownString=it;let dt=class{constructor(U,ne){this.label=U,this.documentation=ne}};dt=qe([P],dt),e.ParameterInformation=dt;let Fe=class{constructor(U,ne){this.label=U,this.documentation=ne,this.parameters=[]}};Fe=qe([P],Fe),e.SignatureInformation=Fe;let ot=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ot=qe([P],ot),e.SignatureHelp=ot;var Q;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(Q=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var G;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(G=e.InlayHintKind||(e.InlayHintKind={}));let pe=class{constructor(U){this.value=U}};pe=qe([P],pe),e.InlayHintLabelPart=pe;let Me=class{constructor(U,ne,we){this.position=U,this.label=ne,this.kind=we}};Me=qe([P],Me),e.InlayHint=Me;var ze;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ve;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(Ve=e.CompletionItemKind||(e.CompletionItemKind={}));var _e;(function(z){z[z.Deprecated=1]="Deprecated"})(_e=e.CompletionItemTag||(e.CompletionItemTag={}));let nt=class{constructor(U,ne){this.label=U,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&Ve[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};nt=qe([P],nt),e.CompletionItem=nt;let vt=class{constructor(U=[],ne=!1){this.items=U,this.isIncomplete=ne}};vt=qe([P],vt),e.CompletionList=vt;let wt=class{constructor(U,ne,we){this.insertText=U,this.range=ne,this.command=we}};wt=qe([P],wt),e.InlineSuggestion=wt;let Ct=class{constructor(U){this.commands=void 0,this.items=U}};Ct=qe([P],Ct),e.InlineSuggestionList=Ct;var jt;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(jt=e.ViewColumn||(e.ViewColumn={}));var rt;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(rt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var mt;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(mt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ft;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Ft=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Gt;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Gt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Pt;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ht;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(ht=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var kt;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(kt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function U(ne){switch(ne){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=U}(Pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let $t=class{constructor(U,ne){if(ne&&!k.URI.isUri(ne))throw(0,C.illegalArgument)("target");if(!_.isRange(U)||U.isEmpty)throw(0,C.illegalArgument)("range");this.range=U,this.target=ne}};$t=qe([P],$t),e.DocumentLink=$t;let Ot=class{constructor(U,ne,we,xe){this.red=U,this.green=ne,this.blue=we,this.alpha=xe}};Ot=qe([P],Ot),e.Color=Ot;let Ge=class{constructor(U,ne){if(ne&&!(ne instanceof Ot))throw(0,C.illegalArgument)("color");if(!_.isRange(U)||U.isEmpty)throw(0,C.illegalArgument)("range");this.range=U,this.color=ne}};Ge=qe([P],Ge),e.ColorInformation=Ge;let Nt=class{constructor(U){if(!U||typeof U!="string")throw(0,C.illegalArgument)("label");this.label=U}};Nt=qe([P],Nt),e.ColorPresentation=Nt;var Mt;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(Mt=e.ColorFormat||(e.ColorFormat={}));var zt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(zt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var ft;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(ft=e.TerminalExitReason||(e.TerminalExitReason={}));class De{constructor(U,ne,we){if(this.startIndex=U,this.length=ne,this.tooltip=we,typeof U!="number"||U<0)throw(0,C.illegalArgument)("startIndex");if(typeof ne!="number"||ne<1)throw(0,C.illegalArgument)("length");if(we!==void 0&&typeof we!="string")throw(0,C.illegalArgument)("tooltip")}}e.TerminalLink=De;class Ae{constructor(U){this.uri=U}}e.TerminalQuickFixOpener=Ae;class ge{constructor(U){this.terminalCommand=U}}e.TerminalQuickFixCommand=ge;var x;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(x=e.TerminalLocation||(e.TerminalLocation={}));class Re{constructor(U){if(this.options=U,typeof U!="object")throw(0,C.illegalArgument)("options")}}e.TerminalProfile=Re;var $e;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})($e=e.TaskRevealKind||(e.TaskRevealKind={}));var Qe;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(Qe=e.TaskPanelKind||(e.TaskPanelKind={}));let Be=O=class{static from(U){switch(U){case"clean":return O.Clean;case"build":return O.Build;case"rebuild":return O.Rebuild;case"test":return O.Test;default:return}}constructor(U,ne){if(this.label=ne,typeof U!="string"||typeof ne!="string")throw(0,C.illegalArgument)("name");this.c=U}get id(){return this.c}};Be.Clean=new O("clean","Clean"),Be.Build=new O("build","Build"),Be.Rebuild=new O("rebuild","Rebuild"),Be.Test=new O("test","Test"),Be=O=qe([P],Be),e.TaskGroup=Be;function Ze(z){let U="";for(let ne=0;ne<z.length;ne++)U+=z[ne].replace(/,/g,",,")+",";return U}let ct=class{constructor(U,ne,we){if(typeof U!="string")throw(0,C.illegalArgument)("process");this.e=[],this.c=U,ne!==void 0&&(Array.isArray(ne)?(this.e=ne,this.f=we):this.f=ne)}get process(){return this.c}set process(U){if(typeof U!="string")throw(0,C.illegalArgument)("process");this.c=U}get args(){return this.e}set args(U){Array.isArray(U)||(U=[]),this.e=U}get options(){return this.f}set options(U){this.f=U}computeId(){const U=[];if(U.push("process"),this.c!==void 0&&U.push(this.c),this.e&&this.e.length>0)for(const ne of this.e)U.push(ne);return Ze(U)}};ct=qe([P],ct),e.ProcessExecution=ct;let Tt=class{constructor(U,ne,we){if(this.f=[],Array.isArray(ne)){if(!U)throw(0,C.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,C.illegalArgument)("command");this.e=U,this.f=ne,this.g=we}else{if(typeof U!="string")throw(0,C.illegalArgument)("commandLine");this.c=U,this.g=ne}}get commandLine(){return this.c}set commandLine(U){if(typeof U!="string")throw(0,C.illegalArgument)("commandLine");this.c=U}get command(){return this.e?this.e:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,C.illegalArgument)("command");this.e=U}get args(){return this.f}set args(U){this.f=U||[]}get options(){return this.g}set options(U){this.g=U}computeId(){const U=[];if(U.push("shell"),this.c!==void 0&&U.push(this.c),this.e!==void 0&&U.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ne of this.f)U.push(typeof ne=="string"?ne:ne.value);return Ze(U)}};Tt=qe([P],Tt),e.ShellExecution=Tt;var bt;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(bt=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class It{constructor(U){this.c=U}computeId(){return"customExecution"+(0,N.generateUuid)()}set callback(U){this.c=U}get callback(){return this.c}}e.CustomExecution=It;let St=H=class{constructor(U,ne,we,xe,Ye,at){this.j=!1,this.k=this.definition=U;let lt;typeof ne=="string"?(this.m=this.name=ne,this.t=this.source=we,this.execution=xe,lt=Ye,this.j=!0):ne===Et.Global||ne===Et.Workspace?(this.target=ne,this.m=this.name=we,this.t=this.source=xe,this.execution=Ye,lt=at):(this.target=ne,this.m=this.name=we,this.t=this.source=xe,this.execution=Ye,lt=at),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(U){this.h=U}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof ct?this.k={type:H.e,id:this.n.computeId()}:this.n instanceof Tt?this.k={type:H.f,id:this.n.computeId()}:this.n instanceof It?this.k={type:H.c,id:this.n.computeId()}:this.k={type:H.g,id:(0,N.generateUuid)()}}get definition(){return this.k}set definition(U){if(U==null)throw(0,C.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=U}get scope(){return this.l}set target(U){this.y(),this.l=U}get name(){return this.m}set name(U){if(typeof U!="string")throw(0,C.illegalArgument)("name");this.y(),this.m=U}get execution(){return this.n}set execution(U){U===null&&(U=void 0),this.y(),this.n=U;const ne=this.k.type;(H.g===ne||H.e===ne||H.f===ne||H.c===ne)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(U){if(Array.isArray(U))this.y(),this.o=U,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.y(),this.r=U}get source(){return this.t}set source(U){if(typeof U!="string"||U.length===0)throw(0,C.illegalArgument)("source must be a string of length > 0");this.y(),this.t=U}get group(){return this.u}set group(U){U===null&&(U=void 0),this.y(),this.u=U}get detail(){return this.x}set detail(U){U===null&&(U=void 0),this.x=U}get presentationOptions(){return this.v}set presentationOptions(U){U==null&&(U=Object.create(null)),this.y(),this.v=U}get runOptions(){return this.w}set runOptions(U){U==null&&(U=Object.create(null)),this.y(),this.w=U}};St.c="customExecution",St.e="process",St.f="shell",St.g="$empty",St=H=qe([P],St),e.Task=St;var yt;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(yt=e.ProgressLocation||(e.ProgressLocation={}));var qt;(function(z){function U(ne){const we=ne;return(0,y.isNumber)(we.value)?we.tooltip&&!(0,y.isString)(we.tooltip)?(console.log("INVALID view badge, invalid tooltip",we.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",we.value),!1)}z.isViewBadge=U})(qt=e.ViewBadge||(e.ViewBadge={}));let Jt=J=class{static isTreeItem(U,ne){if(U instanceof J)return!0;const we=U;if(we.label!==void 0&&!(0,y.isString)(we.label)&&!we.label?.label)return console.log("INVALID tree item, invalid label",we.label),!1;if(we.id!==void 0&&!(0,y.isString)(we.id))return console.log("INVALID tree item, invalid id",we.id),!1;if(we.iconPath!==void 0&&!(0,y.isString)(we.iconPath)&&!k.URI.isUri(we.iconPath)&&(!we.iconPath||!(0,y.isString)(we.iconPath.id))){const xe=we.iconPath;if(!xe||!(0,y.isString)(xe.light)&&!k.URI.isUri(xe.light)&&!(0,y.isString)(xe.dark)&&!k.URI.isUri(xe.dark))return console.log("INVALID tree item, invalid iconPath",we.iconPath),!1}if(we.description!==void 0&&!(0,y.isString)(we.description)&&typeof we.description!="boolean")return console.log("INVALID tree item, invalid description",we.description),!1;if(we.resourceUri!==void 0&&!k.URI.isUri(we.resourceUri))return console.log("INVALID tree item, invalid resourceUri",we.resourceUri),!1;if(we.tooltip!==void 0&&!(0,y.isString)(we.tooltip)&&!(we.tooltip instanceof it))return console.log("INVALID tree item, invalid tooltip",we.tooltip),!1;if(we.command!==void 0&&!we.command.command)return console.log("INVALID tree item, invalid command",we.command),!1;if(we.collapsibleState!==void 0&&we.collapsibleState<pt.None&&we.collapsibleState>pt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",we.collapsibleState),!1;if(we.contextValue!==void 0&&!(0,y.isString)(we.contextValue))return console.log("INVALID tree item, invalid contextValue",we.contextValue),!1;if(we.accessibilityInformation!==void 0&&!we.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",we.accessibilityInformation),!1;if(we.checkboxState!==void 0){(0,m.checkProposedApiEnabled)(ne,"treeItemCheckbox");const xe=(0,y.isNumber)(we.checkboxState)?we.checkboxState:(0,y.isObject)(we.checkboxState)&&(0,y.isNumber)(we.checkboxState.state)?we.checkboxState.state:void 0,Ye=!(0,y.isNumber)(we.checkboxState)&&(0,y.isObject)(we.checkboxState)?we.checkboxState.tooltip:void 0;if(xe===void 0||xe!==si.Checked&&xe!==si.Unchecked||Ye!==void 0&&!(0,y.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",we.checkboxState),!1}return!0}constructor(U,ne=pt.None){this.collapsibleState=ne,k.URI.isUri(U)?this.resourceUri=U:this.label=U}};Jt=J=qe([P],Jt),e.TreeItem=Jt;var pt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(pt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var si;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(si=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let oi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U,ne){this.value=U,this.id=ne??(0,N.generateUuid)()}};oi=qe([P],oi),e.DataTransferItem=oi;let Zt=class{constructor(U){l.set(this,new Map);for(const[ne,we]of U??[]){const xe=Le(this,l,"f").get(ne);xe?xe.push(we):Le(this,l,"f").set(ne,[we])}}get(U){return Le(this,l,"f").get(U)?.[0]}set(U,ne){Le(this,l,"f").set(U,[ne])}forEach(U,ne){for(const[we,xe]of Le(this,l,"f"))for(const Ye of xe)U.call(ne,Ye,we,this)}*[(l=new WeakMap,Symbol.iterator)](){for(const[U,ne]of Le(this,l,"f"))for(const we of ne)yield[U,we]}};Zt=qe([P],Zt),e.DataTransfer=Zt;let vi=class{constructor(U){this.insertText=U}};vi=qe([P],vi),e.DocumentDropEdit=vi;let At=class{constructor(U){this.insertText=U}};At=qe([P],At),e.DocumentPasteEdit=At;let Wt=class{constructor(U,ne){this.id=U,this.color=ne}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};Wt=qe([P],Wt),e.ThemeIcon=Wt,Wt.File=new Wt("file"),Wt.Folder=new Wt("folder");let bi=class{constructor(U){this.id=U}};bi=qe([P],bi),e.ThemeColor=bi;var ai;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(ai=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ei=class{get base(){return this.c}set base(U){this.c=U,this.e=k.URI.file(U)}get baseUri(){return this.e}set baseUri(U){this.e=U,this.c=U.fsPath}constructor(U,ne){if(typeof U!="string"&&(!U||!k.URI.isUri(U)&&!k.URI.isUri(U.uri)))throw(0,C.illegalArgument)("base");if(typeof ne!="string")throw(0,C.illegalArgument)("pattern");typeof U=="string"?this.baseUri=k.URI.file(U):k.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ei=qe([P],ei),e.RelativePattern=ei;const ut=new WeakMap;function $i(z,U){ut.set(z,U)}e.setBreakpointId=$i;let Ut=class{constructor(U,ne,we,xe){this.enabled=typeof U=="boolean"?U:!0,typeof ne=="string"&&(this.condition=ne),typeof we=="string"&&(this.hitCondition=we),typeof xe=="string"&&(this.logMessage=xe)}get id(){return this.c||(this.c=ut.get(this)??(0,N.generateUuid)()),this.c}};Ut=qe([P],Ut),e.Breakpoint=Ut;let Qt=class extends Ut{constructor(U,ne,we,xe,Ye){if(super(ne,we,xe,Ye),U===null)throw(0,C.illegalArgument)("location");this.location=U}};Qt=qe([P],Qt),e.SourceBreakpoint=Qt;let ci=class extends Ut{constructor(U,ne,we,xe,Ye){super(ne,we,xe,Ye),this.functionName=U}};ci=qe([P],ci),e.FunctionBreakpoint=ci;let Ei=class extends Ut{constructor(U,ne,we,xe,Ye,at,lt){if(super(xe,Ye,at,lt),!ne)throw(0,C.illegalArgument)("dataId");this.label=U,this.dataId=ne,this.canPersist=we}};Ei=qe([P],Ei),e.DataBreakpoint=Ei;let wi=class{constructor(U,ne,we){this.command=U,this.args=ne||[],this.options=we}};wi=qe([P],wi),e.DebugAdapterExecutable=wi;let ui=class{constructor(U,ne){this.port=U,this.host=ne}};ui=qe([P],ui),e.DebugAdapterServer=ui;let Si=class{constructor(U){this.path=U}};Si=qe([P],Si),e.DebugAdapterNamedPipeServer=Si;let li=class{constructor(U){this.implementation=U}};li=qe([P],li),e.DebugAdapterInlineImplementation=li;let ti=class{constructor(U,ne){this.range=U,this.expression=ne}};ti=qe([P],ti),e.EvaluatableExpression=ti;var Bi;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Bi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ii=class{constructor(U,ne){this.range=U,this.text=ne}};ii=qe([P],ii),e.InlineValueText=ii;let ni=class{constructor(U,ne,we=!0){this.range=U,this.variableName=ne,this.caseSensitiveLookup=we}};ni=qe([P],ni),e.InlineValueVariableLookup=ni;let yi=class{constructor(U,ne){this.range=U,this.expression=ne}};yi=qe([P],yi),e.InlineValueEvaluatableExpression=yi;let Di=class{constructor(U,ne){this.frameId=U,this.stoppedLocation=ne}};Di=qe([P],Di),e.InlineValueContext=Di;var ri;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(ri=e.FileChangeType||(e.FileChangeType={}));let Ii=K=class extends Error{static FileExists(U){return new K(U,w.FileSystemProviderErrorCode.FileExists,K.FileExists)}static FileNotFound(U){return new K(U,w.FileSystemProviderErrorCode.FileNotFound,K.FileNotFound)}static FileNotADirectory(U){return new K(U,w.FileSystemProviderErrorCode.FileNotADirectory,K.FileNotADirectory)}static FileIsADirectory(U){return new K(U,w.FileSystemProviderErrorCode.FileIsADirectory,K.FileIsADirectory)}static NoPermissions(U){return new K(U,w.FileSystemProviderErrorCode.NoPermissions,K.NoPermissions)}static Unavailable(U){return new K(U,w.FileSystemProviderErrorCode.Unavailable,K.Unavailable)}constructor(U,ne=w.FileSystemProviderErrorCode.Unknown,we){super(k.URI.isUri(U)?U.toString(!0):U),this.code=we?.name??"Unknown",(0,w.markAsFileSystemProviderError)(this,ne),Object.setPrototypeOf(this,K.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}};Ii=K=qe([P],Ii),e.FileSystemError=Ii;let Ci=class{constructor(U,ne,we){this.start=U,this.end=ne,this.kind=we}};Ci=qe([P],Ci),e.FoldingRange=Ci;var zi;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(zi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Wi;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Hi;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Hi=e.CommentMode||(e.CommentMode={}));var ki;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(ki=e.CommentThreadState||(e.CommentThreadState={}));class Ri{constructor(U,ne=[]){this.tokenTypes=U,this.tokenModifiers=ne}}e.SemanticTokensLegend=Ri;function Oi(z){return typeof z>"u"||(0,y.isStringArray)(z)}class Ue{constructor(U){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,U){this.l=!0;for(let ne=0,we=U.tokenTypes.length;ne<we;ne++)this.j.set(U.tokenTypes[ne],ne);for(let ne=0,we=U.tokenModifiers.length;ne<we;ne++)this.k.set(U.tokenModifiers[ne],ne)}}push(U,ne,we,xe,Ye){if(typeof U=="number"&&typeof ne=="number"&&typeof we=="number"&&typeof xe=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(U,ne,we,xe,Ye);if(_.isRange(U)&&typeof ne=="string"&&Oi(we))return this.m(U,ne,we);throw(0,C.illegalArgument)()}m(U,ne,we){if(!this.l)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ne))throw new Error("`tokenType` is not in the provided legend");const xe=U.start.line,Ye=U.start.character,at=U.end.character-U.start.character,lt=this.j.get(ne);let Lt=0;if(we)for(const Vt of we){if(!this.k.has(Vt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this.k.get(Vt);Lt|=1<<xt>>>0}this.n(xe,Ye,at,lt,Lt)}n(U,ne,we,xe,Ye){if(this.f&&(U<this.c||U===this.c&&ne<this.e)){this.f=!1;const Lt=this.g.length/5|0;let Vt=0,xt=0;for(let Xt=0;Xt<Lt;Xt++){let _t=this.g[5*Xt],Pi=this.g[5*Xt+1];_t===0?(_t=Vt,Pi+=xt):_t+=Vt,this.g[5*Xt]=_t,this.g[5*Xt+1]=Pi,Vt=_t,xt=Pi}}let at=U,lt=ne;this.f&&this.h>0&&(at-=this.c,at===0&&(lt-=this.e)),this.g[this.h++]=at,this.g[this.h++]=lt,this.g[this.h++]=we,this.g[this.h++]=xe,this.g[this.h++]=Ye,this.c=U,this.e=ne}static o(U){const ne=[],we=U.length/5|0;for(let lt=0;lt<we;lt++)ne[lt]=lt;ne.sort((lt,Lt)=>{const Vt=U[5*lt],xt=U[5*Lt];if(Vt===xt){const Xt=U[5*lt+1],_t=U[5*Lt+1];return Xt-_t}return Vt-xt});const xe=new Uint32Array(U.length);let Ye=0,at=0;for(let lt=0;lt<we;lt++){const Lt=5*ne[lt],Vt=U[Lt+0],xt=U[Lt+1],Xt=U[Lt+2],_t=U[Lt+3],Pi=U[Lt+4],sn=Vt-Ye,Rn=sn===0?xt-at:xt,Ai=5*lt;xe[Ai+0]=sn,xe[Ai+1]=Rn,xe[Ai+2]=Xt,xe[Ai+3]=_t,xe[Ai+4]=Pi,Ye=Vt,at=xt}return xe}build(U){return this.f?new Ht(new Uint32Array(this.g),U):new Ht(Ue.o(this.g),U)}}e.SemanticTokensBuilder=Ue;class Ht{constructor(U,ne){this.resultId=ne,this.data=U}}e.SemanticTokens=Ht;class Li{constructor(U,ne,we){this.start=U,this.deleteCount=ne,this.data=we}}e.SemanticTokensEdit=Li;class gt{constructor(U,ne){this.resultId=ne,this.edits=U}}e.SemanticTokensEdits=gt;var Vi;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Vi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let di=class{constructor(){}};di.Back={iconPath:new Wt("arrow-left")},di=qe([P],di),e.QuickInputButtons=di;var Fi;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(Fi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ji;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(ji=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var hi;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(hi=e.ExtensionKind||(e.ExtensionKind={}));class qi{static validate(U){if(typeof U.badge=="string"){let ne=(0,R.nextCharLength)(U.badge,0);if(ne<U.badge.length&&(ne+=(0,R.nextCharLength)(U.badge,ne)),U.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!Wt.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,ne,we){this.badge=U,this.tooltip=ne,this.color=we}}e.FileDecoration=qi;let Ti=class{constructor(U){this.kind=U}};Ti=qe([P],Ti),e.ColorTheme=Ti;var Ki;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(Ki=e.ColorThemeKind||(e.ColorThemeKind={}));class Kt{static isNotebookRange(U){return U instanceof Kt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(U,ne){if(U<0)throw(0,C.illegalArgument)("start must be positive");if(ne<0)throw(0,C.illegalArgument)("end must be positive");U<=ne?(this.c=U,this.e=ne):(this.c=ne,this.e=U)}with(U){let ne=this.c,we=this.e;return U.start!==void 0&&(ne=U.start),U.end!==void 0&&(we=U.end),ne===this.c&&we===this.e?this:new Kt(ne,we)}}e.NotebookRange=Kt;class fi{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(ne=>fi.isNotebookCellData(ne))}static isNotebookCellData(U){return!0}constructor(U,ne,we,xe,Ye,at,lt){this.kind=U,this.value=ne,this.languageId=we,this.mime=xe,this.outputs=Ye??[],this.metadata=at,this.executionSummary=lt,fi.validate(this)}}e.NotebookCellData=fi;class xi{constructor(U){this.cells=U}}e.NotebookData=xi;class Bt{static isNotebookCellOutputItem(U){return U instanceof Bt?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const ne={name:U.name,message:U.message,stack:U.stack};return Bt.json(ne,"application/vnd.code.notebook.error")}static stdout(U){return Bt.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return Bt.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,ne="application/octet-stream"){return new Bt(U,ne)}static text(U,ne=S.Mimes.text){const we=Le(Bt,g,"f",E).encode(String(U));return new Bt(we,ne)}static json(U,ne="text/x-json"){const we=JSON.stringify(U,void 0,"	");return Bt.text(we,ne)}constructor(U,ne){this.data=U,this.mime=ne;const we=(0,S.normalizeMimeType)(ne,!0);if(!we)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}}g=Bt,E={value:new TextEncoder},e.NotebookCellOutputItem=Bt;class mi{static isNotebookCellOutput(U){return U instanceof mi?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,ne=!1){const we=new Set,xe=new Set;for(let Ye=0;Ye<U.length;Ye++){const at=U[Ye],lt=(0,S.normalizeMimeType)(at.mime);if(!we.has(lt)||(0,b.isTextStreamMime)(lt)){we.add(lt);continue}xe.add(Ye),ne&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return xe.size===0?U:U.filter((Ye,at)=>!xe.has(at))}constructor(U,ne,we){this.items=mi.ensureUniqueMimeTypes(U,!0),typeof ne=="string"?(this.id=ne,this.metadata=we):(this.id=(0,N.generateUuid)(),this.metadata=ne??we)}}e.NotebookCellOutput=mi;var Gi;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(Gi=e.NotebookCellKind||(e.NotebookCellKind={}));var Xi;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(Xi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var re;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(re=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var me;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(me=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Oe{constructor(U,ne){this.text=U,this.alignment=ne}}e.NotebookCellStatusBarItem=Oe;var st;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(st=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Dt;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(Dt=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Rt{constructor(U,ne=[]){this.uri=U,this.provides=(0,n.asArray)(ne)}}e.NotebookRendererScript=Rt;class un{constructor(U){this.label=U}}e.NotebookKernelSourceAction=un;let Qi=class{constructor(U,ne){this.label=U,this.timestamp=ne}};Qi=qe([P],Qi),e.TimelineItem=Qi;var ln;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(ln=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(U,ne){this.ranges=U,this.wordPattern=ne}}e.LinkedEditingRanges=fn;class mn{constructor(U,ne){this.c=U,this.e=ne}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=mn;var gn;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(gn=e.TestResultState||(e.TestResultState={}));var pn;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(pn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Ni=class{constructor(U=void 0,ne=void 0,we=void 0){this.include=U,this.exclude=ne,this.profile=we}};Ni=qe([P],Ni),e.TestRunRequest=Ni;let _i=class extends Ni{constructor(U=void 0,ne=void 0,we=void 0,xe=!1){super(U,ne,we),this.continuous=xe}};_i=qe([P],_i),e.TestRunRequest2=_i;let Yi=L=class{static diff(U,ne,we){const xe=new L(U);return xe.expectedOutput=ne,xe.actualOutput=we,xe}constructor(U){this.message=U}};Yi=L=qe([P],Yi),e.TestMessage=Yi;let Ji=class{constructor(U){this.id=U}};Ji=qe([P],Ji),e.TestTag=Ji;let gi=class{constructor(U,ne){this.covered=U,this.total=ne}};gi=qe([P],gi),e.CoveredCount=gi;let Zi=B=class{static fromDetails(U,ne){const we=new gi(0,0),xe=new gi(0,0),Ye=new gi(0,0);for(const lt of ne)if("branches"in lt){we.total+=1,we.covered+=lt.executionCount>0?1:0;for(const Lt of lt.branches)xe.total+=1,xe.covered+=Lt.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=lt.executionCount>0?1:0;const at=new B(U,we,xe.total>0?xe:void 0,Ye.total>0?Ye:void 0);return at.detailedCoverage=ne,at}constructor(U,ne,we,xe){this.uri=U,this.statementCoverage=ne,this.branchCoverage=we,this.functionCoverage=xe}};Zi=B=qe([P],Zi),e.FileCoverage=Zi;let en=class{constructor(U,ne,we=[]){this.executionCount=U,this.location=ne,this.branches=we}};en=qe([P],en),e.StatementCoverage=en;let tn=class{constructor(U,ne){this.executionCount=U,this.location=ne}};tn=qe([P],tn),e.BranchCoverage=tn;let nn=class{constructor(U,ne){this.executionCount=U,this.location=ne}};nn=qe([P],nn),e.FunctionCoverage=nn;var vn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(vn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var bn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(bn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var En;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(En=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class wn{constructor(U,ne,we,xe,Ye,at){this.kind=U,this.name=ne,this.detail=we,this.uri=xe,this.range=Ye,this.selectionRange=at}}e.TypeHierarchyItem=wn;class Sn{constructor(U){this.uri=U}}e.TextTabInput=Sn;class yn{constructor(U,ne){this.original=U,this.modified=ne}}e.TextDiffTabInput=yn;class Dn{constructor(U,ne,we,xe){this.base=U,this.input1=ne,this.input2=we,this.result=xe}}e.TextMergeTabInput=Dn;class In{constructor(U,ne){this.uri=U,this.viewType=ne}}e.CustomEditorTabInput=In;class Cn{constructor(U){this.viewType=U}}e.WebviewEditorTabInput=Cn;class kn{constructor(U,ne){this.uri=U,this.notebookType=ne}}e.NotebookEditorTabInput=kn;class Tn{constructor(U,ne,we){this.original=U,this.modified=ne,this.notebookType=we}}e.NotebookDiffEditorTabInput=Tn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class An{constructor(U,ne){this.uri=U,this.inputBoxUri=ne}}e.InteractiveWindowInput=An}),define(Ce[99],ke([1,0,49,16,10,258,131,7,15]),function(te,e,n,C,D,M,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const k=new Map;function N(m,a){a?k.set(m,a):k.delete(m)}e.setWordDefinitionFor=N;function w(m){return k.get(m)}class f extends M.MirrorTextModel{constructor(a,o,l,g,E,A,v,t){super(o,l,g,E),this.m=a,this.p=A,this.q=v,this.notebook=t,this.b=!1}dispose(){(0,n.ok)(!this.b),this.b=!0,this.q=!1}equalLines(a){return(0,y.equals)(this.d,a)}get document(){if(!this.a){const a=this;this.a={get uri(){return a.c},get fileName(){return a.c.fsPath},get isUntitled(){return a.c.scheme===C.Schemas.untitled},get languageId(){return a.p},get version(){return a.g},get isClosed(){return a.b},get isDirty(){return a.q},save(){return a.r()},getText(o){return o?a.s(o):a.getText()},get eol(){return a.f===`
`?R.EndOfLine.LF:R.EndOfLine.CRLF},get lineCount(){return a.d.length},lineAt(o){return a.t(o)},offsetAt(o){return a.u(o)},positionAt(o){return a.v(o)},validateRange(o){return a.w(o)},validatePosition(o){return a.x(o)},getWordRangeAtPosition(o,l){return a.y(o,l)}}}return Object.freeze(this.a)}_acceptLanguageId(a){(0,n.ok)(!this.b),this.p=a}_acceptIsDirty(a){(0,n.ok)(!this.b),this.q=a}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(a){const o=this.w(a);if(o.isEmpty)return"";if(o.isSingleLine)return this.d[o.start.line].substring(o.start.character,o.end.character);const l=this.f,g=o.start.line,E=o.end.line,A=[];A.push(this.d[g].substring(o.start.character));for(let v=g+1;v<E;v++)A.push(this.d[v]);return A.push(this.d[E].substring(0,o.end.character)),A.join(l)}t(a){let o;if(a instanceof R.Position?o=a.line:typeof a=="number"&&(o=a),typeof o!="number"||o<0||o>=this.d.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new b(o,this.d[o],o===this.d.length-1)}u(a){return a=this.x(a),this.k(),this.h.getPrefixSum(a.line-1)+a.character}v(a){a=Math.floor(a),a=Math.max(0,a),this.k();const o=this.h.getIndexOf(a),l=this.d[o.index].length;return new R.Position(o.index,Math.min(o.remainder,l))}w(a){if(!(a instanceof R.Range))throw new Error("Invalid argument");const o=this.x(a.start),l=this.x(a.end);return o===a.start&&l===a.end?a:new R.Range(o.line,o.character,l.line,l.character)}x(a){if(!(a instanceof R.Position))throw new Error("Invalid argument");if(this.d.length===0)return a.with(0,0);let{line:o,character:l}=a,g=!1;if(o<0)o=0,l=0,g=!0;else if(o>=this.d.length)o=this.d.length-1,l=this.d[o].length,g=!0;else{const E=this.d[o].length;l<0?(l=0,g=!0):l>E&&(l=E,g=!0)}return g?new R.Position(o,l):a}y(a,o){const l=this.x(a);if(!o)o=w(this.p);else if((0,D.regExpLeadsToEndlessLoop)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const g=(0,S.getWordAtText)(l.character+1,(0,S.ensureValidWordDefinition)(o),this.d[l.line],0);if(g)return new R.Range(l.line,g.startColumn-1,l.line,g.endColumn-1)}}e.ExtHostDocumentData=f;class b{constructor(a,o,l){this.a=a,this.b=o,this.c=l}get lineNumber(){return this.a}get text(){return this.b}get range(){return new R.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new R.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=b}),define(Ce[193],ke([1,0,7,18,4]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let M=class{constructor(R){this.a=new n.ColorTheme(n.ColorThemeKind.Dark),this.b=new D.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(R){let y;switch(R){case"light":y=n.ColorThemeKind.Light;break;case"hcDark":y=n.ColorThemeKind.HighContrast;break;case"hcLight":y=n.ColorThemeKind.HighContrastLight;break;default:y=n.ColorThemeKind.Dark}this.a=new n.ColorTheme(y),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};M=qe([je(0,C.IExtHostRpcService)],M),e.ExtHostTheming=M}),define(Ce[8],ke([1,0,15,23,116,194,86,28,112,65,64,22,9,2,44,75,91,96,95,70,45,56,190,7]),function(te,e,n,C,D,M,S,R,y,k,N,w,f,b,m,a,o,l,g,E,A,v,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(De){function Ae(x){const{selectionStartLineNumber:Re,selectionStartColumn:$e,positionLineNumber:Qe,positionColumn:Be}=x,Ze=new h.Position(Re-1,$e-1),ct=new h.Position(Qe-1,Be-1);return new h.Selection(Ze,ct)}De.to=Ae;function ge(x){const{anchor:Re,active:$e}=x;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:$e.line+1,positionColumn:$e.character+1}}De.from=ge})(r=e.Selection||(e.Selection={}));var u;(function(De){function Ae(x){if(!x)return;const{start:Re,end:$e}=x;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:$e.line+1,endColumn:$e.character+1}}De.from=Ae;function ge(x){if(!x)return;const{startLineNumber:Re,startColumn:$e,endLineNumber:Qe,endColumn:Be}=x;return new h.Range(Re-1,$e-1,Qe-1,Be-1)}De.to=ge})(u=e.Range||(e.Range={}));var i;(function(De){function Ae(ge){switch(ge){case 1:return h.StandardTokenType.Comment;case 0:return h.StandardTokenType.Other;case 3:return h.StandardTokenType.RegEx;case 2:return h.StandardTokenType.String}}De.to=Ae})(i=e.TokenType||(e.TokenType={}));var p;(function(De){function Ae(x){return new h.Position(x.lineNumber-1,x.column-1)}De.to=Ae;function ge(x){return{lineNumber:x.line+1,column:x.character+1}}De.from=ge})(p=e.Position||(e.Position={}));var c;(function(De){function Ae(Re,$e){return(0,n.coalesce)((0,n.asArray)(Re).map(Qe=>ge(Qe,$e)))}De.from=Ae;function ge(Re,$e){if(typeof Re=="string")return{$serialized:!0,language:Re};if(Re)return{$serialized:!0,language:Re.language,scheme:x(Re.scheme,$e),pattern:G.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType}}function x(Re,$e){return $e&&typeof Re=="string"?$e.transformOutgoingScheme(Re):Re}})(c=e.DocumentSelector||(e.DocumentSelector={}));var s;(function(De){function Ae(x){switch(x){case h.DiagnosticTag.Unnecessary:return 1;case h.DiagnosticTag.Deprecated:return 2}}De.from=Ae;function ge(x){switch(x){case 1:return h.DiagnosticTag.Unnecessary;case 2:return h.DiagnosticTag.Deprecated;default:return}}De.to=ge})(s=e.DiagnosticTag||(e.DiagnosticTag={}));var d;(function(De){function Ae(x){let Re;return x.code&&((0,f.isString)(x.code)||(0,f.isNumber)(x.code)?Re=String(x.code):Re={value:String(x.code.value),target:x.code.target}),{...u.from(x.range),message:x.message,source:x.source,code:Re,severity:O.from(x.severity),relatedInformation:x.relatedInformation&&x.relatedInformation.map(T.from),tags:Array.isArray(x.tags)?(0,n.coalesce)(x.tags.map(s.from)):void 0}}De.from=Ae;function ge(x){const Re=new h.Diagnostic(u.to(x),x.message,O.to(x.severity));return Re.source=x.source,Re.code=(0,f.isString)(x.code)?x.code:x.code?.value,Re.relatedInformation=x.relatedInformation&&x.relatedInformation.map(T.to),Re.tags=x.tags&&(0,n.coalesce)(x.tags.map(s.to)),Re}De.to=ge})(d=e.Diagnostic||(e.Diagnostic={}));var T;(function(De){function Ae(x){return{...u.from(x.location.range),message:x.message,resource:x.location.uri}}De.from=Ae;function ge(x){return new h.DiagnosticRelatedInformation(new h.Location(x.resource,u.to(x)),x.message)}De.to=ge})(T=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var O;(function(De){function Ae(x){switch(x){case h.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case h.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case h.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case h.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}De.from=Ae;function ge(x){switch(x){case o.MarkerSeverity.Info:return h.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return h.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return h.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return h.DiagnosticSeverity.Hint;default:return h.DiagnosticSeverity.Error}}De.to=ge})(O=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var H;(function(De){function Ae(x){return typeof x=="number"&&x>=h.ViewColumn.One?x-1:x===h.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}De.from=Ae;function ge(x){if(typeof x=="number"&&x>=0)return x+1;throw new Error("invalid 'EditorGroupColumn'")}De.to=ge})(H=e.ViewColumn||(e.ViewColumn={}));function J(De){return typeof De.range<"u"}function K(De){return De.length===0?!0:!!J(De[0])}e.isDecorationOptionsArr=K;var L;(function(De){function Ae(Be){return Be.map(De.from)}De.fromMany=Ae;function ge(Be){return Be&&typeof Be=="object"&&typeof Be.language=="string"&&typeof Be.value=="string"}function x(Be){let Ze;if(ge(Be)){const{language:Et,value:It}=Be;Ze={value:"```"+Et+`
`+It+"\n```\n"}}else h.MarkdownString.isMarkdownString(Be)?Ze={value:Be.value,isTrusted:Be.isTrusted,supportThemeIcons:Be.supportThemeIcons,supportHtml:Be.supportHtml,baseUri:Be.baseUri}:typeof Be=="string"?Ze={value:Be}:Ze={value:""};const ct=Object.create(null);Ze.uris=ct;const Tt=Et=>{try{let It=b.URI.parse(Et,!0);It=It.with({query:Re(It.query,ct)}),ct[Et]=It}catch{}return""},bt=new y.marked.Renderer;return bt.link=Tt,bt.image=Et=>typeof Et=="string"?Tt(S.parseHrefAndDimensions(Et).href):"",(0,y.marked)(Ze.value,{renderer:bt}),Ze}De.from=x;function Re(Be,Ze){if(!Be)return Be;let ct;try{ct=(0,k.parse)(Be)}catch{}if(!ct)return Be;let Tt=!1;return ct=(0,w.cloneAndChange)(ct,bt=>{if(b.URI.isUri(bt)){const Et=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[Et]=bt,Tt=!0,Et}else return}),Tt?JSON.stringify(ct):Be}function $e(Be){const Ze=new h.MarkdownString(Be.value,Be.supportThemeIcons);return Ze.isTrusted=Be.isTrusted,Ze.supportHtml=Be.supportHtml,Ze.baseUri=Be.baseUri?b.URI.from(Be.baseUri):void 0,Ze}De.to=$e;function Qe(Be){if(!!Be)return typeof Be=="string"?Be:De.from(Be)}De.fromStrict=Qe})(L=e.MarkdownString||(e.MarkdownString={}));function B(De){return K(De)?De.map(Ae=>({range:u.from(Ae.range),hoverMessage:Array.isArray(Ae.hoverMessage)?L.fromMany(Ae.hoverMessage):Ae.hoverMessage?L.from(Ae.hoverMessage):void 0,renderOptions:Ae.renderOptions})):De.map(Ae=>({range:u.from(Ae)}))}e.fromRangeOrRangeWithMessage=B;function P(De){return typeof De>"u"?De:typeof De=="string"?b.URI.file(De):De}e.pathOrURIToURI=P;var F;(function(De){function Ae(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?P(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}De.from=Ae})(F=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var V;(function(De){function Ae(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?P(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?F.from(ge.before):void 0,after:ge.after?F.from(ge.after):void 0}}De.from=Ae})(V=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var j;(function(De){function Ae(ge){if(typeof ge>"u")return ge;switch(ge){case h.DecorationRangeBehavior.OpenOpen:return 0;case h.DecorationRangeBehavior.ClosedClosed:return 1;case h.DecorationRangeBehavior.OpenClosed:return 2;case h.DecorationRangeBehavior.ClosedOpen:return 3}}De.from=Ae})(j=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var le;(function(De){function Ae(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?j.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?V.from(ge.light):void 0,dark:ge.dark?V.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?P(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?F.from(ge.before):void 0,after:ge.after?F.from(ge.after):void 0}}De.from=Ae})(le=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var _;(function(De){function Ae(x){return{text:x.newText,eol:x.newEol&&it.from(x.newEol),range:u.from(x.range)}}De.from=Ae;function ge(x){const Re=new h.TextEdit(u.to(x.range),x.text);return Re.newEol=typeof x.eol>"u"?void 0:it.to(x.eol),Re}De.to=ge})(_=e.TextEdit||(e.TextEdit={}));var be;(function(De){function Ae(x,Re){const $e={edits:[]};if(x instanceof h.WorkspaceEdit){const Qe=new R.ResourceSet;for(const Be of x._allEntries())Be._type===1&&b.URI.isUri(Be.to)&&Be.from===void 0&&Qe.add(Be.to);for(const Be of x._allEntries())Be._type===1?$e.edits.push({oldResource:Be.from,newResource:Be.to,options:{...Be.options,contentsBase64:Be.options?.contents&&(0,C.encodeBase64)(C.VSBuffer.wrap(Be.options.contents))},metadata:Be.metadata}):Be._type===2?$e.edits.push({resource:Be.uri,textEdit:_.from(Be.edit),versionId:Qe.has(Be.uri)?void 0:Re?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===6?$e.edits.push({resource:Be.uri,textEdit:{range:u.from(Be.range),text:Be.edit.value,insertAsSnippet:!0},versionId:Qe.has(Be.uri)?void 0:Re?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===3?$e.edits.push({metadata:Be.metadata,resource:Be.uri,cellEdit:Be.edit,notebookMetadata:Be.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(Be.uri)}):Be._type===5&&$e.edits.push({metadata:Be.metadata,resource:Be.uri,notebookVersionId:Re?.getNotebookDocumentVersion(Be.uri),cellEdit:{editType:1,index:Be.index,count:Be.count,cells:Be.cells.map(vt.from)}})}return $e}De.from=Ae;function ge(x){const Re=new h.WorkspaceEdit;for(const $e of x.edits)$e.textEdit?Re.replace(b.URI.revive($e.resource),u.to($e.textEdit.range),$e.textEdit.text):Re.renameFile(b.URI.revive($e.oldResource),b.URI.revive($e.newResource),$e.options);return Re}De.to=ge})(be=e.WorkspaceEdit||(e.WorkspaceEdit={}));var de;(function(De){const Ae=Object.create(null);Ae[h.SymbolKind.File]=0,Ae[h.SymbolKind.Module]=1,Ae[h.SymbolKind.Namespace]=2,Ae[h.SymbolKind.Package]=3,Ae[h.SymbolKind.Class]=4,Ae[h.SymbolKind.Method]=5,Ae[h.SymbolKind.Property]=6,Ae[h.SymbolKind.Field]=7,Ae[h.SymbolKind.Constructor]=8,Ae[h.SymbolKind.Enum]=9,Ae[h.SymbolKind.Interface]=10,Ae[h.SymbolKind.Function]=11,Ae[h.SymbolKind.Variable]=12,Ae[h.SymbolKind.Constant]=13,Ae[h.SymbolKind.String]=14,Ae[h.SymbolKind.Number]=15,Ae[h.SymbolKind.Boolean]=16,Ae[h.SymbolKind.Array]=17,Ae[h.SymbolKind.Object]=18,Ae[h.SymbolKind.Key]=19,Ae[h.SymbolKind.Null]=20,Ae[h.SymbolKind.EnumMember]=21,Ae[h.SymbolKind.Struct]=22,Ae[h.SymbolKind.Event]=23,Ae[h.SymbolKind.Operator]=24,Ae[h.SymbolKind.TypeParameter]=25;function ge(Re){return typeof Ae[Re]=="number"?Ae[Re]:6}De.from=ge;function x(Re){for(const $e in Ae)if(Ae[$e]===Re)return Number($e);return h.SymbolKind.Property}De.to=x})(de=e.SymbolKind||(e.SymbolKind={}));var ue;(function(De){function Ae(x){switch(x){case h.SymbolTag.Deprecated:return 1}}De.from=Ae;function ge(x){switch(x){case 1:return h.SymbolTag.Deprecated}}De.to=ge})(ue=e.SymbolTag||(e.SymbolTag={}));var se;(function(De){function Ae(x){return{name:x.name,kind:de.from(x.kind),tags:x.tags&&x.tags.map(ue.from),containerName:x.containerName,location:Te.from(x.location)}}De.from=Ae;function ge(x){const Re=new h.SymbolInformation(x.name,de.to(x.kind),x.containerName,Te.to(x.location));return Re.tags=x.tags&&x.tags.map(ue.to),Re}De.to=ge})(se=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Z;(function(De){function Ae(x){const Re={name:x.name||"!!MISSING: name!!",detail:x.detail,range:u.from(x.range),selectionRange:u.from(x.selectionRange),kind:de.from(x.kind),tags:x.tags?.map(ue.from)??[]};return x.children&&(Re.children=x.children.map(Ae)),Re}De.from=Ae;function ge(x){const Re=new h.DocumentSymbol(x.name,x.detail,de.to(x.kind),u.to(x.range),u.to(x.selectionRange));return(0,n.isNonEmptyArray)(x.tags)&&(Re.tags=x.tags.map(ue.to)),x.children&&(Re.children=x.children.map(ge)),Re}De.to=ge})(Z=e.DocumentSymbol||(e.DocumentSymbol={}));var X;(function(De){function Ae(x){const Re=new h.CallHierarchyItem(de.to(x.kind),x.name,x.detail||"",b.URI.revive(x.uri),u.to(x.range),u.to(x.selectionRange));return Re._sessionId=x._sessionId,Re._itemId=x._itemId,Re}De.to=Ae;function ge(x,Re,$e){if(Re=Re??x._sessionId,$e=$e??x._itemId,Re===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:$e,name:x.name,detail:x.detail,kind:de.from(x.kind),uri:x.uri,range:u.from(x.range),selectionRange:u.from(x.selectionRange),tags:x.tags?.map(ue.from)}}De.from=ge})(X=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ee;(function(De){function Ae(ge){return new h.CallHierarchyIncomingCall(X.to(ge.from),ge.fromRanges.map(x=>u.to(x)))}De.to=Ae})(ee=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var he;(function(De){function Ae(ge){return new h.CallHierarchyOutgoingCall(X.to(ge.to),ge.fromRanges.map(x=>u.to(x)))}De.to=Ae})(he=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Te;(function(De){function Ae(x){return{range:x.range&&u.from(x.range),uri:x.uri}}De.from=Ae;function ge(x){return new h.Location(b.URI.revive(x.uri),u.to(x.range))}De.to=ge})(Te=e.location||(e.location={}));var Ne;(function(De){function Ae(x){const Re=x,$e=x;return{originSelectionRange:Re.originSelectionRange?u.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:$e.uri,range:u.from(Re.targetRange?Re.targetRange:$e.range),targetSelectionRange:Re.targetSelectionRange?u.from(Re.targetSelectionRange):void 0}}De.from=Ae;function ge(x){return{targetUri:b.URI.revive(x.uri),targetRange:u.to(x.range),targetSelectionRange:x.targetSelectionRange?u.to(x.targetSelectionRange):void 0,originSelectionRange:x.originSelectionRange?u.to(x.originSelectionRange):void 0}}De.to=ge})(Ne=e.DefinitionLink||(e.DefinitionLink={}));var Ke;(function(De){function Ae(x){return{range:u.from(x.range),contents:L.fromMany(x.contents)}}De.from=Ae;function ge(x){return new h.Hover(x.contents.map(L.to),u.to(x.range))}De.to=ge})(Ke=e.Hover||(e.Hover={}));var Pe;(function(De){function Ae(x){return{range:u.from(x.range),expression:x.expression}}De.from=Ae;function ge(x){return new h.EvaluatableExpression(u.to(x.range),x.expression)}De.to=ge})(Pe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Se;(function(De){function Ae(x){if(x instanceof h.InlineValueText)return{type:"text",range:u.from(x.range),text:x.text};if(x instanceof h.InlineValueVariableLookup)return{type:"variable",range:u.from(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};if(x instanceof h.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(x.range),expression:x.expression};throw new Error("Unknown 'InlineValue' type")}De.from=Ae;function ge(x){switch(x.type){case"text":return{range:u.to(x.range),text:x.text};case"variable":return{range:u.to(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};case"expression":return{range:u.to(x.range),expression:x.expression}}}De.to=ge})(Se=e.InlineValue||(e.InlineValue={}));var Ie;(function(De){function Ae(x){return{frameId:x.frameId,stoppedLocation:u.from(x.stoppedLocation)}}De.from=Ae;function ge(x){return new h.InlineValueContext(x.frameId,u.to(x.stoppedLocation))}De.to=ge})(Ie=e.InlineValueContext||(e.InlineValueContext={}));var oe;(function(De){function Ae(x){return{range:u.from(x.range),kind:x.kind}}De.from=Ae;function ge(x){return new h.DocumentHighlight(u.to(x.range),x.kind)}De.to=ge})(oe=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(De){function Ae(ge){switch(ge){case 1:return h.CompletionTriggerKind.TriggerCharacter;case 2:return h.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return h.CompletionTriggerKind.Invoke}}De.to=Ae})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Y;(function(De){function Ae(ge){return{triggerKind:ce.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}De.to=Ae})(Y=e.CompletionContext||(e.CompletionContext={}));var I;(function(De){function Ae(x){switch(x){case h.CompletionItemTag.Deprecated:return 1}}De.from=Ae;function ge(x){switch(x){case 1:return h.CompletionItemTag.Deprecated}}De.to=ge})(I=e.CompletionItemTag||(e.CompletionItemTag={}));var $;(function(De){const Ae=new Map([[h.CompletionItemKind.Method,0],[h.CompletionItemKind.Function,1],[h.CompletionItemKind.Constructor,2],[h.CompletionItemKind.Field,3],[h.CompletionItemKind.Variable,4],[h.CompletionItemKind.Class,5],[h.CompletionItemKind.Interface,7],[h.CompletionItemKind.Struct,6],[h.CompletionItemKind.Module,8],[h.CompletionItemKind.Property,9],[h.CompletionItemKind.Unit,12],[h.CompletionItemKind.Value,13],[h.CompletionItemKind.Constant,14],[h.CompletionItemKind.Enum,15],[h.CompletionItemKind.EnumMember,16],[h.CompletionItemKind.Keyword,17],[h.CompletionItemKind.Snippet,27],[h.CompletionItemKind.Text,18],[h.CompletionItemKind.Color,19],[h.CompletionItemKind.File,20],[h.CompletionItemKind.Reference,21],[h.CompletionItemKind.Folder,23],[h.CompletionItemKind.Event,10],[h.CompletionItemKind.Operator,11],[h.CompletionItemKind.TypeParameter,24],[h.CompletionItemKind.Issue,26],[h.CompletionItemKind.User,25]]);function ge($e){return Ae.get($e)??9}De.from=ge;const x=new Map([[0,h.CompletionItemKind.Method],[1,h.CompletionItemKind.Function],[2,h.CompletionItemKind.Constructor],[3,h.CompletionItemKind.Field],[4,h.CompletionItemKind.Variable],[5,h.CompletionItemKind.Class],[7,h.CompletionItemKind.Interface],[6,h.CompletionItemKind.Struct],[8,h.CompletionItemKind.Module],[9,h.CompletionItemKind.Property],[12,h.CompletionItemKind.Unit],[13,h.CompletionItemKind.Value],[14,h.CompletionItemKind.Constant],[15,h.CompletionItemKind.Enum],[16,h.CompletionItemKind.EnumMember],[17,h.CompletionItemKind.Keyword],[27,h.CompletionItemKind.Snippet],[18,h.CompletionItemKind.Text],[19,h.CompletionItemKind.Color],[20,h.CompletionItemKind.File],[21,h.CompletionItemKind.Reference],[23,h.CompletionItemKind.Folder],[10,h.CompletionItemKind.Event],[11,h.CompletionItemKind.Operator],[24,h.CompletionItemKind.TypeParameter],[25,h.CompletionItemKind.User],[26,h.CompletionItemKind.Issue]]);function Re($e){return x.get($e)??h.CompletionItemKind.Property}De.to=Re})($=e.CompletionItemKind||(e.CompletionItemKind={}));var W;(function(De){function Ae(ge,x){const Re=new h.CompletionItem(ge.label);return Re.insertText=ge.insertText,Re.kind=$.to(ge.kind),Re.tags=ge.tags?.map(I.to),Re.detail=ge.detail,Re.documentation=S.isMarkdownString(ge.documentation)?L.to(ge.documentation):ge.documentation,Re.sortText=ge.sortText,Re.filterText=ge.filterText,Re.preselect=ge.preselect,Re.commitCharacters=ge.commitCharacters,m.Range.isIRange(ge.range)?Re.range=u.to(ge.range):typeof ge.range=="object"&&(Re.range={inserting:u.to(ge.range.insert),replacing:u.to(ge.range.replace)}),Re.keepWhitespace=typeof ge.insertTextRules>"u"?!1:Boolean(ge.insertTextRules&1),typeof ge.insertTextRules<"u"&&ge.insertTextRules&4?Re.insertText=new h.SnippetString(ge.insertText):(Re.insertText=ge.insertText,Re.textEdit=Re.range instanceof h.Range?new h.TextEdit(Re.range,Re.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Re.additionalTextEdits=ge.additionalTextEdits.map($e=>_.to($e))),Re.command=x&&ge.command?x.fromInternal(ge.command):void 0,Re}De.to=Ae})(W=e.CompletionItem||(e.CompletionItem={}));var q;(function(De){function Ae(x){if(typeof x.label!="string"&&!Array.isArray(x.label))throw new TypeError("Invalid label");return{label:x.label,documentation:L.fromStrict(x.documentation)}}De.from=Ae;function ge(x){return{label:x.label,documentation:S.isMarkdownString(x.documentation)?L.to(x.documentation):x.documentation}}De.to=ge})(q=e.ParameterInformation||(e.ParameterInformation={}));var ie;(function(De){function Ae(x){return{label:x.label,documentation:L.fromStrict(x.documentation),parameters:Array.isArray(x.parameters)?x.parameters.map(q.from):[],activeParameter:x.activeParameter}}De.from=Ae;function ge(x){return{label:x.label,documentation:S.isMarkdownString(x.documentation)?L.to(x.documentation):x.documentation,parameters:Array.isArray(x.parameters)?x.parameters.map(q.to):[],activeParameter:x.activeParameter}}De.to=ge})(ie=e.SignatureInformation||(e.SignatureInformation={}));var fe;(function(De){function Ae(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(ie.from):[]}}De.from=Ae;function ge(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(ie.to):[]}}De.to=ge})(fe=e.SignatureHelp||(e.SignatureHelp={}));var ye;(function(De){function Ae(ge,x){const Re=new h.InlayHint(p.to(x.position),typeof x.label=="string"?x.label:x.label.map(ae.to.bind(void 0,ge)),x.kind&&ve.to(x.kind));return Re.textEdits=x.textEdits&&x.textEdits.map(_.to),Re.tooltip=S.isMarkdownString(x.tooltip)?L.to(x.tooltip):x.tooltip,Re.paddingLeft=x.paddingLeft,Re.paddingRight=x.paddingRight,Re}De.to=Ae})(ye=e.InlayHint||(e.InlayHint={}));var ae;(function(De){function Ae(ge,x){const Re=new h.InlayHintLabelPart(x.label);return Re.tooltip=S.isMarkdownString(x.tooltip)?L.to(x.tooltip):x.tooltip,a.Command.is(x.command)&&(Re.command=ge.fromInternal(x.command)),x.location&&(Re.location=Te.to(x.location)),Re}De.to=Ae})(ae=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ve;(function(De){function Ae(x){return x}De.from=Ae;function ge(x){return x}De.to=ge})(ve=e.InlayHintKind||(e.InlayHintKind={}));var Ee;(function(De){function Ae(x){return{range:u.from(x.range),url:x.target,tooltip:x.tooltip}}De.from=Ae;function ge(x){let Re;if(x.url)try{Re=typeof x.url=="string"?b.URI.parse(x.url,!0):b.URI.revive(x.url)}catch{}return new h.DocumentLink(u.to(x.range),Re)}De.to=ge})(Ee=e.DocumentLink||(e.DocumentLink={}));var We;(function(De){function Ae(x){const Re=new h.ColorPresentation(x.label);return x.textEdit&&(Re.textEdit=_.to(x.textEdit)),x.additionalTextEdits&&(Re.additionalTextEdits=x.additionalTextEdits.map($e=>_.to($e))),Re}De.to=Ae;function ge(x){return{label:x.label,textEdit:x.textEdit?_.from(x.textEdit):void 0,additionalTextEdits:x.additionalTextEdits?x.additionalTextEdits.map(Re=>_.from(Re)):void 0}}De.from=ge})(We=e.ColorPresentation||(e.ColorPresentation={}));var He;(function(De){function Ae(x){return new h.Color(x[0],x[1],x[2],x[3])}De.to=Ae;function ge(x){return[x.red,x.green,x.blue,x.alpha]}De.from=ge})(He=e.Color||(e.Color={}));var tt;(function(De){function Ae(x){return{range:u.from(x.range)}}De.from=Ae;function ge(x){return new h.SelectionRange(u.to(x.range))}De.to=ge})(tt=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(De){function Ae(ge){switch(ge){case 2:return h.TextDocumentSaveReason.AfterDelay;case 1:return h.TextDocumentSaveReason.Manual;case 3:case 4:return h.TextDocumentSaveReason.FocusOut}}De.to=Ae})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var et;(function(De){function Ae(x){switch(x){case h.TextEditorLineNumbersStyle.Off:return 0;case h.TextEditorLineNumbersStyle.Relative:return 2;case h.TextEditorLineNumbersStyle.On:default:return 1}}De.from=Ae;function ge(x){switch(x){case 0:return h.TextEditorLineNumbersStyle.Off;case 2:return h.TextEditorLineNumbersStyle.Relative;case 1:default:return h.TextEditorLineNumbersStyle.On}}De.to=ge})(et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var it;(function(De){function Ae(x){if(x===h.EndOfLine.CRLF)return 1;if(x===h.EndOfLine.LF)return 0}De.from=Ae;function ge(x){if(x===1)return h.EndOfLine.CRLF;if(x===0)return h.EndOfLine.LF}De.to=ge})(it=e.EndOfLine||(e.EndOfLine={}));var dt;(function(De){function Ae(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case h.ProgressLocation.SourceControl:return 3;case h.ProgressLocation.Window:return 10;case h.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}De.from=Ae})(dt=e.ProgressLocation||(e.ProgressLocation={}));var Fe;(function(De){function Ae(ge){const x={start:ge.start+1,end:ge.end+1};return ge.kind&&(x.kind=ot.from(ge.kind)),x}De.from=Ae})(Fe=e.FoldingRange||(e.FoldingRange={}));var ot;(function(De){function Ae(ge){if(ge)switch(ge){case h.FoldingRangeKind.Comment:return a.FoldingRangeKind.Comment;case h.FoldingRangeKind.Imports:return a.FoldingRangeKind.Imports;case h.FoldingRangeKind.Region:return a.FoldingRangeKind.Region}}De.from=Ae})(ot=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Q;(function(De){function Ae(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?u.from(ge.selection):void 0,override:typeof ge.override=="boolean"?g.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}De.from=Ae})(Q=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var G;(function(De){function Ae($e){return $e instanceof h.RelativePattern?$e.toJSON():typeof $e=="string"?$e:ge($e)||x($e)?new h.RelativePattern($e.baseUri??$e.base,$e.pattern).toJSON():$e}De.from=Ae;function ge($e){const Qe=$e;return Qe?b.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function x($e){const Qe=$e;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Re($e){return typeof $e=="string"?$e:new h.RelativePattern(b.URI.revive($e.baseUri),$e.pattern)}De.to=Re})(G=e.GlobPattern||(e.GlobPattern={}));var pe;(function(De){function Ae(ge){if(ge){if(Array.isArray(ge))return ge.map(Ae);if(typeof ge=="string")return ge;{const x=ge;return{language:x.language,scheme:x.scheme,pattern:G.from(x.pattern),exclusive:x.exclusive,notebookType:x.notebookType}}}else return}De.from=Ae})(pe=e.LanguageSelector||(e.LanguageSelector={}));var Me;(function(De){function Ae(x){return{start:x.start,end:x.end}}De.from=Ae;function ge(x){return new h.NotebookRange(x.start,x.end)}De.to=ge})(Me=e.NotebookRange||(e.NotebookRange={}));var ze;(function(De){function Ae(x){return{timing:typeof x.runStartTime=="number"&&typeof x.runEndTime=="number"?{startTime:x.runStartTime,endTime:x.runEndTime}:void 0,executionOrder:x.executionOrder,success:x.lastRunSuccess}}De.to=Ae;function ge(x){return{lastRunSuccess:x.success,runStartTime:x.timing?.startTime,runEndTime:x.timing?.endTime,executionOrder:x.executionOrder}}De.from=ge})(ze=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ve;(function(De){function Ae(ge){if(ge===E.NotebookCellExecutionState.Unconfirmed)return h.NotebookCellExecutionState.Pending;if(ge===E.NotebookCellExecutionState.Pending)return;if(ge===E.NotebookCellExecutionState.Executing)return h.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}De.to=Ae})(Ve=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var _e;(function(De){function Ae(x){switch(x){case h.NotebookCellKind.Markup:return E.CellKind.Markup;case h.NotebookCellKind.Code:default:return E.CellKind.Code}}De.from=Ae;function ge(x){switch(x){case E.CellKind.Markup:return h.NotebookCellKind.Markup;case E.CellKind.Code:default:return h.NotebookCellKind.Code}}De.to=ge})(_e=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(De){function Ae(x){const Re={metadata:x.metadata??Object.create(null),cells:[]};for(const $e of x.cells)h.NotebookCellData.validate($e),Re.cells.push(vt.from($e));return Re}De.from=Ae;function ge(x){const Re=new h.NotebookData(x.cells.map(vt.to));return(0,f.isEmptyObject)(x.metadata)||(Re.metadata=x.metadata),Re}De.to=ge})(nt=e.NotebookData||(e.NotebookData={}));var vt;(function(De){function Ae(x){return{cellKind:_e.from(x.kind),language:x.languageId,mime:x.mime,source:x.value,metadata:x.metadata,internalMetadata:ze.from(x.executionSummary??{}),outputs:x.outputs?x.outputs.map(Ct.from):[]}}De.from=Ae;function ge(x){return new h.NotebookCellData(_e.to(x.cellKind),x.source,x.language,x.mime,x.outputs?x.outputs.map(Ct.to):void 0,x.metadata,x.internalMetadata?ze.to(x.internalMetadata):void 0)}De.to=ge})(vt=e.NotebookCellData||(e.NotebookCellData={}));var wt;(function(De){function Ae(x){return{mime:x.mime,valueBytes:C.VSBuffer.wrap(x.data)}}De.from=Ae;function ge(x){return new h.NotebookCellOutputItem(x.valueBytes.buffer,x.mime)}De.to=ge})(wt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ct;(function(De){function Ae(x){return{outputId:x.id,items:x.items.map(wt.from),metadata:x.metadata}}De.from=Ae;function ge(x){const Re=x.items.map(wt.to);return new h.NotebookCellOutput(Re,x.outputId,x.metadata)}De.to=ge})(Ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var jt;(function(De){function Ae(Re){return x(Re)?{include:(0,f.withNullAsUndefined)(G.from(Re.include)),exclude:(0,f.withNullAsUndefined)(G.from(Re.exclude))}:(0,f.withNullAsUndefined)(G.from(Re))}De.from=Ae;function ge(Re){return x(Re)?{include:G.to(Re.include),exclude:G.to(Re.exclude)}:G.to(Re)}De.to=ge;function x(Re){const $e=Re;return $e?!(0,f.isUndefinedOrNull)($e.include)&&!(0,f.isUndefinedOrNull)($e.exclude):!1}})(jt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var rt;(function(De){function Ae(ge,x,Re){const $e=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===h.NotebookCellStatusBarAlignment.Left?1:2,command:x.toInternal($e,Re),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}De.from=Ae})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var mt;(function(De){function Ae(ge,x,Re){const $e=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{command:x.toInternal($e,Re),label:ge.label,description:ge.description,detail:ge.detail,documentation:ge.documentation}}De.from=Ae})(mt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Ft;(function(De){function Ae(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}De.from=Ae})(Ft=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Gt;(function(De){function Ae(x){return{uri:x.uri,provides:x.provides}}De.from=Ae;function ge(x){return new h.NotebookRendererScript(b.URI.revive(x.uri),x.provides)}De.to=ge})(Gt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Pt;(function(De){function Ae(x){return{message:L.fromStrict(x.message)||"",type:0,expected:x.expectedOutput,actual:x.actualOutput,location:x.location&&{range:u.from(x.location.range),uri:x.location.uri}}}De.from=Ae;function ge(x){const Re=new h.TestMessage(typeof x.message=="string"?x.message:L.to(x.message));return Re.actualOutput=x.actual,Re.expectedOutput=x.expected,Re.location=x.location?Te.to(x.location):void 0,Re}De.to=ge})(Pt=e.TestMessage||(e.TestMessage={}));var ht;(function(De){De.namespace=v.namespaceTestTag,De.denamespace=v.denamespaceTestTag})(ht=e.TestTag||(e.TestTag={}));var kt;(function(De){function Ae(x){const Re=(0,l.getPrivateApiFor)(x).controllerId;return{extId:A.TestId.fromExtHostTestItem(x,Re).toString(),label:x.label,uri:b.URI.revive(x.uri),busy:x.busy,tags:x.tags.map($e=>ht.namespace(Re,$e.id)),range:m.Range.lift(u.from(x.range)),description:x.description||null,sortText:x.sortText||null,error:x.error&&L.fromStrict(x.error)||null}}De.from=Ae;function ge(x){return{parent:void 0,error:void 0,id:A.TestId.fromString(x.extId).localId,label:x.label,uri:b.URI.revive(x.uri),tags:(x.tags||[]).map(Re=>{const{tagId:$e}=ht.denamespace(Re);return new h.TestTag($e)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(x.range||void 0),canResolveChildren:!1,busy:x.busy,description:x.description||void 0,sortText:x.sortText||void 0}}De.toPlain=ge})(kt=e.TestItem||(e.TestItem={})),function(De){function Ae(x){return{id:x.id}}De.from=Ae;function ge(x){return new h.TestTag(x.id)}De.to=ge}(ht=e.TestTag||(e.TestTag={}));var $t;(function(De){const Ae=(x,Re)=>{const $e=[];for(const[Be,Ze]of Re)A.TestId.compare(Ze.item.extId,Be)===2&&(Re.delete(Be),$e.push(Ze));const Qe={...kt.toPlain(x.item),parent:void 0,taskStates:x.tasks.map(Be=>({state:Be.state,duration:Be.duration,messages:Be.messages.filter(Ze=>Ze.type===0).map(Pt.to)})),children:$e.map(Be=>Ae(Be,Re))};for(const Be of Qe.children)Be.parent=Qe;return Qe};function ge(x){const Re=[],$e=new Map;for(const Qe of x.items){$e.set(Qe.item.extId,Qe);const Be=A.TestId.root(Qe.item.extId);x.request.targets.some(Ze=>Ze.controllerId===Be&&Ze.testIds.includes(Qe.item.extId))&&Re.push(Qe)}return{completedAt:x.completedAt,results:Re.map(Qe=>Ae(Qe,$e))}}De.to=ge})($t=e.TestResults||(e.TestResults={}));var Ot;(function(De){function Ae($e){return{covered:$e.covered,total:$e.covered}}function ge($e){return"line"in $e?p.from($e):u.from($e)}function x($e){return"branches"in $e?{count:$e.executionCount,location:ge($e.location),type:1,branches:$e.branches.length?$e.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&ge(Qe.location)})):void 0}:{type:0,count:$e.executionCount,location:ge($e.location)}}De.fromDetailed=x;function Re($e){return{uri:$e.uri,statement:Ae($e.statementCoverage),branch:$e.branchCoverage&&Ae($e.branchCoverage),function:$e.functionCoverage&&Ae($e.functionCoverage),details:$e.detailedCoverage?.map(x)}}De.fromFile=Re})(Ot=e.TestCoverage||(e.TestCoverage={}));var Ge;(function(De){function Ae(ge){switch(ge){case 1:return h.CodeActionTriggerKind.Invoke;case 2:return h.CodeActionTriggerKind.Automatic}}De.to=Ae})(Ge=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Nt;(function(De){function Ae(x){const Re=new h.TypeHierarchyItem(de.to(x.kind),x.name,x.detail||"",b.URI.revive(x.uri),u.to(x.range),u.to(x.selectionRange));return Re._sessionId=x._sessionId,Re._itemId=x._itemId,Re}De.to=Ae;function ge(x,Re,$e){if(Re=Re??x._sessionId,$e=$e??x._itemId,Re===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:$e,kind:de.from(x.kind),name:x.name,detail:x.detail??"",uri:x.uri,range:u.from(x.range),selectionRange:u.from(x.selectionRange),tags:x.tags?.map(ue.from)}}De.from=ge})(Nt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Mt;(function(De){function Ae(ge){if(!!ge)return{value:ge.value,tooltip:ge.tooltip}}De.from=Ae})(Mt=e.ViewBadge||(e.ViewBadge={}));var zt;(function(De){function Ae($e,Qe,Be){const Ze=Qe.fileData;return Ze?new class extends h.DataTransferItem{asFile(){return{name:Ze.name,uri:b.URI.revive(Ze.uri),data:(0,M.once)(()=>Be())}}}("",Qe.id):$e===N.Mimes.uriList&&Qe.uriListData?new h.DataTransferItem(Re(Qe.uriListData)):new h.DataTransferItem(Qe.asString)}De.to=Ae;async function ge($e,Qe){const Be=await Qe.asString();if($e===N.Mimes.uriList)return{id:Qe.id,asString:"",fileData:void 0,uriListData:x(Be)};const Ze=Qe.asFile();return{id:Qe.id,asString:Be,fileData:Ze?{name:Ze.name,uri:Ze.uri}:void 0}}De.from=ge;function x($e){return D.UriList.split($e).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return b.URI.parse(Qe)}catch{}return Qe})}function Re($e){return D.UriList.create($e.map(Qe=>typeof Qe=="string"?Qe:b.URI.revive(Qe)))}})(zt=e.DataTransferItem||(e.DataTransferItem={}));var ft;(function(De){function Ae(x,Re){const $e=x.items.map(([Qe,Be])=>[Qe,zt.to(Qe,Be,()=>Re(Be.id))]);return new h.DataTransfer($e)}De.toDataTransfer=Ae;async function ge(x){const Re={items:[]},$e=[];return x.forEach((Qe,Be)=>{$e.push((async()=>{Re.items.push([Be,await zt.from(Be,Qe)])})())}),await Promise.all($e),Re}De.toDataTransferDTO=ge})(ft=e.DataTransfer||(e.DataTransfer={}))}),define(Ce[195],ke([1,0,2,12,7,8,161]),function(te,e,n,C,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class R{constructor(k,N,w,f={timeout:1500,errors:3}){this.c=k,this.d=N,this.f=w,this.g=f,this.a=new S.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(N,w,f)=>{const m={dispose:this.a.push([N,w,k])};return Array.isArray(f)&&f.push(m),m}}async $participateInSave(k,N){const w=n.URI.revive(k);let f=!1;const b=setTimeout(()=>f=!0,this.g.timeout),m=[];try{for(const a of[...this.a]){if(f)break;const o=this.d.getDocument(w),l=await this.h(a,{document:o,reason:M.TextDocumentSaveReason.to(N)});m.push(l)}}finally{clearTimeout(b)}return m}h([k,N,w],f){const b=this.b.get(k);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(w,k,N,f).then(()=>!0,m=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' threw ERROR`),this.c.error(m),!(m instanceof Error)||m.message!=="concurrent_edits"){const a=this.b.get(k);this.b.set(k,a?a+1:1),typeof a=="number"&&a>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,N,w,f){const b=[],m=Date.now(),{document:a,reason:o}=f,{version:l}=a,g=Object.freeze({document:a,reason:o,waitUntil(E){if(Object.isFrozen(b))throw(0,C.illegalState)("waitUntil can not be called async");b.push(Promise.resolve(E))}});try{N.apply(w,[g])}catch(E){return Promise.reject(E)}return Object.freeze(b),new Promise((E,A)=>{const v=setTimeout(()=>A(new Error("timeout")),this.g.timeout);return Promise.all(b).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-m}ms`),clearTimeout(v),E(t)}).catch(t=>{clearTimeout(v),A(t)})}).then(E=>{const A={edits:[]};for(const v of E)if(Array.isArray(v)&&v.every(t=>t instanceof D.TextEdit))for(const{newText:t,newEol:h,range:r}of v)A.edits.push({resource:a.uri,versionId:void 0,textEdit:{range:r&&M.Range.from(r),text:t,eol:h&&M.EndOfLine.from(h)}});if(A.edits.length!==0)return l===a.version?this.f.$tryApplyWorkspaceEdit(A):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=R}),define(Ce[196],ke([1,0,16,2,8,7,70]),function(te,e,n,C,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class R{constructor(w,f,b,m){this.start=w,this.deletedCount=f,this.deletedItems=b,this.items=m}asApiEvent(){return{range:new M.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(w=>w.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(w,f){return{EOL:f.eol,lines:f.source,languageId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:w}}constructor(w,f,b){this.notebook=w,this.h=f,this.j=b,this.handle=b.handle,this.uri=C.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(D.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(D.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const w=this,f=this.h.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return w.notebook.getCellIndex(w)},notebook:w.notebook.apiNotebook,kind:D.NotebookCellKind.to(this.j.cellKind),document:f.document,get mime(){return w.g},set mime(m){w.g=m},get outputs(){return w.a.slice(0)},get metadata(){return w.b},get executionSummary(){return w.d}};this.f=Object.freeze(b)}return this.f}setOutputs(w){this.a=w.map(D.NotebookCellOutput.to)}setOutputItems(w,f,b){const m=b.map(D.NotebookCellOutputItem.to),a=this.a.find(o=>o.id===w);if(a&&(f||(a.items.length=0),a.items.push(...m),a.items.length>1&&a.items.every(o=>S.isTextStreamMime(o.mime)))){const o=new Map,l=[];a.items.forEach(g=>{let E;o.has(g.mime)?E=o.get(g.mime):(E=[],o.set(g.mime,E),l.push(g.mime)),E.push(g.data)}),a.items.length=0,l.forEach(g=>{const E=S.compressOutputItemStreams(o.get(g));a.items.push({mime:g,data:E.buffer})})}}setMetadata(w){this.b=Object.freeze(w)}setInternalMetadata(w){this.e=w,this.d=Object.freeze(D.NotebookCellExecutionSummary.to(w))}setMime(w){}}e.ExtHostCell=y;class k{constructor(w,f,b,m,a){this.k=w,this.l=f,this.m=b,this.uri=m,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=a.viewType,this.f=Object.freeze(a.metadata??Object.create(null)),this.r([[0,0,a.cells]],!0,void 0),this.g=a.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const w=this,f={get uri(){return w.uri},get version(){return w.g},get notebookType(){return w.d},get isDirty(){return w.h},get isUntitled(){return w.uri.scheme===n.Schemas.untitled},get isClosed(){return w.j},get metadata(){return w.f},get cellCount(){return w.b.length},cellAt(b){return b=w.n(b),w.b[b].apiCell},getCells(b){return(b?w.p(b):w.b).map(a=>a.apiCell)},save(){return w.q()}};this.e=Object.freeze(f)}return this.e}acceptDocumentPropertiesChanged(w){w.metadata&&(this.f=Object.freeze({...this.f,...w.metadata}))}acceptDirty(w){this.h=w}acceptModelChanged(w,f,b){this.g=w.versionId,this.h=f,this.acceptDocumentPropertiesChanged({metadata:b});const m={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},a=[];for(const l of w.rawEvents)l.kind===S.NotebookCellsChangeType.ModelChange?this.r(l.changes,!1,m.contentChanges):l.kind===S.NotebookCellsChangeType.Move?this.s(l.index,l.length,l.newIdx,m.contentChanges):l.kind===S.NotebookCellsChangeType.Output?(this.t(l.index,l.outputs),a.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===S.NotebookCellsChangeType.OutputItem?(this.u(l.index,l.outputId,l.append,l.outputItems),a.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===S.NotebookCellsChangeType.ChangeCellLanguage?(this.v(l.index,l.language),a.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document})):l.kind===S.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document}):l.kind===S.NotebookCellsChangeType.ChangeCellMime?this.w(l.index,l.mime):l.kind===S.NotebookCellsChangeType.ChangeCellMetadata?(this.x(l.index,l.metadata),a.push({cell:this.b[l.index].apiCell,metadata:this.b[l.index].apiCell.metadata})):l.kind===S.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(l.index,l.internalMetadata),a.push({cell:this.b[l.index].apiCell,executionSummary:this.b[l.index].apiCell.executionSummary}));const o=new Map;for(let l=0;l<a.length;l++){const g=a[l],E=o.get(g.cell);if(E===void 0){const A=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...g});o.set(g.cell,A-1)}else m.cellChanges[E]={...m.cellChanges[E],...g}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}n(w){return w=w|0,w<0?0:w>=this.b.length?this.b.length-1:w}o(w){let f=w.start|0,b=w.end|0;return f<0&&(f=0),b>this.b.length&&(b=this.b.length),w.with({start:f,end:b})}p(w){w=this.o(w);const f=[];for(let b=w.start;b<w.end;b++)f.push(this.b[b]);return f}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(w,f,b){if(this.j)return;const m=[],a=[],o=[];if(w.reverse().forEach(l=>{const E=l[2].map(t=>{const h=new y(this,this.l,t);return f||a.push(y.asModelAddData(this.apiNotebook,t)),h}),A=new R(l[0],l[1],[],E),v=this.b.splice(l[0],l[1],...E);for(const t of v)o.push(t.uri),A.deletedItems.push(t.apiCell);m.push(A)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:o}),b)for(const l of m)b.push(l.asApiEvent())}s(w,f,b,m){const a=this.b.splice(w,f);this.b.splice(b,0,...a);const o=[new R(w,f,a.map(l=>l.apiCell),[]),new R(b,0,[],a)];for(const l of o)m.push(l.asApiEvent())}t(w,f){this.b[w].setOutputs(f)}u(w,f,b,m){this.b[w].setOutputItems(f,b,m)}v(w,f){const b=this.b[w];b.apiCell.document.languageId!==f&&this.m.$acceptModelLanguageChanged(b.uri,f)}w(w,f){const b=this.b[w];b.apiCell.mime=f}x(w,f){this.b[w].setMetadata(f)}y(w,f){this.b[w].setInternalMetadata(f)}getCellFromApiCell(w){return this.b.find(f=>f.apiCell===w)}getCellFromIndex(w){return this.b[w]}getCell(w){return this.b.find(f=>f.handle===w)}getCellIndex(w){return this.b.indexOf(w)}}k.a=0,e.ExtHostNotebookDocument=k}),define(Ce[100],ke([1,0,12,8,7]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class M{constructor(R,y,k,N,w,f){this.id=R,this.f=y,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=w,this.b=N,this.c=f}get apiEditor(){if(!this.e){const R=this;this.e={get notebook(){return R.notebookData.apiNotebook},get selection(){return R.a[0]},set selection(y){this.selections=[y]},get selections(){return R.a},set selections(y){if(!Array.isArray(y)||!y.every(D.NotebookRange.isNotebookRange))throw(0,n.illegalArgument)("selections");R.a=y,R.g(y)},get visibleRanges(){return R.b},revealRange(y,k){R.f.$tryRevealRange(R.id,C.NotebookRange.from(y),k??D.NotebookEditorRevealType.Default)},get viewColumn(){return R.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(R){this.d=R}_acceptVisibleRanges(R){this.b=R}_acceptSelections(R){this.a=R}g(R){this.f.$trySetSelections(this.id,R.map(C.NotebookRange.from))}_acceptViewColumn(R){this.c=R}}M.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=M}),define(Ce[197],ke([1,0,4,11,8]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let M=class{constructor(R,y){this.c=R,this.d=y,this.a=new n.Emitter,this.b=new n.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(R,y){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",R,y);const k=this.d.getEditorById(R);y.visibleRanges&&k._acceptVisibleRanges(y.visibleRanges.ranges.map(D.NotebookRange.to)),y.selections&&k._acceptSelections(y.selections.selections.map(D.NotebookRange.to)),y.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),y.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(R){for(const y in R)this.d.getEditorById(y)._acceptViewColumn(D.ViewColumn.to(R[y]))}};M=qe([je(0,C.ILogService)],M),e.ExtHostNotebookEditors=M}),define(Ce[198],ke([1,0,8,165,141,20,63,12]),function(te,e,n,C,D,M,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(f){this.b=0,this.c=new Map,this.a=f}async withProgress(f,b,m){const a=this.b++,{title:o,location:l,cancellable:g}=b,E={label:(0,D.localize)(0,null,f.displayName||f.name),id:f.identifier.value};return this.a.$startProgress(a,{location:n.ProgressLocation.from(l),title:o,source:E,cancellable:g},f.isUnderDevelopment?void 0:f.identifier.value).catch(R.onUnexpectedExternalError),this.d(a,m,!!g)}d(f,b,m){let a;m&&(a=new M.CancellationTokenSource,this.c.set(f,a));const o=g=>{this.a.$progressEnd(g),this.c.delete(g),a?.dispose()};let l;try{l=b(new N(this.a,f),m&&a?a.token:M.CancellationToken.None)}catch(g){throw o(f),g}return l.then(g=>o(f),g=>o(f)),l}$acceptProgressCanceled(f){const b=this.c.get(f);b&&(b.cancel(),this.c.delete(f))}}e.ExtHostProgress=y;function k(w,f){return w.message=f.message,typeof f.increment=="number"&&(typeof w.increment=="number"?w.increment+=f.increment:w.increment=f.increment),w}class N extends C.Progress{constructor(f,b){super(m=>this.throttledReport(m)),this.c=f,this.d=b}throttledReport(f){this.c.$progressReport(this.d,f)}}qe([(0,S.throttle)(100,(w,f)=>k(w,f),()=>Object.create(null))],N.prototype,"throttledReport",null)}),define(Ce[101],ke([1,0,44,96,45,71,56,8,2]),function(te,e,n,C,D,M,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const k=(E,A,v,t)=>{let h=A;return{enumerable:!0,configurable:!1,get(){return h},set(r){if(!v(h,r)){const u=h;h=r,E.listener?.(t(r,u))}}}},N=(E,A)=>E===A,w={range:(E,A)=>E===A?!0:!E||!A?!1:E.isEqual(A),label:N,description:N,sortText:N,busy:N,error:N,canResolveChildren:N,tags:(E,A)=>!(E.length!==A.length||E.some(v=>!A.find(t=>v.id===t.id)))},f=E=>A=>({op:4,update:E(A)}),b=(E,A)=>({range:(()=>{let v;const t=f(h=>({range:n.Range.lift(R.Range.from(h))}));return{enumerable:!0,configurable:!1,get(){return v},set(h){E.listener?.({op:6}),w.range(v,h)||(v=h,E.listener?.(t(h)))}}})(),label:k(E,A,w.label,f(v=>({label:v}))),description:k(E,void 0,w.description,f(v=>({description:v}))),sortText:k(E,void 0,w.sortText,f(v=>({sortText:v}))),canResolveChildren:k(E,!1,w.canResolveChildren,v=>({op:2,state:v})),busy:k(E,!1,w.busy,f(v=>({busy:v}))),error:k(E,void 0,w.error,f(v=>({error:R.MarkdownString.fromStrict(v)||null}))),tags:k(E,[],w.tags,(v,t)=>({op:1,new:v.map(R.TestTag.from),old:t.map(R.TestTag.from)}))}),m=E=>{const A=D.TestId.fromString(E.extId),v=new o(A.controllerId,A.localId,E.label,y.URI.revive(E.uri)||void 0);return v.range=R.Range.to(E.range||void 0),v.description=E.description||void 0,v.sortText=E.sortText||void 0,v.tags=E.tags.map(t=>R.TestTag.to({id:(0,S.denamespaceTestTag)(t).tagId})),v},a=E=>{let A;for(const v of E.tests){const t=m(v.item);(0,C.getPrivateApiFor)(t).parent=A,A=t}return A};e.toItemFromContext=a;class o{constructor(A,v,t,h){if(v.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(v)} symbol`);const r=(0,C.createPrivateApiFor)(this,A);Object.defineProperties(this,{id:{value:v,enumerable:!0,writable:!1},uri:{value:h,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof l?void 0:r.parent}},children:{value:(0,M.createTestItemChildren)(r,C.getPrivateApiFor,o),enumerable:!0,writable:!1},...b(r,t)})}}e.TestItemImpl=o;class l extends o{constructor(A,v){super(A,A,v,void 0),this._isRoot=!0}}e.TestItemRootImpl=l;class g extends M.TestItemCollection{constructor(A,v,t){super({controllerId:A,getDocumentVersion:h=>h&&t.getDocument(h)?.version,getApiFor:C.getPrivateApiFor,getChildren:h=>h.children,root:new l(A,v),toITestItem:R.TestItem.from})}}e.ExtHostTestItemCollection=g}),define(Ce[102],ke([1,0,49,12,83,8,7]),function(te,e,n,C,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class R{constructor(f,b,m){const a=R.c.nextId();f.$registerTextEditorDecorationType(b.identifier,a,M.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:a,dispose(){f.$removeTextEditorDecorationType(a)}})}}R.c=new D.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=R;class y{constructor(f,b){this.g=[],this.h=void 0,this.j=!1,this.c=f,this.d=f.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(f,b){this.k();let m=null;if(f instanceof S.Position)m=new S.Range(f,f);else if(f instanceof S.Range)m=f;else throw new Error("Unrecognized location");this.l(m,b,!1)}insert(f,b){this.k(),this.l(new S.Range(f,f),b,!0)}delete(f){this.k();let b=null;if(f instanceof S.Range)b=f;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(f,b,m){const a=this.c.validateRange(f);this.g.push({range:a,text:b,forceMoveMarkers:m})}setEndOfLine(f){if(this.k(),f!==S.EndOfLine.LF&&f!==S.EndOfLine.CRLF)throw(0,C.illegalArgument)("endOfLine");this.h=f}}class k{constructor(f,b,m,a){this.c=f,this.d=b,this._accept(m),this.e=a;const o=this;this.value={get tabSize(){return o.f},set tabSize(l){o.m(l)},get indentSize(){return o.g},set indentSize(l){o.o(l)},get insertSpaces(){return o.h},set insertSpaces(l){o.q(l)},get cursorStyle(){return o.j},set cursorStyle(l){o.s(l)},get lineNumbers(){return o.k},set lineNumbers(l){o.t(l)}}}_accept(f){this.f=f.tabSize,this.g=f.indentSize,this.h=f.insertSpaces,this.j=f.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(f.lineNumbers)}l(f){if(f==="auto")return"auto";if(typeof f=="number"){const b=Math.floor(f);return b>0?b:null}if(typeof f=="string"){const b=parseInt(f,10);return isNaN(b)?null:b>0?b:null}return null}m(f){const b=this.l(f);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}n(f){if(f==="tabSize")return"tabSize";if(typeof f=="number"){const b=Math.floor(f);return b>0?b:null}if(typeof f=="string"){const b=parseInt(f,10);return isNaN(b)?null:b>0?b:null}return null}o(f){const b=this.n(f);if(b!==null){if(typeof b=="number"){if(this.g===b)return;this.g=b}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}p(f){return f==="auto"?"auto":f==="false"?!1:Boolean(f)}q(f){const b=this.p(f);if(typeof b=="boolean"){if(this.h===b)return;this.h=b}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}s(f){this.j!==f&&(this.j=f,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:f})))}t(f){this.k!==f&&(this.k=f,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(f)})))}assign(f){const b={};let m=!1;if(typeof f.tabSize<"u"){const a=this.l(f.tabSize);a==="auto"?(m=!0,b.tabSize=a):typeof a=="number"&&this.f!==a&&(this.f=a,m=!0,b.tabSize=a)}if(typeof f.indentSize<"u"){const a=this.n(f.indentSize);a==="tabSize"?(m=!0,b.indentSize=a):typeof a=="number"&&this.g!==a&&(this.g=a,m=!0,b.indentSize=a)}if(typeof f.insertSpaces<"u"){const a=this.p(f.insertSpaces);a==="auto"?(m=!0,b.insertSpaces=a):this.h!==a&&(this.h=a,m=!0,b.insertSpaces=a)}typeof f.cursorStyle<"u"&&this.j!==f.cursorStyle&&(this.j=f.cursorStyle,m=!0,b.cursorStyle=f.cursorStyle),typeof f.lineNumbers<"u"&&this.k!==f.lineNumbers&&(this.k=f.lineNumbers,m=!0,b.lineNumbers=M.TextEditorLineNumbersStyle.from(f.lineNumbers)),m&&this.u("setOptions",this.c.$trySetOptions(this.d,b))}u(f,b){b.catch(m=>{this.e.warn(`ExtHostTextEditorOptions '${f}' failed:'`),this.e.warn(m)})}}e.ExtHostTextEditorOptions=k;class N{constructor(f,b,m,a,o,l,g,E){this.id=f,this.j=b,this.k=m,this.g=!1,this.h=new Set,this.c=o,this.d=new k(this.j,this.id,l,m),this.e=g,this.f=E;const A=this;this.value=Object.freeze({get document(){return a.value},set document(v){throw(0,C.readonly)("document")},get selection(){return A.c&&A.c[0]},set selection(v){if(!(v instanceof S.Selection))throw(0,C.illegalArgument)("selection");A.c=[v],A.l()},get selections(){return A.c},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof S.Selection)))throw(0,C.illegalArgument)("selections");A.c=v,A.l()},get visibleRanges(){return A.e},set visibleRanges(v){throw(0,C.readonly)("visibleRanges")},get options(){return A.d.value},set options(v){A.g||A.d.assign(v)},get viewColumn(){return A.f},set viewColumn(v){throw(0,C.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(A.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const h=new y(a.value,t);return v(h),A.m(h)},insertSnippet(v,t,h={undoStopBefore:!0,undoStopAfter:!0}){if(A.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=A.c.map(u=>M.Range.from(u));else if(t instanceof S.Position){const{lineNumber:u,column:i}=M.Position.from(t);r=[{startLineNumber:u,startColumn:i,endLineNumber:u,endColumn:i}]}else if(t instanceof S.Range)r=[M.Range.from(t)];else{r=[];for(const u of t)if(u instanceof S.Range)r.push(M.Range.from(u));else{const{lineNumber:i,column:p}=M.Position.from(u);r.push({startLineNumber:i,startColumn:p,endLineNumber:i,endColumn:p})}}return b.$tryInsertSnippet(f,a.value.version,v.value,r,h)},setDecorations(v,t){const h=t.length===0;h&&!A.h.has(v.key)||(h?A.h.delete(v.key):A.h.add(v.key),A.n(()=>{if(M.isDecorationOptionsArr(t))return b.$trySetDecorations(f,v.key,M.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let u=0,i=t.length;u<i;u++){const p=t[u];r[4*u]=p.start.line+1,r[4*u+1]=p.start.character+1,r[4*u+2]=p.end.line+1,r[4*u+3]=p.end.character+1}return b.$trySetDecorationsFast(f,v.key,r)}}))},revealRange(v,t){A.n(()=>b.$tryRevealRange(f,M.Range.from(v),t||S.TextEditorRevealType.Default))},show(v){b.$tryShowEditor(f,M.ViewColumn.from(v))},hide(){b.$tryHideEditor(f)}})}dispose(){(0,n.ok)(!this.g),this.g=!0}_acceptOptions(f){(0,n.ok)(!this.g),this.d._accept(f)}_acceptVisibleRanges(f){(0,n.ok)(!this.g),this.e=f}_acceptViewColumn(f){(0,n.ok)(!this.g),this.f=f}_acceptSelections(f){(0,n.ok)(!this.g),this.c=f}async l(){const f=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,f)),this.value}m(f){const b=f.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const m=b.edits.map(o=>o.range);m.sort((o,l)=>o.end.line===l.end.line?o.end.character===l.end.character?o.start.line===l.start.line?o.start.character-l.start.character:o.start.line-l.start.line:o.end.character-l.end.character:o.end.line-l.end.line);for(let o=0,l=m.length-1;o<l;o++){const g=m[o].end;if(m[o+1].start.isBefore(g))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=b.edits.map(o=>({range:M.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,a,{setEndOfLine:typeof b.setEndOfLine=="number"?M.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(f){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):f().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.ExtHostTextEditor=N}),define(Ce[199],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[200],ke([1,0,154,12,29,90,68,30,25,199,164,156]),function(te,e,n,C,D,M,S,R,y,k,N,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const f=R.Registry.as(S.Extensions.JSONContribution);class b{constructor(v,t,h){this.a=v,this.b=t,this.c=h}d(v,t){this.a({type:v,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(v){this.d(D.default.Error,v)}warn(v){this.d(D.default.Warning,v)}info(v){this.d(D.default.Info,v)}}e.ExtensionMessageCollector=b;class m{static a(v){const t=new Set;for(let h=0,r=v.length;h<r;h++)t.add(y.ExtensionIdentifier.toKey(v[h].description.identifier));return t}static compute(v,t){if(!v||!v.length)return new m(t,[]);if(!t||!t.length)return new m([],v);const h=this.a(v),r=this.a(t),u=t.filter(p=>!h.has(y.ExtensionIdentifier.toKey(p.description.identifier))),i=v.filter(p=>!r.has(y.ExtensionIdentifier.toKey(p.description.identifier)));return new m(u,i)}constructor(v,t){this.added=v,this.removed=t}}e.ExtensionPointUserDelta=m;class a{constructor(v,t){this.name=v,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(v){if(this.a!==null)throw new Error("Handler already set!");this.a=v,this.d()}acceptUsers(v){this.c=m.compute(this.b,v),this.b=v,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(v){(0,C.onUnexpectedError)(v)}}}e.ExtensionPoint=a;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[n.localize(0,null),n.localize(1,null)]},l="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:n.localize(2,null),properties:{vscode:{type:"string",description:n.localize(3,null),default:"^1.22.0"}}},publisher:{description:n.localize(4,null),type:"string"},displayName:{description:n.localize(5,null),type:"string"},categories:{description:n.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:n.localize(7,null)}]}},galleryBanner:{type:"object",description:n.localize(8,null),properties:{color:{description:n.localize(9,null),type:"string"},theme:{description:n.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:n.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:n.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:n.localize(13,null)},enabledApiProposals:{markdownDescription:n.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:n.localize(15,null),type:"string",enum:["none"],enumDescriptions:[n.localize(16,null)]},activationEvents:{description:n.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:n.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:n.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:n.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:n.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:n.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:n.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:n.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:n.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:n.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:n.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:n.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:n.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:n.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:n.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:n.localize(32,null)},{label:"onUri",body:"onUri",description:n.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:n.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:n.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:n.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:n.localize(37,null)},{label:"onRenderer",description:n.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:n.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:n.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:n.localize(41,null)},{label:"*",description:n.localize(42,null),body:"*"}]}},badges:{type:"array",description:n.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:n.localize(44,null)},href:{type:"string",description:n.localize(45,null)},description:{type:"string",description:n.localize(46,null)}}}},markdown:{type:"string",description:n.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:n.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:n.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:n.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:n.localize(51,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:n.localize(52,null)},{body:["workspace"],description:n.localize(53,null)},{body:["ui","workspace"],description:n.localize(54,null)},{body:["workspace","ui"],description:n.localize(55,null)},{body:[],description:n.localize(56,null)}]},capabilities:{description:n.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:n.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:n.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(60,null),n.localize(61,null),n.localize(62,null)]},description:{type:"string",markdownDescription:n.localize(63,null)}}},untrustedWorkspaces:{description:n.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:n.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(66,null),n.localize(67,null),n.localize(68,null)]},restrictedConfigurations:{description:n.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:n.localize(70,null)}}}}},sponsor:{description:n.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:n.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:n.localize(73,null),type:"string"},"vscode:uninstall":{description:n.localize(74,null),type:"string"}}},icon:{type:"string",description:n.localize(75,null)},l10n:{type:"string",description:n.localize(76,null)}}};class g{constructor(){this.a=new Map}registerExtensionPoint(v){if(this.a.has(v.extensionPoint))throw new Error("Duplicate extension point: "+v.extensionPoint);const t=new a(v.extensionPoint,v.defaultExtensionKind);return this.a.set(v.extensionPoint,t),v.activationEventsGenerator&&w.ImplicitActivationEvents.register(v.extensionPoint,v.activationEventsGenerator),e.schema.properties.contributes.properties[v.extensionPoint]=v.jsonSchema,f.registerSchema(l,e.schema),t}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=g;const E={ExtensionsRegistry:"ExtensionsRegistry"};R.Registry.add(E.ExtensionsRegistry,new g),e.ExtensionsRegistry=R.Registry.as(E.ExtensionsRegistry),f.registerSchema(l,e.schema),f.registerSchema(N.productSchemaId,{properties:{extensionEnabledApiProposals:{description:n.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Ce[201],ke([1,0,151,9,22,200,42,4]),function(te,e,n,C,D,M,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:n.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:n.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:n.localize(2,null),default:""}}};var k;(function(f){function b(m,a,o){if(!m)return;const l=C.isString(m.type)?m.type:void 0;if(!l||l.length===0){o.error(n.localize(3,null));return}const g=[];if(Array.isArray(m.required))for(const E of m.required)C.isString(E)&&g.push(E);return{extensionId:a.value,taskType:l,required:g,properties:m.properties?D.deepClone(m.properties):{},when:m.when?S.ContextKeyExpr.deserialize(m.when):void 0}}f.from=b})(k||(k={}));const N=M.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:n.localize(4,null),type:"array",items:y}});class w{constructor(){this.d=new R.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,m)=>{N.setHandler((a,o)=>{this.c=void 0;try{for(const l of o.removed){const g=l.value;for(const E of g)this.a&&E.type&&this.a[E.type]&&delete this.a[E.type]}for(const l of o.added){const g=l.value;for(const E of g){const A=k.from(E,l.description.identifier,l.collector);A&&(this.a[A.taskType]=A)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const m of this.all()){const a={type:"object",additionalProperties:!1};m.required.length>0&&(a.required=m.required.slice(0)),m.properties!==void 0?a.properties=D.deepClone(m.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[m.taskType]},b.push(a)}this.c={oneOf:b}}return this.c}}e.TaskDefinitionRegistry=new w}),define(Ce[202],ke([1,0,152,9,24,22,42,201]),function(te,e,n,C,D,M,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new S.RawContextKey("taskRunning",!1,n.localize(0,null)),e.TASKS_CATEGORY={value:n.localize(1,null),original:"Tasks"};var y;(function(P){P[P.Escape=1]="Escape",P[P.Strong=2]="Strong",P[P.Weak=3]="Weak"})(y=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(P){function F(V){if(!V)return P.Strong;switch(V.toLowerCase()){case"escape":return P.Escape;case"strong":return P.Strong;case"weak":return P.Weak;default:return P.Strong}}P.from=F}(y=e.ShellQuoting||(e.ShellQuoting={}));var k;(function(P){P.defaults={cwd:"${workspaceFolder}"}})(k=e.CommandOptions||(e.CommandOptions={}));var N;(function(P){P[P.Always=1]="Always",P[P.Silent=2]="Silent",P[P.Never=3]="Never"})(N=e.RevealKind||(e.RevealKind={})),function(P){function F(V){switch(V.toLowerCase()){case"always":return P.Always;case"silent":return P.Silent;case"never":return P.Never;default:return P.Always}}P.fromString=F}(N=e.RevealKind||(e.RevealKind={}));var w;(function(P){P[P.Never=1]="Never",P[P.OnProblem=2]="OnProblem",P[P.Always=3]="Always"})(w=e.RevealProblemKind||(e.RevealProblemKind={})),function(P){function F(V){switch(V.toLowerCase()){case"always":return P.Always;case"never":return P.Never;case"onproblem":return P.OnProblem;default:return P.OnProblem}}P.fromString=F}(w=e.RevealProblemKind||(e.RevealProblemKind={}));var f;(function(P){P[P.Shared=1]="Shared",P[P.Dedicated=2]="Dedicated",P[P.New=3]="New"})(f=e.PanelKind||(e.PanelKind={})),function(P){function F(V){switch(V.toLowerCase()){case"shared":return P.Shared;case"dedicated":return P.Dedicated;case"new":return P.New;default:return P.Shared}}P.fromString=F}(f=e.PanelKind||(e.PanelKind={}));var b;(function(P){P.defaults={echo:!0,reveal:N.Always,revealProblems:w.Never,focus:!1,panel:f.Shared,showReuseMessage:!0,clear:!1}})(b=e.PresentationOptions||(e.PresentationOptions={}));var m;(function(P){P[P.Shell=1]="Shell",P[P.Process=2]="Process",P[P.CustomExecution=3]="CustomExecution"})(m=e.RuntimeType||(e.RuntimeType={})),function(P){function F(j){switch(j.toLowerCase()){case"shell":return P.Shell;case"process":return P.Process;case"customExecution":return P.CustomExecution;default:return P.Process}}P.fromString=F;function V(j){switch(j){case P.Shell:return"shell";case P.Process:return"process";case P.CustomExecution:return"customExecution";default:return"process"}}P.toString=V}(m=e.RuntimeType||(e.RuntimeType={}));var a;(function(P){function F(V){return C.isString(V)?V:V.value}P.value=F})(a=e.CommandString||(e.CommandString={}));var o;(function(P){P.Clean={_id:"clean",isDefault:!1},P.Build={_id:"build",isDefault:!1},P.Rebuild={_id:"rebuild",isDefault:!1},P.Test={_id:"test",isDefault:!1};function F(j){return j===P.Clean._id||j===P.Build._id||j===P.Rebuild._id||j===P.Test._id}P.is=F;function V(j){if(j!==void 0)return C.isString(j)?F(j)?{_id:j,isDefault:!1}:void 0:j}P.from=V})(o=e.TaskGroup||(e.TaskGroup={}));var l;(function(P){P[P.Global=1]="Global",P[P.Workspace=2]="Workspace",P[P.Folder=3]="Folder"})(l=e.TaskScope||(e.TaskScope={}));var g;(function(P){P.Workspace="workspace",P.Extension="extension",P.InMemory="inMemory",P.WorkspaceFile="workspaceFile",P.User="user";function F(V){switch(V){case P.User:return 2;case P.WorkspaceFile:return 5;default:return 6}}P.toConfigurationTarget=F})(g=e.TaskSourceKind||(e.TaskSourceKind={}));var E;(function(P){P.parallel="parallel",P.sequence="sequence"})(E=e.DependsOrder||(e.DependsOrder={}));var A;(function(P){P[P.default=1]="default",P[P.folderOpen=2]="folderOpen"})(A=e.RunOnOptions||(e.RunOnOptions={}));var v;(function(P){P.defaults={reevaluateOnRerun:!0,runOn:A.default,instanceLimit:1}})(v=e.RunOptions||(e.RunOptions={}));class t{constructor(F,V,j,le,_,be){this._label="",this._id=F,V&&(this._label=V),j&&(this.type=j),this.runOptions=le,this.configurationProperties=_,this._source=be}getDefinition(F){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,V=!1){if(F===void 0)return!1;if(C.isString(F))return F===this._label||F===this.configurationProperties.identifier||V&&F===this._id;const j=this.getDefinition(!0);return j!==void 0&&j._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.CommonTask=t;class h extends t{constructor(F,V,j,le,_,be,de,ue){super(F,j,void 0,de,ue,V),this.command={},this._source=V,this.hasDefinedMatchers=be,_&&(this.command=_)}clone(){return new h(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let V;switch(this.command?this.command.runtime:void 0){case m.Shell:V="shell";break;case m.Process:V="process";break;case m.CustomExecution:V="customExecution";break;case void 0:V="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:V,_key:this._id,id:this._id}}}static is(F){return F instanceof h}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const F=this.d();if(!F)return;let V=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(V+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:F,id:V};return JSON.stringify(j)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new h(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.CustomTask=h;class r extends t{constructor(F,V,j,le,_,be,de){super(F,j,le,be,de,V),this._source=V,this.configures=_}static is(F){return F instanceof r}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const F=this.d();if(!F)return;let V=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(V+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:F,id:V};return JSON.stringify(j)}}e.ConfiguringTask=r;class u extends t{constructor(F,V,j,le,_,be,de,ue,se){super(F,j,le,ue,se,V),this.defines=_,this.hasDefinedMatchers=de,this.command=be,this.icon=se.icon,this.hide=se.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof u}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new u(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.ContributedTask=u;class i extends t{constructor(F,V,j,le,_,be){super(F,j,le,_,be,V),this._source=V}clone(){return new i(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof i}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new i(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.InMemoryTask=i;var p;(function(P){P[P.Process=1]="Process",P[P.Terminal=2]="Terminal"})(p=e.ExecutionEngine||(e.ExecutionEngine={})),function(P){P._default=P.Terminal}(p=e.ExecutionEngine||(e.ExecutionEngine={}));var c;(function(P){P[P.V0_1_0=1]="V0_1_0",P[P.V2_0_0=2]="V2_0_0"})(c=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class s{constructor(F){this.c=new Map;for(let V=0;V<F.length;V++)this.c.set(F[V].uri.toString(),V)}compare(F,V){const j=F.getWorkspaceFolder(),le=V.getWorkspaceFolder();if(j&&le){let _=this.c.get(j.uri.toString());_=_===void 0?0:_+1;let be=this.c.get(le.uri.toString());return be=be===void 0?0:be+1,_===be?F._label.localeCompare(V._label):_-be}else return!j&&le?-1:j&&!le?1:0}}e.TaskSorter=s;var d;(function(P){P.DependsOnStarted="dependsOnStarted",P.AcquiredInput="acquiredInput",P.Start="start",P.ProcessStarted="processStarted",P.Active="active",P.Inactive="inactive",P.Changed="changed",P.Terminated="terminated",P.ProcessEnded="processEnded",P.End="end"})(d=e.TaskEventKind||(e.TaskEventKind={}));var T;(function(P){P.SingleRun="singleRun",P.Background="background"})(T=e.TaskRunType||(e.TaskRunType={}));var O;(function(P){P[P.System=0]="System",P[P.User=1]="User",P[P.FolderOpen=2]="FolderOpen",P[P.ConfigurationChange=3]="ConfigurationChange",P[P.Reconnect=4]="Reconnect"})(O=e.TaskRunSource||(e.TaskRunSource={}));var H;(function(P){function F(V,j,le,_){if(j){const be={kind:V,taskId:j._id,taskName:j.configurationProperties.name,runType:j.configurationProperties.isBackground?"background":"singleRun",group:j.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:le,__task:j};return V==="start"?be.resolvedVariables=_:V==="processStarted"?be.processId=_:V==="processEnded"&&(be.exitCode=_),Object.freeze(be)}else return Object.freeze({kind:"changed"})}P.create=F})(H=e.TaskEvent||(e.TaskEvent={}));var J;(function(P){function F(j){const le=Object.keys(j).sort();let _="";for(const be of le){let de=j[be];de instanceof Object?de=F(de):typeof de=="string"&&(de=de.replace(/,/g,",,")),_+=be+","+de+","}return _}function V(j){const _={_key:F(j),type:j.taskType};return Object.assign(_,j),_}P.create=V})(J=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var K;(function(P){P.AutoDetect="task.autoDetect",P.SaveBeforeRun="task.saveBeforeRun",P.ShowDecorations="task.showDecorations",P.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",P.SlowProviderWarning="task.slowProviderWarning",P.QuickOpenHistory="task.quickOpen.history",P.QuickOpenDetail="task.quickOpen.detail",P.QuickOpenSkip="task.quickOpen.skip",P.QuickOpenShowAll="task.quickOpen.showAll",P.AllowAutomaticTasks="task.allowAutomaticTasks",P.Reconnection="task.reconnection"})(K=e.TaskSettingId||(e.TaskSettingId={}));var L;(function(P){P.Tasks="tasks",P.SuppressTaskName="tasks.suppressTaskName",P.Windows="tasks.windows",P.Osx="tasks.osx",P.Linux="tasks.linux",P.ShowOutput="tasks.showOutput",P.IsShellCommand="tasks.isShellCommand",P.ServiceTestSetting="tasks.service.testSetting"})(L=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var B;(function(P){function F(V,j){const le=R.TaskDefinitionRegistry.get(V.type);if(le===void 0){const ue=M.deepClone(V);return delete ue._key,J.create(ue)}const _=Object.create(null);_.type=le.taskType;const be=new Set;le.required.forEach(ue=>be.add(ue));const de=le.properties;for(const ue of Object.keys(de)){const se=V[ue];if(se!=null)_[ue]=se;else if(be.has(ue)){const Z=de[ue];if(Z.default!==void 0)_[ue]=M.deepClone(Z.default);else switch(Z.type){case"boolean":_[ue]=!1;break;case"number":case"integer":_[ue]=0;break;case"string":_[ue]="";break;default:j.error(n.localize(2,null,JSON.stringify(V,void 0,0),ue));return}}}return J.create(_)}P.createTaskIdentifier=F})(B=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ce[203],ke([1,0,12]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class C{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((S,R)=>{this.b=S,this.d=R,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(S){this.f||this.h||(this.f=!0,this.g=S,this.a&&this.b(S))}resolveErr(S){this.f||this.h||(this.h=!0,this.i=S,this.a?this.d(S):(0,n.onUnexpectedError)(S))}then(S,R){return this.j().then(S,R)}catch(S){return this.j().then(void 0,S)}finally(S){return this.j().finally(S)}}e.LazyPromise=C;class D extends C{constructor(){super(),this.h=!0,this.i=new n.CancellationError}}e.CanceledLazyPromise=D}),define(Ce[46],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class n{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++n.count}}n.count=0,e.ProxyIdentifier=n;const C=[];function D(R){const y=new n(R);return C[y.nid]=y,y}e.createProxyIdentifier=D;function M(R){return C[R].sid}e.getStringIdentifierForProxy=M;class S{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=S}),define(Ce[5],ke([1,0,46]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var C;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(C=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput"})(D=e.TabInputKind||(e.TabInputKind={}));var M;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(M=e.TabModelOperationKind||(e.TabModelOperationKind={}));var S;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(S=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var R;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(R=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var N;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(N=e.CandidatePortSource||(e.CandidatePortSource={}));class w{static mixin(o){return o._id=w.a++,o}}w.a=0,e.IdObject=w;var f;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(f=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var b;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(b=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(m=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,n.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,n.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,n.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,n.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,n.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,n.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,n.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,n.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,n.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,n.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,n.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,n.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,n.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,n.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,n.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,n.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,n.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,n.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,n.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,n.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,n.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,n.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,n.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,n.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,n.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,n.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,n.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,n.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,n.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,n.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,n.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,n.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,n.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,n.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,n.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,n.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,n.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,n.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,n.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,n.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,n.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,n.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,n.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,n.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,n.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,n.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,n.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,n.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,n.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,n.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,n.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,n.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,n.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,n.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,n.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,n.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,n.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,n.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,n.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,n.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,n.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,n.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,n.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,n.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,n.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,n.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,n.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,n.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,n.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,n.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,n.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,n.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,n.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,n.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,n.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,n.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,n.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,n.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,n.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,n.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,n.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,n.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,n.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,n.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,n.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,n.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,n.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,n.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,n.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,n.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,n.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,n.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,n.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,n.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,n.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,n.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,n.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,n.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,n.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,n.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,n.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,n.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,n.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,n.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,n.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,n.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,n.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,n.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,n.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,n.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,n.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,n.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,n.createProxyIdentifier)("ExtHostLocalization")}}),define(Ce[76],ke([1,0,3,11,5,18]),function(te,e,n,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,n.createDecorator)("IExtHostApiDeprecationService");let S=class{constructor(y,k){this.c=k,this.a=new Set,this.b=y.getProxy(D.MainContext.MainThreadTelemetry)}report(y,k,N){const w=this.d(y,k);this.a.has(w)||(this.a.add(w),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${y}' is deprecated. ${N}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:y}))}d(y,k){return`${y}-${k.identifier.value}`}};S=qe([je(0,M.IExtHostRpcService),je(1,C.ILogService)],S),e.ExtHostApiDeprecationService=S,e.NullApiDeprecationService=Object.freeze(new class{report(R,y,k){}})}),define(Ce[204],ke([1,0,4,5,7,25]),function(te,e,n,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class S{constructor(y){this.b=new Map,this.c=[],this.d=new n.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=y.getProxy(C.MainContext.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,k,N,w={}){const f=M.ExtensionIdentifier.toKey(y.identifier),b=this.f.get(f)||[],m=[...N].sort().join(" ");let a=b.find(o=>o.providerId===k&&o.scopes===m);if(a)return a.result;{const o=this.g(y,f,k,N,w);a={providerId:k,scopes:m,result:o},b.push(a),this.f.set(f,b);try{await o}finally{const l=b.findIndex(g=>g.providerId===k&&g.scopes===m);l>-1&&(b.splice(l),this.f.set(f,b))}return o}}async g(y,k,N,w,f={}){await this.a.$ensureProvider(N);const b=y.displayName||y.name;return this.a.$getSession(N,w,k,b,f)}async removeSession(y,k){const N=this.b.get(y);return N?N.provider.removeSession(k):this.a.$removeSession(y,k)}registerAuthenticationProvider(y,k,N,w){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:k,provider:N,options:w??{supportsMultipleAccounts:!1}}),this.c.find(b=>b.id===y)||this.c.push({id:y,label:k});const f=N.onDidChangeSessions(b=>{this.a.$sendDidChangeSessions(y,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this.a.$registerAuthenticationProvider(y,k,w?.supportsMultipleAccounts??!1),new D.Disposable(()=>{f.dispose(),this.b.delete(y);const b=this.c.findIndex(m=>m.id===y);b>-1&&this.c.splice(b),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,k){const N=this.b.get(y);if(N)return Promise.resolve(N.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,k){const N=this.b.get(y);if(N)return Promise.resolve(N.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,k){const N=this.b.get(y);if(N)return Promise.resolve(N.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,k){return this.d.fire({provider:{id:y,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=S}),define(Ce[205],ke([1,0,5,18,8]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let M=class{constructor(R,y){this.a=R.getProxy(n.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>y.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(R,y,k){const N=D.WorkspaceEdit.from(R,this.b);return this.a.$tryApplyWorkspaceEdit(N,void 0,k?.isRefactoring??!1)}};M=qe([je(0,C.IExtHostRpcService)],M),e.ExtHostBulkEdits=M}),define(Ce[206],ke([1,0,5]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class C{constructor(M){const S=M.getProxy(n.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return S.$readText()},writeText(R){return S.$writeText(R)}})}}e.ExtHostClipboard=C});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[37],ke([1,0,9,7,8,22,5,15,11,65,44,259,2,6,3,18,101,23,46,39,77,52]),function(te,e,n,C,D,M,S,R,y,k,N,w,f,b,m,a,o,l,g,E,A,v){"use strict";var t,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{constructor(d,T){t.set(this,void 0),this.b=new Map,this.c=new Map,h.set(this,void 0),Je(this,t,d.getProxy(S.MainContext.MainThreadCommands),"f"),this.d=T,Je(this,h,d.getProxy(S.MainContext.MainThreadTelemetry),"f"),this.converter=new u(this,O=>{const H=this.c.get(O);return H?.result===p.Void?H:void 0},T),this.f=[{processArgument(O){return(0,k.revive)(O)}},{processArgument(O){return(0,M.cloneAndChange)(O,function(H){if(N.Range.isIRange(H))return D.Range.to(H);if(w.Position.isIPosition(H))return D.Position.to(H);if(N.Range.isIRange(H.range)&&f.URI.isUri(H.uri))return D.location.to(H);if(H instanceof l.VSBuffer)return H.buffer.buffer;if(!Array.isArray(H))return H})}}]}registerArgumentProcessor(d){this.f.push(d)}registerApiCommand(d){const T=this.registerCommand(!1,d.id,async(...O)=>{const H=d.args.map((K,L)=>{if(!K.validate(O[L]))throw new Error(`Invalid argument '${K.name}' when running '${d.id}', received: ${O[L]}`);return K.convert(O[L])}),J=await this.executeCommand(d.internalId,...H);return d.result.convert(J,O,this.converter)},void 0,{description:d.description,args:d.args,returns:d.result.description});return this.c.set(d.id,d),new C.Disposable(()=>{T.dispose(),this.c.delete(d.id)})}registerCommand(d,T,O,H,J,K){if(this.d.trace("ExtHostCommands#registerCommand",T),!T.trim().length)throw new Error("invalid id");if(this.b.has(T))throw new Error(`command '${T}' already exists`);return this.b.set(T,{callback:O,thisArg:H,description:J,extension:K}),d&&Le(this,t,"f").$registerCommand(T),new C.Disposable(()=>{this.b.delete(T)&&d&&Le(this,t,"f").$unregisterCommand(T)})}executeCommand(d,...T){return this.d.trace("ExtHostCommands#executeCommand",d),this.g(d,T,!0)}async g(d,T,O){if(this.b.has(d))return Le(this,t,"f").$fireCommandActivationEvent(d),this.h(d,T,!1);{let H=!1;const J=(0,M.cloneAndChange)(T,function(K){if(K instanceof C.Position)return D.Position.from(K);if(K instanceof C.Range)return D.Range.from(K);if(K instanceof C.Location)return D.location.from(K);if(C.NotebookRange.isNotebookRange(K))return D.NotebookRange.from(K);if(K instanceof ArrayBuffer)return H=!0,l.VSBuffer.wrap(new Uint8Array(K));if(K instanceof Uint8Array)return H=!0,l.VSBuffer.wrap(K);if(K instanceof l.VSBuffer)return H=!0,K;if(!Array.isArray(K))return K});try{const K=await Le(this,t,"f").$executeCommand(d,H?new g.SerializableObjectWithBuffers(J):J,O);return(0,k.revive)(K)}catch(K){if(K instanceof Error&&K.message==="$executeCommand:retry")return this.g(d,T,!1);throw K}}}async h(d,T,O){const H=this.b.get(d);if(!H)throw new Error("Unknown command");const{callback:J,thisArg:K,description:L}=H;if(L)for(let P=0;P<L.args.length;P++)try{(0,n.validateConstraint)(T[P],L.args[P].constraint)}catch{throw new Error(`Running the contributed command: '${d}' failed. Illegal argument '${L.args[P].name}' - ${L.args[P].description}`)}const B=A.StopWatch.create();try{return await J.apply(K,T)}catch(P){if(d===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...T);F&&(d=F.command)}throw this.d.error(P,d,H.extension?.identifier),O?new class extends Error{constructor(){super((0,E.toErrorMessage)(P)),this.id=d,this.source=H.extension?.displayName??H.extension?.name}}:P}finally{this.j(H,d,B.elapsed())}}j(d,T,O){!d.extension||Le(this,h,"f").$publicLog2("Extension:ActionExecuted",{extensionId:d.extension.identifier.value,id:new v.TelemetryTrustedValue(T),duration:O})}$executeContributedCommand(d,...T){this.d.trace("ExtHostCommands#$executeContributedCommand",d);const O=this.b.get(d);return O?(T=T.map(H=>this.f.reduce((J,K)=>K.processArgument(J,O.extension?.identifier),H)),this.h(d,T,!0)):Promise.reject(new Error(`Contributed command '${d}' does not exist.`))}getCommands(d=!1){return this.d.trace("ExtHostCommands#getCommands",d),Le(this,t,"f").$getCommands().then(T=>(d&&(T=T.filter(O=>O[0]!=="_")),T))}$getContributedCommandHandlerDescriptions(){const d=Object.create(null);for(const[T,O]of this.b){const{description:H}=O;H&&(d[T]=H)}return Promise.resolve(d)}};t=new WeakMap,h=new WeakMap,r=qe([je(0,a.IExtHostRpcService),je(1,y.ILogService)],r),e.ExtHostCommands=r,e.IExtHostCommands=(0,m.createDecorator)("IExtHostCommands");class u{constructor(d,T,O){this.d=d,this.f=T,this.g=O,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(d,T){if(!d)return;const O={$ident:void 0,id:d.command,title:d.title,tooltip:d.tooltip};if(!d.command)return O;const H=this.f(d.command);if(H)O.id=H.internalId,O.arguments=H.args.map((J,K)=>J.convert(d.arguments&&d.arguments[K]));else if((0,R.isNonEmptyArray)(d.arguments)){const J=`${d.command}/${++this.c}`;this.b.set(J,d),T.add((0,b.toDisposable)(()=>{this.b.delete(J),this.g.trace("CommandsConverter#DISPOSE",J)})),O.$ident=J,O.id=this.delegatingCommandId,O.arguments=[J],this.g.trace("CommandsConverter#CREATE",d.command,J)}return O}fromInternal(d){return typeof d.$ident=="string"?this.b.get(d.$ident):{command:d.id,title:d.title,arguments:d.arguments}}getActualCommand(...d){return this.b.get(d[0])}h(...d){const T=this.getActualCommand(...d);return this.g.trace("CommandsConverter#EXECUTE",d[0],T?T.command:"MISSING"),T?this.d.executeCommand(T.command,...T.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${d[0]}`)}}e.CommandsConverter=u;class i{constructor(d,T,O,H){this.name=d,this.description=T,this.validate=O,this.convert=H}optional(){return new i(this.name,`(optional) ${this.description}`,d=>d==null||this.validate(d),d=>d===void 0?void 0:d===null?null:this.convert(d))}with(d,T){return new i(d??this.name,T??this.description,this.validate,this.convert)}}i.Uri=new i("uri","Uri of a text document",s=>f.URI.isUri(s),s=>s),i.Position=new i("position","A position in a text document",s=>C.Position.isPosition(s),D.Position.from),i.Range=new i("range","A range in a text document",s=>C.Range.isRange(s),D.Range.from),i.Selection=new i("selection","A selection in a text document",s=>C.Selection.isSelection(s),D.Selection.from),i.Number=new i("number","",s=>typeof s=="number",s=>s),i.String=new i("string","",s=>typeof s=="string",s=>s),i.CallHierarchyItem=new i("item","A call hierarchy item",s=>s instanceof C.CallHierarchyItem,D.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",s=>s instanceof C.TypeHierarchyItem,D.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",s=>s instanceof o.TestItemImpl,D.TestItem.from),e.ApiCommandArgument=i;class p{constructor(d,T){this.description=d,this.convert=T}}p.Void=new p("no result",s=>s),e.ApiCommandResult=p;class c{constructor(d,T,O,H,J){this.id=d,this.internalId=T,this.description=O,this.args=H,this.result=J}}e.ApiCommand=c}),define(Ce[207],ke([1,0,2,8,7,75,37,15,88,92,16]),function(te,e,n,C,D,M,S,R,y,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const w=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",b(C.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,o)=>{if((0,R.isFalsyOrEmpty)(a))return;class l extends D.SymbolInformation{static to(E){const A=new l(E.name,C.SymbolKind.to(E.kind),E.containerName||"",new D.Location(o[0],C.Range.to(E.range)));return A.detail=E.detail,A.range=A.location.range,A.selectionRange=C.Range.to(E.selectionRange),A.children=E.children?E.children.map(l.to):[],A}}return a.map(l.to)})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(C.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(C.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new S.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(C.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",b(C.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",b(C.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(o=>D.Position.isPosition(o)),a=>a.map(C.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(o=>{let l;for(const g of o.reverse())l=new D.SelectionRange(C.Range.to(g),l);return l}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(C.WorkspaceSymbol.to))),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(C.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(C.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(C.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to a range and placeholder text.",a=>{if(!!a)return{range:C.Range.to(a.range),placeholder:a.text}})),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return C.WorkspaceEdit.to(a)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(C.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new D.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const o=(0,y.decodeSemanticTokensDto)(a);if(o.type==="full")return new D.SemanticTokens(o.data,void 0)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range.optional()],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new D.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const o=(0,y.decodeSemanticTokensDto)(a);if(o.type==="full")return new D.SemanticTokens(o.data,void 0)})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,o,l)=>{if(!a)return new D.CompletionList([]);const g=a.suggestions.map(E=>C.CompletionItem.to(E,l));return new D.CompletionList(g,a.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return C.SignatureHelp.to(a)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,o,l)=>b(g=>new D.CodeLens(C.Range.to(g.range),g.command&&l.fromInternal(g.command)))(a))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>D.Range.isRange(a),a=>D.Selection.isSelection(a)?C.Selection.from(a):C.Range.from(a)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,o,l)=>b(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(g.command)}else{const E=new D.CodeAction(g.title,g.kind?new D.CodeActionKind(g.kind):void 0);return g.edit&&(E.edit=C.WorkspaceEdit.to(g.edit)),g.command&&(E.command=l.fromInternal(g.command)),E.isPreferred=g.isPreferred,E}})(a))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(o=>new D.ColorInformation(C.Range.to(o.range),C.Color.to(o.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",a=>a instanceof D.Color,C.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:C.Range.from(a.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(C.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of Inlay objects",(a,o,l)=>a.map(C.InlayHint.to.bind(void 0,l)))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",b(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(o=>C.NotebookExclusiveDocumentPattern.to(o))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(C.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new S.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",a=>n.URI.isUri(a)||typeof a=="string"&&(0,k.matchesSomeScheme)(a,N.Schemas.http,N.Schemas.https),a=>a),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[C.ViewColumn.from(a),void 0]:[C.ViewColumn.from(a.viewColumn),C.TextEditorOpenOptions.from(a)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[C.ViewColumn.from(a),void 0]:[C.ViewColumn.from(a.viewColumn),C.TextEditorOpenOptions.from(a)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[C.ViewColumn.from(a.viewColumn),C.TextEditorOpenOptions.from(a)]).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(C.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(C.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(C.TypeHierarchyItem.to))),new S.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[S.ApiCommandArgument.TestItem],S.ApiCommandResult.Void),new S.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[S.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],S.ApiCommandResult.Void),new S.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[S.ApiCommandArgument.String.with("name","The context key name"),new S.ApiCommandArgument("value","The context key value",()=>!0,a=>a)],S.ApiCommandResult.Void)];class f{static register(o){w.forEach(o.registerApiCommand,o)}}e.ExtHostApiCommands=f;function b(a){return o=>{if(Array.isArray(o))return o.map(a)}}function m(a){if(!Array.isArray(a))return;const o=[];for(const l of a)M.isLocationLink(l)?o.push(C.DefinitionLink.to(l)):o.push(C.location.to(l));return o}}),define(Ce[208],ke([1,0,17,63,4,6,2,75,25,8,7,5]),function(te,e,n,C,D,M,S,R,y,k,N,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function f(b,m,a){const o=b.getProxy(w.MainContext.MainThreadComments);class l{constructor(){this.b=new Map,this.c=new Map,m.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const p=this.b.get(i.handle);return p?p.value:i}else if(i&&i.$mid===7){const p=this.b.get(i.commentControlHandle);if(!p)return i;const c=p.getCommentThread(i.commentThreadHandle);return c?c.value:i}else if(i&&(i.$mid===9||i.$mid===8)){const p=this.b.get(i.thread.commentControlHandle);if(!p)return i;const c=p.getCommentThread(i.thread.commentThreadHandle);return c?i.$mid===8?c.value:{thread:c.value,text:i.text}:i}else if(i&&i.$mid===10){const p=this.b.get(i.thread.commentControlHandle);if(!p)return i;const c=p.getCommentThread(i.thread.commentThreadHandle);if(!c)return i;const s=i.commentUniqueId,d=c.getCommentByUniqueId(s);return d||i}else if(i&&i.$mid===11){const p=this.b.get(i.thread.commentControlHandle);if(!p)return i;const c=p.getCommentThread(i.thread.commentThreadHandle);if(!c)return i;const s=i.text,d=i.commentUniqueId,T=c.getCommentByUniqueId(d);return T?(typeof T.body=="string"?T.body=s:T.body=new N.MarkdownString(s),T):i}return i}})}createCommentController(i,p,c){const s=l.a++,d=new E(i,s,p,c);this.b.set(d.handle,d);const T=this.c.get(y.ExtensionIdentifier.toKey(i.identifier))||[];return T.push(d),this.c.set(y.ExtensionIdentifier.toKey(i.identifier),T),d.value}$createCommentThreadTemplate(i,p,c){const s=this.b.get(i);!s||s.$createCommentThreadTemplate(p,c)}async $updateCommentThreadTemplate(i,p,c){const s=this.b.get(i);!s||s.$updateCommentThreadTemplate(p,c)}$deleteCommentThread(i,p){this.b.get(i)?.$deleteCommentThread(p)}$provideCommentingRanges(i,p,c){const s=this.b.get(i);if(!s||!s.commentingRangeProvider)return Promise.resolve(void 0);const d=a.getDocument(S.URI.revive(p));return(0,n.asPromise)(()=>s.commentingRangeProvider.provideCommentingRanges(d,c)).then(T=>T?T.map(O=>k.Range.from(O)):void 0)}$toggleReaction(i,p,c,s,d){const T=this.b.get(i);return!T||!T.reactionHandler?Promise.resolve(void 0):(0,n.asPromise)(()=>{const O=T.getCommentThread(p);if(O){const H=O.getCommentByUniqueId(s.uniqueIdInThread);if(T!==void 0&&H&&T.reactionHandler)return T.reactionHandler(H,t(d))}return Promise.resolve(void 0)})}dispose(){}}l.a=0;class g{set threadId(i){this.n=i}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(i){i.isEqual(this.p)||(this.p=i,this.b.range=i,this.c.fire())}get range(){return this.p}set canReply(i){this.d!==i&&(this.d=i,this.b.canReply=i,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(i){this.e=i,this.b.label=i,this.c.fire()}get contextValue(){return this.f}set contextValue(i){this.f=i,this.b.contextValue=i,this.c.fire()}get comments(){return this.q}set comments(i){this.q=i,this.b.comments=i,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(i){this.g=i,this.b.collapsibleState=i,this.c.fire()}get state(){return this.h}set state(i){this.h=i,this.b.state=i,this.c.fire()}get isDisposed(){return this.j}constructor(i,p,c,s,d,T,O,H){this.m=p,this.n=c,this.o=s,this.p=d,this.q=T,this.extensionDescription=O,this.r=H,this.handle=g.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new D.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.MutableDisposable,this.l.value=new M.DisposableStore,this.n===void 0&&(this.n=`${i}.${this.handle}`),o.$createCommentThread(p,this.handle,this.n,this.o,k.Range.from(this.p),O.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=T,this.i.push({dispose:()=>{o.$deleteCommentThread(p,this.handle)}});const J=this;this.value={get uri(){return J.uri},get range(){return J.range},set range(K){J.range=K},get comments(){return J.comments},set comments(K){J.comments=K},get collapsibleState(){return J.collapsibleState},set collapsibleState(K){J.collapsibleState=K},get canReply(){return J.canReply},set canReply(K){J.canReply=K},get contextValue(){return J.contextValue},set contextValue(K){J.contextValue=K},get label(){return J.label},set label(K){J.label=K},get state(){return J.state},set state(K){J.state=K},dispose:()=>{J.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.DisposableStore);const i=c=>Object.prototype.hasOwnProperty.call(this.b,c),p={};i("range")&&(p.range=k.Range.from(this.p)),i("label")&&(p.label=this.label),i("contextValue")&&(p.contextValue=this.contextValue??null),i("comments")&&(p.comments=this.q.map(c=>A(this,c,this.k))),i("collapsibleState")&&(p.collapseState=h(this.g)),i("canReply")&&(p.canReply=this.canReply),i("state")&&(p.state=r(this.h)),i("isTemplate")&&(p.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,p)}getCommentByUniqueId(i){for(const p of this.k){const c=p[0],s=p[1];if(i===s)return c}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(i=>i.dispose())}}g.a=0,qe([(0,C.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null);class E{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(i){this.b=i,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(i){this.c=i,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this.d}set options(i){this.d=i,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(i,p,c,s){this.f=i,this.g=p,this.h=c,this.i=s,this.a=new Map,o.$registerCommentController(this.handle,c,s);const d=this;this.value=Object.freeze({id:d.id,label:d.label,get options(){return d.options},set options(T){d.options=T},get commentingRangeProvider(){return d.commentingRangeProvider},set commentingRangeProvider(T){d.commentingRangeProvider=T},get reactionHandler(){return d.reactionHandler},set reactionHandler(T){d.reactionHandler=T},createCommentThread(T,O,H){return d.createCommentThread(T,O,H).value},dispose:()=>{d.dispose()}}),this.e=[],this.e.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(i,p,c,s){if(typeof i=="string"){const d=new g(this.id,this.handle,i,p,c,s,this.f,!1);return this.a.set(d.handle,d),d}else{const d=new g(this.id,this.handle,void 0,i,p,c,this.f,!1);return this.a.set(d.handle,d),d}}$createCommentThreadTemplate(i,p){const c=new g(this.id,this.handle,void 0,S.URI.revive(i),k.Range.to(p),[],this.f,!0);return c.collapsibleState=R.CommentThreadCollapsibleState.Expanded,this.a.set(c.handle,c),c}$updateCommentThreadTemplate(i,p){const c=this.a.get(i);c&&(c.range=k.Range.to(p))}$deleteCommentThread(i){this.a.get(i)?.dispose(),this.a.delete(i)}getCommentThread(i){return this.a.get(i)}dispose(){this.a.forEach(i=>{i.dispose()}),this.e.forEach(i=>i.dispose())}}function A(u,i,p){let c=p.get(i);c||(c=++u.commentHandle,p.set(i,c));const s=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:c,body:typeof i.body=="string"?i.body:k.MarkdownString.from(i.body),userName:i.author.name,userIconPath:s,label:i.label,commentReactions:i.reactions?i.reactions.map(d=>v(d)):void 0,timestamp:i.timestamp?.toJSON()}}function v(u){return{label:u.label,iconPath:u.iconPath?k.pathOrURIToURI(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted}}function t(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?S.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1}}function h(u){if(u!==void 0)switch(u){case N.CommentThreadCollapsibleState.Expanded:return R.CommentThreadCollapsibleState.Expanded;case N.CommentThreadCollapsibleState.Collapsed:return R.CommentThreadCollapsibleState.Collapsed}return R.CommentThreadCollapsibleState.Collapsed}function r(u){if(u!==void 0)switch(u){case N.CommentThreadState.Unresolved:return R.CommentThreadState.Unresolved;case N.CommentThreadState.Resolved:return R.CommentThreadState.Resolved}return R.CommentThreadState.Unresolved}return new l}e.createExtHostComments=f}),define(Ce[209],ke([1,0,22,5,26,18]),function(te,e,n,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let S=class{constructor(N,w){this.a=N.getProxy(C.MainContext.MainThreadConsole),this.b=w.consoleForward.includeStack,this.c=w.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(N,w){const f=this,b=console[N];Object.defineProperty(console,N,{set:()=>{},get:()=>function(){f.e(N,w,b,arguments)}})}e(N,w,f,b){this.a.$logExtensionHostMessage({type:"__$console",severity:w,arguments:y(b,this.b)}),this.c&&this.f(N,f,b)}};S=qe([je(0,M.IExtHostRpcService),je(1,D.IExtHostInitDataService)],S),e.AbstractExtHostConsoleForwarder=S;const R=1e5;function y(k,N){const w=[];if(k.length)for(let f=0;f<k.length;f++){let b=k[f];if(typeof b>"u")b="undefined";else if(b instanceof Error){const m=b;m.stack?b=m.stack:b=m.toString()}w.push(b)}if(N){const f=new Error().stack;f&&w.push({__$stack:f.split(`
`).slice(3).join(`
`)})}try{const f=(0,n.safeStringify)(w);return f.length>R?"Output omitted for a large object that exceeds the limits":f}catch(f){return`Output omitted for an object that cannot be inspected ('${f.toString()}')`}}}),define(Ce[103],ke([1,0,2,5,7,3,18,11,15,10,19,27]),function(te,e,n,C,D,M,S,R,y,k,N,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let f=class Mi{constructor(m,a){this.h=a,this.f=new Map,this.g=m.getProxy(C.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,a){const o=Mi.c++;this.f.set(o,{provider:m,extensionDescription:a}),this.g.$registerDecorationProvider(o,a.identifier.value);const l=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(g=>{if(!g){this.g.$onDidChange(o,null);return}const E=(0,y.asArray)(g);if(E.length<=Mi.d){this.g.$onDidChange(o,E);return}this.h.warn("[Decorations] CAPPING events from decorations provider",a.identifier.value,E.length);const A=E.map(h=>({uri:h,rank:(0,k.count)(h.path,"/")})),v=(0,y.groupBy)(A,(h,r)=>h.rank-r.rank||(0,k.compare)(h.uri.path,r.uri.path)),t=[];e:for(const h of v){let r;for(const u of h){const i=(0,N.dirname)(u.uri.path);if(r!==i&&(r=i,t.push(u.uri)>=Mi.d))break e}}this.g.$onDidChange(o,t)});return new D.Disposable(()=>{l?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(m,a,o){if(!this.f.has(m))return Object.create(null);const l=Object.create(null),{provider:g,extensionDescription:E}=this.f.get(m);return await Promise.all(a.map(async A=>{try{const{uri:v,id:t}=A,h=await Promise.resolve(g.provideFileDecoration(n.URI.revive(v),o));if(!h)return;try{D.FileDecoration.validate(h),h.badge&&typeof h.badge!="string"&&(0,w.checkProposedApiEnabled)(E,"codiconDecoration"),l[t]=[h.propagate,h.tooltip,h.badge,h.color]}catch(r){this.h.warn(`INVALID decoration from extension '${E}': ${r}`)}}catch(v){this.h.error(v)}})),l}};f.c=0,f.d=250,f=qe([je(0,S.IExtHostRpcService),je(1,R.ILogService)],f),e.ExtHostDecorations=f,e.IExtHostDecorations=(0,M.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[210],ke([1,0,139,91,2,5,7,8,4,11,28,36]),function(te,e,n,C,D,M,S,R,y,k,N,w){"use strict";var f,b,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class a{constructor(g,E,A,v,t,h,r){this.d=g,this.e=E,this.f=A,this.g=v,f.set(this,void 0),b.set(this,void 0),m.set(this,void 0),this.c=!1,Je(this,m,new N.ResourceMap(u=>t.getComparisonKey(u)),"f"),Je(this,f,h,"f"),Je(this,b,r,"f")}dispose(){this.c||(Le(this,b,"f").fire([...Le(this,m,"f").keys()]),Le(this,f,"f")?.$clear(this.e),Le(this,m,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(g,E){if(!g){this.clear();return}this.h();let A=[];if(D.URI.isUri(g)){if(!E){this.delete(g);return}Le(this,m,"f").set(g,E.slice()),A=[g]}else if(Array.isArray(g)){A=[];let t;g=[...g].sort(a.j);for(const h of g){const[r,u]=h;if((!t||r.toString()!==t.toString())&&(t&&Le(this,m,"f").get(t).length===0&&Le(this,m,"f").delete(t),t=r,A.push(r),Le(this,m,"f").set(r,[])),u)Le(this,m,"f").get(r)?.push(...u);else{const i=Le(this,m,"f").get(r);i&&(i.length=0)}}}if(Le(this,b,"f").fire(A),!Le(this,f,"f"))return;const v=[];for(const t of A){let h=[];const r=Le(this,m,"f").get(t);if(r)if(r.length>this.f){h=[];const u=[S.DiagnosticSeverity.Error,S.DiagnosticSeverity.Warning,S.DiagnosticSeverity.Information,S.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(const p of r)if(p.severity===u[i]&&h.push({...R.Diagnostic.from(p),modelVersionId:this.g(t)})===this.f)break e;h.push({severity:C.MarkerSeverity.Info,message:(0,n.localize)(0,null,r.length-this.f),startLineNumber:h[h.length-1].startLineNumber,startColumn:h[h.length-1].startColumn,endLineNumber:h[h.length-1].endLineNumber,endColumn:h[h.length-1].endColumn})}else h=r.map(u=>({...R.Diagnostic.from(u),modelVersionId:this.g(t)}));v.push([t,h])}Le(this,f,"f").$changeMany(this.e,v)}delete(g){this.h(),Le(this,b,"f").fire([g]),Le(this,m,"f").delete(g),Le(this,f,"f")?.$changeMany(this.e,[[g,void 0]])}clear(){this.h(),Le(this,b,"f").fire([...Le(this,m,"f").keys()]),Le(this,m,"f").clear(),Le(this,f,"f")?.$clear(this.e)}forEach(g,E){this.h();for(const[A,v]of this)g.call(E,A,v,this)}*[(f=new WeakMap,b=new WeakMap,m=new WeakMap,Symbol.iterator)](){this.h();for(const g of Le(this,m,"f").keys())yield[g,this.get(g)]}get(g){this.h();const E=Le(this,m,"f").get(g);return Array.isArray(E)?Object.freeze(E.slice(0)):[]}has(g){return this.h(),Array.isArray(Le(this,m,"f").get(g))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(g,E){return g[0].toString()<E[0].toString()?-1:g[0].toString()>E[0].toString()?1:0}}e.DiagnosticCollection=a;let o=class pi{static _mapper(g){const E=new N.ResourceMap;for(const A of g)E.set(A,A);return{uris:Object.freeze(Array.from(E.values()))}}constructor(g,E,A,v){this.h=E,this.j=A,this.k=v,this.f=new Map,this.g=new y.DebounceEmitter({merge:t=>t.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this.g.event,pi._mapper),this.e=g.getProxy(M.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(g,E){const{f:A,e:v,g:t,h,j:r,k:u}=this,i=new class{$changeMany(s,d){v.$changeMany(s,d),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,s,d.length===0?"CLEARING":d)}$clear(s){v.$clear(s),h.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,s)}dispose(){v.dispose()}};let p;if(!E)E="_generated_diagnostic_collection_name_#"+pi.c++,p=E;else if(!A.has(E))p=E;else{this.h.warn(`DiagnosticCollection with name '${E}' does already exist.`);do p=E+pi.c++;while(A.has(p))}return new class extends a{constructor(){super(E,p,pi.d,s=>u.getDocument(s)?.version,r.extUri,i,t),A.set(p,this)}dispose(){super.dispose(),A.delete(p)}}}getDiagnostics(g){if(g)return this.l(g);{const E=new Map,A=[];for(const v of this.f.values())v.forEach((t,h)=>{let r=E.get(t.toString());typeof r>"u"&&(r=A.length,E.set(t.toString(),r),A.push([t,[]])),A[r][1]=A[r][1].concat(...h)});return A}}l(g){let E=[];for(const A of this.f.values())A.has(g)&&(E=E.concat(A.get(g)));return E}$acceptMarkersChange(g){if(!this.m){const E="_generated_mirror",A=new a(E,E,pi.d,v=>{},this.j.extUri,void 0,this.g);this.f.set(E,A),this.m=A}for(const[E,A]of g)this.m.set(D.URI.revive(E),A.map(R.Diagnostic.to))}};o.c=0,o.d=1e3,o=qe([je(1,k.ILogService),je(2,w.IExtHostFileSystemInfo)],o),e.ExtHostDiagnostics=o}),define(Ce[211],ke([1,0,2,5]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(S){this.a=S.getProxy(C.MainContext.MainThreadDialogs)}showOpenDialog(S){return this.a.$showOpenDialog(S).then(R=>R?R.map(y=>n.URI.revive(y)):void 0)}showSaveDialog(S){return this.a.$showSaveDialog(S).then(R=>R?n.URI.revive(R):void 0)}}e.ExtHostDialogs=D}),define(Ce[212],ke([1,0,12,2,7,5,16,20,10]),function(te,e,n,C,D,M,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(w,f,b){this.d=f,this.e=b,this.b=new Map,this.c=w.getProxy(M.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(w,f){if(Object.keys(S.Schemas).indexOf(w)>=0)throw new Error(`scheme '${w}' already registered`);const b=k.a++;this.b.set(b,f),this.c.$registerTextContentProvider(b,w);let m;return typeof f.onDidChange=="function"&&(m=f.onDidChange(a=>{if(a.scheme!==w){this.e.warn(`Provider for scheme '${w}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this.d.getDocument(a)&&this.$provideTextDocumentContent(b,a).then(o=>{if(!o&&typeof o!="string")return;const l=this.d.getDocument(a);if(!l)return;const g=(0,y.splitLines)(o);if(!l.equalLines(g))return this.c.$onVirtualDocumentChange(a,o)},n.onUnexpectedError)})),new D.Disposable(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(w,f){const b=this.b.get(w);return b?Promise.resolve(b.provideTextDocumentContent(C.URI.revive(f),R.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${f.scheme}`))}}k.a=0,e.ExtHostDocumentContentProvider=k}),define(Ce[213],ke([1,0,4,6,2,5,99,8,9,22,7]),function(te,e,n,C,D,M,S,R,y,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class w{constructor(b,m){this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter,this.d=new n.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new C.DisposableStore,this.h=new Map,this.f=b.getProxy(M.MainContext.MainThreadDocuments),this.g=m,this.g.onDidRemoveDocuments(a=>{for(const o of a)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(a=>{for(const o of a)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const m=this.g.getDocument(b);if(m)return m}getDocument(b){const m=this.getDocumentData(b);if(!m?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return m.document}ensureDocumentData(b){const m=this.g.getDocument(b);if(m)return Promise.resolve(m);let a=this.h.get(b.toString());return a||(a=this.f.$tryOpenDocument(b).then(o=>{this.h.delete(b.toString());const l=D.URI.revive(o);return(0,y.assertIsDefined)(this.g.getDocument(l))},o=>(this.h.delete(b.toString()),Promise.reject(o))),this.h.set(b.toString(),a)),a}createDocumentData(b){return this.f.$tryCreateDocument(b).then(m=>D.URI.revive(m))}$acceptModelLanguageChanged(b,m){const a=D.URI.revive(b),o=this.g.getDocument(a);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(m),this.a.fire(o.document)}$acceptModelSaved(b){const m=D.URI.revive(b),a=this.g.getDocument(m);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(a.document)}$acceptDirtyStateChanged(b,m){const a=D.URI.revive(b),o=this.g.getDocument(a);if(!o)throw new Error("unknown document");o._acceptIsDirty(m),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,m,a){const o=D.URI.revive(b),l=this.g.getDocument(o);if(!l)throw new Error("unknown document");l._acceptIsDirty(a),l.onEvents(m);let g;m.isUndoing?g=N.TextDocumentChangeReason.Undo:m.isRedoing&&(g=N.TextDocumentChangeReason.Redo),this.c.fire((0,k.deepFreeze)({document:l.document,contentChanges:m.changes.map(E=>({range:R.Range.to(E.range),rangeOffset:E.rangeOffset,rangeLength:E.rangeLength,text:E.text})),reason:g}))}setWordDefinitionFor(b,m){(0,S.setWordDefinitionFor)(b,m)}}e.ExtHostDocuments=w}),define(Ce[57],ke([1,0,49,4,6,2,3,5,99,18,102,8,11,28,16,185,85]),function(te,e,n,C,D,M,S,R,y,k,N,w,f,b,m,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class l{constructor(A){this.value=A,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let g=class{constructor(A,v){this.h=A,this.i=v,this.a=null,this.b=new Map,this.c=new b.ResourceMap,this.d=new C.Emitter,this.e=new C.Emitter,this.f=new C.Emitter,this.g=new C.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(A){this.acceptDocumentsAndEditorsDelta(A)}acceptDocumentsAndEditorsDelta(A){const v=[],t=[],h=[];if(A.removedDocuments)for(const r of A.removedDocuments){const u=M.URI.revive(r),i=this.c.get(u);i?.unref()&&(this.c.delete(u),v.push(i.value))}if(A.addedDocuments)for(const r of A.addedDocuments){const u=M.URI.revive(r.uri);let i=this.c.get(u);if(i&&u.scheme!==m.Schemas.vscodeNotebookCell&&u.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);i||(i=new l(new y.ExtHostDocumentData(this.h.getProxy(R.MainContext.MainThreadDocuments),u,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this.c.set(u,i),t.push(i.value)),i.ref()}if(A.removedEditors)for(const r of A.removedEditors){const u=this.b.get(r);this.b.delete(r),u&&h.push(u)}if(A.addedEditors)for(const r of A.addedEditors){const u=M.URI.revive(r.documentUri);n.ok(this.c.has(u),`document '${u}' does not exist`),n.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const i=this.c.get(u).value,p=new N.ExtHostTextEditor(r.id,this.h.getProxy(R.MainContext.MainThreadTextEditors),this.i,new o.Lazy(()=>i.document),r.selections.map(w.Selection.to),r.options,r.visibleRanges.map(c=>w.Range.to(c)),typeof r.editorPosition=="number"?w.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,p)}A.newActiveEditor!==void 0&&(n.ok(A.newActiveEditor===null||this.b.has(A.newActiveEditor),`active editor '${A.newActiveEditor}' does not exist`),this.a=A.newActiveEditor),(0,D.dispose)(v),(0,D.dispose)(h),A.removedDocuments&&this.e.fire(v),A.addedDocuments&&this.d.fire(t),(A.removedEditors||A.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),A.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(A){return this.c.get(A)?.value}allDocuments(){return a.Iterable.map(this.c.values(),A=>A.value)}getEditor(A){return this.b.get(A)}activeEditor(A){if(!this.a)return;const v=this.b.get(this.a);return A?v:v?.value}allEditors(){return[...this.b.values()]}};g=qe([je(0,k.IExtHostRpcService),je(1,f.ILogService)],g),e.ExtHostDocumentsAndEditors=g,e.IExtHostDocumentsAndEditors=(0,S.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ce[58],ke([1,0,8,5,2,4,3,7,18,9,62]),function(te,e,n,C,D,M,S,R,y,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,S.createDecorator)("IExtHostEditorTabs");class w{constructor(o,l,g){this.e=g,this.d=l,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,l={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(l)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.TextTabInput(D.URI.revive(this.b.input.uri));case 2:return new R.TextDiffTabInput(D.URI.revive(this.b.input.original),D.URI.revive(this.b.input.modified));case 3:return new R.TextMergeTabInput(D.URI.revive(this.b.input.base),D.URI.revive(this.b.input.input1),D.URI.revive(this.b.input.input2),D.URI.revive(this.b.input.result));case 6:return new R.CustomEditorTabInput(D.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.WebviewEditorTabInput(this.b.input.viewType);case 4:return new R.NotebookEditorTabInput(D.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.NotebookDiffEditorTabInput(D.URI.revive(this.b.input.original),D.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.TerminalEditorTabInput;case 9:return new R.InteractiveWindowInput(D.URI.revive(this.b.input.uri),D.URI.revive(this.b.input.inputBoxUri));default:return}}}class f{constructor(o,l){this.c=[],this.d="",this.b=o,this.e=l;for(const g of o.tabs)g.isActive&&(this.d=g.id),this.c.push(new w(g,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,l={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return n.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(g=>g.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(g=>g.apiObject))}};this.a=Object.freeze(l)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const g=new w(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,g),o.tabDto.isActive&&(this.d=g.tabId),g}else if(o.kind===1){const g=this.c.splice(o.index,1)[0];if(!g)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return g.tabId===this.d&&(this.d=""),g}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const g=this.c.splice(o.oldIndex,1)[0];if(!g)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,g),g}const l=this.c.find(g=>g.tabId===o.tabDto.id);if(!l)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),l.acceptDtoUpdate(o.tabDto),l}activeTabId(){return this.d}}let b=class{constructor(o){this.b=new M.Emitter,this.c=new M.Emitter,this.e=[],this.a=o.getProxy(C.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,l={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(g=>g.apiObject))},get activeTabGroup(){const g=o.d;return(0,k.assertIsDefined)(o.e.find(A=>A.groupId===g)?.apiObject)},close:async(g,E)=>{const A=Array.isArray(g)?g:[g];return A.length?m(A[0])?this.j(A,E):this.i(A,E):!0}};this.f=Object.freeze(l)}return this.f}$acceptEditorTabModel(o){const l=new Set(this.e.map(r=>r.groupId)),g=new Set(o.map(r=>r.groupId)),E=(0,N.diffSets)(l,g),A=this.e.filter(r=>E.removed.includes(r.groupId)).map(r=>r.apiObject),v=[],t=[];this.e=o.map(r=>{const u=new f(r,()=>this.d);return E.added.includes(u.groupId)?v.push(u.apiObject):t.push(u.apiObject),u});const h=(0,k.assertIsDefined)(o.find(r=>r.isActive===!0)?.groupId);h!==void 0&&this.d!==h&&(this.d=h),this.c.fire(Object.freeze({opened:v,closed:A,changed:t}))}$acceptTabGroupUpdate(o){const l=this.e.find(g=>g.groupId===o.groupId);if(!l)throw new Error("Update Group IPC call received before group creation.");l.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[l.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const l=this.e.find(E=>E.groupId===o.groupId);if(!l)throw new Error("Update Tabs IPC call received before group creation.");const g=l.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[g.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[g.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[g.apiObject]}));return}}g(o){for(const l of this.e)for(const g of l.tabs)if(g.apiObject===o)return g}h(o){return this.e.find(l=>l.apiObject===o)}async i(o,l){const g=[];for(const E of o){const A=this.g(E);if(!A)throw new Error("Tab close: Invalid tab not found!");g.push(A.tabId)}return this.a.$closeTab(g,l)}async j(o,l){const g=[];for(const E of o){const A=this.h(E);if(!A)throw new Error("Group close: Invalid group not found!");g.push(A.groupId)}return this.a.$closeGroup(g,l)}};b=qe([je(0,y.IExtHostRpcService)],b),e.ExtHostEditorTabs=b;function m(a){return a.tabs!==void 0}}),define(Ce[214],ke([1,0,2,5,6,7,8,260,10,23,27]),function(te,e,n,C,D,M,S,R,y,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class w{constructor(){this.a=[]}add(m){this.b=void 0,this.a.push(m)}delete(m){const a=this.a.indexOf(m);a>=0&&(this.a.splice(a,1),this.b=void 0)}c(){if(!this.b){const m=this.a.sort(),a=[];let o,l,g=14,E=14;for(const A of m){let v=o?(0,y.commonPrefixLength)(o,A):0;for(v===0?l=1:l=E;v<A.length;v++)v+1===A.length?(g=E,E=9):E+=1,a.push([l,A.toUpperCase().charCodeAt(v),E]),a.push([l,A.toLowerCase().charCodeAt(v),E]),l=E;o=A,E=g}a.push([9,58,10]),a.push([10,47,12]),this.b=new R.StateMachine(a)}}provideDocumentLinks(m){this.c();const a=[],o=R.LinkComputer.computeLinks({getLineContent(l){return m.lineAt(l-1).text},getLineCount(){return m.lineCount}},this.b);for(const l of o){const g=S.DocumentLink.to(l);g.target&&a.push(g)}return a}}class f{constructor(m,a){this.i=a,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=m.getProxy(C.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(m,a,o,l={}){if(this.d.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(m,"*",this.b));const g=this.h++;this.b.add(a),this.d.add(a),this.c.set(g,o);let E=2;l.isCaseSensitive&&(E+=1024),l.isReadonly&&(E+=2048),typeof o.copy=="function"&&(E+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,N.checkProposedApiEnabled)(m,"fsChunks"),E+=4),this.a.$registerFileSystemProvider(g,a,E).catch(v=>{console.error(`FAILED to register filesystem provider of ${m.identifier.value}-extension for the scheme ${a}`),console.error(v)});const A=o.onDidChangeFile(v=>{const t=[];for(const h of v){const{uri:r,type:u}=h;if(r.scheme!==a)continue;let i;switch(u){case M.FileChangeType.Changed:i=0;break;case M.FileChangeType.Created:i=1;break;case M.FileChangeType.Deleted:i=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:r,type:i})}this.a.$onFileSystemChange(g,t)});return(0,D.toDisposable)(()=>{A.dispose(),this.b.delete(a),this.d.delete(a),this.c.delete(g),this.a.$unregisterProvider(g)})}static j(m){const{type:a,ctime:o,mtime:l,size:g,permissions:E}=m;return{type:a,ctime:o,mtime:l,size:g,permissions:E}}$stat(m,a){return Promise.resolve(this.k(m).stat(n.URI.revive(a))).then(o=>f.j(o))}$readdir(m,a){return Promise.resolve(this.k(m).readDirectory(n.URI.revive(a)))}$readFile(m,a){return Promise.resolve(this.k(m).readFile(n.URI.revive(a))).then(o=>k.VSBuffer.wrap(o))}$writeFile(m,a,o,l){return Promise.resolve(this.k(m).writeFile(n.URI.revive(a),o.buffer,l))}$delete(m,a,o){return Promise.resolve(this.k(m).delete(n.URI.revive(a),o))}$rename(m,a,o,l){return Promise.resolve(this.k(m).rename(n.URI.revive(a),n.URI.revive(o),l))}$copy(m,a,o,l){const g=this.k(m);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(n.URI.revive(a),n.URI.revive(o),l))}$mkdir(m,a){return Promise.resolve(this.k(m).createDirectory(n.URI.revive(a)))}$watch(m,a,o,l){const g=this.k(m).watch(n.URI.revive(o),l);this.f.set(a,g)}$unwatch(m,a){const o=this.f.get(a);o&&(o.dispose(),this.f.delete(a))}$open(m,a,o){const l=this.k(m);if(!l.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(l.open(n.URI.revive(a),o))}$close(m,a){const o=this.k(m);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(a))}$read(m,a,o,l){const g=this.k(m);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const E=k.VSBuffer.alloc(l);return Promise.resolve(g.read(a,o,E.buffer,0,l)).then(A=>E.slice(0,A))}$write(m,a,o,l){const g=this.k(m);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(a,o,l.buffer,0,l.byteLength))}k(m){const a=this.c.get(m);if(!a){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return a}}e.ExtHostFileSystem=f}),define(Ce[59],ke([1,0,5,43,7,23,3,18,36,6]),function(te,e,n,C,D,M,S,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let N=class Yt{constructor(f,b){this.b=new Map,this.a=f.getProxy(n.MainContext.MainThreadFileSystem);const m=this;this.value=Object.freeze({async stat(a){try{const o=m.b.get(a.scheme);if(!o)return await m.a.$stat(a);await m.a.$ensureActivation(a.scheme);const l=await o.stat(a);return{type:l.type,ctime:l.ctime,mtime:l.mtime,size:l.size,permissions:l.permissions}}catch(o){Yt.c(o)}},async readDirectory(a){try{const o=m.b.get(a.scheme);return o?(await m.a.$ensureActivation(a.scheme),(await o.readDirectory(a)).slice()):await m.a.$readdir(a)}catch(o){return Yt.c(o)}},async createDirectory(a){try{return await m.a.$mkdir(a)}catch(o){return Yt.c(o)}},async readFile(a){try{const o=m.b.get(a.scheme);return o?(await m.a.$ensureActivation(a.scheme),(await o.readFile(a)).slice()):(await m.a.$readFile(a)).buffer}catch(o){return Yt.c(o)}},async writeFile(a,o){try{return await m.a.$writeFile(a,M.VSBuffer.wrap(o))}catch(l){return Yt.c(l)}},async delete(a,o){try{const l=m.b.get(a.scheme);return l?(await m.a.$ensureActivation(a.scheme),await l.delete(a,{recursive:!1,...o})):await m.a.$delete(a,{recursive:!1,useTrash:!1,...o})}catch(l){return Yt.c(l)}},async rename(a,o,l){try{return await m.a.$rename(a,o,{overwrite:!1,...l})}catch(g){return Yt.c(g)}},async copy(a,o,l){try{return await m.a.$copy(a,o,{overwrite:!1,...l})}catch(g){return Yt.c(g)}},isWritableFileSystem(a){const o=b.getCapabilities(a);if(typeof o=="number")return!(o&2048)}})}static c(f){if(f instanceof D.FileSystemError)throw f;if(!(f instanceof Error))throw new D.FileSystemError(String(f));if(f.name==="ENOPRO"||f.message.includes("ENOPRO"))throw D.FileSystemError.Unavailable(f.message);switch(f.name){case C.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(f.message);case C.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(f.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(f.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(f.message);case C.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(f.message);case C.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(f.message);default:throw new D.FileSystemError(f.message,f.name)}}addFileSystemProvider(f,b){return this.b.set(f,b),(0,k.toDisposable)(()=>this.b.delete(f))}};N=qe([je(0,R.IExtHostRpcService),je(1,y.IExtHostFileSystemInfo)],N),e.ExtHostConsumerFileSystem=N,e.IExtHostConsumerFileSystem=(0,S.createDecorator)("IExtHostConsumerFileSystem")}),define(Ce[215],ke([1,0,4,35,2,5,8,7]),function(te,e,n,C,D,M,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(w,f,b,m,a,o,l,g){this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter;const E=this.h(w,b,a);this.g=0,o&&(this.g+=1),l&&(this.g+=2),g&&(this.g+=4);const A=(0,C.parse)(a),v=typeof a=="string",t=m(h=>{if(!o)for(const r of h.created){const u=D.URI.revive(r);A(u.fsPath)&&(!v||f.getWorkspaceFolder(u))&&this.a.fire(u)}if(!l)for(const r of h.changed){const u=D.URI.revive(r);A(u.fsPath)&&(!v||f.getWorkspaceFolder(u))&&this.b.fire(u)}if(!g)for(const r of h.deleted){const u=D.URI.revive(r);A(u.fsPath)&&(!v||f.getWorkspaceFolder(u))&&this.c.fire(u)}});this.d=R.Disposable.from(E,this.a,this.b,this.c,t)}h(w,f,b){const m=R.Disposable.from();if(typeof b=="string")return m;const a=w.getProxy(M.MainContext.MainThreadFileSystem);let o=!1;(b.pattern.includes(C.GLOBSTAR)||b.pattern.includes(C.GLOB_SPLIT))&&(o=!0);const l=Math.random();return a.$watch(f.identifier.value,l,b.baseUri,{recursive:o,excludes:[]}),R.Disposable.from({dispose:()=>a.$unwatch(l)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class k{constructor(w,f,b){this.j=w,this.k=f,this.l=b,this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter,this.d=new n.Emitter,this.g=new n.AsyncEmitter,this.h=new n.AsyncEmitter,this.i=new n.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,f,b,m,a,o){return new y(this.j,w,f,this.a.event,S.GlobPattern.from(b),m,a,o)}$onFileEvent(w){this.a.fire(w)}$onDidRunFileOperation(w,f){switch(w){case 2:this.b.fire(Object.freeze({files:f.map(b=>({oldUri:D.URI.revive(b.source),newUri:D.URI.revive(b.target)}))}));break;case 1:this.d.fire(Object.freeze({files:f.map(b=>D.URI.revive(b.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:f.map(b=>D.URI.revive(b.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,f){return(b,m,a)=>{const o=function(g){b.call(m,g)};return o.extension=w,f.event(o,void 0,a)}}async $onWillRunFileOperation(w,f,b,m){switch(w){case 2:return await this.n(this.g,{files:f.map(a=>({oldUri:D.URI.revive(a.source),newUri:D.URI.revive(a.target)}))},b,m);case 1:return await this.n(this.i,{files:f.map(a=>D.URI.revive(a.target))},b,m);case 0:case 3:return await this.n(this.h,{files:f.map(a=>D.URI.revive(a.target))},b,m)}}async n(w,f,b,m){const a=new Set,o=[];if(await w.fireAsync(f,m,async(g,E)=>{const A=Date.now(),v=await Promise.resolve(g);v instanceof R.WorkspaceEdit&&(o.push([E.extension,v]),a.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-A>b&&this.k.warn("SLOW file-participant",E.extension.identifier)}),m.isCancellationRequested||o.length===0)return;const l={edits:[]};for(const[,g]of o){const{edits:E}=S.WorkspaceEdit.from(g,{getTextDocumentVersion:A=>this.l.getDocument(A)?.version,getNotebookDocumentVersion:()=>{}});l.edits=l.edits.concat(E)}return{edit:l,extensionNames:Array.from(a)}}}e.ExtHostFileSystemEventService=k}),define(Ce[216],ke([1,0,2,37]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(S,R,y,k,N){this.a=R,this.b=y,this.c=k;const w=new C.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new C.ApiCommandArgument("showOptions","Show Options",f=>!0,f=>f),new C.ApiCommandArgument("resource","Interactive resource Uri",f=>!0,f=>f),new C.ApiCommandArgument("controllerId","Notebook controller Id",f=>!0,f=>f),new C.ApiCommandArgument("title","Interactive editor title",f=>!0,f=>f)],new C.ApiCommandResult("Notebook and input URI",f=>{if(N.debug("[ExtHostInteractive] open iw with notebook editor id",f.notebookEditorId),f.notebookEditorId!==void 0){const b=this.a.getEditorById(f.notebookEditorId);return N.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:n.URI.revive(f.notebookUri),inputUri:n.URI.revive(f.inputUri),notebookEditor:b.apiEditor}}return N.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",f.notebookUri,f.inputUri),{notebookUri:n.URI.revive(f.notebookUri),inputUri:n.URI.revive(f.inputUri)}}));this.c.registerApiCommand(w)}$willAddInteractiveDocument(S,R,y,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:R,lines:[""],languageId:y,uri:S,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(n.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(S,R){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[S]})}}e.ExtHostInteractive=D}),define(Ce[217],ke([1,0,6,5]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(S){this.b=0,this.a=S.getProxy(C.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(S){const R=this.b++;return this.a.$registerResourceLabelFormatter(R,S),(0,n.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(R)})}}e.ExtHostLabelService=D}),define(Ce[218],ke([1,0,2,22,8,7,75,5,10,44,15,9,261,20,6,88,83,54,77,12,17,27]),function(te,e,n,C,D,M,S,R,y,k,N,w,f,b,m,a,o,l,g,E,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class t{constructor(I,$){this.d=I,this.e=$}async provideDocumentSymbols(I,$){const W=this.d.getDocument(I),q=await this.e.provideDocumentSymbols(W,$);if(!(0,N.isFalsyOrEmpty)(q))return q[0]instanceof M.DocumentSymbol?q.map(D.DocumentSymbol.from):t.f(q)}static f(I){I=I.slice(0).sort((q,ie)=>{let fe=q.location.range.start.compareTo(ie.location.range.start);return fe===0&&(fe=ie.location.range.end.compareTo(q.location.range.end)),fe});const $=[],W=[];for(const q of I){const ie={name:q.name||"!!MISSING: name!!",kind:D.SymbolKind.from(q.kind),tags:q.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:q.containerName,range:D.Range.from(q.location.range),selectionRange:D.Range.from(q.location.range),children:[]};for(;;){if(W.length===0){W.push(ie),$.push(ie);break}const fe=W[W.length-1];if(k.Range.containsRange(fe.range,ie.range)&&!k.Range.equalsRange(fe.range,ie.range)){fe.children?.push(ie),W.push(ie);break}W.pop()}}return $}}class h{constructor(I,$,W){this.g=I,this.h=$,this.j=W,this.e=new l.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(I,$){const W=this.g.getDocument(I),q=await this.j.provideCodeLenses(W,$);if(!q||$.isCancellationRequested)return;const ie=this.e.add(q),fe=new m.DisposableStore;this.f.set(ie,fe);const ye={cacheId:ie,lenses:[]};for(let ae=0;ae<q.length;ae++)ye.lenses.push({cacheId:[ie,ae],range:D.Range.from(q[ae].range),command:this.h.toInternal(q[ae].command,fe)});return ye}async resolveCodeLens(I,$){const W=I.cacheId&&this.e.get(...I.cacheId);if(!W)return;let q;if(typeof this.j.resolveCodeLens!="function"||W.isResolved?q=W:q=await this.j.resolveCodeLens(W,$),q||(q=W),$.isCancellationRequested)return;const ie=I.cacheId&&this.f.get(I.cacheId[0]);if(!!ie)return I.command=this.h.toInternal(q.command??h.d,ie),I}releaseCodeLenses(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}}h.d={command:"missing",title:"!!MISSING: command!!"};function r(Y){return Array.isArray(Y)?Y.map(D.DefinitionLink.from):Y?[D.DefinitionLink.from(Y)]:[]}class u{constructor(I,$){this.d=I,this.e=$}async provideDefinition(I,$,W){const q=this.d.getDocument(I),ie=D.Position.to($),fe=await this.e.provideDefinition(q,ie,W);return r(fe)}}class i{constructor(I,$){this.d=I,this.e=$}async provideDeclaration(I,$,W){const q=this.d.getDocument(I),ie=D.Position.to($),fe=await this.e.provideDeclaration(q,ie,W);return r(fe)}}class p{constructor(I,$){this.d=I,this.e=$}async provideImplementation(I,$,W){const q=this.d.getDocument(I),ie=D.Position.to($),fe=await this.e.provideImplementation(q,ie,W);return r(fe)}}class c{constructor(I,$){this.d=I,this.e=$}async provideTypeDefinition(I,$,W){const q=this.d.getDocument(I),ie=D.Position.to($),fe=await this.e.provideTypeDefinition(q,ie,W);return r(fe)}}class s{constructor(I,$){this.d=I,this.e=$}async provideHover(I,$,W){const q=this.d.getDocument(I),ie=D.Position.to($),fe=await this.e.provideHover(q,ie,W);if(!(!fe||(0,N.isFalsyOrEmpty)(fe.contents)))return fe.range||(fe.range=q.getWordRangeAtPosition(ie)),fe.range||(fe.range=new M.Range(ie,ie)),D.Hover.from(fe)}}class d{constructor(I,$){this.d=I,this.e=$}async provideEvaluatableExpression(I,$,W){const q=this.d.getDocument(I),ie=D.Position.to($),fe=await this.e.provideEvaluatableExpression(q,ie,W);if(fe)return D.EvaluatableExpression.from(fe)}}class T{constructor(I,$){this.d=I,this.e=$}async provideInlineValues(I,$,W,q){const ie=this.d.getDocument(I),fe=await this.e.provideInlineValues(ie,D.Range.to($),D.InlineValueContext.to(W),q);if(Array.isArray(fe))return fe.map(ye=>D.InlineValue.from(ye))}}class O{constructor(I,$){this.d=I,this.e=$}async provideDocumentHighlights(I,$,W){const q=this.d.getDocument(I),ie=D.Position.to($),fe=await this.e.provideDocumentHighlights(q,ie,W);if(Array.isArray(fe))return fe.map(D.DocumentHighlight.from)}}class H{constructor(I,$){this.d=I,this.e=$}async provideLinkedEditingRanges(I,$,W){const q=this.d.getDocument(I),ie=D.Position.to($),fe=await this.e.provideLinkedEditingRanges(q,ie,W);if(fe&&Array.isArray(fe.ranges))return{ranges:(0,N.coalesce)(fe.ranges.map(D.Range.from)),wordPattern:fe.wordPattern}}}class J{constructor(I,$){this.d=I,this.e=$}async provideReferences(I,$,W,q){const ie=this.d.getDocument(I),fe=D.Position.to($),ye=await this.e.provideReferences(ie,fe,W,q);if(Array.isArray(ye))return ye.map(D.location.from)}}class K{constructor(I,$,W,q,ie,fe,ye){this.g=I,this.h=$,this.j=W,this.k=q,this.l=ie,this.m=fe,this.n=ye,this.e=new l.Cache("CodeAction"),this.f=new Map}async provideCodeActions(I,$,W,q){const ie=this.g.getDocument(I),fe=f.Selection.isISelection($)?D.Selection.to($):D.Range.to($),ye=[];for(const tt of this.j.getDiagnostics(I))if(fe.intersection(tt.range)&&ye.push(tt)>K.d)break;const ae={diagnostics:ye,only:W.only?new M.CodeActionKind(W.only):void 0,triggerKind:D.CodeActionTriggerKind.to(W.trigger)},ve=await this.k.provideCodeActions(ie,fe,ae,q);if(!(0,N.isNonEmptyArray)(ve)||q.isCancellationRequested)return;const Ee=this.e.add(ve),We=new m.DisposableStore;this.f.set(Ee,We);const He=[];for(let tt=0;tt<ve.length;tt++){const Xe=ve[tt];!Xe||(K.o(Xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),He.push({_isSynthetic:!0,title:Xe.title,command:this.h.toInternal(Xe,We)})):(ae.only&&(Xe.kind?ae.only.contains(Xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ae.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),He.push({cacheId:[Ee,tt],title:Xe.title,command:Xe.command&&this.h.toInternal(Xe.command,We),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(D.Diagnostic.from),edit:Xe.edit&&D.WorkspaceEdit.from(Xe.edit,void 0),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:Ee,actions:He}}async resolveCodeAction(I,$){const[W,q]=I,ie=this.e.get(W,q);if(!ie||K.o(ie)||!this.k.resolveCodeAction)return;const fe=await this.k.resolveCodeAction(ie,$)??ie;return fe?.edit?D.WorkspaceEdit.from(fe.edit,void 0):void 0}releaseCodeActions(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}static o(I){return typeof I.command=="string"&&typeof I.title=="string"}}K.d=1e3;class L{constructor(I,$,W,q){this.d=I,this.e=$,this.f=W,this.g=q}async prepareDocumentPaste(I,$,W,q){if(!this.f.prepareDocumentPaste)return;const ie=this.e.getDocument(I),fe=$.map(ae=>D.Range.to(ae)),ye=D.DataTransfer.toDataTransfer(W,()=>{throw new E.NotImplementedError});return await this.f.prepareDocumentPaste(ie,fe,ye,q),D.DataTransfer.toDataTransferDTO(ye)}async providePasteEdits(I,$,W,q,ie){const fe=this.e.getDocument($),ye=W.map(Ee=>D.Range.to(Ee)),ae=D.DataTransfer.toDataTransfer(q,async Ee=>(await this.d.$resolvePasteFileData(this.g,I,Ee)).buffer),ve=await this.f.provideDocumentPasteEdits(fe,ye,ae,ie);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?D.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class B{constructor(I,$){this.d=I,this.e=$}async provideDocumentFormattingEdits(I,$,W){const q=this.d.getDocument(I),ie=await this.e.provideDocumentFormattingEdits(q,$,W);if(Array.isArray(ie))return ie.map(D.TextEdit.from)}}class P{constructor(I,$){this.d=I,this.e=$}async provideDocumentRangeFormattingEdits(I,$,W,q){const ie=this.d.getDocument(I),fe=D.Range.to($),ye=await this.e.provideDocumentRangeFormattingEdits(ie,fe,W,q);if(Array.isArray(ye))return ye.map(D.TextEdit.from)}}class F{constructor(I,$){this.d=I,this.e=$,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(I,$,W,q,ie){const fe=this.d.getDocument(I),ye=D.Position.to($),ae=await this.e.provideOnTypeFormattingEdits(fe,ye,W,q,ie);if(Array.isArray(ae))return ae.map(D.TextEdit.from)}}class V{constructor(I,$){this.e=I,this.f=$,this.d=new l.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(I,$){const W=await this.e.provideWorkspaceSymbols(I,$);if(!(0,N.isNonEmptyArray)(W))return{symbols:[]};const q=this.d.add(W),ie={cacheId:q,symbols:[]};for(let fe=0;fe<W.length;fe++){const ye=W[fe];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}ie.symbols.push({...D.WorkspaceSymbol.from(ye),cacheId:[q,fe]})}return ie}async resolveWorkspaceSymbol(I,$){if(typeof this.e.resolveWorkspaceSymbol!="function"||!I.cacheId)return I;const W=this.d.get(...I.cacheId);if(W){const q=await this.e.resolveWorkspaceSymbol(W,$);return q&&(0,C.mixin)(I,D.WorkspaceSymbol.from(q),!0)}}releaseWorkspaceSymbols(I){this.d.delete(I)}}class j{static supportsResolving(I){return typeof I.prepareRename=="function"}constructor(I,$,W){this.d=I,this.e=$,this.f=W}async provideRenameEdits(I,$,W,q){const ie=this.d.getDocument(I),fe=D.Position.to($);try{const ye=await this.e.provideRenameEdits(ie,fe,W,q);return ye?D.WorkspaceEdit.from(ye):void 0}catch(ye){const ae=j.g(ye);return ae?{rejectReason:ae,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(I,$,W){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const q=this.d.getDocument(I),ie=D.Position.to($);try{const fe=await this.e.prepareRename(q,ie,W);let ye,ae;if(M.Range.isRange(fe)?(ye=fe,ae=q.getText(fe)):(0,w.isObject)(fe)&&(ye=fe.range,ae=fe.placeholder),!ye||!ae)return;if(ye.start.line>ie.line||ye.end.line<ie.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(ye),text:ae}}catch(fe){const ye=j.g(fe);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(fe)}}static g(I){return typeof I=="string"?I:I instanceof Error&&typeof I.message=="string"?I.message:void 0}}class le{constructor(I,$){this.resultId=I,this.tokens=$}}class _{constructor(I,$){this.f=I,this.g=$,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(I,$,W){const q=this.f.getDocument(I),ie=$!==0?this.d.get($):null;let fe=typeof ie?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(q,ie.resultId,W):await this.g.provideDocumentSemanticTokens(q,W);return ie&&this.d.delete($),fe?(fe=_.h(fe),this.o(_.n(ie,fe),fe)):null}async releaseDocumentSemanticColoring(I){this.d.delete(I)}static h(I){return _.j(I)?_.k(I)?I:new M.SemanticTokens(new Uint32Array(I.data),I.resultId):_.l(I)?_.m(I)?I:new M.SemanticTokensEdits(I.edits.map($=>new M.SemanticTokensEdit($.start,$.deleteCount,$.data?new Uint32Array($.data):$.data)),I.resultId):I}static j(I){return I&&!!I.data}static k(I){return I.data instanceof Uint32Array}static l(I){return I&&Array.isArray(I.edits)}static m(I){for(const $ of I.edits)if(!($.data instanceof Uint32Array))return!1;return!0}static n(I,$){if(!_.j($)||!I||!I.tokens)return $;const W=I.tokens,q=W.length,ie=$.data,fe=ie.length;let ye=0;const ae=Math.min(q,fe);for(;ye<ae&&W[ye]===ie[ye];)ye++;if(ye===q&&ye===fe)return new M.SemanticTokensEdits([],$.resultId);let ve=0;const Ee=ae-ye;for(;ve<Ee&&W[q-ve-1]===ie[fe-ve-1];)ve++;return new M.SemanticTokensEdits([{start:ye,deleteCount:q-ye-ve,data:ie.subarray(ye,fe-ve)}],$.resultId)}o(I,$){if(_.j(I)){const W=this.e++;return this.d.set(W,new le(I.resultId,I.data)),(0,a.encodeSemanticTokensDto)({id:W,type:"full",data:I.data})}if(_.l(I)){const W=this.e++;return _.j($)?this.d.set(W,new le($.resultId,$.data)):this.d.set(W,new le(I.resultId)),(0,a.encodeSemanticTokensDto)({id:W,type:"delta",deltas:(I.edits||[]).map(q=>({start:q.start,deleteCount:q.deleteCount,data:q.data}))})}return null}}class be{constructor(I,$){this.d=I,this.e=$}async provideDocumentRangeSemanticTokens(I,$,W){const q=this.d.getDocument(I),ie=await this.e.provideDocumentRangeSemanticTokens(q,D.Range.to($),W);return ie?this.f(ie):null}f(I){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:I.data})}}class de{static supportsResolving(I){return typeof I.resolveCompletionItem=="function"}constructor(I,$,W,q,ie){this.f=I,this.g=$,this.h=W,this.j=q,this.k=ie,this.d=new l.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(I,$,W,q){const ie=this.f.getDocument(I),fe=D.Position.to($),ye=ie.getWordRangeAtPosition(fe)||new M.Range(fe,fe),ae=ye.with({end:fe}),ve=new g.StopWatch(!0),Ee=await this.h.provideCompletionItems(ie,fe,q,D.CompletionContext.to(W));if(!Ee||q.isCancellationRequested)return;const We=Array.isArray(Ee)?new M.CompletionList(Ee):Ee,He=de.supportsResolving(this.h)?this.d.add(We.items):this.d.add([]),tt=new m.DisposableStore;this.e.set(He,tt);const Xe=[],et={x:He,b:Xe,a:{replace:D.Range.from(ye),insert:D.Range.from(ae)},c:We.isIncomplete||void 0,d:ve.elapsed()};for(let it=0;it<We.items.length;it++){const dt=We.items[it],Fe=this.l(dt,[He,it],ae,ye);Xe.push(Fe)}return et}async resolveCompletionItem(I,$){if(typeof this.h.resolveCompletionItem!="function")return;const W=this.d.get(...I);if(!W)return;const q=await this.h.resolveCompletionItem(W,$);if(!!q)return this.l(q,I)}releaseCompletionItems(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,$,W,q){const ie=this.e.get($[0]);if(!ie)throw Error("DisposableStore is missing...");const fe=this.g.toInternal(I.command,ie),ye={x:$,a:I.label,b:I.kind!==void 0?D.CompletionItemKind.from(I.kind):void 0,m:I.tags&&I.tags.map(D.CompletionItemTag.from),c:I.detail,d:typeof I.documentation>"u"?void 0:D.MarkdownString.fromStrict(I.documentation),e:I.sortText!==I.label?I.sortText:void 0,f:I.filterText!==I.label?I.filterText:void 0,g:I.preselect||void 0,i:I.keepWhitespace?1:0,k:I.commitCharacters?.join(""),l:I.additionalTextEdits&&I.additionalTextEdits.map(D.TextEdit.from),n:fe?.$ident,o:fe?.id,p:fe?.$ident?void 0:fe?.arguments};I.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=I.textEdit.newText):typeof I.insertText=="string"?ye.h=I.insertText:I.insertText instanceof M.SnippetString&&(ye.h=I.insertText.value,ye.i|=4);let ae;return I.textEdit?ae=I.textEdit.range:I.range&&(ae=I.range),M.Range.isRange(ae)?ye.j=D.Range.from(ae):ae&&(!W?.isEqual(ae.inserting)||!q?.isEqual(ae.replacing))&&(ye.j={insert:D.Range.from(ae.inserting),replace:D.Range.from(ae.replacing)}),ye}}class ue{async provideInlineCompletions(I,$,W,q){}disposeCompletions(I){}handleDidShowCompletionItem(I,$){}}class se extends ue{constructor(I,$,W,q){super(),this.f=I,this.g=$,this.h=W,this.j=q,this.d=new Z,this.e=(0,v.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[S.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[S.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,v.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(I,$,W,q){const ie=this.g.getDocument(I),fe=D.Position.to($),ye=await this.h.provideInlineCompletionItems(ie,fe,{selectedCompletionInfo:W.selectedSuggestionInfo?{range:D.Range.to(W.selectedSuggestionInfo.range),text:W.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[W.triggerKind]},q);if(!ye||q.isCancellationRequested)return;const ae=Array.isArray(ye)?ye:ye.items,ve=this.e?Array.isArray(ye)?[]:ye.commands||[]:[];let Ee;return{pid:this.d.createReferenceId({dispose(){Ee?.dispose()},items:ae}),items:ae.map((He,tt)=>{let Xe;He.command&&(Ee||(Ee=new m.DisposableStore),Xe=this.j.toInternal(He.command,Ee));const et=He.insertText;return{insertText:typeof et=="string"?et:{snippet:et.value},filterText:He.filterText,range:He.range?D.Range.from(He.range):void 0,command:Xe,idx:tt,completeBracketPairs:this.e?He.completeBracketPairs:!1}}),commands:ve.map(He=>(Ee||(Ee=new m.DisposableStore),this.j.toInternal(He,Ee)))}}disposeCompletions(I){this.d.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,$){const W=this.d.get(I)?.items[$];W&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(W)}}class Z{constructor(){this.d=new Map,this.e=1}createReferenceId(I){const $=this.e++;return this.d.set($,I),$}disposeReferenceId(I){const $=this.d.get(I);return this.d.delete(I),$}get(I){return this.d.get(I)}}class X{constructor(I,$){this.e=I,this.f=$,this.d=new l.Cache("SignatureHelp")}async provideSignatureHelp(I,$,W,q){const ie=this.e.getDocument(I),fe=D.Position.to($),ye=this.g(W),ae=await this.f.provideSignatureHelp(ie,fe,q,ye);if(ae){const ve=this.d.add([ae]);return{...D.SignatureHelp.from(ae),id:ve}}}g(I){let $;if(I.activeSignatureHelp){const W=D.SignatureHelp.to(I.activeSignatureHelp),q=this.d.get(I.activeSignatureHelp.id,0);q?($=q,$.activeSignature=W.activeSignature,$.activeParameter=W.activeParameter):$=W}return{...I,activeSignatureHelp:$}}releaseSignatureHelp(I){this.d.delete(I)}}class ee{constructor(I,$,W,q,ie){this.f=I,this.g=$,this.h=W,this.j=q,this.k=ie,this.d=new l.Cache("InlayHints"),this.e=new Map}async provideInlayHints(I,$,W){const q=this.f.getDocument(I),ie=D.Range.to($),fe=await this.h.provideInlayHints(q,ie,W);if(!Array.isArray(fe)||fe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${$}`);return}if(W.isCancellationRequested)return;const ye=this.d.add(fe);this.e.set(ye,new m.DisposableStore);const ae={hints:[],cacheId:ye};for(let ve=0;ve<fe.length;ve++)this.l(fe[ve],ie)&&ae.hints.push(this.m(fe[ve],[ye,ve]));return this.j.trace(`[InlayHints] ${ae.hints.length} inlay hints from '${this.k.identifier.value}' for ${$}`),ae}async resolveInlayHint(I,$){if(typeof this.h.resolveInlayHint!="function")return;const W=this.d.get(...I);if(!W)return;const q=await this.h.resolveInlayHint(W,$);if(!!q&&!!this.l(q))return this.m(q,I)}releaseHints(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,$){return I.label.length===0||Array.isArray(I.label)&&I.label.every(W=>W.value.length===0)?(console.log("INVALID inlay hint, empty label",I),!1):!($&&!$.contains(I.position))}m(I,$){const W=this.e.get($[0]);if(!W)throw Error("DisposableStore is missing...");const q={label:"",cacheId:$,tooltip:D.MarkdownString.fromStrict(I.tooltip),position:D.Position.from(I.position),textEdits:I.textEdits&&I.textEdits.map(D.TextEdit.from),kind:I.kind&&D.InlayHintKind.from(I.kind),paddingLeft:I.paddingLeft,paddingRight:I.paddingRight};return typeof I.label=="string"?q.label=I.label:q.label=I.label.map(ie=>{const fe={label:ie.value};return fe.tooltip=D.MarkdownString.fromStrict(ie.tooltip),M.Location.isLocation(ie.location)&&(fe.location=D.location.from(ie.location)),ie.command&&(fe.command=this.g.toInternal(ie.command,W)),fe}),q}}class he{constructor(I,$){this.e=I,this.f=$,this.d=new l.Cache("DocumentLink")}async provideLinks(I,$){const W=this.e.getDocument(I),q=await this.f.provideDocumentLinks(W,$);if(!(!Array.isArray(q)||q.length===0)&&!$.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:q.filter(he.g).map(D.DocumentLink.from)};{const ie=this.d.add(q),fe={links:[],cacheId:ie};for(let ye=0;ye<q.length;ye++){if(!he.g(q[ye]))continue;const ae=D.DocumentLink.from(q[ye]);ae.cacheId=[ie,ye],fe.links.push(ae)}return fe}}}static g(I){return I.target&&I.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(I,$){if(typeof this.f.resolveDocumentLink!="function")return;const W=this.d.get(...I);if(!W)return;const q=await this.f.resolveDocumentLink(W,$);if(!(!q||!he.g(q)))return D.DocumentLink.from(q)}releaseLinks(I){this.d.delete(I)}}class Te{constructor(I,$){this.d=I,this.e=$}async provideColors(I,$){const W=this.d.getDocument(I),q=await this.e.provideDocumentColors(W,$);return Array.isArray(q)?q.map(fe=>({color:D.Color.from(fe.color),range:D.Range.from(fe.range)})):[]}async provideColorPresentations(I,$,W){const q=this.d.getDocument(I),ie=D.Range.to($.range),fe=D.Color.to($.color),ye=await this.e.provideColorPresentations(fe,{document:q,range:ie},W);if(!!Array.isArray(ye))return ye.map(D.ColorPresentation.from)}}class Ne{constructor(I,$){this.d=I,this.e=$}async provideFoldingRanges(I,$,W){const q=this.d.getDocument(I),ie=await this.e.provideFoldingRanges(q,$,W);if(!!Array.isArray(ie))return ie.map(D.FoldingRange.from)}}class Ke{constructor(I,$,W){this.d=I,this.e=$,this.f=W}async provideSelectionRanges(I,$,W){const q=this.d.getDocument(I),ie=$.map(D.Position.to),fe=await this.e.provideSelectionRanges(q,ie,W);if(!(0,N.isNonEmptyArray)(fe))return[];if(fe.length!==ie.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let ae=0;ae<ie.length;ae++){const ve=[];ye.push(ve);let Ee=ie[ae],We=fe[ae];for(;;){if(!We.range.contains(Ee))throw new Error("INVALID selection range, must contain the previous range");if(ve.push(D.SelectionRange.from(We)),!We.parent)break;Ee=We.range,We=We.parent}}return ye}}class Pe{constructor(I,$){this.f=I,this.g=$,this.d=new o.IdGenerator(""),this.e=new Map}async prepareSession(I,$,W){const q=this.f.getDocument(I),ie=D.Position.to($),fe=await this.g.prepareCallHierarchy(q,ie,W);if(!fe)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(fe)?fe.map(ae=>this.h(ye,ae)):[this.h(ye,fe)]}async provideCallsTo(I,$,W){const q=this.j(I,$);if(!q)throw new Error("missing call hierarchy item");const ie=await this.g.provideCallHierarchyIncomingCalls(q,W);if(!!ie)return ie.map(fe=>({from:this.h(I,fe.from),fromRanges:fe.fromRanges.map(ye=>D.Range.from(ye))}))}async provideCallsFrom(I,$,W){const q=this.j(I,$);if(!q)throw new Error("missing call hierarchy item");const ie=await this.g.provideCallHierarchyOutgoingCalls(q,W);if(!!ie)return ie.map(fe=>({to:this.h(I,fe.to),fromRanges:fe.fromRanges.map(ye=>D.Range.from(ye))}))}releaseSession(I){this.e.delete(I)}h(I,$){const W=this.e.get(I),q=D.CallHierarchyItem.from($,I,W.size.toString(36));return W.set(q._itemId,$),q}j(I,$){return this.e.get(I)?.get($)}}class Se{constructor(I,$){this.f=I,this.g=$,this.d=new o.IdGenerator(""),this.e=new Map}async prepareSession(I,$,W){const q=this.f.getDocument(I),ie=D.Position.to($),fe=await this.g.prepareTypeHierarchy(q,ie,W);if(!fe)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(fe)?fe.map(ae=>this.h(ye,ae)):[this.h(ye,fe)]}async provideSupertypes(I,$,W){const q=this.j(I,$);if(!q)throw new Error("missing type hierarchy item");const ie=await this.g.provideTypeHierarchySupertypes(q,W);if(!!ie)return ie.map(fe=>this.h(I,fe))}async provideSubtypes(I,$,W){const q=this.j(I,$);if(!q)throw new Error("missing type hierarchy item");const ie=await this.g.provideTypeHierarchySubtypes(q,W);if(!!ie)return ie.map(fe=>this.h(I,fe))}releaseSession(I){this.e.delete(I)}h(I,$){const W=this.e.get(I),q=D.TypeHierarchyItem.from($,I,W.size.toString(36));return W.set(q._itemId,$),q}j(I,$){return this.e.get(I)?.get($)}}class Ie{constructor(I,$,W,q){this.d=I,this.e=$,this.f=W,this.g=q}async provideDocumentOnDropEdits(I,$,W,q,ie){const fe=this.e.getDocument($),ye=D.Position.to(W),ae=D.DataTransfer.toDataTransfer(q,async Ee=>(await this.d.$resolveDocumentOnDropFileData(this.g,I,Ee)).buffer),ve=await this.f.provideDocumentDropEdits(fe,ye,ae,ie);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?D.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class oe{constructor(I,$){this.adapter=I,this.extension=$}}class ce{constructor(I,$,W,q,ie,fe,ye,ae){this.g=$,this.h=W,this.j=q,this.k=ie,this.l=fe,this.m=ye,this.n=ae,this.f=new Map,this.e=I.getProxy(R.MainContext.MainThreadLanguageFeatures)}o(I){return D.DocumentSelector.from(I,this.g)}p(I){return new M.Disposable(()=>{this.f.delete(I),this.e.$unregister(I)})}q(){return ce.d++}async s(I,$,W,q,ie,fe=!1){const ye=this.f.get(I);if(!ye||!(ye.adapter instanceof $))return q;const ae=Date.now();fe||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${W.toString().replace(/[\r\n]/g,"")}'`);const ve=W(ye.adapter,ye.extension);return Promise.resolve(ve).catch(Ee=>{(0,E.isCancellationError)(Ee)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(Ee),this.n.onExtensionError(ye.extension.identifier,Ee))}).finally(()=>{fe||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-ae}ms`)}),b.CancellationToken.isCancellationToken(ie)?(0,A.raceCancellationError)(ve,ie):ve}t(I,$){const W=this.q();return this.f.set(W,new oe(I,$)),W}static u(I){return I.displayName||I.name}registerDocumentSymbolProvider(I,$,W,q){const ie=this.t(new t(this.h,W),I),fe=q&&q.label||ce.u(I);return this.e.$registerDocumentSymbolProvider(ie,this.o($),fe),this.p(ie)}$provideDocumentSymbols(I,$,W){return this.s(I,t,q=>q.provideDocumentSymbols(n.URI.revive($),W),void 0,W)}registerCodeLensProvider(I,$,W){const q=this.q(),ie=typeof W.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(q,new oe(new h(this.h,this.j.converter,W),I)),this.e.$registerCodeLensSupport(q,this.o($),ie);let fe=this.p(q);if(ie!==void 0){const ye=W.onDidChangeCodeLenses(ae=>this.e.$emitCodeLensEvent(ie));fe=M.Disposable.from(fe,ye)}return fe}$provideCodeLenses(I,$,W){return this.s(I,h,q=>q.provideCodeLenses(n.URI.revive($),W),void 0,W)}$resolveCodeLens(I,$,W){return this.s(I,h,q=>q.resolveCodeLens($,W),void 0,void 0)}$releaseCodeLenses(I,$){this.s(I,h,W=>Promise.resolve(W.releaseCodeLenses($)),void 0,void 0)}registerDefinitionProvider(I,$,W){const q=this.t(new u(this.h,W),I);return this.e.$registerDefinitionSupport(q,this.o($)),this.p(q)}$provideDefinition(I,$,W,q){return this.s(I,u,ie=>ie.provideDefinition(n.URI.revive($),W,q),[],q)}registerDeclarationProvider(I,$,W){const q=this.t(new i(this.h,W),I);return this.e.$registerDeclarationSupport(q,this.o($)),this.p(q)}$provideDeclaration(I,$,W,q){return this.s(I,i,ie=>ie.provideDeclaration(n.URI.revive($),W,q),[],q)}registerImplementationProvider(I,$,W){const q=this.t(new p(this.h,W),I);return this.e.$registerImplementationSupport(q,this.o($)),this.p(q)}$provideImplementation(I,$,W,q){return this.s(I,p,ie=>ie.provideImplementation(n.URI.revive($),W,q),[],q)}registerTypeDefinitionProvider(I,$,W){const q=this.t(new c(this.h,W),I);return this.e.$registerTypeDefinitionSupport(q,this.o($)),this.p(q)}$provideTypeDefinition(I,$,W,q){return this.s(I,c,ie=>ie.provideTypeDefinition(n.URI.revive($),W,q),[],q)}registerHoverProvider(I,$,W,q){const ie=this.t(new s(this.h,W),I);return this.e.$registerHoverProvider(ie,this.o($)),this.p(ie)}$provideHover(I,$,W,q){return this.s(I,s,ie=>ie.provideHover(n.URI.revive($),W,q),void 0,q)}registerEvaluatableExpressionProvider(I,$,W,q){const ie=this.t(new d(this.h,W),I);return this.e.$registerEvaluatableExpressionProvider(ie,this.o($)),this.p(ie)}$provideEvaluatableExpression(I,$,W,q){return this.s(I,d,ie=>ie.provideEvaluatableExpression(n.URI.revive($),W,q),void 0,q)}registerInlineValuesProvider(I,$,W,q){const ie=typeof W.onDidChangeInlineValues=="function"?this.q():void 0,fe=this.t(new T(this.h,W),I);this.e.$registerInlineValuesProvider(fe,this.o($),ie);let ye=this.p(fe);if(ie!==void 0){const ae=W.onDidChangeInlineValues(ve=>this.e.$emitInlineValuesEvent(ie));ye=M.Disposable.from(ye,ae)}return ye}$provideInlineValues(I,$,W,q,ie){return this.s(I,T,fe=>fe.provideInlineValues(n.URI.revive($),W,q,ie),void 0,ie)}registerDocumentHighlightProvider(I,$,W){const q=this.t(new O(this.h,W),I);return this.e.$registerDocumentHighlightProvider(q,this.o($)),this.p(q)}$provideDocumentHighlights(I,$,W,q){return this.s(I,O,ie=>ie.provideDocumentHighlights(n.URI.revive($),W,q),void 0,q)}registerLinkedEditingRangeProvider(I,$,W){const q=this.t(new H(this.h,W),I);return this.e.$registerLinkedEditingRangeProvider(q,this.o($)),this.p(q)}$provideLinkedEditingRanges(I,$,W,q){return this.s(I,H,async ie=>{const fe=await ie.provideLinkedEditingRanges(n.URI.revive($),W,q);if(fe)return{ranges:fe.ranges,wordPattern:fe.wordPattern?ce.w(fe.wordPattern):void 0}},void 0,q)}registerReferenceProvider(I,$,W){const q=this.t(new J(this.h,W),I);return this.e.$registerReferenceSupport(q,this.o($)),this.p(q)}$provideReferences(I,$,W,q,ie){return this.s(I,J,fe=>fe.provideReferences(n.URI.revive($),W,q,ie),void 0,ie)}registerCodeActionProvider(I,$,W,q){const ie=new m.DisposableStore,fe=this.t(new K(this.h,this.j.converter,this.k,W,this.l,I,this.m),I);return this.e.$registerQuickFixSupport(fe,this.o($),{providedKinds:q?.providedCodeActionKinds?.map(ye=>ye.value),documentation:q?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,ie)}))},ce.u(I),Boolean(W.resolveCodeAction)),ie.add(this.p(fe)),ie}$provideCodeActions(I,$,W,q,ie){return this.s(I,K,fe=>fe.provideCodeActions(n.URI.revive($),W,q,ie),void 0,ie)}$resolveCodeAction(I,$,W){return this.s(I,K,q=>q.resolveCodeAction($,W),void 0,void 0)}$releaseCodeActions(I,$){this.s(I,K,W=>Promise.resolve(W.releaseCodeActions($)),void 0,void 0)}registerDocumentFormattingEditProvider(I,$,W){const q=this.t(new B(this.h,W),I);return this.e.$registerDocumentFormattingSupport(q,this.o($),I.identifier,I.displayName||I.name),this.p(q)}$provideDocumentFormattingEdits(I,$,W,q){return this.s(I,B,ie=>ie.provideDocumentFormattingEdits(n.URI.revive($),W,q),void 0,q)}registerDocumentRangeFormattingEditProvider(I,$,W){const q=this.t(new P(this.h,W),I);return this.e.$registerRangeFormattingSupport(q,this.o($),I.identifier,I.displayName||I.name),this.p(q)}$provideDocumentRangeFormattingEdits(I,$,W,q,ie){return this.s(I,P,fe=>fe.provideDocumentRangeFormattingEdits(n.URI.revive($),W,q,ie),void 0,ie)}registerOnTypeFormattingEditProvider(I,$,W,q){const ie=this.t(new F(this.h,W),I);return this.e.$registerOnTypeFormattingSupport(ie,this.o($),q,I.identifier),this.p(ie)}$provideOnTypeFormattingEdits(I,$,W,q,ie,fe){return this.s(I,F,ye=>ye.provideOnTypeFormattingEdits(n.URI.revive($),W,q,ie,fe),void 0,fe)}registerWorkspaceSymbolProvider(I,$){const W=this.t(new V($,this.l),I);return this.e.$registerNavigateTypeSupport(W,typeof $.resolveWorkspaceSymbol=="function"),this.p(W)}$provideWorkspaceSymbols(I,$,W){return this.s(I,V,q=>q.provideWorkspaceSymbols($,W),{symbols:[]},W)}$resolveWorkspaceSymbol(I,$,W){return this.s(I,V,q=>q.resolveWorkspaceSymbol($,W),void 0,void 0)}$releaseWorkspaceSymbols(I,$){this.s(I,V,W=>W.releaseWorkspaceSymbols($),void 0,void 0)}registerRenameProvider(I,$,W){const q=this.t(new j(this.h,W,this.l),I);return this.e.$registerRenameSupport(q,this.o($),j.supportsResolving(W)),this.p(q)}$provideRenameEdits(I,$,W,q,ie){return this.s(I,j,fe=>fe.provideRenameEdits(n.URI.revive($),W,q,ie),void 0,ie)}$resolveRenameLocation(I,$,W,q){return this.s(I,j,ie=>ie.resolveRenameLocation(n.URI.revive($),W,q),void 0,q)}registerDocumentSemanticTokensProvider(I,$,W,q){const ie=this.t(new _(this.h,W),I),fe=typeof W.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ie,this.o($),q,fe);let ye=this.p(ie);if(fe){const ae=W.onDidChangeSemanticTokens(ve=>this.e.$emitDocumentSemanticTokensEvent(fe));ye=M.Disposable.from(ye,ae)}return ye}$provideDocumentSemanticTokens(I,$,W,q){return this.s(I,_,ie=>ie.provideDocumentSemanticTokens(n.URI.revive($),W,q),null,q)}$releaseDocumentSemanticTokens(I,$){this.s(I,_,W=>W.releaseDocumentSemanticColoring($),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(I,$,W,q){const ie=this.t(new be(this.h,W),I);return this.e.$registerDocumentRangeSemanticTokensProvider(ie,this.o($),q),this.p(ie)}$provideDocumentRangeSemanticTokens(I,$,W,q){return this.s(I,be,ie=>ie.provideDocumentRangeSemanticTokens(n.URI.revive($),W,q),null,q)}registerCompletionItemProvider(I,$,W,q){const ie=this.t(new de(this.h,this.j.converter,W,this.m,I),I);return this.e.$registerCompletionsProvider(ie,this.o($),q,de.supportsResolving(W),`${I.identifier.value}(${q.join("")})`),this.p(ie)}$provideCompletionItems(I,$,W,q,ie){return this.s(I,de,fe=>fe.provideCompletionItems(n.URI.revive($),W,q,ie),void 0,ie)}$resolveCompletionItem(I,$,W){return this.s(I,de,q=>q.resolveCompletionItem($,W),void 0,W)}$releaseCompletionItems(I,$){this.s(I,de,W=>W.releaseCompletionItems($),void 0,void 0)}registerInlineCompletionsProvider(I,$,W){const q=new se(I,this.h,W,this.j.converter),ie=this.t(q,I);return this.e.$registerInlineCompletionsSupport(ie,this.o($),q.supportsHandleDidShowCompletionItem),this.p(ie)}$provideInlineCompletions(I,$,W,q,ie){return this.s(I,ue,fe=>fe.provideInlineCompletions(n.URI.revive($),W,q,ie),void 0,ie)}$handleInlineCompletionDidShow(I,$,W){this.s(I,ue,async q=>{q.handleDidShowCompletionItem($,W)},void 0,void 0)}$freeInlineCompletionsList(I,$){this.s(I,ue,async W=>{W.disposeCompletions($)},void 0,void 0)}registerSignatureHelpProvider(I,$,W,q){const ie=Array.isArray(q)?{triggerCharacters:q,retriggerCharacters:[]}:q,fe=this.t(new X(this.h,W),I);return this.e.$registerSignatureHelpProvider(fe,this.o($),ie),this.p(fe)}$provideSignatureHelp(I,$,W,q,ie){return this.s(I,X,fe=>fe.provideSignatureHelp(n.URI.revive($),W,q,ie),void 0,ie)}$releaseSignatureHelp(I,$){this.s(I,X,W=>W.releaseSignatureHelp($),void 0,void 0)}registerInlayHintsProvider(I,$,W){const q=typeof W.onDidChangeInlayHints=="function"?this.q():void 0,ie=this.t(new ee(this.h,this.j.converter,W,this.l,I),I);this.e.$registerInlayHintsProvider(ie,this.o($),typeof W.resolveInlayHint=="function",q,ce.u(I));let fe=this.p(ie);if(q!==void 0){const ye=W.onDidChangeInlayHints(ae=>this.e.$emitInlayHintsEvent(q));fe=M.Disposable.from(fe,ye)}return fe}$provideInlayHints(I,$,W,q){return this.s(I,ee,ie=>ie.provideInlayHints(n.URI.revive($),W,q),void 0,q)}$resolveInlayHint(I,$,W){return this.s(I,ee,q=>q.resolveInlayHint($,W),void 0,W)}$releaseInlayHints(I,$){this.s(I,ee,W=>W.releaseHints($),void 0,void 0)}registerDocumentLinkProvider(I,$,W){const q=this.t(new he(this.h,W),I);return this.e.$registerDocumentLinkProvider(q,this.o($),typeof W.resolveDocumentLink=="function"),this.p(q)}$provideDocumentLinks(I,$,W){return this.s(I,he,q=>q.provideLinks(n.URI.revive($),W),void 0,W,$.scheme==="output")}$resolveDocumentLink(I,$,W){return this.s(I,he,q=>q.resolveLink($,W),void 0,void 0,!0)}$releaseDocumentLinks(I,$){this.s(I,he,W=>W.releaseLinks($),void 0,void 0,!0)}registerColorProvider(I,$,W){const q=this.t(new Te(this.h,W),I);return this.e.$registerDocumentColorProvider(q,this.o($)),this.p(q)}$provideDocumentColors(I,$,W){return this.s(I,Te,q=>q.provideColors(n.URI.revive($),W),[],W)}$provideColorPresentations(I,$,W,q){return this.s(I,Te,ie=>ie.provideColorPresentations(n.URI.revive($),W,q),void 0,q)}registerFoldingRangeProvider(I,$,W){const q=this.q(),ie=typeof W.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(q,new oe(new Ne(this.h,W),I)),this.e.$registerFoldingRangeProvider(q,this.o($),I.identifier,ie);let fe=this.p(q);if(ie!==void 0){const ye=W.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ie));fe=M.Disposable.from(fe,ye)}return fe}$provideFoldingRanges(I,$,W,q){return this.s(I,Ne,ie=>ie.provideFoldingRanges(n.URI.revive($),W,q),void 0,q)}registerSelectionRangeProvider(I,$,W){const q=this.t(new Ke(this.h,W,this.l),I);return this.e.$registerSelectionRangeProvider(q,this.o($)),this.p(q)}$provideSelectionRanges(I,$,W,q){return this.s(I,Ke,ie=>ie.provideSelectionRanges(n.URI.revive($),W,q),[],q)}registerCallHierarchyProvider(I,$,W){const q=this.t(new Pe(this.h,W),I);return this.e.$registerCallHierarchyProvider(q,this.o($)),this.p(q)}$prepareCallHierarchy(I,$,W,q){return this.s(I,Pe,ie=>Promise.resolve(ie.prepareSession(n.URI.revive($),W,q)),void 0,q)}$provideCallHierarchyIncomingCalls(I,$,W,q){return this.s(I,Pe,ie=>ie.provideCallsTo($,W,q),void 0,q)}$provideCallHierarchyOutgoingCalls(I,$,W,q){return this.s(I,Pe,ie=>ie.provideCallsFrom($,W,q),void 0,q)}$releaseCallHierarchy(I,$){this.s(I,Pe,W=>Promise.resolve(W.releaseSession($)),void 0,void 0)}registerTypeHierarchyProvider(I,$,W){const q=this.t(new Se(this.h,W),I);return this.e.$registerTypeHierarchyProvider(q,this.o($)),this.p(q)}$prepareTypeHierarchy(I,$,W,q){return this.s(I,Se,ie=>Promise.resolve(ie.prepareSession(n.URI.revive($),W,q)),void 0,q)}$provideTypeHierarchySupertypes(I,$,W,q){return this.s(I,Se,ie=>ie.provideSupertypes($,W,q),void 0,q)}$provideTypeHierarchySubtypes(I,$,W,q){return this.s(I,Se,ie=>ie.provideSubtypes($,W,q),void 0,q)}$releaseTypeHierarchy(I,$){this.s(I,Se,W=>Promise.resolve(W.releaseSession($)),void 0,void 0)}registerDocumentOnDropEditProvider(I,$,W){const q=this.q();return this.f.set(q,new oe(new Ie(this.e,this.h,W,q),I)),this.e.$registerDocumentOnDropEditProvider(q,this.o($)),this.p(q)}$provideDocumentOnDropEdits(I,$,W,q,ie,fe){return this.s(I,Ie,ye=>Promise.resolve(ye.provideDocumentOnDropEdits($,n.URI.revive(W),q,ie,fe)),void 0,void 0)}registerDocumentPasteEditProvider(I,$,W,q){const ie=this.q();return this.f.set(ie,new oe(new L(this.e,this.h,W,ie),I)),this.e.$registerPasteEditProvider(ie,this.o($),!!W.prepareDocumentPaste,q.pasteMimeTypes),this.p(ie)}$prepareDocumentPaste(I,$,W,q,ie){return this.s(I,L,fe=>fe.prepareDocumentPaste(n.URI.revive($),W,q,ie),void 0,ie)}$providePasteEdits(I,$,W,q,ie,fe){return this.s(I,L,ye=>ye.providePasteEdits($,n.URI.revive(W),q,ie,fe),void 0,fe)}static w(I){return{pattern:I.source,flags:(0,y.regExpFlags)(I)}}static y(I){return{decreaseIndentPattern:ce.w(I.decreaseIndentPattern),increaseIndentPattern:ce.w(I.increaseIndentPattern),indentNextLinePattern:I.indentNextLinePattern?ce.w(I.indentNextLinePattern):void 0,unIndentedLinePattern:I.unIndentedLinePattern?ce.w(I.unIndentedLinePattern):void 0}}static z(I){return{beforeText:ce.w(I.beforeText),afterText:I.afterText?ce.w(I.afterText):void 0,previousLineText:I.previousLineText?ce.w(I.previousLineText):void 0,action:I.action}}static B(I){return I.map(ce.z)}setLanguageConfiguration(I,$,W){const{wordPattern:q}=W;if(q&&(0,y.regExpLeadsToEndlessLoop)(q))throw new Error(`Invalid language configuration: wordPattern '${q}' is not allowed to match the empty string.`);q?this.h.setWordDefinitionFor($,q):this.h.setWordDefinitionFor($,void 0),W.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",I,"Do not use."),W.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",I,"Do not use.");const ie=this.q(),fe={comments:W.comments,brackets:W.brackets,wordPattern:W.wordPattern?ce.w(W.wordPattern):void 0,indentationRules:W.indentationRules?ce.y(W.indentationRules):void 0,onEnterRules:W.onEnterRules?ce.B(W.onEnterRules):void 0,__electricCharacterSupport:W.__electricCharacterSupport,__characterPairSupport:W.__characterPairSupport};return this.e.$setLanguageConfiguration(ie,$,fe),this.p(ie)}$setWordDefinitions(I){for(const $ of I)this.h.setWordDefinitionFor($.languageId,new RegExp($.regexSource,$.regexFlags))}}ce.d=0,e.ExtHostLanguageFeatures=ce}),define(Ce[219],ke([1,0,5,8,7,29,17,6]),function(te,e,n,C,D,M,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(N,w,f,b){this.c=w,this.d=f,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=N.getProxy(n.MainContext.MainThreadLanguages)}$acceptLanguageIds(N){this.b=N}async getLanguages(){return this.b.slice(0)}async changeLanguage(N,w){await this.a.$changeLanguage(N,w);const f=this.c.getDocumentData(N);if(!f)throw new Error(`document '${N.toString()}' NOT found`);return f.document}async tokenAtPosition(N,w){const f=N.version,b=C.Position.from(w),m=await this.a.$tokensAtPosition(N.uri,b),a={type:D.StandardTokenType.Other,range:N.getWordRangeAtPosition(w)??new D.Range(w.line,w.character,w.line,w.character)};if(!m)return a;const o={range:C.Range.to(m.range),type:C.TokenType.to(m.type)};return!o.range.contains(w)||f!==N.version?a:o}createLanguageStatusItem(N,w,f){const b=this.f++,m=this.a,a=this.g,o=`${N.identifier.value}/${w}`;if(a.has(o))throw new Error(`LanguageStatusItem with id '${w}' ALREADY exists`);a.add(o);const l={selector:f,id:w,name:N.displayName??N.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let g;const E=new R.DisposableStore,A=()=>{g?.dispose(),g=(0,S.disposableTimeout)(()=>{E.clear(),this.a.$setLanguageStatus(b,{id:o,name:l.name??N.displayName??N.name,source:N.displayName??N.name,selector:C.DocumentSelector.from(l.selector,this.e),label:l.text,detail:l.detail??"",severity:l.severity===D.LanguageStatusSeverity.Error?M.default.Error:l.severity===D.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:l.command&&this.d.toInternal(l.command,E),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},v={dispose(){E.dispose(),g?.dispose(),m.$removeLanguageStatus(b),a.delete(o)},get id(){return l.id},get name(){return l.name},set name(t){l.name=t,A()},get selector(){return l.selector},set selector(t){l.selector=t,A()},get text(){return l.text},set text(t){l.text=t,A()},get detail(){return l.detail},set detail(t){l.detail=t,A()},get severity(){return l.severity},set severity(t){l.severity=t,A()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(t){l.accessibilityInformation=t,A()},get command(){return l.command},set command(t){l.command=t,A()},get busy(){return l.busy},set busy(t){l.busy=t,A()}};return A(),v}}e.ExtHostLanguages=y}),define(Ce[78],ke([1,0,21,10,2,3,11,5,26,18]),function(te,e,n,C,D,M,S,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let N=class{constructor(f,b,m){this.f=m,this.d=new Map,this.a=b.getProxy(R.MainContext.MainThreadLocalization),this.b=f.environment.appLanguage,this.c=this.b===n.LANGUAGE_DEFAULT}getMessage(f,b){const{message:m,args:a,comment:o}=b;if(this.c)return(0,C.format2)(m,a??{});let l=m;o&&o.length>0&&(l+=`/${Array.isArray(o)?o.join(""):o}`);const g=this.d.get(f)?.contents[l];return g||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${l}`),(0,C.format2)(g??m,a??{})}getBundle(f){return this.d.get(f)?.contents}getBundleUri(f){return this.d.get(f)?.uri}async initializeLocalizedMessages(f){if(this.c||!f.l10n&&!f.isBuiltin||this.d.has(f.identifier.value))return;let b;const m=await this.g(f);if(!m){this.f.error(`No bundle location found for extension ${f.identifier.value}`);return}try{const a=await this.a.$fetchBundleContents(m),o=JSON.parse(a);b=f.isBuiltin?o.contents?.bundle:o}catch(a){this.f.error(`Failed to load translations for ${f.identifier.value} from ${m}: ${a.message}`);return}b&&this.d.set(f.identifier.value,{contents:b,uri:m})}async g(f){if(f.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(f.identifier.value);return D.URI.revive(b)}return f.l10n?D.URI.joinPath(f.extensionLocation,f.l10n,`bundle.l10n.${this.b}.json`):void 0}};N=qe([je(0,y.IExtHostInitDataService),je(1,k.IExtHostRpcService),je(2,S.ILogService)],N),e.ExtHostLocalizationService=N,e.IExtHostLocalizationService=(0,M.createDecorator)("IExtHostLocalizationService")}),define(Ce[220],ke([1,0,11,5,26,18,2,65]),function(te,e,n,C,D,M,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=class extends n.AbstractLoggerService{constructor(w,f){super(f.logLevel,f.loggers.map(b=>(0,R.revive)(b))),this.l=w.getProxy(C.MainContext.MainThreadLogger)}$setLogLevel(w,f){f?this.setLogLevel(S.URI.revive(f),w):this.setLogLevel(w)}setVisibility(w,f){super.setVisibility(w,f),this.l.$setVisibility(w,f)}k(w,f,b){return new k(this.l,w,f,b)}};y=qe([je(0,M.IExtHostRpcService),je(1,D.IExtHostInitDataService)],y),e.ExtHostLoggerService=y;class k extends n.AbstractMessageLogger{constructor(w,f,b,m){super(m?.logLevel==="always"),this.m=w,this.n=f,this.k=!1,this.l=[],this.setLevel(b),this.m.$createLogger(f,m).then(()=>{this.r(this.l),this.k=!0})}g(w,f){const b=[[w,f]];this.k?this.r(b):this.l.push(...b)}r(w){this.m.$log(this.n,w)}}}),define(Ce[221],ke([1,0,5,11,27]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function M(R){return R&&R.title}let S=class{constructor(y,k){this.b=k,this.a=y.getProxy(n.MainContext.MainThreadMessageService)}showMessage(y,k,N,w,f){const b={source:{identifier:y.identifier,label:y.displayName||y.name}};let m;typeof w=="string"||M(w)?m=[w,...f]:(b.modal=w?.modal,b.useCustom=w?.useCustom,b.detail=w?.detail,m=f),b.useCustom&&(0,D.checkProposedApiEnabled)(y,"resolvers");const a=[];for(let o=0;o<m.length;o++){const l=m[o];if(typeof l=="string")a.push({title:l,handle:o,isCloseAffordance:!1});else if(typeof l=="object"){const{title:g,isCloseAffordance:E}=l;a.push({title:g,isCloseAffordance:!!E,handle:o})}else this.b.warn("Invalid message item:",l)}return this.a.$showMessage(k,N,b,a).then(o=>{if(typeof o=="number")return m[o]})}};S=qe([je(1,C.ILogService)],S),e.ExtHostMessageService=S}),define(Ce[222],ke([1,0,23,4,6,28,10,9,2,54,5,37,8,7,46,196,100]),function(te,e,n,C,D,M,S,R,y,k,N,w,f,b,m,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class l{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(E=>E.apiEditor)}constructor(E,A,v,t){this.q=v,this.r=t,this.f=new Map,this.g=new M.ResourceMap,this.h=new Map,this.j=new C.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new C.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new C.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=E.getProxy(N.MainContext.MainThreadNotebook),this.c=E.getProxy(N.MainContext.MainThreadNotebookDocuments),this.d=E.getProxy(N.MainContext.MainThreadNotebookEditors),this.i=A.converter,A.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===13){const r=h.notebookEditor?.notebookUri,u=h.cell.handle,p=this.g.get(r)?.getCell(u);if(p)return p.apiCell}if(h&&h.$mid===14){const r=h.uri,u=this.g.get(r);if(u)return u.apiNotebook}return h}}),l.x(A)}getEditorById(E){const A=this.h.get(E);if(!A)throw new Error(`unknown text editor: ${E}. known editors: ${[...this.h.keys()]} `);return A}getIdByEditor(E){for(const[A,v]of this.h)if(v.apiEditor===E)return A}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(E,A){const v=this.g.get(E);if(!v&&!A)throw new Error(`NO notebook document for '${E}'`);return v}static s(E,A){if(!A)return;const v=A.filenamePattern.map(t=>f.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(A.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${A.filenamePattern}`);return}return{extension:E.identifier,providerDisplayName:E.displayName||E.name,displayName:A.displayName,filenamePattern:v,exclusive:A.exclusive||!1}}registerNotebookCellStatusBarItemProvider(E,A,v){const t=l.a++,h=typeof v.onDidChangeCellStatusBarItems=="function"?l.a++:void 0;this.f.set(t,v),this.b.$registerNotebookCellStatusBarItemProvider(t,h,A);let r;return h!==void 0&&(r=v.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(h))),new b.Disposable(()=>{this.f.delete(t),this.b.$unregisterNotebookCellStatusBarItemProvider(t,h),r?.dispose()})}async createNotebookDocument(E){const A=await this.c.$tryCreateNotebook({viewType:E.viewType,content:E.content&&f.NotebookData.from(E.content)});return y.URI.revive(A)}async openNotebookDocument(E){const A=this.g.get(E);if(A)return A.apiNotebook;const v=await this.c.$tryOpenNotebook(E),t=this.g.get(y.URI.revive(v));return(0,R.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(E,A){y.URI.isUri(E)&&(E=await this.openNotebookDocument(E));let v;typeof A=="object"?v={position:f.ViewColumn.from(A.viewColumn),preserveFocus:A.preserveFocus,selections:A.selections&&A.selections.map(f.NotebookRange.from),pinned:typeof A.preview=="boolean"?!A.preview:void 0}:v={preserveFocus:!1};const t=await this.d.$tryShowNotebookDocument(E.uri,E.notebookType,v),h=t&&this.h.get(t)?.apiEditor;if(h)return h;throw t?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(E,A,v,t){const h=this.f.get(E),r=y.URI.revive(A),u=this.g.get(r);if(!u||!h)return;const i=u.getCellFromIndex(v);if(!i)return;const p=await h.provideCellStatusBarItems(i.apiCell,t);if(!p)return;const c=new D.DisposableStore,s=this.p.add([c]),T=(Array.isArray(p)?p:[p]).map(O=>f.NotebookStatusBarItem.from(O,this.i,c));return{cacheId:s,items:T}}$releaseNotebookCellStatusBarItems(E){this.p.delete(E)}registerNotebookSerializer(E,A,v,t,h){if((0,S.isFalsyOrWhitespace)(A))throw new Error("viewType cannot be empty or just whitespace");const r=this.t++;return this.u.set(r,v),this.b.$registerNotebookSerializer(r,{id:E.identifier,location:E.extensionLocation},A,f.NotebookDocumentContentOptions.from(t),l.s(E,h)),(0,D.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(r)})}async $dataToNotebook(E,A,v){const t=this.u.get(E);if(!t)throw new Error("NO serializer found");const h=await t.deserializeNotebook(A.buffer,v);return new m.SerializableObjectWithBuffers(f.NotebookData.from(h))}async $notebookToData(E,A,v){const t=this.u.get(E);if(!t)throw new Error("NO serializer found");const h=await t.serializeNotebook(f.NotebookData.to(A.value),v);return n.VSBuffer.wrap(h)}w(E,A,v){if(this.h.has(A))throw new Error(`editor with id ALREADY EXSIST: ${A}`);const t=new o.ExtHostNotebookEditor(A,this.d,E,v.visibleRanges.map(f.NotebookRange.to),v.selections.map(f.NotebookRange.to),typeof v.viewColumn=="number"?f.ViewColumn.to(v.viewColumn):void 0);this.h.set(A,t)}$acceptDocumentAndEditorsDelta(E){if(E.value.removedDocuments)for(const v of E.value.removedDocuments){const t=y.URI.revive(v),h=this.g.get(t);h&&(h.dispose(),this.g.delete(t),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:h.apiNotebook.getCells().map(r=>r.document.uri)}),this.n.fire(h.apiNotebook));for(const r of this.h.values())r.notebookData.uri.toString()===t.toString()&&this.h.delete(r.id)}if(E.value.addedDocuments){const v=[];for(const t of E.value.addedDocuments){const h=y.URI.revive(t.uri);if(this.g.has(h))throw new Error(`adding EXISTING notebook ${h} `);const r=new a.ExtHostNotebookDocument(this.c,this.q,this.r,h,t);v.push(...t.cells.map(u=>a.ExtHostCell.asModelAddData(r.apiNotebook,u))),this.g.get(h)?.dispose(),this.g.set(h,r),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this.m.fire(r.apiNotebook)}}if(E.value.addedEditors)for(const v of E.value.addedEditors){if(this.h.has(v.id))return;const t=y.URI.revive(v.documentUri),h=this.g.get(t);h&&this.w(h,v.id,v)}const A=[];if(E.value.removedEditors)for(const v of E.value.removedEditors){const t=this.h.get(v);t&&(this.h.delete(v),this.k?.id===t.id&&(this.k=void 0),A.push(t))}if(E.value.visibleEditors){this.l=E.value.visibleEditors.map(t=>this.h.get(t)).filter(t=>!!t);const v=new Set;this.l.forEach(t=>v.add(t.id));for(const t of this.h.values()){const h=v.has(t.id);t._acceptVisibility(h)}this.l=[...this.h.values()].map(t=>t).filter(t=>t.visible),this.o.fire(this.visibleNotebookEditors)}E.value.newActiveEditor===null?this.k=void 0:E.value.newActiveEditor&&(this.k=this.h.get(E.value.newActiveEditor)),E.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(E){const A=w.ApiCommandArgument.String.with("notebookType","A notebook type"),v=new w.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[A,new w.ApiCommandArgument("data","Bytes to convert to data",h=>h instanceof Uint8Array,h=>n.VSBuffer.wrap(h))],new w.ApiCommandResult("Notebook Data",h=>f.NotebookData.to(h.value))),t=new w.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[A,new w.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",h=>!0,h=>new m.SerializableObjectWithBuffers(f.NotebookData.from(h)))],new w.ApiCommandResult("Bytes",h=>h.buffer));E.registerApiCommand(v),E.registerApiCommand(t)}}l.a=0,e.ExtHostNotebookController=l}),define(Ce[223],ke([1,0,15,17,20,4,6,28,2,25,11,54,5,37,8,7,72,186,27,46]),function(te,e,n,C,D,M,S,R,y,k,N,w,f,b,m,a,o,l,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let A=class{constructor(i,p,c,s,d){this.k=p,this.l=c,this.m=s,this.n=d,this.b=new R.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new w.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=i.getProxy(f.MainContext.MainThreadNotebookKernels);const T=new b.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new b.ApiCommandArgument("options","Select kernel options",O=>!0,O=>{if(O&&"notebookEditor"in O&&"id"in O){const H=this.l.getIdByEditor(O.notebookEditor);return{id:O.id,extension:O.extension,notebookEditorId:H}}else if(O&&"notebookEditor"in O){const H=this.l.getIdByEditor(O.notebookEditor);if(H===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${O.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:H}}return O})],b.ApiCommandResult.Void);this.m.registerApiCommand(T)}createNotebookController(i,p,c,s,d,T){for(const ue of this.h.values())if(ue.controller.id===p&&k.ExtensionIdentifier.equals(i.identifier,ue.extensionId))throw new Error(`notebook controller with id '${p}' ALREADY exist`);const O=this.i++,H=this;this.n.trace(`NotebookController[${O}], CREATED by ${i.identifier.value}, ${p}`);const J=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${i.identifier}'`);let K=!1;const L=new S.DisposableStore,B=new M.Emitter,P=new M.Emitter,F={id:r(i.identifier,p),notebookType:c,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:s||i.identifier.value,preloads:T?T.map(m.NotebookRendererScript.from):[]};let V=d??J,j;this.a.$addKernel(O,F).catch(ue=>{console.log(ue),K=!0});let le=0;const _=()=>{if(K)return;const ue=++le;Promise.resolve().then(()=>{ue===le&&this.a.$updateKernel(O,F)})},be=new R.ResourceMap,de={get id(){return p},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return F.label},set label(ue){F.label=ue??i.displayName??i.name,_()},get detail(){return F.detail??""},set detail(ue){F.detail=ue,_()},get description(){return F.description??""},set description(ue){F.description=ue,_()},get kind(){return(0,g.checkProposedApiEnabled)(i,"notebookControllerKind"),F.kind??""},set kind(ue){(0,g.checkProposedApiEnabled)(i,"notebookControllerKind"),F.kind=ue,_()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(ue){F.supportedLanguages=ue,_()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(ue){F.supportsExecutionOrder=ue,_()},get rendererScripts(){return F.preloads?F.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return V},set executeHandler(ue){V=ue??J},get interruptHandler(){return j},set interruptHandler(ue){j=ue,F.supportsInterrupt=Boolean(ue),_()},createNotebookCellExecution(ue){if(K)throw new Error("notebook controller is DISPOSED");if(!be.has(ue.notebook.uri))throw H.n.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(be.keys()).map(se=>se.toString())),new Error(`notebook controller is NOT associated to notebook: ${ue.notebook.uri.toString()}`);return H._createNotebookCellExecution(ue,r(i.identifier,this.id))},dispose:()=>{K||(this.n.trace(`NotebookController[${O}], DISPOSED`),K=!0,this.h.delete(O),L.dispose(),B.dispose(),P.dispose(),this.a.$removeKernel(O))},updateNotebookAffinity(ue,se){se===a.NotebookControllerAffinity2.Hidden&&(0,g.checkProposedApiEnabled)(i,"notebookControllerAffinityHidden"),H.a.$updateNotebookPriority(O,ue.uri,se)},onDidReceiveMessage:P.event,postMessage(ue,se){return(0,g.checkProposedApiEnabled)(i,"notebookMessaging"),H.a.$postMessage(O,se&&H.l.getIdByEditor(se),ue)},asWebviewUri(ue){return(0,g.checkProposedApiEnabled)(i,"notebookMessaging"),(0,o.asWebviewUri)(ue,H.k.remote)}};return this.h.set(O,{extensionId:i.identifier,controller:de,onDidReceiveMessage:P,onDidChangeSelection:B,associatedNotebooks:be}),de}getIdByController(i){for(const[p,c]of this.h)if(c.controller===i)return r(c.extensionId,i.id);return null}createNotebookControllerDetectionTask(i,p){const c=this.d++,s=this;this.n.trace(`NotebookControllerDetectionTask[${c}], CREATED by ${i.identifier.value}`),this.a.$addKernelDetectionTask(c,p);const d={dispose:()=>{this.c.delete(c),s.a.$removeKernelDetectionTask(c)}};return this.c.set(c,d),d}registerKernelSourceActionProvider(i,p,c){const s=this.f++,d=typeof c.onDidChangeNotebookKernelSourceActions=="function"?s:void 0,T=this;this.e.set(s,c),this.n.trace(`NotebookKernelSourceActionProvider[${s}], CREATED by ${i.identifier.value}`),this.a.$addKernelSourceActionProvider(s,s,p);let O;return d!==void 0&&(O=c.onDidChangeNotebookKernelSourceActions(H=>this.a.$emitNotebookKernelSourceActionsChangeEvent(d))),{dispose:()=>{this.e.delete(s),T.a.$removeKernelSourceActionProvider(s,s),O?.dispose()}}}async $provideKernelSourceActions(i,p){const c=this.e.get(i);if(c){const s=new S.DisposableStore;return this.g.add([s]),(await c.provideNotebookKernelSourceActions(p)??[]).map(T=>m.NotebookKernelSourceAction.from(T,this.m.converter,s))}return[]}$acceptNotebookAssociation(i,p,c){const s=this.h.get(i);if(s){const d=this.l.getNotebookDocument(y.URI.revive(p));c?s.associatedNotebooks.set(d.uri,!0):s.associatedNotebooks.delete(d.uri),this.n.trace(`NotebookController[${i}] ASSOCIATE notebook`,d.uri.toString(),c),s.onDidChangeSelection.fire({selected:c,notebook:d.apiNotebook})}}async $executeCells(i,p,c){const s=this.h.get(i);if(!s)return;const d=this.l.getNotebookDocument(y.URI.revive(p)),T=[];for(const O of c){const H=d.getCell(O);H&&T.push(H.apiCell)}try{this.n.trace(`NotebookController[${i}] EXECUTE cells`,d.uri.toString(),T.length),await s.controller.executeHandler.call(s.controller,T,d.apiNotebook,s.controller)}catch(O){this.n.error(`NotebookController[${i}] execute cells FAILED`,O),console.error(O)}}async $cancelCells(i,p,c){const s=this.h.get(i);if(!s)return;const d=this.l.getNotebookDocument(y.URI.revive(p));if(s.controller.interruptHandler)await s.controller.interruptHandler.call(s.controller,d.apiNotebook);else for(const T of c){const O=d.getCell(T);O&&this.b.get(O.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,p,c){const s=this.h.get(i);if(!s)return;const d=this.l.getEditorById(p);s.onDidReceiveMessage.fire(Object.freeze({editor:d.apiEditor,message:c}))}$cellExecutionChanged(i,p,c){const d=this.l.getNotebookDocument(y.URI.revive(i)).getCell(p);if(d){const T=c?m.NotebookCellExecutionState.to(c):a.NotebookCellExecutionState.Idle;T!==void 0&&this.j.fire({cell:d.apiCell,state:T})}}_createNotebookCellExecution(i,p){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this.l.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!s)throw new Error("invalid cell");if(this.b.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const d=new t(p,s,this.a);this.b.set(s.uri,d);const T=d.onDidChangeState(()=>{d.state===v.Resolved&&(d.dispose(),T.dispose(),this.b.delete(s.uri))});return d.asApiObject()}};A=qe([je(4,N.ILogService)],A),e.ExtHostNotebookKernels=A;var v;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(v||(v={}));class t extends S.Disposable{get state(){return this.f}constructor(i,p,c){super(),this.j=p,this.k=c,this.b=t.a++,this.c=new M.Emitter,this.onDidChangeState=this.c.event,this.f=v.Init,this.g=this.B(new D.CancellationTokenSource),this.h=new h(10,s=>this.m(s)),this.i=p.internalMetadata.executionOrder,this.k.$createExecution(this.b,i,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(i){await this.h.addItem(i)}async m(i){const p=Array.isArray(i)?i:[i];return this.k.$updateExecution(this.b,new E.SerializableObjectWithBuffers(p))}n(){if(this.f===v.Init)throw new Error("Must call start before modifying cell output");if(this.f===v.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(i){let p=this.j;if(i&&(p=this.j.notebook.getCellFromApiCell(i)),!p)throw new Error("INVALID cell");return p.handle}s(i){return i.map(p=>{const c=a.NotebookCellOutput.ensureUniqueMimeTypes(p.items,!0);return c===p.items?m.NotebookCellOutput.from(p):m.NotebookCellOutput.from({items:c,id:p.id,metadata:p.metadata})})}async t(i,p,c){const s=this.r(p),d=this.s((0,n.asArray)(i));return this.l({editType:l.CellExecutionUpdateType.Output,cellHandle:s,append:c,outputs:d})}async w(i,p,c){return i=a.NotebookCellOutput.ensureUniqueMimeTypes((0,n.asArray)(i),!0),this.l({editType:l.CellExecutionUpdateType.OutputItems,items:i.map(m.NotebookCellOutputItem.from),outputId:p.id,append:c})}asApiObject(){const i=this;return Object.freeze({get token(){return i.g.token},get cell(){return i.j.apiCell},get executionOrder(){return i.i},set executionOrder(c){i.i=c,i.m([{editType:l.CellExecutionUpdateType.ExecutionState,executionOrder:i.i}])},start(c){if(i.f===v.Resolved||i.f===v.Started)throw new Error("Cannot call start again");i.f=v.Started,i.c.fire(),i.m({editType:l.CellExecutionUpdateType.ExecutionState,runStartTime:c})},end(c,s){if(i.f===v.Resolved)throw new Error("Cannot call resolve twice");i.f=v.Resolved,i.c.fire(),i.h.flush(),i.k.$completeExecution(i.b,new E.SerializableObjectWithBuffers({runEndTime:s,lastRunSuccess:c}))},clearOutput(c){return i.n(),i.t([],c,!1)},appendOutput(c,s){return i.n(),i.t(c,s,!0)},replaceOutput(c,s){return i.n(),i.t(c,s,!1)},appendOutputItems(c,s){return i.n(),i.w(c,s,!0)},replaceOutputItems(c,s){return i.n(),i.w(c,s,!1)}})}}t.a=0;class h{constructor(i,p){this.d=i,this.e=p,this.a=[],this.b=Date.now()}addItem(i){return this.a.push(i),this.c||(this.c=new C.DeferredPromise,this.b=Date.now(),(0,C.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const i=this.c;this.c=void 0;const p=this.a;return this.a=[],this.e(p).finally(()=>i.complete())}}function r(u,i){return`${u.value}/${i}`}e.createKernelId=r}),define(Ce[224],ke([1,0,4,5,100]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class M{constructor(R,y){this.c=y,this.a=new Map,this.b=R.getProxy(C.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(R,y,k){const N=this.c.getEditorById(R);this.a.get(y)?.fire({editor:N.apiEditor,message:k})}createRendererMessaging(R,y){if(!R.contributes?.notebookRenderer?.some(N=>N.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(N,w,f)=>this.d(y).event(N,w,f),postMessage:(N,w)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(N)&&([N,w]=[w,N]);const f=w&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(w);return this.b.$postMessage(f?.id,y,N)}}}d(R){let y=this.a.get(R);return y||(y=new n.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this.a.delete(R)}}),this.a.set(R,y),y)}}e.ExtHostNotebookRenderers=M}),define(Ce[225],ke([1,0,6,9,2,27,5]),function(te,e,n,C,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class R{constructor(k){this.b=new Map,this.a=k.getProxy(S.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(k,N,w){if((0,M.checkProposedApiEnabled)(k,"profileContentHandlers"),this.b.has(N))throw new Error(`Handler with id '${N}' already registered`);return this.b.set(N,w),this.a.$registerProfileContentHandler(N,w.name,w.description,k.identifier.value),(0,n.toDisposable)(()=>{this.b.delete(N),this.a.$unregisterProfileContentHandler(N)})}async $saveProfile(k,N,w,f){const b=this.b.get(k);if(!b)throw new Error(`Unknown handler with id: ${k}`);return b.saveProfile(N,w,f)}async $readProfile(k,N,w){const f=this.b.get(k);if(!f)throw new Error(`Unknown handler with id: ${k}`);return f.readProfile((0,C.isString)(N)?N:D.URI.revive(N),w)}}e.ExtHostProfileContentHandlers=R}),define(Ce[226],ke([1,0,2,5,17,8]),function(te,e,n,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class S{constructor(y,k){this.d=k,this.c=new Map,this.b=y.getProxy(C.MainContext.MainThreadQuickDiff)}$provideOriginalResource(y,k,N){const w=n.URI.revive(k),f=this.c.get(y);return f?(0,D.asPromise)(()=>f.provideOriginalResource(w,N)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(y,k,N,w){const f=S.a++;return this.c.set(f,k),this.b.$registerQuickDiffProvider(f,M.DocumentSelector.from(y,this.d),N,w),{dispose:()=>this.c.delete(f)}}}S.a=0,e.ExtHostQuickDiff=S}),define(Ce[227],ke([1,0,20,4,6,5,2,7,12,15,29,38]),function(te,e,n,C,D,M,S,R,y,k,N,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(b,m,a){const o=b.getProxy(M.MainContext.MainThreadQuickOpen);class l{constructor(i,p){this.e=new Map,this.f=0,this.a=i,this.b=p}showQuickPick(i,p,c=n.CancellationToken.None){this.c=void 0;const s=Promise.resolve(i),d=++this.f,T=o.$show(d,{title:p?.title,placeHolder:p?.placeHolder,matchOnDescription:p?.matchOnDescription,matchOnDetail:p?.matchOnDetail,ignoreFocusLost:p?.ignoreFocusOut,canPickMany:p?.canPickMany},c),O={},H=T.then(()=>O);return Promise.race([H,s]).then(J=>{if(J!==O)return s.then(K=>{const L=[];for(let B=0;B<K.length;B++){const P=K[B];typeof P=="string"?L.push({label:P,handle:B}):P.kind===R.QuickPickItemKind.Separator?L.push({type:"separator",label:P.label}):L.push({label:P.label,description:P.description,detail:P.detail,picked:P.picked,alwaysShow:P.alwaysShow,handle:B})}return p&&typeof p.onDidSelectItem=="function"&&(this.c=B=>{p.onDidSelectItem(K[B])}),o.$setItems(d,L),T.then(B=>{if(typeof B=="number")return K[B];if(Array.isArray(B))return B.map(P=>K[P])})})}).then(void 0,J=>{if(!(0,y.isCancellationError)(J))return o.$setError(d,J),Promise.reject(J)})}$onItemSelected(i){this.c?.(i)}showInput(i,p=n.CancellationToken.None){return this.d=i?.validateInput,o.$input(i,typeof this.d=="function",p).then(void 0,c=>{if(!(0,y.isCancellationError)(c))return Promise.reject(c)})}async $validateInput(i){if(!this.d)return;const p=await this.d(i);if(!p||typeof p=="string")return p;let c;switch(p.severity){case R.InputBoxValidationSeverity.Info:c=N.default.Info;break;case R.InputBoxValidationSeverity.Warning:c=N.default.Warning;break;case R.InputBoxValidationSeverity.Error:c=N.default.Error;break;default:c=p.message?N.default.Error:N.default.Ignore;break}return{content:p.message,severity:c}}async showWorkspaceFolderPick(i,p=n.CancellationToken.None){const c=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!c)return;const s=await this.a.getWorkspaceFolders2();if(!!s)return s.find(d=>d.uri.toString()===c.uri.toString())}createQuickPick(i){const p=new h(i,()=>this.e.delete(p._id));return this.e.set(p._id,p),p}createInputBox(i){const p=new r(i,()=>this.e.delete(p._id));return this.e.set(p._id,p),p}$onDidChangeValue(i,p){this.e.get(i)?._fireDidChangeValue(p)}$onDidAccept(i){this.e.get(i)?._fireDidAccept()}$onDidChangeActive(i,p){const c=this.e.get(i);c instanceof h&&c._fireDidChangeActive(p)}$onDidChangeSelection(i,p){const c=this.e.get(i);c instanceof h&&c._fireDidChangeSelection(p)}$onDidTriggerButton(i,p){this.e.get(i)?._fireDidTriggerButton(p)}$onDidTriggerItemButton(i,p,c){const s=this.e.get(i);s instanceof h&&s._fireDidTriggerItemButton(p,c)}$onDidHide(i){this.e.get(i)?._fireDidHide()}}class g{constructor(i,p){this.x=i,this.y=p,this._id=h.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new C.Emitter,this.q=new C.Emitter,this.r=new C.Emitter,this.s=new C.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(i){this.b=i,this.z({title:i})}get step(){return this.c}set step(i){this.c=i,this.z({step:i})}get totalSteps(){return this.d}set totalSteps(i){this.d=i,this.z({totalSteps:i})}get enabled(){return this.g}set enabled(i){this.g=i,this.z({enabled:i})}get busy(){return this.j}set busy(i){this.j=i,this.z({busy:i})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(i){this.k=i,this.z({ignoreFocusOut:i})}get value(){return this.l}set value(i){this.l=i,this.z({value:i})}get placeholder(){return this.m}set placeholder(i){this.m=i,this.z({placeholder:i})}get buttons(){return this.n}set buttons(i){this.n=i.slice(),this.o.clear(),i.forEach((p,c)=>{const s=p===R.QuickInputButtons.Back?-1:c;this.o.set(s,p)}),this.z({buttons:i.map((p,c)=>({...t(p),tooltip:p.tooltip,handle:p===R.QuickInputButtons.Back?-1:c}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(i){this.l=i,this.q.fire(i)}_fireDidTriggerButton(i){const p=this.o.get(i);p&&this.r.fire(p)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,D.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),o.$dispose(this._id))}z(i){if(!this.v){for(const p of Object.keys(i)){const c=i[p];this.u[p]=c===void 0?null:c}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){o.$createOrUpdate(this.u),this.u={id:this._id}}}g.a=1;function E(u){if(u instanceof R.ThemeIcon)return{id:u.id};const i=v(u),p=A(u);return{dark:typeof i=="string"?S.URI.file(i):i,light:typeof p=="string"?S.URI.file(p):p}}function A(u){return typeof u=="object"&&"light"in u?u.light:u}function v(u){return typeof u=="object"&&"dark"in u?u.dark:u}function t(u){const i=E(u.iconPath);let p,c;return"id"in i?c=w.ThemeIcon.asClassName(i):p=i,{iconPath:p,iconClass:c}}class h extends g{constructor(i,p){super(i.identifier,p),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new C.Emitter,this.L=[],this.M=new C.Emitter,this.N=new C.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(i){this.B=i.slice(),this.C.clear(),this.D.clear(),i.forEach((c,s)=>{this.C.set(s,c),this.D.set(c,s)});const p=[];for(let c=0;c<i.length;c++){const s=i[c];s.kind===R.QuickPickItemKind.Separator?p.push({type:"separator",label:s.label}):p.push({handle:c,label:s.label,description:s.description,detail:s.detail,picked:s.picked,alwaysShow:s.alwaysShow,buttons:s.buttons?.map((d,T)=>({...t(d),tooltip:d.tooltip,handle:T}))})}this.z({items:p})}get canSelectMany(){return this.E}set canSelectMany(i){this.E=i,this.z({canSelectMany:i})}get matchOnDescription(){return this.F}set matchOnDescription(i){this.F=i,this.z({matchOnDescription:i})}get matchOnDetail(){return this.G}set matchOnDetail(i){this.G=i,this.z({matchOnDetail:i})}get sortByLabel(){return this.H}set sortByLabel(i){this.H=i,this.z({sortByLabel:i})}get keepScrollPosition(){return this.I}set keepScrollPosition(i){this.I=i,this.z({keepScrollPosition:i})}get activeItems(){return this.J}set activeItems(i){this.J=i.filter(p=>this.D.has(p)),this.z({activeItems:this.J.map(p=>this.D.get(p))})}get selectedItems(){return this.L}set selectedItems(i){this.L=i.filter(p=>this.D.has(p)),this.z({selectedItems:this.L.map(p=>this.D.get(p))})}_fireDidChangeActive(i){const p=(0,k.coalesce)(i.map(c=>this.C.get(c)));this.J=p,this.K.fire(p)}_fireDidChangeSelection(i){const p=(0,k.coalesce)(i.map(c=>this.C.get(c)));this.L=p,this.M.fire(p)}_fireDidTriggerItemButton(i,p){const c=this.C.get(i);if(!c||!c.buttons||!c.buttons.length)return;const s=c.buttons[p];s&&this.N.fire({button:s,item:c})}}class r extends g{constructor(i,p){super(i.identifier,p),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(i){this.B=i,this.z({password:i})}get prompt(){return this.C}set prompt(i){this.C=i,this.z({prompt:i})}get valueSelection(){return this.D}set valueSelection(i){this.D=i,this.z({valueSelection:i})}get validationMessage(){return this.E}set validationMessage(i){this.E=i,i?typeof i=="string"?this.z({validationMessage:i,severity:N.default.Error}):this.z({validationMessage:i.message,severity:i.severity??N.default.Error}):this.z({validationMessage:void 0,severity:N.default.Ignore})}}return new l(m,a)}e.createExtHostQuickOpen=f});var Le=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n};define(Ce[228],ke([1,0,2,4,63,6,17,5,15,123,11,25,38,8,27]),function(te,e,n,C,D,M,S,R,y,k,N,w,f,b,m){"use strict";var a,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(s){if(s)return typeof s.iconPath=="string"?n.URI.file(s.iconPath):n.URI.isUri(s.iconPath)||f.ThemeIcon.isThemeIcon(s.iconPath)?s.iconPath:void 0}function g(s,d){if(!s.iconPath&&!d.iconPath)return 0;if(s.iconPath){if(!d.iconPath)return 1}else return-1;const T=typeof s.iconPath=="string"?s.iconPath:n.URI.isUri(s.iconPath)?s.iconPath.fsPath:s.iconPath.id,O=typeof d.iconPath=="string"?d.iconPath:n.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,k.comparePaths)(T,O)}function E(s,d){let T=0;if(s.strikeThrough!==d.strikeThrough)return s.strikeThrough?1:-1;if(s.faded!==d.faded)return s.faded?1:-1;if(s.tooltip!==d.tooltip)return(s.tooltip||"").localeCompare(d.tooltip||"");if(T=g(s,d),T!==0)return T;if(s.light&&d.light)T=g(s.light,d.light);else{if(s.light)return 1;if(d.light)return-1}if(T!==0)return T;if(s.dark&&d.dark)T=g(s.dark,d.dark);else{if(s.dark)return 1;if(d.dark)return-1}return T}function A(s,d){if(s.command!==d.command)return s.command<d.command?-1:1;if(s.title!==d.title)return s.title<d.title?-1:1;if(s.tooltip!==d.tooltip){if(s.tooltip!==void 0&&d.tooltip!==void 0)return s.tooltip<d.tooltip?-1:1;if(s.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(s.arguments===d.arguments)return 0;if(s.arguments)if(d.arguments){if(s.arguments.length!==d.arguments.length)return s.arguments.length-d.arguments.length}else return 1;else return-1;for(let T=0;T<s.arguments.length;T++){const O=s.arguments[T],H=d.arguments[T];if(O!==H)return O<H?-1:1}return 0}function v(s,d){let T=(0,k.comparePaths)(s.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(T!==0)return T;if(s.command&&d.command)T=A(s.command,d.command);else{if(s.command)return 1;if(d.command)return-1}if(T!==0)return T;if(s.decorations&&d.decorations)T=E(s.decorations,d.decorations);else{if(s.decorations)return 1;if(d.decorations)return-1}return T}function t(s,d){for(let T=0;T<s.length;T++)if(s[T]!==d[T])return!1;return!0}function h(s,d){return s.command===d.command&&s.title===d.title&&s.tooltip===d.tooltip&&(s.arguments&&d.arguments?t(s.arguments,d.arguments):s.arguments===d.arguments)}function r(s,d){return(0,y.equals)(s,d,h)}class u{get value(){return this.d}set value(d){d=d??"",Le(this,a,"f").$setInputBoxValue(this.l,d),this.m(d)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(d){Le(this,a,"f").$setInputBoxPlaceholder(this.l,d),this.f=d}get validateInput(){return(0,m.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(d){if((0,m.checkProposedApiEnabled)(this.k,"scmValidation"),d&&typeof d!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=d,Le(this,a,"f").$setValidationProviderIsEnabled(this.l,!!d)}get enabled(){return this.h}set enabled(d){d=!!d,this.h!==d&&(this.h=d,Le(this,a,"f").$setInputBoxEnablement(this.l,d))}get visible(){return this.j}set visible(d){d=!!d,this.j!==d&&(this.j=d,Le(this,a,"f").$setInputBoxVisibility(this.l,d))}constructor(d,T,O){this.k=d,this.l=O,a.set(this,void 0),this.d="",this.e=new C.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,a,T,"f")}showValidationMessage(d,T){(0,m.checkProposedApiEnabled)(this.k,"scmValidation"),Le(this,a,"f").$showValidationMessage(this.l,d,T)}$onInputBoxValueChange(d){this.m(d)}m(d){this.d=d,this.e.fire(d)}}e.ExtHostSCMInputBox=u,a=new WeakMap;class i{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(d){this.v=d,this.q.$updateGroupLabel(this.t,this.handle,d)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(d){this.p=d,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(d){this.f=[...d],this.k.fire()}constructor(d,T,O,H,J){this.q=d,this.s=T,this.t=O,this.u=H,this.v=J,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new C.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new C.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=i.d++}getResourceState(d){return this.g.get(d)}$executeResourceCommand(d,T){const O=this.h.get(d);return O?(0,S.asPromise)(()=>this.s.executeCommand(O.command,...O.arguments||[],T)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this.f].sort(v),O=(0,y.sortedDiff)(this.o,d,v).map(K=>{const L=K.toInsert.map(B=>{const P=this.e++;this.g.set(P,B);const F=B.resourceUri;let V;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const ee=new M.DisposableStore;V=this.s.converter.toInternal(B.command,ee),this.j.set(P,ee)}else this.h.set(P,B.command);const j=l(B.decorations),le=B.decorations&&l(B.decorations.light)||j,_=B.decorations&&l(B.decorations.dark)||j,be=[le,_],de=B.decorations&&B.decorations.tooltip||"",ue=B.decorations&&!!B.decorations.strikeThrough,se=B.decorations&&!!B.decorations.faded,Z=B.contextValue||"";return{rawResource:[P,F,be,de,ue,se,Z,V],handle:P}});return{start:K.start,deleteCount:K.deleteCount,toInsert:L}}),H=O.map(({start:K,deleteCount:L,toInsert:B})=>[K,L,B.map(P=>P.rawResource)]),J=O.reverse();for(const{start:K,deleteCount:L,toInsert:B}of J){const P=B.map(V=>V.handle),F=this.n.splice(K,L,...P);for(const V of F)this.g.delete(V),this.h.delete(V),this.j.get(V)?.dispose(),this.j.delete(V)}return this.o=d,H}dispose(){this.l=!0,this.m.fire()}}i.d=0;class p{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(d){this.g!==d&&(this.g=d,Le(this,o,"f").$updateSourceControl(this.t,{count:d}))}get quickDiffProvider(){return this.h}set quickDiffProvider(d){this.h=d,Le(this,o,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!d})}get commitTemplate(){return this.j}set commitTemplate(d){d!==this.j&&(this.j=d,Le(this,o,"f").$updateSourceControl(this.t,{commitTemplate:d}))}get acceptInputCommand(){return this.l}set acceptInputCommand(d){this.k.value=new M.DisposableStore,this.l=d;const T=this.v.converter.toInternal(d,this.k.value);Le(this,o,"f").$updateSourceControl(this.t,{acceptInputCommand:T})}get actionButton(){return(0,m.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(d){(0,m.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new M.DisposableStore,this.n=d;const T=d!==void 0?{command:this.v.converter.toInternal(d.command,this.m.value),secondaryCommands:d.secondaryCommands?.map(O=>O.map(H=>this.v.converter.toInternal(H,this.m.value))),description:d.description,enabled:d.enabled}:void 0;Le(this,o,"f").$updateSourceControl(this.t,{actionButton:T??null})}get statusBarCommands(){return this.p}set statusBarCommands(d){if(this.p&&d&&r(this.p,d))return;this.o.value=new M.DisposableStore,this.p=d;const T=(d||[]).map(O=>this.v.converter.toInternal(O,this.o.value));Le(this,o,"f").$updateSourceControl(this.t,{statusBarCommands:T})}get selected(){return this.q}constructor(d,T,O,H,J,K){this.u=d,this.v=O,this.w=H,this.x=J,this.y=K,o.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new M.MutableDisposable,this.l=void 0,this.m=new M.MutableDisposable,this.o=new M.MutableDisposable,this.p=void 0,this.q=!1,this.s=new C.Emitter,this.onDidChangeSelection=this.s.event,this.t=p.d++,this.z=new Map,this.A=new Set,Je(this,o,T,"f"),this.f=new u(d,Le(this,o,"f"),this.t),Le(this,o,"f").$registerSourceControl(this.t,H,J,K)}createResourceGroup(d,T){const O=new i(Le(this,o,"f"),this.v,this.t,d,T),H=C.Event.once(O.onDidDispose)(()=>this.z.delete(O));return this.z.set(O,H),this.eventuallyAddResourceGroups(),O}eventuallyAddResourceGroups(){const d=[],T=[];for(const[O,H]of this.z){H.dispose();const J=O.onDidUpdateResourceStates(()=>{this.A.add(O),this.eventuallyUpdateResourceStates()});C.Event.once(O.onDidDispose)(()=>{this.A.delete(O),J.dispose(),this.e.delete(O.handle),Le(this,o,"f").$unregisterGroup(this.t,O.handle)}),d.push([O.handle,O.id,O.label,O.features]);const K=O._takeResourceStateSnapshot();K.length>0&&T.push([O.handle,K]),this.e.set(O.handle,O)}Le(this,o,"f").$registerGroups(this.t,d,T),this.z.clear()}eventuallyUpdateResourceStates(){const d=[];this.A.forEach(T=>{const O=T._takeResourceStateSnapshot();O.length!==0&&d.push([T.handle,O])}),d.length>0&&Le(this,o,"f").$spliceResourceStates(this.t,d),this.A.clear()}getResourceGroup(d){return this.e.get(d)}setSelectionState(d){this.q=d,this.s.fire(d)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(d=>d.dispose()),Le(this,o,"f").$unregisterSourceControl(this.t)}}o=new WeakMap,p.d=0,qe([(0,D.debounce)(100)],p.prototype,"eventuallyAddResourceGroups",null),qe([(0,D.debounce)(100)],p.prototype,"eventuallyUpdateResourceStates",null);let c=class on{get onDidChangeActiveProvider(){return this.j.event}constructor(d,T,O){this.l=T,this.m=O,this.g=new Map,this.h=new Map,this.j=new C.Emitter,this.e=d.getProxy(R.MainContext.MainThreadSCM),this.f=d.getProxy(R.MainContext.MainThreadTelemetry),T.registerArgumentProcessor({processArgument:H=>{if(H&&H.$mid===3){const J=this.g.get(H.sourceControlHandle);if(!J)return H;const K=J.getResourceGroup(H.groupHandle);return K?K.getResourceState(H.handle):H}else if(H&&H.$mid===4){const J=this.g.get(H.sourceControlHandle);return J?J.getResourceGroup(H.groupHandle):H}else if(H&&H.$mid===5){const J=this.g.get(H.handle);return J||H}return H}})}createSourceControl(d,T,O,H){this.m.trace("ExtHostSCM#createSourceControl",d.identifier.value,T,O,H),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const J=on.d++,K=new p(d,this.e,this.l,T,O,H);this.g.set(J,K);const L=this.h.get(w.ExtensionIdentifier.toKey(d.identifier))||[];return L.push(K),this.h.set(w.ExtensionIdentifier.toKey(d.identifier),L),K}getLastInputBox(d){this.m.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const T=this.h.get(w.ExtensionIdentifier.toKey(d.identifier)),O=T&&T[T.length-1];return O&&O.inputBox}$provideOriginalResource(d,T,O){const H=n.URI.revive(T);this.m.trace("ExtHostSCM#$provideOriginalResource",d,H.toString());const J=this.g.get(d);return!J||!J.quickDiffProvider||!J.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,S.asPromise)(()=>J.quickDiffProvider.provideOriginalResource(H,O)).then(K=>K||null)}$onInputBoxValueChange(d,T){this.m.trace("ExtHostSCM#$onInputBoxValueChange",d);const O=this.g.get(d);return O&&O.inputBox.$onInputBoxValueChange(T),Promise.resolve(void 0)}$executeResourceCommand(d,T,O,H){this.m.trace("ExtHostSCM#$executeResourceCommand",d,T,O);const J=this.g.get(d);if(!J)return Promise.resolve(void 0);const K=J.getResourceGroup(T);return K?K.$executeResourceCommand(O,H):Promise.resolve(void 0)}$validateInput(d,T,O){this.m.trace("ExtHostSCM#$validateInput",d);const H=this.g.get(d);return!H||!H.inputBox.validateInput?Promise.resolve(void 0):(0,S.asPromise)(()=>H.inputBox.validateInput(T,O)).then(J=>{if(!J)return Promise.resolve(void 0);const K=b.MarkdownString.fromStrict(J.message);return K?Promise.resolve([K,J.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this.g.get(d)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=d,Promise.resolve(void 0)}};c.d=0,c=qe([je(2,N.ILogService)],c),e.ExtHostSCM=c}),define(Ce[79],ke([1,0,5,4,3]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class M{constructor(R){this.b=new C.Emitter,this.onDidChangePassword=this.b.event,this.a=R.getProxy(n.MainContext.MainThreadSecretState)}async $onDidChangePassword(R){this.b.fire(R)}get(R,y){return this.a.$getPassword(R,y)}store(R,y,k){return this.a.$setPassword(R,y,k)}delete(R,y){return this.a.$deletePassword(R,y)}}e.ExtHostSecretState=M,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[229],ke([1,0,7,5,142,6,8,9]),function(te,e,n,C,D,M,S,R){"use strict";var y,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class N{constructor(m,a,o,l,g=n.StatusBarAlignment.Left,E){y.set(this,void 0),k.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new M.DisposableStore,Je(this,y,m,"f"),Je(this,k,a,"f"),this.c=N.a++,this.e=o,this.f=l,this.g=g,this.h=this.u(E)}u(m){if(!!(0,R.isNumber)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(m){this.k=m,this.v()}set name(m){this.m=m,this.v()}set tooltip(m){this.l=m,this.v()}set color(m){this.n=m,this.v()}set backgroundColor(m){m&&!N.b.has(m.id)&&(m=void 0),this.o=m,this.v()}set command(m){this.r?.fromApi!==m&&(this.p&&this.q.add(this.p),this.p=new M.DisposableStore,typeof m=="string"?this.r={fromApi:m,internal:Le(this,k,"f").toInternal({title:"",command:m},this.p)}:m?this.r={fromApi:m,internal:Le(this,k,"f").toInternal(m,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(m){this.t=m,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Le(this,y,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let m;this.e?this.f?m=`${this.e.identifier.value}.${this.f}`:m=this.e.identifier.value:m=this.f;let a;this.m?a=this.m:a=(0,D.localize)(0,null,this.e.displayName||this.e.name);let o=this.n;this.o&&(o=N.b.get(this.o.id));const l=S.MarkdownString.fromStrict(this.l);Le(this,y,"f").$setEntry(this.c,m,a,this.k,l,this.r?.internal,o,this.o,this.g===n.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}y=new WeakMap,k=new WeakMap,N.a=0,N.b=new Map([["statusBarItem.errorBackground",new n.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new n.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=N;class w{constructor(m){this.b=[],this.a=m.createStatusBarEntry(void 0,"status.extensionMessage",n.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,D.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(m){const a={message:m};return this.b.unshift(a),this.c(),new n.Disposable(()=>{const o=this.b.indexOf(a);o>=0&&(this.b.splice(o,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class f{constructor(m,a){this.a=m.getProxy(C.MainContext.MainThreadStatusBar),this.b=a,this.c=new w(this)}createStatusBarEntry(m,a,o,l){return new N(this.a,this.b,m,a,o,l)}setStatusBarMessage(m,a){const o=this.c.setMessage(m);let l;return typeof a=="number"?l=setTimeout(()=>o.dispose(),a):typeof a<"u"&&a.then(()=>o.dispose(),()=>o.dispose()),new n.Disposable(()=>{o.dispose(),clearTimeout(l)})}}e.ExtHostStatusBar=f}),define(Ce[80],ke([1,0,5,4,3]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class M{constructor(R,y){this.c=y,this.b=new C.Emitter,this.onDidChangeStorage=this.b.event,this.a=R.getProxy(n.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(R,y){this.a.$registerExtensionStorageKeysToSync(R,y)}async initializeExtensionStorage(R,y,k){const N=await this.a.$initializeExtensionStorage(R,y);let w;return N&&(w=this.d(R,y,N)),w||k}setValue(R,y,k){return this.a.$setValue(R,y,k)}$acceptValue(R,y,k){const N=this.d(R,y,k);N&&this.b.fire({shared:R,key:y,value:N})}d(R,y,k){try{return JSON.parse(k)}catch(N){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${R}): ${N}`)}}}e.ExtHostStorage=M,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(Ce[81],ke([1,0,3,26,11,59,2]),function(te,e,n,C,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,n.createDecorator)("IExtensionStoragePaths");let R=class{constructor(k,N,w){this.d=N,this.f=w,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(f=>this.c=f)}async g(k){return S.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,N=await this.g(k);try{return await this.f.value.stat(N),this.d.trace("[ExtHostStorage] storage dir already exists",N),N}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",N),await this.f.value.createDirectory(N),await this.f.value.writeFile(S.URI.joinPath(N,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:S.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),N}catch(w){this.d.error("[ExtHostStorage]",w);return}}workspaceValue(k){if(this.c)return S.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return S.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};R=qe([je(0,C.IExtHostInitDataService),je(1,D.ILogService),je(2,M.IExtHostConsumerFileSystem)],R),e.ExtensionStoragePaths=R}),define(Ce[60],ke([1,0,4,5,3,2,18,6,7,144,12,170,20,34,171,38,9,17,8]),function(te,e,n,C,D,M,S,R,y,k,N,w,f,b,m,a,o,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class E{constructor(c,s,d,T){this.k=c,this._id=s,this.l=d,this.m=T,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(H=>this.f=H);const O=this;this.value={get name(){return O.m||""},get processId(){return O.b},get creationOptions(){return O.l},get exitStatus(){return O.h},get state(){return O.j},sendText(H,J=!0){O.o(),O.k.$sendText(O._id,H,J)},show(H){O.o(),O.k.$show(O._id,H)},hide(){O.o(),O.k.$hide(O._id)},dispose(){O.a||(O.a=!0,O.k.$dispose(O._id))},get dimensions(){if(!(O.d===void 0||O.g===void 0))return{columns:O.d,rows:O.g}}}}async create(c,s){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:c.name,shellPath:(0,o.withNullAsUndefined)(c.shellPath),shellArgs:(0,o.withNullAsUndefined)(c.shellArgs),cwd:(0,o.withNullAsUndefined)(c.cwd),env:(0,o.withNullAsUndefined)(c.env),icon:(0,o.withNullAsUndefined)(u(c.iconPath)),color:a.ThemeColor.isThemeColor(c.color)?c.color.id:void 0,initialText:(0,o.withNullAsUndefined)(c.message),strictEnv:(0,o.withNullAsUndefined)(c.strictEnv),hideFromUser:(0,o.withNullAsUndefined)(c.hideFromUser),isFeatureTerminal:(0,o.withNullAsUndefined)(s?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,o.withNullAsUndefined)(s?.useShellEnvironment),location:s?.location||this.n(c.location,s?.resolvedExtHostIdentifier),isTransient:(0,o.withNullAsUndefined)(c.isTransient)})}async createExtensionTerminal(c,s,d,T){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:d,color:a.ThemeColor.isThemeColor(T)?T.id:void 0,location:this.n(c,s),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(c,s){return typeof c=="object"?"parentTerminal"in c&&c.parentTerminal&&s?{parentTerminal:s}:"viewColumn"in c?{viewColumn:g.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus}:void 0:c}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(c){this.m=c}setExitStatus(c,s){this.h=Object.freeze({code:c,reason:s})}setDimensions(c,s){return c===this.d&&s===this.g||c===0||s===0?!1:(this.d=c,this.g=s,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(c){this.f?(this.f(c),this.f=void 0):this.b.then(s=>{s!==c&&(this.b=Promise.resolve(c))})}}e.ExtHostTerminal=E;class A{get onProcessReady(){return this.b.event}constructor(c){this.g=c,this.id=0,this.shouldPersist=!1,this.a=new n.Emitter,this.onProcessData=this.a.event,this.b=new n.Emitter,this.d=new n.Emitter,this.onDidChangeProperty=this.d.event,this.f=new n.Emitter,this.onProcessExit=this.f.event}refreshProperty(c){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${c}`)}updateProperty(c,s){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${c}, value: ${s}`)}async start(){}shutdown(){this.g.close()}input(c){this.g.handleInput?.(c)}resize(c,s){this.g.setDimensions?.({columns:c,rows:s})}async processBinary(c){}acknowledgeDataEvent(c){}async setUnicodeVersion(c){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(c){this.g.onDidWrite(s=>this.a.fire(s)),this.g.onDidClose?.((s=void 0)=>{this.f.fire(s===void 0?void 0:s)}),this.g.onDidOverrideDimensions?.(s=>{s&&this.d.fire({type:"overrideDimensions",value:{cols:s.columns,rows:s.rows}})}),this.g.onDidChangeName?.(s=>{this.d.fire({type:"title",value:s})}),this.g.open(c||void 0),c&&this.g.setDimensions?.(c),this.b.fire({pid:-1,cwd:""})}}let v=1,t=class extends R.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(c=>c.value)}get onDidWriteTerminalData(){return this.I.event}constructor(c,s){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new n.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new n.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new n.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new n.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new n.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new n.Emitter,this.onDidChangeShell=this.J.event,this.a=s.getProxy(C.MainContext.MainThreadTerminalService),this.s=new m.TerminalDataBufferer(this.a.$sendProcessData),this.I=new n.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(c),this.B({dispose:()=>{for(const[d,T]of this.g)T.shutdown(!0)}})}getDefaultShell(c){return(c?this.n:this.m)?.path||""}getDefaultShellArgs(c){return(c?this.n:this.m)?.args||[]}createExtensionTerminal(c,s){const d=new E(this.a,(0,b.generateUuid)(),c,c.name),T=new A(c.pty);return d.createExtensionTerminal(c.location,this.L(c,s).resolvedExtHostIdentifier,u(c.iconPath),i(c.color)).then(O=>{const H=this.M(O,T);this.h[O]=H}),this.f.push(d),d.value}L(c,s){if(s=s||{},c.location&&typeof c.location=="object"&&"parentTerminal"in c.location){const d=c.location.parentTerminal;if(d){const T=this.f.find(O=>O.value===d);T&&(s.resolvedExtHostIdentifier=T._id)}}else c.location&&typeof c.location!="object"?s.location=c.location:s.location&&typeof s.location=="object"&&"splitActiveTerminal"in s.location&&(s.location={splitActiveTerminal:!0});return s}attachPtyToTerminal(c,s){if(!this.O(c))throw new Error(`Cannot resolve terminal with id ${c} for virtual process`);const T=new A(s),O=this.M(c,T);this.h[c]=O}async $acceptActiveTerminalChanged(c){const s=this.b;if(c===null){this.b=void 0,s!==this.b&&this.F.fire(this.b);return}const d=this.O(c);d&&(this.b=d,s!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(c,s){const d=this.O(c);d&&this.I.fire({terminal:d.value,data:s})}async $acceptTerminalDimensions(c,s,d){const T=this.O(c);T&&T.setDimensions(s,d)&&this.G.fire({terminal:T.value,dimensions:T.value.dimensions})}async $acceptTerminalMaximumDimensions(c,s,d){this.g.get(c)?.resize(s,d)}async $acceptTerminalTitleChange(c,s){const d=this.O(c);d&&(d.name=s)}async $acceptTerminalClosed(c,s,d){const T=this.Q(this.f,c);if(T!==null){const O=this.f.splice(T,1)[0];O.setExitStatus(s,d),this.C.fire(O.value)}}$acceptTerminalOpened(c,s,d,T){if(s){const J=this.Q(this.f,s);if(J!==null){this.f[J]._id=c,this.D.fire(this.terminals[J]),this.f[J].isOpen=!0;return}}const O={name:T.name,shellPath:T.executable,shellArgs:T.args,cwd:typeof T.cwd=="string"?T.cwd:M.URI.revive(T.cwd),env:T.env,hideFromUser:T.hideFromUser},H=new E(this.a,c,O,d);this.f.push(H),this.D.fire(H.value),H.isOpen=!0}async $acceptTerminalProcessId(c,s){this.O(c)?._setProcessId(s)}async $startExtensionTerminal(c,s){const d=this.O(c);if(!d)return{message:(0,k.localize)(0,null,c)};d.isOpen||await new Promise(O=>{const H=this.onDidOpenTerminal(async J=>{J===d.value&&(H.dispose(),O())})});const T=this.g.get(c);T?T.startSendingEvents(s):this.j[c]={initialDimensions:s}}M(c,s){const d=new R.DisposableStore;d.add(s.onProcessReady(O=>this.a.$sendProcessReady(c,O.pid,O.cwd))),d.add(s.onDidChangeProperty(O=>this.a.$sendProcessProperty(c,O))),this.s.startBuffering(c,s.onProcessData),d.add(s.onProcessExit(O=>this.N(c,O))),this.g.set(c,s);const T=this.j[c];return T&&s instanceof A&&(s.startSendingEvents(T.initialDimensions),delete this.j[c]),d}$acceptProcessAckDataEvent(c,s){this.g.get(c)?.acknowledgeDataEvent(s)}$acceptProcessInput(c,s){this.g.get(c)?.input(s)}$acceptTerminalInteraction(c){const s=this.O(c);s?.setInteractedWith()&&this.H.fire(s.value)}$acceptProcessResize(c,s,d){try{this.g.get(c)?.resize(s,d)}catch(T){if(T.code!=="EPIPE"&&T.code!=="ERR_IPC_CHANNEL_CLOSED")throw T}}$acceptProcessShutdown(c,s){this.g.get(c)?.shutdown(s)}$acceptProcessRequestInitialCwd(c){this.g.get(c)?.getInitialCwd().then(s=>this.a.$sendProcessProperty(c,{type:"initialCwd",value:s}))}$acceptProcessRequestCwd(c){this.g.get(c)?.getCwd().then(s=>this.a.$sendProcessProperty(c,{type:"cwd",value:s}))}$acceptProcessRequestLatency(c){return Promise.resolve(c)}registerLinkProvider(c){return this.u.add(c),this.u.size===1&&this.a.$startLinkProvider(),new y.Disposable(()=>{this.u.delete(c),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(c,s,d){if(this.v.has(s))throw new Error(`Terminal profile provider "${s}" already registered`);return this.v.set(s,d),this.a.$registerProfileProvider(s,c.identifier.value),new y.Disposable(()=>{this.v.delete(s),this.a.$unregisterProfileProvider(s)})}registerTerminalQuickFixProvider(c,s,d){if(this.w.has(c))throw new Error(`Terminal quick fix provider "${c}" is already registered`);return this.w.set(c,d),this.a.$registerQuickFixProvider(c,s),new y.Disposable(()=>{this.w.delete(c),this.a.$unregisterQuickFixProvider(c)})}async $provideTerminalQuickFixes(c,s){const d=new f.CancellationTokenSource().token;if(d.isCancellationRequested)return;const T=this.w.get(c);if(!T)return;const O=await T.provideTerminalQuickFixes(s,d);if(O!==null)return O}async $createContributedProfileTerminal(c,s){const d=new f.CancellationTokenSource().token;let T=await this.v.get(c)?.provideTerminalProfile(d);if(!d.isCancellationRequested){if(T&&!("options"in T)&&(T={options:T}),!T||!("options"in T))throw new Error(`No terminal profile options provided for id "${c}"`);if("pty"in T.options){this.createExtensionTerminal(T.options,s);return}this.createTerminalFromOptions(T.options,s)}}async $provideLinks(c,s){const d=this.O(c);if(!d)return[];this.y.delete(c),this.z.get(c)?.dispose(!0);const O=new f.CancellationTokenSource;this.z.set(c,O);const H=[],J={terminal:d.value,line:s},K=[];for(const P of this.u)K.push(l.Promises.withAsyncBody(async F=>{O.token.onCancellationRequested(()=>F({provider:P,links:[]}));const V=await P.provideTerminalLinks(J,O.token)||[];O.token.isCancellationRequested||F({provider:P,links:V})}));const L=await Promise.all(K);if(O.token.isCancellationRequested)return[];const B=new Map;for(const P of L)P&&P.links.length>0&&H.push(...P.links.map(F=>{const V={id:v++,startIndex:F.startIndex,length:F.length,label:F.tooltip};return B.set(V.id,{provider:P.provider,link:F}),V}));return this.y.set(c,B),H}$activateLink(c,s){const d=this.y.get(c)?.get(s);!d||d.provider.handleTerminalLink(d.link)}N(c,s){this.s.stopBuffering(c),this.g.delete(c),delete this.j[c];const d=this.h[c];d&&(d.dispose(),delete this.h[c]),this.a.$sendProcessExit(c,s)}O(c){return this.P(this.f,c)}P(c,s){const d=this.Q(c,s);return d!==null?c[d]:null}Q(c,s){let d=null;return c.some((T,O)=>T._id===s?(d=O,!0):!1),d}getEnvironmentVariableCollection(c){let s=this.l.get(c.identifier.value);return s||(s=new h,this.S(c.identifier.value,s)),s}R(c,s){const d=(0,w.serializeEnvironmentVariableCollection)(s.map);this.a.$setEnvironmentVariableCollection(c,s.persistent,d.length===0?void 0:d)}$initEnvironmentVariableCollections(c){c.forEach(s=>{const d=s[0],T=new h(s[1]);this.S(d,T)})}$acceptDefaultProfile(c,s){const d=this.m;this.m=c,this.n=s,d?.path!==c.path&&this.J.fire(c.path)}S(c,s){this.l.set(c,s),s.onDidChangeCollection(()=>{this.R(c,s)})}};t=qe([je(1,S.IExtHostRpcService)],t),e.BaseExtHostTerminalService=t;class h{get persistent(){return this.a}set persistent(c){this.a=c,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(c){this.map=new Map,this.a=!0,this.b=new n.Emitter,this.map=new Map(c)}get size(){return this.map.size}replace(c,s){this.d(c,{value:s,type:y.EnvironmentVariableMutatorType.Replace})}append(c,s){this.d(c,{value:s,type:y.EnvironmentVariableMutatorType.Append})}prepend(c,s){this.d(c,{value:s,type:y.EnvironmentVariableMutatorType.Prepend})}d(c,s){const d=this.map.get(c);(!d||d.value!==s.value||d.type!==s.type)&&(this.map.set(c,s),this.b.fire())}get(c){return this.map.get(c)}forEach(c,s){this.map.forEach((d,T)=>c.call(s,T,d,this))}[Symbol.iterator](){return this.map.entries()}delete(c){this.map.delete(c),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let r=class extends t{constructor(c){super(!1,c)}createTerminal(c,s,d){throw new N.NotSupportedError}createTerminalFromOptions(c,s){throw new N.NotSupportedError}};r=qe([je(0,S.IExtHostRpcService)],r),e.WorkerExtHostTerminalService=r;function u(p){if(!(!p||typeof p=="string"))return"id"in p?{id:p.id,color:p.color}:p}function i(p){return a.ThemeColor.isThemeColor(p)?p:void 0}});var Le=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n};define(Ce[230],ke([1,0,15,17,23,20,4,194,231,6,22,9,34,5,18,101,8,7,45,71,56,27]),function(te,e,n,C,D,M,S,R,y,k,N,w,f,b,m,a,o,l,g,E,A,v){"use strict";var t,h;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(P,F,V){this.j=V,this.c=new S.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=P.getProxy(b.MainContext.MainThreadTesting),this.h=new J(this.f),this.g=new c(this.f),F.registerArgumentProcessor({processArgument:j=>{if(j?.$mid!==15)return j;const le=j,_=le.tests[le.tests.length-1].item.extId;return this.d.get(g.TestId.root(_))?.collection.tree.get(_)?.actual??(0,a.toItemFromContext)(j)}})}createTestController(P,F,V,j){if(this.d.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const le=new k.DisposableStore,_=le.add(new a.ExtHostTestItemCollection(F,V,this.j));_.root.label=V;const be=new Map,de=this.f,ue={items:_.root.children,get label(){return V},set label(Z){V=Z,_.root.label=Z,de.$updateController(F,{label:V})},get refreshHandler(){return j},set refreshHandler(Z){j=Z,de.$updateController(F,{canRefresh:!!Z})},get id(){return F},createRunProfile:(Z,X,ee,he,Te,Ne)=>{let Ke=(0,y.hash)(Z);for(;be.has(Ke);)Ke++;return Ne!==void 0&&(0,v.checkProposedApiEnabled)(P,"testContinuousRun"),new K(this.f,be,F,Ke,Z,X,ee,he,Te,Ne)},createTestItem(Z,X,ee){return new a.TestItemImpl(F,Z,X,ee)},createTestRun:(Z,X,ee=!0)=>this.g.createTestRun(F,_,Z,X,ee),set resolveHandler(Z){_.resolveHandler=Z},get resolveHandler(){return _.resolveHandler},dispose:()=>{le.dispose()}};de.$registerTestController(F,V,!!j),le.add((0,k.toDisposable)(()=>de.$unregisterTestController(F)));const se={controller:ue,collection:_,profiles:be};return this.d.set(F,se),le.add((0,k.toDisposable)(()=>this.d.delete(F))),le.add(_.onDidGenerateDiff(Z=>de.$publishDiff(F,Z.map(A.TestsDiffOp.serialize)))),ue}createTestObserver(){return this.h.checkout()}async runTests(P,F=M.CancellationToken.None){const V=s(P);if(!V)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.d.get(V.controllerId);if(!j)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:P.include?.map(le=>g.TestId.fromExtHostTestItem(le,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:L[V.kind],profileId:V.profileId,controllerId:V.controllerId}],exclude:P.exclude?.map(le=>le.id)},F)}$syncTests(){for(const{collection:P}of this.d.values())P.flushDiff();return Promise.resolve()}$provideFileCoverage(P,F,V){return(0,n.mapFind)(this.g.trackers,le=>le.id===P?le.getCoverage(F):void 0)?.provideFileCoverage(V)??Promise.resolve([])}$resolveFileCoverage(P,F,V,j){return(0,n.mapFind)(this.g.trackers,_=>_.id===P?_.getCoverage(F):void 0)?.resolveFileCoverage(V,j)??Promise.resolve([])}$configureRunProfile(P,F){this.d.get(P)?.profiles.get(F)?.configureHandler?.()}async $refreshTests(P,F){await this.d.get(P)?.controller.refreshHandler?.(F)}$publishTestResults(P){this.results=Object.freeze(P.map(F=>(0,N.deepFreeze)(o.TestResults.to(F))).concat(this.results).sort((F,V)=>V.completedAt-F.completedAt).slice(0,32)),this.c.fire()}async $expandTest(P,F){const V=this.d.get(g.TestId.fromString(P).controllerId)?.collection;V&&(await V.expand(P,F<0?1/0:F),V.flushDiff())}$acceptDiff(P){this.h.applyDiff(P.map(A.TestsDiffOp.deserialize))}async $runControllerTests(P,F){return Promise.all(P.map(V=>this.k(V,!1,F)))}async $startContinuousRun(P,F){const V=new M.CancellationTokenSource(F),j=await Promise.all(P.map(le=>this.k(le,!0,V.token)));return!F.isCancellationRequested&&!j.some(le=>le.error)&&await new Promise(le=>F.onCancellationRequested(le)),V.dispose(!0),j}async k(P,F,V){const j=this.d.get(P.controllerId);if(!j)return{};const{collection:le,profiles:_}=j,be=_.get(P.profileId);if(!be)return{};const de=P.testIds.map(X=>le.tree.get(X)).filter(w.isDefined),ue=P.excludeExtIds.map(X=>j.collection.tree.get(X)).filter(w.isDefined).filter(X=>de.some(ee=>ee.fullId.compare(X.fullId)===2));if(!de.length)return{};const se=new l.TestRunRequest2(de.some(X=>X.actual instanceof a.TestItemRootImpl)?void 0:de.map(X=>X.actual),ue.map(X=>X.actual),be,F),Z=(0,A.isStartControllerTests)(P)&&this.g.prepareForMainThreadTestRun(se,d.fromInternal(P,j.collection),V);try{return await be.runHandler(se,V),{}}catch(X){return{error:String(X)}}finally{Z&&(Z.hasRunningTasks&&!V.isCancellationRequested&&await S.Event.toPromise(Z.onEnd),Z.dispose())}}$cancelExtensionTestRun(P){P===void 0?this.g.cancelAllRuns():this.g.cancelRunById(P)}};r=qe([je(0,m.IExtHostRpcService)],r),e.ExtHostTesting=r;const u=1e4;var i;(function(B){B[B.Running=0]="Running",B[B.Cancelling=1]="Cancelling",B[B.Ended=2]="Ended"})(i||(i={}));class p extends k.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(P,F,V){super(),this.k=P,this.l=F,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new S.Emitter),this.onEnd=this.j.event,this.h=this.B(new M.CancellationTokenSource(V));const j=this.B(new C.RunOnceScheduler(()=>this.m(),u));this.B(this.h.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(P){return this.f.get(P)?.coverage}createRun(P){const F=this.k.id,V=this.k.controllerId,j=(0,f.generateUuid)(),le=new T(this.l,F,j),_=se=>(Z,...X)=>{if(de){console.warn(`Setting the state of test "${Z.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(Z)||(this.s(Z),se(Z,...X))},be=(se,Z)=>{const X=Z instanceof Array?Z.map(o.TestMessage.from):[o.TestMessage.from(Z)];if(se.uri&&se.range){const ee={range:o.Range.from(se.range),uri:se.uri};for(const he of X)he.location=he.location||ee}this.l.$appendTestMessagesInRun(F,j,g.TestId.fromExtHostTestItem(se,V).toString(),X)};let de=!1;const ue={isPersisted:this.k.isPersisted,token:this.h.token,name:P,get coverageProvider(){return le.coverageProvider},set coverageProvider(se){le.coverageProvider=se},enqueued:_(se=>{this.l.$updateTestStateInRun(F,j,g.TestId.fromExtHostTestItem(se,V).toString(),1)}),skipped:_(se=>{this.l.$updateTestStateInRun(F,j,g.TestId.fromExtHostTestItem(se,V).toString(),5)}),started:_(se=>{this.l.$updateTestStateInRun(F,j,g.TestId.fromExtHostTestItem(se,V).toString(),2)}),errored:_((se,Z,X)=>{be(se,Z),this.l.$updateTestStateInRun(F,j,g.TestId.fromExtHostTestItem(se,V).toString(),6,X)}),failed:_((se,Z,X)=>{be(se,Z),this.l.$updateTestStateInRun(F,j,g.TestId.fromExtHostTestItem(se,V).toString(),4,X)}),passed:_((se,Z)=>{this.l.$updateTestStateInRun(F,j,g.TestId.fromExtHostTestItem(se,this.k.controllerId).toString(),3,Z)}),appendOutput:(se,Z,X)=>{de||(X&&(this.k.isIncluded(X)?this.s(X):X=void 0),this.l.$appendOutputToRun(F,j,D.VSBuffer.fromString(se),Z&&o.location.from(Z),X&&g.TestId.fromExtHostTestItem(X,V).toString()))},end:()=>{de||(de=!0,this.l.$finishedTestRunTask(F,j),this.f.delete(j),this.f.size||this.p())}};return this.f.set(j,{run:ue,coverage:le}),this.l.$startedTestRunTask(F,{id:j,name:P,running:!0}),ue}m(){for(const{run:P}of this.f.values())P.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(P){if(!(P instanceof a.TestItemImpl))throw new E.InvalidTestItemError(P.id);if(this.g.has(g.TestId.fromExtHostTestItem(P,this.k.controllerId).toString()))return;const F=[],V=this.k.colllection.root;for(;;){const j=o.TestItem.from(P);if(F.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),P===V))break;P=P.parent||V}this.l.$addTestsToRun(this.k.controllerId,this.k.id,F)}}class c{get trackers(){return this.c.values()}constructor(P){this.d=P,this.c=new Map}prepareForMainThreadTestRun(P,F,V){return this.f(P,F,V)}cancelRunById(P){for(const F of this.c.values())if(F.id===P){F.cancel();return}}cancelAllRuns(){for(const P of this.c.values())P.cancel()}createTestRun(P,F,V,j,le){const _=this.c.get(V);if(_)return _.createRun(j);const be=d.fromPublic(P,F,V,le),de=s(V);this.d.$startedExtensionTestRun({controllerId:P,continuous:!!V.continuous,profile:de&&{group:L[de.kind],id:de.profileId},exclude:V.exclude?.map(se=>g.TestId.fromExtHostTestItem(se,F.root.id).toString())??[],id:be.id,include:V.include?.map(se=>g.TestId.fromExtHostTestItem(se,F.root.id).toString())??[F.root.id],persist:le});const ue=this.f(V,be);return ue.onEnd(()=>{this.d.$finishedExtensionTestRun(be.id),ue.dispose()}),ue.createRun(j)}f(P,F,V){const j=new p(F,this.d,V);return this.c.set(P,j),j.onEnd(()=>this.c.delete(P)),j}}e.TestRunCoordinator=c;const s=B=>{if(!!B.profile){if(!(B.profile instanceof K))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return B.profile}};class d{static fromPublic(P,F,V,j){return new d(P,(0,f.generateUuid)(),V.include?.map(le=>g.TestId.fromExtHostTestItem(le,P).toString())??[P],V.exclude?.map(le=>g.TestId.fromExtHostTestItem(le,P).toString())??[],j,F)}static fromInternal(P,F){return new d(P.controllerId,P.runId,P.testIds,P.excludeExtIds,!0,F)}constructor(P,F,V,j,le,_){this.controllerId=P,this.id=F,this.isPersisted=le,this.colllection=_,this.c=V.map(be=>be+"\0"),this.d=j.map(be=>be+"\0")}isIncluded(P){const F=g.TestId.fromExtHostTestItem(P,this.controllerId).toString()+"\0";for(const V of this.d)if(F===V||F.startsWith(V))return!1;for(const V of this.c)if(F===V||F.startsWith(V))return!0;return!1}}e.TestRunDto=d;class T{set coverageProvider(P){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!P||(this.c=P,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(P,F,V){this.f=P,this.g=F,this.h=V}async provideFileCoverage(P){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(P))());try{return(await this.d)?.map(o.TestCoverage.fromFile)??[]}catch(F){throw this.d=void 0,F}}async resolveFileCoverage(P,F){const V=await this.d;let j=V?.[P];return!this.c||!V||!j?[]:(j.detailedCoverage||(j=V[P]=await this.c.resolveFileCoverage?.(j,F)??j),j.detailedCoverage?.map(o.TestCoverage.fromDetailed)??[])}}class O{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(P){this.h=P,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(P){this.c.add(P)}update(P){Object.assign(P.revived,o.TestItem.toPlain(P.item)),this.c.has(P)||this.d.add(P)}remove(P){if(this.c.has(P)){this.c.delete(P);return}this.d.delete(P);const F=g.TestId.parentId(P.item.extId);if(F&&this.g.has(F.toString())){this.g.add(P.item.extId);return}this.f.add(P)}getChangeEvent(){const{c:P,d:F,f:V}=this;return{get added(){return[...P].map(j=>j.revived)},get updated(){return[...F].map(j=>j.revived)},get removed(){return[...V].map(j=>j.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class H extends A.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new S.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(P){return this.d.get(P)}getMirroredTestDataByReference(P){return this.d.get(P.id)}p(P,F){return{...P,revived:o.TestItem.toPlain(P.item),depth:F?F.depth+1:0,children:new Set}}o(){return new O(this.q)}}class J{constructor(P){this.d=P}checkout(){this.c||(this.c=this.f());const P=this.c;return P.observers++,{onDidChangeTest:P.tests.onDidChangeTests,get tests(){return[...P.tests.rootTests].map(F=>F.revived)},dispose:(0,R.once)(()=>{--P.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(P){return this.c?.tests.getMirroredTestDataByReference(P)}applyDiff(P){this.c?.tests.apply(P)}f(){const P=new H;return this.d.$subscribeToDiffs(),{observers:0,tests:P}}}class K{get label(){return this.d}set label(P){P!==this.d&&(this.d=P,Le(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:P}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(P){P!==this.g&&(this.g=P,Le(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:P}))}get isDefault(){return this.f}set isDefault(P){P!==this.f&&(this.f=P,Le(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:P}))}get tag(){return this._tag}set tag(P){P?.id!==this._tag?.id&&(this._tag=P,Le(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:P?o.TestTag.namespace(this.controllerId,P.id):null}))}get configureHandler(){return this.c}set configureHandler(P){P!==this.c&&(this.c=P,Le(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!P}))}constructor(P,F,V,j,le,_,be,de=!1,ue=void 0,se=!1){this.controllerId=V,this.profileId=j,this.d=le,this.kind=_,this.runHandler=be,this.f=de,this._tag=ue,this.g=se,t.set(this,void 0),h.set(this,void 0),Je(this,t,P,"f"),Je(this,h,F,"f"),F.set(j,this);const Z=L[_];if(typeof Z!="number")throw new Error(`Unknown TestRunProfile.group ${_}`);Le(this,t,"f").$publishTestRunProfile({profileId:j,controllerId:V,tag:ue?o.TestTag.namespace(this.controllerId,ue.id):null,label:le,group:Z,isDefault:de,hasConfigurationHandler:!1,supportsContinuousRun:se})}dispose(){Le(this,h,"f")?.delete(this.profileId)&&(Je(this,h,void 0,"f"),Le(this,t,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=K,t=new WeakMap,h=new WeakMap;const L={[l.TestRunProfileKind.Coverage]:8,[l.TestRunProfileKind.Debug]:4,[l.TestRunProfileKind.Run]:2}}),define(Ce[232],ke([1,0,15,4,5,102,8,7]),function(te,e,n,C,D,M,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(N,w){this.i=w,this.a=new C.Emitter,this.b=new C.Emitter,this.c=new C.Emitter,this.d=new C.Emitter,this.f=new C.Emitter,this.g=new C.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=N.getProxy(D.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(f=>this.g.fire(f)),this.i.onDidChangeActiveTextEditor(f=>this.f.fire(f))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(N){const w=this.i.allEditors();return N?w:w.map(f=>f.value)}async showTextDocument(N,w,f){let b;typeof w=="number"?b={position:S.ViewColumn.from(w),preserveFocus:f}:typeof w=="object"?b={position:S.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:typeof w.selection=="object"?S.Range.from(w.selection):void 0,pinned:typeof w.preview=="boolean"?!w.preview:void 0}:b={preserveFocus:!1};const m=await this.h.$tryShowTextDocument(N.uri,b),a=m&&this.i.getEditor(m);if(a)return a.value;throw m?new Error(`Could NOT open editor for "${N.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${N.uri.toString()}".`)}createTextEditorDecorationType(N,w){return new M.TextEditorDecorationType(this.h,N,w).value}$acceptEditorPropertiesChanged(N,w){const f=this.i.getEditor(N);if(!f)throw new Error("unknown text editor");if(w.options&&f._acceptOptions(w.options),w.selections){const b=w.selections.selections.map(S.Selection.to);f._acceptSelections(b)}if(w.visibleRanges){const b=n.coalesce(w.visibleRanges.map(S.Range.to));f._acceptVisibleRanges(b)}if(w.options&&this.b.fire({textEditor:f.value,options:{...w.options,lineNumbers:S.TextEditorLineNumbersStyle.to(w.options.lineNumbers)}}),w.selections){const b=R.TextEditorSelectionChangeKind.fromValue(w.selections.source),m=w.selections.selections.map(S.Selection.to);this.a.fire({textEditor:f.value,selections:m,kind:b})}if(w.visibleRanges){const b=n.coalesce(w.visibleRanges.map(S.Range.to));this.c.fire({textEditor:f.value,visibleRanges:b})}}$acceptEditorPositionData(N){for(const w in N){const f=this.i.getEditor(w);if(!f)throw new Error("Unknown text editor");const b=S.ViewColumn.to(N[w]);f.value.viewColumn!==b&&(f._acceptViewColumn(b),this.d.fire({textEditor:f.value,viewColumn:b}))}}getDiffInformation(N){return Promise.resolve(this.h.$getDiffInformation(N))}}e.ExtHostEditors=y}),define(Ce[233],ke([1,0,2,3,5,6,7,8,25,9]),function(te,e,n,C,D,M,S,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,C.createDecorator)("IExtHostTimeline");class N{constructor(b,m){this.b=new Map,this.c=new Map,this.a=b.getProxy(D.MainContext.MainThreadTimeline),m.registerArgumentProcessor({processArgument:(a,o)=>{if(a&&a.$mid===12)if(this.b.get(a.source)&&y.ExtensionIdentifier.equals(o,this.b.get(a.source)?.extension)){const l=a.uri===void 0?void 0:n.URI.revive(a.uri);return this.c.get(a.source)?.get(w(l))?.get(a.handle)}else return;return a}})}async $getTimeline(b,m,a,o){return this.b.get(b)?.provider.provideTimeline(n.URI.revive(m),a,o)}registerTimelineProvider(b,m,a,o){const l=new M.DisposableStore,g=this.d(m.id,o,l).bind(this);let E;m.onDidChange&&(E=m.onDidChange(v=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:m.id}),this));const A=this.c;return this.f({...m,scheme:b,onDidChange:void 0,async provideTimeline(v,t,h){t?.resetCache&&(l.clear(),A.get(m.id)?.clear());const r=await m.provideTimeline(v,t,h);if(r==null)return;const u=g(v,t);return{...r,source:m.id,items:r.items.map(u)}},dispose(){for(const v of A.values())v.get(m.id)?.clear();E?.dispose(),l.dispose()}},a)}d(b,m,a){return(o,l)=>{let g;if(l?.cacheResults){let E=this.c.get(b);E===void 0&&(E=new Map,this.c.set(b,E));const A=w(o);g=E.get(A),g===void 0&&(g=new Map,E.set(A,g))}return E=>{const{iconPath:A,...v}=E,t=`${b}|${E.id??E.timestamp}`;g?.set(t,E);let h,r,u;E.iconPath&&(A instanceof S.ThemeIcon?u={id:A.id,color:A.color}:n.URI.isUri(A)?(h=A,r=A):{light:h,dark:r}=A);let i;return S.MarkdownString.isMarkdownString(v.tooltip)?i=R.MarkdownString.from(v.tooltip):(0,k.isString)(v.tooltip)?i=v.tooltip:S.MarkdownString.isMarkdownString(v.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=R.MarkdownString.from(v.detail)):(0,k.isString)(v.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=v.detail),{...v,id:v.id??void 0,handle:t,source:b,command:E.command?m.toInternal(E.command,a):void 0,icon:h,iconDark:r,themeIcon:u,tooltip:i,accessibilityInformation:E.accessibilityInformation}}}}f(b,m){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:m}),(0,M.toDisposable)(()=>{for(const o of this.c.values())o.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.ExtHostTimeline=N;function w(f){return f?.toString()}}),define(Ce[234],ke([1,0,6,16,2,5]),function(te,e,n,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class S{constructor(y){this.c=new Map,this.b=y.getProxy(M.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,k,N,w){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const f=w.schemes.find(b=>!S.a.has(b));if(f)throw new Error(`Scheme '${f}' is not supported. Only http and https are currently supported.`);return this.c.set(k,N),this.b.$registerUriOpener(k,w.schemes,y,w.label),(0,n.toDisposable)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(y,k,N){const w=this.c.get(y);if(!w)throw new Error(`Unknown opener with id: ${y}`);const f=D.URI.revive(k);return w.canOpenExternalUri(f,N)}async $openUri(y,k,N){const w=this.c.get(y);if(!w)throw new Error(`Unknown opener id: '${y}'`);return w.openExternalUri(D.URI.revive(k.resolvedUri),{sourceUri:D.URI.revive(k.sourceUri)},N)}}S.a=new Set([C.Schemas.http,C.Schemas.https]),e.ExtHostUriOpeners=S}),define(Ce[235],ke([1,0,5,2,6,12,25]),function(te,e,n,C,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class R{constructor(k){this.c=new Set,this.d=new Map,this.b=k.getProxy(n.MainContext.MainThreadUrls)}registerUriHandler(k,N){if(this.c.has(S.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const w=R.a++;return this.c.add(S.ExtensionIdentifier.toKey(k)),this.d.set(w,N),this.b.$registerUriHandler(w,k),(0,D.toDisposable)(()=>{this.c.delete(S.ExtensionIdentifier.toKey(k)),this.d.delete(w),this.b.$unregisterUriHandler(w)})}$handleExternalUri(k,N){const w=this.d.get(k);if(!w)return Promise.resolve(void 0);try{w.handleUri(C.URI.revive(N))}catch(f){(0,M.onUnexpectedError)(f)}return Promise.resolve(void 0)}async createAppUri(k){return C.URI.revive(await this.b.$createAppUri(k))}}R.a=0,e.ExtHostUrls=R});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[61],ke([1,0,4,16,22,2,157,180,72,5]),function(te,e,n,C,D,M,S,R,y,k){"use strict";var N,w,f,b,m,a,o,l,g,E,A,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class h{constructor(O,H,J,K,L,B,P){N.set(this,void 0),w.set(this,void 0),f.set(this,void 0),b.set(this,void 0),m.set(this,void 0),a.set(this,void 0),o.set(this,""),l.set(this,void 0),g.set(this,!1),E.set(this,!1),A.set(this,void 0),v.set(this,void 0),this._onMessageEmitter=new n.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,t.set(this,new n.Emitter),this._onDidDispose=Le(this,t,"f").event,Je(this,N,O,"f"),Je(this,w,H,"f"),Je(this,l,J,"f"),Je(this,b,K,"f"),Je(this,m,L,"f"),Je(this,a,B,"f"),Je(this,A,r(B),"f"),Je(this,v,u(B),"f"),Je(this,f,P,"f")}dispose(){Je(this,g,!0,"f"),Le(this,t,"f").fire(),Le(this,t,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(O){return Je(this,E,!0,"f"),(0,y.asWebviewUri)(O,Le(this,b,"f"))}get cspSource(){const O=Le(this,a,"f").extensionLocation;if(O.scheme===C.Schemas.https||O.scheme===C.Schemas.http){let H=O.toString();return H.endsWith("/")||(H+="/"),H+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.a(),Le(this,o,"f")}set html(O){this.a(),Le(this,o,"f")!==O&&(Je(this,o,O,"f"),Le(this,v,"f")&&!Le(this,E,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(O)&&(Je(this,E,!0,"f"),Le(this,f,"f").report("Webview vscode-resource: uris",Le(this,a,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Le(this,w,"f").$setHtml(Le(this,N,"f"),this.b(O)))}get options(){return this.a(),Le(this,l,"f")}set options(O){this.a(),D.equals(Le(this,l,"f"),O)||Le(this,w,"f").$setOptions(Le(this,N,"f"),c(Le(this,a,"f"),Le(this,m,"f"),O)),Je(this,l,O,"f")}async postMessage(O){if(Le(this,g,"f"))return!1;const H=(0,R.serializeWebviewMessage)(O,{serializeBuffersForPostMessage:Le(this,A,"f")});return Le(this,w,"f").$postMessage(Le(this,N,"f"),H.message,...H.buffers)}a(){if(Le(this,g,"f"))throw new Error("Webview is disposed")}b(O){if(!Le(this,v,"f"))return O;const H=Le(this,a,"f").extensionLocation?.scheme===C.Schemas.vscodeRemote,J=Le(this,a,"f").extensionLocation.scheme===C.Schemas.vscodeRemote?Le(this,a,"f").extensionLocation.authority:void 0;return O.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(K,L,B,P,F,V)=>{const j=M.URI.from({scheme:P||"file",path:decodeURIComponent(F)}),le=(0,y.asWebviewUri)(j,{isRemote:H,authority:J}).toString();return`${L}${le}${V}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(K,L,B,P,F,V)=>{const j=M.URI.from({scheme:P||"file",path:decodeURIComponent(F)}),le=(0,y.asWebviewUri)(j,{isRemote:H,authority:J}).toString();return`${L}${le}${V}`})}}e.ExtHostWebview=h,N=new WeakMap,w=new WeakMap,f=new WeakMap,b=new WeakMap,m=new WeakMap,a=new WeakMap,o=new WeakMap,l=new WeakMap,g=new WeakMap,E=new WeakMap,A=new WeakMap,v=new WeakMap,t=new WeakMap;function r(T){try{const O=(0,S.normalizeVersion)((0,S.parseVersion)(T.engines.vscode));return!!O&&O.majorBase>=1&&O.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;function u(T){try{const O=(0,S.normalizeVersion)((0,S.parseVersion)(T.engines.vscode));return O?O.majorBase<1||O.majorBase===1&&O.minorBase<60:!1}catch{return!1}}class i{constructor(O,H,J,K,L){this.c=H,this.d=J,this.e=K,this.f=L,this.b=new Map,this.a=O.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(O,H,J){const K=this.g(O);if(K){const{message:L}=(0,R.deserializeWebviewMessage)(H,J.value);K._onMessageEmitter.fire(L)}}$onMissingCsp(O,H){this.e.warn(`${H} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(O,H,J){const K=new h(O,this.a,s(H),this.c,this.d,J,this.f);return this.b.set(O,K),K._onDidDispose(()=>{this.b.delete(O)}),K}deleteWebview(O){this.b.delete(O)}g(O){return this.b.get(O)}}e.ExtHostWebviews=i;function p(T){return{id:T.identifier,location:T.extensionLocation}}e.toExtensionData=p;function c(T,O,H){return{enableCommandUris:H.enableCommandUris,enableScripts:H.enableScripts,enableForms:H.enableForms,portMapping:H.portMapping,localResourceRoots:H.localResourceRoots||d(T,O)}}e.serializeWebviewOptions=c;function s(T){return{enableCommandUris:T.enableCommandUris,enableScripts:T.enableScripts,enableForms:T.enableForms,portMapping:T.portMapping,localResourceRoots:T.localResourceRoots?.map(O=>M.URI.from(O))}}function d(T,O){return[...(O?.getWorkspaceFolders()||[]).map(H=>H.uri),T.extensionLocation]}}),define(Ce[236],ke([1,0,20,231,6,16,24,2,8,61,54,5,7]),function(te,e,n,C,D,M,S,R,y,k,N,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class b{constructor(h,r){this.document=h,this.b=r,this.a=1,this.c=new N.Cache("custom documents")}addEdit(h){return this.c.add([h])}async undo(h,r){await this.f(h).undo(),r||this.disposeBackup()}async redo(h,r){await this.f(h).redo(),r||this.disposeBackup()}disposeEdits(h){for(const r of h)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const h=v(this.document.uri)+this.a++;return(0,S.joinPath)(this.b,h)}updateBackup(h){this.d?.delete(),this.d=h}disposeBackup(){this.d?.delete(),this.d=void 0}f(h){const r=this.c.get(h,0);if(!r)throw new Error("No edit found");return r}}class m{constructor(){this.a=new Map}get(h,r){return this.a.get(this.b(h,r))}add(h,r,u){const i=this.b(h,r.uri);if(this.a.has(i))throw new Error(`Document already exists for viewType:${h} resource:${r.uri}`);const p=new b(r,u);return this.a.set(i,p),p}delete(h,r){const u=this.b(h,r.uri);this.a.delete(u)}b(h,r){return`${h}@@@${r}`}}var a;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(a||(a={}));class o{constructor(){this.a=new Map}addTextProvider(h,r,u){return this.b(0,h,r,u)}addCustomProvider(h,r,u){return this.b(1,h,r,u)}get(h){return this.a.get(h)}b(h,r,u,i){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:h,extension:u,provider:i}),new f.Disposable(()=>this.a.delete(r))}}class l{constructor(h,r,u,i,p){this.d=r,this.f=u,this.g=i,this.h=p,this.b=new o,this.c=new m,this.a=h.getProxy(w.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(h,r,u,i){const p=new D.DisposableStore;return E(u)?(p.add(this.b.addTextProvider(r,h,u)),this.a.$registerTextEditorProvider((0,k.toExtensionData)(h),r,i.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(h))):(p.add(this.b.addCustomProvider(r,h,u)),g(u)&&p.add(u.onDidChangeCustomDocument(c=>{const s=this.i(r,c.document.uri);if(A(c)){const d=s.addEdit(c);this.a.$onDidEdit(c.document.uri,r,d,c.label)}else this.a.$onContentChange(c.document.uri,r)})),this.a.$registerCustomEditorProvider((0,k.toExtensionData)(h),r,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(h))),f.Disposable.from(p,new f.Disposable(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(h,r,u,i,p){const c=this.b.get(r);if(!c)throw new Error(`No provider found for '${r}'`);if(c.type!==1)throw new Error(`Invalid provide type for '${r}'`);const s=R.URI.revive(h),d=await c.provider.openCustomDocument(s,{backupId:u,untitledDocumentData:i?.buffer},p);let T;return g(c.provider)&&this.f&&(T=this.f.workspaceValue(c.extension)??this.f.globalValue(c.extension)),this.c.add(r,d,T),{editable:g(c.provider)}}async $disposeCustomDocument(h,r){const u=this.b.get(r);if(!u)throw new Error(`No provider found for '${r}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${r}'`);const i=R.URI.revive(h),{document:p}=this.i(r,i);this.c.delete(r,p),p.dispose()}async $resolveCustomEditor(h,r,u,i,p,c){const s=this.b.get(u);if(!s)throw new Error(`No provider found for '${u}'`);const d=y.ViewColumn.to(p),T=this.g.createNewWebview(r,i.contentOptions,s.extension),O=this.h.createNewWebviewPanel(r,u,i.title,d,i.options,T,!0),H=R.URI.revive(h);switch(s.type){case 1:{const{document:J}=this.i(u,H);return s.provider.resolveCustomEditor(J,O,c)}case 0:{const J=this.d.getDocument(H);return s.provider.resolveCustomTextEditor(J,O,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(h,r,u){this.i(r,h).disposeEdits(u)}async $onMoveCustomEditor(h,r,u){const i=this.b.get(u);if(!i)throw new Error(`No provider found for '${u}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const p=this.h.getWebviewPanel(h);if(!p)throw new Error("No webview found");const c=R.URI.revive(r),s=this.d.getDocument(c);await i.provider.moveCustomTextEditor(s,p,n.CancellationToken.None)}async $undo(h,r,u,i){return this.i(r,h).undo(u,i)}async $redo(h,r,u,i){return this.i(r,h).redo(u,i)}async $revert(h,r,u){const i=this.i(r,h);await this.j(r).revertCustomDocument(i.document,u),i.disposeBackup()}async $onSave(h,r,u){const i=this.i(r,h);await this.j(r).saveCustomDocument(i.document,u),i.disposeBackup()}async $onSaveAs(h,r,u,i){const p=this.i(r,h);return this.j(r).saveCustomDocumentAs(p.document,R.URI.revive(u),i)}async $backup(h,r,u){const i=this.i(r,h),c=await this.j(r).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},u);return i.updateBackup(c),c.id}i(h,r){const u=this.c.get(h,R.URI.revive(r));if(!u)throw new Error("No custom document found");return u}j(h){const u=this.b.get(h)?.provider;if(!u||!g(u))throw new Error("Custom document is not editable");return u}}e.ExtHostCustomEditors=l;function g(t){return!!t.onDidChangeCustomDocument}function E(t){return typeof t.resolveCustomTextEditor=="function"}function A(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function v(t){const h=t.scheme===M.Schemas.file||t.scheme===M.Schemas.untitled?t.fsPath:t.toString();return(0,C.hash)(h)+""}});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[237],ke([1,0,4,6,2,34,8,61,5,7]),function(te,e,n,C,D,M,S,R,y,k){"use strict";var N,w,f,b,m,a,o,l,g,E,A,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class h extends C.Disposable{constructor(p,c,s,d){super(),N.set(this,void 0),w.set(this,void 0),f.set(this,void 0),b.set(this,void 0),m.set(this,void 0),a.set(this,void 0),o.set(this,void 0),l.set(this,void 0),g.set(this,!0),E.set(this,void 0),A.set(this,!1),v.set(this,this.B(new n.Emitter)),this.onDidDispose=Le(this,v,"f").event,t.set(this,this.B(new n.Emitter)),this.onDidChangeViewState=Le(this,t,"f").event,Je(this,N,p,"f"),Je(this,w,c,"f"),Je(this,b,s,"f"),Je(this,f,d.viewType,"f"),Je(this,m,d.panelOptions,"f"),Je(this,l,d.viewColumn,"f"),Je(this,a,d.title,"f"),Je(this,E,d.active,"f")}dispose(){Le(this,A,"f")||(Je(this,A,!0,"f"),Le(this,v,"f").fire(),Le(this,w,"f").$disposeWebview(Le(this,N,"f")),Le(this,b,"f").dispose(),super.dispose())}get webview(){return this.c(),Le(this,b,"f")}get viewType(){return this.c(),Le(this,f,"f")}get title(){return this.c(),Le(this,a,"f")}set title(p){this.c(),Le(this,a,"f")!==p&&(Je(this,a,p,"f"),Le(this,w,"f").$setTitle(Le(this,N,"f"),p))}get iconPath(){return this.c(),Le(this,o,"f")}set iconPath(p){this.c(),Le(this,o,"f")!==p&&(Je(this,o,p,"f"),Le(this,w,"f").$setIconPath(Le(this,N,"f"),D.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return Le(this,m,"f")}get viewColumn(){if(this.c(),!(typeof Le(this,l,"f")=="number"&&Le(this,l,"f")<0))return Le(this,l,"f")}get active(){return this.c(),Le(this,E,"f")}get visible(){return this.c(),Le(this,g,"f")}_updateViewState(p){Le(this,A,"f")||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(Je(this,E,p.active,"f"),Je(this,g,p.visible,"f"),Je(this,l,p.viewColumn,"f"),Le(this,t,"f").fire({webviewPanel:this}))}reveal(p,c){this.c(),Le(this,w,"f").$reveal(Le(this,N,"f"),{viewColumn:typeof p>"u"?void 0:S.ViewColumn.from(p),preserveFocus:!!c})}c(){if(Le(this,A,"f"))throw new Error("Webview is disposed")}}N=new WeakMap,w=new WeakMap,f=new WeakMap,b=new WeakMap,m=new WeakMap,a=new WeakMap,o=new WeakMap,l=new WeakMap,g=new WeakMap,E=new WeakMap,A=new WeakMap,v=new WeakMap,t=new WeakMap;class r{static c(){return(0,M.generateUuid)()}constructor(p,c,s){this.g=c,this.h=s,this.e=new Map,this.f=new Map,this.d=p.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(p,c,s,d,T={}){const O=typeof d=="object"?d.viewColumn:d,H={viewColumn:S.ViewColumn.from(O),preserveFocus:typeof d=="object"&&!!d.preserveFocus},J=(0,R.shouldSerializeBuffersForPostMessage)(p),K=r.c();this.d.$createWebviewPanel((0,R.toExtensionData)(p),K,c,{title:s,panelOptions:u(T),webviewOptions:(0,R.serializeWebviewOptions)(p,this.h,T),serializeBuffersForPostMessage:J},H);const L=this.g.createNewWebview(K,T,p);return this.createNewWebviewPanel(K,c,s,O,T,L,!0)}$onDidChangeWebviewPanelViewStates(p){const c=Object.keys(p);c.sort((s,d)=>{const T=p[s],O=p[d];return T.active?1:O.active?-1:+T.visible-+O.visible});for(const s of c){const d=this.getWebviewPanel(s);if(!d)continue;const T=p[s];d._updateViewState({active:T.active,visible:T.visible,viewColumn:S.ViewColumn.to(T.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this.e.delete(p),this.g.deleteWebview(p)}registerWebviewPanelSerializer(p,c,s){if(this.f.has(c))throw new Error(`Serializer for '${c}' already registered`);return this.f.set(c,{serializer:s,extension:p}),this.d.$registerSerializer(c,{serializeBuffersForPostMessage:(0,R.shouldSerializeBuffersForPostMessage)(p)}),new k.Disposable(()=>{this.f.delete(c),this.d.$unregisterSerializer(c)})}async $deserializeWebviewPanel(p,c,s,d){const T=this.f.get(c);if(!T)throw new Error(`No serializer found for '${c}'`);const{serializer:O,extension:H}=T,J=this.g.createNewWebview(p,s.webviewOptions,H),K=this.createNewWebviewPanel(p,c,s.title,d,s.panelOptions,J,s.active);await O.deserializeWebviewPanel(K,s.state)}createNewWebviewPanel(p,c,s,d,T,O,H){const J=new h(p,this.d,O,{viewType:c,title:s,viewColumn:d,panelOptions:T,active:H});return this.e.set(p,J),J}getWebviewPanel(p){return this.e.get(p)}}e.ExtHostWebviewPanels=r;function u(i){return{enableFindWidget:i.enableFindWidget,retainContextWhenHidden:i.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[238],ke([1,0,4,6,61,8,5,7]),function(te,e,n,C,D,M,S,R){"use strict";var y,k,N,w,f,b,m,a,o,l,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class E extends C.Disposable{constructor(t,h,r,u,i,p){super(),y.set(this,void 0),k.set(this,void 0),N.set(this,void 0),w.set(this,void 0),f.set(this,!1),b.set(this,void 0),m.set(this,void 0),a.set(this,void 0),o.set(this,void 0),l.set(this,this.B(new n.Emitter)),this.onDidChangeVisibility=Le(this,l,"f").event,g.set(this,this.B(new n.Emitter)),this.onDidDispose=Le(this,g,"f").event,Je(this,N,r,"f"),Je(this,m,u,"f"),Je(this,y,t,"f"),Je(this,k,h,"f"),Je(this,w,i,"f"),Je(this,b,p,"f")}dispose(){Le(this,f,"f")||(Je(this,f,!0,"f"),Le(this,g,"f").fire(),Le(this,w,"f").dispose(),super.dispose())}get title(){return this.a(),Le(this,m,"f")}set title(t){this.a(),Le(this,m,"f")!==t&&(Je(this,m,t,"f"),Le(this,k,"f").$setWebviewViewTitle(Le(this,y,"f"),t))}get description(){return this.a(),Le(this,a,"f")}set description(t){this.a(),Le(this,a,"f")!==t&&(Je(this,a,t,"f"),Le(this,k,"f").$setWebviewViewDescription(Le(this,y,"f"),t))}get visible(){return Le(this,b,"f")}get webview(){return Le(this,w,"f")}get viewType(){return Le(this,N,"f")}_setVisible(t){t===Le(this,b,"f")||Le(this,f,"f")||(Je(this,b,t,"f"),Le(this,l,"f").fire())}get badge(){return this.a(),Le(this,o,"f")}set badge(t){this.a(),!(t?.value===Le(this,o,"f")?.value&&t?.tooltip===Le(this,o,"f")?.tooltip)&&(Je(this,o,M.ViewBadge.from(t),"f"),Le(this,k,"f").$setWebviewViewBadge(Le(this,y,"f"),t))}show(t){this.a(),Le(this,k,"f").$show(Le(this,y,"f"),!!t)}a(){if(Le(this,f,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,k=new WeakMap,N=new WeakMap,w=new WeakMap,f=new WeakMap,b=new WeakMap,m=new WeakMap,a=new WeakMap,o=new WeakMap,l=new WeakMap,g=new WeakMap;class A{constructor(t,h){this.d=h,this.b=new Map,this.c=new Map,this.a=t.getProxy(S.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,h,r,u){if(this.b.has(h))throw new Error(`View provider for '${h}' already registered`);return this.b.set(h,{provider:r,extension:t}),this.a.$registerWebviewViewProvider((0,D.toExtensionData)(t),h,{retainContextWhenHidden:u?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(t)}),new R.Disposable(()=>{this.b.delete(h),this.a.$unregisterWebviewViewProvider(h)})}async $resolveWebviewView(t,h,r,u,i){const p=this.b.get(h);if(!p)throw new Error(`No view provider found for '${h}'`);const{provider:c,extension:s}=p,d=this.d.createNewWebview(t,{},s),T=new E(t,this.a,h,r,d,!0);this.c.set(t,T),await c.resolveWebviewView(T,{state:u},i)}async $onDidChangeWebviewViewVisibility(t,h){this.e(t)._setVisible(h)}async $disposeWebviewView(t){const h=this.e(t);this.c.delete(t),h.dispose(),this.d.deleteWebview(t)}e(t){const h=this.c.get(t);if(!h)throw new Error("No webview found");return h}}e.ExtHostWebviewViews=A}),define(Ce[104],ke([1,0,4,5,2,16,10,3,18]),function(te,e,n,C,D,M,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class an{get state(){return this.d}constructor(w){this.c=new n.Emitter,this.onDidChangeWindowState=this.c.event,this.d=an.a,this.b=w.getProxy(C.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(f=>this.$onDidChangeWindowFocus(f))}$onDidChangeWindowFocus(w){w!==this.d.focused&&(this.d={...this.d,focused:w},this.c.fire(this.d))}openUri(w,f){let b;if(typeof w=="string"){b=w;try{w=D.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,S.isFalsyOrWhitespace)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this.b.$openUri(w,b,f)}async asExternalUri(w,f){if((0,S.isFalsyOrWhitespace)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this.b.$asExternalUri(w,f);return D.URI.from(b)}};k.a={focused:!0},k=qe([je(0,y.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,R.createDecorator)("IExtHostWindow")}),define(Ce[239],ke([1,0,209,26,18]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let M=class extends n.AbstractExtHostConsoleForwarder{constructor(R,y){super(R,y)}f(R,y,k){y.apply(console,k)}};M=qe([je(0,D.IExtHostRpcService),je(1,C.IExtHostInitDataService)],M),e.ExtHostConsoleForwarder=M}),define(Ce[240],ke([1,0,17,23,20,12,4,6,127,203,46]),function(te,e,n,C,D,M,S,R,y,k,N){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function f(T,O){try{return JSON.stringify(T,O)}catch{return"null"}}const b="$$ref$$",m={[b]:-1};class a{constructor(O,H){this.jsonString=O,this.referencedBuffers=H}}function o(T,O=null,H=!1){const J=[];return{jsonString:(H?f:JSON.stringify)(T,(L,B)=>{if(typeof B>"u")return m;if(typeof B=="object"){if(B instanceof C.VSBuffer){const P=J.push(B)-1;return{[b]:P}}if(O)return O(L,B)}return B}),referencedBuffers:J}}e.stringifyJsonWithBufferRefs=o;function l(T,O,H){return JSON.parse(T,(J,K)=>{if(K){const L=K[b];if(typeof L=="number")return O[L];if(H&&K.$mid===1)return H.transformIncoming(K)}return K})}e.parseJsonAndRestoreBufferRefs=l;function g(T,O){return JSON.stringify(T,O)}function E(T){return T?(O,H)=>H&&H.$mid===1?T.transformOutgoing(H):H:null}var A;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(A=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(T){T[T.Responsive=0]="Responsive",T[T.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},h=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class u extends R.Disposable{constructor(O,H=null,J=null){super(),this[w]=!0,this.b=this.B(new S.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=O,this.f=H,this.g=J,this.h=E(this.g),this.j=!1,this.k=[],this.l=[];for(let K=0,L=N.ProxyIdentifier.count;K<L;K++)this.k[K]=null,this.l[K]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new n.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(K=>this.G(K))}dispose(){this.j=!0,Object.keys(this.s).forEach(O=>{this.s[O].resolveErr(M.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(O){this.u===0&&(this.v=Date.now()+u.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(O){this.v=Date.now()+u.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(O){this.t!==O&&(this.t=O,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(O){return this.g?(0,y.transformIncomingURIs)(O,this.g):O}getProxy(O){const{nid:H,sid:J}=O;return this.l[H]||(this.l[H]=this.F(H,J)),this.l[H]}F(O,H){const J={get:(K,L)=>(typeof L=="string"&&!K[L]&&L.charCodeAt(0)===36&&(K[L]=(...B)=>this.O(O,L,B)),L===r?H:K[L])};return new Proxy(Object.create(null),J)}set(O,H){return this.k[O.nid]=H,H}assertRegistered(O){for(let H=0,J=O.length;H<J;H++){const K=O[H];if(!this.k[K.nid])throw new Error(`Missing proxy instance ${K.sid}`)}}G(O){if(this.j)return;const H=O.byteLength,J=i.read(O,0),K=J.readUInt8(),L=J.readUInt32();switch(K){case 1:case 2:{let{rpcId:B,method:P,args:F}=c.deserializeRequestJSONArgs(J);this.g&&(F=(0,y.transformIncomingURIs)(F,this.g)),this.H(H,L,B,P,F,K===2);break}case 3:case 4:{let{rpcId:B,method:P,args:F}=c.deserializeRequestMixedArgs(J);this.g&&(F=(0,y.transformIncomingURIs)(F,this.g)),this.H(H,L,B,P,F,K===4);break}case 5:{this.f?.logIncoming(H,L,0,"ack"),this.z(L);break}case 6:{this.I(H,L);break}case 7:{this.J(H,L,void 0);break}case 9:{let B=c.deserializeReplyOKJSON(J);this.g&&(B=(0,y.transformIncomingURIs)(B,this.g)),this.J(H,L,B);break}case 10:{const B=c.deserializeReplyOKJSONWithBuffers(J,this.g);this.J(H,L,B);break}case 8:{const B=c.deserializeReplyOKVSBuffer(J);this.J(H,L,B);break}case 11:{let B=c.deserializeReplyErrError(J);this.g&&(B=(0,y.transformIncomingURIs)(B,this.g)),this.L(H,L,B);break}case 12:{this.L(H,L,void 0);break}default:console.error("received unexpected message"),console.error(O)}}H(O,H,J,K,L,B){this.f?.logIncoming(O,H,1,`receiveRequest ${(0,N.getStringIdentifierForProxy)(J)}.${K}(`,L);const P=String(H);let F,V;if(B){const le=new D.CancellationTokenSource;L.push(le.token),F=this.M(J,K,L),V=()=>le.cancel()}else F=this.M(J,K,L),V=t;this.p[P]=V;const j=c.serializeAcknowledged(H);this.f?.logOutgoing(j.byteLength,H,1,"ack"),this.c.send(j),F.then(le=>{delete this.p[P];const _=c.serializeReplyOK(H,le,this.h);this.f?.logOutgoing(_.byteLength,H,1,"reply:",le),this.c.send(_)},le=>{delete this.p[P];const _=c.serializeReplyErr(H,le);this.f?.logOutgoing(_.byteLength,H,1,"replyErr:",le),this.c.send(_)})}I(O,H){this.f?.logIncoming(O,H,1,"receiveCancel");const J=String(H);this.p[J]?.()}J(O,H,J){this.f?.logIncoming(O,H,0,"receiveReply:",J);const K=String(H);if(!this.s.hasOwnProperty(K))return;const L=this.s[K];delete this.s[K],L.resolveOk(J)}L(O,H,J){this.f?.logIncoming(O,H,0,"receiveReplyErr:",J);const K=String(H);if(!this.s.hasOwnProperty(K))return;const L=this.s[K];delete this.s[K];let B;J&&(J.$isError?(B=new Error,B.name=J.name,B.message=J.message,B.stack=J.stack):B=J),L.resolveErr(B)}M(O,H,J){try{return Promise.resolve(this.N(O,H,J))}catch(K){return Promise.reject(K)}}N(O,H,J){const K=this.k[O];if(!K)throw new Error("Unknown actor "+(0,N.getStringIdentifierForProxy)(O));const L=K[H];if(typeof L!="function")throw new Error("Unknown method "+H+" on actor "+(0,N.getStringIdentifierForProxy)(O));return L.apply(K,J)}O(O,H,J){if(this.j)return new k.CanceledLazyPromise;let K=null;if(J.length>0&&D.CancellationToken.isCancellationToken(J[J.length-1])&&(K=J.pop()),K&&K.isCancellationRequested)return Promise.reject(M.canceled());const L=c.serializeRequestArguments(J,this.h),B=++this.m,P=String(B),F=new k.LazyPromise;K&&K.onCancellationRequested(()=>{const j=c.serializeCancel(B);this.f?.logOutgoing(j.byteLength,B,0,"cancel"),this.c.send(c.serializeCancel(B))}),this.s[P]=F,this.y(B);const V=c.serializeRequest(B,O,H,L,!!K);return this.f?.logOutgoing(V.byteLength,B,0,`request: ${(0,N.getStringIdentifierForProxy)(O)}.${H}(`,J),this.c.send(V),F}}w=h,u.a=3*1e3,e.RPCProtocol=u;class i{static alloc(O,H,J){const K=new i(C.VSBuffer.alloc(J+1+4),0);return K.writeUInt8(O),K.writeUInt32(H),K}static read(O,H){return new i(O,H)}get buffer(){return this.a}constructor(O,H){this.a=O,this.b=H}static sizeUInt8(){return 1}writeUInt8(O){this.a.writeUInt8(O,this.b),this.b+=1}readUInt8(){const O=this.a.readUInt8(this.b);return this.b+=1,O}writeUInt32(O){this.a.writeUInt32BE(O,this.b),this.b+=4}readUInt32(){const O=this.a.readUInt32BE(this.b);return this.b+=4,O}static sizeShortString(O){return 1+O.byteLength}writeShortString(O){this.a.writeUInt8(O.byteLength,this.b),this.b+=1,this.a.set(O,this.b),this.b+=O.byteLength}readShortString(){const O=this.a.readUInt8(this.b);this.b+=1;const J=this.a.slice(this.b,this.b+O).toString();return this.b+=O,J}static sizeLongString(O){return 4+O.byteLength}writeLongString(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}readLongString(){const O=this.a.readUInt32BE(this.b);this.b+=4;const J=this.a.slice(this.b,this.b+O).toString();return this.b+=O,J}writeBuffer(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}static sizeVSBuffer(O){return 4+O.byteLength}writeVSBuffer(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}readVSBuffer(){const O=this.a.readUInt32BE(this.b);this.b+=4;const H=this.a.slice(this.b,this.b+O);return this.b+=O,H}static sizeMixedArray(O){let H=0;H+=1;for(let J=0,K=O.length;J<K;J++){const L=O[J];switch(H+=1,L.type){case 1:H+=this.sizeLongString(L.value);break;case 2:H+=this.sizeVSBuffer(L.value);break;case 3:H+=this.sizeUInt32,H+=this.sizeLongString(L.value);for(let B=0;B<L.buffers.length;++B)H+=this.sizeVSBuffer(L.buffers[B]);break;case 4:break}}return H}writeMixedArray(O){this.a.writeUInt8(O.length,this.b),this.b+=1;for(let H=0,J=O.length;H<J;H++){const K=O[H];switch(K.type){case 1:this.writeUInt8(1),this.writeLongString(K.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(K.value);break;case 3:this.writeUInt8(3),this.writeUInt32(K.buffers.length),this.writeLongString(K.value);for(let L=0;L<K.buffers.length;++L)this.writeBuffer(K.buffers[L]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const O=this.a.readUInt8(this.b);this.b+=1;const H=new Array(O);for(let J=0;J<O;J++)switch(this.readUInt8()){case 1:H[J]=this.readLongString();break;case 2:H[J]=this.readVSBuffer();break;case 3:{const L=this.readUInt32(),B=this.readLongString(),P=[];for(let F=0;F<L;++F)P.push(this.readVSBuffer());H[J]=new N.SerializableObjectWithBuffers(l(B,P,null));break}case 4:H[J]=void 0;break}return H}}i.sizeUInt32=4;var p;(function(T){T[T.Simple=0]="Simple",T[T.Mixed=1]="Mixed"})(p||(p={}));class c{static a(O){for(let H=0,J=O.length;H<J;H++)if(O[H]instanceof C.VSBuffer||O[H]instanceof N.SerializableObjectWithBuffers||typeof O[H]>"u")return!0;return!1}static serializeRequestArguments(O,H){if(this.a(O)){const J=[];for(let K=0,L=O.length;K<L;K++){const B=O[K];if(B instanceof C.VSBuffer)J[K]={type:2,value:B};else if(typeof B>"u")J[K]={type:4};else if(B instanceof N.SerializableObjectWithBuffers){const{jsonString:P,referencedBuffers:F}=o(B.value,H);J[K]={type:3,value:C.VSBuffer.fromString(P),buffers:F}}else J[K]={type:1,value:C.VSBuffer.fromString(g(B,H))}}return{type:1,args:J}}return{type:0,args:g(O,H)}}static serializeRequest(O,H,J,K,L){switch(K.type){case 0:return this.b(O,H,J,K.args,L);case 1:return this.c(O,H,J,K.args,L)}}static b(O,H,J,K,L){const B=C.VSBuffer.fromString(J),P=C.VSBuffer.fromString(K);let F=0;F+=i.sizeUInt8(),F+=i.sizeShortString(B),F+=i.sizeLongString(P);const V=i.alloc(L?2:1,O,F);return V.writeUInt8(H),V.writeShortString(B),V.writeLongString(P),V.buffer}static deserializeRequestJSONArgs(O){const H=O.readUInt8(),J=O.readShortString(),K=O.readLongString();return{rpcId:H,method:J,args:JSON.parse(K)}}static c(O,H,J,K,L){const B=C.VSBuffer.fromString(J);let P=0;P+=i.sizeUInt8(),P+=i.sizeShortString(B),P+=i.sizeMixedArray(K);const F=i.alloc(L?4:3,O,P);return F.writeUInt8(H),F.writeShortString(B),F.writeMixedArray(K),F.buffer}static deserializeRequestMixedArgs(O){const H=O.readUInt8(),J=O.readShortString(),K=O.readMixedArray(),L=new Array(K.length);for(let B=0,P=K.length;B<P;B++){const F=K[B];typeof F=="string"?L[B]=JSON.parse(F):L[B]=F}return{rpcId:H,method:J,args:L}}static serializeAcknowledged(O){return i.alloc(5,O,0).buffer}static serializeCancel(O){return i.alloc(6,O,0).buffer}static serializeReplyOK(O,H,J){if(typeof H>"u")return this.d(O);if(H instanceof C.VSBuffer)return this.e(O,H);if(H instanceof N.SerializableObjectWithBuffers){const{jsonString:K,referencedBuffers:L}=o(H.value,J,!0);return this.g(O,K,L)}else return this.f(O,f(H,J))}static d(O){return i.alloc(7,O,0).buffer}static e(O,H){let J=0;J+=i.sizeVSBuffer(H);const K=i.alloc(8,O,J);return K.writeVSBuffer(H),K.buffer}static deserializeReplyOKVSBuffer(O){return O.readVSBuffer()}static f(O,H){const J=C.VSBuffer.fromString(H);let K=0;K+=i.sizeLongString(J);const L=i.alloc(9,O,K);return L.writeLongString(J),L.buffer}static g(O,H,J){const K=C.VSBuffer.fromString(H);let L=0;L+=i.sizeUInt32,L+=i.sizeLongString(K);for(const P of J)L+=i.sizeVSBuffer(P);const B=i.alloc(10,O,L);B.writeUInt32(J.length),B.writeLongString(K);for(const P of J)B.writeBuffer(P);return B.buffer}static deserializeReplyOKJSON(O){const H=O.readLongString();return JSON.parse(H)}static deserializeReplyOKJSONWithBuffers(O,H){const J=O.readUInt32(),K=O.readLongString(),L=[];for(let B=0;B<J;++B)L.push(O.readVSBuffer());return new N.SerializableObjectWithBuffers(l(K,L,H))}static serializeReplyErr(O,H){const J=H?f(M.transformErrorForSerialization(H),null):void 0;if(typeof J!="string")return this.h(O);const K=C.VSBuffer.fromString(J);let L=0;L+=i.sizeLongString(K);const B=i.alloc(11,O,L);return B.writeLongString(K),B.buffer}static deserializeReplyErrError(O){const H=O.readLongString();return JSON.parse(H)}static h(O){return i.alloc(12,O,0).buffer}}var s;(function(T){T[T.RequestJSONArgs=1]="RequestJSONArgs",T[T.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",T[T.RequestMixedArgs=3]="RequestMixedArgs",T[T.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",T[T.Acknowledged=5]="Acknowledged",T[T.Cancel=6]="Cancel",T[T.ReplyOKEmpty=7]="ReplyOKEmpty",T[T.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",T[T.ReplyOKJSON=9]="ReplyOKJSON",T[T.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",T[T.ReplyErrError=11]="ReplyErrError",T[T.ReplyErrEmpty=12]="ReplyErrEmpty"})(s||(s={}));var d;(function(T){T[T.String=1]="String",T[T.VSBuffer=2]="VSBuffer",T[T.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",T[T.Undefined=4]="Undefined"})(d||(d={}))}),define(Ce[241],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const n=function(M){const S=R=>{self.removeEventListener("message",S);const y=R.data;Object.defineProperties(self,{postMessage:{value(k,N){y.postMessage(k,N)}},onmessage:{get(){return y.onmessage},set(k){y.onmessage=k}}}),y.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};self.addEventListener("message",S)}.toString();class C extends EventTarget{constructor(M,S,R){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${n})('${S}'))`,k=new Blob([y],{type:"application/javascript"}),N=URL.createObjectURL(k),w=new MessageChannel,f=N,b={type:"_newWorker",id:f,port:w.port2,url:N,options:R};M(b,[w.port2]),this.postMessage=w.port1.postMessage.bind(w.port1),this.terminate=()=>{M({type:"_terminateWorker",id:f}),URL.revokeObjectURL(N),w.port1.close(),w.port2.close()},Object.defineProperties(this,{onmessage:{get(){return w.port1.onmessage},set(m){w.port1.onmessage=m}},onmessageerror:{get(){return w.port1.onmessageerror},set(m){w.port1.onmessageerror=m}}}),w.port1.addEventListener("messageerror",m=>{const a=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(a)}),w.port1.addEventListener("message",m=>{const a=new MessageEvent("message",{data:m.data});this.dispatchEvent(a)}),w.port1.start()}}e.NestedWorker=C}),define(Ce[242],ke([1,0,4,30,42,3]),function(te,e,n,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new D.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new D.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new D.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,M.createDecorator)(e.OUTPUT_SERVICE_ID);var S;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(S=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.a=new Map,this.b=new n.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new n.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(N=>k.push(N)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}C.Registry.add(e.Extensions.OutputChannels,new R),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new D.RawContextKey("activeOutputChannel","")}),define(Ce[105],ke([1,0,5,3,18,25,11,242,59,26,36,121,23,9,43,4,6]),function(te,e,n,C,D,M,S,R,y,k,N,w,f,b,m,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class l extends S.AbstractMessageLogger{get disposed(){return this.l}constructor(v,t,h,r,u){super(),this.id=v,this.name=t,this.m=h,this.n=r,this.extension=u,this.k=0,this.l=!1,this.visible=!1,this.setLevel(h.getLevel()),this.B(h.onDidChangeLogLevel(i=>this.setLevel(i)))}get logLevel(){return this.getLevel()}appendLine(v){this.append(v+`
`)}append(v){this.info(v)}clear(){const v=this.k;this.m.flush(),this.n.$update(this.id,R.OutputChannelUpdateMode.Clear,v)}replace(v){const t=this.k;this.info(v),this.n.$update(this.id,R.OutputChannelUpdateMode.Replace,t),this.visible&&this.m.flush()}show(v,t){this.m.flush(),this.n.$reveal(this.id,!!(typeof v=="boolean"?v:t))}hide(){this.n.$close(this.id)}g(v,t){this.k+=f.VSBuffer.fromString(t).byteLength,(0,S.log)(this.m,v,t),this.visible&&(this.m.flush(),this.n.$update(this.id,R.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class g extends l{appendLine(v){this.append(v)}}let E=class{constructor(v,t,h,r,u,i){this.i=t,this.j=h,this.k=r,this.l=u,this.m=i,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=v.getProxy(n.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.h=v;for(const[t,h]of this.g)h.visible=t===this.h}createOutputChannel(v,t,h){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,u=(0,b.isString)(t)?t:void 0;if((0,b.isString)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let i;const p=this.i.environment.extensionLogLevel?.find(([s])=>M.ExtensionIdentifier.equals(h.identifier,s))?.[1];p&&(i=(0,S.parseLogLevel)(p));const c=r?this.o(v,i,h):this.n(v,u,h);return c.then(s=>{this.g.set(s.id,s),s.visible=s.id===this.h}),r?this.r(v,i??this.m.getLevel(),c):this.q(v,c)}async n(v,t,h){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,u=this.k.extUri.joinPath(r,`${this.f++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),i=this.l.createLogger(u,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),p=await this.a.$register(v,u,t,h.identifier.value);return new l(p,v,i,this.a,h)}async o(v,t,h){const r=await this.p(h),u=this.k.extUri.joinPath(r,`${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),i=u.toString(),p=this.l.createLogger(u,{id:i,name:v,logLevel:t,extensionId:h.identifier.value});return new g(i,v,p,this.a,h)}p(v){let t=this.d.get(v.identifier.value);if(!t){const h=this.k.extUri.joinPath(this.i.logsLocation,v.identifier.value);this.d.set(v.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(h)}catch(r){if((0,m.toFileSystemProviderErrorCode)(r)!==m.FileSystemProviderErrorCode.FileExists)throw r}return h})())}return t}q(v,t){let h=!1;const r=()=>{if(h)throw new Error("Channel has been closed")};return{get name(){return v},append(u){r(),t.then(i=>i.append(u))},appendLine(u){r(),t.then(i=>i.appendLine(u))},clear(){r(),t.then(u=>u.clear())},replace(u){r(),t.then(i=>i.replace(u))},show(u,i){r(),t.then(p=>p.show(u,i))},hide(){r(),t.then(u=>u.hide())},dispose(){h=!0,t.then(u=>u.dispose())}}}r(v,t,h){const r=new o.DisposableStore,u=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},i=r.add(new a.Emitter);function p(c){t=c,i.fire(c)}return h.then(c=>{r.add(c),c.logLevel!==t&&p(c.logLevel),r.add(c.onDidChangeLogLevel(s=>p(s)))}),{...this.q(v,h),get logLevel(){return t},onDidChangeLogLevel:i.event,trace(c,...s){u(),h.then(d=>d.trace(c,...s))},debug(c,...s){u(),h.then(d=>d.debug(c,...s))},info(c,...s){u(),h.then(d=>d.info(c,...s))},warn(c,...s){u(),h.then(d=>d.warn(c,...s))},error(c,...s){u(),h.then(d=>d.error(c,...s))},dispose(){r.dispose()}}}};E=qe([je(0,D.IExtHostRpcService),je(1,k.IExtHostInitDataService),je(2,y.IExtHostConsumerFileSystem),je(3,N.IExtHostFileSystemInfo),je(4,S.ILoggerService),je(5,S.ILogService)],E),e.ExtHostOutputService=E,e.IExtHostOutputService=(0,C.createDecorator)("IExtHostOutputService")}),define(Ce[243],ke([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,n.createDecorator)("remoteAgentService")}),define(Ce[244],ke([1,0,40,16,19,21,24,2,3,175,53,191,243]),function(te,e,n,C,D,M,S,R,y,k,N,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let b=class cn{constructor(a,o,l,g){this.d=a,this.e=o,this.f=l,this.g=g,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const E=await this.e.getEnvironment();return this.c=E?.userHome??a})()}hasValidBasename(a,o,l){return typeof o=="string"||typeof o>"u"?this.a.then(g=>this.h(a,g,o)):this.h(a,o,l)}h(a,o,l){return a.scheme===C.Schemas.file||a.scheme===C.Schemas.vscodeRemote?(0,n.isValidBasename)(l??(0,S.basename)(a),o===1):!0}get defaultUriScheme(){return cn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(a,o){if(a.remoteAuthority)return C.Schemas.vscodeRemote;const l=(0,k.getVirtualWorkspaceScheme)(o.getWorkspace());if(l)return l;const g=o.getWorkspace().folders[0];if(g)return g.uri.scheme;const E=o.getWorkspace().configuration;return E?E.scheme:C.Schemas.file}userHome(a){return a?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(a=>a===1?D.win32:D.posix)}async fileURI(a){let o="";if(await this.a===1&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const g=a.indexOf("/",2);g===-1?(o=a.substring(2),a="/"):(o=a.substring(2,g),a=a.substring(g)||"/")}return R.URI.from({scheme:C.Schemas.file,authority:o,path:a,query:"",fragment:""})}};b=qe([je(1,f.IRemoteAgentService),je(2,w.IWorkbenchEnvironmentService),je(3,N.IWorkspaceContextService)],b),e.AbstractPathService=b}),define(Ce[106],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class n{constructor(S,R){this.line=S,this.character=R}isBefore(S){return!1}isBeforeOrEqual(S){return!1}isAfter(S){return!1}isAfterOrEqual(S){return!1}isEqual(S){return!1}compareTo(S){return 0}translate(S,R){return new n(0,0)}with(S){return new n(0,0)}}e.Position=n;class C{constructor(S,R,y,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new n(S,R),this.end=new n(y,k)}contains(S){return!1}isEqual(S){return!1}intersection(S){}union(S){return new C(0,0,0,0)}with(S){return new C(0,0,0,0)}}e.Range=C;var D;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ce[47],ke([1,0,15,35,22,40,10,3,19,12,106,17]),function(te,e,n,C,D,M,S,R,y,k,N,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return N.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const f="\u27EA ",b=" characters skipped \u27EB",m=(f.length+b.length+5)*2;e.ISearchService=(0,R.createDecorator)("searchService");var a;(function(de){de[de.file=0]="file",de[de.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var o;(function(de){de[de.File=1]="File",de[de.Text=2]="Text"})(o=e.QueryType||(e.QueryType={}));function l(de){return!!de.preview}e.resultIsMatch=l;function g(de){return!!de.resource}e.isFileMatch=g;function E(de){return!!de.message}e.isProgressMessage=E;var A;(function(de){de[de.Normal=0]="Normal",de[de.NewSearchStarted=1]="NewSearchStarted"})(A=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class v{constructor(ue){this.resource=ue,this.results=[]}}e.FileMatch=v;class t{constructor(ue,se,Z){this.ranges=se;const X=Array.isArray(se)?se:[se];if(Z&&Z.matchLines===1&&h(X)){ue=(0,S.getNLines)(ue,Z.matchLines);let ee="",he=0,Te=0;const Ne=Math.floor(Z.charsPerLine/5),Ke=[];for(const Pe of X){const Se=Math.max(Pe.startColumn-Ne,0),Ie=Pe.startColumn+Z.charsPerLine;if(Se>Te+Ne+m){const oe=f+(Se-Te)+b;ee+=oe+ue.slice(Se,Ie),he+=Se-(Te+oe.length)}else ee+=ue.slice(Te,Ie);Ke.push(new u(0,Pe.startColumn-he,Pe.endColumn-he)),Te=Ie}this.preview={text:ee,matches:Array.isArray(this.ranges)?Ke:Ke[0]}}else{const ee=Array.isArray(se)?se[0].startLineNumber:se.startLineNumber;this.preview={text:ue,matches:(0,n.mapArrayOrNot)(se,he=>new r(he.startLineNumber-ee,he.startColumn,he.endLineNumber-ee,he.endColumn))}}}}e.TextSearchMatch=t;function h(de){const ue=de[0].startLineNumber;for(const se of de)if(se.startLineNumber!==ue||se.endLineNumber!==ue)return!1;return!0}class r{constructor(ue,se,Z,X){this.startLineNumber=ue,this.startColumn=se,this.endLineNumber=Z,this.endColumn=X}}e.SearchRange=r;class u extends r{constructor(ue,se,Z){super(ue,se,ue,Z)}}e.OneLineRange=u;var i;(function(de){de.List="list",de.Tree="tree"})(i=e.ViewMode||(e.ViewMode={}));var p;(function(de){de.Default="default",de.FileNames="fileNames",de.Type="type",de.Modified="modified",de.CountDescending="countDescending",de.CountAscending="countAscending"})(p=e.SearchSortOrder||(e.SearchSortOrder={}));function c(de,ue=!0){const se=de&&de.files&&de.files.exclude,Z=ue&&de&&de.search&&de.search.exclude;if(!se&&!Z)return;if(!se||!Z)return se||Z;let X=Object.create(null);return X=D.mixin(X,D.deepClone(se)),X=D.mixin(X,D.deepClone(Z),!0),X}e.getExcludes=c;function s(de,ue){return de.excludePattern&&C.match(de.excludePattern,ue)?!1:de.includePattern||de.usingSearchPaths?de.includePattern&&C.match(de.includePattern,ue)?!0:de.usingSearchPaths?!!de.folderQueries&&de.folderQueries.some(se=>{const Z=se.folder.fsPath;if(M.isEqualOrParent(ue,Z)){const X=y.relative(Z,ue);return!se.includePattern||!!C.match(se.includePattern,X)}else return!1}):!1:!0}e.pathIncludedInQuery=s;var d;(function(de){de[de.unknownEncoding=1]="unknownEncoding",de[de.regexParseError=2]="regexParseError",de[de.globParseError=3]="globParseError",de[de.invalidLiteral=4]="invalidLiteral",de[de.rgProcessError=5]="rgProcessError",de[de.other=6]="other",de[de.canceled=7]="canceled"})(d=e.SearchErrorCode||(e.SearchErrorCode={}));class T extends Error{constructor(ue,se){super(ue),this.code=se}}e.SearchError=T;function O(de){const ue=de.message;if((0,k.isCancellationError)(de))return new T(ue,d.canceled);try{const se=JSON.parse(ue);return new T(se.message,se.code)}catch{return new T(ue,d.other)}}e.deserializeSearchError=O;function H(de){const ue={message:de.message,code:de.code};return new Error(JSON.stringify(ue))}e.serializeSearchError=H;function J(de){return de.type==="error"?!0:de.type==="success"}e.isSerializedSearchComplete=J;function K(de){return de.type==="success"}e.isSerializedSearchSuccess=K;function L(de){return!!de.path}e.isSerializedFileMatch=L;function B(de,ue){const se=de.searchPath?de.searchPath:de.relativePath;return(0,S.fuzzyContains)(se,ue)}e.isFilePatternMatch=B;class P{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=P;function F(de,ue){const se={...de||{},...ue||{}};return Object.keys(se).filter(Z=>{const X=se[Z];return typeof X=="boolean"&&X})}e.resolvePatternsForProvider=F;class V{constructor(ue,se){this.c=null,this.a={...ue.excludePattern||{},...se.excludePattern||{}},this.b=C.parse(this.a);let Z=ue.includePattern;se.includePattern&&(Z?Z={...Z,...se.includePattern}:Z=se.includePattern),Z&&(this.c=C.parse(Z))}matchesExcludesSync(ue,se,Z){return!!(this.b&&this.b(ue,se,Z))}includedInQuerySync(ue,se,Z){return!(this.b&&this.b(ue,se,Z)||this.c&&!this.c(ue,se,Z))}includedInQuery(ue,se,Z){const X=this.b(ue,se,Z),ee=()=>this.c?!!this.c(ue,se,Z):!0;return(0,w.isThenable)(X)?X.then(he=>he?!1:ee()):ee()}hasSiblingExcludeClauses(){return j(this.a)}}e.QueryGlobTester=V;function j(de){for(const ue in de)if(typeof de[ue]!="boolean")return!0;return!1}function le(de){if(!de)return;let ue;return se=>(ue||(ue=(de()||Promise.resolve([])).then(Z=>Z?be(Z):{})),ue.then(Z=>!!Z[se]))}e.hasSiblingPromiseFn=le;function _(de){if(!de)return;let ue;return se=>{if(!ue){const Z=de();ue=Z?be(Z):{}}return!!ue[se]}}e.hasSiblingFn=_;function be(de){const ue={};for(const se of de)ue[se]=!0;return ue}}),define(Ce[31],ke([1,0,15,17,20,4,6,48,16,113,24,10,9,2,146,3,11,163,53,36,26,18,8,7,55,47,5]),function(te,e,n,C,D,M,S,R,y,k,N,w,f,b,m,a,o,l,g,E,A,v,t,h,r,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function p(K,L,B){return new N.ExtUri(P=>T(P,B)).isEqual(K,L)}function c(K,L,B){return p(K.uri,L.uri,B)?0:(0,w.compare)(K.uri.toString(),L.uri.toString())}function s(K,L,B){return K.index!==L.index?K.index<L.index?-1:1:p(K.uri,L.uri,B)?(0,w.compare)(K.name,L.name):(0,w.compare)(K.uri.toString(),L.uri.toString())}function d(K,L,B,P){const F=K.slice(0).sort((j,le)=>B(j,le,P)),V=L.slice(0).sort((j,le)=>B(j,le,P));return(0,n.delta)(F,V,(j,le)=>B(j,le,P))}function T(K,L){const B=L.getCapabilities(K.scheme);return!(B&&B&1024)}class O extends g.Workspace{static toExtHostWorkspace(L,B,P,F){if(!L)return{workspace:null,added:[],removed:[]};const{id:V,name:j,folders:le,configuration:_,transient:be,isUntitled:de}=L,ue=[],se=B;B?le.forEach((he,Te)=>{const Ne=b.URI.revive(he.uri),Ke=O.o(P||B,Ne,F);Ke?(Ke.name=he.name,Ke.index=he.index,ue.push(Ke)):ue.push({uri:Ne,name:he.name,index:Te})}):ue.push(...le.map(({uri:he,name:Te,index:Ne})=>({uri:b.URI.revive(he),name:Te,index:Ne}))),ue.sort((he,Te)=>he.index<Te.index?-1:1);const Z=new O(V,j,ue,!!be,_?b.URI.revive(_):null,!!de,he=>T(he,F)),{added:X,removed:ee}=d(se?se.workspaceFolders:[],Z.workspaceFolders,c,F);return{workspace:Z,added:X,removed:ee}}static o(L,B,P){for(let F=0;F<L.folders.length;F++){const V=L.workspaceFolders[F];if(p(V.uri,B,P))return V}}constructor(L,B,P,F,V,j,le){super(L,P.map(_=>new g.WorkspaceFolder(_)),F,V,le),this.t=B,this.u=j,this.q=[],this.s=R.TernarySearchTree.forUris(le),P.forEach(_=>{this.q.push(_),this.s.set(_.uri,_)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(L,B){return B&&this.s.get(L)&&(L=(0,N.dirname)(L)),this.s.findSubstr(L)}resolveWorkspaceFolder(L){return this.s.get(L)}}let H=class{constructor(L,B,P,F,V){this.c=new M.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new M.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.AsyncEmitter,this.h=F,this.s=P,this.t=V,this.j=new k.Counter,this.k=new C.Barrier,this.o=L.getProxy(i.MainContext.MainThreadWorkspace),this.q=L.getProxy(i.MainContext.MainThreadMessageService);const j=B.workspace;this.l=j?new O(j.id,j.name,[],!!j.transient,j.configuration?b.URI.revive(j.configuration):null,!!j.isUntitled,le=>T(le,P)):void 0}$initializeWorkspace(L,B){this.v=B,this.$acceptWorkspaceData(L),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?b.URI.from({scheme:y.Schemas.untitled,path:(0,N.basename)((0,N.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(!!this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(L,B,P,...F){const V=[];if(Array.isArray(F)&&F.forEach(de=>{b.URI.isUri(de.uri)&&!V.some(ue=>p(ue.uri,de.uri,this.s))&&V.push({uri:de.uri,name:de.name||(0,N.basenameOrAuthority)(de.uri)})}),this.n||[B,P].some(de=>typeof de!="number"||de<0)||P===0&&V.length===0)return!1;const j=this.x?this.x.workspaceFolders:[];if(B+P>j.length)return!1;const le=j.slice(0);le.splice(B,P,...V.map(de=>({uri:de.uri,name:de.name||(0,N.basenameOrAuthority)(de.uri),index:void 0})));for(let de=0;de<le.length;de++){const ue=le[de];if(le.some((se,Z)=>Z!==de&&p(ue.uri,se.uri,this.s)))return!1}le.forEach((de,ue)=>de.index=ue);const{added:_,removed:be}=d(j,le,s,this.s);if(_.length===0&&be.length===0)return!1;if(this.o){const de=L.displayName||L.name;this.o.$updateWorkspaceFolders(de,B,P,V).then(void 0,ue=>{this.n=void 0;const se={source:{identifier:L.identifier,label:L.displayName||L.name}};this.q.$showMessage(l.Severity.Error,(0,m.localize)(0,null,de,ue.toString()),se,[])})}return this.y(le),!0}getWorkspaceFolder(L,B){if(!!this.x)return this.x.getWorkspaceFolder(L,B)}async getWorkspaceFolder2(L,B){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(L,B)}async resolveWorkspaceFolder(L){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(L)}getPath(){if(!this.x)return;const{folders:L}=this.x;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,B){let P,F="";if(typeof L=="string"?(P=b.URI.file(L),F=L):typeof L<"u"&&(P=L,F=L.fsPath),!P)return F;const V=this.getWorkspaceFolder(P,!0);if(!V)return F;typeof B>"u"&&this.x&&(B=this.x.folders.length>1);let j=(0,N.relativePath)(V.uri,P);return B&&V.name&&(j=`${V.name}/${j}`),j}y(L){this.x&&(this.n=O.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:L,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:B,added:P,removed:F}=O.toExtHostWorkspace(L,this.l,this.n,this.s);this.l=B||void 0,this.n=void 0,this.c.fire(Object.freeze({added:P,removed:F}))}findFiles(L,B,P,F,V=D.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let j;if(B===null?j=!1:B&&(typeof B=="string"?j=B:j=B.pattern),V&&V.isCancellationRequested)return Promise.resolve([]);const{includePattern:le,folder:_}=J(t.GlobPattern.from(L));return this.o.$startFileSearch((0,f.withUndefinedAsNull)(le),(0,f.withUndefinedAsNull)(_),(0,f.withUndefinedAsNull)(j),(0,f.withUndefinedAsNull)(P),V).then(be=>Array.isArray(be)?be.map(de=>b.URI.revive(de)):[])}async findTextInFiles(L,B,P,F,V=D.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const j=this.j.getNext(),le=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:_,folder:be}=J(t.GlobPattern.from(B.include)),de=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,ue={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:le,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:_,excludePattern:de},se=!1;if(this.u[j]=Z=>{if(se)return;const X=b.URI.revive(Z.resource);Z.results.forEach(ee=>{(0,u.resultIsMatch)(ee)?P({uri:X,preview:{text:ee.preview.text,matches:(0,n.mapArrayOrNot)(ee.preview.matches,he=>new h.Range(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))},ranges:(0,n.mapArrayOrNot)(ee.ranges,he=>new h.Range(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))}):P({uri:X,text:ee.text,lineNumber:ee.lineNumber})})},V.isCancellationRequested)return{};try{const Z=await this.o.$startTextSearch(L,(0,f.withUndefinedAsNull)(be),ue,j,V);return delete this.u[j],Z||{}}catch(Z){throw delete this.u[j],Z}}$handleTextSearchResult(L,B){this.u[B]?.(L)}saveAll(L){return this.o.$saveAll(L)}resolveProxy(L){return this.o.$resolveProxy(L)}get trusted(){return this.v}requestWorkspaceTrust(L){return this.o.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(L,B){if(this.w.has(L))throw new Error(`A provider has already been registered for scheme ${L}`);this.w.set(L,B);const P=this.t.transformOutgoingScheme(L),F=this.z++;return this.o.$registerEditSessionIdentityProvider(F,P),(0,S.toDisposable)(()=>{this.w.delete(L),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(L,B){this.h.info("Getting edit session identifier for workspaceFolder",L);const P=await this.resolveWorkspaceFolder(b.URI.revive(L));if(!P){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",P);const F=this.w.get(P.uri.scheme);if(this.h.info(`Provider for scheme ${P.uri.scheme} is defined: `,!!F),!F)return;const V=await F.provideEditSessionIdentity(P,B);if(this.h.info("Provider returned edit session identifier: ",V),!!V)return V}async $provideEditSessionIdentityMatch(L,B,P,F){this.h.info("Getting edit session identifier for workspaceFolder",L);const V=await this.resolveWorkspaceFolder(b.URI.revive(L));if(!V){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",V);const j=this.w.get(V.uri.scheme);if(this.h.info(`Provider for scheme ${V.uri.scheme} is defined: `,!!j),!j)return;const le=await j.provideEditSessionIdentityMatch?.(B,P,F);if(this.h.info("Provider returned edit session identifier match result: ",le),!!le)return le}getOnWillCreateEditSessionIdentityEvent(L){return(B,P,F)=>{const V=function(le){B.call(P,le)};return V.extension=L,this.A.event(V,void 0,F)}}async $onWillCreateEditSessionIdentity(L,B,P){const F=await this.resolveWorkspaceFolder(b.URI.revive(L));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:F},B,async(V,j)=>{const le=Date.now();await Promise.resolve(V),Date.now()-le>P&&this.h.warn("SLOW edit session create-participant",j.extension.identifier)}),B.isCancellationRequested}};H=qe([je(0,v.IExtHostRpcService),je(1,A.IExtHostInitDataService),je(2,E.IExtHostFileSystemInfo),je(3,o.ILogService),je(4,r.IURITransformerService)],H),e.ExtHostWorkspace=H,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function J(K){let L,B;return K&&(typeof K=="string"?L=K:(L=K.pattern,B=b.URI.revive(K.baseUri))),{includePattern:L,folder:B}}}),define(Ce[32],ke([1,0,22,4,31,5,7,166,93,9,17,3,18,11,2]),function(te,e,n,C,D,M,S,R,y,k,N,w,f,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function a(h,r){if(r){const u=r.split(".");let i=h;for(let p=0;i&&p<u.length;p++)i=i[u[p]];return i}}function o(h){return h instanceof m.URI}function l(h){return h&&h.uri instanceof m.URI&&h.languageId&&typeof h.languageId=="string"}function g(h){return h&&!h.uri&&h.languageId&&typeof h.languageId=="string"}function E(h){return h&&h.uri instanceof m.URI&&(!h.name||typeof h.name=="string")&&(!h.index||typeof h.index=="number")}function A(h){if(o(h))return{resource:h};if(l(h))return{resource:h.uri,overrideIdentifier:h.languageId};if(g(h))return{overrideIdentifier:h.languageId};if(E(h))return{resource:h.uri};if(h===null)return{resource:null}}let v=class{constructor(r,u,i){this.a=r.getProxy(M.MainContext.MainThreadConfiguration),this.c=u,this.b=i,this.d=new N.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new t(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,u){this.getConfigProvider().then(i=>i.$acceptConfigurationChanged(r,u))}};v=qe([je(0,f.IExtHostRpcService),je(1,D.IExtHostWorkspace),je(2,b.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(r,u,i,p){this.a=new C.Emitter,this.b=r,this.f=p,this.c=u,this.e=R.Configuration.parse(i),this.d=this.k(i.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,u){const i={data:this.e.toData(),workspace:this.c.workspace};this.e=R.Configuration.parse(r),this.d=this.k(r.configurationScopes),this.a.fire(this.j(u,i))}getConfiguration(r,u,i){const p=A(u)||{},c=this.g(r?a(this.e.getValue(void 0,p,this.c.workspace),r):this.e.getValue(void 0,p,this.c.workspace));r&&this.h(r,p,i?.identifier);function s(T){if(T==null)return null;if(typeof T=="boolean")return T?2:5;switch(T){case S.ConfigurationTarget.Global:return 2;case S.ConfigurationTarget.Workspace:return 5;case S.ConfigurationTarget.WorkspaceFolder:return 6}}const d={has(T){return typeof a(c,T)<"u"},get:(T,O)=>{this.h(r?`${r}.${T}`:T,p,i?.identifier);let H=a(c,T);if(typeof H>"u")H=O;else{let J;const K=(L,B)=>{let P;const F=()=>{J=J||(0,n.deepClone)(c),P=P||a(J,B)};return(0,k.isObject)(L)?new Proxy(L,{get:(V,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return F(),()=>P;if(J)return P=P||a(J,B),P[j];const le=V[j];return typeof j=="string"?K(le,`${B}.${j}`):le},set:(V,j,le)=>(F(),P&&(P[j]=le),!0),deleteProperty:(V,j)=>(F(),P&&delete P[j],!0),defineProperty:(V,j,le)=>(F(),P&&Object.defineProperty(P,j,le),!0)}):L};H=K(H,T)}return H},update:(T,O,H,J)=>{T=r?`${r}.${T}`:T;const K=s(H);return O!==void 0?this.b.$updateConfigurationOption(K,T,O,p,J):this.b.$removeConfigurationOption(K,T,p,J)},inspect:T=>{T=r?`${r}.${T}`:T;const O=this.e.inspect(T,p,this.c.workspace);if(O)return{key:T,defaultValue:(0,n.deepClone)(O.policy?.value??O.default?.value),globalValue:(0,n.deepClone)(O.user?.value??O.application?.value),workspaceValue:(0,n.deepClone)(O.workspace?.value),workspaceFolderValue:(0,n.deepClone)(O.workspaceFolder?.value),defaultLanguageValue:(0,n.deepClone)(O.default?.override),globalLanguageValue:(0,n.deepClone)(O.user?.override??O.application?.override),workspaceLanguageValue:(0,n.deepClone)(O.workspace?.override),workspaceFolderLanguageValue:(0,n.deepClone)(O.workspaceFolder?.override),languageIds:(0,n.deepClone)(O.overrideIdentifiers)}}};return typeof c=="object"&&(0,n.mixin)(d,c,!1),Object.freeze(d)}g(r){const u=i=>(0,k.isObject)(i)?new Proxy(i,{get:(p,c)=>u(p[c]),set:(p,c,s)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(p,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(p,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):i;return u(r)}h(r,u,i){const p=y.OVERRIDE_PROPERTY_REGEX.test(r)?4:this.d.get(r),c=i?`[${i.value}] `:"";if(p===4){typeof u?.resource>"u"&&this.f.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){u?.resource&&this.f.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,u){const i=new R.ConfigurationChangeEvent(r,u,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(p,c)=>i.affectsConfiguration(p,A(c))})}k(r){return r.reduce((u,i)=>(u.set(i[0],i[1]),u),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,w.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[107],ke([1,0,2,17,4,5,7,31,57,32,20,60,18,26,3,16,21,11,76,202,12]),function(te,e,n,C,D,M,S,R,y,k,N,w,f,b,m,a,o,l,g,E,A){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(L){function B(F){if(F!=null)return F}L.from=B;function P(F){if(F!=null)return F}L.to=P})(t||(t={}));var h;(function(L){function B(F){if(F!=null)return F}L.from=B;function P(F){if(F!=null)return F}L.to=P})(h||(h={}));var r;(function(L){function B(F){if(F!=null)return F}L.from=B;function P(F){if(F!=null)return F}L.to=P})(r||(r={}));var u;(function(L){function B(V){if(V){const j=V;return j&&!!j.process}else return!1}L.is=B;function P(V){if(V==null)return;const j={process:V.process,args:V.args};return V.options&&(j.options=r.from(V.options)),j}L.from=P;function F(V){if(V!=null)return new S.ProcessExecution(V.process,V.args,V.options)}L.to=F})(u||(u={}));var i;(function(L){function B(F){if(F!=null)return F}L.from=B;function P(F){if(F!=null)return F}L.to=P})(i||(i={}));var p;(function(L){function B(V){if(V){const j=V;return j&&(!!j.commandLine||!!j.command)}else return!1}L.is=B;function P(V){if(V==null)return;const j={};return V.commandLine!==void 0?j.commandLine=V.commandLine:(j.command=V.command,j.args=V.args),V.options&&(j.options=i.from(V.options)),j}L.from=P;function F(V){if(!(V==null||V.command===void 0&&V.commandLine===void 0))return V.commandLine?new S.ShellExecution(V.commandLine,V.options):new S.ShellExecution(V.command,V.args?V.args:[],V.options)}L.to=F})(p||(p={}));var c;(function(L){function B(V){if(V){const j=V;return j&&j.customExecution==="customExecution"}else return!1}L.is=B;function P(V){return{customExecution:"customExecution"}}L.from=P;function F(V,j){return j.get(V)}L.to=F})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var s;(function(L){function B(P,F){let V;return P.scope!==void 0&&typeof P.scope!="number"?V=P.scope.uri:P.scope!==void 0&&typeof P.scope=="number"&&(P.scope===S.TaskScope.Workspace&&F&&F.workspaceFile?V=F.workspaceFile:V=E.USER_TASKS_GROUP_KEY),{id:P._id,workspaceFolder:V}}L.from=B})(s=e.TaskHandleDTO||(e.TaskHandleDTO={}));var d;(function(L){function B(P){if(P!=null)return{_id:P.id,isDefault:P.isDefault}}L.from=B})(d||(d={}));var T;(function(L){function B(V,j){if(V==null)return[];const le=[];for(const _ of V){const be=P(_,j);be&&le.push(be)}return le}L.fromMany=B;function P(V,j){if(V==null)return;let le;V.execution instanceof S.ProcessExecution?le=u.from(V.execution):V.execution instanceof S.ShellExecution?le=p.from(V.execution):V.execution&&V.execution instanceof S.CustomExecution&&(le=c.from(V.execution));const _=t.from(V.definition);let be;return V.scope?typeof V.scope=="number"?be=V.scope:be=V.scope.uri:be=S.TaskScope.Workspace,!_||!be?void 0:{_id:V._id,definition:_,name:V.name,source:{extensionId:j.identifier.value,label:V.source,scope:be},execution:le,isBackground:V.isBackground,group:d.from(V.group),presentationOptions:h.from(V.presentationOptions),problemMatchers:V.problemMatchers,hasDefinedMatchers:V.hasDefinedMatchers,runOptions:V.runOptions?V.runOptions:{reevaluateOnRerun:!0},detail:V.detail}}L.from=P;async function F(V,j,le){if(V==null)return;let _;u.is(V.execution)?_=u.to(V.execution):p.is(V.execution)?_=p.to(V.execution):c.is(V.execution)&&(_=c.to(V._id,le));const be=t.to(V.definition);let de;if(V.source&&(V.source.scope!==void 0?typeof V.source.scope=="number"?de=V.source.scope:de=await j.resolveWorkspaceFolder(n.URI.revive(V.source.scope)):de=S.TaskScope.Workspace),!be||!de)return;const ue=new S.Task(be,de,V.name,V.source.label,_,V.problemMatchers);return V.isBackground!==void 0&&(ue.isBackground=V.isBackground),V.group!==void 0&&(ue.group=S.TaskGroup.from(V.group._id),ue.group&&V.group.isDefault&&(ue.group=new S.TaskGroup(ue.group.id,ue.group.label),V.group.isDefault===!0&&(ue.group.isDefault=V.group.isDefault))),V.presentationOptions&&(ue.presentationOptions=h.to(V.presentationOptions)),V._id&&(ue._id=V._id),V.detail&&(ue.detail=V.detail),ue}L.to=F})(T=e.TaskDTO||(e.TaskDTO={}));var O;(function(L){function B(F){return F}L.from=B;function P(F){if(!!F)return Object.assign(Object.create(null),F)}L.to=P})(O||(O={}));class H{constructor(B,P,F){this._id=P,this.a=F,v.set(this,void 0),Je(this,v,B,"f")}get task(){return this.a}terminate(){Le(this,v,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}v=new WeakMap;let J=class{constructor(B,P,F,V,j,le,_,be){this.q=new D.Emitter,this.r=new D.Emitter,this.s=new D.Emitter,this.t=new D.Emitter,this.a=B.getProxy(M.MainContext.MainThreadTask),this.b=F,this.c=V,this.d=j,this.e=le,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=_,this.g=be,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(B,P,F){if(!F)return new S.Disposable(()=>{});const V=this.w();return this.j.set(V,{type:P,provider:F,extension:B}),this.a.$registerTaskProvider(V,P),new S.Disposable(()=>{this.j.delete(V),this.a.$unregisterTaskProvider(V)})}registerTaskSystem(B,P){this.a.$registerTaskSystem(B,P)}fetchTasks(B){return this.a.$fetchTasks(O.from(B)).then(async P=>{const F=[];for(const V of P){const j=await T.to(V,this.b,this.m);j&&F.push(j)}return F})}get taskExecutions(){const B=[];return this.k.forEach(P=>B.push(P)),B}terminateTask(B){if(!(B instanceof H))throw new Error("No valid task execution provided");return this.a.$terminateTask(B._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(B,P,F){const V=this.m.get(B.id);V&&(this.o.set(B.id,V),this.e.attachPtyToTerminal(P,await V.callback(F))),this.p=B.id,this.q.fire({execution:await this.y(B)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(B){const P=await this.y(B);this.l.delete(B.id),this.k.delete(B.id),this.A(B),this.r.fire({execution:P})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(B){const P=await this.y(B.id);this.s.fire({execution:P,processId:B.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(B){const P=await this.y(B.id);this.t.fire({execution:P,exitCode:B.exitCode})}$provideTasks(B,P){const F=this.j.get(B);if(!F)return Promise.reject(new Error("no handler found"));const V=[],j=(0,C.asPromise)(()=>F.provider.provideTasks(N.CancellationToken.None)).then(le=>this.u(P,V,F,le));return new Promise(le=>{j.then(_=>{Promise.all(V).then(()=>{le(_)})})})}async $resolveTask(B,P){const F=this.j.get(B);if(!F)return Promise.reject(new Error("no handler found"));if(P.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${P.definition.type}] cannot be resolved by provider of type [${F.type}].`);const V=await T.to(P,this.b,this.m);if(!V)throw new Error("Unexpected: Task cannot be resolved.");const j=await F.provider.resolveTask(V,N.CancellationToken.None);if(!j)return;this.z(j,F);const le=T.from(j,F.extension);if(!le)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==V.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(le.execution)&&await this.x(le,j,!0),await this.v(le)}w(){return this.h++}async x(B,P,F){const V=await this.a.$createTaskId(B);!F&&!this.m.has(V)&&(this.n.add(V),this.o.set(V,P.execution)),this.m.set(V,P.execution)}async y(B,P){if(typeof B=="string"){const j=this.l.get(B);if(!j)throw new A.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return j}const F=this.l.get(B.id);if(F)return F;const V=new Promise((j,le)=>{function _(be,de,ue){ue?j(new H(be,de.id,ue)):le("Unexpected: Task does not exist.")}P?_(this,B,P):T.to(B.task,this.b,this.m).then(be=>_(this,B,be))});return this.l.set(B.id,V),V.then(j=>(this.k.set(B.id,j),j),j=>Promise.reject(j))}z(B,P){B._deprecated&&this.g.report("Task.constructor",P.extension,"Use the Task constructor that takes a `scope` instead.")}A(B){this.o.get(B.id)&&this.o.delete(B.id),this.n.has(B.id)&&this.p!==B.id&&(this.m.delete(B.id),this.n.delete(B.id));const F=this.n.values();let V=F.next();for(;!V.done;)!this.o.has(V.value)&&this.p!==V.value&&(this.m.delete(V.value),this.n.delete(V.value)),V=F.next()}};J=qe([je(0,f.IExtHostRpcService),je(1,b.IExtHostInitDataService),je(2,R.IExtHostWorkspace),je(3,y.IExtHostDocumentsAndEditors),je(4,k.IExtHostConfiguration),je(5,w.IExtHostTerminalService),je(6,l.ILogService),je(7,g.IExtHostApiDeprecationService)],J),e.ExtHostTaskBase=J;let K=class extends J{constructor(B,P,F,V,j,le,_,be){super(B,P,F,V,j,le,_,be),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:o.PlatformToString(0)})}async executeTask(B,P){if(!P.execution)throw new Error("Tasks to execute must include an execution");const F=T.from(P,B);if(F===void 0)throw new Error("Task is not valid");if(c.is(F.execution))await this.x(F,P,!1);else throw new A.NotSupportedError;const V=await this.y(await this.a.$getTaskExecution(F),P);return this.a.$executeTask(F).catch(j=>{throw new Error(j)}),V}u(B,P,F,V){const j=[];if(V)for(const le of V){this.z(le,F),(!le.definition||!B[le.definition.type])&&this.f.warn(`The task [${le.source}, ${le.name}] uses an undefined task type. The task will be ignored in the future.`);const _=T.from(le,F.extension);_&&c.is(_.execution)?(j.push(_),P.push(this.x(_,le,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:j,extension:F.extension}}async v(B){if(c.is(B.execution))return B;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(B,P){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,P,F){}};K=qe([je(0,f.IExtHostRpcService),je(1,b.IExtHostInitDataService),je(2,R.IExtHostWorkspace),je(3,y.IExtHostDocumentsAndEditors),je(4,k.IExtHostConfiguration),je(5,w.IExtHostTerminalService),je(6,l.ILogService),je(7,g.IExtHostApiDeprecationService)],K),e.WorkerExtHostTask=K,e.IExtHostTask=(0,m.createDecorator)("IExtHostTask")}),define(Ce[245],ke([1,0,19,20,39,35,24,77,47]),function(te,e,n,C,D,M,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(f,b,m){this.k=f,this.l=b,this.o=m,this.e=!1,this.f=0,this.g=!1,this.a=f.filePattern,this.b=f.includePattern&&M.parse(f.includePattern),this.c=f.maxResults||void 0,this.d=f.exists,this.h=new Set,this.j=f.excludePattern&&M.parse(f.excludePattern)}cancel(){this.g=!0,this.h.forEach(f=>f.cancel()),this.h=new Set}search(f){const b=this.k.folderQueries||[];return new Promise((m,a)=>{const o=l=>{this.f++,f(l)};if(this.g)return m({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(l=>{const g=l.toString(),E=n.basename(g);this.j&&this.j(g,E)||this.v(o,{base:l,basename:E})}),Promise.all(b.map(l=>this.p(l,o))).then(l=>{m({limitHit:this.e,stats:l[0]||void 0})},l=>{a(new Error((0,D.toErrorMessage)(l)))})})}async p(f,b){const m=new C.CancellationTokenSource,a=this.q(f),o=this.r(),l=new y.QueryGlobTester(this.k,f),g=!l.hasSiblingExcludeClauses();let E;try{this.h.add(m),E=R.StopWatch.create();const A=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},a,m.token),v=E.elapsed(),t=R.StopWatch.create();return this.g&&!this.e||(A&&A.forEach(h=>{const r=n.posix.relative(f.folder.path,h.path);if(g){const u=n.basename(h.path);this.v(b,{base:f.folder,relativePath:r,basename:u});return}this.s(o,f.folder,r,b)}),this.g&&!this.e)?null:(this.u(o,l,b),{providerTime:v,postProcessTime:t.elapsed()})}finally{m.dispose(),this.h.delete(m)}}q(f){const b=(0,y.resolvePatternsForProvider)(this.k.includePattern,f.includePattern),m=(0,y.resolvePatternsForProvider)(this.k.excludePattern,f.excludePattern);return{folder:f.folder,excludes:m,includes:b,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}s({pathToEntries:f},b,m,a){if(m===this.a){const l=n.basename(this.a);this.v(a,{base:b,relativePath:this.a,basename:l})}function o(l){const g=n.basename(l),E=n.dirname(l);let A=f[E];A||(A=f[E]=[],o(E)),A.push({base:b,relativePath:l,basename:g})}o(m)}u({rootEntries:f,pathToEntries:b},m,a){const o=this,l=this.a;function g(E){const A=(0,y.hasSiblingFn)(()=>E.map(v=>v.basename));for(let v=0,t=E.length;v<t;v++){const h=E[v],{relativePath:r,basename:u}=h;if(m.matchesExcludesSync(r,u,l!==u?A:void 0))continue;const i=b[r];if(i)g(i);else{if(r===l)continue;o.v(a,h)}if(o.e)break}}g(f)}v(f,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||f(b))}}class N{constructor(){this.b=new Map}fileSearch(f,b,m,a){const o=this.c(f.cacheKey),l=new k(f,b,o&&o.token);let g=0;const E=A=>{g+=A.length,m(A.map(v=>this.d(v)))};return this.e(l,N.a,E,a).then(A=>({limitHit:A.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:g,detailStats:A.stats}}))}clearCache(f){this.c(f)?.cancel()}c(f){if(!!f)return this.b.has(f)||this.b.set(f,new C.CancellationTokenSource),this.b.get(f)}d(f){return f.relativePath?{resource:S.joinPath(f.base,f.relativePath)}:{resource:f.base}}e(f,b,m,a){a.onCancellationRequested(()=>{f.cancel()});const o=g=>{g&&(l.push(g),b>0&&l.length>=b&&(m(l),l=[]))};let l=[];return f.search(o).then(g=>(l.length&&m(l),g),g=>(l.length&&m(l),Promise.reject(g)))}}N.a=512,e.FileSearchManager=N}),define(Ce[246],ke([1,0,15,62,35,87,28,16,19,24,10,9,2,262,155,41,11,53,97,244,47]),function(te,e,n,C,D,M,S,R,y,k,N,w,f,b,m,a,o,l,g,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let v=class{constructor(d,T,O,H,J){this.a=d,this.b=T,this.c=O,this.d=H,this.e=J}text(d,T,O={}){d=this.f(d,O);const H=this.a.getValue(),J=T&&T.some(L=>!this.a.getValue({resource:L}).search.useRipgrep);return{...this.h(T?.map(l.toWorkspaceFolder),O),type:2,contentPattern:d,previewOptions:O.previewOptions,maxFileSize:O.maxFileSize,usePCRE2:H.search.usePCRE2||J||!1,beforeContext:O.beforeContext,afterContext:O.afterContext,userDisabledExcludesAndIgnoreFiles:O.disregardExcludeSettings&&O.disregardIgnoreFiles}}f(d,T){const O=this.a.getValue();d.isRegExp&&(d.pattern=d.pattern.replace(/\r?\n/g,"\\n"));const H={...d,wordSeparators:O.editor.wordSeparators};return this.j(d,T)&&(H.isCaseSensitive=!0),this.k(d)&&(H.isMultiline=!0),H}file(d,T={}){return{...this.h(d,T),type:1,filePattern:T.filePattern?T.filePattern.trim():T.filePattern,exists:T.exists,sortByScore:T.sortByScore,cacheKey:T.cacheKey}}g(d,T){return d?(d=Array.isArray(d)?d.map(i):i(d),T?this.parseSearchPaths(d):{pattern:h(...Array.isArray(d)?d:[d])}):{}}h(d=[],T={}){const O=this.g(T.includePattern,T.expandPatterns),H=this.g(T.excludePattern,T.expandPatterns),J=d.length>1,K=(O.searchPaths&&O.searchPaths.length?O.searchPaths.map(P=>this.q(P,T,H)):d.map(P=>this.r(P,T,H,J))).filter(P=>!!P),L={_reason:T._reason,folderQueries:K,usingSearchPaths:!!(O.searchPaths&&O.searchPaths.length),extraFileResources:T.extraFileResources,excludePattern:H.pattern,includePattern:O.pattern,onlyOpenEditors:T.onlyOpenEditors,maxResults:T.maxResults};if(T.onlyOpenEditors){const P=n.coalesce(n.flatten(this.c.groups.map(j=>j.editors.map(le=>le.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(P));const F=P.filter(j=>(0,A.pathIncludedInQuery)(L,j.fsPath)),V=this.i(F);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(V)),{...L,...V}}const B=T.extraFileResources&&T.extraFileResources.filter(P=>(0,A.pathIncludedInQuery)(L,P.fsPath));return L.extraFileResources=B&&B.length?B:void 0,L}i(d){const T=[],O=new S.ResourceMap,H={};let J=!1;return d.forEach(K=>{if(K.scheme===R.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(K)){const B=this.b.getWorkspaceFolder(K)?.uri??K.with({path:y.dirname(K.fsPath)});let P=O.get(B);P||(J=!0,P={folder:B,includePattern:{}},T.push(P),O.set(B,P));const F=y.relative(B.fsPath,K.fsPath);(0,w.assertIsDefined)(P.includePattern)[F.replace(/\\/g,"/")]=!0}else K.fsPath&&(J=!0,H[K.fsPath]=!0)}),{folderQueries:T,includePattern:H,usingSearchPaths:!0,excludePattern:J?void 0:{"**/*":!0}}}j(d,T){if(T.isSmartCase){if(d.isRegExp){if(N.containsUppercaseCharacter(d.pattern,!0))return!0}else if(N.containsUppercaseCharacter(d.pattern))return!0}return!!d.isCaseSensitive}k(d){return d.isMultiline||d.isRegExp&&(0,b.isMultilineRegexSource)(d.pattern)||d.pattern.indexOf(`
`)>=0?!0:!!d.isMultiline}parseSearchPaths(d){const T=V=>y.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),H=(Array.isArray(d)?d:r(d)).map(V=>{const j=this.e.resolvedUserHome;return j?(0,M.untildify)(V,j.scheme===R.Schemas.file?j.fsPath:j.path):V}),J=C.groupBy(H,V=>T(V)?"searchPaths":"exprSegments"),K=(J.exprSegments||[]).map(V=>N.rtrim(V,"/")).map(V=>N.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),u(V))),L={},B=this.m(J.searchPaths||[]);B&&B.length&&(L.searchPaths=B);const P=n.flatten(K),F=h(...P);return F&&(L.pattern=F),L}l(d,T){return T.disregardExcludeSettings?void 0:(0,A.getExcludes)(d,!T.disregardSearchExcludeSettings)}m(d){if(!d||!d.length)return[];const T=d.flatMap(H=>{let{pathPortion:J,globPortion:K}=t(H);return K&&(K=p(K)),this.n(J).flatMap(B=>this.o(B,K))}),O=new Map;return T.forEach(H=>{const J=H.searchPath.toString(),K=O.get(J);K?H.pattern&&(K.pattern=K.pattern||{},K.pattern[H.pattern]=!0):O.set(J,{searchPath:H.searchPath,pattern:H.pattern?h(H.pattern):void 0})}),Array.from(O.values())}n(d){if(y.isAbsolute(d)){const T=this.b.getWorkspace().folders;return T[0]&&T[0].uri.scheme!==R.Schemas.file?[{searchPath:T[0].uri.with({path:d})}]:[{searchPath:f.URI.file(y.normalize(d))}]}if(this.b.getWorkbenchState()===2){const T=this.b.getWorkspace().folders[0].uri;if(d=i(d),d.startsWith("../")||d===".."){const H=y.posix.resolve(T.path,d);return[{searchPath:T.with({path:H})}]}const O=p(d);return[{searchPath:T,pattern:O}]}else{if(d==="./"||d===".\\")return[];{const T=d.replace(/^\.[\/\\]/,""),H=this.b.getWorkspace().folders.map(J=>{const K=T.match(new RegExp(`^${N.escapeRegExpCharacters(J.name)}(?:/(.*)|$)`));return K?{match:K,folder:J}:null}).filter(w.isDefined);if(H.length)return H.map(J=>{const K=J.match[1];return{searchPath:J.folder.uri,pattern:K&&p(K)}});{const J=d.match(/\.[\/\\](.+)[\/\\]?/),K=J?J[1]:d,L=m.localize(0,null,K);throw new Error(L)}}}}o(d,T){const O=d.pattern&&T?`${d.pattern}/${T}`:d.pattern||T,H=[{searchPath:d.searchPath,pattern:O}];return O&&!O.endsWith("**")&&H.push({searchPath:d.searchPath,pattern:O+"/**"}),H}q(d,T,O){const H=this.r((0,l.toWorkspaceFolder)(d.searchPath),T,O,!1);return H?{...H,includePattern:d.pattern}:null}r(d,T,O,H){let J;const K=f.URI.isUri(d)?d:d.uri;if(O.searchPaths){const V=O.searchPaths.filter(j=>(0,k.isEqual)(j.searchPath,K))[0];if(V&&!V.pattern)return null;V&&(J=V.pattern)}const L=this.a.getValue({resource:K}),P={...this.l(L,T)||{},...J||{}},F=f.URI.isUri(d)?(0,k.basename)(d):d.name;return{folder:K,folderName:H?F:void 0,excludePattern:Object.keys(P).length>0?P:void 0,fileEncoding:L.files&&L.files.encoding,disregardIgnoreFiles:typeof T.disregardIgnoreFiles=="boolean"?T.disregardIgnoreFiles:!L.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof T.disregardGlobalIgnoreFiles=="boolean"?T.disregardGlobalIgnoreFiles:!L.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof T.disregardParentIgnoreFiles=="boolean"?T.disregardParentIgnoreFiles:!L.search.useParentIgnoreFiles,ignoreSymlinks:typeof T.ignoreSymlinks=="boolean"?T.ignoreSymlinks:!L.search.followSymlinks}}};v=qe([je(0,a.IConfigurationService),je(1,l.IWorkspaceContextService),je(2,g.IEditorGroupsService),je(3,o.ILogService),je(4,E.IPathService)],v),e.QueryBuilder=v;function t(s){const d=s.match(/[\*\{\}\(\)\[\]\?]/);if(d){const T=d.index,O=s.substr(0,T).match(/[/|\\][^/\\]*$/);if(O){let H=s.substr(0,O.index);return H.match(/[/\\]/)||(H+="/"),{pathPortion:H,globPortion:s.substr((O.index||0)+1)}}}return{pathPortion:s}}function h(...s){return s.length?s.reduce((d,T)=>(d[T]=!0,d),Object.create(null)):void 0}function r(s){return D.splitGlobAware(s,",").map(d=>d.trim()).filter(d=>!!d.length)}function u(s){return[`**/${s}/**`,`**/${s}`].map(T=>T.replace(/\*\*\/\*\*/g,"**"))}function i(s){return s.replace(/\\/g,"/")}function p(s){return i(s).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(s,d){s=n.distinct(s,H=>H.toString());const T=[],O=d.getWorkspace();return s&&s.forEach(H=>{let J;if(d.getWorkbenchState()===2)J=(0,k.relativePath)(O.folders[0].uri,H),J&&J!=="."&&(J="./"+J);else{const K=d.getWorkspaceFolder(H);if(K){const L=K.name;if(O.folders.filter(P=>P.name===L).length===1){const P=(0,k.relativePath)(K.uri,H);P===""?J=`./${K.name}`:J=`./${K.name}/${P}`}else J=H.fsPath}}J&&T.push(J)}),T}e.resolveResourcesForSearchIncludes=c}),define(Ce[247],ke([1,0,24,2,20,12,3,246,47,53]),function(te,e,n,C,D,M,S,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const N=7e3;function w(a,o){const l=o.activationEvents;if(!l)return Promise.resolve(void 0);const g=[],E=[];for(const u of l)if(/^workspaceContains:/.test(u)){const i=u.substr(18);i.indexOf("*")>=0||i.indexOf("?")>=0||a.forceUsingSearch?E.push(i):g.push(i)}if(g.length===0&&E.length===0)return Promise.resolve(void 0);let A;const v=new Promise((u,i)=>{A=u}),t=u=>A({activationEvent:u}),h=Promise.all(g.map(u=>f(a,u,t))).then(()=>{}),r=b(a,o.identifier,E,t);return Promise.all([h,r]).then(()=>{A(void 0)}),v}e.checkActivateWorkspaceContainsExtension=w;async function f(a,o,l){for(const g of a.folders)if(await a.exists(n.joinPath(C.URI.revive(g),o))){l(`workspaceContains:${o}`);return}}async function b(a,o,l,g){if(l.length===0)return Promise.resolve(void 0);const E=new D.CancellationTokenSource,A=a.checkExists(a.folders,l,E.token),v=setTimeout(async()=>{E.cancel(),a.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${l.join(",")}`)},N);let t=!1;try{t=await A}catch(h){M.isCancellationError(h)||M.onUnexpectedError(h)}E.dispose(),clearTimeout(v),t&&g(`workspaceContains:${l.join(",")}`)}function m(a,o,l,g){const E=a.get(S.IInstantiationService),A=a.get(y.ISearchService),t=E.createInstance(R.QueryBuilder).file(o.map(h=>(0,k.toWorkspaceFolder)(C.URI.revive(h))),{_reason:"checkExists",includePattern:l,exists:!0});return A.fileSearch(t,g).then(h=>!!h.limitHit,h=>M.isCancellationError(h)?!1:Promise.reject(h))}e.checkGlobFileExists=m});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[33],ke([1,0,140,19,82,24,17,6,48,2,11,5,32,192,80,31,27,98,12,25,23,177,7,94,3,26,81,18,67,69,60,4,247,79,179,16,78,77]),function(te,e,n,C,D,M,S,R,y,k,N,w,f,b,m,a,o,l,g,E,A,v,t,h,r,u,i,p,c,s,d,T,O,H,J,K,L,B){"use strict";var P,F,V;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let j=class Ui extends R.Disposable{constructor(se,Z,X,ee,he,Te,Ne,Ke,Pe,Se,Ie){super(),this.a=this.B(new T.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=Z,this.g=X,this.f=Ne,this.j=ee,this.k=he,this.l=Te,this.m=Pe,this.p=Se,this.s=Ie,this.t=this.g.getProxy(w.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(w.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(w.MainContext.MainThreadExtensionService),this.w=new S.Barrier,this.y=new S.Barrier,this.z=new S.Barrier,this.C=new S.Barrier,this.F=new l.ExtensionDescriptionRegistry(this.f.allExtensions);const oe=(0,o.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new l.ExtensionDescriptionRegistry(be(this.F,oe)),this.G=new m.ExtHostStorage(this.g,this.l),this.H=new H.ExtHostSecretState(this.g),this.I=Ke,this.h=se.createChild(new c.ServiceCollection([m.IExtHostStorage,this.G],[H.IExtHostSecretState,this.H])),this.J=this.B(new b.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(ce,Y,I)=>{this.v.$onExtensionActivationError(ce,g.transformErrorForSerialization(Y),I)},actualActivateExtension:async(ce,Y)=>{if(l.ExtensionDescriptionRegistry.isHostExtension(ce,this.D,this.F))return await this.v.$activateExtension(ce,Y),new b.HostExtension;const I=this.D.getExtensionDescription(ce);return this.Y(I,Y)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),D.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(se){g.onUnexpectedError(se)}}async Q(){this.I.onWillDeactivateAll();let se=[];try{se=this.D.getAllExtensionDescriptions().map(he=>he.identifier).filter(he=>this.isActivated(he)).map(he=>this.X(he))}catch{}await Promise.all(se)}terminate(se,Z=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${se}`),this.l.flush(),this.p.dispose(),this.J.dispose(),g.setUnexpectedErrorHandler(ee=>{this.l.error(ee)}),this.g.dispose();const X=this.Q();Promise.race([(0,S.timeout)(5e3),X]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${Z}`):this.l.info(`Extension host exiting with code ${Z}`),this.l.flush(),this.l.dispose(),this.c.exit(Z)})}isActivated(se){return this.z.isOpen()?this.J.isActivated(se):!1}async getExtension(se){const Z=await this.v.$getExtension(se);let X;if(Z?.browserNlsBundleUris){X={};for(const ee of Object.keys(Z.browserNlsBundleUris))X[ee]=k.URI.revive(Z.browserNlsBundleUris[ee])}return Z&&{...Z,identifier:new E.ExtensionIdentifier(Z.identifier.value),extensionLocation:k.URI.revive(Z.extensionLocation),browserNlsBundleUris:X}}R(se,Z){return this.J.activateByEvent(se,Z)}S(se,Z){return this.J.activateById(se,Z)}activateByIdWithErrors(se,Z){return this.S(se,Z).then(()=>{const X=this.J.getActivatedExtension(se);if(X.activationFailed)return Promise.reject(X.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(se=>this.D)}getExtensionExports(se){return this.z.isOpen()?this.J.getActivatedExtension(se).exports:null}async U(se){if(se.scheme!==K.Schemas.file)return se;const Z=await this.c.realpath(se.fsPath);return k.URI.file(Z)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(se=>new de(se))),this.L}async W(se){const Z=y.TernarySearchTree.forUris(X=>M.extUriBiasedIgnorePathCase.ignorePathCasing(X));return await Promise.all(se.map(async X=>{if(this.ob(X)){const ee=await this.U(X.extensionLocation);Z.set(ee,X)}})),Z}X(se){let Z=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(se))return Z;const X=this.J.getActivatedExtension(se);if(!X)return Z;try{typeof X.module.deactivate=="function"&&(Z=Promise.resolve(X.module.deactivate()).then(void 0,ee=>(this.l.error(ee),Promise.resolve(void 0))))}catch(ee){this.l.error(`An error occurred when deactivating the extension '${se.value}':`),this.l.error(ee)}try{(0,R.dispose)(X.subscriptions)}catch(ee){this.l.error(`An error occurred when deactivating the subscriptions for extension '${se.value}':`),this.l.error(ee)}return Z}async Y(se,Z){return this.f.remote.isRemote?this.v.$onWillActivateExtension(se.identifier):await this.v.$onWillActivateExtension(se.identifier),this.ab(se,Z).then(X=>{const ee=X.activationTimes;return this.v.$onDidActivateExtension(se.identifier,ee.codeLoadingTime,ee.activateCallTime,ee.activateResolvedTime,Z),this.Z(se,Z,"success",ee),X},X=>{throw this.Z(se,Z,"failure"),X})}Z(se,Z,X,ee){const he=le(se,Z);this.u.$publicLog2("extensionActivationTimes",{...he,...ee||{},outcome:X})}ab(se,Z){const X=le(se,Z);this.u.$publicLog2("activatePlugin",X);const ee=this.ob(se);if(!ee)return Promise.resolve(new b.EmptyExtension(b.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${se.identifier.value}, startup: ${Z.startup}, activationEvent: '${Z.activationEvent}'${se.identifier.value!==Z.extensionId.value?`, root cause: ${Z.extensionId.value}`:""}`),this.l.flush();const he=new b.ExtensionActivationTimesBuilder(Z.startup);return Promise.all([this.pb(se,(0,M.joinPath)(se.extensionLocation,ee),he),this.bb(se)]).then(Te=>(D.mark(`code/extHost/willActivateExtension/${se.identifier.value}`),Ui.cb(this.l,se.identifier,Te[0],Te[1],he))).then(Te=>(D.mark(`code/extHost/didActivateExtension/${se.identifier.value}`),Te))}bb(se){const Z=new v.ExtensionGlobalMemento(se,this.G),X=new v.ExtensionMemento(se.identifier.value,!1,this.G),ee=new J.ExtensionSecrets(se,this.H),he=se.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Te=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${se.identifier.value}`),Promise.all([Z.whenReady,X.whenReady,this.I.whenReady]).then(()=>{const Ne=this;let Ke,Pe;const Se=(0,o.isProposedApiEnabled)(se,"ipc")?this.f.messagePorts?.get(E.ExtensionIdentifier.toKey(se.identifier)):void 0;return Object.freeze({globalState:Z,workspaceState:X,secrets:ee,subscriptions:[],get extensionUri(){return se.extensionLocation},get extensionPath(){return se.extensionLocation.fsPath},asAbsolutePath(Ie){return C.join(se.extensionLocation.fsPath,Ie)},get storagePath(){return Ne.I.workspaceValue(se)?.fsPath},get globalStoragePath(){return Ne.I.globalValue(se).fsPath},get logPath(){return C.join(Ne.f.logsLocation.fsPath,se.identifier.value)},get logUri(){return k.URI.joinPath(Ne.f.logsLocation,se.identifier.value)},get storageUri(){return Ne.I.workspaceValue(se)},get globalStorageUri(){return Ne.I.globalValue(se)},get extensionMode(){return he},get extension(){return Ke===void 0&&(Ke=new _(Ne,se.identifier,se,Te,!1)),Ke},get extensionRuntime(){return(0,o.checkProposedApiEnabled)(se,"extensionRuntime"),Ne.extensionRuntime},get environmentVariableCollection(){return Ne.p.getEnvironmentVariableCollection(se)},get messagePassingProtocol(){if(!Pe){if(!Se)return;const Ie=T.Event.buffer(T.Event.fromDOMEventEmitter(Se,"message",oe=>oe.data));Se.start(),Pe={onDidReceiveMessage:Ie,postMessage:Se.postMessage.bind(Se)}}return Pe}})})}static cb(se,Z,X,ee,he){return X=X||{activate:void 0,deactivate:void 0},this.db(se,Z,X,ee,he).then(Te=>new b.ActivatedExtension(!1,null,he.build(),X,Te,ee.subscriptions))}static db(se,Z,X,ee,he){if(typeof X.activate=="function")try{he.activateCallStart(),se.trace(`ExtensionService#_callActivateOptional ${Z.value}`);const Te=typeof global=="object"?global:self,Ne=X.activate.apply(Te,[ee]);return he.activateCallStop(),he.activateResolveStart(),Promise.resolve(Ne).then(Ke=>(he.activateResolveStop(),Ke))}catch(Te){return Promise.reject(Te)}else return Promise.resolve(X)}eb(se,Z){this.S(se.identifier,{startup:!1,extensionId:se.identifier,activationEvent:Z}).then(void 0,X=>{this.l.error(X)})}fb(){this.v.$setPerformanceMarks(D.getMarks());for(const se of this.D.getAllExtensionDescriptions())if(se.activationEvents)for(const Z of se.activationEvents)Z==="onStartupFinished"&&this.eb(se,Z)}gb(){const se=this.R("*",!0).then(void 0,he=>{this.l.error(he)});this.B(this.j.onDidChangeWorkspace(he=>this.hb(he.added)));const Z=this.j.workspace?this.j.workspace.folders:[],X=this.hb(Z),ee=Promise.all([se,X]).then(()=>{});return Promise.race([ee,(0,S.timeout)(1e4)]).then(()=>{this.fb()}),ee}hb(se){return se.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(Z=>this.ib(se,Z))).then(()=>{})}async ib(se,Z){if(this.isActivated(Z.identifier))return;const X=!this.f.remote.isRemote&&!!this.f.remote.authority,ee={logService:this.l,folders:se.map(Te=>Te.uri),forceUsingSearch:X,exists:Te=>this.c.exists(Te.fsPath),checkExists:(Te,Ne,Ke)=>this.t.$checkExists(Te,Ne,Ke)},he=await(0,O.checkActivateWorkspaceContainsExtension)(ee,Z);if(!!he)return this.S(Z.identifier,{startup:!0,extensionId:Z.identifier,activationEvent:he.activationEvent}).then(void 0,Te=>this.l.error(Te))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(se){throw console.error(se),se}}async jb(){const{extensionDevelopmentLocationURI:se,extensionTestsLocationURI:Z}=this.f.environment;if(!se||!Z)throw new Error(n.localize(0,null));const X=await this.pb(null,Z,new b.ExtensionActivationTimesBuilder(!1));if(!X||typeof X.run!="function")throw new Error(n.localize(1,null,Z.toString()));return new Promise((ee,he)=>{const Te=(Pe,Se)=>{Pe?he(Pe):ee(typeof Se=="number"&&Se>0?1:0)},Ne=(0,M.originalFSPath)(Z),Ke=X.run(Ne,Te);Ke&&Ke.then&&Ke.then(()=>{ee(0)}).catch(Pe=>{he(Pe instanceof Error&&Pe.stack?Pe.stack:String(Pe))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(se,Z){return this.M[se]=Z,(0,R.toDisposable)(()=>{delete this.M[se]})}async lb(se){const Z=se.indexOf("+");if(Z===-1)throw new Error("Not an authority that can be resolved!");const X=se.substr(0,Z);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${X}`,!1),{authorityPrefix:X,resolver:this.M[X]}}async $resolveAuthority(se,Z){const X=B.StopWatch.create(!1),ee=()=>`[resolveAuthority(${(0,h.getRemoteAuthorityPrefix)(se)},${Z})][${X.elapsed()}ms] `,he=Se=>this.l.info(`${ee()}${Se}`),Te=(Se,Ie=void 0)=>this.l.error(`${ee()}${Se}`,Ie);he("activating resolver...");const{authorityPrefix:Ne,resolver:Ke}=await this.lb(se);if(!Ke)return Te("no resolver"),{type:"error",error:{code:h.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Ne}.`,detail:void 0}};const Pe=new S.IntervalTimer;try{he("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(Ke)),Pe.cancelAndSet(()=>he("waiting..."),1e3),he("invoking resolve()..."),D.mark(`code/extHost/willResolveAuthority/${Ne}`);const Se=await Ke.resolve(se,{resolveAttempt:Z});D.mark(`code/extHost/didResolveAuthorityOK/${Ne}`),Pe.dispose(),he(`returned ${Se.host}:${Se.port}`);const Ie={authority:se,host:Se.host,port:Se.port,connectionToken:Se.connectionToken},oe={extensionHostEnv:Se.extensionHostEnv,isTrusted:Se.isTrusted,authenticationSession:Se.authenticationSessionForInitializingExtensions?{id:Se.authenticationSessionForInitializingExtensions.id,providerId:Se.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Ie,options:oe,tunnelInformation:{environmentTunnels:Se.environmentTunnels,features:Se.tunnelFeatures}}}}catch(Se){if(D.mark(`code/extHost/didResolveAuthorityError/${Ne}`),Pe.dispose(),Te("returned an error",Se),Se instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Se._code,message:Se._message,detail:Se._detail}};throw Se}}async $getCanonicalURI(se,Z){this.l.info(`$getCanonicalURI invoked for authority (${(0,h.getRemoteAuthorityPrefix)(se)})`);const{resolver:X}=await this.lb(se);if(!X)return null;const ee=k.URI.revive(Z);if(typeof X.getCanonicalURI>"u")return ee;const he=await(0,S.asPromise)(()=>X.getCanonicalURI(ee));return he||ee}static mb(se,Z,X){const ee=new l.ExtensionDescriptionRegistry(se.getAllExtensionDescriptions());ee.deltaExtensions(X.toAdd,X.toRemove);const he=(0,o.extensionIdentifiersArrayToSet)(Z.getAllExtensionDescriptions().map(Ne=>Ne.identifier));for(const Ne of X.myToRemove)he.delete(E.ExtensionIdentifier.toKey(Ne));for(const Ne of X.myToAdd)he.add(E.ExtensionIdentifier.toKey(Ne));const Te=be(ee,he);return{globalRegistry:ee,myExtensions:Te}}$startExtensionHost(se){se.toAdd.forEach(ee=>ee.extensionLocation=k.URI.revive(ee.extensionLocation));const{globalRegistry:Z,myExtensions:X}=Ui.mb(this.F,this.D,se);return this.F.set(Z.getAllExtensionDescriptions()),this.D.set(X),this.kb()}$activateByEvent(se,Z){return Z===1?this.R(se,!1):this.z.wait().then(X=>this.R(se,!1))}async $activate(se,Z){return await this.z.wait(),this.D.getExtensionDescription(se)?(await this.S(se,Z),!0):!1}async $deltaExtensions(se){se.toAdd.forEach(Te=>Te.extensionLocation=k.URI.revive(Te.extensionLocation));const{globalRegistry:Z,myExtensions:X}=Ui.mb(this.F,this.D,se),ee=await this.W(X);return(await this.getExtensionPathIndex()).setSearchTree(ee),this.F.set(Z.getAllExtensionDescriptions()),this.D.set(X),Promise.resolve(void 0)}async $test_latency(se){return se}async $test_up(se){return se.byteLength}async $test_down(se){const Z=A.VSBuffer.alloc(se),X=Math.random()%256;for(let ee=0;ee<se;ee++)Z.writeUInt8(X,ee);return Z}async $updateRemoteConnectionData(se){this.P=se,this.a.fire()}};j=qe([je(0,r.IInstantiationService),je(1,e.IHostUtils),je(2,p.IExtHostRpcService),je(3,a.IExtHostWorkspace),je(4,f.IExtHostConfiguration),je(5,N.ILogService),je(6,u.IExtHostInitDataService),je(7,i.IExtensionStoragePaths),je(8,s.IExtHostTunnelService),je(9,d.IExtHostTerminalService),je(10,L.IExtHostLocalizationService)],j),e.AbstractExtHostExtensionService=j;function le(ue,se){return{id:ue.identifier.value,name:ue.name,extensionVersion:ue.version,publisherDisplayName:ue.publisher,activationEvents:ue.activationEvents?ue.activationEvents.join(","):null,isBuiltin:ue.isBuiltin,reason:se.activationEvent,reasonId:se.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class _{constructor(se,Z,X,ee,he){P.set(this,void 0),F.set(this,void 0),V.set(this,void 0),Je(this,P,se,"f"),Je(this,F,Z,"f"),Je(this,V,X.identifier,"f"),this.id=X.identifier.value,this.extensionUri=X.extensionLocation,this.extensionPath=C.normalize((0,M.originalFSPath)(X.extensionLocation)),this.packageJSON=X,this.extensionKind=ee,this.isFromDifferentExtensionHost=he}get isActive(){return Le(this,P,"f").isActivated(Le(this,V,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Le(this,P,"f").getExtensionExports(Le(this,V,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Le(this,P,"f").activateByIdWithErrors(Le(this,V,"f"),{startup:!1,extensionId:Le(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=_,P=new WeakMap,F=new WeakMap,V=new WeakMap;function be(ue,se){return ue.getAllExtensionDescriptions().filter(Z=>se.has(E.ExtensionIdentifier.toKey(Z.identifier)))}class de{constructor(se){this.a=se}setSearchTree(se){this.a=se}findSubstr(se){return this.a.findSubstr(se)}forEach(se){return this.a.forEach(se)}}e.ExtensionPaths=de}),define(Ce[248],ke([1,0,82,2,5,32,27,25,18,26,3,33,51,11,10]),function(te,e,n,C,D,M,S,R,y,k,N,w,f,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(v,t,h,r,u,i,p){this.c=v,this.d=t,this.e=h,this.f=r,this.g=u,this.h=i,this.i=p,this.a=new Map,this.b=[]}async install(){this.j(),n.mark("code/extHost/willWaitForConfig");const v=await this.f.getConfigProvider();n.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new l(this.c,t,this.d,v,this.i)),this.register(this.e.createInstance(g,t)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(E,t,this.h.environment.appUriScheme))}register(v){if("nodeModuleName"in v)if(Array.isArray(v.nodeModuleName))for(const t of v.nodeModuleName)this.a.set(t,v);else this.a.set(v.nodeModuleName,v);typeof v.alternativeModuleName=="function"&&this.b.push(t=>v.alternativeModuleName(t))}};a=qe([je(2,N.IInstantiationService),je(3,M.IExtHostConfiguration),je(4,w.IExtHostExtensionService),je(5,k.IExtHostInitDataService),je(6,b.ILogService)],a),e.RequireInterceptor=a;let o=class rn{constructor(v){if(v.environment.appRoot&&rn.a.size){const t=(0,m.escapeRegExpCharacters)(this.c(v.environment.appRoot.fsPath)),h="[a-z0-9_.-]",r=`@${h}+\\/${h}+|${h}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${u}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(v){if(!this.b)return;const t=this.b.exec(this.c(v));if(!t)return;const[,h,r,u]=t,i=rn.a.get(r);if(i!==void 0)return console.warn(`${r} as been renamed to ${i}, please update your imports`),h+i+u}c(v){return v.replace(/\\/g,"/")}};o.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),o=qe([je(0,k.IExtHostInitDataService)],o);class l{constructor(v,t,h,r,u){this.c=v,this.d=t,this.e=h,this.f=r,this.g=u,this.nodeModuleName="vscode",this.a=new Map}load(v,t){const h=this.d.findSubstr(t);if(h){let r=this.a.get(R.ExtensionIdentifier.toKey(h.identifier));return r||(r=this.c(h,this.e,this.f),this.a.set(R.ExtensionIdentifier.toKey(h.identifier),r)),r}if(!this.b){let r="";this.d.forEach((u,i)=>r+=`	${i} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${r}`),this.b=this.c(S.nullExtensionDescription,this.e,this.f)}return this.b}}let g=class{constructor(v,t,h){this.d=v,this.nodeModuleName="keytar",this.a=t.getProxy(D.MainContext.MainThreadTelemetry);const{environment:r}=h,u=t.getProxy(D.MainContext.MainThreadKeytar);if(r.appRoot){let i=r.appRoot.fsPath;f.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.b=new Set,this.b.add(`${i}/node_modules.asar/keytar`),this.b.add(`${i}/node_modules/keytar`)}this.c={getPassword:(i,p)=>u.$getPassword(i,p),setPassword:(i,p,c)=>u.$setPassword(i,p,c),deletePassword:(i,p)=>u.$deletePassword(i,p),findPassword:i=>u.$findPassword(i),findCredentials(i){return u.$findCredentials(i)}}}load(v,t){const h=this.d.findSubstr(t);return this.a.$publicLog2("shimming.keytar",{extension:h?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(v){const t=v.length;if(t<=7||!this.b)return;const h=t-7;if((v.charAt(h)==="/"||v.charAt(h)==="\\")&&v.endsWith("keytar")&&(v=v.replace(/\\/g,"/"),this.b.has(v)))return"keytar"}};g=qe([je(1,y.IExtHostRpcService),je(2,k.IExtHostInitDataService)],g);let E=class{constructor(v,t,h){this.e=v,this.f=t,this.nodeModuleName=["open","opn"],this.d=h.getProxy(D.MainContext.MainThreadTelemetry);const r=h.getProxy(D.MainContext.MainThreadWindow);this.c=(u,i)=>{const p=C.URI.parse(u);return i?this.g(u,i):p.scheme==="http"||p.scheme==="https"?r.$openUri(p,u,{allowTunneling:!0}):p.scheme==="mailto"||p.scheme===this.f?r.$openUri(p,u,{}):this.g(u,i)}}load(v,t,h){const r=this.e.findSubstr(t);return r&&(this.a=r.identifier.value,this.h()),this.b=h(v),this.c}g(v,t){return this.i(),this.b(v,t)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};E=qe([je(2,y.IExtHostRpcService)],E)}),define(Ce[108],ke([1,0,85,6,19,51,3,57,58,33,7,31,189,32]),function(te,e,n,C,D,M,S,R,y,k,N,w,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,S.createDecorator)("IExtHostVariableResolverProvider");class m extends f.AbstractVariableResolverService{constructor(l,g,E,A,v,t,h){function r(){if(E){const u=E.activeEditor();if(u)return u.document.uri;const i=A.tabGroups.all.find(p=>p.isActive)?.activeTab;if(i!==void 0){if(i.input instanceof N.TextDiffTabInput||i.input instanceof N.NotebookDiffEditorTabInput)return i.input.modified;if(i.input instanceof N.TextTabInput||i.input instanceof N.NotebookEditorTabInput||i.input instanceof N.CustomEditorTabInput)return i.input.uri}}}super({getFolderUri:u=>{const i=t.folders.filter(p=>p.name===u);if(i&&i.length>0)return i[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(u,i)=>v.getConfiguration(void 0,u).get(i),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=r();if(u)return D.normalize(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(g){const u=r();if(u){const i=g.getWorkspaceFolder(u);if(i)return D.normalize(i.uri.fsPath)}}},getSelectedText:()=>{if(E){const u=E.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(E){const u=E.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>l.getExtension(u)},void 0,h?Promise.resolve(h):void 0,Promise.resolve(M.env))}}let a=class extends C.Disposable{constructor(l,g,E,A,v){super(),this.b=l,this.c=g,this.g=E,this.h=A,this.i=v,this.a=new n.Lazy(async()=>{const t=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new m(this.b,this.c,this.g,this.i,t,r,this.j())})}getResolver(){return this.a.value}j(){}};a=qe([je(0,k.IExtHostExtensionService),je(1,w.IExtHostWorkspace),je(2,R.IExtHostDocumentsAndEditors),je(3,b.IExtHostConfiguration),je(4,y.IExtHostEditorTabs)],a),e.ExtHostVariableResolverProviderService=a}),define(Ce[109],ke([1,0,17,4,9,2,3,5,58,33,18,7,31,182,184,32,108]),function(te,e,n,C,D,M,S,R,y,k,N,w,f,b,m,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,S.createDecorator)("IExtHostDebugService");let l=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,u,i,p,c,s){this.D=u,this.E=i,this.F=p,this.G=c,this.H=s,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new C.Emitter,this.n=new C.Emitter,this.o=new C.Emitter,this.u=new C.Emitter,this.k=r.getProxy(R.MainContext.MainThreadDebugService),this.z=new C.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new E(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(d=>{d.onDidChange(T=>{this.I(d)}),this.I(d)})}asDebugSourceUri(r,u){const i=r;if(typeof i.sourceReference=="number"&&i.sourceReference>0){let p=`debug:${encodeURIComponent(i.path||"")}`,c="?";return u&&(p+=`${c}session=${encodeURIComponent(u.id)}`,c="&"),p+=`${c}ref=${i.sourceReference}`,M.URI.parse(p)}else{if(i.path)return M.URI.file(i.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(r){const u=[];for(const i of r.getAllExtensionDescriptions())if(i.contributes){const p=i.contributes.debuggers;if(p&&p.length>0)for(const c of p)(0,m.isDebuggerMainContribution)(c)&&u.push(c.type)}this.k.$registerDebugTypes(u)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const r=[];return this.w.forEach(u=>r.push(u)),r}addBreakpoints(r){this.T();const u=r.filter(c=>{const s=c.id;return this.w.has(s)?!1:(this.w.set(s,c),!0)});this.U(u,[],[]);const i=[],p=new Map;for(const c of u)if(c instanceof w.SourceBreakpoint){let s=p.get(c.location.uri.toString());s||(s={type:"sourceMulti",uri:c.location.uri,lines:[]},p.set(c.location.uri.toString(),s),i.push(s)),s.lines.push({id:c.id,enabled:c.enabled,condition:c.condition,hitCondition:c.hitCondition,logMessage:c.logMessage,line:c.location.range.start.line,character:c.location.range.start.character})}else c instanceof w.FunctionBreakpoint&&i.push({type:"function",id:c.id,enabled:c.enabled,hitCondition:c.hitCondition,logMessage:c.logMessage,condition:c.condition,functionName:c.functionName});return this.k.$registerBreakpoints(i)}removeBreakpoints(r){this.T();const u=r.filter(s=>this.w.delete(s.id));this.U([],u,[]);const i=u.filter(s=>s instanceof w.SourceBreakpoint).map(s=>s.id),p=u.filter(s=>s instanceof w.FunctionBreakpoint).map(s=>s.id),c=u.filter(s=>s instanceof w.DataBreakpoint).map(s=>s.id);return this.k.$unregisterBreakpoints(i,p,c)}startDebugging(r,u,i){return this.k.$startDebugging(r?r.uri:void 0,u,{parentSessionID:i.parentSession?i.parentSession.id:void 0,lifecycleManagedByParent:i.lifecycleManagedByParent,repl:i.consoleMode===w.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:i.noDebug,compact:i.compact,suppressSaveBeforeStart:i.suppressSaveBeforeStart,suppressDebugStatusbar:i.suppressDebugStatusbar??i.debugUI?.simple,suppressDebugToolbar:i.suppressDebugToolbar??i.debugUI?.simple,suppressDebugView:i.suppressDebugView??i.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,u,i){if(!u)return new w.Disposable(()=>{});const p=this.d++;return this.f.push({type:r,handle:p,provider:u}),this.k.$registerDebugConfigurationProvider(r,i,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,p),new w.Disposable(()=>{this.f=this.f.filter(c=>c.provider!==u),this.k.$unregisterDebugConfigurationProvider(p)})}registerDebugAdapterDescriptorFactory(r,u,i){if(!i)return new w.Disposable(()=>{});if(!this.P(r,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.M(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const p=this.g++;return this.h.push({type:u,handle:p,factory:i}),this.k.$registerDebugAdapterDescriptorFactory(u,p),new w.Disposable(()=>{this.h=this.h.filter(c=>c.factory!==i),this.k.$unregisterDebugAdapterDescriptorFactory(p)})}registerDebugAdapterTrackerFactory(r,u){if(!u)return new w.Disposable(()=>{});const i=this.i++;return this.j.push({type:r,handle:i,factory:u}),new w.Disposable(()=>{this.j=this.j.filter(p=>p.factory!==u)})}async $runInTerminal(r,u){return Promise.resolve(void 0)}async $substituteVariables(r,u){let i;const p=await this.W(r);return p&&(i={uri:p.uri,name:p.name,index:p.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(i,u)}J(r,u){if(r.type==="implementation")return new v(r.implementation)}K(){}async $startDASession(r,u){const i=this,p=await this.V(u);return this.R(this.M(p.type),p).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}' (extension might have failed to activate)`);const s=this.L(c),d=this.J(s,p);if(!d)throw new Error(`Couldn't create a debug adapter for type '${p.type}'.`);const T=d;return this.A.set(r,T),this.Q(p).then(O=>(O&&this.B.set(r,O),T.onMessage(async H=>{if(H.type==="request"&&H.command==="handshake"){const J=H,K={type:"response",seq:0,command:J.command,request_seq:J.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const L=await this.C.sign(J.arguments.value);K.body={signature:L},T.sendResponse(K)}else throw new Error("no signer")}catch(L){K.success=!1,K.message=L.message,T.sendResponse(K)}}else O&&O.onDidSendMessage&&O.onDidSendMessage(H),H=(0,m.convertToVSCPaths)(H,!0),i.k.$acceptDAMessage(r,H)}),T.onError(H=>{O&&O.onError&&O.onError(H),this.k.$acceptDAError(r,H.name,H.message,H.stack)}),T.onExit(H=>{O&&O.onExit&&O.onExit((0,D.withNullAsUndefined)(H),void 0),this.k.$acceptDAExit(r,(0,D.withNullAsUndefined)(H),void 0)}),O&&O.onWillStartSession&&O.onWillStartSession(),T.startSession()))})}$sendDAMessage(r,u){u=(0,m.convertToDAPaths)(u,!1);const i=this.B.get(r);i&&i.onWillReceiveMessage&&i.onWillReceiveMessage(u),this.A.get(r)?.sendMessage(u)}$stopDASession(r){const u=this.B.get(r);this.B.delete(r),u&&u.onWillStopSession&&u.onWillStopSession();const i=this.A.get(r);return this.A.delete(r),i?i.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const u=[],i=[],p=[];if(r.added)for(const c of r.added){const s=c.id;if(s&&!this.w.has(s)){let d;if(c.type==="function")d=new w.FunctionBreakpoint(c.functionName,c.enabled,c.condition,c.hitCondition,c.logMessage);else if(c.type==="data")d=new w.DataBreakpoint(c.label,c.dataId,c.canPersist,c.enabled,c.hitCondition,c.condition,c.logMessage);else{const T=M.URI.revive(c.uri);d=new w.SourceBreakpoint(new w.Location(T,new w.Position(c.line,c.character)),c.enabled,c.condition,c.hitCondition,c.logMessage)}(0,w.setBreakpointId)(d,s),this.w.set(s,d),u.push(d)}}if(r.removed)for(const c of r.removed){const s=this.w.get(c);s&&(this.w.delete(c),i.push(s))}if(r.changed){for(const c of r.changed)if(c.id){const s=this.w.get(c.id);if(s){if(s instanceof w.FunctionBreakpoint&&c.type==="function"){const d=s;d.enabled=c.enabled,d.condition=c.condition,d.hitCondition=c.hitCondition,d.logMessage=c.logMessage,d.functionName=c.functionName}else if(s instanceof w.SourceBreakpoint&&c.type==="source"){const d=s;d.enabled=c.enabled,d.condition=c.condition,d.hitCondition=c.hitCondition,d.logMessage=c.logMessage,d.location=new w.Location(M.URI.revive(c.uri),new w.Position(c.line,c.character))}p.push(s)}}}this.U(u,i,p)}$provideDebugConfigurations(r,u,i){return(0,n.asPromise)(async()=>{const p=this.O(r);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const c=await this.W(u);return p.provideDebugConfigurations(c,i)}).then(p=>{if(!p)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return p})}$resolveDebugConfiguration(r,u,i,p){return(0,n.asPromise)(async()=>{const c=this.O(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const s=await this.W(u);return c.resolveDebugConfiguration(s,i,p)})}$resolveDebugConfigurationWithSubstitutedVariables(r,u,i,p){return(0,n.asPromise)(async()=>{const c=this.O(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const s=await this.W(u);return c.resolveDebugConfigurationWithSubstitutedVariables(s,i,p)})}async $provideDebugAdapter(r,u){const i=this.N(r);if(!i)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const p=await this.V(u);return this.R(i,p).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}'`);return this.L(c)})}async $acceptDebugSessionStarted(r){const u=await this.V(r);this.m.fire(u)}async $acceptDebugSessionTerminated(r){const u=await this.V(r);u&&(this.n.fire(u),this.l.delete(u.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,u){(await this.V(r))?._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(r,u){const p={session:await this.V(r),event:u.event,body:u.body};this.u.fire(p)}L(r){if(r instanceof w.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof w.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof w.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof w.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}M(r){const u=this.h.filter(i=>i.type===r);if(u.length>0)return u[0].factory}N(r){const u=this.h.filter(i=>i.handle===r);if(u.length>0)return u[0].factory}O(r){const u=this.f.filter(i=>i.handle===r);if(u.length>0)return u[0].provider}P(r,u){if(r.contributes){const i=r.contributes.debuggers;if(i&&i.length>0){for(const p of i)if(p.label&&p.type&&p.type===u)return!0}}return!1}Q(r){const i=r.configuration.type,p=this.j.filter(c=>c.type===i||c.type==="*").map(c=>(0,n.asPromise)(()=>c.factory.createDebugAdapterTracker(r)).then(s=>s,s=>null));return Promise.race([Promise.all(p).then(c=>{const s=c.filter(d=>!!d);if(s.length>0)return new A(s)}),new Promise(c=>setTimeout(()=>c(void 0),1e3))]).catch(c=>{})}async R(r,u){const i=u.configuration.debugServer;if(typeof i=="number")return Promise.resolve(new w.DebugAdapterServer(i));if(r){const c=await this.E.getExtensionRegistry();return(0,n.asPromise)(()=>r.createDebugAdapterDescriptor(u,this.S(u,c))).then(s=>{if(s)return s})}const p=await this.E.getExtensionRegistry();return Promise.resolve(this.S(u,p))}S(r,u){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(r,u,i){(r.length>0||u.length>0||i.length>0)&&this.z.fire(Object.freeze({added:r,removed:u,changed:i}))}async V(r){if(r)if(typeof r=="string"){const u=this.l.get(r);if(u)return u}else{let u=this.l.get(r.id);if(!u){const i=await this.W(r.folderUri),p=r.parent?this.l.get(r.parent):void 0;u=new g(this.k,r.id,r.type,r.name,i,r.configuration,p),this.l.set(u.id,u),this.k.$sessionCached(u.id)}return u}throw new Error("cannot find session")}W(r){if(r){const u=M.URI.revive(r);return this.D.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};l=qe([je(0,N.IExtHostRpcService),je(1,f.IExtHostWorkspace),je(2,k.IExtHostExtensionService),je(3,a.IExtHostConfiguration),je(4,y.IExtHostEditorTabs),je(5,o.IExtHostVariableResolverProvider)],l),e.ExtHostDebugServiceBase=l;class g{constructor(r,u,i,p,c,s,d){this.d=r,this.f=u,this.g=i,this.h=p,this.i=c,this.j=s,this.k=d}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,u){return this.d.$customDebugAdapterRequest(this.f,r,u)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.ExtHostDebugSession=g;class E{constructor(r){this.value=Object.freeze({append(u){r.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.ExtHostDebugConsole=E;class A{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(u=>u.onError?u.onError(r):void 0)}onExit(r,u){this.d.forEach(i=>i.onExit?i.onExit(r,u):void 0)}}class v extends b.AbstractDebugAdapter{constructor(r){super(),this.h=r,r.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let t=class extends l{constructor(r,u,i,p,c,s){super(r,u,i,p,c,s)}};t=qe([je(0,N.IExtHostRpcService),je(1,f.IExtHostWorkspace),je(2,k.IExtHostExtensionService),je(3,a.IExtHostConfiguration),je(4,y.IExtHostEditorTabs),je(5,o.IExtHostVariableResolverProvider)],t),e.WorkerExtHostDebugService=t}),define(Ce[249],ke([1,0,12,82,2,5,240,11,66,67,26,160,18,55,33,74]),function(te,e,n,C,D,M,S,R,y,k,N,w,f,b,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class o{static async installEarlyHandler(E){const A=E.get(R.ILogService),t=E.get(f.IExtHostRpcService).getProxy(M.MainContext.MainThreadErrors);n.setUnexpectedErrorHandler(h=>{A.error(h);const r=n.transformErrorForSerialization(h);t.$onUnexpectedError(r)})}static async installFullHandler(E){const A=E.get(R.ILogService),v=E.get(f.IExtHostRpcService),t=E.get(m.IExtHostExtensionService),h=E.get(a.IExtHostTelemetry),r=v.getProxy(M.MainContext.MainThreadExtensionService),u=v.getProxy(M.MainContext.MainThreadErrors),i=await t.getExtensionPathIndex(),p=new WeakMap;Error.prepareStackTrace=(c,s)=>{let d="",T,O;for(const H of s)d+=`
	at ${H.toString()}`,O=H.getFileName(),!T&&O&&(T=i.findSubstr(D.URI.file(O)));return p.set(c,T?.identifier),`${c.name||"Error"}: ${c.message||""}${d}`},n.setUnexpectedErrorHandler(c=>{A.error(c);const s=n.transformErrorForSerialization(c),d=p.get(c);if(!d){u.$onUnexpectedError(s);return}r.$onExtensionRuntimeError(d,s);const T=h.onExtensionError(d,c);A.trace("forwarded error to extension?",T,d)})}}Error.stackTraceLimit=100;class l{constructor(E,A,v,t,h){this.a=v,this.b=new S.RPCProtocol(E,null,t),A=l.e(A,this.b);const r=new k.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());r.set(N.IExtHostInitDataService,{_serviceBrand:void 0,...A,messagePorts:h}),r.set(f.IExtHostRpcService,new f.ExtHostRpcService(this.b)),r.set(b.IURITransformerService,new b.URITransformerService(t)),r.set(m.IHostUtils,v);const u=new w.InstantiationService(r,!0);u.invokeFunction(o.installEarlyHandler),this.d=u.invokeFunction(i=>i.get(R.ILogService)),C.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",A),this.c=u.invokeFunction(i=>i.get(m.IExtHostExtensionService)),this.c.initialize(),u.invokeFunction(o.installFullHandler)}async asBrowserUri(E){const A=this.b.getProxy(M.MainContext.MainThreadExtensionService);return D.URI.revive(await A.$asBrowserUri(E))}terminate(E){this.c.terminate(E)}static e(E,A){E.allExtensions.forEach(t=>{t.extensionLocation=D.URI.revive(A.transformIncomingURIs(t.extensionLocation));const h={};t.browserNlsBundleUris&&(Object.keys(t.browserNlsBundleUris).forEach(r=>h[r]=D.URI.revive(A.transformIncomingURIs(t.browserNlsBundleUris[r]))),t.browserNlsBundleUris=h)}),E.environment.appRoot=D.URI.revive(A.transformIncomingURIs(E.environment.appRoot));const v=E.environment.extensionDevelopmentLocationURI;return v&&(E.environment.extensionDevelopmentLocationURI=v.map(t=>D.URI.revive(A.transformIncomingURIs(t)))),E.environment.extensionTestsLocationURI=D.URI.revive(A.transformIncomingURIs(E.environment.extensionTestsLocationURI)),E.environment.globalStorageHome=D.URI.revive(A.transformIncomingURIs(E.environment.globalStorageHome)),E.environment.workspaceStorageHome=D.URI.revive(A.transformIncomingURIs(E.environment.workspaceStorageHome)),E.environment.extensionTelemetryLogResource=D.URI.revive(A.transformIncomingURIs(E.environment.extensionTelemetryLogResource)),E.nlsBaseUrl=D.URI.revive(A.transformIncomingURIs(E.nlsBaseUrl)),E.logsLocation=D.URI.revive(A.transformIncomingURIs(E.logsLocation)),E.logFile=D.URI.revive(A.transformIncomingURIs(E.logFile)),E.workspace=A.transformIncomingURIs(E.workspace),E}}e.ExtensionHostMain=l}),define(Ce[250],ke([1,0,15,17,20,39,16,19,24,2,47]),function(te,e,n,C,D,M,S,R,y,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class w{constructor(g,E,A,v){this.d=g,this.e=E,this.f=A,this.g=v,this.a=null,this.b=!1,this.c=0}search(g,E){const A=this.d.folderQueries||[],v=new D.CancellationTokenSource;return E.onCancellationRequested(()=>v.cancel()),new Promise((t,h)=>{this.a=new b(g);let r=!1;const u=(i,p)=>{if(!r&&!this.b){const c=this.h(i);a(i)&&typeof this.d.maxResults=="number"&&this.c+c>this.d.maxResults&&(this.b=!0,r=!0,v.cancel(),i=this.j(i,this.d.maxResults-this.c));const s=this.h(i);this.c+=s,(s>0||!a(i))&&this.a.add(i,p)}};Promise.all(A.map((i,p)=>this.k(i,c=>u(c,p),v.token))).then(i=>{v.dispose(),this.a.flush();const p=i.some(c=>!!c&&!!c.limitHit);t({limitHit:this.b||p,messages:(0,n.flatten)(i.map(c=>c?.message?Array.isArray(c.message)?c.message:[c.message]:[])),stats:{type:this.g}})},i=>{v.dispose();const p=(0,M.toErrorMessage)(i);h(new Error(p))})})}h(g){return a(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}j(g,E){const A=Array.isArray(g.ranges)?g.ranges:[g.ranges],v=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:A.slice(0,E),preview:{matches:v.slice(0,E),text:g.preview.text},uri:g.uri}}async k(g,E,A){const v=new N.QueryGlobTester(this.d,g),t=[],h={report:i=>{if(!this.l(i))return;const p=g.folder.scheme===S.Schemas.file?(0,N.hasSiblingPromiseFn)(()=>this.f.readdir(y.dirname(i.uri))):void 0,c=y.relativePath(g.folder,i.uri);if(c){const s=v.includedInQuery(c,R.basename(c),p);(0,C.isThenable)(s)?t.push(s.then(d=>{d&&E(i)})):s&&E(i)}}},r=this.n(g),u=await this.e.provideTextSearchResults(f(this.d.contentPattern),r,h,A);return t.length&&await Promise.all(t),u}l(g){if(a(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(g){const E=(0,N.resolvePatternsForProvider)(this.d.includePattern,g.includePattern),A=(0,N.resolvePatternsForProvider)(this.d.excludePattern,g.excludePattern),v={folder:k.URI.from(g.folder),excludes:A,includes:E,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.f.toCanonicalName(g.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return v.usePCRE2=this.d.usePCRE2,v}}e.TextSearchManager=w;function f(l){return{isCaseSensitive:l.isCaseSensitive||!1,isRegExp:l.isRegExp||!1,isWordMatch:l.isWordMatch||!1,isMultiline:l.isMultiline||!1,pattern:l.pattern}}class b{constructor(g){this.e=g,this.b=-1,this.d=null,this.a=new o(512,E=>this.g(E))}add(g,E){this.d&&(this.b!==E||!y.isEqual(this.c,g.uri))&&(this.f(),this.d=null),this.d||(this.b=E,this.d={resource:g.uri,results:[]}),this.d.results.push(m(g))}f(){const g=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,g)}flush(){this.f(),this.a.flush()}g(g){this.e(g)}}e.TextSearchResultsCollector=b;function m(l){return a(l)?{preview:{matches:(0,n.mapArrayOrNot)(l.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:l.preview.text},ranges:(0,n.mapArrayOrNot)(l.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:l.text,lineNumber:l.lineNumber}}function a(l){return!!l.preview}e.extensionResultIsMatch=a;class o{constructor(g,E){this.g=g,this.h=E,this.c=0,this.d=[],this.e=0}addItem(g,E){!g||this.j(g,E)}addItems(g,E){!g||this.k(g,E)}j(g,E){this.d.push(g),this.e+=E,this.l()}k(g,E){this.d=this.d.concat(g),this.e+=E,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}o.a=4e3,o.b=50,e.BatchedCollector=o}),define(Ce[110],ke([1,0,6,5,3,245,18,55,11,2,250]),function(te,e,n,C,D,M,S,R,y,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let w=class{constructor(a,o,l){this.k=a,this.l=o,this.n=l,this.c=this.k.getProxy(C.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.FileSearchManager}o(a){return this.l.transformOutgoingScheme(a)}registerTextSearchProvider(a,o){if(this.g.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this.g.add(a);const l=this.d++;return this.e.set(l,o),this.c.$registerTextSearchProvider(l,this.o(a)),(0,n.toDisposable)(()=>{this.g.delete(a),this.e.delete(l),this.c.$unregisterProvider(l)})}registerFileSearchProvider(a,o){if(this.i.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this.i.add(a);const l=this.d++;return this.h.set(l,o),this.c.$registerFileSearchProvider(l,this.o(a)),(0,n.toDisposable)(()=>{this.i.delete(a),this.h.delete(l),this.c.$unregisterProvider(l)})}$provideFileSearchResults(a,o,l,g){const E=f(l),A=this.h.get(a);if(A)return this.j.fileSearch(E,A,v=>{this.c.$handleFileMatch(a,o,v.map(t=>t.resource))},g);throw new Error("unknown provider: "+a)}$clearCache(a){return this.j.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,o,l,g){const E=this.e.get(a);if(!E||!E.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const A=f(l);return this.q(A,E).search(t=>this.c.$handleTextMatch(a,o,t),g)}$enableExtensionHostSearch(){}q(a,o){return new N.TextSearchManager(a,o,{readdir:l=>Promise.resolve([]),toCanonicalName:l=>l},"textSearchProvider")}};w=qe([je(0,S.IExtHostRpcService),je(1,R.IURITransformerService),je(2,y.ILogService)],w),e.ExtHostSearch=w;function f(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(b),extraFileResources:m.extraFileResources&&m.extraFileResources.map(a=>k.URI.revive(a))}}e.reviveQuery=f;function b(m){return{...m,folder:k.URI.revive(m.folder)}}}),define(Ce[251],ke([1,0,66,105,31,103,32,37,57,60,107,109,110,80,69,76,104,59,36,79,74,58,220,11,176,108,78]),function(te,e,n,C,D,M,S,R,y,k,N,w,f,b,m,a,o,l,g,E,A,v,t,h,r,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(i.IExtHostLocalizationService,i.ExtHostLocalizationService,1),(0,n.registerSingleton)(h.ILoggerService,t.ExtHostLoggerService,1),(0,n.registerSingleton)(h.ILogService,r.ExtHostLogService,1),(0,n.registerSingleton)(a.IExtHostApiDeprecationService,a.ExtHostApiDeprecationService,1),(0,n.registerSingleton)(R.IExtHostCommands,R.ExtHostCommands,0),(0,n.registerSingleton)(S.IExtHostConfiguration,S.ExtHostConfiguration,0),(0,n.registerSingleton)(l.IExtHostConsumerFileSystem,l.ExtHostConsumerFileSystem,0),(0,n.registerSingleton)(w.IExtHostDebugService,w.WorkerExtHostDebugService,0),(0,n.registerSingleton)(M.IExtHostDecorations,M.ExtHostDecorations,0),(0,n.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,n.registerSingleton)(g.IExtHostFileSystemInfo,g.ExtHostFileSystemInfo,0),(0,n.registerSingleton)(C.IExtHostOutputService,C.ExtHostOutputService,1),(0,n.registerSingleton)(f.IExtHostSearch,f.ExtHostSearch,0),(0,n.registerSingleton)(b.IExtHostStorage,b.ExtHostStorage,0),(0,n.registerSingleton)(N.IExtHostTask,N.WorkerExtHostTask,0),(0,n.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService,0),(0,n.registerSingleton)(m.IExtHostTunnelService,m.ExtHostTunnelService,0),(0,n.registerSingleton)(o.IExtHostWindow,o.ExtHostWindow,0),(0,n.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace,0),(0,n.registerSingleton)(E.IExtHostSecretState,E.ExtHostSecretState,0),(0,n.registerSingleton)(A.IExtHostTelemetry,A.ExtHostTelemetry,0),(0,n.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs,0),(0,n.registerSingleton)(u.IExtHostVariableResolverProvider,u.ExtHostVariableResolverProviderService,0)}),define(Ce[252],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class n{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(D){if(D&&this.a.has(D)){const M=this.a.get(D);return this.a.delete(D),M}}addDragOperationTransfer(D,M){this.a.set(D,M)}getRenderedTreeElement(D){if(this.b.has(D))return this.b.get(D)}addRenderedTreeItemElement(D,M){this.b.set(D,M)}removeRenderedTreeItemElement(D){this.b.has(D)&&this.b.delete(D)}}e.TreeviewsService=n}),define(Ce[253],ke([1,0,145,7,24,2,4,6,181,17,7,9,15,8,20,252,27]),function(te,e,n,C,D,M,S,R,y,k,N,w,f,b,m,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function l(A,v){if((0,w.isString)(A))return{label:A};if(A&&typeof A=="object"&&typeof A.label=="string"){let t;return Array.isArray(A.highlights)&&(t=A.highlights.filter(h=>h.length===2&&typeof h[0]=="number"&&typeof h[1]=="number"),t=t.length?t:void 0),{label:A.label,highlights:t}}}class g{constructor(v,t,h){this.d=v,this.e=t,this.f=h,this.a=new Map,this.b=new a.TreeviewsService;function r(u){return u&&u.$treeViewId&&(u.$treeItemHandle||u.$selectedTreeItems||u.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:u=>r(u)?this.i(u):Array.isArray(u)&&u.length>0?u.map(i=>r(i)?this.i(i):i):u})}registerTreeDataProvider(v,t,h){const r=this.createTreeView(v,{treeDataProvider:t},h);return{dispose:()=>r.dispose()}}createTreeView(v,t,h){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],u=t.dragAndDropController?.dragMimeTypes??[],i=!!t.dragAndDropController?.handleDrag,p=!!t.dragAndDropController?.handleDrop,c=this.h(v,t,h),s=this.d.$registerTreeViewDataProvider(v,{showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:u,hasHandleDrag:i,hasHandleDrop:p});return{get onDidCollapseElement(){return c.onDidCollapseElement},get onDidExpandElement(){return c.onDidExpandElement},get selection(){return c.selectedElements},get onDidChangeSelection(){return c.onDidChangeSelection},get visible(){return c.visible},get onDidChangeVisibility(){return c.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,o.checkProposedApiEnabled)(h,"treeItemCheckbox"),c.onDidChangeCheckboxState},get message(){return c.message},set message(d){c.message=d},get title(){return c.title},set title(d){c.title=d},get description(){return c.description},set description(d){c.description=d},get badge(){return c.badge},set badge(d){d!==void 0&&N.ViewBadge.isViewBadge(d)?c.badge={value:Math.floor(Math.abs(d.value)),tooltip:d.tooltip}:d===void 0&&(c.badge=void 0)},reveal:(d,T)=>c.reveal(d,T),dispose:async()=>{await s,this.a.delete(v),c.dispose()}}}$getChildren(v,t){const h=this.a.get(v);return h?h.getChildren(t):Promise.reject(new y.NoTreeViewError(v))}async $handleDrop(v,t,h,r,u,i,p,c){const s=this.a.get(v);if(!s)return Promise.reject(new y.NoTreeViewError(v));const d=b.DataTransfer.toDataTransfer(h,async T=>(await this.d.$resolveDropFileData(v,t,T)).buffer);return p===v&&c&&await this.g(d,s,c,u,i),s.onDrop(d,r,u)}async g(v,t,h,r,u){const i=this.b.removeDragOperationTransfer(u);if(i)(await i)?.forEach((p,c)=>{p&&v.set(c,p)});else if(u&&t.handleDrag){const p=t.handleDrag(h,v,r);this.b.addDragOperationTransfer(u,p),await p}return v}async $handleDrag(v,t,h,r){const u=this.a.get(v);if(!u)return Promise.reject(new y.NoTreeViewError(v));const i=await this.g(new C.DataTransfer,u,t,r,h);if(!!i)return b.DataTransfer.toDataTransferDTO(i)}async $hasResolve(v){const t=this.a.get(v);if(!t)throw new y.NoTreeViewError(v);return t.hasResolve}$resolve(v,t,h){const r=this.a.get(v);if(!r)throw new y.NoTreeViewError(v);return r.resolveTreeItem(t,h)}$setExpanded(v,t,h){const r=this.a.get(v);if(!r)throw new y.NoTreeViewError(v);r.setExpanded(t,h)}$setSelection(v,t){const h=this.a.get(v);if(!h)throw new y.NoTreeViewError(v);h.setSelection(t)}$setFocus(v,t){const h=this.a.get(v);if(!h)throw new y.NoTreeViewError(v);h.setFocus(t)}$setVisible(v,t){const h=this.a.get(v);if(!h)throw new y.NoTreeViewError(v);h.setVisible(t)}$changeCheckboxState(v,t){const h=this.a.get(v);if(!h)throw new y.NoTreeViewError(v);h.setCheckboxState(t)}h(v,t,h){const r=new E(v,t,this.d,this.e.converter,this.f,h);return this.a.set(v,r),r}i(v){const t=this.a.get(v.$treeViewId);return t&&"$treeItemHandle"in v?t.getExtensionElement(v.$treeItemHandle):t&&"$focusedTreeItem"in v&&v.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=g;class E extends R.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(v=>this.getExtensionElement(v)).filter(v=>!(0,w.isUndefinedOrNull)(v))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(v,t,h,r,u,i){if(super(),this.C=v,this.D=h,this.F=r,this.G=u,this.H=i,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new S.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new S.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new S.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new S.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new S.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new S.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new m.CancellationTokenSource,i.contributes&&i.contributes.views)for(const s in i.contributes.views)for(const d of i.contributes.views[s])d.id===v&&(this.J=d.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(s=>this.w.fire({message:!1,element:s})));let p,c;this.B(S.Event.debounce(this.w.event,(s,d)=>(s||(s={message:!1,elements:[]}),d.element!==!1&&(p||(p=new Promise(T=>c=T),this.y=this.y.then(()=>p)),Array.isArray(d.element)?s.elements.push(...d.element):s.elements.push(d.element)),d.message&&(s.message=!0),s),200,!0)(({message:s,elements:d})=>{d.length&&(this.z=this.z.then(()=>{const T=c;return p=null,this.U(d).then(()=>T())})),s&&this.D.$setMessage(this.C,this.I)}))}async getChildren(v){const t=v?this.getExtensionElement(v):void 0;if(v&&!t)return this.G.error(`No tree item with id '${v}' found.`),Promise.resolve([]);let h=this.Q(v);return h||(h=await this.R(t)),h?h.map(r=>r.item):void 0}getExtensionElement(v){return this.i.get(v)}reveal(v,t){t=t||{select:!0,focus:!1};const h=(0,w.isUndefinedOrNull)(t.select)?!0:t.select,r=(0,w.isUndefinedOrNull)(t.focus)?!1:t.focus,u=(0,w.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.y.then(()=>this.N(v)).then(i=>this.P(v,i[i.length-1]).then(p=>this.D.$reveal(this.C,{item:p.item,parentChain:i.map(c=>c.item)},{select:h,focus:r,expand:u})),i=>this.G.error(i)):this.D.$reveal(this.C,void 0,{select:h,focus:r,expand:u})}get message(){return this.I}set message(v){this.I=v,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(v){this.J=v,this.D.$setTitle(this.C,v,this.L)}get description(){return this.L}set description(v){this.L=v,this.D.$setTitle(this.C,this.J,v)}get badge(){return this.M}set badge(v){this.M?.value===v?.value&&this.M?.tooltip===v?.tooltip||(this.M=b.ViewBadge.from(v),this.D.$setBadge(this.C,v))}setExpanded(v,t){const h=this.getExtensionElement(v);h&&(t?this.r.fire(Object.freeze({element:h})):this.s.fire(Object.freeze({element:h})))}setSelection(v){(0,f.equals)(this.l,v)||(this.l=v,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(v){this.m=v}setVisible(v){v!==this.k&&(this.k=v,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(v){const t=(await Promise.all(v.map(async h=>{const r=this.getExtensionElement(h.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:h.newState?N.TreeItemCheckboxState.Checked:N.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(h=>h!==void 0);t.forEach(h=>{h.treeItem.checkboxState=h.newState?N.TreeItemCheckboxState.Checked:N.TreeItemCheckboxState.Unchecked}),this.v.fire({items:t.map(h=>[h.extensionItem,h.newState])})}async handleDrag(v,t,h){const r=[];for(const u of v){const i=this.getExtensionElement(u);i&&r.push(i)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,t,h),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(v,t,h){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.g?.handleDrop))return(0,k.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(r,v,h):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(v,t){if(!this.f.resolveTreeItem)return;const h=this.i.get(v);if(h){const r=this.j.get(h);if(r){const u=await this.f.resolveTreeItem(r.extensionItem,h,t)??r.extensionItem;return this.db(u),r.item.tooltip=this.ab(u.tooltip),r.item.command=this.bb(r.disposableStore,u.command),r.item}}}N(v){return this.O(v).then(t=>t?this.N(t).then(h=>this.P(t,h[h.length-1]).then(r=>(h.push(r),h))):Promise.resolve([]))}O(v){const t=this.j.get(v);return t?Promise.resolve(t.parent?this.i.get(t.parent.item.handle):void 0):(0,k.asPromise)(()=>this.f.getParent(v))}P(v,t){const h=this.j.get(v);return h?Promise.resolve(h):(0,k.asPromise)(()=>this.f.getTreeItem(v)).then(r=>this.gb(v,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const u=this.getExtensionElement(r);if(u){const i=this.j.get(u);if(i)return Promise.resolve(i)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}Q(v){if(v){let t;if(typeof v=="string"){const h=this.getExtensionElement(v);t=h?this.j.get(h):void 0}else t=v;return t&&t.children||void 0}return this.h}async R(v){this.nb(v);const t=new m.CancellationTokenSource(this.S.token);try{const h=v?this.j.get(v):void 0,r=await this.f.getChildren(v);if(t.token.isCancellationRequested)return;const u=await Promise.all((0,f.coalesce)(r||[]).map(async i=>{const p=await this.f.getTreeItem(i);return p&&!t.token.isCancellationRequested?this.Z(i,p,h):null}));return t.token.isCancellationRequested?void 0:(0,f.coalesce)(u)}finally{t.dispose()}}U(v){if(v.some(h=>!h))return this.S.dispose(!0),this.S=new m.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const h=this.W(v);if(h.length)return this.X(h)}return Promise.resolve(void 0)}W(v){const t=new Set,h=v.map(u=>this.j.get(u));for(const u of h)if(u&&!t.has(u.item.handle)){let i=u;for(;i&&i.parent&&h.findIndex(p=>i&&i.parent&&p&&p.item.handle===i.parent.item.handle)===-1;){const p=this.i.get(i.parent.item.handle);i=p?this.j.get(p):void 0}i&&!i.parent&&t.add(u.item.handle)}const r=[];return t.forEach(u=>{const i=this.i.get(u);if(i){const p=this.j.get(i);p&&(!p.parent||!t.has(p.parent.item.handle))&&r.push(u)}}),r}X(v){const t={};return Promise.all(v.map(h=>this.Y(h).then(r=>{r&&(t[h]=r.item)}))).then(()=>Object.keys(t).length?this.D.$refresh(this.C,t):void 0)}Y(v){const t=this.getExtensionElement(v);if(t){const h=this.j.get(t);if(h)return this.nb(t),(0,k.asPromise)(()=>this.f.getTreeItem(t)).then(r=>{if(r){const u=this.eb(t,r,h.parent);return this.lb(t,u,h,h.parent),h.dispose(),u}return null})}return Promise.resolve(null)}Z(v,t,h){const r=this.eb(v,t,h);if(t.id&&this.i.has(r.item.handle))throw new Error((0,n.localize)(0,null,t.id));return this.kb(v,r),this.mb(r,h),r}ab(v){return N.MarkdownString.isMarkdownString(v)?b.MarkdownString.from(v):v}bb(v,t){return t?{...this.F.toInternal(t,v),originalId:t.command}:void 0}cb(v){if(!v.checkboxState)return;let t,h;return typeof v.checkboxState=="number"?t=v.checkboxState:(t=v.checkboxState.state,h=v.checkboxState.tooltip),{isChecked:t===N.TreeItemCheckboxState.Checked,tooltip:h}}db(v){if(!N.TreeItem.isTreeItem(v,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(v,t,h){this.db(t);const r=new R.DisposableStore,u=this.gb(v,t,h),i=this.hb(t);return{item:{handle:u,parentHandle:h?h.item.handle:void 0,label:l(t.label,this.H),description:t.description,resourceUri:t.resourceUri,tooltip:this.ab(t.tooltip),command:this.bb(r,t.command),contextValue:t.contextValue,icon:i,iconDark:this.ib(t)||i,themeIcon:this.fb(t),collapsibleState:(0,w.isUndefinedOrNull)(t.collapsibleState)?N.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.cb(t)},extensionItem:t,parent:h,children:void 0,disposableStore:r,dispose(){r.dispose()}}}fb(v){return v.iconPath instanceof N.ThemeIcon?v.iconPath:void 0}gb(v,{id:t,label:h,resourceUri:r},u,i){if(t)return`${E.b}/${t}`;const p=l(h,this.H),c=u?u.item.handle:E.a;let s=p?p.label:r?(0,D.basename)(r):"";s=s.indexOf("/")!==-1?s.replace("/","//"):s;const d=this.j.has(v)?this.j.get(v).item.handle:void 0,T=this.Q(u)||[];let O,H=0;do{if(O=`${c}/${H}:${s}`,i||!this.i.has(O)||d===O)break;H++}while(H<=T.length);return O}hb(v){if(v.iconPath&&!(v.iconPath instanceof N.ThemeIcon))return typeof v.iconPath=="string"||M.URI.isUri(v.iconPath)?this.jb(v.iconPath):this.jb(v.iconPath.light)}ib(v){if(v.iconPath&&!(v.iconPath instanceof N.ThemeIcon)&&v.iconPath.dark)return this.jb(v.iconPath.dark)}jb(v){return M.URI.isUri(v)?v:M.URI.file(v)}kb(v,t){this.i.set(t.item.handle,v),this.j.set(v,t)}lb(v,t,h,r){this.i.delete(t.item.handle),this.j.delete(v),t.item.handle!==h.item.handle&&this.i.delete(h.item.handle),this.kb(v,t);const u=this.Q(r)||[],i=u.filter(p=>p.item.handle===h.item.handle)[0];i&&u.splice(u.indexOf(i),1,t)}mb(v,t){t?(t.children||(t.children=[]),t.children.push(v)):(this.h||(this.h=[]),this.h.push(v))}nb(v){if(v){const t=this.j.get(v);if(t){if(t.children)for(const h of t.children){const r=this.i.get(h.item.handle);r&&this.ob(r)}t.children=void 0}}else this.pb()}ob(v){const t=this.j.get(v);if(t){if(t.children)for(const h of t.children){const r=this.i.get(h.item.handle);r&&this.ob(r)}this.j.delete(v),this.i.delete(t.item.handle),t.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(v=>v.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}E.a="0",E.b="1"}),define(Ce[254],ke([1,0,20,12,4,29,2,130,263,118,128,43,5,73,207,206,37,208,32,210,211,212,195,213,57,33,214,215,218,219,221,105,198,227,228,229,80,60,232,253,8,7,52,235,61,104,31,187,217,50,103,107,109,110,11,55,18,26,222,193,69,76,204,233,81,59,238,236,237,205,36,230,234,79,58,74,223,106,224,16,92,197,178,216,6,27,183,78,174,225,226]),function(te,e,n,C,D,M,S,R,y,k,N,w,f,b,m,a,o,l,g,E,A,v,t,h,r,u,i,p,c,s,d,T,O,H,J,K,L,B,P,F,V,j,le,_,be,de,ue,se,Z,X,ee,he,Te,Ne,Ke,Pe,Se,Ie,oe,ce,Y,I,$,W,q,ie,fe,ye,ae,ve,Ee,We,He,tt,Xe,et,it,dt,Fe,ot,Q,G,pe,Me,ze,Ve,_e,nt,vt,wt,Ct){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function jt(rt){const mt=rt.get(Ie.IExtHostInitDataService),Ft=rt.get(Ee.IExtHostFileSystemInfo),Gt=rt.get(ie.IExtHostConsumerFileSystem),Pt=rt.get(u.IExtHostExtensionService),ht=rt.get(ue.IExtHostWorkspace),kt=rt.get(et.IExtHostTelemetry),$t=rt.get(g.IExtHostConfiguration),Ot=rt.get(Pe.IURITransformerService),Ge=rt.get(Se.IExtHostRpcService),Nt=rt.get(L.IExtHostStorage),Mt=rt.get(q.IExtensionStoragePaths),zt=rt.get(Ke.ILoggerService),ft=rt.get(Ke.ILogService),De=rt.get(Y.IExtHostTunnelService),Ae=rt.get(I.IExtHostApiDeprecationService),ge=rt.get(de.IExtHostWindow),x=rt.get(tt.IExtHostSecretState),Re=rt.get(Xe.IExtHostEditorTabs);Ge.set(f.ExtHostContext.ExtHostFileSystemInfo,Ft),Ge.set(f.ExtHostContext.ExtHostLogLevelServiceShape,zt),Ge.set(f.ExtHostContext.ExtHostWorkspace,ht),Ge.set(f.ExtHostContext.ExtHostConfiguration,$t),Ge.set(f.ExtHostContext.ExtHostExtensionService,Pt),Ge.set(f.ExtHostContext.ExtHostStorage,Nt),Ge.set(f.ExtHostContext.ExtHostTunnelService,De),Ge.set(f.ExtHostContext.ExtHostWindow,ge),Ge.set(f.ExtHostContext.ExtHostSecretState,x),Ge.set(f.ExtHostContext.ExtHostTelemetry,kt),Ge.set(f.ExtHostContext.ExtHostEditorTabs,Re);const $e=Ge.set(f.ExtHostContext.ExtHostDecorations,rt.get(ee.IExtHostDecorations)),Qe=Ge.set(f.ExtHostContext.ExtHostDocumentsAndEditors,rt.get(r.IExtHostDocumentsAndEditors)),Be=Ge.set(f.ExtHostContext.ExtHostCommands,rt.get(o.IExtHostCommands)),Ze=Ge.set(f.ExtHostContext.ExtHostTerminalService,rt.get(B.IExtHostTerminalService)),ct=Ge.set(f.ExtHostContext.ExtHostDebugService,rt.get(Te.IExtHostDebugService)),Tt=Ge.set(f.ExtHostContext.ExtHostSearch,rt.get(Ne.IExtHostSearch)),bt=Ge.set(f.ExtHostContext.ExtHostTask,rt.get(he.IExtHostTask)),Et=Ge.set(f.ExtHostContext.ExtHostOutputService,rt.get(T.IExtHostOutputService)),It=Ge.set(f.ExtHostContext.ExtHostLocalization,rt.get(nt.IExtHostLocalizationService)),St=Ge.set(f.ExtHostContext.ExtHostUrls,new _.ExtHostUrls(Ge)),yt=Ge.set(f.ExtHostContext.ExtHostDocuments,new h.ExtHostDocuments(Ge,Qe)),qt=Ge.set(f.ExtHostContext.ExtHostDocumentContentProviders,new v.ExtHostDocumentContentProvider(Ge,Qe,ft)),Jt=Ge.set(f.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(ft,yt,Ge.getProxy(f.MainContext.MainThreadBulkEdits))),pt=Ge.set(f.ExtHostContext.ExtHostNotebook,new oe.ExtHostNotebookController(Ge,Be,Qe,yt)),si=Ge.set(f.ExtHostContext.ExtHostNotebookDocuments,new pe.ExtHostNotebookDocuments(pt)),oi=Ge.set(f.ExtHostContext.ExtHostNotebookEditors,new G.ExtHostNotebookEditors(ft,pt)),Zt=Ge.set(f.ExtHostContext.ExtHostNotebookKernels,new it.ExtHostNotebookKernels(Ge,mt,pt,Be,ft)),vi=Ge.set(f.ExtHostContext.ExtHostNotebookRenderers,new Fe.ExtHostNotebookRenderers(Ge,pt)),At=Ge.set(f.ExtHostContext.ExtHostEditors,new P.ExtHostEditors(Ge,Qe)),Wt=Ge.set(f.ExtHostContext.ExtHostTreeViews,new F.ExtHostTreeViews(Ge.getProxy(f.MainContext.MainThreadTreeViews),Be,ft)),bi=Ge.set(f.ExtHostContext.ExtHostEditorInsets,new se.ExtHostEditorInsets(Ge.getProxy(f.MainContext.MainThreadEditorInsets),At,mt.remote)),ai=Ge.set(f.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(Ge,ft,Ft,Qe)),ei=Ge.set(f.ExtHostContext.ExtHostLanguages,new s.ExtHostLanguages(Ge,yt,Be.converter,Ot)),ut=Ge.set(f.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(Ge,Ot,yt,Be,ai,ft,Ae,kt)),$i=Ge.set(f.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(Ge,ut)),Ut=Ge.set(f.ExtHostContext.ExtHostFileSystemEventService,new p.ExtHostFileSystemEventService(Ge,ft,Qe)),Qt=Ge.set(f.ExtHostContext.ExtHostQuickOpen,(0,H.createExtHostQuickOpen)(Ge,ht,Be)),ci=Ge.set(f.ExtHostContext.ExtHostSCM,new J.ExtHostSCM(Ge,Be,ft)),Ei=Ge.set(f.ExtHostContext.ExtHostQuickDiff,new Ct.ExtHostQuickDiff(Ge,Ot)),wi=Ge.set(f.ExtHostContext.ExtHostComments,(0,l.createExtHostComments)(Ge,Be,yt)),ui=Ge.set(f.ExtHostContext.ExtHostProgress,new O.ExtHostProgress(Ge.getProxy(f.MainContext.MainThreadProgress))),Si=Ge.set(f.ExtHostContext.ExtHosLabelService,new Z.ExtHostLabelService(Ge)),li=Ge.set(f.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(Ge)),ti=Ge.set(f.ExtHostContext.ExtHostAuthentication,new $.ExtHostAuthentication(Ge)),Bi=Ge.set(f.ExtHostContext.ExtHostTimeline,new W.ExtHostTimeline(Ge,Be)),ii=Ge.set(f.ExtHostContext.ExtHostWebviews,new be.ExtHostWebviews(Ge,mt.remote,ht,ft,Ae)),ni=Ge.set(f.ExtHostContext.ExtHostWebviewPanels,new ae.ExtHostWebviewPanels(Ge,ii,ht)),yi=Ge.set(f.ExtHostContext.ExtHostCustomEditors,new ye.ExtHostCustomEditors(Ge,yt,Mt,ii,ni)),Di=Ge.set(f.ExtHostContext.ExtHostWebviewViews,new fe.ExtHostWebviewViews(Ge,ii)),ri=Ge.set(f.ExtHostContext.ExtHostTesting,new We.ExtHostTesting(Ge,Be,Qe)),Ii=Ge.set(f.ExtHostContext.ExtHostUriOpeners,new He.ExtHostUriOpeners(Ge)),Ci=Ge.set(f.ExtHostContext.ExtHostProfileContentHandlers,new wt.ExtHostProfileContentHandlers(Ge));Ge.set(f.ExtHostContext.ExtHostInteractive,new Me.ExtHostInteractive(Ge,pt,Qe,Be,ft));const zi=Object.values(f.ExtHostContext);Ge.assertRegistered(zi);const Wi=new ve.ExtHostBulkEdits(Ge,Qe),Hi=new a.ExtHostClipboard(Ge),ki=new d.ExtHostMessageService(Ge,ft),Ri=new A.ExtHostDialogs(Ge),Oi=new K.ExtHostStatusBar(Ge,Be.converter);return m.ExtHostApiCommands.register(Be),function(Ue,Ht,Li){const gt=function(){let re=!Ue.isUnderDevelopment;function me(){re||(ft.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Oe(st){if(Array.isArray(st))st.forEach(Oe);else if(typeof st=="string")me();else{const Dt=st;typeof Dt.scheme>"u"&&me(),typeof Dt.exclusive=="boolean"&&(0,Ve.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return st}}(),Vi={getSession(re,me,Oe){return ti.getSession(Ue,re,me,Oe)},async hasSession(re,me){return(0,Ve.checkProposedApiEnabled)(Ue,"authSession"),!!await ti.getSession(Ue,re,me,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(re,me,Oe,st){return ti.registerAuthenticationProvider(re,me,Oe,st)}},di={registerCommand(re,me,Oe){return Be.registerCommand(!0,re,me,Oe,void 0,Ue)},registerTextEditorCommand(re,me,Oe){return Be.registerCommand(!0,re,(...st)=>{const Dt=At.getActiveTextEditor();if(!Dt){ft.warn("Cannot execute "+re+" because there is no active text editor.");return}return Dt.edit(Rt=>{me.apply(Oe,[Dt,Rt,...st])}).then(Rt=>{Rt||ft.warn("Edits from command "+re+" were not applied.")},Rt=>{ft.warn("An error occurred while running command "+re,Rt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(re,me,Oe)=>((0,Ve.checkProposedApiEnabled)(Ue,"diffCommand"),Be.registerCommand(!0,re,async(...st)=>{const Dt=Qe.activeEditor(!0);if(!Dt){ft.warn("Cannot execute "+re+" because there is no active text editor.");return}const Rt=await At.getDiffInformation(Dt.id);me.apply(Oe,[Rt,...st])},void 0,void 0,Ue)),executeCommand(re,...me){return Be.executeCommand(re,...me)},getCommands(re=!1){return Be.getCommands(re)}},Fi={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return Hi.value},get shell(){return Ze.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ve.checkProposedApiEnabled)(Ue,"envShellEvent"),Ze.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Ue,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Ue,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.isNewAppInstall)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(re){return et.ExtHostTelemetryLogger.validateSender(re),kt.instantiateLogger(Ue,re)},openExternal(re,me){return ge.openUri(re,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:me?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===mt.environment.appUriScheme)return St.createAppUri(re);try{return await ge.asExternalUri(re,{allowTunneling:!!mt.remote.authority})}catch(me){if((0,Q.matchesScheme)(re,ot.Schemas.http)||(0,Q.matchesScheme)(re,ot.Schemas.https))return re;throw me}},get remoteName(){return(0,X.getRemoteName)(mt.remote.authority)},get remoteAuthority(){return(0,Ve.checkProposedApiEnabled)(Ue,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return ft.onDidChangeLogLevel}};mt.environment.extensionTestsLocationURI||Object.freeze(Fi);const ji={createTestController(re,me,Oe){return ri.createTestController(Ue,re,me,Oe)},createTestObserver(){return(0,Ve.checkProposedApiEnabled)(Ue,"testObserver"),ri.createTestObserver()},runTests(re){return(0,Ve.checkProposedApiEnabled)(Ue,"testObserver"),ri.runTests(re)},get onDidChangeTestResults(){return(0,Ve.checkProposedApiEnabled)(Ue,"testObserver"),ri.onResultsChanged},get testResults(){return(0,Ve.checkProposedApiEnabled)(Ue,"testObserver"),ri.results}},hi=mt.remote.isRemote?j.ExtensionKind.Workspace:j.ExtensionKind.UI,qi={getExtension(re,me){(0,Ve.isProposedApiEnabled)(Ue,"extensionsAny")||(me=!1);const Oe=Ht.mine.getExtensionDescription(re);if(Oe)return new u.Extension(Pt,Ue.identifier,Oe,hi,!1);if(me){const st=Ht.all.getExtensionDescription(re);if(st)return new u.Extension(Pt,Ue.identifier,st,hi,!0)}},get all(){const re=[];for(const me of Ht.mine.getAllExtensionDescriptions())re.push(new u.Extension(Pt,Ue.identifier,me,hi,!1));return re},get allAcrossExtensionHosts(){(0,Ve.checkProposedApiEnabled)(Ue,"extensionsAny");const re=new Ve.ExtensionIdentifierSet(Ht.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),me=[];for(const Oe of Ht.all.getAllExtensionDescriptions()){const st=!re.has(Oe.identifier);me.push(new u.Extension(Pt,Ue.identifier,Oe,hi,st))}return me},get onDidChange(){return(0,Ve.isProposedApiEnabled)(Ue,"extensionsAny")?D.Event.any(Ht.mine.onDidChange,Ht.all.onDidChange):Ht.mine.onDidChange}},Ti={createDiagnosticCollection(re){return ai.createDiagnosticCollection(Ue.identifier,re)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:re=>ai.getDiagnostics(re),getLanguages(){return ei.getLanguages()},setTextDocumentLanguage(re,me){return ei.changeLanguage(re.uri,me)},match(re,me){const Oe=yt.getDocumentData(me.uri)?.notebook;return(0,N.score)(V.LanguageSelector.from(re),me.uri,me.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(re,me,Oe){return ut.registerCodeActionProvider(Ue,gt(re),me,Oe)},registerDocumentPasteEditProvider(re,me,Oe){return(0,Ve.checkProposedApiEnabled)(Ue,"documentPaste"),ut.registerDocumentPasteEditProvider(Ue,gt(re),me,Oe)},registerCodeLensProvider(re,me){return ut.registerCodeLensProvider(Ue,gt(re),me)},registerDefinitionProvider(re,me){return ut.registerDefinitionProvider(Ue,gt(re),me)},registerDeclarationProvider(re,me){return ut.registerDeclarationProvider(Ue,gt(re),me)},registerImplementationProvider(re,me){return ut.registerImplementationProvider(Ue,gt(re),me)},registerTypeDefinitionProvider(re,me){return ut.registerTypeDefinitionProvider(Ue,gt(re),me)},registerHoverProvider(re,me){return ut.registerHoverProvider(Ue,gt(re),me,Ue.identifier)},registerEvaluatableExpressionProvider(re,me){return ut.registerEvaluatableExpressionProvider(Ue,gt(re),me,Ue.identifier)},registerInlineValuesProvider(re,me){return ut.registerInlineValuesProvider(Ue,gt(re),me,Ue.identifier)},registerDocumentHighlightProvider(re,me){return ut.registerDocumentHighlightProvider(Ue,gt(re),me)},registerLinkedEditingRangeProvider(re,me){return ut.registerLinkedEditingRangeProvider(Ue,gt(re),me)},registerReferenceProvider(re,me){return ut.registerReferenceProvider(Ue,gt(re),me)},registerRenameProvider(re,me){return ut.registerRenameProvider(Ue,gt(re),me)},registerDocumentSymbolProvider(re,me,Oe){return ut.registerDocumentSymbolProvider(Ue,gt(re),me,Oe)},registerWorkspaceSymbolProvider(re){return ut.registerWorkspaceSymbolProvider(Ue,re)},registerDocumentFormattingEditProvider(re,me){return ut.registerDocumentFormattingEditProvider(Ue,gt(re),me)},registerDocumentRangeFormattingEditProvider(re,me){return ut.registerDocumentRangeFormattingEditProvider(Ue,gt(re),me)},registerOnTypeFormattingEditProvider(re,me,Oe,...st){return ut.registerOnTypeFormattingEditProvider(Ue,gt(re),me,[Oe].concat(st))},registerDocumentSemanticTokensProvider(re,me,Oe){return ut.registerDocumentSemanticTokensProvider(Ue,gt(re),me,Oe)},registerDocumentRangeSemanticTokensProvider(re,me,Oe){return ut.registerDocumentRangeSemanticTokensProvider(Ue,gt(re),me,Oe)},registerSignatureHelpProvider(re,me,Oe,...st){return typeof Oe=="object"?ut.registerSignatureHelpProvider(Ue,gt(re),me,Oe):ut.registerSignatureHelpProvider(Ue,gt(re),me,typeof Oe>"u"?[]:[Oe,...st])},registerCompletionItemProvider(re,me,...Oe){return ut.registerCompletionItemProvider(Ue,gt(re),me,Oe)},registerInlineCompletionItemProvider(re,me){return me.handleDidShowCompletionItem&&(0,Ve.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Ue,gt(re),me)},registerDocumentLinkProvider(re,me){return ut.registerDocumentLinkProvider(Ue,gt(re),me)},registerColorProvider(re,me){return ut.registerColorProvider(Ue,gt(re),me)},registerFoldingRangeProvider(re,me){return ut.registerFoldingRangeProvider(Ue,gt(re),me)},registerSelectionRangeProvider(re,me){return ut.registerSelectionRangeProvider(Ue,re,me)},registerCallHierarchyProvider(re,me){return ut.registerCallHierarchyProvider(Ue,re,me)},registerTypeHierarchyProvider(re,me){return ut.registerTypeHierarchyProvider(Ue,re,me)},setLanguageConfiguration:(re,me)=>ut.setLanguageConfiguration(Ue,re,me),getTokenInformationAtPosition(re,me){return(0,Ve.checkProposedApiEnabled)(Ue,"tokenInformation"),ei.tokenAtPosition(re,me)},registerInlayHintsProvider(re,me){return ut.registerInlayHintsProvider(Ue,re,me)},createLanguageStatusItem(re,me){return ei.createLanguageStatusItem(Ue,re,me)},registerDocumentDropEditProvider(re,me){return ut.registerDocumentOnDropEditProvider(Ue,re,me)}},Ki={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return Ze.activeTerminal},get terminals(){return Ze.terminals},async showTextDocument(re,me,Oe){const st=await(S.URI.isUri(re)?Promise.resolve(Kt.openTextDocument(re)):Promise.resolve(re));return At.showTextDocument(st,me,Oe)},createTextEditorDecorationType(re){return At.createTextEditorDecorationType(Ue,re)},onDidChangeActiveTextEditor(re,me,Oe){return At.onDidChangeActiveTextEditor(re,me,Oe)},onDidChangeVisibleTextEditors(re,me,Oe){return At.onDidChangeVisibleTextEditors(re,me,Oe)},onDidChangeTextEditorSelection(re,me,Oe){return At.onDidChangeTextEditorSelection(re,me,Oe)},onDidChangeTextEditorOptions(re,me,Oe){return At.onDidChangeTextEditorOptions(re,me,Oe)},onDidChangeTextEditorVisibleRanges(re,me,Oe){return At.onDidChangeTextEditorVisibleRanges(re,me,Oe)},onDidChangeTextEditorViewColumn(re,me,Oe){return At.onDidChangeTextEditorViewColumn(re,me,Oe)},onDidCloseTerminal(re,me,Oe){return Ze.onDidCloseTerminal(re,me,Oe)},onDidOpenTerminal(re,me,Oe){return Ze.onDidOpenTerminal(re,me,Oe)},onDidChangeActiveTerminal(re,me,Oe){return Ze.onDidChangeActiveTerminal(re,me,Oe)},onDidChangeTerminalDimensions(re,me,Oe){return(0,Ve.checkProposedApiEnabled)(Ue,"terminalDimensions"),Ze.onDidChangeTerminalDimensions(re,me,Oe)},onDidChangeTerminalState(re,me,Oe){return Ze.onDidChangeTerminalState(re,me,Oe)},onDidWriteTerminalData(re,me,Oe){return(0,Ve.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),Ze.onDidWriteTerminalData(re,me,Oe)},get state(){return ge.state},onDidChangeWindowState(re,me,Oe){return ge.onDidChangeWindowState(re,me,Oe)},showInformationMessage(re,...me){return ki.showMessage(Ue,M.default.Info,re,me[0],me.slice(1))},showWarningMessage(re,...me){return ki.showMessage(Ue,M.default.Warning,re,me[0],me.slice(1))},showErrorMessage(re,...me){return ki.showMessage(Ue,M.default.Error,re,me[0],me.slice(1))},showQuickPick(re,me,Oe){return Qt.showQuickPick(re,me,Oe)},showWorkspaceFolderPick(re){return Qt.showWorkspaceFolderPick(re)},showInputBox(re,me){return Qt.showInput(re,me)},showOpenDialog(re){return Ri.showOpenDialog(re)},showSaveDialog(re){return Ri.showSaveDialog(re)},createStatusBarItem(re,me,Oe){let st,Dt,Rt;return typeof re=="string"?(st=re,Dt=me,Rt=Oe):(Dt=re,Rt=me),Oi.createStatusBarEntry(Ue,st,Dt,Rt)},setStatusBarMessage(re,me){return Oi.setStatusBarMessage(re,me)},withScmProgress(re){return Ae.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),ui.withProgress(Ue,{location:j.ProgressLocation.SourceControl},(me,Oe)=>re({report(st){}}))},withProgress(re,me){return ui.withProgress(Ue,re,me)},createOutputChannel(re,me){return Et.createOutputChannel(re,me,Ue)},createWebviewPanel(re,me,Oe,st){return ni.createWebviewPanel(Ue,re,me,Oe,st)},createWebviewTextEditorInset(re,me,Oe,st){return(0,Ve.checkProposedApiEnabled)(Ue,"editorInsets"),bi.createWebviewEditorInset(re,me,Oe,st,Ue)},createTerminal(re,me,Oe){return typeof re=="object"?"pty"in re?Ze.createExtensionTerminal(re):Ze.createTerminalFromOptions(re):Ze.createTerminal(re,me,Oe)},registerTerminalLinkProvider(re){return Ze.registerLinkProvider(re)},registerTerminalProfileProvider(re,me){return Ze.registerProfileProvider(Ue,re,me)},registerTerminalQuickFixProvider(re,me){return(0,Ve.checkProposedApiEnabled)(Ue,"terminalQuickFixProvider"),Ze.registerTerminalQuickFixProvider(re,Ue.identifier.value,me)},registerTreeDataProvider(re,me){return Wt.registerTreeDataProvider(re,me,Ue)},createTreeView(re,me){return Wt.createTreeView(re,me,Ue)},registerWebviewPanelSerializer:(re,me)=>ni.registerWebviewPanelSerializer(Ue,re,me),registerCustomEditorProvider:(re,me,Oe={})=>yi.registerCustomEditorProvider(Ue,re,me,Oe),registerFileDecorationProvider(re){return $e.registerFileDecorationProvider(re,Ue)},registerUriHandler(re){return St.registerUriHandler(Ue.identifier,re)},createQuickPick(){return Qt.createQuickPick(Ue)},createInputBox(){return Qt.createInputBox(Ue)},get activeColorTheme(){return li.activeColorTheme},onDidChangeActiveColorTheme(re,me,Oe){return li.onDidChangeActiveColorTheme(re,me,Oe)},registerWebviewViewProvider(re,me,Oe){return Di.registerWebviewViewProvider(Ue,re,me,Oe?.webviewOptions)},get activeNotebookEditor(){return pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,me,Oe){return pt.onDidChangeActiveNotebookEditor(re,me,Oe)},get visibleNotebookEditors(){return pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,me,Oe){return oi.onDidChangeNotebookEditorSelection(re,me,Oe)},onDidChangeNotebookEditorVisibleRanges(re,me,Oe){return oi.onDidChangeNotebookEditorVisibleRanges(re,me,Oe)},showNotebookDocument(re,me){return pt.showNotebookDocument(re,me)},registerExternalUriOpener(re,me,Oe){return(0,Ve.checkProposedApiEnabled)(Ue,"externalUriOpener"),Ii.registerExternalUriOpener(Ue.identifier,re,me,Oe)},registerProfileContentHandler(re,me){return(0,Ve.checkProposedApiEnabled)(Ue,"profileContentHandlers"),Ci.registrProfileContentHandler(Ue,re,me)},registerQuickDiffProvider(re,me,Oe,st){return(0,Ve.checkProposedApiEnabled)(Ue,"quickDiffProvider"),Ei.registerQuickDiffProvider(gt(re),me,Oe,st)},get tabGroups(){return Re.tabGroups}},Kt={get rootPath(){return Ae.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(re){throw C.readonly()},getWorkspaceFolder(re){return ht.getWorkspaceFolder(re)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(re){throw C.readonly()},get workspaceFile(){return ht.workspaceFile},set workspaceFile(re){throw C.readonly()},updateWorkspaceFolders:(re,me,...Oe)=>ht.updateWorkspaceFolders(Ue,re,me||0,...Oe),onDidChangeWorkspaceFolders:function(re,me,Oe){return ht.onDidChangeWorkspace(re,me,Oe)},asRelativePath:(re,me)=>ht.getRelativePath(re,me),findFiles:(re,me,Oe,st)=>ht.findFiles(re,me,Oe,Ue.identifier,st),findTextInFiles:(re,me,Oe,st)=>{(0,Ve.checkProposedApiEnabled)(Ue,"findTextInFiles");let Dt,Rt;return typeof me=="object"?(Dt=me,Rt=Oe):(Dt={},Rt=me,st=Oe),ht.findTextInFiles(re,Dt||{},Rt,Ue.identifier,st)},saveAll:re=>ht.saveAll(re),applyEdit(re,me){return Wi.applyWorkspaceEdit(re,Ue,me)},createFileSystemWatcher:(re,me,Oe,st)=>Ut.createFileSystemWatcher(ht,Ue,re,me,Oe,st),get textDocuments(){return yt.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw C.readonly()},openTextDocument(re){let me;const Oe=re;if(typeof re=="string")me=Promise.resolve(S.URI.file(re));else if(S.URI.isUri(re))me=Promise.resolve(re);else if(!Oe||typeof Oe=="object")me=yt.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return me.then(st=>yt.ensureDocumentData(st).then(Dt=>Dt.document))},onDidOpenTextDocument:(re,me,Oe)=>yt.onDidAddDocument(re,me,Oe),onDidCloseTextDocument:(re,me,Oe)=>yt.onDidRemoveDocument(re,me,Oe),onDidChangeTextDocument:(re,me,Oe)=>yt.onDidChangeDocument(re,me,Oe),onDidSaveTextDocument:(re,me,Oe)=>yt.onDidSaveDocument(re,me,Oe),onWillSaveTextDocument:(re,me,Oe)=>Jt.getOnWillSaveTextDocumentEvent(Ue)(re,me,Oe),get notebookDocuments(){return pt.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,me){let Oe;if(S.URI.isUri(re))Oe=re,await pt.openNotebookDocument(re);else if(typeof re=="string")Oe=S.URI.revive(await pt.createNotebookDocument({viewType:re,content:me}));else throw new Error("Invalid arguments");return pt.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(re,me,Oe){return si.onDidSaveNotebookDocument(re,me,Oe)},onDidChangeNotebookDocument(re,me,Oe){return si.onDidChangeNotebookDocument(re,me,Oe)},get onDidOpenNotebookDocument(){return pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return pt.onDidCloseNotebookDocument},registerNotebookSerializer(re,me,Oe,st){return pt.registerNotebookSerializer(Ue,re,me,Oe,(0,Ve.isProposedApiEnabled)(Ue,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(re,me,Oe)=>Li.onDidChangeConfiguration(re,me,Oe),getConfiguration(re,me){return me=arguments.length===1?void 0:me,Li.getConfiguration(re,me,Ue)},registerTextDocumentContentProvider(re,me){return qt.registerTextDocumentContentProvider(re,me)},registerTaskProvider:(re,me)=>(Ae.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),bt.registerTaskProvider(Ue,re,me)),registerFileSystemProvider(re,me,Oe){return(0,ze.combinedDisposable)($i.registerFileSystemProvider(Ue,re,me,Oe),Gt.addFileSystemProvider(re,me))},get fs(){return Gt.value},registerFileSearchProvider:(re,me)=>((0,Ve.checkProposedApiEnabled)(Ue,"fileSearchProvider"),Tt.registerFileSearchProvider(re,me)),registerTextSearchProvider:(re,me)=>((0,Ve.checkProposedApiEnabled)(Ue,"textSearchProvider"),Tt.registerTextSearchProvider(re,me)),registerRemoteAuthorityResolver:(re,me)=>((0,Ve.checkProposedApiEnabled)(Ue,"resolvers"),Pt.registerRemoteAuthorityResolver(re,me)),registerResourceLabelFormatter:re=>((0,Ve.checkProposedApiEnabled)(Ue,"resolvers"),Si.$registerResourceLabelFormatter(re)),onDidCreateFiles:(re,me,Oe)=>Ut.onDidCreateFile(re,me,Oe),onDidDeleteFiles:(re,me,Oe)=>Ut.onDidDeleteFile(re,me,Oe),onDidRenameFiles:(re,me,Oe)=>Ut.onDidRenameFile(re,me,Oe),onWillCreateFiles:(re,me,Oe)=>Ut.getOnWillCreateFileEvent(Ue)(re,me,Oe),onWillDeleteFiles:(re,me,Oe)=>Ut.getOnWillDeleteFileEvent(Ue)(re,me,Oe),onWillRenameFiles:(re,me,Oe)=>Ut.getOnWillRenameFileEvent(Ue)(re,me,Oe),openTunnel:re=>((0,Ve.checkProposedApiEnabled)(Ue,"tunnels"),De.openTunnel(Ue,re).then(me=>{if(!me)throw new Error("cannot open tunnel");return me})),get tunnels(){return(0,Ve.checkProposedApiEnabled)(Ue,"tunnels"),De.getTunnels()},onDidChangeTunnels:(re,me,Oe)=>((0,Ve.checkProposedApiEnabled)(Ue,"tunnels"),De.onDidChangeTunnels(re,me,Oe)),registerPortAttributesProvider:(re,me)=>((0,Ve.checkProposedApiEnabled)(Ue,"portsAttributes"),De.registerPortsAttributesProvider(re,me)),registerTimelineProvider:(re,me)=>((0,Ve.checkProposedApiEnabled)(Ue,"timeline"),Bi.registerTimelineProvider(re,me,Ue.identifier,Be.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:re=>((0,Ve.checkProposedApiEnabled)(Ue,"workspaceTrust"),ht.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,me,Oe)=>ht.onDidGrantWorkspaceTrust(re,me,Oe),registerEditSessionIdentityProvider:(re,me)=>((0,Ve.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(re,me)),onWillCreateEditSessionIdentity:(re,me,Oe)=>((0,Ve.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(Ue)(re,me,Oe))},fi={get inputBox(){return Ae.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),ci.getLastInputBox(Ue)},createSourceControl(re,me,Oe){return ci.createSourceControl(Ue,re,me,Oe)}},xi={createCommentController(re,me){return wi.createCommentController(Ue,re,me)}},Bt={get activeDebugSession(){return ct.activeDebugSession},get activeDebugConsole(){return ct.activeDebugConsole},get breakpoints(){return ct.breakpoints},onDidStartDebugSession(re,me,Oe){return ct.onDidStartDebugSession(re,me,Oe)},onDidTerminateDebugSession(re,me,Oe){return ct.onDidTerminateDebugSession(re,me,Oe)},onDidChangeActiveDebugSession(re,me,Oe){return ct.onDidChangeActiveDebugSession(re,me,Oe)},onDidReceiveDebugSessionCustomEvent(re,me,Oe){return ct.onDidReceiveDebugSessionCustomEvent(re,me,Oe)},onDidChangeBreakpoints(re,me,Oe){return ct.onDidChangeBreakpoints(re,me,Oe)},registerDebugConfigurationProvider(re,me,Oe){return ct.registerDebugConfigurationProvider(re,me,Oe||_e.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,me){return ct.registerDebugAdapterDescriptorFactory(Ue,re,me)},registerDebugAdapterTrackerFactory(re,me){return ct.registerDebugAdapterTrackerFactory(re,me)},startDebugging(re,me,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?ct.startDebugging(re,me,{parentSession:Oe}):ct.startDebugging(re,me,Oe||{})},stopDebugging(re){return ct.stopDebugging(re)},addBreakpoints(re){return ct.addBreakpoints(re)},removeBreakpoints(re){return ct.removeBreakpoints(re)},asDebugSourceUri(re,me){return ct.asDebugSourceUri(re,me)}},mi={registerTaskProvider:(re,me)=>bt.registerTaskProvider(Ue,re,me),fetchTasks:re=>bt.fetchTasks(re),executeTask:re=>bt.executeTask(Ue,re),get taskExecutions(){return bt.taskExecutions},onDidStartTask:(re,me,Oe)=>bt.onDidStartTask(re,me,Oe),onDidEndTask:(re,me,Oe)=>bt.onDidEndTask(re,me,Oe),onDidStartTaskProcess:(re,me,Oe)=>bt.onDidStartTaskProcess(re,me,Oe),onDidEndTaskProcess:(re,me,Oe)=>bt.onDidEndTaskProcess(re,me,Oe)},Gi={createNotebookController(re,me,Oe,st,Dt){return Zt.createNotebookController(Ue,re,me,Oe,st,(0,Ve.isProposedApiEnabled)(Ue,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(re,me)=>pt.registerNotebookCellStatusBarItemProvider(Ue,re,me),createRendererMessaging(re){return vi.createRendererMessaging(Ue,re)},createNotebookControllerDetectionTask(re){return(0,Ve.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(Ue,re)},registerKernelSourceActionProvider(re,me){return(0,Ve.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(Ue,re,me)},onDidChangeNotebookCellExecutionState(re,me,Oe){return(0,Ve.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(re,me,Oe)}},Xi={t(...re){if(typeof re[0]=="string"){const me=re.shift(),Oe=!re||typeof re[0]!="object"?re:re[0];return It.getMessage(Ue.identifier.value,{message:me,args:Oe})}return It.getMessage(Ue.identifier.value,re[0])},get bundle(){return It.getBundle(Ue.identifier.value)},get uri(){return It.getBundleUri(Ue.identifier.value)}};return{version:mt.version,authentication:Vi,commands:di,comments:xi,debug:Bt,env:Fi,extensions:qi,l10n:Xi,languages:Ti,notebooks:Gi,scm:fi,tasks:mi,tests:ji,window:Ki,workspace:Kt,Breakpoint:j.Breakpoint,TerminalOutputAnchor:j.TerminalOutputAnchor,CallHierarchyIncomingCall:j.CallHierarchyIncomingCall,CallHierarchyItem:j.CallHierarchyItem,CallHierarchyOutgoingCall:j.CallHierarchyOutgoingCall,CancellationError:C.CancellationError,CancellationTokenSource:n.CancellationTokenSource,CandidatePortSource:f.CandidatePortSource,CodeAction:j.CodeAction,CodeActionKind:j.CodeActionKind,CodeActionTriggerKind:j.CodeActionTriggerKind,CodeLens:j.CodeLens,Color:j.Color,ColorInformation:j.ColorInformation,ColorPresentation:j.ColorPresentation,ColorThemeKind:j.ColorThemeKind,CommentMode:j.CommentMode,CommentThreadCollapsibleState:j.CommentThreadCollapsibleState,CommentThreadState:j.CommentThreadState,CompletionItem:j.CompletionItem,CompletionItemKind:j.CompletionItemKind,CompletionItemTag:j.CompletionItemTag,CompletionList:j.CompletionList,CompletionTriggerKind:j.CompletionTriggerKind,ConfigurationTarget:j.ConfigurationTarget,CustomExecution:j.CustomExecution,DebugAdapterExecutable:j.DebugAdapterExecutable,DebugAdapterInlineImplementation:j.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:j.DebugAdapterNamedPipeServer,DebugAdapterServer:j.DebugAdapterServer,DebugConfigurationProviderTriggerKind:_e.DebugConfigurationProviderTriggerKind,DebugConsoleMode:j.DebugConsoleMode,DecorationRangeBehavior:j.DecorationRangeBehavior,Diagnostic:j.Diagnostic,DiagnosticRelatedInformation:j.DiagnosticRelatedInformation,DiagnosticSeverity:j.DiagnosticSeverity,DiagnosticTag:j.DiagnosticTag,Disposable:j.Disposable,DocumentHighlight:j.DocumentHighlight,DocumentHighlightKind:j.DocumentHighlightKind,DocumentLink:j.DocumentLink,DocumentSymbol:j.DocumentSymbol,EndOfLine:j.EndOfLine,EnvironmentVariableMutatorType:j.EnvironmentVariableMutatorType,EvaluatableExpression:j.EvaluatableExpression,InlineValueText:j.InlineValueText,InlineValueVariableLookup:j.InlineValueVariableLookup,InlineValueEvaluatableExpression:j.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:j.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:j.ExtensionKind,ExtensionMode:j.ExtensionMode,ExternalUriOpenerPriority:j.ExternalUriOpenerPriority,FileChangeType:j.FileChangeType,FileDecoration:j.FileDecoration,FileDecoration2:j.FileDecoration,FileSystemError:j.FileSystemError,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:j.FoldingRange,FoldingRangeKind:j.FoldingRangeKind,FunctionBreakpoint:j.FunctionBreakpoint,InlineCompletionItem:j.InlineSuggestion,InlineCompletionList:j.InlineSuggestionList,Hover:j.Hover,IndentAction:k.IndentAction,Location:j.Location,MarkdownString:j.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:j.ParameterInformation,PortAutoForwardAction:j.PortAutoForwardAction,Position:j.Position,ProcessExecution:j.ProcessExecution,ProgressLocation:j.ProgressLocation,QuickInputButtons:j.QuickInputButtons,Range:j.Range,RelativePattern:j.RelativePattern,Selection:j.Selection,SelectionRange:j.SelectionRange,SemanticTokens:j.SemanticTokens,SemanticTokensBuilder:j.SemanticTokensBuilder,SemanticTokensEdit:j.SemanticTokensEdit,SemanticTokensEdits:j.SemanticTokensEdits,SemanticTokensLegend:j.SemanticTokensLegend,ShellExecution:j.ShellExecution,ShellQuoting:j.ShellQuoting,SignatureHelp:j.SignatureHelp,SignatureHelpTriggerKind:j.SignatureHelpTriggerKind,SignatureInformation:j.SignatureInformation,SnippetString:j.SnippetString,SourceBreakpoint:j.SourceBreakpoint,StandardTokenType:j.StandardTokenType,StatusBarAlignment:j.StatusBarAlignment,SymbolInformation:j.SymbolInformation,SymbolKind:j.SymbolKind,SymbolTag:j.SymbolTag,Task:j.Task,TaskGroup:j.TaskGroup,TaskPanelKind:j.TaskPanelKind,TaskRevealKind:j.TaskRevealKind,TaskScope:j.TaskScope,TerminalLink:j.TerminalLink,TerminalQuickFixCommand:j.TerminalQuickFixCommand,TerminalQuickFixOpener:j.TerminalQuickFixOpener,TerminalLocation:j.TerminalLocation,TerminalProfile:j.TerminalProfile,TerminalExitReason:j.TerminalExitReason,TerminalQuickFixType:j.TerminalQuickFixType,TextDocumentSaveReason:j.TextDocumentSaveReason,TextEdit:j.TextEdit,SnippetTextEdit:j.SnippetTextEdit,TextEditorCursorStyle:R.TextEditorCursorStyle,TextEditorLineNumbersStyle:j.TextEditorLineNumbersStyle,TextEditorRevealType:j.TextEditorRevealType,TextEditorSelectionChangeKind:j.TextEditorSelectionChangeKind,TextDocumentChangeReason:j.TextDocumentChangeReason,ThemeColor:j.ThemeColor,ThemeIcon:j.ThemeIcon,TreeItem:j.TreeItem,TreeItem2:j.TreeItem,TreeItemCheckboxState:j.TreeItemCheckboxState,TreeItemCollapsibleState:j.TreeItemCollapsibleState,TypeHierarchyItem:j.TypeHierarchyItem,UIKind:b.UIKind,Uri:S.URI,ViewColumn:j.ViewColumn,WorkspaceEdit:j.WorkspaceEdit,DocumentDropEdit:j.DocumentDropEdit,DocumentPasteEdit:j.DocumentPasteEdit,InlayHint:j.InlayHint,InlayHintLabelPart:j.InlayHintLabelPart,InlayHintKind:j.InlayHintKind,RemoteAuthorityResolverError:j.RemoteAuthorityResolverError,ResolvedAuthority:j.ResolvedAuthority,SourceControlInputBoxValidationType:j.SourceControlInputBoxValidationType,ExtensionRuntime:j.ExtensionRuntime,TimelineItem:j.TimelineItem,NotebookRange:j.NotebookRange,NotebookCellKind:j.NotebookCellKind,NotebookCellExecutionState:j.NotebookCellExecutionState,NotebookCellData:j.NotebookCellData,NotebookData:j.NotebookData,NotebookRendererScript:j.NotebookRendererScript,NotebookCellStatusBarAlignment:j.NotebookCellStatusBarAlignment,NotebookEditorRevealType:j.NotebookEditorRevealType,NotebookCellOutput:j.NotebookCellOutput,NotebookCellOutputItem:j.NotebookCellOutputItem,NotebookCellStatusBarItem:j.NotebookCellStatusBarItem,NotebookControllerAffinity:j.NotebookControllerAffinity,NotebookControllerAffinity2:j.NotebookControllerAffinity2,NotebookEdit:j.NotebookEdit,NotebookKernelSourceAction:j.NotebookKernelSourceAction,PortAttributes:j.PortAttributes,LinkedEditingRanges:j.LinkedEditingRanges,TestResultState:j.TestResultState,TestRunRequest:j.TestRunRequest,TestRunRequest2:j.TestRunRequest2,TestMessage:j.TestMessage,TestTag:j.TestTag,TestRunProfileKind:j.TestRunProfileKind,TextSearchCompleteMessageType:dt.TextSearchCompleteMessageType,DataTransfer:j.DataTransfer,DataTransferItem:j.DataTransferItem,CoveredCount:j.CoveredCount,FileCoverage:j.FileCoverage,StatementCoverage:j.StatementCoverage,BranchCoverage:j.BranchCoverage,FunctionCoverage:j.FunctionCoverage,WorkspaceTrustState:j.WorkspaceTrustState,LanguageStatusSeverity:j.LanguageStatusSeverity,QuickPickItemKind:j.QuickPickItemKind,InputBoxValidationSeverity:j.InputBoxValidationSeverity,TabInputText:j.TextTabInput,TabInputTextDiff:j.TextDiffTabInput,TabInputTextMerge:j.TextMergeTabInput,TabInputCustom:j.CustomEditorTabInput,TabInputNotebook:j.NotebookEditorTabInput,TabInputNotebookDiff:j.NotebookDiffEditorTabInput,TabInputWebview:j.WebviewEditorTabInput,TabInputTerminal:j.TerminalEditorTabInput,TabInputInteractiveWindow:j.InteractiveWindowInput,TelemetryTrustedValue:le.TelemetryTrustedValue,LogLevel:Ke.LogLevel,EditSessionIdentityMatch:vt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=jt}),define(Ce[255],ke([1,0,254,33,2,248,7,17,239]),function(te,e,n,C,D,M,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class k extends M.RequireInterceptor{j(){}getModule(b,m){for(const a of this.b){const o=a(b);if(o){b=o;break}}if(this.a.has(b))return this.a.get(b).load(b,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class N extends C.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=S.ExtensionRuntime.Webworker}async nb(){this.h.createInstance(y.ExtHostConsoleForwarder);const b=this.h.invokeFunction(n.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(k,b,{mine:this.D,all:this.F}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.tb()}ob(b){return b.browser}async pb(b,m,a){m=m.with({path:w(m.path,".js")});const o=b?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const l=D.URI.revive(await this.v.$asBrowserUri(m)),g=await fetch(l.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),g.status!==200)throw new Error(g.statusText);const E=await g.text(),A=`${m.toString(!0)}#vscode-extension`,v=`${E}
//# sourceURL=${A}`;let t;try{t=new Function("module","exports","require",v)}catch(i){throw console.error(o?`Loading code for extension ${o} failed: ${i.message}`:`Loading code failed: ${i.message}`),console.error(`${m.toString(!0)}${typeof i.line=="number"?` line ${i.line}`:""}${typeof i.column=="number"?` column ${i.column}`:""}`),console.error(i),i}b&&await this.s.initializeLocalizedMessages(b);const h={},r={exports:h},u=i=>{const p=this.r.getModule(i,m);if(p===void 0)throw new Error(`Cannot load module '${i}'`);return p};try{return a.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),t(r,h,u),r.exports!==h?r.exports:h}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),a.codeLoadingStop()}}async $setRemoteEnvironment(b){}async tb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+b;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,R.timeout)(10)}}e.ExtHostExtensionService=N;function w(f,b){return f.endsWith(b)?f:f+b}}),define(Ce[256],ke([1,0,66,33,81,255]),function(te,e,n,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(C.IExtHostExtensionService,M.ExtHostExtensionService,0),(0,n.registerSingleton)(D.IExtensionStoragePaths,D.ExtensionStoragePaths,0)}),define(Ce[264],ke([1,0,23,4,73,249,241,19,82,16,2,251,256]),function(te,e,n,C,D,M,S,R,y,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const w=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const f=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(t){return/^(file|vscode-remote):/i.test(t)}const m=fetch.bind(self);function a(t){self.fetch=async function(h,r){return h instanceof Request||b(String(h))&&(h=(await t(N.URI.parse(String(h)))).toString(!0)),m(h,r)},self.XMLHttpRequest=class extends XMLHttpRequest{open(h,r,u,i,p){(async()=>(b(r.toString())&&(r=(await t(N.URI.parse(r.toString()))).toString(!0)),super.open(h,r,u??!0,i,p)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(h,r){if(/^file:/i.test(h.toString()))h=k.FileAccess.uriToBrowserUri(N.URI.parse(h.toString())).toString(!0);else if(/^vscode-remote:/i.test(h.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const i=`(${function(d){function T(J){return typeof J=="string"||J instanceof URL?String(J).replace(/^file:\/\//i,"vscode-file://vscode-app"):J}const O=fetch.bind(self);self.fetch=function(J,K){return J instanceof Request?O(J,K):O(T(J),K)},self.XMLHttpRequest=class extends XMLHttpRequest{open(J,K,L,B,P){return super.open(J,T(K),L??!0,B,P)}};const H=importScripts.bind(self);self.importScripts=(...J)=>{H(...J.map(T))},H(d)}.toString()}('${h}'))`;r=r||{},r.name=r.name||R.basename(h.toString());const p=new Blob([i],{type:"application/javascript"}),c=URL.createObjectURL(p);return new t(c,r)}}else self.Worker=class extends S.NestedWorker{constructor(t,h){super(f,t,{name:R.basename(t.toString()),...h})}};const o=new class{constructor(){this.pid=void 0}exit(t){w()}async exists(t){return!0}async realpath(t){return t}};class l{constructor(){const h=new MessageChannel,r=new C.Emitter;let u=!1;f(h.port2,[h.port2]),h.port1.onmessage=i=>{const{data:p}=i;if(!(p instanceof ArrayBuffer)){console.warn("UNKNOWN data received",p);return}const c=n.VSBuffer.wrap(new Uint8Array(p,0,p.byteLength));if((0,D.isMessageOfType)(c,2)){u=!0,E("received terminate message from renderer");return}r.fire(c)},this.protocol={onMessage:r.event,send:i=>{if(!u){const p=i.buffer.buffer.slice(i.buffer.byteOffset,i.buffer.byteOffset+i.buffer.byteLength);h.port1.postMessage(p,[p])}}}}}function g(t){return new Promise(h=>{const r=t.onMessage(u=>{r.dispose();const i=JSON.parse(u.toString());t.send((0,D.createMessageOfType)(0)),h({protocol:t,initData:i})});t.send((0,D.createMessageOfType)(1))})}let E=t=>w();function A(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function v(){y.mark("code/extHost/willConnectToRenderer");const t=new l;return{onmessage(h){!A(h)||g(t.protocol).then(r=>{y.mark("code/extHost/didWaitForInitData");const u=new M.ExtensionHostMain(r.protocol,r.initData,o,null,h.data);a(i=>u.asBrowserUri(i)),E=i=>u.terminate(i)})}}}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ac229ad6e485f87b5c172a909c5aafe333cad9ce/core/vs/workbench/api/worker/extensionHostWorker.js.map
